/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the X86 target                             *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 152;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(X86InstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(X86InstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static X86InstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static X86InstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testMOPredicate_MO(unsigned PredicateID, const MachineOperand &MO, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(1),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s1,
  GILLT_s8,
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_s80,
  GILLT_s128,
  GILLT_v2s1,
  GILLT_v2s64,
  GILLT_v4s1,
  GILLT_v4s32,
  GILLT_v4s64,
  GILLT_v8s1,
  GILLT_v8s16,
  GILLT_v8s32,
  GILLT_v8s64,
  GILLT_v16s1,
  GILLT_v16s8,
  GILLT_v16s16,
  GILLT_v16s32,
  GILLT_v32s1,
  GILLT_v32s8,
  GILLT_v32s16,
  GILLT_v64s1,
  GILLT_v64s8,
};
const static size_t NumTypeObjects = 25;
const static LLT TypeObjects[] = {
  LLT::scalar(1),
  LLT::scalar(8),
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::scalar(80),
  LLT::scalar(128),
  LLT::vector(ElementCount::getFixed(2), 1),
  LLT::vector(ElementCount::getFixed(2), 64),
  LLT::vector(ElementCount::getFixed(4), 1),
  LLT::vector(ElementCount::getFixed(4), 32),
  LLT::vector(ElementCount::getFixed(4), 64),
  LLT::vector(ElementCount::getFixed(8), 1),
  LLT::vector(ElementCount::getFixed(8), 16),
  LLT::vector(ElementCount::getFixed(8), 32),
  LLT::vector(ElementCount::getFixed(8), 64),
  LLT::vector(ElementCount::getFixed(16), 1),
  LLT::vector(ElementCount::getFixed(16), 8),
  LLT::vector(ElementCount::getFixed(16), 16),
  LLT::vector(ElementCount::getFixed(16), 32),
  LLT::vector(ElementCount::getFixed(32), 1),
  LLT::vector(ElementCount::getFixed(32), 8),
  LLT::vector(ElementCount::getFixed(32), 16),
  LLT::vector(ElementCount::getFixed(64), 1),
  LLT::vector(ElementCount::getFixed(64), 8),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_TruePredicateBit = 63,
  Feature_HasEGPRBit = 5,
  Feature_NoEGPRBit = 4,
  Feature_HasNDDBit = 6,
  Feature_NoNDDBit = 27,
  Feature_HasZUBit = 151,
  Feature_HasCFBit = 30,
  Feature_HasCMOVBit = 29,
  Feature_NoCMOVBit = 137,
  Feature_HasMMXBit = 109,
  Feature_HasSSE1Bit = 49,
  Feature_UseSSE1Bit = 56,
  Feature_HasSSE2Bit = 48,
  Feature_UseSSE2Bit = 57,
  Feature_HasSSE3Bit = 40,
  Feature_UseSSE3Bit = 66,
  Feature_HasSSSE3Bit = 110,
  Feature_UseSSSE3Bit = 67,
  Feature_UseSSE41Bit = 64,
  Feature_UseSSE42Bit = 71,
  Feature_HasSSE4ABit = 81,
  Feature_NoAVXBit = 77,
  Feature_HasAVXBit = 58,
  Feature_HasAVX2Bit = 52,
  Feature_HasAVX1OnlyBit = 50,
  Feature_HasEVEX512Bit = 144,
  Feature_HasAVX10_2Bit = 108,
  Feature_HasAVX10_2_512Bit = 107,
  Feature_NoAVX10_2Bit = 70,
  Feature_HasAVX512Bit = 94,
  Feature_UseAVXBit = 54,
  Feature_NoAVX512Bit = 45,
  Feature_HasCDIBit = 98,
  Feature_HasVPOPCNTDQBit = 102,
  Feature_HasDQIBit = 96,
  Feature_NoDQIBit = 68,
  Feature_HasBWIBit = 97,
  Feature_NoBWIBit = 65,
  Feature_HasVLXBit = 95,
  Feature_NoVLXBit = 44,
  Feature_NoVLX_Or_NoBWIBit = 62,
  Feature_HasVNNIBit = 104,
  Feature_HasVP2INTERSECTBit = 106,
  Feature_HasFP16Bit = 100,
  Feature_HasAVXVNNIINT16Bit = 93,
  Feature_HasAVXVNNIINT8Bit = 88,
  Feature_HasAVXVNNIBit = 82,
  Feature_NoVLX_Or_NoVNNIBit = 83,
  Feature_HasBITALGBit = 105,
  Feature_HasPOPCNTBit = 69,
  Feature_HasAESBit = 74,
  Feature_HasVAESBit = 76,
  Feature_NoVLX_Or_NoVAESBit = 75,
  Feature_HasFXSRBit = 41,
  Feature_HasX87Bit = 39,
  Feature_HasXSAVEBit = 126,
  Feature_HasXSAVEOPTBit = 127,
  Feature_HasXSAVECBit = 128,
  Feature_HasXSAVESBit = 129,
  Feature_HasPCLMULBit = 78,
  Feature_NoVLX_Or_NoVPCLMULQDQBit = 79,
  Feature_HasVPCLMULQDQBit = 80,
  Feature_HasGFNIBit = 85,
  Feature_HasFMABit = 42,
  Feature_HasFMA4Bit = 46,
  Feature_NoFMA4Bit = 43,
  Feature_HasXOPBit = 47,
  Feature_HasTBMBit = 26,
  Feature_NoTBMBit = 142,
  Feature_HasLWPBit = 12,
  Feature_HasMOVBEBit = 3,
  Feature_NoNDD_Or_NoMOVBEBit = 2,
  Feature_HasRDRANDBit = 7,
  Feature_HasF16CBit = 84,
  Feature_HasFSGSBaseBit = 130,
  Feature_HasLZCNTBit = 9,
  Feature_HasBMIBit = 10,
  Feature_HasBMI2Bit = 11,
  Feature_NoBMI2Bit = 141,
  Feature_HasVBMIBit = 99,
  Feature_HasVBMI2Bit = 103,
  Feature_HasIFMABit = 101,
  Feature_HasAVXIFMABit = 86,
  Feature_NoVLX_Or_NoIFMABit = 87,
  Feature_HasRTMBit = 112,
  Feature_HasSHABit = 73,
  Feature_HasSHA512Bit = 90,
  Feature_HasSM3Bit = 91,
  Feature_HasRDSEEDBit = 8,
  Feature_HasSSEPrefetchBit = 59,
  Feature_HasPREFETCHIBit = 20,
  Feature_HasPrefetchWBit = 111,
  Feature_HasMWAITXBit = 140,
  Feature_HasCLDEMOTEBit = 24,
  Feature_HasMOVDIRIBit = 14,
  Feature_HasMOVDIR64BBit = 15,
  Feature_HasMOVRSBit = 25,
  Feature_HasPTWRITEBit = 133,
  Feature_FPStackf32Bit = 37,
  Feature_FPStackf64Bit = 38,
  Feature_HasSM4Bit = 92,
  Feature_HasCLFLUSHBit = 60,
  Feature_HasCLFLUSHOPTBit = 22,
  Feature_HasCLWBBit = 23,
  Feature_HasWBNOINVDBit = 125,
  Feature_HasRDPIDBit = 132,
  Feature_HasWAITPKGBit = 13,
  Feature_HasINVPCIDBit = 131,
  Feature_HasCX8Bit = 138,
  Feature_HasCX16Bit = 139,
  Feature_HasENQCMDBit = 16,
  Feature_HasAMXFP16Bit = 117,
  Feature_HasCMPCCXADDBit = 21,
  Feature_HasAVXNECONVERTBit = 89,
  Feature_HasKLBit = 113,
  Feature_HasRAOINTBit = 123,
  Feature_HasSERIALIZEBit = 17,
  Feature_HasTSXLDTRKBit = 18,
  Feature_HasAMXTILEBit = 114,
  Feature_HasAMXBF16Bit = 116,
  Feature_HasAMXINT8Bit = 115,
  Feature_HasAMXCOMPLEXBit = 118,
  Feature_HasAMXFP8Bit = 119,
  Feature_HasAMXTRANSPOSEBit = 120,
  Feature_HasAMXAVX512Bit = 121,
  Feature_HasAMXTF32Bit = 122,
  Feature_HasUINTRBit = 19,
  Feature_HasUSERMSRBit = 124,
  Feature_HasCRC32Bit = 72,
  Feature_Not64BitModeBit = 0,
  Feature_In64BitModeBit = 1,
  Feature_IsLP64Bit = 135,
  Feature_NotLP64Bit = 134,
  Feature_NotWin64WithoutFPBit = 136,
  Feature_IsPSBit = 146,
  Feature_NotPSBit = 145,
  Feature_KernelCodeBit = 147,
  Feature_NearDataBit = 149,
  Feature_IsNotPICBit = 148,
  Feature_OptForSizeBit = 53,
  Feature_OptForMinSizeBit = 51,
  Feature_OptForSpeedBit = 143,
  Feature_UseIncDecBit = 28,
  Feature_NoSSE41_Or_OptForSizeBit = 55,
  Feature_ImportCallOptimizationEnabledBit = 35,
  Feature_ImportCallOptimizationDisabledBit = 33,
  Feature_CallImmAddrBit = 150,
  Feature_FavorMemIndirectCallBit = 31,
  Feature_HasFastSHLDRotateBit = 36,
  Feature_HasMFenceBit = 61,
  Feature_UseIndirectThunkCallsBit = 34,
  Feature_NotUseIndirectThunkCallsBit = 32,
};

PredicateBitset X86InstructionSelector::
computeAvailableModuleFeatures(const X86Subtarget *Subtarget) const {
  PredicateBitset Features{};
  if (true)
    Features.set(Feature_TruePredicateBit);
  if (Subtarget->hasEGPR())
    Features.set(Feature_HasEGPRBit);
  if (!Subtarget->hasEGPR())
    Features.set(Feature_NoEGPRBit);
  if (Subtarget->hasNDD())
    Features.set(Feature_HasNDDBit);
  if (!Subtarget->hasNDD())
    Features.set(Feature_NoNDDBit);
  if (Subtarget->hasZU())
    Features.set(Feature_HasZUBit);
  if (Subtarget->hasCF())
    Features.set(Feature_HasCFBit);
  if (Subtarget->canUseCMOV())
    Features.set(Feature_HasCMOVBit);
  if (!Subtarget->canUseCMOV())
    Features.set(Feature_NoCMOVBit);
  if (Subtarget->hasMMX())
    Features.set(Feature_HasMMXBit);
  if (Subtarget->hasSSE1())
    Features.set(Feature_HasSSE1Bit);
  if (Subtarget->hasSSE1() && !Subtarget->hasAVX())
    Features.set(Feature_UseSSE1Bit);
  if (Subtarget->hasSSE2())
    Features.set(Feature_HasSSE2Bit);
  if (Subtarget->hasSSE2() && !Subtarget->hasAVX())
    Features.set(Feature_UseSSE2Bit);
  if (Subtarget->hasSSE3())
    Features.set(Feature_HasSSE3Bit);
  if (Subtarget->hasSSE3() && !Subtarget->hasAVX())
    Features.set(Feature_UseSSE3Bit);
  if (Subtarget->hasSSSE3())
    Features.set(Feature_HasSSSE3Bit);
  if (Subtarget->hasSSSE3() && !Subtarget->hasAVX())
    Features.set(Feature_UseSSSE3Bit);
  if (Subtarget->hasSSE41() && !Subtarget->hasAVX())
    Features.set(Feature_UseSSE41Bit);
  if (Subtarget->hasSSE42() && !Subtarget->hasAVX())
    Features.set(Feature_UseSSE42Bit);
  if (Subtarget->hasSSE4A())
    Features.set(Feature_HasSSE4ABit);
  if (!Subtarget->hasAVX())
    Features.set(Feature_NoAVXBit);
  if (Subtarget->hasAVX())
    Features.set(Feature_HasAVXBit);
  if (Subtarget->hasAVX2())
    Features.set(Feature_HasAVX2Bit);
  if (Subtarget->hasAVX() && !Subtarget->hasAVX2())
    Features.set(Feature_HasAVX1OnlyBit);
  if (Subtarget->hasEVEX512())
    Features.set(Feature_HasEVEX512Bit);
  if (Subtarget->hasAVX10_2())
    Features.set(Feature_HasAVX10_2Bit);
  if (Subtarget->hasAVX10_2_512())
    Features.set(Feature_HasAVX10_2_512Bit);
  if (!Subtarget->hasAVX10_2())
    Features.set(Feature_NoAVX10_2Bit);
  if (Subtarget->hasAVX512())
    Features.set(Feature_HasAVX512Bit);
  if (Subtarget->hasAVX() && !Subtarget->hasAVX512())
    Features.set(Feature_UseAVXBit);
  if (!Subtarget->hasAVX512())
    Features.set(Feature_NoAVX512Bit);
  if (Subtarget->hasCDI())
    Features.set(Feature_HasCDIBit);
  if (Subtarget->hasVPOPCNTDQ())
    Features.set(Feature_HasVPOPCNTDQBit);
  if (Subtarget->hasDQI())
    Features.set(Feature_HasDQIBit);
  if (!Subtarget->hasDQI())
    Features.set(Feature_NoDQIBit);
  if (Subtarget->hasBWI())
    Features.set(Feature_HasBWIBit);
  if (!Subtarget->hasBWI())
    Features.set(Feature_NoBWIBit);
  if (Subtarget->hasVLX())
    Features.set(Feature_HasVLXBit);
  if (!Subtarget->hasVLX())
    Features.set(Feature_NoVLXBit);
  if (!Subtarget->hasVLX() || !Subtarget->hasBWI())
    Features.set(Feature_NoVLX_Or_NoBWIBit);
  if (Subtarget->hasVNNI())
    Features.set(Feature_HasVNNIBit);
  if (Subtarget->hasVP2INTERSECT())
    Features.set(Feature_HasVP2INTERSECTBit);
  if (Subtarget->hasFP16())
    Features.set(Feature_HasFP16Bit);
  if (Subtarget->hasAVXVNNIINT16())
    Features.set(Feature_HasAVXVNNIINT16Bit);
  if (Subtarget->hasAVXVNNIINT8())
    Features.set(Feature_HasAVXVNNIINT8Bit);
  if (Subtarget->hasAVXVNNI())
    Features.set(Feature_HasAVXVNNIBit);
  if (!Subtarget->hasVLX() || !Subtarget->hasVNNI())
    Features.set(Feature_NoVLX_Or_NoVNNIBit);
  if (Subtarget->hasBITALG())
    Features.set(Feature_HasBITALGBit);
  if (Subtarget->hasPOPCNT())
    Features.set(Feature_HasPOPCNTBit);
  if (Subtarget->hasAES())
    Features.set(Feature_HasAESBit);
  if (Subtarget->hasVAES())
    Features.set(Feature_HasVAESBit);
  if (!Subtarget->hasVLX() || !Subtarget->hasVAES())
    Features.set(Feature_NoVLX_Or_NoVAESBit);
  if (Subtarget->hasFXSR())
    Features.set(Feature_HasFXSRBit);
  if (Subtarget->hasX87())
    Features.set(Feature_HasX87Bit);
  if (Subtarget->hasXSAVE())
    Features.set(Feature_HasXSAVEBit);
  if (Subtarget->hasXSAVEOPT())
    Features.set(Feature_HasXSAVEOPTBit);
  if (Subtarget->hasXSAVEC())
    Features.set(Feature_HasXSAVECBit);
  if (Subtarget->hasXSAVES())
    Features.set(Feature_HasXSAVESBit);
  if (Subtarget->hasPCLMUL())
    Features.set(Feature_HasPCLMULBit);
  if (!Subtarget->hasVLX() || !Subtarget->hasVPCLMULQDQ())
    Features.set(Feature_NoVLX_Or_NoVPCLMULQDQBit);
  if (Subtarget->hasVPCLMULQDQ())
    Features.set(Feature_HasVPCLMULQDQBit);
  if (Subtarget->hasGFNI())
    Features.set(Feature_HasGFNIBit);
  if (Subtarget->hasFMA())
    Features.set(Feature_HasFMABit);
  if (Subtarget->hasFMA4())
    Features.set(Feature_HasFMA4Bit);
  if (!Subtarget->hasFMA4())
    Features.set(Feature_NoFMA4Bit);
  if (Subtarget->hasXOP())
    Features.set(Feature_HasXOPBit);
  if (Subtarget->hasTBM())
    Features.set(Feature_HasTBMBit);
  if (!Subtarget->hasTBM())
    Features.set(Feature_NoTBMBit);
  if (Subtarget->hasLWP())
    Features.set(Feature_HasLWPBit);
  if (Subtarget->hasMOVBE())
    Features.set(Feature_HasMOVBEBit);
  if (!Subtarget->hasNDD() || !Subtarget->hasMOVBE())
    Features.set(Feature_NoNDD_Or_NoMOVBEBit);
  if (Subtarget->hasRDRAND())
    Features.set(Feature_HasRDRANDBit);
  if (Subtarget->hasF16C())
    Features.set(Feature_HasF16CBit);
  if (Subtarget->hasFSGSBase())
    Features.set(Feature_HasFSGSBaseBit);
  if (Subtarget->hasLZCNT())
    Features.set(Feature_HasLZCNTBit);
  if (Subtarget->hasBMI())
    Features.set(Feature_HasBMIBit);
  if (Subtarget->hasBMI2())
    Features.set(Feature_HasBMI2Bit);
  if (!Subtarget->hasBMI2())
    Features.set(Feature_NoBMI2Bit);
  if (Subtarget->hasVBMI())
    Features.set(Feature_HasVBMIBit);
  if (Subtarget->hasVBMI2())
    Features.set(Feature_HasVBMI2Bit);
  if (Subtarget->hasIFMA())
    Features.set(Feature_HasIFMABit);
  if (Subtarget->hasAVXIFMA())
    Features.set(Feature_HasAVXIFMABit);
  if (!Subtarget->hasVLX() || !Subtarget->hasIFMA())
    Features.set(Feature_NoVLX_Or_NoIFMABit);
  if (Subtarget->hasRTM())
    Features.set(Feature_HasRTMBit);
  if (Subtarget->hasSHA())
    Features.set(Feature_HasSHABit);
  if (Subtarget->hasSHA512())
    Features.set(Feature_HasSHA512Bit);
  if (Subtarget->hasSM3())
    Features.set(Feature_HasSM3Bit);
  if (Subtarget->hasRDSEED())
    Features.set(Feature_HasRDSEEDBit);
  if (Subtarget->hasSSEPrefetch())
    Features.set(Feature_HasSSEPrefetchBit);
  if (Subtarget->hasPREFETCHI())
    Features.set(Feature_HasPREFETCHIBit);
  if (Subtarget->hasPrefetchW())
    Features.set(Feature_HasPrefetchWBit);
  if (Subtarget->hasMWAITX())
    Features.set(Feature_HasMWAITXBit);
  if (Subtarget->hasCLDEMOTE())
    Features.set(Feature_HasCLDEMOTEBit);
  if (Subtarget->hasMOVDIRI())
    Features.set(Feature_HasMOVDIRIBit);
  if (Subtarget->hasMOVDIR64B())
    Features.set(Feature_HasMOVDIR64BBit);
  if (Subtarget->hasMOVRS())
    Features.set(Feature_HasMOVRSBit);
  if (Subtarget->hasPTWRITE())
    Features.set(Feature_HasPTWRITEBit);
  if (!Subtarget->hasSSE1())
    Features.set(Feature_FPStackf32Bit);
  if (!Subtarget->hasSSE2())
    Features.set(Feature_FPStackf64Bit);
  if (Subtarget->hasSM4())
    Features.set(Feature_HasSM4Bit);
  if (Subtarget->hasCLFLUSH())
    Features.set(Feature_HasCLFLUSHBit);
  if (Subtarget->hasCLFLUSHOPT())
    Features.set(Feature_HasCLFLUSHOPTBit);
  if (Subtarget->hasCLWB())
    Features.set(Feature_HasCLWBBit);
  if (Subtarget->hasWBNOINVD())
    Features.set(Feature_HasWBNOINVDBit);
  if (Subtarget->hasRDPID())
    Features.set(Feature_HasRDPIDBit);
  if (Subtarget->hasWAITPKG())
    Features.set(Feature_HasWAITPKGBit);
  if (Subtarget->hasINVPCID())
    Features.set(Feature_HasINVPCIDBit);
  if (Subtarget->hasCX8())
    Features.set(Feature_HasCX8Bit);
  if (Subtarget->hasCX16())
    Features.set(Feature_HasCX16Bit);
  if (Subtarget->hasENQCMD())
    Features.set(Feature_HasENQCMDBit);
  if (Subtarget->hasAMXFP16())
    Features.set(Feature_HasAMXFP16Bit);
  if (Subtarget->hasCMPCCXADD())
    Features.set(Feature_HasCMPCCXADDBit);
  if (Subtarget->hasAVXNECONVERT())
    Features.set(Feature_HasAVXNECONVERTBit);
  if (Subtarget->hasKL())
    Features.set(Feature_HasKLBit);
  if (Subtarget->hasRAOINT())
    Features.set(Feature_HasRAOINTBit);
  if (Subtarget->hasSERIALIZE())
    Features.set(Feature_HasSERIALIZEBit);
  if (Subtarget->hasTSXLDTRK())
    Features.set(Feature_HasTSXLDTRKBit);
  if (Subtarget->hasAMXTILE())
    Features.set(Feature_HasAMXTILEBit);
  if (Subtarget->hasAMXBF16())
    Features.set(Feature_HasAMXBF16Bit);
  if (Subtarget->hasAMXINT8())
    Features.set(Feature_HasAMXINT8Bit);
  if (Subtarget->hasAMXCOMPLEX())
    Features.set(Feature_HasAMXCOMPLEXBit);
  if (Subtarget->hasAMXFP8())
    Features.set(Feature_HasAMXFP8Bit);
  if (Subtarget->hasAMXTRANSPOSE())
    Features.set(Feature_HasAMXTRANSPOSEBit);
  if (Subtarget->hasAMXAVX512())
    Features.set(Feature_HasAMXAVX512Bit);
  if (Subtarget->hasAMXTF32())
    Features.set(Feature_HasAMXTF32Bit);
  if (Subtarget->hasUINTR())
    Features.set(Feature_HasUINTRBit);
  if (Subtarget->hasUSERMSR())
    Features.set(Feature_HasUSERMSRBit);
  if (Subtarget->hasCRC32())
    Features.set(Feature_HasCRC32Bit);
  if (!Subtarget->is64Bit())
    Features.set(Feature_Not64BitModeBit);
  if (Subtarget->is64Bit())
    Features.set(Feature_In64BitModeBit);
  if (Subtarget->isTarget64BitLP64())
    Features.set(Feature_IsLP64Bit);
  if (!Subtarget->isTarget64BitLP64())
    Features.set(Feature_NotLP64Bit);
  if (Subtarget->isTargetPS())
    Features.set(Feature_IsPSBit);
  if (!Subtarget->isTargetPS())
    Features.set(Feature_NotPSBit);
  if (TM.getCodeModel() == CodeModel::Kernel)
    Features.set(Feature_KernelCodeBit);
  if (TM.getCodeModel() == CodeModel::Small ||TM.getCodeModel() == CodeModel::Kernel)
    Features.set(Feature_NearDataBit);
  if (!TM.isPositionIndependent())
    Features.set(Feature_IsNotPICBit);
  if (Subtarget->isLegalToCallImmediateAddr())
    Features.set(Feature_CallImmAddrBit);
  if (!Subtarget->slowTwoMemOps())
    Features.set(Feature_FavorMemIndirectCallBit);
  if (Subtarget->hasFastSHLDRotate())
    Features.set(Feature_HasFastSHLDRotateBit);
  if (Subtarget->hasMFence())
    Features.set(Feature_HasMFenceBit);
  if (Subtarget->useIndirectThunkCalls())
    Features.set(Feature_UseIndirectThunkCallsBit);
  if (!Subtarget->useIndirectThunkCalls())
    Features.set(Feature_NotUseIndirectThunkCallsBit);
  return Features;
}

void X86InstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const X86Subtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset X86InstructionSelector::
computeAvailableFunctionFeatures(const X86Subtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  if (!Subtarget->isTargetWin64() ||Subtarget->getFrameLowering()->hasFP(*MF))
    Features.set(Feature_NotWin64WithoutFPBit);
  if (shouldOptForSize(MF))
    Features.set(Feature_OptForSizeBit);
  if (MF->getFunction().hasMinSize())
    Features.set(Feature_OptForMinSizeBit);
  if (!shouldOptForSize(MF))
    Features.set(Feature_OptForSpeedBit);
  if (!Subtarget->slowIncDec() || shouldOptForSize(MF))
    Features.set(Feature_UseIncDecBit);
  if (shouldOptForSize(MF) || !Subtarget->hasSSE41())
    Features.set(Feature_NoSSE41_Or_OptForSizeBit);
  if (MF->getFunction().getParent()->getModuleFlag("import-call-optimization"))
    Features.set(Feature_ImportCallOptimizationEnabledBit);
  if (!MF->getFunction().getParent()->getModuleFlag("import-call-optimization"))
    Features.set(Feature_ImportCallOptimizationDisabledBit);
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_FPStackf32,
  GIFBS_FPStackf64,
  GIFBS_HasAVX,
  GIFBS_HasAVX1Only,
  GIFBS_HasAVX2,
  GIFBS_HasAVX512,
  GIFBS_HasAVXNECONVERT,
  GIFBS_HasBITALG,
  GIFBS_HasBMI,
  GIFBS_HasBWI,
  GIFBS_HasCDI,
  GIFBS_HasCLDEMOTE,
  GIFBS_HasCLFLUSH,
  GIFBS_HasCLFLUSHOPT,
  GIFBS_HasCLWB,
  GIFBS_HasDQI,
  GIFBS_HasFP16,
  GIFBS_HasFXSR,
  GIFBS_HasFastSHLDRotate,
  GIFBS_HasKL,
  GIFBS_HasLWP,
  GIFBS_HasLZCNT,
  GIFBS_HasMFence,
  GIFBS_HasMMX,
  GIFBS_HasMOVBE,
  GIFBS_HasMOVRS,
  GIFBS_HasMWAITX,
  GIFBS_HasNDD,
  GIFBS_HasPOPCNT,
  GIFBS_HasPTWRITE,
  GIFBS_HasPrefetchW,
  GIFBS_HasRTM,
  GIFBS_HasSERIALIZE,
  GIFBS_HasSHA,
  GIFBS_HasSHA512,
  GIFBS_HasSM3,
  GIFBS_HasSM4,
  GIFBS_HasSSE1,
  GIFBS_HasSSE2,
  GIFBS_HasSSE3,
  GIFBS_HasSSE4A,
  GIFBS_HasSSEPrefetch,
  GIFBS_HasTBM,
  GIFBS_HasTSXLDTRK,
  GIFBS_HasVBMI2,
  GIFBS_HasVLX,
  GIFBS_HasVPOPCNTDQ,
  GIFBS_HasWAITPKG,
  GIFBS_HasWBNOINVD,
  GIFBS_HasX87,
  GIFBS_HasXOP,
  GIFBS_HasXSAVE,
  GIFBS_HasXSAVEC,
  GIFBS_HasXSAVEOPT,
  GIFBS_HasXSAVES,
  GIFBS_HasZU,
  GIFBS_In64BitMode,
  GIFBS_IsPS,
  GIFBS_NoAVX,
  GIFBS_NoDQI,
  GIFBS_NoEGPR,
  GIFBS_NoNDD,
  GIFBS_NoNDD_Or_NoMOVBE,
  GIFBS_Not64BitMode,
  GIFBS_NotPS,
  GIFBS_UseAVX,
  GIFBS_UseIncDec,
  GIFBS_UseSSE1,
  GIFBS_UseSSE2,
  GIFBS_UseSSE3,
  GIFBS_UseSSE41,
  GIFBS_UseSSSE3,
  GIFBS_HasAES_HasAVX,
  GIFBS_HasAES_NoAVX,
  GIFBS_HasAMXBF16_In64BitMode,
  GIFBS_HasAMXCOMPLEX_In64BitMode,
  GIFBS_HasAMXFP16_In64BitMode,
  GIFBS_HasAMXFP8_In64BitMode,
  GIFBS_HasAMXINT8_In64BitMode,
  GIFBS_HasAMXTF32_In64BitMode,
  GIFBS_HasAMXTILE_In64BitMode,
  GIFBS_HasAMXTRANSPOSE_In64BitMode,
  GIFBS_HasAVX_In64BitMode,
  GIFBS_HasAVX_NoBWI,
  GIFBS_HasAVX_NoVLX,
  GIFBS_HasAVX_NoVLX_Or_NoBWI,
  GIFBS_HasAVX10_2_HasSM4,
  GIFBS_HasAVX10_2_512_HasSM4,
  GIFBS_HasAVX2_NoVLX,
  GIFBS_HasAVX2_NoVLX_Or_NoBWI,
  GIFBS_HasAVX512_HasVAES,
  GIFBS_HasAVX512_HasVLX,
  GIFBS_HasAVX512_HasVPCLMULQDQ,
  GIFBS_HasAVX512_NoBWI,
  GIFBS_HasAVX512_NoDQI,
  GIFBS_HasAVX512_NoEGPR,
  GIFBS_HasAVX512_OptForSize,
  GIFBS_HasBITALG_HasVLX,
  GIFBS_HasBMI_HasEGPR,
  GIFBS_HasBMI_NoEGPR,
  GIFBS_HasBMI2_HasEGPR,
  GIFBS_HasBMI2_NoEGPR,
  GIFBS_HasBWI_HasVLX,
  GIFBS_HasBWI_NoEGPR,
  GIFBS_HasCDI_HasVLX,
  GIFBS_HasCRC32_NoEGPR,
  GIFBS_HasDQI_HasVLX,
  GIFBS_HasDQI_NoBWI,
  GIFBS_HasDQI_NoEGPR,
  GIFBS_HasEGPR_HasINVPCID,
  GIFBS_HasEGPR_In64BitMode,
  GIFBS_HasEVEX512_NoVLX,
  GIFBS_HasFMA4_NoAVX512,
  GIFBS_HasFMA4_NoVLX,
  GIFBS_HasFP16_HasVLX,
  GIFBS_HasFP16_In64BitMode,
  GIFBS_HasFP16_OptForSize,
  GIFBS_HasFSGSBase_In64BitMode,
  GIFBS_HasFXSR_In64BitMode,
  GIFBS_HasINVPCID_NoEGPR,
  GIFBS_HasINVPCID_Not64BitMode,
  GIFBS_HasMOVBE_NoEGPR,
  GIFBS_HasMOVDIR64B_NoEGPR,
  GIFBS_HasMOVDIRI_NoEGPR,
  GIFBS_HasNDD_In64BitMode,
  GIFBS_HasNDD_UseIncDec,
  GIFBS_HasPCLMUL_NoAVX,
  GIFBS_HasPREFETCHI_In64BitMode,
  GIFBS_HasPTWRITE_In64BitMode,
  GIFBS_HasRDPID_In64BitMode,
  GIFBS_HasRDPID_Not64BitMode,
  GIFBS_HasUINTR_In64BitMode,
  GIFBS_HasUSERMSR_NoEGPR,
  GIFBS_HasVAES_HasVLX,
  GIFBS_HasVAES_NoVLX,
  GIFBS_HasVBMI2_HasVLX,
  GIFBS_HasVLX_HasVPCLMULQDQ,
  GIFBS_HasVLX_HasVPOPCNTDQ,
  GIFBS_HasVPCLMULQDQ_NoVLX,
  GIFBS_HasWAITPKG_In64BitMode,
  GIFBS_HasWAITPKG_Not64BitMode,
  GIFBS_HasXSAVE_In64BitMode,
  GIFBS_HasXSAVEC_In64BitMode,
  GIFBS_HasXSAVEOPT_In64BitMode,
  GIFBS_HasXSAVES_In64BitMode,
  GIFBS_In64BitMode_UseIncDec,
  GIFBS_In64BitMode_UseSSE2,
  GIFBS_NoNDD_UseIncDec,
  GIFBS_Not64BitMode_OptForSize,
  GIFBS_NotWin64WithoutFP_OptForMinSize,
  GIFBS_OptForSize_UseAVX,
  GIFBS_OptForSize_UseSSE1,
  GIFBS_OptForSize_UseSSE2,
  GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES,
  GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode,
  GIFBS_HasAMXBF16_HasAMXTRANSPOSE_In64BitMode,
  GIFBS_HasAMXCOMPLEX_HasAMXTRANSPOSE_In64BitMode,
  GIFBS_HasAMXFP16_HasAMXTRANSPOSE_In64BitMode,
  GIFBS_HasAMXTF32_HasAMXTRANSPOSE_In64BitMode,
  GIFBS_HasAMXTILE_HasEGPR_In64BitMode,
  GIFBS_HasAMXTILE_In64BitMode_NoEGPR,
  GIFBS_HasAVX_HasPCLMUL_NoVLX_Or_NoVPCLMULQDQ,
  GIFBS_HasAVX10_2_HasMOVRS_In64BitMode,
  GIFBS_HasAVX10_2_512_HasMOVRS_In64BitMode,
  GIFBS_HasAVX512_HasEGPR_In64BitMode,
  GIFBS_HasAVX512_HasEVEX512_NoVLX,
  GIFBS_HasBITALG_HasEVEX512_NoVLX,
  GIFBS_HasBWI_HasEGPR_In64BitMode,
  GIFBS_HasBWI_HasEVEX512_NoVLX,
  GIFBS_HasCDI_HasEVEX512_NoVLX,
  GIFBS_HasCRC32_HasEGPR_In64BitMode,
  GIFBS_HasDQI_HasEGPR_In64BitMode,
  GIFBS_HasDQI_HasEVEX512_NoVLX,
  GIFBS_HasDQI_HasVLX_NoBWI,
  GIFBS_HasEGPR_HasMOVBE_In64BitMode,
  GIFBS_HasEGPR_HasMOVDIR64B_In64BitMode,
  GIFBS_HasEGPR_HasMOVDIRI_In64BitMode,
  GIFBS_HasEGPR_HasMOVRS_In64BitMode,
  GIFBS_HasEGPR_HasUSERMSR_In64BitMode,
  GIFBS_HasEVEX512_HasVPOPCNTDQ_NoVLX,
  GIFBS_HasFMA_NoAVX512_NoFMA4,
  GIFBS_HasFMA_NoFMA4_NoVLX,
  GIFBS_HasMOVBE_HasNDD_In64BitMode,
  GIFBS_HasMOVDIR64B_In64BitMode_NoEGPR,
  GIFBS_HasMOVDIRI_In64BitMode_NoEGPR,
  GIFBS_HasMOVRS_In64BitMode_NoEGPR,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_FPStackf32Bit, },
  {Feature_FPStackf64Bit, },
  {Feature_HasAVXBit, },
  {Feature_HasAVX1OnlyBit, },
  {Feature_HasAVX2Bit, },
  {Feature_HasAVX512Bit, },
  {Feature_HasAVXNECONVERTBit, },
  {Feature_HasBITALGBit, },
  {Feature_HasBMIBit, },
  {Feature_HasBWIBit, },
  {Feature_HasCDIBit, },
  {Feature_HasCLDEMOTEBit, },
  {Feature_HasCLFLUSHBit, },
  {Feature_HasCLFLUSHOPTBit, },
  {Feature_HasCLWBBit, },
  {Feature_HasDQIBit, },
  {Feature_HasFP16Bit, },
  {Feature_HasFXSRBit, },
  {Feature_HasFastSHLDRotateBit, },
  {Feature_HasKLBit, },
  {Feature_HasLWPBit, },
  {Feature_HasLZCNTBit, },
  {Feature_HasMFenceBit, },
  {Feature_HasMMXBit, },
  {Feature_HasMOVBEBit, },
  {Feature_HasMOVRSBit, },
  {Feature_HasMWAITXBit, },
  {Feature_HasNDDBit, },
  {Feature_HasPOPCNTBit, },
  {Feature_HasPTWRITEBit, },
  {Feature_HasPrefetchWBit, },
  {Feature_HasRTMBit, },
  {Feature_HasSERIALIZEBit, },
  {Feature_HasSHABit, },
  {Feature_HasSHA512Bit, },
  {Feature_HasSM3Bit, },
  {Feature_HasSM4Bit, },
  {Feature_HasSSE1Bit, },
  {Feature_HasSSE2Bit, },
  {Feature_HasSSE3Bit, },
  {Feature_HasSSE4ABit, },
  {Feature_HasSSEPrefetchBit, },
  {Feature_HasTBMBit, },
  {Feature_HasTSXLDTRKBit, },
  {Feature_HasVBMI2Bit, },
  {Feature_HasVLXBit, },
  {Feature_HasVPOPCNTDQBit, },
  {Feature_HasWAITPKGBit, },
  {Feature_HasWBNOINVDBit, },
  {Feature_HasX87Bit, },
  {Feature_HasXOPBit, },
  {Feature_HasXSAVEBit, },
  {Feature_HasXSAVECBit, },
  {Feature_HasXSAVEOPTBit, },
  {Feature_HasXSAVESBit, },
  {Feature_HasZUBit, },
  {Feature_In64BitModeBit, },
  {Feature_IsPSBit, },
  {Feature_NoAVXBit, },
  {Feature_NoDQIBit, },
  {Feature_NoEGPRBit, },
  {Feature_NoNDDBit, },
  {Feature_NoNDD_Or_NoMOVBEBit, },
  {Feature_Not64BitModeBit, },
  {Feature_NotPSBit, },
  {Feature_UseAVXBit, },
  {Feature_UseIncDecBit, },
  {Feature_UseSSE1Bit, },
  {Feature_UseSSE2Bit, },
  {Feature_UseSSE3Bit, },
  {Feature_UseSSE41Bit, },
  {Feature_UseSSSE3Bit, },
  {Feature_HasAESBit, Feature_HasAVXBit, },
  {Feature_HasAESBit, Feature_NoAVXBit, },
  {Feature_HasAMXBF16Bit, Feature_In64BitModeBit, },
  {Feature_HasAMXCOMPLEXBit, Feature_In64BitModeBit, },
  {Feature_HasAMXFP16Bit, Feature_In64BitModeBit, },
  {Feature_HasAMXFP8Bit, Feature_In64BitModeBit, },
  {Feature_HasAMXINT8Bit, Feature_In64BitModeBit, },
  {Feature_HasAMXTF32Bit, Feature_In64BitModeBit, },
  {Feature_HasAMXTILEBit, Feature_In64BitModeBit, },
  {Feature_HasAMXTRANSPOSEBit, Feature_In64BitModeBit, },
  {Feature_HasAVXBit, Feature_In64BitModeBit, },
  {Feature_HasAVXBit, Feature_NoBWIBit, },
  {Feature_HasAVXBit, Feature_NoVLXBit, },
  {Feature_HasAVXBit, Feature_NoVLX_Or_NoBWIBit, },
  {Feature_HasAVX10_2Bit, Feature_HasSM4Bit, },
  {Feature_HasAVX10_2_512Bit, Feature_HasSM4Bit, },
  {Feature_HasAVX2Bit, Feature_NoVLXBit, },
  {Feature_HasAVX2Bit, Feature_NoVLX_Or_NoBWIBit, },
  {Feature_HasAVX512Bit, Feature_HasVAESBit, },
  {Feature_HasAVX512Bit, Feature_HasVLXBit, },
  {Feature_HasAVX512Bit, Feature_HasVPCLMULQDQBit, },
  {Feature_HasAVX512Bit, Feature_NoBWIBit, },
  {Feature_HasAVX512Bit, Feature_NoDQIBit, },
  {Feature_HasAVX512Bit, Feature_NoEGPRBit, },
  {Feature_HasAVX512Bit, Feature_OptForSizeBit, },
  {Feature_HasBITALGBit, Feature_HasVLXBit, },
  {Feature_HasBMIBit, Feature_HasEGPRBit, },
  {Feature_HasBMIBit, Feature_NoEGPRBit, },
  {Feature_HasBMI2Bit, Feature_HasEGPRBit, },
  {Feature_HasBMI2Bit, Feature_NoEGPRBit, },
  {Feature_HasBWIBit, Feature_HasVLXBit, },
  {Feature_HasBWIBit, Feature_NoEGPRBit, },
  {Feature_HasCDIBit, Feature_HasVLXBit, },
  {Feature_HasCRC32Bit, Feature_NoEGPRBit, },
  {Feature_HasDQIBit, Feature_HasVLXBit, },
  {Feature_HasDQIBit, Feature_NoBWIBit, },
  {Feature_HasDQIBit, Feature_NoEGPRBit, },
  {Feature_HasEGPRBit, Feature_HasINVPCIDBit, },
  {Feature_HasEGPRBit, Feature_In64BitModeBit, },
  {Feature_HasEVEX512Bit, Feature_NoVLXBit, },
  {Feature_HasFMA4Bit, Feature_NoAVX512Bit, },
  {Feature_HasFMA4Bit, Feature_NoVLXBit, },
  {Feature_HasFP16Bit, Feature_HasVLXBit, },
  {Feature_HasFP16Bit, Feature_In64BitModeBit, },
  {Feature_HasFP16Bit, Feature_OptForSizeBit, },
  {Feature_HasFSGSBaseBit, Feature_In64BitModeBit, },
  {Feature_HasFXSRBit, Feature_In64BitModeBit, },
  {Feature_HasINVPCIDBit, Feature_NoEGPRBit, },
  {Feature_HasINVPCIDBit, Feature_Not64BitModeBit, },
  {Feature_HasMOVBEBit, Feature_NoEGPRBit, },
  {Feature_HasMOVDIR64BBit, Feature_NoEGPRBit, },
  {Feature_HasMOVDIRIBit, Feature_NoEGPRBit, },
  {Feature_HasNDDBit, Feature_In64BitModeBit, },
  {Feature_HasNDDBit, Feature_UseIncDecBit, },
  {Feature_HasPCLMULBit, Feature_NoAVXBit, },
  {Feature_HasPREFETCHIBit, Feature_In64BitModeBit, },
  {Feature_HasPTWRITEBit, Feature_In64BitModeBit, },
  {Feature_HasRDPIDBit, Feature_In64BitModeBit, },
  {Feature_HasRDPIDBit, Feature_Not64BitModeBit, },
  {Feature_HasUINTRBit, Feature_In64BitModeBit, },
  {Feature_HasUSERMSRBit, Feature_NoEGPRBit, },
  {Feature_HasVAESBit, Feature_HasVLXBit, },
  {Feature_HasVAESBit, Feature_NoVLXBit, },
  {Feature_HasVBMI2Bit, Feature_HasVLXBit, },
  {Feature_HasVLXBit, Feature_HasVPCLMULQDQBit, },
  {Feature_HasVLXBit, Feature_HasVPOPCNTDQBit, },
  {Feature_HasVPCLMULQDQBit, Feature_NoVLXBit, },
  {Feature_HasWAITPKGBit, Feature_In64BitModeBit, },
  {Feature_HasWAITPKGBit, Feature_Not64BitModeBit, },
  {Feature_HasXSAVEBit, Feature_In64BitModeBit, },
  {Feature_HasXSAVECBit, Feature_In64BitModeBit, },
  {Feature_HasXSAVEOPTBit, Feature_In64BitModeBit, },
  {Feature_HasXSAVESBit, Feature_In64BitModeBit, },
  {Feature_In64BitModeBit, Feature_UseIncDecBit, },
  {Feature_In64BitModeBit, Feature_UseSSE2Bit, },
  {Feature_NoNDDBit, Feature_UseIncDecBit, },
  {Feature_Not64BitModeBit, Feature_OptForSizeBit, },
  {Feature_NotWin64WithoutFPBit, Feature_OptForMinSizeBit, },
  {Feature_OptForSizeBit, Feature_UseAVXBit, },
  {Feature_OptForSizeBit, Feature_UseSSE1Bit, },
  {Feature_OptForSizeBit, Feature_UseSSE2Bit, },
  {Feature_HasAESBit, Feature_HasAVXBit, Feature_NoVLX_Or_NoVAESBit, },
  {Feature_HasAMXAVX512Bit, Feature_HasAVX10_2_512Bit, Feature_In64BitModeBit, },
  {Feature_HasAMXBF16Bit, Feature_HasAMXTRANSPOSEBit, Feature_In64BitModeBit, },
  {Feature_HasAMXCOMPLEXBit, Feature_HasAMXTRANSPOSEBit, Feature_In64BitModeBit, },
  {Feature_HasAMXFP16Bit, Feature_HasAMXTRANSPOSEBit, Feature_In64BitModeBit, },
  {Feature_HasAMXTF32Bit, Feature_HasAMXTRANSPOSEBit, Feature_In64BitModeBit, },
  {Feature_HasAMXTILEBit, Feature_HasEGPRBit, Feature_In64BitModeBit, },
  {Feature_HasAMXTILEBit, Feature_In64BitModeBit, Feature_NoEGPRBit, },
  {Feature_HasAVXBit, Feature_HasPCLMULBit, Feature_NoVLX_Or_NoVPCLMULQDQBit, },
  {Feature_HasAVX10_2Bit, Feature_HasMOVRSBit, Feature_In64BitModeBit, },
  {Feature_HasAVX10_2_512Bit, Feature_HasMOVRSBit, Feature_In64BitModeBit, },
  {Feature_HasAVX512Bit, Feature_HasEGPRBit, Feature_In64BitModeBit, },
  {Feature_HasAVX512Bit, Feature_HasEVEX512Bit, Feature_NoVLXBit, },
  {Feature_HasBITALGBit, Feature_HasEVEX512Bit, Feature_NoVLXBit, },
  {Feature_HasBWIBit, Feature_HasEGPRBit, Feature_In64BitModeBit, },
  {Feature_HasBWIBit, Feature_HasEVEX512Bit, Feature_NoVLXBit, },
  {Feature_HasCDIBit, Feature_HasEVEX512Bit, Feature_NoVLXBit, },
  {Feature_HasCRC32Bit, Feature_HasEGPRBit, Feature_In64BitModeBit, },
  {Feature_HasDQIBit, Feature_HasEGPRBit, Feature_In64BitModeBit, },
  {Feature_HasDQIBit, Feature_HasEVEX512Bit, Feature_NoVLXBit, },
  {Feature_HasDQIBit, Feature_HasVLXBit, Feature_NoBWIBit, },
  {Feature_HasEGPRBit, Feature_HasMOVBEBit, Feature_In64BitModeBit, },
  {Feature_HasEGPRBit, Feature_HasMOVDIR64BBit, Feature_In64BitModeBit, },
  {Feature_HasEGPRBit, Feature_HasMOVDIRIBit, Feature_In64BitModeBit, },
  {Feature_HasEGPRBit, Feature_HasMOVRSBit, Feature_In64BitModeBit, },
  {Feature_HasEGPRBit, Feature_HasUSERMSRBit, Feature_In64BitModeBit, },
  {Feature_HasEVEX512Bit, Feature_HasVPOPCNTDQBit, Feature_NoVLXBit, },
  {Feature_HasFMABit, Feature_NoAVX512Bit, Feature_NoFMA4Bit, },
  {Feature_HasFMABit, Feature_NoFMA4Bit, Feature_NoVLXBit, },
  {Feature_HasMOVBEBit, Feature_HasNDDBit, Feature_In64BitModeBit, },
  {Feature_HasMOVDIR64BBit, Feature_In64BitModeBit, Feature_NoEGPRBit, },
  {Feature_HasMOVDIRIBit, Feature_In64BitModeBit, Feature_NoEGPRBit, },
  {Feature_HasMOVRSBit, Feature_In64BitModeBit, Feature_NoEGPRBit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
  GICP_gi_addr,
};
// See constructor for table contents

X86InstructionSelector::ComplexMatcherMemFn
X86InstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
  &X86InstructionSelector::selectAddr, // gi_addr
};

// PatFrag predicates.
enum {
  GICXXPred_MI_Predicate_alignedload = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_alignedstore,
  GICXXPred_MI_Predicate_imm_su,
  GICXXPred_MI_Predicate_loadi8,
  GICXXPred_MI_Predicate_loadi16,
  GICXXPred_MI_Predicate_loadi32,
  GICXXPred_MI_Predicate_or_disjoint,
};
bool X86InstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_alignedload: {
    
        auto &LdSt = cast<GLoadStore>(MI);
        return LdSt.getAlign() >= LdSt.getMemSize().getValue();
      
    llvm_unreachable("alignedload should have returned");
  }
  case GICXXPred_MI_Predicate_alignedstore: {
    
        auto &LdSt = cast<GLoadStore>(MI);
        return LdSt.getAlign() >= LdSt.getMemSize().getValue();
      
    llvm_unreachable("alignedstore should have returned");
  }
  case GICXXPred_MI_Predicate_imm_su: {
     return true; 
  }
  case GICXXPred_MI_Predicate_loadi8: {
     return isa<GLoad>(MI); 
  }
  case GICXXPred_MI_Predicate_loadi16: {
    
        auto &Load = cast<GLoad>(MI);
        LLT Ty = MRI.getType(Load.getDstReg());
        // Non extending load has MMO and destination types of the same size
        if (Load.getMemSizeInBits() == Ty.getSizeInBits())
           return true;
        return Load.getAlign() >= 2 && Load.isSimple();
      
    llvm_unreachable("loadi16 should have returned");
  }
  case GICXXPred_MI_Predicate_loadi32: {
    
        auto &Load = cast<GLoad>(MI);
        LLT Ty = MRI.getType(Load.getDstReg());
        // Non extending load has MMO and destination types of the same size
        if (Load.getMemSizeInBits() == Ty.getSizeInBits())
           return true;
        return Load.getAlign() >= 4 && Load.isSimple();
      
    llvm_unreachable("loadi32 should have returned");
  }
  case GICXXPred_MI_Predicate_or_disjoint: {
    
        return MI.getFlag(MachineInstr::Disjoint);
      
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool X86InstructionSelector::testMOPredicate_MO(unsigned PredicateID, const MachineOperand & MO, const MatcherState &State) const {
  const auto &Operands = State.RecordedOperands;
  Register Reg = MO.getReg();
  (void)Operands;
  (void)Reg;
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_AndMask64 = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_BTCBTSMask64,
  GICXXPred_I64_Predicate_BTRMask64,
  GICXXPred_I64_Predicate_i16immSExt8,
  GICXXPred_I64_Predicate_i32immSExt8,
  GICXXPred_I64_Predicate_i64immSExt8,
  GICXXPred_I64_Predicate_i64immSExt32,
  GICXXPred_I64_Predicate_i64immZExt32,
  GICXXPred_I64_Predicate_i64immZExt32SExt8,
  GICXXPred_I64_Predicate_i64timmSExt32,
  GICXXPred_I64_Predicate_immff00_ffff,
};
bool X86InstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_AndMask64: {
    
      return isMask_64(Imm) && !isUInt<32>(Imm);
    
  }
  case GICXXPred_I64_Predicate_BTCBTSMask64: {
    
      return !isInt<32>(Imm) && isPowerOf2_64(Imm);
    
  }
  case GICXXPred_I64_Predicate_BTRMask64: {
    
      return !isUInt<32>(Imm) && !isInt<32>(Imm) && isPowerOf2_64(~Imm);
    
  }
  case GICXXPred_I64_Predicate_i16immSExt8: {
     return isInt<8>(Imm); 
  }
  case GICXXPred_I64_Predicate_i32immSExt8: {
     return isInt<8>(Imm); 
  }
  case GICXXPred_I64_Predicate_i64immSExt8: {
     return isInt<8>(Imm); 
  }
  case GICXXPred_I64_Predicate_i64immSExt32: {
     return isInt<32>(Imm); 
  }
  case GICXXPred_I64_Predicate_i64immZExt32: {
     return isUInt<32>(Imm); 
  }
  case GICXXPred_I64_Predicate_i64immZExt32SExt8: {
    
      return isUInt<32>(Imm) && isInt<8>(static_cast<int32_t>(Imm));
    
  }
  case GICXXPred_I64_Predicate_i64timmSExt32: {
     return isInt<32>(Imm); 
  }
  case GICXXPred_I64_Predicate_immff00_ffff: {
    
      return Imm >= 0xff00 && Imm <= 0xffff;
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APFloat_Predicate_fpimm0 = GICXXPred_Invalid + 1,
  GICXXPred_APFloat_Predicate_fpimm1,
  GICXXPred_APFloat_Predicate_fpimmneg0,
  GICXXPred_APFloat_Predicate_fpimmneg1,
};
bool X86InstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APFloat_Predicate_fpimm0: {
    
      return Imm.isExactlyValue(+0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm1: {
    
      return Imm.isExactlyValue(+1.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimmneg0: {
    
      return Imm.isExactlyValue(-0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimmneg1: {
    
      return Imm.isExactlyValue(-1.0);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool X86InstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool X86InstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("X86InstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
};
X86InstructionSelector::CustomRendererFn
X86InstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
};

bool X86InstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool X86InstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("X86InstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *X86InstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*      0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(344), /*)*//*default:*//*Label 79*/ GIMT_Encode4(236811),
     /*     10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(1174),
     /*     14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(7407),
     /*     18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(10943), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     46 */ /*TargetOpcode::G_AND*//*Label 3*/ GIMT_Encode4(14726),
     /*     50 */ /*TargetOpcode::G_OR*//*Label 4*/ GIMT_Encode4(25318),
     /*     54 */ /*TargetOpcode::G_XOR*//*Label 5*/ GIMT_Encode4(33722), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    114 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 6*/ GIMT_Encode4(46423), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    126 */ /*TargetOpcode::G_BITCAST*//*Label 7*/ GIMT_Encode4(46590), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    150 */ /*TargetOpcode::G_INTRINSIC_LRINT*//*Label 8*/ GIMT_Encode4(48880),
     /*    154 */ /*TargetOpcode::G_INTRINSIC_LLRINT*//*Label 9*/ GIMT_Encode4(52058), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    170 */ /*TargetOpcode::G_LOAD*//*Label 10*/ GIMT_Encode4(53278),
     /*    174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 11*/ GIMT_Encode4(59503),
     /*    178 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 12*/ GIMT_Encode4(59836), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    194 */ /*TargetOpcode::G_STORE*//*Label 13*/ GIMT_Encode4(60491), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    210 */ /*TargetOpcode::G_ATOMICRMW_XCHG*//*Label 14*/ GIMT_Encode4(85954),
     /*    214 */ /*TargetOpcode::G_ATOMICRMW_ADD*//*Label 15*/ GIMT_Encode4(86190), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    298 */ /*TargetOpcode::G_PREFETCH*//*Label 16*/ GIMT_Encode4(86438), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    314 */ /*TargetOpcode::G_INTRINSIC*//*Label 17*/ GIMT_Encode4(86757),
     /*    318 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 18*/ GIMT_Encode4(100583), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    330 */ /*TargetOpcode::G_ANYEXT*//*Label 19*/ GIMT_Encode4(109658),
     /*    334 */ /*TargetOpcode::G_TRUNC*//*Label 20*/ GIMT_Encode4(110093), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    350 */ /*TargetOpcode::G_CONSTANT*//*Label 21*/ GIMT_Encode4(111182),
     /*    354 */ /*TargetOpcode::G_FCONSTANT*//*Label 22*/ GIMT_Encode4(111788), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    366 */ /*TargetOpcode::G_SEXT*//*Label 23*/ GIMT_Encode4(112241),
     /*    370 */ /*TargetOpcode::G_SEXT_INREG*//*Label 24*/ GIMT_Encode4(113913),
     /*    374 */ /*TargetOpcode::G_ZEXT*//*Label 25*/ GIMT_Encode4(114155),
     /*    378 */ /*TargetOpcode::G_SHL*//*Label 26*/ GIMT_Encode4(116139),
     /*    382 */ /*TargetOpcode::G_LSHR*//*Label 27*/ GIMT_Encode4(118423),
     /*    386 */ /*TargetOpcode::G_ASHR*//*Label 28*/ GIMT_Encode4(120467),
     /*    390 */ /*TargetOpcode::G_FSHL*//*Label 29*/ GIMT_Encode4(122511),
     /*    394 */ /*TargetOpcode::G_FSHR*//*Label 30*/ GIMT_Encode4(123239),
     /*    398 */ /*TargetOpcode::G_ROTR*//*Label 31*/ GIMT_Encode4(123927),
     /*    402 */ /*TargetOpcode::G_ROTL*//*Label 32*/ GIMT_Encode4(127425),
     /*    406 */ /*TargetOpcode::G_ICMP*//*Label 33*/ GIMT_Encode4(131145), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    422 */ /*TargetOpcode::G_SELECT*//*Label 34*/ GIMT_Encode4(132802), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    466 */ /*TargetOpcode::G_UMULH*//*Label 35*/ GIMT_Encode4(140468),
     /*    470 */ /*TargetOpcode::G_SMULH*//*Label 36*/ GIMT_Encode4(141333),
     /*    474 */ /*TargetOpcode::G_UADDSAT*//*Label 37*/ GIMT_Encode4(142198),
     /*    478 */ /*TargetOpcode::G_SADDSAT*//*Label 38*/ GIMT_Encode4(143884),
     /*    482 */ /*TargetOpcode::G_USUBSAT*//*Label 39*/ GIMT_Encode4(145570),
     /*    486 */ /*TargetOpcode::G_SSUBSAT*//*Label 40*/ GIMT_Encode4(146636), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    530 */ /*TargetOpcode::G_FADD*//*Label 41*/ GIMT_Encode4(147702),
     /*    534 */ /*TargetOpcode::G_FSUB*//*Label 42*/ GIMT_Encode4(153616),
     /*    538 */ /*TargetOpcode::G_FMUL*//*Label 43*/ GIMT_Encode4(157798),
     /*    542 */ /*TargetOpcode::G_FMA*//*Label 44*/ GIMT_Encode4(163712), GIMT_Encode4(0),
     /*    550 */ /*TargetOpcode::G_FDIV*//*Label 45*/ GIMT_Encode4(169700), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    598 */ /*TargetOpcode::G_FNEG*//*Label 46*/ GIMT_Encode4(173882),
     /*    602 */ /*TargetOpcode::G_FPEXT*//*Label 47*/ GIMT_Encode4(174005),
     /*    606 */ /*TargetOpcode::G_FPTRUNC*//*Label 48*/ GIMT_Encode4(174937),
     /*    610 */ /*TargetOpcode::G_FPTOSI*//*Label 49*/ GIMT_Encode4(175323),
     /*    614 */ /*TargetOpcode::G_FPTOUI*//*Label 50*/ GIMT_Encode4(176704),
     /*    618 */ /*TargetOpcode::G_SITOFP*//*Label 51*/ GIMT_Encode4(177260),
     /*    622 */ /*TargetOpcode::G_UITOFP*//*Label 52*/ GIMT_Encode4(180636), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    634 */ /*TargetOpcode::G_FABS*//*Label 53*/ GIMT_Encode4(182883), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    714 */ /*TargetOpcode::G_SMIN*//*Label 54*/ GIMT_Encode4(183006),
     /*    718 */ /*TargetOpcode::G_SMAX*//*Label 55*/ GIMT_Encode4(186327),
     /*    722 */ /*TargetOpcode::G_UMIN*//*Label 56*/ GIMT_Encode4(189648),
     /*    726 */ /*TargetOpcode::G_UMAX*//*Label 57*/ GIMT_Encode4(192969),
     /*    730 */ /*TargetOpcode::G_ABS*//*Label 58*/ GIMT_Encode4(196290), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    742 */ /*TargetOpcode::G_BR*//*Label 59*/ GIMT_Encode4(198171), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    758 */ /*TargetOpcode::G_EXTRACT_SUBVECTOR*//*Label 60*/ GIMT_Encode4(198187), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    782 */ /*TargetOpcode::G_VECTOR_COMPRESS*//*Label 61*/ GIMT_Encode4(201116),
     /*    786 */ /*TargetOpcode::G_CTTZ*//*Label 62*/ GIMT_Encode4(203098),
     /*    790 */ /*TargetOpcode::G_CTTZ_ZERO_UNDEF*//*Label 63*/ GIMT_Encode4(203404),
     /*    794 */ /*TargetOpcode::G_CTLZ*//*Label 64*/ GIMT_Encode4(203791), GIMT_Encode4(0),
     /*    802 */ /*TargetOpcode::G_CTPOP*//*Label 65*/ GIMT_Encode4(205095),
     /*    806 */ /*TargetOpcode::G_BSWAP*//*Label 66*/ GIMT_Encode4(207357), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    862 */ /*TargetOpcode::G_FSQRT*//*Label 67*/ GIMT_Encode4(207857), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    902 */ /*TargetOpcode::G_STRICT_FADD*//*Label 68*/ GIMT_Encode4(210026),
     /*    906 */ /*TargetOpcode::G_STRICT_FSUB*//*Label 69*/ GIMT_Encode4(214956),
     /*    910 */ /*TargetOpcode::G_STRICT_FMUL*//*Label 70*/ GIMT_Encode4(218646),
     /*    914 */ /*TargetOpcode::G_STRICT_FDIV*//*Label 71*/ GIMT_Encode4(223576), GIMT_Encode4(0),
     /*    922 */ /*TargetOpcode::G_STRICT_FMA*//*Label 72*/ GIMT_Encode4(227266),
     /*    926 */ /*TargetOpcode::G_STRICT_FSQRT*//*Label 73*/ GIMT_Encode4(233254), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    962 */ /*TargetOpcode::G_TRAP*//*Label 74*/ GIMT_Encode4(235423),
     /*    966 */ /*TargetOpcode::G_DEBUGTRAP*//*Label 75*/ GIMT_Encode4(235436),
     /*    970 */ /*TargetOpcode::G_UBSANTRAP*//*Label 76*/ GIMT_Encode4(235472), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   1166 */ /*X86::G_FILD*//*Label 77*/ GIMT_Encode4(235488),
     /*   1170 */ /*X86::G_FIST*//*Label 78*/ GIMT_Encode4(235947),
     /*   1174 */ // Label 0: @1174
     /*   1174 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(25), /*)*//*default:*//*Label 96*/ GIMT_Encode4(7406),
     /*   1185 */ /*GILLT_s8*//*Label 80*/ GIMT_Encode4(1281),
     /*   1189 */ /*GILLT_s16*//*Label 81*/ GIMT_Encode4(1786),
     /*   1193 */ /*GILLT_s32*//*Label 82*/ GIMT_Encode4(2436),
     /*   1197 */ /*GILLT_s64*//*Label 83*/ GIMT_Encode4(3086), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   1213 */ /*GILLT_v2s64*//*Label 84*/ GIMT_Encode4(3910), GIMT_Encode4(0),
     /*   1221 */ /*GILLT_v4s32*//*Label 85*/ GIMT_Encode4(4252),
     /*   1225 */ /*GILLT_v4s64*//*Label 86*/ GIMT_Encode4(4716), GIMT_Encode4(0),
     /*   1233 */ /*GILLT_v8s16*//*Label 87*/ GIMT_Encode4(5031),
     /*   1237 */ /*GILLT_v8s32*//*Label 88*/ GIMT_Encode4(5495),
     /*   1241 */ /*GILLT_v8s64*//*Label 89*/ GIMT_Encode4(5810), GIMT_Encode4(0),
     /*   1249 */ /*GILLT_v16s8*//*Label 90*/ GIMT_Encode4(5966),
     /*   1253 */ /*GILLT_v16s16*//*Label 91*/ GIMT_Encode4(6308),
     /*   1257 */ /*GILLT_v16s32*//*Label 92*/ GIMT_Encode4(6623), GIMT_Encode4(0),
     /*   1265 */ /*GILLT_v32s8*//*Label 93*/ GIMT_Encode4(6779),
     /*   1269 */ /*GILLT_v32s16*//*Label 94*/ GIMT_Encode4(7094), GIMT_Encode4(0),
     /*   1277 */ /*GILLT_v64s8*//*Label 95*/ GIMT_Encode4(7250),
     /*   1281 */ // Label 80: @1281
     /*   1281 */ GIM_Try, /*On fail goto*//*Label 97*/ GIMT_Encode4(1785),
     /*   1286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /*   1289 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /*   1292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1296 */   GIM_Try, /*On fail goto*//*Label 98*/ GIMT_Encode4(1357), // Rule ID 26054 //
     /*   1301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   1304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   1312 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   1315 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   1319 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*   1323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1329 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   1336 */     // (add:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, GR8:{ *:[i8] }:$src1)  =>  (ADD8rm:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   1336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8rm),
     /*   1339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1341 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   1343 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   1347 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1350 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   1355 */     GIR_RootConstrainSelectedInstOperands,
     /*   1356 */     // GIR_Coverage, 26054,
     /*   1356 */     GIR_EraseRootFromParent_Done,
     /*   1357 */   // Label 98: @1357
     /*   1357 */   GIM_Try, /*On fail goto*//*Label 99*/ GIMT_Encode4(1418), // Rule ID 26073 //
     /*   1362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   1365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   1373 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   1376 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   1380 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*   1384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1390 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   1397 */     // (add:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, GR8:{ *:[i8] }:$src1)  =>  (ADD8rm_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   1397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8rm_ND),
     /*   1400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1402 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   1404 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   1408 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1411 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   1416 */     GIR_RootConstrainSelectedInstOperands,
     /*   1417 */     // GIR_Coverage, 26073,
     /*   1417 */     GIR_EraseRootFromParent_Done,
     /*   1418 */   // Label 99: @1418
     /*   1418 */   GIM_Try, /*On fail goto*//*Label 100*/ GIMT_Encode4(1479), // Rule ID 22796 //
     /*   1423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   1426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   1438 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   1441 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   1445 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*   1449 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1451 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   1458 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (ADD8rm:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   1458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8rm),
     /*   1461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1463 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   1465 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   1469 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1472 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   1477 */     GIR_RootConstrainSelectedInstOperands,
     /*   1478 */     // GIR_Coverage, 22796,
     /*   1478 */     GIR_EraseRootFromParent_Done,
     /*   1479 */   // Label 100: @1479
     /*   1479 */   GIM_Try, /*On fail goto*//*Label 101*/ GIMT_Encode4(1540), // Rule ID 22886 //
     /*   1484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   1487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   1499 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   1502 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   1506 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*   1510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1512 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   1519 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (ADD8rm_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   1519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8rm_ND),
     /*   1522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1524 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   1526 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   1530 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1533 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   1538 */     GIR_RootConstrainSelectedInstOperands,
     /*   1539 */     // GIR_Coverage, 22886,
     /*   1539 */     GIR_EraseRootFromParent_Done,
     /*   1540 */   // Label 101: @1540
     /*   1540 */   GIM_Try, /*On fail goto*//*Label 102*/ GIMT_Encode4(1568), // Rule ID 22862 //
     /*   1545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*   1548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1552 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*   1556 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src, 1:{ *:[i8] })  =>  (INC8r:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /*   1556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC8r),
     /*   1559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1561 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   1563 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1566 */     GIR_RootConstrainSelectedInstOperands,
     /*   1567 */     // GIR_Coverage, 22862,
     /*   1567 */     GIR_EraseRootFromParent_Done,
     /*   1568 */   // Label 102: @1568
     /*   1568 */   GIM_Try, /*On fail goto*//*Label 103*/ GIMT_Encode4(1596), // Rule ID 22866 //
     /*   1573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*   1576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1580 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*   1584 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src, -1:{ *:[i8] })  =>  (DEC8r:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /*   1584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC8r),
     /*   1587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1589 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   1591 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1594 */     GIR_RootConstrainSelectedInstOperands,
     /*   1595 */     // GIR_Coverage, 22866,
     /*   1595 */     GIR_EraseRootFromParent_Done,
     /*   1596 */   // Label 103: @1596
     /*   1596 */   GIM_Try, /*On fail goto*//*Label 104*/ GIMT_Encode4(1624), // Rule ID 22952 //
     /*   1601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*   1604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1608 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*   1612 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src, 1:{ *:[i8] })  =>  (INC8r_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /*   1612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC8r_ND),
     /*   1615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1617 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   1619 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1622 */     GIR_RootConstrainSelectedInstOperands,
     /*   1623 */     // GIR_Coverage, 22952,
     /*   1623 */     GIR_EraseRootFromParent_Done,
     /*   1624 */   // Label 104: @1624
     /*   1624 */   GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(1652), // Rule ID 22956 //
     /*   1629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*   1632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1636 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*   1640 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src, -1:{ *:[i8] })  =>  (DEC8r_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /*   1640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC8r_ND),
     /*   1643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1645 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   1647 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1650 */     GIR_RootConstrainSelectedInstOperands,
     /*   1651 */     // GIR_Coverage, 22956,
     /*   1651 */     GIR_EraseRootFromParent_Done,
     /*   1652 */   // Label 105: @1652
     /*   1652 */   GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(1689), // Rule ID 22800 //
     /*   1657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   1660 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   1672 */     // MIs[1] Operand 1
     /*   1672 */     // No operand predicates
     /*   1672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1674 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ADD8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*   1674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8ri),
     /*   1677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1679 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   1681 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   1684 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1687 */     GIR_RootConstrainSelectedInstOperands,
     /*   1688 */     // GIR_Coverage, 22800,
     /*   1688 */     GIR_EraseRootFromParent_Done,
     /*   1689 */   // Label 106: @1689
     /*   1689 */   GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(1726), // Rule ID 22890 //
     /*   1694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   1697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   1709 */     // MIs[1] Operand 1
     /*   1709 */     // No operand predicates
     /*   1709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1711 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ADD8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*   1711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8ri_ND),
     /*   1714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1716 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   1718 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   1721 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1724 */     GIR_RootConstrainSelectedInstOperands,
     /*   1725 */     // GIR_Coverage, 22890,
     /*   1725 */     GIR_EraseRootFromParent_Done,
     /*   1726 */   // Label 107: @1726
     /*   1726 */   GIM_Try, /*On fail goto*//*Label 108*/ GIMT_Encode4(1755), // Rule ID 22792 //
     /*   1731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   1734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1742 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (ADD8rr:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*   1742 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD8rr),
     /*   1747 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   1753 */     GIR_RootConstrainSelectedInstOperands,
     /*   1754 */     // GIR_Coverage, 22792,
     /*   1754 */     GIR_Done,
     /*   1755 */   // Label 108: @1755
     /*   1755 */   GIM_Try, /*On fail goto*//*Label 109*/ GIMT_Encode4(1784), // Rule ID 22882 //
     /*   1760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   1763 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1771 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (ADD8rr_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*   1771 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD8rr_ND),
     /*   1776 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   1782 */     GIR_RootConstrainSelectedInstOperands,
     /*   1783 */     // GIR_Coverage, 22882,
     /*   1783 */     GIR_Done,
     /*   1784 */   // Label 109: @1784
     /*   1784 */   GIM_Reject,
     /*   1785 */ // Label 97: @1785
     /*   1785 */ GIM_Reject,
     /*   1786 */ // Label 81: @1786
     /*   1786 */ GIM_Try, /*On fail goto*//*Label 110*/ GIMT_Encode4(2435),
     /*   1791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*   1794 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*   1797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   1801 */   GIM_Try, /*On fail goto*//*Label 111*/ GIMT_Encode4(1870), // Rule ID 22617 //
     /*   1806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   1809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   1817 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   1820 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   1824 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*   1828 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*   1839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1841 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   1848 */     // (add:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 128:{ *:[i16] })  =>  (SUB16mi_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src, -128:{ *:[i16] })
     /*   1848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16mi_ND),
     /*   1851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1853 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*   1857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*   1860 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1863 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   1868 */     GIR_RootConstrainSelectedInstOperands,
     /*   1869 */     // GIR_Coverage, 22617,
     /*   1869 */     GIR_EraseRootFromParent_Done,
     /*   1870 */   // Label 111: @1870
     /*   1870 */   GIM_Try, /*On fail goto*//*Label 112*/ GIMT_Encode4(1931), // Rule ID 26055 //
     /*   1875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   1878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   1886 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   1889 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   1893 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*   1897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   1901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1903 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   1910 */     // (add:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (ADD16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   1910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16rm),
     /*   1913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1915 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   1917 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   1921 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   1929 */     GIR_RootConstrainSelectedInstOperands,
     /*   1930 */     // GIR_Coverage, 26055,
     /*   1930 */     GIR_EraseRootFromParent_Done,
     /*   1931 */   // Label 112: @1931
     /*   1931 */   GIM_Try, /*On fail goto*//*Label 113*/ GIMT_Encode4(1992), // Rule ID 26074 //
     /*   1936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   1939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   1947 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   1950 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   1954 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*   1958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   1962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1964 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   1971 */     // (add:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (ADD16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   1971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16rm_ND),
     /*   1974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1976 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   1978 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   1982 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1985 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   1990 */     GIR_RootConstrainSelectedInstOperands,
     /*   1991 */     // GIR_Coverage, 26074,
     /*   1991 */     GIR_EraseRootFromParent_Done,
     /*   1992 */   // Label 113: @1992
     /*   1992 */   GIM_Try, /*On fail goto*//*Label 114*/ GIMT_Encode4(2053), // Rule ID 22797 //
     /*   1997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   2000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   2012 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   2015 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   2019 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*   2023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2025 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   2032 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (ADD16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   2032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16rm),
     /*   2035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2037 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2039 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   2043 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2046 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   2051 */     GIR_RootConstrainSelectedInstOperands,
     /*   2052 */     // GIR_Coverage, 22797,
     /*   2052 */     GIR_EraseRootFromParent_Done,
     /*   2053 */   // Label 114: @2053
     /*   2053 */   GIM_Try, /*On fail goto*//*Label 115*/ GIMT_Encode4(2114), // Rule ID 22887 //
     /*   2058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   2073 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   2076 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   2080 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*   2084 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2086 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   2093 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (ADD16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   2093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16rm_ND),
     /*   2096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2098 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2100 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   2104 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2107 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   2112 */     GIR_RootConstrainSelectedInstOperands,
     /*   2113 */     // GIR_Coverage, 22887,
     /*   2113 */     GIR_EraseRootFromParent_Done,
     /*   2114 */   // Label 115: @2114
     /*   2114 */   GIM_Try, /*On fail goto*//*Label 116*/ GIMT_Encode4(2152), // Rule ID 22602 //
     /*   2119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   2122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2126 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*   2137 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, 128:{ *:[i16] })  =>  (SUB16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, -128:{ *:[i16] })
     /*   2137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16ri),
     /*   2140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2142 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*   2147 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2150 */     GIR_RootConstrainSelectedInstOperands,
     /*   2151 */     // GIR_Coverage, 22602,
     /*   2151 */     GIR_EraseRootFromParent_Done,
     /*   2152 */   // Label 116: @2152
     /*   2152 */   GIM_Try, /*On fail goto*//*Label 117*/ GIMT_Encode4(2190), // Rule ID 22608 //
     /*   2157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2164 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*   2175 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, 128:{ *:[i16] })  =>  (SUB16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, -128:{ *:[i16] })
     /*   2175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16ri_ND),
     /*   2178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2180 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*   2185 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2188 */     GIR_RootConstrainSelectedInstOperands,
     /*   2189 */     // GIR_Coverage, 22608,
     /*   2189 */     GIR_EraseRootFromParent_Done,
     /*   2190 */   // Label 117: @2190
     /*   2190 */   GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(2218), // Rule ID 22863 //
     /*   2195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*   2198 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2202 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*   2206 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src, 1:{ *:[i16] })  =>  (INC16r:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src)
     /*   2206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC16r),
     /*   2209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2211 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   2213 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2216 */     GIR_RootConstrainSelectedInstOperands,
     /*   2217 */     // GIR_Coverage, 22863,
     /*   2217 */     GIR_EraseRootFromParent_Done,
     /*   2218 */   // Label 118: @2218
     /*   2218 */   GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(2246), // Rule ID 22867 //
     /*   2223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*   2226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2230 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*   2234 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src, -1:{ *:[i16] })  =>  (DEC16r:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src)
     /*   2234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC16r),
     /*   2237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2239 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   2241 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2244 */     GIR_RootConstrainSelectedInstOperands,
     /*   2245 */     // GIR_Coverage, 22867,
     /*   2245 */     GIR_EraseRootFromParent_Done,
     /*   2246 */   // Label 119: @2246
     /*   2246 */   GIM_Try, /*On fail goto*//*Label 120*/ GIMT_Encode4(2274), // Rule ID 22953 //
     /*   2251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*   2254 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2258 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*   2262 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src, 1:{ *:[i16] })  =>  (INC16r_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src)
     /*   2262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC16r_ND),
     /*   2265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2267 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   2269 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2272 */     GIR_RootConstrainSelectedInstOperands,
     /*   2273 */     // GIR_Coverage, 22953,
     /*   2273 */     GIR_EraseRootFromParent_Done,
     /*   2274 */   // Label 120: @2274
     /*   2274 */   GIM_Try, /*On fail goto*//*Label 121*/ GIMT_Encode4(2302), // Rule ID 22957 //
     /*   2279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*   2282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2286 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*   2290 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src, -1:{ *:[i16] })  =>  (DEC16r_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src)
     /*   2290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC16r_ND),
     /*   2293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2295 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   2297 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2300 */     GIR_RootConstrainSelectedInstOperands,
     /*   2301 */     // GIR_Coverage, 22957,
     /*   2301 */     GIR_EraseRootFromParent_Done,
     /*   2302 */   // Label 121: @2302
     /*   2302 */   GIM_Try, /*On fail goto*//*Label 122*/ GIMT_Encode4(2339), // Rule ID 22801 //
     /*   2307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   2310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   2322 */     // MIs[1] Operand 1
     /*   2322 */     // No operand predicates
     /*   2322 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2324 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (ADD16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*   2324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16ri),
     /*   2327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2329 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   2334 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2337 */     GIR_RootConstrainSelectedInstOperands,
     /*   2338 */     // GIR_Coverage, 22801,
     /*   2338 */     GIR_EraseRootFromParent_Done,
     /*   2339 */   // Label 122: @2339
     /*   2339 */   GIM_Try, /*On fail goto*//*Label 123*/ GIMT_Encode4(2376), // Rule ID 22891 //
     /*   2344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   2359 */     // MIs[1] Operand 1
     /*   2359 */     // No operand predicates
     /*   2359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2361 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (ADD16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*   2361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16ri_ND),
     /*   2364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2366 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2368 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   2371 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2374 */     GIR_RootConstrainSelectedInstOperands,
     /*   2375 */     // GIR_Coverage, 22891,
     /*   2375 */     GIR_EraseRootFromParent_Done,
     /*   2376 */   // Label 123: @2376
     /*   2376 */   GIM_Try, /*On fail goto*//*Label 124*/ GIMT_Encode4(2405), // Rule ID 22793 //
     /*   2381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   2384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2392 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (ADD16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*   2392 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD16rr),
     /*   2397 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   2403 */     GIR_RootConstrainSelectedInstOperands,
     /*   2404 */     // GIR_Coverage, 22793,
     /*   2404 */     GIR_Done,
     /*   2405 */   // Label 124: @2405
     /*   2405 */   GIM_Try, /*On fail goto*//*Label 125*/ GIMT_Encode4(2434), // Rule ID 22883 //
     /*   2410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2421 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (ADD16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*   2421 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD16rr_ND),
     /*   2426 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   2432 */     GIR_RootConstrainSelectedInstOperands,
     /*   2433 */     // GIR_Coverage, 22883,
     /*   2433 */     GIR_Done,
     /*   2434 */   // Label 125: @2434
     /*   2434 */   GIM_Reject,
     /*   2435 */ // Label 110: @2435
     /*   2435 */ GIM_Reject,
     /*   2436 */ // Label 82: @2436
     /*   2436 */ GIM_Try, /*On fail goto*//*Label 126*/ GIMT_Encode4(3085),
     /*   2441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   2444 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   2447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2451 */   GIM_Try, /*On fail goto*//*Label 127*/ GIMT_Encode4(2520), // Rule ID 22618 //
     /*   2456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   2467 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   2470 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   2474 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*   2478 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*   2489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2491 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   2498 */     // (add:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 128:{ *:[i32] })  =>  (SUB32mi_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src, -128:{ *:[i32] })
     /*   2498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32mi_ND),
     /*   2501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2503 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*   2507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*   2510 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2513 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   2518 */     GIR_RootConstrainSelectedInstOperands,
     /*   2519 */     // GIR_Coverage, 22618,
     /*   2519 */     GIR_EraseRootFromParent_Done,
     /*   2520 */   // Label 127: @2520
     /*   2520 */   GIM_Try, /*On fail goto*//*Label 128*/ GIMT_Encode4(2581), // Rule ID 26056 //
     /*   2525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   2528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   2536 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   2539 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   2543 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*   2547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2553 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   2560 */     // (add:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (ADD32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   2560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32rm),
     /*   2563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2565 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   2567 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   2571 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2574 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   2579 */     GIR_RootConstrainSelectedInstOperands,
     /*   2580 */     // GIR_Coverage, 26056,
     /*   2580 */     GIR_EraseRootFromParent_Done,
     /*   2581 */   // Label 128: @2581
     /*   2581 */   GIM_Try, /*On fail goto*//*Label 129*/ GIMT_Encode4(2642), // Rule ID 26075 //
     /*   2586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   2597 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   2600 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   2604 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*   2608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2612 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2614 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   2621 */     // (add:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (ADD32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   2621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32rm_ND),
     /*   2624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2626 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   2628 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   2632 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2635 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   2640 */     GIR_RootConstrainSelectedInstOperands,
     /*   2641 */     // GIR_Coverage, 26075,
     /*   2641 */     GIR_EraseRootFromParent_Done,
     /*   2642 */   // Label 129: @2642
     /*   2642 */   GIM_Try, /*On fail goto*//*Label 130*/ GIMT_Encode4(2703), // Rule ID 22798 //
     /*   2647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   2650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   2662 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   2665 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   2669 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*   2673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2675 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   2682 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (ADD32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   2682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32rm),
     /*   2685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2687 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2689 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   2693 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2696 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   2701 */     GIR_RootConstrainSelectedInstOperands,
     /*   2702 */     // GIR_Coverage, 22798,
     /*   2702 */     GIR_EraseRootFromParent_Done,
     /*   2703 */   // Label 130: @2703
     /*   2703 */   GIM_Try, /*On fail goto*//*Label 131*/ GIMT_Encode4(2764), // Rule ID 22888 //
     /*   2708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   2723 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   2726 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   2730 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*   2734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2736 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   2743 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (ADD32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   2743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32rm_ND),
     /*   2746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2748 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2750 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   2754 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2757 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   2762 */     GIR_RootConstrainSelectedInstOperands,
     /*   2763 */     // GIR_Coverage, 22888,
     /*   2763 */     GIR_EraseRootFromParent_Done,
     /*   2764 */   // Label 131: @2764
     /*   2764 */   GIM_Try, /*On fail goto*//*Label 132*/ GIMT_Encode4(2802), // Rule ID 22603 //
     /*   2769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   2772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2776 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*   2787 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, 128:{ *:[i32] })  =>  (SUB32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, -128:{ *:[i32] })
     /*   2787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32ri),
     /*   2790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2792 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*   2797 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2800 */     GIR_RootConstrainSelectedInstOperands,
     /*   2801 */     // GIR_Coverage, 22603,
     /*   2801 */     GIR_EraseRootFromParent_Done,
     /*   2802 */   // Label 132: @2802
     /*   2802 */   GIM_Try, /*On fail goto*//*Label 133*/ GIMT_Encode4(2840), // Rule ID 22609 //
     /*   2807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2814 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*   2825 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, 128:{ *:[i32] })  =>  (SUB32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, -128:{ *:[i32] })
     /*   2825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32ri_ND),
     /*   2828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2830 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*   2835 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2838 */     GIR_RootConstrainSelectedInstOperands,
     /*   2839 */     // GIR_Coverage, 22609,
     /*   2839 */     GIR_EraseRootFromParent_Done,
     /*   2840 */   // Label 133: @2840
     /*   2840 */   GIM_Try, /*On fail goto*//*Label 134*/ GIMT_Encode4(2868), // Rule ID 22864 //
     /*   2845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*   2848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2852 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*   2856 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] })  =>  (INC32r:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*   2856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC32r),
     /*   2859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2861 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   2863 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2866 */     GIR_RootConstrainSelectedInstOperands,
     /*   2867 */     // GIR_Coverage, 22864,
     /*   2867 */     GIR_EraseRootFromParent_Done,
     /*   2868 */   // Label 134: @2868
     /*   2868 */   GIM_Try, /*On fail goto*//*Label 135*/ GIMT_Encode4(2896), // Rule ID 22868 //
     /*   2873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*   2876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2880 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*   2884 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] })  =>  (DEC32r:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*   2884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC32r),
     /*   2887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2889 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   2891 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2894 */     GIR_RootConstrainSelectedInstOperands,
     /*   2895 */     // GIR_Coverage, 22868,
     /*   2895 */     GIR_EraseRootFromParent_Done,
     /*   2896 */   // Label 135: @2896
     /*   2896 */   GIM_Try, /*On fail goto*//*Label 136*/ GIMT_Encode4(2924), // Rule ID 22954 //
     /*   2901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*   2904 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2908 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*   2912 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] })  =>  (INC32r_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*   2912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC32r_ND),
     /*   2915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2917 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   2919 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2922 */     GIR_RootConstrainSelectedInstOperands,
     /*   2923 */     // GIR_Coverage, 22954,
     /*   2923 */     GIR_EraseRootFromParent_Done,
     /*   2924 */   // Label 136: @2924
     /*   2924 */   GIM_Try, /*On fail goto*//*Label 137*/ GIMT_Encode4(2952), // Rule ID 22958 //
     /*   2929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*   2932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2936 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*   2940 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] })  =>  (DEC32r_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*   2940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC32r_ND),
     /*   2943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2945 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   2947 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2950 */     GIR_RootConstrainSelectedInstOperands,
     /*   2951 */     // GIR_Coverage, 22958,
     /*   2951 */     GIR_EraseRootFromParent_Done,
     /*   2952 */   // Label 137: @2952
     /*   2952 */   GIM_Try, /*On fail goto*//*Label 138*/ GIMT_Encode4(2989), // Rule ID 22802 //
     /*   2957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   2960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   2972 */     // MIs[1] Operand 1
     /*   2972 */     // No operand predicates
     /*   2972 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2974 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (ADD32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*   2974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32ri),
     /*   2977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2979 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   2984 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2987 */     GIR_RootConstrainSelectedInstOperands,
     /*   2988 */     // GIR_Coverage, 22802,
     /*   2988 */     GIR_EraseRootFromParent_Done,
     /*   2989 */   // Label 138: @2989
     /*   2989 */   GIM_Try, /*On fail goto*//*Label 139*/ GIMT_Encode4(3026), // Rule ID 22892 //
     /*   2994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   3001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   3009 */     // MIs[1] Operand 1
     /*   3009 */     // No operand predicates
     /*   3009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3011 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (ADD32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*   3011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32ri_ND),
     /*   3014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3016 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3018 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   3021 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3024 */     GIR_RootConstrainSelectedInstOperands,
     /*   3025 */     // GIR_Coverage, 22892,
     /*   3025 */     GIR_EraseRootFromParent_Done,
     /*   3026 */   // Label 139: @3026
     /*   3026 */   GIM_Try, /*On fail goto*//*Label 140*/ GIMT_Encode4(3055), // Rule ID 22794 //
     /*   3031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   3034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   3038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   3042 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (ADD32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*   3042 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD32rr),
     /*   3047 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   3053 */     GIR_RootConstrainSelectedInstOperands,
     /*   3054 */     // GIR_Coverage, 22794,
     /*   3054 */     GIR_Done,
     /*   3055 */   // Label 140: @3055
     /*   3055 */   GIM_Try, /*On fail goto*//*Label 141*/ GIMT_Encode4(3084), // Rule ID 22884 //
     /*   3060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   3063 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   3067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   3071 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (ADD32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*   3071 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD32rr_ND),
     /*   3076 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   3082 */     GIR_RootConstrainSelectedInstOperands,
     /*   3083 */     // GIR_Coverage, 22884,
     /*   3083 */     GIR_Done,
     /*   3084 */   // Label 141: @3084
     /*   3084 */   GIM_Reject,
     /*   3085 */ // Label 126: @3085
     /*   3085 */ GIM_Reject,
     /*   3086 */ // Label 83: @3086
     /*   3086 */ GIM_Try, /*On fail goto*//*Label 142*/ GIMT_Encode4(3909),
     /*   3091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   3094 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   3097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3101 */   GIM_Try, /*On fail goto*//*Label 143*/ GIMT_Encode4(3170), // Rule ID 22619 //
     /*   3106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   3109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   3117 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   3120 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   3124 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   3128 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*   3139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3141 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   3148 */     // (add:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 128:{ *:[i64] })  =>  (SUB64mi32_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src, -128:{ *:[i64] })
     /*   3148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64mi32_ND),
     /*   3151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3153 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*   3157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*   3160 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3163 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   3168 */     GIR_RootConstrainSelectedInstOperands,
     /*   3169 */     // GIR_Coverage, 22619,
     /*   3169 */     GIR_EraseRootFromParent_Done,
     /*   3170 */   // Label 143: @3170
     /*   3170 */   GIM_Try, /*On fail goto*//*Label 144*/ GIMT_Encode4(3246), // Rule ID 22625 //
     /*   3175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   3178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   3186 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   3189 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   3193 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   3197 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2147483648),
     /*   3208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3210 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   3217 */     // (add:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 2147483648:{ *:[i64] })  =>  (SUB64mi32_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src, -2147483648:{ *:[i64] })
     /*   3217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64mi32_ND),
     /*   3220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3222 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*   3226 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(-2147483648),
     /*   3236 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3239 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   3244 */     GIR_RootConstrainSelectedInstOperands,
     /*   3245 */     // GIR_Coverage, 22625,
     /*   3245 */     GIR_EraseRootFromParent_Done,
     /*   3246 */   // Label 144: @3246
     /*   3246 */   GIM_Try, /*On fail goto*//*Label 145*/ GIMT_Encode4(3307), // Rule ID 26057 //
     /*   3251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   3254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   3262 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   3265 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   3269 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   3273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3279 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   3286 */     // (add:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (ADD64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   3286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64rm),
     /*   3289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3291 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   3293 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   3297 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3300 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   3305 */     GIR_RootConstrainSelectedInstOperands,
     /*   3306 */     // GIR_Coverage, 26057,
     /*   3306 */     GIR_EraseRootFromParent_Done,
     /*   3307 */   // Label 145: @3307
     /*   3307 */   GIM_Try, /*On fail goto*//*Label 146*/ GIMT_Encode4(3368), // Rule ID 26076 //
     /*   3312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   3315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   3323 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   3326 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   3330 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   3334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3340 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   3347 */     // (add:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (ADD64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   3347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64rm_ND),
     /*   3350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3352 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   3354 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   3358 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3361 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   3366 */     GIR_RootConstrainSelectedInstOperands,
     /*   3367 */     // GIR_Coverage, 26076,
     /*   3367 */     GIR_EraseRootFromParent_Done,
     /*   3368 */   // Label 146: @3368
     /*   3368 */   GIM_Try, /*On fail goto*//*Label 147*/ GIMT_Encode4(3429), // Rule ID 22799 //
     /*   3373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   3376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   3388 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   3391 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   3395 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   3399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3401 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   3408 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADD64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   3408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64rm),
     /*   3411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3413 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3415 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   3419 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3422 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   3427 */     GIR_RootConstrainSelectedInstOperands,
     /*   3428 */     // GIR_Coverage, 22799,
     /*   3428 */     GIR_EraseRootFromParent_Done,
     /*   3429 */   // Label 147: @3429
     /*   3429 */   GIM_Try, /*On fail goto*//*Label 148*/ GIMT_Encode4(3490), // Rule ID 22889 //
     /*   3434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   3437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   3449 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   3452 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   3456 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   3460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3462 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   3469 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADD64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   3469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64rm_ND),
     /*   3472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3474 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3476 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   3480 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3483 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   3488 */     GIR_RootConstrainSelectedInstOperands,
     /*   3489 */     // GIR_Coverage, 22889,
     /*   3489 */     GIR_EraseRootFromParent_Done,
     /*   3490 */   // Label 148: @3490
     /*   3490 */   GIM_Try, /*On fail goto*//*Label 149*/ GIMT_Encode4(3528), // Rule ID 22604 //
     /*   3495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   3498 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3502 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*   3513 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, 128:{ *:[i64] })  =>  (SUB64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, -128:{ *:[i64] })
     /*   3513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64ri32),
     /*   3516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3518 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*   3523 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3526 */     GIR_RootConstrainSelectedInstOperands,
     /*   3527 */     // GIR_Coverage, 22604,
     /*   3527 */     GIR_EraseRootFromParent_Done,
     /*   3528 */   // Label 149: @3528
     /*   3528 */   GIM_Try, /*On fail goto*//*Label 150*/ GIMT_Encode4(3566), // Rule ID 22610 //
     /*   3533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   3536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3540 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*   3551 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, 128:{ *:[i64] })  =>  (SUB64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, -128:{ *:[i64] })
     /*   3551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64ri32_ND),
     /*   3554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3556 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*   3561 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3564 */     GIR_RootConstrainSelectedInstOperands,
     /*   3565 */     // GIR_Coverage, 22610,
     /*   3565 */     GIR_EraseRootFromParent_Done,
     /*   3566 */   // Label 150: @3566
     /*   3566 */   GIM_Try, /*On fail goto*//*Label 151*/ GIMT_Encode4(3611), // Rule ID 22620 //
     /*   3571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   3574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3578 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2147483648),
     /*   3589 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, 2147483648:{ *:[i64] })  =>  (SUB64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, -2147483648:{ *:[i64] })
     /*   3589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64ri32),
     /*   3592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3594 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3596 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(-2147483648),
     /*   3606 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3609 */     GIR_RootConstrainSelectedInstOperands,
     /*   3610 */     // GIR_Coverage, 22620,
     /*   3610 */     GIR_EraseRootFromParent_Done,
     /*   3611 */   // Label 151: @3611
     /*   3611 */   GIM_Try, /*On fail goto*//*Label 152*/ GIMT_Encode4(3656), // Rule ID 22622 //
     /*   3616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   3619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3623 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2147483648),
     /*   3634 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, 2147483648:{ *:[i64] })  =>  (SUB64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, -2147483648:{ *:[i64] })
     /*   3634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64ri32_ND),
     /*   3637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3639 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3641 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(-2147483648),
     /*   3651 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3654 */     GIR_RootConstrainSelectedInstOperands,
     /*   3655 */     // GIR_Coverage, 22622,
     /*   3655 */     GIR_EraseRootFromParent_Done,
     /*   3656 */   // Label 152: @3656
     /*   3656 */   GIM_Try, /*On fail goto*//*Label 153*/ GIMT_Encode4(3684), // Rule ID 22865 //
     /*   3661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*   3664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3668 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*   3672 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] })  =>  (INC64r:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*   3672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC64r),
     /*   3675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3677 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   3679 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3682 */     GIR_RootConstrainSelectedInstOperands,
     /*   3683 */     // GIR_Coverage, 22865,
     /*   3683 */     GIR_EraseRootFromParent_Done,
     /*   3684 */   // Label 153: @3684
     /*   3684 */   GIM_Try, /*On fail goto*//*Label 154*/ GIMT_Encode4(3712), // Rule ID 22869 //
     /*   3689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*   3692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3696 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*   3700 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] })  =>  (DEC64r:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*   3700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC64r),
     /*   3703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3705 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   3707 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3710 */     GIR_RootConstrainSelectedInstOperands,
     /*   3711 */     // GIR_Coverage, 22869,
     /*   3711 */     GIR_EraseRootFromParent_Done,
     /*   3712 */   // Label 154: @3712
     /*   3712 */   GIM_Try, /*On fail goto*//*Label 155*/ GIMT_Encode4(3740), // Rule ID 22955 //
     /*   3717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*   3720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3724 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*   3728 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] })  =>  (INC64r_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*   3728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC64r_ND),
     /*   3731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3733 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   3735 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3738 */     GIR_RootConstrainSelectedInstOperands,
     /*   3739 */     // GIR_Coverage, 22955,
     /*   3739 */     GIR_EraseRootFromParent_Done,
     /*   3740 */   // Label 155: @3740
     /*   3740 */   GIM_Try, /*On fail goto*//*Label 156*/ GIMT_Encode4(3768), // Rule ID 22959 //
     /*   3745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*   3748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3752 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*   3756 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] })  =>  (DEC64r_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*   3756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC64r_ND),
     /*   3759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3761 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   3763 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3766 */     GIR_RootConstrainSelectedInstOperands,
     /*   3767 */     // GIR_Coverage, 22959,
     /*   3767 */     GIR_EraseRootFromParent_Done,
     /*   3768 */   // Label 156: @3768
     /*   3768 */   GIM_Try, /*On fail goto*//*Label 157*/ GIMT_Encode4(3809), // Rule ID 22803 //
     /*   3773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   3776 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   3788 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*   3792 */     // MIs[1] Operand 1
     /*   3792 */     // No operand predicates
     /*   3792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3794 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (ADD64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*   3794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64ri32),
     /*   3797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3799 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   3804 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3807 */     GIR_RootConstrainSelectedInstOperands,
     /*   3808 */     // GIR_Coverage, 22803,
     /*   3808 */     GIR_EraseRootFromParent_Done,
     /*   3809 */   // Label 157: @3809
     /*   3809 */   GIM_Try, /*On fail goto*//*Label 158*/ GIMT_Encode4(3850), // Rule ID 22893 //
     /*   3814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   3817 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   3829 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*   3833 */     // MIs[1] Operand 1
     /*   3833 */     // No operand predicates
     /*   3833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3835 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (ADD64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*   3835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64ri32_ND),
     /*   3838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3840 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3842 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   3845 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3848 */     GIR_RootConstrainSelectedInstOperands,
     /*   3849 */     // GIR_Coverage, 22893,
     /*   3849 */     GIR_EraseRootFromParent_Done,
     /*   3850 */   // Label 158: @3850
     /*   3850 */   GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(3879), // Rule ID 22795 //
     /*   3855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   3858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3866 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (ADD64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*   3866 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD64rr),
     /*   3871 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   3877 */     GIR_RootConstrainSelectedInstOperands,
     /*   3878 */     // GIR_Coverage, 22795,
     /*   3878 */     GIR_Done,
     /*   3879 */   // Label 159: @3879
     /*   3879 */   GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(3908), // Rule ID 22885 //
     /*   3884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   3887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3895 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (ADD64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*   3895 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD64rr_ND),
     /*   3900 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   3906 */     GIR_RootConstrainSelectedInstOperands,
     /*   3907 */     // GIR_Coverage, 22885,
     /*   3907 */     GIR_Done,
     /*   3908 */   // Label 160: @3908
     /*   3908 */   GIM_Reject,
     /*   3909 */ // Label 142: @3909
     /*   3909 */ GIM_Reject,
     /*   3910 */ // Label 84: @3910
     /*   3910 */ GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(4251),
     /*   3915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   3918 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   3921 */   GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(3983), // Rule ID 23438 //
     /*   3926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   3929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   3933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   3941 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   3944 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   3948 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   3952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   3956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3958 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   3965 */     // (add:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2i64] }:$src1)  =>  (VPADDQrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   3965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQrm),
     /*   3968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3970 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   3972 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   3976 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   3981 */     GIR_RootConstrainSelectedInstOperands,
     /*   3982 */     // GIR_Coverage, 23438,
     /*   3982 */     GIR_EraseRootFromParent_Done,
     /*   3983 */   // Label 162: @3983
     /*   3983 */   GIM_Try, /*On fail goto*//*Label 163*/ GIMT_Encode4(4045), // Rule ID 23708 //
     /*   3988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   3991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   3995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4003 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4006 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4010 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4018 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4020 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4027 */     // (add:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2i64] }:$src1)  =>  (VPADDQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQZ128rm),
     /*   4030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4032 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   4034 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4038 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4043 */     GIR_RootConstrainSelectedInstOperands,
     /*   4044 */     // GIR_Coverage, 23708,
     /*   4044 */     GIR_EraseRootFromParent_Done,
     /*   4045 */   // Label 163: @4045
     /*   4045 */   GIM_Try, /*On fail goto*//*Label 164*/ GIMT_Encode4(4107), // Rule ID 2541 //
     /*   4050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   4053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4057 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4069 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4072 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4076 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4082 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4089 */     // (add:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDQrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQrm),
     /*   4092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4094 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   4096 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4100 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4105 */     GIR_RootConstrainSelectedInstOperands,
     /*   4106 */     // GIR_Coverage, 2541,
     /*   4106 */     GIR_EraseRootFromParent_Done,
     /*   4107 */   // Label 164: @4107
     /*   4107 */   GIM_Try, /*On fail goto*//*Label 165*/ GIMT_Encode4(4169), // Rule ID 4654 //
     /*   4112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   4115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4131 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4134 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4138 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4144 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4151 */     // (add:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQZ128rm),
     /*   4154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4156 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   4158 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4162 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4167 */     GIR_RootConstrainSelectedInstOperands,
     /*   4168 */     // GIR_Coverage, 4654,
     /*   4168 */     GIR_EraseRootFromParent_Done,
     /*   4169 */   // Label 165: @4169
     /*   4169 */   GIM_Try, /*On fail goto*//*Label 166*/ GIMT_Encode4(4196), // Rule ID 2540 //
     /*   4174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   4177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4189 */     // (add:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VPADDQrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*   4189 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDQrr),
     /*   4194 */     GIR_RootConstrainSelectedInstOperands,
     /*   4195 */     // GIR_Coverage, 2540,
     /*   4195 */     GIR_Done,
     /*   4196 */   // Label 166: @4196
     /*   4196 */   GIM_Try, /*On fail goto*//*Label 167*/ GIMT_Encode4(4223), // Rule ID 2542 //
     /*   4201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*   4204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4216 */     // (add:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (PADDQrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*   4216 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDQrr),
     /*   4221 */     GIR_RootConstrainSelectedInstOperands,
     /*   4222 */     // GIR_Coverage, 2542,
     /*   4222 */     GIR_Done,
     /*   4223 */   // Label 167: @4223
     /*   4223 */   GIM_Try, /*On fail goto*//*Label 168*/ GIMT_Encode4(4250), // Rule ID 4651 //
     /*   4228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   4231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4235 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4243 */     // (add:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPADDQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*   4243 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDQZ128rr),
     /*   4248 */     GIR_RootConstrainSelectedInstOperands,
     /*   4249 */     // GIR_Coverage, 4651,
     /*   4249 */     GIR_Done,
     /*   4250 */   // Label 168: @4250
     /*   4250 */   GIM_Reject,
     /*   4251 */ // Label 161: @4251
     /*   4251 */ GIM_Reject,
     /*   4252 */ // Label 85: @4252
     /*   4252 */ GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(4715),
     /*   4257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4260 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4263 */   GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(4325), // Rule ID 23435 //
     /*   4268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   4271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4283 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4286 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4290 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4298 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4300 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4307 */     // (add:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1)  =>  (VPADDDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDrm),
     /*   4310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4312 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   4314 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4318 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4323 */     GIR_RootConstrainSelectedInstOperands,
     /*   4324 */     // GIR_Coverage, 23435,
     /*   4324 */     GIR_EraseRootFromParent_Done,
     /*   4325 */   // Label 170: @4325
     /*   4325 */   GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(4387), // Rule ID 23726 //
     /*   4330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   4333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4345 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4348 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4352 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4362 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4369 */     // (add:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4i32] }:$src1)  =>  (VPADDDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDZ128rm),
     /*   4372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4374 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   4376 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4380 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4385 */     GIR_RootConstrainSelectedInstOperands,
     /*   4386 */     // GIR_Coverage, 23726,
     /*   4386 */     GIR_EraseRootFromParent_Done,
     /*   4387 */   // Label 171: @4387
     /*   4387 */   GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(4449), // Rule ID 2535 //
     /*   4392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   4395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4399 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4411 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4414 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4418 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4424 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4431 */     // (add:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDrm),
     /*   4434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4436 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   4438 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4442 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4447 */     GIR_RootConstrainSelectedInstOperands,
     /*   4448 */     // GIR_Coverage, 2535,
     /*   4448 */     GIR_EraseRootFromParent_Done,
     /*   4449 */   // Label 172: @4449
     /*   4449 */   GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(4511), // Rule ID 4681 //
     /*   4454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   4457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4461 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4473 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4476 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4480 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4486 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4493 */     // (add:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDZ128rm),
     /*   4496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4498 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   4500 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4504 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4509 */     GIR_RootConstrainSelectedInstOperands,
     /*   4510 */     // GIR_Coverage, 4681,
     /*   4510 */     GIR_EraseRootFromParent_Done,
     /*   4511 */   // Label 173: @4511
     /*   4511 */   GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(4572), // Rule ID 17867 //
     /*   4516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*   4519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4535 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4539 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4544 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4555 */     // (add:{ *:[v4i32] } (mul:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2), VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSDDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*   4555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDDrr),
     /*   4558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*   4564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*   4568 */     GIR_RootToRootCopy, /*OpIdx*/2, // src3
     /*   4570 */     GIR_RootConstrainSelectedInstOperands,
     /*   4571 */     // GIR_Coverage, 17867,
     /*   4571 */     GIR_EraseRootFromParent_Done,
     /*   4572 */   // Label 174: @4572
     /*   4572 */   GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(4633), // Rule ID 25190 //
     /*   4577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*   4580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4600 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4604 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4609 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4616 */     // (add:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src3, (mul:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2))  =>  (VPMACSDDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*   4616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDDrr),
     /*   4619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*   4625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*   4629 */     GIR_RootToRootCopy, /*OpIdx*/1, // src3
     /*   4631 */     GIR_RootConstrainSelectedInstOperands,
     /*   4632 */     // GIR_Coverage, 25190,
     /*   4632 */     GIR_EraseRootFromParent_Done,
     /*   4633 */   // Label 175: @4633
     /*   4633 */   GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(4660), // Rule ID 2534 //
     /*   4638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   4641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4653 */     // (add:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPADDDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*   4653 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDDrr),
     /*   4658 */     GIR_RootConstrainSelectedInstOperands,
     /*   4659 */     // GIR_Coverage, 2534,
     /*   4659 */     GIR_Done,
     /*   4660 */   // Label 176: @4660
     /*   4660 */   GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(4687), // Rule ID 2536 //
     /*   4665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*   4668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4680 */     // (add:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PADDDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*   4680 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDDrr),
     /*   4685 */     GIR_RootConstrainSelectedInstOperands,
     /*   4686 */     // GIR_Coverage, 2536,
     /*   4686 */     GIR_Done,
     /*   4687 */   // Label 177: @4687
     /*   4687 */   GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(4714), // Rule ID 4678 //
     /*   4692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   4695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4699 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4707 */     // (add:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPADDDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /*   4707 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDDZ128rr),
     /*   4712 */     GIR_RootConstrainSelectedInstOperands,
     /*   4713 */     // GIR_Coverage, 4678,
     /*   4713 */     GIR_Done,
     /*   4714 */   // Label 178: @4714
     /*   4714 */   GIM_Reject,
     /*   4715 */ // Label 169: @4715
     /*   4715 */ GIM_Reject,
     /*   4716 */ // Label 86: @4716
     /*   4716 */ GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(5030),
     /*   4721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*   4724 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*   4727 */   GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(4789), // Rule ID 23440 //
     /*   4732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   4735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   4739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4747 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4750 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4754 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   4762 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4764 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4771 */     // (add:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4i64] }:$src1)  =>  (VPADDQYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQYrm),
     /*   4774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4776 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   4778 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4782 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4787 */     GIR_RootConstrainSelectedInstOperands,
     /*   4788 */     // GIR_Coverage, 23440,
     /*   4788 */     GIR_EraseRootFromParent_Done,
     /*   4789 */   // Label 180: @4789
     /*   4789 */   GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(4851), // Rule ID 23702 //
     /*   4794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   4797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   4801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4809 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4812 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4816 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   4824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4826 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4833 */     // (add:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4i64] }:$src1)  =>  (VPADDQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQZ256rm),
     /*   4836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4838 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   4840 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4844 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4849 */     GIR_RootConstrainSelectedInstOperands,
     /*   4850 */     // GIR_Coverage, 23702,
     /*   4850 */     GIR_EraseRootFromParent_Done,
     /*   4851 */   // Label 181: @4851
     /*   4851 */   GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(4913), // Rule ID 2545 //
     /*   4856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   4859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   4863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   4867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4875 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4878 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4882 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4888 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4895 */     // (add:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDQYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQYrm),
     /*   4898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4900 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   4902 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4906 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4911 */     GIR_RootConstrainSelectedInstOperands,
     /*   4912 */     // GIR_Coverage, 2545,
     /*   4912 */     GIR_EraseRootFromParent_Done,
     /*   4913 */   // Label 182: @4913
     /*   4913 */   GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(4975), // Rule ID 4645 //
     /*   4918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   4921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   4925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   4929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4937 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4940 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4944 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4950 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4957 */     // (add:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQZ256rm),
     /*   4960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4962 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   4964 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4968 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4973 */     GIR_RootConstrainSelectedInstOperands,
     /*   4974 */     // GIR_Coverage, 4645,
     /*   4974 */     GIR_EraseRootFromParent_Done,
     /*   4975 */   // Label 183: @4975
     /*   4975 */   GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(5002), // Rule ID 2544 //
     /*   4980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   4983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   4987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   4991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   4995 */     // (add:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VPADDQYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*   4995 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDQYrr),
     /*   5000 */     GIR_RootConstrainSelectedInstOperands,
     /*   5001 */     // GIR_Coverage, 2544,
     /*   5001 */     GIR_Done,
     /*   5002 */   // Label 184: @5002
     /*   5002 */   GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(5029), // Rule ID 4642 //
     /*   5007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   5010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   5014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   5018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   5022 */     // (add:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPADDQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*   5022 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDQZ256rr),
     /*   5027 */     GIR_RootConstrainSelectedInstOperands,
     /*   5028 */     // GIR_Coverage, 4642,
     /*   5028 */     GIR_Done,
     /*   5029 */   // Label 185: @5029
     /*   5029 */   GIM_Reject,
     /*   5030 */ // Label 179: @5030
     /*   5030 */ GIM_Reject,
     /*   5031 */ // Label 87: @5031
     /*   5031 */ GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(5494),
     /*   5036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   5039 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   5042 */   GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(5104), // Rule ID 23432 //
     /*   5047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*   5050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5062 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5065 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5069 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5079 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5086 */     // (add:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPADDWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWrm),
     /*   5089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5091 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   5093 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5097 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5102 */     GIR_RootConstrainSelectedInstOperands,
     /*   5103 */     // GIR_Coverage, 23432,
     /*   5103 */     GIR_EraseRootFromParent_Done,
     /*   5104 */   // Label 187: @5104
     /*   5104 */   GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(5166), // Rule ID 23738 //
     /*   5109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   5112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   5116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5124 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5127 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5131 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   5139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5141 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5148 */     // (add:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPADDWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWZ128rm),
     /*   5151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5153 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   5155 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5159 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5164 */     GIR_RootConstrainSelectedInstOperands,
     /*   5165 */     // GIR_Coverage, 23738,
     /*   5165 */     GIR_EraseRootFromParent_Done,
     /*   5166 */   // Label 188: @5166
     /*   5166 */   GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(5228), // Rule ID 2529 //
     /*   5171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*   5174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5190 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5193 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5197 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5203 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5210 */     // (add:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWrm),
     /*   5213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5215 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   5217 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5221 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5226 */     GIR_RootConstrainSelectedInstOperands,
     /*   5227 */     // GIR_Coverage, 2529,
     /*   5227 */     GIR_EraseRootFromParent_Done,
     /*   5228 */   // Label 189: @5228
     /*   5228 */   GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(5290), // Rule ID 4702 //
     /*   5233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   5236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   5240 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   5244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5252 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5255 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5259 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5265 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5272 */     // (add:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWZ128rm),
     /*   5275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5277 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   5279 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5283 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5288 */     GIR_RootConstrainSelectedInstOperands,
     /*   5289 */     // GIR_Coverage, 4702,
     /*   5289 */     GIR_EraseRootFromParent_Done,
     /*   5290 */   // Label 190: @5290
     /*   5290 */   GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(5351), // Rule ID 17866 //
     /*   5295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*   5298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   5314 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   5318 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5323 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5332 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5334 */     // (add:{ *:[v8i16] } (mul:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2), VR128:{ *:[v8i16] }:$src3)  =>  (VPMACSWWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /*   5334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWWrr),
     /*   5337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*   5343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*   5347 */     GIR_RootToRootCopy, /*OpIdx*/2, // src3
     /*   5349 */     GIR_RootConstrainSelectedInstOperands,
     /*   5350 */     // GIR_Coverage, 17866,
     /*   5350 */     GIR_EraseRootFromParent_Done,
     /*   5351 */   // Label 191: @5351
     /*   5351 */   GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(5412), // Rule ID 25189 //
     /*   5356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*   5359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   5379 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   5383 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5388 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5395 */     // (add:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src3, (mul:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2))  =>  (VPMACSWWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /*   5395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWWrr),
     /*   5398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*   5404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*   5408 */     GIR_RootToRootCopy, /*OpIdx*/1, // src3
     /*   5410 */     GIR_RootConstrainSelectedInstOperands,
     /*   5411 */     // GIR_Coverage, 25189,
     /*   5411 */     GIR_EraseRootFromParent_Done,
     /*   5412 */   // Label 192: @5412
     /*   5412 */   GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(5439), // Rule ID 2528 //
     /*   5417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*   5420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5432 */     // (add:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPADDWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*   5432 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDWrr),
     /*   5437 */     GIR_RootConstrainSelectedInstOperands,
     /*   5438 */     // GIR_Coverage, 2528,
     /*   5438 */     GIR_Done,
     /*   5439 */   // Label 193: @5439
     /*   5439 */   GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(5466), // Rule ID 2530 //
     /*   5444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*   5447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5459 */     // (add:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PADDWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*   5459 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDWrr),
     /*   5464 */     GIR_RootConstrainSelectedInstOperands,
     /*   5465 */     // GIR_Coverage, 2530,
     /*   5465 */     GIR_Done,
     /*   5466 */   // Label 194: @5466
     /*   5466 */   GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(5493), // Rule ID 4699 //
     /*   5471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   5474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   5478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   5482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   5486 */     // (add:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPADDWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /*   5486 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDWZ128rr),
     /*   5491 */     GIR_RootConstrainSelectedInstOperands,
     /*   5492 */     // GIR_Coverage, 4699,
     /*   5492 */     GIR_Done,
     /*   5493 */   // Label 195: @5493
     /*   5493 */   GIM_Reject,
     /*   5494 */ // Label 186: @5494
     /*   5494 */ GIM_Reject,
     /*   5495 */ // Label 88: @5495
     /*   5495 */ GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(5809),
     /*   5500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*   5503 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*   5506 */   GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(5568), // Rule ID 23437 //
     /*   5511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   5514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   5518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5526 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5529 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5533 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   5541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5543 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5550 */     // (add:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VPADDDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDYrm),
     /*   5553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5555 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   5557 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5561 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5566 */     GIR_RootConstrainSelectedInstOperands,
     /*   5567 */     // GIR_Coverage, 23437,
     /*   5567 */     GIR_EraseRootFromParent_Done,
     /*   5568 */   // Label 197: @5568
     /*   5568 */   GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(5630), // Rule ID 23720 //
     /*   5573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   5576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   5580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5588 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5591 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5595 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   5603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5605 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5612 */     // (add:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8i32] }:$src1)  =>  (VPADDDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDZ256rm),
     /*   5615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5617 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   5619 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5623 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5628 */     GIR_RootConstrainSelectedInstOperands,
     /*   5629 */     // GIR_Coverage, 23720,
     /*   5629 */     GIR_EraseRootFromParent_Done,
     /*   5630 */   // Label 198: @5630
     /*   5630 */   GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(5692), // Rule ID 2539 //
     /*   5635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   5638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   5642 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   5646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5654 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5657 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5661 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5667 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5674 */     // (add:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDYrm),
     /*   5677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5679 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   5681 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5685 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5690 */     GIR_RootConstrainSelectedInstOperands,
     /*   5691 */     // GIR_Coverage, 2539,
     /*   5691 */     GIR_EraseRootFromParent_Done,
     /*   5692 */   // Label 199: @5692
     /*   5692 */   GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(5754), // Rule ID 4672 //
     /*   5697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   5700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   5704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   5708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5716 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5719 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5723 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5729 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5736 */     // (add:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDZ256rm),
     /*   5739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5741 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   5743 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5747 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5752 */     GIR_RootConstrainSelectedInstOperands,
     /*   5753 */     // GIR_Coverage, 4672,
     /*   5753 */     GIR_EraseRootFromParent_Done,
     /*   5754 */   // Label 200: @5754
     /*   5754 */   GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(5781), // Rule ID 2538 //
     /*   5759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   5762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   5766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   5770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   5774 */     // (add:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPADDDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*   5774 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDDYrr),
     /*   5779 */     GIR_RootConstrainSelectedInstOperands,
     /*   5780 */     // GIR_Coverage, 2538,
     /*   5780 */     GIR_Done,
     /*   5781 */   // Label 201: @5781
     /*   5781 */   GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(5808), // Rule ID 4669 //
     /*   5786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   5789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   5793 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   5797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   5801 */     // (add:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPADDDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /*   5801 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDDZ256rr),
     /*   5806 */     GIR_RootConstrainSelectedInstOperands,
     /*   5807 */     // GIR_Coverage, 4669,
     /*   5807 */     GIR_Done,
     /*   5808 */   // Label 202: @5808
     /*   5808 */   GIM_Reject,
     /*   5809 */ // Label 196: @5809
     /*   5809 */ GIM_Reject,
     /*   5810 */ // Label 89: @5810
     /*   5810 */ GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(5965),
     /*   5815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*   5818 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*   5821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   5825 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(5883), // Rule ID 23696 //
     /*   5830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*   5833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5841 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5844 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5848 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   5856 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5858 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5865 */     // (add:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8i64] }:$src1)  =>  (VPADDQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQZrm),
     /*   5868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5870 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   5872 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5876 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5881 */     GIR_RootConstrainSelectedInstOperands,
     /*   5882 */     // GIR_Coverage, 23696,
     /*   5882 */     GIR_EraseRootFromParent_Done,
     /*   5883 */   // Label 204: @5883
     /*   5883 */   GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(5941), // Rule ID 4636 //
     /*   5888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*   5891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   5895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5903 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5906 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5910 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5916 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5923 */     // (add:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQZrm),
     /*   5926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5928 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   5930 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5934 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5939 */     GIR_RootConstrainSelectedInstOperands,
     /*   5940 */     // GIR_Coverage, 4636,
     /*   5940 */     GIR_EraseRootFromParent_Done,
     /*   5941 */   // Label 205: @5941
     /*   5941 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(5964), // Rule ID 4633 //
     /*   5946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*   5949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   5953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   5957 */     // (add:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPADDQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*   5957 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDQZrr),
     /*   5962 */     GIR_RootConstrainSelectedInstOperands,
     /*   5963 */     // GIR_Coverage, 4633,
     /*   5963 */     GIR_Done,
     /*   5964 */   // Label 206: @5964
     /*   5964 */   GIM_Reject,
     /*   5965 */ // Label 203: @5965
     /*   5965 */ GIM_Reject,
     /*   5966 */ // Label 90: @5966
     /*   5966 */ GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(6307),
     /*   5971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   5974 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*   5977 */   GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(6039), // Rule ID 23429 //
     /*   5982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*   5985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5997 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6000 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6004 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   6012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6014 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6021 */     // (add:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPADDBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBrm),
     /*   6024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6026 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   6028 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6032 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6037 */     GIR_RootConstrainSelectedInstOperands,
     /*   6038 */     // GIR_Coverage, 23429,
     /*   6038 */     GIR_EraseRootFromParent_Done,
     /*   6039 */   // Label 208: @6039
     /*   6039 */   GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(6101), // Rule ID 23747 //
     /*   6044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   6047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   6051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6059 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6062 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6066 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   6074 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6076 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6083 */     // (add:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPADDBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBZ128rm),
     /*   6086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6088 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   6090 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6094 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6099 */     GIR_RootConstrainSelectedInstOperands,
     /*   6100 */     // GIR_Coverage, 23747,
     /*   6100 */     GIR_EraseRootFromParent_Done,
     /*   6101 */   // Label 209: @6101
     /*   6101 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(6163), // Rule ID 2523 //
     /*   6106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*   6109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   6113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   6117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6125 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6128 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6132 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6138 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6145 */     // (add:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBrm),
     /*   6148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6150 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   6152 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6156 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6161 */     GIR_RootConstrainSelectedInstOperands,
     /*   6162 */     // GIR_Coverage, 2523,
     /*   6162 */     GIR_EraseRootFromParent_Done,
     /*   6163 */   // Label 210: @6163
     /*   6163 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(6225), // Rule ID 4720 //
     /*   6168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   6171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   6175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   6179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6187 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6190 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6194 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6200 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6207 */     // (add:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBZ128rm),
     /*   6210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6212 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   6214 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6218 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6223 */     GIR_RootConstrainSelectedInstOperands,
     /*   6224 */     // GIR_Coverage, 4720,
     /*   6224 */     GIR_EraseRootFromParent_Done,
     /*   6225 */   // Label 211: @6225
     /*   6225 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(6252), // Rule ID 2522 //
     /*   6230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*   6233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   6237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   6241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   6245 */     // (add:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPADDBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*   6245 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDBrr),
     /*   6250 */     GIR_RootConstrainSelectedInstOperands,
     /*   6251 */     // GIR_Coverage, 2522,
     /*   6251 */     GIR_Done,
     /*   6252 */   // Label 212: @6252
     /*   6252 */   GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(6279), // Rule ID 2524 //
     /*   6257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*   6260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   6264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   6268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   6272 */     // (add:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PADDBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*   6272 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDBrr),
     /*   6277 */     GIR_RootConstrainSelectedInstOperands,
     /*   6278 */     // GIR_Coverage, 2524,
     /*   6278 */     GIR_Done,
     /*   6279 */   // Label 213: @6279
     /*   6279 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(6306), // Rule ID 4717 //
     /*   6284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   6287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   6291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   6295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   6299 */     // (add:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPADDBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /*   6299 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDBZ128rr),
     /*   6304 */     GIR_RootConstrainSelectedInstOperands,
     /*   6305 */     // GIR_Coverage, 4717,
     /*   6305 */     GIR_Done,
     /*   6306 */   // Label 214: @6306
     /*   6306 */   GIM_Reject,
     /*   6307 */ // Label 207: @6307
     /*   6307 */ GIM_Reject,
     /*   6308 */ // Label 91: @6308
     /*   6308 */ GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(6622),
     /*   6313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*   6316 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*   6319 */   GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(6381), // Rule ID 23434 //
     /*   6324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*   6327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6339 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6342 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6346 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6354 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6356 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6363 */     // (add:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPADDWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWYrm),
     /*   6366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6368 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   6370 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6374 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6379 */     GIR_RootConstrainSelectedInstOperands,
     /*   6380 */     // GIR_Coverage, 23434,
     /*   6380 */     GIR_EraseRootFromParent_Done,
     /*   6381 */   // Label 216: @6381
     /*   6381 */   GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(6443), // Rule ID 23735 //
     /*   6386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   6389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6401 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6404 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6408 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6416 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6418 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6425 */     // (add:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPADDWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWZ256rm),
     /*   6428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6430 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   6432 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6436 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6441 */     GIR_RootConstrainSelectedInstOperands,
     /*   6442 */     // GIR_Coverage, 23735,
     /*   6442 */     GIR_EraseRootFromParent_Done,
     /*   6443 */   // Label 217: @6443
     /*   6443 */   GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(6505), // Rule ID 2533 //
     /*   6448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*   6451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6467 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6470 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6474 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6478 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6480 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6487 */     // (add:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWYrm),
     /*   6490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6492 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   6494 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6498 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6503 */     GIR_RootConstrainSelectedInstOperands,
     /*   6504 */     // GIR_Coverage, 2533,
     /*   6504 */     GIR_EraseRootFromParent_Done,
     /*   6505 */   // Label 218: @6505
     /*   6505 */   GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(6567), // Rule ID 4696 //
     /*   6510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   6513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6529 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6532 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6536 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6540 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6542 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6549 */     // (add:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWZ256rm),
     /*   6552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6554 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   6556 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6560 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6565 */     GIR_RootConstrainSelectedInstOperands,
     /*   6566 */     // GIR_Coverage, 4696,
     /*   6566 */     GIR_EraseRootFromParent_Done,
     /*   6567 */   // Label 219: @6567
     /*   6567 */   GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(6594), // Rule ID 2532 //
     /*   6572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*   6575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6587 */     // (add:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPADDWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*   6587 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDWYrr),
     /*   6592 */     GIR_RootConstrainSelectedInstOperands,
     /*   6593 */     // GIR_Coverage, 2532,
     /*   6593 */     GIR_Done,
     /*   6594 */   // Label 220: @6594
     /*   6594 */   GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(6621), // Rule ID 4693 //
     /*   6599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   6602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6614 */     // (add:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPADDWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /*   6614 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDWZ256rr),
     /*   6619 */     GIR_RootConstrainSelectedInstOperands,
     /*   6620 */     // GIR_Coverage, 4693,
     /*   6620 */     GIR_Done,
     /*   6621 */   // Label 221: @6621
     /*   6621 */   GIM_Reject,
     /*   6622 */ // Label 215: @6622
     /*   6622 */ GIM_Reject,
     /*   6623 */ // Label 92: @6623
     /*   6623 */ GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(6778),
     /*   6628 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*   6631 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*   6634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   6638 */   GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(6696), // Rule ID 23714 //
     /*   6643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*   6646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6654 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6657 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6661 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   6669 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6671 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6678 */     // (add:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16i32] }:$src1)  =>  (VPADDDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDZrm),
     /*   6681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6683 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   6685 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6689 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6694 */     GIR_RootConstrainSelectedInstOperands,
     /*   6695 */     // GIR_Coverage, 23714,
     /*   6695 */     GIR_EraseRootFromParent_Done,
     /*   6696 */   // Label 223: @6696
     /*   6696 */   GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(6754), // Rule ID 4663 //
     /*   6701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*   6704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   6708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6716 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6719 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6723 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6729 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6736 */     // (add:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDZrm),
     /*   6739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6741 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   6743 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6747 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6752 */     GIR_RootConstrainSelectedInstOperands,
     /*   6753 */     // GIR_Coverage, 4663,
     /*   6753 */     GIR_EraseRootFromParent_Done,
     /*   6754 */   // Label 224: @6754
     /*   6754 */   GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(6777), // Rule ID 4660 //
     /*   6759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*   6762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   6766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   6770 */     // (add:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPADDDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /*   6770 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDDZrr),
     /*   6775 */     GIR_RootConstrainSelectedInstOperands,
     /*   6776 */     // GIR_Coverage, 4660,
     /*   6776 */     GIR_Done,
     /*   6777 */   // Label 225: @6777
     /*   6777 */   GIM_Reject,
     /*   6778 */ // Label 222: @6778
     /*   6778 */ GIM_Reject,
     /*   6779 */ // Label 93: @6779
     /*   6779 */ GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(7093),
     /*   6784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /*   6787 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /*   6790 */   GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(6852), // Rule ID 23431 //
     /*   6795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*   6798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6810 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6813 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6817 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6827 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6834 */     // (add:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPADDBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBYrm),
     /*   6837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6839 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   6841 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6845 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6850 */     GIR_RootConstrainSelectedInstOperands,
     /*   6851 */     // GIR_Coverage, 23431,
     /*   6851 */     GIR_EraseRootFromParent_Done,
     /*   6852 */   // Label 227: @6852
     /*   6852 */   GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(6914), // Rule ID 23744 //
     /*   6857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   6860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6872 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6875 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6879 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6889 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6896 */     // (add:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPADDBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBZ256rm),
     /*   6899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6901 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   6903 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6907 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6912 */     GIR_RootConstrainSelectedInstOperands,
     /*   6913 */     // GIR_Coverage, 23744,
     /*   6913 */     GIR_EraseRootFromParent_Done,
     /*   6914 */   // Label 228: @6914
     /*   6914 */   GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(6976), // Rule ID 2527 //
     /*   6919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*   6922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6938 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6941 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6945 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6951 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6958 */     // (add:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBYrm),
     /*   6961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6963 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   6965 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6969 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6974 */     GIR_RootConstrainSelectedInstOperands,
     /*   6975 */     // GIR_Coverage, 2527,
     /*   6975 */     GIR_EraseRootFromParent_Done,
     /*   6976 */   // Label 229: @6976
     /*   6976 */   GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(7038), // Rule ID 4714 //
     /*   6981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   6984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   7000 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   7003 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   7007 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   7011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7013 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   7020 */     // (add:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   7020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBZ256rm),
     /*   7023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7025 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7027 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   7031 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   7036 */     GIR_RootConstrainSelectedInstOperands,
     /*   7037 */     // GIR_Coverage, 4714,
     /*   7037 */     GIR_EraseRootFromParent_Done,
     /*   7038 */   // Label 230: @7038
     /*   7038 */   GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(7065), // Rule ID 2526 //
     /*   7043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*   7046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   7050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   7054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   7058 */     // (add:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPADDBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*   7058 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDBYrr),
     /*   7063 */     GIR_RootConstrainSelectedInstOperands,
     /*   7064 */     // GIR_Coverage, 2526,
     /*   7064 */     GIR_Done,
     /*   7065 */   // Label 231: @7065
     /*   7065 */   GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(7092), // Rule ID 4711 //
     /*   7070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   7073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   7077 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   7081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   7085 */     // (add:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPADDBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /*   7085 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDBZ256rr),
     /*   7090 */     GIR_RootConstrainSelectedInstOperands,
     /*   7091 */     // GIR_Coverage, 4711,
     /*   7091 */     GIR_Done,
     /*   7092 */   // Label 232: @7092
     /*   7092 */   GIM_Reject,
     /*   7093 */ // Label 226: @7093
     /*   7093 */ GIM_Reject,
     /*   7094 */ // Label 94: @7094
     /*   7094 */ GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(7249),
     /*   7099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*   7102 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /*   7105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   7109 */   GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(7167), // Rule ID 23732 //
     /*   7114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*   7117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   7125 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   7128 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   7132 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   7136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   7140 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7142 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   7149 */     // (add:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPADDWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   7149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWZrm),
     /*   7152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7154 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   7156 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   7160 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   7165 */     GIR_RootConstrainSelectedInstOperands,
     /*   7166 */     // GIR_Coverage, 23732,
     /*   7166 */     GIR_EraseRootFromParent_Done,
     /*   7167 */   // Label 234: @7167
     /*   7167 */   GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(7225), // Rule ID 4690 //
     /*   7172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*   7175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   7179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   7187 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   7190 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   7194 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   7198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7200 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   7207 */     // (add:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   7207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWZrm),
     /*   7210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7212 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7214 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   7218 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   7223 */     GIR_RootConstrainSelectedInstOperands,
     /*   7224 */     // GIR_Coverage, 4690,
     /*   7224 */     GIR_EraseRootFromParent_Done,
     /*   7225 */   // Label 235: @7225
     /*   7225 */   GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(7248), // Rule ID 4687 //
     /*   7230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*   7233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   7237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   7241 */     // (add:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPADDWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /*   7241 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDWZrr),
     /*   7246 */     GIR_RootConstrainSelectedInstOperands,
     /*   7247 */     // GIR_Coverage, 4687,
     /*   7247 */     GIR_Done,
     /*   7248 */   // Label 236: @7248
     /*   7248 */   GIM_Reject,
     /*   7249 */ // Label 233: @7249
     /*   7249 */ GIM_Reject,
     /*   7250 */ // Label 95: @7250
     /*   7250 */ GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(7405),
     /*   7255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /*   7258 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /*   7261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   7265 */   GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(7323), // Rule ID 23741 //
     /*   7270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*   7273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   7281 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   7284 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   7288 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   7292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   7296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7298 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   7305 */     // (add:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPADDBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   7305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBZrm),
     /*   7308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7310 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   7312 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   7316 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   7321 */     GIR_RootConstrainSelectedInstOperands,
     /*   7322 */     // GIR_Coverage, 23741,
     /*   7322 */     GIR_EraseRootFromParent_Done,
     /*   7323 */   // Label 238: @7323
     /*   7323 */   GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(7381), // Rule ID 4708 //
     /*   7328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*   7331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   7335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   7343 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   7346 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   7350 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   7354 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7356 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   7363 */     // (add:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   7363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBZrm),
     /*   7366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7368 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7370 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   7374 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   7379 */     GIR_RootConstrainSelectedInstOperands,
     /*   7380 */     // GIR_Coverage, 4708,
     /*   7380 */     GIR_EraseRootFromParent_Done,
     /*   7381 */   // Label 239: @7381
     /*   7381 */   GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(7404), // Rule ID 4705 //
     /*   7386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*   7389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   7393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   7397 */     // (add:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPADDBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /*   7397 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDBZrr),
     /*   7402 */     GIR_RootConstrainSelectedInstOperands,
     /*   7403 */     // GIR_Coverage, 4705,
     /*   7403 */     GIR_Done,
     /*   7404 */   // Label 240: @7404
     /*   7404 */   GIM_Reject,
     /*   7405 */ // Label 237: @7405
     /*   7405 */ GIM_Reject,
     /*   7406 */ // Label 96: @7406
     /*   7406 */ GIM_Reject,
     /*   7407 */ // Label 1: @7407
     /*   7407 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(25), /*)*//*default:*//*Label 257*/ GIMT_Encode4(10942),
     /*   7418 */ /*GILLT_s8*//*Label 241*/ GIMT_Encode4(7514),
     /*   7422 */ /*GILLT_s16*//*Label 242*/ GIMT_Encode4(7866),
     /*   7426 */ /*GILLT_s32*//*Label 243*/ GIMT_Encode4(8218),
     /*   7430 */ /*GILLT_s64*//*Label 244*/ GIMT_Encode4(8570), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   7446 */ /*GILLT_v2s64*//*Label 245*/ GIMT_Encode4(8930), GIMT_Encode4(0),
     /*   7454 */ /*GILLT_v4s32*//*Label 246*/ GIMT_Encode4(9148),
     /*   7458 */ /*GILLT_v4s64*//*Label 247*/ GIMT_Encode4(9366), GIMT_Encode4(0),
     /*   7466 */ /*GILLT_v8s16*//*Label 248*/ GIMT_Encode4(9557),
     /*   7470 */ /*GILLT_v8s32*//*Label 249*/ GIMT_Encode4(9775),
     /*   7474 */ /*GILLT_v8s64*//*Label 250*/ GIMT_Encode4(9966), GIMT_Encode4(0),
     /*   7482 */ /*GILLT_v16s8*//*Label 251*/ GIMT_Encode4(10060),
     /*   7486 */ /*GILLT_v16s16*//*Label 252*/ GIMT_Encode4(10278),
     /*   7490 */ /*GILLT_v16s32*//*Label 253*/ GIMT_Encode4(10469), GIMT_Encode4(0),
     /*   7498 */ /*GILLT_v32s8*//*Label 254*/ GIMT_Encode4(10563),
     /*   7502 */ /*GILLT_v32s16*//*Label 255*/ GIMT_Encode4(10754), GIMT_Encode4(0),
     /*   7510 */ /*GILLT_v64s8*//*Label 256*/ GIMT_Encode4(10848),
     /*   7514 */ // Label 241: @7514
     /*   7514 */ GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(7865),
     /*   7519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /*   7522 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /*   7525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7529 */   GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(7590), // Rule ID 22808 //
     /*   7534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   7537 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   7549 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   7552 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   7556 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*   7560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7562 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   7569 */     // (sub:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (SUB8rm:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   7569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB8rm),
     /*   7572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7574 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7576 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   7580 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7583 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   7588 */     GIR_RootConstrainSelectedInstOperands,
     /*   7589 */     // GIR_Coverage, 22808,
     /*   7589 */     GIR_EraseRootFromParent_Done,
     /*   7590 */   // Label 259: @7590
     /*   7590 */   GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(7651), // Rule ID 22898 //
     /*   7595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   7598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   7610 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   7613 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   7617 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*   7621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7623 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   7630 */     // (sub:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (SUB8rm_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   7630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB8rm_ND),
     /*   7633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7635 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7637 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   7641 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7644 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   7649 */     GIR_RootConstrainSelectedInstOperands,
     /*   7650 */     // GIR_Coverage, 22898,
     /*   7650 */     GIR_EraseRootFromParent_Done,
     /*   7651 */   // Label 260: @7651
     /*   7651 */   GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(7679), // Rule ID 241 //
     /*   7656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   7659 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   7663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7667 */     // (sub:{ *:[i8] } 0:{ *:[i8] }, GR8:{ *:[i8] }:$src1)  =>  (NEG8r:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /*   7667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG8r),
     /*   7670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7672 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   7674 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7677 */     GIR_RootConstrainSelectedInstOperands,
     /*   7678 */     // GIR_Coverage, 241,
     /*   7678 */     GIR_EraseRootFromParent_Done,
     /*   7679 */   // Label 261: @7679
     /*   7679 */   GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(7707), // Rule ID 249 //
     /*   7684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*   7687 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   7691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7695 */     // (sub:{ *:[i8] } 0:{ *:[i8] }, GR8:{ *:[i8] }:$src1)  =>  (NEG8r_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /*   7695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG8r_ND),
     /*   7698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7700 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   7702 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7705 */     GIR_RootConstrainSelectedInstOperands,
     /*   7706 */     // GIR_Coverage, 249,
     /*   7706 */     GIR_EraseRootFromParent_Done,
     /*   7707 */   // Label 262: @7707
     /*   7707 */   GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(7732), // Rule ID 257 //
     /*   7712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*   7715 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   7719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7723 */     // (sub:{ *:[i8] } 0:{ *:[i8] }, GR8:{ *:[i8] }:$src1)  =>  (NEG8r_NF_ND:{ *:[i8] } GR8:{ *:[i8] }:$src1)
     /*   7723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG8r_NF_ND),
     /*   7726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7728 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   7730 */     GIR_RootConstrainSelectedInstOperands,
     /*   7731 */     // GIR_Coverage, 257,
     /*   7731 */     GIR_EraseRootFromParent_Done,
     /*   7732 */   // Label 263: @7732
     /*   7732 */   GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(7769), // Rule ID 22812 //
     /*   7737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   7740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7752 */     // MIs[1] Operand 1
     /*   7752 */     // No operand predicates
     /*   7752 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7754 */     // (sub:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SUB8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*   7754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB8ri),
     /*   7757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7759 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7761 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   7764 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7767 */     GIR_RootConstrainSelectedInstOperands,
     /*   7768 */     // GIR_Coverage, 22812,
     /*   7768 */     GIR_EraseRootFromParent_Done,
     /*   7769 */   // Label 264: @7769
     /*   7769 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(7806), // Rule ID 22902 //
     /*   7774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   7777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7789 */     // MIs[1] Operand 1
     /*   7789 */     // No operand predicates
     /*   7789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7791 */     // (sub:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SUB8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*   7791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB8ri_ND),
     /*   7794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7796 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7798 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   7801 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7804 */     GIR_RootConstrainSelectedInstOperands,
     /*   7805 */     // GIR_Coverage, 22902,
     /*   7805 */     GIR_EraseRootFromParent_Done,
     /*   7806 */   // Label 265: @7806
     /*   7806 */   GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(7835), // Rule ID 22804 //
     /*   7811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   7814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7822 */     // (sub:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SUB8rr:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*   7822 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB8rr),
     /*   7827 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   7833 */     GIR_RootConstrainSelectedInstOperands,
     /*   7834 */     // GIR_Coverage, 22804,
     /*   7834 */     GIR_Done,
     /*   7835 */   // Label 266: @7835
     /*   7835 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(7864), // Rule ID 22894 //
     /*   7840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   7843 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7851 */     // (sub:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SUB8rr_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*   7851 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB8rr_ND),
     /*   7856 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   7862 */     GIR_RootConstrainSelectedInstOperands,
     /*   7863 */     // GIR_Coverage, 22894,
     /*   7863 */     GIR_Done,
     /*   7864 */   // Label 267: @7864
     /*   7864 */   GIM_Reject,
     /*   7865 */ // Label 258: @7865
     /*   7865 */ GIM_Reject,
     /*   7866 */ // Label 242: @7866
     /*   7866 */ GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(8217),
     /*   7871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*   7874 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*   7877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   7881 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(7942), // Rule ID 22809 //
     /*   7886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   7889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   7893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   7901 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   7904 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   7908 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*   7912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7914 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   7921 */     // (sub:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (SUB16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   7921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16rm),
     /*   7924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7926 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7928 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   7932 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7935 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   7940 */     GIR_RootConstrainSelectedInstOperands,
     /*   7941 */     // GIR_Coverage, 22809,
     /*   7941 */     GIR_EraseRootFromParent_Done,
     /*   7942 */   // Label 269: @7942
     /*   7942 */   GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(8003), // Rule ID 22899 //
     /*   7947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   7950 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   7954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   7962 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   7965 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   7969 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*   7973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7975 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   7982 */     // (sub:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (SUB16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   7982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16rm_ND),
     /*   7985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7987 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7989 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   7993 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7996 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   8001 */     GIR_RootConstrainSelectedInstOperands,
     /*   8002 */     // GIR_Coverage, 22899,
     /*   8002 */     GIR_EraseRootFromParent_Done,
     /*   8003 */   // Label 270: @8003
     /*   8003 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(8031), // Rule ID 242 //
     /*   8008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8011 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   8015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   8019 */     // (sub:{ *:[i16] } 0:{ *:[i16] }, GR16:{ *:[i16] }:$src1)  =>  (NEG16r:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /*   8019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG16r),
     /*   8022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8024 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8026 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8029 */     GIR_RootConstrainSelectedInstOperands,
     /*   8030 */     // GIR_Coverage, 242,
     /*   8030 */     GIR_EraseRootFromParent_Done,
     /*   8031 */   // Label 271: @8031
     /*   8031 */   GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(8059), // Rule ID 250 //
     /*   8036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*   8039 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   8043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   8047 */     // (sub:{ *:[i16] } 0:{ *:[i16] }, GR16:{ *:[i16] }:$src1)  =>  (NEG16r_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /*   8047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG16r_ND),
     /*   8050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8052 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8054 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8057 */     GIR_RootConstrainSelectedInstOperands,
     /*   8058 */     // GIR_Coverage, 250,
     /*   8058 */     GIR_EraseRootFromParent_Done,
     /*   8059 */   // Label 272: @8059
     /*   8059 */   GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(8084), // Rule ID 258 //
     /*   8064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*   8067 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   8071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   8075 */     // (sub:{ *:[i16] } 0:{ *:[i16] }, GR16:{ *:[i16] }:$src1)  =>  (NEG16r_NF_ND:{ *:[i16] } GR16:{ *:[i16] }:$src1)
     /*   8075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG16r_NF_ND),
     /*   8078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8080 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8082 */     GIR_RootConstrainSelectedInstOperands,
     /*   8083 */     // GIR_Coverage, 258,
     /*   8083 */     GIR_EraseRootFromParent_Done,
     /*   8084 */   // Label 273: @8084
     /*   8084 */   GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(8121), // Rule ID 22813 //
     /*   8089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8092 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   8096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   8104 */     // MIs[1] Operand 1
     /*   8104 */     // No operand predicates
     /*   8104 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8106 */     // (sub:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (SUB16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*   8106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16ri),
     /*   8109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8111 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8113 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   8116 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8119 */     GIR_RootConstrainSelectedInstOperands,
     /*   8120 */     // GIR_Coverage, 22813,
     /*   8120 */     GIR_EraseRootFromParent_Done,
     /*   8121 */   // Label 274: @8121
     /*   8121 */   GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(8158), // Rule ID 22903 //
     /*   8126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   8129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   8133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   8141 */     // MIs[1] Operand 1
     /*   8141 */     // No operand predicates
     /*   8141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8143 */     // (sub:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (SUB16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*   8143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16ri_ND),
     /*   8146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8148 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8150 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   8153 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8156 */     GIR_RootConstrainSelectedInstOperands,
     /*   8157 */     // GIR_Coverage, 22903,
     /*   8157 */     GIR_EraseRootFromParent_Done,
     /*   8158 */   // Label 275: @8158
     /*   8158 */   GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(8187), // Rule ID 22805 //
     /*   8163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8166 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   8170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   8174 */     // (sub:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (SUB16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*   8174 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB16rr),
     /*   8179 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   8185 */     GIR_RootConstrainSelectedInstOperands,
     /*   8186 */     // GIR_Coverage, 22805,
     /*   8186 */     GIR_Done,
     /*   8187 */   // Label 276: @8187
     /*   8187 */   GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(8216), // Rule ID 22895 //
     /*   8192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   8195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   8199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   8203 */     // (sub:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (SUB16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*   8203 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB16rr_ND),
     /*   8208 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   8214 */     GIR_RootConstrainSelectedInstOperands,
     /*   8215 */     // GIR_Coverage, 22895,
     /*   8215 */     GIR_Done,
     /*   8216 */   // Label 277: @8216
     /*   8216 */   GIM_Reject,
     /*   8217 */ // Label 268: @8217
     /*   8217 */ GIM_Reject,
     /*   8218 */ // Label 243: @8218
     /*   8218 */ GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(8569),
     /*   8223 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   8226 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   8229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8233 */   GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(8294), // Rule ID 22810 //
     /*   8238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   8253 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   8256 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   8260 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*   8264 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8266 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   8273 */     // (sub:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (SUB32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   8273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32rm),
     /*   8276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8278 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8280 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   8284 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8287 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   8292 */     GIR_RootConstrainSelectedInstOperands,
     /*   8293 */     // GIR_Coverage, 22810,
     /*   8293 */     GIR_EraseRootFromParent_Done,
     /*   8294 */   // Label 279: @8294
     /*   8294 */   GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(8355), // Rule ID 22900 //
     /*   8299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   8302 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   8314 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   8317 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   8321 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*   8325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8327 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   8334 */     // (sub:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (SUB32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   8334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32rm_ND),
     /*   8337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8339 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8341 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   8345 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8348 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   8353 */     GIR_RootConstrainSelectedInstOperands,
     /*   8354 */     // GIR_Coverage, 22900,
     /*   8354 */     GIR_EraseRootFromParent_Done,
     /*   8355 */   // Label 280: @8355
     /*   8355 */   GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(8383), // Rule ID 243 //
     /*   8360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8363 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   8367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8371 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, GR32:{ *:[i32] }:$src1)  =>  (NEG32r:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /*   8371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG32r),
     /*   8374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8376 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8378 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8381 */     GIR_RootConstrainSelectedInstOperands,
     /*   8382 */     // GIR_Coverage, 243,
     /*   8382 */     GIR_EraseRootFromParent_Done,
     /*   8383 */   // Label 281: @8383
     /*   8383 */   GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(8411), // Rule ID 251 //
     /*   8388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*   8391 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   8395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8399 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, GR32:{ *:[i32] }:$src1)  =>  (NEG32r_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /*   8399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG32r_ND),
     /*   8402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8404 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8406 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8409 */     GIR_RootConstrainSelectedInstOperands,
     /*   8410 */     // GIR_Coverage, 251,
     /*   8410 */     GIR_EraseRootFromParent_Done,
     /*   8411 */   // Label 282: @8411
     /*   8411 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(8436), // Rule ID 259 //
     /*   8416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*   8419 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   8423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8427 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, GR32:{ *:[i32] }:$src1)  =>  (NEG32r_NF_ND:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /*   8427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG32r_NF_ND),
     /*   8430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8432 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8434 */     GIR_RootConstrainSelectedInstOperands,
     /*   8435 */     // GIR_Coverage, 259,
     /*   8435 */     GIR_EraseRootFromParent_Done,
     /*   8436 */   // Label 283: @8436
     /*   8436 */   GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(8473), // Rule ID 22814 //
     /*   8441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   8456 */     // MIs[1] Operand 1
     /*   8456 */     // No operand predicates
     /*   8456 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8458 */     // (sub:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (SUB32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*   8458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32ri),
     /*   8461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8463 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8465 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   8468 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8471 */     GIR_RootConstrainSelectedInstOperands,
     /*   8472 */     // GIR_Coverage, 22814,
     /*   8472 */     GIR_EraseRootFromParent_Done,
     /*   8473 */   // Label 284: @8473
     /*   8473 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(8510), // Rule ID 22904 //
     /*   8478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   8481 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   8493 */     // MIs[1] Operand 1
     /*   8493 */     // No operand predicates
     /*   8493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8495 */     // (sub:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (SUB32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*   8495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32ri_ND),
     /*   8498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8500 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8502 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   8505 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8508 */     GIR_RootConstrainSelectedInstOperands,
     /*   8509 */     // GIR_Coverage, 22904,
     /*   8509 */     GIR_EraseRootFromParent_Done,
     /*   8510 */   // Label 285: @8510
     /*   8510 */   GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(8539), // Rule ID 22806 //
     /*   8515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8526 */     // (sub:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (SUB32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*   8526 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB32rr),
     /*   8531 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   8537 */     GIR_RootConstrainSelectedInstOperands,
     /*   8538 */     // GIR_Coverage, 22806,
     /*   8538 */     GIR_Done,
     /*   8539 */   // Label 286: @8539
     /*   8539 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(8568), // Rule ID 22896 //
     /*   8544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   8547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8555 */     // (sub:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (SUB32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*   8555 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB32rr_ND),
     /*   8560 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   8566 */     GIR_RootConstrainSelectedInstOperands,
     /*   8567 */     // GIR_Coverage, 22896,
     /*   8567 */     GIR_Done,
     /*   8568 */   // Label 287: @8568
     /*   8568 */   GIM_Reject,
     /*   8569 */ // Label 278: @8569
     /*   8569 */ GIM_Reject,
     /*   8570 */ // Label 244: @8570
     /*   8570 */ GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(8929),
     /*   8575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   8578 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   8581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8585 */   GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(8646), // Rule ID 22811 //
     /*   8590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   8605 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   8608 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   8612 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   8616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8618 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   8625 */     // (sub:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUB64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   8625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64rm),
     /*   8628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8630 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8632 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   8636 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8639 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   8644 */     GIR_RootConstrainSelectedInstOperands,
     /*   8645 */     // GIR_Coverage, 22811,
     /*   8645 */     GIR_EraseRootFromParent_Done,
     /*   8646 */   // Label 289: @8646
     /*   8646 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(8707), // Rule ID 22901 //
     /*   8651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   8654 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   8666 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   8669 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   8673 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   8677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8679 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   8686 */     // (sub:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUB64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   8686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64rm_ND),
     /*   8689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8691 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8693 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   8697 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8700 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   8705 */     GIR_RootConstrainSelectedInstOperands,
     /*   8706 */     // GIR_Coverage, 22901,
     /*   8706 */     GIR_EraseRootFromParent_Done,
     /*   8707 */   // Label 290: @8707
     /*   8707 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(8735), // Rule ID 244 //
     /*   8712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8715 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   8719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8723 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, GR64:{ *:[i64] }:$src1)  =>  (NEG64r:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /*   8723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG64r),
     /*   8726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8728 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8730 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8733 */     GIR_RootConstrainSelectedInstOperands,
     /*   8734 */     // GIR_Coverage, 244,
     /*   8734 */     GIR_EraseRootFromParent_Done,
     /*   8735 */   // Label 291: @8735
     /*   8735 */   GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(8763), // Rule ID 252 //
     /*   8740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*   8743 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   8747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8751 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, GR64:{ *:[i64] }:$src1)  =>  (NEG64r_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /*   8751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG64r_ND),
     /*   8754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8756 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8758 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8761 */     GIR_RootConstrainSelectedInstOperands,
     /*   8762 */     // GIR_Coverage, 252,
     /*   8762 */     GIR_EraseRootFromParent_Done,
     /*   8763 */   // Label 292: @8763
     /*   8763 */   GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(8788), // Rule ID 260 //
     /*   8768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*   8771 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   8775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8779 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, GR64:{ *:[i64] }:$src1)  =>  (NEG64r_NF_ND:{ *:[i64] } GR64:{ *:[i64] }:$src1)
     /*   8779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG64r_NF_ND),
     /*   8782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8784 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8786 */     GIR_RootConstrainSelectedInstOperands,
     /*   8787 */     // GIR_Coverage, 260,
     /*   8787 */     GIR_EraseRootFromParent_Done,
     /*   8788 */   // Label 293: @8788
     /*   8788 */   GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(8829), // Rule ID 22815 //
     /*   8793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   8808 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*   8812 */     // MIs[1] Operand 1
     /*   8812 */     // No operand predicates
     /*   8812 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8814 */     // (sub:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (SUB64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*   8814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64ri32),
     /*   8817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8819 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   8824 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8827 */     GIR_RootConstrainSelectedInstOperands,
     /*   8828 */     // GIR_Coverage, 22815,
     /*   8828 */     GIR_EraseRootFromParent_Done,
     /*   8829 */   // Label 294: @8829
     /*   8829 */   GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(8870), // Rule ID 22905 //
     /*   8834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   8837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   8849 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*   8853 */     // MIs[1] Operand 1
     /*   8853 */     // No operand predicates
     /*   8853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8855 */     // (sub:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (SUB64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*   8855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64ri32_ND),
     /*   8858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8860 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8862 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   8865 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8868 */     GIR_RootConstrainSelectedInstOperands,
     /*   8869 */     // GIR_Coverage, 22905,
     /*   8869 */     GIR_EraseRootFromParent_Done,
     /*   8870 */   // Label 295: @8870
     /*   8870 */   GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(8899), // Rule ID 22807 //
     /*   8875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8886 */     // (sub:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (SUB64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*   8886 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB64rr),
     /*   8891 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   8897 */     GIR_RootConstrainSelectedInstOperands,
     /*   8898 */     // GIR_Coverage, 22807,
     /*   8898 */     GIR_Done,
     /*   8899 */   // Label 296: @8899
     /*   8899 */   GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(8928), // Rule ID 22897 //
     /*   8904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   8907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8915 */     // (sub:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (SUB64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*   8915 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB64rr_ND),
     /*   8920 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   8926 */     GIR_RootConstrainSelectedInstOperands,
     /*   8927 */     // GIR_Coverage, 22897,
     /*   8927 */     GIR_Done,
     /*   8928 */   // Label 297: @8928
     /*   8928 */   GIM_Reject,
     /*   8929 */ // Label 288: @8929
     /*   8929 */ GIM_Reject,
     /*   8930 */ // Label 245: @8930
     /*   8930 */ GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(9147),
     /*   8935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8938 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   8941 */   GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(9003), // Rule ID 2607 //
     /*   8946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   8949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   8953 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   8957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   8965 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   8968 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   8972 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   8976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8978 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   8985 */     // (sub:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBQrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   8985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBQrm),
     /*   8988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8990 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8992 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   8996 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9001 */     GIR_RootConstrainSelectedInstOperands,
     /*   9002 */     // GIR_Coverage, 2607,
     /*   9002 */     GIR_EraseRootFromParent_Done,
     /*   9003 */   // Label 299: @9003
     /*   9003 */   GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(9065), // Rule ID 4744 //
     /*   9008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   9011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9015 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9027 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9030 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9034 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9038 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9040 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9047 */     // (sub:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBQZ128rm),
     /*   9050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9052 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9054 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9058 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9063 */     GIR_RootConstrainSelectedInstOperands,
     /*   9064 */     // GIR_Coverage, 4744,
     /*   9064 */     GIR_EraseRootFromParent_Done,
     /*   9065 */   // Label 300: @9065
     /*   9065 */   GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(9092), // Rule ID 2606 //
     /*   9070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   9073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9077 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9085 */     // (sub:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VPSUBQrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*   9085 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBQrr),
     /*   9090 */     GIR_RootConstrainSelectedInstOperands,
     /*   9091 */     // GIR_Coverage, 2606,
     /*   9091 */     GIR_Done,
     /*   9092 */   // Label 301: @9092
     /*   9092 */   GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(9119), // Rule ID 2608 //
     /*   9097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*   9100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9104 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9112 */     // (sub:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (PSUBQrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*   9112 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBQrr),
     /*   9117 */     GIR_RootConstrainSelectedInstOperands,
     /*   9118 */     // GIR_Coverage, 2608,
     /*   9118 */     GIR_Done,
     /*   9119 */   // Label 302: @9119
     /*   9119 */   GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(9146), // Rule ID 4741 //
     /*   9124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   9127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9139 */     // (sub:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPSUBQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*   9139 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBQZ128rr),
     /*   9144 */     GIR_RootConstrainSelectedInstOperands,
     /*   9145 */     // GIR_Coverage, 4741,
     /*   9145 */     GIR_Done,
     /*   9146 */   // Label 303: @9146
     /*   9146 */   GIM_Reject,
     /*   9147 */ // Label 298: @9147
     /*   9147 */ GIM_Reject,
     /*   9148 */ // Label 246: @9148
     /*   9148 */ GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(9365),
     /*   9153 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9156 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9159 */   GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(9221), // Rule ID 2601 //
     /*   9164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   9167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9171 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9183 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9186 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9190 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9194 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9196 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9203 */     // (sub:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBDrm),
     /*   9206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9208 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9210 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9214 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9219 */     GIR_RootConstrainSelectedInstOperands,
     /*   9220 */     // GIR_Coverage, 2601,
     /*   9220 */     GIR_EraseRootFromParent_Done,
     /*   9221 */   // Label 305: @9221
     /*   9221 */   GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(9283), // Rule ID 4771 //
     /*   9226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   9229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9245 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9248 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9252 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9256 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9258 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9265 */     // (sub:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBDZ128rm),
     /*   9268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9270 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9272 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9276 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9281 */     GIR_RootConstrainSelectedInstOperands,
     /*   9282 */     // GIR_Coverage, 4771,
     /*   9282 */     GIR_EraseRootFromParent_Done,
     /*   9283 */   // Label 306: @9283
     /*   9283 */   GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(9310), // Rule ID 2600 //
     /*   9288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   9291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9303 */     // (sub:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPSUBDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*   9303 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBDrr),
     /*   9308 */     GIR_RootConstrainSelectedInstOperands,
     /*   9309 */     // GIR_Coverage, 2600,
     /*   9309 */     GIR_Done,
     /*   9310 */   // Label 307: @9310
     /*   9310 */   GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(9337), // Rule ID 2602 //
     /*   9315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*   9318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9330 */     // (sub:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PSUBDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*   9330 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBDrr),
     /*   9335 */     GIR_RootConstrainSelectedInstOperands,
     /*   9336 */     // GIR_Coverage, 2602,
     /*   9336 */     GIR_Done,
     /*   9337 */   // Label 308: @9337
     /*   9337 */   GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(9364), // Rule ID 4768 //
     /*   9342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   9345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9349 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9357 */     // (sub:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPSUBDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /*   9357 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBDZ128rr),
     /*   9362 */     GIR_RootConstrainSelectedInstOperands,
     /*   9363 */     // GIR_Coverage, 4768,
     /*   9363 */     GIR_Done,
     /*   9364 */   // Label 309: @9364
     /*   9364 */   GIM_Reject,
     /*   9365 */ // Label 304: @9365
     /*   9365 */ GIM_Reject,
     /*   9366 */ // Label 247: @9366
     /*   9366 */ GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(9556),
     /*   9371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*   9374 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*   9377 */   GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(9439), // Rule ID 2611 //
     /*   9382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   9385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9401 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9404 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9408 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9414 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9421 */     // (sub:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBQYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBQYrm),
     /*   9424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9426 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9428 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9432 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9437 */     GIR_RootConstrainSelectedInstOperands,
     /*   9438 */     // GIR_Coverage, 2611,
     /*   9438 */     GIR_EraseRootFromParent_Done,
     /*   9439 */   // Label 311: @9439
     /*   9439 */   GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(9501), // Rule ID 4735 //
     /*   9444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   9447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9463 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9466 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9470 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9474 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9476 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9483 */     // (sub:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBQZ256rm),
     /*   9486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9488 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9490 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9494 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9499 */     GIR_RootConstrainSelectedInstOperands,
     /*   9500 */     // GIR_Coverage, 4735,
     /*   9500 */     GIR_EraseRootFromParent_Done,
     /*   9501 */   // Label 312: @9501
     /*   9501 */   GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(9528), // Rule ID 2610 //
     /*   9506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   9509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9521 */     // (sub:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VPSUBQYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*   9521 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBQYrr),
     /*   9526 */     GIR_RootConstrainSelectedInstOperands,
     /*   9527 */     // GIR_Coverage, 2610,
     /*   9527 */     GIR_Done,
     /*   9528 */   // Label 313: @9528
     /*   9528 */   GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(9555), // Rule ID 4732 //
     /*   9533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   9536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9548 */     // (sub:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPSUBQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*   9548 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBQZ256rr),
     /*   9553 */     GIR_RootConstrainSelectedInstOperands,
     /*   9554 */     // GIR_Coverage, 4732,
     /*   9554 */     GIR_Done,
     /*   9555 */   // Label 314: @9555
     /*   9555 */   GIM_Reject,
     /*   9556 */ // Label 310: @9556
     /*   9556 */ GIM_Reject,
     /*   9557 */ // Label 248: @9557
     /*   9557 */ GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(9774),
     /*   9562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   9565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   9568 */   GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(9630), // Rule ID 2595 //
     /*   9573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*   9576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9580 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9592 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9595 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9599 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9605 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9612 */     // (sub:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBWrm),
     /*   9615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9617 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9619 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9623 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9628 */     GIR_RootConstrainSelectedInstOperands,
     /*   9629 */     // GIR_Coverage, 2595,
     /*   9629 */     GIR_EraseRootFromParent_Done,
     /*   9630 */   // Label 316: @9630
     /*   9630 */   GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(9692), // Rule ID 4792 //
     /*   9635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   9638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9642 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9654 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9657 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9661 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9667 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9674 */     // (sub:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBWZ128rm),
     /*   9677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9679 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9681 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9685 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9690 */     GIR_RootConstrainSelectedInstOperands,
     /*   9691 */     // GIR_Coverage, 4792,
     /*   9691 */     GIR_EraseRootFromParent_Done,
     /*   9692 */   // Label 317: @9692
     /*   9692 */   GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(9719), // Rule ID 2594 //
     /*   9697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*   9700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9712 */     // (sub:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPSUBWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*   9712 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBWrr),
     /*   9717 */     GIR_RootConstrainSelectedInstOperands,
     /*   9718 */     // GIR_Coverage, 2594,
     /*   9718 */     GIR_Done,
     /*   9719 */   // Label 318: @9719
     /*   9719 */   GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(9746), // Rule ID 2596 //
     /*   9724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*   9727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9739 */     // (sub:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PSUBWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*   9739 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBWrr),
     /*   9744 */     GIR_RootConstrainSelectedInstOperands,
     /*   9745 */     // GIR_Coverage, 2596,
     /*   9745 */     GIR_Done,
     /*   9746 */   // Label 319: @9746
     /*   9746 */   GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(9773), // Rule ID 4789 //
     /*   9751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   9754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9758 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9766 */     // (sub:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPSUBWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /*   9766 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBWZ128rr),
     /*   9771 */     GIR_RootConstrainSelectedInstOperands,
     /*   9772 */     // GIR_Coverage, 4789,
     /*   9772 */     GIR_Done,
     /*   9773 */   // Label 320: @9773
     /*   9773 */   GIM_Reject,
     /*   9774 */ // Label 315: @9774
     /*   9774 */ GIM_Reject,
     /*   9775 */ // Label 249: @9775
     /*   9775 */ GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(9965),
     /*   9780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*   9783 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*   9786 */   GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(9848), // Rule ID 2605 //
     /*   9791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   9794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9810 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9813 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9817 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9823 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9830 */     // (sub:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBDYrm),
     /*   9833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9835 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9837 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9841 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9846 */     GIR_RootConstrainSelectedInstOperands,
     /*   9847 */     // GIR_Coverage, 2605,
     /*   9847 */     GIR_EraseRootFromParent_Done,
     /*   9848 */   // Label 322: @9848
     /*   9848 */   GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(9910), // Rule ID 4762 //
     /*   9853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   9856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9872 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9875 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9879 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9885 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9892 */     // (sub:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBDZ256rm),
     /*   9895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9897 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9899 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9903 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9908 */     GIR_RootConstrainSelectedInstOperands,
     /*   9909 */     // GIR_Coverage, 4762,
     /*   9909 */     GIR_EraseRootFromParent_Done,
     /*   9910 */   // Label 323: @9910
     /*   9910 */   GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(9937), // Rule ID 2604 //
     /*   9915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   9918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9930 */     // (sub:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPSUBDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*   9930 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBDYrr),
     /*   9935 */     GIR_RootConstrainSelectedInstOperands,
     /*   9936 */     // GIR_Coverage, 2604,
     /*   9936 */     GIR_Done,
     /*   9937 */   // Label 324: @9937
     /*   9937 */   GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(9964), // Rule ID 4759 //
     /*   9942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   9945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9957 */     // (sub:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPSUBDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /*   9957 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBDZ256rr),
     /*   9962 */     GIR_RootConstrainSelectedInstOperands,
     /*   9963 */     // GIR_Coverage, 4759,
     /*   9963 */     GIR_Done,
     /*   9964 */   // Label 325: @9964
     /*   9964 */   GIM_Reject,
     /*   9965 */ // Label 321: @9965
     /*   9965 */ GIM_Reject,
     /*   9966 */ // Label 250: @9966
     /*   9966 */ GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(10059),
     /*   9971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*   9974 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*   9977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   9981 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   9985 */   GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(10039), // Rule ID 4726 //
     /*   9990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*   9993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10001 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10004 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  10008 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10014 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10021 */     // (sub:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBQZrm),
     /*  10024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10026 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10028 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  10032 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  10037 */     GIR_RootConstrainSelectedInstOperands,
     /*  10038 */     // GIR_Coverage, 4726,
     /*  10038 */     GIR_EraseRootFromParent_Done,
     /*  10039 */   // Label 327: @10039
     /*  10039 */   GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(10058), // Rule ID 4723 //
     /*  10044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  10047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10051 */     // (sub:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPSUBQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  10051 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBQZrr),
     /*  10056 */     GIR_RootConstrainSelectedInstOperands,
     /*  10057 */     // GIR_Coverage, 4723,
     /*  10057 */     GIR_Done,
     /*  10058 */   // Label 328: @10058
     /*  10058 */   GIM_Reject,
     /*  10059 */ // Label 326: @10059
     /*  10059 */ GIM_Reject,
     /*  10060 */ // Label 251: @10060
     /*  10060 */ GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(10277),
     /*  10065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  10068 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  10071 */   GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(10133), // Rule ID 2589 //
     /*  10076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*  10079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  10083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  10087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10095 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10098 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  10102 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10106 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10108 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10115 */     // (sub:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBBrm),
     /*  10118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10120 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10122 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  10126 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  10131 */     GIR_RootConstrainSelectedInstOperands,
     /*  10132 */     // GIR_Coverage, 2589,
     /*  10132 */     GIR_EraseRootFromParent_Done,
     /*  10133 */   // Label 330: @10133
     /*  10133 */   GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(10195), // Rule ID 4810 //
     /*  10138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  10141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  10145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  10149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10157 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10160 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  10164 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10168 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10170 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10177 */     // (sub:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBBZ128rm),
     /*  10180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10182 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10184 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  10188 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  10193 */     GIR_RootConstrainSelectedInstOperands,
     /*  10194 */     // GIR_Coverage, 4810,
     /*  10194 */     GIR_EraseRootFromParent_Done,
     /*  10195 */   // Label 331: @10195
     /*  10195 */   GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(10222), // Rule ID 2588 //
     /*  10200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*  10203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  10207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  10211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  10215 */     // (sub:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPSUBBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  10215 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBBrr),
     /*  10220 */     GIR_RootConstrainSelectedInstOperands,
     /*  10221 */     // GIR_Coverage, 2588,
     /*  10221 */     GIR_Done,
     /*  10222 */   // Label 332: @10222
     /*  10222 */   GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(10249), // Rule ID 2590 //
     /*  10227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  10230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  10234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  10238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  10242 */     // (sub:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PSUBBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  10242 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBBrr),
     /*  10247 */     GIR_RootConstrainSelectedInstOperands,
     /*  10248 */     // GIR_Coverage, 2590,
     /*  10248 */     GIR_Done,
     /*  10249 */   // Label 333: @10249
     /*  10249 */   GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(10276), // Rule ID 4807 //
     /*  10254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  10257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  10261 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  10265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  10269 */     // (sub:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPSUBBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /*  10269 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBBZ128rr),
     /*  10274 */     GIR_RootConstrainSelectedInstOperands,
     /*  10275 */     // GIR_Coverage, 4807,
     /*  10275 */     GIR_Done,
     /*  10276 */   // Label 334: @10276
     /*  10276 */   GIM_Reject,
     /*  10277 */ // Label 329: @10277
     /*  10277 */ GIM_Reject,
     /*  10278 */ // Label 252: @10278
     /*  10278 */ GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(10468),
     /*  10283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  10286 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  10289 */   GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(10351), // Rule ID 2599 //
     /*  10294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*  10297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10301 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10313 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10316 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  10320 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10324 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10326 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10333 */     // (sub:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBWYrm),
     /*  10336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10338 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10340 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  10344 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  10349 */     GIR_RootConstrainSelectedInstOperands,
     /*  10350 */     // GIR_Coverage, 2599,
     /*  10350 */     GIR_EraseRootFromParent_Done,
     /*  10351 */   // Label 336: @10351
     /*  10351 */   GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(10413), // Rule ID 4786 //
     /*  10356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  10359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10375 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10378 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  10382 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10386 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10388 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10395 */     // (sub:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBWZ256rm),
     /*  10398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10400 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10402 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  10406 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  10411 */     GIR_RootConstrainSelectedInstOperands,
     /*  10412 */     // GIR_Coverage, 4786,
     /*  10412 */     GIR_EraseRootFromParent_Done,
     /*  10413 */   // Label 337: @10413
     /*  10413 */   GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(10440), // Rule ID 2598 //
     /*  10418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*  10421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10433 */     // (sub:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPSUBWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  10433 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBWYrr),
     /*  10438 */     GIR_RootConstrainSelectedInstOperands,
     /*  10439 */     // GIR_Coverage, 2598,
     /*  10439 */     GIR_Done,
     /*  10440 */   // Label 338: @10440
     /*  10440 */   GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(10467), // Rule ID 4783 //
     /*  10445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  10448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10460 */     // (sub:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPSUBWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /*  10460 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBWZ256rr),
     /*  10465 */     GIR_RootConstrainSelectedInstOperands,
     /*  10466 */     // GIR_Coverage, 4783,
     /*  10466 */     GIR_Done,
     /*  10467 */   // Label 339: @10467
     /*  10467 */   GIM_Reject,
     /*  10468 */ // Label 335: @10468
     /*  10468 */ GIM_Reject,
     /*  10469 */ // Label 253: @10469
     /*  10469 */ GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(10562),
     /*  10474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  10477 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  10480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10484 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10488 */   GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(10542), // Rule ID 4753 //
     /*  10493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  10496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10504 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10507 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  10511 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10517 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10524 */     // (sub:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBDZrm),
     /*  10527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10529 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10531 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  10535 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  10540 */     GIR_RootConstrainSelectedInstOperands,
     /*  10541 */     // GIR_Coverage, 4753,
     /*  10541 */     GIR_EraseRootFromParent_Done,
     /*  10542 */   // Label 341: @10542
     /*  10542 */   GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(10561), // Rule ID 4750 //
     /*  10547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  10550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10554 */     // (sub:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPSUBDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /*  10554 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBDZrr),
     /*  10559 */     GIR_RootConstrainSelectedInstOperands,
     /*  10560 */     // GIR_Coverage, 4750,
     /*  10560 */     GIR_Done,
     /*  10561 */   // Label 342: @10561
     /*  10561 */   GIM_Reject,
     /*  10562 */ // Label 340: @10562
     /*  10562 */ GIM_Reject,
     /*  10563 */ // Label 254: @10563
     /*  10563 */ GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(10753),
     /*  10568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /*  10571 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /*  10574 */   GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(10636), // Rule ID 2593 //
     /*  10579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*  10582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10598 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10601 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  10605 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10611 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10618 */     // (sub:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBBYrm),
     /*  10621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10623 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10625 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  10629 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  10634 */     GIR_RootConstrainSelectedInstOperands,
     /*  10635 */     // GIR_Coverage, 2593,
     /*  10635 */     GIR_EraseRootFromParent_Done,
     /*  10636 */   // Label 344: @10636
     /*  10636 */   GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(10698), // Rule ID 4804 //
     /*  10641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  10644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10660 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10663 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  10667 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10673 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10680 */     // (sub:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBBZ256rm),
     /*  10683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10685 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10687 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  10691 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  10696 */     GIR_RootConstrainSelectedInstOperands,
     /*  10697 */     // GIR_Coverage, 4804,
     /*  10697 */     GIR_EraseRootFromParent_Done,
     /*  10698 */   // Label 345: @10698
     /*  10698 */   GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(10725), // Rule ID 2592 //
     /*  10703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*  10706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10710 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10718 */     // (sub:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPSUBBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*  10718 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBBYrr),
     /*  10723 */     GIR_RootConstrainSelectedInstOperands,
     /*  10724 */     // GIR_Coverage, 2592,
     /*  10724 */     GIR_Done,
     /*  10725 */   // Label 346: @10725
     /*  10725 */   GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(10752), // Rule ID 4801 //
     /*  10730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  10733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10745 */     // (sub:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPSUBBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /*  10745 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBBZ256rr),
     /*  10750 */     GIR_RootConstrainSelectedInstOperands,
     /*  10751 */     // GIR_Coverage, 4801,
     /*  10751 */     GIR_Done,
     /*  10752 */   // Label 347: @10752
     /*  10752 */   GIM_Reject,
     /*  10753 */ // Label 343: @10753
     /*  10753 */ GIM_Reject,
     /*  10754 */ // Label 255: @10754
     /*  10754 */ GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(10847),
     /*  10759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  10762 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /*  10765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10769 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10773 */   GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(10827), // Rule ID 4780 //
     /*  10778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  10781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10789 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10792 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  10796 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10800 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10802 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10809 */     // (sub:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBWZrm),
     /*  10812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10814 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10816 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  10820 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  10825 */     GIR_RootConstrainSelectedInstOperands,
     /*  10826 */     // GIR_Coverage, 4780,
     /*  10826 */     GIR_EraseRootFromParent_Done,
     /*  10827 */   // Label 349: @10827
     /*  10827 */   GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(10846), // Rule ID 4777 //
     /*  10832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  10835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10839 */     // (sub:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPSUBWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /*  10839 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBWZrr),
     /*  10844 */     GIR_RootConstrainSelectedInstOperands,
     /*  10845 */     // GIR_Coverage, 4777,
     /*  10845 */     GIR_Done,
     /*  10846 */   // Label 350: @10846
     /*  10846 */   GIM_Reject,
     /*  10847 */ // Label 348: @10847
     /*  10847 */ GIM_Reject,
     /*  10848 */ // Label 256: @10848
     /*  10848 */ GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(10941),
     /*  10853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /*  10856 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /*  10859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10863 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10867 */   GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(10921), // Rule ID 4798 //
     /*  10872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  10875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10883 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10886 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  10890 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10896 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10903 */     // (sub:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBBZrm),
     /*  10906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10908 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10910 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  10914 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  10919 */     GIR_RootConstrainSelectedInstOperands,
     /*  10920 */     // GIR_Coverage, 4798,
     /*  10920 */     GIR_EraseRootFromParent_Done,
     /*  10921 */   // Label 352: @10921
     /*  10921 */   GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(10940), // Rule ID 4795 //
     /*  10926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  10929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10933 */     // (sub:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPSUBBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /*  10933 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBBZrr),
     /*  10938 */     GIR_RootConstrainSelectedInstOperands,
     /*  10939 */     // GIR_Coverage, 4795,
     /*  10939 */     GIR_Done,
     /*  10940 */   // Label 353: @10940
     /*  10940 */   GIM_Reject,
     /*  10941 */ // Label 351: @10941
     /*  10941 */ GIM_Reject,
     /*  10942 */ // Label 257: @10942
     /*  10942 */ GIM_Reject,
     /*  10943 */ // Label 2: @10943
     /*  10943 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 366*/ GIMT_Encode4(14725),
     /*  10954 */ /*GILLT_s16*//*Label 354*/ GIMT_Encode4(11038),
     /*  10958 */ /*GILLT_s32*//*Label 355*/ GIMT_Encode4(11455),
     /*  10962 */ /*GILLT_s64*//*Label 356*/ GIMT_Encode4(11872), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  10978 */ /*GILLT_v2s64*//*Label 357*/ GIMT_Encode4(12297), GIMT_Encode4(0),
     /*  10986 */ /*GILLT_v4s32*//*Label 358*/ GIMT_Encode4(12626),
     /*  10990 */ /*GILLT_v4s64*//*Label 359*/ GIMT_Encode4(12968), GIMT_Encode4(0),
     /*  10998 */ /*GILLT_v8s16*//*Label 360*/ GIMT_Encode4(13285),
     /*  11002 */ /*GILLT_v8s32*//*Label 361*/ GIMT_Encode4(13627),
     /*  11006 */ /*GILLT_v8s64*//*Label 362*/ GIMT_Encode4(13942), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  11018 */ /*GILLT_v16s16*//*Label 363*/ GIMT_Encode4(14098),
     /*  11022 */ /*GILLT_v16s32*//*Label 364*/ GIMT_Encode4(14413), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  11034 */ /*GILLT_v32s16*//*Label 365*/ GIMT_Encode4(14569),
     /*  11038 */ // Label 354: @11038
     /*  11038 */ GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(11454),
     /*  11043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  11046 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  11049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  11053 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(11117), // Rule ID 22979 //
     /*  11058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11066 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11069 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11073 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  11077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11085 */     // MIs[2] Operand 1
     /*  11085 */     // No operand predicates
     /*  11085 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11087 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11094 */     // (mul:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i16] }):$src2)  =>  (IMUL16rmi:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  11094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL16rmi),
     /*  11097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11099 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  11103 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /*  11106 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11109 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  11115 */     GIR_RootConstrainSelectedInstOperands,
     /*  11116 */     // GIR_Coverage, 22979,
     /*  11116 */     GIR_EraseRootFromParent_Done,
     /*  11117 */   // Label 368: @11117
     /*  11117 */   GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(11178), // Rule ID 26058 //
     /*  11122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  11125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11133 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11136 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11140 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  11144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  11148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11150 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11157 */     // (mul:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (IMUL16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL16rm),
     /*  11160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11162 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  11164 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11168 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11171 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11176 */     GIR_RootConstrainSelectedInstOperands,
     /*  11177 */     // GIR_Coverage, 26058,
     /*  11177 */     GIR_EraseRootFromParent_Done,
     /*  11178 */   // Label 369: @11178
     /*  11178 */   GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(11239), // Rule ID 26077 //
     /*  11183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  11186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11194 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11197 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11201 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  11205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  11209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11211 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11218 */     // (mul:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (IMUL16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL16rm_ND),
     /*  11221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11223 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  11225 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11229 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11232 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11237 */     GIR_RootConstrainSelectedInstOperands,
     /*  11238 */     // GIR_Coverage, 26077,
     /*  11238 */     GIR_EraseRootFromParent_Done,
     /*  11239 */   // Label 370: @11239
     /*  11239 */   GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(11300), // Rule ID 22823 //
     /*  11244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  11247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  11251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11259 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11262 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11266 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  11270 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11272 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11279 */     // (mul:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (IMUL16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL16rm),
     /*  11282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11284 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11286 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11290 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11293 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11298 */     GIR_RootConstrainSelectedInstOperands,
     /*  11299 */     // GIR_Coverage, 22823,
     /*  11299 */     GIR_EraseRootFromParent_Done,
     /*  11300 */   // Label 371: @11300
     /*  11300 */   GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(11361), // Rule ID 22913 //
     /*  11305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  11308 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  11312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11320 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11323 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11327 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  11331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11333 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11340 */     // (mul:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (IMUL16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL16rm_ND),
     /*  11343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11345 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11347 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11351 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11359 */     GIR_RootConstrainSelectedInstOperands,
     /*  11360 */     // GIR_Coverage, 22913,
     /*  11360 */     GIR_EraseRootFromParent_Done,
     /*  11361 */   // Label 372: @11361
     /*  11361 */   GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(11395), // Rule ID 22976 //
     /*  11366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  11370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11378 */     // MIs[1] Operand 1
     /*  11378 */     // No operand predicates
     /*  11378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11380 */     // (mul:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (IMUL16rri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  11380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL16rri),
     /*  11383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11385 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11387 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  11390 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11393 */     GIR_RootConstrainSelectedInstOperands,
     /*  11394 */     // GIR_Coverage, 22976,
     /*  11394 */     GIR_EraseRootFromParent_Done,
     /*  11395 */   // Label 373: @11395
     /*  11395 */   GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(11424), // Rule ID 22820 //
     /*  11400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  11403 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  11407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  11411 */     // (mul:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (IMUL16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  11411 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::IMUL16rr),
     /*  11416 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  11422 */     GIR_RootConstrainSelectedInstOperands,
     /*  11423 */     // GIR_Coverage, 22820,
     /*  11423 */     GIR_Done,
     /*  11424 */   // Label 374: @11424
     /*  11424 */   GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(11453), // Rule ID 22910 //
     /*  11429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  11432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  11436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  11440 */     // (mul:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (IMUL16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  11440 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::IMUL16rr_ND),
     /*  11445 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  11451 */     GIR_RootConstrainSelectedInstOperands,
     /*  11452 */     // GIR_Coverage, 22910,
     /*  11452 */     GIR_Done,
     /*  11453 */   // Label 375: @11453
     /*  11453 */   GIM_Reject,
     /*  11454 */ // Label 367: @11454
     /*  11454 */ GIM_Reject,
     /*  11455 */ // Label 355: @11455
     /*  11455 */ GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(11871),
     /*  11460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  11463 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  11466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11470 */   GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(11534), // Rule ID 22980 //
     /*  11475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11483 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11486 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11490 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  11494 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11498 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11502 */     // MIs[2] Operand 1
     /*  11502 */     // No operand predicates
     /*  11502 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11504 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11511 */     // (mul:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i32] }):$src2)  =>  (IMUL32rmi:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  11511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL32rmi),
     /*  11514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11516 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  11520 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /*  11523 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11526 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  11532 */     GIR_RootConstrainSelectedInstOperands,
     /*  11533 */     // GIR_Coverage, 22980,
     /*  11533 */     GIR_EraseRootFromParent_Done,
     /*  11534 */   // Label 377: @11534
     /*  11534 */   GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(11595), // Rule ID 26059 //
     /*  11539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  11542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11550 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11553 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11557 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  11561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11567 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11574 */     // (mul:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (IMUL32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL32rm),
     /*  11577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11579 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  11581 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11585 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11588 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11593 */     GIR_RootConstrainSelectedInstOperands,
     /*  11594 */     // GIR_Coverage, 26059,
     /*  11594 */     GIR_EraseRootFromParent_Done,
     /*  11595 */   // Label 378: @11595
     /*  11595 */   GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(11656), // Rule ID 26078 //
     /*  11600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  11603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11611 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11614 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11618 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  11622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11626 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11628 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11635 */     // (mul:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (IMUL32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL32rm_ND),
     /*  11638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11640 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  11642 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11646 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11649 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11654 */     GIR_RootConstrainSelectedInstOperands,
     /*  11655 */     // GIR_Coverage, 26078,
     /*  11655 */     GIR_EraseRootFromParent_Done,
     /*  11656 */   // Label 379: @11656
     /*  11656 */   GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(11717), // Rule ID 22824 //
     /*  11661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  11664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11676 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11679 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11683 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  11687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11689 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11696 */     // (mul:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (IMUL32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL32rm),
     /*  11699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11701 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11703 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11707 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11710 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11715 */     GIR_RootConstrainSelectedInstOperands,
     /*  11716 */     // GIR_Coverage, 22824,
     /*  11716 */     GIR_EraseRootFromParent_Done,
     /*  11717 */   // Label 380: @11717
     /*  11717 */   GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(11778), // Rule ID 22914 //
     /*  11722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  11725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11737 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11740 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11744 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  11748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11750 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11757 */     // (mul:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (IMUL32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL32rm_ND),
     /*  11760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11762 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11764 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11768 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11771 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11776 */     GIR_RootConstrainSelectedInstOperands,
     /*  11777 */     // GIR_Coverage, 22914,
     /*  11777 */     GIR_EraseRootFromParent_Done,
     /*  11778 */   // Label 381: @11778
     /*  11778 */   GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(11812), // Rule ID 22977 //
     /*  11783 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11795 */     // MIs[1] Operand 1
     /*  11795 */     // No operand predicates
     /*  11795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11797 */     // (mul:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (IMUL32rri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  11797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL32rri),
     /*  11800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11802 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11804 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  11807 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11810 */     GIR_RootConstrainSelectedInstOperands,
     /*  11811 */     // GIR_Coverage, 22977,
     /*  11811 */     GIR_EraseRootFromParent_Done,
     /*  11812 */   // Label 382: @11812
     /*  11812 */   GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(11841), // Rule ID 22821 //
     /*  11817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  11820 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11828 */     // (mul:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (IMUL32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  11828 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::IMUL32rr),
     /*  11833 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  11839 */     GIR_RootConstrainSelectedInstOperands,
     /*  11840 */     // GIR_Coverage, 22821,
     /*  11840 */     GIR_Done,
     /*  11841 */   // Label 383: @11841
     /*  11841 */   GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(11870), // Rule ID 22911 //
     /*  11846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  11849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11857 */     // (mul:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (IMUL32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  11857 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::IMUL32rr_ND),
     /*  11862 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  11868 */     GIR_RootConstrainSelectedInstOperands,
     /*  11869 */     // GIR_Coverage, 22911,
     /*  11869 */     GIR_Done,
     /*  11870 */   // Label 384: @11870
     /*  11870 */   GIM_Reject,
     /*  11871 */ // Label 376: @11871
     /*  11871 */ GIM_Reject,
     /*  11872 */ // Label 356: @11872
     /*  11872 */ GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(12296),
     /*  11877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  11880 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  11883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  11887 */   GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(11955), // Rule ID 22981 //
     /*  11892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11900 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11903 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  11907 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11919 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  11923 */     // MIs[2] Operand 1
     /*  11923 */     // No operand predicates
     /*  11923 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11925 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11932 */     // (mul:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (IMUL64rmi32:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  11932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL64rmi32),
     /*  11935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11937 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  11941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /*  11944 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11947 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  11953 */     GIR_RootConstrainSelectedInstOperands,
     /*  11954 */     // GIR_Coverage, 22981,
     /*  11954 */     GIR_EraseRootFromParent_Done,
     /*  11955 */   // Label 386: @11955
     /*  11955 */   GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(12016), // Rule ID 26060 //
     /*  11960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  11963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11971 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11974 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  11978 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  11986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11988 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11995 */     // (mul:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (IMUL64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL64rm),
     /*  11998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12000 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  12002 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  12006 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  12009 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  12014 */     GIR_RootConstrainSelectedInstOperands,
     /*  12015 */     // GIR_Coverage, 26060,
     /*  12015 */     GIR_EraseRootFromParent_Done,
     /*  12016 */   // Label 387: @12016
     /*  12016 */   GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(12077), // Rule ID 26079 //
     /*  12021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  12024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  12032 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  12035 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  12039 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  12043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  12047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12049 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  12056 */     // (mul:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (IMUL64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  12056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL64rm_ND),
     /*  12059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12061 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  12063 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  12067 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  12070 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  12075 */     GIR_RootConstrainSelectedInstOperands,
     /*  12076 */     // GIR_Coverage, 26079,
     /*  12076 */     GIR_EraseRootFromParent_Done,
     /*  12077 */   // Label 388: @12077
     /*  12077 */   GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(12138), // Rule ID 22825 //
     /*  12082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  12085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  12089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  12097 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  12100 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  12104 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  12108 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12110 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  12117 */     // (mul:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (IMUL64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  12117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL64rm),
     /*  12120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12122 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  12124 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  12128 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  12131 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  12136 */     GIR_RootConstrainSelectedInstOperands,
     /*  12137 */     // GIR_Coverage, 22825,
     /*  12137 */     GIR_EraseRootFromParent_Done,
     /*  12138 */   // Label 389: @12138
     /*  12138 */   GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(12199), // Rule ID 22915 //
     /*  12143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  12146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  12150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  12158 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  12161 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  12165 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  12169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12171 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  12178 */     // (mul:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (IMUL64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  12178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL64rm_ND),
     /*  12181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12183 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  12185 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  12189 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  12192 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  12197 */     GIR_RootConstrainSelectedInstOperands,
     /*  12198 */     // GIR_Coverage, 22915,
     /*  12198 */     GIR_EraseRootFromParent_Done,
     /*  12199 */   // Label 390: @12199
     /*  12199 */   GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(12237), // Rule ID 22978 //
     /*  12204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  12208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  12216 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  12220 */     // MIs[1] Operand 1
     /*  12220 */     // No operand predicates
     /*  12220 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12222 */     // (mul:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (IMUL64rri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  12222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL64rri32),
     /*  12225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12227 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  12229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  12232 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  12235 */     GIR_RootConstrainSelectedInstOperands,
     /*  12236 */     // GIR_Coverage, 22978,
     /*  12236 */     GIR_EraseRootFromParent_Done,
     /*  12237 */   // Label 391: @12237
     /*  12237 */   GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(12266), // Rule ID 22822 //
     /*  12242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  12245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  12249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  12253 */     // (mul:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (IMUL64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  12253 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::IMUL64rr),
     /*  12258 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  12264 */     GIR_RootConstrainSelectedInstOperands,
     /*  12265 */     // GIR_Coverage, 22822,
     /*  12265 */     GIR_Done,
     /*  12266 */   // Label 392: @12266
     /*  12266 */   GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(12295), // Rule ID 22912 //
     /*  12271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  12274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  12278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  12282 */     // (mul:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (IMUL64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  12282 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::IMUL64rr_ND),
     /*  12287 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  12293 */     GIR_RootConstrainSelectedInstOperands,
     /*  12294 */     // GIR_Coverage, 22912,
     /*  12294 */     GIR_Done,
     /*  12295 */   // Label 393: @12295
     /*  12295 */   GIM_Reject,
     /*  12296 */ // Label 385: @12296
     /*  12296 */ GIM_Reject,
     /*  12297 */ // Label 357: @12297
     /*  12297 */ GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(12625),
     /*  12302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  12305 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  12308 */   GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(12370), // Rule ID 23825 //
     /*  12313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  12316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  12328 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  12331 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  12335 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  12339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12345 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  12352 */     // (mul:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2i64] }:$src1)  =>  (VPMULLQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  12352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLQZ128rm),
     /*  12355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12357 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  12359 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  12363 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  12368 */     GIR_RootConstrainSelectedInstOperands,
     /*  12369 */     // GIR_Coverage, 23825,
     /*  12369 */     GIR_EraseRootFromParent_Done,
     /*  12370 */   // Label 395: @12370
     /*  12370 */   GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(12432), // Rule ID 5023 //
     /*  12375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  12378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12382 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  12394 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  12397 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  12401 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  12405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12407 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  12414 */     // (mul:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  12414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLQZ128rm),
     /*  12417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12419 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  12421 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  12425 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  12430 */     GIR_RootConstrainSelectedInstOperands,
     /*  12431 */     // GIR_Coverage, 5023,
     /*  12431 */     GIR_EraseRootFromParent_Done,
     /*  12432 */   // Label 396: @12432
     /*  12432 */   GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(12459), // Rule ID 5020 //
     /*  12437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  12440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12452 */     // (mul:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPMULLQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*  12452 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLQZ128rr),
     /*  12457 */     GIR_RootConstrainSelectedInstOperands,
     /*  12458 */     // GIR_Coverage, 5020,
     /*  12458 */     GIR_Done,
     /*  12459 */   // Label 397: @12459
     /*  12459 */   GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(12624), // Rule ID 19998 //
     /*  12464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEVEX512_NoVLX),
     /*  12467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  12471 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12479 */     // (mul:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPMULLQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /*  12479 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  12482 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12486 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12491 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  12493 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  12496 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  12500 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12505 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  12508 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  12512 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /*  12515 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  12520 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  12525 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  12530 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  12533 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12537 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  12544 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  12547 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  12551 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12556 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  12559 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  12563 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /*  12566 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  12571 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  12576 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  12581 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  12584 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMULLQZrr),
     /*  12588 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12593 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  12596 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  12599 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12606 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /*  12613 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /*  12618 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  12623 */     // GIR_Coverage, 19998,
     /*  12623 */     GIR_EraseRootFromParent_Done,
     /*  12624 */   // Label 398: @12624
     /*  12624 */   GIM_Reject,
     /*  12625 */ // Label 394: @12625
     /*  12625 */ GIM_Reject,
     /*  12626 */ // Label 358: @12626
     /*  12626 */ GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(12967),
     /*  12631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12634 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12637 */   GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(12699), // Rule ID 23528 //
     /*  12642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  12645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  12657 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  12660 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  12664 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  12668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12674 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  12681 */     // (mul:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1)  =>  (VPMULLDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  12681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDrm),
     /*  12684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12686 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  12688 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  12692 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  12697 */     GIR_RootConstrainSelectedInstOperands,
     /*  12698 */     // GIR_Coverage, 23528,
     /*  12698 */     GIR_EraseRootFromParent_Done,
     /*  12699 */   // Label 400: @12699
     /*  12699 */   GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(12761), // Rule ID 23798 //
     /*  12704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  12707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  12719 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  12722 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  12726 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  12730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12736 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  12743 */     // (mul:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4i32] }:$src1)  =>  (VPMULLDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  12743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDZ128rm),
     /*  12746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12748 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  12750 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  12754 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  12759 */     GIR_RootConstrainSelectedInstOperands,
     /*  12760 */     // GIR_Coverage, 23798,
     /*  12760 */     GIR_EraseRootFromParent_Done,
     /*  12761 */   // Label 401: @12761
     /*  12761 */   GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(12823), // Rule ID 3240 //
     /*  12766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  12769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  12785 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  12788 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  12792 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  12796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12798 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  12805 */     // (mul:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  12805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDrm),
     /*  12808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12810 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  12812 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  12816 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  12821 */     GIR_RootConstrainSelectedInstOperands,
     /*  12822 */     // GIR_Coverage, 3240,
     /*  12822 */     GIR_EraseRootFromParent_Done,
     /*  12823 */   // Label 402: @12823
     /*  12823 */   GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(12885), // Rule ID 4978 //
     /*  12828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  12831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  12847 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  12850 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  12854 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  12858 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12860 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  12867 */     // (mul:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  12867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDZ128rm),
     /*  12870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12872 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  12874 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  12878 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  12883 */     GIR_RootConstrainSelectedInstOperands,
     /*  12884 */     // GIR_Coverage, 4978,
     /*  12884 */     GIR_EraseRootFromParent_Done,
     /*  12885 */   // Label 403: @12885
     /*  12885 */   GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(12912), // Rule ID 3239 //
     /*  12890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  12893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12905 */     // (mul:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPMULLDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  12905 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLDrr),
     /*  12910 */     GIR_RootConstrainSelectedInstOperands,
     /*  12911 */     // GIR_Coverage, 3239,
     /*  12911 */     GIR_Done,
     /*  12912 */   // Label 404: @12912
     /*  12912 */   GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(12939), // Rule ID 3247 //
     /*  12917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /*  12920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12932 */     // (mul:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PMULLDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  12932 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMULLDrr),
     /*  12937 */     GIR_RootConstrainSelectedInstOperands,
     /*  12938 */     // GIR_Coverage, 3247,
     /*  12938 */     GIR_Done,
     /*  12939 */   // Label 405: @12939
     /*  12939 */   GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(12966), // Rule ID 4975 //
     /*  12944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  12947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12951 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12959 */     // (mul:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPMULLDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /*  12959 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLDZ128rr),
     /*  12964 */     GIR_RootConstrainSelectedInstOperands,
     /*  12965 */     // GIR_Coverage, 4975,
     /*  12965 */     GIR_Done,
     /*  12966 */   // Label 406: @12966
     /*  12966 */   GIM_Reject,
     /*  12967 */ // Label 399: @12967
     /*  12967 */ GIM_Reject,
     /*  12968 */ // Label 359: @12968
     /*  12968 */ GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(13284),
     /*  12973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  12976 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  12979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  12983 */   GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(13041), // Rule ID 23819 //
     /*  12988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  12991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  12999 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13002 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13006 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13016 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13023 */     // (mul:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4i64] }:$src1)  =>  (VPMULLQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLQZ256rm),
     /*  13026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13028 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  13030 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13034 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13039 */     GIR_RootConstrainSelectedInstOperands,
     /*  13040 */     // GIR_Coverage, 23819,
     /*  13040 */     GIR_EraseRootFromParent_Done,
     /*  13041 */   // Label 408: @13041
     /*  13041 */   GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(13099), // Rule ID 5014 //
     /*  13046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  13049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13061 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13064 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13068 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13072 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13074 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13081 */     // (mul:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLQZ256rm),
     /*  13084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13086 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  13088 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13092 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13097 */     GIR_RootConstrainSelectedInstOperands,
     /*  13098 */     // GIR_Coverage, 5014,
     /*  13098 */     GIR_EraseRootFromParent_Done,
     /*  13099 */   // Label 409: @13099
     /*  13099 */   GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(13122), // Rule ID 5011 //
     /*  13104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  13107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13115 */     // (mul:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPMULLQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*  13115 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLQZ256rr),
     /*  13120 */     GIR_RootConstrainSelectedInstOperands,
     /*  13121 */     // GIR_Coverage, 5011,
     /*  13121 */     GIR_Done,
     /*  13122 */   // Label 410: @13122
     /*  13122 */   GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(13283), // Rule ID 19996 //
     /*  13127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEVEX512_NoVLX),
     /*  13130 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13138 */     // (mul:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPMULLQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /*  13138 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  13141 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13145 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13150 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  13152 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  13155 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13159 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13164 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  13167 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  13171 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /*  13174 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  13179 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  13184 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  13189 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  13192 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13196 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13201 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13203 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  13206 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13210 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13215 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13218 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  13222 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /*  13225 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  13230 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  13235 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  13240 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  13243 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMULLQZrr),
     /*  13247 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13252 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13255 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  13258 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13265 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /*  13272 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /*  13277 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  13282 */     // GIR_Coverage, 19996,
     /*  13282 */     GIR_EraseRootFromParent_Done,
     /*  13283 */   // Label 411: @13283
     /*  13283 */   GIM_Reject,
     /*  13284 */ // Label 407: @13284
     /*  13284 */ GIM_Reject,
     /*  13285 */ // Label 360: @13285
     /*  13285 */ GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(13626),
     /*  13290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  13293 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  13296 */   GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(13358), // Rule ID 23453 //
     /*  13301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*  13304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13316 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13319 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13323 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13333 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13340 */     // (mul:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPMULLWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWrm),
     /*  13343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13345 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  13347 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13351 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13356 */     GIR_RootConstrainSelectedInstOperands,
     /*  13357 */     // GIR_Coverage, 23453,
     /*  13357 */     GIR_EraseRootFromParent_Done,
     /*  13358 */   // Label 413: @13358
     /*  13358 */   GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(13420), // Rule ID 23810 //
     /*  13363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  13366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  13370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13378 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13381 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13385 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  13393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13395 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13402 */     // (mul:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPMULLWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWZ128rm),
     /*  13405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13407 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  13409 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13413 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13418 */     GIR_RootConstrainSelectedInstOperands,
     /*  13419 */     // GIR_Coverage, 23810,
     /*  13419 */     GIR_EraseRootFromParent_Done,
     /*  13420 */   // Label 414: @13420
     /*  13420 */   GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(13482), // Rule ID 2571 //
     /*  13425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*  13428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13444 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13447 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13451 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13457 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13464 */     // (mul:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWrm),
     /*  13467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13469 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  13471 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13475 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13480 */     GIR_RootConstrainSelectedInstOperands,
     /*  13481 */     // GIR_Coverage, 2571,
     /*  13481 */     GIR_EraseRootFromParent_Done,
     /*  13482 */   // Label 415: @13482
     /*  13482 */   GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(13544), // Rule ID 4999 //
     /*  13487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  13490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  13494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  13498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13506 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13509 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13513 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13519 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13526 */     // (mul:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWZ128rm),
     /*  13529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13531 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  13533 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13537 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13542 */     GIR_RootConstrainSelectedInstOperands,
     /*  13543 */     // GIR_Coverage, 4999,
     /*  13543 */     GIR_EraseRootFromParent_Done,
     /*  13544 */   // Label 416: @13544
     /*  13544 */   GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(13571), // Rule ID 2570 //
     /*  13549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*  13552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13564 */     // (mul:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMULLWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  13564 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLWrr),
     /*  13569 */     GIR_RootConstrainSelectedInstOperands,
     /*  13570 */     // GIR_Coverage, 2570,
     /*  13570 */     GIR_Done,
     /*  13571 */   // Label 417: @13571
     /*  13571 */   GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(13598), // Rule ID 2572 //
     /*  13576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  13579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13591 */     // (mul:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMULLWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  13591 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMULLWrr),
     /*  13596 */     GIR_RootConstrainSelectedInstOperands,
     /*  13597 */     // GIR_Coverage, 2572,
     /*  13597 */     GIR_Done,
     /*  13598 */   // Label 418: @13598
     /*  13598 */   GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(13625), // Rule ID 4996 //
     /*  13603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  13606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  13610 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  13614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  13618 */     // (mul:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMULLWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /*  13618 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLWZ128rr),
     /*  13623 */     GIR_RootConstrainSelectedInstOperands,
     /*  13624 */     // GIR_Coverage, 4996,
     /*  13624 */     GIR_Done,
     /*  13625 */   // Label 419: @13625
     /*  13625 */   GIM_Reject,
     /*  13626 */ // Label 412: @13626
     /*  13626 */ GIM_Reject,
     /*  13627 */ // Label 361: @13627
     /*  13627 */ GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(13941),
     /*  13632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  13635 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  13638 */   GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(13700), // Rule ID 23530 //
     /*  13643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  13646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  13650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13658 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13661 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13665 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  13673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13675 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13682 */     // (mul:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VPMULLDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDYrm),
     /*  13685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13687 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  13689 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13693 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13698 */     GIR_RootConstrainSelectedInstOperands,
     /*  13699 */     // GIR_Coverage, 23530,
     /*  13699 */     GIR_EraseRootFromParent_Done,
     /*  13700 */   // Label 421: @13700
     /*  13700 */   GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(13762), // Rule ID 23792 //
     /*  13705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  13708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13720 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13723 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13727 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13737 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13744 */     // (mul:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8i32] }:$src1)  =>  (VPMULLDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDZ256rm),
     /*  13747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13749 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  13751 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13755 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13760 */     GIR_RootConstrainSelectedInstOperands,
     /*  13761 */     // GIR_Coverage, 23792,
     /*  13761 */     GIR_EraseRootFromParent_Done,
     /*  13762 */   // Label 422: @13762
     /*  13762 */   GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(13824), // Rule ID 3244 //
     /*  13767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  13770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  13774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  13778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13786 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13789 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13793 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13799 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13806 */     // (mul:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDYrm),
     /*  13809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13811 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  13813 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13817 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13822 */     GIR_RootConstrainSelectedInstOperands,
     /*  13823 */     // GIR_Coverage, 3244,
     /*  13823 */     GIR_EraseRootFromParent_Done,
     /*  13824 */   // Label 423: @13824
     /*  13824 */   GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(13886), // Rule ID 4969 //
     /*  13829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  13832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13848 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13851 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13855 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13861 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13868 */     // (mul:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDZ256rm),
     /*  13871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13873 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  13875 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13879 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13884 */     GIR_RootConstrainSelectedInstOperands,
     /*  13885 */     // GIR_Coverage, 4969,
     /*  13885 */     GIR_EraseRootFromParent_Done,
     /*  13886 */   // Label 424: @13886
     /*  13886 */   GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(13913), // Rule ID 3243 //
     /*  13891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  13894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  13898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  13902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  13906 */     // (mul:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPMULLDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  13906 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLDYrr),
     /*  13911 */     GIR_RootConstrainSelectedInstOperands,
     /*  13912 */     // GIR_Coverage, 3243,
     /*  13912 */     GIR_Done,
     /*  13913 */   // Label 425: @13913
     /*  13913 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(13940), // Rule ID 4966 //
     /*  13918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  13921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13933 */     // (mul:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPMULLDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /*  13933 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLDZ256rr),
     /*  13938 */     GIR_RootConstrainSelectedInstOperands,
     /*  13939 */     // GIR_Coverage, 4966,
     /*  13939 */     GIR_Done,
     /*  13940 */   // Label 426: @13940
     /*  13940 */   GIM_Reject,
     /*  13941 */ // Label 420: @13941
     /*  13941 */ GIM_Reject,
     /*  13942 */ // Label 362: @13942
     /*  13942 */ GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(14097),
     /*  13947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  13950 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  13953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  13957 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(14015), // Rule ID 23813 //
     /*  13962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  13965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13973 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13976 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13980 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  13988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13990 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13997 */     // (mul:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8i64] }:$src1)  =>  (VPMULLQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLQZrm),
     /*  14000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14002 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  14004 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  14008 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  14013 */     GIR_RootConstrainSelectedInstOperands,
     /*  14014 */     // GIR_Coverage, 23813,
     /*  14014 */     GIR_EraseRootFromParent_Done,
     /*  14015 */   // Label 428: @14015
     /*  14015 */   GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(14073), // Rule ID 5005 //
     /*  14020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  14023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  14035 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  14038 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  14042 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  14046 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14048 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  14055 */     // (mul:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  14055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLQZrm),
     /*  14058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14060 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  14062 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  14066 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  14071 */     GIR_RootConstrainSelectedInstOperands,
     /*  14072 */     // GIR_Coverage, 5005,
     /*  14072 */     GIR_EraseRootFromParent_Done,
     /*  14073 */   // Label 429: @14073
     /*  14073 */   GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(14096), // Rule ID 5002 //
     /*  14078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  14081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14089 */     // (mul:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPMULLQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  14089 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLQZrr),
     /*  14094 */     GIR_RootConstrainSelectedInstOperands,
     /*  14095 */     // GIR_Coverage, 5002,
     /*  14095 */     GIR_Done,
     /*  14096 */   // Label 430: @14096
     /*  14096 */   GIM_Reject,
     /*  14097 */ // Label 427: @14097
     /*  14097 */ GIM_Reject,
     /*  14098 */ // Label 363: @14098
     /*  14098 */ GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(14412),
     /*  14103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  14106 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  14109 */   GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(14171), // Rule ID 23455 //
     /*  14114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*  14117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  14121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  14129 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  14132 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  14136 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  14140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  14144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14146 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  14153 */     // (mul:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPMULLWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  14153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWYrm),
     /*  14156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14158 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  14160 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  14164 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  14169 */     GIR_RootConstrainSelectedInstOperands,
     /*  14170 */     // GIR_Coverage, 23455,
     /*  14170 */     GIR_EraseRootFromParent_Done,
     /*  14171 */   // Label 432: @14171
     /*  14171 */   GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(14233), // Rule ID 23807 //
     /*  14176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  14179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  14183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  14191 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  14194 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  14198 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  14202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  14206 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14208 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  14215 */     // (mul:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPMULLWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  14215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWZ256rm),
     /*  14218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14220 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  14222 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  14226 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  14231 */     GIR_RootConstrainSelectedInstOperands,
     /*  14232 */     // GIR_Coverage, 23807,
     /*  14232 */     GIR_EraseRootFromParent_Done,
     /*  14233 */   // Label 433: @14233
     /*  14233 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(14295), // Rule ID 2575 //
     /*  14238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*  14241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  14245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  14249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  14257 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  14260 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  14264 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  14268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14270 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  14277 */     // (mul:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  14277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWYrm),
     /*  14280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14282 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  14284 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  14288 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  14293 */     GIR_RootConstrainSelectedInstOperands,
     /*  14294 */     // GIR_Coverage, 2575,
     /*  14294 */     GIR_EraseRootFromParent_Done,
     /*  14295 */   // Label 434: @14295
     /*  14295 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(14357), // Rule ID 4993 //
     /*  14300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  14303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  14307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  14311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  14319 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  14322 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  14326 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  14330 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14332 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  14339 */     // (mul:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  14339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWZ256rm),
     /*  14342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14344 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  14346 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  14350 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  14355 */     GIR_RootConstrainSelectedInstOperands,
     /*  14356 */     // GIR_Coverage, 4993,
     /*  14356 */     GIR_EraseRootFromParent_Done,
     /*  14357 */   // Label 435: @14357
     /*  14357 */   GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(14384), // Rule ID 2574 //
     /*  14362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*  14365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  14369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  14373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  14377 */     // (mul:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMULLWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  14377 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLWYrr),
     /*  14382 */     GIR_RootConstrainSelectedInstOperands,
     /*  14383 */     // GIR_Coverage, 2574,
     /*  14383 */     GIR_Done,
     /*  14384 */   // Label 436: @14384
     /*  14384 */   GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(14411), // Rule ID 4990 //
     /*  14389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  14392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  14396 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  14400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  14404 */     // (mul:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMULLWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /*  14404 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLWZ256rr),
     /*  14409 */     GIR_RootConstrainSelectedInstOperands,
     /*  14410 */     // GIR_Coverage, 4990,
     /*  14410 */     GIR_Done,
     /*  14411 */   // Label 437: @14411
     /*  14411 */   GIM_Reject,
     /*  14412 */ // Label 431: @14412
     /*  14412 */ GIM_Reject,
     /*  14413 */ // Label 364: @14413
     /*  14413 */ GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(14568),
     /*  14418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  14421 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  14424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14428 */   GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(14486), // Rule ID 23786 //
     /*  14433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  14436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  14444 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  14447 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  14451 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  14455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14461 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  14468 */     // (mul:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16i32] }:$src1)  =>  (VPMULLDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  14468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDZrm),
     /*  14471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14473 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  14475 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  14479 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  14484 */     GIR_RootConstrainSelectedInstOperands,
     /*  14485 */     // GIR_Coverage, 23786,
     /*  14485 */     GIR_EraseRootFromParent_Done,
     /*  14486 */   // Label 439: @14486
     /*  14486 */   GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(14544), // Rule ID 4960 //
     /*  14491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  14494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  14506 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  14509 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  14513 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  14517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14519 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  14526 */     // (mul:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  14526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDZrm),
     /*  14529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14531 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  14533 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  14537 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  14542 */     GIR_RootConstrainSelectedInstOperands,
     /*  14543 */     // GIR_Coverage, 4960,
     /*  14543 */     GIR_EraseRootFromParent_Done,
     /*  14544 */   // Label 440: @14544
     /*  14544 */   GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(14567), // Rule ID 4957 //
     /*  14549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  14552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14560 */     // (mul:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPMULLDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /*  14560 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLDZrr),
     /*  14565 */     GIR_RootConstrainSelectedInstOperands,
     /*  14566 */     // GIR_Coverage, 4957,
     /*  14566 */     GIR_Done,
     /*  14567 */   // Label 441: @14567
     /*  14567 */   GIM_Reject,
     /*  14568 */ // Label 438: @14568
     /*  14568 */ GIM_Reject,
     /*  14569 */ // Label 365: @14569
     /*  14569 */ GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(14724),
     /*  14574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  14577 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /*  14580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14584 */   GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(14642), // Rule ID 23804 //
     /*  14589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  14592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  14600 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  14603 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  14607 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  14611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14617 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  14624 */     // (mul:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPMULLWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  14624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWZrm),
     /*  14627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14629 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  14631 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  14635 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  14640 */     GIR_RootConstrainSelectedInstOperands,
     /*  14641 */     // GIR_Coverage, 23804,
     /*  14641 */     GIR_EraseRootFromParent_Done,
     /*  14642 */   // Label 443: @14642
     /*  14642 */   GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(14700), // Rule ID 4987 //
     /*  14647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  14650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  14662 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  14665 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  14669 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  14673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14675 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  14682 */     // (mul:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  14682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWZrm),
     /*  14685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14687 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  14689 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  14693 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  14698 */     GIR_RootConstrainSelectedInstOperands,
     /*  14699 */     // GIR_Coverage, 4987,
     /*  14699 */     GIR_EraseRootFromParent_Done,
     /*  14700 */   // Label 444: @14700
     /*  14700 */   GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(14723), // Rule ID 4984 //
     /*  14705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  14708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14716 */     // (mul:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMULLWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /*  14716 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLWZrr),
     /*  14721 */     GIR_RootConstrainSelectedInstOperands,
     /*  14722 */     // GIR_Coverage, 4984,
     /*  14722 */     GIR_Done,
     /*  14723 */   // Label 445: @14723
     /*  14723 */   GIM_Reject,
     /*  14724 */ // Label 442: @14724
     /*  14724 */ GIM_Reject,
     /*  14725 */ // Label 366: @14725
     /*  14725 */ GIM_Reject,
     /*  14726 */ // Label 3: @14726
     /*  14726 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(25), /*)*//*default:*//*Label 469*/ GIMT_Encode4(25317),
     /*  14737 */ /*GILLT_s1*//*Label 446*/ GIMT_Encode4(14837),
     /*  14741 */ /*GILLT_s8*//*Label 447*/ GIMT_Encode4(15183),
     /*  14745 */ /*GILLT_s16*//*Label 448*/ GIMT_Encode4(15576),
     /*  14749 */ /*GILLT_s32*//*Label 449*/ GIMT_Encode4(16261),
     /*  14753 */ /*GILLT_s64*//*Label 450*/ GIMT_Encode4(18087), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  14765 */ /*GILLT_v2s1*//*Label 451*/ GIMT_Encode4(19791),
     /*  14769 */ /*GILLT_v2s64*//*Label 452*/ GIMT_Encode4(20137),
     /*  14773 */ /*GILLT_v4s1*//*Label 453*/ GIMT_Encode4(20479),
     /*  14777 */ /*GILLT_v4s32*//*Label 454*/ GIMT_Encode4(20825),
     /*  14781 */ /*GILLT_v4s64*//*Label 455*/ GIMT_Encode4(21167),
     /*  14785 */ /*GILLT_v8s1*//*Label 456*/ GIMT_Encode4(21633),
     /*  14789 */ /*GILLT_v8s16*//*Label 457*/ GIMT_Encode4(22131),
     /*  14793 */ /*GILLT_v8s32*//*Label 458*/ GIMT_Encode4(22473),
     /*  14797 */ /*GILLT_v8s64*//*Label 459*/ GIMT_Encode4(22939),
     /*  14801 */ /*GILLT_v16s1*//*Label 460*/ GIMT_Encode4(23095),
     /*  14805 */ /*GILLT_v16s8*//*Label 461*/ GIMT_Encode4(23255),
     /*  14809 */ /*GILLT_v16s16*//*Label 462*/ GIMT_Encode4(23597),
     /*  14813 */ /*GILLT_v16s32*//*Label 463*/ GIMT_Encode4(24063),
     /*  14817 */ /*GILLT_v32s1*//*Label 464*/ GIMT_Encode4(24219),
     /*  14821 */ /*GILLT_v32s8*//*Label 465*/ GIMT_Encode4(24379),
     /*  14825 */ /*GILLT_v32s16*//*Label 466*/ GIMT_Encode4(24845),
     /*  14829 */ /*GILLT_v64s1*//*Label 467*/ GIMT_Encode4(25001),
     /*  14833 */ /*GILLT_v64s8*//*Label 468*/ GIMT_Encode4(25161),
     /*  14837 */ // Label 446: @14837
     /*  14837 */ GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(15182),
     /*  14842 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*  14845 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*  14848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  14852 */   GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(14972), // Rule ID 19488 //
     /*  14857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  14865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  14869 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  14873 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  14878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14882 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  14888 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  14890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  14894 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14896 */     // (and:{ *:[v1i1] } (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, immAllOnesV:{ *:[v1i1] }), VK1:{ *:[v1i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /*  14896 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  14899 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14903 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14908 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  14912 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  14917 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  14920 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14924 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14929 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  14933 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  14938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  14941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  14945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14950 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14953 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  14956 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14963 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  14966 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  14971 */     // GIR_Coverage, 19488,
     /*  14971 */     GIR_EraseRootFromParent_Done,
     /*  14972 */   // Label 471: @14972
     /*  14972 */   GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(15092), // Rule ID 25367 //
     /*  14977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  14981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  14989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  14993 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  14997 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  15002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15006 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  15012 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  15014 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15016 */     // (and:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src2, (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, immAllOnesV:{ *:[v1i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /*  15016 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  15019 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  15023 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15028 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  15032 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  15037 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  15040 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  15044 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15049 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  15053 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  15058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  15061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  15065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15070 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  15073 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  15076 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  15078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  15081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15083 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  15086 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  15091 */     // GIR_Coverage, 25367,
     /*  15091 */     GIR_EraseRootFromParent_Done,
     /*  15092 */   // Label 472: @15092
     /*  15092 */   GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(15181), // Rule ID 19484 //
     /*  15097 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  15101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  15105 */     // (and:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, VK1:{ *:[v1i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KANDWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /*  15105 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  15108 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  15112 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15117 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  15121 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  15126 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  15129 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  15133 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15138 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  15142 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  15147 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  15150 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDWkk),
     /*  15154 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15159 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  15162 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  15165 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  15167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  15170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15172 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  15175 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  15180 */     // GIR_Coverage, 19484,
     /*  15180 */     GIR_EraseRootFromParent_Done,
     /*  15181 */   // Label 473: @15181
     /*  15181 */   GIM_Reject,
     /*  15182 */ // Label 470: @15182
     /*  15182 */ GIM_Reject,
     /*  15183 */ // Label 447: @15183
     /*  15183 */ GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(15575),
     /*  15188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /*  15191 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /*  15194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15198 */   GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(15259), // Rule ID 26069 //
     /*  15203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  15206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  15214 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  15217 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  15221 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  15225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15231 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  15238 */     // (and:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, GR8:{ *:[i8] }:$src1)  =>  (AND8rm:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  15238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8rm),
     /*  15241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15243 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  15245 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  15249 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15252 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  15257 */     GIR_RootConstrainSelectedInstOperands,
     /*  15258 */     // GIR_Coverage, 26069,
     /*  15258 */     GIR_EraseRootFromParent_Done,
     /*  15259 */   // Label 475: @15259
     /*  15259 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(15320), // Rule ID 26088 //
     /*  15264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  15267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  15275 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  15278 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  15282 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  15286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15290 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15292 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  15299 */     // (and:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, GR8:{ *:[i8] }:$src1)  =>  (AND8rm_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  15299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8rm_ND),
     /*  15302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15304 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  15306 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  15310 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15313 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  15318 */     GIR_RootConstrainSelectedInstOperands,
     /*  15319 */     // GIR_Coverage, 26088,
     /*  15319 */     GIR_EraseRootFromParent_Done,
     /*  15320 */   // Label 476: @15320
     /*  15320 */   GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(15381), // Rule ID 22854 //
     /*  15325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  15328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  15340 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  15343 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  15347 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  15351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15353 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  15360 */     // (and:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (AND8rm:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  15360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8rm),
     /*  15363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15365 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  15367 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  15371 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15374 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  15379 */     GIR_RootConstrainSelectedInstOperands,
     /*  15380 */     // GIR_Coverage, 22854,
     /*  15380 */     GIR_EraseRootFromParent_Done,
     /*  15381 */   // Label 477: @15381
     /*  15381 */   GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(15442), // Rule ID 22944 //
     /*  15386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  15389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  15401 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  15404 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  15408 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  15412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15414 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  15421 */     // (and:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (AND8rm_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  15421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8rm_ND),
     /*  15424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15426 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  15428 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  15432 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15435 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  15440 */     GIR_RootConstrainSelectedInstOperands,
     /*  15441 */     // GIR_Coverage, 22944,
     /*  15441 */     GIR_EraseRootFromParent_Done,
     /*  15442 */   // Label 478: @15442
     /*  15442 */   GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(15479), // Rule ID 22858 //
     /*  15447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  15450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15462 */     // MIs[1] Operand 1
     /*  15462 */     // No operand predicates
     /*  15462 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15464 */     // (and:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (AND8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  15464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8ri),
     /*  15467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15469 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  15471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  15474 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15477 */     GIR_RootConstrainSelectedInstOperands,
     /*  15478 */     // GIR_Coverage, 22858,
     /*  15478 */     GIR_EraseRootFromParent_Done,
     /*  15479 */   // Label 479: @15479
     /*  15479 */   GIM_Try, /*On fail goto*//*Label 480*/ GIMT_Encode4(15516), // Rule ID 22948 //
     /*  15484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  15487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15499 */     // MIs[1] Operand 1
     /*  15499 */     // No operand predicates
     /*  15499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15501 */     // (and:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (AND8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  15501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8ri_ND),
     /*  15504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15506 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  15508 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  15511 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15514 */     GIR_RootConstrainSelectedInstOperands,
     /*  15515 */     // GIR_Coverage, 22948,
     /*  15515 */     GIR_EraseRootFromParent_Done,
     /*  15516 */   // Label 480: @15516
     /*  15516 */   GIM_Try, /*On fail goto*//*Label 481*/ GIMT_Encode4(15545), // Rule ID 22850 //
     /*  15521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  15524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15532 */     // (and:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (AND8rr:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  15532 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND8rr),
     /*  15537 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  15543 */     GIR_RootConstrainSelectedInstOperands,
     /*  15544 */     // GIR_Coverage, 22850,
     /*  15544 */     GIR_Done,
     /*  15545 */   // Label 481: @15545
     /*  15545 */   GIM_Try, /*On fail goto*//*Label 482*/ GIMT_Encode4(15574), // Rule ID 22940 //
     /*  15550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  15553 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15561 */     // (and:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (AND8rr_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  15561 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND8rr_ND),
     /*  15566 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  15572 */     GIR_RootConstrainSelectedInstOperands,
     /*  15573 */     // GIR_Coverage, 22940,
     /*  15573 */     GIR_Done,
     /*  15574 */   // Label 482: @15574
     /*  15574 */   GIM_Reject,
     /*  15575 */ // Label 474: @15575
     /*  15575 */ GIM_Reject,
     /*  15576 */ // Label 448: @15576
     /*  15576 */ GIM_Try, /*On fail goto*//*Label 483*/ GIMT_Encode4(16260),
     /*  15581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  15584 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  15587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  15591 */   GIM_Try, /*On fail goto*//*Label 484*/ GIMT_Encode4(15652), // Rule ID 26070 //
     /*  15596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  15599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  15607 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  15610 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  15614 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  15618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  15622 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15624 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  15631 */     // (and:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (AND16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  15631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16rm),
     /*  15634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15636 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  15638 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  15642 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15645 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  15650 */     GIR_RootConstrainSelectedInstOperands,
     /*  15651 */     // GIR_Coverage, 26070,
     /*  15651 */     GIR_EraseRootFromParent_Done,
     /*  15652 */   // Label 484: @15652
     /*  15652 */   GIM_Try, /*On fail goto*//*Label 485*/ GIMT_Encode4(15713), // Rule ID 26089 //
     /*  15657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  15660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  15668 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  15671 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  15675 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  15679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  15683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15685 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  15692 */     // (and:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (AND16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  15692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16rm_ND),
     /*  15695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15697 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  15699 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  15703 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15706 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  15711 */     GIR_RootConstrainSelectedInstOperands,
     /*  15712 */     // GIR_Coverage, 26089,
     /*  15712 */     GIR_EraseRootFromParent_Done,
     /*  15713 */   // Label 485: @15713
     /*  15713 */   GIM_Try, /*On fail goto*//*Label 486*/ GIMT_Encode4(15774), // Rule ID 22855 //
     /*  15718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  15721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  15725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  15733 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  15736 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  15740 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  15744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15746 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  15753 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (AND16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  15753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16rm),
     /*  15756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15758 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  15760 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  15764 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15767 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  15772 */     GIR_RootConstrainSelectedInstOperands,
     /*  15773 */     // GIR_Coverage, 22855,
     /*  15773 */     GIR_EraseRootFromParent_Done,
     /*  15774 */   // Label 486: @15774
     /*  15774 */   GIM_Try, /*On fail goto*//*Label 487*/ GIMT_Encode4(15835), // Rule ID 22945 //
     /*  15779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  15782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  15786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  15794 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  15797 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  15801 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  15805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15807 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  15814 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (AND16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  15814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16rm_ND),
     /*  15817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15819 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  15821 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  15825 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15828 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  15833 */     GIR_RootConstrainSelectedInstOperands,
     /*  15834 */     // GIR_Coverage, 22945,
     /*  15834 */     GIR_EraseRootFromParent_Done,
     /*  15835 */   // Label 487: @15835
     /*  15835 */   GIM_Try, /*On fail goto*//*Label 488*/ GIMT_Encode4(15937), // Rule ID 26036 //
     /*  15840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  15848 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  15852 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  15856 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  15860 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  15869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15871 */     // (and:{ *:[i16] } (rotl:{ *:[i16] } -2:{ *:[i16] }, GR8:{ *:[i8] }:$src2), GR16:{ *:[i16] }:$src1)  =>  (BTR16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (INSERT_SUBREG:{ *:[i16] } (IMPLICIT_DEF:{ *:[i16] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  15871 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  15874 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  15878 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  15885 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  15888 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  15892 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15897 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  15900 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  15904 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  15907 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  15912 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /*  15917 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  15922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTR16rr),
     /*  15925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15927 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  15929 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  15932 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15935 */     GIR_RootConstrainSelectedInstOperands,
     /*  15936 */     // GIR_Coverage, 26036,
     /*  15936 */     GIR_EraseRootFromParent_Done,
     /*  15937 */   // Label 488: @15937
     /*  15937 */   GIM_Try, /*On fail goto*//*Label 489*/ GIMT_Encode4(16039), // Rule ID 22774 //
     /*  15942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  15946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  15954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  15958 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  15962 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  15966 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15973 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, (rotl:{ *:[i16] } -2:{ *:[i16] }, GR8:{ *:[i8] }:$src2))  =>  (BTR16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (INSERT_SUBREG:{ *:[i16] } (IMPLICIT_DEF:{ *:[i16] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  15973 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  15976 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  15980 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  15987 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  15990 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  15994 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15999 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  16002 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  16006 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  16009 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  16014 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /*  16019 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  16024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTR16rr),
     /*  16027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16029 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  16031 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  16034 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16037 */     GIR_RootConstrainSelectedInstOperands,
     /*  16038 */     // GIR_Coverage, 22774,
     /*  16038 */     GIR_EraseRootFromParent_Done,
     /*  16039 */   // Label 489: @16039
     /*  16039 */   GIM_Try, /*On fail goto*//*Label 490*/ GIMT_Encode4(16127), // Rule ID 22634 //
     /*  16044 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  16048 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  16059 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, 255:{ *:[i16] })  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVZX32rr8:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i8] } GR16:{ *:[i16] }:$src1, sub_8bit:{ *:[i32] })), sub_16bit:{ *:[i32] })
     /*  16059 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s8,
     /*  16062 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  16066 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  16071 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src1
     /*  16077 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /*  16082 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /*  16087 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  16090 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /*  16094 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  16099 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  16102 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  16104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  16107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16109 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  16116 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  16121 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  16126 */     // GIR_Coverage, 22634,
     /*  16126 */     GIR_EraseRootFromParent_Done,
     /*  16127 */   // Label 490: @16127
     /*  16127 */   GIM_Try, /*On fail goto*//*Label 491*/ GIMT_Encode4(16164), // Rule ID 22859 //
     /*  16132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  16135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  16139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16147 */     // MIs[1] Operand 1
     /*  16147 */     // No operand predicates
     /*  16147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16149 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (AND16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  16149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16ri),
     /*  16152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16154 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  16156 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  16159 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16162 */     GIR_RootConstrainSelectedInstOperands,
     /*  16163 */     // GIR_Coverage, 22859,
     /*  16163 */     GIR_EraseRootFromParent_Done,
     /*  16164 */   // Label 491: @16164
     /*  16164 */   GIM_Try, /*On fail goto*//*Label 492*/ GIMT_Encode4(16201), // Rule ID 22949 //
     /*  16169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  16172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  16176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16184 */     // MIs[1] Operand 1
     /*  16184 */     // No operand predicates
     /*  16184 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16186 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (AND16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  16186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16ri_ND),
     /*  16189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16191 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  16193 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  16196 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16199 */     GIR_RootConstrainSelectedInstOperands,
     /*  16200 */     // GIR_Coverage, 22949,
     /*  16200 */     GIR_EraseRootFromParent_Done,
     /*  16201 */   // Label 492: @16201
     /*  16201 */   GIM_Try, /*On fail goto*//*Label 493*/ GIMT_Encode4(16230), // Rule ID 22851 //
     /*  16206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  16209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  16213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  16217 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (AND16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  16217 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND16rr),
     /*  16222 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  16228 */     GIR_RootConstrainSelectedInstOperands,
     /*  16229 */     // GIR_Coverage, 22851,
     /*  16229 */     GIR_Done,
     /*  16230 */   // Label 493: @16230
     /*  16230 */   GIM_Try, /*On fail goto*//*Label 494*/ GIMT_Encode4(16259), // Rule ID 22941 //
     /*  16235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  16238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  16242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  16246 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (AND16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  16246 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND16rr_ND),
     /*  16251 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  16257 */     GIR_RootConstrainSelectedInstOperands,
     /*  16258 */     // GIR_Coverage, 22941,
     /*  16258 */     GIR_Done,
     /*  16259 */   // Label 494: @16259
     /*  16259 */   GIM_Reject,
     /*  16260 */ // Label 483: @16260
     /*  16260 */ GIM_Reject,
     /*  16261 */ // Label 449: @16261
     /*  16261 */ GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(18086),
     /*  16266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  16269 */   GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(16361), // Rule ID 17546 //
     /*  16274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  16277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16300 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16305 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  16313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  16317 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  16320 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  16324 */     GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  16328 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16330 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  16337 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }), (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (ANDN32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  16337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rm),
     /*  16340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  16346 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  16350 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16353 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  16359 */     GIR_RootConstrainSelectedInstOperands,
     /*  16360 */     // GIR_Coverage, 17546,
     /*  16360 */     GIR_EraseRootFromParent_Done,
     /*  16361 */   // Label 496: @16361
     /*  16361 */   GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(16453), // Rule ID 17550 //
     /*  16366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  16369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16388 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16392 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16397 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  16405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  16409 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  16412 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  16416 */     GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  16420 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16422 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  16429 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }), (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (ANDN32rm_EVEX:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  16429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rm_EVEX),
     /*  16432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  16438 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  16442 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16445 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  16451 */     GIR_RootConstrainSelectedInstOperands,
     /*  16452 */     // GIR_Coverage, 17550,
     /*  16452 */     GIR_EraseRootFromParent_Done,
     /*  16453 */   // Label 497: @16453
     /*  16453 */   GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(16545), // Rule ID 25103 //
     /*  16458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  16461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  16476 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  16479 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  16483 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  16487 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  16491 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16495 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  16499 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  16503 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16508 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  16512 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16514 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  16521 */     // (and:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }))  =>  (ANDN32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  16521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rm),
     /*  16524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  16530 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  16534 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16537 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  16543 */     GIR_RootConstrainSelectedInstOperands,
     /*  16544 */     // GIR_Coverage, 25103,
     /*  16544 */     GIR_EraseRootFromParent_Done,
     /*  16545 */   // Label 498: @16545
     /*  16545 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(16637), // Rule ID 25107 //
     /*  16550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  16553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  16568 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  16571 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  16575 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  16579 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  16583 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16587 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  16591 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  16595 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16600 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  16604 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16606 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  16613 */     // (and:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }))  =>  (ANDN32rm_EVEX:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  16613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rm_EVEX),
     /*  16616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  16622 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  16626 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16629 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  16635 */     GIR_RootConstrainSelectedInstOperands,
     /*  16636 */     // GIR_Coverage, 25107,
     /*  16636 */     GIR_EraseRootFromParent_Done,
     /*  16637 */   // Label 499: @16637
     /*  16637 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(16705), // Rule ID 26071 //
     /*  16642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  16645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  16660 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  16663 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  16667 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  16671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16677 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  16684 */     // (and:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (AND32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  16684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32rm),
     /*  16687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16689 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  16691 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  16695 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16698 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  16703 */     GIR_RootConstrainSelectedInstOperands,
     /*  16704 */     // GIR_Coverage, 26071,
     /*  16704 */     GIR_EraseRootFromParent_Done,
     /*  16705 */   // Label 500: @16705
     /*  16705 */   GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(16773), // Rule ID 26090 //
     /*  16710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  16713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  16728 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  16731 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  16735 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  16739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16745 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  16752 */     // (and:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (AND32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  16752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32rm_ND),
     /*  16755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16757 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  16759 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  16763 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16766 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  16771 */     GIR_RootConstrainSelectedInstOperands,
     /*  16772 */     // GIR_Coverage, 26090,
     /*  16772 */     GIR_EraseRootFromParent_Done,
     /*  16773 */   // Label 501: @16773
     /*  16773 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(16841), // Rule ID 22856 //
     /*  16778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  16781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  16800 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  16803 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  16807 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  16811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16813 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  16820 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (AND32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  16820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32rm),
     /*  16823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16825 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  16827 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  16831 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16834 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  16839 */     GIR_RootConstrainSelectedInstOperands,
     /*  16840 */     // GIR_Coverage, 22856,
     /*  16840 */     GIR_EraseRootFromParent_Done,
     /*  16841 */   // Label 502: @16841
     /*  16841 */   GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(16909), // Rule ID 22946 //
     /*  16846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  16849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  16868 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  16871 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  16875 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  16879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16881 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  16888 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (AND32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  16888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32rm_ND),
     /*  16891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16893 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  16895 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  16899 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16902 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  16907 */     GIR_RootConstrainSelectedInstOperands,
     /*  16908 */     // GIR_Coverage, 22946,
     /*  16908 */     GIR_EraseRootFromParent_Done,
     /*  16909 */   // Label 503: @16909
     /*  16909 */   GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(16986), // Rule ID 24995 //
     /*  16914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  16917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  16932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16936 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16940 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16945 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  16949 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  16953 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16957 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  16961 */     // MIs[2] src
     /*  16961 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  16966 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  16970 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16972 */     // (and:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (BLCIC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  16972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCIC32rr),
     /*  16975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  16981 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16984 */     GIR_RootConstrainSelectedInstOperands,
     /*  16985 */     // GIR_Coverage, 24995,
     /*  16985 */     GIR_EraseRootFromParent_Done,
     /*  16986 */   // Label 504: @16986
     /*  16986 */   GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(17063), // Rule ID 25007 //
     /*  16991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  16994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  17009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17013 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17017 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17022 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  17026 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17030 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17034 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  17038 */     // MIs[2] src
     /*  17038 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  17043 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  17047 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17049 */     // (and:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (TZMSK32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  17049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TZMSK32rr),
     /*  17052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  17058 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17061 */     GIR_RootConstrainSelectedInstOperands,
     /*  17062 */     // GIR_Coverage, 25007,
     /*  17062 */     GIR_EraseRootFromParent_Done,
     /*  17063 */   // Label 505: @17063
     /*  17063 */   GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(17140), // Rule ID 17356 //
     /*  17068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  17071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17086 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17090 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17094 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17099 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  17103 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17107 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  17111 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  17115 */     // MIs[2] src
     /*  17115 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  17120 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*  17124 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17126 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }))  =>  (BLCIC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  17126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCIC32rr),
     /*  17129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  17135 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17138 */     GIR_RootConstrainSelectedInstOperands,
     /*  17139 */     // GIR_Coverage, 17356,
     /*  17139 */     GIR_EraseRootFromParent_Done,
     /*  17140 */   // Label 506: @17140
     /*  17140 */   GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(17217), // Rule ID 17368 //
     /*  17145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  17148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17167 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17171 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17176 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  17180 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17184 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  17188 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  17192 */     // MIs[2] src
     /*  17192 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  17197 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  17201 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17203 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (TZMSK32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  17203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TZMSK32rr),
     /*  17206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  17212 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17215 */     GIR_RootConstrainSelectedInstOperands,
     /*  17216 */     // GIR_Coverage, 17368,
     /*  17216 */     GIR_EraseRootFromParent_Done,
     /*  17217 */   // Label 507: @17217
     /*  17217 */   GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(17275), // Rule ID 24989 //
     /*  17222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  17225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  17237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17241 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17245 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17250 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  17254 */     // MIs[0] src
     /*  17254 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  17259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17261 */     // (and:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), GR32:{ *:[i32] }:$src)  =>  (BLCFILL32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  17261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCFILL32rr),
     /*  17264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  17270 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17273 */     GIR_RootConstrainSelectedInstOperands,
     /*  17274 */     // GIR_Coverage, 24989,
     /*  17274 */     GIR_EraseRootFromParent_Done,
     /*  17275 */   // Label 508: @17275
     /*  17275 */   GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(17384), // Rule ID 26042 //
     /*  17280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  17295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17299 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  17303 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  17307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  17312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17316 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17318 */     // (and:{ *:[i32] } (rotl:{ *:[i32] } -2:{ *:[i32] }, GR8:{ *:[i8] }:$src2), GR32:{ *:[i32] }:$src1)  =>  (BTR32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  17318 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  17321 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  17325 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17330 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  17332 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  17335 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  17339 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17344 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  17347 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  17351 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  17354 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  17359 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  17364 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  17369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTR32rr),
     /*  17372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17374 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  17376 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17379 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17382 */     GIR_RootConstrainSelectedInstOperands,
     /*  17383 */     // GIR_Coverage, 26042,
     /*  17383 */     GIR_EraseRootFromParent_Done,
     /*  17384 */   // Label 509: @17384
     /*  17384 */   GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(17438), // Rule ID 17350 //
     /*  17389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  17392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17399 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  17411 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17415 */     // MIs[1] src
     /*  17415 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  17420 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  17424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17426 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src, (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }))  =>  (BLCFILL32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  17426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCFILL32rr),
     /*  17429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17431 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  17433 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17436 */     GIR_RootConstrainSelectedInstOperands,
     /*  17437 */     // GIR_Coverage, 17350,
     /*  17437 */     GIR_EraseRootFromParent_Done,
     /*  17438 */   // Label 510: @17438
     /*  17438 */   GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(17547), // Rule ID 22780 //
     /*  17443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  17462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17466 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  17470 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  17474 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  17479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17481 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, (rotl:{ *:[i32] } -2:{ *:[i32] }, GR8:{ *:[i8] }:$src2))  =>  (BTR32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  17481 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  17484 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  17488 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17493 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  17495 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  17498 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  17502 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17507 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  17510 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  17514 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  17517 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  17522 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  17527 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  17532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTR32rr),
     /*  17535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17537 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  17539 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17542 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17545 */     GIR_RootConstrainSelectedInstOperands,
     /*  17546 */     // GIR_Coverage, 22780,
     /*  17546 */     GIR_EraseRootFromParent_Done,
     /*  17547 */   // Label 511: @17547
     /*  17547 */   GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(17612), // Rule ID 22632 //
     /*  17552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17563 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  17574 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, 65535:{ *:[i32] })  =>  (MOVZX32rr16:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i16] } GR32:{ *:[i32] }:$src1, sub_16bit:{ *:[i32] }))
     /*  17574 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  17577 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17581 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17586 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(4), // src1
     /*  17592 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  17597 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  17602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr16),
     /*  17605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17607 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17610 */     GIR_RootConstrainSelectedInstOperands,
     /*  17611 */     // GIR_Coverage, 22632,
     /*  17611 */     GIR_EraseRootFromParent_Done,
     /*  17612 */   // Label 512: @17612
     /*  17612 */   GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(17677), // Rule ID 22633 //
     /*  17617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17628 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  17639 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, 255:{ *:[i32] })  =>  (MOVZX32rr8:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i8] } GR32:{ *:[i32] }:$src1, sub_8bit:{ *:[i32] }))
     /*  17639 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /*  17642 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17646 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17651 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src1
     /*  17657 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /*  17662 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  17667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /*  17670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17672 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17675 */     GIR_RootConstrainSelectedInstOperands,
     /*  17676 */     // GIR_Coverage, 22633,
     /*  17676 */     GIR_EraseRootFromParent_Done,
     /*  17677 */   // Label 513: @17677
     /*  17677 */   GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(17721), // Rule ID 22860 //
     /*  17682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  17685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17704 */     // MIs[1] Operand 1
     /*  17704 */     // No operand predicates
     /*  17704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17706 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (AND32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  17706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32ri),
     /*  17709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17711 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  17713 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  17716 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17719 */     GIR_RootConstrainSelectedInstOperands,
     /*  17720 */     // GIR_Coverage, 22860,
     /*  17720 */     GIR_EraseRootFromParent_Done,
     /*  17721 */   // Label 514: @17721
     /*  17721 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(17765), // Rule ID 22950 //
     /*  17726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  17729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17748 */     // MIs[1] Operand 1
     /*  17748 */     // No operand predicates
     /*  17748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17750 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (AND32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  17750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32ri_ND),
     /*  17753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17755 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  17757 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  17760 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17763 */     GIR_RootConstrainSelectedInstOperands,
     /*  17764 */     // GIR_Coverage, 22950,
     /*  17764 */     GIR_EraseRootFromParent_Done,
     /*  17765 */   // Label 515: @17765
     /*  17765 */   GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(17827), // Rule ID 17544 //
     /*  17770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  17773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17792 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17796 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17801 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  17805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17811 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }), GR32:{ *:[i32] }:$src2)  =>  (ANDN32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  17811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rr),
     /*  17814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  17820 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  17822 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17825 */     GIR_RootConstrainSelectedInstOperands,
     /*  17826 */     // GIR_Coverage, 17544,
     /*  17826 */     GIR_EraseRootFromParent_Done,
     /*  17827 */   // Label 516: @17827
     /*  17827 */   GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(17889), // Rule ID 17548 //
     /*  17832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  17835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17854 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17858 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17863 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  17867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17873 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }), GR32:{ *:[i32] }:$src2)  =>  (ANDN32rr_EVEX:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  17873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rr_EVEX),
     /*  17876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  17882 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  17884 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17887 */     GIR_RootConstrainSelectedInstOperands,
     /*  17888 */     // GIR_Coverage, 17548,
     /*  17888 */     GIR_EraseRootFromParent_Done,
     /*  17889 */   // Label 517: @17889
     /*  17889 */   GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(17951), // Rule ID 25101 //
     /*  17894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  17897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17904 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17920 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17924 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17929 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  17933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17935 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src2, (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }))  =>  (ANDN32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  17935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rr),
     /*  17938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  17944 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  17946 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17949 */     GIR_RootConstrainSelectedInstOperands,
     /*  17950 */     // GIR_Coverage, 25101,
     /*  17950 */     GIR_EraseRootFromParent_Done,
     /*  17951 */   // Label 518: @17951
     /*  17951 */   GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(18013), // Rule ID 25105 //
     /*  17956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  17959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17966 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17982 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17986 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17991 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  17995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17997 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src2, (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }))  =>  (ANDN32rr_EVEX:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  17997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rr_EVEX),
     /*  18000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  18006 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  18008 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18011 */     GIR_RootConstrainSelectedInstOperands,
     /*  18012 */     // GIR_Coverage, 25105,
     /*  18012 */     GIR_EraseRootFromParent_Done,
     /*  18013 */   // Label 519: @18013
     /*  18013 */   GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(18049), // Rule ID 22852 //
     /*  18018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  18021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  18024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  18028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  18032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  18036 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (AND32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  18036 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND32rr),
     /*  18041 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  18047 */     GIR_RootConstrainSelectedInstOperands,
     /*  18048 */     // GIR_Coverage, 22852,
     /*  18048 */     GIR_Done,
     /*  18049 */   // Label 520: @18049
     /*  18049 */   GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(18085), // Rule ID 22942 //
     /*  18054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  18057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  18060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  18064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  18068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  18072 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (AND32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  18072 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND32rr_ND),
     /*  18077 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  18083 */     GIR_RootConstrainSelectedInstOperands,
     /*  18084 */     // GIR_Coverage, 22942,
     /*  18084 */     GIR_Done,
     /*  18085 */   // Label 521: @18085
     /*  18085 */   GIM_Reject,
     /*  18086 */ // Label 495: @18086
     /*  18086 */ GIM_Reject,
     /*  18087 */ // Label 450: @18087
     /*  18087 */ GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(19790),
     /*  18092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  18095 */   GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(18187), // Rule ID 17547 //
     /*  18100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  18103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  18122 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  18126 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18131 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  18135 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18139 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  18143 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  18146 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  18150 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  18154 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18156 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  18163 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }), (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ANDN64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  18163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rm),
     /*  18166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  18172 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  18176 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18179 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  18185 */     GIR_RootConstrainSelectedInstOperands,
     /*  18186 */     // GIR_Coverage, 17547,
     /*  18186 */     GIR_EraseRootFromParent_Done,
     /*  18187 */   // Label 523: @18187
     /*  18187 */   GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(18279), // Rule ID 17551 //
     /*  18192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  18195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  18214 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  18218 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18223 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  18227 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18231 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  18235 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  18238 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  18242 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  18246 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18248 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  18255 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }), (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ANDN64rm_EVEX:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  18255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rm_EVEX),
     /*  18258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  18264 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  18268 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18271 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  18277 */     GIR_RootConstrainSelectedInstOperands,
     /*  18278 */     // GIR_Coverage, 17551,
     /*  18278 */     GIR_EraseRootFromParent_Done,
     /*  18279 */   // Label 524: @18279
     /*  18279 */   GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(18371), // Rule ID 25104 //
     /*  18284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  18287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  18302 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  18305 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  18309 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  18313 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18317 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18321 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  18325 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18329 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18334 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  18338 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18340 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  18347 */     // (and:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }))  =>  (ANDN64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  18347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rm),
     /*  18350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  18356 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  18360 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18363 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  18369 */     GIR_RootConstrainSelectedInstOperands,
     /*  18370 */     // GIR_Coverage, 25104,
     /*  18370 */     GIR_EraseRootFromParent_Done,
     /*  18371 */   // Label 525: @18371
     /*  18371 */   GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(18463), // Rule ID 25108 //
     /*  18376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  18379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  18394 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  18397 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  18401 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  18405 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18409 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18413 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  18417 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18421 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18426 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  18430 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18432 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  18439 */     // (and:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }))  =>  (ANDN64rm_EVEX:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  18439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rm_EVEX),
     /*  18442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  18448 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  18452 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18455 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  18461 */     GIR_RootConstrainSelectedInstOperands,
     /*  18462 */     // GIR_Coverage, 25108,
     /*  18462 */     GIR_EraseRootFromParent_Done,
     /*  18463 */   // Label 526: @18463
     /*  18463 */   GIM_Try, /*On fail goto*//*Label 527*/ GIMT_Encode4(18531), // Rule ID 26072 //
     /*  18468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  18471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  18486 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  18489 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  18493 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  18497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18503 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  18510 */     // (and:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (AND64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  18510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64rm),
     /*  18513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18515 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  18517 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  18521 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18524 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  18529 */     GIR_RootConstrainSelectedInstOperands,
     /*  18530 */     // GIR_Coverage, 26072,
     /*  18530 */     GIR_EraseRootFromParent_Done,
     /*  18531 */   // Label 527: @18531
     /*  18531 */   GIM_Try, /*On fail goto*//*Label 528*/ GIMT_Encode4(18599), // Rule ID 26091 //
     /*  18536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  18539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  18554 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  18557 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  18561 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  18565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18571 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  18578 */     // (and:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (AND64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  18578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64rm_ND),
     /*  18581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18583 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  18585 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  18589 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18592 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  18597 */     GIR_RootConstrainSelectedInstOperands,
     /*  18598 */     // GIR_Coverage, 26091,
     /*  18598 */     GIR_EraseRootFromParent_Done,
     /*  18599 */   // Label 528: @18599
     /*  18599 */   GIM_Try, /*On fail goto*//*Label 529*/ GIMT_Encode4(18667), // Rule ID 22857 //
     /*  18604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  18607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18614 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  18626 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  18629 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  18633 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  18637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18639 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  18646 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (AND64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  18646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64rm),
     /*  18649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18651 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  18653 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  18657 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18660 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  18665 */     GIR_RootConstrainSelectedInstOperands,
     /*  18666 */     // GIR_Coverage, 22857,
     /*  18666 */     GIR_EraseRootFromParent_Done,
     /*  18667 */   // Label 529: @18667
     /*  18667 */   GIM_Try, /*On fail goto*//*Label 530*/ GIMT_Encode4(18735), // Rule ID 22947 //
     /*  18672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  18675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18682 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  18694 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  18697 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  18701 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  18705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18707 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  18714 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (AND64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  18714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64rm_ND),
     /*  18717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18719 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  18721 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  18725 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18728 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  18733 */     GIR_RootConstrainSelectedInstOperands,
     /*  18734 */     // GIR_Coverage, 22947,
     /*  18734 */     GIR_EraseRootFromParent_Done,
     /*  18735 */   // Label 530: @18735
     /*  18735 */   GIM_Try, /*On fail goto*//*Label 531*/ GIMT_Encode4(18812), // Rule ID 24996 //
     /*  18740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  18743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  18758 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  18762 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  18766 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18771 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  18775 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18779 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18783 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18787 */     // MIs[2] src
     /*  18787 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18792 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  18796 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18798 */     // (and:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (BLCIC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  18798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCIC64rr),
     /*  18801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  18807 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18810 */     GIR_RootConstrainSelectedInstOperands,
     /*  18811 */     // GIR_Coverage, 24996,
     /*  18811 */     GIR_EraseRootFromParent_Done,
     /*  18812 */   // Label 531: @18812
     /*  18812 */   GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(18889), // Rule ID 25008 //
     /*  18817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  18820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  18835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  18839 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  18843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18848 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  18852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18860 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18864 */     // MIs[2] src
     /*  18864 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18869 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  18873 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18875 */     // (and:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (TZMSK64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  18875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TZMSK64rr),
     /*  18878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  18884 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18887 */     GIR_RootConstrainSelectedInstOperands,
     /*  18888 */     // GIR_Coverage, 25008,
     /*  18888 */     GIR_EraseRootFromParent_Done,
     /*  18889 */   // Label 532: @18889
     /*  18889 */   GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(18966), // Rule ID 17357 //
     /*  18894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  18897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  18916 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  18920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18925 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  18929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  18937 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18941 */     // MIs[2] src
     /*  18941 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18946 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*  18950 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18952 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }))  =>  (BLCIC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  18952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCIC64rr),
     /*  18955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  18961 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18964 */     GIR_RootConstrainSelectedInstOperands,
     /*  18965 */     // GIR_Coverage, 17357,
     /*  18965 */     GIR_EraseRootFromParent_Done,
     /*  18966 */   // Label 533: @18966
     /*  18966 */   GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(19043), // Rule ID 17369 //
     /*  18971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  18974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  18993 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  18997 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19002 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  19006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  19010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  19014 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  19018 */     // MIs[2] src
     /*  19018 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  19023 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  19027 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19029 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (TZMSK64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  19029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TZMSK64rr),
     /*  19032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  19038 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19041 */     GIR_RootConstrainSelectedInstOperands,
     /*  19042 */     // GIR_Coverage, 17369,
     /*  19042 */     GIR_EraseRootFromParent_Done,
     /*  19043 */   // Label 534: @19043
     /*  19043 */   GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(19101), // Rule ID 24990 //
     /*  19048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  19051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  19063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  19067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  19071 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19076 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  19080 */     // MIs[0] src
     /*  19080 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  19085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19087 */     // (and:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), GR64:{ *:[i64] }:$src)  =>  (BLCFILL64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  19087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCFILL64rr),
     /*  19090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  19096 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19099 */     GIR_RootConstrainSelectedInstOperands,
     /*  19100 */     // GIR_Coverage, 24990,
     /*  19100 */     GIR_EraseRootFromParent_Done,
     /*  19101 */   // Label 535: @19101
     /*  19101 */   GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(19210), // Rule ID 26048 //
     /*  19106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  19121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  19125 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  19129 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  19133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  19138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19144 */     // (and:{ *:[i64] } (rotl:{ *:[i64] } -2:{ *:[i64] }, GR8:{ *:[i8] }:$src2), GR64:{ *:[i64] }:$src1)  =>  (BTR64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  19144 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  19147 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  19151 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19156 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  19158 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  19161 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  19165 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19170 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  19173 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  19177 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  19180 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  19185 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  19190 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  19195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTR64rr),
     /*  19198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19200 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  19202 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  19205 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19208 */     GIR_RootConstrainSelectedInstOperands,
     /*  19209 */     // GIR_Coverage, 26048,
     /*  19209 */     GIR_EraseRootFromParent_Done,
     /*  19210 */   // Label 536: @19210
     /*  19210 */   GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(19264), // Rule ID 17351 //
     /*  19215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  19218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  19237 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  19241 */     // MIs[1] src
     /*  19241 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  19246 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  19250 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19252 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src, (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }))  =>  (BLCFILL64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  19252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCFILL64rr),
     /*  19255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19257 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  19259 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19262 */     GIR_RootConstrainSelectedInstOperands,
     /*  19263 */     // GIR_Coverage, 17351,
     /*  19263 */     GIR_EraseRootFromParent_Done,
     /*  19264 */   // Label 537: @19264
     /*  19264 */   GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(19373), // Rule ID 22786 //
     /*  19269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  19288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  19292 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  19296 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  19300 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  19305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19307 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src1, (rotl:{ *:[i64] } -2:{ *:[i64] }, GR8:{ *:[i8] }:$src2))  =>  (BTR64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  19307 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  19310 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  19314 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19319 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  19321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  19324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  19328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19333 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  19336 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  19340 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  19343 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  19348 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  19353 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  19358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTR64rr),
     /*  19361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19363 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  19365 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  19368 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19371 */     GIR_RootConstrainSelectedInstOperands,
     /*  19372 */     // GIR_Coverage, 22786,
     /*  19372 */     GIR_EraseRootFromParent_Done,
     /*  19373 */   // Label 538: @19373
     /*  19373 */   GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(19421), // Rule ID 22861 //
     /*  19378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  19381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19388 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19400 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  19404 */     // MIs[1] Operand 1
     /*  19404 */     // No operand predicates
     /*  19404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19406 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (AND64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  19406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64ri32),
     /*  19409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19411 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  19413 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  19416 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19419 */     GIR_RootConstrainSelectedInstOperands,
     /*  19420 */     // GIR_Coverage, 22861,
     /*  19420 */     GIR_EraseRootFromParent_Done,
     /*  19421 */   // Label 539: @19421
     /*  19421 */   GIM_Try, /*On fail goto*//*Label 540*/ GIMT_Encode4(19469), // Rule ID 22951 //
     /*  19426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  19429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19448 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  19452 */     // MIs[1] Operand 1
     /*  19452 */     // No operand predicates
     /*  19452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19454 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (AND64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  19454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64ri32_ND),
     /*  19457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19459 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  19461 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  19464 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19467 */     GIR_RootConstrainSelectedInstOperands,
     /*  19468 */     // GIR_Coverage, 22951,
     /*  19468 */     GIR_EraseRootFromParent_Done,
     /*  19469 */   // Label 540: @19469
     /*  19469 */   GIM_Try, /*On fail goto*//*Label 541*/ GIMT_Encode4(19531), // Rule ID 17545 //
     /*  19474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  19477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  19496 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  19500 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19505 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  19509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19515 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }), GR64:{ *:[i64] }:$src2)  =>  (ANDN64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  19515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rr),
     /*  19518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19520 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  19524 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  19526 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19529 */     GIR_RootConstrainSelectedInstOperands,
     /*  19530 */     // GIR_Coverage, 17545,
     /*  19530 */     GIR_EraseRootFromParent_Done,
     /*  19531 */   // Label 541: @19531
     /*  19531 */   GIM_Try, /*On fail goto*//*Label 542*/ GIMT_Encode4(19593), // Rule ID 17549 //
     /*  19536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  19539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  19558 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  19562 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19567 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  19571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19577 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }), GR64:{ *:[i64] }:$src2)  =>  (ANDN64rr_EVEX:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  19577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rr_EVEX),
     /*  19580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  19586 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  19588 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19591 */     GIR_RootConstrainSelectedInstOperands,
     /*  19592 */     // GIR_Coverage, 17549,
     /*  19592 */     GIR_EraseRootFromParent_Done,
     /*  19593 */   // Label 542: @19593
     /*  19593 */   GIM_Try, /*On fail goto*//*Label 543*/ GIMT_Encode4(19655), // Rule ID 25102 //
     /*  19598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  19601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  19624 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  19628 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19633 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  19637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19639 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src2, (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }))  =>  (ANDN64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  19639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rr),
     /*  19642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  19648 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  19650 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19653 */     GIR_RootConstrainSelectedInstOperands,
     /*  19654 */     // GIR_Coverage, 25102,
     /*  19654 */     GIR_EraseRootFromParent_Done,
     /*  19655 */   // Label 543: @19655
     /*  19655 */   GIM_Try, /*On fail goto*//*Label 544*/ GIMT_Encode4(19717), // Rule ID 25106 //
     /*  19660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  19663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  19686 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  19690 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19695 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  19699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19701 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src2, (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }))  =>  (ANDN64rr_EVEX:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  19701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rr_EVEX),
     /*  19704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  19710 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  19712 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19715 */     GIR_RootConstrainSelectedInstOperands,
     /*  19716 */     // GIR_Coverage, 25106,
     /*  19716 */     GIR_EraseRootFromParent_Done,
     /*  19717 */   // Label 544: @19717
     /*  19717 */   GIM_Try, /*On fail goto*//*Label 545*/ GIMT_Encode4(19753), // Rule ID 22853 //
     /*  19722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  19725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19740 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (AND64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  19740 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND64rr),
     /*  19745 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  19751 */     GIR_RootConstrainSelectedInstOperands,
     /*  19752 */     // GIR_Coverage, 22853,
     /*  19752 */     GIR_Done,
     /*  19753 */   // Label 545: @19753
     /*  19753 */   GIM_Try, /*On fail goto*//*Label 546*/ GIMT_Encode4(19789), // Rule ID 22943 //
     /*  19758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  19761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19768 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19776 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (AND64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  19776 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND64rr_ND),
     /*  19781 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  19787 */     GIR_RootConstrainSelectedInstOperands,
     /*  19788 */     // GIR_Coverage, 22943,
     /*  19788 */     GIR_Done,
     /*  19789 */   // Label 546: @19789
     /*  19789 */   GIM_Reject,
     /*  19790 */ // Label 522: @19790
     /*  19790 */ GIM_Reject,
     /*  19791 */ // Label 451: @19791
     /*  19791 */ GIM_Try, /*On fail goto*//*Label 547*/ GIMT_Encode4(20136),
     /*  19796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  19799 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  19802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  19806 */   GIM_Try, /*On fail goto*//*Label 548*/ GIMT_Encode4(19926), // Rule ID 19489 //
     /*  19811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  19823 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  19827 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  19832 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19836 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  19842 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  19844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  19848 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19850 */     // (and:{ *:[v2i1] } (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, immAllOnesV:{ *:[v2i1] }), VK2:{ *:[v2i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  19850 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  19853 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19857 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19862 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  19866 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  19871 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  19874 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19878 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19883 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  19887 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  19892 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  19895 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  19899 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19904 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  19907 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  19910 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  19912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19917 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  19920 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  19925 */     // GIR_Coverage, 19489,
     /*  19925 */     GIR_EraseRootFromParent_Done,
     /*  19926 */   // Label 548: @19926
     /*  19926 */   GIM_Try, /*On fail goto*//*Label 549*/ GIMT_Encode4(20046), // Rule ID 25368 //
     /*  19931 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  19935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  19947 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  19951 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  19956 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19960 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  19966 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  19968 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19970 */     // (and:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src2, (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, immAllOnesV:{ *:[v2i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  19970 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  19973 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19977 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19982 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  19986 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  19991 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  19994 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19998 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20003 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  20007 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  20012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  20015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  20019 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20024 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  20027 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  20030 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  20032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20037 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  20040 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  20045 */     // GIR_Coverage, 25368,
     /*  20045 */     GIR_EraseRootFromParent_Done,
     /*  20046 */   // Label 549: @20046
     /*  20046 */   GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(20135), // Rule ID 19485 //
     /*  20051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  20055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  20059 */     // (and:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, VK2:{ *:[v2i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KANDWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  20059 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  20062 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20066 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20071 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  20075 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  20080 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  20083 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20087 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20092 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  20096 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  20101 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  20104 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDWkk),
     /*  20108 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20113 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  20116 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  20119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  20121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  20129 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  20134 */     // GIR_Coverage, 19485,
     /*  20134 */     GIR_EraseRootFromParent_Done,
     /*  20135 */   // Label 550: @20135
     /*  20135 */   GIM_Reject,
     /*  20136 */ // Label 547: @20136
     /*  20136 */ GIM_Reject,
     /*  20137 */ // Label 452: @20137
     /*  20137 */ GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(20478),
     /*  20142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  20145 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  20148 */   GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(20210), // Rule ID 23360 //
     /*  20153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  20156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  20168 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  20171 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  20175 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  20179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20185 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  20192 */     // (and:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2i64] }:$src1)  =>  (VPANDrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  20192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDrm),
     /*  20195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20197 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  20199 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  20203 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  20208 */     GIR_RootConstrainSelectedInstOperands,
     /*  20209 */     // GIR_Coverage, 23360,
     /*  20209 */     GIR_EraseRootFromParent_Done,
     /*  20210 */   // Label 552: @20210
     /*  20210 */   GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(20272), // Rule ID 24149 //
     /*  20215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  20218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  20230 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  20233 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  20237 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  20241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20247 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  20254 */     // (and:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2i64] }:$src1)  =>  (VPANDQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  20254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rm),
     /*  20257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20259 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  20261 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  20265 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  20270 */     GIR_RootConstrainSelectedInstOperands,
     /*  20271 */     // GIR_Coverage, 24149,
     /*  20271 */     GIR_EraseRootFromParent_Done,
     /*  20272 */   // Label 553: @20272
     /*  20272 */   GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(20334), // Rule ID 2111 //
     /*  20277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  20280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  20296 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  20299 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  20303 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  20307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20309 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  20316 */     // (and:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  20316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDrm),
     /*  20319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20321 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  20323 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  20327 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  20332 */     GIR_RootConstrainSelectedInstOperands,
     /*  20333 */     // GIR_Coverage, 2111,
     /*  20333 */     GIR_EraseRootFromParent_Done,
     /*  20334 */   // Label 554: @20334
     /*  20334 */   GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(20396), // Rule ID 5707 //
     /*  20339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  20342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  20358 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  20361 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  20365 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  20369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20371 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  20378 */     // (and:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  20378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rm),
     /*  20381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20383 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  20385 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  20389 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  20394 */     GIR_RootConstrainSelectedInstOperands,
     /*  20395 */     // GIR_Coverage, 5707,
     /*  20395 */     GIR_EraseRootFromParent_Done,
     /*  20396 */   // Label 555: @20396
     /*  20396 */   GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(20423), // Rule ID 2110 //
     /*  20401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  20404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20416 */     // (and:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VPANDrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  20416 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDrr),
     /*  20421 */     GIR_RootConstrainSelectedInstOperands,
     /*  20422 */     // GIR_Coverage, 2110,
     /*  20422 */     GIR_Done,
     /*  20423 */   // Label 556: @20423
     /*  20423 */   GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(20450), // Rule ID 2112 //
     /*  20428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  20431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20443 */     // (and:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (PANDrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  20443 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PANDrr),
     /*  20448 */     GIR_RootConstrainSelectedInstOperands,
     /*  20449 */     // GIR_Coverage, 2112,
     /*  20449 */     GIR_Done,
     /*  20450 */   // Label 557: @20450
     /*  20450 */   GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(20477), // Rule ID 5704 //
     /*  20455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  20458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20470 */     // (and:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPANDQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*  20470 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rr),
     /*  20475 */     GIR_RootConstrainSelectedInstOperands,
     /*  20476 */     // GIR_Coverage, 5704,
     /*  20476 */     GIR_Done,
     /*  20477 */   // Label 558: @20477
     /*  20477 */   GIM_Reject,
     /*  20478 */ // Label 551: @20478
     /*  20478 */ GIM_Reject,
     /*  20479 */ // Label 453: @20479
     /*  20479 */ GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(20824),
     /*  20484 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  20487 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  20490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  20494 */   GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(20614), // Rule ID 19490 //
     /*  20499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  20507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  20511 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  20515 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  20520 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20524 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  20530 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  20532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  20536 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20538 */     // (and:{ *:[v4i1] } (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, immAllOnesV:{ *:[v4i1] }), VK4:{ *:[v4i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /*  20538 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  20541 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20545 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20550 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  20554 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  20559 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  20562 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20566 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20571 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  20575 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  20580 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  20583 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  20587 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20592 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  20595 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  20598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  20600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  20608 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  20613 */     // GIR_Coverage, 19490,
     /*  20613 */     GIR_EraseRootFromParent_Done,
     /*  20614 */   // Label 560: @20614
     /*  20614 */   GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(20734), // Rule ID 25369 //
     /*  20619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  20623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  20631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  20635 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  20639 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  20644 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20648 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  20654 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  20656 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20658 */     // (and:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src2, (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, immAllOnesV:{ *:[v4i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /*  20658 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  20661 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20665 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20670 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  20674 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  20679 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  20682 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20686 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20691 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  20695 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  20700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  20703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  20707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20712 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  20715 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  20718 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  20720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20725 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  20728 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  20733 */     // GIR_Coverage, 25369,
     /*  20733 */     GIR_EraseRootFromParent_Done,
     /*  20734 */   // Label 561: @20734
     /*  20734 */   GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(20823), // Rule ID 19486 //
     /*  20739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  20743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  20747 */     // (and:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, VK4:{ *:[v4i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KANDWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /*  20747 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  20750 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20754 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20759 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  20763 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  20768 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  20771 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20775 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20780 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  20784 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  20789 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  20792 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDWkk),
     /*  20796 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20801 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  20804 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  20807 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  20809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20814 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  20817 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  20822 */     // GIR_Coverage, 19486,
     /*  20822 */     GIR_EraseRootFromParent_Done,
     /*  20823 */   // Label 562: @20823
     /*  20823 */   GIM_Reject,
     /*  20824 */ // Label 559: @20824
     /*  20824 */ GIM_Reject,
     /*  20825 */ // Label 454: @20825
     /*  20825 */ GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(21166),
     /*  20830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20833 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20836 */   GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(20898), // Rule ID 24167 //
     /*  20841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  20844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  20856 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  20859 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  20863 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  20867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20873 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  20880 */     // (and:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4i32] }:$src1)  =>  (VPANDDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  20880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDDZ128rm),
     /*  20883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20885 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  20887 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  20891 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  20896 */     GIR_RootConstrainSelectedInstOperands,
     /*  20897 */     // GIR_Coverage, 24167,
     /*  20897 */     GIR_EraseRootFromParent_Done,
     /*  20898 */   // Label 564: @20898
     /*  20898 */   GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(20960), // Rule ID 25253 //
     /*  20903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  20906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  20918 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  20921 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  20925 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  20929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20935 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  20942 */     // (and:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1)  =>  (VPANDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  20942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDrm),
     /*  20945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20947 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  20949 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  20953 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  20958 */     GIR_RootConstrainSelectedInstOperands,
     /*  20959 */     // GIR_Coverage, 25253,
     /*  20959 */     GIR_EraseRootFromParent_Done,
     /*  20960 */   // Label 565: @20960
     /*  20960 */   GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(21022), // Rule ID 5734 //
     /*  20965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  20968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  20984 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  20987 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  20991 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  20995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20997 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  21004 */     // (and:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  21004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDDZ128rm),
     /*  21007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21009 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  21011 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  21015 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  21020 */     GIR_RootConstrainSelectedInstOperands,
     /*  21021 */     // GIR_Coverage, 5734,
     /*  21021 */     GIR_EraseRootFromParent_Done,
     /*  21022 */   // Label 566: @21022
     /*  21022 */   GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(21084), // Rule ID 18160 //
     /*  21027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  21030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  21034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  21038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  21046 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  21049 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  21053 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  21057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21059 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  21066 */     // (and:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  21066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDrm),
     /*  21069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21071 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  21073 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  21077 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  21082 */     GIR_RootConstrainSelectedInstOperands,
     /*  21083 */     // GIR_Coverage, 18160,
     /*  21083 */     GIR_EraseRootFromParent_Done,
     /*  21084 */   // Label 567: @21084
     /*  21084 */   GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(21111), // Rule ID 5731 //
     /*  21089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  21092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  21096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  21100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  21104 */     // (and:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPANDDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /*  21104 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDDZ128rr),
     /*  21109 */     GIR_RootConstrainSelectedInstOperands,
     /*  21110 */     // GIR_Coverage, 5731,
     /*  21110 */     GIR_Done,
     /*  21111 */   // Label 568: @21111
     /*  21111 */   GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(21138), // Rule ID 18148 //
     /*  21116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  21119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  21123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  21127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  21131 */     // (and:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPANDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  21131 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDrr),
     /*  21136 */     GIR_RootConstrainSelectedInstOperands,
     /*  21137 */     // GIR_Coverage, 18148,
     /*  21137 */     GIR_Done,
     /*  21138 */   // Label 569: @21138
     /*  21138 */   GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(21165), // Rule ID 18172 //
     /*  21143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  21146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  21150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  21154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  21158 */     // (and:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PANDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  21158 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PANDrr),
     /*  21163 */     GIR_RootConstrainSelectedInstOperands,
     /*  21164 */     // GIR_Coverage, 18172,
     /*  21164 */     GIR_Done,
     /*  21165 */   // Label 570: @21165
     /*  21165 */   GIM_Reject,
     /*  21166 */ // Label 563: @21166
     /*  21166 */ GIM_Reject,
     /*  21167 */ // Label 455: @21167
     /*  21167 */ GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(21632),
     /*  21172 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  21175 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  21178 */   GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(21240), // Rule ID 23362 //
     /*  21183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  21186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  21198 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  21201 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  21205 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  21209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21215 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  21222 */     // (and:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4i64] }:$src1)  =>  (VPANDYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  21222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDYrm),
     /*  21225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21227 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  21229 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  21233 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  21238 */     GIR_RootConstrainSelectedInstOperands,
     /*  21239 */     // GIR_Coverage, 23362,
     /*  21239 */     GIR_EraseRootFromParent_Done,
     /*  21240 */   // Label 572: @21240
     /*  21240 */   GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(21302), // Rule ID 24143 //
     /*  21245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  21248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  21252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  21260 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  21263 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  21267 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  21271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  21275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21277 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  21284 */     // (and:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4i64] }:$src1)  =>  (VPANDQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  21284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rm),
     /*  21287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21289 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  21291 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  21295 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  21300 */     GIR_RootConstrainSelectedInstOperands,
     /*  21301 */     // GIR_Coverage, 24143,
     /*  21301 */     GIR_EraseRootFromParent_Done,
     /*  21302 */   // Label 573: @21302
     /*  21302 */   GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(21364), // Rule ID 25242 //
     /*  21307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  21310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  21322 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  21325 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  21329 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  21333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21339 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  21346 */     // (and:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4i64] }:$src1)  =>  (VANDPSYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  21346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VANDPSYrm),
     /*  21349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21351 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  21353 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  21357 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  21362 */     GIR_RootConstrainSelectedInstOperands,
     /*  21363 */     // GIR_Coverage, 25242,
     /*  21363 */     GIR_EraseRootFromParent_Done,
     /*  21364 */   // Label 574: @21364
     /*  21364 */   GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(21426), // Rule ID 2115 //
     /*  21369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  21372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  21388 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  21391 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  21395 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  21399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21401 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  21408 */     // (and:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  21408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDYrm),
     /*  21411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21413 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  21415 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  21419 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  21424 */     GIR_RootConstrainSelectedInstOperands,
     /*  21425 */     // GIR_Coverage, 2115,
     /*  21425 */     GIR_EraseRootFromParent_Done,
     /*  21426 */   // Label 575: @21426
     /*  21426 */   GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(21488), // Rule ID 5698 //
     /*  21431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  21434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  21438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  21442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  21450 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  21453 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  21457 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  21461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21463 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  21470 */     // (and:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  21470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rm),
     /*  21473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21475 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  21477 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  21481 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  21486 */     GIR_RootConstrainSelectedInstOperands,
     /*  21487 */     // GIR_Coverage, 5698,
     /*  21487 */     GIR_EraseRootFromParent_Done,
     /*  21488 */   // Label 576: @21488
     /*  21488 */   GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(21550), // Rule ID 18133 //
     /*  21493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  21496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21500 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  21512 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  21515 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  21519 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  21523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21525 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  21532 */     // (and:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VANDPSYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  21532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VANDPSYrm),
     /*  21535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21537 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  21539 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  21543 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  21548 */     GIR_RootConstrainSelectedInstOperands,
     /*  21549 */     // GIR_Coverage, 18133,
     /*  21549 */     GIR_EraseRootFromParent_Done,
     /*  21550 */   // Label 577: @21550
     /*  21550 */   GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(21577), // Rule ID 2114 //
     /*  21555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  21558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21570 */     // (and:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VPANDYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  21570 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDYrr),
     /*  21575 */     GIR_RootConstrainSelectedInstOperands,
     /*  21576 */     // GIR_Coverage, 2114,
     /*  21576 */     GIR_Done,
     /*  21577 */   // Label 578: @21577
     /*  21577 */   GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(21604), // Rule ID 5695 //
     /*  21582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  21585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  21589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  21593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  21597 */     // (and:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPANDQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*  21597 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rr),
     /*  21602 */     GIR_RootConstrainSelectedInstOperands,
     /*  21603 */     // GIR_Coverage, 5695,
     /*  21603 */     GIR_Done,
     /*  21604 */   // Label 579: @21604
     /*  21604 */   GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(21631), // Rule ID 18117 //
     /*  21609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  21612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21616 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21624 */     // (and:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VANDPSYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  21624 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VANDPSYrr),
     /*  21629 */     GIR_RootConstrainSelectedInstOperands,
     /*  21630 */     // GIR_Coverage, 18117,
     /*  21630 */     GIR_Done,
     /*  21631 */   // Label 580: @21631
     /*  21631 */   GIM_Reject,
     /*  21632 */ // Label 571: @21632
     /*  21632 */ GIM_Reject,
     /*  21633 */ // Label 456: @21633
     /*  21633 */ GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(22130),
     /*  21638 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  21641 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  21644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21648 */   GIM_Try, /*On fail goto*//*Label 582*/ GIMT_Encode4(21708), // Rule ID 4431 //
     /*  21653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  21656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  21668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  21672 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21681 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21687 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  21689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21693 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21695 */     // (and:{ *:[v8i1] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }), VK8:{ *:[v8i1] }:$src2)  =>  (KANDNBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /*  21695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNBkk),
     /*  21698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21704 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  21706 */     GIR_RootConstrainSelectedInstOperands,
     /*  21707 */     // GIR_Coverage, 4431,
     /*  21707 */     GIR_EraseRootFromParent_Done,
     /*  21708 */   // Label 582: @21708
     /*  21708 */   GIM_Try, /*On fail goto*//*Label 583*/ GIMT_Encode4(21831), // Rule ID 19487 //
     /*  21713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /*  21716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  21728 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  21732 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21737 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21741 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21747 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  21749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21753 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21755 */     // (and:{ *:[v8i1] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }), VK8:{ *:[v8i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /*  21755 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  21758 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21762 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21767 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  21771 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  21776 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  21779 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21783 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21788 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21792 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  21797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  21800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  21804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21809 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  21812 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  21815 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21822 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  21825 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  21830 */     // GIR_Coverage, 19487,
     /*  21830 */     GIR_EraseRootFromParent_Done,
     /*  21831 */   // Label 583: @21831
     /*  21831 */   GIM_Try, /*On fail goto*//*Label 584*/ GIMT_Encode4(21891), // Rule ID 23692 //
     /*  21836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  21839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  21855 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  21859 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21868 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21874 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  21876 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21878 */     // (and:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src2, (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }))  =>  (KANDNBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /*  21878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNBkk),
     /*  21881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21887 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  21889 */     GIR_RootConstrainSelectedInstOperands,
     /*  21890 */     // GIR_Coverage, 23692,
     /*  21890 */     GIR_EraseRootFromParent_Done,
     /*  21891 */   // Label 584: @21891
     /*  21891 */   GIM_Try, /*On fail goto*//*Label 585*/ GIMT_Encode4(22014), // Rule ID 25366 //
     /*  21896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /*  21899 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  21915 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  21919 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21924 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21928 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21934 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  21936 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21938 */     // (and:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src2, (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /*  21938 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  21941 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21945 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21950 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  21954 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  21959 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  21962 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21966 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21971 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21975 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  21980 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  21983 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  21987 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21992 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  21995 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  21998 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22005 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  22008 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  22013 */     // GIR_Coverage, 25366,
     /*  22013 */     GIR_EraseRootFromParent_Done,
     /*  22014 */   // Label 585: @22014
     /*  22014 */   GIM_Try, /*On fail goto*//*Label 586*/ GIMT_Encode4(22037), // Rule ID 4415 //
     /*  22019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  22022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  22026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  22030 */     // (and:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (KANDBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /*  22030 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KANDBkk),
     /*  22035 */     GIR_RootConstrainSelectedInstOperands,
     /*  22036 */     // GIR_Coverage, 4415,
     /*  22036 */     GIR_Done,
     /*  22037 */   // Label 586: @22037
     /*  22037 */   GIM_Try, /*On fail goto*//*Label 587*/ GIMT_Encode4(22129), // Rule ID 19483 //
     /*  22042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /*  22045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  22049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  22053 */     // (and:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KANDWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /*  22053 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  22056 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22060 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22065 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  22069 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  22074 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  22077 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22081 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22086 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  22090 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  22095 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  22098 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDWkk),
     /*  22102 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22107 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22110 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  22113 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22120 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  22123 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  22128 */     // GIR_Coverage, 19483,
     /*  22128 */     GIR_EraseRootFromParent_Done,
     /*  22129 */   // Label 587: @22129
     /*  22129 */   GIM_Reject,
     /*  22130 */ // Label 581: @22130
     /*  22130 */ GIM_Reject,
     /*  22131 */ // Label 457: @22131
     /*  22131 */ GIM_Try, /*On fail goto*//*Label 588*/ GIMT_Encode4(22472),
     /*  22136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22139 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  22142 */   GIM_Try, /*On fail goto*//*Label 589*/ GIMT_Encode4(22204), // Rule ID 25252 //
     /*  22147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  22150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  22154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22162 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22165 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22169 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  22177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22179 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22186 */     // (and:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPANDrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDrm),
     /*  22189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22191 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  22193 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22197 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22202 */     GIR_RootConstrainSelectedInstOperands,
     /*  22203 */     // GIR_Coverage, 25252,
     /*  22203 */     GIR_EraseRootFromParent_Done,
     /*  22204 */   // Label 589: @22204
     /*  22204 */   GIM_Try, /*On fail goto*//*Label 590*/ GIMT_Encode4(22266), // Rule ID 25433 //
     /*  22209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  22212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  22216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22224 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22227 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22231 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  22239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22241 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22248 */     // (and:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPANDQZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rm),
     /*  22251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22253 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  22255 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22259 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22264 */     GIR_RootConstrainSelectedInstOperands,
     /*  22265 */     // GIR_Coverage, 25433,
     /*  22265 */     GIR_EraseRootFromParent_Done,
     /*  22266 */   // Label 590: @22266
     /*  22266 */   GIM_Try, /*On fail goto*//*Label 591*/ GIMT_Encode4(22328), // Rule ID 18159 //
     /*  22271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  22274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  22278 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  22282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22290 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22293 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22297 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22303 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22310 */     // (and:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDrm),
     /*  22313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22315 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  22317 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22321 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22326 */     GIR_RootConstrainSelectedInstOperands,
     /*  22327 */     // GIR_Coverage, 18159,
     /*  22327 */     GIR_EraseRootFromParent_Done,
     /*  22328 */   // Label 591: @22328
     /*  22328 */   GIM_Try, /*On fail goto*//*Label 592*/ GIMT_Encode4(22390), // Rule ID 20025 //
     /*  22333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  22336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  22340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  22344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22352 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22355 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22359 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22365 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22372 */     // (and:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDQZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rm),
     /*  22375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22377 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  22379 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22383 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22388 */     GIR_RootConstrainSelectedInstOperands,
     /*  22389 */     // GIR_Coverage, 20025,
     /*  22389 */     GIR_EraseRootFromParent_Done,
     /*  22390 */   // Label 592: @22390
     /*  22390 */   GIM_Try, /*On fail goto*//*Label 593*/ GIMT_Encode4(22417), // Rule ID 18147 //
     /*  22395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  22398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  22402 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  22406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  22410 */     // (and:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPANDrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  22410 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDrr),
     /*  22415 */     GIR_RootConstrainSelectedInstOperands,
     /*  22416 */     // GIR_Coverage, 18147,
     /*  22416 */     GIR_Done,
     /*  22417 */   // Label 593: @22417
     /*  22417 */   GIM_Try, /*On fail goto*//*Label 594*/ GIMT_Encode4(22444), // Rule ID 18171 //
     /*  22422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  22425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  22429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  22433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  22437 */     // (and:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PANDrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  22437 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PANDrr),
     /*  22442 */     GIR_RootConstrainSelectedInstOperands,
     /*  22443 */     // GIR_Coverage, 18171,
     /*  22443 */     GIR_Done,
     /*  22444 */   // Label 594: @22444
     /*  22444 */   GIM_Try, /*On fail goto*//*Label 595*/ GIMT_Encode4(22471), // Rule ID 20017 //
     /*  22449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  22452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  22456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  22460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  22464 */     // (and:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPANDQZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /*  22464 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rr),
     /*  22469 */     GIR_RootConstrainSelectedInstOperands,
     /*  22470 */     // GIR_Coverage, 20017,
     /*  22470 */     GIR_Done,
     /*  22471 */   // Label 595: @22471
     /*  22471 */   GIM_Reject,
     /*  22472 */ // Label 588: @22472
     /*  22472 */ GIM_Reject,
     /*  22473 */ // Label 458: @22473
     /*  22473 */ GIM_Try, /*On fail goto*//*Label 596*/ GIMT_Encode4(22938),
     /*  22478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  22481 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  22484 */   GIM_Try, /*On fail goto*//*Label 597*/ GIMT_Encode4(22546), // Rule ID 24161 //
     /*  22489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  22492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  22496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22504 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22507 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22511 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  22519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22521 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22528 */     // (and:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8i32] }:$src1)  =>  (VPANDDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDDZ256rm),
     /*  22531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22533 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  22535 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22539 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22544 */     GIR_RootConstrainSelectedInstOperands,
     /*  22545 */     // GIR_Coverage, 24161,
     /*  22545 */     GIR_EraseRootFromParent_Done,
     /*  22546 */   // Label 597: @22546
     /*  22546 */   GIM_Try, /*On fail goto*//*Label 598*/ GIMT_Encode4(22608), // Rule ID 25232 //
     /*  22551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  22554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22566 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22569 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22573 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22583 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22590 */     // (and:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VPANDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDYrm),
     /*  22593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22595 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  22597 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22601 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22606 */     GIR_RootConstrainSelectedInstOperands,
     /*  22607 */     // GIR_Coverage, 25232,
     /*  22607 */     GIR_EraseRootFromParent_Done,
     /*  22608 */   // Label 598: @22608
     /*  22608 */   GIM_Try, /*On fail goto*//*Label 599*/ GIMT_Encode4(22670), // Rule ID 25241 //
     /*  22613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  22616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22628 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22631 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22635 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22645 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22652 */     // (and:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VANDPSYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VANDPSYrm),
     /*  22655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22657 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  22659 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22663 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22668 */     GIR_RootConstrainSelectedInstOperands,
     /*  22669 */     // GIR_Coverage, 25241,
     /*  22669 */     GIR_EraseRootFromParent_Done,
     /*  22670 */   // Label 599: @22670
     /*  22670 */   GIM_Try, /*On fail goto*//*Label 600*/ GIMT_Encode4(22732), // Rule ID 5725 //
     /*  22675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  22678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  22682 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  22686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22694 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22697 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22701 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22707 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22714 */     // (and:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDDZ256rm),
     /*  22717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22719 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  22721 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22725 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22730 */     GIR_RootConstrainSelectedInstOperands,
     /*  22731 */     // GIR_Coverage, 5725,
     /*  22731 */     GIR_EraseRootFromParent_Done,
     /*  22732 */   // Label 600: @22732
     /*  22732 */   GIM_Try, /*On fail goto*//*Label 601*/ GIMT_Encode4(22794), // Rule ID 18104 //
     /*  22737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  22740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22744 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22756 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22759 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22763 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22769 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22776 */     // (and:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDYrm),
     /*  22779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22781 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  22783 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22787 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22792 */     GIR_RootConstrainSelectedInstOperands,
     /*  22793 */     // GIR_Coverage, 18104,
     /*  22793 */     GIR_EraseRootFromParent_Done,
     /*  22794 */   // Label 601: @22794
     /*  22794 */   GIM_Try, /*On fail goto*//*Label 602*/ GIMT_Encode4(22856), // Rule ID 18132 //
     /*  22799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  22802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22818 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22821 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22825 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22831 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22838 */     // (and:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VANDPSYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VANDPSYrm),
     /*  22841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22843 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  22845 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22849 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22854 */     GIR_RootConstrainSelectedInstOperands,
     /*  22855 */     // GIR_Coverage, 18132,
     /*  22855 */     GIR_EraseRootFromParent_Done,
     /*  22856 */   // Label 602: @22856
     /*  22856 */   GIM_Try, /*On fail goto*//*Label 603*/ GIMT_Encode4(22883), // Rule ID 5722 //
     /*  22861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  22864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  22868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  22872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  22876 */     // (and:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPANDDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /*  22876 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDDZ256rr),
     /*  22881 */     GIR_RootConstrainSelectedInstOperands,
     /*  22882 */     // GIR_Coverage, 5722,
     /*  22882 */     GIR_Done,
     /*  22883 */   // Label 603: @22883
     /*  22883 */   GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(22910), // Rule ID 18092 //
     /*  22888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  22891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22903 */     // (and:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPANDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  22903 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDYrr),
     /*  22908 */     GIR_RootConstrainSelectedInstOperands,
     /*  22909 */     // GIR_Coverage, 18092,
     /*  22909 */     GIR_Done,
     /*  22910 */   // Label 604: @22910
     /*  22910 */   GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(22937), // Rule ID 18116 //
     /*  22915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  22918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22930 */     // (and:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VANDPSYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  22930 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VANDPSYrr),
     /*  22935 */     GIR_RootConstrainSelectedInstOperands,
     /*  22936 */     // GIR_Coverage, 18116,
     /*  22936 */     GIR_Done,
     /*  22937 */   // Label 605: @22937
     /*  22937 */   GIM_Reject,
     /*  22938 */ // Label 596: @22938
     /*  22938 */ GIM_Reject,
     /*  22939 */ // Label 459: @22939
     /*  22939 */ GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(23094),
     /*  22944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  22947 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  22950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  22954 */   GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(23012), // Rule ID 24137 //
     /*  22959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  22962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22970 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22973 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22977 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  22985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22987 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22994 */     // (and:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8i64] }:$src1)  =>  (VPANDQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZrm),
     /*  22997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22999 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  23001 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23005 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23010 */     GIR_RootConstrainSelectedInstOperands,
     /*  23011 */     // GIR_Coverage, 24137,
     /*  23011 */     GIR_EraseRootFromParent_Done,
     /*  23012 */   // Label 607: @23012
     /*  23012 */   GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(23070), // Rule ID 5689 //
     /*  23017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  23020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  23024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23032 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23035 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23039 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23045 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23052 */     // (and:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZrm),
     /*  23055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23057 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  23059 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23063 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23068 */     GIR_RootConstrainSelectedInstOperands,
     /*  23069 */     // GIR_Coverage, 5689,
     /*  23069 */     GIR_EraseRootFromParent_Done,
     /*  23070 */   // Label 608: @23070
     /*  23070 */   GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(23093), // Rule ID 5686 //
     /*  23075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  23078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  23082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  23086 */     // (and:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPANDQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  23086 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZrr),
     /*  23091 */     GIR_RootConstrainSelectedInstOperands,
     /*  23092 */     // GIR_Coverage, 5686,
     /*  23092 */     GIR_Done,
     /*  23093 */   // Label 609: @23093
     /*  23093 */   GIM_Reject,
     /*  23094 */ // Label 606: @23094
     /*  23094 */ GIM_Reject,
     /*  23095 */ // Label 460: @23095
     /*  23095 */ GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(23254),
     /*  23100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  23103 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  23106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  23110 */   GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(23170), // Rule ID 4432 //
     /*  23115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  23118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  23126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  23130 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  23134 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  23139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23143 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  23149 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  23151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  23155 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23157 */     // (and:{ *:[v16i1] } (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, immAllOnesV:{ *:[v16i1] }), VK16:{ *:[v16i1] }:$src2)  =>  (KANDNWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /*  23157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  23160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  23166 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  23168 */     GIR_RootConstrainSelectedInstOperands,
     /*  23169 */     // GIR_Coverage, 4432,
     /*  23169 */     GIR_EraseRootFromParent_Done,
     /*  23170 */   // Label 611: @23170
     /*  23170 */   GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(23230), // Rule ID 23693 //
     /*  23175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  23178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  23182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  23190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  23194 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  23198 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  23203 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23207 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  23213 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  23215 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23217 */     // (and:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src2, (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, immAllOnesV:{ *:[v16i1] }))  =>  (KANDNWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /*  23217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  23220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  23226 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  23228 */     GIR_RootConstrainSelectedInstOperands,
     /*  23229 */     // GIR_Coverage, 23693,
     /*  23229 */     GIR_EraseRootFromParent_Done,
     /*  23230 */   // Label 612: @23230
     /*  23230 */   GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(23253), // Rule ID 4416 //
     /*  23235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  23238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  23242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  23246 */     // (and:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)  =>  (KANDWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /*  23246 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KANDWkk),
     /*  23251 */     GIR_RootConstrainSelectedInstOperands,
     /*  23252 */     // GIR_Coverage, 4416,
     /*  23252 */     GIR_Done,
     /*  23253 */   // Label 613: @23253
     /*  23253 */   GIM_Reject,
     /*  23254 */ // Label 610: @23254
     /*  23254 */ GIM_Reject,
     /*  23255 */ // Label 461: @23255
     /*  23255 */ GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(23596),
     /*  23260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  23263 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  23266 */   GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(23328), // Rule ID 25251 //
     /*  23271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  23274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23286 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23289 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23293 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23303 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23310 */     // (and:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPANDrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDrm),
     /*  23313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23315 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  23317 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23321 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23326 */     GIR_RootConstrainSelectedInstOperands,
     /*  23327 */     // GIR_Coverage, 25251,
     /*  23327 */     GIR_EraseRootFromParent_Done,
     /*  23328 */   // Label 615: @23328
     /*  23328 */   GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(23390), // Rule ID 25432 //
     /*  23333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  23336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  23340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23348 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23351 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23355 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  23363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23365 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23372 */     // (and:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPANDQZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rm),
     /*  23375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23377 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  23379 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23383 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23388 */     GIR_RootConstrainSelectedInstOperands,
     /*  23389 */     // GIR_Coverage, 25432,
     /*  23389 */     GIR_EraseRootFromParent_Done,
     /*  23390 */   // Label 616: @23390
     /*  23390 */   GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(23452), // Rule ID 18158 //
     /*  23395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  23398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23402 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23414 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23417 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23421 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23427 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23434 */     // (and:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDrm),
     /*  23437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23439 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  23441 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23445 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23450 */     GIR_RootConstrainSelectedInstOperands,
     /*  23451 */     // GIR_Coverage, 18158,
     /*  23451 */     GIR_EraseRootFromParent_Done,
     /*  23452 */   // Label 617: @23452
     /*  23452 */   GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(23514), // Rule ID 20024 //
     /*  23457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  23460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  23464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  23468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23476 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23479 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23483 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23489 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23496 */     // (and:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDQZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rm),
     /*  23499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23501 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  23503 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23507 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23512 */     GIR_RootConstrainSelectedInstOperands,
     /*  23513 */     // GIR_Coverage, 20024,
     /*  23513 */     GIR_EraseRootFromParent_Done,
     /*  23514 */   // Label 618: @23514
     /*  23514 */   GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(23541), // Rule ID 18146 //
     /*  23519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  23522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23534 */     // (and:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPANDrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  23534 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDrr),
     /*  23539 */     GIR_RootConstrainSelectedInstOperands,
     /*  23540 */     // GIR_Coverage, 18146,
     /*  23540 */     GIR_Done,
     /*  23541 */   // Label 619: @23541
     /*  23541 */   GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(23568), // Rule ID 18170 //
     /*  23546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  23549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23553 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23561 */     // (and:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PANDrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  23561 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PANDrr),
     /*  23566 */     GIR_RootConstrainSelectedInstOperands,
     /*  23567 */     // GIR_Coverage, 18170,
     /*  23567 */     GIR_Done,
     /*  23568 */   // Label 620: @23568
     /*  23568 */   GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(23595), // Rule ID 20016 //
     /*  23573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  23576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  23580 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  23584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  23588 */     // (and:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPANDQZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /*  23588 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rr),
     /*  23593 */     GIR_RootConstrainSelectedInstOperands,
     /*  23594 */     // GIR_Coverage, 20016,
     /*  23594 */     GIR_Done,
     /*  23595 */   // Label 621: @23595
     /*  23595 */   GIM_Reject,
     /*  23596 */ // Label 614: @23596
     /*  23596 */ GIM_Reject,
     /*  23597 */ // Label 462: @23597
     /*  23597 */ GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(24062),
     /*  23602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  23605 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  23608 */   GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(23670), // Rule ID 25231 //
     /*  23613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  23616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23628 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23631 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23635 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23645 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23652 */     // (and:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPANDYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDYrm),
     /*  23655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23657 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  23659 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23663 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23668 */     GIR_RootConstrainSelectedInstOperands,
     /*  23669 */     // GIR_Coverage, 25231,
     /*  23669 */     GIR_EraseRootFromParent_Done,
     /*  23670 */   // Label 623: @23670
     /*  23670 */   GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(23732), // Rule ID 25240 //
     /*  23675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  23678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23690 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23693 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23697 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23707 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23714 */     // (and:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VANDPSYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VANDPSYrm),
     /*  23717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23719 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  23721 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23725 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23730 */     GIR_RootConstrainSelectedInstOperands,
     /*  23731 */     // GIR_Coverage, 25240,
     /*  23731 */     GIR_EraseRootFromParent_Done,
     /*  23732 */   // Label 624: @23732
     /*  23732 */   GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(23794), // Rule ID 25439 //
     /*  23737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  23740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  23744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23752 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23755 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23759 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  23767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23769 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23776 */     // (and:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPANDQZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rm),
     /*  23779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23781 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  23783 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23787 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23792 */     GIR_RootConstrainSelectedInstOperands,
     /*  23793 */     // GIR_Coverage, 25439,
     /*  23793 */     GIR_EraseRootFromParent_Done,
     /*  23794 */   // Label 625: @23794
     /*  23794 */   GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(23856), // Rule ID 18103 //
     /*  23799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  23802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23818 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23821 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23825 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23831 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23838 */     // (and:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDYrm),
     /*  23841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23843 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  23845 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23849 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23854 */     GIR_RootConstrainSelectedInstOperands,
     /*  23855 */     // GIR_Coverage, 18103,
     /*  23855 */     GIR_EraseRootFromParent_Done,
     /*  23856 */   // Label 626: @23856
     /*  23856 */   GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(23918), // Rule ID 18131 //
     /*  23861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  23864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23880 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23883 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23887 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23893 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23900 */     // (and:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VANDPSYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VANDPSYrm),
     /*  23903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23905 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  23907 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23911 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23916 */     GIR_RootConstrainSelectedInstOperands,
     /*  23917 */     // GIR_Coverage, 18131,
     /*  23917 */     GIR_EraseRootFromParent_Done,
     /*  23918 */   // Label 627: @23918
     /*  23918 */   GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(23980), // Rule ID 20041 //
     /*  23923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  23926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  23930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  23934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23942 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23945 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23949 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23953 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23955 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23962 */     // (and:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDQZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rm),
     /*  23965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23967 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  23969 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23973 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23978 */     GIR_RootConstrainSelectedInstOperands,
     /*  23979 */     // GIR_Coverage, 20041,
     /*  23979 */     GIR_EraseRootFromParent_Done,
     /*  23980 */   // Label 628: @23980
     /*  23980 */   GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(24007), // Rule ID 18091 //
     /*  23985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  23988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23992 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24000 */     // (and:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPANDYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  24000 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDYrr),
     /*  24005 */     GIR_RootConstrainSelectedInstOperands,
     /*  24006 */     // GIR_Coverage, 18091,
     /*  24006 */     GIR_Done,
     /*  24007 */   // Label 629: @24007
     /*  24007 */   GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(24034), // Rule ID 18115 //
     /*  24012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  24015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24019 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24027 */     // (and:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VANDPSYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  24027 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VANDPSYrr),
     /*  24032 */     GIR_RootConstrainSelectedInstOperands,
     /*  24033 */     // GIR_Coverage, 18115,
     /*  24033 */     GIR_Done,
     /*  24034 */   // Label 630: @24034
     /*  24034 */   GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(24061), // Rule ID 20033 //
     /*  24039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  24042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  24046 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  24050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  24054 */     // (and:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPANDQZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /*  24054 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rr),
     /*  24059 */     GIR_RootConstrainSelectedInstOperands,
     /*  24060 */     // GIR_Coverage, 20033,
     /*  24060 */     GIR_Done,
     /*  24061 */   // Label 631: @24061
     /*  24061 */   GIM_Reject,
     /*  24062 */ // Label 622: @24062
     /*  24062 */ GIM_Reject,
     /*  24063 */ // Label 463: @24063
     /*  24063 */ GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(24218),
     /*  24068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  24071 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  24074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  24078 */   GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(24136), // Rule ID 24155 //
     /*  24083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  24086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24094 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24097 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24101 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  24109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24111 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24118 */     // (and:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16i32] }:$src1)  =>  (VPANDDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDDZrm),
     /*  24121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24123 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  24125 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  24129 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  24134 */     GIR_RootConstrainSelectedInstOperands,
     /*  24135 */     // GIR_Coverage, 24155,
     /*  24135 */     GIR_EraseRootFromParent_Done,
     /*  24136 */   // Label 633: @24136
     /*  24136 */   GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(24194), // Rule ID 5716 //
     /*  24141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  24144 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  24148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24156 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24159 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24163 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24167 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24169 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24176 */     // (and:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDDZrm),
     /*  24179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24181 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  24183 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  24187 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  24192 */     GIR_RootConstrainSelectedInstOperands,
     /*  24193 */     // GIR_Coverage, 5716,
     /*  24193 */     GIR_EraseRootFromParent_Done,
     /*  24194 */   // Label 634: @24194
     /*  24194 */   GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(24217), // Rule ID 5713 //
     /*  24199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  24202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  24206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  24210 */     // (and:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPANDDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /*  24210 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDDZrr),
     /*  24215 */     GIR_RootConstrainSelectedInstOperands,
     /*  24216 */     // GIR_Coverage, 5713,
     /*  24216 */     GIR_Done,
     /*  24217 */   // Label 635: @24217
     /*  24217 */   GIM_Reject,
     /*  24218 */ // Label 632: @24218
     /*  24218 */ GIM_Reject,
     /*  24219 */ // Label 464: @24219
     /*  24219 */ GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(24378),
     /*  24224 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  24227 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s1,
     /*  24230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  24234 */   GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(24294), // Rule ID 4433 //
     /*  24239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  24242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  24250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  24254 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v32s1,
     /*  24258 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  24263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24267 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  24273 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  24275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  24279 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24281 */     // (and:{ *:[v32i1] } (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, immAllOnesV:{ *:[v32i1] }), VK32:{ *:[v32i1] }:$src2)  =>  (KANDNDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /*  24281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNDkk),
     /*  24284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  24290 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  24292 */     GIR_RootConstrainSelectedInstOperands,
     /*  24293 */     // GIR_Coverage, 4433,
     /*  24293 */     GIR_EraseRootFromParent_Done,
     /*  24294 */   // Label 637: @24294
     /*  24294 */   GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(24354), // Rule ID 23694 //
     /*  24299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  24302 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  24306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  24314 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  24318 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v32s1,
     /*  24322 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  24327 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24331 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  24337 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  24339 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24341 */     // (and:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src2, (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, immAllOnesV:{ *:[v32i1] }))  =>  (KANDNDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /*  24341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNDkk),
     /*  24344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  24350 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  24352 */     GIR_RootConstrainSelectedInstOperands,
     /*  24353 */     // GIR_Coverage, 23694,
     /*  24353 */     GIR_EraseRootFromParent_Done,
     /*  24354 */   // Label 638: @24354
     /*  24354 */   GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(24377), // Rule ID 4417 //
     /*  24359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  24362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  24366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  24370 */     // (and:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)  =>  (KANDDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /*  24370 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KANDDkk),
     /*  24375 */     GIR_RootConstrainSelectedInstOperands,
     /*  24376 */     // GIR_Coverage, 4417,
     /*  24376 */     GIR_Done,
     /*  24377 */   // Label 639: @24377
     /*  24377 */   GIM_Reject,
     /*  24378 */ // Label 636: @24378
     /*  24378 */ GIM_Reject,
     /*  24379 */ // Label 465: @24379
     /*  24379 */ GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(24844),
     /*  24384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /*  24387 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /*  24390 */   GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(24452), // Rule ID 25230 //
     /*  24395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  24398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24410 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24413 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24417 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24427 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24434 */     // (and:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPANDYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDYrm),
     /*  24437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24439 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  24441 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  24445 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  24450 */     GIR_RootConstrainSelectedInstOperands,
     /*  24451 */     // GIR_Coverage, 25230,
     /*  24451 */     GIR_EraseRootFromParent_Done,
     /*  24452 */   // Label 641: @24452
     /*  24452 */   GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(24514), // Rule ID 25239 //
     /*  24457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  24460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24472 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24475 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24479 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24489 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24496 */     // (and:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VANDPSYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VANDPSYrm),
     /*  24499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24501 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  24503 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  24507 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  24512 */     GIR_RootConstrainSelectedInstOperands,
     /*  24513 */     // GIR_Coverage, 25239,
     /*  24513 */     GIR_EraseRootFromParent_Done,
     /*  24514 */   // Label 642: @24514
     /*  24514 */   GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(24576), // Rule ID 25438 //
     /*  24519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  24522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  24526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24534 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24537 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24541 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  24549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24551 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24558 */     // (and:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPANDQZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rm),
     /*  24561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24563 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  24565 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  24569 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  24574 */     GIR_RootConstrainSelectedInstOperands,
     /*  24575 */     // GIR_Coverage, 25438,
     /*  24575 */     GIR_EraseRootFromParent_Done,
     /*  24576 */   // Label 643: @24576
     /*  24576 */   GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(24638), // Rule ID 18102 //
     /*  24581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  24584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24600 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24603 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24607 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24613 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24620 */     // (and:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDYrm),
     /*  24623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24625 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  24627 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  24631 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  24636 */     GIR_RootConstrainSelectedInstOperands,
     /*  24637 */     // GIR_Coverage, 18102,
     /*  24637 */     GIR_EraseRootFromParent_Done,
     /*  24638 */   // Label 644: @24638
     /*  24638 */   GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(24700), // Rule ID 18130 //
     /*  24643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  24646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24662 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24665 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24669 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24675 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24682 */     // (and:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VANDPSYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VANDPSYrm),
     /*  24685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24687 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  24689 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  24693 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  24698 */     GIR_RootConstrainSelectedInstOperands,
     /*  24699 */     // GIR_Coverage, 18130,
     /*  24699 */     GIR_EraseRootFromParent_Done,
     /*  24700 */   // Label 645: @24700
     /*  24700 */   GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(24762), // Rule ID 20040 //
     /*  24705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  24708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  24712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  24716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24724 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24727 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24731 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24737 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24744 */     // (and:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDQZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rm),
     /*  24747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24749 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  24751 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  24755 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  24760 */     GIR_RootConstrainSelectedInstOperands,
     /*  24761 */     // GIR_Coverage, 20040,
     /*  24761 */     GIR_EraseRootFromParent_Done,
     /*  24762 */   // Label 646: @24762
     /*  24762 */   GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(24789), // Rule ID 18090 //
     /*  24767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  24770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24782 */     // (and:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPANDYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*  24782 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDYrr),
     /*  24787 */     GIR_RootConstrainSelectedInstOperands,
     /*  24788 */     // GIR_Coverage, 18090,
     /*  24788 */     GIR_Done,
     /*  24789 */   // Label 647: @24789
     /*  24789 */   GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(24816), // Rule ID 18114 //
     /*  24794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  24797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24801 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24809 */     // (and:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VANDPSYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*  24809 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VANDPSYrr),
     /*  24814 */     GIR_RootConstrainSelectedInstOperands,
     /*  24815 */     // GIR_Coverage, 18114,
     /*  24815 */     GIR_Done,
     /*  24816 */   // Label 648: @24816
     /*  24816 */   GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(24843), // Rule ID 20032 //
     /*  24821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  24824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  24828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  24832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  24836 */     // (and:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPANDQZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /*  24836 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rr),
     /*  24841 */     GIR_RootConstrainSelectedInstOperands,
     /*  24842 */     // GIR_Coverage, 20032,
     /*  24842 */     GIR_Done,
     /*  24843 */   // Label 649: @24843
     /*  24843 */   GIM_Reject,
     /*  24844 */ // Label 640: @24844
     /*  24844 */ GIM_Reject,
     /*  24845 */ // Label 466: @24845
     /*  24845 */ GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(25000),
     /*  24850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  24853 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /*  24856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  24860 */   GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(24918), // Rule ID 25445 //
     /*  24865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  24868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24876 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24879 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24883 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  24891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24893 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24900 */     // (and:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPANDQZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZrm),
     /*  24903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24905 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  24907 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  24911 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  24916 */     GIR_RootConstrainSelectedInstOperands,
     /*  24917 */     // GIR_Coverage, 25445,
     /*  24917 */     GIR_EraseRootFromParent_Done,
     /*  24918 */   // Label 651: @24918
     /*  24918 */   GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(24976), // Rule ID 20057 //
     /*  24923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  24926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  24930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24938 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24941 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24945 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24951 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24958 */     // (and:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDQZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZrm),
     /*  24961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24963 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  24965 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  24969 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  24974 */     GIR_RootConstrainSelectedInstOperands,
     /*  24975 */     // GIR_Coverage, 20057,
     /*  24975 */     GIR_EraseRootFromParent_Done,
     /*  24976 */   // Label 652: @24976
     /*  24976 */   GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(24999), // Rule ID 20049 //
     /*  24981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  24984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  24988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  24992 */     // (and:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPANDQZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /*  24992 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZrr),
     /*  24997 */     GIR_RootConstrainSelectedInstOperands,
     /*  24998 */     // GIR_Coverage, 20049,
     /*  24998 */     GIR_Done,
     /*  24999 */   // Label 653: @24999
     /*  24999 */   GIM_Reject,
     /*  25000 */ // Label 650: @25000
     /*  25000 */ GIM_Reject,
     /*  25001 */ // Label 467: @25001
     /*  25001 */ GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(25160),
     /*  25006 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  25009 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s1,
     /*  25012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  25016 */   GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(25076), // Rule ID 4434 //
     /*  25021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  25024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  25032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  25036 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v64s1,
     /*  25040 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  25045 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25049 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  25055 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  25057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  25061 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25063 */     // (and:{ *:[v64i1] } (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, immAllOnesV:{ *:[v64i1] }), VK64:{ *:[v64i1] }:$src2)  =>  (KANDNQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /*  25063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNQkk),
     /*  25066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  25072 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  25074 */     GIR_RootConstrainSelectedInstOperands,
     /*  25075 */     // GIR_Coverage, 4434,
     /*  25075 */     GIR_EraseRootFromParent_Done,
     /*  25076 */   // Label 655: @25076
     /*  25076 */   GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(25136), // Rule ID 23695 //
     /*  25081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  25084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  25088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  25096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  25100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v64s1,
     /*  25104 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  25109 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25113 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  25119 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  25121 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25123 */     // (and:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src2, (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, immAllOnesV:{ *:[v64i1] }))  =>  (KANDNQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /*  25123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNQkk),
     /*  25126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  25132 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  25134 */     GIR_RootConstrainSelectedInstOperands,
     /*  25135 */     // GIR_Coverage, 23695,
     /*  25135 */     GIR_EraseRootFromParent_Done,
     /*  25136 */   // Label 656: @25136
     /*  25136 */   GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(25159), // Rule ID 4418 //
     /*  25141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  25144 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  25148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  25152 */     // (and:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)  =>  (KANDQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /*  25152 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KANDQkk),
     /*  25157 */     GIR_RootConstrainSelectedInstOperands,
     /*  25158 */     // GIR_Coverage, 4418,
     /*  25158 */     GIR_Done,
     /*  25159 */   // Label 657: @25159
     /*  25159 */   GIM_Reject,
     /*  25160 */ // Label 654: @25160
     /*  25160 */ GIM_Reject,
     /*  25161 */ // Label 468: @25161
     /*  25161 */ GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(25316),
     /*  25166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /*  25169 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /*  25172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  25176 */   GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(25234), // Rule ID 25444 //
     /*  25181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  25184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  25192 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  25195 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  25199 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  25203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  25207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25209 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  25216 */     // (and:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPANDQZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  25216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZrm),
     /*  25219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25221 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  25223 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  25227 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  25232 */     GIR_RootConstrainSelectedInstOperands,
     /*  25233 */     // GIR_Coverage, 25444,
     /*  25233 */     GIR_EraseRootFromParent_Done,
     /*  25234 */   // Label 659: @25234
     /*  25234 */   GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(25292), // Rule ID 20056 //
     /*  25239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  25242 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  25246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  25254 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  25257 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  25261 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  25265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25267 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  25274 */     // (and:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDQZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  25274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZrm),
     /*  25277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25279 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  25281 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  25285 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  25290 */     GIR_RootConstrainSelectedInstOperands,
     /*  25291 */     // GIR_Coverage, 20056,
     /*  25291 */     GIR_EraseRootFromParent_Done,
     /*  25292 */   // Label 660: @25292
     /*  25292 */   GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(25315), // Rule ID 20048 //
     /*  25297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  25300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  25304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  25308 */     // (and:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPANDQZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /*  25308 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZrr),
     /*  25313 */     GIR_RootConstrainSelectedInstOperands,
     /*  25314 */     // GIR_Coverage, 20048,
     /*  25314 */     GIR_Done,
     /*  25315 */   // Label 661: @25315
     /*  25315 */   GIM_Reject,
     /*  25316 */ // Label 658: @25316
     /*  25316 */ GIM_Reject,
     /*  25317 */ // Label 469: @25317
     /*  25317 */ GIM_Reject,
     /*  25318 */ // Label 4: @25318
     /*  25318 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(25), /*)*//*default:*//*Label 685*/ GIMT_Encode4(33721),
     /*  25329 */ /*GILLT_s1*//*Label 662*/ GIMT_Encode4(25429),
     /*  25333 */ /*GILLT_s8*//*Label 663*/ GIMT_Encode4(25529),
     /*  25337 */ /*GILLT_s16*//*Label 664*/ GIMT_Encode4(25922),
     /*  25341 */ /*GILLT_s32*//*Label 665*/ GIMT_Encode4(26519),
     /*  25345 */ /*GILLT_s64*//*Label 666*/ GIMT_Encode4(27975), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  25357 */ /*GILLT_v2s1*//*Label 667*/ GIMT_Encode4(29439),
     /*  25361 */ /*GILLT_v2s64*//*Label 668*/ GIMT_Encode4(29539),
     /*  25365 */ /*GILLT_v4s1*//*Label 669*/ GIMT_Encode4(29881),
     /*  25369 */ /*GILLT_v4s32*//*Label 670*/ GIMT_Encode4(29981),
     /*  25373 */ /*GILLT_v4s64*//*Label 671*/ GIMT_Encode4(30323),
     /*  25377 */ /*GILLT_v8s1*//*Label 672*/ GIMT_Encode4(30789),
     /*  25381 */ /*GILLT_v8s16*//*Label 673*/ GIMT_Encode4(30913),
     /*  25385 */ /*GILLT_v8s32*//*Label 674*/ GIMT_Encode4(31255),
     /*  25389 */ /*GILLT_v8s64*//*Label 675*/ GIMT_Encode4(31721),
     /*  25393 */ /*GILLT_v16s1*//*Label 676*/ GIMT_Encode4(31877),
     /*  25397 */ /*GILLT_v16s8*//*Label 677*/ GIMT_Encode4(31911),
     /*  25401 */ /*GILLT_v16s16*//*Label 678*/ GIMT_Encode4(32253),
     /*  25405 */ /*GILLT_v16s32*//*Label 679*/ GIMT_Encode4(32719),
     /*  25409 */ /*GILLT_v32s1*//*Label 680*/ GIMT_Encode4(32875),
     /*  25413 */ /*GILLT_v32s8*//*Label 681*/ GIMT_Encode4(32909),
     /*  25417 */ /*GILLT_v32s16*//*Label 682*/ GIMT_Encode4(33375),
     /*  25421 */ /*GILLT_v64s1*//*Label 683*/ GIMT_Encode4(33531),
     /*  25425 */ /*GILLT_v64s8*//*Label 684*/ GIMT_Encode4(33565),
     /*  25429 */ // Label 662: @25429
     /*  25429 */ GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(25528), // Rule ID 19492 //
     /*  25434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*  25437 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*  25440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  25444 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  25448 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  25452 */   // (or:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, VK1:{ *:[v1i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /*  25452 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  25455 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25459 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25464 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  25468 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  25473 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  25476 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25480 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25485 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  25489 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  25494 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  25497 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KORWkk),
     /*  25501 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25506 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  25509 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  25512 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  25514 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25517 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25519 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25522 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  25527 */   // GIR_Coverage, 19492,
     /*  25527 */   GIR_EraseRootFromParent_Done,
     /*  25528 */ // Label 686: @25528
     /*  25528 */ GIM_Reject,
     /*  25529 */ // Label 663: @25529
     /*  25529 */ GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(25921),
     /*  25534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /*  25537 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /*  25540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25544 */   GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(25605), // Rule ID 26061 //
     /*  25549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  25552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  25560 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  25563 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  25567 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  25571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25577 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  25584 */     // (or:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, GR8:{ *:[i8] }:$src1)  =>  (OR8rm:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  25584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8rm),
     /*  25587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25589 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  25591 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  25595 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  25598 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  25603 */     GIR_RootConstrainSelectedInstOperands,
     /*  25604 */     // GIR_Coverage, 26061,
     /*  25604 */     GIR_EraseRootFromParent_Done,
     /*  25605 */   // Label 688: @25605
     /*  25605 */   GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(25666), // Rule ID 26080 //
     /*  25610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  25613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  25621 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  25624 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  25628 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  25632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25638 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  25645 */     // (or:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, GR8:{ *:[i8] }:$src1)  =>  (OR8rm_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  25645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8rm_ND),
     /*  25648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25650 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  25652 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  25656 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  25659 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  25664 */     GIR_RootConstrainSelectedInstOperands,
     /*  25665 */     // GIR_Coverage, 26080,
     /*  25665 */     GIR_EraseRootFromParent_Done,
     /*  25666 */   // Label 689: @25666
     /*  25666 */   GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(25727), // Rule ID 22830 //
     /*  25671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  25674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  25686 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  25689 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  25693 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  25697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25699 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  25706 */     // (or:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (OR8rm:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  25706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8rm),
     /*  25709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25711 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  25713 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  25717 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  25720 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  25725 */     GIR_RootConstrainSelectedInstOperands,
     /*  25726 */     // GIR_Coverage, 22830,
     /*  25726 */     GIR_EraseRootFromParent_Done,
     /*  25727 */   // Label 690: @25727
     /*  25727 */   GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(25788), // Rule ID 22920 //
     /*  25732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  25735 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  25747 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  25750 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  25754 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  25758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25760 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  25767 */     // (or:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (OR8rm_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  25767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8rm_ND),
     /*  25770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25772 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  25774 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  25778 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  25781 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  25786 */     GIR_RootConstrainSelectedInstOperands,
     /*  25787 */     // GIR_Coverage, 22920,
     /*  25787 */     GIR_EraseRootFromParent_Done,
     /*  25788 */   // Label 691: @25788
     /*  25788 */   GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(25825), // Rule ID 22834 //
     /*  25793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  25796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25808 */     // MIs[1] Operand 1
     /*  25808 */     // No operand predicates
     /*  25808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25810 */     // (or:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (OR8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  25810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8ri),
     /*  25813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25815 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  25817 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  25820 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  25823 */     GIR_RootConstrainSelectedInstOperands,
     /*  25824 */     // GIR_Coverage, 22834,
     /*  25824 */     GIR_EraseRootFromParent_Done,
     /*  25825 */   // Label 692: @25825
     /*  25825 */   GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(25862), // Rule ID 22924 //
     /*  25830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  25833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25845 */     // MIs[1] Operand 1
     /*  25845 */     // No operand predicates
     /*  25845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25847 */     // (or:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (OR8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  25847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8ri_ND),
     /*  25850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25852 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  25854 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  25857 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  25860 */     GIR_RootConstrainSelectedInstOperands,
     /*  25861 */     // GIR_Coverage, 22924,
     /*  25861 */     GIR_EraseRootFromParent_Done,
     /*  25862 */   // Label 693: @25862
     /*  25862 */   GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(25891), // Rule ID 22826 //
     /*  25867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  25870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25878 */     // (or:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (OR8rr:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  25878 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR8rr),
     /*  25883 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  25889 */     GIR_RootConstrainSelectedInstOperands,
     /*  25890 */     // GIR_Coverage, 22826,
     /*  25890 */     GIR_Done,
     /*  25891 */   // Label 694: @25891
     /*  25891 */   GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(25920), // Rule ID 22916 //
     /*  25896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  25899 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25907 */     // (or:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (OR8rr_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  25907 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR8rr_ND),
     /*  25912 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  25918 */     GIR_RootConstrainSelectedInstOperands,
     /*  25919 */     // GIR_Coverage, 22916,
     /*  25919 */     GIR_Done,
     /*  25920 */   // Label 695: @25920
     /*  25920 */   GIM_Reject,
     /*  25921 */ // Label 687: @25921
     /*  25921 */ GIM_Reject,
     /*  25922 */ // Label 664: @25922
     /*  25922 */ GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(26518),
     /*  25927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  25930 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  25933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  25937 */   GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(25998), // Rule ID 26062 //
     /*  25942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  25945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  25953 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  25956 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  25960 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  25964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  25968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25970 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  25977 */     // (or:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (OR16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  25977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16rm),
     /*  25980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25982 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  25984 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  25988 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  25991 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  25996 */     GIR_RootConstrainSelectedInstOperands,
     /*  25997 */     // GIR_Coverage, 26062,
     /*  25997 */     GIR_EraseRootFromParent_Done,
     /*  25998 */   // Label 697: @25998
     /*  25998 */   GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(26059), // Rule ID 26081 //
     /*  26003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  26006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  26014 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  26017 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  26021 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  26025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  26029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26031 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  26038 */     // (or:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (OR16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  26038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16rm_ND),
     /*  26041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26043 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  26045 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  26049 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26052 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  26057 */     GIR_RootConstrainSelectedInstOperands,
     /*  26058 */     // GIR_Coverage, 26081,
     /*  26058 */     GIR_EraseRootFromParent_Done,
     /*  26059 */   // Label 698: @26059
     /*  26059 */   GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(26120), // Rule ID 22831 //
     /*  26064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  26067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  26071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  26079 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  26082 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  26086 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  26090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26092 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  26099 */     // (or:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (OR16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  26099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16rm),
     /*  26102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26104 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  26106 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  26110 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26113 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  26118 */     GIR_RootConstrainSelectedInstOperands,
     /*  26119 */     // GIR_Coverage, 22831,
     /*  26119 */     GIR_EraseRootFromParent_Done,
     /*  26120 */   // Label 699: @26120
     /*  26120 */   GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(26181), // Rule ID 22921 //
     /*  26125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  26128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  26132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  26140 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  26143 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  26147 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  26151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26153 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  26160 */     // (or:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (OR16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  26160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16rm_ND),
     /*  26163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26165 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  26167 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  26171 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26174 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  26179 */     GIR_RootConstrainSelectedInstOperands,
     /*  26180 */     // GIR_Coverage, 22921,
     /*  26180 */     GIR_EraseRootFromParent_Done,
     /*  26181 */   // Label 700: @26181
     /*  26181 */   GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(26283), // Rule ID 26037 //
     /*  26186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  26194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  26198 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  26202 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  26206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  26211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  26215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26217 */     // (or:{ *:[i16] } (shl:{ *:[i16] } 1:{ *:[i16] }, GR8:{ *:[i8] }:$src2), GR16:{ *:[i16] }:$src1)  =>  (BTS16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (INSERT_SUBREG:{ *:[i16] } (IMPLICIT_DEF:{ *:[i16] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  26217 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  26220 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  26224 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26229 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  26231 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  26234 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  26238 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26243 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  26246 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  26250 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  26253 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  26258 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /*  26263 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  26268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTS16rr),
     /*  26271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26273 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  26275 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  26278 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26281 */     GIR_RootConstrainSelectedInstOperands,
     /*  26282 */     // GIR_Coverage, 26037,
     /*  26282 */     GIR_EraseRootFromParent_Done,
     /*  26283 */   // Label 701: @26283
     /*  26283 */   GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(26385), // Rule ID 22775 //
     /*  26288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  26292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  26300 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  26304 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  26308 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  26312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  26317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26319 */     // (or:{ *:[i16] } GR16:{ *:[i16] }:$src1, (shl:{ *:[i16] } 1:{ *:[i16] }, GR8:{ *:[i8] }:$src2))  =>  (BTS16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (INSERT_SUBREG:{ *:[i16] } (IMPLICIT_DEF:{ *:[i16] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  26319 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  26322 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  26326 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26331 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  26333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  26336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  26340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26345 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  26348 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  26352 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  26355 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  26360 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /*  26365 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  26370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTS16rr),
     /*  26373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26375 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  26377 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  26380 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26383 */     GIR_RootConstrainSelectedInstOperands,
     /*  26384 */     // GIR_Coverage, 22775,
     /*  26384 */     GIR_EraseRootFromParent_Done,
     /*  26385 */   // Label 702: @26385
     /*  26385 */   GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(26422), // Rule ID 22835 //
     /*  26390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  26393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  26397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26405 */     // MIs[1] Operand 1
     /*  26405 */     // No operand predicates
     /*  26405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26407 */     // (or:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (OR16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  26407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16ri),
     /*  26410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26412 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  26414 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  26417 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26420 */     GIR_RootConstrainSelectedInstOperands,
     /*  26421 */     // GIR_Coverage, 22835,
     /*  26421 */     GIR_EraseRootFromParent_Done,
     /*  26422 */   // Label 703: @26422
     /*  26422 */   GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(26459), // Rule ID 22925 //
     /*  26427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  26430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  26434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26442 */     // MIs[1] Operand 1
     /*  26442 */     // No operand predicates
     /*  26442 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26444 */     // (or:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (OR16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  26444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16ri_ND),
     /*  26447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26449 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  26451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  26454 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26457 */     GIR_RootConstrainSelectedInstOperands,
     /*  26458 */     // GIR_Coverage, 22925,
     /*  26458 */     GIR_EraseRootFromParent_Done,
     /*  26459 */   // Label 704: @26459
     /*  26459 */   GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(26488), // Rule ID 22827 //
     /*  26464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  26467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  26471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  26475 */     // (or:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (OR16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  26475 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR16rr),
     /*  26480 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  26486 */     GIR_RootConstrainSelectedInstOperands,
     /*  26487 */     // GIR_Coverage, 22827,
     /*  26487 */     GIR_Done,
     /*  26488 */   // Label 705: @26488
     /*  26488 */   GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(26517), // Rule ID 22917 //
     /*  26493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  26496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  26500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  26504 */     // (or:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (OR16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  26504 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR16rr_ND),
     /*  26509 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  26515 */     GIR_RootConstrainSelectedInstOperands,
     /*  26516 */     // GIR_Coverage, 22917,
     /*  26516 */     GIR_Done,
     /*  26517 */   // Label 706: @26517
     /*  26517 */   GIM_Reject,
     /*  26518 */ // Label 696: @26518
     /*  26518 */ GIM_Reject,
     /*  26519 */ // Label 665: @26519
     /*  26519 */ GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(27974),
     /*  26524 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  26527 */   GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(26595), // Rule ID 26063 //
     /*  26532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  26535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  26538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  26550 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  26553 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  26557 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  26561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26567 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  26574 */     // (or:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (OR32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  26574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32rm),
     /*  26577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26579 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  26581 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  26585 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26588 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  26593 */     GIR_RootConstrainSelectedInstOperands,
     /*  26594 */     // GIR_Coverage, 26063,
     /*  26594 */     GIR_EraseRootFromParent_Done,
     /*  26595 */   // Label 708: @26595
     /*  26595 */   GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(26663), // Rule ID 26082 //
     /*  26600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  26603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  26606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  26618 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  26621 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  26625 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  26629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26635 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  26642 */     // (or:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (OR32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  26642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32rm_ND),
     /*  26645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26647 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  26649 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  26653 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26656 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  26661 */     GIR_RootConstrainSelectedInstOperands,
     /*  26662 */     // GIR_Coverage, 26082,
     /*  26662 */     GIR_EraseRootFromParent_Done,
     /*  26663 */   // Label 709: @26663
     /*  26663 */   GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(26731), // Rule ID 22832 //
     /*  26668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  26671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  26674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26678 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  26690 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  26693 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  26697 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  26701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26703 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  26710 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (OR32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  26710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32rm),
     /*  26713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26715 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  26717 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  26721 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26724 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  26729 */     GIR_RootConstrainSelectedInstOperands,
     /*  26730 */     // GIR_Coverage, 22832,
     /*  26730 */     GIR_EraseRootFromParent_Done,
     /*  26731 */   // Label 710: @26731
     /*  26731 */   GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(26799), // Rule ID 22922 //
     /*  26736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  26739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  26742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  26758 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  26761 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  26765 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  26769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26771 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  26778 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (OR32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  26778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32rm_ND),
     /*  26781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26783 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  26785 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  26789 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26792 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  26797 */     GIR_RootConstrainSelectedInstOperands,
     /*  26798 */     // GIR_Coverage, 22922,
     /*  26798 */     GIR_EraseRootFromParent_Done,
     /*  26799 */   // Label 711: @26799
     /*  26799 */   GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(26876), // Rule ID 25003 //
     /*  26804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  26807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  26810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  26822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  26826 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  26830 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26835 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  26839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26847 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  26851 */     // MIs[2] src
     /*  26851 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  26856 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  26860 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26862 */     // (or:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (BLSIC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  26862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSIC32rr),
     /*  26865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  26871 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26874 */     GIR_RootConstrainSelectedInstOperands,
     /*  26875 */     // GIR_Coverage, 25003,
     /*  26875 */     GIR_EraseRootFromParent_Done,
     /*  26876 */   // Label 712: @26876
     /*  26876 */   GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(26953), // Rule ID 25005 //
     /*  26881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  26884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  26887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  26899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  26903 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  26907 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26912 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  26916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26924 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  26928 */     // MIs[2] src
     /*  26928 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  26933 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  26937 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26939 */     // (or:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (T1MSKC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  26939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::T1MSKC32rr),
     /*  26942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  26948 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26951 */     GIR_RootConstrainSelectedInstOperands,
     /*  26952 */     // GIR_Coverage, 25005,
     /*  26952 */     GIR_EraseRootFromParent_Done,
     /*  26953 */   // Label 713: @26953
     /*  26953 */   GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(27031), // Rule ID 24991 //
     /*  26958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  26961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  26977 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  26981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  26989 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  26993 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  26997 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27002 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*  27006 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  27010 */     // MIs[0] src
     /*  27010 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  27015 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27017 */     // (or:{ *:[i32] } (xor:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), -1:{ *:[i32] }), GR32:{ *:[i32] }:$src)  =>  (BLCI32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  27017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI32rr),
     /*  27020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src
     /*  27026 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27029 */     GIR_RootConstrainSelectedInstOperands,
     /*  27030 */     // GIR_Coverage, 24991,
     /*  27030 */     GIR_EraseRootFromParent_Done,
     /*  27031 */   // Label 714: @27031
     /*  27031 */   GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(27108), // Rule ID 17364 //
     /*  27036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  27039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  27054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  27058 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  27062 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27067 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  27071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  27075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  27079 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  27083 */     // MIs[2] src
     /*  27083 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  27088 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  27092 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27094 */     // (or:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (BLSIC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  27094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSIC32rr),
     /*  27097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  27103 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27106 */     GIR_RootConstrainSelectedInstOperands,
     /*  27107 */     // GIR_Coverage, 17364,
     /*  27107 */     GIR_EraseRootFromParent_Done,
     /*  27108 */   // Label 715: @27108
     /*  27108 */   GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(27185), // Rule ID 17366 //
     /*  27113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  27116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  27131 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  27135 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  27139 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27144 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  27148 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  27152 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  27156 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  27160 */     // MIs[2] src
     /*  27160 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  27165 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*  27169 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27171 */     // (or:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }))  =>  (T1MSKC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  27171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::T1MSKC32rr),
     /*  27174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  27180 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27183 */     GIR_RootConstrainSelectedInstOperands,
     /*  27184 */     // GIR_Coverage, 17366,
     /*  27184 */     GIR_EraseRootFromParent_Done,
     /*  27185 */   // Label 716: @27185
     /*  27185 */   GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(27259), // Rule ID 17352 //
     /*  27190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  27193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  27212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  27216 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  27220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  27228 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  27232 */     // MIs[2] src
     /*  27232 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  27237 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*  27241 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  27245 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27247 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src, (xor:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), -1:{ *:[i32] }))  =>  (BLCI32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  27247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI32rr),
     /*  27250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27252 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27254 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27257 */     GIR_RootConstrainSelectedInstOperands,
     /*  27258 */     // GIR_Coverage, 17352,
     /*  27258 */     GIR_EraseRootFromParent_Done,
     /*  27259 */   // Label 717: @27259
     /*  27259 */   GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(27317), // Rule ID 24999 //
     /*  27264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  27267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  27279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  27283 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  27287 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27292 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  27296 */     // MIs[0] src
     /*  27296 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  27301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27303 */     // (or:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), GR32:{ *:[i32] }:$src)  =>  (BLCS32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  27303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCS32rr),
     /*  27306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  27312 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27315 */     GIR_RootConstrainSelectedInstOperands,
     /*  27316 */     // GIR_Coverage, 24999,
     /*  27316 */     GIR_EraseRootFromParent_Done,
     /*  27317 */   // Label 718: @27317
     /*  27317 */   GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(27375), // Rule ID 25001 //
     /*  27322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  27325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  27337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  27341 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  27345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27350 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  27354 */     // MIs[0] src
     /*  27354 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  27359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27361 */     // (or:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), GR32:{ *:[i32] }:$src)  =>  (BLSFILL32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  27361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSFILL32rr),
     /*  27364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  27370 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27373 */     GIR_RootConstrainSelectedInstOperands,
     /*  27374 */     // GIR_Coverage, 25001,
     /*  27374 */     GIR_EraseRootFromParent_Done,
     /*  27375 */   // Label 719: @27375
     /*  27375 */   GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(27484), // Rule ID 26043 //
     /*  27380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  27395 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  27399 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  27403 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  27407 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  27412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27416 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27418 */     // (or:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, GR8:{ *:[i8] }:$src2), GR32:{ *:[i32] }:$src1)  =>  (BTS32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  27418 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  27421 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  27425 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  27430 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  27432 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  27435 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  27439 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  27444 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  27447 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  27451 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  27454 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  27459 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  27464 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  27469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTS32rr),
     /*  27472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27474 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  27476 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  27479 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27482 */     GIR_RootConstrainSelectedInstOperands,
     /*  27483 */     // GIR_Coverage, 26043,
     /*  27483 */     GIR_EraseRootFromParent_Done,
     /*  27484 */   // Label 720: @27484
     /*  27484 */   GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(27542), // Rule ID 24993 //
     /*  27489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  27492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  27504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  27508 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  27512 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  27516 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27521 */     // MIs[0] src
     /*  27521 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  27526 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27528 */     // (or:{ *:[i32] } (sub:{ *:[i32] } -2:{ *:[i32] }, GR32:{ *:[i32] }:$src), GR32:{ *:[i32] }:$src)  =>  (BLCI32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  27528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI32rr),
     /*  27531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  27537 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27540 */     GIR_RootConstrainSelectedInstOperands,
     /*  27541 */     // GIR_Coverage, 24993,
     /*  27541 */     GIR_EraseRootFromParent_Done,
     /*  27542 */   // Label 721: @27542
     /*  27542 */   GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(27596), // Rule ID 17360 //
     /*  27547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  27550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27557 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  27569 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  27573 */     // MIs[1] src
     /*  27573 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  27578 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  27582 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27584 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src, (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }))  =>  (BLCS32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  27584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCS32rr),
     /*  27587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27589 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27591 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27594 */     GIR_RootConstrainSelectedInstOperands,
     /*  27595 */     // GIR_Coverage, 17360,
     /*  27595 */     GIR_EraseRootFromParent_Done,
     /*  27596 */   // Label 722: @27596
     /*  27596 */   GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(27650), // Rule ID 17362 //
     /*  27601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  27604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27611 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  27623 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  27627 */     // MIs[1] src
     /*  27627 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  27632 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  27636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27638 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src, (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (BLSFILL32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  27638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSFILL32rr),
     /*  27641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27643 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27645 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27648 */     GIR_RootConstrainSelectedInstOperands,
     /*  27649 */     // GIR_Coverage, 17362,
     /*  27649 */     GIR_EraseRootFromParent_Done,
     /*  27650 */   // Label 723: @27650
     /*  27650 */   GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(27759), // Rule ID 22781 //
     /*  27655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  27674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  27678 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  27682 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  27686 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  27691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27693 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src1, (shl:{ *:[i32] } 1:{ *:[i32] }, GR8:{ *:[i8] }:$src2))  =>  (BTS32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  27693 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  27696 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  27700 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  27705 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  27707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  27710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  27714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  27719 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  27722 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  27726 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  27729 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  27734 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  27739 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  27744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTS32rr),
     /*  27747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27749 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  27751 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  27754 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27757 */     GIR_RootConstrainSelectedInstOperands,
     /*  27758 */     // GIR_Coverage, 22781,
     /*  27758 */     GIR_EraseRootFromParent_Done,
     /*  27759 */   // Label 724: @27759
     /*  27759 */   GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(27813), // Rule ID 17354 //
     /*  27764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  27767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  27786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  27790 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  27794 */     // MIs[1] src
     /*  27794 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  27799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27801 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src, (sub:{ *:[i32] } -2:{ *:[i32] }, GR32:{ *:[i32] }:$src))  =>  (BLCI32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  27801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI32rr),
     /*  27804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27806 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27808 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27811 */     GIR_RootConstrainSelectedInstOperands,
     /*  27812 */     // GIR_Coverage, 17354,
     /*  27812 */     GIR_EraseRootFromParent_Done,
     /*  27813 */   // Label 725: @27813
     /*  27813 */   GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(27857), // Rule ID 22836 //
     /*  27818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  27821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27840 */     // MIs[1] Operand 1
     /*  27840 */     // No operand predicates
     /*  27840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27842 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (OR32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  27842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32ri),
     /*  27845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27847 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  27849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  27852 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27855 */     GIR_RootConstrainSelectedInstOperands,
     /*  27856 */     // GIR_Coverage, 22836,
     /*  27856 */     GIR_EraseRootFromParent_Done,
     /*  27857 */   // Label 726: @27857
     /*  27857 */   GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(27901), // Rule ID 22926 //
     /*  27862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  27865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27872 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27884 */     // MIs[1] Operand 1
     /*  27884 */     // No operand predicates
     /*  27884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27886 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (OR32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  27886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32ri_ND),
     /*  27889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27891 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  27893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  27896 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27899 */     GIR_RootConstrainSelectedInstOperands,
     /*  27900 */     // GIR_Coverage, 22926,
     /*  27900 */     GIR_EraseRootFromParent_Done,
     /*  27901 */   // Label 727: @27901
     /*  27901 */   GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(27937), // Rule ID 22828 //
     /*  27906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  27909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27924 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (OR32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  27924 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR32rr),
     /*  27929 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  27935 */     GIR_RootConstrainSelectedInstOperands,
     /*  27936 */     // GIR_Coverage, 22828,
     /*  27936 */     GIR_Done,
     /*  27937 */   // Label 728: @27937
     /*  27937 */   GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(27973), // Rule ID 22918 //
     /*  27942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  27945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27960 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (OR32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  27960 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR32rr_ND),
     /*  27965 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  27971 */     GIR_RootConstrainSelectedInstOperands,
     /*  27972 */     // GIR_Coverage, 22918,
     /*  27972 */     GIR_Done,
     /*  27973 */   // Label 729: @27973
     /*  27973 */   GIM_Reject,
     /*  27974 */ // Label 707: @27974
     /*  27974 */ GIM_Reject,
     /*  27975 */ // Label 666: @27975
     /*  27975 */ GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(29438),
     /*  27980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27983 */   GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(28051), // Rule ID 26064 //
     /*  27988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  27991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  27994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  27998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  28006 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  28009 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  28013 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  28017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28023 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  28030 */     // (or:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (OR64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  28030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64rm),
     /*  28033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28035 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  28037 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  28041 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28044 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  28049 */     GIR_RootConstrainSelectedInstOperands,
     /*  28050 */     // GIR_Coverage, 26064,
     /*  28050 */     GIR_EraseRootFromParent_Done,
     /*  28051 */   // Label 731: @28051
     /*  28051 */   GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(28119), // Rule ID 26083 //
     /*  28056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  28059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  28074 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  28077 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  28081 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  28085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28091 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  28098 */     // (or:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (OR64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  28098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64rm_ND),
     /*  28101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28103 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  28105 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  28109 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28112 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  28117 */     GIR_RootConstrainSelectedInstOperands,
     /*  28118 */     // GIR_Coverage, 26083,
     /*  28118 */     GIR_EraseRootFromParent_Done,
     /*  28119 */   // Label 732: @28119
     /*  28119 */   GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(28187), // Rule ID 22833 //
     /*  28124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  28127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  28146 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  28149 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  28153 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  28157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28159 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  28166 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (OR64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  28166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64rm),
     /*  28169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28171 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  28173 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  28177 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28180 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  28185 */     GIR_RootConstrainSelectedInstOperands,
     /*  28186 */     // GIR_Coverage, 22833,
     /*  28186 */     GIR_EraseRootFromParent_Done,
     /*  28187 */   // Label 733: @28187
     /*  28187 */   GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(28255), // Rule ID 22923 //
     /*  28192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  28195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  28214 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  28217 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  28221 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  28225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28227 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  28234 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (OR64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  28234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64rm_ND),
     /*  28237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28239 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  28241 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  28245 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28248 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  28253 */     GIR_RootConstrainSelectedInstOperands,
     /*  28254 */     // GIR_Coverage, 22923,
     /*  28254 */     GIR_EraseRootFromParent_Done,
     /*  28255 */   // Label 734: @28255
     /*  28255 */   GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(28332), // Rule ID 25004 //
     /*  28260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28282 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28286 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28291 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  28295 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  28299 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28303 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28307 */     // MIs[2] src
     /*  28307 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  28312 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  28316 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28318 */     // (or:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (BLSIC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSIC64rr),
     /*  28321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  28327 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28330 */     GIR_RootConstrainSelectedInstOperands,
     /*  28331 */     // GIR_Coverage, 25004,
     /*  28331 */     GIR_EraseRootFromParent_Done,
     /*  28332 */   // Label 735: @28332
     /*  28332 */   GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(28409), // Rule ID 25006 //
     /*  28337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28355 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28359 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28363 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28368 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  28372 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  28376 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28380 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28384 */     // MIs[2] src
     /*  28384 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  28389 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  28393 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28395 */     // (or:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (T1MSKC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::T1MSKC64rr),
     /*  28398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  28404 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28407 */     GIR_RootConstrainSelectedInstOperands,
     /*  28408 */     // GIR_Coverage, 25006,
     /*  28408 */     GIR_EraseRootFromParent_Done,
     /*  28409 */   // Label 736: @28409
     /*  28409 */   GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(28487), // Rule ID 24992 //
     /*  28414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28433 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28437 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28441 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28445 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  28449 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28453 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28458 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*  28462 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  28466 */     // MIs[0] src
     /*  28466 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  28471 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28473 */     // (or:{ *:[i64] } (xor:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), -1:{ *:[i64] }), GR64:{ *:[i64] }:$src)  =>  (BLCI64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI64rr),
     /*  28476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src
     /*  28482 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28485 */     GIR_RootConstrainSelectedInstOperands,
     /*  28486 */     // GIR_Coverage, 24992,
     /*  28486 */     GIR_EraseRootFromParent_Done,
     /*  28487 */   // Label 737: @28487
     /*  28487 */   GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(28564), // Rule ID 17365 //
     /*  28492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28510 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28514 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28518 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28523 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  28527 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  28531 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28535 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28539 */     // MIs[2] src
     /*  28539 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  28544 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  28548 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28550 */     // (or:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (BLSIC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSIC64rr),
     /*  28553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  28559 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28562 */     GIR_RootConstrainSelectedInstOperands,
     /*  28563 */     // GIR_Coverage, 17365,
     /*  28563 */     GIR_EraseRootFromParent_Done,
     /*  28564 */   // Label 738: @28564
     /*  28564 */   GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(28641), // Rule ID 17367 //
     /*  28569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28591 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28595 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28600 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  28604 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  28608 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28612 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28616 */     // MIs[2] src
     /*  28616 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  28621 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*  28625 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28627 */     // (or:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }))  =>  (T1MSKC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::T1MSKC64rr),
     /*  28630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  28636 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28639 */     GIR_RootConstrainSelectedInstOperands,
     /*  28640 */     // GIR_Coverage, 17367,
     /*  28640 */     GIR_EraseRootFromParent_Done,
     /*  28641 */   // Label 739: @28641
     /*  28641 */   GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(28715), // Rule ID 17353 //
     /*  28646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28672 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28676 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28680 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28684 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28688 */     // MIs[2] src
     /*  28688 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  28693 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*  28697 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  28701 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28703 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src, (xor:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), -1:{ *:[i64] }))  =>  (BLCI64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI64rr),
     /*  28706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28708 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28710 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28713 */     GIR_RootConstrainSelectedInstOperands,
     /*  28714 */     // GIR_Coverage, 17353,
     /*  28714 */     GIR_EraseRootFromParent_Done,
     /*  28715 */   // Label 740: @28715
     /*  28715 */   GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(28773), // Rule ID 25000 //
     /*  28720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28739 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28743 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28748 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  28752 */     // MIs[0] src
     /*  28752 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  28757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28759 */     // (or:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), GR64:{ *:[i64] }:$src)  =>  (BLCS64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCS64rr),
     /*  28762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  28768 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28771 */     GIR_RootConstrainSelectedInstOperands,
     /*  28772 */     // GIR_Coverage, 25000,
     /*  28772 */     GIR_EraseRootFromParent_Done,
     /*  28773 */   // Label 741: @28773
     /*  28773 */   GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(28831), // Rule ID 25002 //
     /*  28778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28797 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28801 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28806 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  28810 */     // MIs[0] src
     /*  28810 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  28815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28817 */     // (or:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), GR64:{ *:[i64] }:$src)  =>  (BLSFILL64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSFILL64rr),
     /*  28820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  28826 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28829 */     GIR_RootConstrainSelectedInstOperands,
     /*  28830 */     // GIR_Coverage, 25002,
     /*  28830 */     GIR_EraseRootFromParent_Done,
     /*  28831 */   // Label 742: @28831
     /*  28831 */   GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(28940), // Rule ID 26049 //
     /*  28836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  28851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28855 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  28859 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  28863 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  28868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28874 */     // (or:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, GR8:{ *:[i8] }:$src2), GR64:{ *:[i64] }:$src1)  =>  (BTS64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  28874 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  28877 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  28881 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  28886 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  28888 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  28891 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  28895 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  28900 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  28903 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  28907 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  28910 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  28915 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  28920 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  28925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTS64rr),
     /*  28928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28930 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  28932 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  28935 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28938 */     GIR_RootConstrainSelectedInstOperands,
     /*  28939 */     // GIR_Coverage, 26049,
     /*  28939 */     GIR_EraseRootFromParent_Done,
     /*  28940 */   // Label 743: @28940
     /*  28940 */   GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(28998), // Rule ID 24994 //
     /*  28945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  28960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28964 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28968 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  28972 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28977 */     // MIs[0] src
     /*  28977 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  28982 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28984 */     // (or:{ *:[i64] } (sub:{ *:[i64] } -2:{ *:[i64] }, GR64:{ *:[i64] }:$src), GR64:{ *:[i64] }:$src)  =>  (BLCI64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI64rr),
     /*  28987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  28993 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28996 */     GIR_RootConstrainSelectedInstOperands,
     /*  28997 */     // GIR_Coverage, 24994,
     /*  28997 */     GIR_EraseRootFromParent_Done,
     /*  28998 */   // Label 744: @28998
     /*  28998 */   GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(29052), // Rule ID 17361 //
     /*  29003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  29006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  29009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  29025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  29029 */     // MIs[1] src
     /*  29029 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  29034 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  29038 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29040 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src, (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }))  =>  (BLCS64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  29040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCS64rr),
     /*  29043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29045 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29047 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  29050 */     GIR_RootConstrainSelectedInstOperands,
     /*  29051 */     // GIR_Coverage, 17361,
     /*  29051 */     GIR_EraseRootFromParent_Done,
     /*  29052 */   // Label 745: @29052
     /*  29052 */   GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(29106), // Rule ID 17363 //
     /*  29057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  29060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  29063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  29079 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  29083 */     // MIs[1] src
     /*  29083 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  29088 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  29092 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29094 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src, (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (BLSFILL64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  29094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSFILL64rr),
     /*  29097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29099 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29101 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  29104 */     GIR_RootConstrainSelectedInstOperands,
     /*  29105 */     // GIR_Coverage, 17363,
     /*  29105 */     GIR_EraseRootFromParent_Done,
     /*  29106 */   // Label 746: @29106
     /*  29106 */   GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(29215), // Rule ID 22787 //
     /*  29111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  29114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  29130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  29134 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  29138 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  29142 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  29147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29149 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src1, (shl:{ *:[i64] } 1:{ *:[i64] }, GR8:{ *:[i8] }:$src2))  =>  (BTS64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  29149 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  29152 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29156 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  29163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  29166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  29170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29175 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  29178 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  29182 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  29185 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  29190 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  29195 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  29200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTS64rr),
     /*  29203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29205 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  29207 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29210 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  29213 */     GIR_RootConstrainSelectedInstOperands,
     /*  29214 */     // GIR_Coverage, 22787,
     /*  29214 */     GIR_EraseRootFromParent_Done,
     /*  29215 */   // Label 747: @29215
     /*  29215 */   GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(29269), // Rule ID 17355 //
     /*  29220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  29223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  29226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  29242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  29246 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  29250 */     // MIs[1] src
     /*  29250 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  29255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29257 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src, (sub:{ *:[i64] } -2:{ *:[i64] }, GR64:{ *:[i64] }:$src))  =>  (BLCI64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  29257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI64rr),
     /*  29260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29262 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29264 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  29267 */     GIR_RootConstrainSelectedInstOperands,
     /*  29268 */     // GIR_Coverage, 17355,
     /*  29268 */     GIR_EraseRootFromParent_Done,
     /*  29269 */   // Label 748: @29269
     /*  29269 */   GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(29317), // Rule ID 22837 //
     /*  29274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  29277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  29280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29296 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  29300 */     // MIs[1] Operand 1
     /*  29300 */     // No operand predicates
     /*  29300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29302 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (OR64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  29302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64ri32),
     /*  29305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29307 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  29309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  29312 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  29315 */     GIR_RootConstrainSelectedInstOperands,
     /*  29316 */     // GIR_Coverage, 22837,
     /*  29316 */     GIR_EraseRootFromParent_Done,
     /*  29317 */   // Label 749: @29317
     /*  29317 */   GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(29365), // Rule ID 22927 //
     /*  29322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  29325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  29328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29332 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29344 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  29348 */     // MIs[1] Operand 1
     /*  29348 */     // No operand predicates
     /*  29348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29350 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (OR64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  29350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64ri32_ND),
     /*  29353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29355 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  29357 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  29360 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  29363 */     GIR_RootConstrainSelectedInstOperands,
     /*  29364 */     // GIR_Coverage, 22927,
     /*  29364 */     GIR_EraseRootFromParent_Done,
     /*  29365 */   // Label 750: @29365
     /*  29365 */   GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(29401), // Rule ID 22829 //
     /*  29370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  29373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  29376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29380 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29388 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (OR64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  29388 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR64rr),
     /*  29393 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  29399 */     GIR_RootConstrainSelectedInstOperands,
     /*  29400 */     // GIR_Coverage, 22829,
     /*  29400 */     GIR_Done,
     /*  29401 */   // Label 751: @29401
     /*  29401 */   GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(29437), // Rule ID 22919 //
     /*  29406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  29409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  29412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29424 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (OR64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  29424 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR64rr_ND),
     /*  29429 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  29435 */     GIR_RootConstrainSelectedInstOperands,
     /*  29436 */     // GIR_Coverage, 22919,
     /*  29436 */     GIR_Done,
     /*  29437 */   // Label 752: @29437
     /*  29437 */   GIM_Reject,
     /*  29438 */ // Label 730: @29438
     /*  29438 */ GIM_Reject,
     /*  29439 */ // Label 667: @29439
     /*  29439 */ GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(29538), // Rule ID 19493 //
     /*  29444 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  29447 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  29450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  29454 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  29458 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  29462 */   // (or:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, VK2:{ *:[v2i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  29462 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  29465 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29469 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29474 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  29478 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  29483 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  29486 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29490 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29495 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  29499 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  29504 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  29507 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KORWkk),
     /*  29511 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29516 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  29519 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  29522 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  29524 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29527 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29529 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29532 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  29537 */   // GIR_Coverage, 19493,
     /*  29537 */   GIR_EraseRootFromParent_Done,
     /*  29538 */ // Label 753: @29538
     /*  29538 */ GIM_Reject,
     /*  29539 */ // Label 668: @29539
     /*  29539 */ GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(29880),
     /*  29544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  29547 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  29550 */   GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(29612), // Rule ID 23363 //
     /*  29555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  29558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  29570 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  29573 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  29577 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  29581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29587 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  29594 */     // (or:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2i64] }:$src1)  =>  (VPORrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  29594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORrm),
     /*  29597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29599 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  29601 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  29605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  29610 */     GIR_RootConstrainSelectedInstOperands,
     /*  29611 */     // GIR_Coverage, 23363,
     /*  29611 */     GIR_EraseRootFromParent_Done,
     /*  29612 */   // Label 755: @29612
     /*  29612 */   GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(29674), // Rule ID 24185 //
     /*  29617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  29620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  29624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  29632 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  29635 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  29639 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  29643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  29647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29649 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  29656 */     // (or:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2i64] }:$src1)  =>  (VPORQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  29656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rm),
     /*  29659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29661 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  29663 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  29667 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  29672 */     GIR_RootConstrainSelectedInstOperands,
     /*  29673 */     // GIR_Coverage, 24185,
     /*  29673 */     GIR_EraseRootFromParent_Done,
     /*  29674 */   // Label 756: @29674
     /*  29674 */   GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(29736), // Rule ID 2117 //
     /*  29679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  29682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  29698 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  29701 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  29705 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  29709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29711 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  29718 */     // (or:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  29718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORrm),
     /*  29721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29723 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  29725 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  29729 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  29734 */     GIR_RootConstrainSelectedInstOperands,
     /*  29735 */     // GIR_Coverage, 2117,
     /*  29735 */     GIR_EraseRootFromParent_Done,
     /*  29736 */   // Label 757: @29736
     /*  29736 */   GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(29798), // Rule ID 5761 //
     /*  29741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  29744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  29748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  29752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  29760 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  29763 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  29767 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  29771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29773 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  29780 */     // (or:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  29780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rm),
     /*  29783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29785 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  29787 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  29791 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  29796 */     GIR_RootConstrainSelectedInstOperands,
     /*  29797 */     // GIR_Coverage, 5761,
     /*  29797 */     GIR_EraseRootFromParent_Done,
     /*  29798 */   // Label 758: @29798
     /*  29798 */   GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(29825), // Rule ID 2116 //
     /*  29803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  29806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29818 */     // (or:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VPORrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  29818 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORrr),
     /*  29823 */     GIR_RootConstrainSelectedInstOperands,
     /*  29824 */     // GIR_Coverage, 2116,
     /*  29824 */     GIR_Done,
     /*  29825 */   // Label 759: @29825
     /*  29825 */   GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(29852), // Rule ID 2118 //
     /*  29830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  29833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29845 */     // (or:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (PORrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  29845 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PORrr),
     /*  29850 */     GIR_RootConstrainSelectedInstOperands,
     /*  29851 */     // GIR_Coverage, 2118,
     /*  29851 */     GIR_Done,
     /*  29852 */   // Label 760: @29852
     /*  29852 */   GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(29879), // Rule ID 5758 //
     /*  29857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  29860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  29864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  29868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  29872 */     // (or:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPORQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*  29872 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rr),
     /*  29877 */     GIR_RootConstrainSelectedInstOperands,
     /*  29878 */     // GIR_Coverage, 5758,
     /*  29878 */     GIR_Done,
     /*  29879 */   // Label 761: @29879
     /*  29879 */   GIM_Reject,
     /*  29880 */ // Label 754: @29880
     /*  29880 */ GIM_Reject,
     /*  29881 */ // Label 669: @29881
     /*  29881 */ GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(29980), // Rule ID 19494 //
     /*  29886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  29889 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  29892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  29896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  29900 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  29904 */   // (or:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, VK4:{ *:[v4i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /*  29904 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  29907 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29911 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29916 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  29920 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  29925 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  29928 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29932 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29937 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  29941 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  29946 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  29949 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KORWkk),
     /*  29953 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29958 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  29961 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  29964 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  29966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29969 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29971 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29974 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  29979 */   // GIR_Coverage, 19494,
     /*  29979 */   GIR_EraseRootFromParent_Done,
     /*  29980 */ // Label 762: @29980
     /*  29980 */ GIM_Reject,
     /*  29981 */ // Label 670: @29981
     /*  29981 */ GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(30322),
     /*  29986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29989 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29992 */   GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(30054), // Rule ID 24203 //
     /*  29997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  30000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  30004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30012 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30015 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30019 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  30027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30029 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30036 */     // (or:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4i32] }:$src1)  =>  (VPORDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORDZ128rm),
     /*  30039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30041 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  30043 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30047 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30052 */     GIR_RootConstrainSelectedInstOperands,
     /*  30053 */     // GIR_Coverage, 24203,
     /*  30053 */     GIR_EraseRootFromParent_Done,
     /*  30054 */   // Label 764: @30054
     /*  30054 */   GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(30116), // Rule ID 25256 //
     /*  30059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  30062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30074 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30077 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30081 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30091 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30098 */     // (or:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1)  =>  (VPORrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORrm),
     /*  30101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30103 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  30105 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30109 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30114 */     GIR_RootConstrainSelectedInstOperands,
     /*  30115 */     // GIR_Coverage, 25256,
     /*  30115 */     GIR_EraseRootFromParent_Done,
     /*  30116 */   // Label 765: @30116
     /*  30116 */   GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(30178), // Rule ID 5788 //
     /*  30121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  30124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  30128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  30132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30140 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30143 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30147 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30153 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30160 */     // (or:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORDZ128rm),
     /*  30163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30165 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  30167 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30171 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30176 */     GIR_RootConstrainSelectedInstOperands,
     /*  30177 */     // GIR_Coverage, 5788,
     /*  30177 */     GIR_EraseRootFromParent_Done,
     /*  30178 */   // Label 766: @30178
     /*  30178 */   GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(30240), // Rule ID 18163 //
     /*  30183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  30186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30202 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30205 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30209 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30215 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30222 */     // (or:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORrm),
     /*  30225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30227 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  30229 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30233 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30238 */     GIR_RootConstrainSelectedInstOperands,
     /*  30239 */     // GIR_Coverage, 18163,
     /*  30239 */     GIR_EraseRootFromParent_Done,
     /*  30240 */   // Label 767: @30240
     /*  30240 */   GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(30267), // Rule ID 5785 //
     /*  30245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  30248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  30252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  30256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  30260 */     // (or:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPORDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /*  30260 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORDZ128rr),
     /*  30265 */     GIR_RootConstrainSelectedInstOperands,
     /*  30266 */     // GIR_Coverage, 5785,
     /*  30266 */     GIR_Done,
     /*  30267 */   // Label 768: @30267
     /*  30267 */   GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(30294), // Rule ID 18151 //
     /*  30272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  30275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30287 */     // (or:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPORrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  30287 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORrr),
     /*  30292 */     GIR_RootConstrainSelectedInstOperands,
     /*  30293 */     // GIR_Coverage, 18151,
     /*  30293 */     GIR_Done,
     /*  30294 */   // Label 769: @30294
     /*  30294 */   GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(30321), // Rule ID 18175 //
     /*  30299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  30302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30314 */     // (or:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PORrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  30314 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PORrr),
     /*  30319 */     GIR_RootConstrainSelectedInstOperands,
     /*  30320 */     // GIR_Coverage, 18175,
     /*  30320 */     GIR_Done,
     /*  30321 */   // Label 770: @30321
     /*  30321 */   GIM_Reject,
     /*  30322 */ // Label 763: @30322
     /*  30322 */ GIM_Reject,
     /*  30323 */ // Label 671: @30323
     /*  30323 */ GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(30788),
     /*  30328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  30331 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  30334 */   GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(30396), // Rule ID 23365 //
     /*  30339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  30342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30354 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30357 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30361 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30371 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30378 */     // (or:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4i64] }:$src1)  =>  (VPORYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORYrm),
     /*  30381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30383 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  30385 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30389 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30394 */     GIR_RootConstrainSelectedInstOperands,
     /*  30395 */     // GIR_Coverage, 23365,
     /*  30395 */     GIR_EraseRootFromParent_Done,
     /*  30396 */   // Label 772: @30396
     /*  30396 */   GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(30458), // Rule ID 24179 //
     /*  30401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  30404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  30408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30416 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30419 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30423 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  30431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30433 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30440 */     // (or:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4i64] }:$src1)  =>  (VPORQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rm),
     /*  30443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30445 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  30447 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30451 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30456 */     GIR_RootConstrainSelectedInstOperands,
     /*  30457 */     // GIR_Coverage, 24179,
     /*  30457 */     GIR_EraseRootFromParent_Done,
     /*  30458 */   // Label 773: @30458
     /*  30458 */   GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(30520), // Rule ID 25246 //
     /*  30463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  30466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30478 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30481 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30485 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30495 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30502 */     // (or:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4i64] }:$src1)  =>  (VORPSYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VORPSYrm),
     /*  30505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30507 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  30509 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30513 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30518 */     GIR_RootConstrainSelectedInstOperands,
     /*  30519 */     // GIR_Coverage, 25246,
     /*  30519 */     GIR_EraseRootFromParent_Done,
     /*  30520 */   // Label 774: @30520
     /*  30520 */   GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(30582), // Rule ID 2121 //
     /*  30525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  30528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30544 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30547 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30551 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30557 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30564 */     // (or:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORYrm),
     /*  30567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30569 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  30571 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30575 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30580 */     GIR_RootConstrainSelectedInstOperands,
     /*  30581 */     // GIR_Coverage, 2121,
     /*  30581 */     GIR_EraseRootFromParent_Done,
     /*  30582 */   // Label 775: @30582
     /*  30582 */   GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(30644), // Rule ID 5752 //
     /*  30587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  30590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  30594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  30598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30606 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30609 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30613 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30619 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30626 */     // (or:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rm),
     /*  30629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30631 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  30633 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30637 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30642 */     GIR_RootConstrainSelectedInstOperands,
     /*  30643 */     // GIR_Coverage, 5752,
     /*  30643 */     GIR_EraseRootFromParent_Done,
     /*  30644 */   // Label 776: @30644
     /*  30644 */   GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(30706), // Rule ID 18137 //
     /*  30649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  30652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30668 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30671 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30675 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30681 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30688 */     // (or:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VORPSYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VORPSYrm),
     /*  30691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30693 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  30695 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30699 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30704 */     GIR_RootConstrainSelectedInstOperands,
     /*  30705 */     // GIR_Coverage, 18137,
     /*  30705 */     GIR_EraseRootFromParent_Done,
     /*  30706 */   // Label 777: @30706
     /*  30706 */   GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(30733), // Rule ID 2120 //
     /*  30711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  30714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30726 */     // (or:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VPORYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  30726 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORYrr),
     /*  30731 */     GIR_RootConstrainSelectedInstOperands,
     /*  30732 */     // GIR_Coverage, 2120,
     /*  30732 */     GIR_Done,
     /*  30733 */   // Label 778: @30733
     /*  30733 */   GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(30760), // Rule ID 5749 //
     /*  30738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  30741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  30745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  30749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  30753 */     // (or:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPORQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*  30753 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rr),
     /*  30758 */     GIR_RootConstrainSelectedInstOperands,
     /*  30759 */     // GIR_Coverage, 5749,
     /*  30759 */     GIR_Done,
     /*  30760 */   // Label 779: @30760
     /*  30760 */   GIM_Try, /*On fail goto*//*Label 780*/ GIMT_Encode4(30787), // Rule ID 18121 //
     /*  30765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  30768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30780 */     // (or:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VORPSYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  30780 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VORPSYrr),
     /*  30785 */     GIR_RootConstrainSelectedInstOperands,
     /*  30786 */     // GIR_Coverage, 18121,
     /*  30786 */     GIR_Done,
     /*  30787 */   // Label 780: @30787
     /*  30787 */   GIM_Reject,
     /*  30788 */ // Label 771: @30788
     /*  30788 */ GIM_Reject,
     /*  30789 */ // Label 672: @30789
     /*  30789 */ GIM_Try, /*On fail goto*//*Label 781*/ GIMT_Encode4(30912),
     /*  30794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  30797 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  30800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  30804 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  30808 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  30812 */   GIM_Try, /*On fail goto*//*Label 782*/ GIMT_Encode4(30827), // Rule ID 4419 //
     /*  30817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  30820 */     // (or:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (KORBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /*  30820 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KORBkk),
     /*  30825 */     GIR_RootConstrainSelectedInstOperands,
     /*  30826 */     // GIR_Coverage, 4419,
     /*  30826 */     GIR_Done,
     /*  30827 */   // Label 782: @30827
     /*  30827 */   GIM_Try, /*On fail goto*//*Label 783*/ GIMT_Encode4(30911), // Rule ID 19491 //
     /*  30832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /*  30835 */     // (or:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /*  30835 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  30838 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30842 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  30847 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  30851 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  30856 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  30859 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30863 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  30868 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  30872 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  30877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  30880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KORWkk),
     /*  30884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  30889 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  30892 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  30895 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  30897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30902 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  30905 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  30910 */     // GIR_Coverage, 19491,
     /*  30910 */     GIR_EraseRootFromParent_Done,
     /*  30911 */   // Label 783: @30911
     /*  30911 */   GIM_Reject,
     /*  30912 */ // Label 781: @30912
     /*  30912 */ GIM_Reject,
     /*  30913 */ // Label 673: @30913
     /*  30913 */ GIM_Try, /*On fail goto*//*Label 784*/ GIMT_Encode4(31254),
     /*  30918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30921 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  30924 */   GIM_Try, /*On fail goto*//*Label 785*/ GIMT_Encode4(30986), // Rule ID 25255 //
     /*  30929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  30932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30944 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30947 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30951 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30961 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30968 */     // (or:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPORrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORrm),
     /*  30971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30973 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  30975 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30979 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30984 */     GIR_RootConstrainSelectedInstOperands,
     /*  30985 */     // GIR_Coverage, 25255,
     /*  30985 */     GIR_EraseRootFromParent_Done,
     /*  30986 */   // Label 785: @30986
     /*  30986 */   GIM_Try, /*On fail goto*//*Label 786*/ GIMT_Encode4(31048), // Rule ID 25435 //
     /*  30991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  30994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  30998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31006 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31009 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31013 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  31021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31023 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31030 */     // (or:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPORQZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rm),
     /*  31033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31035 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  31037 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31041 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31046 */     GIR_RootConstrainSelectedInstOperands,
     /*  31047 */     // GIR_Coverage, 25435,
     /*  31047 */     GIR_EraseRootFromParent_Done,
     /*  31048 */   // Label 786: @31048
     /*  31048 */   GIM_Try, /*On fail goto*//*Label 787*/ GIMT_Encode4(31110), // Rule ID 18162 //
     /*  31053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  31056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31072 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31075 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31079 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31085 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31092 */     // (or:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORrm),
     /*  31095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31097 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  31099 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31103 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31108 */     GIR_RootConstrainSelectedInstOperands,
     /*  31109 */     // GIR_Coverage, 18162,
     /*  31109 */     GIR_EraseRootFromParent_Done,
     /*  31110 */   // Label 787: @31110
     /*  31110 */   GIM_Try, /*On fail goto*//*Label 788*/ GIMT_Encode4(31172), // Rule ID 20027 //
     /*  31115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  31118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  31122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  31126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31134 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31137 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31141 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31147 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31154 */     // (or:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORQZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rm),
     /*  31157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31159 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  31161 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31165 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31170 */     GIR_RootConstrainSelectedInstOperands,
     /*  31171 */     // GIR_Coverage, 20027,
     /*  31171 */     GIR_EraseRootFromParent_Done,
     /*  31172 */   // Label 788: @31172
     /*  31172 */   GIM_Try, /*On fail goto*//*Label 789*/ GIMT_Encode4(31199), // Rule ID 18150 //
     /*  31177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  31180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31192 */     // (or:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPORrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  31192 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORrr),
     /*  31197 */     GIR_RootConstrainSelectedInstOperands,
     /*  31198 */     // GIR_Coverage, 18150,
     /*  31198 */     GIR_Done,
     /*  31199 */   // Label 789: @31199
     /*  31199 */   GIM_Try, /*On fail goto*//*Label 790*/ GIMT_Encode4(31226), // Rule ID 18174 //
     /*  31204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  31207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31219 */     // (or:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PORrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  31219 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PORrr),
     /*  31224 */     GIR_RootConstrainSelectedInstOperands,
     /*  31225 */     // GIR_Coverage, 18174,
     /*  31225 */     GIR_Done,
     /*  31226 */   // Label 790: @31226
     /*  31226 */   GIM_Try, /*On fail goto*//*Label 791*/ GIMT_Encode4(31253), // Rule ID 20019 //
     /*  31231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  31234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  31238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  31242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  31246 */     // (or:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPORQZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /*  31246 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rr),
     /*  31251 */     GIR_RootConstrainSelectedInstOperands,
     /*  31252 */     // GIR_Coverage, 20019,
     /*  31252 */     GIR_Done,
     /*  31253 */   // Label 791: @31253
     /*  31253 */   GIM_Reject,
     /*  31254 */ // Label 784: @31254
     /*  31254 */ GIM_Reject,
     /*  31255 */ // Label 674: @31255
     /*  31255 */ GIM_Try, /*On fail goto*//*Label 792*/ GIMT_Encode4(31720),
     /*  31260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  31263 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  31266 */   GIM_Try, /*On fail goto*//*Label 793*/ GIMT_Encode4(31328), // Rule ID 24197 //
     /*  31271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  31274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  31278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31286 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31289 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31293 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  31301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31303 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31310 */     // (or:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8i32] }:$src1)  =>  (VPORDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORDZ256rm),
     /*  31313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31315 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  31317 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31321 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31326 */     GIR_RootConstrainSelectedInstOperands,
     /*  31327 */     // GIR_Coverage, 24197,
     /*  31327 */     GIR_EraseRootFromParent_Done,
     /*  31328 */   // Label 793: @31328
     /*  31328 */   GIM_Try, /*On fail goto*//*Label 794*/ GIMT_Encode4(31390), // Rule ID 25235 //
     /*  31333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  31336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31348 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31351 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31355 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31365 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31372 */     // (or:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VPORYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORYrm),
     /*  31375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31377 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  31379 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31383 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31388 */     GIR_RootConstrainSelectedInstOperands,
     /*  31389 */     // GIR_Coverage, 25235,
     /*  31389 */     GIR_EraseRootFromParent_Done,
     /*  31390 */   // Label 794: @31390
     /*  31390 */   GIM_Try, /*On fail goto*//*Label 795*/ GIMT_Encode4(31452), // Rule ID 25245 //
     /*  31395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  31398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31410 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31413 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31417 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31427 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31434 */     // (or:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VORPSYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VORPSYrm),
     /*  31437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31439 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  31441 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31445 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31450 */     GIR_RootConstrainSelectedInstOperands,
     /*  31451 */     // GIR_Coverage, 25245,
     /*  31451 */     GIR_EraseRootFromParent_Done,
     /*  31452 */   // Label 795: @31452
     /*  31452 */   GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(31514), // Rule ID 5779 //
     /*  31457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  31460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  31464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  31468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31476 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31479 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31483 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31489 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31496 */     // (or:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORDZ256rm),
     /*  31499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31501 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  31503 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31507 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31512 */     GIR_RootConstrainSelectedInstOperands,
     /*  31513 */     // GIR_Coverage, 5779,
     /*  31513 */     GIR_EraseRootFromParent_Done,
     /*  31514 */   // Label 796: @31514
     /*  31514 */   GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(31576), // Rule ID 18107 //
     /*  31519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  31522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31538 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31541 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31545 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31551 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31558 */     // (or:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORYrm),
     /*  31561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31563 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  31565 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31569 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31574 */     GIR_RootConstrainSelectedInstOperands,
     /*  31575 */     // GIR_Coverage, 18107,
     /*  31575 */     GIR_EraseRootFromParent_Done,
     /*  31576 */   // Label 797: @31576
     /*  31576 */   GIM_Try, /*On fail goto*//*Label 798*/ GIMT_Encode4(31638), // Rule ID 18136 //
     /*  31581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  31584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31600 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31603 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31607 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31613 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31620 */     // (or:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VORPSYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VORPSYrm),
     /*  31623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31625 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  31627 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31631 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31636 */     GIR_RootConstrainSelectedInstOperands,
     /*  31637 */     // GIR_Coverage, 18136,
     /*  31637 */     GIR_EraseRootFromParent_Done,
     /*  31638 */   // Label 798: @31638
     /*  31638 */   GIM_Try, /*On fail goto*//*Label 799*/ GIMT_Encode4(31665), // Rule ID 5776 //
     /*  31643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  31646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  31650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  31654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  31658 */     // (or:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPORDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /*  31658 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORDZ256rr),
     /*  31663 */     GIR_RootConstrainSelectedInstOperands,
     /*  31664 */     // GIR_Coverage, 5776,
     /*  31664 */     GIR_Done,
     /*  31665 */   // Label 799: @31665
     /*  31665 */   GIM_Try, /*On fail goto*//*Label 800*/ GIMT_Encode4(31692), // Rule ID 18095 //
     /*  31670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  31673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31677 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31685 */     // (or:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPORYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  31685 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORYrr),
     /*  31690 */     GIR_RootConstrainSelectedInstOperands,
     /*  31691 */     // GIR_Coverage, 18095,
     /*  31691 */     GIR_Done,
     /*  31692 */   // Label 800: @31692
     /*  31692 */   GIM_Try, /*On fail goto*//*Label 801*/ GIMT_Encode4(31719), // Rule ID 18120 //
     /*  31697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  31700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31712 */     // (or:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VORPSYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  31712 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VORPSYrr),
     /*  31717 */     GIR_RootConstrainSelectedInstOperands,
     /*  31718 */     // GIR_Coverage, 18120,
     /*  31718 */     GIR_Done,
     /*  31719 */   // Label 801: @31719
     /*  31719 */   GIM_Reject,
     /*  31720 */ // Label 792: @31720
     /*  31720 */ GIM_Reject,
     /*  31721 */ // Label 675: @31721
     /*  31721 */ GIM_Try, /*On fail goto*//*Label 802*/ GIMT_Encode4(31876),
     /*  31726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  31729 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  31732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  31736 */   GIM_Try, /*On fail goto*//*Label 803*/ GIMT_Encode4(31794), // Rule ID 24173 //
     /*  31741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  31744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31752 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31755 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31759 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  31767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31769 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31776 */     // (or:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8i64] }:$src1)  =>  (VPORQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZrm),
     /*  31779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31781 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  31783 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31787 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31792 */     GIR_RootConstrainSelectedInstOperands,
     /*  31793 */     // GIR_Coverage, 24173,
     /*  31793 */     GIR_EraseRootFromParent_Done,
     /*  31794 */   // Label 803: @31794
     /*  31794 */   GIM_Try, /*On fail goto*//*Label 804*/ GIMT_Encode4(31852), // Rule ID 5743 //
     /*  31799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  31802 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  31806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31814 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31817 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31821 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31827 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31834 */     // (or:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZrm),
     /*  31837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31839 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  31841 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31845 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31850 */     GIR_RootConstrainSelectedInstOperands,
     /*  31851 */     // GIR_Coverage, 5743,
     /*  31851 */     GIR_EraseRootFromParent_Done,
     /*  31852 */   // Label 804: @31852
     /*  31852 */   GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(31875), // Rule ID 5740 //
     /*  31857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  31860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  31864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  31868 */     // (or:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPORQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  31868 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZrr),
     /*  31873 */     GIR_RootConstrainSelectedInstOperands,
     /*  31874 */     // GIR_Coverage, 5740,
     /*  31874 */     GIR_Done,
     /*  31875 */   // Label 805: @31875
     /*  31875 */   GIM_Reject,
     /*  31876 */ // Label 802: @31876
     /*  31876 */ GIM_Reject,
     /*  31877 */ // Label 676: @31877
     /*  31877 */ GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(31910), // Rule ID 4420 //
     /*  31882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  31885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  31888 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  31891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  31895 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  31899 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  31903 */   // (or:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)  =>  (KORWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /*  31903 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KORWkk),
     /*  31908 */   GIR_RootConstrainSelectedInstOperands,
     /*  31909 */   // GIR_Coverage, 4420,
     /*  31909 */   GIR_Done,
     /*  31910 */ // Label 806: @31910
     /*  31910 */ GIM_Reject,
     /*  31911 */ // Label 677: @31911
     /*  31911 */ GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(32252),
     /*  31916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31919 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  31922 */   GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(31984), // Rule ID 25254 //
     /*  31927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  31930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31942 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31945 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31949 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31959 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31966 */     // (or:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPORrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORrm),
     /*  31969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31971 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  31973 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31977 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31982 */     GIR_RootConstrainSelectedInstOperands,
     /*  31983 */     // GIR_Coverage, 25254,
     /*  31983 */     GIR_EraseRootFromParent_Done,
     /*  31984 */   // Label 808: @31984
     /*  31984 */   GIM_Try, /*On fail goto*//*Label 809*/ GIMT_Encode4(32046), // Rule ID 25434 //
     /*  31989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  31992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  31996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32004 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32007 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32011 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  32019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32021 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32028 */     // (or:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPORQZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rm),
     /*  32031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32033 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  32035 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32039 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32044 */     GIR_RootConstrainSelectedInstOperands,
     /*  32045 */     // GIR_Coverage, 25434,
     /*  32045 */     GIR_EraseRootFromParent_Done,
     /*  32046 */   // Label 809: @32046
     /*  32046 */   GIM_Try, /*On fail goto*//*Label 810*/ GIMT_Encode4(32108), // Rule ID 18161 //
     /*  32051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  32054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  32058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  32062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32070 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32073 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32077 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32083 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32090 */     // (or:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORrm),
     /*  32093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32095 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  32097 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32101 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32106 */     GIR_RootConstrainSelectedInstOperands,
     /*  32107 */     // GIR_Coverage, 18161,
     /*  32107 */     GIR_EraseRootFromParent_Done,
     /*  32108 */   // Label 810: @32108
     /*  32108 */   GIM_Try, /*On fail goto*//*Label 811*/ GIMT_Encode4(32170), // Rule ID 20026 //
     /*  32113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  32116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  32120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  32124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32132 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32135 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32139 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32145 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32152 */     // (or:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORQZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rm),
     /*  32155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32157 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  32159 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32163 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32168 */     GIR_RootConstrainSelectedInstOperands,
     /*  32169 */     // GIR_Coverage, 20026,
     /*  32169 */     GIR_EraseRootFromParent_Done,
     /*  32170 */   // Label 811: @32170
     /*  32170 */   GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(32197), // Rule ID 18149 //
     /*  32175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  32178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  32182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  32186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  32190 */     // (or:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPORrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  32190 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORrr),
     /*  32195 */     GIR_RootConstrainSelectedInstOperands,
     /*  32196 */     // GIR_Coverage, 18149,
     /*  32196 */     GIR_Done,
     /*  32197 */   // Label 812: @32197
     /*  32197 */   GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(32224), // Rule ID 18173 //
     /*  32202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  32205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  32209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  32213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  32217 */     // (or:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PORrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  32217 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PORrr),
     /*  32222 */     GIR_RootConstrainSelectedInstOperands,
     /*  32223 */     // GIR_Coverage, 18173,
     /*  32223 */     GIR_Done,
     /*  32224 */   // Label 813: @32224
     /*  32224 */   GIM_Try, /*On fail goto*//*Label 814*/ GIMT_Encode4(32251), // Rule ID 20018 //
     /*  32229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  32232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  32236 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  32240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  32244 */     // (or:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPORQZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /*  32244 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rr),
     /*  32249 */     GIR_RootConstrainSelectedInstOperands,
     /*  32250 */     // GIR_Coverage, 20018,
     /*  32250 */     GIR_Done,
     /*  32251 */   // Label 814: @32251
     /*  32251 */   GIM_Reject,
     /*  32252 */ // Label 807: @32252
     /*  32252 */ GIM_Reject,
     /*  32253 */ // Label 678: @32253
     /*  32253 */ GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(32718),
     /*  32258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  32261 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  32264 */   GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(32326), // Rule ID 25234 //
     /*  32269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  32272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32284 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32287 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32291 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32301 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32308 */     // (or:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPORYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORYrm),
     /*  32311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32313 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  32315 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32319 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32324 */     GIR_RootConstrainSelectedInstOperands,
     /*  32325 */     // GIR_Coverage, 25234,
     /*  32325 */     GIR_EraseRootFromParent_Done,
     /*  32326 */   // Label 816: @32326
     /*  32326 */   GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(32388), // Rule ID 25244 //
     /*  32331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  32334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32346 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32349 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32353 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32363 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32370 */     // (or:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VORPSYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VORPSYrm),
     /*  32373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32375 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  32377 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32381 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32386 */     GIR_RootConstrainSelectedInstOperands,
     /*  32387 */     // GIR_Coverage, 25244,
     /*  32387 */     GIR_EraseRootFromParent_Done,
     /*  32388 */   // Label 817: @32388
     /*  32388 */   GIM_Try, /*On fail goto*//*Label 818*/ GIMT_Encode4(32450), // Rule ID 25441 //
     /*  32393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  32396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  32400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32408 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32411 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32415 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  32423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32425 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32432 */     // (or:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPORQZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rm),
     /*  32435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32437 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  32439 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32443 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32448 */     GIR_RootConstrainSelectedInstOperands,
     /*  32449 */     // GIR_Coverage, 25441,
     /*  32449 */     GIR_EraseRootFromParent_Done,
     /*  32450 */   // Label 818: @32450
     /*  32450 */   GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(32512), // Rule ID 18106 //
     /*  32455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  32458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32474 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32477 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32481 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32487 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32494 */     // (or:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORYrm),
     /*  32497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32499 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  32501 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32505 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32510 */     GIR_RootConstrainSelectedInstOperands,
     /*  32511 */     // GIR_Coverage, 18106,
     /*  32511 */     GIR_EraseRootFromParent_Done,
     /*  32512 */   // Label 819: @32512
     /*  32512 */   GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(32574), // Rule ID 18135 //
     /*  32517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  32520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32536 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32539 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32543 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32549 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32556 */     // (or:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VORPSYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VORPSYrm),
     /*  32559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32561 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  32563 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32567 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32572 */     GIR_RootConstrainSelectedInstOperands,
     /*  32573 */     // GIR_Coverage, 18135,
     /*  32573 */     GIR_EraseRootFromParent_Done,
     /*  32574 */   // Label 820: @32574
     /*  32574 */   GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(32636), // Rule ID 20043 //
     /*  32579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  32582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  32586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  32590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32598 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32601 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32605 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32611 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32618 */     // (or:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORQZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rm),
     /*  32621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32623 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  32625 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32629 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32634 */     GIR_RootConstrainSelectedInstOperands,
     /*  32635 */     // GIR_Coverage, 20043,
     /*  32635 */     GIR_EraseRootFromParent_Done,
     /*  32636 */   // Label 821: @32636
     /*  32636 */   GIM_Try, /*On fail goto*//*Label 822*/ GIMT_Encode4(32663), // Rule ID 18094 //
     /*  32641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  32644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32656 */     // (or:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPORYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  32656 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORYrr),
     /*  32661 */     GIR_RootConstrainSelectedInstOperands,
     /*  32662 */     // GIR_Coverage, 18094,
     /*  32662 */     GIR_Done,
     /*  32663 */   // Label 822: @32663
     /*  32663 */   GIM_Try, /*On fail goto*//*Label 823*/ GIMT_Encode4(32690), // Rule ID 18119 //
     /*  32668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  32671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32683 */     // (or:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VORPSYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  32683 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VORPSYrr),
     /*  32688 */     GIR_RootConstrainSelectedInstOperands,
     /*  32689 */     // GIR_Coverage, 18119,
     /*  32689 */     GIR_Done,
     /*  32690 */   // Label 823: @32690
     /*  32690 */   GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(32717), // Rule ID 20035 //
     /*  32695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  32698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  32702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  32706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  32710 */     // (or:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPORQZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /*  32710 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rr),
     /*  32715 */     GIR_RootConstrainSelectedInstOperands,
     /*  32716 */     // GIR_Coverage, 20035,
     /*  32716 */     GIR_Done,
     /*  32717 */   // Label 824: @32717
     /*  32717 */   GIM_Reject,
     /*  32718 */ // Label 815: @32718
     /*  32718 */ GIM_Reject,
     /*  32719 */ // Label 679: @32719
     /*  32719 */ GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(32874),
     /*  32724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  32727 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  32730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  32734 */   GIM_Try, /*On fail goto*//*Label 826*/ GIMT_Encode4(32792), // Rule ID 24191 //
     /*  32739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  32742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32750 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32753 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32757 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  32765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32767 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32774 */     // (or:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16i32] }:$src1)  =>  (VPORDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORDZrm),
     /*  32777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32779 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  32781 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32785 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32790 */     GIR_RootConstrainSelectedInstOperands,
     /*  32791 */     // GIR_Coverage, 24191,
     /*  32791 */     GIR_EraseRootFromParent_Done,
     /*  32792 */   // Label 826: @32792
     /*  32792 */   GIM_Try, /*On fail goto*//*Label 827*/ GIMT_Encode4(32850), // Rule ID 5770 //
     /*  32797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  32800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  32804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32812 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32815 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32819 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32825 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32832 */     // (or:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORDZrm),
     /*  32835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32837 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  32839 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32843 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32848 */     GIR_RootConstrainSelectedInstOperands,
     /*  32849 */     // GIR_Coverage, 5770,
     /*  32849 */     GIR_EraseRootFromParent_Done,
     /*  32850 */   // Label 827: @32850
     /*  32850 */   GIM_Try, /*On fail goto*//*Label 828*/ GIMT_Encode4(32873), // Rule ID 5767 //
     /*  32855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  32858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  32862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  32866 */     // (or:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPORDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /*  32866 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORDZrr),
     /*  32871 */     GIR_RootConstrainSelectedInstOperands,
     /*  32872 */     // GIR_Coverage, 5767,
     /*  32872 */     GIR_Done,
     /*  32873 */   // Label 828: @32873
     /*  32873 */   GIM_Reject,
     /*  32874 */ // Label 825: @32874
     /*  32874 */ GIM_Reject,
     /*  32875 */ // Label 680: @32875
     /*  32875 */ GIM_Try, /*On fail goto*//*Label 829*/ GIMT_Encode4(32908), // Rule ID 4421 //
     /*  32880 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  32883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  32886 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s1,
     /*  32889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  32893 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  32897 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  32901 */   // (or:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)  =>  (KORDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /*  32901 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KORDkk),
     /*  32906 */   GIR_RootConstrainSelectedInstOperands,
     /*  32907 */   // GIR_Coverage, 4421,
     /*  32907 */   GIR_Done,
     /*  32908 */ // Label 829: @32908
     /*  32908 */ GIM_Reject,
     /*  32909 */ // Label 681: @32909
     /*  32909 */ GIM_Try, /*On fail goto*//*Label 830*/ GIMT_Encode4(33374),
     /*  32914 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /*  32917 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /*  32920 */   GIM_Try, /*On fail goto*//*Label 831*/ GIMT_Encode4(32982), // Rule ID 25233 //
     /*  32925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  32928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32940 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32943 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32947 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32957 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32964 */     // (or:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPORYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORYrm),
     /*  32967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32969 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  32971 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32975 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32980 */     GIR_RootConstrainSelectedInstOperands,
     /*  32981 */     // GIR_Coverage, 25233,
     /*  32981 */     GIR_EraseRootFromParent_Done,
     /*  32982 */   // Label 831: @32982
     /*  32982 */   GIM_Try, /*On fail goto*//*Label 832*/ GIMT_Encode4(33044), // Rule ID 25243 //
     /*  32987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  32990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  33002 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  33005 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  33009 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  33013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  33017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33019 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  33026 */     // (or:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VORPSYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  33026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VORPSYrm),
     /*  33029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33031 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  33033 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  33037 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  33042 */     GIR_RootConstrainSelectedInstOperands,
     /*  33043 */     // GIR_Coverage, 25243,
     /*  33043 */     GIR_EraseRootFromParent_Done,
     /*  33044 */   // Label 832: @33044
     /*  33044 */   GIM_Try, /*On fail goto*//*Label 833*/ GIMT_Encode4(33106), // Rule ID 25440 //
     /*  33049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  33052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  33056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  33064 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  33067 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  33071 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  33075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  33079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33081 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  33088 */     // (or:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPORQZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  33088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rm),
     /*  33091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33093 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  33095 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  33099 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  33104 */     GIR_RootConstrainSelectedInstOperands,
     /*  33105 */     // GIR_Coverage, 25440,
     /*  33105 */     GIR_EraseRootFromParent_Done,
     /*  33106 */   // Label 833: @33106
     /*  33106 */   GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(33168), // Rule ID 18105 //
     /*  33111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  33114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  33118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  33122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  33130 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  33133 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  33137 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  33141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33143 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  33150 */     // (or:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  33150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORYrm),
     /*  33153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33155 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  33157 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  33161 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  33166 */     GIR_RootConstrainSelectedInstOperands,
     /*  33167 */     // GIR_Coverage, 18105,
     /*  33167 */     GIR_EraseRootFromParent_Done,
     /*  33168 */   // Label 834: @33168
     /*  33168 */   GIM_Try, /*On fail goto*//*Label 835*/ GIMT_Encode4(33230), // Rule ID 18134 //
     /*  33173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  33176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  33180 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  33184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  33192 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  33195 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  33199 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  33203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33205 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  33212 */     // (or:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VORPSYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  33212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VORPSYrm),
     /*  33215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33217 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  33219 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  33223 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  33228 */     GIR_RootConstrainSelectedInstOperands,
     /*  33229 */     // GIR_Coverage, 18134,
     /*  33229 */     GIR_EraseRootFromParent_Done,
     /*  33230 */   // Label 835: @33230
     /*  33230 */   GIM_Try, /*On fail goto*//*Label 836*/ GIMT_Encode4(33292), // Rule ID 20042 //
     /*  33235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  33238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  33242 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  33246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  33254 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  33257 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  33261 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  33265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33267 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  33274 */     // (or:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORQZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  33274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rm),
     /*  33277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33279 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  33281 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  33285 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  33290 */     GIR_RootConstrainSelectedInstOperands,
     /*  33291 */     // GIR_Coverage, 20042,
     /*  33291 */     GIR_EraseRootFromParent_Done,
     /*  33292 */   // Label 836: @33292
     /*  33292 */   GIM_Try, /*On fail goto*//*Label 837*/ GIMT_Encode4(33319), // Rule ID 18093 //
     /*  33297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  33300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  33304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  33308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  33312 */     // (or:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPORYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*  33312 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORYrr),
     /*  33317 */     GIR_RootConstrainSelectedInstOperands,
     /*  33318 */     // GIR_Coverage, 18093,
     /*  33318 */     GIR_Done,
     /*  33319 */   // Label 837: @33319
     /*  33319 */   GIM_Try, /*On fail goto*//*Label 838*/ GIMT_Encode4(33346), // Rule ID 18118 //
     /*  33324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  33327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  33331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  33335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  33339 */     // (or:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VORPSYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*  33339 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VORPSYrr),
     /*  33344 */     GIR_RootConstrainSelectedInstOperands,
     /*  33345 */     // GIR_Coverage, 18118,
     /*  33345 */     GIR_Done,
     /*  33346 */   // Label 838: @33346
     /*  33346 */   GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(33373), // Rule ID 20034 //
     /*  33351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  33354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  33358 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  33362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  33366 */     // (or:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPORQZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /*  33366 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rr),
     /*  33371 */     GIR_RootConstrainSelectedInstOperands,
     /*  33372 */     // GIR_Coverage, 20034,
     /*  33372 */     GIR_Done,
     /*  33373 */   // Label 839: @33373
     /*  33373 */   GIM_Reject,
     /*  33374 */ // Label 830: @33374
     /*  33374 */ GIM_Reject,
     /*  33375 */ // Label 682: @33375
     /*  33375 */ GIM_Try, /*On fail goto*//*Label 840*/ GIMT_Encode4(33530),
     /*  33380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  33383 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /*  33386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33390 */   GIM_Try, /*On fail goto*//*Label 841*/ GIMT_Encode4(33448), // Rule ID 25447 //
     /*  33395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  33398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  33406 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  33409 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  33413 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  33417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33423 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  33430 */     // (or:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPORQZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  33430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZrm),
     /*  33433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33435 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  33437 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  33441 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  33446 */     GIR_RootConstrainSelectedInstOperands,
     /*  33447 */     // GIR_Coverage, 25447,
     /*  33447 */     GIR_EraseRootFromParent_Done,
     /*  33448 */   // Label 841: @33448
     /*  33448 */   GIM_Try, /*On fail goto*//*Label 842*/ GIMT_Encode4(33506), // Rule ID 20059 //
     /*  33453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  33456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  33468 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  33471 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  33475 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  33479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33481 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  33488 */     // (or:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORQZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  33488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZrm),
     /*  33491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33493 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  33495 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  33499 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  33504 */     GIR_RootConstrainSelectedInstOperands,
     /*  33505 */     // GIR_Coverage, 20059,
     /*  33505 */     GIR_EraseRootFromParent_Done,
     /*  33506 */   // Label 842: @33506
     /*  33506 */   GIM_Try, /*On fail goto*//*Label 843*/ GIMT_Encode4(33529), // Rule ID 20051 //
     /*  33511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  33514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33522 */     // (or:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPORQZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /*  33522 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZrr),
     /*  33527 */     GIR_RootConstrainSelectedInstOperands,
     /*  33528 */     // GIR_Coverage, 20051,
     /*  33528 */     GIR_Done,
     /*  33529 */   // Label 843: @33529
     /*  33529 */   GIM_Reject,
     /*  33530 */ // Label 840: @33530
     /*  33530 */ GIM_Reject,
     /*  33531 */ // Label 683: @33531
     /*  33531 */ GIM_Try, /*On fail goto*//*Label 844*/ GIMT_Encode4(33564), // Rule ID 4422 //
     /*  33536 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  33539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  33542 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s1,
     /*  33545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  33549 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  33553 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  33557 */   // (or:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)  =>  (KORQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /*  33557 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KORQkk),
     /*  33562 */   GIR_RootConstrainSelectedInstOperands,
     /*  33563 */   // GIR_Coverage, 4422,
     /*  33563 */   GIR_Done,
     /*  33564 */ // Label 844: @33564
     /*  33564 */ GIM_Reject,
     /*  33565 */ // Label 684: @33565
     /*  33565 */ GIM_Try, /*On fail goto*//*Label 845*/ GIMT_Encode4(33720),
     /*  33570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /*  33573 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /*  33576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33580 */   GIM_Try, /*On fail goto*//*Label 846*/ GIMT_Encode4(33638), // Rule ID 25446 //
     /*  33585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  33588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  33596 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  33599 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  33603 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  33607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33613 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  33620 */     // (or:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPORQZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  33620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZrm),
     /*  33623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33625 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  33627 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  33631 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  33636 */     GIR_RootConstrainSelectedInstOperands,
     /*  33637 */     // GIR_Coverage, 25446,
     /*  33637 */     GIR_EraseRootFromParent_Done,
     /*  33638 */   // Label 846: @33638
     /*  33638 */   GIM_Try, /*On fail goto*//*Label 847*/ GIMT_Encode4(33696), // Rule ID 20058 //
     /*  33643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  33646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  33658 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  33661 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  33665 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  33669 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33671 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  33678 */     // (or:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORQZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  33678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZrm),
     /*  33681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33683 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  33685 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  33689 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  33694 */     GIR_RootConstrainSelectedInstOperands,
     /*  33695 */     // GIR_Coverage, 20058,
     /*  33695 */     GIR_EraseRootFromParent_Done,
     /*  33696 */   // Label 847: @33696
     /*  33696 */   GIM_Try, /*On fail goto*//*Label 848*/ GIMT_Encode4(33719), // Rule ID 20050 //
     /*  33701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  33704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33712 */     // (or:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPORQZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /*  33712 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZrr),
     /*  33717 */     GIR_RootConstrainSelectedInstOperands,
     /*  33718 */     // GIR_Coverage, 20050,
     /*  33718 */     GIR_Done,
     /*  33719 */   // Label 848: @33719
     /*  33719 */   GIM_Reject,
     /*  33720 */ // Label 845: @33720
     /*  33720 */ GIM_Reject,
     /*  33721 */ // Label 685: @33721
     /*  33721 */ GIM_Reject,
     /*  33722 */ // Label 5: @33722
     /*  33722 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(25), /*)*//*default:*//*Label 872*/ GIMT_Encode4(46422),
     /*  33733 */ /*GILLT_s1*//*Label 849*/ GIMT_Encode4(33833),
     /*  33737 */ /*GILLT_s8*//*Label 850*/ GIMT_Encode4(34391),
     /*  33741 */ /*GILLT_s16*//*Label 851*/ GIMT_Encode4(34918),
     /*  33745 */ /*GILLT_s32*//*Label 852*/ GIMT_Encode4(35663),
     /*  33749 */ /*GILLT_s64*//*Label 853*/ GIMT_Encode4(36611), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  33761 */ /*GILLT_v2s1*//*Label 854*/ GIMT_Encode4(37518),
     /*  33765 */ /*GILLT_v2s64*//*Label 855*/ GIMT_Encode4(38060),
     /*  33769 */ /*GILLT_v4s1*//*Label 856*/ GIMT_Encode4(38680),
     /*  33773 */ /*GILLT_v4s32*//*Label 857*/ GIMT_Encode4(39222),
     /*  33777 */ /*GILLT_v4s64*//*Label 858*/ GIMT_Encode4(39842),
     /*  33781 */ /*GILLT_v8s1*//*Label 859*/ GIMT_Encode4(40586),
     /*  33785 */ /*GILLT_v8s16*//*Label 860*/ GIMT_Encode4(41384),
     /*  33789 */ /*GILLT_v8s32*//*Label 861*/ GIMT_Encode4(42004),
     /*  33793 */ /*GILLT_v8s64*//*Label 862*/ GIMT_Encode4(42748),
     /*  33797 */ /*GILLT_v16s1*//*Label 863*/ GIMT_Encode4(42946),
     /*  33801 */ /*GILLT_v16s8*//*Label 864*/ GIMT_Encode4(43204),
     /*  33805 */ /*GILLT_v16s16*//*Label 865*/ GIMT_Encode4(43824),
     /*  33809 */ /*GILLT_v16s32*//*Label 866*/ GIMT_Encode4(44568),
     /*  33813 */ /*GILLT_v32s1*//*Label 867*/ GIMT_Encode4(44766),
     /*  33817 */ /*GILLT_v32s8*//*Label 868*/ GIMT_Encode4(45024),
     /*  33821 */ /*GILLT_v32s16*//*Label 869*/ GIMT_Encode4(45768),
     /*  33825 */ /*GILLT_v64s1*//*Label 870*/ GIMT_Encode4(45966),
     /*  33829 */ /*GILLT_v64s8*//*Label 871*/ GIMT_Encode4(46224),
     /*  33833 */ // Label 849: @33833
     /*  33833 */ GIM_Try, /*On fail goto*//*Label 873*/ GIMT_Encode4(34390),
     /*  33838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*  33841 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*  33844 */   GIM_Try, /*On fail goto*//*Label 874*/ GIMT_Encode4(33968), // Rule ID 25372 //
     /*  33849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  33853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  33861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  33865 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  33869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  33874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33878 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  33884 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  33886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  33890 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33892 */     // (xor:{ *:[v1i1] } (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, immAllOnesV:{ *:[v1i1] }), VK1:{ *:[v1i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /*  33892 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  33895 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33899 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  33904 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  33908 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  33913 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  33916 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33920 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  33925 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  33929 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  33934 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  33937 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  33941 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  33946 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  33949 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  33952 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  33954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  33962 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  33967 */     // GIR_Coverage, 25372,
     /*  33967 */     GIR_EraseRootFromParent_Done,
     /*  33968 */   // Label 874: @33968
     /*  33968 */   GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(34093), // Rule ID 19496 //
     /*  33973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  33977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  33985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  33989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  33993 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  33998 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  34003 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34007 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  34013 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  34015 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34017 */     // (xor:{ *:[v1i1] } (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, VK1:{ *:[v1i1] }:$src2), immAllOnesV:{ *:[v1i1] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /*  34017 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  34020 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34024 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34029 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  34033 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  34038 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  34041 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34045 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34050 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  34054 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  34059 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  34062 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  34066 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34071 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  34074 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  34077 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  34079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34084 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34087 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  34092 */     // GIR_Coverage, 19496,
     /*  34092 */     GIR_EraseRootFromParent_Done,
     /*  34093 */   // Label 875: @34093
     /*  34093 */   GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(34217), // Rule ID 25373 //
     /*  34098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  34102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  34106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  34114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  34118 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  34122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  34127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  34131 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  34137 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  34139 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34141 */     // (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src2, (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, immAllOnesV:{ *:[v1i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /*  34141 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  34144 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34148 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34153 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  34157 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  34162 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  34165 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34169 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34174 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  34178 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  34183 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  34186 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  34190 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34195 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  34198 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  34201 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  34203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34211 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  34216 */     // GIR_Coverage, 25373,
     /*  34216 */     GIR_EraseRootFromParent_Done,
     /*  34217 */   // Label 876: @34217
     /*  34217 */   GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(34296), // Rule ID 19482 //
     /*  34222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  34226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  34230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34234 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  34240 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  34242 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34244 */     // (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src, immAllOnesV:{ *:[v1i1] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KNOTWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  34244 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  34247 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34251 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34256 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  34260 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  34265 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  34268 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /*  34272 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34277 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  34280 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  34282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34287 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34290 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  34295 */     // GIR_Coverage, 19482,
     /*  34295 */     GIR_EraseRootFromParent_Done,
     /*  34296 */   // Label 877: @34296
     /*  34296 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(34389), // Rule ID 19500 //
     /*  34301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  34305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  34309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  34313 */     // (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, VK1:{ *:[v1i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KXORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /*  34313 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  34316 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34320 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34325 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  34329 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  34334 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  34337 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34341 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34346 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  34350 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  34355 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  34358 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXORWkk),
     /*  34362 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34367 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  34370 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  34373 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  34375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34380 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34383 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  34388 */     // GIR_Coverage, 19500,
     /*  34388 */     GIR_EraseRootFromParent_Done,
     /*  34389 */   // Label 878: @34389
     /*  34389 */   GIM_Reject,
     /*  34390 */ // Label 873: @34390
     /*  34390 */ GIM_Reject,
     /*  34391 */ // Label 850: @34391
     /*  34391 */ GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(34917),
     /*  34396 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /*  34399 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /*  34402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34406 */   GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(34462), // Rule ID 273 //
     /*  34411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  34414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  34422 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  34425 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  34429 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  34433 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  34437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34439 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  34446 */     // (xor:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, -1:{ *:[i8] })  =>  (NOT8m_ND:{ *:[i8] } addr:{ *:[iPTR] }:$src1)
     /*  34446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT8m_ND),
     /*  34449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34451 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  34455 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  34460 */     GIR_RootConstrainSelectedInstOperands,
     /*  34461 */     // GIR_Coverage, 273,
     /*  34461 */     GIR_EraseRootFromParent_Done,
     /*  34462 */   // Label 880: @34462
     /*  34462 */   GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(34523), // Rule ID 26065 //
     /*  34467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  34470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  34478 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  34481 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  34485 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  34489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34495 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  34502 */     // (xor:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, GR8:{ *:[i8] }:$src1)  =>  (XOR8rm:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  34502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8rm),
     /*  34505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34507 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  34509 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  34513 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  34516 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  34521 */     GIR_RootConstrainSelectedInstOperands,
     /*  34522 */     // GIR_Coverage, 26065,
     /*  34522 */     GIR_EraseRootFromParent_Done,
     /*  34523 */   // Label 881: @34523
     /*  34523 */   GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(34584), // Rule ID 26084 //
     /*  34528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  34531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  34539 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  34542 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  34546 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  34550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34556 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  34563 */     // (xor:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, GR8:{ *:[i8] }:$src1)  =>  (XOR8rm_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  34563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8rm_ND),
     /*  34566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34568 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  34570 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  34574 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  34577 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  34582 */     GIR_RootConstrainSelectedInstOperands,
     /*  34583 */     // GIR_Coverage, 26084,
     /*  34583 */     GIR_EraseRootFromParent_Done,
     /*  34584 */   // Label 882: @34584
     /*  34584 */   GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(34645), // Rule ID 22842 //
     /*  34589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  34592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  34604 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  34607 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  34611 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  34615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34617 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  34624 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (XOR8rm:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  34624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8rm),
     /*  34627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34629 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34631 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  34635 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  34638 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  34643 */     GIR_RootConstrainSelectedInstOperands,
     /*  34644 */     // GIR_Coverage, 22842,
     /*  34644 */     GIR_EraseRootFromParent_Done,
     /*  34645 */   // Label 883: @34645
     /*  34645 */   GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(34706), // Rule ID 22932 //
     /*  34650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  34653 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  34665 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  34668 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  34672 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  34676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34678 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  34685 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (XOR8rm_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  34685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8rm_ND),
     /*  34688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34690 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34692 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  34696 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  34699 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  34704 */     GIR_RootConstrainSelectedInstOperands,
     /*  34705 */     // GIR_Coverage, 22932,
     /*  34705 */     GIR_EraseRootFromParent_Done,
     /*  34706 */   // Label 884: @34706
     /*  34706 */   GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(34734), // Rule ID 22599 //
     /*  34711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34715 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-128),
     /*  34719 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, -128:{ *:[i8] })  =>  (ADD8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, -128:{ *:[i8] })
     /*  34719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8ri),
     /*  34722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34724 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*  34729 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  34732 */     GIR_RootConstrainSelectedInstOperands,
     /*  34733 */     // GIR_Coverage, 22599,
     /*  34733 */     GIR_EraseRootFromParent_Done,
     /*  34734 */   // Label 885: @34734
     /*  34734 */   GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(34759), // Rule ID 245 //
     /*  34739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  34742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34746 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  34750 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, -1:{ *:[i8] })  =>  (NOT8r:{ *:[i8] } GR8:{ *:[i8] }:$src1)
     /*  34750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT8r),
     /*  34753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34755 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34757 */     GIR_RootConstrainSelectedInstOperands,
     /*  34758 */     // GIR_Coverage, 245,
     /*  34758 */     GIR_EraseRootFromParent_Done,
     /*  34759 */   // Label 886: @34759
     /*  34759 */   GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(34784), // Rule ID 253 //
     /*  34764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  34767 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34771 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  34775 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, -1:{ *:[i8] })  =>  (NOT8r_ND:{ *:[i8] } GR8:{ *:[i8] }:$src1)
     /*  34775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT8r_ND),
     /*  34778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34780 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34782 */     GIR_RootConstrainSelectedInstOperands,
     /*  34783 */     // GIR_Coverage, 253,
     /*  34783 */     GIR_EraseRootFromParent_Done,
     /*  34784 */   // Label 887: @34784
     /*  34784 */   GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(34821), // Rule ID 22846 //
     /*  34789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  34792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  34804 */     // MIs[1] Operand 1
     /*  34804 */     // No operand predicates
     /*  34804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34806 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (XOR8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  34806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8ri),
     /*  34809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34811 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34813 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  34816 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  34819 */     GIR_RootConstrainSelectedInstOperands,
     /*  34820 */     // GIR_Coverage, 22846,
     /*  34820 */     GIR_EraseRootFromParent_Done,
     /*  34821 */   // Label 888: @34821
     /*  34821 */   GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(34858), // Rule ID 22936 //
     /*  34826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  34829 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  34841 */     // MIs[1] Operand 1
     /*  34841 */     // No operand predicates
     /*  34841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34843 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (XOR8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  34843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8ri_ND),
     /*  34846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34848 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34850 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  34853 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  34856 */     GIR_RootConstrainSelectedInstOperands,
     /*  34857 */     // GIR_Coverage, 22936,
     /*  34857 */     GIR_EraseRootFromParent_Done,
     /*  34858 */   // Label 889: @34858
     /*  34858 */   GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(34887), // Rule ID 22838 //
     /*  34863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  34866 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34874 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (XOR8rr:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  34874 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR8rr),
     /*  34879 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  34885 */     GIR_RootConstrainSelectedInstOperands,
     /*  34886 */     // GIR_Coverage, 22838,
     /*  34886 */     GIR_Done,
     /*  34887 */   // Label 890: @34887
     /*  34887 */   GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(34916), // Rule ID 22928 //
     /*  34892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  34895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34903 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (XOR8rr_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  34903 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR8rr_ND),
     /*  34908 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  34914 */     GIR_RootConstrainSelectedInstOperands,
     /*  34915 */     // GIR_Coverage, 22928,
     /*  34915 */     GIR_Done,
     /*  34916 */   // Label 891: @34916
     /*  34916 */   GIM_Reject,
     /*  34917 */ // Label 879: @34917
     /*  34917 */ GIM_Reject,
     /*  34918 */ // Label 851: @34918
     /*  34918 */ GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(35662),
     /*  34923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  34926 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  34929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  34933 */   GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(34989), // Rule ID 274 //
     /*  34938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  34941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  34949 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  34952 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  34956 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  34960 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  34964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34966 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  34973 */     // (xor:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, -1:{ *:[i16] })  =>  (NOT16m_ND:{ *:[i16] } addr:{ *:[iPTR] }:$src1)
     /*  34973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT16m_ND),
     /*  34976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34978 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  34982 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  34987 */     GIR_RootConstrainSelectedInstOperands,
     /*  34988 */     // GIR_Coverage, 274,
     /*  34988 */     GIR_EraseRootFromParent_Done,
     /*  34989 */   // Label 893: @34989
     /*  34989 */   GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(35050), // Rule ID 26066 //
     /*  34994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  34997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  35005 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  35008 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  35012 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  35016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35020 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35022 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  35029 */     // (xor:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (XOR16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  35029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16rm),
     /*  35032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35034 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  35036 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  35040 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35043 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  35048 */     GIR_RootConstrainSelectedInstOperands,
     /*  35049 */     // GIR_Coverage, 26066,
     /*  35049 */     GIR_EraseRootFromParent_Done,
     /*  35050 */   // Label 894: @35050
     /*  35050 */   GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(35111), // Rule ID 26085 //
     /*  35055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  35058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  35066 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  35069 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  35073 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  35077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35083 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  35090 */     // (xor:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (XOR16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  35090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16rm_ND),
     /*  35093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35095 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  35097 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  35101 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35104 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  35109 */     GIR_RootConstrainSelectedInstOperands,
     /*  35110 */     // GIR_Coverage, 26085,
     /*  35110 */     GIR_EraseRootFromParent_Done,
     /*  35111 */   // Label 895: @35111
     /*  35111 */   GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(35172), // Rule ID 22843 //
     /*  35116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  35119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  35131 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  35134 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  35138 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  35142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35144 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  35151 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (XOR16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  35151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16rm),
     /*  35154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35156 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35158 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  35162 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35165 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  35170 */     GIR_RootConstrainSelectedInstOperands,
     /*  35171 */     // GIR_Coverage, 22843,
     /*  35171 */     GIR_EraseRootFromParent_Done,
     /*  35172 */   // Label 896: @35172
     /*  35172 */   GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(35233), // Rule ID 22933 //
     /*  35177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  35180 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  35192 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  35195 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  35199 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  35203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35205 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  35212 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (XOR16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  35212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16rm_ND),
     /*  35215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35217 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35219 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  35223 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35226 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  35231 */     GIR_RootConstrainSelectedInstOperands,
     /*  35232 */     // GIR_Coverage, 22933,
     /*  35232 */     GIR_EraseRootFromParent_Done,
     /*  35233 */   // Label 897: @35233
     /*  35233 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(35275), // Rule ID 22600 //
     /*  35238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35242 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(-32768),
     /*  35253 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, -32768:{ *:[i16] })  =>  (ADD16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, -32768:{ *:[i16] })
     /*  35253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16ri),
     /*  35256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35258 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35260 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(-32768),
     /*  35270 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35273 */     GIR_RootConstrainSelectedInstOperands,
     /*  35274 */     // GIR_Coverage, 22600,
     /*  35274 */     GIR_EraseRootFromParent_Done,
     /*  35275 */   // Label 898: @35275
     /*  35275 */   GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(35377), // Rule ID 26038 //
     /*  35280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  35288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  35292 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  35296 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  35300 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  35305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35311 */     // (xor:{ *:[i16] } (shl:{ *:[i16] } 1:{ *:[i16] }, GR8:{ *:[i8] }:$src2), GR16:{ *:[i16] }:$src1)  =>  (BTC16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (INSERT_SUBREG:{ *:[i16] } (IMPLICIT_DEF:{ *:[i16] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  35311 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  35314 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35318 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35323 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  35325 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  35328 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  35332 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35337 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  35340 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  35344 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  35347 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  35352 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /*  35357 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  35362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTC16rr),
     /*  35365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35367 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  35369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35372 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35375 */     GIR_RootConstrainSelectedInstOperands,
     /*  35376 */     // GIR_Coverage, 26038,
     /*  35376 */     GIR_EraseRootFromParent_Done,
     /*  35377 */   // Label 899: @35377
     /*  35377 */   GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(35479), // Rule ID 22776 //
     /*  35382 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  35394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  35398 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  35402 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  35406 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  35411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35413 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, (shl:{ *:[i16] } 1:{ *:[i16] }, GR8:{ *:[i8] }:$src2))  =>  (BTC16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (INSERT_SUBREG:{ *:[i16] } (IMPLICIT_DEF:{ *:[i16] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  35413 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  35416 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35420 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35425 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  35427 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  35430 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  35434 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35439 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  35442 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  35446 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  35449 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  35454 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /*  35459 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  35464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTC16rr),
     /*  35467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35469 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35474 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35477 */     GIR_RootConstrainSelectedInstOperands,
     /*  35478 */     // GIR_Coverage, 22776,
     /*  35478 */     GIR_EraseRootFromParent_Done,
     /*  35479 */   // Label 900: @35479
     /*  35479 */   GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(35504), // Rule ID 246 //
     /*  35484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  35487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35491 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  35495 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, -1:{ *:[i16] })  =>  (NOT16r:{ *:[i16] } GR16:{ *:[i16] }:$src1)
     /*  35495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT16r),
     /*  35498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35500 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35502 */     GIR_RootConstrainSelectedInstOperands,
     /*  35503 */     // GIR_Coverage, 246,
     /*  35503 */     GIR_EraseRootFromParent_Done,
     /*  35504 */   // Label 901: @35504
     /*  35504 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(35529), // Rule ID 254 //
     /*  35509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  35512 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35516 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  35520 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, -1:{ *:[i16] })  =>  (NOT16r_ND:{ *:[i16] } GR16:{ *:[i16] }:$src1)
     /*  35520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT16r_ND),
     /*  35523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35525 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35527 */     GIR_RootConstrainSelectedInstOperands,
     /*  35528 */     // GIR_Coverage, 254,
     /*  35528 */     GIR_EraseRootFromParent_Done,
     /*  35529 */   // Label 902: @35529
     /*  35529 */   GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(35566), // Rule ID 22847 //
     /*  35534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  35537 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35549 */     // MIs[1] Operand 1
     /*  35549 */     // No operand predicates
     /*  35549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35551 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (XOR16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  35551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16ri),
     /*  35554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35556 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35558 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  35561 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35564 */     GIR_RootConstrainSelectedInstOperands,
     /*  35565 */     // GIR_Coverage, 22847,
     /*  35565 */     GIR_EraseRootFromParent_Done,
     /*  35566 */   // Label 903: @35566
     /*  35566 */   GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(35603), // Rule ID 22937 //
     /*  35571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  35574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35586 */     // MIs[1] Operand 1
     /*  35586 */     // No operand predicates
     /*  35586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35588 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (XOR16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  35588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16ri_ND),
     /*  35591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35593 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35595 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  35598 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35601 */     GIR_RootConstrainSelectedInstOperands,
     /*  35602 */     // GIR_Coverage, 22937,
     /*  35602 */     GIR_EraseRootFromParent_Done,
     /*  35603 */   // Label 904: @35603
     /*  35603 */   GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(35632), // Rule ID 22839 //
     /*  35608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  35611 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35619 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (XOR16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  35619 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR16rr),
     /*  35624 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  35630 */     GIR_RootConstrainSelectedInstOperands,
     /*  35631 */     // GIR_Coverage, 22839,
     /*  35631 */     GIR_Done,
     /*  35632 */   // Label 905: @35632
     /*  35632 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(35661), // Rule ID 22929 //
     /*  35637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  35640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35648 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (XOR16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  35648 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR16rr_ND),
     /*  35653 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  35659 */     GIR_RootConstrainSelectedInstOperands,
     /*  35660 */     // GIR_Coverage, 22929,
     /*  35660 */     GIR_Done,
     /*  35661 */   // Label 906: @35661
     /*  35661 */   GIM_Reject,
     /*  35662 */ // Label 892: @35662
     /*  35662 */ GIM_Reject,
     /*  35663 */ // Label 852: @35663
     /*  35663 */ GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(36610),
     /*  35668 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  35671 */   GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(35734), // Rule ID 275 //
     /*  35676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  35679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  35682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  35694 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  35697 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  35701 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  35705 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  35709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35711 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  35718 */     // (xor:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, -1:{ *:[i32] })  =>  (NOT32m_ND:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  35718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT32m_ND),
     /*  35721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35723 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  35727 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  35732 */     GIR_RootConstrainSelectedInstOperands,
     /*  35733 */     // GIR_Coverage, 275,
     /*  35733 */     GIR_EraseRootFromParent_Done,
     /*  35734 */   // Label 908: @35734
     /*  35734 */   GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(35802), // Rule ID 26067 //
     /*  35739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  35742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  35745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  35757 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  35760 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  35764 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  35768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35774 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  35781 */     // (xor:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (XOR32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  35781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32rm),
     /*  35784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35786 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  35788 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  35792 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35795 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  35800 */     GIR_RootConstrainSelectedInstOperands,
     /*  35801 */     // GIR_Coverage, 26067,
     /*  35801 */     GIR_EraseRootFromParent_Done,
     /*  35802 */   // Label 909: @35802
     /*  35802 */   GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(35870), // Rule ID 26086 //
     /*  35807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  35810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  35813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  35825 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  35828 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  35832 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  35836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35842 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  35849 */     // (xor:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (XOR32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  35849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32rm_ND),
     /*  35852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35854 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  35856 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  35860 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35863 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  35868 */     GIR_RootConstrainSelectedInstOperands,
     /*  35869 */     // GIR_Coverage, 26086,
     /*  35869 */     GIR_EraseRootFromParent_Done,
     /*  35870 */   // Label 910: @35870
     /*  35870 */   GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(35938), // Rule ID 22844 //
     /*  35875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  35878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  35881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  35897 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  35900 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  35904 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  35908 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35910 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  35917 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (XOR32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  35917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32rm),
     /*  35920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35922 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35924 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  35928 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35931 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  35936 */     GIR_RootConstrainSelectedInstOperands,
     /*  35937 */     // GIR_Coverage, 22844,
     /*  35937 */     GIR_EraseRootFromParent_Done,
     /*  35938 */   // Label 911: @35938
     /*  35938 */   GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(36006), // Rule ID 22934 //
     /*  35943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  35946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  35949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35953 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  35965 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  35968 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  35972 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  35976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35978 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  35985 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (XOR32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  35985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32rm_ND),
     /*  35988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35990 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35992 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  35996 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35999 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  36004 */     GIR_RootConstrainSelectedInstOperands,
     /*  36005 */     // GIR_Coverage, 22934,
     /*  36005 */     GIR_EraseRootFromParent_Done,
     /*  36006 */   // Label 912: @36006
     /*  36006 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(36055), // Rule ID 22601 //
     /*  36011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36018 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36022 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(-2147483648),
     /*  36033 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -2147483648:{ *:[i32] })  =>  (ADD32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, -2147483648:{ *:[i32] })
     /*  36033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32ri),
     /*  36036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36038 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  36040 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(-2147483648),
     /*  36050 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36053 */     GIR_RootConstrainSelectedInstOperands,
     /*  36054 */     // GIR_Coverage, 22601,
     /*  36054 */     GIR_EraseRootFromParent_Done,
     /*  36055 */   // Label 913: @36055
     /*  36055 */   GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(36113), // Rule ID 24997 //
     /*  36060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  36063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  36075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  36079 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  36083 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36088 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  36092 */     // MIs[0] src
     /*  36092 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  36097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36099 */     // (xor:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), GR32:{ *:[i32] }:$src)  =>  (BLCMSK32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  36099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCMSK32rr),
     /*  36102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  36108 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36111 */     GIR_RootConstrainSelectedInstOperands,
     /*  36112 */     // GIR_Coverage, 24997,
     /*  36112 */     GIR_EraseRootFromParent_Done,
     /*  36113 */   // Label 914: @36113
     /*  36113 */   GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(36222), // Rule ID 26044 //
     /*  36118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  36133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  36137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  36141 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  36145 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  36150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36154 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36156 */     // (xor:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, GR8:{ *:[i8] }:$src2), GR32:{ *:[i32] }:$src1)  =>  (BTC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  36156 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  36159 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36163 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36168 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  36170 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  36173 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  36177 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36182 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  36185 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  36189 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  36192 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  36197 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  36202 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  36207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTC32rr),
     /*  36210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36212 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  36214 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36217 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36220 */     GIR_RootConstrainSelectedInstOperands,
     /*  36221 */     // GIR_Coverage, 26044,
     /*  36221 */     GIR_EraseRootFromParent_Done,
     /*  36222 */   // Label 915: @36222
     /*  36222 */   GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(36276), // Rule ID 17358 //
     /*  36227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  36230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  36249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  36253 */     // MIs[1] src
     /*  36253 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  36258 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  36262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36264 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }))  =>  (BLCMSK32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  36264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCMSK32rr),
     /*  36267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36269 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  36271 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36274 */     GIR_RootConstrainSelectedInstOperands,
     /*  36275 */     // GIR_Coverage, 17358,
     /*  36275 */     GIR_EraseRootFromParent_Done,
     /*  36276 */   // Label 916: @36276
     /*  36276 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(36385), // Rule ID 22782 //
     /*  36281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  36300 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  36304 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  36308 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  36312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  36317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36319 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, (shl:{ *:[i32] } 1:{ *:[i32] }, GR8:{ *:[i8] }:$src2))  =>  (BTC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  36319 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  36322 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36326 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36331 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  36333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  36336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  36340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36345 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  36348 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  36352 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  36355 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  36360 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  36365 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  36370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTC32rr),
     /*  36373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36375 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  36377 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36380 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36383 */     GIR_RootConstrainSelectedInstOperands,
     /*  36384 */     // GIR_Coverage, 22782,
     /*  36384 */     GIR_EraseRootFromParent_Done,
     /*  36385 */   // Label 917: @36385
     /*  36385 */   GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(36417), // Rule ID 247 //
     /*  36390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  36393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36404 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  36408 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] })  =>  (NOT32r:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /*  36408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT32r),
     /*  36411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36413 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  36415 */     GIR_RootConstrainSelectedInstOperands,
     /*  36416 */     // GIR_Coverage, 247,
     /*  36416 */     GIR_EraseRootFromParent_Done,
     /*  36417 */   // Label 918: @36417
     /*  36417 */   GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(36449), // Rule ID 255 //
     /*  36422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  36425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36436 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  36440 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] })  =>  (NOT32r_ND:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /*  36440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT32r_ND),
     /*  36443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36445 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  36447 */     GIR_RootConstrainSelectedInstOperands,
     /*  36448 */     // GIR_Coverage, 255,
     /*  36448 */     GIR_EraseRootFromParent_Done,
     /*  36449 */   // Label 919: @36449
     /*  36449 */   GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(36493), // Rule ID 22848 //
     /*  36454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  36457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  36476 */     // MIs[1] Operand 1
     /*  36476 */     // No operand predicates
     /*  36476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36478 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (XOR32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  36478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32ri),
     /*  36481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36483 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  36485 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  36488 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36491 */     GIR_RootConstrainSelectedInstOperands,
     /*  36492 */     // GIR_Coverage, 22848,
     /*  36492 */     GIR_EraseRootFromParent_Done,
     /*  36493 */   // Label 920: @36493
     /*  36493 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(36537), // Rule ID 22938 //
     /*  36498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  36501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  36520 */     // MIs[1] Operand 1
     /*  36520 */     // No operand predicates
     /*  36520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36522 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (XOR32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  36522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32ri_ND),
     /*  36525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36527 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  36529 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  36532 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36535 */     GIR_RootConstrainSelectedInstOperands,
     /*  36536 */     // GIR_Coverage, 22938,
     /*  36536 */     GIR_EraseRootFromParent_Done,
     /*  36537 */   // Label 921: @36537
     /*  36537 */   GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(36573), // Rule ID 22840 //
     /*  36542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  36545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36560 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (XOR32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  36560 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR32rr),
     /*  36565 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  36571 */     GIR_RootConstrainSelectedInstOperands,
     /*  36572 */     // GIR_Coverage, 22840,
     /*  36572 */     GIR_Done,
     /*  36573 */   // Label 922: @36573
     /*  36573 */   GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(36609), // Rule ID 22930 //
     /*  36578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  36581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36596 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (XOR32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  36596 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR32rr_ND),
     /*  36601 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  36607 */     GIR_RootConstrainSelectedInstOperands,
     /*  36608 */     // GIR_Coverage, 22930,
     /*  36608 */     GIR_Done,
     /*  36609 */   // Label 923: @36609
     /*  36609 */   GIM_Reject,
     /*  36610 */ // Label 907: @36610
     /*  36610 */ GIM_Reject,
     /*  36611 */ // Label 853: @36611
     /*  36611 */ GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(37517),
     /*  36616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  36619 */   GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(36682), // Rule ID 276 //
     /*  36624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  36627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  36642 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  36645 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  36649 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  36653 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  36657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36659 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  36666 */     // (xor:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, -1:{ *:[i64] })  =>  (NOT64m_ND:{ *:[i64] } addr:{ *:[iPTR] }:$src1)
     /*  36666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT64m_ND),
     /*  36669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36671 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  36675 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  36680 */     GIR_RootConstrainSelectedInstOperands,
     /*  36681 */     // GIR_Coverage, 276,
     /*  36681 */     GIR_EraseRootFromParent_Done,
     /*  36682 */   // Label 925: @36682
     /*  36682 */   GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(36750), // Rule ID 26068 //
     /*  36687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  36690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  36705 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  36708 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  36712 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  36716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36722 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  36729 */     // (xor:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (XOR64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  36729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64rm),
     /*  36732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36734 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  36736 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  36740 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36743 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  36748 */     GIR_RootConstrainSelectedInstOperands,
     /*  36749 */     // GIR_Coverage, 26068,
     /*  36749 */     GIR_EraseRootFromParent_Done,
     /*  36750 */   // Label 926: @36750
     /*  36750 */   GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(36818), // Rule ID 26087 //
     /*  36755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  36758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  36773 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  36776 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  36780 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  36784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36790 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  36797 */     // (xor:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (XOR64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  36797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64rm_ND),
     /*  36800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36802 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  36804 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  36808 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36811 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  36816 */     GIR_RootConstrainSelectedInstOperands,
     /*  36817 */     // GIR_Coverage, 26087,
     /*  36817 */     GIR_EraseRootFromParent_Done,
     /*  36818 */   // Label 927: @36818
     /*  36818 */   GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(36886), // Rule ID 22845 //
     /*  36823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  36826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  36845 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  36848 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  36852 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  36856 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36858 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  36865 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (XOR64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  36865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64rm),
     /*  36868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36870 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  36872 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  36876 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36879 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  36884 */     GIR_RootConstrainSelectedInstOperands,
     /*  36885 */     // GIR_Coverage, 22845,
     /*  36885 */     GIR_EraseRootFromParent_Done,
     /*  36886 */   // Label 928: @36886
     /*  36886 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(36954), // Rule ID 22935 //
     /*  36891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  36894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  36913 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  36916 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  36920 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  36924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36926 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  36933 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (XOR64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  36933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64rm_ND),
     /*  36936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36938 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  36940 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  36944 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36947 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  36952 */     GIR_RootConstrainSelectedInstOperands,
     /*  36953 */     // GIR_Coverage, 22935,
     /*  36953 */     GIR_EraseRootFromParent_Done,
     /*  36954 */   // Label 929: @36954
     /*  36954 */   GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(37012), // Rule ID 24998 //
     /*  36959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  36962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  36974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36978 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  36982 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36987 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  36991 */     // MIs[0] src
     /*  36991 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  36996 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36998 */     // (xor:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), GR64:{ *:[i64] }:$src)  =>  (BLCMSK64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  36998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCMSK64rr),
     /*  37001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  37007 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  37010 */     GIR_RootConstrainSelectedInstOperands,
     /*  37011 */     // GIR_Coverage, 24998,
     /*  37011 */     GIR_EraseRootFromParent_Done,
     /*  37012 */   // Label 930: @37012
     /*  37012 */   GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(37121), // Rule ID 26050 //
     /*  37017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  37032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37036 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  37040 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  37044 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  37049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37055 */     // (xor:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, GR8:{ *:[i8] }:$src2), GR64:{ *:[i64] }:$src1)  =>  (BTC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  37055 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37058 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37062 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37067 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  37069 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37072 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37076 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37081 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37084 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  37088 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  37091 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  37096 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  37101 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  37106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTC64rr),
     /*  37109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37111 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  37113 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  37116 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  37119 */     GIR_RootConstrainSelectedInstOperands,
     /*  37120 */     // GIR_Coverage, 26050,
     /*  37120 */     GIR_EraseRootFromParent_Done,
     /*  37121 */   // Label 931: @37121
     /*  37121 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(37175), // Rule ID 17359 //
     /*  37126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  37129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  37148 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  37152 */     // MIs[1] src
     /*  37152 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  37157 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  37161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37163 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }))  =>  (BLCMSK64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  37163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCMSK64rr),
     /*  37166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37168 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  37170 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  37173 */     GIR_RootConstrainSelectedInstOperands,
     /*  37174 */     // GIR_Coverage, 17359,
     /*  37174 */     GIR_EraseRootFromParent_Done,
     /*  37175 */   // Label 932: @37175
     /*  37175 */   GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(37284), // Rule ID 22788 //
     /*  37180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37187 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  37199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37203 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  37207 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  37211 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  37216 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37218 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, (shl:{ *:[i64] } 1:{ *:[i64] }, GR8:{ *:[i8] }:$src2))  =>  (BTC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  37218 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37221 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37225 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37230 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  37232 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37235 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37239 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37244 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37247 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  37251 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  37254 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  37259 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  37264 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  37269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTC64rr),
     /*  37272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37274 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  37276 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  37279 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  37282 */     GIR_RootConstrainSelectedInstOperands,
     /*  37283 */     // GIR_Coverage, 22788,
     /*  37283 */     GIR_EraseRootFromParent_Done,
     /*  37284 */   // Label 933: @37284
     /*  37284 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(37316), // Rule ID 248 //
     /*  37289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  37292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37303 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  37307 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] })  =>  (NOT64r:{ *:[i64] } GR64:{ *:[i64] }:$src1)
     /*  37307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT64r),
     /*  37310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37312 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  37314 */     GIR_RootConstrainSelectedInstOperands,
     /*  37315 */     // GIR_Coverage, 248,
     /*  37315 */     GIR_EraseRootFromParent_Done,
     /*  37316 */   // Label 934: @37316
     /*  37316 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(37348), // Rule ID 256 //
     /*  37321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  37324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37335 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  37339 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] })  =>  (NOT64r_ND:{ *:[i64] } GR64:{ *:[i64] }:$src1)
     /*  37339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT64r_ND),
     /*  37342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37344 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  37346 */     GIR_RootConstrainSelectedInstOperands,
     /*  37347 */     // GIR_Coverage, 256,
     /*  37347 */     GIR_EraseRootFromParent_Done,
     /*  37348 */   // Label 935: @37348
     /*  37348 */   GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(37396), // Rule ID 22849 //
     /*  37353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  37356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  37375 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  37379 */     // MIs[1] Operand 1
     /*  37379 */     // No operand predicates
     /*  37379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37381 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (XOR64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  37381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64ri32),
     /*  37384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37386 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  37388 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  37391 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  37394 */     GIR_RootConstrainSelectedInstOperands,
     /*  37395 */     // GIR_Coverage, 22849,
     /*  37395 */     GIR_EraseRootFromParent_Done,
     /*  37396 */   // Label 936: @37396
     /*  37396 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(37444), // Rule ID 22939 //
     /*  37401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  37404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37411 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  37423 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  37427 */     // MIs[1] Operand 1
     /*  37427 */     // No operand predicates
     /*  37427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37429 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (XOR64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  37429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64ri32_ND),
     /*  37432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37434 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  37436 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  37439 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  37442 */     GIR_RootConstrainSelectedInstOperands,
     /*  37443 */     // GIR_Coverage, 22939,
     /*  37443 */     GIR_EraseRootFromParent_Done,
     /*  37444 */   // Label 937: @37444
     /*  37444 */   GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(37480), // Rule ID 22841 //
     /*  37449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  37452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37467 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (XOR64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  37467 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR64rr),
     /*  37472 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  37478 */     GIR_RootConstrainSelectedInstOperands,
     /*  37479 */     // GIR_Coverage, 22841,
     /*  37479 */     GIR_Done,
     /*  37480 */   // Label 938: @37480
     /*  37480 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(37516), // Rule ID 22931 //
     /*  37485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  37488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37503 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (XOR64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  37503 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR64rr_ND),
     /*  37508 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  37514 */     GIR_RootConstrainSelectedInstOperands,
     /*  37515 */     // GIR_Coverage, 22931,
     /*  37515 */     GIR_Done,
     /*  37516 */   // Label 939: @37516
     /*  37516 */   GIM_Reject,
     /*  37517 */ // Label 924: @37517
     /*  37517 */ GIM_Reject,
     /*  37518 */ // Label 854: @37518
     /*  37518 */ GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(38059),
     /*  37523 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  37526 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  37529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37533 */   GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(37653), // Rule ID 25374 //
     /*  37538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  37550 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  37554 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37559 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  37563 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37569 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  37571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37575 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37577 */     // (xor:{ *:[v2i1] } (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, immAllOnesV:{ *:[v2i1] }), VK2:{ *:[v2i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  37577 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  37580 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37584 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37589 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  37593 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  37598 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  37601 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37605 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37610 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  37614 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  37619 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  37622 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  37626 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37631 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37634 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  37637 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37644 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  37647 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  37652 */     // GIR_Coverage, 25374,
     /*  37652 */     GIR_EraseRootFromParent_Done,
     /*  37653 */   // Label 941: @37653
     /*  37653 */   GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(37774), // Rule ID 19497 //
     /*  37658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37666 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  37670 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  37674 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37679 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37684 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  37688 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37694 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  37696 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37698 */     // (xor:{ *:[v2i1] } (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, VK2:{ *:[v2i1] }:$src2), immAllOnesV:{ *:[v2i1] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  37698 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  37701 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37705 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37710 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  37714 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  37719 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  37722 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37726 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37731 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  37735 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  37740 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  37743 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  37747 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37752 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37755 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  37758 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37765 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  37768 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  37773 */     // GIR_Coverage, 19497,
     /*  37773 */     GIR_EraseRootFromParent_Done,
     /*  37774 */   // Label 942: @37774
     /*  37774 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(37894), // Rule ID 25375 //
     /*  37779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  37795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  37799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37804 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  37808 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37814 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  37816 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37818 */     // (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src2, (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, immAllOnesV:{ *:[v2i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  37818 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  37821 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37825 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37830 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  37834 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  37839 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  37842 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37846 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37851 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  37855 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  37860 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  37863 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  37867 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37872 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37875 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  37878 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37885 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  37888 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  37893 */     // GIR_Coverage, 25375,
     /*  37893 */     GIR_EraseRootFromParent_Done,
     /*  37894 */   // Label 943: @37894
     /*  37894 */   GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(37969), // Rule ID 19481 //
     /*  37899 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37907 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37913 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  37915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37917 */     // (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src, immAllOnesV:{ *:[v2i1] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KNOTWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  37917 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  37920 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37924 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37929 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  37933 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  37938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  37941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /*  37945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37950 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37953 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37960 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  37963 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  37968 */     // GIR_Coverage, 19481,
     /*  37968 */     GIR_EraseRootFromParent_Done,
     /*  37969 */   // Label 944: @37969
     /*  37969 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(38058), // Rule ID 19501 //
     /*  37974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37982 */     // (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, VK2:{ *:[v2i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KXORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  37982 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  37985 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37989 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37994 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  37998 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  38003 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  38006 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38010 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38015 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  38019 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  38024 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  38027 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXORWkk),
     /*  38031 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38036 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38039 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  38042 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38049 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  38052 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  38057 */     // GIR_Coverage, 19501,
     /*  38057 */     GIR_EraseRootFromParent_Done,
     /*  38058 */   // Label 945: @38058
     /*  38058 */   GIM_Reject,
     /*  38059 */ // Label 940: @38059
     /*  38059 */ GIM_Reject,
     /*  38060 */ // Label 855: @38060
     /*  38060 */ GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(38679),
     /*  38065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38068 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  38071 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(38133), // Rule ID 23366 //
     /*  38076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  38079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  38083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  38091 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  38094 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  38098 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  38102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  38106 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  38108 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  38115 */     // (xor:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2i64] }:$src1)  =>  (VPXORrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  38115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORrm),
     /*  38118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38120 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  38122 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  38126 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  38131 */     GIR_RootConstrainSelectedInstOperands,
     /*  38132 */     // GIR_Coverage, 23366,
     /*  38132 */     GIR_EraseRootFromParent_Done,
     /*  38133 */   // Label 947: @38133
     /*  38133 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(38195), // Rule ID 24221 //
     /*  38138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  38141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  38145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  38153 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  38156 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  38160 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  38164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  38168 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  38170 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  38177 */     // (xor:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2i64] }:$src1)  =>  (VPXORQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  38177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rm),
     /*  38180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38182 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  38184 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  38188 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  38193 */     GIR_RootConstrainSelectedInstOperands,
     /*  38194 */     // GIR_Coverage, 24221,
     /*  38194 */     GIR_EraseRootFromParent_Done,
     /*  38195 */   // Label 948: @38195
     /*  38195 */   GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(38257), // Rule ID 2123 //
     /*  38200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  38203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  38207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  38211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  38219 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  38222 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  38226 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  38230 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  38232 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  38239 */     // (xor:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  38239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORrm),
     /*  38242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38244 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  38246 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  38250 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  38255 */     GIR_RootConstrainSelectedInstOperands,
     /*  38256 */     // GIR_Coverage, 2123,
     /*  38256 */     GIR_EraseRootFromParent_Done,
     /*  38257 */   // Label 949: @38257
     /*  38257 */   GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(38319), // Rule ID 5815 //
     /*  38262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  38265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  38269 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  38273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  38281 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  38284 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  38288 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  38292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  38294 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  38301 */     // (xor:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  38301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rm),
     /*  38304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38306 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  38308 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  38312 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  38317 */     GIR_RootConstrainSelectedInstOperands,
     /*  38318 */     // GIR_Coverage, 5815,
     /*  38318 */     GIR_EraseRootFromParent_Done,
     /*  38319 */   // Label 950: @38319
     /*  38319 */   GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(38551), // Rule ID 21946 //
     /*  38324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /*  38327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  38331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  38335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38339 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38345 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  38347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  38349 */     // (xor:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src, immAllOnesV:{ *:[v2i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src, sub_xmm:{ *:[i32] }), 15:{ *:[i8] }), sub_xmm:{ *:[i32] })
     /*  38349 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /*  38352 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  38356 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38361 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  38363 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /*  38366 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  38370 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38375 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /*  38378 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  38382 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/11,
     /*  38385 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  38390 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  38395 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  38400 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  38403 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  38407 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38412 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  38414 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  38417 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  38421 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38426 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  38429 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  38433 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /*  38436 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  38441 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  38446 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  38451 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  38454 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  38458 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38463 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  38465 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  38468 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  38472 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38477 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  38480 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  38484 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /*  38487 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  38492 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  38497 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  38502 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  38505 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  38509 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38514 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38517 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  38520 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  38523 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /*  38526 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38533 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /*  38540 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /*  38545 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  38550 */     // GIR_Coverage, 21946,
     /*  38550 */     GIR_EraseRootFromParent_Done,
     /*  38551 */   // Label 951: @38551
     /*  38551 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(38597), // Rule ID 21954 //
     /*  38556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  38559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  38563 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  38567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38571 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38577 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  38579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  38581 */     // (xor:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src, immAllOnesV:{ *:[v2i64] })  =>  (VPTERNLOGQZ128rri:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src, VR128X:{ *:[v2i64] }:$src, VR128X:{ *:[v2i64] }:$src, 15:{ *:[i8] })
     /*  38581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ128rri),
     /*  38584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38586 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  38588 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  38590 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  38592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  38595 */     GIR_RootConstrainSelectedInstOperands,
     /*  38596 */     // GIR_Coverage, 21954,
     /*  38596 */     GIR_EraseRootFromParent_Done,
     /*  38597 */   // Label 952: @38597
     /*  38597 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(38624), // Rule ID 2122 //
     /*  38602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  38605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  38609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  38613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  38617 */     // (xor:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VPXORrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  38617 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORrr),
     /*  38622 */     GIR_RootConstrainSelectedInstOperands,
     /*  38623 */     // GIR_Coverage, 2122,
     /*  38623 */     GIR_Done,
     /*  38624 */   // Label 953: @38624
     /*  38624 */   GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(38651), // Rule ID 2124 //
     /*  38629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  38632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  38636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  38640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  38644 */     // (xor:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (PXORrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  38644 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PXORrr),
     /*  38649 */     GIR_RootConstrainSelectedInstOperands,
     /*  38650 */     // GIR_Coverage, 2124,
     /*  38650 */     GIR_Done,
     /*  38651 */   // Label 954: @38651
     /*  38651 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(38678), // Rule ID 5812 //
     /*  38656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  38659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  38663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  38667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  38671 */     // (xor:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPXORQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*  38671 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rr),
     /*  38676 */     GIR_RootConstrainSelectedInstOperands,
     /*  38677 */     // GIR_Coverage, 5812,
     /*  38677 */     GIR_Done,
     /*  38678 */   // Label 955: @38678
     /*  38678 */   GIM_Reject,
     /*  38679 */ // Label 946: @38679
     /*  38679 */ GIM_Reject,
     /*  38680 */ // Label 856: @38680
     /*  38680 */ GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(39221),
     /*  38685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  38688 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  38691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  38695 */   GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(38815), // Rule ID 25376 //
     /*  38700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  38708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  38712 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  38716 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  38721 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  38725 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38731 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  38733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  38737 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  38739 */     // (xor:{ *:[v4i1] } (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, immAllOnesV:{ *:[v4i1] }), VK4:{ *:[v4i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /*  38739 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  38742 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38746 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38751 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  38755 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  38760 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  38763 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38767 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38772 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  38776 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  38781 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  38784 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  38788 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38793 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38796 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  38799 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  38809 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  38814 */     // GIR_Coverage, 25376,
     /*  38814 */     GIR_EraseRootFromParent_Done,
     /*  38815 */   // Label 957: @38815
     /*  38815 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(38936), // Rule ID 19498 //
     /*  38820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  38828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  38832 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  38836 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  38841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  38846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  38850 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38856 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  38858 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  38860 */     // (xor:{ *:[v4i1] } (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, VK4:{ *:[v4i1] }:$src2), immAllOnesV:{ *:[v4i1] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /*  38860 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  38863 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38867 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38872 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  38876 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  38881 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  38884 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38888 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38893 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  38897 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  38902 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  38905 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  38909 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38914 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38917 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  38920 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38927 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  38930 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  38935 */     // GIR_Coverage, 19498,
     /*  38935 */     GIR_EraseRootFromParent_Done,
     /*  38936 */   // Label 958: @38936
     /*  38936 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(39056), // Rule ID 25377 //
     /*  38941 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  38945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  38953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  38957 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  38961 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  38966 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  38970 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38976 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  38978 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  38980 */     // (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src2, (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, immAllOnesV:{ *:[v4i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /*  38980 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  38983 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38987 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38992 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  38996 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  39001 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  39004 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39008 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39013 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  39017 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  39022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  39025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  39029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39034 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  39037 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  39040 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39047 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39050 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  39055 */     // GIR_Coverage, 25377,
     /*  39055 */     GIR_EraseRootFromParent_Done,
     /*  39056 */   // Label 959: @39056
     /*  39056 */   GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(39131), // Rule ID 19480 //
     /*  39061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  39065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39069 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  39075 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  39077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39079 */     // (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src, immAllOnesV:{ *:[v4i1] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KNOTWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /*  39079 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  39082 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39086 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39091 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  39095 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  39100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  39103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /*  39107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39112 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  39115 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39122 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39125 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  39130 */     // GIR_Coverage, 19480,
     /*  39130 */     GIR_EraseRootFromParent_Done,
     /*  39131 */   // Label 960: @39131
     /*  39131 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(39220), // Rule ID 19502 //
     /*  39136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  39140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  39144 */     // (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, VK4:{ *:[v4i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KXORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /*  39144 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  39147 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39151 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39156 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  39160 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  39165 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  39168 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39172 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39177 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  39181 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  39186 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  39189 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXORWkk),
     /*  39193 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39198 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  39201 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  39204 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39211 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39214 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  39219 */     // GIR_Coverage, 19502,
     /*  39219 */     GIR_EraseRootFromParent_Done,
     /*  39220 */   // Label 961: @39220
     /*  39220 */   GIM_Reject,
     /*  39221 */ // Label 956: @39221
     /*  39221 */ GIM_Reject,
     /*  39222 */ // Label 857: @39222
     /*  39222 */ GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(39841),
     /*  39227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39230 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39233 */   GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(39295), // Rule ID 24239 //
     /*  39238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  39241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  39253 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  39256 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  39260 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  39264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39270 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  39277 */     // (xor:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4i32] }:$src1)  =>  (VPXORDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  39277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORDZ128rm),
     /*  39280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39282 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  39284 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  39288 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  39293 */     GIR_RootConstrainSelectedInstOperands,
     /*  39294 */     // GIR_Coverage, 24239,
     /*  39294 */     GIR_EraseRootFromParent_Done,
     /*  39295 */   // Label 963: @39295
     /*  39295 */   GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(39357), // Rule ID 25259 //
     /*  39300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  39303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  39315 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  39318 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  39322 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  39326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39330 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39332 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  39339 */     // (xor:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1)  =>  (VPXORrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  39339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORrm),
     /*  39342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39344 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  39346 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  39350 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  39355 */     GIR_RootConstrainSelectedInstOperands,
     /*  39356 */     // GIR_Coverage, 25259,
     /*  39356 */     GIR_EraseRootFromParent_Done,
     /*  39357 */   // Label 964: @39357
     /*  39357 */   GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(39419), // Rule ID 5842 //
     /*  39362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  39365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  39381 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  39384 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  39388 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  39392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39394 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  39401 */     // (xor:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  39401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORDZ128rm),
     /*  39404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39406 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  39408 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  39412 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  39417 */     GIR_RootConstrainSelectedInstOperands,
     /*  39418 */     // GIR_Coverage, 5842,
     /*  39418 */     GIR_EraseRootFromParent_Done,
     /*  39419 */   // Label 965: @39419
     /*  39419 */   GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(39481), // Rule ID 18166 //
     /*  39424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  39427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39431 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  39443 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  39446 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  39450 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  39454 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39456 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  39463 */     // (xor:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  39463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORrm),
     /*  39466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39468 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  39470 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  39474 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  39479 */     GIR_RootConstrainSelectedInstOperands,
     /*  39480 */     // GIR_Coverage, 18166,
     /*  39480 */     GIR_EraseRootFromParent_Done,
     /*  39481 */   // Label 966: @39481
     /*  39481 */   GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(39713), // Rule ID 21945 //
     /*  39486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /*  39489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  39493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39501 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  39507 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  39509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39511 */     // (xor:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src, immAllOnesV:{ *:[v4i32] })  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v4i32] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v4i32] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v4i32] }:$src, sub_xmm:{ *:[i32] }), 15:{ *:[i8] }), sub_xmm:{ *:[i32] })
     /*  39511 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /*  39514 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  39518 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39523 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  39525 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /*  39528 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  39532 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39537 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /*  39540 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  39544 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/11,
     /*  39547 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  39552 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  39557 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  39562 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  39565 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  39569 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  39576 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  39579 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  39583 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39588 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  39591 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  39595 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /*  39598 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  39603 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  39608 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  39613 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  39616 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  39620 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  39627 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  39630 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  39634 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39639 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  39642 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  39646 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /*  39649 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  39654 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  39659 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  39664 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  39667 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  39671 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39676 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  39679 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  39682 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  39685 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /*  39688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39695 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /*  39702 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /*  39707 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  39712 */     // GIR_Coverage, 21945,
     /*  39712 */     GIR_EraseRootFromParent_Done,
     /*  39713 */   // Label 967: @39713
     /*  39713 */   GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(39759), // Rule ID 21953 //
     /*  39718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  39721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39733 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  39739 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  39741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39743 */     // (xor:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src, immAllOnesV:{ *:[v4i32] })  =>  (VPTERNLOGQZ128rri:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src, VR128X:{ *:[v4i32] }:$src, VR128X:{ *:[v4i32] }:$src, 15:{ *:[i8] })
     /*  39743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ128rri),
     /*  39746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39748 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  39750 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  39752 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  39754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  39757 */     GIR_RootConstrainSelectedInstOperands,
     /*  39758 */     // GIR_Coverage, 21953,
     /*  39758 */     GIR_EraseRootFromParent_Done,
     /*  39759 */   // Label 968: @39759
     /*  39759 */   GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(39786), // Rule ID 5839 //
     /*  39764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  39767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39779 */     // (xor:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPXORDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /*  39779 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORDZ128rr),
     /*  39784 */     GIR_RootConstrainSelectedInstOperands,
     /*  39785 */     // GIR_Coverage, 5839,
     /*  39785 */     GIR_Done,
     /*  39786 */   // Label 969: @39786
     /*  39786 */   GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(39813), // Rule ID 18154 //
     /*  39791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  39794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39806 */     // (xor:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPXORrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  39806 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORrr),
     /*  39811 */     GIR_RootConstrainSelectedInstOperands,
     /*  39812 */     // GIR_Coverage, 18154,
     /*  39812 */     GIR_Done,
     /*  39813 */   // Label 970: @39813
     /*  39813 */   GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(39840), // Rule ID 18178 //
     /*  39818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  39821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39833 */     // (xor:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PXORrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  39833 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PXORrr),
     /*  39838 */     GIR_RootConstrainSelectedInstOperands,
     /*  39839 */     // GIR_Coverage, 18178,
     /*  39839 */     GIR_Done,
     /*  39840 */   // Label 971: @39840
     /*  39840 */   GIM_Reject,
     /*  39841 */ // Label 962: @39841
     /*  39841 */ GIM_Reject,
     /*  39842 */ // Label 858: @39842
     /*  39842 */ GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(40585),
     /*  39847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  39850 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  39853 */   GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(39915), // Rule ID 23368 //
     /*  39858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  39861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  39865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  39873 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  39876 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  39880 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  39884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  39888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39890 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  39897 */     // (xor:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4i64] }:$src1)  =>  (VPXORYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  39897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORYrm),
     /*  39900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39902 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  39904 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  39908 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  39913 */     GIR_RootConstrainSelectedInstOperands,
     /*  39914 */     // GIR_Coverage, 23368,
     /*  39914 */     GIR_EraseRootFromParent_Done,
     /*  39915 */   // Label 973: @39915
     /*  39915 */   GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(39977), // Rule ID 24215 //
     /*  39920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  39923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  39927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  39935 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  39938 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  39942 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  39946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  39950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39952 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  39959 */     // (xor:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4i64] }:$src1)  =>  (VPXORQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  39959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rm),
     /*  39962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39964 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  39966 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  39970 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  39975 */     GIR_RootConstrainSelectedInstOperands,
     /*  39976 */     // GIR_Coverage, 24215,
     /*  39976 */     GIR_EraseRootFromParent_Done,
     /*  39977 */   // Label 974: @39977
     /*  39977 */   GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(40039), // Rule ID 25250 //
     /*  39982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  39985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  39989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  39997 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  40000 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  40004 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  40008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  40012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40014 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  40021 */     // (xor:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4i64] }:$src1)  =>  (VXORPSYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  40021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VXORPSYrm),
     /*  40024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40026 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  40028 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  40032 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  40037 */     GIR_RootConstrainSelectedInstOperands,
     /*  40038 */     // GIR_Coverage, 25250,
     /*  40038 */     GIR_EraseRootFromParent_Done,
     /*  40039 */   // Label 975: @40039
     /*  40039 */   GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(40101), // Rule ID 2127 //
     /*  40044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  40047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  40051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  40055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  40063 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  40066 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  40070 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  40074 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40076 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  40083 */     // (xor:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  40083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORYrm),
     /*  40086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40088 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  40090 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  40094 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  40099 */     GIR_RootConstrainSelectedInstOperands,
     /*  40100 */     // GIR_Coverage, 2127,
     /*  40100 */     GIR_EraseRootFromParent_Done,
     /*  40101 */   // Label 976: @40101
     /*  40101 */   GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(40163), // Rule ID 5806 //
     /*  40106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  40109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  40113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  40117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  40125 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  40128 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  40132 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  40136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40138 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  40145 */     // (xor:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  40145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rm),
     /*  40148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40150 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  40152 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  40156 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  40161 */     GIR_RootConstrainSelectedInstOperands,
     /*  40162 */     // GIR_Coverage, 5806,
     /*  40162 */     GIR_EraseRootFromParent_Done,
     /*  40163 */   // Label 977: @40163
     /*  40163 */   GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(40225), // Rule ID 18141 //
     /*  40168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  40171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  40175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  40179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  40187 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  40190 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  40194 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  40198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40200 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  40207 */     // (xor:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VXORPSYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  40207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VXORPSYrm),
     /*  40210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40212 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  40214 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  40218 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  40223 */     GIR_RootConstrainSelectedInstOperands,
     /*  40224 */     // GIR_Coverage, 18141,
     /*  40224 */     GIR_EraseRootFromParent_Done,
     /*  40225 */   // Label 978: @40225
     /*  40225 */   GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(40457), // Rule ID 21950 //
     /*  40230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /*  40233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  40237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  40241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40245 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40251 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  40253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40255 */     // (xor:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src, immAllOnesV:{ *:[v4i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src, sub_ymm:{ *:[i32] }), 15:{ *:[i8] }), sub_ymm:{ *:[i32] })
     /*  40255 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /*  40258 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40262 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40267 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  40269 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /*  40272 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40276 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40281 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /*  40284 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  40288 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/12,
     /*  40291 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  40296 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  40301 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  40306 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  40309 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40313 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40318 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  40320 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  40323 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40327 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40332 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  40335 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  40339 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /*  40342 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  40347 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  40352 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  40357 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  40360 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40364 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40369 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40371 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  40374 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40378 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40383 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40386 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  40390 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /*  40393 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  40398 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  40403 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  40408 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  40411 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  40415 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40420 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40423 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  40426 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  40429 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /*  40432 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40439 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /*  40446 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /*  40451 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  40456 */     // GIR_Coverage, 21950,
     /*  40456 */     GIR_EraseRootFromParent_Done,
     /*  40457 */   // Label 979: @40457
     /*  40457 */   GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(40503), // Rule ID 21958 //
     /*  40462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  40465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  40469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  40473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40477 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40483 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  40485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40487 */     // (xor:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src, immAllOnesV:{ *:[v4i64] })  =>  (VPTERNLOGQZ256rri:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src, VR256X:{ *:[v4i64] }:$src, VR256X:{ *:[v4i64] }:$src, 15:{ *:[i8] })
     /*  40487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ256rri),
     /*  40490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40492 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  40494 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  40496 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  40498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  40501 */     GIR_RootConstrainSelectedInstOperands,
     /*  40502 */     // GIR_Coverage, 21958,
     /*  40502 */     GIR_EraseRootFromParent_Done,
     /*  40503 */   // Label 980: @40503
     /*  40503 */   GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(40530), // Rule ID 2126 //
     /*  40508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  40511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  40515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  40519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  40523 */     // (xor:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VPXORYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  40523 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORYrr),
     /*  40528 */     GIR_RootConstrainSelectedInstOperands,
     /*  40529 */     // GIR_Coverage, 2126,
     /*  40529 */     GIR_Done,
     /*  40530 */   // Label 981: @40530
     /*  40530 */   GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(40557), // Rule ID 5803 //
     /*  40535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  40538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  40542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  40546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  40550 */     // (xor:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPXORQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*  40550 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rr),
     /*  40555 */     GIR_RootConstrainSelectedInstOperands,
     /*  40556 */     // GIR_Coverage, 5803,
     /*  40556 */     GIR_Done,
     /*  40557 */   // Label 982: @40557
     /*  40557 */   GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(40584), // Rule ID 18125 //
     /*  40562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  40565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  40569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  40573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  40577 */     // (xor:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VXORPSYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  40577 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VXORPSYrr),
     /*  40582 */     GIR_RootConstrainSelectedInstOperands,
     /*  40583 */     // GIR_Coverage, 18125,
     /*  40583 */     GIR_Done,
     /*  40584 */   // Label 983: @40584
     /*  40584 */   GIM_Reject,
     /*  40585 */ // Label 972: @40585
     /*  40585 */ GIM_Reject,
     /*  40586 */ // Label 859: @40586
     /*  40586 */ GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(41383),
     /*  40591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  40594 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  40597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40601 */   GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(40661), // Rule ID 23684 //
     /*  40606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  40609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  40621 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  40625 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40630 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  40634 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40640 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  40642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40646 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40648 */     // (xor:{ *:[v8i1] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }), VK8:{ *:[v8i1] }:$src2)  =>  (KXNORBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /*  40648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORBkk),
     /*  40651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  40657 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  40659 */     GIR_RootConstrainSelectedInstOperands,
     /*  40660 */     // GIR_Coverage, 23684,
     /*  40660 */     GIR_EraseRootFromParent_Done,
     /*  40661 */   // Label 985: @40661
     /*  40661 */   GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(40784), // Rule ID 25370 //
     /*  40666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /*  40669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  40681 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  40685 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  40694 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40700 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  40702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40706 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40708 */     // (xor:{ *:[v8i1] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }), VK8:{ *:[v8i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /*  40708 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  40711 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40715 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40720 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  40724 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  40729 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  40732 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40736 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40741 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  40745 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  40750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  40753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  40757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40762 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40765 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  40768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  40778 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  40783 */     // GIR_Coverage, 25370,
     /*  40783 */     GIR_EraseRootFromParent_Done,
     /*  40784 */   // Label 986: @40784
     /*  40784 */   GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(40847), // Rule ID 4423 //
     /*  40789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  40792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  40804 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  40808 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40813 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  40822 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40828 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  40830 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40832 */     // (xor:{ *:[v8i1] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2), immAllOnesV:{ *:[v8i1] })  =>  (KXNORBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /*  40832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORBkk),
     /*  40835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  40841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  40845 */     GIR_RootConstrainSelectedInstOperands,
     /*  40846 */     // GIR_Coverage, 4423,
     /*  40846 */     GIR_EraseRootFromParent_Done,
     /*  40847 */   // Label 987: @40847
     /*  40847 */   GIM_Try, /*On fail goto*//*Label 988*/ GIMT_Encode4(40971), // Rule ID 19495 //
     /*  40852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /*  40855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  40867 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  40871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40876 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  40885 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40891 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  40893 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40895 */     // (xor:{ *:[v8i1] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2), immAllOnesV:{ *:[v8i1] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /*  40895 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  40898 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40902 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40907 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  40911 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  40916 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  40919 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40923 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40928 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  40932 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  40937 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  40940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  40944 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40949 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40952 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  40955 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40962 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  40965 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  40970 */     // GIR_Coverage, 19495,
     /*  40970 */     GIR_EraseRootFromParent_Done,
     /*  40971 */   // Label 988: @40971
     /*  40971 */   GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(41031), // Rule ID 23685 //
     /*  40976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  40979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40991 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  40995 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  40999 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  41004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  41008 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41014 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  41016 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  41018 */     // (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src2, (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }))  =>  (KXNORBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /*  41018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORBkk),
     /*  41021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  41027 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  41029 */     GIR_RootConstrainSelectedInstOperands,
     /*  41030 */     // GIR_Coverage, 23685,
     /*  41030 */     GIR_EraseRootFromParent_Done,
     /*  41031 */   // Label 989: @41031
     /*  41031 */   GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(41154), // Rule ID 25371 //
     /*  41036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /*  41039 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  41043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  41051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  41055 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  41059 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  41064 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  41068 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41074 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  41076 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  41078 */     // (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src2, (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /*  41078 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  41081 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41085 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41090 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  41094 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  41099 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  41102 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41106 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41111 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  41115 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  41120 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  41123 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  41127 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41132 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  41135 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  41138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41148 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  41153 */     // GIR_Coverage, 25371,
     /*  41153 */     GIR_EraseRootFromParent_Done,
     /*  41154 */   // Label 990: @41154
     /*  41154 */   GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(41189), // Rule ID 4411 //
     /*  41159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  41162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  41166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41170 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41176 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  41178 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41180 */     // (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src, immAllOnesV:{ *:[v8i1] })  =>  (KNOTBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src)
     /*  41180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KNOTBkk),
     /*  41183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41185 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  41187 */     GIR_RootConstrainSelectedInstOperands,
     /*  41188 */     // GIR_Coverage, 4411,
     /*  41188 */     GIR_EraseRootFromParent_Done,
     /*  41189 */   // Label 991: @41189
     /*  41189 */   GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(41267), // Rule ID 19479 //
     /*  41194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_NoDQI),
     /*  41197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  41201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41205 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41211 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  41213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41215 */     // (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src, immAllOnesV:{ *:[v8i1] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KNOTWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /*  41215 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  41218 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41222 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41227 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  41231 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  41236 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  41239 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /*  41243 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41248 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  41251 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41258 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41261 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  41266 */     // GIR_Coverage, 19479,
     /*  41266 */     GIR_EraseRootFromParent_Done,
     /*  41267 */   // Label 992: @41267
     /*  41267 */   GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(41290), // Rule ID 4427 //
     /*  41272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  41275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  41279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  41283 */     // (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (KXORBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /*  41283 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KXORBkk),
     /*  41288 */     GIR_RootConstrainSelectedInstOperands,
     /*  41289 */     // GIR_Coverage, 4427,
     /*  41289 */     GIR_Done,
     /*  41290 */   // Label 993: @41290
     /*  41290 */   GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(41382), // Rule ID 19499 //
     /*  41295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /*  41298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  41302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  41306 */     // (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KXORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /*  41306 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  41309 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41313 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41318 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  41322 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  41327 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  41330 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41334 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41339 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  41343 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  41348 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  41351 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXORWkk),
     /*  41355 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41360 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  41363 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  41366 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41373 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41376 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  41381 */     // GIR_Coverage, 19499,
     /*  41381 */     GIR_EraseRootFromParent_Done,
     /*  41382 */   // Label 994: @41382
     /*  41382 */   GIM_Reject,
     /*  41383 */ // Label 984: @41383
     /*  41383 */ GIM_Reject,
     /*  41384 */ // Label 860: @41384
     /*  41384 */ GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(42003),
     /*  41389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  41392 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  41395 */   GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(41457), // Rule ID 25258 //
     /*  41400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  41403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  41415 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  41418 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  41422 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  41426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41430 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41432 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  41439 */     // (xor:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPXORrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  41439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORrm),
     /*  41442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41444 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  41446 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  41450 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  41455 */     GIR_RootConstrainSelectedInstOperands,
     /*  41456 */     // GIR_Coverage, 25258,
     /*  41456 */     GIR_EraseRootFromParent_Done,
     /*  41457 */   // Label 996: @41457
     /*  41457 */   GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(41519), // Rule ID 25437 //
     /*  41462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  41465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  41477 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  41480 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  41484 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  41488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41494 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  41501 */     // (xor:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPXORQZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  41501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rm),
     /*  41504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41506 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  41508 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  41512 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  41517 */     GIR_RootConstrainSelectedInstOperands,
     /*  41518 */     // GIR_Coverage, 25437,
     /*  41518 */     GIR_EraseRootFromParent_Done,
     /*  41519 */   // Label 997: @41519
     /*  41519 */   GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(41581), // Rule ID 18165 //
     /*  41524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  41527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  41543 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  41546 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  41550 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  41554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41556 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  41563 */     // (xor:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  41563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORrm),
     /*  41566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41568 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  41570 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  41574 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  41579 */     GIR_RootConstrainSelectedInstOperands,
     /*  41580 */     // GIR_Coverage, 18165,
     /*  41580 */     GIR_EraseRootFromParent_Done,
     /*  41581 */   // Label 998: @41581
     /*  41581 */   GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(41643), // Rule ID 20029 //
     /*  41586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  41589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  41605 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  41608 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  41612 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  41616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41618 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  41625 */     // (xor:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORQZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  41625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rm),
     /*  41628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41630 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  41632 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  41636 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  41641 */     GIR_RootConstrainSelectedInstOperands,
     /*  41642 */     // GIR_Coverage, 20029,
     /*  41642 */     GIR_EraseRootFromParent_Done,
     /*  41643 */   // Label 999: @41643
     /*  41643 */   GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(41875), // Rule ID 21944 //
     /*  41648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /*  41651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  41655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41663 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41669 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  41671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41673 */     // (xor:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src, immAllOnesV:{ *:[v8i16] })  =>  (EXTRACT_SUBREG:{ *:[v8i16] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v8i16] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v8i16] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v8i16] }:$src, sub_xmm:{ *:[i32] }), 15:{ *:[i8] }), sub_xmm:{ *:[i32] })
     /*  41673 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /*  41676 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41680 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41685 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  41687 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /*  41690 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  41694 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41699 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /*  41702 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  41706 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/11,
     /*  41709 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  41714 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  41719 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  41724 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  41727 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41731 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41736 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  41738 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  41741 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  41745 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41750 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  41753 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  41757 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /*  41760 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  41765 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  41770 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  41775 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  41778 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41782 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41787 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  41789 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  41792 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  41796 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41801 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  41804 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  41808 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /*  41811 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  41816 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  41821 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  41826 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  41829 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  41833 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41838 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  41841 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  41844 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  41847 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /*  41850 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41857 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /*  41864 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /*  41869 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  41874 */     // GIR_Coverage, 21944,
     /*  41874 */     GIR_EraseRootFromParent_Done,
     /*  41875 */   // Label 1000: @41875
     /*  41875 */   GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(41921), // Rule ID 21952 //
     /*  41880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  41883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41895 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41901 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  41903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41905 */     // (xor:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src, immAllOnesV:{ *:[v8i16] })  =>  (VPTERNLOGQZ128rri:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src, VR128X:{ *:[v8i16] }:$src, VR128X:{ *:[v8i16] }:$src, 15:{ *:[i8] })
     /*  41905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ128rri),
     /*  41908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41910 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  41912 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  41914 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  41916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  41919 */     GIR_RootConstrainSelectedInstOperands,
     /*  41920 */     // GIR_Coverage, 21952,
     /*  41920 */     GIR_EraseRootFromParent_Done,
     /*  41921 */   // Label 1001: @41921
     /*  41921 */   GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(41948), // Rule ID 18153 //
     /*  41926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  41929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41941 */     // (xor:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPXORrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  41941 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORrr),
     /*  41946 */     GIR_RootConstrainSelectedInstOperands,
     /*  41947 */     // GIR_Coverage, 18153,
     /*  41947 */     GIR_Done,
     /*  41948 */   // Label 1002: @41948
     /*  41948 */   GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(41975), // Rule ID 18177 //
     /*  41953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  41956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41968 */     // (xor:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PXORrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  41968 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PXORrr),
     /*  41973 */     GIR_RootConstrainSelectedInstOperands,
     /*  41974 */     // GIR_Coverage, 18177,
     /*  41974 */     GIR_Done,
     /*  41975 */   // Label 1003: @41975
     /*  41975 */   GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(42002), // Rule ID 20021 //
     /*  41980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  41983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41995 */     // (xor:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPXORQZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /*  41995 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rr),
     /*  42000 */     GIR_RootConstrainSelectedInstOperands,
     /*  42001 */     // GIR_Coverage, 20021,
     /*  42001 */     GIR_Done,
     /*  42002 */   // Label 1004: @42002
     /*  42002 */   GIM_Reject,
     /*  42003 */ // Label 995: @42003
     /*  42003 */ GIM_Reject,
     /*  42004 */ // Label 861: @42004
     /*  42004 */ GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(42747),
     /*  42009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  42012 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  42015 */   GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(42077), // Rule ID 24233 //
     /*  42020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  42023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  42035 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  42038 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  42042 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  42046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42052 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  42059 */     // (xor:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8i32] }:$src1)  =>  (VPXORDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  42059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORDZ256rm),
     /*  42062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42064 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  42066 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  42070 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  42075 */     GIR_RootConstrainSelectedInstOperands,
     /*  42076 */     // GIR_Coverage, 24233,
     /*  42076 */     GIR_EraseRootFromParent_Done,
     /*  42077 */   // Label 1006: @42077
     /*  42077 */   GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(42139), // Rule ID 25238 //
     /*  42082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  42085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  42097 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  42100 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  42104 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  42108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42114 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  42121 */     // (xor:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VPXORYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  42121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORYrm),
     /*  42124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42126 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  42128 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  42132 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  42137 */     GIR_RootConstrainSelectedInstOperands,
     /*  42138 */     // GIR_Coverage, 25238,
     /*  42138 */     GIR_EraseRootFromParent_Done,
     /*  42139 */   // Label 1007: @42139
     /*  42139 */   GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(42201), // Rule ID 25249 //
     /*  42144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  42147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  42159 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  42162 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  42166 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  42170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42174 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42176 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  42183 */     // (xor:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VXORPSYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  42183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VXORPSYrm),
     /*  42186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42188 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  42190 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  42194 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  42199 */     GIR_RootConstrainSelectedInstOperands,
     /*  42200 */     // GIR_Coverage, 25249,
     /*  42200 */     GIR_EraseRootFromParent_Done,
     /*  42201 */   // Label 1008: @42201
     /*  42201 */   GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(42263), // Rule ID 5833 //
     /*  42206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  42209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  42225 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  42228 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  42232 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  42236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42238 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  42245 */     // (xor:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  42245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORDZ256rm),
     /*  42248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42250 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  42252 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  42256 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  42261 */     GIR_RootConstrainSelectedInstOperands,
     /*  42262 */     // GIR_Coverage, 5833,
     /*  42262 */     GIR_EraseRootFromParent_Done,
     /*  42263 */   // Label 1009: @42263
     /*  42263 */   GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(42325), // Rule ID 18110 //
     /*  42268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  42271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  42287 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  42290 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  42294 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  42298 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42300 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  42307 */     // (xor:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  42307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORYrm),
     /*  42310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42312 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  42314 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  42318 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  42323 */     GIR_RootConstrainSelectedInstOperands,
     /*  42324 */     // GIR_Coverage, 18110,
     /*  42324 */     GIR_EraseRootFromParent_Done,
     /*  42325 */   // Label 1010: @42325
     /*  42325 */   GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(42387), // Rule ID 18140 //
     /*  42330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  42333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  42349 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  42352 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  42356 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  42360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42362 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  42369 */     // (xor:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VXORPSYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  42369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VXORPSYrm),
     /*  42372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42374 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  42376 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  42380 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  42385 */     GIR_RootConstrainSelectedInstOperands,
     /*  42386 */     // GIR_Coverage, 18140,
     /*  42386 */     GIR_EraseRootFromParent_Done,
     /*  42387 */   // Label 1011: @42387
     /*  42387 */   GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(42619), // Rule ID 21949 //
     /*  42392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /*  42395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42399 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42407 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42413 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  42415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42417 */     // (xor:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src, immAllOnesV:{ *:[v8i32] })  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v8i32] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v8i32] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v8i32] }:$src, sub_ymm:{ *:[i32] }), 15:{ *:[i8] }), sub_ymm:{ *:[i32] })
     /*  42417 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /*  42420 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42424 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42429 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  42431 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /*  42434 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42438 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42443 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /*  42446 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  42450 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/12,
     /*  42453 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  42458 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  42463 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  42468 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  42471 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42475 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42480 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  42482 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  42485 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42489 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42494 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  42497 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  42501 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /*  42504 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  42509 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  42514 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  42519 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  42522 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42526 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42531 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42533 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  42536 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42540 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42545 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42548 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  42552 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /*  42555 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  42560 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  42565 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  42570 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  42573 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  42577 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42582 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42585 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  42588 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  42591 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /*  42594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42601 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /*  42608 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /*  42613 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  42618 */     // GIR_Coverage, 21949,
     /*  42618 */     GIR_EraseRootFromParent_Done,
     /*  42619 */   // Label 1012: @42619
     /*  42619 */   GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(42665), // Rule ID 21957 //
     /*  42624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  42627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42639 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42645 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  42647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42649 */     // (xor:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src, immAllOnesV:{ *:[v8i32] })  =>  (VPTERNLOGQZ256rri:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src, VR256X:{ *:[v8i32] }:$src, VR256X:{ *:[v8i32] }:$src, 15:{ *:[i8] })
     /*  42649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ256rri),
     /*  42652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42654 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  42656 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  42658 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  42660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  42663 */     GIR_RootConstrainSelectedInstOperands,
     /*  42664 */     // GIR_Coverage, 21957,
     /*  42664 */     GIR_EraseRootFromParent_Done,
     /*  42665 */   // Label 1013: @42665
     /*  42665 */   GIM_Try, /*On fail goto*//*Label 1014*/ GIMT_Encode4(42692), // Rule ID 5830 //
     /*  42670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  42673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42677 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42685 */     // (xor:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPXORDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /*  42685 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORDZ256rr),
     /*  42690 */     GIR_RootConstrainSelectedInstOperands,
     /*  42691 */     // GIR_Coverage, 5830,
     /*  42691 */     GIR_Done,
     /*  42692 */   // Label 1014: @42692
     /*  42692 */   GIM_Try, /*On fail goto*//*Label 1015*/ GIMT_Encode4(42719), // Rule ID 18098 //
     /*  42697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  42700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42712 */     // (xor:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPXORYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  42712 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORYrr),
     /*  42717 */     GIR_RootConstrainSelectedInstOperands,
     /*  42718 */     // GIR_Coverage, 18098,
     /*  42718 */     GIR_Done,
     /*  42719 */   // Label 1015: @42719
     /*  42719 */   GIM_Try, /*On fail goto*//*Label 1016*/ GIMT_Encode4(42746), // Rule ID 18124 //
     /*  42724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  42727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42739 */     // (xor:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VXORPSYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  42739 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VXORPSYrr),
     /*  42744 */     GIR_RootConstrainSelectedInstOperands,
     /*  42745 */     // GIR_Coverage, 18124,
     /*  42745 */     GIR_Done,
     /*  42746 */   // Label 1016: @42746
     /*  42746 */   GIM_Reject,
     /*  42747 */ // Label 1005: @42747
     /*  42747 */ GIM_Reject,
     /*  42748 */ // Label 862: @42748
     /*  42748 */ GIM_Try, /*On fail goto*//*Label 1017*/ GIMT_Encode4(42945),
     /*  42753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  42756 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  42759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  42763 */   GIM_Try, /*On fail goto*//*Label 1018*/ GIMT_Encode4(42821), // Rule ID 24209 //
     /*  42768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  42771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  42779 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  42782 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  42786 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  42790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  42794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42796 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  42803 */     // (xor:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8i64] }:$src1)  =>  (VPXORQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  42803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZrm),
     /*  42806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42808 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  42810 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  42814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  42819 */     GIR_RootConstrainSelectedInstOperands,
     /*  42820 */     // GIR_Coverage, 24209,
     /*  42820 */     GIR_EraseRootFromParent_Done,
     /*  42821 */   // Label 1018: @42821
     /*  42821 */   GIM_Try, /*On fail goto*//*Label 1019*/ GIMT_Encode4(42879), // Rule ID 5797 //
     /*  42826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  42829 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  42833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  42841 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  42844 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  42848 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  42852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42854 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  42861 */     // (xor:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  42861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZrm),
     /*  42864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42866 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  42868 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  42872 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  42877 */     GIR_RootConstrainSelectedInstOperands,
     /*  42878 */     // GIR_Coverage, 5797,
     /*  42878 */     GIR_EraseRootFromParent_Done,
     /*  42879 */   // Label 1019: @42879
     /*  42879 */   GIM_Try, /*On fail goto*//*Label 1020*/ GIMT_Encode4(42921), // Rule ID 21942 //
     /*  42884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  42887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  42891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42895 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42901 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  42903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42905 */     // (xor:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src, immAllOnesV:{ *:[v8i64] })  =>  (VPTERNLOGQZrri:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src, VR512:{ *:[v8i64] }:$src, VR512:{ *:[v8i64] }:$src, 15:{ *:[i8] })
     /*  42905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  42908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42910 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  42912 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  42914 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  42916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  42919 */     GIR_RootConstrainSelectedInstOperands,
     /*  42920 */     // GIR_Coverage, 21942,
     /*  42920 */     GIR_EraseRootFromParent_Done,
     /*  42921 */   // Label 1020: @42921
     /*  42921 */   GIM_Try, /*On fail goto*//*Label 1021*/ GIMT_Encode4(42944), // Rule ID 5794 //
     /*  42926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  42929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  42933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  42937 */     // (xor:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPXORQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  42937 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZrr),
     /*  42942 */     GIR_RootConstrainSelectedInstOperands,
     /*  42943 */     // GIR_Coverage, 5794,
     /*  42943 */     GIR_Done,
     /*  42944 */   // Label 1021: @42944
     /*  42944 */   GIM_Reject,
     /*  42945 */ // Label 1017: @42945
     /*  42945 */ GIM_Reject,
     /*  42946 */ // Label 863: @42946
     /*  42946 */ GIM_Try, /*On fail goto*//*Label 1022*/ GIMT_Encode4(43203),
     /*  42951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  42954 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  42957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  42961 */   GIM_Try, /*On fail goto*//*Label 1023*/ GIMT_Encode4(43021), // Rule ID 23686 //
     /*  42966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  42969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42977 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  42981 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  42985 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  42990 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  42994 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43000 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  43002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  43006 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43008 */     // (xor:{ *:[v16i1] } (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, immAllOnesV:{ *:[v16i1] }), VK16:{ *:[v16i1] }:$src2)  =>  (KXNORWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /*  43008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  43011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43013 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  43017 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  43019 */     GIR_RootConstrainSelectedInstOperands,
     /*  43020 */     // GIR_Coverage, 23686,
     /*  43020 */     GIR_EraseRootFromParent_Done,
     /*  43021 */   // Label 1023: @43021
     /*  43021 */   GIM_Try, /*On fail goto*//*Label 1024*/ GIMT_Encode4(43084), // Rule ID 4424 //
     /*  43026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  43029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  43037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  43041 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  43045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  43050 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  43055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43059 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43065 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  43067 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43069 */     // (xor:{ *:[v16i1] } (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2), immAllOnesV:{ *:[v16i1] })  =>  (KXNORWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /*  43069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  43072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  43078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  43082 */     GIR_RootConstrainSelectedInstOperands,
     /*  43083 */     // GIR_Coverage, 4424,
     /*  43083 */     GIR_EraseRootFromParent_Done,
     /*  43084 */   // Label 1024: @43084
     /*  43084 */   GIM_Try, /*On fail goto*//*Label 1025*/ GIMT_Encode4(43144), // Rule ID 23687 //
     /*  43089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  43092 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  43096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  43104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  43108 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  43112 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  43117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  43121 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43127 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  43129 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43131 */     // (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src2, (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, immAllOnesV:{ *:[v16i1] }))  =>  (KXNORWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /*  43131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  43134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  43140 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  43142 */     GIR_RootConstrainSelectedInstOperands,
     /*  43143 */     // GIR_Coverage, 23687,
     /*  43143 */     GIR_EraseRootFromParent_Done,
     /*  43144 */   // Label 1025: @43144
     /*  43144 */   GIM_Try, /*On fail goto*//*Label 1026*/ GIMT_Encode4(43179), // Rule ID 4412 //
     /*  43149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  43152 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  43156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43160 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43166 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  43168 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43170 */     // (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src, immAllOnesV:{ *:[v16i1] })  =>  (KNOTWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src)
     /*  43170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /*  43173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43175 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  43177 */     GIR_RootConstrainSelectedInstOperands,
     /*  43178 */     // GIR_Coverage, 4412,
     /*  43178 */     GIR_EraseRootFromParent_Done,
     /*  43179 */   // Label 1026: @43179
     /*  43179 */   GIM_Try, /*On fail goto*//*Label 1027*/ GIMT_Encode4(43202), // Rule ID 4428 //
     /*  43184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  43187 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  43191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  43195 */     // (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)  =>  (KXORWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /*  43195 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KXORWkk),
     /*  43200 */     GIR_RootConstrainSelectedInstOperands,
     /*  43201 */     // GIR_Coverage, 4428,
     /*  43201 */     GIR_Done,
     /*  43202 */   // Label 1027: @43202
     /*  43202 */   GIM_Reject,
     /*  43203 */ // Label 1022: @43203
     /*  43203 */ GIM_Reject,
     /*  43204 */ // Label 864: @43204
     /*  43204 */ GIM_Try, /*On fail goto*//*Label 1028*/ GIMT_Encode4(43823),
     /*  43209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  43212 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  43215 */   GIM_Try, /*On fail goto*//*Label 1029*/ GIMT_Encode4(43277), // Rule ID 25257 //
     /*  43220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  43223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  43235 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  43238 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  43242 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  43246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43250 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43252 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  43259 */     // (xor:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPXORrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  43259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORrm),
     /*  43262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43264 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  43266 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  43270 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  43275 */     GIR_RootConstrainSelectedInstOperands,
     /*  43276 */     // GIR_Coverage, 25257,
     /*  43276 */     GIR_EraseRootFromParent_Done,
     /*  43277 */   // Label 1029: @43277
     /*  43277 */   GIM_Try, /*On fail goto*//*Label 1030*/ GIMT_Encode4(43339), // Rule ID 25436 //
     /*  43282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  43285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  43297 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  43300 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  43304 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  43308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43314 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  43321 */     // (xor:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPXORQZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  43321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rm),
     /*  43324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43326 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  43328 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  43332 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  43337 */     GIR_RootConstrainSelectedInstOperands,
     /*  43338 */     // GIR_Coverage, 25436,
     /*  43338 */     GIR_EraseRootFromParent_Done,
     /*  43339 */   // Label 1030: @43339
     /*  43339 */   GIM_Try, /*On fail goto*//*Label 1031*/ GIMT_Encode4(43401), // Rule ID 18164 //
     /*  43344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  43347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  43363 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  43366 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  43370 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  43374 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43376 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  43383 */     // (xor:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  43383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORrm),
     /*  43386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43388 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  43390 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  43394 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  43399 */     GIR_RootConstrainSelectedInstOperands,
     /*  43400 */     // GIR_Coverage, 18164,
     /*  43400 */     GIR_EraseRootFromParent_Done,
     /*  43401 */   // Label 1031: @43401
     /*  43401 */   GIM_Try, /*On fail goto*//*Label 1032*/ GIMT_Encode4(43463), // Rule ID 20028 //
     /*  43406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  43409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  43425 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  43428 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  43432 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  43436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43438 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  43445 */     // (xor:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORQZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  43445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rm),
     /*  43448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43450 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  43452 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  43456 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  43461 */     GIR_RootConstrainSelectedInstOperands,
     /*  43462 */     // GIR_Coverage, 20028,
     /*  43462 */     GIR_EraseRootFromParent_Done,
     /*  43463 */   // Label 1032: @43463
     /*  43463 */   GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(43695), // Rule ID 21943 //
     /*  43468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /*  43471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  43475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43483 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43489 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  43491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43493 */     // (xor:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src, immAllOnesV:{ *:[v16i8] })  =>  (EXTRACT_SUBREG:{ *:[v16i8] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v16i8] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v16i8] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v16i8] }:$src, sub_xmm:{ *:[i32] }), 15:{ *:[i8] }), sub_xmm:{ *:[i32] })
     /*  43493 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /*  43496 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43500 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43505 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  43507 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /*  43510 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43514 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43519 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /*  43522 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  43526 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/11,
     /*  43529 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  43534 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  43539 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  43544 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  43547 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43551 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43556 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  43558 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  43561 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43565 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43570 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  43573 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  43577 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /*  43580 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  43585 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  43590 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  43595 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  43598 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43602 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43607 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  43609 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  43612 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43616 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43621 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  43624 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  43628 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /*  43631 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  43636 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  43641 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  43646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  43649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  43653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43658 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43661 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  43664 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  43667 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /*  43670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43677 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /*  43684 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /*  43689 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  43694 */     // GIR_Coverage, 21943,
     /*  43694 */     GIR_EraseRootFromParent_Done,
     /*  43695 */   // Label 1033: @43695
     /*  43695 */   GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(43741), // Rule ID 21951 //
     /*  43700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  43703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43707 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43715 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43721 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  43723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43725 */     // (xor:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src, immAllOnesV:{ *:[v16i8] })  =>  (VPTERNLOGQZ128rri:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src, VR128X:{ *:[v16i8] }:$src, VR128X:{ *:[v16i8] }:$src, 15:{ *:[i8] })
     /*  43725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ128rri),
     /*  43728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43730 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  43732 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  43734 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  43736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  43739 */     GIR_RootConstrainSelectedInstOperands,
     /*  43740 */     // GIR_Coverage, 21951,
     /*  43740 */     GIR_EraseRootFromParent_Done,
     /*  43741 */   // Label 1034: @43741
     /*  43741 */   GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(43768), // Rule ID 18152 //
     /*  43746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  43749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43761 */     // (xor:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPXORrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  43761 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORrr),
     /*  43766 */     GIR_RootConstrainSelectedInstOperands,
     /*  43767 */     // GIR_Coverage, 18152,
     /*  43767 */     GIR_Done,
     /*  43768 */   // Label 1035: @43768
     /*  43768 */   GIM_Try, /*On fail goto*//*Label 1036*/ GIMT_Encode4(43795), // Rule ID 18176 //
     /*  43773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  43776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43788 */     // (xor:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PXORrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  43788 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PXORrr),
     /*  43793 */     GIR_RootConstrainSelectedInstOperands,
     /*  43794 */     // GIR_Coverage, 18176,
     /*  43794 */     GIR_Done,
     /*  43795 */   // Label 1036: @43795
     /*  43795 */   GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(43822), // Rule ID 20020 //
     /*  43800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  43803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43807 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43815 */     // (xor:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPXORQZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /*  43815 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rr),
     /*  43820 */     GIR_RootConstrainSelectedInstOperands,
     /*  43821 */     // GIR_Coverage, 20020,
     /*  43821 */     GIR_Done,
     /*  43822 */   // Label 1037: @43822
     /*  43822 */   GIM_Reject,
     /*  43823 */ // Label 1028: @43823
     /*  43823 */ GIM_Reject,
     /*  43824 */ // Label 865: @43824
     /*  43824 */ GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(44567),
     /*  43829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  43832 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  43835 */   GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(43897), // Rule ID 25237 //
     /*  43840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  43843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  43847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  43855 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  43858 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  43862 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  43866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  43870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43872 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  43879 */     // (xor:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPXORYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  43879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORYrm),
     /*  43882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43884 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  43886 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  43890 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  43895 */     GIR_RootConstrainSelectedInstOperands,
     /*  43896 */     // GIR_Coverage, 25237,
     /*  43896 */     GIR_EraseRootFromParent_Done,
     /*  43897 */   // Label 1039: @43897
     /*  43897 */   GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(43959), // Rule ID 25248 //
     /*  43902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  43905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  43909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  43917 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  43920 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  43924 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  43928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  43932 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43934 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  43941 */     // (xor:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VXORPSYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  43941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VXORPSYrm),
     /*  43944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43946 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  43948 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  43952 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  43957 */     GIR_RootConstrainSelectedInstOperands,
     /*  43958 */     // GIR_Coverage, 25248,
     /*  43958 */     GIR_EraseRootFromParent_Done,
     /*  43959 */   // Label 1040: @43959
     /*  43959 */   GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(44021), // Rule ID 25443 //
     /*  43964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  43967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  43971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  43979 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  43982 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  43986 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  43990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  43994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43996 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  44003 */     // (xor:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPXORQZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  44003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rm),
     /*  44006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44008 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  44010 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  44014 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  44019 */     GIR_RootConstrainSelectedInstOperands,
     /*  44020 */     // GIR_Coverage, 25443,
     /*  44020 */     GIR_EraseRootFromParent_Done,
     /*  44021 */   // Label 1041: @44021
     /*  44021 */   GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(44083), // Rule ID 18109 //
     /*  44026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  44029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44033 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  44045 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  44048 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  44052 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  44056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44058 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  44065 */     // (xor:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  44065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORYrm),
     /*  44068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44070 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  44072 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  44076 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  44081 */     GIR_RootConstrainSelectedInstOperands,
     /*  44082 */     // GIR_Coverage, 18109,
     /*  44082 */     GIR_EraseRootFromParent_Done,
     /*  44083 */   // Label 1042: @44083
     /*  44083 */   GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(44145), // Rule ID 18139 //
     /*  44088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  44091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  44107 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  44110 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  44114 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  44118 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44120 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  44127 */     // (xor:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VXORPSYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  44127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VXORPSYrm),
     /*  44130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44132 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  44134 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  44138 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  44143 */     GIR_RootConstrainSelectedInstOperands,
     /*  44144 */     // GIR_Coverage, 18139,
     /*  44144 */     GIR_EraseRootFromParent_Done,
     /*  44145 */   // Label 1043: @44145
     /*  44145 */   GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(44207), // Rule ID 20045 //
     /*  44150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  44153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  44157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  44161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  44169 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  44172 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  44176 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  44180 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44182 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  44189 */     // (xor:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORQZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  44189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rm),
     /*  44192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44194 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  44196 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  44200 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  44205 */     GIR_RootConstrainSelectedInstOperands,
     /*  44206 */     // GIR_Coverage, 20045,
     /*  44206 */     GIR_EraseRootFromParent_Done,
     /*  44207 */   // Label 1044: @44207
     /*  44207 */   GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(44439), // Rule ID 21948 //
     /*  44212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /*  44215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  44219 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  44223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44227 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44233 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  44235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44237 */     // (xor:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src, immAllOnesV:{ *:[v16i16] })  =>  (EXTRACT_SUBREG:{ *:[v16i16] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v16i16] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v16i16] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v16i16] }:$src, sub_ymm:{ *:[i32] }), 15:{ *:[i8] }), sub_ymm:{ *:[i32] })
     /*  44237 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /*  44240 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44244 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44249 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  44251 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /*  44254 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  44258 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44263 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /*  44266 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  44270 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/12,
     /*  44273 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  44278 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  44283 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  44288 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  44291 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44295 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  44302 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  44305 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  44309 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44314 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  44317 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  44321 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /*  44324 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  44329 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  44334 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  44339 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  44342 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44346 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44351 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  44353 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  44356 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  44360 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44365 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  44368 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  44372 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /*  44375 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  44380 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  44385 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  44390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  44393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  44397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44402 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  44405 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  44408 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  44411 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /*  44414 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  44416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44421 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /*  44428 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /*  44433 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  44438 */     // GIR_Coverage, 21948,
     /*  44438 */     GIR_EraseRootFromParent_Done,
     /*  44439 */   // Label 1045: @44439
     /*  44439 */   GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(44485), // Rule ID 21956 //
     /*  44444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  44447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  44451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  44455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44459 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44465 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  44467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44469 */     // (xor:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src, immAllOnesV:{ *:[v16i16] })  =>  (VPTERNLOGQZ256rri:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src, VR256X:{ *:[v16i16] }:$src, VR256X:{ *:[v16i16] }:$src, 15:{ *:[i8] })
     /*  44469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ256rri),
     /*  44472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44474 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  44476 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  44478 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  44480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  44483 */     GIR_RootConstrainSelectedInstOperands,
     /*  44484 */     // GIR_Coverage, 21956,
     /*  44484 */     GIR_EraseRootFromParent_Done,
     /*  44485 */   // Label 1046: @44485
     /*  44485 */   GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(44512), // Rule ID 18097 //
     /*  44490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  44493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44505 */     // (xor:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPXORYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  44505 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORYrr),
     /*  44510 */     GIR_RootConstrainSelectedInstOperands,
     /*  44511 */     // GIR_Coverage, 18097,
     /*  44511 */     GIR_Done,
     /*  44512 */   // Label 1047: @44512
     /*  44512 */   GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(44539), // Rule ID 18123 //
     /*  44517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  44520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44532 */     // (xor:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VXORPSYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  44532 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VXORPSYrr),
     /*  44537 */     GIR_RootConstrainSelectedInstOperands,
     /*  44538 */     // GIR_Coverage, 18123,
     /*  44538 */     GIR_Done,
     /*  44539 */   // Label 1048: @44539
     /*  44539 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(44566), // Rule ID 20037 //
     /*  44544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  44547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  44551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  44555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  44559 */     // (xor:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPXORQZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /*  44559 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rr),
     /*  44564 */     GIR_RootConstrainSelectedInstOperands,
     /*  44565 */     // GIR_Coverage, 20037,
     /*  44565 */     GIR_Done,
     /*  44566 */   // Label 1049: @44566
     /*  44566 */   GIM_Reject,
     /*  44567 */ // Label 1038: @44567
     /*  44567 */ GIM_Reject,
     /*  44568 */ // Label 866: @44568
     /*  44568 */ GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(44765),
     /*  44573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  44576 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  44579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  44583 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(44641), // Rule ID 24227 //
     /*  44588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  44591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  44599 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  44602 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  44606 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  44610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  44614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44616 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  44623 */     // (xor:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16i32] }:$src1)  =>  (VPXORDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  44623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORDZrm),
     /*  44626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44628 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  44630 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  44634 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  44639 */     GIR_RootConstrainSelectedInstOperands,
     /*  44640 */     // GIR_Coverage, 24227,
     /*  44640 */     GIR_EraseRootFromParent_Done,
     /*  44641 */   // Label 1051: @44641
     /*  44641 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(44699), // Rule ID 5824 //
     /*  44646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  44649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  44653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  44661 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  44664 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  44668 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  44672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44674 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  44681 */     // (xor:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  44681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORDZrm),
     /*  44684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44686 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  44688 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  44692 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  44697 */     GIR_RootConstrainSelectedInstOperands,
     /*  44698 */     // GIR_Coverage, 5824,
     /*  44698 */     GIR_EraseRootFromParent_Done,
     /*  44699 */   // Label 1052: @44699
     /*  44699 */   GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(44741), // Rule ID 21941 //
     /*  44704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  44707 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  44711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44715 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44721 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  44723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44725 */     // (xor:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src, immAllOnesV:{ *:[v16i32] })  =>  (VPTERNLOGQZrri:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src, VR512:{ *:[v16i32] }:$src, VR512:{ *:[v16i32] }:$src, 15:{ *:[i8] })
     /*  44725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  44728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44730 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  44732 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  44734 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  44736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  44739 */     GIR_RootConstrainSelectedInstOperands,
     /*  44740 */     // GIR_Coverage, 21941,
     /*  44740 */     GIR_EraseRootFromParent_Done,
     /*  44741 */   // Label 1053: @44741
     /*  44741 */   GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(44764), // Rule ID 5821 //
     /*  44746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  44749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  44753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  44757 */     // (xor:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPXORDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /*  44757 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORDZrr),
     /*  44762 */     GIR_RootConstrainSelectedInstOperands,
     /*  44763 */     // GIR_Coverage, 5821,
     /*  44763 */     GIR_Done,
     /*  44764 */   // Label 1054: @44764
     /*  44764 */   GIM_Reject,
     /*  44765 */ // Label 1050: @44765
     /*  44765 */ GIM_Reject,
     /*  44766 */ // Label 867: @44766
     /*  44766 */ GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(45023),
     /*  44771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  44774 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s1,
     /*  44777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  44781 */   GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(44841), // Rule ID 23688 //
     /*  44786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  44789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  44797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  44801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v32s1,
     /*  44805 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  44810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44814 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44820 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  44822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  44826 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44828 */     // (xor:{ *:[v32i1] } (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, immAllOnesV:{ *:[v32i1] }), VK32:{ *:[v32i1] }:$src2)  =>  (KXNORDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /*  44828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORDkk),
     /*  44831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  44837 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  44839 */     GIR_RootConstrainSelectedInstOperands,
     /*  44840 */     // GIR_Coverage, 23688,
     /*  44840 */     GIR_EraseRootFromParent_Done,
     /*  44841 */   // Label 1056: @44841
     /*  44841 */   GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(44904), // Rule ID 4425 //
     /*  44846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  44849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  44857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  44861 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v32s1,
     /*  44865 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  44870 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  44875 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44879 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44885 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  44887 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44889 */     // (xor:{ *:[v32i1] } (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2), immAllOnesV:{ *:[v32i1] })  =>  (KXNORDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /*  44889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORDkk),
     /*  44892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  44898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  44902 */     GIR_RootConstrainSelectedInstOperands,
     /*  44903 */     // GIR_Coverage, 4425,
     /*  44903 */     GIR_EraseRootFromParent_Done,
     /*  44904 */   // Label 1057: @44904
     /*  44904 */   GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(44964), // Rule ID 23689 //
     /*  44909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  44912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  44916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  44924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  44928 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v32s1,
     /*  44932 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  44937 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44941 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44947 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  44949 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44951 */     // (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src2, (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, immAllOnesV:{ *:[v32i1] }))  =>  (KXNORDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /*  44951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORDkk),
     /*  44954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  44960 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  44962 */     GIR_RootConstrainSelectedInstOperands,
     /*  44963 */     // GIR_Coverage, 23689,
     /*  44963 */     GIR_EraseRootFromParent_Done,
     /*  44964 */   // Label 1058: @44964
     /*  44964 */   GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(44999), // Rule ID 4413 //
     /*  44969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  44972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  44976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44980 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44986 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  44988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44990 */     // (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src, immAllOnesV:{ *:[v32i1] })  =>  (KNOTDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src)
     /*  44990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KNOTDkk),
     /*  44993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44995 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  44997 */     GIR_RootConstrainSelectedInstOperands,
     /*  44998 */     // GIR_Coverage, 4413,
     /*  44998 */     GIR_EraseRootFromParent_Done,
     /*  44999 */   // Label 1059: @44999
     /*  44999 */   GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(45022), // Rule ID 4429 //
     /*  45004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  45007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  45011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  45015 */     // (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)  =>  (KXORDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /*  45015 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KXORDkk),
     /*  45020 */     GIR_RootConstrainSelectedInstOperands,
     /*  45021 */     // GIR_Coverage, 4429,
     /*  45021 */     GIR_Done,
     /*  45022 */   // Label 1060: @45022
     /*  45022 */   GIM_Reject,
     /*  45023 */ // Label 1055: @45023
     /*  45023 */ GIM_Reject,
     /*  45024 */ // Label 868: @45024
     /*  45024 */ GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(45767),
     /*  45029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /*  45032 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /*  45035 */   GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(45097), // Rule ID 25236 //
     /*  45040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  45043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  45055 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  45058 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  45062 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  45066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45070 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45072 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  45079 */     // (xor:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPXORYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  45079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORYrm),
     /*  45082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45084 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  45086 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  45090 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  45095 */     GIR_RootConstrainSelectedInstOperands,
     /*  45096 */     // GIR_Coverage, 25236,
     /*  45096 */     GIR_EraseRootFromParent_Done,
     /*  45097 */   // Label 1062: @45097
     /*  45097 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(45159), // Rule ID 25247 //
     /*  45102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  45105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  45117 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  45120 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  45124 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  45128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45134 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  45141 */     // (xor:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VXORPSYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  45141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VXORPSYrm),
     /*  45144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45146 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  45148 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  45152 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  45157 */     GIR_RootConstrainSelectedInstOperands,
     /*  45158 */     // GIR_Coverage, 25247,
     /*  45158 */     GIR_EraseRootFromParent_Done,
     /*  45159 */   // Label 1063: @45159
     /*  45159 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(45221), // Rule ID 25442 //
     /*  45164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  45167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  45179 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  45182 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  45186 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  45190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45194 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45196 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  45203 */     // (xor:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPXORQZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  45203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rm),
     /*  45206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45208 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  45210 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  45214 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  45219 */     GIR_RootConstrainSelectedInstOperands,
     /*  45220 */     // GIR_Coverage, 25442,
     /*  45220 */     GIR_EraseRootFromParent_Done,
     /*  45221 */   // Label 1064: @45221
     /*  45221 */   GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(45283), // Rule ID 18108 //
     /*  45226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  45229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  45245 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  45248 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  45252 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  45256 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45258 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  45265 */     // (xor:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  45265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORYrm),
     /*  45268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45270 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  45272 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  45276 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  45281 */     GIR_RootConstrainSelectedInstOperands,
     /*  45282 */     // GIR_Coverage, 18108,
     /*  45282 */     GIR_EraseRootFromParent_Done,
     /*  45283 */   // Label 1065: @45283
     /*  45283 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(45345), // Rule ID 18138 //
     /*  45288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  45291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  45307 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  45310 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  45314 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  45318 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45320 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  45327 */     // (xor:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VXORPSYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  45327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VXORPSYrm),
     /*  45330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45332 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  45334 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  45338 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  45343 */     GIR_RootConstrainSelectedInstOperands,
     /*  45344 */     // GIR_Coverage, 18138,
     /*  45344 */     GIR_EraseRootFromParent_Done,
     /*  45345 */   // Label 1066: @45345
     /*  45345 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(45407), // Rule ID 20044 //
     /*  45350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  45353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  45369 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  45372 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  45376 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  45380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45382 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  45389 */     // (xor:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORQZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  45389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rm),
     /*  45392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45394 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  45396 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  45400 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  45405 */     GIR_RootConstrainSelectedInstOperands,
     /*  45406 */     // GIR_Coverage, 20044,
     /*  45406 */     GIR_EraseRootFromParent_Done,
     /*  45407 */   // Label 1067: @45407
     /*  45407 */   GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(45639), // Rule ID 21947 //
     /*  45412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /*  45415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45427 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45433 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  45435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45437 */     // (xor:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src, immAllOnesV:{ *:[v32i8] })  =>  (EXTRACT_SUBREG:{ *:[v32i8] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v32i8] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v32i8] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v32i8] }:$src, sub_ymm:{ *:[i32] }), 15:{ *:[i8] }), sub_ymm:{ *:[i32] })
     /*  45437 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /*  45440 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  45444 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45449 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  45451 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /*  45454 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  45458 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45463 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /*  45466 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  45470 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/12,
     /*  45473 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  45478 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  45483 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  45488 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  45491 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  45495 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45500 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  45502 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  45505 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  45509 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45514 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  45517 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  45521 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /*  45524 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  45529 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  45534 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  45539 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  45542 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  45546 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45551 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  45553 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  45556 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  45560 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45565 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  45568 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  45572 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /*  45575 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  45580 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  45585 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  45590 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  45593 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  45597 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45602 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  45605 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  45608 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  45611 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /*  45614 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45621 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /*  45628 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /*  45633 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  45638 */     // GIR_Coverage, 21947,
     /*  45638 */     GIR_EraseRootFromParent_Done,
     /*  45639 */   // Label 1068: @45639
     /*  45639 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(45685), // Rule ID 21955 //
     /*  45644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  45647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45659 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45665 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  45667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45669 */     // (xor:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src, immAllOnesV:{ *:[v32i8] })  =>  (VPTERNLOGQZ256rri:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src, VR256X:{ *:[v32i8] }:$src, VR256X:{ *:[v32i8] }:$src, 15:{ *:[i8] })
     /*  45669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ256rri),
     /*  45672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45674 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  45676 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  45678 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  45680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  45683 */     GIR_RootConstrainSelectedInstOperands,
     /*  45684 */     // GIR_Coverage, 21955,
     /*  45684 */     GIR_EraseRootFromParent_Done,
     /*  45685 */   // Label 1069: @45685
     /*  45685 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(45712), // Rule ID 18096 //
     /*  45690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  45693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45705 */     // (xor:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPXORYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*  45705 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORYrr),
     /*  45710 */     GIR_RootConstrainSelectedInstOperands,
     /*  45711 */     // GIR_Coverage, 18096,
     /*  45711 */     GIR_Done,
     /*  45712 */   // Label 1070: @45712
     /*  45712 */   GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(45739), // Rule ID 18122 //
     /*  45717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  45720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45732 */     // (xor:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VXORPSYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*  45732 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VXORPSYrr),
     /*  45737 */     GIR_RootConstrainSelectedInstOperands,
     /*  45738 */     // GIR_Coverage, 18122,
     /*  45738 */     GIR_Done,
     /*  45739 */   // Label 1071: @45739
     /*  45739 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(45766), // Rule ID 20036 //
     /*  45744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  45747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45751 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45759 */     // (xor:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPXORQZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /*  45759 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rr),
     /*  45764 */     GIR_RootConstrainSelectedInstOperands,
     /*  45765 */     // GIR_Coverage, 20036,
     /*  45765 */     GIR_Done,
     /*  45766 */   // Label 1072: @45766
     /*  45766 */   GIM_Reject,
     /*  45767 */ // Label 1061: @45767
     /*  45767 */ GIM_Reject,
     /*  45768 */ // Label 869: @45768
     /*  45768 */ GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(45965),
     /*  45773 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  45776 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /*  45779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  45783 */   GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(45841), // Rule ID 25449 //
     /*  45788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  45791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  45799 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  45802 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  45806 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  45810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  45814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45816 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  45823 */     // (xor:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPXORQZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  45823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZrm),
     /*  45826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45828 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  45830 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  45834 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  45839 */     GIR_RootConstrainSelectedInstOperands,
     /*  45840 */     // GIR_Coverage, 25449,
     /*  45840 */     GIR_EraseRootFromParent_Done,
     /*  45841 */   // Label 1074: @45841
     /*  45841 */   GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(45899), // Rule ID 20061 //
     /*  45846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  45849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  45853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  45861 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  45864 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  45868 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  45872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45874 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  45881 */     // (xor:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORQZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  45881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZrm),
     /*  45884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45886 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  45888 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  45892 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  45897 */     GIR_RootConstrainSelectedInstOperands,
     /*  45898 */     // GIR_Coverage, 20061,
     /*  45898 */     GIR_EraseRootFromParent_Done,
     /*  45899 */   // Label 1075: @45899
     /*  45899 */   GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(45941), // Rule ID 21940 //
     /*  45904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  45907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  45911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45915 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45921 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  45923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45925 */     // (xor:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src, immAllOnesV:{ *:[v32i16] })  =>  (VPTERNLOGQZrri:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src, VR512:{ *:[v32i16] }:$src, VR512:{ *:[v32i16] }:$src, 15:{ *:[i8] })
     /*  45925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  45928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45930 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  45932 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  45934 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  45936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  45939 */     GIR_RootConstrainSelectedInstOperands,
     /*  45940 */     // GIR_Coverage, 21940,
     /*  45940 */     GIR_EraseRootFromParent_Done,
     /*  45941 */   // Label 1076: @45941
     /*  45941 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(45964), // Rule ID 20053 //
     /*  45946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  45949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  45953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  45957 */     // (xor:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPXORQZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /*  45957 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZrr),
     /*  45962 */     GIR_RootConstrainSelectedInstOperands,
     /*  45963 */     // GIR_Coverage, 20053,
     /*  45963 */     GIR_Done,
     /*  45964 */   // Label 1077: @45964
     /*  45964 */   GIM_Reject,
     /*  45965 */ // Label 1073: @45965
     /*  45965 */ GIM_Reject,
     /*  45966 */ // Label 870: @45966
     /*  45966 */ GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(46223),
     /*  45971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  45974 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s1,
     /*  45977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  45981 */   GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(46041), // Rule ID 23690 //
     /*  45986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  45989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  46001 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v64s1,
     /*  46005 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  46010 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  46014 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46020 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  46022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  46026 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46028 */     // (xor:{ *:[v64i1] } (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, immAllOnesV:{ *:[v64i1] }), VK64:{ *:[v64i1] }:$src2)  =>  (KXNORQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /*  46028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORQkk),
     /*  46031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  46037 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  46039 */     GIR_RootConstrainSelectedInstOperands,
     /*  46040 */     // GIR_Coverage, 23690,
     /*  46040 */     GIR_EraseRootFromParent_Done,
     /*  46041 */   // Label 1079: @46041
     /*  46041 */   GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(46104), // Rule ID 4426 //
     /*  46046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  46049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  46061 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v64s1,
     /*  46065 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  46070 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  46075 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46079 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46085 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  46087 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46089 */     // (xor:{ *:[v64i1] } (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2), immAllOnesV:{ *:[v64i1] })  =>  (KXNORQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /*  46089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORQkk),
     /*  46092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  46098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  46102 */     GIR_RootConstrainSelectedInstOperands,
     /*  46103 */     // GIR_Coverage, 4426,
     /*  46103 */     GIR_EraseRootFromParent_Done,
     /*  46104 */   // Label 1080: @46104
     /*  46104 */   GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(46164), // Rule ID 23691 //
     /*  46109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  46112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  46116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  46128 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v64s1,
     /*  46132 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  46137 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  46141 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46147 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  46149 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46151 */     // (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src2, (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, immAllOnesV:{ *:[v64i1] }))  =>  (KXNORQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /*  46151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORQkk),
     /*  46154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  46160 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  46162 */     GIR_RootConstrainSelectedInstOperands,
     /*  46163 */     // GIR_Coverage, 23691,
     /*  46163 */     GIR_EraseRootFromParent_Done,
     /*  46164 */   // Label 1081: @46164
     /*  46164 */   GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(46199), // Rule ID 4414 //
     /*  46169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  46172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  46176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46180 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46186 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  46188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46190 */     // (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src, immAllOnesV:{ *:[v64i1] })  =>  (KNOTQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src)
     /*  46190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KNOTQkk),
     /*  46193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46195 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  46197 */     GIR_RootConstrainSelectedInstOperands,
     /*  46198 */     // GIR_Coverage, 4414,
     /*  46198 */     GIR_EraseRootFromParent_Done,
     /*  46199 */   // Label 1082: @46199
     /*  46199 */   GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(46222), // Rule ID 4430 //
     /*  46204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  46207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  46211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  46215 */     // (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)  =>  (KXORQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /*  46215 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KXORQkk),
     /*  46220 */     GIR_RootConstrainSelectedInstOperands,
     /*  46221 */     // GIR_Coverage, 4430,
     /*  46221 */     GIR_Done,
     /*  46222 */   // Label 1083: @46222
     /*  46222 */   GIM_Reject,
     /*  46223 */ // Label 1078: @46223
     /*  46223 */ GIM_Reject,
     /*  46224 */ // Label 871: @46224
     /*  46224 */ GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(46421),
     /*  46229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /*  46232 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /*  46235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  46239 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(46297), // Rule ID 25448 //
     /*  46244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  46247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  46255 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  46258 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  46262 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  46266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  46270 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46272 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  46279 */     // (xor:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPXORQZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  46279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZrm),
     /*  46282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46284 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  46286 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  46290 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  46295 */     GIR_RootConstrainSelectedInstOperands,
     /*  46296 */     // GIR_Coverage, 25448,
     /*  46296 */     GIR_EraseRootFromParent_Done,
     /*  46297 */   // Label 1085: @46297
     /*  46297 */   GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(46355), // Rule ID 20060 //
     /*  46302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  46305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  46309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  46317 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  46320 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  46324 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  46328 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46330 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  46337 */     // (xor:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORQZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  46337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZrm),
     /*  46340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46342 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  46344 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  46348 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  46353 */     GIR_RootConstrainSelectedInstOperands,
     /*  46354 */     // GIR_Coverage, 20060,
     /*  46354 */     GIR_EraseRootFromParent_Done,
     /*  46355 */   // Label 1086: @46355
     /*  46355 */   GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(46397), // Rule ID 21939 //
     /*  46360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  46363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  46367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46371 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46377 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  46379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46381 */     // (xor:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src, immAllOnesV:{ *:[v64i8] })  =>  (VPTERNLOGQZrri:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src, VR512:{ *:[v64i8] }:$src, VR512:{ *:[v64i8] }:$src, 15:{ *:[i8] })
     /*  46381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  46384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46386 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  46388 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  46390 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  46392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  46395 */     GIR_RootConstrainSelectedInstOperands,
     /*  46396 */     // GIR_Coverage, 21939,
     /*  46396 */     GIR_EraseRootFromParent_Done,
     /*  46397 */   // Label 1087: @46397
     /*  46397 */   GIM_Try, /*On fail goto*//*Label 1088*/ GIMT_Encode4(46420), // Rule ID 20052 //
     /*  46402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  46405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  46409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  46413 */     // (xor:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPXORQZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /*  46413 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZrr),
     /*  46418 */     GIR_RootConstrainSelectedInstOperands,
     /*  46419 */     // GIR_Coverage, 20052,
     /*  46419 */     GIR_Done,
     /*  46420 */   // Label 1088: @46420
     /*  46420 */   GIM_Reject,
     /*  46421 */ // Label 1084: @46421
     /*  46421 */ GIM_Reject,
     /*  46422 */ // Label 872: @46422
     /*  46422 */ GIM_Reject,
     /*  46423 */ // Label 6: @46423
     /*  46423 */ GIM_Try, /*On fail goto*//*Label 1089*/ GIMT_Encode4(46589),
     /*  46428 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  46431 */   GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(16), GIMT_Encode2(24), /*)*//*default:*//*Label 1093*/ GIMT_Encode4(46588),
     /*  46442 */   /*GILLT_v16s1*//*Label 1090*/ GIMT_Encode4(46474), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  46458 */   /*GILLT_v32s1*//*Label 1091*/ GIMT_Encode4(46512), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  46470 */   /*GILLT_v64s1*//*Label 1092*/ GIMT_Encode4(46550),
     /*  46474 */   // Label 1090: @46474
     /*  46474 */   GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(46511), // Rule ID 19503 //
     /*  46479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  46482 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  46485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  46488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  46492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  46496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  46500 */     // (concat_vectors:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (KUNPCKBWkk:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK8:{ *:[v8i1] }:$src1)
     /*  46500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KUNPCKBWkk),
     /*  46503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46505 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  46507 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  46509 */     GIR_RootConstrainSelectedInstOperands,
     /*  46510 */     // GIR_Coverage, 19503,
     /*  46510 */     GIR_EraseRootFromParent_Done,
     /*  46511 */   // Label 1094: @46511
     /*  46511 */   GIM_Reject,
     /*  46512 */   // Label 1091: @46512
     /*  46512 */   GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(46549), // Rule ID 19504 //
     /*  46517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  46520 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  46523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  46526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  46530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  46534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  46538 */     // (concat_vectors:{ *:[v32i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)  =>  (KUNPCKWDkk:{ *:[v32i1] } VK16:{ *:[v16i1] }:$src2, VK16:{ *:[v16i1] }:$src1)
     /*  46538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KUNPCKWDkk),
     /*  46541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46543 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  46545 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  46547 */     GIR_RootConstrainSelectedInstOperands,
     /*  46548 */     // GIR_Coverage, 19504,
     /*  46548 */     GIR_EraseRootFromParent_Done,
     /*  46549 */   // Label 1095: @46549
     /*  46549 */   GIM_Reject,
     /*  46550 */   // Label 1092: @46550
     /*  46550 */   GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(46587), // Rule ID 19505 //
     /*  46555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  46558 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  46561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s1,
     /*  46564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  46568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  46572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  46576 */     // (concat_vectors:{ *:[v64i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)  =>  (KUNPCKDQkk:{ *:[v64i1] } VK32:{ *:[v32i1] }:$src2, VK32:{ *:[v32i1] }:$src1)
     /*  46576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KUNPCKDQkk),
     /*  46579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46581 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  46583 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  46585 */     GIR_RootConstrainSelectedInstOperands,
     /*  46586 */     // GIR_Coverage, 19505,
     /*  46586 */     GIR_EraseRootFromParent_Done,
     /*  46587 */   // Label 1096: @46587
     /*  46587 */   GIM_Reject,
     /*  46588 */   // Label 1093: @46588
     /*  46588 */   GIM_Reject,
     /*  46589 */ // Label 1089: @46589
     /*  46589 */ GIM_Reject,
     /*  46590 */ // Label 7: @46590
     /*  46590 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(24), /*)*//*default:*//*Label 1105*/ GIMT_Encode4(48879),
     /*  46601 */ /*GILLT_s8*//*Label 1097*/ GIMT_Encode4(46693),
     /*  46605 */ /*GILLT_s16*//*Label 1098*/ GIMT_Encode4(46754),
     /*  46609 */ /*GILLT_s32*//*Label 1099*/ GIMT_Encode4(47584),
     /*  46613 */ /*GILLT_s64*//*Label 1100*/ GIMT_Encode4(48010), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  46645 */ /*GILLT_v8s1*//*Label 1101*/ GIMT_Encode4(48436), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  46661 */ /*GILLT_v16s1*//*Label 1102*/ GIMT_Encode4(48597), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  46677 */ /*GILLT_v32s1*//*Label 1103*/ GIMT_Encode4(48737), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  46689 */ /*GILLT_v64s1*//*Label 1104*/ GIMT_Encode4(48808),
     /*  46693 */ // Label 1097: @46693
     /*  46693 */ GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(46753), // Rule ID 19434 //
     /*  46698 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  46701 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  46705 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  46709 */   // (bitconvert:{ *:[i8] } VK8:{ *:[v8i1] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i8] } (COPY_TO_REGCLASS:{ *:[i32] } VK8:{ *:[v8i1] }:$src, GR32:{ *:[i32] }), sub_8bit:{ *:[i32] })
     /*  46709 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  46712 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46716 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46721 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  46725 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /*  46730 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46733 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46735 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_8bit),
     /*  46742 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /*  46747 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  46752 */   // GIR_Coverage, 19434,
     /*  46752 */   GIR_EraseRootFromParent_Done,
     /*  46753 */ // Label 1106: @46753
     /*  46753 */ GIM_Reject,
     /*  46754 */ // Label 1098: @46754
     /*  46754 */ GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(46814), // Rule ID 19431 //
     /*  46759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  46762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  46766 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  46770 */   // (bitconvert:{ *:[i16] } VK16:{ *:[v16i1] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i32] } VK16:{ *:[v16i1] }:$src, GR32:{ *:[i32] }), sub_16bit:{ *:[i32] })
     /*  46770 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  46773 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46777 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46782 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  46786 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /*  46791 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46794 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46796 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  46803 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  46808 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  46813 */   // GIR_Coverage, 19431,
     /*  46813 */   GIR_EraseRootFromParent_Done,
     /*  46814 */ // Label 1107: @46814
     /*  46814 */ GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(46915), // Rule ID 22140 //
     /*  46819 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  46822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  46825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  46829 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  46833 */   // (bitconvert:{ *:[f16] } GR16:{ *:[i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VMOVW2SHrr:{ *:[f128] } (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR16:{ *:[i16] }:$src, sub_16bit:{ *:[i32] })), FR16X:{ *:[i32] })
     /*  46833 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  46836 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46840 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46845 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46847 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  46850 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46854 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46859 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46862 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  46866 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/4,
     /*  46869 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  46874 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  46879 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /*  46884 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  46887 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVW2SHrr),
     /*  46891 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46896 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46899 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46901 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46904 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46906 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  46909 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /*  46914 */   // GIR_Coverage, 22140,
     /*  46914 */   GIR_EraseRootFromParent_Done,
     /*  46915 */ // Label 1108: @46915
     /*  46915 */ GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(46995), // Rule ID 22153 //
     /*  46920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  46923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  46926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  46930 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  46934 */   // (bitconvert:{ *:[i16] } FR16X:{ *:[f16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (VMOVSH2Wrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[f128] } FR16X:{ *:[f16] }:$src, VR128X:{ *:[i32] })), sub_16bit:{ *:[i32] })
     /*  46934 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  46937 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46941 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46946 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  46950 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR128XRegClassID),
     /*  46955 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  46958 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVSH2Wrr),
     /*  46962 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46967 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46970 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46972 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46975 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46977 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  46984 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  46989 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  46994 */   // GIR_Coverage, 22153,
     /*  46994 */   GIR_EraseRootFromParent_Done,
     /*  46995 */ // Label 1109: @46995
     /*  46995 */ GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(47074), // Rule ID 18340 //
     /*  47000 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoBWI),
     /*  47003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  47006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  47010 */   // (bitconvert:{ *:[i16] } f16:{ *:[f16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (VPEXTRWrri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[v8i16] } FR16:{ *:[f16] }:$src, VR128:{ *:[i32] }), 0:{ *:[i8] }), sub_16bit:{ *:[i32] })
     /*  47010 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  47013 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47017 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47022 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  47026 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR128RegClassID),
     /*  47031 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  47034 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPEXTRWrri),
     /*  47038 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47043 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47046 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  47049 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47051 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47054 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47056 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  47063 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  47068 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  47073 */   // GIR_Coverage, 18340,
     /*  47073 */   GIR_EraseRootFromParent_Done,
     /*  47074 */ // Label 1110: @47074
     /*  47074 */ GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(47191), // Rule ID 18341 //
     /*  47079 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoBWI),
     /*  47082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  47085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /*  47089 */   // (bitconvert:{ *:[f16] } i16:{ *:[i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VPINSRWrri:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR16:{ *:[i16] }:$src, sub_16bit:{ *:[i32] }), 0:{ *:[i8] }), FR16:{ *:[i32] })
     /*  47089 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  47092 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  47096 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47101 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  47103 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  47106 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  47110 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47115 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  47118 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  47122 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/4,
     /*  47125 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  47130 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  47135 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /*  47140 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  47143 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  47147 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47152 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  47154 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  47157 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPINSRWrri),
     /*  47161 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47166 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47169 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  47172 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  47175 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47177 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47180 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47182 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  47185 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /*  47190 */   // GIR_Coverage, 18341,
     /*  47190 */   GIR_EraseRootFromParent_Done,
     /*  47191 */ // Label 1111: @47191
     /*  47191 */ GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(47270), // Rule ID 18337 //
     /*  47196 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  47199 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  47202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  47206 */   // (bitconvert:{ *:[i16] } f16:{ *:[f16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (PEXTRWrri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[v8i16] } FR16:{ *:[f16] }:$src, VR128:{ *:[i32] }), 0:{ *:[i8] }), sub_16bit:{ *:[i32] })
     /*  47206 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  47209 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47213 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47218 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  47222 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR128RegClassID),
     /*  47227 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  47230 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::PEXTRWrri),
     /*  47234 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47239 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47242 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  47245 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47247 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47250 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47252 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  47259 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  47264 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  47269 */   // GIR_Coverage, 18337,
     /*  47269 */   GIR_EraseRootFromParent_Done,
     /*  47270 */ // Label 1112: @47270
     /*  47270 */ GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(47387), // Rule ID 18338 //
     /*  47275 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  47278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  47281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /*  47285 */   // (bitconvert:{ *:[f16] } i16:{ *:[i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (PINSRWrri:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR16:{ *:[i16] }:$src, sub_16bit:{ *:[i32] }), 0:{ *:[i8] }), FR16:{ *:[i32] })
     /*  47285 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  47288 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  47292 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47297 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  47299 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  47302 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  47306 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47311 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  47314 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  47318 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/4,
     /*  47321 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  47326 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  47331 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /*  47336 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  47339 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  47343 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47348 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  47350 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  47353 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::PINSRWrri),
     /*  47357 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47362 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47365 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  47368 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  47371 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47373 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47376 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47378 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  47381 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /*  47386 */   // GIR_Coverage, 18338,
     /*  47386 */   GIR_EraseRootFromParent_Done,
     /*  47387 */ // Label 1113: @47387
     /*  47387 */ GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(47466), // Rule ID 21841 //
     /*  47392 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  47395 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  47398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  47402 */   // (bitconvert:{ *:[i16] } f16:{ *:[f16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (VPEXTRWZrri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[v8i16] } FR16X:{ *:[f16] }:$src, VR128X:{ *:[i32] }), 0:{ *:[i8] }), sub_16bit:{ *:[i32] })
     /*  47402 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  47405 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47409 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47414 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  47418 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR128XRegClassID),
     /*  47423 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  47426 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPEXTRWZrri),
     /*  47430 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47435 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47438 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  47441 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47443 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47446 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47448 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  47455 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  47460 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  47465 */   // GIR_Coverage, 21841,
     /*  47465 */   GIR_EraseRootFromParent_Done,
     /*  47466 */ // Label 1114: @47466
     /*  47466 */ GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(47583), // Rule ID 21842 //
     /*  47471 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  47474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  47477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  47481 */   // (bitconvert:{ *:[f16] } i16:{ *:[i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VPINSRWZrri:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR16:{ *:[i16] }:$src, sub_16bit:{ *:[i32] }), 0:{ *:[i8] }), FR16X:{ *:[i32] })
     /*  47481 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  47484 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  47488 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47493 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  47495 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  47498 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  47502 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47507 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  47510 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  47514 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/4,
     /*  47517 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  47522 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  47527 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /*  47532 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  47535 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  47539 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47544 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  47546 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  47549 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPINSRWZrri),
     /*  47553 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47558 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47561 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  47564 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  47567 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47569 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47572 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47574 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  47577 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /*  47582 */   // GIR_Coverage, 21842,
     /*  47582 */   GIR_EraseRootFromParent_Done,
     /*  47583 */ // Label 1115: @47583
     /*  47583 */ GIM_Reject,
     /*  47584 */ // Label 1099: @47584
     /*  47584 */ GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(47650), // Rule ID 22525 //
     /*  47589 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  47592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  47595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  47599 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47603 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  47607 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  47610 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  47614 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  47621 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  47625 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47627 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  47634 */   // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>)  =>  (MOVSSrm_alt:{ *:[f32] } addr:{ *:[iPTR] }:$src)
     /*  47634 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSSrm_alt),
     /*  47637 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47639 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  47643 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  47648 */   GIR_RootConstrainSelectedInstOperands,
     /*  47649 */   // GIR_Coverage, 22525,
     /*  47649 */   GIR_EraseRootFromParent_Done,
     /*  47650 */ // Label 1116: @47650
     /*  47650 */ GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(47716), // Rule ID 22526 //
     /*  47655 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  47658 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  47661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  47665 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47669 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  47673 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  47676 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  47680 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  47687 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  47691 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47693 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  47700 */   // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>)  =>  (VMOVSSrm_alt:{ *:[f32] } addr:{ *:[iPTR] }:$src)
     /*  47700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSSrm_alt),
     /*  47703 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47705 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  47709 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  47714 */   GIR_RootConstrainSelectedInstOperands,
     /*  47715 */   // GIR_Coverage, 22526,
     /*  47715 */   GIR_EraseRootFromParent_Done,
     /*  47716 */ // Label 1117: @47716
     /*  47716 */ GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(47782), // Rule ID 22527 //
     /*  47721 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  47724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  47727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /*  47731 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47735 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  47739 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  47742 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  47746 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  47753 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  47757 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47759 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  47766 */   // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>)  =>  (VMOVSSZrm_alt:{ *:[f32] } addr:{ *:[iPTR] }:$src)
     /*  47766 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSSZrm_alt),
     /*  47769 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47771 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  47775 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  47780 */   GIR_RootConstrainSelectedInstOperands,
     /*  47781 */   // GIR_Coverage, 22527,
     /*  47781 */   GIR_EraseRootFromParent_Done,
     /*  47782 */ // Label 1118: @47782
     /*  47782 */ GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(47808), // Rule ID 2915 //
     /*  47787 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  47790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  47793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  47797 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  47801 */   // (bitconvert:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (VMOVDI2SSrr:{ *:[f32] } GR32:{ *:[i32] }:$src)
     /*  47801 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOVDI2SSrr),
     /*  47806 */   GIR_RootConstrainSelectedInstOperands,
     /*  47807 */   // GIR_Coverage, 2915,
     /*  47807 */   GIR_Done,
     /*  47808 */ // Label 1119: @47808
     /*  47808 */ GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(47834), // Rule ID 2916 //
     /*  47813 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  47816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  47819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  47823 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  47827 */   // (bitconvert:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (MOVDI2SSrr:{ *:[f32] } GR32:{ *:[i32] }:$src)
     /*  47827 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVDI2SSrr),
     /*  47832 */   GIR_RootConstrainSelectedInstOperands,
     /*  47833 */   // GIR_Coverage, 2916,
     /*  47833 */   GIR_Done,
     /*  47834 */ // Label 1120: @47834
     /*  47834 */ GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(47860), // Rule ID 2925 //
     /*  47839 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  47842 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  47845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  47849 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  47853 */   // (bitconvert:{ *:[i32] } FR32:{ *:[f32] }:$src)  =>  (VMOVSS2DIrr:{ *:[i32] } FR32:{ *:[f32] }:$src)
     /*  47853 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOVSS2DIrr),
     /*  47858 */   GIR_RootConstrainSelectedInstOperands,
     /*  47859 */   // GIR_Coverage, 2925,
     /*  47859 */   GIR_Done,
     /*  47860 */ // Label 1121: @47860
     /*  47860 */ GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(47886), // Rule ID 2926 //
     /*  47865 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  47868 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  47871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  47875 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  47879 */   // (bitconvert:{ *:[i32] } FR32:{ *:[f32] }:$src)  =>  (MOVSS2DIrr:{ *:[i32] } FR32:{ *:[f32] }:$src)
     /*  47879 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSS2DIrr),
     /*  47884 */   GIR_RootConstrainSelectedInstOperands,
     /*  47885 */   // GIR_Coverage, 2926,
     /*  47885 */   GIR_Done,
     /*  47886 */ // Label 1122: @47886
     /*  47886 */ GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(47912), // Rule ID 4598 //
     /*  47891 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  47894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  47897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /*  47901 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  47905 */   // (bitconvert:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (VMOVDI2SSZrr:{ *:[f32] } GR32:{ *:[i32] }:$src)
     /*  47905 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOVDI2SSZrr),
     /*  47910 */   GIR_RootConstrainSelectedInstOperands,
     /*  47911 */   // GIR_Coverage, 4598,
     /*  47911 */   GIR_Done,
     /*  47912 */ // Label 1123: @47912
     /*  47912 */ GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(47938), // Rule ID 4603 //
     /*  47917 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  47920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  47923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  47927 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /*  47931 */   // (bitconvert:{ *:[i32] } FR32X:{ *:[f32] }:$src)  =>  (VMOVSS2DIZrr:{ *:[i32] } FR32X:{ *:[f32] }:$src)
     /*  47931 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOVSS2DIZrr),
     /*  47936 */   GIR_RootConstrainSelectedInstOperands,
     /*  47937 */   // GIR_Coverage, 4603,
     /*  47937 */   GIR_Done,
     /*  47938 */ // Label 1124: @47938
     /*  47938 */ GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(47965), // Rule ID 19442 //
     /*  47943 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  47946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  47950 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  47954 */   // (bitconvert:{ *:[i32] } VK32:{ *:[v32i1] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[i32] } VK32:{ *:[v32i1] }:$src, GR32:{ *:[i32] })
     /*  47954 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47959 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /*  47964 */   // GIR_Coverage, 19442,
     /*  47964 */   GIR_Done,
     /*  47965 */ // Label 1125: @47965
     /*  47965 */ GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(48009), // Rule ID 19876 //
     /*  47970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  47973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /*  47977 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  47981 */   // (bitconvert:{ *:[f32] } VK32:{ *:[v32i1] }:$src)  =>  (VMOVDI2SSZrr:{ *:[f32] } (KMOVDrk:{ *:[i32] } VK32:{ *:[v32i1] }:$src))
     /*  47981 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  47984 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KMOVDrk),
     /*  47988 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47993 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  47997 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47999 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDI2SSZrr),
     /*  48002 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48004 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48007 */   GIR_RootConstrainSelectedInstOperands,
     /*  48008 */   // GIR_Coverage, 19876,
     /*  48008 */   GIR_EraseRootFromParent_Done,
     /*  48009 */ // Label 1126: @48009
     /*  48009 */ GIM_Reject,
     /*  48010 */ // Label 1100: @48010
     /*  48010 */ GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(48076), // Rule ID 22528 //
     /*  48015 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  48018 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48021 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  48025 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48029 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  48033 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  48036 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  48040 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  48047 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  48051 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48053 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  48060 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>)  =>  (MOVSDrm_alt:{ *:[f64] } addr:{ *:[iPTR] }:$src)
     /*  48060 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSDrm_alt),
     /*  48063 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48065 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  48069 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  48074 */   GIR_RootConstrainSelectedInstOperands,
     /*  48075 */   // GIR_Coverage, 22528,
     /*  48075 */   GIR_EraseRootFromParent_Done,
     /*  48076 */ // Label 1127: @48076
     /*  48076 */ GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(48142), // Rule ID 22529 //
     /*  48081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  48084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  48091 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48095 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  48099 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  48102 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  48106 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  48113 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  48117 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48119 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  48126 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>)  =>  (VMOVSDrm_alt:{ *:[f64] } addr:{ *:[iPTR] }:$src)
     /*  48126 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSDrm_alt),
     /*  48129 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48131 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  48135 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  48140 */   GIR_RootConstrainSelectedInstOperands,
     /*  48141 */   // GIR_Coverage, 22529,
     /*  48141 */   GIR_EraseRootFromParent_Done,
     /*  48142 */ // Label 1128: @48142
     /*  48142 */ GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(48208), // Rule ID 22530 //
     /*  48147 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  48150 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /*  48157 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48161 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  48165 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  48168 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  48172 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  48179 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  48183 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48185 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  48192 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>)  =>  (VMOVSDZrm_alt:{ *:[f64] } addr:{ *:[iPTR] }:$src)
     /*  48192 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSDZrm_alt),
     /*  48195 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48197 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  48201 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  48206 */   GIR_RootConstrainSelectedInstOperands,
     /*  48207 */   // GIR_Coverage, 22530,
     /*  48207 */   GIR_EraseRootFromParent_Done,
     /*  48208 */ // Label 1129: @48208
     /*  48208 */ GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(48234), // Rule ID 2910 //
     /*  48213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  48216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  48223 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  48227 */   // (bitconvert:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (VMOV64toSDrr:{ *:[f64] } GR64:{ *:[i64] }:$src)
     /*  48227 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOV64toSDrr),
     /*  48232 */   GIR_RootConstrainSelectedInstOperands,
     /*  48233 */   // GIR_Coverage, 2910,
     /*  48233 */   GIR_Done,
     /*  48234 */ // Label 1130: @48234
     /*  48234 */ GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(48260), // Rule ID 2914 //
     /*  48239 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  48242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  48249 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  48253 */   // (bitconvert:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (MOV64toSDrr:{ *:[f64] } GR64:{ *:[i64] }:$src)
     /*  48253 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOV64toSDrr),
     /*  48258 */   GIR_RootConstrainSelectedInstOperands,
     /*  48259 */   // GIR_Coverage, 2914,
     /*  48259 */   GIR_Done,
     /*  48260 */ // Label 1131: @48260
     /*  48260 */ GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(48286), // Rule ID 2923 //
     /*  48265 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  48268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  48275 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  48279 */   // (bitconvert:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (VMOVSDto64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /*  48279 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOVSDto64rr),
     /*  48284 */   GIR_RootConstrainSelectedInstOperands,
     /*  48285 */   // GIR_Coverage, 2923,
     /*  48285 */   GIR_Done,
     /*  48286 */ // Label 1132: @48286
     /*  48286 */ GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(48312), // Rule ID 2924 //
     /*  48291 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  48294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  48301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  48305 */   // (bitconvert:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (MOVSDto64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /*  48305 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSDto64rr),
     /*  48310 */   GIR_RootConstrainSelectedInstOperands,
     /*  48311 */   // GIR_Coverage, 2924,
     /*  48311 */   GIR_Done,
     /*  48312 */ // Label 1133: @48312
     /*  48312 */ GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(48338), // Rule ID 4596 //
     /*  48317 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  48320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /*  48327 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  48331 */   // (bitconvert:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (VMOV64toSDZrr:{ *:[f64] } GR64:{ *:[i64] }:$src)
     /*  48331 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOV64toSDZrr),
     /*  48336 */   GIR_RootConstrainSelectedInstOperands,
     /*  48337 */   // GIR_Coverage, 4596,
     /*  48337 */   GIR_Done,
     /*  48338 */ // Label 1134: @48338
     /*  48338 */ GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(48364), // Rule ID 4597 //
     /*  48343 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  48346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  48353 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /*  48357 */   // (bitconvert:{ *:[i64] } FR64X:{ *:[f64] }:$src)  =>  (VMOVSDto64Zrr:{ *:[i64] } FR64X:{ *:[f64] }:$src)
     /*  48357 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOVSDto64Zrr),
     /*  48362 */   GIR_RootConstrainSelectedInstOperands,
     /*  48363 */   // GIR_Coverage, 4597,
     /*  48363 */   GIR_Done,
     /*  48364 */ // Label 1135: @48364
     /*  48364 */ GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(48391), // Rule ID 19444 //
     /*  48369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  48372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  48376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  48380 */   // (bitconvert:{ *:[i64] } VK64:{ *:[v64i1] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[i64] } VK64:{ *:[v64i1] }:$src, GR64:{ *:[i32] })
     /*  48380 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48385 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /*  48390 */   // GIR_Coverage, 19444,
     /*  48390 */   GIR_Done,
     /*  48391 */ // Label 1136: @48391
     /*  48391 */ GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(48435), // Rule ID 19878 //
     /*  48396 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  48399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /*  48403 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  48407 */   // (bitconvert:{ *:[f64] } VK64:{ *:[v64i1] }:$src)  =>  (VMOV64toSDZrr:{ *:[f64] } (KMOVQrk:{ *:[i64] } VK64:{ *:[v64i1] }:$src))
     /*  48407 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  48410 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KMOVQrk),
     /*  48414 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48419 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  48423 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48425 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOV64toSDZrr),
     /*  48428 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48430 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48433 */   GIR_RootConstrainSelectedInstOperands,
     /*  48434 */   // GIR_Coverage, 19878,
     /*  48434 */   GIR_EraseRootFromParent_Done,
     /*  48435 */ // Label 1137: @48435
     /*  48435 */ GIM_Reject,
     /*  48436 */ // Label 1101: @48436
     /*  48436 */ GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(48596),
     /*  48441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /*  48444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  48448 */   GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(48521), // Rule ID 19448 //
     /*  48453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  48456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  48464 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  48467 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  48471 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  48475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48477 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  48484 */     // (bitconvert:{ *:[v8i1] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), VK8:{ *:[i32] })
     /*  48484 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48487 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  48491 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48496 */     GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  48500 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  48505 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48512 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48515 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  48520 */     // GIR_Coverage, 19448,
     /*  48520 */     GIR_EraseRootFromParent_Done,
     /*  48521 */   // Label 1139: @48521
     /*  48521 */   GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(48595), // Rule ID 19433 //
     /*  48526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  48530 */     // (bitconvert:{ *:[v8i1] } GR8:{ *:[i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src, sub_8bit:{ *:[i32] }), VK8:{ *:[i32] })
     /*  48530 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  48533 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  48537 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  48544 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48547 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  48551 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48556 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  48559 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  48563 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  48566 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  48571 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  48576 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  48581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48589 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  48594 */     // GIR_Coverage, 19433,
     /*  48594 */     GIR_EraseRootFromParent_Done,
     /*  48595 */   // Label 1140: @48595
     /*  48595 */   GIM_Reject,
     /*  48596 */ // Label 1138: @48596
     /*  48596 */ GIM_Reject,
     /*  48597 */ // Label 1102: @48597
     /*  48597 */ GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(48736),
     /*  48602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  48605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  48609 */   GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(48661), // Rule ID 19449 //
     /*  48614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  48617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  48625 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  48628 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  48632 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  48636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48638 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  48645 */     // (bitconvert:{ *:[v16i1] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (KMOVWkm:{ *:[v16i1] } addr:{ *:[iPTR] }:$src)
     /*  48645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVWkm),
     /*  48648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48650 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  48654 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  48659 */     GIR_RootConstrainSelectedInstOperands,
     /*  48660 */     // GIR_Coverage, 19449,
     /*  48660 */     GIR_EraseRootFromParent_Done,
     /*  48661 */   // Label 1142: @48661
     /*  48661 */   GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(48735), // Rule ID 19430 //
     /*  48666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  48670 */     // (bitconvert:{ *:[v16i1] } GR16:{ *:[i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR16:{ *:[i16] }:$src, sub_16bit:{ *:[i32] }), VK16:{ *:[i32] })
     /*  48670 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  48673 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  48677 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48682 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  48684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  48691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48696 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  48699 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  48703 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/4,
     /*  48706 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  48711 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  48716 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /*  48721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48729 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  48734 */     // GIR_Coverage, 19430,
     /*  48734 */     GIR_EraseRootFromParent_Done,
     /*  48735 */   // Label 1143: @48735
     /*  48735 */   GIM_Reject,
     /*  48736 */ // Label 1141: @48736
     /*  48736 */ GIM_Reject,
     /*  48737 */ // Label 1103: @48737
     /*  48737 */ GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(48807),
     /*  48742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  48745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  48749 */   GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(48769), // Rule ID 19441 //
     /*  48754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  48758 */     // (bitconvert:{ *:[v32i1] } GR32:{ *:[i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v32i1] } GR32:{ *:[i32] }:$src, VK32:{ *:[i32] })
     /*  48758 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48763 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK32RegClassID),
     /*  48768 */     // GIR_Coverage, 19441,
     /*  48768 */     GIR_Done,
     /*  48769 */   // Label 1145: @48769
     /*  48769 */   GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(48806), // Rule ID 19875 //
     /*  48774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /*  48778 */     // (bitconvert:{ *:[v32i1] } FR32X:{ *:[f32] }:$src)  =>  (KMOVDkr:{ *:[v32i1] } (VMOVSS2DIZrr:{ *:[i32] } FR32X:{ *:[f32] }:$src))
     /*  48778 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48781 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVSS2DIZrr),
     /*  48785 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48790 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  48794 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVDkr),
     /*  48799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48801 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48804 */     GIR_RootConstrainSelectedInstOperands,
     /*  48805 */     // GIR_Coverage, 19875,
     /*  48805 */     GIR_EraseRootFromParent_Done,
     /*  48806 */   // Label 1146: @48806
     /*  48806 */   GIM_Reject,
     /*  48807 */ // Label 1144: @48807
     /*  48807 */ GIM_Reject,
     /*  48808 */ // Label 1104: @48808
     /*  48808 */ GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(48878),
     /*  48813 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  48820 */   GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(48840), // Rule ID 19443 //
     /*  48825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  48829 */     // (bitconvert:{ *:[v64i1] } GR64:{ *:[i64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v64i1] } GR64:{ *:[i64] }:$src, VK64:{ *:[i32] })
     /*  48829 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48834 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK64RegClassID),
     /*  48839 */     // GIR_Coverage, 19443,
     /*  48839 */     GIR_Done,
     /*  48840 */   // Label 1148: @48840
     /*  48840 */   GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(48877), // Rule ID 19877 //
     /*  48845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /*  48849 */     // (bitconvert:{ *:[v64i1] } FR64X:{ *:[f64] }:$src)  =>  (KMOVQkr:{ *:[v64i1] } (VMOVSDto64Zrr:{ *:[i64] } FR64X:{ *:[f64] }:$src))
     /*  48849 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  48852 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVSDto64Zrr),
     /*  48856 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48861 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  48865 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVQkr),
     /*  48870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48872 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48875 */     GIR_RootConstrainSelectedInstOperands,
     /*  48876 */     // GIR_Coverage, 19877,
     /*  48876 */     GIR_EraseRootFromParent_Done,
     /*  48877 */   // Label 1149: @48877
     /*  48877 */   GIM_Reject,
     /*  48878 */ // Label 1147: @48878
     /*  48878 */ GIM_Reject,
     /*  48879 */ // Label 1105: @48879
     /*  48879 */ GIM_Reject,
     /*  48880 */ // Label 8: @48880
     /*  48880 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 1162*/ GIMT_Encode4(52057),
     /*  48891 */ /*GILLT_s16*//*Label 1150*/ GIMT_Encode4(48975),
     /*  48895 */ /*GILLT_s32*//*Label 1151*/ GIMT_Encode4(49036),
     /*  48899 */ /*GILLT_s64*//*Label 1152*/ GIMT_Encode4(49660), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  48915 */ /*GILLT_v2s64*//*Label 1153*/ GIMT_Encode4(50284), GIMT_Encode4(0),
     /*  48923 */ /*GILLT_v4s32*//*Label 1154*/ GIMT_Encode4(50373),
     /*  48927 */ /*GILLT_v4s64*//*Label 1155*/ GIMT_Encode4(50819), GIMT_Encode4(0),
     /*  48935 */ /*GILLT_v8s16*//*Label 1156*/ GIMT_Encode4(50998),
     /*  48939 */ /*GILLT_v8s32*//*Label 1157*/ GIMT_Encode4(51087),
     /*  48943 */ /*GILLT_v8s64*//*Label 1158*/ GIMT_Encode4(51438), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  48955 */ /*GILLT_v16s16*//*Label 1159*/ GIMT_Encode4(51706),
     /*  48959 */ /*GILLT_v16s32*//*Label 1160*/ GIMT_Encode4(51795), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  48971 */ /*GILLT_v32s16*//*Label 1161*/ GIMT_Encode4(51968),
     /*  48975 */ // Label 1150: @48975
     /*  48975 */ GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(49035), // Rule ID 22169 //
     /*  48980 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  48983 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  48986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  48990 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /*  48994 */   // (lrint:{ *:[i16] } FR16:{ *:[f16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (VCVTTSH2SIZrr:{ *:[i32] } FR16:{ *:[f16] }:$src), sub_16bit:{ *:[i32] })
     /*  48994 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48997 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SIZrr),
     /*  49001 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49006 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  49010 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49012 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49015 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49017 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  49024 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  49029 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  49034 */   // GIR_Coverage, 22169,
     /*  49034 */   GIR_EraseRootFromParent_Done,
     /*  49035 */ // Label 1163: @49035
     /*  49035 */ GIM_Reject,
     /*  49036 */ // Label 1151: @49036
     /*  49036 */ GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(49095), // Rule ID 1756 //
     /*  49041 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  49044 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49047 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49051 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49055 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49059 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49062 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49066 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49070 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49072 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49079 */   // (lrint:{ *:[i32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSS2SIrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  49079 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SIrm),
     /*  49082 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49084 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49088 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49093 */   GIR_RootConstrainSelectedInstOperands,
     /*  49094 */   // GIR_Coverage, 1756,
     /*  49094 */   GIR_EraseRootFromParent_Done,
     /*  49095 */ // Label 1164: @49095
     /*  49095 */ GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(49154), // Rule ID 1760 //
     /*  49100 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  49103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49110 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49114 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49118 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49121 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49125 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49129 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49131 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49138 */   // (lrint:{ *:[i32] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSD2SIrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  49138 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SIrm),
     /*  49141 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49143 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49147 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49152 */   GIR_RootConstrainSelectedInstOperands,
     /*  49153 */   // GIR_Coverage, 1760,
     /*  49153 */   GIR_EraseRootFromParent_Done,
     /*  49154 */ // Label 1165: @49154
     /*  49154 */ GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(49213), // Rule ID 1780 //
     /*  49159 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  49162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49169 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49173 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49177 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49180 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49184 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49188 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49190 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49197 */   // (lrint:{ *:[i32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSS2SIrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  49197 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSS2SIrm),
     /*  49200 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49202 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49206 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49211 */   GIR_RootConstrainSelectedInstOperands,
     /*  49212 */   // GIR_Coverage, 1780,
     /*  49212 */   GIR_EraseRootFromParent_Done,
     /*  49213 */ // Label 1166: @49213
     /*  49213 */ GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(49272), // Rule ID 1784 //
     /*  49218 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  49221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49228 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49232 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49236 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49239 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49243 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49247 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49249 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49256 */   // (lrint:{ *:[i32] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSD2SIrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  49256 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSD2SIrm),
     /*  49259 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49261 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49265 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49270 */   GIR_RootConstrainSelectedInstOperands,
     /*  49271 */   // GIR_Coverage, 1784,
     /*  49271 */   GIR_EraseRootFromParent_Done,
     /*  49272 */ // Label 1167: @49272
     /*  49272 */ GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(49331), // Rule ID 10353 //
     /*  49277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  49280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49287 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49291 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49295 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49298 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49302 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49306 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49308 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49315 */   // (lrint:{ *:[i32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSS2SIZrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  49315 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SIZrm),
     /*  49318 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49320 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49324 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49329 */   GIR_RootConstrainSelectedInstOperands,
     /*  49330 */   // GIR_Coverage, 10353,
     /*  49330 */   GIR_EraseRootFromParent_Done,
     /*  49331 */ // Label 1168: @49331
     /*  49331 */ GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(49390), // Rule ID 10357 //
     /*  49336 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  49339 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49346 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49350 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49354 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49357 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49361 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49365 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49367 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49374 */   // (lrint:{ *:[i32] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSD2SIZrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  49374 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SIZrm),
     /*  49377 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49379 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49383 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49388 */   GIR_RootConstrainSelectedInstOperands,
     /*  49389 */   // GIR_Coverage, 10357,
     /*  49389 */   GIR_EraseRootFromParent_Done,
     /*  49390 */ // Label 1169: @49390
     /*  49390 */ GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(49449), // Rule ID 22171 //
     /*  49395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  49398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  49401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49405 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49409 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49413 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49416 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49420 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49424 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49426 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49433 */   // (lrint:{ *:[i32] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSH2SIZrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  49433 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SIZrm),
     /*  49436 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49438 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49442 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49447 */   GIR_RootConstrainSelectedInstOperands,
     /*  49448 */   // GIR_Coverage, 22171,
     /*  49448 */   GIR_EraseRootFromParent_Done,
     /*  49449 */ // Label 1170: @49449
     /*  49449 */ GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(49479), // Rule ID 1755 //
     /*  49454 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  49457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49464 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  49468 */   // (lrint:{ *:[i32] } FR32:{ *:[f32] }:$src)  =>  (VCVTSS2SIrr:{ *:[i32] } FR32:{ *:[f32] }:$src)
     /*  49468 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SIrr),
     /*  49473 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49477 */   GIR_RootConstrainSelectedInstOperands,
     /*  49478 */   // GIR_Coverage, 1755,
     /*  49478 */   GIR_Done,
     /*  49479 */ // Label 1171: @49479
     /*  49479 */ GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(49509), // Rule ID 1759 //
     /*  49484 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  49487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49494 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  49498 */   // (lrint:{ *:[i32] } FR64:{ *:[f64] }:$src)  =>  (VCVTSD2SIrr:{ *:[i32] } FR64:{ *:[f64] }:$src)
     /*  49498 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SIrr),
     /*  49503 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49507 */   GIR_RootConstrainSelectedInstOperands,
     /*  49508 */   // GIR_Coverage, 1759,
     /*  49508 */   GIR_Done,
     /*  49509 */ // Label 1172: @49509
     /*  49509 */ GIM_Try, /*On fail goto*//*Label 1173*/ GIMT_Encode4(49539), // Rule ID 1779 //
     /*  49514 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  49517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49524 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  49528 */   // (lrint:{ *:[i32] } FR32:{ *:[f32] }:$src)  =>  (CVTSS2SIrr:{ *:[i32] } FR32:{ *:[f32] }:$src)
     /*  49528 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSS2SIrr),
     /*  49533 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49537 */   GIR_RootConstrainSelectedInstOperands,
     /*  49538 */   // GIR_Coverage, 1779,
     /*  49538 */   GIR_Done,
     /*  49539 */ // Label 1173: @49539
     /*  49539 */ GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(49569), // Rule ID 1783 //
     /*  49544 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  49547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49554 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  49558 */   // (lrint:{ *:[i32] } FR64:{ *:[f64] }:$src)  =>  (CVTSD2SIrr:{ *:[i32] } FR64:{ *:[f64] }:$src)
     /*  49558 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSD2SIrr),
     /*  49563 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49567 */   GIR_RootConstrainSelectedInstOperands,
     /*  49568 */   // GIR_Coverage, 1783,
     /*  49568 */   GIR_Done,
     /*  49569 */ // Label 1174: @49569
     /*  49569 */ GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(49599), // Rule ID 10352 //
     /*  49574 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  49577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49584 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /*  49588 */   // (lrint:{ *:[i32] } FR32X:{ *:[f32] }:$src)  =>  (VCVTSS2SIZrr:{ *:[i32] } FR32X:{ *:[f32] }:$src)
     /*  49588 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SIZrr),
     /*  49593 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49597 */   GIR_RootConstrainSelectedInstOperands,
     /*  49598 */   // GIR_Coverage, 10352,
     /*  49598 */   GIR_Done,
     /*  49599 */ // Label 1175: @49599
     /*  49599 */ GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(49629), // Rule ID 10356 //
     /*  49604 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  49607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49614 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /*  49618 */   // (lrint:{ *:[i32] } FR64X:{ *:[f64] }:$src)  =>  (VCVTSD2SIZrr:{ *:[i32] } FR64X:{ *:[f64] }:$src)
     /*  49618 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SIZrr),
     /*  49623 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49627 */   GIR_RootConstrainSelectedInstOperands,
     /*  49628 */   // GIR_Coverage, 10356,
     /*  49628 */   GIR_Done,
     /*  49629 */ // Label 1176: @49629
     /*  49629 */ GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(49659), // Rule ID 22170 //
     /*  49634 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  49637 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  49640 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49644 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /*  49648 */   // (lrint:{ *:[i32] } FR16:{ *:[f16] }:$src)  =>  (VCVTTSH2SIZrr:{ *:[i32] } FR16:{ *:[f16] }:$src)
     /*  49648 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SIZrr),
     /*  49653 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49657 */   GIR_RootConstrainSelectedInstOperands,
     /*  49658 */   // GIR_Coverage, 22170,
     /*  49658 */   GIR_Done,
     /*  49659 */ // Label 1177: @49659
     /*  49659 */ GIM_Reject,
     /*  49660 */ // Label 1152: @49660
     /*  49660 */ GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(49719), // Rule ID 17990 //
     /*  49665 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  49668 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  49675 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49679 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49683 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49686 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49690 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49694 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49696 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49703 */   // (lrint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSS2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  49703 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64rm),
     /*  49706 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49708 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49712 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49717 */   GIR_RootConstrainSelectedInstOperands,
     /*  49718 */   // GIR_Coverage, 17990,
     /*  49718 */   GIR_EraseRootFromParent_Done,
     /*  49719 */ // Label 1178: @49719
     /*  49719 */ GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(49778), // Rule ID 17992 //
     /*  49724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  49727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  49734 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49738 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49742 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49745 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49749 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49753 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49755 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49762 */   // (lrint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSD2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  49762 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64rm),
     /*  49765 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49767 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49771 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49776 */   GIR_RootConstrainSelectedInstOperands,
     /*  49777 */   // GIR_Coverage, 17992,
     /*  49777 */   GIR_EraseRootFromParent_Done,
     /*  49778 */ // Label 1179: @49778
     /*  49778 */ GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(49837), // Rule ID 17994 //
     /*  49783 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  49786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  49793 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49797 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49801 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49804 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49808 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49812 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49814 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49821 */   // (lrint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSS2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  49821 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSS2SI64rm),
     /*  49824 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49826 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49830 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49835 */   GIR_RootConstrainSelectedInstOperands,
     /*  49836 */   // GIR_Coverage, 17994,
     /*  49836 */   GIR_EraseRootFromParent_Done,
     /*  49837 */ // Label 1180: @49837
     /*  49837 */ GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(49896), // Rule ID 17996 //
     /*  49842 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  49845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  49852 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49856 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49860 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49863 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49867 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49871 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49873 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49880 */   // (lrint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSD2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  49880 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSD2SI64rm),
     /*  49883 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49885 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49889 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49894 */   GIR_RootConstrainSelectedInstOperands,
     /*  49895 */   // GIR_Coverage, 17996,
     /*  49895 */   GIR_EraseRootFromParent_Done,
     /*  49896 */ // Label 1181: @49896
     /*  49896 */ GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(49955), // Rule ID 21160 //
     /*  49901 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  49904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  49911 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49915 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49919 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49922 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49926 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49930 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49932 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49939 */   // (lrint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSS2SI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  49939 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64Zrm),
     /*  49942 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49944 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49948 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49953 */   GIR_RootConstrainSelectedInstOperands,
     /*  49954 */   // GIR_Coverage, 21160,
     /*  49954 */   GIR_EraseRootFromParent_Done,
     /*  49955 */ // Label 1182: @49955
     /*  49955 */ GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(50014), // Rule ID 21162 //
     /*  49960 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  49963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  49970 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49974 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49978 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49981 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49985 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49989 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49991 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49998 */   // (lrint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSD2SI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  49998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64Zrm),
     /*  50001 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50003 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50007 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50012 */   GIR_RootConstrainSelectedInstOperands,
     /*  50013 */   // GIR_Coverage, 21162,
     /*  50013 */   GIR_EraseRootFromParent_Done,
     /*  50014 */ // Label 1183: @50014
     /*  50014 */ GIM_Try, /*On fail goto*//*Label 1184*/ GIMT_Encode4(50073), // Rule ID 22173 //
     /*  50019 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_In64BitMode),
     /*  50022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  50025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  50029 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50033 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50037 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50040 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50044 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50048 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50050 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50057 */   // (lrint:{ *:[i64] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSH2SI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  50057 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SI64Zrm),
     /*  50060 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50062 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50066 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50071 */   GIR_RootConstrainSelectedInstOperands,
     /*  50072 */   // GIR_Coverage, 22173,
     /*  50072 */   GIR_EraseRootFromParent_Done,
     /*  50073 */ // Label 1184: @50073
     /*  50073 */ GIM_Try, /*On fail goto*//*Label 1185*/ GIMT_Encode4(50103), // Rule ID 17989 //
     /*  50078 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  50081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  50084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  50088 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  50092 */   // (lrint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (VCVTSS2SI64rr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /*  50092 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64rr),
     /*  50097 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50101 */   GIR_RootConstrainSelectedInstOperands,
     /*  50102 */   // GIR_Coverage, 17989,
     /*  50102 */   GIR_Done,
     /*  50103 */ // Label 1185: @50103
     /*  50103 */ GIM_Try, /*On fail goto*//*Label 1186*/ GIMT_Encode4(50133), // Rule ID 17991 //
     /*  50108 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  50111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  50114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  50118 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  50122 */   // (lrint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (VCVTSD2SI64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /*  50122 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64rr),
     /*  50127 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50131 */   GIR_RootConstrainSelectedInstOperands,
     /*  50132 */   // GIR_Coverage, 17991,
     /*  50132 */   GIR_Done,
     /*  50133 */ // Label 1186: @50133
     /*  50133 */ GIM_Try, /*On fail goto*//*Label 1187*/ GIMT_Encode4(50163), // Rule ID 17993 //
     /*  50138 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  50141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  50144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  50148 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  50152 */   // (lrint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (CVTSS2SI64rr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /*  50152 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSS2SI64rr),
     /*  50157 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50161 */   GIR_RootConstrainSelectedInstOperands,
     /*  50162 */   // GIR_Coverage, 17993,
     /*  50162 */   GIR_Done,
     /*  50163 */ // Label 1187: @50163
     /*  50163 */ GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(50193), // Rule ID 17995 //
     /*  50168 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  50171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  50174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  50178 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  50182 */   // (lrint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (CVTSD2SI64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /*  50182 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSD2SI64rr),
     /*  50187 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50191 */   GIR_RootConstrainSelectedInstOperands,
     /*  50192 */   // GIR_Coverage, 17995,
     /*  50192 */   GIR_Done,
     /*  50193 */ // Label 1188: @50193
     /*  50193 */ GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(50223), // Rule ID 21159 //
     /*  50198 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  50201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  50204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  50208 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  50212 */   // (lrint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (VCVTSS2SI64Zrr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /*  50212 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64Zrr),
     /*  50217 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50221 */   GIR_RootConstrainSelectedInstOperands,
     /*  50222 */   // GIR_Coverage, 21159,
     /*  50222 */   GIR_Done,
     /*  50223 */ // Label 1189: @50223
     /*  50223 */ GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(50253), // Rule ID 21161 //
     /*  50228 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  50231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  50234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  50238 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  50242 */   // (lrint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (VCVTSD2SI64Zrr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /*  50242 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64Zrr),
     /*  50247 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50251 */   GIR_RootConstrainSelectedInstOperands,
     /*  50252 */   // GIR_Coverage, 21161,
     /*  50252 */   GIR_Done,
     /*  50253 */ // Label 1190: @50253
     /*  50253 */ GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(50283), // Rule ID 22172 //
     /*  50258 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_In64BitMode),
     /*  50261 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  50264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  50268 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /*  50272 */   // (lrint:{ *:[i64] } FR16:{ *:[f16] }:$src)  =>  (VCVTTSH2SI64Zrr:{ *:[i64] } FR16:{ *:[f16] }:$src)
     /*  50272 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SI64Zrr),
     /*  50277 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50281 */   GIR_RootConstrainSelectedInstOperands,
     /*  50282 */   // GIR_Coverage, 22172,
     /*  50282 */   GIR_Done,
     /*  50283 */ // Label 1191: @50283
     /*  50283 */ GIM_Reject,
     /*  50284 */ // Label 1153: @50284
     /*  50284 */ GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(50372),
     /*  50289 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  50292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  50296 */   GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(50348), // Rule ID 21385 //
     /*  50301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  50304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50312 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50315 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50319 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50325 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50332 */     // (lrint:{ *:[v2i64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPD2QQZ128rm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  50332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ128rm),
     /*  50335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50337 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50341 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50346 */     GIR_RootConstrainSelectedInstOperands,
     /*  50347 */     // GIR_Coverage, 21385,
     /*  50347 */     GIR_EraseRootFromParent_Done,
     /*  50348 */   // Label 1193: @50348
     /*  50348 */   GIM_Try, /*On fail goto*//*Label 1194*/ GIMT_Encode4(50371), // Rule ID 21384 //
     /*  50353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  50356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  50360 */     // (lrint:{ *:[v2i64] } VR128X:{ *:[v2f64] }:$src)  =>  (VCVTPD2QQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2f64] }:$src)
     /*  50360 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ128rr),
     /*  50365 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50369 */     GIR_RootConstrainSelectedInstOperands,
     /*  50370 */     // GIR_Coverage, 21384,
     /*  50370 */     GIR_Done,
     /*  50371 */   // Label 1194: @50371
     /*  50371 */   GIM_Reject,
     /*  50372 */ // Label 1192: @50372
     /*  50372 */ GIM_Reject,
     /*  50373 */ // Label 1154: @50373
     /*  50373 */ GIM_Try, /*On fail goto*//*Label 1195*/ GIMT_Encode4(50432), // Rule ID 18044 //
     /*  50378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  50381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  50384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  50388 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50392 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50396 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50399 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50403 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50407 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50409 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50416 */   // (lrint:{ *:[v4i32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPS2DQrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  50416 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQrm),
     /*  50419 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50421 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50425 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50430 */   GIR_RootConstrainSelectedInstOperands,
     /*  50431 */   // GIR_Coverage, 18044,
     /*  50431 */   GIR_EraseRootFromParent_Done,
     /*  50432 */ // Label 1195: @50432
     /*  50432 */ GIM_Try, /*On fail goto*//*Label 1196*/ GIMT_Encode4(50491), // Rule ID 18048 //
     /*  50437 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  50440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  50443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  50447 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50451 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50455 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50458 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50462 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50466 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50468 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50475 */   // (lrint:{ *:[v4i32] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPD2DQYrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  50475 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPD2DQYrm),
     /*  50478 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50480 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50484 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50489 */   GIR_RootConstrainSelectedInstOperands,
     /*  50490 */   // GIR_Coverage, 18048,
     /*  50490 */   GIR_EraseRootFromParent_Done,
     /*  50491 */ // Label 1196: @50491
     /*  50491 */ GIM_Try, /*On fail goto*//*Label 1197*/ GIMT_Encode4(50550), // Rule ID 18050 //
     /*  50496 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  50499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  50502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  50506 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50510 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50514 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50517 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50521 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50525 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50527 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50534 */   // (lrint:{ *:[v4i32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTPS2DQrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  50534 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTPS2DQrm),
     /*  50537 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50539 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50543 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50548 */   GIR_RootConstrainSelectedInstOperands,
     /*  50549 */   // GIR_Coverage, 18050,
     /*  50549 */   GIR_EraseRootFromParent_Done,
     /*  50550 */ // Label 1197: @50550
     /*  50550 */ GIM_Try, /*On fail goto*//*Label 1198*/ GIMT_Encode4(50609), // Rule ID 21357 //
     /*  50555 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  50558 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  50561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  50565 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50569 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50573 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50576 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50580 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50584 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50586 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50593 */   // (lrint:{ *:[v4i32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPS2DQZ128rm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  50593 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQZ128rm),
     /*  50596 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50598 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50602 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50607 */   GIR_RootConstrainSelectedInstOperands,
     /*  50608 */   // GIR_Coverage, 21357,
     /*  50608 */   GIR_EraseRootFromParent_Done,
     /*  50609 */ // Label 1198: @50609
     /*  50609 */ GIM_Try, /*On fail goto*//*Label 1199*/ GIMT_Encode4(50668), // Rule ID 21361 //
     /*  50614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  50617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  50620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  50624 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50628 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50632 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50635 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50639 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50643 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50645 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50652 */   // (lrint:{ *:[v4i32] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPD2DQZ256rm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  50652 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPD2DQZ256rm),
     /*  50655 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50657 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50661 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50666 */   GIR_RootConstrainSelectedInstOperands,
     /*  50667 */   // GIR_Coverage, 21361,
     /*  50667 */   GIR_EraseRootFromParent_Done,
     /*  50668 */ // Label 1199: @50668
     /*  50668 */ GIM_Try, /*On fail goto*//*Label 1200*/ GIMT_Encode4(50698), // Rule ID 18043 //
     /*  50673 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  50676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  50679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  50683 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  50687 */   // (lrint:{ *:[v4i32] } VR128:{ *:[v4f32] }:$src)  =>  (VCVTPS2DQrr:{ *:[v4i32] } VR128:{ *:[v4f32] }:$src)
     /*  50687 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQrr),
     /*  50692 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50696 */   GIR_RootConstrainSelectedInstOperands,
     /*  50697 */   // GIR_Coverage, 18043,
     /*  50697 */   GIR_Done,
     /*  50698 */ // Label 1200: @50698
     /*  50698 */ GIM_Try, /*On fail goto*//*Label 1201*/ GIMT_Encode4(50728), // Rule ID 18047 //
     /*  50703 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  50706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  50709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  50713 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  50717 */   // (lrint:{ *:[v4i32] } VR256:{ *:[v4f64] }:$src)  =>  (VCVTPD2DQYrr:{ *:[v4i32] } VR256:{ *:[v4f64] }:$src)
     /*  50717 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2DQYrr),
     /*  50722 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50726 */   GIR_RootConstrainSelectedInstOperands,
     /*  50727 */   // GIR_Coverage, 18047,
     /*  50727 */   GIR_Done,
     /*  50728 */ // Label 1201: @50728
     /*  50728 */ GIM_Try, /*On fail goto*//*Label 1202*/ GIMT_Encode4(50758), // Rule ID 18049 //
     /*  50733 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  50736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  50739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  50743 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  50747 */   // (lrint:{ *:[v4i32] } VR128:{ *:[v4f32] }:$src)  =>  (CVTPS2DQrr:{ *:[v4i32] } VR128:{ *:[v4f32] }:$src)
     /*  50747 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTPS2DQrr),
     /*  50752 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50756 */   GIR_RootConstrainSelectedInstOperands,
     /*  50757 */   // GIR_Coverage, 18049,
     /*  50757 */   GIR_Done,
     /*  50758 */ // Label 1202: @50758
     /*  50758 */ GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(50788), // Rule ID 21356 //
     /*  50763 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  50766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  50769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  50773 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  50777 */   // (lrint:{ *:[v4i32] } VR128X:{ *:[v4f32] }:$src)  =>  (VCVTPS2DQZ128rr:{ *:[v4i32] } VR128X:{ *:[v4f32] }:$src)
     /*  50777 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQZ128rr),
     /*  50782 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50786 */   GIR_RootConstrainSelectedInstOperands,
     /*  50787 */   // GIR_Coverage, 21356,
     /*  50787 */   GIR_Done,
     /*  50788 */ // Label 1203: @50788
     /*  50788 */ GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(50818), // Rule ID 21360 //
     /*  50793 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  50796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  50799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  50803 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  50807 */   // (lrint:{ *:[v4i32] } VR256X:{ *:[v4f64] }:$src)  =>  (VCVTPD2DQZ256rr:{ *:[v4i32] } VR256X:{ *:[v4f64] }:$src)
     /*  50807 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2DQZ256rr),
     /*  50812 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50816 */   GIR_RootConstrainSelectedInstOperands,
     /*  50817 */   // GIR_Coverage, 21360,
     /*  50817 */   GIR_Done,
     /*  50818 */ // Label 1204: @50818
     /*  50818 */ GIM_Reject,
     /*  50819 */ // Label 1155: @50819
     /*  50819 */ GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(50878), // Rule ID 21381 //
     /*  50824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  50827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  50830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  50834 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50838 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50842 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50845 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50849 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50853 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50855 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50862 */   // (lrint:{ *:[v4i64] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPS2QQZ256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /*  50862 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZ256rm),
     /*  50865 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50867 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50871 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50876 */   GIR_RootConstrainSelectedInstOperands,
     /*  50877 */   // GIR_Coverage, 21381,
     /*  50877 */   GIR_EraseRootFromParent_Done,
     /*  50878 */ // Label 1205: @50878
     /*  50878 */ GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(50937), // Rule ID 21387 //
     /*  50883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  50886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  50889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  50893 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50897 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50901 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50904 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50908 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50912 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50914 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50921 */   // (lrint:{ *:[v4i64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPD2QQZ256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /*  50921 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ256rm),
     /*  50924 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50926 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50930 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50935 */   GIR_RootConstrainSelectedInstOperands,
     /*  50936 */   // GIR_Coverage, 21387,
     /*  50936 */   GIR_EraseRootFromParent_Done,
     /*  50937 */ // Label 1206: @50937
     /*  50937 */ GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(50967), // Rule ID 21380 //
     /*  50942 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  50945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  50948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  50952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  50956 */   // (lrint:{ *:[v4i64] } VR128X:{ *:[v4f32] }:$src)  =>  (VCVTPS2QQZ256rr:{ *:[v4i64] } VR128X:{ *:[v4f32] }:$src)
     /*  50956 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZ256rr),
     /*  50961 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50965 */   GIR_RootConstrainSelectedInstOperands,
     /*  50966 */   // GIR_Coverage, 21380,
     /*  50966 */   GIR_Done,
     /*  50967 */ // Label 1207: @50967
     /*  50967 */ GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(50997), // Rule ID 21386 //
     /*  50972 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  50975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  50978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  50982 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  50986 */   // (lrint:{ *:[v4i64] } VR256X:{ *:[v4f64] }:$src)  =>  (VCVTPD2QQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4f64] }:$src)
     /*  50986 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ256rr),
     /*  50991 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50995 */   GIR_RootConstrainSelectedInstOperands,
     /*  50996 */   // GIR_Coverage, 21386,
     /*  50996 */   GIR_Done,
     /*  50997 */ // Label 1208: @50997
     /*  50997 */ GIM_Reject,
     /*  50998 */ // Label 1156: @50998
     /*  50998 */ GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(51086),
     /*  51003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  51006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  51010 */   GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(51062), // Rule ID 22156 //
     /*  51015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /*  51018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51026 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51029 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51033 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51039 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51046 */     // (lrint:{ *:[v8i16] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPH2WZ128rm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  51046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPH2WZ128rm),
     /*  51049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51051 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51055 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51060 */     GIR_RootConstrainSelectedInstOperands,
     /*  51061 */     // GIR_Coverage, 22156,
     /*  51061 */     GIR_EraseRootFromParent_Done,
     /*  51062 */   // Label 1210: @51062
     /*  51062 */   GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(51085), // Rule ID 22155 //
     /*  51067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /*  51070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  51074 */     // (lrint:{ *:[v8i16] } VR128X:{ *:[v8f16] }:$src)  =>  (VCVTPH2WZ128rr:{ *:[v8i16] } VR128X:{ *:[v8f16] }:$src)
     /*  51074 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2WZ128rr),
     /*  51079 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51083 */     GIR_RootConstrainSelectedInstOperands,
     /*  51084 */     // GIR_Coverage, 22155,
     /*  51084 */     GIR_Done,
     /*  51085 */   // Label 1211: @51085
     /*  51085 */   GIM_Reject,
     /*  51086 */ // Label 1209: @51086
     /*  51086 */ GIM_Reject,
     /*  51087 */ // Label 1157: @51087
     /*  51087 */ GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(51146), // Rule ID 18046 //
     /*  51092 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  51095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  51098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  51102 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51106 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51110 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51113 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51117 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51121 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51123 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51130 */   // (lrint:{ *:[v8i32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPS2DQYrm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /*  51130 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQYrm),
     /*  51133 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51135 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51139 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51144 */   GIR_RootConstrainSelectedInstOperands,
     /*  51145 */   // GIR_Coverage, 18046,
     /*  51145 */   GIR_EraseRootFromParent_Done,
     /*  51146 */ // Label 1212: @51146
     /*  51146 */ GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(51205), // Rule ID 21359 //
     /*  51151 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  51154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  51157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51161 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51165 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51169 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51172 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51176 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51180 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51182 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51189 */   // (lrint:{ *:[v8i32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPS2DQZ256rm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /*  51189 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQZ256rm),
     /*  51192 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51194 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51198 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51203 */   GIR_RootConstrainSelectedInstOperands,
     /*  51204 */   // GIR_Coverage, 21359,
     /*  51204 */   GIR_EraseRootFromParent_Done,
     /*  51205 */ // Label 1213: @51205
     /*  51205 */ GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(51261), // Rule ID 21365 //
     /*  51210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  51213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51217 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51221 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51225 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51228 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51232 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51236 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51238 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51245 */   // (lrint:{ *:[v8i32] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPD2DQZrm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /*  51245 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPD2DQZrm),
     /*  51248 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51250 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51254 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51259 */   GIR_RootConstrainSelectedInstOperands,
     /*  51260 */   // GIR_Coverage, 21365,
     /*  51260 */   GIR_EraseRootFromParent_Done,
     /*  51261 */ // Label 1214: @51261
     /*  51261 */ GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(51320), // Rule ID 22160 //
     /*  51266 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /*  51269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  51272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51276 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51280 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51284 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51287 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51291 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51295 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51297 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51304 */   // (lrint:{ *:[v8i32] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPH2DQZ256rm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /*  51304 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPH2DQZ256rm),
     /*  51307 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51309 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51313 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51318 */   GIR_RootConstrainSelectedInstOperands,
     /*  51319 */   // GIR_Coverage, 22160,
     /*  51319 */   GIR_EraseRootFromParent_Done,
     /*  51320 */ // Label 1215: @51320
     /*  51320 */ GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(51350), // Rule ID 18045 //
     /*  51325 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  51328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  51331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  51335 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  51339 */   // (lrint:{ *:[v8i32] } VR256:{ *:[v8f32] }:$src)  =>  (VCVTPS2DQYrr:{ *:[v8i32] } VR256:{ *:[v8f32] }:$src)
     /*  51339 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQYrr),
     /*  51344 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51348 */   GIR_RootConstrainSelectedInstOperands,
     /*  51349 */   // GIR_Coverage, 18045,
     /*  51349 */   GIR_Done,
     /*  51350 */ // Label 1216: @51350
     /*  51350 */ GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(51380), // Rule ID 21358 //
     /*  51355 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  51358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  51361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51365 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51369 */   // (lrint:{ *:[v8i32] } VR256X:{ *:[v8f32] }:$src)  =>  (VCVTPS2DQZ256rr:{ *:[v8i32] } VR256X:{ *:[v8f32] }:$src)
     /*  51369 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQZ256rr),
     /*  51374 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51378 */   GIR_RootConstrainSelectedInstOperands,
     /*  51379 */   // GIR_Coverage, 21358,
     /*  51379 */   GIR_Done,
     /*  51380 */ // Label 1217: @51380
     /*  51380 */ GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(51407), // Rule ID 21364 //
     /*  51385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  51388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51392 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51396 */   // (lrint:{ *:[v8i32] } VR512:{ *:[v8f64] }:$src)  =>  (VCVTPD2DQZrr:{ *:[v8i32] } VR512:{ *:[v8f64] }:$src)
     /*  51396 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2DQZrr),
     /*  51401 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51405 */   GIR_RootConstrainSelectedInstOperands,
     /*  51406 */   // GIR_Coverage, 21364,
     /*  51406 */   GIR_Done,
     /*  51407 */ // Label 1218: @51407
     /*  51407 */ GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(51437), // Rule ID 22159 //
     /*  51412 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /*  51415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  51418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51422 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  51426 */   // (lrint:{ *:[v8i32] } VR128X:{ *:[v8f16] }:$src)  =>  (VCVTPH2DQZ256rr:{ *:[v8i32] } VR128X:{ *:[v8f16] }:$src)
     /*  51426 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2DQZ256rr),
     /*  51431 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51435 */   GIR_RootConstrainSelectedInstOperands,
     /*  51436 */   // GIR_Coverage, 22159,
     /*  51436 */   GIR_Done,
     /*  51437 */ // Label 1219: @51437
     /*  51437 */ GIM_Reject,
     /*  51438 */ // Label 1158: @51438
     /*  51438 */ GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(51497), // Rule ID 21393 //
     /*  51443 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  51446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  51449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51453 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51457 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51461 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51464 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51468 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51472 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51474 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51481 */   // (lrint:{ *:[v8i64] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPS2QQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /*  51481 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZrm),
     /*  51484 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51486 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51490 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51495 */   GIR_RootConstrainSelectedInstOperands,
     /*  51496 */   // GIR_Coverage, 21393,
     /*  51496 */   GIR_EraseRootFromParent_Done,
     /*  51497 */ // Label 1220: @51497
     /*  51497 */ GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(51556), // Rule ID 21397 //
     /*  51502 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  51505 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  51508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51512 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51516 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51520 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51523 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51527 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51531 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51533 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51540 */   // (lrint:{ *:[v8i64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPD2QQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /*  51540 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZrm),
     /*  51543 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51545 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51549 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51554 */   GIR_RootConstrainSelectedInstOperands,
     /*  51555 */   // GIR_Coverage, 21397,
     /*  51555 */   GIR_EraseRootFromParent_Done,
     /*  51556 */ // Label 1221: @51556
     /*  51556 */ GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(51615), // Rule ID 22166 //
     /*  51561 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  51564 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  51567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51571 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51575 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51579 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51582 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51586 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51590 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51592 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51599 */   // (lrint:{ *:[v8i64] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPH2QQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /*  51599 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPH2QQZrm),
     /*  51602 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51604 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51608 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51613 */   GIR_RootConstrainSelectedInstOperands,
     /*  51614 */   // GIR_Coverage, 22166,
     /*  51614 */   GIR_EraseRootFromParent_Done,
     /*  51615 */ // Label 1222: @51615
     /*  51615 */ GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(51645), // Rule ID 21392 //
     /*  51620 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  51623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  51626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51630 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51634 */   // (lrint:{ *:[v8i64] } VR256X:{ *:[v8f32] }:$src)  =>  (VCVTPS2QQZrr:{ *:[v8i64] } VR256X:{ *:[v8f32] }:$src)
     /*  51634 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZrr),
     /*  51639 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51643 */   GIR_RootConstrainSelectedInstOperands,
     /*  51644 */   // GIR_Coverage, 21392,
     /*  51644 */   GIR_Done,
     /*  51645 */ // Label 1223: @51645
     /*  51645 */ GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(51675), // Rule ID 21396 //
     /*  51650 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  51653 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  51656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51660 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51664 */   // (lrint:{ *:[v8i64] } VR512:{ *:[v8f64] }:$src)  =>  (VCVTPD2QQZrr:{ *:[v8i64] } VR512:{ *:[v8f64] }:$src)
     /*  51664 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZrr),
     /*  51669 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51673 */   GIR_RootConstrainSelectedInstOperands,
     /*  51674 */   // GIR_Coverage, 21396,
     /*  51674 */   GIR_Done,
     /*  51675 */ // Label 1224: @51675
     /*  51675 */ GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(51705), // Rule ID 22165 //
     /*  51680 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  51683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  51686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51690 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  51694 */   // (lrint:{ *:[v8i64] } VR128X:{ *:[v8f16] }:$src)  =>  (VCVTPH2QQZrr:{ *:[v8i64] } VR128X:{ *:[v8f16] }:$src)
     /*  51694 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2QQZrr),
     /*  51699 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51703 */   GIR_RootConstrainSelectedInstOperands,
     /*  51704 */   // GIR_Coverage, 22165,
     /*  51704 */   GIR_Done,
     /*  51705 */ // Label 1225: @51705
     /*  51705 */ GIM_Reject,
     /*  51706 */ // Label 1159: @51706
     /*  51706 */ GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(51794),
     /*  51711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  51714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51718 */   GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(51770), // Rule ID 22158 //
     /*  51723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /*  51726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51734 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51737 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51741 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51747 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51754 */     // (lrint:{ *:[v16i16] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPH2WZ256rm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /*  51754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPH2WZ256rm),
     /*  51757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51759 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51763 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51768 */     GIR_RootConstrainSelectedInstOperands,
     /*  51769 */     // GIR_Coverage, 22158,
     /*  51769 */     GIR_EraseRootFromParent_Done,
     /*  51770 */   // Label 1227: @51770
     /*  51770 */   GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(51793), // Rule ID 22157 //
     /*  51775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /*  51778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51782 */     // (lrint:{ *:[v16i16] } VR256X:{ *:[v16f16] }:$src)  =>  (VCVTPH2WZ256rr:{ *:[v16i16] } VR256X:{ *:[v16f16] }:$src)
     /*  51782 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2WZ256rr),
     /*  51787 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51791 */     GIR_RootConstrainSelectedInstOperands,
     /*  51792 */     // GIR_Coverage, 22157,
     /*  51792 */     GIR_Done,
     /*  51793 */   // Label 1228: @51793
     /*  51793 */   GIM_Reject,
     /*  51794 */ // Label 1226: @51794
     /*  51794 */ GIM_Reject,
     /*  51795 */ // Label 1160: @51795
     /*  51795 */ GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(51851), // Rule ID 21363 //
     /*  51800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  51803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51807 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51811 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51815 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51818 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51822 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51826 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51828 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51835 */   // (lrint:{ *:[v16i32] } (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPS2DQZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)
     /*  51835 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQZrm),
     /*  51838 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51840 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51844 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51849 */   GIR_RootConstrainSelectedInstOperands,
     /*  51850 */   // GIR_Coverage, 21363,
     /*  51850 */   GIR_EraseRootFromParent_Done,
     /*  51851 */ // Label 1229: @51851
     /*  51851 */ GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(51910), // Rule ID 22164 //
     /*  51856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  51859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  51862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51866 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51870 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51874 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51877 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51881 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51885 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51887 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51894 */   // (lrint:{ *:[v16i32] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPH2DQZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)
     /*  51894 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPH2DQZrm),
     /*  51897 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51899 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51903 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51908 */   GIR_RootConstrainSelectedInstOperands,
     /*  51909 */   // GIR_Coverage, 22164,
     /*  51909 */   GIR_EraseRootFromParent_Done,
     /*  51910 */ // Label 1230: @51910
     /*  51910 */ GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(51937), // Rule ID 21362 //
     /*  51915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  51918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51922 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51926 */   // (lrint:{ *:[v16i32] } VR512:{ *:[v16f32] }:$src)  =>  (VCVTPS2DQZrr:{ *:[v16i32] } VR512:{ *:[v16f32] }:$src)
     /*  51926 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQZrr),
     /*  51931 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51935 */   GIR_RootConstrainSelectedInstOperands,
     /*  51936 */   // GIR_Coverage, 21362,
     /*  51936 */   GIR_Done,
     /*  51937 */ // Label 1231: @51937
     /*  51937 */ GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(51967), // Rule ID 22163 //
     /*  51942 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  51945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  51948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51956 */   // (lrint:{ *:[v16i32] } VR256X:{ *:[v16f16] }:$src)  =>  (VCVTPH2DQZrr:{ *:[v16i32] } VR256X:{ *:[v16f16] }:$src)
     /*  51956 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2DQZrr),
     /*  51961 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51965 */   GIR_RootConstrainSelectedInstOperands,
     /*  51966 */   // GIR_Coverage, 22163,
     /*  51966 */   GIR_Done,
     /*  51967 */ // Label 1232: @51967
     /*  51967 */ GIM_Reject,
     /*  51968 */ // Label 1161: @51968
     /*  51968 */ GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(52056),
     /*  51973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  51976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51980 */   GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(52032), // Rule ID 22162 //
     /*  51985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  51988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51996 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51999 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52003 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52009 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52016 */     // (lrint:{ *:[v32i16] } (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPH2WZrm:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)
     /*  52016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPH2WZrm),
     /*  52019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52021 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52025 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52030 */     GIR_RootConstrainSelectedInstOperands,
     /*  52031 */     // GIR_Coverage, 22162,
     /*  52031 */     GIR_EraseRootFromParent_Done,
     /*  52032 */   // Label 1234: @52032
     /*  52032 */   GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(52055), // Rule ID 22161 //
     /*  52037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  52040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  52044 */     // (lrint:{ *:[v32i16] } VR512:{ *:[v32f16] }:$src)  =>  (VCVTPH2WZrr:{ *:[v32i16] } VR512:{ *:[v32f16] }:$src)
     /*  52044 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2WZrr),
     /*  52049 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52053 */     GIR_RootConstrainSelectedInstOperands,
     /*  52054 */     // GIR_Coverage, 22161,
     /*  52054 */     GIR_Done,
     /*  52055 */   // Label 1235: @52055
     /*  52055 */   GIM_Reject,
     /*  52056 */ // Label 1233: @52056
     /*  52056 */ GIM_Reject,
     /*  52057 */ // Label 1162: @52057
     /*  52057 */ GIM_Reject,
     /*  52058 */ // Label 9: @52058
     /*  52058 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 1240*/ GIMT_Encode4(53277),
     /*  52069 */ /*GILLT_s64*//*Label 1236*/ GIMT_Encode4(52117), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  52085 */ /*GILLT_v2s64*//*Label 1237*/ GIMT_Encode4(52741), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  52097 */ /*GILLT_v4s64*//*Label 1238*/ GIMT_Encode4(52830), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  52113 */ /*GILLT_v8s64*//*Label 1239*/ GIMT_Encode4(53009),
     /*  52117 */ // Label 1236: @52117
     /*  52117 */ GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(52176), // Rule ID 1758 //
     /*  52122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  52125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  52128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52132 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52136 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52140 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52143 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52147 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52151 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52153 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52160 */   // (llrint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSS2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  52160 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64rm),
     /*  52163 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52165 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52169 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52174 */   GIR_RootConstrainSelectedInstOperands,
     /*  52175 */   // GIR_Coverage, 1758,
     /*  52175 */   GIR_EraseRootFromParent_Done,
     /*  52176 */ // Label 1241: @52176
     /*  52176 */ GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(52235), // Rule ID 1762 //
     /*  52181 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  52184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  52187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52191 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52195 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52199 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52202 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52206 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52210 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52212 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52219 */   // (llrint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSD2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  52219 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64rm),
     /*  52222 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52224 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52228 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52233 */   GIR_RootConstrainSelectedInstOperands,
     /*  52234 */   // GIR_Coverage, 1762,
     /*  52234 */   GIR_EraseRootFromParent_Done,
     /*  52235 */ // Label 1242: @52235
     /*  52235 */ GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(52294), // Rule ID 1782 //
     /*  52240 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  52243 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  52246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52250 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52254 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52258 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52261 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52265 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52269 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52271 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52278 */   // (llrint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSS2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  52278 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSS2SI64rm),
     /*  52281 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52283 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52287 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52292 */   GIR_RootConstrainSelectedInstOperands,
     /*  52293 */   // GIR_Coverage, 1782,
     /*  52293 */   GIR_EraseRootFromParent_Done,
     /*  52294 */ // Label 1243: @52294
     /*  52294 */ GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(52353), // Rule ID 1786 //
     /*  52299 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  52302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  52305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52309 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52313 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52317 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52320 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52324 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52328 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52330 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52337 */   // (llrint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSD2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  52337 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSD2SI64rm),
     /*  52340 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52342 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52346 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52351 */   GIR_RootConstrainSelectedInstOperands,
     /*  52352 */   // GIR_Coverage, 1786,
     /*  52352 */   GIR_EraseRootFromParent_Done,
     /*  52353 */ // Label 1244: @52353
     /*  52353 */ GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(52412), // Rule ID 10355 //
     /*  52358 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  52361 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  52364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52368 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52372 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52376 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52379 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52383 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52387 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52389 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52396 */   // (llrint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSS2SI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  52396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64Zrm),
     /*  52399 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52401 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52405 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52410 */   GIR_RootConstrainSelectedInstOperands,
     /*  52411 */   // GIR_Coverage, 10355,
     /*  52411 */   GIR_EraseRootFromParent_Done,
     /*  52412 */ // Label 1245: @52412
     /*  52412 */ GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(52471), // Rule ID 10359 //
     /*  52417 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  52420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  52423 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52427 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52431 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52435 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52438 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52442 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52446 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52448 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52455 */   // (llrint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSD2SI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  52455 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64Zrm),
     /*  52458 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52460 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52464 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52469 */   GIR_RootConstrainSelectedInstOperands,
     /*  52470 */   // GIR_Coverage, 10359,
     /*  52470 */   GIR_EraseRootFromParent_Done,
     /*  52471 */ // Label 1246: @52471
     /*  52471 */ GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(52530), // Rule ID 22175 //
     /*  52476 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_In64BitMode),
     /*  52479 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  52482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52486 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52490 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52494 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52497 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52501 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52505 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52507 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52514 */   // (llrint:{ *:[i64] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSH2SI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  52514 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SI64Zrm),
     /*  52517 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52519 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52523 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52528 */   GIR_RootConstrainSelectedInstOperands,
     /*  52529 */   // GIR_Coverage, 22175,
     /*  52529 */   GIR_EraseRootFromParent_Done,
     /*  52530 */ // Label 1247: @52530
     /*  52530 */ GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(52560), // Rule ID 1757 //
     /*  52535 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  52538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  52541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52545 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  52549 */   // (llrint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (VCVTSS2SI64rr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /*  52549 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64rr),
     /*  52554 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52558 */   GIR_RootConstrainSelectedInstOperands,
     /*  52559 */   // GIR_Coverage, 1757,
     /*  52559 */   GIR_Done,
     /*  52560 */ // Label 1248: @52560
     /*  52560 */ GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(52590), // Rule ID 1761 //
     /*  52565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  52568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  52571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52575 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  52579 */   // (llrint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (VCVTSD2SI64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /*  52579 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64rr),
     /*  52584 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52588 */   GIR_RootConstrainSelectedInstOperands,
     /*  52589 */   // GIR_Coverage, 1761,
     /*  52589 */   GIR_Done,
     /*  52590 */ // Label 1249: @52590
     /*  52590 */ GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(52620), // Rule ID 1781 //
     /*  52595 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  52598 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  52601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52605 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  52609 */   // (llrint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (CVTSS2SI64rr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /*  52609 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSS2SI64rr),
     /*  52614 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52618 */   GIR_RootConstrainSelectedInstOperands,
     /*  52619 */   // GIR_Coverage, 1781,
     /*  52619 */   GIR_Done,
     /*  52620 */ // Label 1250: @52620
     /*  52620 */ GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(52650), // Rule ID 1785 //
     /*  52625 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  52628 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  52631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52635 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  52639 */   // (llrint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (CVTSD2SI64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /*  52639 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSD2SI64rr),
     /*  52644 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52648 */   GIR_RootConstrainSelectedInstOperands,
     /*  52649 */   // GIR_Coverage, 1785,
     /*  52649 */   GIR_Done,
     /*  52650 */ // Label 1251: @52650
     /*  52650 */ GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(52680), // Rule ID 10354 //
     /*  52655 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  52658 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  52661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52665 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /*  52669 */   // (llrint:{ *:[i64] } FR32X:{ *:[f32] }:$src)  =>  (VCVTSS2SI64Zrr:{ *:[i64] } FR32X:{ *:[f32] }:$src)
     /*  52669 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64Zrr),
     /*  52674 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52678 */   GIR_RootConstrainSelectedInstOperands,
     /*  52679 */   // GIR_Coverage, 10354,
     /*  52679 */   GIR_Done,
     /*  52680 */ // Label 1252: @52680
     /*  52680 */ GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(52710), // Rule ID 10358 //
     /*  52685 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  52688 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  52691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52695 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /*  52699 */   // (llrint:{ *:[i64] } FR64X:{ *:[f64] }:$src)  =>  (VCVTSD2SI64Zrr:{ *:[i64] } FR64X:{ *:[f64] }:$src)
     /*  52699 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64Zrr),
     /*  52704 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52708 */   GIR_RootConstrainSelectedInstOperands,
     /*  52709 */   // GIR_Coverage, 10358,
     /*  52709 */   GIR_Done,
     /*  52710 */ // Label 1253: @52710
     /*  52710 */ GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(52740), // Rule ID 22174 //
     /*  52715 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_In64BitMode),
     /*  52718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  52721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52725 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /*  52729 */   // (llrint:{ *:[i64] } FR16:{ *:[f16] }:$src)  =>  (VCVTTSH2SI64Zrr:{ *:[i64] } FR16:{ *:[f16] }:$src)
     /*  52729 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SI64Zrr),
     /*  52734 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52738 */   GIR_RootConstrainSelectedInstOperands,
     /*  52739 */   // GIR_Coverage, 22174,
     /*  52739 */   GIR_Done,
     /*  52740 */ // Label 1254: @52740
     /*  52740 */ GIM_Reject,
     /*  52741 */ // Label 1237: @52741
     /*  52741 */ GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(52829),
     /*  52746 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  52749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  52753 */   GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(52805), // Rule ID 21389 //
     /*  52758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  52761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52769 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52772 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52776 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52780 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52782 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52789 */     // (llrint:{ *:[v2i64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPD2QQZ128rm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  52789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ128rm),
     /*  52792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52794 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52798 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52803 */     GIR_RootConstrainSelectedInstOperands,
     /*  52804 */     // GIR_Coverage, 21389,
     /*  52804 */     GIR_EraseRootFromParent_Done,
     /*  52805 */   // Label 1256: @52805
     /*  52805 */   GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(52828), // Rule ID 21388 //
     /*  52810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  52813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  52817 */     // (llrint:{ *:[v2i64] } VR128X:{ *:[v2f64] }:$src)  =>  (VCVTPD2QQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2f64] }:$src)
     /*  52817 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ128rr),
     /*  52822 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52826 */     GIR_RootConstrainSelectedInstOperands,
     /*  52827 */     // GIR_Coverage, 21388,
     /*  52827 */     GIR_Done,
     /*  52828 */   // Label 1257: @52828
     /*  52828 */   GIM_Reject,
     /*  52829 */ // Label 1255: @52829
     /*  52829 */ GIM_Reject,
     /*  52830 */ // Label 1238: @52830
     /*  52830 */ GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(52889), // Rule ID 21383 //
     /*  52835 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  52838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  52845 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52849 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52853 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52856 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52860 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52864 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52866 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52873 */   // (llrint:{ *:[v4i64] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPS2QQZ256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /*  52873 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZ256rm),
     /*  52876 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52878 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52882 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52887 */   GIR_RootConstrainSelectedInstOperands,
     /*  52888 */   // GIR_Coverage, 21383,
     /*  52888 */   GIR_EraseRootFromParent_Done,
     /*  52889 */ // Label 1258: @52889
     /*  52889 */ GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(52948), // Rule ID 21391 //
     /*  52894 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  52897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  52900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  52904 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52908 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52912 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52915 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52919 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52923 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52925 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52932 */   // (llrint:{ *:[v4i64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPD2QQZ256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /*  52932 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ256rm),
     /*  52935 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52937 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52941 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52946 */   GIR_RootConstrainSelectedInstOperands,
     /*  52947 */   // GIR_Coverage, 21391,
     /*  52947 */   GIR_EraseRootFromParent_Done,
     /*  52948 */ // Label 1259: @52948
     /*  52948 */ GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(52978), // Rule ID 21382 //
     /*  52953 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  52956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  52963 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  52967 */   // (llrint:{ *:[v4i64] } VR128X:{ *:[v4f32] }:$src)  =>  (VCVTPS2QQZ256rr:{ *:[v4i64] } VR128X:{ *:[v4f32] }:$src)
     /*  52967 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZ256rr),
     /*  52972 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52976 */   GIR_RootConstrainSelectedInstOperands,
     /*  52977 */   // GIR_Coverage, 21382,
     /*  52977 */   GIR_Done,
     /*  52978 */ // Label 1260: @52978
     /*  52978 */ GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(53008), // Rule ID 21390 //
     /*  52983 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  52986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  52989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  52993 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  52997 */   // (llrint:{ *:[v4i64] } VR256X:{ *:[v4f64] }:$src)  =>  (VCVTPD2QQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4f64] }:$src)
     /*  52997 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ256rr),
     /*  53002 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  53006 */   GIR_RootConstrainSelectedInstOperands,
     /*  53007 */   // GIR_Coverage, 21390,
     /*  53007 */   GIR_Done,
     /*  53008 */ // Label 1261: @53008
     /*  53008 */ GIM_Reject,
     /*  53009 */ // Label 1239: @53009
     /*  53009 */ GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(53068), // Rule ID 21395 //
     /*  53014 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  53017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  53020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  53024 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53028 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  53032 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53035 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  53039 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  53043 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53045 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53052 */   // (llrint:{ *:[v8i64] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPS2QQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /*  53052 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZrm),
     /*  53055 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53057 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  53061 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  53066 */   GIR_RootConstrainSelectedInstOperands,
     /*  53067 */   // GIR_Coverage, 21395,
     /*  53067 */   GIR_EraseRootFromParent_Done,
     /*  53068 */ // Label 1262: @53068
     /*  53068 */ GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(53127), // Rule ID 21399 //
     /*  53073 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  53076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  53079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  53083 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53087 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  53091 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53094 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  53098 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  53102 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53104 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53111 */   // (llrint:{ *:[v8i64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPD2QQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /*  53111 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZrm),
     /*  53114 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53116 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  53120 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  53125 */   GIR_RootConstrainSelectedInstOperands,
     /*  53126 */   // GIR_Coverage, 21399,
     /*  53126 */   GIR_EraseRootFromParent_Done,
     /*  53127 */ // Label 1263: @53127
     /*  53127 */ GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(53186), // Rule ID 22168 //
     /*  53132 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  53135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  53138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  53142 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53146 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  53150 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53153 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  53157 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  53161 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53163 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53170 */   // (llrint:{ *:[v8i64] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPH2QQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /*  53170 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPH2QQZrm),
     /*  53173 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53175 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  53179 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  53184 */   GIR_RootConstrainSelectedInstOperands,
     /*  53185 */   // GIR_Coverage, 22168,
     /*  53185 */   GIR_EraseRootFromParent_Done,
     /*  53186 */ // Label 1264: @53186
     /*  53186 */ GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(53216), // Rule ID 21394 //
     /*  53191 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  53194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  53197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  53201 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  53205 */   // (llrint:{ *:[v8i64] } VR256X:{ *:[v8f32] }:$src)  =>  (VCVTPS2QQZrr:{ *:[v8i64] } VR256X:{ *:[v8f32] }:$src)
     /*  53205 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZrr),
     /*  53210 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  53214 */   GIR_RootConstrainSelectedInstOperands,
     /*  53215 */   // GIR_Coverage, 21394,
     /*  53215 */   GIR_Done,
     /*  53216 */ // Label 1265: @53216
     /*  53216 */ GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(53246), // Rule ID 21398 //
     /*  53221 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  53224 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  53227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  53231 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  53235 */   // (llrint:{ *:[v8i64] } VR512:{ *:[v8f64] }:$src)  =>  (VCVTPD2QQZrr:{ *:[v8i64] } VR512:{ *:[v8f64] }:$src)
     /*  53235 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZrr),
     /*  53240 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  53244 */   GIR_RootConstrainSelectedInstOperands,
     /*  53245 */   // GIR_Coverage, 21398,
     /*  53245 */   GIR_Done,
     /*  53246 */ // Label 1266: @53246
     /*  53246 */ GIM_Try, /*On fail goto*//*Label 1267*/ GIMT_Encode4(53276), // Rule ID 22167 //
     /*  53251 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  53254 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  53257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  53261 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  53265 */   // (llrint:{ *:[v8i64] } VR128X:{ *:[v8f16] }:$src)  =>  (VCVTPH2QQZrr:{ *:[v8i64] } VR128X:{ *:[v8f16] }:$src)
     /*  53265 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2QQZrr),
     /*  53270 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  53274 */   GIR_RootConstrainSelectedInstOperands,
     /*  53275 */   // GIR_Coverage, 22167,
     /*  53275 */   GIR_Done,
     /*  53276 */ // Label 1267: @53276
     /*  53276 */ GIM_Reject,
     /*  53277 */ // Label 1240: @53277
     /*  53277 */ GIM_Reject,
     /*  53278 */ // Label 10: @53278
     /*  53278 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(25), /*)*//*default:*//*Label 1293*/ GIMT_Encode4(59502),
     /*  53289 */ /*GILLT_s1*//*Label 1268*/ GIMT_Encode4(53389),
     /*  53293 */ /*GILLT_s8*//*Label 1269*/ GIMT_Encode4(53456),
     /*  53297 */ /*GILLT_s16*//*Label 1270*/ GIMT_Encode4(53597),
     /*  53301 */ /*GILLT_s32*//*Label 1271*/ GIMT_Encode4(54150),
     /*  53305 */ /*GILLT_s64*//*Label 1272*/ GIMT_Encode4(54572),
     /*  53309 */ /*GILLT_s80*//*Label 1273*/ GIMT_Encode4(55145),
     /*  53313 */ /*GILLT_s128*//*Label 1274*/ GIMT_Encode4(55304),
     /*  53317 */ /*GILLT_v2s1*//*Label 1275*/ GIMT_Encode4(55432),
     /*  53321 */ /*GILLT_v2s64*//*Label 1276*/ GIMT_Encode4(55499),
     /*  53325 */ /*GILLT_v4s1*//*Label 1277*/ GIMT_Encode4(55993),
     /*  53329 */ /*GILLT_v4s32*//*Label 1278*/ GIMT_Encode4(56060),
     /*  53333 */ /*GILLT_v4s64*//*Label 1279*/ GIMT_Encode4(56554),
     /*  53337 */ /*GILLT_v8s1*//*Label 1280*/ GIMT_Encode4(56888),
     /*  53341 */ /*GILLT_v8s16*//*Label 1281*/ GIMT_Encode4(56970),
     /*  53345 */ /*GILLT_v8s32*//*Label 1282*/ GIMT_Encode4(57544),
     /*  53349 */ /*GILLT_v8s64*//*Label 1283*/ GIMT_Encode4(57878),
     /*  53353 */ /*GILLT_v16s1*//*Label 1284*/ GIMT_Encode4(58052),
     /*  53357 */ /*GILLT_v16s8*//*Label 1285*/ GIMT_Encode4(58134),
     /*  53361 */ /*GILLT_v16s16*//*Label 1286*/ GIMT_Encode4(58388),
     /*  53365 */ /*GILLT_v16s32*//*Label 1287*/ GIMT_Encode4(58722),
     /*  53369 */ /*GILLT_v32s1*//*Label 1288*/ GIMT_Encode4(58896),
     /*  53373 */ /*GILLT_v32s8*//*Label 1289*/ GIMT_Encode4(58978),
     /*  53377 */ /*GILLT_v32s16*//*Label 1290*/ GIMT_Encode4(59152),
     /*  53381 */ /*GILLT_v64s1*//*Label 1291*/ GIMT_Encode4(59326),
     /*  53385 */ /*GILLT_v64s8*//*Label 1292*/ GIMT_Encode4(59408),
     /*  53389 */ // Label 1268: @53389
     /*  53389 */ GIM_Try, /*On fail goto*//*Label 1294*/ GIMT_Encode4(53455), // Rule ID 19445 //
     /*  53394 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  53397 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53400 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  53408 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53412 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53419 */   // (ld:{ *:[v1i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KMOVBkm:{ *:[v8i1] } addr:{ *:[iPTR] }:$src), VK1:{ *:[i32] })
     /*  53419 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s1,
     /*  53422 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KMOVBkm),
     /*  53426 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53431 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  53435 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53439 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53441 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53444 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53446 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53449 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  53454 */   // GIR_Coverage, 19445,
     /*  53454 */   GIR_EraseRootFromParent_Done,
     /*  53455 */ // Label 1294: @53455
     /*  53455 */ GIM_Reject,
     /*  53456 */ // Label 1269: @53456
     /*  53456 */ GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(53505), // Rule ID 22515 //
     /*  53461 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  53464 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53468 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  53475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  53479 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53483 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53490 */   // (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>  =>  (MOV8rm:{ *:[i8] } addr:{ *:[iPTR] }:$src)
     /*  53490 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8rm),
     /*  53493 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53495 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  53499 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53503 */   GIR_RootConstrainSelectedInstOperands,
     /*  53504 */   // GIR_Coverage, 22515,
     /*  53504 */   GIR_EraseRootFromParent_Done,
     /*  53505 */ // Label 1295: @53505
     /*  53505 */ GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(53554), // Rule ID 22580 //
     /*  53510 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53513 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53517 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  53524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  53528 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53532 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53539 */   // (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (MOV8rm:{ *:[i8] } addr:{ *:[iPTR] }:$src)
     /*  53539 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8rm),
     /*  53542 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53544 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  53548 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53552 */   GIR_RootConstrainSelectedInstOperands,
     /*  53553 */   // GIR_Coverage, 22580,
     /*  53553 */   GIR_EraseRootFromParent_Done,
     /*  53554 */ // Label 1296: @53554
     /*  53554 */ GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(53596), // Rule ID 28 //
     /*  53559 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  53566 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53570 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  53574 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53581 */   // (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>  =>  (MOV8rm:{ *:[i8] } addr:{ *:[iPTR] }:$src)
     /*  53581 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8rm),
     /*  53584 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53586 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  53590 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53594 */   GIR_RootConstrainSelectedInstOperands,
     /*  53595 */   // GIR_Coverage, 28,
     /*  53595 */   GIR_EraseRootFromParent_Done,
     /*  53596 */ // Label 1297: @53596
     /*  53596 */ GIM_Reject,
     /*  53597 */ // Label 1270: @53597
     /*  53597 */ GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(53646), // Rule ID 22516 //
     /*  53602 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  53605 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53609 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  53616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  53620 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53624 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53631 */   // (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>  =>  (MOV16rm:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /*  53631 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV16rm),
     /*  53634 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53636 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  53640 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53644 */   GIR_RootConstrainSelectedInstOperands,
     /*  53645 */   // GIR_Coverage, 22516,
     /*  53645 */   GIR_EraseRootFromParent_Done,
     /*  53646 */ // Label 1298: @53646
     /*  53646 */ GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(53725), // Rule ID 22581 //
     /*  53651 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53654 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53658 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  53665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  53669 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53673 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53680 */   // (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_16bit:{ *:[i32] })
     /*  53680 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53683 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  53687 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53692 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  53696 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53700 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53702 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53705 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53707 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  53714 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  53719 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  53724 */   // GIR_Coverage, 22581,
     /*  53724 */   GIR_EraseRootFromParent_Done,
     /*  53725 */ // Label 1299: @53725
     /*  53725 */ GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(53804), // Rule ID 22583 //
     /*  53730 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53733 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53737 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  53744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  53748 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53752 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53759 */   // (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_16bit:{ *:[i32] })
     /*  53759 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53762 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  53766 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53771 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  53775 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53779 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53781 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53784 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53786 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  53793 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  53798 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  53803 */   // GIR_Coverage, 22583,
     /*  53803 */   GIR_EraseRootFromParent_Done,
     /*  53804 */ // Label 1300: @53804
     /*  53804 */ GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(53849), // Rule ID 4621 //
     /*  53809 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  53812 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53815 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  53823 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53827 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53834 */   // (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVSHZrm_alt:{ *:[f16] } addr:{ *:[iPTR] }:$src)
     /*  53834 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSHZrm_alt),
     /*  53837 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53839 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  53843 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53847 */   GIR_RootConstrainSelectedInstOperands,
     /*  53848 */   // GIR_Coverage, 4621,
     /*  53848 */   GIR_EraseRootFromParent_Done,
     /*  53849 */ // Label 1301: @53849
     /*  53849 */ GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(53935), // Rule ID 18339 //
     /*  53854 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoBWI),
     /*  53857 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53860 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /*  53868 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53872 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53879 */   // (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VPINSRWrmi:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), addr:{ *:[iPTR] }:$src, 0:{ *:[i8] }), FR16:{ *:[i32] })
     /*  53879 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  53882 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  53886 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53891 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  53893 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  53896 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPINSRWrmi),
     /*  53900 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53905 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  53908 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  53912 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  53915 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53919 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53921 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53924 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53926 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53929 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /*  53934 */   // GIR_Coverage, 18339,
     /*  53934 */   GIR_EraseRootFromParent_Done,
     /*  53935 */ // Label 1302: @53935
     /*  53935 */ GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(53977), // Rule ID 29 //
     /*  53940 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  53947 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53951 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  53955 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53962 */   // (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>  =>  (MOV16rm:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /*  53962 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV16rm),
     /*  53965 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53967 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  53971 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53975 */   GIR_RootConstrainSelectedInstOperands,
     /*  53976 */   // GIR_Coverage, 29,
     /*  53976 */   GIR_EraseRootFromParent_Done,
     /*  53977 */ // Label 1303: @53977
     /*  53977 */ GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(54063), // Rule ID 18335 //
     /*  53982 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  53985 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53988 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53992 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /*  53996 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54000 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54007 */   // (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (COPY_TO_REGCLASS:{ *:[f16] } (PINSRWrmi:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), addr:{ *:[iPTR] }:$src, 0:{ *:[i8] }), FR16:{ *:[i32] })
     /*  54007 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  54010 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  54014 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54019 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  54021 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  54024 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::PINSRWrmi),
     /*  54028 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54033 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  54036 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  54040 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  54043 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54047 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54049 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54052 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54054 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54057 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /*  54062 */   // GIR_Coverage, 18335,
     /*  54062 */   GIR_EraseRootFromParent_Done,
     /*  54063 */ // Label 1304: @54063
     /*  54063 */ GIM_Try, /*On fail goto*//*Label 1305*/ GIMT_Encode4(54149), // Rule ID 21839 //
     /*  54068 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  54071 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54074 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  54082 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54086 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54093 */   // (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VPINSRWZrmi:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), addr:{ *:[iPTR] }:$src, 0:{ *:[i8] }), FR16X:{ *:[i32] })
     /*  54093 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  54096 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  54100 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54105 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  54107 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  54110 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPINSRWZrmi),
     /*  54114 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54119 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  54122 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  54126 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  54129 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54133 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54135 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54138 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54140 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54143 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /*  54148 */   // GIR_Coverage, 21839,
     /*  54148 */   GIR_EraseRootFromParent_Done,
     /*  54149 */ // Label 1305: @54149
     /*  54149 */ GIM_Reject,
     /*  54150 */ // Label 1271: @54150
     /*  54150 */ GIM_Try, /*On fail goto*//*Label 1306*/ GIMT_Encode4(54198), // Rule ID 1080 //
     /*  54155 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /*  54158 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54161 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /*  54169 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54173 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54180 */   // (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD_Fp32m:{ *:[f32] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /*  54180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp32m),
     /*  54183 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54185 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54189 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  54192 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54196 */   GIR_RootConstrainSelectedInstOperands,
     /*  54197 */   // GIR_Coverage, 1080,
     /*  54197 */   GIR_EraseRootFromParent_Done,
     /*  54198 */ // Label 1306: @54198
     /*  54198 */ GIM_Try, /*On fail goto*//*Label 1307*/ GIMT_Encode4(54243), // Rule ID 1697 //
     /*  54203 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  54206 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54209 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  54217 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54221 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54228 */   // (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVSSrm_alt:{ *:[f32] } addr:{ *:[iPTR] }:$src)
     /*  54228 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSSrm_alt),
     /*  54231 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54233 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54237 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54241 */   GIR_RootConstrainSelectedInstOperands,
     /*  54242 */   // GIR_Coverage, 1697,
     /*  54242 */   GIR_EraseRootFromParent_Done,
     /*  54243 */ // Label 1307: @54243
     /*  54243 */ GIM_Try, /*On fail goto*//*Label 1308*/ GIMT_Encode4(54288), // Rule ID 1698 //
     /*  54248 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  54251 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54254 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  54262 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54266 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54273 */   // (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVSSrm_alt:{ *:[f32] } addr:{ *:[iPTR] }:$src)
     /*  54273 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSSrm_alt),
     /*  54276 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54278 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54282 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54286 */   GIR_RootConstrainSelectedInstOperands,
     /*  54287 */   // GIR_Coverage, 1698,
     /*  54287 */   GIR_EraseRootFromParent_Done,
     /*  54288 */ // Label 1308: @54288
     /*  54288 */ GIM_Try, /*On fail goto*//*Label 1309*/ GIMT_Encode4(54337), // Rule ID 22517 //
     /*  54293 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  54296 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54300 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  54307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  54311 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54315 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54322 */   // (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>  =>  (MOV32rm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  54322 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32rm),
     /*  54325 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54327 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54331 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54335 */   GIR_RootConstrainSelectedInstOperands,
     /*  54336 */   // GIR_Coverage, 22517,
     /*  54336 */   GIR_EraseRootFromParent_Done,
     /*  54337 */ // Label 1309: @54337
     /*  54337 */ GIM_Try, /*On fail goto*//*Label 1310*/ GIMT_Encode4(54386), // Rule ID 22582 //
     /*  54342 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54345 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54349 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  54356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  54360 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54364 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54371 */   // (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  54371 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  54374 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54376 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54380 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54384 */   GIR_RootConstrainSelectedInstOperands,
     /*  54385 */   // GIR_Coverage, 22582,
     /*  54385 */   GIR_EraseRootFromParent_Done,
     /*  54386 */ // Label 1310: @54386
     /*  54386 */ GIM_Try, /*On fail goto*//*Label 1311*/ GIMT_Encode4(54435), // Rule ID 22584 //
     /*  54391 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54394 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54398 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  54405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  54409 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54413 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54420 */   // (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  54420 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  54423 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54425 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54429 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54433 */   GIR_RootConstrainSelectedInstOperands,
     /*  54434 */   // GIR_Coverage, 22584,
     /*  54434 */   GIR_EraseRootFromParent_Done,
     /*  54435 */ // Label 1311: @54435
     /*  54435 */ GIM_Try, /*On fail goto*//*Label 1312*/ GIMT_Encode4(54484), // Rule ID 22585 //
     /*  54440 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54443 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54447 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  54454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  54458 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54462 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54469 */   // (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (MOVZX32rm16:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  54469 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm16),
     /*  54472 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54474 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54478 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54482 */   GIR_RootConstrainSelectedInstOperands,
     /*  54483 */   // GIR_Coverage, 22585,
     /*  54483 */   GIR_EraseRootFromParent_Done,
     /*  54484 */ // Label 1312: @54484
     /*  54484 */ GIM_Try, /*On fail goto*//*Label 1313*/ GIMT_Encode4(54529), // Rule ID 4609 //
     /*  54489 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  54492 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54495 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /*  54503 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54507 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54514 */   // (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVSSZrm_alt:{ *:[f32] } addr:{ *:[iPTR] }:$src)
     /*  54514 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSSZrm_alt),
     /*  54517 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54519 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54523 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54527 */   GIR_RootConstrainSelectedInstOperands,
     /*  54528 */   // GIR_Coverage, 4609,
     /*  54528 */   GIR_EraseRootFromParent_Done,
     /*  54529 */ // Label 1313: @54529
     /*  54529 */ GIM_Try, /*On fail goto*//*Label 1314*/ GIMT_Encode4(54571), // Rule ID 30 //
     /*  54534 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  54541 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54545 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  54549 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54556 */   // (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>  =>  (MOV32rm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  54556 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32rm),
     /*  54559 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54561 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54565 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54569 */   GIR_RootConstrainSelectedInstOperands,
     /*  54570 */   // GIR_Coverage, 30,
     /*  54570 */   GIR_EraseRootFromParent_Done,
     /*  54571 */ // Label 1314: @54571
     /*  54571 */ GIM_Reject,
     /*  54572 */ // Label 1272: @54572
     /*  54572 */ GIM_Try, /*On fail goto*//*Label 1315*/ GIMT_Encode4(54614), // Rule ID 31 //
     /*  54577 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54580 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  54588 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54592 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54599 */   // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOV64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  54599 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV64rm),
     /*  54602 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54604 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54608 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54612 */   GIR_RootConstrainSelectedInstOperands,
     /*  54613 */   // GIR_Coverage, 31,
     /*  54613 */   GIR_EraseRootFromParent_Done,
     /*  54614 */ // Label 1315: @54614
     /*  54614 */ GIM_Try, /*On fail goto*//*Label 1316*/ GIMT_Encode4(54662), // Rule ID 1081 //
     /*  54619 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /*  54622 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54625 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /*  54633 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54637 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54644 */   // (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD_Fp64m:{ *:[f64] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /*  54644 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp64m),
     /*  54647 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54649 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54653 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  54656 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54660 */   GIR_RootConstrainSelectedInstOperands,
     /*  54661 */   // GIR_Coverage, 1081,
     /*  54661 */   GIR_EraseRootFromParent_Done,
     /*  54662 */ // Label 1316: @54662
     /*  54662 */ GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(54717), // Rule ID 1083 //
     /*  54667 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /*  54670 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54673 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54677 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  54684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /*  54688 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54692 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54699 */   // (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>  =>  (LD_Fp32m64:{ *:[f64] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /*  54699 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp32m64),
     /*  54702 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54704 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54708 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  54711 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54715 */   GIR_RootConstrainSelectedInstOperands,
     /*  54716 */   // GIR_Coverage, 1083,
     /*  54716 */   GIR_EraseRootFromParent_Done,
     /*  54717 */ // Label 1317: @54717
     /*  54717 */ GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(54762), // Rule ID 1701 //
     /*  54722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  54725 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54728 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  54736 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54740 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54747 */   // (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVSDrm_alt:{ *:[f64] } addr:{ *:[iPTR] }:$src)
     /*  54747 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSDrm_alt),
     /*  54750 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54752 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54756 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54760 */   GIR_RootConstrainSelectedInstOperands,
     /*  54761 */   // GIR_Coverage, 1701,
     /*  54761 */   GIR_EraseRootFromParent_Done,
     /*  54762 */ // Label 1318: @54762
     /*  54762 */ GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(54807), // Rule ID 1702 //
     /*  54767 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  54770 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54773 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  54781 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54785 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54792 */   // (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVSDrm_alt:{ *:[f64] } addr:{ *:[iPTR] }:$src)
     /*  54792 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSDrm_alt),
     /*  54795 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54797 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54801 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54805 */   GIR_RootConstrainSelectedInstOperands,
     /*  54806 */   // GIR_Coverage, 1702,
     /*  54806 */   GIR_EraseRootFromParent_Done,
     /*  54807 */ // Label 1319: @54807
     /*  54807 */ GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(54856), // Rule ID 22518 //
     /*  54812 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  54815 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54819 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  54826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  54830 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54834 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54841 */   // (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>  =>  (MOV64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  54841 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV64rm),
     /*  54844 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54846 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54850 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54854 */   GIR_RootConstrainSelectedInstOperands,
     /*  54855 */   // GIR_Coverage, 22518,
     /*  54855 */   GIR_EraseRootFromParent_Done,
     /*  54856 */ // Label 1320: @54856
     /*  54856 */ GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(54937), // Rule ID 22587 //
     /*  54861 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54864 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54868 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  54875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  54879 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54883 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54890 */   // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_32bit:{ *:[i32] })
     /*  54890 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54893 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  54897 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54902 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  54906 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54910 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54912 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54915 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54917 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54920 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54923 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  54926 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /*  54931 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /*  54936 */   // GIR_Coverage, 22587,
     /*  54936 */   GIR_EraseRootFromParent_Done,
     /*  54937 */ // Label 1321: @54937
     /*  54937 */ GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(55018), // Rule ID 22588 //
     /*  54942 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54945 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54949 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  54956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  54960 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54964 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54971 */   // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_32bit:{ *:[i32] })
     /*  54971 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54974 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  54978 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54983 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  54987 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54991 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54993 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54996 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54998 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  55001 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  55004 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  55007 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /*  55012 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /*  55017 */   // GIR_Coverage, 22588,
     /*  55017 */   GIR_EraseRootFromParent_Done,
     /*  55018 */ // Label 1322: @55018
     /*  55018 */ GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(55099), // Rule ID 22589 //
     /*  55023 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  55026 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  55030 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  55037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  55041 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55045 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55052 */   // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rm16:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_32bit:{ *:[i32] })
     /*  55052 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  55055 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm16),
     /*  55059 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55064 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  55068 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55072 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  55074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  55077 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55079 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  55082 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  55085 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  55088 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /*  55093 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /*  55098 */   // GIR_Coverage, 22589,
     /*  55098 */   GIR_EraseRootFromParent_Done,
     /*  55099 */ // Label 1323: @55099
     /*  55099 */ GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(55144), // Rule ID 4615 //
     /*  55104 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  55107 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  55110 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  55114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /*  55118 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55122 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55129 */   // (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVSDZrm_alt:{ *:[f64] } addr:{ *:[iPTR] }:$src)
     /*  55129 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSDZrm_alt),
     /*  55132 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55134 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55138 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55142 */   GIR_RootConstrainSelectedInstOperands,
     /*  55143 */   // GIR_Coverage, 4615,
     /*  55143 */   GIR_EraseRootFromParent_Done,
     /*  55144 */ // Label 1324: @55144
     /*  55144 */ GIM_Reject,
     /*  55145 */ // Label 1273: @55145
     /*  55145 */ GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(55303),
     /*  55150 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  55153 */   GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(55198), // Rule ID 1082 //
     /*  55158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /*  55161 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  55165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /*  55169 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55180 */     // (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD_Fp80m:{ *:[f80] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /*  55180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp80m),
     /*  55183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55185 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55189 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  55192 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55196 */     GIR_RootConstrainSelectedInstOperands,
     /*  55197 */     // GIR_Coverage, 1082,
     /*  55197 */     GIR_EraseRootFromParent_Done,
     /*  55198 */   // Label 1326: @55198
     /*  55198 */   GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(55250), // Rule ID 1084 //
     /*  55203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /*  55206 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  55210 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  55217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /*  55221 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55232 */     // (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>  =>  (LD_Fp64m80:{ *:[f80] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /*  55232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp64m80),
     /*  55235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55237 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55241 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  55244 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55248 */     GIR_RootConstrainSelectedInstOperands,
     /*  55249 */     // GIR_Coverage, 1084,
     /*  55249 */     GIR_EraseRootFromParent_Done,
     /*  55250 */   // Label 1327: @55250
     /*  55250 */   GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(55302), // Rule ID 1085 //
     /*  55255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /*  55258 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  55262 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  55269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /*  55273 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55284 */     // (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>  =>  (LD_Fp32m80:{ *:[f80] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /*  55284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp32m80),
     /*  55287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55289 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55293 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  55296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55300 */     GIR_RootConstrainSelectedInstOperands,
     /*  55301 */     // GIR_Coverage, 1085,
     /*  55301 */     GIR_EraseRootFromParent_Done,
     /*  55302 */   // Label 1328: @55302
     /*  55302 */   GIM_Reject,
     /*  55303 */ // Label 1325: @55303
     /*  55303 */ GIM_Reject,
     /*  55304 */ // Label 1274: @55304
     /*  55304 */ GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(55431),
     /*  55309 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  55312 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  55316 */   GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(55354), // Rule ID 23145 //
     /*  55321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoAVX),
     /*  55324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55328 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55339 */     // (ld:{ *:[f128] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVUPSrm:{ *:[f128] } addr:{ *:[iPTR] }:$src)
     /*  55339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSrm),
     /*  55342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55344 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55348 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55352 */     GIR_RootConstrainSelectedInstOperands,
     /*  55353 */     // GIR_Coverage, 23145,
     /*  55353 */     GIR_EraseRootFromParent_Done,
     /*  55354 */   // Label 1330: @55354
     /*  55354 */   GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(55392), // Rule ID 23149 //
     /*  55359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  55362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55366 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55377 */     // (ld:{ *:[f128] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSrm:{ *:[f128] } addr:{ *:[iPTR] }:$src)
     /*  55377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSrm),
     /*  55380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55382 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55386 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55390 */     GIR_RootConstrainSelectedInstOperands,
     /*  55391 */     // GIR_Coverage, 23149,
     /*  55391 */     GIR_EraseRootFromParent_Done,
     /*  55392 */   // Label 1331: @55392
     /*  55392 */   GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(55430), // Rule ID 23153 //
     /*  55397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  55400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  55404 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55415 */     // (ld:{ *:[f128] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSZ128rm:{ *:[f128] } addr:{ *:[iPTR] }:$src)
     /*  55415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ128rm),
     /*  55418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55420 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55424 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55428 */     GIR_RootConstrainSelectedInstOperands,
     /*  55429 */     // GIR_Coverage, 23153,
     /*  55429 */     GIR_EraseRootFromParent_Done,
     /*  55430 */   // Label 1332: @55430
     /*  55430 */   GIM_Reject,
     /*  55431 */ // Label 1329: @55431
     /*  55431 */ GIM_Reject,
     /*  55432 */ // Label 1275: @55432
     /*  55432 */ GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(55498), // Rule ID 19446 //
     /*  55437 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  55440 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  55443 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  55447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  55451 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55455 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55462 */   // (ld:{ *:[v2i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KMOVBkm:{ *:[v8i1] } addr:{ *:[iPTR] }:$src), VK2:{ *:[i32] })
     /*  55462 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s1,
     /*  55465 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KMOVBkm),
     /*  55469 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55474 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  55478 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55482 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  55484 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  55487 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55489 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  55492 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  55497 */   // GIR_Coverage, 19446,
     /*  55497 */   GIR_EraseRootFromParent_Done,
     /*  55498 */ // Label 1333: @55498
     /*  55498 */ GIM_Reject,
     /*  55499 */ // Label 1276: @55499
     /*  55499 */ GIM_Try, /*On fail goto*//*Label 1334*/ GIMT_Encode4(55992),
     /*  55504 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  55507 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  55511 */   GIM_Try, /*On fail goto*//*Label 1335*/ GIMT_Encode4(55553), // Rule ID 1704 //
     /*  55516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  55519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55523 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55527 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  55531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55538 */     // (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPDrm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /*  55538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDrm),
     /*  55541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55543 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55547 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55551 */     GIR_RootConstrainSelectedInstOperands,
     /*  55552 */     // GIR_Coverage, 1704,
     /*  55552 */     GIR_EraseRootFromParent_Done,
     /*  55553 */   // Label 1335: @55553
     /*  55553 */   GIM_Try, /*On fail goto*//*Label 1336*/ GIMT_Encode4(55591), // Rule ID 1706 //
     /*  55558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  55561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55565 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55576 */     // (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPDrm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /*  55576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDrm),
     /*  55579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55581 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55585 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55589 */     GIR_RootConstrainSelectedInstOperands,
     /*  55590 */     // GIR_Coverage, 1706,
     /*  55590 */     GIR_EraseRootFromParent_Done,
     /*  55591 */   // Label 1336: @55591
     /*  55591 */   GIM_Try, /*On fail goto*//*Label 1337*/ GIMT_Encode4(55633), // Rule ID 1713 //
     /*  55596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  55599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55603 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55607 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  55611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55618 */     // (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (MOVAPDrm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /*  55618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPDrm),
     /*  55621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55623 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55627 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55631 */     GIR_RootConstrainSelectedInstOperands,
     /*  55632 */     // GIR_Coverage, 1713,
     /*  55632 */     GIR_EraseRootFromParent_Done,
     /*  55633 */   // Label 1337: @55633
     /*  55633 */   GIM_Try, /*On fail goto*//*Label 1338*/ GIMT_Encode4(55671), // Rule ID 1714 //
     /*  55638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  55641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55645 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55656 */     // (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVUPDrm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /*  55656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPDrm),
     /*  55659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55661 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55665 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55669 */     GIR_RootConstrainSelectedInstOperands,
     /*  55670 */     // GIR_Coverage, 1714,
     /*  55670 */     GIR_EraseRootFromParent_Done,
     /*  55671 */   // Label 1338: @55671
     /*  55671 */   GIM_Try, /*On fail goto*//*Label 1339*/ GIMT_Encode4(55713), // Rule ID 2518 //
     /*  55676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  55679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55683 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55687 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  55691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55698 */     // (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQArm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  55698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQArm),
     /*  55701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55703 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55707 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55711 */     GIR_RootConstrainSelectedInstOperands,
     /*  55712 */     // GIR_Coverage, 2518,
     /*  55712 */     GIR_EraseRootFromParent_Done,
     /*  55713 */   // Label 1339: @55713
     /*  55713 */   GIM_Try, /*On fail goto*//*Label 1340*/ GIMT_Encode4(55751), // Rule ID 2519 //
     /*  55718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  55721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55725 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55736 */     // (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQUrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  55736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUrm),
     /*  55739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55741 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55745 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55749 */     GIR_RootConstrainSelectedInstOperands,
     /*  55750 */     // GIR_Coverage, 2519,
     /*  55750 */     GIR_EraseRootFromParent_Done,
     /*  55751 */   // Label 1340: @55751
     /*  55751 */   GIM_Try, /*On fail goto*//*Label 1341*/ GIMT_Encode4(55793), // Rule ID 4490 //
     /*  55756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  55759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  55763 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55767 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  55771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55778 */     // (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPDZ128rm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /*  55778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ128rm),
     /*  55781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55783 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55787 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55791 */     GIR_RootConstrainSelectedInstOperands,
     /*  55792 */     // GIR_Coverage, 4490,
     /*  55792 */     GIR_EraseRootFromParent_Done,
     /*  55793 */   // Label 1341: @55793
     /*  55793 */   GIM_Try, /*On fail goto*//*Label 1342*/ GIMT_Encode4(55831), // Rule ID 4515 //
     /*  55798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  55801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  55805 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55816 */     // (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPDZ128rm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /*  55816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDZ128rm),
     /*  55819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55821 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55825 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55829 */     GIR_RootConstrainSelectedInstOperands,
     /*  55830 */     // GIR_Coverage, 4515,
     /*  55830 */     GIR_EraseRootFromParent_Done,
     /*  55831 */   // Label 1342: @55831
     /*  55831 */   GIM_Try, /*On fail goto*//*Label 1343*/ GIMT_Encode4(55873), // Rule ID 4544 //
     /*  55836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  55839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  55843 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55847 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  55851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55858 */     // (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Z128rm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  55858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128rm),
     /*  55861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55863 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55867 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55871 */     GIR_RootConstrainSelectedInstOperands,
     /*  55872 */     // GIR_Coverage, 4544,
     /*  55872 */     GIR_EraseRootFromParent_Done,
     /*  55873 */   // Label 1343: @55873
     /*  55873 */   GIM_Try, /*On fail goto*//*Label 1344*/ GIMT_Encode4(55911), // Rule ID 4587 //
     /*  55878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  55881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  55885 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55896 */     // (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Z128rm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  55896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z128rm),
     /*  55899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55901 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55905 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55909 */     GIR_RootConstrainSelectedInstOperands,
     /*  55910 */     // GIR_Coverage, 4587,
     /*  55910 */     GIR_EraseRootFromParent_Done,
     /*  55911 */   // Label 1344: @55911
     /*  55911 */   GIM_Try, /*On fail goto*//*Label 1345*/ GIMT_Encode4(55953), // Rule ID 17939 //
     /*  55916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  55919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55923 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55927 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  55931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55938 */     // (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (MOVAPSrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  55938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSrm),
     /*  55941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55943 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55947 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55951 */     GIR_RootConstrainSelectedInstOperands,
     /*  55952 */     // GIR_Coverage, 17939,
     /*  55952 */     GIR_EraseRootFromParent_Done,
     /*  55953 */   // Label 1345: @55953
     /*  55953 */   GIM_Try, /*On fail goto*//*Label 1346*/ GIMT_Encode4(55991), // Rule ID 17943 //
     /*  55958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  55961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55965 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55976 */     // (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVUPSrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  55976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSrm),
     /*  55979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55981 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55985 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55989 */     GIR_RootConstrainSelectedInstOperands,
     /*  55990 */     // GIR_Coverage, 17943,
     /*  55990 */     GIR_EraseRootFromParent_Done,
     /*  55991 */   // Label 1346: @55991
     /*  55991 */   GIM_Reject,
     /*  55992 */ // Label 1334: @55992
     /*  55992 */ GIM_Reject,
     /*  55993 */ // Label 1277: @55993
     /*  55993 */ GIM_Try, /*On fail goto*//*Label 1347*/ GIMT_Encode4(56059), // Rule ID 19447 //
     /*  55998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  56001 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  56004 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  56008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  56012 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56016 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56023 */   // (ld:{ *:[v4i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KMOVBkm:{ *:[v8i1] } addr:{ *:[iPTR] }:$src), VK4:{ *:[i32] })
     /*  56023 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s1,
     /*  56026 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KMOVBkm),
     /*  56030 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56035 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  56039 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56043 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  56045 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  56048 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56050 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  56053 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  56058 */   // GIR_Coverage, 19447,
     /*  56058 */   GIR_EraseRootFromParent_Done,
     /*  56059 */ // Label 1347: @56059
     /*  56059 */ GIM_Reject,
     /*  56060 */ // Label 1278: @56060
     /*  56060 */ GIM_Try, /*On fail goto*//*Label 1348*/ GIMT_Encode4(56553),
     /*  56065 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  56068 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  56072 */   GIM_Try, /*On fail goto*//*Label 1349*/ GIMT_Encode4(56114), // Rule ID 1703 //
     /*  56077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  56080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56084 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56088 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56099 */     // (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /*  56099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSrm),
     /*  56102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56104 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56108 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56112 */     GIR_RootConstrainSelectedInstOperands,
     /*  56113 */     // GIR_Coverage, 1703,
     /*  56113 */     GIR_EraseRootFromParent_Done,
     /*  56114 */   // Label 1349: @56114
     /*  56114 */   GIM_Try, /*On fail goto*//*Label 1350*/ GIMT_Encode4(56152), // Rule ID 1705 //
     /*  56119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  56122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56126 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56137 */     // (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /*  56137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSrm),
     /*  56140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56142 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56146 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56150 */     GIR_RootConstrainSelectedInstOperands,
     /*  56151 */     // GIR_Coverage, 1705,
     /*  56151 */     GIR_EraseRootFromParent_Done,
     /*  56152 */   // Label 1350: @56152
     /*  56152 */   GIM_Try, /*On fail goto*//*Label 1351*/ GIMT_Encode4(56194), // Rule ID 1711 //
     /*  56157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  56160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56164 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56168 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56179 */     // (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (MOVAPSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /*  56179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSrm),
     /*  56182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56184 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56188 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56192 */     GIR_RootConstrainSelectedInstOperands,
     /*  56193 */     // GIR_Coverage, 1711,
     /*  56193 */     GIR_EraseRootFromParent_Done,
     /*  56194 */   // Label 1351: @56194
     /*  56194 */   GIM_Try, /*On fail goto*//*Label 1352*/ GIMT_Encode4(56232), // Rule ID 1712 //
     /*  56199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  56202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56206 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56217 */     // (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVUPSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /*  56217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSrm),
     /*  56220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56222 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56226 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56230 */     GIR_RootConstrainSelectedInstOperands,
     /*  56231 */     // GIR_Coverage, 1712,
     /*  56231 */     GIR_EraseRootFromParent_Done,
     /*  56232 */   // Label 1352: @56232
     /*  56232 */   GIM_Try, /*On fail goto*//*Label 1353*/ GIMT_Encode4(56274), // Rule ID 4472 //
     /*  56237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  56240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  56244 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56248 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56259 */     // (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSZ128rm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /*  56259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ128rm),
     /*  56262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56264 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56268 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56272 */     GIR_RootConstrainSelectedInstOperands,
     /*  56273 */     // GIR_Coverage, 4472,
     /*  56273 */     GIR_EraseRootFromParent_Done,
     /*  56274 */   // Label 1353: @56274
     /*  56274 */   GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(56312), // Rule ID 4503 //
     /*  56279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  56282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  56286 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56297 */     // (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSZ128rm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /*  56297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ128rm),
     /*  56300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56302 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56306 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56310 */     GIR_RootConstrainSelectedInstOperands,
     /*  56311 */     // GIR_Coverage, 4503,
     /*  56311 */     GIR_EraseRootFromParent_Done,
     /*  56312 */   // Label 1354: @56312
     /*  56312 */   GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(56354), // Rule ID 17940 //
     /*  56317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  56320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56324 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56328 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56339 */     // (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (MOVAPSrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  56339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSrm),
     /*  56342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56344 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56348 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56352 */     GIR_RootConstrainSelectedInstOperands,
     /*  56353 */     // GIR_Coverage, 17940,
     /*  56353 */     GIR_EraseRootFromParent_Done,
     /*  56354 */   // Label 1355: @56354
     /*  56354 */   GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(56392), // Rule ID 17944 //
     /*  56359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  56362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56366 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56377 */     // (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVUPSrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  56377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSrm),
     /*  56380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56382 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56386 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56390 */     GIR_RootConstrainSelectedInstOperands,
     /*  56391 */     // GIR_Coverage, 17944,
     /*  56391 */     GIR_EraseRootFromParent_Done,
     /*  56392 */   // Label 1356: @56392
     /*  56392 */   GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(56434), // Rule ID 18319 //
     /*  56397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  56400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56404 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56408 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56419 */     // (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQArm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  56419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQArm),
     /*  56422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56424 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56428 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56432 */     GIR_RootConstrainSelectedInstOperands,
     /*  56433 */     // GIR_Coverage, 18319,
     /*  56433 */     GIR_EraseRootFromParent_Done,
     /*  56434 */   // Label 1357: @56434
     /*  56434 */   GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(56472), // Rule ID 18323 //
     /*  56439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  56442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56446 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56457 */     // (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQUrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  56457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUrm),
     /*  56460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56462 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56466 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56470 */     GIR_RootConstrainSelectedInstOperands,
     /*  56471 */     // GIR_Coverage, 18323,
     /*  56471 */     GIR_EraseRootFromParent_Done,
     /*  56472 */   // Label 1358: @56472
     /*  56472 */   GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(56514), // Rule ID 19812 //
     /*  56477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  56480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  56484 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56488 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56499 */     // (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Z128rm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  56499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128rm),
     /*  56502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56504 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56508 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56512 */     GIR_RootConstrainSelectedInstOperands,
     /*  56513 */     // GIR_Coverage, 19812,
     /*  56513 */     GIR_EraseRootFromParent_Done,
     /*  56514 */   // Label 1359: @56514
     /*  56514 */   GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(56552), // Rule ID 19816 //
     /*  56519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  56522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  56526 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56537 */     // (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Z128rm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  56537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z128rm),
     /*  56540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56542 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56546 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56550 */     GIR_RootConstrainSelectedInstOperands,
     /*  56551 */     // GIR_Coverage, 19816,
     /*  56551 */     GIR_EraseRootFromParent_Done,
     /*  56552 */   // Label 1360: @56552
     /*  56552 */   GIM_Reject,
     /*  56553 */ // Label 1348: @56553
     /*  56553 */ GIM_Reject,
     /*  56554 */ // Label 1279: @56554
     /*  56554 */ GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(56887),
     /*  56559 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  56562 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  56566 */   GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(56608), // Rule ID 1708 //
     /*  56571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  56574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  56578 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56582 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56593 */     // (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPDYrm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /*  56593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDYrm),
     /*  56596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56598 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56602 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56606 */     GIR_RootConstrainSelectedInstOperands,
     /*  56607 */     // GIR_Coverage, 1708,
     /*  56607 */     GIR_EraseRootFromParent_Done,
     /*  56608 */   // Label 1362: @56608
     /*  56608 */   GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(56646), // Rule ID 1710 //
     /*  56613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  56616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  56620 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56631 */     // (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPDYrm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /*  56631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDYrm),
     /*  56634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56636 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56640 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56644 */     GIR_RootConstrainSelectedInstOperands,
     /*  56645 */     // GIR_Coverage, 1710,
     /*  56645 */     GIR_EraseRootFromParent_Done,
     /*  56646 */   // Label 1363: @56646
     /*  56646 */   GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(56688), // Rule ID 4485 //
     /*  56651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  56654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  56658 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56662 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56673 */     // (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPDZ256rm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /*  56673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ256rm),
     /*  56676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56678 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56682 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56686 */     GIR_RootConstrainSelectedInstOperands,
     /*  56687 */     // GIR_Coverage, 4485,
     /*  56687 */     GIR_EraseRootFromParent_Done,
     /*  56688 */   // Label 1364: @56688
     /*  56688 */   GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(56726), // Rule ID 4512 //
     /*  56693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  56696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  56700 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56711 */     // (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPDZ256rm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /*  56711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDZ256rm),
     /*  56714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56716 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56720 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56724 */     GIR_RootConstrainSelectedInstOperands,
     /*  56725 */     // GIR_Coverage, 4512,
     /*  56725 */     GIR_EraseRootFromParent_Done,
     /*  56726 */   // Label 1365: @56726
     /*  56726 */   GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(56768), // Rule ID 4539 //
     /*  56731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  56734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  56738 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56742 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56753 */     // (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Z256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /*  56753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256rm),
     /*  56756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56758 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56762 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56766 */     GIR_RootConstrainSelectedInstOperands,
     /*  56767 */     // GIR_Coverage, 4539,
     /*  56767 */     GIR_EraseRootFromParent_Done,
     /*  56768 */   // Label 1366: @56768
     /*  56768 */   GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(56806), // Rule ID 4584 //
     /*  56773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  56776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  56780 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56791 */     // (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Z256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /*  56791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z256rm),
     /*  56794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56796 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56800 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56804 */     GIR_RootConstrainSelectedInstOperands,
     /*  56805 */     // GIR_Coverage, 4584,
     /*  56805 */     GIR_EraseRootFromParent_Done,
     /*  56806 */   // Label 1367: @56806
     /*  56806 */   GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(56848), // Rule ID 17915 //
     /*  56811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  56814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  56818 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56822 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56833 */     // (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSYrm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /*  56833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYrm),
     /*  56836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56838 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56842 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56846 */     GIR_RootConstrainSelectedInstOperands,
     /*  56847 */     // GIR_Coverage, 17915,
     /*  56847 */     GIR_EraseRootFromParent_Done,
     /*  56848 */   // Label 1368: @56848
     /*  56848 */   GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(56886), // Rule ID 17919 //
     /*  56853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  56856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  56860 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56871 */     // (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSYrm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /*  56871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYrm),
     /*  56874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56876 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56880 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56884 */     GIR_RootConstrainSelectedInstOperands,
     /*  56885 */     // GIR_Coverage, 17919,
     /*  56885 */     GIR_EraseRootFromParent_Done,
     /*  56886 */   // Label 1369: @56886
     /*  56886 */   GIM_Reject,
     /*  56887 */ // Label 1361: @56887
     /*  56887 */ GIM_Reject,
     /*  56888 */ // Label 1280: @56888
     /*  56888 */ GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(56969),
     /*  56893 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  56896 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  56900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  56904 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56908 */   GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(56938), // Rule ID 4395 //
     /*  56913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_NoEGPR),
     /*  56916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56923 */     // (ld:{ *:[v8i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (KMOVBkm:{ *:[v8i1] } addr:{ *:[iPTR] }:$src)
     /*  56923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVBkm),
     /*  56926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56928 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56932 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56936 */     GIR_RootConstrainSelectedInstOperands,
     /*  56937 */     // GIR_Coverage, 4395,
     /*  56937 */     GIR_EraseRootFromParent_Done,
     /*  56938 */   // Label 1371: @56938
     /*  56938 */   GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(56968), // Rule ID 4397 //
     /*  56943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEGPR_In64BitMode),
     /*  56946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56953 */     // (ld:{ *:[v8i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (KMOVBkm_EVEX:{ *:[v8i1] } addr:{ *:[iPTR] }:$src)
     /*  56953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVBkm_EVEX),
     /*  56956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56958 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56962 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56966 */     GIR_RootConstrainSelectedInstOperands,
     /*  56967 */     // GIR_Coverage, 4397,
     /*  56967 */     GIR_EraseRootFromParent_Done,
     /*  56968 */   // Label 1372: @56968
     /*  56968 */   GIM_Reject,
     /*  56969 */ // Label 1370: @56969
     /*  56969 */ GIM_Reject,
     /*  56970 */ // Label 1281: @56970
     /*  56970 */ GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(57543),
     /*  56975 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  56978 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  56982 */   GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(57024), // Rule ID 17931 //
     /*  56987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  56990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56994 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56998 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57009 */     // (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSrm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /*  57009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSrm),
     /*  57012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57014 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57018 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57022 */     GIR_RootConstrainSelectedInstOperands,
     /*  57023 */     // GIR_Coverage, 17931,
     /*  57023 */     GIR_EraseRootFromParent_Done,
     /*  57024 */   // Label 1374: @57024
     /*  57024 */   GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(57062), // Rule ID 17932 //
     /*  57029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  57032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  57036 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57047 */     // (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSrm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /*  57047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSrm),
     /*  57050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57052 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57056 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57060 */     GIR_RootConstrainSelectedInstOperands,
     /*  57061 */     // GIR_Coverage, 17932,
     /*  57061 */     GIR_EraseRootFromParent_Done,
     /*  57062 */   // Label 1375: @57062
     /*  57062 */   GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(57104), // Rule ID 17941 //
     /*  57067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  57070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  57074 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57078 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57089 */     // (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (MOVAPSrm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  57089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSrm),
     /*  57092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57094 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57098 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57102 */     GIR_RootConstrainSelectedInstOperands,
     /*  57103 */     // GIR_Coverage, 17941,
     /*  57103 */     GIR_EraseRootFromParent_Done,
     /*  57104 */   // Label 1376: @57104
     /*  57104 */   GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(57142), // Rule ID 17945 //
     /*  57109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  57112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  57116 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57127 */     // (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVUPSrm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  57127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSrm),
     /*  57130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57132 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57136 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57140 */     GIR_RootConstrainSelectedInstOperands,
     /*  57141 */     // GIR_Coverage, 17945,
     /*  57141 */     GIR_EraseRootFromParent_Done,
     /*  57142 */   // Label 1377: @57142
     /*  57142 */   GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(57184), // Rule ID 17955 //
     /*  57147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  57150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  57154 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57158 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57169 */     // (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (MOVAPSrm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /*  57169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSrm),
     /*  57172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57174 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57178 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57182 */     GIR_RootConstrainSelectedInstOperands,
     /*  57183 */     // GIR_Coverage, 17955,
     /*  57183 */     GIR_EraseRootFromParent_Done,
     /*  57184 */   // Label 1378: @57184
     /*  57184 */   GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(57222), // Rule ID 17956 //
     /*  57189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  57192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  57196 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57207 */     // (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVUPSrm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /*  57207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSrm),
     /*  57210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57212 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57216 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57220 */     GIR_RootConstrainSelectedInstOperands,
     /*  57221 */     // GIR_Coverage, 17956,
     /*  57221 */     GIR_EraseRootFromParent_Done,
     /*  57222 */   // Label 1379: @57222
     /*  57222 */   GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(57264), // Rule ID 18320 //
     /*  57227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  57230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  57234 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57238 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57249 */     // (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQArm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  57249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQArm),
     /*  57252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57254 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57258 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57262 */     GIR_RootConstrainSelectedInstOperands,
     /*  57263 */     // GIR_Coverage, 18320,
     /*  57263 */     GIR_EraseRootFromParent_Done,
     /*  57264 */   // Label 1380: @57264
     /*  57264 */   GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(57306), // Rule ID 18321 //
     /*  57269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  57272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  57276 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57280 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57291 */     // (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQArm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /*  57291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQArm),
     /*  57294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57296 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57300 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57304 */     GIR_RootConstrainSelectedInstOperands,
     /*  57305 */     // GIR_Coverage, 18321,
     /*  57305 */     GIR_EraseRootFromParent_Done,
     /*  57306 */   // Label 1381: @57306
     /*  57306 */   GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(57344), // Rule ID 18324 //
     /*  57311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  57314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  57318 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57329 */     // (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQUrm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  57329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUrm),
     /*  57332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57334 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57338 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57342 */     GIR_RootConstrainSelectedInstOperands,
     /*  57343 */     // GIR_Coverage, 18324,
     /*  57343 */     GIR_EraseRootFromParent_Done,
     /*  57344 */   // Label 1382: @57344
     /*  57344 */   GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(57382), // Rule ID 18325 //
     /*  57349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  57352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  57356 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57367 */     // (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQUrm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /*  57367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUrm),
     /*  57370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57372 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57376 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57380 */     GIR_RootConstrainSelectedInstOperands,
     /*  57381 */     // GIR_Coverage, 18325,
     /*  57381 */     GIR_EraseRootFromParent_Done,
     /*  57382 */   // Label 1383: @57382
     /*  57382 */   GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(57424), // Rule ID 19813 //
     /*  57387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  57390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  57394 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57398 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57409 */     // (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Z128rm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  57409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128rm),
     /*  57412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57414 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57418 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57422 */     GIR_RootConstrainSelectedInstOperands,
     /*  57423 */     // GIR_Coverage, 19813,
     /*  57423 */     GIR_EraseRootFromParent_Done,
     /*  57424 */   // Label 1384: @57424
     /*  57424 */   GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(57466), // Rule ID 19814 //
     /*  57429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  57432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  57436 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57440 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57451 */     // (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSZ128rm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /*  57451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ128rm),
     /*  57454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57456 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57460 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57464 */     GIR_RootConstrainSelectedInstOperands,
     /*  57465 */     // GIR_Coverage, 19814,
     /*  57465 */     GIR_EraseRootFromParent_Done,
     /*  57466 */   // Label 1385: @57466
     /*  57466 */   GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(57504), // Rule ID 19817 //
     /*  57471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  57474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  57478 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57489 */     // (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Z128rm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  57489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z128rm),
     /*  57492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57494 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57498 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57502 */     GIR_RootConstrainSelectedInstOperands,
     /*  57503 */     // GIR_Coverage, 19817,
     /*  57503 */     GIR_EraseRootFromParent_Done,
     /*  57504 */   // Label 1386: @57504
     /*  57504 */   GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(57542), // Rule ID 19818 //
     /*  57509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  57512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  57516 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57527 */     // (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSZ128rm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /*  57527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ128rm),
     /*  57530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57532 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57536 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57540 */     GIR_RootConstrainSelectedInstOperands,
     /*  57541 */     // GIR_Coverage, 19818,
     /*  57541 */     GIR_EraseRootFromParent_Done,
     /*  57542 */   // Label 1387: @57542
     /*  57542 */   GIM_Reject,
     /*  57543 */ // Label 1373: @57543
     /*  57543 */ GIM_Reject,
     /*  57544 */ // Label 1282: @57544
     /*  57544 */ GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(57877),
     /*  57549 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  57552 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  57556 */   GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(57598), // Rule ID 1707 //
     /*  57561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  57564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  57568 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57572 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57583 */     // (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /*  57583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYrm),
     /*  57586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57588 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57592 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57596 */     GIR_RootConstrainSelectedInstOperands,
     /*  57597 */     // GIR_Coverage, 1707,
     /*  57597 */     GIR_EraseRootFromParent_Done,
     /*  57598 */   // Label 1389: @57598
     /*  57598 */   GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(57636), // Rule ID 1709 //
     /*  57603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  57606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  57610 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57621 */     // (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /*  57621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYrm),
     /*  57624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57626 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57630 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57634 */     GIR_RootConstrainSelectedInstOperands,
     /*  57635 */     // GIR_Coverage, 1709,
     /*  57635 */     GIR_EraseRootFromParent_Done,
     /*  57636 */   // Label 1390: @57636
     /*  57636 */   GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(57678), // Rule ID 4467 //
     /*  57641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  57644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  57648 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57652 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57663 */     // (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSZ256rm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /*  57663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ256rm),
     /*  57666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57668 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57672 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57676 */     GIR_RootConstrainSelectedInstOperands,
     /*  57677 */     // GIR_Coverage, 4467,
     /*  57677 */     GIR_EraseRootFromParent_Done,
     /*  57678 */   // Label 1391: @57678
     /*  57678 */   GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(57716), // Rule ID 4500 //
     /*  57683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  57686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  57690 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57701 */     // (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSZ256rm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /*  57701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ256rm),
     /*  57704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57706 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57710 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57714 */     GIR_RootConstrainSelectedInstOperands,
     /*  57715 */     // GIR_Coverage, 4500,
     /*  57715 */     GIR_EraseRootFromParent_Done,
     /*  57716 */   // Label 1392: @57716
     /*  57716 */   GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(57758), // Rule ID 17916 //
     /*  57721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  57724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  57728 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57732 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57743 */     // (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSYrm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /*  57743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYrm),
     /*  57746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57748 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57752 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57756 */     GIR_RootConstrainSelectedInstOperands,
     /*  57757 */     // GIR_Coverage, 17916,
     /*  57757 */     GIR_EraseRootFromParent_Done,
     /*  57758 */   // Label 1393: @57758
     /*  57758 */   GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(57796), // Rule ID 17920 //
     /*  57763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  57766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  57770 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57781 */     // (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSYrm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /*  57781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYrm),
     /*  57784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57786 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57790 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57794 */     GIR_RootConstrainSelectedInstOperands,
     /*  57795 */     // GIR_Coverage, 17920,
     /*  57795 */     GIR_EraseRootFromParent_Done,
     /*  57796 */   // Label 1394: @57796
     /*  57796 */   GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(57838), // Rule ID 19828 //
     /*  57801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  57804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  57808 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57812 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57823 */     // (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Z256rm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /*  57823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256rm),
     /*  57826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57828 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57832 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57836 */     GIR_RootConstrainSelectedInstOperands,
     /*  57837 */     // GIR_Coverage, 19828,
     /*  57837 */     GIR_EraseRootFromParent_Done,
     /*  57838 */   // Label 1395: @57838
     /*  57838 */   GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(57876), // Rule ID 19832 //
     /*  57843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  57846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  57850 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57861 */     // (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Z256rm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /*  57861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z256rm),
     /*  57864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57866 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57870 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57874 */     GIR_RootConstrainSelectedInstOperands,
     /*  57875 */     // GIR_Coverage, 19832,
     /*  57875 */     GIR_EraseRootFromParent_Done,
     /*  57876 */   // Label 1396: @57876
     /*  57876 */   GIM_Reject,
     /*  57877 */ // Label 1388: @57877
     /*  57877 */ GIM_Reject,
     /*  57878 */ // Label 1283: @57878
     /*  57878 */ GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(58051),
     /*  57883 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  57886 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  57890 */   GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(57932), // Rule ID 4480 //
     /*  57895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  57898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  57902 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57906 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57917 */     // (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPDZrm:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)
     /*  57917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZrm),
     /*  57920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57922 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57926 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57930 */     GIR_RootConstrainSelectedInstOperands,
     /*  57931 */     // GIR_Coverage, 4480,
     /*  57931 */     GIR_EraseRootFromParent_Done,
     /*  57932 */   // Label 1398: @57932
     /*  57932 */   GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(57970), // Rule ID 4509 //
     /*  57937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  57940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  57944 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57955 */     // (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPDZrm:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)
     /*  57955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDZrm),
     /*  57958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57960 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57964 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57968 */     GIR_RootConstrainSelectedInstOperands,
     /*  57969 */     // GIR_Coverage, 4509,
     /*  57969 */     GIR_EraseRootFromParent_Done,
     /*  57970 */   // Label 1399: @57970
     /*  57970 */   GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(58012), // Rule ID 4534 //
     /*  57975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  57978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  57982 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57986 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57997 */     // (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Zrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /*  57997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrm),
     /*  58000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58002 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58006 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58010 */     GIR_RootConstrainSelectedInstOperands,
     /*  58011 */     // GIR_Coverage, 4534,
     /*  58011 */     GIR_EraseRootFromParent_Done,
     /*  58012 */   // Label 1400: @58012
     /*  58012 */   GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(58050), // Rule ID 4581 //
     /*  58017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  58020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  58024 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58035 */     // (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Zrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /*  58035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Zrm),
     /*  58038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58040 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58044 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58048 */     GIR_RootConstrainSelectedInstOperands,
     /*  58049 */     // GIR_Coverage, 4581,
     /*  58049 */     GIR_EraseRootFromParent_Done,
     /*  58050 */   // Label 1401: @58050
     /*  58050 */   GIM_Reject,
     /*  58051 */ // Label 1397: @58051
     /*  58051 */ GIM_Reject,
     /*  58052 */ // Label 1284: @58052
     /*  58052 */ GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(58133),
     /*  58057 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  58060 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  58064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  58068 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58072 */   GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(58102), // Rule ID 4399 //
     /*  58077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_NoEGPR),
     /*  58080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58087 */     // (ld:{ *:[v16i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (KMOVWkm:{ *:[v16i1] } addr:{ *:[iPTR] }:$src)
     /*  58087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVWkm),
     /*  58090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58092 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58096 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58100 */     GIR_RootConstrainSelectedInstOperands,
     /*  58101 */     // GIR_Coverage, 4399,
     /*  58101 */     GIR_EraseRootFromParent_Done,
     /*  58102 */   // Label 1403: @58102
     /*  58102 */   GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(58132), // Rule ID 4401 //
     /*  58107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEGPR_In64BitMode),
     /*  58110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58117 */     // (ld:{ *:[v16i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (KMOVWkm_EVEX:{ *:[v16i1] } addr:{ *:[iPTR] }:$src)
     /*  58117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVWkm_EVEX),
     /*  58120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58122 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58126 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58130 */     GIR_RootConstrainSelectedInstOperands,
     /*  58131 */     // GIR_Coverage, 4401,
     /*  58131 */     GIR_EraseRootFromParent_Done,
     /*  58132 */   // Label 1404: @58132
     /*  58132 */   GIM_Reject,
     /*  58133 */ // Label 1402: @58133
     /*  58133 */ GIM_Reject,
     /*  58134 */ // Label 1285: @58134
     /*  58134 */ GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(58387),
     /*  58139 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  58142 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  58146 */   GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(58188), // Rule ID 17942 //
     /*  58151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  58154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  58158 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58162 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58173 */     // (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (MOVAPSrm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /*  58173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSrm),
     /*  58176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58178 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58182 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58186 */     GIR_RootConstrainSelectedInstOperands,
     /*  58187 */     // GIR_Coverage, 17942,
     /*  58187 */     GIR_EraseRootFromParent_Done,
     /*  58188 */   // Label 1406: @58188
     /*  58188 */   GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(58226), // Rule ID 17946 //
     /*  58193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  58196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  58200 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58211 */     // (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVUPSrm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /*  58211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSrm),
     /*  58214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58216 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58220 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58224 */     GIR_RootConstrainSelectedInstOperands,
     /*  58225 */     // GIR_Coverage, 17946,
     /*  58225 */     GIR_EraseRootFromParent_Done,
     /*  58226 */   // Label 1407: @58226
     /*  58226 */   GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(58268), // Rule ID 18322 //
     /*  58231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  58234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  58238 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58242 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58253 */     // (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQArm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /*  58253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQArm),
     /*  58256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58258 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58262 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58266 */     GIR_RootConstrainSelectedInstOperands,
     /*  58267 */     // GIR_Coverage, 18322,
     /*  58267 */     GIR_EraseRootFromParent_Done,
     /*  58268 */   // Label 1408: @58268
     /*  58268 */   GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(58306), // Rule ID 18326 //
     /*  58273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  58276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  58280 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58291 */     // (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQUrm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /*  58291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUrm),
     /*  58294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58296 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58300 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58304 */     GIR_RootConstrainSelectedInstOperands,
     /*  58305 */     // GIR_Coverage, 18326,
     /*  58305 */     GIR_EraseRootFromParent_Done,
     /*  58306 */   // Label 1409: @58306
     /*  58306 */   GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(58348), // Rule ID 19815 //
     /*  58311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  58314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  58318 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58322 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58333 */     // (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Z128rm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /*  58333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128rm),
     /*  58336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58338 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58342 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58346 */     GIR_RootConstrainSelectedInstOperands,
     /*  58347 */     // GIR_Coverage, 19815,
     /*  58347 */     GIR_EraseRootFromParent_Done,
     /*  58348 */   // Label 1410: @58348
     /*  58348 */   GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(58386), // Rule ID 19819 //
     /*  58353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  58356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  58360 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58371 */     // (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Z128rm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /*  58371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z128rm),
     /*  58374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58376 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58380 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58384 */     GIR_RootConstrainSelectedInstOperands,
     /*  58385 */     // GIR_Coverage, 19819,
     /*  58385 */     GIR_EraseRootFromParent_Done,
     /*  58386 */   // Label 1411: @58386
     /*  58386 */   GIM_Reject,
     /*  58387 */ // Label 1405: @58387
     /*  58387 */ GIM_Reject,
     /*  58388 */ // Label 1286: @58388
     /*  58388 */ GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(58721),
     /*  58393 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  58396 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  58400 */   GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(58442), // Rule ID 17917 //
     /*  58405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  58408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  58412 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58416 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58427 */     // (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSYrm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /*  58427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYrm),
     /*  58430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58432 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58436 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58440 */     GIR_RootConstrainSelectedInstOperands,
     /*  58441 */     // GIR_Coverage, 17917,
     /*  58441 */     GIR_EraseRootFromParent_Done,
     /*  58442 */   // Label 1413: @58442
     /*  58442 */   GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(58480), // Rule ID 17921 //
     /*  58447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  58450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  58454 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58465 */     // (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSYrm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /*  58465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYrm),
     /*  58468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58470 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58474 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58478 */     GIR_RootConstrainSelectedInstOperands,
     /*  58479 */     // GIR_Coverage, 17921,
     /*  58479 */     GIR_EraseRootFromParent_Done,
     /*  58480 */   // Label 1414: @58480
     /*  58480 */   GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(58522), // Rule ID 17935 //
     /*  58485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  58488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  58492 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58496 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58507 */     // (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSYrm:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /*  58507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYrm),
     /*  58510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58512 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58516 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58520 */     GIR_RootConstrainSelectedInstOperands,
     /*  58521 */     // GIR_Coverage, 17935,
     /*  58521 */     GIR_EraseRootFromParent_Done,
     /*  58522 */   // Label 1415: @58522
     /*  58522 */   GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(58560), // Rule ID 17936 //
     /*  58527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  58530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  58534 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58545 */     // (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSYrm:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /*  58545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYrm),
     /*  58548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58550 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58554 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58558 */     GIR_RootConstrainSelectedInstOperands,
     /*  58559 */     // GIR_Coverage, 17936,
     /*  58559 */     GIR_EraseRootFromParent_Done,
     /*  58560 */   // Label 1416: @58560
     /*  58560 */   GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(58602), // Rule ID 19829 //
     /*  58565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  58568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  58572 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58576 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58587 */     // (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Z256rm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /*  58587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256rm),
     /*  58590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58592 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58596 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58600 */     GIR_RootConstrainSelectedInstOperands,
     /*  58601 */     // GIR_Coverage, 19829,
     /*  58601 */     GIR_EraseRootFromParent_Done,
     /*  58602 */   // Label 1417: @58602
     /*  58602 */   GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(58644), // Rule ID 19830 //
     /*  58607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  58610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  58614 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58618 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58629 */     // (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSZ256rm:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /*  58629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ256rm),
     /*  58632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58634 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58638 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58642 */     GIR_RootConstrainSelectedInstOperands,
     /*  58643 */     // GIR_Coverage, 19830,
     /*  58643 */     GIR_EraseRootFromParent_Done,
     /*  58644 */   // Label 1418: @58644
     /*  58644 */   GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(58682), // Rule ID 19833 //
     /*  58649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  58652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  58656 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58667 */     // (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Z256rm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /*  58667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z256rm),
     /*  58670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58672 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58676 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58680 */     GIR_RootConstrainSelectedInstOperands,
     /*  58681 */     // GIR_Coverage, 19833,
     /*  58681 */     GIR_EraseRootFromParent_Done,
     /*  58682 */   // Label 1419: @58682
     /*  58682 */   GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(58720), // Rule ID 19834 //
     /*  58687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  58690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  58694 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58705 */     // (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSZ256rm:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /*  58705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ256rm),
     /*  58708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58710 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58714 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58718 */     GIR_RootConstrainSelectedInstOperands,
     /*  58719 */     // GIR_Coverage, 19834,
     /*  58719 */     GIR_EraseRootFromParent_Done,
     /*  58720 */   // Label 1420: @58720
     /*  58720 */   GIM_Reject,
     /*  58721 */ // Label 1412: @58721
     /*  58721 */ GIM_Reject,
     /*  58722 */ // Label 1287: @58722
     /*  58722 */ GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(58895),
     /*  58727 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  58730 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  58734 */   GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(58776), // Rule ID 4462 //
     /*  58739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  58742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  58746 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58750 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58761 */     // (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSZrm:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)
     /*  58761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrm),
     /*  58764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58766 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58770 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58774 */     GIR_RootConstrainSelectedInstOperands,
     /*  58775 */     // GIR_Coverage, 4462,
     /*  58775 */     GIR_EraseRootFromParent_Done,
     /*  58776 */   // Label 1422: @58776
     /*  58776 */   GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(58814), // Rule ID 4497 //
     /*  58781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  58784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  58788 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58799 */     // (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSZrm:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)
     /*  58799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZrm),
     /*  58802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58804 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58808 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58812 */     GIR_RootConstrainSelectedInstOperands,
     /*  58813 */     // GIR_Coverage, 4497,
     /*  58813 */     GIR_EraseRootFromParent_Done,
     /*  58814 */   // Label 1423: @58814
     /*  58814 */   GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(58856), // Rule ID 19796 //
     /*  58819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  58822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  58826 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58830 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58841 */     // (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Zrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)
     /*  58841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrm),
     /*  58844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58846 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58850 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58854 */     GIR_RootConstrainSelectedInstOperands,
     /*  58855 */     // GIR_Coverage, 19796,
     /*  58855 */     GIR_EraseRootFromParent_Done,
     /*  58856 */   // Label 1424: @58856
     /*  58856 */   GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(58894), // Rule ID 19800 //
     /*  58861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  58864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  58868 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58879 */     // (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Zrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)
     /*  58879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Zrm),
     /*  58882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58884 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58888 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58892 */     GIR_RootConstrainSelectedInstOperands,
     /*  58893 */     // GIR_Coverage, 19800,
     /*  58893 */     GIR_EraseRootFromParent_Done,
     /*  58894 */   // Label 1425: @58894
     /*  58894 */   GIM_Reject,
     /*  58895 */ // Label 1421: @58895
     /*  58895 */ GIM_Reject,
     /*  58896 */ // Label 1288: @58896
     /*  58896 */ GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(58977),
     /*  58901 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  58904 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  58908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  58912 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58916 */   GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(58946), // Rule ID 4403 //
     /*  58921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_NoEGPR),
     /*  58924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58931 */     // (ld:{ *:[v32i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (KMOVDkm:{ *:[v32i1] } addr:{ *:[iPTR] }:$src)
     /*  58931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVDkm),
     /*  58934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58936 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58940 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58944 */     GIR_RootConstrainSelectedInstOperands,
     /*  58945 */     // GIR_Coverage, 4403,
     /*  58945 */     GIR_EraseRootFromParent_Done,
     /*  58946 */   // Label 1427: @58946
     /*  58946 */   GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(58976), // Rule ID 4407 //
     /*  58951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEGPR_In64BitMode),
     /*  58954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58961 */     // (ld:{ *:[v32i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (KMOVDkm_EVEX:{ *:[v32i1] } addr:{ *:[iPTR] }:$src)
     /*  58961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVDkm_EVEX),
     /*  58964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58966 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58970 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58974 */     GIR_RootConstrainSelectedInstOperands,
     /*  58975 */     // GIR_Coverage, 4407,
     /*  58975 */     GIR_EraseRootFromParent_Done,
     /*  58976 */   // Label 1428: @58976
     /*  58976 */   GIM_Reject,
     /*  58977 */ // Label 1426: @58977
     /*  58977 */ GIM_Reject,
     /*  58978 */ // Label 1289: @58978
     /*  58978 */ GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(59151),
     /*  58983 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  58986 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  58990 */   GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(59032), // Rule ID 17918 //
     /*  58995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  58998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  59002 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59006 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  59010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59017 */     // (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSYrm:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)
     /*  59017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYrm),
     /*  59020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59022 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59026 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59030 */     GIR_RootConstrainSelectedInstOperands,
     /*  59031 */     // GIR_Coverage, 17918,
     /*  59031 */     GIR_EraseRootFromParent_Done,
     /*  59032 */   // Label 1430: @59032
     /*  59032 */   GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(59070), // Rule ID 17922 //
     /*  59037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  59040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  59044 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59055 */     // (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSYrm:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)
     /*  59055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYrm),
     /*  59058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59060 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59064 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59068 */     GIR_RootConstrainSelectedInstOperands,
     /*  59069 */     // GIR_Coverage, 17922,
     /*  59069 */     GIR_EraseRootFromParent_Done,
     /*  59070 */   // Label 1431: @59070
     /*  59070 */   GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(59112), // Rule ID 19831 //
     /*  59075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  59078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  59082 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59086 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  59090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59097 */     // (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Z256rm:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)
     /*  59097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256rm),
     /*  59100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59102 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59106 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59110 */     GIR_RootConstrainSelectedInstOperands,
     /*  59111 */     // GIR_Coverage, 19831,
     /*  59111 */     GIR_EraseRootFromParent_Done,
     /*  59112 */   // Label 1432: @59112
     /*  59112 */   GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(59150), // Rule ID 19835 //
     /*  59117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  59120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  59124 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59135 */     // (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Z256rm:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)
     /*  59135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z256rm),
     /*  59138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59140 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59144 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59148 */     GIR_RootConstrainSelectedInstOperands,
     /*  59149 */     // GIR_Coverage, 19835,
     /*  59149 */     GIR_EraseRootFromParent_Done,
     /*  59150 */   // Label 1433: @59150
     /*  59150 */   GIM_Reject,
     /*  59151 */ // Label 1429: @59151
     /*  59151 */ GIM_Reject,
     /*  59152 */ // Label 1290: @59152
     /*  59152 */ GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(59325),
     /*  59157 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  59160 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  59164 */   GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(59206), // Rule ID 19797 //
     /*  59169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  59172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  59176 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59180 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  59184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59191 */     // (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Zrm:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)
     /*  59191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrm),
     /*  59194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59196 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59200 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59204 */     GIR_RootConstrainSelectedInstOperands,
     /*  59205 */     // GIR_Coverage, 19797,
     /*  59205 */     GIR_EraseRootFromParent_Done,
     /*  59206 */   // Label 1435: @59206
     /*  59206 */   GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(59248), // Rule ID 19798 //
     /*  59211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  59214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  59218 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59222 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  59226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59233 */     // (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSZrm:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)
     /*  59233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrm),
     /*  59236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59238 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59242 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59246 */     GIR_RootConstrainSelectedInstOperands,
     /*  59247 */     // GIR_Coverage, 19798,
     /*  59247 */     GIR_EraseRootFromParent_Done,
     /*  59248 */   // Label 1436: @59248
     /*  59248 */   GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(59286), // Rule ID 19801 //
     /*  59253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  59256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  59260 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59271 */     // (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Zrm:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)
     /*  59271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Zrm),
     /*  59274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59276 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59280 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59284 */     GIR_RootConstrainSelectedInstOperands,
     /*  59285 */     // GIR_Coverage, 19801,
     /*  59285 */     GIR_EraseRootFromParent_Done,
     /*  59286 */   // Label 1437: @59286
     /*  59286 */   GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(59324), // Rule ID 19802 //
     /*  59291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  59294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  59298 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59309 */     // (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSZrm:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)
     /*  59309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZrm),
     /*  59312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59314 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59318 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59322 */     GIR_RootConstrainSelectedInstOperands,
     /*  59323 */     // GIR_Coverage, 19802,
     /*  59323 */     GIR_EraseRootFromParent_Done,
     /*  59324 */   // Label 1438: @59324
     /*  59324 */   GIM_Reject,
     /*  59325 */ // Label 1434: @59325
     /*  59325 */ GIM_Reject,
     /*  59326 */ // Label 1291: @59326
     /*  59326 */ GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(59407),
     /*  59331 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  59334 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  59338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  59342 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59346 */   GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(59376), // Rule ID 4405 //
     /*  59351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_NoEGPR),
     /*  59354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59361 */     // (ld:{ *:[v64i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (KMOVQkm:{ *:[v64i1] } addr:{ *:[iPTR] }:$src)
     /*  59361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVQkm),
     /*  59364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59366 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59370 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59374 */     GIR_RootConstrainSelectedInstOperands,
     /*  59375 */     // GIR_Coverage, 4405,
     /*  59375 */     GIR_EraseRootFromParent_Done,
     /*  59376 */   // Label 1440: @59376
     /*  59376 */   GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(59406), // Rule ID 4409 //
     /*  59381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEGPR_In64BitMode),
     /*  59384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59391 */     // (ld:{ *:[v64i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (KMOVQkm_EVEX:{ *:[v64i1] } addr:{ *:[iPTR] }:$src)
     /*  59391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVQkm_EVEX),
     /*  59394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59396 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59400 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59404 */     GIR_RootConstrainSelectedInstOperands,
     /*  59405 */     // GIR_Coverage, 4409,
     /*  59405 */     GIR_EraseRootFromParent_Done,
     /*  59406 */   // Label 1441: @59406
     /*  59406 */   GIM_Reject,
     /*  59407 */ // Label 1439: @59407
     /*  59407 */ GIM_Reject,
     /*  59408 */ // Label 1292: @59408
     /*  59408 */ GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(59501),
     /*  59413 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  59416 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  59420 */   GIM_Try, /*On fail goto*//*Label 1443*/ GIMT_Encode4(59462), // Rule ID 19799 //
     /*  59425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  59428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  59432 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59436 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  59440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59447 */     // (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Zrm:{ *:[v64i8] } addr:{ *:[iPTR] }:$src)
     /*  59447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrm),
     /*  59450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59452 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59456 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59460 */     GIR_RootConstrainSelectedInstOperands,
     /*  59461 */     // GIR_Coverage, 19799,
     /*  59461 */     GIR_EraseRootFromParent_Done,
     /*  59462 */   // Label 1443: @59462
     /*  59462 */   GIM_Try, /*On fail goto*//*Label 1444*/ GIMT_Encode4(59500), // Rule ID 19803 //
     /*  59467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  59470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  59474 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59485 */     // (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Zrm:{ *:[v64i8] } addr:{ *:[iPTR] }:$src)
     /*  59485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Zrm),
     /*  59488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59490 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59494 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59498 */     GIR_RootConstrainSelectedInstOperands,
     /*  59499 */     // GIR_Coverage, 19803,
     /*  59499 */     GIR_EraseRootFromParent_Done,
     /*  59500 */   // Label 1444: @59500
     /*  59500 */   GIM_Reject,
     /*  59501 */ // Label 1442: @59501
     /*  59501 */ GIM_Reject,
     /*  59502 */ // Label 1293: @59502
     /*  59502 */ GIM_Reject,
     /*  59503 */ // Label 11: @59503
     /*  59503 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 1448*/ GIMT_Encode4(59835),
     /*  59514 */ /*GILLT_s16*//*Label 1445*/ GIMT_Encode4(59526),
     /*  59518 */ /*GILLT_s32*//*Label 1446*/ GIMT_Encode4(59602),
     /*  59522 */ /*GILLT_s64*//*Label 1447*/ GIMT_Encode4(59696),
     /*  59526 */ // Label 1445: @59526
     /*  59526 */ GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(59601), // Rule ID 22648 //
     /*  59531 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  59534 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  59541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  59545 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59549 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59556 */   // (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVSX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_16bit:{ *:[i32] })
     /*  59556 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  59559 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVSX32rm8),
     /*  59563 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59568 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  59572 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59576 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  59578 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59581 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59583 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  59590 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  59595 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  59600 */   // GIR_Coverage, 22648,
     /*  59600 */   GIR_EraseRootFromParent_Done,
     /*  59601 */ // Label 1449: @59601
     /*  59601 */ GIM_Reject,
     /*  59602 */ // Label 1446: @59602
     /*  59602 */ GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(59695),
     /*  59607 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  59610 */   GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(59652), // Rule ID 615 //
     /*  59615 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  59622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  59626 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59637 */     // (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (MOVSX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  59637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSX32rm8),
     /*  59640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59642 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59646 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59650 */     GIR_RootConstrainSelectedInstOperands,
     /*  59651 */     // GIR_Coverage, 615,
     /*  59651 */     GIR_EraseRootFromParent_Done,
     /*  59652 */   // Label 1451: @59652
     /*  59652 */   GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(59694), // Rule ID 617 //
     /*  59657 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  59664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  59668 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59679 */     // (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (MOVSX32rm16:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  59679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSX32rm16),
     /*  59682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59684 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59688 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59692 */     GIR_RootConstrainSelectedInstOperands,
     /*  59693 */     // GIR_Coverage, 617,
     /*  59693 */     GIR_EraseRootFromParent_Done,
     /*  59694 */   // Label 1452: @59694
     /*  59694 */   GIM_Reject,
     /*  59695 */ // Label 1450: @59695
     /*  59695 */ GIM_Reject,
     /*  59696 */ // Label 1447: @59696
     /*  59696 */ GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(59834),
     /*  59701 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  59704 */   GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(59746), // Rule ID 623 //
     /*  59709 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  59716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  59720 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59731 */     // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (MOVSX64rm8:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  59731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSX64rm8),
     /*  59734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59736 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59740 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59744 */     GIR_RootConstrainSelectedInstOperands,
     /*  59745 */     // GIR_Coverage, 623,
     /*  59745 */     GIR_EraseRootFromParent_Done,
     /*  59746 */   // Label 1454: @59746
     /*  59746 */   GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(59788), // Rule ID 625 //
     /*  59751 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  59758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  59762 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59773 */     // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (MOVSX64rm16:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  59773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSX64rm16),
     /*  59776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59778 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59782 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59786 */     GIR_RootConstrainSelectedInstOperands,
     /*  59787 */     // GIR_Coverage, 625,
     /*  59787 */     GIR_EraseRootFromParent_Done,
     /*  59788 */   // Label 1455: @59788
     /*  59788 */   GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(59833), // Rule ID 627 //
     /*  59793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  59796 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  59803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  59807 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59818 */     // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (MOVSX64rm32:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  59818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSX64rm32),
     /*  59821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59823 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59827 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59831 */     GIR_RootConstrainSelectedInstOperands,
     /*  59832 */     // GIR_Coverage, 627,
     /*  59832 */     GIR_EraseRootFromParent_Done,
     /*  59833 */   // Label 1456: @59833
     /*  59833 */   GIM_Reject,
     /*  59834 */ // Label 1453: @59834
     /*  59834 */ GIM_Reject,
     /*  59835 */ // Label 1448: @59835
     /*  59835 */ GIM_Reject,
     /*  59836 */ // Label 12: @59836
     /*  59836 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(5), /*)*//*default:*//*Label 1461*/ GIMT_Encode4(60490),
     /*  59847 */ /*GILLT_s8*//*Label 1457*/ GIMT_Encode4(59863),
     /*  59851 */ /*GILLT_s16*//*Label 1458*/ GIMT_Encode4(59909),
     /*  59855 */ /*GILLT_s32*//*Label 1459*/ GIMT_Encode4(60048),
     /*  59859 */ /*GILLT_s64*//*Label 1460*/ GIMT_Encode4(60184),
     /*  59863 */ // Label 1457: @59863
     /*  59863 */ GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(59908), // Rule ID 22576 //
     /*  59868 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  59871 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  59878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  59882 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59886 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59893 */   // (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (MOV8rm:{ *:[i8] } addr:{ *:[iPTR] }:$src)
     /*  59893 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8rm),
     /*  59896 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59898 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59902 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59906 */   GIR_RootConstrainSelectedInstOperands,
     /*  59907 */   // GIR_Coverage, 22576,
     /*  59907 */   GIR_EraseRootFromParent_Done,
     /*  59908 */ // Label 1462: @59908
     /*  59908 */ GIM_Reject,
     /*  59909 */ // Label 1458: @59909
     /*  59909 */ GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(60047),
     /*  59914 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  59917 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  59924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  59928 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59932 */   GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(59989), // Rule ID 22577 //
     /*  59937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59944 */     // (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_16bit:{ *:[i32] })
     /*  59944 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  59947 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  59951 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59956 */     GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  59960 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59964 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  59966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59971 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  59978 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  59983 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  59988 */     // GIR_Coverage, 22577,
     /*  59988 */     GIR_EraseRootFromParent_Done,
     /*  59989 */   // Label 1464: @59989
     /*  59989 */   GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(60046), // Rule ID 22650 //
     /*  59994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60001 */     // (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_16bit:{ *:[i32] })
     /*  60001 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60004 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  60008 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60013 */     GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  60017 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  60021 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60028 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  60035 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  60040 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  60045 */     // GIR_Coverage, 22650,
     /*  60045 */     GIR_EraseRootFromParent_Done,
     /*  60046 */   // Label 1465: @60046
     /*  60046 */   GIM_Reject,
     /*  60047 */ // Label 1463: @60047
     /*  60047 */ GIM_Reject,
     /*  60048 */ // Label 1459: @60048
     /*  60048 */ GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(60183),
     /*  60053 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  60056 */   GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(60098), // Rule ID 619 //
     /*  60061 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  60072 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  60076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60083 */     // (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  60083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  60086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60088 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  60092 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  60096 */     GIR_RootConstrainSelectedInstOperands,
     /*  60097 */     // GIR_Coverage, 619,
     /*  60097 */     GIR_EraseRootFromParent_Done,
     /*  60098 */   // Label 1467: @60098
     /*  60098 */   GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(60140), // Rule ID 621 //
     /*  60103 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  60110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  60114 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  60118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60125 */     // (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (MOVZX32rm16:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  60125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm16),
     /*  60128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60130 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  60134 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  60138 */     GIR_RootConstrainSelectedInstOperands,
     /*  60139 */     // GIR_Coverage, 621,
     /*  60139 */     GIR_EraseRootFromParent_Done,
     /*  60140 */   // Label 1468: @60140
     /*  60140 */   GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(60182), // Rule ID 22578 //
     /*  60145 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  60156 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  60160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60167 */     // (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  60167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  60170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60172 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  60176 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  60180 */     GIR_RootConstrainSelectedInstOperands,
     /*  60181 */     // GIR_Coverage, 22578,
     /*  60181 */     GIR_EraseRootFromParent_Done,
     /*  60182 */   // Label 1469: @60182
     /*  60182 */   GIM_Reject,
     /*  60183 */ // Label 1466: @60183
     /*  60183 */ GIM_Reject,
     /*  60184 */ // Label 1460: @60184
     /*  60184 */ GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(60489),
     /*  60189 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  60192 */   GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(60266), // Rule ID 17591 //
     /*  60197 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  60208 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  60212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60219 */     // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_32bit:{ *:[i32] })
     /*  60219 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60222 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  60226 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60231 */     GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  60235 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  60239 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  60244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  60255 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /*  60260 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /*  60265 */     // GIR_Coverage, 17591,
     /*  60265 */     GIR_EraseRootFromParent_Done,
     /*  60266 */   // Label 1471: @60266
     /*  60266 */   GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(60340), // Rule ID 17593 //
     /*  60271 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  60278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  60282 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  60286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60293 */     // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rm16:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_32bit:{ *:[i32] })
     /*  60293 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60296 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm16),
     /*  60300 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60305 */     GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  60309 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  60313 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  60318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60323 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  60329 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /*  60334 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /*  60339 */     // GIR_Coverage, 17593,
     /*  60339 */     GIR_EraseRootFromParent_Done,
     /*  60340 */   // Label 1472: @60340
     /*  60340 */   GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(60414), // Rule ID 17595 //
     /*  60345 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  60352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  60356 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  60360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60367 */     // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOV32rm:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_32bit:{ *:[i32] })
     /*  60367 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60370 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOV32rm),
     /*  60374 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60379 */     GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  60383 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  60387 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  60392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60397 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  60403 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /*  60408 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /*  60413 */     // GIR_Coverage, 17595,
     /*  60413 */     GIR_EraseRootFromParent_Done,
     /*  60414 */   // Label 1473: @60414
     /*  60414 */   GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(60488), // Rule ID 22579 //
     /*  60419 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  60430 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  60434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60441 */     // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_32bit:{ *:[i32] })
     /*  60441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  60448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60453 */     GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  60457 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  60461 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  60466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  60477 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /*  60482 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /*  60487 */     // GIR_Coverage, 22579,
     /*  60487 */     GIR_EraseRootFromParent_Done,
     /*  60488 */   // Label 1474: @60488
     /*  60488 */   GIM_Reject,
     /*  60489 */ // Label 1470: @60489
     /*  60489 */ GIM_Reject,
     /*  60490 */ // Label 1461: @60490
     /*  60490 */ GIM_Reject,
     /*  60491 */ // Label 13: @60491
     /*  60491 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(25), /*)*//*default:*//*Label 1497*/ GIMT_Encode4(85953),
     /*  60502 */ /*GILLT_s8*//*Label 1475*/ GIMT_Encode4(60598),
     /*  60506 */ /*GILLT_s16*//*Label 1476*/ GIMT_Encode4(65268),
     /*  60510 */ /*GILLT_s32*//*Label 1477*/ GIMT_Encode4(70512),
     /*  60514 */ /*GILLT_s64*//*Label 1478*/ GIMT_Encode4(76212),
     /*  60518 */ /*GILLT_s80*//*Label 1479*/ GIMT_Encode4(81604),
     /*  60522 */ /*GILLT_s128*//*Label 1480*/ GIMT_Encode4(81763), GIMT_Encode4(0),
     /*  60530 */ /*GILLT_v2s64*//*Label 1481*/ GIMT_Encode4(82017), GIMT_Encode4(0),
     /*  60538 */ /*GILLT_v4s32*//*Label 1482*/ GIMT_Encode4(82511),
     /*  60542 */ /*GILLT_v4s64*//*Label 1483*/ GIMT_Encode4(83005),
     /*  60546 */ /*GILLT_v8s1*//*Label 1484*/ GIMT_Encode4(83339),
     /*  60550 */ /*GILLT_v8s16*//*Label 1485*/ GIMT_Encode4(83421),
     /*  60554 */ /*GILLT_v8s32*//*Label 1486*/ GIMT_Encode4(83995),
     /*  60558 */ /*GILLT_v8s64*//*Label 1487*/ GIMT_Encode4(84329),
     /*  60562 */ /*GILLT_v16s1*//*Label 1488*/ GIMT_Encode4(84503),
     /*  60566 */ /*GILLT_v16s8*//*Label 1489*/ GIMT_Encode4(84585),
     /*  60570 */ /*GILLT_v16s16*//*Label 1490*/ GIMT_Encode4(84839),
     /*  60574 */ /*GILLT_v16s32*//*Label 1491*/ GIMT_Encode4(85173),
     /*  60578 */ /*GILLT_v32s1*//*Label 1492*/ GIMT_Encode4(85347),
     /*  60582 */ /*GILLT_v32s8*//*Label 1493*/ GIMT_Encode4(85429),
     /*  60586 */ /*GILLT_v32s16*//*Label 1494*/ GIMT_Encode4(85603),
     /*  60590 */ /*GILLT_v64s1*//*Label 1495*/ GIMT_Encode4(85777),
     /*  60594 */ /*GILLT_v64s8*//*Label 1496*/ GIMT_Encode4(85859),
     /*  60598 */ // Label 1475: @60598
     /*  60598 */ GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(60694), // Rule ID 22491 //
     /*  60603 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  60606 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  60609 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60616 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  60620 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  60624 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  60628 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  60632 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60636 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  60640 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  60643 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  60647 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60654 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  60658 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  60662 */   // MIs[0] dst
     /*  60662 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  60667 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60669 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60676 */   // (atomic_store (add:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, 1:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (INC8m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  60676 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC8m),
     /*  60679 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  60683 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  60686 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  60692 */   GIR_RootConstrainSelectedInstOperands,
     /*  60693 */   // GIR_Coverage, 22491,
     /*  60693 */   GIR_EraseRootFromParent_Done,
     /*  60694 */ // Label 1498: @60694
     /*  60694 */ GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(60790), // Rule ID 22495 //
     /*  60699 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  60702 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  60705 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60712 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  60716 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  60720 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  60724 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  60728 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60732 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  60736 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  60739 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  60743 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60750 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  60754 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  60758 */   // MIs[0] dst
     /*  60758 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  60763 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60765 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60772 */   // (atomic_store (add:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, -1:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (DEC8m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  60772 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC8m),
     /*  60775 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  60779 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  60782 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  60788 */   GIR_RootConstrainSelectedInstOperands,
     /*  60789 */   // GIR_Coverage, 22495,
     /*  60789 */   GIR_EraseRootFromParent_Done,
     /*  60790 */ // Label 1499: @60790
     /*  60790 */ GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(60883), // Rule ID 22499 //
     /*  60795 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  60798 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60805 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  60809 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  60813 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  60817 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  60821 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  60825 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60829 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  60833 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  60836 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  60840 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60847 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  60851 */   // MIs[0] dst
     /*  60851 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  60856 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60858 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60865 */   // (atomic_store (sub:{ *:[i8] } 0:{ *:[i8] }, (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (NEG8m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  60865 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG8m),
     /*  60868 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  60872 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  60875 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  60881 */   GIR_RootConstrainSelectedInstOperands,
     /*  60882 */   // GIR_Coverage, 22499,
     /*  60882 */   GIR_EraseRootFromParent_Done,
     /*  60883 */ // Label 1500: @60883
     /*  60883 */ GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(60973), // Rule ID 22503 //
     /*  60888 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  60891 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60898 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  60902 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60906 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  60910 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  60914 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60918 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  60922 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  60925 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  60929 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60936 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  60940 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  60944 */   // MIs[0] dst
     /*  60944 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  60949 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60951 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60958 */   // (atomic_store (xor:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, -1:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (NOT8m addr:{ *:[iPTR] }:$dst)
     /*  60958 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT8m),
     /*  60961 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  60965 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  60971 */   GIR_RootConstrainSelectedInstOperands,
     /*  60972 */   // GIR_Coverage, 22503,
     /*  60972 */   GIR_EraseRootFromParent_Done,
     /*  60973 */ // Label 1501: @60973
     /*  60973 */ GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(61059), // Rule ID 225 //
     /*  60978 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  60981 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  60984 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  60988 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  60992 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  60996 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61000 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61004 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61008 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61012 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61015 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61019 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  61023 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  61027 */   // MIs[0] src1
     /*  61027 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61032 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61034 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61041 */   // (st (add:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, 1:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (INC8m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  61041 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC8m),
     /*  61044 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  61048 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61051 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  61057 */   GIR_RootConstrainSelectedInstOperands,
     /*  61058 */   // GIR_Coverage, 225,
     /*  61058 */   GIR_EraseRootFromParent_Done,
     /*  61059 */ // Label 1502: @61059
     /*  61059 */ GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(61145), // Rule ID 228 //
     /*  61064 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  61067 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61070 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  61074 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61078 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  61082 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61086 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61090 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61094 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61098 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61101 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61105 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  61109 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61113 */   // MIs[0] src1
     /*  61113 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61118 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61120 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61127 */   // (st (add:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, -1:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (DEC8m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  61127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC8m),
     /*  61130 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  61134 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61137 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  61143 */   GIR_RootConstrainSelectedInstOperands,
     /*  61144 */   // GIR_Coverage, 228,
     /*  61144 */   GIR_EraseRootFromParent_Done,
     /*  61145 */ // Label 1503: @61145
     /*  61145 */ GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(61228), // Rule ID 17612 //
     /*  61150 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61153 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  61157 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61161 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  61165 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61169 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61173 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61177 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61181 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61184 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61188 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  61192 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 7,
     /*  61196 */   // MIs[0] dst
     /*  61196 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61201 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61203 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61210 */   // (st (rotl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, 7:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR8m1:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  61210 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8m1),
     /*  61213 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  61217 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61220 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  61226 */   GIR_RootConstrainSelectedInstOperands,
     /*  61227 */   // GIR_Coverage, 17612,
     /*  61227 */   GIR_EraseRootFromParent_Done,
     /*  61228 */ // Label 1504: @61228
     /*  61228 */ GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(61311), // Rule ID 17616 //
     /*  61233 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61236 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  61240 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61244 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  61248 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61252 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61256 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61260 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61264 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61267 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61271 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  61275 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 7,
     /*  61279 */   // MIs[0] dst
     /*  61279 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61284 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61286 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61293 */   // (st (rotr:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, 7:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL8m1:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  61293 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8m1),
     /*  61296 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  61300 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61303 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  61309 */   GIR_RootConstrainSelectedInstOperands,
     /*  61310 */   // GIR_Coverage, 17616,
     /*  61310 */   GIR_EraseRootFromParent_Done,
     /*  61311 */ // Label 1505: @61311
     /*  61311 */ GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(61394), // Rule ID 261 //
     /*  61316 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61319 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  61323 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61327 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  61331 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61335 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61339 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  61343 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61347 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61351 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61354 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61358 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  61362 */   // MIs[0] src1
     /*  61362 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61367 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61369 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61376 */   // (st (sub:{ *:[i8] } 0:{ *:[i8] }, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (NEG8m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  61376 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG8m),
     /*  61379 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  61383 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61386 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  61392 */   GIR_RootConstrainSelectedInstOperands,
     /*  61393 */   // GIR_Coverage, 261,
     /*  61393 */   GIR_EraseRootFromParent_Done,
     /*  61394 */ // Label 1506: @61394
     /*  61394 */ GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(61474), // Rule ID 269 //
     /*  61399 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61402 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  61406 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61410 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61414 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61418 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61422 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61426 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61430 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61433 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61437 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  61441 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61445 */   // MIs[0] src1
     /*  61445 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61450 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61452 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61459 */   // (st (xor:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, -1:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (NOT8m addr:{ *:[iPTR] }:$src1)
     /*  61459 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT8m),
     /*  61462 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  61466 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  61472 */   GIR_RootConstrainSelectedInstOperands,
     /*  61473 */   // GIR_Coverage, 269,
     /*  61473 */   GIR_EraseRootFromParent_Done,
     /*  61474 */ // Label 1507: @61474
     /*  61474 */ GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(61569), // Rule ID 413 //
     /*  61479 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61482 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  61486 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61490 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  61494 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61498 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61502 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61506 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61510 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61513 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  61517 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61521 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  61525 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61529 */   // MIs[3] Operand 1
     /*  61529 */   // No operand predicates
     /*  61529 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  61533 */   // MIs[0] src1
     /*  61533 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61538 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  61540 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61547 */   // (st (add:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  61547 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8mi),
     /*  61550 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  61554 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  61557 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61560 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  61567 */   GIR_RootConstrainSelectedInstOperands,
     /*  61568 */   // GIR_Coverage, 413,
     /*  61568 */   GIR_EraseRootFromParent_Done,
     /*  61569 */ // Label 1508: @61569
     /*  61569 */ GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(61664), // Rule ID 305 //
     /*  61574 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61577 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  61581 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61585 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61589 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61593 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61597 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61601 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61605 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61608 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  61612 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61616 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  61620 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61624 */   // MIs[3] Operand 1
     /*  61624 */   // No operand predicates
     /*  61624 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  61628 */   // MIs[0] src1
     /*  61628 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61633 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  61635 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61642 */   // (st (and:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  61642 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8mi),
     /*  61645 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  61649 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  61652 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61655 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  61662 */   GIR_RootConstrainSelectedInstOperands,
     /*  61663 */   // GIR_Coverage, 305,
     /*  61663 */   GIR_EraseRootFromParent_Done,
     /*  61664 */ // Label 1509: @61664
     /*  61664 */ GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(61759), // Rule ID 341 //
     /*  61669 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61672 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  61676 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61680 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  61684 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61688 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61692 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61696 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61700 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61703 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  61707 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61711 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  61715 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61719 */   // MIs[3] Operand 1
     /*  61719 */   // No operand predicates
     /*  61719 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  61723 */   // MIs[0] src1
     /*  61723 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61728 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  61730 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61737 */   // (st (or:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  61737 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8mi),
     /*  61740 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  61744 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  61747 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61750 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  61757 */   GIR_RootConstrainSelectedInstOperands,
     /*  61758 */   // GIR_Coverage, 341,
     /*  61758 */   GIR_EraseRootFromParent_Done,
     /*  61759 */ // Label 1510: @61759
     /*  61759 */ GIM_Try, /*On fail goto*//*Label 1511*/ GIMT_Encode4(61854), // Rule ID 453 //
     /*  61764 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61767 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  61771 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61775 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  61779 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61783 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61787 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61791 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61795 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61798 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  61802 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61806 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  61810 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61814 */   // MIs[3] Operand 1
     /*  61814 */   // No operand predicates
     /*  61814 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  61818 */   // MIs[0] src1
     /*  61818 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61823 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  61825 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61832 */   // (st (sub:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  61832 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB8mi),
     /*  61835 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  61839 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  61842 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61845 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  61852 */   GIR_RootConstrainSelectedInstOperands,
     /*  61853 */   // GIR_Coverage, 453,
     /*  61853 */   GIR_EraseRootFromParent_Done,
     /*  61854 */ // Label 1511: @61854
     /*  61854 */ GIM_Try, /*On fail goto*//*Label 1512*/ GIMT_Encode4(61949), // Rule ID 377 //
     /*  61859 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61862 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  61866 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61870 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61874 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61878 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61882 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61886 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61890 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61893 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  61897 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61901 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  61905 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61909 */   // MIs[3] Operand 1
     /*  61909 */   // No operand predicates
     /*  61909 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  61913 */   // MIs[0] src1
     /*  61913 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61918 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  61920 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61927 */   // (st (xor:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  61927 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8mi),
     /*  61930 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  61934 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  61937 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61940 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  61947 */   GIR_RootConstrainSelectedInstOperands,
     /*  61948 */   // GIR_Coverage, 377,
     /*  61948 */   GIR_EraseRootFromParent_Done,
     /*  61949 */ // Label 1512: @61949
     /*  61949 */ GIM_Try, /*On fail goto*//*Label 1513*/ GIMT_Encode4(62050), // Rule ID 22427 //
     /*  61954 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  61957 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  61964 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61968 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  61972 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61976 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61980 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61984 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61988 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  61991 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  61995 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62002 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62006 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  62010 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62014 */   // MIs[3] Operand 1
     /*  62014 */   // No operand predicates
     /*  62014 */   // MIs[0] dst
     /*  62014 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62019 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  62021 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62028 */   // (atomic_store (add:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, (imm:{ *:[i8] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (ADD8mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i8] }):$src)
     /*  62028 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8mi),
     /*  62031 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  62035 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  62038 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62041 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  62048 */   GIR_RootConstrainSelectedInstOperands,
     /*  62049 */   // GIR_Coverage, 22427,
     /*  62049 */   GIR_EraseRootFromParent_Done,
     /*  62050 */ // Label 1513: @62050
     /*  62050 */ GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(62151), // Rule ID 22435 //
     /*  62055 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62058 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62065 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62069 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62073 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62077 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62081 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62085 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62089 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62092 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  62096 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62103 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62107 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  62111 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62115 */   // MIs[3] Operand 1
     /*  62115 */   // No operand predicates
     /*  62115 */   // MIs[0] dst
     /*  62115 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62120 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  62122 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62129 */   // (atomic_store (and:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, (imm:{ *:[i8] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (AND8mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i8] }):$src)
     /*  62129 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8mi),
     /*  62132 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  62136 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  62139 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62142 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  62149 */   GIR_RootConstrainSelectedInstOperands,
     /*  62150 */   // GIR_Coverage, 22435,
     /*  62150 */   GIR_EraseRootFromParent_Done,
     /*  62151 */ // Label 1514: @62151
     /*  62151 */ GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(62252), // Rule ID 22443 //
     /*  62156 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62159 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62166 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62170 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  62174 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62178 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62182 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62186 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62190 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62193 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  62197 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62204 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62208 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  62212 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62216 */   // MIs[3] Operand 1
     /*  62216 */   // No operand predicates
     /*  62216 */   // MIs[0] dst
     /*  62216 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62221 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  62223 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62230 */   // (atomic_store (or:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, (imm:{ *:[i8] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (OR8mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i8] }):$src)
     /*  62230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8mi),
     /*  62233 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  62237 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  62240 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62243 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  62250 */   GIR_RootConstrainSelectedInstOperands,
     /*  62251 */   // GIR_Coverage, 22443,
     /*  62251 */   GIR_EraseRootFromParent_Done,
     /*  62252 */ // Label 1515: @62252
     /*  62252 */ GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(62353), // Rule ID 22459 //
     /*  62257 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62260 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62267 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62271 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  62275 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62279 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62283 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62287 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62291 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62294 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  62298 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62305 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62309 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  62313 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62317 */   // MIs[3] Operand 1
     /*  62317 */   // No operand predicates
     /*  62317 */   // MIs[0] dst
     /*  62317 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62322 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  62324 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62331 */   // (atomic_store (sub:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, (imm:{ *:[i8] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (SUB8mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i8] }):$src)
     /*  62331 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB8mi),
     /*  62334 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  62338 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  62341 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62344 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  62351 */   GIR_RootConstrainSelectedInstOperands,
     /*  62352 */   // GIR_Coverage, 22459,
     /*  62352 */   GIR_EraseRootFromParent_Done,
     /*  62353 */ // Label 1516: @62353
     /*  62353 */ GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(62454), // Rule ID 22451 //
     /*  62358 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62361 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62368 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62372 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62376 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62380 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62384 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62388 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62392 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62395 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  62399 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62406 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62410 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  62414 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62418 */   // MIs[3] Operand 1
     /*  62418 */   // No operand predicates
     /*  62418 */   // MIs[0] dst
     /*  62418 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62423 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  62425 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62432 */   // (atomic_store (xor:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, (imm:{ *:[i8] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (XOR8mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i8] }):$src)
     /*  62432 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8mi),
     /*  62435 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  62439 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  62442 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62445 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  62452 */   GIR_RootConstrainSelectedInstOperands,
     /*  62453 */   // GIR_Coverage, 22451,
     /*  62453 */   GIR_EraseRootFromParent_Done,
     /*  62454 */ // Label 1517: @62454
     /*  62454 */ GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(62545), // Rule ID 733 //
     /*  62459 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62462 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  62466 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62470 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  62474 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62478 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62482 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62486 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62490 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62493 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62497 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  62501 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  62505 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62509 */   // MIs[3] Operand 1
     /*  62509 */   // No operand predicates
     /*  62509 */   // MIs[0] src1
     /*  62509 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62514 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  62516 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62523 */   // (st (sra:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SAR8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  62523 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8mi),
     /*  62526 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  62530 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  62533 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62536 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  62543 */   GIR_RootConstrainSelectedInstOperands,
     /*  62544 */   // GIR_Coverage, 733,
     /*  62544 */   GIR_EraseRootFromParent_Done,
     /*  62545 */ // Label 1518: @62545
     /*  62545 */ GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(62636), // Rule ID 701 //
     /*  62550 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62553 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  62557 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62561 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  62565 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62569 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62573 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62577 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62581 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62584 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62588 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  62592 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  62596 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62600 */   // MIs[3] Operand 1
     /*  62600 */   // No operand predicates
     /*  62600 */   // MIs[0] src1
     /*  62600 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62605 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  62607 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62614 */   // (st (srl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHR8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  62614 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8mi),
     /*  62617 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  62621 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  62624 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62627 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  62634 */   GIR_RootConstrainSelectedInstOperands,
     /*  62635 */   // GIR_Coverage, 701,
     /*  62635 */   GIR_EraseRootFromParent_Done,
     /*  62636 */ // Label 1519: @62636
     /*  62636 */ GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(62727), // Rule ID 765 //
     /*  62641 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62644 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  62648 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62652 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  62656 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62660 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62664 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62668 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62672 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62675 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62679 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  62683 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  62687 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62691 */   // MIs[3] Operand 1
     /*  62691 */   // No operand predicates
     /*  62691 */   // MIs[0] src1
     /*  62691 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62696 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  62698 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62705 */   // (st (rotl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  62705 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8mi),
     /*  62708 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  62712 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  62715 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62718 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  62725 */   GIR_RootConstrainSelectedInstOperands,
     /*  62726 */   // GIR_Coverage, 765,
     /*  62726 */   GIR_EraseRootFromParent_Done,
     /*  62727 */ // Label 1520: @62727
     /*  62727 */ GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(62818), // Rule ID 797 //
     /*  62732 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62735 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  62739 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62743 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  62747 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62751 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62755 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62759 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62763 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62766 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62770 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  62774 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  62778 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62782 */   // MIs[3] Operand 1
     /*  62782 */   // No operand predicates
     /*  62782 */   // MIs[0] src1
     /*  62782 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62787 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  62789 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62796 */   // (st (rotr:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  62796 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8mi),
     /*  62799 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  62803 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  62806 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62809 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  62816 */   GIR_RootConstrainSelectedInstOperands,
     /*  62817 */   // GIR_Coverage, 797,
     /*  62817 */   GIR_EraseRootFromParent_Done,
     /*  62818 */ // Label 1521: @62818
     /*  62818 */ GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(62909), // Rule ID 669 //
     /*  62823 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62826 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  62830 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62834 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  62838 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62842 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62846 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62850 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62854 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62857 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62861 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  62865 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  62869 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62873 */   // MIs[3] Operand 1
     /*  62873 */   // No operand predicates
     /*  62873 */   // MIs[0] src1
     /*  62873 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62878 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  62880 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62887 */   // (st (shl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHL8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  62887 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8mi),
     /*  62890 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  62894 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  62897 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62900 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  62907 */   GIR_RootConstrainSelectedInstOperands,
     /*  62908 */   // GIR_Coverage, 669,
     /*  62908 */   GIR_EraseRootFromParent_Done,
     /*  62909 */ // Label 1522: @62909
     /*  62909 */ GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(63007), // Rule ID 22431 //
     /*  62914 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62917 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62924 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62928 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  62932 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62936 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62940 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62944 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62948 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62951 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  62955 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62962 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62966 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  62971 */   // MIs[0] dst
     /*  62971 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62976 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62978 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62985 */   // (atomic_store (add:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, GR8:{ *:[i8] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (ADD8mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  62985 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8mr),
     /*  62988 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  62992 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  62996 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62999 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63005 */   GIR_RootConstrainSelectedInstOperands,
     /*  63006 */   // GIR_Coverage, 22431,
     /*  63006 */   GIR_EraseRootFromParent_Done,
     /*  63007 */ // Label 1523: @63007
     /*  63007 */ GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(63105), // Rule ID 26002 //
     /*  63012 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63015 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63022 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63026 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  63030 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63034 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63038 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63043 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63047 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63051 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63054 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  63058 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63065 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63069 */   // MIs[0] dst
     /*  63069 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63074 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63076 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63083 */   // (atomic_store (add:{ *:[i8] } GR8:{ *:[i8] }:$src, (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (ADD8mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  63083 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8mr),
     /*  63086 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  63090 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  63094 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63097 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63103 */   GIR_RootConstrainSelectedInstOperands,
     /*  63104 */   // GIR_Coverage, 26002,
     /*  63104 */   GIR_EraseRootFromParent_Done,
     /*  63105 */ // Label 1524: @63105
     /*  63105 */ GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(63203), // Rule ID 22439 //
     /*  63110 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63113 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63120 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63124 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63128 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63132 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63136 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63140 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63144 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63147 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  63151 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63158 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63162 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63167 */   // MIs[0] dst
     /*  63167 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63172 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63174 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63181 */   // (atomic_store (and:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, GR8:{ *:[i8] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (AND8mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  63181 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8mr),
     /*  63184 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  63188 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  63192 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63195 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63201 */   GIR_RootConstrainSelectedInstOperands,
     /*  63202 */   // GIR_Coverage, 22439,
     /*  63202 */   GIR_EraseRootFromParent_Done,
     /*  63203 */ // Label 1525: @63203
     /*  63203 */ GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(63301), // Rule ID 26006 //
     /*  63208 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63211 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63218 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63222 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63226 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63230 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63234 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63239 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63243 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63247 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63250 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  63254 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63261 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63265 */   // MIs[0] dst
     /*  63265 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63270 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63272 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63279 */   // (atomic_store (and:{ *:[i8] } GR8:{ *:[i8] }:$src, (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (AND8mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  63279 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8mr),
     /*  63282 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  63286 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  63290 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63293 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63299 */   GIR_RootConstrainSelectedInstOperands,
     /*  63300 */   // GIR_Coverage, 26006,
     /*  63300 */   GIR_EraseRootFromParent_Done,
     /*  63301 */ // Label 1526: @63301
     /*  63301 */ GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(63399), // Rule ID 22447 //
     /*  63306 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63309 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63316 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63320 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  63324 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63328 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63332 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63336 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63340 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63343 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  63347 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63354 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63358 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63363 */   // MIs[0] dst
     /*  63363 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63368 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63370 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63377 */   // (atomic_store (or:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, GR8:{ *:[i8] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (OR8mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  63377 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8mr),
     /*  63380 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  63384 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  63388 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63391 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63397 */   GIR_RootConstrainSelectedInstOperands,
     /*  63398 */   // GIR_Coverage, 22447,
     /*  63398 */   GIR_EraseRootFromParent_Done,
     /*  63399 */ // Label 1527: @63399
     /*  63399 */ GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(63497), // Rule ID 26010 //
     /*  63404 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63407 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63414 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63418 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  63422 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63426 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63430 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63435 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63439 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63443 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63446 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  63450 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63457 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63461 */   // MIs[0] dst
     /*  63461 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63466 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63468 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63475 */   // (atomic_store (or:{ *:[i8] } GR8:{ *:[i8] }:$src, (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (OR8mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  63475 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8mr),
     /*  63478 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  63482 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  63486 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63489 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63495 */   GIR_RootConstrainSelectedInstOperands,
     /*  63496 */   // GIR_Coverage, 26010,
     /*  63496 */   GIR_EraseRootFromParent_Done,
     /*  63497 */ // Label 1528: @63497
     /*  63497 */ GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(63595), // Rule ID 22463 //
     /*  63502 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63505 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63512 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63516 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  63520 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63524 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63528 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63532 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63536 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63539 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  63543 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63550 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63554 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63559 */   // MIs[0] dst
     /*  63559 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63564 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63566 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63573 */   // (atomic_store (sub:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, GR8:{ *:[i8] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (SUB8mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  63573 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB8mr),
     /*  63576 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  63580 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  63584 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63587 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63593 */   GIR_RootConstrainSelectedInstOperands,
     /*  63594 */   // GIR_Coverage, 22463,
     /*  63594 */   GIR_EraseRootFromParent_Done,
     /*  63595 */ // Label 1529: @63595
     /*  63595 */ GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(63693), // Rule ID 22455 //
     /*  63600 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63603 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63610 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63614 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63618 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63622 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63626 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63630 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63634 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63637 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  63641 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63648 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63652 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63657 */   // MIs[0] dst
     /*  63657 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63662 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63664 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63671 */   // (atomic_store (xor:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, GR8:{ *:[i8] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (XOR8mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  63671 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8mr),
     /*  63674 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  63678 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  63682 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63685 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63691 */   GIR_RootConstrainSelectedInstOperands,
     /*  63692 */   // GIR_Coverage, 22455,
     /*  63692 */   GIR_EraseRootFromParent_Done,
     /*  63693 */ // Label 1530: @63693
     /*  63693 */ GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(63791), // Rule ID 26014 //
     /*  63698 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63701 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63708 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63712 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63716 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63720 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63724 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63729 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63733 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63737 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63740 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  63744 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63751 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63755 */   // MIs[0] dst
     /*  63755 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63760 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63762 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63769 */   // (atomic_store (xor:{ *:[i8] } GR8:{ *:[i8] }:$src, (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (XOR8mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  63769 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8mr),
     /*  63772 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  63776 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  63780 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63783 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63789 */   GIR_RootConstrainSelectedInstOperands,
     /*  63790 */   // GIR_Coverage, 26014,
     /*  63790 */   GIR_EraseRootFromParent_Done,
     /*  63791 */ // Label 1531: @63791
     /*  63791 */ GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(63879), // Rule ID 409 //
     /*  63796 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  63799 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  63803 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63807 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  63811 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63815 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63819 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63823 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63827 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  63830 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  63834 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63838 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63843 */   // MIs[0] src1
     /*  63843 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63848 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63850 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63857 */   // (st (add:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD8mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  63857 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8mr),
     /*  63860 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  63864 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  63868 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63871 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63877 */   GIR_RootConstrainSelectedInstOperands,
     /*  63878 */   // GIR_Coverage, 409,
     /*  63878 */   GIR_EraseRootFromParent_Done,
     /*  63879 */ // Label 1532: @63879
     /*  63879 */ GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(63967), // Rule ID 23222 //
     /*  63884 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  63887 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  63891 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63895 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  63899 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63903 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63907 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63912 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63916 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63920 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  63923 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  63927 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63931 */   // MIs[0] src1
     /*  63931 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63936 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63938 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63945 */   // (st (add:{ *:[i8] } GR8:{ *:[i8] }:$src2, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD8mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  63945 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8mr),
     /*  63948 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  63952 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  63956 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63959 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63965 */   GIR_RootConstrainSelectedInstOperands,
     /*  63966 */   // GIR_Coverage, 23222,
     /*  63966 */   GIR_EraseRootFromParent_Done,
     /*  63967 */ // Label 1533: @63967
     /*  63967 */ GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(64055), // Rule ID 301 //
     /*  63972 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  63975 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  63979 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63983 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63987 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63991 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63995 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63999 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64003 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64006 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  64010 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64014 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  64019 */   // MIs[0] src1
     /*  64019 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64024 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64026 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64033 */   // (st (and:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND8mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  64033 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8mr),
     /*  64036 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64040 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  64044 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64047 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64053 */   GIR_RootConstrainSelectedInstOperands,
     /*  64054 */   // GIR_Coverage, 301,
     /*  64054 */   GIR_EraseRootFromParent_Done,
     /*  64055 */ // Label 1534: @64055
     /*  64055 */ GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(64143), // Rule ID 23186 //
     /*  64060 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64063 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64067 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64071 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64075 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64079 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64083 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  64088 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64092 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64096 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64099 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  64103 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64107 */   // MIs[0] src1
     /*  64107 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64112 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64114 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64121 */   // (st (and:{ *:[i8] } GR8:{ *:[i8] }:$src2, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND8mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  64121 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8mr),
     /*  64124 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64128 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  64132 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64135 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64141 */   GIR_RootConstrainSelectedInstOperands,
     /*  64142 */   // GIR_Coverage, 23186,
     /*  64142 */   GIR_EraseRootFromParent_Done,
     /*  64143 */ // Label 1535: @64143
     /*  64143 */ GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(64241), // Rule ID 749 //
     /*  64148 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64151 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64155 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64159 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  64163 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64167 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64171 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64175 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64179 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64182 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64186 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  64190 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  64195 */   // MIs[0] src1
     /*  64195 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64200 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64202 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64209 */   // (st (sra:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SAR8mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  64209 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  64213 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64219 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  64223 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8mCL),
     /*  64226 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64230 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64233 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64239 */   GIR_RootConstrainSelectedInstOperands,
     /*  64240 */   // GIR_Coverage, 749,
     /*  64240 */   GIR_EraseRootFromParent_Done,
     /*  64241 */ // Label 1536: @64241
     /*  64241 */ GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(64339), // Rule ID 717 //
     /*  64246 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64249 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64253 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64257 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  64261 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64265 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64269 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64273 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64277 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64280 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64284 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  64288 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  64293 */   // MIs[0] src1
     /*  64293 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64298 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64300 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64307 */   // (st (srl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHR8mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  64307 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  64311 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64317 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  64321 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8mCL),
     /*  64324 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64328 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64331 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64337 */   GIR_RootConstrainSelectedInstOperands,
     /*  64338 */   // GIR_Coverage, 717,
     /*  64338 */   GIR_EraseRootFromParent_Done,
     /*  64339 */ // Label 1537: @64339
     /*  64339 */ GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(64427), // Rule ID 337 //
     /*  64344 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64347 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64351 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64355 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  64359 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64363 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64367 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64371 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64375 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64378 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  64382 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64386 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  64391 */   // MIs[0] src1
     /*  64391 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64396 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64398 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64405 */   // (st (or:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR8mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  64405 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8mr),
     /*  64408 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64412 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  64416 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64419 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64425 */   GIR_RootConstrainSelectedInstOperands,
     /*  64426 */   // GIR_Coverage, 337,
     /*  64426 */   GIR_EraseRootFromParent_Done,
     /*  64427 */ // Label 1538: @64427
     /*  64427 */ GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(64515), // Rule ID 23198 //
     /*  64432 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64435 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64439 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64443 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  64447 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64451 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64455 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  64460 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64464 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64468 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64471 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  64475 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64479 */   // MIs[0] src1
     /*  64479 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64484 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64486 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64493 */   // (st (or:{ *:[i8] } GR8:{ *:[i8] }:$src2, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR8mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  64493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8mr),
     /*  64496 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64500 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  64504 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64507 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64513 */   GIR_RootConstrainSelectedInstOperands,
     /*  64514 */   // GIR_Coverage, 23198,
     /*  64514 */   GIR_EraseRootFromParent_Done,
     /*  64515 */ // Label 1539: @64515
     /*  64515 */ GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(64613), // Rule ID 781 //
     /*  64520 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64523 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64527 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64531 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  64535 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64539 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64543 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64547 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64551 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64554 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64558 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  64562 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  64567 */   // MIs[0] src1
     /*  64567 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64572 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64574 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64581 */   // (st (rotl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL8mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  64581 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  64585 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64591 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  64595 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8mCL),
     /*  64598 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64602 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64605 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64611 */   GIR_RootConstrainSelectedInstOperands,
     /*  64612 */   // GIR_Coverage, 781,
     /*  64612 */   GIR_EraseRootFromParent_Done,
     /*  64613 */ // Label 1540: @64613
     /*  64613 */ GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(64711), // Rule ID 813 //
     /*  64618 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64621 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64625 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64629 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  64633 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64637 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64641 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64645 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64649 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64652 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64656 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  64660 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  64665 */   // MIs[0] src1
     /*  64665 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64670 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64672 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64679 */   // (st (rotr:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR8mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  64679 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  64683 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64689 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  64693 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8mCL),
     /*  64696 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64700 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64703 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64709 */   GIR_RootConstrainSelectedInstOperands,
     /*  64710 */   // GIR_Coverage, 813,
     /*  64710 */   GIR_EraseRootFromParent_Done,
     /*  64711 */ // Label 1541: @64711
     /*  64711 */ GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(64809), // Rule ID 685 //
     /*  64716 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64719 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64723 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64727 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  64731 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64735 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64739 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64743 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64747 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64750 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64754 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  64758 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  64763 */   // MIs[0] src1
     /*  64763 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64768 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64770 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64777 */   // (st (shl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHL8mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  64777 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  64781 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64787 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  64791 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8mCL),
     /*  64794 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64798 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64801 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64807 */   GIR_RootConstrainSelectedInstOperands,
     /*  64808 */   // GIR_Coverage, 685,
     /*  64808 */   GIR_EraseRootFromParent_Done,
     /*  64809 */ // Label 1542: @64809
     /*  64809 */ GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(64897), // Rule ID 445 //
     /*  64814 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64817 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64821 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64825 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  64829 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64833 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64837 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64841 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64845 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64848 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  64852 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64856 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  64861 */   // MIs[0] src1
     /*  64861 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64866 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64868 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64875 */   // (st (sub:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB8mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  64875 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB8mr),
     /*  64878 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64882 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  64886 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64889 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64895 */   GIR_RootConstrainSelectedInstOperands,
     /*  64896 */   // GIR_Coverage, 445,
     /*  64896 */   GIR_EraseRootFromParent_Done,
     /*  64897 */ // Label 1543: @64897
     /*  64897 */ GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(64985), // Rule ID 373 //
     /*  64902 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64905 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64909 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64913 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64917 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64921 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64925 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64929 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64933 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64936 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  64940 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64944 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  64949 */   // MIs[0] src1
     /*  64949 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64954 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64956 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64963 */   // (st (xor:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR8mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  64963 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8mr),
     /*  64966 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64970 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  64974 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64977 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64983 */   GIR_RootConstrainSelectedInstOperands,
     /*  64984 */   // GIR_Coverage, 373,
     /*  64984 */   GIR_EraseRootFromParent_Done,
     /*  64985 */ // Label 1544: @64985
     /*  64985 */ GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(65073), // Rule ID 23210 //
     /*  64990 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64993 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64997 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65001 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65005 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  65009 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  65013 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  65018 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65022 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65026 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65029 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  65033 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65037 */   // MIs[0] src1
     /*  65037 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65042 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65044 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65051 */   // (st (xor:{ *:[i8] } GR8:{ *:[i8] }:$src2, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR8mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  65051 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8mr),
     /*  65054 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  65058 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  65062 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  65065 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65071 */   GIR_RootConstrainSelectedInstOperands,
     /*  65072 */   // GIR_Coverage, 23210,
     /*  65072 */   GIR_EraseRootFromParent_Done,
     /*  65073 */ // Label 1545: @65073
     /*  65073 */ GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(65127), // Rule ID 24 //
     /*  65078 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65081 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  65085 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65089 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65093 */   // MIs[1] Operand 1
     /*  65093 */   // No operand predicates
     /*  65093 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  65097 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  65101 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  65103 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65110 */   // (st (imm:{ *:[i8] })<<P:Predicate_imm_su>>:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOV8mi addr:{ *:[iPTR] }:$dst, (imm:{ *:[i8] }):$src)
     /*  65110 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8mi),
     /*  65113 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  65117 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src
     /*  65120 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  65125 */   GIR_RootConstrainSelectedInstOperands,
     /*  65126 */   // GIR_Coverage, 24,
     /*  65126 */   GIR_EraseRootFromParent_Done,
     /*  65127 */ // Label 1546: @65127
     /*  65127 */ GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(65180), // Rule ID 22507 //
     /*  65132 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  65135 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  65142 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65146 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65150 */   // MIs[1] Operand 1
     /*  65150 */   // No operand predicates
     /*  65150 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  65154 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  65156 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65163 */   // (atomic_store (imm:{ *:[i8] }):$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (MOV8mi addr:{ *:[iPTR] }:$dst, (imm:{ *:[i8] }):$src)
     /*  65163 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8mi),
     /*  65166 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  65170 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src
     /*  65173 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  65178 */   GIR_RootConstrainSelectedInstOperands,
     /*  65179 */   // GIR_Coverage, 22507,
     /*  65179 */   GIR_EraseRootFromParent_Done,
     /*  65180 */ // Label 1547: @65180
     /*  65180 */ GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(65225), // Rule ID 22511 //
     /*  65185 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  65188 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  65195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  65199 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  65203 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65210 */   // (atomic_store GR8:{ *:[i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (MOV8mr addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  65210 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8mr),
     /*  65213 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  65217 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  65219 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  65223 */   GIR_RootConstrainSelectedInstOperands,
     /*  65224 */   // GIR_Coverage, 22511,
     /*  65224 */   GIR_EraseRootFromParent_Done,
     /*  65225 */ // Label 1548: @65225
     /*  65225 */ GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(65267), // Rule ID 32 //
     /*  65230 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65233 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  65237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  65241 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  65245 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65252 */   // (st GR8:{ *:[i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOV8mr addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  65252 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8mr),
     /*  65255 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  65259 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  65261 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  65265 */   GIR_RootConstrainSelectedInstOperands,
     /*  65266 */   // GIR_Coverage, 32,
     /*  65266 */   GIR_EraseRootFromParent_Done,
     /*  65267 */ // Label 1549: @65267
     /*  65267 */ GIM_Reject,
     /*  65268 */ // Label 1476: @65268
     /*  65268 */ GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(65364), // Rule ID 22492 //
     /*  65273 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  65276 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  65279 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  65286 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65290 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  65294 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65298 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  65302 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65306 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65310 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  65313 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  65317 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  65324 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65328 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  65332 */   // MIs[0] dst
     /*  65332 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65337 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65339 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65346 */   // (atomic_store (add:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, 1:{ *:[i16] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (INC16m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  65346 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC16m),
     /*  65349 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  65353 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  65356 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65362 */   GIR_RootConstrainSelectedInstOperands,
     /*  65363 */   // GIR_Coverage, 22492,
     /*  65363 */   GIR_EraseRootFromParent_Done,
     /*  65364 */ // Label 1550: @65364
     /*  65364 */ GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(65460), // Rule ID 22496 //
     /*  65369 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  65372 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  65375 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  65382 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65386 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  65390 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65394 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  65398 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65402 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65406 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  65409 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  65413 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  65420 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65424 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  65428 */   // MIs[0] dst
     /*  65428 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65433 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65435 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65442 */   // (atomic_store (add:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, -1:{ *:[i16] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (DEC16m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  65442 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC16m),
     /*  65445 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  65449 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  65452 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65458 */   GIR_RootConstrainSelectedInstOperands,
     /*  65459 */   // GIR_Coverage, 22496,
     /*  65459 */   GIR_EraseRootFromParent_Done,
     /*  65460 */ // Label 1551: @65460
     /*  65460 */ GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(65553), // Rule ID 22500 //
     /*  65465 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  65468 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  65475 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65479 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  65483 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65487 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  65491 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  65495 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65499 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65503 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  65506 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  65510 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  65517 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65521 */   // MIs[0] dst
     /*  65521 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65526 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65528 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65535 */   // (atomic_store (sub:{ *:[i16] } 0:{ *:[i16] }, (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (NEG16m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  65535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG16m),
     /*  65538 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  65542 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  65545 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65551 */   GIR_RootConstrainSelectedInstOperands,
     /*  65552 */   // GIR_Coverage, 22500,
     /*  65552 */   GIR_EraseRootFromParent_Done,
     /*  65553 */ // Label 1552: @65553
     /*  65553 */ GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(65643), // Rule ID 22504 //
     /*  65558 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  65561 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  65568 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65572 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65576 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65580 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  65584 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65588 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65592 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  65595 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  65599 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  65606 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65610 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  65614 */   // MIs[0] dst
     /*  65614 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65619 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65621 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65628 */   // (atomic_store (xor:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, -1:{ *:[i16] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (NOT16m addr:{ *:[iPTR] }:$dst)
     /*  65628 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT16m),
     /*  65631 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  65635 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65641 */   GIR_RootConstrainSelectedInstOperands,
     /*  65642 */   // GIR_Coverage, 22504,
     /*  65642 */   GIR_EraseRootFromParent_Done,
     /*  65643 */ // Label 1553: @65643
     /*  65643 */ GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(65729), // Rule ID 226 //
     /*  65648 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  65651 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65654 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  65658 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65662 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  65666 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65670 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  65674 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65678 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65682 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65685 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65689 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  65693 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  65697 */   // MIs[0] src1
     /*  65697 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65702 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65704 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65711 */   // (st (add:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 1:{ *:[i16] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (INC16m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  65711 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC16m),
     /*  65714 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  65718 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  65721 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65727 */   GIR_RootConstrainSelectedInstOperands,
     /*  65728 */   // GIR_Coverage, 226,
     /*  65728 */   GIR_EraseRootFromParent_Done,
     /*  65729 */ // Label 1554: @65729
     /*  65729 */ GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(65815), // Rule ID 229 //
     /*  65734 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  65737 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65740 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  65744 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65748 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  65752 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65756 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  65760 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65764 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65768 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65771 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65775 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  65779 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  65783 */   // MIs[0] src1
     /*  65783 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65788 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65790 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65797 */   // (st (add:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, -1:{ *:[i16] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (DEC16m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  65797 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC16m),
     /*  65800 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  65804 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  65807 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65813 */   GIR_RootConstrainSelectedInstOperands,
     /*  65814 */   // GIR_Coverage, 229,
     /*  65814 */   GIR_EraseRootFromParent_Done,
     /*  65815 */ // Label 1555: @65815
     /*  65815 */ GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(65908), // Rule ID 22614 //
     /*  65820 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65823 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  65827 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65831 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  65835 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65839 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  65843 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65847 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65851 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65854 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65858 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  65862 */   GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(128),
     /*  65873 */   // MIs[0] dst
     /*  65873 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65878 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65880 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65887 */   // (st (add:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 128:{ *:[i16] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB16mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, -128:{ *:[i16] })
     /*  65887 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16mi),
     /*  65890 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  65894 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*  65897 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  65900 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65906 */   GIR_RootConstrainSelectedInstOperands,
     /*  65907 */   // GIR_Coverage, 22614,
     /*  65907 */   GIR_EraseRootFromParent_Done,
     /*  65908 */ // Label 1556: @65908
     /*  65908 */ GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(65991), // Rule ID 17613 //
     /*  65913 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65916 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  65920 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65924 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  65928 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65932 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  65936 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65940 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65944 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65947 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65951 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  65955 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 15,
     /*  65959 */   // MIs[0] dst
     /*  65959 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65964 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65966 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65973 */   // (st (rotl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 15:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR16m1:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  65973 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16m1),
     /*  65976 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  65980 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  65983 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65989 */   GIR_RootConstrainSelectedInstOperands,
     /*  65990 */   // GIR_Coverage, 17613,
     /*  65990 */   GIR_EraseRootFromParent_Done,
     /*  65991 */ // Label 1557: @65991
     /*  65991 */ GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(66074), // Rule ID 17617 //
     /*  65996 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65999 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  66003 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66007 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  66011 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66015 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  66019 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66023 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66027 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66030 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66034 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  66038 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 15,
     /*  66042 */   // MIs[0] dst
     /*  66042 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66047 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66049 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66056 */   // (st (rotr:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 15:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL16m1:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  66056 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16m1),
     /*  66059 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  66063 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66066 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  66072 */   GIR_RootConstrainSelectedInstOperands,
     /*  66073 */   // GIR_Coverage, 17617,
     /*  66073 */   GIR_EraseRootFromParent_Done,
     /*  66074 */ // Label 1558: @66074
     /*  66074 */ GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(66157), // Rule ID 262 //
     /*  66079 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66082 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  66086 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66090 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  66094 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66098 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66102 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  66106 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66110 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66114 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66117 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66121 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  66125 */   // MIs[0] src1
     /*  66125 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66130 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66132 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66139 */   // (st (sub:{ *:[i16] } 0:{ *:[i16] }, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (NEG16m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  66139 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG16m),
     /*  66142 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  66146 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66149 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  66155 */   GIR_RootConstrainSelectedInstOperands,
     /*  66156 */   // GIR_Coverage, 262,
     /*  66156 */   GIR_EraseRootFromParent_Done,
     /*  66157 */ // Label 1559: @66157
     /*  66157 */ GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(66237), // Rule ID 270 //
     /*  66162 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66165 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  66169 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66173 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66177 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66181 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66185 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66189 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66193 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66196 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66200 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  66204 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  66208 */   // MIs[0] src1
     /*  66208 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66213 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66215 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66222 */   // (st (xor:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, -1:{ *:[i16] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (NOT16m addr:{ *:[iPTR] }:$src1)
     /*  66222 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT16m),
     /*  66225 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  66229 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  66235 */   GIR_RootConstrainSelectedInstOperands,
     /*  66236 */   // GIR_Coverage, 270,
     /*  66236 */   GIR_EraseRootFromParent_Done,
     /*  66237 */ // Label 1560: @66237
     /*  66237 */ GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(66332), // Rule ID 414 //
     /*  66242 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66245 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  66249 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66253 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  66257 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66261 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66265 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66269 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66273 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66276 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  66280 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66284 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  66288 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66292 */   // MIs[3] Operand 1
     /*  66292 */   // No operand predicates
     /*  66292 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  66296 */   // MIs[0] src1
     /*  66296 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66301 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  66303 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66310 */   // (st (add:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i16] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  66310 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16mi),
     /*  66313 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  66317 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  66320 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66323 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  66330 */   GIR_RootConstrainSelectedInstOperands,
     /*  66331 */   // GIR_Coverage, 414,
     /*  66331 */   GIR_EraseRootFromParent_Done,
     /*  66332 */ // Label 1561: @66332
     /*  66332 */ GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(66427), // Rule ID 306 //
     /*  66337 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66340 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  66344 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66348 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66352 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66356 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66360 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66364 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66368 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66371 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  66375 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66379 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  66383 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66387 */   // MIs[3] Operand 1
     /*  66387 */   // No operand predicates
     /*  66387 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  66391 */   // MIs[0] src1
     /*  66391 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66396 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  66398 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66405 */   // (st (and:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i16] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  66405 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16mi),
     /*  66408 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  66412 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  66415 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66418 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  66425 */   GIR_RootConstrainSelectedInstOperands,
     /*  66426 */   // GIR_Coverage, 306,
     /*  66426 */   GIR_EraseRootFromParent_Done,
     /*  66427 */ // Label 1562: @66427
     /*  66427 */ GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(66522), // Rule ID 342 //
     /*  66432 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66435 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  66439 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66443 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  66447 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66451 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66455 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66459 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66463 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66466 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  66470 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66474 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  66478 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66482 */   // MIs[3] Operand 1
     /*  66482 */   // No operand predicates
     /*  66482 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  66486 */   // MIs[0] src1
     /*  66486 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66491 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  66493 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66500 */   // (st (or:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i16] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  66500 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16mi),
     /*  66503 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  66507 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  66510 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66513 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  66520 */   GIR_RootConstrainSelectedInstOperands,
     /*  66521 */   // GIR_Coverage, 342,
     /*  66521 */   GIR_EraseRootFromParent_Done,
     /*  66522 */ // Label 1563: @66522
     /*  66522 */ GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(66617), // Rule ID 454 //
     /*  66527 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66530 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  66534 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66538 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  66542 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66546 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66550 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66554 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66558 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66561 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  66565 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66569 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  66573 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66577 */   // MIs[3] Operand 1
     /*  66577 */   // No operand predicates
     /*  66577 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  66581 */   // MIs[0] src1
     /*  66581 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66586 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  66588 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66595 */   // (st (sub:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i16] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  66595 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16mi),
     /*  66598 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  66602 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  66605 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66608 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  66615 */   GIR_RootConstrainSelectedInstOperands,
     /*  66616 */   // GIR_Coverage, 454,
     /*  66616 */   GIR_EraseRootFromParent_Done,
     /*  66617 */ // Label 1564: @66617
     /*  66617 */ GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(66712), // Rule ID 378 //
     /*  66622 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66625 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  66629 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66633 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66637 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66641 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66645 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66649 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66653 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66656 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  66660 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66664 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  66668 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66672 */   // MIs[3] Operand 1
     /*  66672 */   // No operand predicates
     /*  66672 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  66676 */   // MIs[0] src1
     /*  66676 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66681 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  66683 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66690 */   // (st (xor:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i16] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  66690 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16mi),
     /*  66693 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  66697 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  66700 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66703 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  66710 */   GIR_RootConstrainSelectedInstOperands,
     /*  66711 */   // GIR_Coverage, 378,
     /*  66711 */   GIR_EraseRootFromParent_Done,
     /*  66712 */ // Label 1565: @66712
     /*  66712 */ GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(66813), // Rule ID 22428 //
     /*  66717 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  66720 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  66727 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66731 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  66735 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66739 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66743 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66747 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66751 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  66754 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  66758 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  66765 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66769 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  66773 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66777 */   // MIs[3] Operand 1
     /*  66777 */   // No operand predicates
     /*  66777 */   // MIs[0] dst
     /*  66777 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66782 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  66784 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66791 */   // (atomic_store (add:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, (imm:{ *:[i16] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (ADD16mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i16] }):$src)
     /*  66791 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16mi),
     /*  66794 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  66798 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  66801 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66804 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  66811 */   GIR_RootConstrainSelectedInstOperands,
     /*  66812 */   // GIR_Coverage, 22428,
     /*  66812 */   GIR_EraseRootFromParent_Done,
     /*  66813 */ // Label 1566: @66813
     /*  66813 */ GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(66914), // Rule ID 22436 //
     /*  66818 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  66821 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  66828 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66832 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66836 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66840 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66844 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66848 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66852 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  66855 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  66859 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  66866 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66870 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  66874 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66878 */   // MIs[3] Operand 1
     /*  66878 */   // No operand predicates
     /*  66878 */   // MIs[0] dst
     /*  66878 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66883 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  66885 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66892 */   // (atomic_store (and:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, (imm:{ *:[i16] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (AND16mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i16] }):$src)
     /*  66892 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16mi),
     /*  66895 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  66899 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  66902 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66905 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  66912 */   GIR_RootConstrainSelectedInstOperands,
     /*  66913 */   // GIR_Coverage, 22436,
     /*  66913 */   GIR_EraseRootFromParent_Done,
     /*  66914 */ // Label 1567: @66914
     /*  66914 */ GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(67015), // Rule ID 22444 //
     /*  66919 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  66922 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  66929 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66933 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  66937 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66941 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66945 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66949 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66953 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  66956 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  66960 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  66967 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66971 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  66975 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66979 */   // MIs[3] Operand 1
     /*  66979 */   // No operand predicates
     /*  66979 */   // MIs[0] dst
     /*  66979 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66984 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  66986 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66993 */   // (atomic_store (or:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, (imm:{ *:[i16] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (OR16mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i16] }):$src)
     /*  66993 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16mi),
     /*  66996 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  67000 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  67003 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67006 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  67013 */   GIR_RootConstrainSelectedInstOperands,
     /*  67014 */   // GIR_Coverage, 22444,
     /*  67014 */   GIR_EraseRootFromParent_Done,
     /*  67015 */ // Label 1568: @67015
     /*  67015 */ GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(67116), // Rule ID 22460 //
     /*  67020 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67023 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67030 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67034 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  67038 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67042 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  67046 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67050 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67054 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67057 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  67061 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67068 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67072 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  67076 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67080 */   // MIs[3] Operand 1
     /*  67080 */   // No operand predicates
     /*  67080 */   // MIs[0] dst
     /*  67080 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67085 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  67087 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67094 */   // (atomic_store (sub:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, (imm:{ *:[i16] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (SUB16mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i16] }):$src)
     /*  67094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16mi),
     /*  67097 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  67101 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  67104 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67107 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  67114 */   GIR_RootConstrainSelectedInstOperands,
     /*  67115 */   // GIR_Coverage, 22460,
     /*  67115 */   GIR_EraseRootFromParent_Done,
     /*  67116 */ // Label 1569: @67116
     /*  67116 */ GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(67217), // Rule ID 22452 //
     /*  67121 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67124 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67131 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67135 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67139 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67143 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  67147 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67151 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67155 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67158 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  67162 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67169 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67173 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  67177 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67181 */   // MIs[3] Operand 1
     /*  67181 */   // No operand predicates
     /*  67181 */   // MIs[0] dst
     /*  67181 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67186 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  67188 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67195 */   // (atomic_store (xor:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, (imm:{ *:[i16] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (XOR16mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i16] }):$src)
     /*  67195 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16mi),
     /*  67198 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  67202 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  67205 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67208 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  67215 */   GIR_RootConstrainSelectedInstOperands,
     /*  67216 */   // GIR_Coverage, 22452,
     /*  67216 */   GIR_EraseRootFromParent_Done,
     /*  67217 */ // Label 1570: @67217
     /*  67217 */ GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(67308), // Rule ID 734 //
     /*  67222 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67225 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  67229 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67233 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  67237 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67241 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  67245 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67249 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67253 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67256 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67260 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  67264 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  67268 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67272 */   // MIs[3] Operand 1
     /*  67272 */   // No operand predicates
     /*  67272 */   // MIs[0] src1
     /*  67272 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67277 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  67279 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67286 */   // (st (sra:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SAR16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  67286 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16mi),
     /*  67289 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  67293 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  67296 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67299 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  67306 */   GIR_RootConstrainSelectedInstOperands,
     /*  67307 */   // GIR_Coverage, 734,
     /*  67307 */   GIR_EraseRootFromParent_Done,
     /*  67308 */ // Label 1571: @67308
     /*  67308 */ GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(67399), // Rule ID 702 //
     /*  67313 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67316 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  67320 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67324 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  67328 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67332 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  67336 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67340 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67344 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67347 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67351 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  67355 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  67359 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67363 */   // MIs[3] Operand 1
     /*  67363 */   // No operand predicates
     /*  67363 */   // MIs[0] src1
     /*  67363 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67368 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  67370 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67377 */   // (st (srl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHR16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  67377 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16mi),
     /*  67380 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  67384 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  67387 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67390 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  67397 */   GIR_RootConstrainSelectedInstOperands,
     /*  67398 */   // GIR_Coverage, 702,
     /*  67398 */   GIR_EraseRootFromParent_Done,
     /*  67399 */ // Label 1572: @67399
     /*  67399 */ GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(67490), // Rule ID 766 //
     /*  67404 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67407 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  67411 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67415 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  67419 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67423 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  67427 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67431 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67435 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67438 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67442 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  67446 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  67450 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67454 */   // MIs[3] Operand 1
     /*  67454 */   // No operand predicates
     /*  67454 */   // MIs[0] src1
     /*  67454 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67459 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  67461 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67468 */   // (st (rotl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  67468 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16mi),
     /*  67471 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  67475 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  67478 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67481 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  67488 */   GIR_RootConstrainSelectedInstOperands,
     /*  67489 */   // GIR_Coverage, 766,
     /*  67489 */   GIR_EraseRootFromParent_Done,
     /*  67490 */ // Label 1573: @67490
     /*  67490 */ GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(67581), // Rule ID 798 //
     /*  67495 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67498 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  67502 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67506 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  67510 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67514 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  67518 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67522 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67526 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67529 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67533 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  67537 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  67541 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67545 */   // MIs[3] Operand 1
     /*  67545 */   // No operand predicates
     /*  67545 */   // MIs[0] src1
     /*  67545 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67550 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  67552 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67559 */   // (st (rotr:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  67559 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16mi),
     /*  67562 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  67566 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  67569 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67572 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  67579 */   GIR_RootConstrainSelectedInstOperands,
     /*  67580 */   // GIR_Coverage, 798,
     /*  67580 */   GIR_EraseRootFromParent_Done,
     /*  67581 */ // Label 1574: @67581
     /*  67581 */ GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(67672), // Rule ID 670 //
     /*  67586 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67589 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  67593 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67597 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  67601 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67605 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  67609 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67613 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67617 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67620 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67624 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  67628 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  67632 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67636 */   // MIs[3] Operand 1
     /*  67636 */   // No operand predicates
     /*  67636 */   // MIs[0] src1
     /*  67636 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67641 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  67643 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67650 */   // (st (shl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHL16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  67650 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16mi),
     /*  67653 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  67657 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  67660 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67663 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  67670 */   GIR_RootConstrainSelectedInstOperands,
     /*  67671 */   // GIR_Coverage, 670,
     /*  67671 */   GIR_EraseRootFromParent_Done,
     /*  67672 */ // Label 1575: @67672
     /*  67672 */ GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(67770), // Rule ID 22432 //
     /*  67677 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67680 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67687 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67691 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  67695 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67699 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  67703 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67707 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67711 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67714 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  67718 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67725 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67729 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  67734 */   // MIs[0] dst
     /*  67734 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67739 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67741 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67748 */   // (atomic_store (add:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, GR16:{ *:[i16] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (ADD16mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  67748 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16mr),
     /*  67751 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  67755 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  67759 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67762 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  67768 */   GIR_RootConstrainSelectedInstOperands,
     /*  67769 */   // GIR_Coverage, 22432,
     /*  67769 */   GIR_EraseRootFromParent_Done,
     /*  67770 */ // Label 1576: @67770
     /*  67770 */ GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(67868), // Rule ID 26003 //
     /*  67775 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67778 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67785 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67789 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  67793 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67797 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  67801 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  67806 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67810 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67814 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67817 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  67821 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67828 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67832 */   // MIs[0] dst
     /*  67832 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67837 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67839 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67846 */   // (atomic_store (add:{ *:[i16] } GR16:{ *:[i16] }:$src, (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (ADD16mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  67846 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16mr),
     /*  67849 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  67853 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  67857 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67860 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  67866 */   GIR_RootConstrainSelectedInstOperands,
     /*  67867 */   // GIR_Coverage, 26003,
     /*  67867 */   GIR_EraseRootFromParent_Done,
     /*  67868 */ // Label 1577: @67868
     /*  67868 */ GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(67966), // Rule ID 22440 //
     /*  67873 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67876 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67883 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67887 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67891 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67895 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  67899 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67903 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67907 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67910 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  67914 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67921 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67925 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  67930 */   // MIs[0] dst
     /*  67930 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67935 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67937 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67944 */   // (atomic_store (and:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, GR16:{ *:[i16] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (AND16mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  67944 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16mr),
     /*  67947 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  67951 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  67955 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67958 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  67964 */   GIR_RootConstrainSelectedInstOperands,
     /*  67965 */   // GIR_Coverage, 22440,
     /*  67965 */   GIR_EraseRootFromParent_Done,
     /*  67966 */ // Label 1578: @67966
     /*  67966 */ GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(68064), // Rule ID 26007 //
     /*  67971 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67974 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67981 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67985 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67989 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67993 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  67997 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  68002 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68006 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68010 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  68013 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  68017 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  68024 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68028 */   // MIs[0] dst
     /*  68028 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68033 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68035 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68042 */   // (atomic_store (and:{ *:[i16] } GR16:{ *:[i16] }:$src, (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (AND16mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  68042 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16mr),
     /*  68045 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  68049 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  68053 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68056 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68062 */   GIR_RootConstrainSelectedInstOperands,
     /*  68063 */   // GIR_Coverage, 26007,
     /*  68063 */   GIR_EraseRootFromParent_Done,
     /*  68064 */ // Label 1579: @68064
     /*  68064 */ GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(68162), // Rule ID 22448 //
     /*  68069 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  68072 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  68079 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68083 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  68087 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68091 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  68095 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68099 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68103 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  68106 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  68110 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  68117 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68121 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  68126 */   // MIs[0] dst
     /*  68126 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68131 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68133 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68140 */   // (atomic_store (or:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, GR16:{ *:[i16] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (OR16mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  68140 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16mr),
     /*  68143 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  68147 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  68151 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68154 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68160 */   GIR_RootConstrainSelectedInstOperands,
     /*  68161 */   // GIR_Coverage, 22448,
     /*  68161 */   GIR_EraseRootFromParent_Done,
     /*  68162 */ // Label 1580: @68162
     /*  68162 */ GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(68260), // Rule ID 26011 //
     /*  68167 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  68170 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  68177 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68181 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  68185 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68189 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  68193 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  68198 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68202 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68206 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  68209 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  68213 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  68220 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68224 */   // MIs[0] dst
     /*  68224 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68229 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68231 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68238 */   // (atomic_store (or:{ *:[i16] } GR16:{ *:[i16] }:$src, (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (OR16mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  68238 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16mr),
     /*  68241 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  68245 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  68249 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68252 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68258 */   GIR_RootConstrainSelectedInstOperands,
     /*  68259 */   // GIR_Coverage, 26011,
     /*  68259 */   GIR_EraseRootFromParent_Done,
     /*  68260 */ // Label 1581: @68260
     /*  68260 */ GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(68358), // Rule ID 22464 //
     /*  68265 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  68268 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  68275 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68279 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  68283 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68287 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  68291 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68295 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68299 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  68302 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  68306 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  68313 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68317 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  68322 */   // MIs[0] dst
     /*  68322 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68327 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68329 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68336 */   // (atomic_store (sub:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, GR16:{ *:[i16] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (SUB16mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  68336 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16mr),
     /*  68339 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  68343 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  68347 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68350 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68356 */   GIR_RootConstrainSelectedInstOperands,
     /*  68357 */   // GIR_Coverage, 22464,
     /*  68357 */   GIR_EraseRootFromParent_Done,
     /*  68358 */ // Label 1582: @68358
     /*  68358 */ GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(68456), // Rule ID 22456 //
     /*  68363 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  68366 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  68373 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68377 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68381 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68385 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  68389 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68393 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68397 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  68400 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  68404 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  68411 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68415 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  68420 */   // MIs[0] dst
     /*  68420 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68425 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68427 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68434 */   // (atomic_store (xor:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, GR16:{ *:[i16] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (XOR16mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  68434 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16mr),
     /*  68437 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  68441 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  68445 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68448 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68454 */   GIR_RootConstrainSelectedInstOperands,
     /*  68455 */   // GIR_Coverage, 22456,
     /*  68455 */   GIR_EraseRootFromParent_Done,
     /*  68456 */ // Label 1583: @68456
     /*  68456 */ GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(68554), // Rule ID 26015 //
     /*  68461 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  68464 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  68471 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68475 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68479 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68483 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  68487 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  68492 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68496 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68500 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  68503 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  68507 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  68514 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68518 */   // MIs[0] dst
     /*  68518 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68523 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68525 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68532 */   // (atomic_store (xor:{ *:[i16] } GR16:{ *:[i16] }:$src, (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (XOR16mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  68532 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16mr),
     /*  68535 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  68539 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  68543 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68546 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68552 */   GIR_RootConstrainSelectedInstOperands,
     /*  68553 */   // GIR_Coverage, 26015,
     /*  68553 */   GIR_EraseRootFromParent_Done,
     /*  68554 */ // Label 1584: @68554
     /*  68554 */ GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(68642), // Rule ID 410 //
     /*  68559 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68562 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  68566 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68570 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  68574 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68578 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  68582 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68586 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68590 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68593 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  68597 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68601 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  68606 */   // MIs[0] src1
     /*  68606 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68611 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68613 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68620 */   // (st (add:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR16:{ *:[i16] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD16mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  68620 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16mr),
     /*  68623 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  68627 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  68631 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68634 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68640 */   GIR_RootConstrainSelectedInstOperands,
     /*  68641 */   // GIR_Coverage, 410,
     /*  68641 */   GIR_EraseRootFromParent_Done,
     /*  68642 */ // Label 1585: @68642
     /*  68642 */ GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(68730), // Rule ID 23223 //
     /*  68647 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68650 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  68654 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68658 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  68662 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68666 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  68670 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  68675 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68679 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68683 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68686 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  68690 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68694 */   // MIs[0] src1
     /*  68694 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68699 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68701 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68708 */   // (st (add:{ *:[i16] } GR16:{ *:[i16] }:$src2, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD16mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  68708 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16mr),
     /*  68711 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  68715 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  68719 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68722 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68728 */   GIR_RootConstrainSelectedInstOperands,
     /*  68729 */   // GIR_Coverage, 23223,
     /*  68729 */   GIR_EraseRootFromParent_Done,
     /*  68730 */ // Label 1586: @68730
     /*  68730 */ GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(68818), // Rule ID 302 //
     /*  68735 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68738 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  68742 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68746 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68750 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68754 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  68758 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68762 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68766 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68769 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  68773 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68777 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  68782 */   // MIs[0] src1
     /*  68782 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68787 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68789 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68796 */   // (st (and:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR16:{ *:[i16] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND16mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  68796 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16mr),
     /*  68799 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  68803 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  68807 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68810 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68816 */   GIR_RootConstrainSelectedInstOperands,
     /*  68817 */   // GIR_Coverage, 302,
     /*  68817 */   GIR_EraseRootFromParent_Done,
     /*  68818 */ // Label 1587: @68818
     /*  68818 */ GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(68906), // Rule ID 23187 //
     /*  68823 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68826 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  68830 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68834 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68838 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68842 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  68846 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  68851 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68855 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68859 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68862 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  68866 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68870 */   // MIs[0] src1
     /*  68870 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68875 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68877 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68884 */   // (st (and:{ *:[i16] } GR16:{ *:[i16] }:$src2, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND16mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  68884 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16mr),
     /*  68887 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  68891 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  68895 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68898 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68904 */   GIR_RootConstrainSelectedInstOperands,
     /*  68905 */   // GIR_Coverage, 23187,
     /*  68905 */   GIR_EraseRootFromParent_Done,
     /*  68906 */ // Label 1588: @68906
     /*  68906 */ GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(69004), // Rule ID 750 //
     /*  68911 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68914 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  68918 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68922 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  68926 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68930 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  68934 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68938 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68942 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68945 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68949 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  68953 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  68958 */   // MIs[0] src1
     /*  68958 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68963 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68965 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68972 */   // (st (sra:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SAR16mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  68972 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68976 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68982 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  68986 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16mCL),
     /*  68989 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  68993 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68996 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  69002 */   GIR_RootConstrainSelectedInstOperands,
     /*  69003 */   // GIR_Coverage, 750,
     /*  69003 */   GIR_EraseRootFromParent_Done,
     /*  69004 */ // Label 1589: @69004
     /*  69004 */ GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(69102), // Rule ID 718 //
     /*  69009 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69012 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69016 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69020 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  69024 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  69028 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  69032 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  69036 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  69040 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69043 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  69047 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  69051 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  69056 */   // MIs[0] src1
     /*  69056 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69061 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69063 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69070 */   // (st (srl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHR16mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  69070 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69074 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69080 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  69084 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16mCL),
     /*  69087 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  69091 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  69094 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  69100 */   GIR_RootConstrainSelectedInstOperands,
     /*  69101 */   // GIR_Coverage, 718,
     /*  69101 */   GIR_EraseRootFromParent_Done,
     /*  69102 */ // Label 1590: @69102
     /*  69102 */ GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(69190), // Rule ID 338 //
     /*  69107 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69110 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69114 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69118 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  69122 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  69126 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  69130 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  69134 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  69138 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69141 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  69145 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  69149 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  69154 */   // MIs[0] src1
     /*  69154 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69159 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69161 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69168 */   // (st (or:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR16:{ *:[i16] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR16mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  69168 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16mr),
     /*  69171 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  69175 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  69179 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  69182 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  69188 */   GIR_RootConstrainSelectedInstOperands,
     /*  69189 */   // GIR_Coverage, 338,
     /*  69189 */   GIR_EraseRootFromParent_Done,
     /*  69190 */ // Label 1591: @69190
     /*  69190 */ GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(69278), // Rule ID 23199 //
     /*  69195 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69198 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69202 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69206 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  69210 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  69214 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  69218 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  69223 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69227 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  69231 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69234 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  69238 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  69242 */   // MIs[0] src1
     /*  69242 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69247 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69249 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69256 */   // (st (or:{ *:[i16] } GR16:{ *:[i16] }:$src2, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR16mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  69256 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16mr),
     /*  69259 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  69263 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  69267 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  69270 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  69276 */   GIR_RootConstrainSelectedInstOperands,
     /*  69277 */   // GIR_Coverage, 23199,
     /*  69277 */   GIR_EraseRootFromParent_Done,
     /*  69278 */ // Label 1592: @69278
     /*  69278 */ GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(69376), // Rule ID 782 //
     /*  69283 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69286 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69290 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69294 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  69298 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  69302 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  69306 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  69310 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  69314 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69317 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  69321 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  69325 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  69330 */   // MIs[0] src1
     /*  69330 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69335 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69337 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69344 */   // (st (rotl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL16mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  69344 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69348 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69354 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  69358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16mCL),
     /*  69361 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  69365 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  69368 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  69374 */   GIR_RootConstrainSelectedInstOperands,
     /*  69375 */   // GIR_Coverage, 782,
     /*  69375 */   GIR_EraseRootFromParent_Done,
     /*  69376 */ // Label 1593: @69376
     /*  69376 */ GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(69474), // Rule ID 814 //
     /*  69381 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69384 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69388 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69392 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  69396 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  69400 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  69404 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  69408 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  69412 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69415 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  69419 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  69423 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  69428 */   // MIs[0] src1
     /*  69428 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69433 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69435 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69442 */   // (st (rotr:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR16mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  69442 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69446 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69452 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  69456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16mCL),
     /*  69459 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  69463 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  69466 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  69472 */   GIR_RootConstrainSelectedInstOperands,
     /*  69473 */   // GIR_Coverage, 814,
     /*  69473 */   GIR_EraseRootFromParent_Done,
     /*  69474 */ // Label 1594: @69474
     /*  69474 */ GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(69572), // Rule ID 686 //
     /*  69479 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69482 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69486 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69490 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  69494 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  69498 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  69502 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  69506 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  69510 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69513 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  69517 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  69521 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  69526 */   // MIs[0] src1
     /*  69526 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69531 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69533 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69540 */   // (st (shl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHL16mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  69540 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69544 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69550 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  69554 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16mCL),
     /*  69557 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  69561 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  69564 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  69570 */   GIR_RootConstrainSelectedInstOperands,
     /*  69571 */   // GIR_Coverage, 686,
     /*  69571 */   GIR_EraseRootFromParent_Done,
     /*  69572 */ // Label 1595: @69572
     /*  69572 */ GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(69660), // Rule ID 446 //
     /*  69577 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69580 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69584 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69588 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  69592 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  69596 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  69600 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  69604 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  69608 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69611 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  69615 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  69619 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  69624 */   // MIs[0] src1
     /*  69624 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69629 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69631 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69638 */   // (st (sub:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR16:{ *:[i16] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB16mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  69638 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16mr),
     /*  69641 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  69645 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  69649 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  69652 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  69658 */   GIR_RootConstrainSelectedInstOperands,
     /*  69659 */   // GIR_Coverage, 446,
     /*  69659 */   GIR_EraseRootFromParent_Done,
     /*  69660 */ // Label 1596: @69660
     /*  69660 */ GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(69748), // Rule ID 374 //
     /*  69665 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69668 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69672 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69676 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69680 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  69684 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  69688 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  69692 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  69696 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69699 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  69703 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  69707 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  69712 */   // MIs[0] src1
     /*  69712 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69717 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69719 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69726 */   // (st (xor:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR16:{ *:[i16] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR16mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  69726 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16mr),
     /*  69729 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  69733 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  69737 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  69740 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  69746 */   GIR_RootConstrainSelectedInstOperands,
     /*  69747 */   // GIR_Coverage, 374,
     /*  69747 */   GIR_EraseRootFromParent_Done,
     /*  69748 */ // Label 1597: @69748
     /*  69748 */ GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(69836), // Rule ID 23211 //
     /*  69753 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69756 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69760 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69764 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69768 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  69772 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  69776 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  69781 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69785 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  69789 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69792 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  69796 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  69800 */   // MIs[0] src1
     /*  69800 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69805 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69807 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69814 */   // (st (xor:{ *:[i16] } GR16:{ *:[i16] }:$src2, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR16mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  69814 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16mr),
     /*  69817 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  69821 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  69825 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  69828 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  69834 */   GIR_RootConstrainSelectedInstOperands,
     /*  69835 */   // GIR_Coverage, 23211,
     /*  69835 */   GIR_EraseRootFromParent_Done,
     /*  69836 */ // Label 1598: @69836
     /*  69836 */ GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(69890), // Rule ID 25 //
     /*  69841 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69844 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69848 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69852 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69856 */   // MIs[1] Operand 1
     /*  69856 */   // No operand predicates
     /*  69856 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  69860 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  69864 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69866 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69873 */   // (st (imm:{ *:[i16] })<<P:Predicate_imm_su>>:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOV16mi addr:{ *:[iPTR] }:$dst, (imm:{ *:[i16] }):$src)
     /*  69873 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV16mi),
     /*  69876 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  69880 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src
     /*  69883 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  69888 */   GIR_RootConstrainSelectedInstOperands,
     /*  69889 */   // GIR_Coverage, 25,
     /*  69889 */   GIR_EraseRootFromParent_Done,
     /*  69890 */ // Label 1599: @69890
     /*  69890 */ GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(69943), // Rule ID 22508 //
     /*  69895 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  69898 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  69905 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69909 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69913 */   // MIs[1] Operand 1
     /*  69913 */   // No operand predicates
     /*  69913 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  69917 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69919 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69926 */   // (atomic_store (imm:{ *:[i16] }):$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (MOV16mi addr:{ *:[iPTR] }:$dst, (imm:{ *:[i16] }):$src)
     /*  69926 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV16mi),
     /*  69929 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  69933 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src
     /*  69936 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  69941 */   GIR_RootConstrainSelectedInstOperands,
     /*  69942 */   // GIR_Coverage, 22508,
     /*  69942 */   GIR_EraseRootFromParent_Done,
     /*  69943 */ // Label 1600: @69943
     /*  69943 */ GIM_Try, /*On fail goto*//*Label 1601*/ GIMT_Encode4(70006), // Rule ID 50 //
     /*  69948 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_NoEGPR),
     /*  69951 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69954 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69958 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69962 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /*  69966 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  69970 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  69975 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  69979 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69981 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69988 */   // (st (bswap:{ *:[i16] } GR16:{ *:[i16] }:$src1), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVBE16mr addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src1)
     /*  69988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE16mr),
     /*  69991 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  69995 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  69999 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  70004 */   GIR_RootConstrainSelectedInstOperands,
     /*  70005 */   // GIR_Coverage, 50,
     /*  70005 */   GIR_EraseRootFromParent_Done,
     /*  70006 */ // Label 1601: @70006
     /*  70006 */ GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(70069), // Rule ID 56 //
     /*  70011 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVBE_In64BitMode),
     /*  70014 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70017 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  70021 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  70025 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /*  70029 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  70033 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  70038 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  70042 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70044 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70051 */   // (st (bswap:{ *:[i16] } GR16:{ *:[i16] }:$src1), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVBE16mr_EVEX addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src1)
     /*  70051 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE16mr_EVEX),
     /*  70054 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70058 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  70062 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  70067 */   GIR_RootConstrainSelectedInstOperands,
     /*  70068 */   // GIR_Coverage, 56,
     /*  70068 */   GIR_EraseRootFromParent_Done,
     /*  70069 */ // Label 1602: @70069
     /*  70069 */ GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(70114), // Rule ID 22512 //
     /*  70074 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  70077 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  70084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  70088 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  70092 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70099 */   // (atomic_store GR16:{ *:[i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (MOV16mr addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  70099 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV16mr),
     /*  70102 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70106 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  70108 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  70112 */   GIR_RootConstrainSelectedInstOperands,
     /*  70113 */   // GIR_Coverage, 22512,
     /*  70113 */   GIR_EraseRootFromParent_Done,
     /*  70114 */ // Label 1603: @70114
     /*  70114 */ GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(70156), // Rule ID 33 //
     /*  70119 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70122 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  70126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  70130 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  70134 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70141 */   // (st GR16:{ *:[i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOV16mr addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  70141 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV16mr),
     /*  70144 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70148 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  70150 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  70154 */   GIR_RootConstrainSelectedInstOperands,
     /*  70155 */   // GIR_Coverage, 33,
     /*  70155 */   GIR_EraseRootFromParent_Done,
     /*  70156 */ // Label 1604: @70156
     /*  70156 */ GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(70201), // Rule ID 4622 //
     /*  70161 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  70164 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70167 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  70171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  70175 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  70179 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70186 */   // (st FR16X:{ *:[f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVSHZmr addr:{ *:[iPTR] }:$dst, FR16X:{ *:[f16] }:$src)
     /*  70186 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSHZmr),
     /*  70189 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70193 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  70195 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  70199 */   GIR_RootConstrainSelectedInstOperands,
     /*  70200 */   // GIR_Coverage, 4622,
     /*  70200 */   GIR_EraseRootFromParent_Done,
     /*  70201 */ // Label 1605: @70201
     /*  70201 */ GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(70267), // Rule ID 18547 //
     /*  70206 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /*  70209 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70212 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  70216 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  70220 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70227 */   // (st f16:{ *:[f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PEXTRWmri addr:{ *:[iPTR] }:$dst, (COPY_TO_REGCLASS:{ *:[v8i16] } FR16:{ *:[f16] }:$src, VR128:{ *:[i32] }), 0:{ *:[i8] })
     /*  70227 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  70230 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70234 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  70239 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // src
     /*  70243 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR128RegClassID),
     /*  70248 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PEXTRWmri),
     /*  70251 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70255 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  70258 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  70261 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  70265 */   GIR_RootConstrainSelectedInstOperands,
     /*  70266 */   // GIR_Coverage, 18547,
     /*  70266 */   GIR_EraseRootFromParent_Done,
     /*  70267 */ // Label 1606: @70267
     /*  70267 */ GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(70333), // Rule ID 18548 //
     /*  70272 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoBWI),
     /*  70275 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70278 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  70282 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  70286 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70293 */   // (st f16:{ *:[f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VPEXTRWmri addr:{ *:[iPTR] }:$dst, (COPY_TO_REGCLASS:{ *:[v8i16] } FR16:{ *:[f16] }:$src, VR128:{ *:[i32] }), 0:{ *:[i8] })
     /*  70293 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  70296 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70300 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  70305 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // src
     /*  70309 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR128RegClassID),
     /*  70314 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPEXTRWmri),
     /*  70317 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70321 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  70324 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  70327 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  70331 */   GIR_RootConstrainSelectedInstOperands,
     /*  70332 */   // GIR_Coverage, 18548,
     /*  70332 */   GIR_EraseRootFromParent_Done,
     /*  70333 */ // Label 1607: @70333
     /*  70333 */ GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(70445), // Rule ID 18336 //
     /*  70338 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  70341 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70344 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  70348 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  70352 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70359 */   // (st f16:{ *:[f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOV16mr addr:{ *:[iPTR] }:$dst, (EXTRACT_SUBREG:{ *:[i16] } (PEXTRWrri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[v8i16] } FR16:{ *:[f16] }:$src, VR128:{ *:[i32] }), 0:{ *:[i8] }), sub_16bit:{ *:[i32] }))
     /*  70359 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  70362 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70366 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  70371 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/0, // src
     /*  70375 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR128RegClassID),
     /*  70380 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  70383 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(X86::PEXTRWrri),
     /*  70387 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  70392 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  70395 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /*  70398 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  70400 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  70403 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70407 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  70412 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  70419 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  70424 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  70429 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV16mr),
     /*  70432 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70436 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  70439 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  70443 */   GIR_RootConstrainSelectedInstOperands,
     /*  70444 */   // GIR_Coverage, 18336,
     /*  70444 */   GIR_EraseRootFromParent_Done,
     /*  70445 */ // Label 1608: @70445
     /*  70445 */ GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(70511), // Rule ID 21840 //
     /*  70450 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  70453 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70456 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  70460 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  70464 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70471 */   // (st f16:{ *:[f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VPEXTRWZmri addr:{ *:[iPTR] }:$dst, (COPY_TO_REGCLASS:{ *:[v8i16] } FR16:{ *:[f16] }:$src, VR128:{ *:[i32] }), 0:{ *:[i8] })
     /*  70471 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  70474 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70478 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  70483 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // src
     /*  70487 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR128RegClassID),
     /*  70492 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPEXTRWZmri),
     /*  70495 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70499 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  70502 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  70505 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  70509 */   GIR_RootConstrainSelectedInstOperands,
     /*  70510 */   // GIR_Coverage, 21840,
     /*  70510 */   GIR_EraseRootFromParent_Done,
     /*  70511 */ // Label 1609: @70511
     /*  70511 */ GIM_Reject,
     /*  70512 */ // Label 1477: @70512
     /*  70512 */ GIM_Try, /*On fail goto*//*Label 1610*/ GIMT_Encode4(70608), // Rule ID 22493 //
     /*  70517 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  70520 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  70523 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  70530 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  70534 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  70538 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70542 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70546 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70550 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  70554 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  70557 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  70561 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  70568 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  70572 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  70576 */   // MIs[0] dst
     /*  70576 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70581 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70583 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70590 */   // (atomic_store (add:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, 1:{ *:[i32] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (INC32m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  70590 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC32m),
     /*  70593 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70597 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  70600 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  70606 */   GIR_RootConstrainSelectedInstOperands,
     /*  70607 */   // GIR_Coverage, 22493,
     /*  70607 */   GIR_EraseRootFromParent_Done,
     /*  70608 */ // Label 1610: @70608
     /*  70608 */ GIM_Try, /*On fail goto*//*Label 1611*/ GIMT_Encode4(70704), // Rule ID 22497 //
     /*  70613 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  70616 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  70619 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  70626 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  70630 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  70634 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70638 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70642 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70646 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  70650 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  70653 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  70657 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  70664 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  70668 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  70672 */   // MIs[0] dst
     /*  70672 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70677 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70679 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70686 */   // (atomic_store (add:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, -1:{ *:[i32] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (DEC32m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  70686 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC32m),
     /*  70689 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70693 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  70696 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  70702 */   GIR_RootConstrainSelectedInstOperands,
     /*  70703 */   // GIR_Coverage, 22497,
     /*  70703 */   GIR_EraseRootFromParent_Done,
     /*  70704 */ // Label 1611: @70704
     /*  70704 */ GIM_Try, /*On fail goto*//*Label 1612*/ GIMT_Encode4(70797), // Rule ID 22501 //
     /*  70709 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  70712 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  70719 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  70723 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  70727 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70731 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70735 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  70739 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70743 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  70747 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  70750 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  70754 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  70761 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  70765 */   // MIs[0] dst
     /*  70765 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70770 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70772 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70779 */   // (atomic_store (sub:{ *:[i32] } 0:{ *:[i32] }, (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (NEG32m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  70779 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG32m),
     /*  70782 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70786 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  70789 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  70795 */   GIR_RootConstrainSelectedInstOperands,
     /*  70796 */   // GIR_Coverage, 22501,
     /*  70796 */   GIR_EraseRootFromParent_Done,
     /*  70797 */ // Label 1612: @70797
     /*  70797 */ GIM_Try, /*On fail goto*//*Label 1613*/ GIMT_Encode4(70887), // Rule ID 22505 //
     /*  70802 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  70805 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  70812 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  70816 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70820 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70824 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70828 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70832 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  70836 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  70839 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  70843 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  70850 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  70854 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  70858 */   // MIs[0] dst
     /*  70858 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70863 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70865 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70872 */   // (atomic_store (xor:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, -1:{ *:[i32] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (NOT32m addr:{ *:[iPTR] }:$dst)
     /*  70872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT32m),
     /*  70875 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70879 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  70885 */   GIR_RootConstrainSelectedInstOperands,
     /*  70886 */   // GIR_Coverage, 22505,
     /*  70886 */   GIR_EraseRootFromParent_Done,
     /*  70887 */ // Label 1613: @70887
     /*  70887 */ GIM_Try, /*On fail goto*//*Label 1614*/ GIMT_Encode4(70973), // Rule ID 227 //
     /*  70892 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  70895 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70898 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  70902 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  70906 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  70910 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70914 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70918 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70922 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  70926 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70929 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  70933 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  70937 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  70941 */   // MIs[0] src1
     /*  70941 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70946 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70948 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70955 */   // (st (add:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 1:{ *:[i32] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (INC32m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  70955 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC32m),
     /*  70958 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  70962 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  70965 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  70971 */   GIR_RootConstrainSelectedInstOperands,
     /*  70972 */   // GIR_Coverage, 227,
     /*  70972 */   GIR_EraseRootFromParent_Done,
     /*  70973 */ // Label 1614: @70973
     /*  70973 */ GIM_Try, /*On fail goto*//*Label 1615*/ GIMT_Encode4(71059), // Rule ID 230 //
     /*  70978 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  70981 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70984 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  70988 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  70992 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  70996 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71000 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71004 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71008 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71012 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71015 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71019 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  71023 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  71027 */   // MIs[0] src1
     /*  71027 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71032 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71034 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71041 */   // (st (add:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, -1:{ *:[i32] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (DEC32m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  71041 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC32m),
     /*  71044 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  71048 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71051 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  71057 */   GIR_RootConstrainSelectedInstOperands,
     /*  71058 */   // GIR_Coverage, 230,
     /*  71058 */   GIR_EraseRootFromParent_Done,
     /*  71059 */ // Label 1615: @71059
     /*  71059 */ GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(71152), // Rule ID 22615 //
     /*  71064 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71067 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  71071 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71075 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  71079 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71083 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71087 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71091 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71095 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71098 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71102 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  71106 */   GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(128),
     /*  71117 */   // MIs[0] dst
     /*  71117 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71122 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71124 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71131 */   // (st (add:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 128:{ *:[i32] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB32mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, -128:{ *:[i32] })
     /*  71131 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32mi),
     /*  71134 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  71138 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*  71141 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71144 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  71150 */   GIR_RootConstrainSelectedInstOperands,
     /*  71151 */   // GIR_Coverage, 22615,
     /*  71151 */   GIR_EraseRootFromParent_Done,
     /*  71152 */ // Label 1616: @71152
     /*  71152 */ GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(71235), // Rule ID 17614 //
     /*  71157 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71160 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  71164 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71168 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  71172 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71176 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  71180 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71184 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71188 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71191 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71195 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  71199 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 31,
     /*  71203 */   // MIs[0] dst
     /*  71203 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71208 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71210 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71217 */   // (st (rotl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 31:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR32m1:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  71217 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32m1),
     /*  71220 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  71224 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71227 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  71233 */   GIR_RootConstrainSelectedInstOperands,
     /*  71234 */   // GIR_Coverage, 17614,
     /*  71234 */   GIR_EraseRootFromParent_Done,
     /*  71235 */ // Label 1617: @71235
     /*  71235 */ GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(71318), // Rule ID 17618 //
     /*  71240 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71243 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  71247 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71251 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  71255 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71259 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  71263 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71267 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71271 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71274 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71278 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  71282 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 31,
     /*  71286 */   // MIs[0] dst
     /*  71286 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71291 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71293 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71300 */   // (st (rotr:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 31:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL32m1:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  71300 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32m1),
     /*  71303 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  71307 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71310 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  71316 */   GIR_RootConstrainSelectedInstOperands,
     /*  71317 */   // GIR_Coverage, 17618,
     /*  71317 */   GIR_EraseRootFromParent_Done,
     /*  71318 */ // Label 1618: @71318
     /*  71318 */ GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(71401), // Rule ID 263 //
     /*  71323 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71326 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  71330 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71334 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  71338 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71342 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71346 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  71350 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71354 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71358 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71361 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71365 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  71369 */   // MIs[0] src1
     /*  71369 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71374 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71376 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71383 */   // (st (sub:{ *:[i32] } 0:{ *:[i32] }, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (NEG32m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  71383 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG32m),
     /*  71386 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  71390 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71393 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  71399 */   GIR_RootConstrainSelectedInstOperands,
     /*  71400 */   // GIR_Coverage, 263,
     /*  71400 */   GIR_EraseRootFromParent_Done,
     /*  71401 */ // Label 1619: @71401
     /*  71401 */ GIM_Try, /*On fail goto*//*Label 1620*/ GIMT_Encode4(71481), // Rule ID 271 //
     /*  71406 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71409 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  71413 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71417 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71421 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71425 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71429 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71433 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71437 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71440 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71444 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  71448 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  71452 */   // MIs[0] src1
     /*  71452 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71457 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71459 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71466 */   // (st (xor:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, -1:{ *:[i32] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (NOT32m addr:{ *:[iPTR] }:$src1)
     /*  71466 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT32m),
     /*  71469 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  71473 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  71479 */   GIR_RootConstrainSelectedInstOperands,
     /*  71480 */   // GIR_Coverage, 271,
     /*  71480 */   GIR_EraseRootFromParent_Done,
     /*  71481 */ // Label 1620: @71481
     /*  71481 */ GIM_Try, /*On fail goto*//*Label 1621*/ GIMT_Encode4(71576), // Rule ID 415 //
     /*  71486 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71489 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  71493 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71497 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  71501 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71505 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71509 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71513 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71517 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71520 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  71524 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71528 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  71532 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71536 */   // MIs[3] Operand 1
     /*  71536 */   // No operand predicates
     /*  71536 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  71540 */   // MIs[0] src1
     /*  71540 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71545 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  71547 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71554 */   // (st (add:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  71554 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32mi),
     /*  71557 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  71561 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  71564 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71567 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  71574 */   GIR_RootConstrainSelectedInstOperands,
     /*  71575 */   // GIR_Coverage, 415,
     /*  71575 */   GIR_EraseRootFromParent_Done,
     /*  71576 */ // Label 1621: @71576
     /*  71576 */ GIM_Try, /*On fail goto*//*Label 1622*/ GIMT_Encode4(71671), // Rule ID 307 //
     /*  71581 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71584 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  71588 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71592 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71596 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71600 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71604 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71608 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71612 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71615 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  71619 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71623 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  71627 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71631 */   // MIs[3] Operand 1
     /*  71631 */   // No operand predicates
     /*  71631 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  71635 */   // MIs[0] src1
     /*  71635 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71640 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  71642 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71649 */   // (st (and:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  71649 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32mi),
     /*  71652 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  71656 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  71659 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71662 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  71669 */   GIR_RootConstrainSelectedInstOperands,
     /*  71670 */   // GIR_Coverage, 307,
     /*  71670 */   GIR_EraseRootFromParent_Done,
     /*  71671 */ // Label 1622: @71671
     /*  71671 */ GIM_Try, /*On fail goto*//*Label 1623*/ GIMT_Encode4(71766), // Rule ID 343 //
     /*  71676 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71679 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  71683 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71687 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  71691 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71695 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71699 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71703 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71707 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71710 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  71714 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71718 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  71722 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71726 */   // MIs[3] Operand 1
     /*  71726 */   // No operand predicates
     /*  71726 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  71730 */   // MIs[0] src1
     /*  71730 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71735 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  71737 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71744 */   // (st (or:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  71744 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32mi),
     /*  71747 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  71751 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  71754 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71757 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  71764 */   GIR_RootConstrainSelectedInstOperands,
     /*  71765 */   // GIR_Coverage, 343,
     /*  71765 */   GIR_EraseRootFromParent_Done,
     /*  71766 */ // Label 1623: @71766
     /*  71766 */ GIM_Try, /*On fail goto*//*Label 1624*/ GIMT_Encode4(71861), // Rule ID 455 //
     /*  71771 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71774 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  71778 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71782 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  71786 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71790 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71794 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71798 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71802 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71805 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  71809 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71813 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  71817 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71821 */   // MIs[3] Operand 1
     /*  71821 */   // No operand predicates
     /*  71821 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  71825 */   // MIs[0] src1
     /*  71825 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71830 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  71832 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71839 */   // (st (sub:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  71839 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32mi),
     /*  71842 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  71846 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  71849 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71852 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  71859 */   GIR_RootConstrainSelectedInstOperands,
     /*  71860 */   // GIR_Coverage, 455,
     /*  71860 */   GIR_EraseRootFromParent_Done,
     /*  71861 */ // Label 1624: @71861
     /*  71861 */ GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(71956), // Rule ID 379 //
     /*  71866 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71869 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  71873 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71877 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71881 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71885 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71889 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71893 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71897 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71900 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  71904 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71908 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  71912 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71916 */   // MIs[3] Operand 1
     /*  71916 */   // No operand predicates
     /*  71916 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  71920 */   // MIs[0] src1
     /*  71920 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71925 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  71927 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71934 */   // (st (xor:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  71934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32mi),
     /*  71937 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  71941 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  71944 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71947 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  71954 */   GIR_RootConstrainSelectedInstOperands,
     /*  71955 */   // GIR_Coverage, 379,
     /*  71955 */   GIR_EraseRootFromParent_Done,
     /*  71956 */ // Label 1625: @71956
     /*  71956 */ GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(72057), // Rule ID 22429 //
     /*  71961 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  71964 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  71971 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71975 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  71979 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71983 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71987 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71991 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71995 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  71998 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  72002 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  72009 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72013 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  72017 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72021 */   // MIs[3] Operand 1
     /*  72021 */   // No operand predicates
     /*  72021 */   // MIs[0] dst
     /*  72021 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72026 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72028 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72035 */   // (atomic_store (add:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, (imm:{ *:[i32] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (ADD32mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i32] }):$src)
     /*  72035 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32mi),
     /*  72038 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  72042 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  72045 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72048 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72055 */   GIR_RootConstrainSelectedInstOperands,
     /*  72056 */   // GIR_Coverage, 22429,
     /*  72056 */   GIR_EraseRootFromParent_Done,
     /*  72057 */ // Label 1626: @72057
     /*  72057 */ GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(72158), // Rule ID 22437 //
     /*  72062 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  72065 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  72072 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72076 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72080 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72084 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72088 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72092 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72096 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  72099 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  72103 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  72110 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72114 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  72118 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72122 */   // MIs[3] Operand 1
     /*  72122 */   // No operand predicates
     /*  72122 */   // MIs[0] dst
     /*  72122 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72127 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72129 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72136 */   // (atomic_store (and:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, (imm:{ *:[i32] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (AND32mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i32] }):$src)
     /*  72136 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32mi),
     /*  72139 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  72143 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  72146 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72149 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72156 */   GIR_RootConstrainSelectedInstOperands,
     /*  72157 */   // GIR_Coverage, 22437,
     /*  72157 */   GIR_EraseRootFromParent_Done,
     /*  72158 */ // Label 1627: @72158
     /*  72158 */ GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(72259), // Rule ID 22445 //
     /*  72163 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  72166 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  72173 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72177 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  72181 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72185 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72189 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72193 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72197 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  72200 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  72204 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  72211 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72215 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  72219 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72223 */   // MIs[3] Operand 1
     /*  72223 */   // No operand predicates
     /*  72223 */   // MIs[0] dst
     /*  72223 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72228 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72230 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72237 */   // (atomic_store (or:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, (imm:{ *:[i32] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (OR32mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i32] }):$src)
     /*  72237 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32mi),
     /*  72240 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  72244 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  72247 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72250 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72257 */   GIR_RootConstrainSelectedInstOperands,
     /*  72258 */   // GIR_Coverage, 22445,
     /*  72258 */   GIR_EraseRootFromParent_Done,
     /*  72259 */ // Label 1628: @72259
     /*  72259 */ GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(72360), // Rule ID 22461 //
     /*  72264 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  72267 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  72274 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72278 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  72282 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72286 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72290 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72294 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72298 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  72301 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  72305 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  72312 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72316 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  72320 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72324 */   // MIs[3] Operand 1
     /*  72324 */   // No operand predicates
     /*  72324 */   // MIs[0] dst
     /*  72324 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72329 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72331 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72338 */   // (atomic_store (sub:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, (imm:{ *:[i32] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (SUB32mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i32] }):$src)
     /*  72338 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32mi),
     /*  72341 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  72345 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  72348 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72351 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72358 */   GIR_RootConstrainSelectedInstOperands,
     /*  72359 */   // GIR_Coverage, 22461,
     /*  72359 */   GIR_EraseRootFromParent_Done,
     /*  72360 */ // Label 1629: @72360
     /*  72360 */ GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(72461), // Rule ID 22453 //
     /*  72365 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  72368 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  72375 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72379 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72383 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72387 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72391 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72395 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72399 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  72402 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  72406 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  72413 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72417 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  72421 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72425 */   // MIs[3] Operand 1
     /*  72425 */   // No operand predicates
     /*  72425 */   // MIs[0] dst
     /*  72425 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72430 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72432 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72439 */   // (atomic_store (xor:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, (imm:{ *:[i32] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (XOR32mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i32] }):$src)
     /*  72439 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32mi),
     /*  72442 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  72446 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  72449 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72452 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72459 */   GIR_RootConstrainSelectedInstOperands,
     /*  72460 */   // GIR_Coverage, 22453,
     /*  72460 */   GIR_EraseRootFromParent_Done,
     /*  72461 */ // Label 1630: @72461
     /*  72461 */ GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(72565), // Rule ID 834 //
     /*  72466 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72469 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  72473 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72477 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSHL),
     /*  72481 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72485 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72489 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s8,
     /*  72493 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72497 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72501 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72504 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72508 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  72512 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  72517 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  72521 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72525 */   // MIs[3] Operand 1
     /*  72525 */   // No operand predicates
     /*  72525 */   // MIs[0] src1
     /*  72525 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72530 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72532 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72539 */   // (st (fshl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHLD32mri8:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /*  72539 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32mri8),
     /*  72542 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  72546 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  72550 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src3
     /*  72553 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72556 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72563 */   GIR_RootConstrainSelectedInstOperands,
     /*  72564 */   // GIR_Coverage, 834,
     /*  72564 */   GIR_EraseRootFromParent_Done,
     /*  72565 */ // Label 1631: @72565
     /*  72565 */ GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(72669), // Rule ID 858 //
     /*  72570 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72573 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  72577 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72581 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSHR),
     /*  72585 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72589 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72593 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s8,
     /*  72597 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  72602 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72606 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72610 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72613 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72617 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  72621 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  72625 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72629 */   // MIs[3] Operand 1
     /*  72629 */   // No operand predicates
     /*  72629 */   // MIs[0] src1
     /*  72629 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72634 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72636 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72643 */   // (st (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src3), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHRD32mri8:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /*  72643 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32mri8),
     /*  72646 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  72650 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  72654 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src3
     /*  72657 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72660 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72667 */   GIR_RootConstrainSelectedInstOperands,
     /*  72668 */   // GIR_Coverage, 858,
     /*  72668 */   GIR_EraseRootFromParent_Done,
     /*  72669 */ // Label 1632: @72669
     /*  72669 */ GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(72760), // Rule ID 735 //
     /*  72674 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72677 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  72681 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72685 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  72689 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72693 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  72697 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72701 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72705 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72708 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72712 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  72716 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  72720 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72724 */   // MIs[3] Operand 1
     /*  72724 */   // No operand predicates
     /*  72724 */   // MIs[0] src1
     /*  72724 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72729 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72731 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72738 */   // (st (sra:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SAR32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  72738 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32mi),
     /*  72741 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  72745 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  72748 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72751 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72758 */   GIR_RootConstrainSelectedInstOperands,
     /*  72759 */   // GIR_Coverage, 735,
     /*  72759 */   GIR_EraseRootFromParent_Done,
     /*  72760 */ // Label 1633: @72760
     /*  72760 */ GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(72851), // Rule ID 703 //
     /*  72765 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72768 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  72772 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72776 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  72780 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72784 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  72788 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72792 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72796 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72799 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72803 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  72807 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  72811 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72815 */   // MIs[3] Operand 1
     /*  72815 */   // No operand predicates
     /*  72815 */   // MIs[0] src1
     /*  72815 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72820 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72822 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72829 */   // (st (srl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHR32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  72829 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32mi),
     /*  72832 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  72836 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  72839 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72842 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72849 */   GIR_RootConstrainSelectedInstOperands,
     /*  72850 */   // GIR_Coverage, 703,
     /*  72850 */   GIR_EraseRootFromParent_Done,
     /*  72851 */ // Label 1634: @72851
     /*  72851 */ GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(72942), // Rule ID 767 //
     /*  72856 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72859 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  72863 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72867 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  72871 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72875 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  72879 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72883 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72887 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72890 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72894 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  72898 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  72902 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72906 */   // MIs[3] Operand 1
     /*  72906 */   // No operand predicates
     /*  72906 */   // MIs[0] src1
     /*  72906 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72911 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72913 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72920 */   // (st (rotl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  72920 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32mi),
     /*  72923 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  72927 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  72930 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72933 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72940 */   GIR_RootConstrainSelectedInstOperands,
     /*  72941 */   // GIR_Coverage, 767,
     /*  72941 */   GIR_EraseRootFromParent_Done,
     /*  72942 */ // Label 1635: @72942
     /*  72942 */ GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(73033), // Rule ID 799 //
     /*  72947 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72950 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  72954 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72958 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  72962 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72966 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  72970 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72974 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72978 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72981 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72985 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  72989 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  72993 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72997 */   // MIs[3] Operand 1
     /*  72997 */   // No operand predicates
     /*  72997 */   // MIs[0] src1
     /*  72997 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73002 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  73004 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73011 */   // (st (rotr:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  73011 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32mi),
     /*  73014 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  73018 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  73021 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73024 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  73031 */   GIR_RootConstrainSelectedInstOperands,
     /*  73032 */   // GIR_Coverage, 799,
     /*  73032 */   GIR_EraseRootFromParent_Done,
     /*  73033 */ // Label 1636: @73033
     /*  73033 */ GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(73124), // Rule ID 671 //
     /*  73038 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  73041 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  73045 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73049 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  73053 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73057 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  73061 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73065 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73069 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  73072 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73076 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  73080 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  73084 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  73088 */   // MIs[3] Operand 1
     /*  73088 */   // No operand predicates
     /*  73088 */   // MIs[0] src1
     /*  73088 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73093 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  73095 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73102 */   // (st (shl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHL32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  73102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32mi),
     /*  73105 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  73109 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  73112 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73115 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  73122 */   GIR_RootConstrainSelectedInstOperands,
     /*  73123 */   // GIR_Coverage, 671,
     /*  73123 */   GIR_EraseRootFromParent_Done,
     /*  73124 */ // Label 1637: @73124
     /*  73124 */ GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(73222), // Rule ID 22433 //
     /*  73129 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73132 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73139 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73143 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  73147 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73151 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73155 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73159 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73163 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73166 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  73170 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73177 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73181 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73186 */   // MIs[0] dst
     /*  73186 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73191 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73193 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73200 */   // (atomic_store (add:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, GR32:{ *:[i32] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (ADD32mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  73200 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32mr),
     /*  73203 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  73207 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  73211 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73214 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  73220 */   GIR_RootConstrainSelectedInstOperands,
     /*  73221 */   // GIR_Coverage, 22433,
     /*  73221 */   GIR_EraseRootFromParent_Done,
     /*  73222 */ // Label 1638: @73222
     /*  73222 */ GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(73320), // Rule ID 26004 //
     /*  73227 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73230 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73237 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73241 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  73245 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73249 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73253 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73258 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73262 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73266 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73269 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  73273 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73280 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73284 */   // MIs[0] dst
     /*  73284 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73289 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73291 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73298 */   // (atomic_store (add:{ *:[i32] } GR32:{ *:[i32] }:$src, (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (ADD32mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  73298 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32mr),
     /*  73301 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  73305 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  73309 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73312 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  73318 */   GIR_RootConstrainSelectedInstOperands,
     /*  73319 */   // GIR_Coverage, 26004,
     /*  73319 */   GIR_EraseRootFromParent_Done,
     /*  73320 */ // Label 1639: @73320
     /*  73320 */ GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(73418), // Rule ID 22441 //
     /*  73325 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73328 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73335 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73339 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73343 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73347 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73351 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73355 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73359 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73362 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  73366 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73373 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73377 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73382 */   // MIs[0] dst
     /*  73382 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73387 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73389 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73396 */   // (atomic_store (and:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, GR32:{ *:[i32] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (AND32mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  73396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32mr),
     /*  73399 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  73403 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  73407 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73410 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  73416 */   GIR_RootConstrainSelectedInstOperands,
     /*  73417 */   // GIR_Coverage, 22441,
     /*  73417 */   GIR_EraseRootFromParent_Done,
     /*  73418 */ // Label 1640: @73418
     /*  73418 */ GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(73516), // Rule ID 26008 //
     /*  73423 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73426 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73433 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73437 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73441 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73445 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73449 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73454 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73458 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73462 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73465 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  73469 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73476 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73480 */   // MIs[0] dst
     /*  73480 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73485 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73487 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73494 */   // (atomic_store (and:{ *:[i32] } GR32:{ *:[i32] }:$src, (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (AND32mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  73494 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32mr),
     /*  73497 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  73501 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  73505 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73508 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  73514 */   GIR_RootConstrainSelectedInstOperands,
     /*  73515 */   // GIR_Coverage, 26008,
     /*  73515 */   GIR_EraseRootFromParent_Done,
     /*  73516 */ // Label 1641: @73516
     /*  73516 */ GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(73614), // Rule ID 22449 //
     /*  73521 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73524 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73531 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73535 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  73539 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73543 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73547 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73551 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73555 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73558 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  73562 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73569 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73573 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73578 */   // MIs[0] dst
     /*  73578 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73583 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73585 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73592 */   // (atomic_store (or:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, GR32:{ *:[i32] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (OR32mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  73592 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32mr),
     /*  73595 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  73599 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  73603 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73606 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  73612 */   GIR_RootConstrainSelectedInstOperands,
     /*  73613 */   // GIR_Coverage, 22449,
     /*  73613 */   GIR_EraseRootFromParent_Done,
     /*  73614 */ // Label 1642: @73614
     /*  73614 */ GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(73712), // Rule ID 26012 //
     /*  73619 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73622 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73629 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73633 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  73637 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73641 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73645 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73650 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73654 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73658 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73661 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  73665 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73672 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73676 */   // MIs[0] dst
     /*  73676 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73681 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73683 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73690 */   // (atomic_store (or:{ *:[i32] } GR32:{ *:[i32] }:$src, (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (OR32mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  73690 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32mr),
     /*  73693 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  73697 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  73701 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73704 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  73710 */   GIR_RootConstrainSelectedInstOperands,
     /*  73711 */   // GIR_Coverage, 26012,
     /*  73711 */   GIR_EraseRootFromParent_Done,
     /*  73712 */ // Label 1643: @73712
     /*  73712 */ GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(73810), // Rule ID 22465 //
     /*  73717 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73720 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73727 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73731 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  73735 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73739 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73743 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73747 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73751 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73754 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  73758 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73765 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73769 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73774 */   // MIs[0] dst
     /*  73774 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73779 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73781 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73788 */   // (atomic_store (sub:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, GR32:{ *:[i32] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (SUB32mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  73788 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32mr),
     /*  73791 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  73795 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  73799 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73802 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  73808 */   GIR_RootConstrainSelectedInstOperands,
     /*  73809 */   // GIR_Coverage, 22465,
     /*  73809 */   GIR_EraseRootFromParent_Done,
     /*  73810 */ // Label 1644: @73810
     /*  73810 */ GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(73908), // Rule ID 22457 //
     /*  73815 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73818 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73825 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73829 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73833 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73837 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73841 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73845 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73849 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73852 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  73856 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73863 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73867 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73872 */   // MIs[0] dst
     /*  73872 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73877 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73879 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73886 */   // (atomic_store (xor:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, GR32:{ *:[i32] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (XOR32mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  73886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32mr),
     /*  73889 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  73893 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  73897 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73900 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  73906 */   GIR_RootConstrainSelectedInstOperands,
     /*  73907 */   // GIR_Coverage, 22457,
     /*  73907 */   GIR_EraseRootFromParent_Done,
     /*  73908 */ // Label 1645: @73908
     /*  73908 */ GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(74006), // Rule ID 26016 //
     /*  73913 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73916 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73923 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73927 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73931 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73935 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73939 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73944 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73948 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73952 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73955 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  73959 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73966 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73970 */   // MIs[0] dst
     /*  73970 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73975 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73977 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73984 */   // (atomic_store (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (XOR32mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  73984 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32mr),
     /*  73987 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  73991 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  73995 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73998 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74004 */   GIR_RootConstrainSelectedInstOperands,
     /*  74005 */   // GIR_Coverage, 26016,
     /*  74005 */   GIR_EraseRootFromParent_Done,
     /*  74006 */ // Label 1646: @74006
     /*  74006 */ GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(74117), // Rule ID 837 //
     /*  74011 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74014 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74018 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74022 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSHL),
     /*  74026 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74030 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  74034 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s8,
     /*  74038 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74042 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74046 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74049 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74053 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  74057 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  74062 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  74067 */   // MIs[0] src1
     /*  74067 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74072 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74074 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74081 */   // (st (fshl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src2, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHLD32mrCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  74081 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74085 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74091 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // CL
     /*  74095 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32mrCL),
     /*  74098 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74102 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  74106 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74109 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74115 */   GIR_RootConstrainSelectedInstOperands,
     /*  74116 */   // GIR_Coverage, 837,
     /*  74116 */   GIR_EraseRootFromParent_Done,
     /*  74117 */ // Label 1647: @74117
     /*  74117 */ GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(74228), // Rule ID 861 //
     /*  74122 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74125 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74129 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74133 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSHR),
     /*  74137 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74141 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  74145 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s8,
     /*  74149 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  74154 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74158 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74162 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74165 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74169 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  74173 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  74178 */   // MIs[0] src1
     /*  74178 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74183 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74185 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74192 */   // (st (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHRD32mrCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  74192 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74196 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74202 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // CL
     /*  74206 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32mrCL),
     /*  74209 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74213 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  74217 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74220 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74226 */   GIR_RootConstrainSelectedInstOperands,
     /*  74227 */   // GIR_Coverage, 861,
     /*  74227 */   GIR_EraseRootFromParent_Done,
     /*  74228 */ // Label 1648: @74228
     /*  74228 */ GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(74316), // Rule ID 411 //
     /*  74233 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74236 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74240 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74244 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  74248 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74252 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  74256 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74260 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74264 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74267 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  74271 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74275 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  74280 */   // MIs[0] src1
     /*  74280 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74285 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74287 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74294 */   // (st (add:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR32:{ *:[i32] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD32mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  74294 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32mr),
     /*  74297 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74301 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  74305 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74308 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74314 */   GIR_RootConstrainSelectedInstOperands,
     /*  74315 */   // GIR_Coverage, 411,
     /*  74315 */   GIR_EraseRootFromParent_Done,
     /*  74316 */ // Label 1649: @74316
     /*  74316 */ GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(74404), // Rule ID 23224 //
     /*  74321 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74324 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74328 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74332 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  74336 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74340 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  74344 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  74349 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74353 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74357 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74360 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  74364 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74368 */   // MIs[0] src1
     /*  74368 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74373 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74375 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74382 */   // (st (add:{ *:[i32] } GR32:{ *:[i32] }:$src2, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD32mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  74382 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32mr),
     /*  74385 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74389 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  74393 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74396 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74402 */   GIR_RootConstrainSelectedInstOperands,
     /*  74403 */   // GIR_Coverage, 23224,
     /*  74403 */   GIR_EraseRootFromParent_Done,
     /*  74404 */ // Label 1650: @74404
     /*  74404 */ GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(74492), // Rule ID 303 //
     /*  74409 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74412 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74416 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74420 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74424 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74428 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  74432 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74436 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74440 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74443 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  74447 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74451 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  74456 */   // MIs[0] src1
     /*  74456 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74461 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74463 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74470 */   // (st (and:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR32:{ *:[i32] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND32mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  74470 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32mr),
     /*  74473 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74477 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  74481 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74484 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74490 */   GIR_RootConstrainSelectedInstOperands,
     /*  74491 */   // GIR_Coverage, 303,
     /*  74491 */   GIR_EraseRootFromParent_Done,
     /*  74492 */ // Label 1651: @74492
     /*  74492 */ GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(74580), // Rule ID 23188 //
     /*  74497 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74500 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74504 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74508 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74512 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74516 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  74520 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  74525 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74529 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74533 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74536 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  74540 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74544 */   // MIs[0] src1
     /*  74544 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74549 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74551 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74558 */   // (st (and:{ *:[i32] } GR32:{ *:[i32] }:$src2, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND32mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  74558 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32mr),
     /*  74561 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74565 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  74569 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74572 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74578 */   GIR_RootConstrainSelectedInstOperands,
     /*  74579 */   // GIR_Coverage, 23188,
     /*  74579 */   GIR_EraseRootFromParent_Done,
     /*  74580 */ // Label 1652: @74580
     /*  74580 */ GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(74678), // Rule ID 751 //
     /*  74585 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74588 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74592 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74596 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  74600 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74604 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  74608 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74612 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74616 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74619 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74623 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  74627 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  74632 */   // MIs[0] src1
     /*  74632 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74637 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74639 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74646 */   // (st (sra:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SAR32mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  74646 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74650 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74656 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  74660 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32mCL),
     /*  74663 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74667 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74670 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74676 */   GIR_RootConstrainSelectedInstOperands,
     /*  74677 */   // GIR_Coverage, 751,
     /*  74677 */   GIR_EraseRootFromParent_Done,
     /*  74678 */ // Label 1653: @74678
     /*  74678 */ GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(74776), // Rule ID 719 //
     /*  74683 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74686 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74690 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74694 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  74698 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74702 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  74706 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74710 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74714 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74717 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74721 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  74725 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  74730 */   // MIs[0] src1
     /*  74730 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74735 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74737 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74744 */   // (st (srl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHR32mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  74744 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74748 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74754 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  74758 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32mCL),
     /*  74761 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74765 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74768 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74774 */   GIR_RootConstrainSelectedInstOperands,
     /*  74775 */   // GIR_Coverage, 719,
     /*  74775 */   GIR_EraseRootFromParent_Done,
     /*  74776 */ // Label 1654: @74776
     /*  74776 */ GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(74864), // Rule ID 339 //
     /*  74781 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74784 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74788 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74792 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  74796 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74800 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  74804 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74808 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74812 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74815 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  74819 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74823 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  74828 */   // MIs[0] src1
     /*  74828 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74833 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74835 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74842 */   // (st (or:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR32:{ *:[i32] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR32mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  74842 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32mr),
     /*  74845 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74849 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  74853 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74856 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74862 */   GIR_RootConstrainSelectedInstOperands,
     /*  74863 */   // GIR_Coverage, 339,
     /*  74863 */   GIR_EraseRootFromParent_Done,
     /*  74864 */ // Label 1655: @74864
     /*  74864 */ GIM_Try, /*On fail goto*//*Label 1656*/ GIMT_Encode4(74952), // Rule ID 23200 //
     /*  74869 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74872 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74876 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74880 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  74884 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74888 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  74892 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  74897 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74901 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74905 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74908 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  74912 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74916 */   // MIs[0] src1
     /*  74916 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74921 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74923 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74930 */   // (st (or:{ *:[i32] } GR32:{ *:[i32] }:$src2, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR32mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  74930 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32mr),
     /*  74933 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74937 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  74941 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74944 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74950 */   GIR_RootConstrainSelectedInstOperands,
     /*  74951 */   // GIR_Coverage, 23200,
     /*  74951 */   GIR_EraseRootFromParent_Done,
     /*  74952 */ // Label 1656: @74952
     /*  74952 */ GIM_Try, /*On fail goto*//*Label 1657*/ GIMT_Encode4(75050), // Rule ID 783 //
     /*  74957 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74960 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74964 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74968 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  74972 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74976 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  74980 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74984 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74988 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74991 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74995 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  74999 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  75004 */   // MIs[0] src1
     /*  75004 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  75009 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  75011 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75018 */   // (st (rotl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL32mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  75018 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  75022 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75028 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  75032 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32mCL),
     /*  75035 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  75039 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  75042 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  75048 */   GIR_RootConstrainSelectedInstOperands,
     /*  75049 */   // GIR_Coverage, 783,
     /*  75049 */   GIR_EraseRootFromParent_Done,
     /*  75050 */ // Label 1657: @75050
     /*  75050 */ GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(75148), // Rule ID 815 //
     /*  75055 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75058 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75062 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75066 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  75070 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  75074 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  75078 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75082 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  75086 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75089 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  75093 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  75097 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  75102 */   // MIs[0] src1
     /*  75102 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  75107 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  75109 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75116 */   // (st (rotr:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR32mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  75116 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  75120 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75126 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  75130 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32mCL),
     /*  75133 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  75137 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  75140 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  75146 */   GIR_RootConstrainSelectedInstOperands,
     /*  75147 */   // GIR_Coverage, 815,
     /*  75147 */   GIR_EraseRootFromParent_Done,
     /*  75148 */ // Label 1658: @75148
     /*  75148 */ GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(75246), // Rule ID 687 //
     /*  75153 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75156 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75160 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75164 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  75168 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  75172 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  75176 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75180 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  75184 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75187 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  75191 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  75195 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  75200 */   // MIs[0] src1
     /*  75200 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  75205 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  75207 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75214 */   // (st (shl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHL32mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  75214 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  75218 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75224 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  75228 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32mCL),
     /*  75231 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  75235 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  75238 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  75244 */   GIR_RootConstrainSelectedInstOperands,
     /*  75245 */   // GIR_Coverage, 687,
     /*  75245 */   GIR_EraseRootFromParent_Done,
     /*  75246 */ // Label 1659: @75246
     /*  75246 */ GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(75334), // Rule ID 447 //
     /*  75251 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75254 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75258 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75262 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  75266 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  75270 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  75274 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75278 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  75282 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75285 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  75289 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  75293 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  75298 */   // MIs[0] src1
     /*  75298 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  75303 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  75305 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75312 */   // (st (sub:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR32:{ *:[i32] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB32mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  75312 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32mr),
     /*  75315 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  75319 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  75323 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  75326 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  75332 */   GIR_RootConstrainSelectedInstOperands,
     /*  75333 */   // GIR_Coverage, 447,
     /*  75333 */   GIR_EraseRootFromParent_Done,
     /*  75334 */ // Label 1660: @75334
     /*  75334 */ GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(75422), // Rule ID 375 //
     /*  75339 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75342 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75346 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75350 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75354 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  75358 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  75362 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75366 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  75370 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75373 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  75377 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  75381 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  75386 */   // MIs[0] src1
     /*  75386 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  75391 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  75393 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75400 */   // (st (xor:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR32:{ *:[i32] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR32mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  75400 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32mr),
     /*  75403 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  75407 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  75411 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  75414 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  75420 */   GIR_RootConstrainSelectedInstOperands,
     /*  75421 */   // GIR_Coverage, 375,
     /*  75421 */   GIR_EraseRootFromParent_Done,
     /*  75422 */ // Label 1661: @75422
     /*  75422 */ GIM_Try, /*On fail goto*//*Label 1662*/ GIMT_Encode4(75510), // Rule ID 23212 //
     /*  75427 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75430 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75434 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75438 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75442 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  75446 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  75450 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  75455 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75459 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  75463 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75466 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  75470 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  75474 */   // MIs[0] src1
     /*  75474 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  75479 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  75481 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75488 */   // (st (xor:{ *:[i32] } GR32:{ *:[i32] }:$src2, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR32mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  75488 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32mr),
     /*  75491 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  75495 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  75499 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  75502 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  75508 */   GIR_RootConstrainSelectedInstOperands,
     /*  75509 */   // GIR_Coverage, 23212,
     /*  75509 */   GIR_EraseRootFromParent_Done,
     /*  75510 */ // Label 1662: @75510
     /*  75510 */ GIM_Try, /*On fail goto*//*Label 1663*/ GIMT_Encode4(75564), // Rule ID 26 //
     /*  75515 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75518 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75522 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75526 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75530 */   // MIs[1] Operand 1
     /*  75530 */   // No operand predicates
     /*  75530 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  75534 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75538 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75540 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75547 */   // (st (imm:{ *:[i32] })<<P:Predicate_imm_su>>:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOV32mi addr:{ *:[iPTR] }:$dst, (imm:{ *:[i32] }):$src)
     /*  75547 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32mi),
     /*  75550 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75554 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src
     /*  75557 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  75562 */   GIR_RootConstrainSelectedInstOperands,
     /*  75563 */   // GIR_Coverage, 26,
     /*  75563 */   GIR_EraseRootFromParent_Done,
     /*  75564 */ // Label 1663: @75564
     /*  75564 */ GIM_Try, /*On fail goto*//*Label 1664*/ GIMT_Encode4(75630), // Rule ID 22519 //
     /*  75569 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  75572 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  75575 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  75582 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75586 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  75590 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  75594 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  75599 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75603 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75605 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75612 */   // (atomic_store (bitconvert:{ *:[i32] } FR32:{ *:[f32] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (MOVSSmr addr:{ *:[iPTR] }:$dst, FR32:{ *:[f32] }:$src)
     /*  75612 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSSmr),
     /*  75615 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75619 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  75623 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  75628 */   GIR_RootConstrainSelectedInstOperands,
     /*  75629 */   // GIR_Coverage, 22519,
     /*  75629 */   GIR_EraseRootFromParent_Done,
     /*  75630 */ // Label 1664: @75630
     /*  75630 */ GIM_Try, /*On fail goto*//*Label 1665*/ GIMT_Encode4(75696), // Rule ID 22520 //
     /*  75635 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  75638 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  75641 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  75648 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75652 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  75656 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  75660 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  75665 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75669 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75671 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75678 */   // (atomic_store (bitconvert:{ *:[i32] } FR32:{ *:[f32] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (VMOVSSmr addr:{ *:[iPTR] }:$dst, FR32:{ *:[f32] }:$src)
     /*  75678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSSmr),
     /*  75681 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75685 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  75689 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  75694 */   GIR_RootConstrainSelectedInstOperands,
     /*  75695 */   // GIR_Coverage, 22520,
     /*  75695 */   GIR_EraseRootFromParent_Done,
     /*  75696 */ // Label 1665: @75696
     /*  75696 */ GIM_Try, /*On fail goto*//*Label 1666*/ GIMT_Encode4(75762), // Rule ID 22521 //
     /*  75701 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  75704 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  75707 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  75714 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75718 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  75722 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  75726 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  75731 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75735 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75737 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75744 */   // (atomic_store (bitconvert:{ *:[i32] } FR32:{ *:[f32] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (VMOVSSZmr addr:{ *:[iPTR] }:$dst, FR32:{ *:[f32] }:$src)
     /*  75744 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSSZmr),
     /*  75747 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75751 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  75755 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  75760 */   GIR_RootConstrainSelectedInstOperands,
     /*  75761 */   // GIR_Coverage, 22521,
     /*  75761 */   GIR_EraseRootFromParent_Done,
     /*  75762 */ // Label 1666: @75762
     /*  75762 */ GIM_Try, /*On fail goto*//*Label 1667*/ GIMT_Encode4(75815), // Rule ID 22509 //
     /*  75767 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  75770 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  75777 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75781 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75785 */   // MIs[1] Operand 1
     /*  75785 */   // No operand predicates
     /*  75785 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75789 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75791 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75798 */   // (atomic_store (imm:{ *:[i32] }):$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (MOV32mi addr:{ *:[iPTR] }:$dst, (imm:{ *:[i32] }):$src)
     /*  75798 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32mi),
     /*  75801 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75805 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src
     /*  75808 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  75813 */   GIR_RootConstrainSelectedInstOperands,
     /*  75814 */   // GIR_Coverage, 22509,
     /*  75814 */   GIR_EraseRootFromParent_Done,
     /*  75815 */ // Label 1667: @75815
     /*  75815 */ GIM_Try, /*On fail goto*//*Label 1668*/ GIMT_Encode4(75878), // Rule ID 52 //
     /*  75820 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_NoEGPR),
     /*  75823 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75826 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75830 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75834 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /*  75838 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  75842 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  75847 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75851 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75853 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75860 */   // (st (bswap:{ *:[i32] } GR32:{ *:[i32] }:$src1), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVBE32mr addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src1)
     /*  75860 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE32mr),
     /*  75863 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75867 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  75871 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  75876 */   GIR_RootConstrainSelectedInstOperands,
     /*  75877 */   // GIR_Coverage, 52,
     /*  75877 */   GIR_EraseRootFromParent_Done,
     /*  75878 */ // Label 1668: @75878
     /*  75878 */ GIM_Try, /*On fail goto*//*Label 1669*/ GIMT_Encode4(75941), // Rule ID 58 //
     /*  75883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVBE_In64BitMode),
     /*  75886 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75889 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75893 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75897 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /*  75901 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  75905 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  75910 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75914 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75916 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75923 */   // (st (bswap:{ *:[i32] } GR32:{ *:[i32] }:$src1), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVBE32mr_EVEX addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src1)
     /*  75923 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE32mr_EVEX),
     /*  75926 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75930 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  75934 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  75939 */   GIR_RootConstrainSelectedInstOperands,
     /*  75940 */   // GIR_Coverage, 58,
     /*  75940 */   GIR_EraseRootFromParent_Done,
     /*  75941 */ // Label 1669: @75941
     /*  75941 */ GIM_Try, /*On fail goto*//*Label 1670*/ GIMT_Encode4(75986), // Rule ID 22513 //
     /*  75946 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  75949 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  75956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  75960 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75964 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75971 */   // (atomic_store GR32:{ *:[i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (MOV32mr addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  75971 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32mr),
     /*  75974 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75978 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  75980 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75984 */   GIR_RootConstrainSelectedInstOperands,
     /*  75985 */   // GIR_Coverage, 22513,
     /*  75985 */   GIR_EraseRootFromParent_Done,
     /*  75986 */ // Label 1670: @75986
     /*  75986 */ GIM_Try, /*On fail goto*//*Label 1671*/ GIMT_Encode4(76028), // Rule ID 34 //
     /*  75991 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75994 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  76002 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76006 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76013 */   // (st GR32:{ *:[i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOV32mr addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  76013 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32mr),
     /*  76016 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  76020 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  76022 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76026 */   GIR_RootConstrainSelectedInstOperands,
     /*  76027 */   // GIR_Coverage, 34,
     /*  76027 */   GIR_EraseRootFromParent_Done,
     /*  76028 */ // Label 1671: @76028
     /*  76028 */ GIM_Try, /*On fail goto*//*Label 1672*/ GIMT_Encode4(76076), // Rule ID 1095 //
     /*  76033 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /*  76036 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76039 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /*  76047 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76051 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76058 */   // (st RFP32:{ *:[f32] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST_Fp32m:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP32:{ *:[f32] }:$src)
     /*  76058 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ST_Fp32m),
     /*  76061 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /*  76065 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  76067 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  76070 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76074 */   GIR_RootConstrainSelectedInstOperands,
     /*  76075 */   // GIR_Coverage, 1095,
     /*  76075 */   GIR_EraseRootFromParent_Done,
     /*  76076 */ // Label 1672: @76076
     /*  76076 */ GIM_Try, /*On fail goto*//*Label 1673*/ GIMT_Encode4(76121), // Rule ID 1688 //
     /*  76081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  76084 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76087 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  76095 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76099 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76106 */   // (st FR32:{ *:[f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVSSmr addr:{ *:[iPTR] }:$dst, FR32:{ *:[f32] }:$src)
     /*  76106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSSmr),
     /*  76109 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  76113 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  76115 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76119 */   GIR_RootConstrainSelectedInstOperands,
     /*  76120 */   // GIR_Coverage, 1688,
     /*  76120 */   GIR_EraseRootFromParent_Done,
     /*  76121 */ // Label 1673: @76121
     /*  76121 */ GIM_Try, /*On fail goto*//*Label 1674*/ GIMT_Encode4(76166), // Rule ID 1690 //
     /*  76126 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  76129 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76132 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  76140 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76144 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76151 */   // (st FR32:{ *:[f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVSSmr addr:{ *:[iPTR] }:$dst, FR32:{ *:[f32] }:$src)
     /*  76151 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSSmr),
     /*  76154 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  76158 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  76160 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76164 */   GIR_RootConstrainSelectedInstOperands,
     /*  76165 */   // GIR_Coverage, 1690,
     /*  76165 */   GIR_EraseRootFromParent_Done,
     /*  76166 */ // Label 1674: @76166
     /*  76166 */ GIM_Try, /*On fail goto*//*Label 1675*/ GIMT_Encode4(76211), // Rule ID 4610 //
     /*  76171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  76174 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76177 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /*  76185 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76189 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76196 */   // (st FR32X:{ *:[f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVSSZmr addr:{ *:[iPTR] }:$dst, FR32X:{ *:[f32] }:$src)
     /*  76196 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSSZmr),
     /*  76199 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  76203 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  76205 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76209 */   GIR_RootConstrainSelectedInstOperands,
     /*  76210 */   // GIR_Coverage, 4610,
     /*  76210 */   GIR_EraseRootFromParent_Done,
     /*  76211 */ // Label 1675: @76211
     /*  76211 */ GIM_Reject,
     /*  76212 */ // Label 1478: @76212
     /*  76212 */ GIM_Try, /*On fail goto*//*Label 1676*/ GIMT_Encode4(76308), // Rule ID 22494 //
     /*  76217 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  76220 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  76223 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  76230 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76234 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  76238 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76242 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  76246 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76250 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76254 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  76257 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76261 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  76268 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76272 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  76276 */   // MIs[0] dst
     /*  76276 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76281 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76283 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76290 */   // (atomic_store (add:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, 1:{ *:[i64] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (INC64m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  76290 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC64m),
     /*  76293 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  76297 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  76300 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  76306 */   GIR_RootConstrainSelectedInstOperands,
     /*  76307 */   // GIR_Coverage, 22494,
     /*  76307 */   GIR_EraseRootFromParent_Done,
     /*  76308 */ // Label 1676: @76308
     /*  76308 */ GIM_Try, /*On fail goto*//*Label 1677*/ GIMT_Encode4(76404), // Rule ID 22498 //
     /*  76313 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  76316 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  76319 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  76326 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76330 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  76334 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76338 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  76342 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76346 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76350 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  76353 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76357 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  76364 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76368 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  76372 */   // MIs[0] dst
     /*  76372 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76377 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76379 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76386 */   // (atomic_store (add:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, -1:{ *:[i64] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (DEC64m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  76386 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC64m),
     /*  76389 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  76393 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  76396 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  76402 */   GIR_RootConstrainSelectedInstOperands,
     /*  76403 */   // GIR_Coverage, 22498,
     /*  76403 */   GIR_EraseRootFromParent_Done,
     /*  76404 */ // Label 1677: @76404
     /*  76404 */ GIM_Try, /*On fail goto*//*Label 1678*/ GIMT_Encode4(76497), // Rule ID 22502 //
     /*  76409 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  76412 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  76419 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76423 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  76427 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76431 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  76435 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  76439 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  76443 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76447 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  76450 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76454 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  76461 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76465 */   // MIs[0] dst
     /*  76465 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76470 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76472 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76479 */   // (atomic_store (sub:{ *:[i64] } 0:{ *:[i64] }, (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (NEG64m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  76479 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG64m),
     /*  76482 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  76486 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  76489 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  76495 */   GIR_RootConstrainSelectedInstOperands,
     /*  76496 */   // GIR_Coverage, 22502,
     /*  76496 */   GIR_EraseRootFromParent_Done,
     /*  76497 */ // Label 1678: @76497
     /*  76497 */ GIM_Try, /*On fail goto*//*Label 1679*/ GIMT_Encode4(76587), // Rule ID 22506 //
     /*  76502 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  76505 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  76512 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76516 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76520 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76524 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  76528 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76532 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76536 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  76539 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76543 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  76550 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76554 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  76558 */   // MIs[0] dst
     /*  76558 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76563 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76565 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76572 */   // (atomic_store (xor:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, -1:{ *:[i64] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (NOT64m addr:{ *:[iPTR] }:$dst)
     /*  76572 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT64m),
     /*  76575 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  76579 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  76585 */   GIR_RootConstrainSelectedInstOperands,
     /*  76586 */   // GIR_Coverage, 22506,
     /*  76586 */   GIR_EraseRootFromParent_Done,
     /*  76587 */ // Label 1679: @76587
     /*  76587 */ GIM_Try, /*On fail goto*//*Label 1680*/ GIMT_Encode4(76673), // Rule ID 231 //
     /*  76592 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode_UseIncDec),
     /*  76595 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76598 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76602 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76606 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  76610 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76614 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  76618 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76622 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76626 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76629 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76633 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76637 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  76641 */   // MIs[0] src1
     /*  76641 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76646 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76648 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76655 */   // (st (add:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 1:{ *:[i64] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (INC64m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  76655 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC64m),
     /*  76658 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  76662 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  76665 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  76671 */   GIR_RootConstrainSelectedInstOperands,
     /*  76672 */   // GIR_Coverage, 231,
     /*  76672 */   GIR_EraseRootFromParent_Done,
     /*  76673 */ // Label 1680: @76673
     /*  76673 */ GIM_Try, /*On fail goto*//*Label 1681*/ GIMT_Encode4(76759), // Rule ID 232 //
     /*  76678 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode_UseIncDec),
     /*  76681 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76684 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76688 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76692 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  76696 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76700 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  76704 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76708 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76712 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76715 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76719 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76723 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  76727 */   // MIs[0] src1
     /*  76727 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76732 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76734 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76741 */   // (st (add:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, -1:{ *:[i64] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (DEC64m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  76741 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC64m),
     /*  76744 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  76748 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  76751 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  76757 */   GIR_RootConstrainSelectedInstOperands,
     /*  76758 */   // GIR_Coverage, 232,
     /*  76758 */   GIR_EraseRootFromParent_Done,
     /*  76759 */ // Label 1681: @76759
     /*  76759 */ GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(76852), // Rule ID 22616 //
     /*  76764 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76767 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76771 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76775 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  76779 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76783 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  76787 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76791 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76795 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76798 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76802 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76806 */   GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(128),
     /*  76817 */   // MIs[0] dst
     /*  76817 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76822 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76824 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76831 */   // (st (add:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 128:{ *:[i64] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB64mi32:{ *:[i32] } addr:{ *:[iPTR] }:$dst, -128:{ *:[i64] })
     /*  76831 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64mi32),
     /*  76834 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  76838 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*  76841 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  76844 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  76850 */   GIR_RootConstrainSelectedInstOperands,
     /*  76851 */   // GIR_Coverage, 22616,
     /*  76851 */   GIR_EraseRootFromParent_Done,
     /*  76852 */ // Label 1682: @76852
     /*  76852 */ GIM_Try, /*On fail goto*//*Label 1683*/ GIMT_Encode4(76952), // Rule ID 22624 //
     /*  76857 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76860 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76864 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76868 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  76872 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76876 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  76880 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76884 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76888 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76891 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76895 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76899 */   GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2147483648),
     /*  76910 */   // MIs[0] dst
     /*  76910 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76915 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76917 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76924 */   // (st (add:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 2147483648:{ *:[i64] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB64mi32:{ *:[i32] } addr:{ *:[iPTR] }:$dst, -2147483648:{ *:[i64] })
     /*  76924 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64mi32),
     /*  76927 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  76931 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(-2147483648),
     /*  76941 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  76944 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  76950 */   GIR_RootConstrainSelectedInstOperands,
     /*  76951 */   // GIR_Coverage, 22624,
     /*  76951 */   GIR_EraseRootFromParent_Done,
     /*  76952 */ // Label 1683: @76952
     /*  76952 */ GIM_Try, /*On fail goto*//*Label 1684*/ GIMT_Encode4(77038), // Rule ID 17615 //
     /*  76957 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  76960 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76963 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76967 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76971 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  76975 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76979 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  76983 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76987 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76991 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76994 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76998 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77002 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 63,
     /*  77006 */   // MIs[0] dst
     /*  77006 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77011 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  77013 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77020 */   // (st (rotl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 63:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR64m1:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  77020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64m1),
     /*  77023 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  77027 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  77030 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  77036 */   GIR_RootConstrainSelectedInstOperands,
     /*  77037 */   // GIR_Coverage, 17615,
     /*  77037 */   GIR_EraseRootFromParent_Done,
     /*  77038 */ // Label 1684: @77038
     /*  77038 */ GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(77124), // Rule ID 17619 //
     /*  77043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  77046 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77049 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  77053 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77057 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  77061 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77065 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  77069 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77073 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77077 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77080 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77084 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77088 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 63,
     /*  77092 */   // MIs[0] dst
     /*  77092 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77097 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  77099 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77106 */   // (st (rotr:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 63:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL64m1:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  77106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64m1),
     /*  77109 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  77113 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  77116 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  77122 */   GIR_RootConstrainSelectedInstOperands,
     /*  77123 */   // GIR_Coverage, 17619,
     /*  77123 */   GIR_EraseRootFromParent_Done,
     /*  77124 */ // Label 1685: @77124
     /*  77124 */ GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(77210), // Rule ID 264 //
     /*  77129 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  77132 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77135 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  77139 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77143 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  77147 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77151 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  77155 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  77159 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  77163 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77167 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77170 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77174 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77178 */   // MIs[0] src1
     /*  77178 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77183 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  77185 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77192 */   // (st (sub:{ *:[i64] } 0:{ *:[i64] }, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (NEG64m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  77192 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG64m),
     /*  77195 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  77199 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  77202 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  77208 */   GIR_RootConstrainSelectedInstOperands,
     /*  77209 */   // GIR_Coverage, 264,
     /*  77209 */   GIR_EraseRootFromParent_Done,
     /*  77210 */ // Label 1686: @77210
     /*  77210 */ GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(77293), // Rule ID 272 //
     /*  77215 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  77218 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77221 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  77225 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77229 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77233 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77237 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  77241 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77245 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77249 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77252 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77256 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77260 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  77264 */   // MIs[0] src1
     /*  77264 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77269 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  77271 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77278 */   // (st (xor:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, -1:{ *:[i64] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (NOT64m addr:{ *:[iPTR] }:$src1)
     /*  77278 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT64m),
     /*  77281 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  77285 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  77291 */   GIR_RootConstrainSelectedInstOperands,
     /*  77292 */   // GIR_Coverage, 272,
     /*  77292 */   GIR_EraseRootFromParent_Done,
     /*  77293 */ // Label 1687: @77293
     /*  77293 */ GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(77398), // Rule ID 22430 //
     /*  77298 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77301 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77308 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77312 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  77316 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77320 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  77324 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77328 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77332 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77335 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77339 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77346 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77350 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  77354 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77358 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  77362 */   // MIs[3] Operand 1
     /*  77362 */   // No operand predicates
     /*  77362 */   // MIs[0] dst
     /*  77362 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77367 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77369 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77376 */   // (atomic_store (add:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (ADD64mi32:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src)
     /*  77376 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64mi32),
     /*  77379 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  77383 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  77386 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  77389 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  77396 */   GIR_RootConstrainSelectedInstOperands,
     /*  77397 */   // GIR_Coverage, 22430,
     /*  77397 */   GIR_EraseRootFromParent_Done,
     /*  77398 */ // Label 1688: @77398
     /*  77398 */ GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(77503), // Rule ID 22438 //
     /*  77403 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77406 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77413 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77417 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77421 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77425 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  77429 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77433 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77437 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77440 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77444 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77451 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77455 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  77459 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77463 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  77467 */   // MIs[3] Operand 1
     /*  77467 */   // No operand predicates
     /*  77467 */   // MIs[0] dst
     /*  77467 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77472 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77474 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77481 */   // (atomic_store (and:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (AND64mi32:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src)
     /*  77481 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64mi32),
     /*  77484 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  77488 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  77491 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  77494 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  77501 */   GIR_RootConstrainSelectedInstOperands,
     /*  77502 */   // GIR_Coverage, 22438,
     /*  77502 */   GIR_EraseRootFromParent_Done,
     /*  77503 */ // Label 1689: @77503
     /*  77503 */ GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(77608), // Rule ID 22446 //
     /*  77508 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77511 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77518 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77522 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  77526 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77530 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  77534 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77538 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77542 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77545 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77549 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77556 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77560 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  77564 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77568 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  77572 */   // MIs[3] Operand 1
     /*  77572 */   // No operand predicates
     /*  77572 */   // MIs[0] dst
     /*  77572 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77577 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77579 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77586 */   // (atomic_store (or:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (OR64mi32:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src)
     /*  77586 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64mi32),
     /*  77589 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  77593 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  77596 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  77599 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  77606 */   GIR_RootConstrainSelectedInstOperands,
     /*  77607 */   // GIR_Coverage, 22446,
     /*  77607 */   GIR_EraseRootFromParent_Done,
     /*  77608 */ // Label 1690: @77608
     /*  77608 */ GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(77713), // Rule ID 22462 //
     /*  77613 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77616 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77623 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77627 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  77631 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77635 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  77639 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77643 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77647 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77650 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77654 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77661 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77665 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  77669 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77673 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  77677 */   // MIs[3] Operand 1
     /*  77677 */   // No operand predicates
     /*  77677 */   // MIs[0] dst
     /*  77677 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77682 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77684 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77691 */   // (atomic_store (sub:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (SUB64mi32:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src)
     /*  77691 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64mi32),
     /*  77694 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  77698 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  77701 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  77704 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  77711 */   GIR_RootConstrainSelectedInstOperands,
     /*  77712 */   // GIR_Coverage, 22462,
     /*  77712 */   GIR_EraseRootFromParent_Done,
     /*  77713 */ // Label 1691: @77713
     /*  77713 */ GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(77818), // Rule ID 22454 //
     /*  77718 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77721 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77728 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77732 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77736 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77740 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  77744 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77748 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77752 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77755 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77759 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77766 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77770 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  77774 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77778 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  77782 */   // MIs[3] Operand 1
     /*  77782 */   // No operand predicates
     /*  77782 */   // MIs[0] dst
     /*  77782 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77787 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77789 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77796 */   // (atomic_store (xor:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (XOR64mi32:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src)
     /*  77796 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64mi32),
     /*  77799 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  77803 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  77806 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  77809 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  77816 */   GIR_RootConstrainSelectedInstOperands,
     /*  77817 */   // GIR_Coverage, 22454,
     /*  77817 */   GIR_EraseRootFromParent_Done,
     /*  77818 */ // Label 1692: @77818
     /*  77818 */ GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(77922), // Rule ID 835 //
     /*  77823 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77826 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  77830 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77834 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSHL),
     /*  77838 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77842 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  77846 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s8,
     /*  77850 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77854 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77858 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77861 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77865 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77869 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  77874 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  77878 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77882 */   // MIs[3] Operand 1
     /*  77882 */   // No operand predicates
     /*  77882 */   // MIs[0] src1
     /*  77882 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77887 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77889 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77896 */   // (st (fshl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHLD64mri8:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /*  77896 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64mri8),
     /*  77899 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  77903 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  77907 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src3
     /*  77910 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  77913 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  77920 */   GIR_RootConstrainSelectedInstOperands,
     /*  77921 */   // GIR_Coverage, 835,
     /*  77921 */   GIR_EraseRootFromParent_Done,
     /*  77922 */ // Label 1693: @77922
     /*  77922 */ GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(78026), // Rule ID 859 //
     /*  77927 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77930 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  77934 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77938 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSHR),
     /*  77942 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77946 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  77950 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s8,
     /*  77954 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  77959 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  77963 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77967 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77970 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77974 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77978 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  77982 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77986 */   // MIs[3] Operand 1
     /*  77986 */   // No operand predicates
     /*  77986 */   // MIs[0] src1
     /*  77986 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77991 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77993 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78000 */   // (st (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src3), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHRD64mri8:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /*  78000 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64mri8),
     /*  78003 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  78007 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  78011 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src3
     /*  78014 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78017 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  78024 */   GIR_RootConstrainSelectedInstOperands,
     /*  78025 */   // GIR_Coverage, 859,
     /*  78025 */   GIR_EraseRootFromParent_Done,
     /*  78026 */ // Label 1694: @78026
     /*  78026 */ GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(78120), // Rule ID 736 //
     /*  78031 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  78034 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  78037 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78041 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78045 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  78049 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78053 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  78057 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78061 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78065 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  78068 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  78072 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78076 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  78080 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  78084 */   // MIs[3] Operand 1
     /*  78084 */   // No operand predicates
     /*  78084 */   // MIs[0] src1
     /*  78084 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78089 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78091 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78098 */   // (st (sra:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SAR64mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  78098 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64mi),
     /*  78101 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  78105 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  78108 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78111 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  78118 */   GIR_RootConstrainSelectedInstOperands,
     /*  78119 */   // GIR_Coverage, 736,
     /*  78119 */   GIR_EraseRootFromParent_Done,
     /*  78120 */ // Label 1695: @78120
     /*  78120 */ GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(78214), // Rule ID 704 //
     /*  78125 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  78128 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  78131 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78135 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78139 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  78143 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78147 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  78151 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78155 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78159 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  78162 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  78166 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78170 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  78174 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  78178 */   // MIs[3] Operand 1
     /*  78178 */   // No operand predicates
     /*  78178 */   // MIs[0] src1
     /*  78178 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78183 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78185 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78192 */   // (st (srl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHR64mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  78192 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64mi),
     /*  78195 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  78199 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  78202 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78205 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  78212 */   GIR_RootConstrainSelectedInstOperands,
     /*  78213 */   // GIR_Coverage, 704,
     /*  78213 */   GIR_EraseRootFromParent_Done,
     /*  78214 */ // Label 1696: @78214
     /*  78214 */ GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(78308), // Rule ID 768 //
     /*  78219 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  78222 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  78225 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78229 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78233 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  78237 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78241 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  78245 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78249 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78253 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  78256 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  78260 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78264 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  78268 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  78272 */   // MIs[3] Operand 1
     /*  78272 */   // No operand predicates
     /*  78272 */   // MIs[0] src1
     /*  78272 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78277 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78279 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78286 */   // (st (rotl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL64mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  78286 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64mi),
     /*  78289 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  78293 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  78296 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78299 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  78306 */   GIR_RootConstrainSelectedInstOperands,
     /*  78307 */   // GIR_Coverage, 768,
     /*  78307 */   GIR_EraseRootFromParent_Done,
     /*  78308 */ // Label 1697: @78308
     /*  78308 */ GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(78402), // Rule ID 800 //
     /*  78313 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  78316 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  78319 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78323 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78327 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  78331 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78335 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  78339 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78343 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78347 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  78350 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  78354 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78358 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  78362 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  78366 */   // MIs[3] Operand 1
     /*  78366 */   // No operand predicates
     /*  78366 */   // MIs[0] src1
     /*  78366 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78371 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78373 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78380 */   // (st (rotr:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR64mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  78380 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64mi),
     /*  78383 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  78387 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  78390 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78393 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  78400 */   GIR_RootConstrainSelectedInstOperands,
     /*  78401 */   // GIR_Coverage, 800,
     /*  78401 */   GIR_EraseRootFromParent_Done,
     /*  78402 */ // Label 1698: @78402
     /*  78402 */ GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(78496), // Rule ID 672 //
     /*  78407 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  78410 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  78413 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78417 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78421 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  78425 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78429 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  78433 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78437 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78441 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  78444 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  78448 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78452 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  78456 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  78460 */   // MIs[3] Operand 1
     /*  78460 */   // No operand predicates
     /*  78460 */   // MIs[0] src1
     /*  78460 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78465 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78467 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78474 */   // (st (shl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHL64mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  78474 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64mi),
     /*  78477 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  78481 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  78484 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78487 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  78494 */   GIR_RootConstrainSelectedInstOperands,
     /*  78495 */   // GIR_Coverage, 672,
     /*  78495 */   GIR_EraseRootFromParent_Done,
     /*  78496 */ // Label 1699: @78496
     /*  78496 */ GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(78594), // Rule ID 22434 //
     /*  78501 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78504 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78511 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78515 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  78519 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78523 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  78527 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78531 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78535 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78538 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  78542 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78549 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78553 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  78558 */   // MIs[0] dst
     /*  78558 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78563 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78565 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78572 */   // (atomic_store (add:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, GR64:{ *:[i64] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (ADD64mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  78572 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64mr),
     /*  78575 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  78579 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  78583 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78586 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  78592 */   GIR_RootConstrainSelectedInstOperands,
     /*  78593 */   // GIR_Coverage, 22434,
     /*  78593 */   GIR_EraseRootFromParent_Done,
     /*  78594 */ // Label 1700: @78594
     /*  78594 */ GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(78692), // Rule ID 26005 //
     /*  78599 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78602 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78609 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78613 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  78617 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78621 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  78625 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  78630 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78634 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78638 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78641 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  78645 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78652 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78656 */   // MIs[0] dst
     /*  78656 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78661 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78663 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78670 */   // (atomic_store (add:{ *:[i64] } GR64:{ *:[i64] }:$src, (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (ADD64mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  78670 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64mr),
     /*  78673 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  78677 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  78681 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78684 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  78690 */   GIR_RootConstrainSelectedInstOperands,
     /*  78691 */   // GIR_Coverage, 26005,
     /*  78691 */   GIR_EraseRootFromParent_Done,
     /*  78692 */ // Label 1701: @78692
     /*  78692 */ GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(78790), // Rule ID 22442 //
     /*  78697 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78700 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78707 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78711 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78715 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78719 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  78723 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78727 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78731 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78734 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  78738 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78745 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78749 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  78754 */   // MIs[0] dst
     /*  78754 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78759 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78761 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78768 */   // (atomic_store (and:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, GR64:{ *:[i64] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (AND64mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  78768 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64mr),
     /*  78771 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  78775 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  78779 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78782 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  78788 */   GIR_RootConstrainSelectedInstOperands,
     /*  78789 */   // GIR_Coverage, 22442,
     /*  78789 */   GIR_EraseRootFromParent_Done,
     /*  78790 */ // Label 1702: @78790
     /*  78790 */ GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(78888), // Rule ID 26009 //
     /*  78795 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78798 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78805 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78809 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78813 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78817 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  78821 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  78826 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78830 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78834 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78837 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  78841 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78848 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78852 */   // MIs[0] dst
     /*  78852 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78857 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78859 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78866 */   // (atomic_store (and:{ *:[i64] } GR64:{ *:[i64] }:$src, (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (AND64mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  78866 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64mr),
     /*  78869 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  78873 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  78877 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78880 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  78886 */   GIR_RootConstrainSelectedInstOperands,
     /*  78887 */   // GIR_Coverage, 26009,
     /*  78887 */   GIR_EraseRootFromParent_Done,
     /*  78888 */ // Label 1703: @78888
     /*  78888 */ GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(78986), // Rule ID 22450 //
     /*  78893 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78896 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78903 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78907 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  78911 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78915 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  78919 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78923 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78927 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78930 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  78934 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78941 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78945 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  78950 */   // MIs[0] dst
     /*  78950 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78955 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78957 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78964 */   // (atomic_store (or:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, GR64:{ *:[i64] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (OR64mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  78964 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64mr),
     /*  78967 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  78971 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  78975 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78978 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  78984 */   GIR_RootConstrainSelectedInstOperands,
     /*  78985 */   // GIR_Coverage, 22450,
     /*  78985 */   GIR_EraseRootFromParent_Done,
     /*  78986 */ // Label 1704: @78986
     /*  78986 */ GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(79084), // Rule ID 26013 //
     /*  78991 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78994 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  79001 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79005 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  79009 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79013 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  79017 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  79022 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  79026 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79030 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  79033 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79037 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  79044 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79048 */   // MIs[0] dst
     /*  79048 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79053 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79055 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79062 */   // (atomic_store (or:{ *:[i64] } GR64:{ *:[i64] }:$src, (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (OR64mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  79062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64mr),
     /*  79065 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  79069 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  79073 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79076 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79082 */   GIR_RootConstrainSelectedInstOperands,
     /*  79083 */   // GIR_Coverage, 26013,
     /*  79083 */   GIR_EraseRootFromParent_Done,
     /*  79084 */ // Label 1705: @79084
     /*  79084 */ GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(79182), // Rule ID 22466 //
     /*  79089 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  79092 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  79099 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79103 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  79107 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79111 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  79115 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79119 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79123 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  79126 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79130 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  79137 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79141 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  79146 */   // MIs[0] dst
     /*  79146 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79151 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79153 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79160 */   // (atomic_store (sub:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, GR64:{ *:[i64] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (SUB64mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  79160 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64mr),
     /*  79163 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  79167 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  79171 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79174 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79180 */   GIR_RootConstrainSelectedInstOperands,
     /*  79181 */   // GIR_Coverage, 22466,
     /*  79181 */   GIR_EraseRootFromParent_Done,
     /*  79182 */ // Label 1706: @79182
     /*  79182 */ GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(79280), // Rule ID 22458 //
     /*  79187 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  79190 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  79197 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79201 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79205 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79209 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  79213 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79217 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79221 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  79224 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79228 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  79235 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79239 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  79244 */   // MIs[0] dst
     /*  79244 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79249 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79251 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79258 */   // (atomic_store (xor:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, GR64:{ *:[i64] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (XOR64mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  79258 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64mr),
     /*  79261 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  79265 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  79269 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79272 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79278 */   GIR_RootConstrainSelectedInstOperands,
     /*  79279 */   // GIR_Coverage, 22458,
     /*  79279 */   GIR_EraseRootFromParent_Done,
     /*  79280 */ // Label 1707: @79280
     /*  79280 */ GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(79378), // Rule ID 26017 //
     /*  79285 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  79288 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  79295 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79299 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79303 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79307 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  79311 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  79316 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  79320 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79324 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  79327 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79331 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  79338 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79342 */   // MIs[0] dst
     /*  79342 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79347 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79349 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79356 */   // (atomic_store (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (XOR64mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  79356 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64mr),
     /*  79359 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  79363 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  79367 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79370 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79376 */   GIR_RootConstrainSelectedInstOperands,
     /*  79377 */   // GIR_Coverage, 26017,
     /*  79377 */   GIR_EraseRootFromParent_Done,
     /*  79378 */ // Label 1708: @79378
     /*  79378 */ GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(79489), // Rule ID 838 //
     /*  79383 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79386 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79390 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79394 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSHL),
     /*  79398 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79402 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  79406 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s8,
     /*  79410 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79414 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79418 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79421 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79425 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79429 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  79434 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  79439 */   // MIs[0] src1
     /*  79439 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79444 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79446 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79453 */   // (st (fshl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src2, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHLD64mrCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  79453 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79457 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79463 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // CL
     /*  79467 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64mrCL),
     /*  79470 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  79474 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  79478 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79481 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79487 */   GIR_RootConstrainSelectedInstOperands,
     /*  79488 */   // GIR_Coverage, 838,
     /*  79488 */   GIR_EraseRootFromParent_Done,
     /*  79489 */ // Label 1709: @79489
     /*  79489 */ GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(79600), // Rule ID 862 //
     /*  79494 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79497 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79501 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79505 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSHR),
     /*  79509 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79513 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  79517 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s8,
     /*  79521 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  79526 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  79530 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79534 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79537 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79541 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79545 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  79550 */   // MIs[0] src1
     /*  79550 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79555 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79557 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79564 */   // (st (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHRD64mrCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  79564 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79568 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79574 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // CL
     /*  79578 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64mrCL),
     /*  79581 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  79585 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  79589 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79592 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79598 */   GIR_RootConstrainSelectedInstOperands,
     /*  79599 */   // GIR_Coverage, 862,
     /*  79599 */   GIR_EraseRootFromParent_Done,
     /*  79600 */ // Label 1710: @79600
     /*  79600 */ GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(79688), // Rule ID 412 //
     /*  79605 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79608 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79612 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79616 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  79620 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79624 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  79628 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79632 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79636 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79639 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79643 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79647 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  79652 */   // MIs[0] src1
     /*  79652 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79657 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79659 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79666 */   // (st (add:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD64mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  79666 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64mr),
     /*  79669 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  79673 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  79677 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79680 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79686 */   GIR_RootConstrainSelectedInstOperands,
     /*  79687 */   // GIR_Coverage, 412,
     /*  79687 */   GIR_EraseRootFromParent_Done,
     /*  79688 */ // Label 1711: @79688
     /*  79688 */ GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(79776), // Rule ID 23225 //
     /*  79693 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79696 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79700 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79704 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  79708 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79712 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  79716 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  79721 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  79725 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79729 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79732 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79736 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79740 */   // MIs[0] src1
     /*  79740 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79745 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79747 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79754 */   // (st (add:{ *:[i64] } GR64:{ *:[i64] }:$src2, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD64mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  79754 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64mr),
     /*  79757 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  79761 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  79765 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79768 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79774 */   GIR_RootConstrainSelectedInstOperands,
     /*  79775 */   // GIR_Coverage, 23225,
     /*  79775 */   GIR_EraseRootFromParent_Done,
     /*  79776 */ // Label 1712: @79776
     /*  79776 */ GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(79864), // Rule ID 304 //
     /*  79781 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79784 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79788 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79792 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79796 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79800 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  79804 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79808 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79812 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79815 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79819 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79823 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  79828 */   // MIs[0] src1
     /*  79828 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79833 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79835 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79842 */   // (st (and:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND64mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  79842 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64mr),
     /*  79845 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  79849 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  79853 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79856 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79862 */   GIR_RootConstrainSelectedInstOperands,
     /*  79863 */   // GIR_Coverage, 304,
     /*  79863 */   GIR_EraseRootFromParent_Done,
     /*  79864 */ // Label 1713: @79864
     /*  79864 */ GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(79952), // Rule ID 23189 //
     /*  79869 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79872 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79876 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79880 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79884 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79888 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  79892 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  79897 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  79901 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79905 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79908 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79912 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79916 */   // MIs[0] src1
     /*  79916 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79921 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79923 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79930 */   // (st (and:{ *:[i64] } GR64:{ *:[i64] }:$src2, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND64mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  79930 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64mr),
     /*  79933 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  79937 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  79941 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79944 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79950 */   GIR_RootConstrainSelectedInstOperands,
     /*  79951 */   // GIR_Coverage, 23189,
     /*  79951 */   GIR_EraseRootFromParent_Done,
     /*  79952 */ // Label 1714: @79952
     /*  79952 */ GIM_Try, /*On fail goto*//*Label 1715*/ GIMT_Encode4(80053), // Rule ID 752 //
     /*  79957 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  79960 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79963 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79967 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79971 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  79975 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79979 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  79983 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79987 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79991 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79994 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79998 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  80002 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  80007 */   // MIs[0] src1
     /*  80007 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80012 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80014 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80021 */   // (st (sra:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SAR64mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  80021 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80025 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80031 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  80035 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64mCL),
     /*  80038 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  80042 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  80045 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  80051 */   GIR_RootConstrainSelectedInstOperands,
     /*  80052 */   // GIR_Coverage, 752,
     /*  80052 */   GIR_EraseRootFromParent_Done,
     /*  80053 */ // Label 1715: @80053
     /*  80053 */ GIM_Try, /*On fail goto*//*Label 1716*/ GIMT_Encode4(80154), // Rule ID 720 //
     /*  80058 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  80061 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80064 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80068 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80072 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  80076 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80080 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  80084 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80088 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  80092 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80095 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  80099 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  80103 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  80108 */   // MIs[0] src1
     /*  80108 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80113 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80115 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80122 */   // (st (srl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHR64mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  80122 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80126 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80132 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  80136 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64mCL),
     /*  80139 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  80143 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  80146 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  80152 */   GIR_RootConstrainSelectedInstOperands,
     /*  80153 */   // GIR_Coverage, 720,
     /*  80153 */   GIR_EraseRootFromParent_Done,
     /*  80154 */ // Label 1716: @80154
     /*  80154 */ GIM_Try, /*On fail goto*//*Label 1717*/ GIMT_Encode4(80242), // Rule ID 340 //
     /*  80159 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80162 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80166 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80170 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  80174 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80178 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  80182 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80186 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  80190 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80193 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  80197 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  80201 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  80206 */   // MIs[0] src1
     /*  80206 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80211 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80213 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80220 */   // (st (or:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR64mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  80220 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64mr),
     /*  80223 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  80227 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  80231 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  80234 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  80240 */   GIR_RootConstrainSelectedInstOperands,
     /*  80241 */   // GIR_Coverage, 340,
     /*  80241 */   GIR_EraseRootFromParent_Done,
     /*  80242 */ // Label 1717: @80242
     /*  80242 */ GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(80330), // Rule ID 23201 //
     /*  80247 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80250 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80254 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80258 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  80262 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80266 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  80270 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  80275 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  80279 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  80283 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80286 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  80290 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  80294 */   // MIs[0] src1
     /*  80294 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80299 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80301 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80308 */   // (st (or:{ *:[i64] } GR64:{ *:[i64] }:$src2, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR64mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  80308 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64mr),
     /*  80311 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  80315 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  80319 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  80322 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  80328 */   GIR_RootConstrainSelectedInstOperands,
     /*  80329 */   // GIR_Coverage, 23201,
     /*  80329 */   GIR_EraseRootFromParent_Done,
     /*  80330 */ // Label 1718: @80330
     /*  80330 */ GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(80431), // Rule ID 784 //
     /*  80335 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  80338 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80341 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80345 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80349 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  80353 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80357 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  80361 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80365 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  80369 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80372 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  80376 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  80380 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  80385 */   // MIs[0] src1
     /*  80385 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80390 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80392 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80399 */   // (st (rotl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL64mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  80399 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80403 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80409 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  80413 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64mCL),
     /*  80416 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  80420 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  80423 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  80429 */   GIR_RootConstrainSelectedInstOperands,
     /*  80430 */   // GIR_Coverage, 784,
     /*  80430 */   GIR_EraseRootFromParent_Done,
     /*  80431 */ // Label 1719: @80431
     /*  80431 */ GIM_Try, /*On fail goto*//*Label 1720*/ GIMT_Encode4(80532), // Rule ID 816 //
     /*  80436 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  80439 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80442 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80446 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80450 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  80454 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80458 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  80462 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80466 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  80470 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80473 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  80477 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  80481 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  80486 */   // MIs[0] src1
     /*  80486 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80491 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80493 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80500 */   // (st (rotr:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR64mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  80500 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80504 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80510 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  80514 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64mCL),
     /*  80517 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  80521 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  80524 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  80530 */   GIR_RootConstrainSelectedInstOperands,
     /*  80531 */   // GIR_Coverage, 816,
     /*  80531 */   GIR_EraseRootFromParent_Done,
     /*  80532 */ // Label 1720: @80532
     /*  80532 */ GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(80633), // Rule ID 688 //
     /*  80537 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  80540 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80543 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80547 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80551 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  80555 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80559 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  80563 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80567 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  80571 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80574 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  80578 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  80582 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  80587 */   // MIs[0] src1
     /*  80587 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80592 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80594 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80601 */   // (st (shl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHL64mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  80601 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80605 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80611 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  80615 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64mCL),
     /*  80618 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  80622 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  80625 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  80631 */   GIR_RootConstrainSelectedInstOperands,
     /*  80632 */   // GIR_Coverage, 688,
     /*  80632 */   GIR_EraseRootFromParent_Done,
     /*  80633 */ // Label 1721: @80633
     /*  80633 */ GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(80721), // Rule ID 448 //
     /*  80638 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80641 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80645 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80649 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  80653 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80657 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  80661 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80665 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  80669 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80672 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  80676 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  80680 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  80685 */   // MIs[0] src1
     /*  80685 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80690 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80692 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80699 */   // (st (sub:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB64mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  80699 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64mr),
     /*  80702 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  80706 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  80710 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  80713 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  80719 */   GIR_RootConstrainSelectedInstOperands,
     /*  80720 */   // GIR_Coverage, 448,
     /*  80720 */   GIR_EraseRootFromParent_Done,
     /*  80721 */ // Label 1722: @80721
     /*  80721 */ GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(80809), // Rule ID 376 //
     /*  80726 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80729 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80733 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80737 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80741 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80745 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  80749 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80753 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  80757 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80760 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  80764 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  80768 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  80773 */   // MIs[0] src1
     /*  80773 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80778 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80780 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80787 */   // (st (xor:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR64mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  80787 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64mr),
     /*  80790 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  80794 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  80798 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  80801 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  80807 */   GIR_RootConstrainSelectedInstOperands,
     /*  80808 */   // GIR_Coverage, 376,
     /*  80808 */   GIR_EraseRootFromParent_Done,
     /*  80809 */ // Label 1723: @80809
     /*  80809 */ GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(80897), // Rule ID 23213 //
     /*  80814 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80817 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80821 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80825 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80829 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80833 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  80837 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  80842 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  80846 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  80850 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80853 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  80857 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  80861 */   // MIs[0] src1
     /*  80861 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80866 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80868 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80875 */   // (st (xor:{ *:[i64] } GR64:{ *:[i64] }:$src2, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR64mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  80875 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64mr),
     /*  80878 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  80882 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  80886 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  80889 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  80895 */   GIR_RootConstrainSelectedInstOperands,
     /*  80896 */   // GIR_Coverage, 23213,
     /*  80896 */   GIR_EraseRootFromParent_Done,
     /*  80897 */ // Label 1724: @80897
     /*  80897 */ GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(80954), // Rule ID 22510 //
     /*  80902 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  80905 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  80912 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80916 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  80920 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  80924 */   // MIs[1] Operand 1
     /*  80924 */   // No operand predicates
     /*  80924 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80928 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80930 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80937 */   // (atomic_store (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (MOV64mi32 addr:{ *:[iPTR] }:$dst, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src)
     /*  80937 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV64mi32),
     /*  80940 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  80944 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src
     /*  80947 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  80952 */   GIR_RootConstrainSelectedInstOperands,
     /*  80953 */   // GIR_Coverage, 22510,
     /*  80953 */   GIR_EraseRootFromParent_Done,
     /*  80954 */ // Label 1725: @80954
     /*  80954 */ GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(81020), // Rule ID 22522 //
     /*  80959 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  80962 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  80965 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  80972 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80976 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  80980 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80984 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  80989 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80993 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80995 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81002 */   // (atomic_store (bitconvert:{ *:[i64] } FR64:{ *:[f64] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (MOVSDmr addr:{ *:[iPTR] }:$dst, FR64:{ *:[f64] }:$src)
     /*  81002 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSDmr),
     /*  81005 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81009 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  81013 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  81018 */   GIR_RootConstrainSelectedInstOperands,
     /*  81019 */   // GIR_Coverage, 22522,
     /*  81019 */   GIR_EraseRootFromParent_Done,
     /*  81020 */ // Label 1726: @81020
     /*  81020 */ GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(81086), // Rule ID 22523 //
     /*  81025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  81028 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  81031 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  81038 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  81042 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  81046 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  81050 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  81055 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81059 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81061 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81068 */   // (atomic_store (bitconvert:{ *:[i64] } FR64:{ *:[f64] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (VMOVSDmr addr:{ *:[iPTR] }:$dst, FR64:{ *:[f64] }:$src)
     /*  81068 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSDmr),
     /*  81071 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81075 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  81079 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  81084 */   GIR_RootConstrainSelectedInstOperands,
     /*  81085 */   // GIR_Coverage, 22523,
     /*  81085 */   GIR_EraseRootFromParent_Done,
     /*  81086 */ // Label 1727: @81086
     /*  81086 */ GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(81152), // Rule ID 22524 //
     /*  81091 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  81094 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  81097 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  81104 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  81108 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  81112 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  81116 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  81121 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81125 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81127 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81134 */   // (atomic_store (bitconvert:{ *:[i64] } FR64:{ *:[f64] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (VMOVSDmr addr:{ *:[iPTR] }:$dst, FR64:{ *:[f64] }:$src)
     /*  81134 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSDmr),
     /*  81137 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81141 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  81145 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  81150 */   GIR_RootConstrainSelectedInstOperands,
     /*  81151 */   // GIR_Coverage, 22524,
     /*  81151 */   GIR_EraseRootFromParent_Done,
     /*  81152 */ // Label 1728: @81152
     /*  81152 */ GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(81215), // Rule ID 54 //
     /*  81157 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_NoEGPR),
     /*  81160 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81163 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81167 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  81171 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /*  81175 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  81179 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  81184 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81188 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81190 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81197 */   // (st (bswap:{ *:[i64] } GR64:{ *:[i64] }:$src1), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVBE64mr addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src1)
     /*  81197 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE64mr),
     /*  81200 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81204 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  81208 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  81213 */   GIR_RootConstrainSelectedInstOperands,
     /*  81214 */   // GIR_Coverage, 54,
     /*  81214 */   GIR_EraseRootFromParent_Done,
     /*  81215 */ // Label 1729: @81215
     /*  81215 */ GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(81278), // Rule ID 60 //
     /*  81220 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVBE_In64BitMode),
     /*  81223 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81226 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81230 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  81234 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /*  81238 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  81242 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  81247 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81251 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81253 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81260 */   // (st (bswap:{ *:[i64] } GR64:{ *:[i64] }:$src1), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVBE64mr_EVEX addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src1)
     /*  81260 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE64mr_EVEX),
     /*  81263 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81267 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  81271 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  81276 */   GIR_RootConstrainSelectedInstOperands,
     /*  81277 */   // GIR_Coverage, 60,
     /*  81277 */   GIR_EraseRootFromParent_Done,
     /*  81278 */ // Label 1730: @81278
     /*  81278 */ GIM_Try, /*On fail goto*//*Label 1731*/ GIMT_Encode4(81323), // Rule ID 22514 //
     /*  81283 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  81286 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  81293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  81297 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81301 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81308 */   // (atomic_store GR64:{ *:[i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (MOV64mr addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  81308 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV64mr),
     /*  81311 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81315 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81317 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81321 */   GIR_RootConstrainSelectedInstOperands,
     /*  81322 */   // GIR_Coverage, 22514,
     /*  81322 */   GIR_EraseRootFromParent_Done,
     /*  81323 */ // Label 1731: @81323
     /*  81323 */ GIM_Try, /*On fail goto*//*Label 1732*/ GIMT_Encode4(81365), // Rule ID 35 //
     /*  81328 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81331 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  81339 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81343 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81350 */   // (st GR64:{ *:[i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOV64mr addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  81350 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV64mr),
     /*  81353 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81357 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81359 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81363 */   GIR_RootConstrainSelectedInstOperands,
     /*  81364 */   // GIR_Coverage, 35,
     /*  81364 */   GIR_EraseRootFromParent_Done,
     /*  81365 */ // Label 1732: @81365
     /*  81365 */ GIM_Try, /*On fail goto*//*Label 1733*/ GIMT_Encode4(81420), // Rule ID 1096 //
     /*  81370 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /*  81373 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81376 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81380 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  81387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /*  81391 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81395 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81402 */   // (st RFP64:{ *:[f64] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstoref32>>  =>  (ST_Fp64m32:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP64:{ *:[f64] }:$src)
     /*  81402 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ST_Fp64m32),
     /*  81405 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /*  81409 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81411 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  81414 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81418 */   GIR_RootConstrainSelectedInstOperands,
     /*  81419 */   // GIR_Coverage, 1096,
     /*  81419 */   GIR_EraseRootFromParent_Done,
     /*  81420 */ // Label 1733: @81420
     /*  81420 */ GIM_Try, /*On fail goto*//*Label 1734*/ GIMT_Encode4(81468), // Rule ID 1097 //
     /*  81425 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /*  81428 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81431 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /*  81439 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81443 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81450 */   // (st RFP64:{ *:[f64] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST_Fp64m:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP64:{ *:[f64] }:$src)
     /*  81450 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ST_Fp64m),
     /*  81453 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /*  81457 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81459 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  81462 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81466 */   GIR_RootConstrainSelectedInstOperands,
     /*  81467 */   // GIR_Coverage, 1097,
     /*  81467 */   GIR_EraseRootFromParent_Done,
     /*  81468 */ // Label 1734: @81468
     /*  81468 */ GIM_Try, /*On fail goto*//*Label 1735*/ GIMT_Encode4(81513), // Rule ID 1692 //
     /*  81473 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  81476 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81479 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  81487 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81491 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81498 */   // (st FR64:{ *:[f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVSDmr addr:{ *:[iPTR] }:$dst, FR64:{ *:[f64] }:$src)
     /*  81498 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSDmr),
     /*  81501 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81505 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81507 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81511 */   GIR_RootConstrainSelectedInstOperands,
     /*  81512 */   // GIR_Coverage, 1692,
     /*  81512 */   GIR_EraseRootFromParent_Done,
     /*  81513 */ // Label 1735: @81513
     /*  81513 */ GIM_Try, /*On fail goto*//*Label 1736*/ GIMT_Encode4(81558), // Rule ID 1694 //
     /*  81518 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  81521 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81524 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  81532 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81536 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81543 */   // (st FR64:{ *:[f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVSDmr addr:{ *:[iPTR] }:$dst, FR64:{ *:[f64] }:$src)
     /*  81543 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSDmr),
     /*  81546 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81550 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81552 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81556 */   GIR_RootConstrainSelectedInstOperands,
     /*  81557 */   // GIR_Coverage, 1694,
     /*  81557 */   GIR_EraseRootFromParent_Done,
     /*  81558 */ // Label 1736: @81558
     /*  81558 */ GIM_Try, /*On fail goto*//*Label 1737*/ GIMT_Encode4(81603), // Rule ID 4616 //
     /*  81563 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  81566 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81569 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81573 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /*  81577 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81581 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81588 */   // (st FR64X:{ *:[f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVSDZmr addr:{ *:[iPTR] }:$dst, FR64X:{ *:[f64] }:$src)
     /*  81588 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSDZmr),
     /*  81591 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81595 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81597 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81601 */   GIR_RootConstrainSelectedInstOperands,
     /*  81602 */   // GIR_Coverage, 4616,
     /*  81602 */   GIR_EraseRootFromParent_Done,
     /*  81603 */ // Label 1737: @81603
     /*  81603 */ GIM_Reject,
     /*  81604 */ // Label 1479: @81604
     /*  81604 */ GIM_Try, /*On fail goto*//*Label 1738*/ GIMT_Encode4(81762),
     /*  81609 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81612 */   GIM_Try, /*On fail goto*//*Label 1739*/ GIMT_Encode4(81664), // Rule ID 1098 //
     /*  81617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /*  81620 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81624 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  81631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /*  81635 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81646 */     // (st RFP80:{ *:[f80] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstoref32>>  =>  (ST_Fp80m32:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP80:{ *:[f80] }:$src)
     /*  81646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ST_Fp80m32),
     /*  81649 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /*  81653 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81655 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  81658 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81662 */     GIR_RootConstrainSelectedInstOperands,
     /*  81663 */     // GIR_Coverage, 1098,
     /*  81663 */     GIR_EraseRootFromParent_Done,
     /*  81664 */   // Label 1739: @81664
     /*  81664 */   GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(81716), // Rule ID 1099 //
     /*  81669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /*  81672 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81676 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  81683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /*  81687 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81698 */     // (st RFP80:{ *:[f80] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstoref64>>  =>  (ST_Fp80m64:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP80:{ *:[f80] }:$src)
     /*  81698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ST_Fp80m64),
     /*  81701 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /*  81705 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81707 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  81710 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81714 */     GIR_RootConstrainSelectedInstOperands,
     /*  81715 */     // GIR_Coverage, 1099,
     /*  81715 */     GIR_EraseRootFromParent_Done,
     /*  81716 */   // Label 1740: @81716
     /*  81716 */   GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(81761), // Rule ID 1100 //
     /*  81721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /*  81724 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /*  81732 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81743 */     // (st RFP80:{ *:[f80] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST_FpP80m:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP80:{ *:[f80] }:$src)
     /*  81743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ST_FpP80m),
     /*  81746 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /*  81750 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81752 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  81755 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81759 */     GIR_RootConstrainSelectedInstOperands,
     /*  81760 */     // GIR_Coverage, 1100,
     /*  81760 */     GIR_EraseRootFromParent_Done,
     /*  81761 */   // Label 1741: @81761
     /*  81761 */   GIM_Reject,
     /*  81762 */ // Label 1738: @81762
     /*  81762 */ GIM_Reject,
     /*  81763 */ // Label 1480: @81763
     /*  81763 */ GIM_Try, /*On fail goto*//*Label 1742*/ GIMT_Encode4(82016),
     /*  81768 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81771 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81775 */   GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(81817), // Rule ID 23142 //
     /*  81780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoAVX),
     /*  81783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  81787 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81791 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  81795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81802 */     // (st VR128:{ *:[f128] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (MOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[f128] }:$src)
     /*  81802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSmr),
     /*  81805 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81809 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81811 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81815 */     GIR_RootConstrainSelectedInstOperands,
     /*  81816 */     // GIR_Coverage, 23142,
     /*  81816 */     GIR_EraseRootFromParent_Done,
     /*  81817 */   // Label 1743: @81817
     /*  81817 */   GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(81855), // Rule ID 23143 //
     /*  81822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoAVX),
     /*  81825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  81829 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81840 */     // (st VR128:{ *:[f128] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[f128] }:$src)
     /*  81840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSmr),
     /*  81843 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81847 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81849 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81853 */     GIR_RootConstrainSelectedInstOperands,
     /*  81854 */     // GIR_Coverage, 23143,
     /*  81854 */     GIR_EraseRootFromParent_Done,
     /*  81855 */   // Label 1744: @81855
     /*  81855 */   GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(81897), // Rule ID 23146 //
     /*  81860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  81863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  81867 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81871 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  81875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81882 */     // (st VR128:{ *:[f128] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[f128] }:$src)
     /*  81882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSmr),
     /*  81885 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81889 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81891 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81895 */     GIR_RootConstrainSelectedInstOperands,
     /*  81896 */     // GIR_Coverage, 23146,
     /*  81896 */     GIR_EraseRootFromParent_Done,
     /*  81897 */   // Label 1745: @81897
     /*  81897 */   GIM_Try, /*On fail goto*//*Label 1746*/ GIMT_Encode4(81935), // Rule ID 23147 //
     /*  81902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  81905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  81909 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81920 */     // (st VR128:{ *:[f128] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[f128] }:$src)
     /*  81920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSmr),
     /*  81923 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81927 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81929 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81933 */     GIR_RootConstrainSelectedInstOperands,
     /*  81934 */     // GIR_Coverage, 23147,
     /*  81934 */     GIR_EraseRootFromParent_Done,
     /*  81935 */   // Label 1746: @81935
     /*  81935 */   GIM_Try, /*On fail goto*//*Label 1747*/ GIMT_Encode4(81977), // Rule ID 23150 //
     /*  81940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  81943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  81947 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81951 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  81955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81962 */     // (st VR128X:{ *:[f128] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSZ128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[f128] }:$src)
     /*  81962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ128mr),
     /*  81965 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81969 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81971 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81975 */     GIR_RootConstrainSelectedInstOperands,
     /*  81976 */     // GIR_Coverage, 23150,
     /*  81976 */     GIR_EraseRootFromParent_Done,
     /*  81977 */   // Label 1747: @81977
     /*  81977 */   GIM_Try, /*On fail goto*//*Label 1748*/ GIMT_Encode4(82015), // Rule ID 23151 //
     /*  81982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  81985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  81989 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82000 */     // (st VR128X:{ *:[f128] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSZ128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[f128] }:$src)
     /*  82000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ128mr),
     /*  82003 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82007 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82009 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82013 */     GIR_RootConstrainSelectedInstOperands,
     /*  82014 */     // GIR_Coverage, 23151,
     /*  82014 */     GIR_EraseRootFromParent_Done,
     /*  82015 */   // Label 1748: @82015
     /*  82015 */   GIM_Reject,
     /*  82016 */ // Label 1742: @82016
     /*  82016 */ GIM_Reject,
     /*  82017 */ // Label 1481: @82017
     /*  82017 */ GIM_Try, /*On fail goto*//*Label 1749*/ GIMT_Encode4(82510),
     /*  82022 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  82025 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  82029 */   GIM_Try, /*On fail goto*//*Label 1750*/ GIMT_Encode4(82071), // Rule ID 1716 //
     /*  82034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  82037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82041 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82045 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82056 */     // (st VR128:{ *:[v2f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPDmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2f64] }:$src)
     /*  82056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDmr),
     /*  82059 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82063 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82065 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82069 */     GIR_RootConstrainSelectedInstOperands,
     /*  82070 */     // GIR_Coverage, 1716,
     /*  82070 */     GIR_EraseRootFromParent_Done,
     /*  82071 */   // Label 1750: @82071
     /*  82071 */   GIM_Try, /*On fail goto*//*Label 1751*/ GIMT_Encode4(82109), // Rule ID 1718 //
     /*  82076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  82079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82083 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82094 */     // (st VR128:{ *:[v2f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPDmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2f64] }:$src)
     /*  82094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDmr),
     /*  82097 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82101 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82103 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82107 */     GIR_RootConstrainSelectedInstOperands,
     /*  82108 */     // GIR_Coverage, 1718,
     /*  82108 */     GIR_EraseRootFromParent_Done,
     /*  82109 */   // Label 1751: @82109
     /*  82109 */   GIM_Try, /*On fail goto*//*Label 1752*/ GIMT_Encode4(82151), // Rule ID 1724 //
     /*  82114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  82117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82121 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82125 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82136 */     // (st VR128:{ *:[v2f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (MOVAPDmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2f64] }:$src)
     /*  82136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPDmr),
     /*  82139 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82143 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82145 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82149 */     GIR_RootConstrainSelectedInstOperands,
     /*  82150 */     // GIR_Coverage, 1724,
     /*  82150 */     GIR_EraseRootFromParent_Done,
     /*  82151 */   // Label 1752: @82151
     /*  82151 */   GIM_Try, /*On fail goto*//*Label 1753*/ GIMT_Encode4(82189), // Rule ID 1726 //
     /*  82156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  82159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82163 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82174 */     // (st VR128:{ *:[v2f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVUPDmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2f64] }:$src)
     /*  82174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPDmr),
     /*  82177 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82181 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82183 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82187 */     GIR_RootConstrainSelectedInstOperands,
     /*  82188 */     // GIR_Coverage, 1726,
     /*  82188 */     GIR_EraseRootFromParent_Done,
     /*  82189 */   // Label 1753: @82189
     /*  82189 */   GIM_Try, /*On fail goto*//*Label 1754*/ GIMT_Encode4(82231), // Rule ID 2520 //
     /*  82194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  82197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82201 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82205 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82216 */     // (st VR128:{ *:[v2i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQAmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2i64] }:$src)
     /*  82216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQAmr),
     /*  82219 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82223 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82225 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82229 */     GIR_RootConstrainSelectedInstOperands,
     /*  82230 */     // GIR_Coverage, 2520,
     /*  82230 */     GIR_EraseRootFromParent_Done,
     /*  82231 */   // Label 1754: @82231
     /*  82231 */   GIM_Try, /*On fail goto*//*Label 1755*/ GIMT_Encode4(82269), // Rule ID 2521 //
     /*  82236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  82239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82243 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82254 */     // (st VR128:{ *:[v2i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQUmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2i64] }:$src)
     /*  82254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUmr),
     /*  82257 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82261 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82263 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82267 */     GIR_RootConstrainSelectedInstOperands,
     /*  82268 */     // GIR_Coverage, 2521,
     /*  82268 */     GIR_EraseRootFromParent_Done,
     /*  82269 */   // Label 1755: @82269
     /*  82269 */   GIM_Try, /*On fail goto*//*Label 1756*/ GIMT_Encode4(82311), // Rule ID 4496 //
     /*  82274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  82277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  82281 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82285 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82296 */     // (st VR128X:{ *:[v2f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPDZ128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v2f64] }:$src)
     /*  82296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ128mr),
     /*  82299 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82303 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82305 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82309 */     GIR_RootConstrainSelectedInstOperands,
     /*  82310 */     // GIR_Coverage, 4496,
     /*  82310 */     GIR_EraseRootFromParent_Done,
     /*  82311 */   // Label 1756: @82311
     /*  82311 */   GIM_Try, /*On fail goto*//*Label 1757*/ GIMT_Encode4(82349), // Rule ID 4520 //
     /*  82316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  82319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  82323 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82334 */     // (st VR128X:{ *:[v2f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPDZ128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v2f64] }:$src)
     /*  82334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDZ128mr),
     /*  82337 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82341 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82343 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82347 */     GIR_RootConstrainSelectedInstOperands,
     /*  82348 */     // GIR_Coverage, 4520,
     /*  82348 */     GIR_EraseRootFromParent_Done,
     /*  82349 */   // Label 1757: @82349
     /*  82349 */   GIM_Try, /*On fail goto*//*Label 1758*/ GIMT_Encode4(82391), // Rule ID 4550 //
     /*  82354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  82357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  82361 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82365 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82376 */     // (st VR128X:{ *:[v2i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Z128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v2i64] }:$src)
     /*  82376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128mr),
     /*  82379 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82383 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82385 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82389 */     GIR_RootConstrainSelectedInstOperands,
     /*  82390 */     // GIR_Coverage, 4550,
     /*  82390 */     GIR_EraseRootFromParent_Done,
     /*  82391 */   // Label 1758: @82391
     /*  82391 */   GIM_Try, /*On fail goto*//*Label 1759*/ GIMT_Encode4(82429), // Rule ID 4592 //
     /*  82396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  82399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  82403 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82414 */     // (st VR128X:{ *:[v2i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Z128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v2i64] }:$src)
     /*  82414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z128mr),
     /*  82417 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82421 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82423 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82427 */     GIR_RootConstrainSelectedInstOperands,
     /*  82428 */     // GIR_Coverage, 4592,
     /*  82428 */     GIR_EraseRootFromParent_Done,
     /*  82429 */   // Label 1759: @82429
     /*  82429 */   GIM_Try, /*On fail goto*//*Label 1760*/ GIMT_Encode4(82471), // Rule ID 17947 //
     /*  82434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  82437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82441 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82445 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82456 */     // (st VR128:{ *:[v2i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (MOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2i64] }:$src)
     /*  82456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSmr),
     /*  82459 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82463 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82465 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82469 */     GIR_RootConstrainSelectedInstOperands,
     /*  82470 */     // GIR_Coverage, 17947,
     /*  82470 */     GIR_EraseRootFromParent_Done,
     /*  82471 */   // Label 1760: @82471
     /*  82471 */   GIM_Try, /*On fail goto*//*Label 1761*/ GIMT_Encode4(82509), // Rule ID 17951 //
     /*  82476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  82479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82483 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82494 */     // (st VR128:{ *:[v2i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2i64] }:$src)
     /*  82494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSmr),
     /*  82497 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82501 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82503 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82507 */     GIR_RootConstrainSelectedInstOperands,
     /*  82508 */     // GIR_Coverage, 17951,
     /*  82508 */     GIR_EraseRootFromParent_Done,
     /*  82509 */   // Label 1761: @82509
     /*  82509 */   GIM_Reject,
     /*  82510 */ // Label 1749: @82510
     /*  82510 */ GIM_Reject,
     /*  82511 */ // Label 1482: @82511
     /*  82511 */ GIM_Try, /*On fail goto*//*Label 1762*/ GIMT_Encode4(83004),
     /*  82516 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  82519 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  82523 */   GIM_Try, /*On fail goto*//*Label 1763*/ GIMT_Encode4(82565), // Rule ID 1715 //
     /*  82528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  82531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82535 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82539 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82550 */     // (st VR128:{ *:[v4f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4f32] }:$src)
     /*  82550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSmr),
     /*  82553 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82557 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82563 */     GIR_RootConstrainSelectedInstOperands,
     /*  82564 */     // GIR_Coverage, 1715,
     /*  82564 */     GIR_EraseRootFromParent_Done,
     /*  82565 */   // Label 1763: @82565
     /*  82565 */   GIM_Try, /*On fail goto*//*Label 1764*/ GIMT_Encode4(82603), // Rule ID 1717 //
     /*  82570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  82573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82577 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82588 */     // (st VR128:{ *:[v4f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4f32] }:$src)
     /*  82588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSmr),
     /*  82591 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82595 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82597 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82601 */     GIR_RootConstrainSelectedInstOperands,
     /*  82602 */     // GIR_Coverage, 1717,
     /*  82602 */     GIR_EraseRootFromParent_Done,
     /*  82603 */   // Label 1764: @82603
     /*  82603 */   GIM_Try, /*On fail goto*//*Label 1765*/ GIMT_Encode4(82645), // Rule ID 1723 //
     /*  82608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  82611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82615 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82619 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82630 */     // (st VR128:{ *:[v4f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (MOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4f32] }:$src)
     /*  82630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSmr),
     /*  82633 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82637 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82639 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82643 */     GIR_RootConstrainSelectedInstOperands,
     /*  82644 */     // GIR_Coverage, 1723,
     /*  82644 */     GIR_EraseRootFromParent_Done,
     /*  82645 */   // Label 1765: @82645
     /*  82645 */   GIM_Try, /*On fail goto*//*Label 1766*/ GIMT_Encode4(82683), // Rule ID 1725 //
     /*  82650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  82653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82657 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82668 */     // (st VR128:{ *:[v4f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4f32] }:$src)
     /*  82668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSmr),
     /*  82671 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82675 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82677 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82681 */     GIR_RootConstrainSelectedInstOperands,
     /*  82682 */     // GIR_Coverage, 1725,
     /*  82682 */     GIR_EraseRootFromParent_Done,
     /*  82683 */   // Label 1766: @82683
     /*  82683 */   GIM_Try, /*On fail goto*//*Label 1767*/ GIMT_Encode4(82725), // Rule ID 4478 //
     /*  82688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  82691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  82695 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82699 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82710 */     // (st VR128X:{ *:[v4f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSZ128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v4f32] }:$src)
     /*  82710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ128mr),
     /*  82713 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82717 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82719 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82723 */     GIR_RootConstrainSelectedInstOperands,
     /*  82724 */     // GIR_Coverage, 4478,
     /*  82724 */     GIR_EraseRootFromParent_Done,
     /*  82725 */   // Label 1767: @82725
     /*  82725 */   GIM_Try, /*On fail goto*//*Label 1768*/ GIMT_Encode4(82763), // Rule ID 4508 //
     /*  82730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  82733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  82737 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82748 */     // (st VR128X:{ *:[v4f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSZ128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v4f32] }:$src)
     /*  82748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ128mr),
     /*  82751 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82755 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82757 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82761 */     GIR_RootConstrainSelectedInstOperands,
     /*  82762 */     // GIR_Coverage, 4508,
     /*  82762 */     GIR_EraseRootFromParent_Done,
     /*  82763 */   // Label 1768: @82763
     /*  82763 */   GIM_Try, /*On fail goto*//*Label 1769*/ GIMT_Encode4(82805), // Rule ID 17948 //
     /*  82768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  82771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82775 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82779 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82790 */     // (st VR128:{ *:[v4i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (MOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4i32] }:$src)
     /*  82790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSmr),
     /*  82793 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82797 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82799 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82803 */     GIR_RootConstrainSelectedInstOperands,
     /*  82804 */     // GIR_Coverage, 17948,
     /*  82804 */     GIR_EraseRootFromParent_Done,
     /*  82805 */   // Label 1769: @82805
     /*  82805 */   GIM_Try, /*On fail goto*//*Label 1770*/ GIMT_Encode4(82843), // Rule ID 17952 //
     /*  82810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  82813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82817 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82828 */     // (st VR128:{ *:[v4i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4i32] }:$src)
     /*  82828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSmr),
     /*  82831 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82835 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82837 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82841 */     GIR_RootConstrainSelectedInstOperands,
     /*  82842 */     // GIR_Coverage, 17952,
     /*  82842 */     GIR_EraseRootFromParent_Done,
     /*  82843 */   // Label 1770: @82843
     /*  82843 */   GIM_Try, /*On fail goto*//*Label 1771*/ GIMT_Encode4(82885), // Rule ID 18327 //
     /*  82848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  82851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82855 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82859 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82870 */     // (st VR128:{ *:[v4i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQAmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4i32] }:$src)
     /*  82870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQAmr),
     /*  82873 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82877 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82879 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82883 */     GIR_RootConstrainSelectedInstOperands,
     /*  82884 */     // GIR_Coverage, 18327,
     /*  82884 */     GIR_EraseRootFromParent_Done,
     /*  82885 */   // Label 1771: @82885
     /*  82885 */   GIM_Try, /*On fail goto*//*Label 1772*/ GIMT_Encode4(82923), // Rule ID 18331 //
     /*  82890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  82893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82897 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82908 */     // (st VR128:{ *:[v4i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQUmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4i32] }:$src)
     /*  82908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUmr),
     /*  82911 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82915 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82917 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82921 */     GIR_RootConstrainSelectedInstOperands,
     /*  82922 */     // GIR_Coverage, 18331,
     /*  82922 */     GIR_EraseRootFromParent_Done,
     /*  82923 */   // Label 1772: @82923
     /*  82923 */   GIM_Try, /*On fail goto*//*Label 1773*/ GIMT_Encode4(82965), // Rule ID 19820 //
     /*  82928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  82931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  82935 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82939 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82950 */     // (st VR128X:{ *:[v4i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Z128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v4i32] }:$src)
     /*  82950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128mr),
     /*  82953 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82957 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82959 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82963 */     GIR_RootConstrainSelectedInstOperands,
     /*  82964 */     // GIR_Coverage, 19820,
     /*  82964 */     GIR_EraseRootFromParent_Done,
     /*  82965 */   // Label 1773: @82965
     /*  82965 */   GIM_Try, /*On fail goto*//*Label 1774*/ GIMT_Encode4(83003), // Rule ID 19824 //
     /*  82970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  82973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  82977 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82988 */     // (st VR128X:{ *:[v4i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Z128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v4i32] }:$src)
     /*  82988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z128mr),
     /*  82991 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82995 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82997 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83001 */     GIR_RootConstrainSelectedInstOperands,
     /*  83002 */     // GIR_Coverage, 19824,
     /*  83002 */     GIR_EraseRootFromParent_Done,
     /*  83003 */   // Label 1774: @83003
     /*  83003 */   GIM_Reject,
     /*  83004 */ // Label 1762: @83004
     /*  83004 */ GIM_Reject,
     /*  83005 */ // Label 1483: @83005
     /*  83005 */ GIM_Try, /*On fail goto*//*Label 1775*/ GIMT_Encode4(83338),
     /*  83010 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  83013 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83017 */   GIM_Try, /*On fail goto*//*Label 1776*/ GIMT_Encode4(83059), // Rule ID 1720 //
     /*  83022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  83029 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83033 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83044 */     // (st VR256:{ *:[v4f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPDYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v4f64] }:$src)
     /*  83044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDYmr),
     /*  83047 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83051 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83053 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83057 */     GIR_RootConstrainSelectedInstOperands,
     /*  83058 */     // GIR_Coverage, 1720,
     /*  83058 */     GIR_EraseRootFromParent_Done,
     /*  83059 */   // Label 1776: @83059
     /*  83059 */   GIM_Try, /*On fail goto*//*Label 1777*/ GIMT_Encode4(83097), // Rule ID 1722 //
     /*  83064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  83071 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83082 */     // (st VR256:{ *:[v4f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPDYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v4f64] }:$src)
     /*  83082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDYmr),
     /*  83085 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83089 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83091 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83095 */     GIR_RootConstrainSelectedInstOperands,
     /*  83096 */     // GIR_Coverage, 1722,
     /*  83096 */     GIR_EraseRootFromParent_Done,
     /*  83097 */   // Label 1777: @83097
     /*  83097 */   GIM_Try, /*On fail goto*//*Label 1778*/ GIMT_Encode4(83139), // Rule ID 4495 //
     /*  83102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  83105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  83109 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83113 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83124 */     // (st VR256X:{ *:[v4f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPDZ256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v4f64] }:$src)
     /*  83124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ256mr),
     /*  83127 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83131 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83133 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83137 */     GIR_RootConstrainSelectedInstOperands,
     /*  83138 */     // GIR_Coverage, 4495,
     /*  83138 */     GIR_EraseRootFromParent_Done,
     /*  83139 */   // Label 1778: @83139
     /*  83139 */   GIM_Try, /*On fail goto*//*Label 1779*/ GIMT_Encode4(83177), // Rule ID 4519 //
     /*  83144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  83147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  83151 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83162 */     // (st VR256X:{ *:[v4f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPDZ256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v4f64] }:$src)
     /*  83162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDZ256mr),
     /*  83165 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83169 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83171 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83175 */     GIR_RootConstrainSelectedInstOperands,
     /*  83176 */     // GIR_Coverage, 4519,
     /*  83176 */     GIR_EraseRootFromParent_Done,
     /*  83177 */   // Label 1779: @83177
     /*  83177 */   GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(83219), // Rule ID 4549 //
     /*  83182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  83185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  83189 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83193 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83204 */     // (st VR256X:{ *:[v4i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Z256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v4i64] }:$src)
     /*  83204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256mr),
     /*  83207 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83211 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83213 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83217 */     GIR_RootConstrainSelectedInstOperands,
     /*  83218 */     // GIR_Coverage, 4549,
     /*  83218 */     GIR_EraseRootFromParent_Done,
     /*  83219 */   // Label 1780: @83219
     /*  83219 */   GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(83257), // Rule ID 4591 //
     /*  83224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  83227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  83231 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83242 */     // (st VR256X:{ *:[v4i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Z256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v4i64] }:$src)
     /*  83242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z256mr),
     /*  83245 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83249 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83251 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83255 */     GIR_RootConstrainSelectedInstOperands,
     /*  83256 */     // GIR_Coverage, 4591,
     /*  83256 */     GIR_EraseRootFromParent_Done,
     /*  83257 */   // Label 1781: @83257
     /*  83257 */   GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(83299), // Rule ID 17923 //
     /*  83262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  83269 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83273 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83284 */     // (st VR256:{ *:[v4i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v4i64] }:$src)
     /*  83284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYmr),
     /*  83287 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83291 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83293 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83297 */     GIR_RootConstrainSelectedInstOperands,
     /*  83298 */     // GIR_Coverage, 17923,
     /*  83298 */     GIR_EraseRootFromParent_Done,
     /*  83299 */   // Label 1782: @83299
     /*  83299 */   GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(83337), // Rule ID 17927 //
     /*  83304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  83311 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83322 */     // (st VR256:{ *:[v4i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v4i64] }:$src)
     /*  83322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYmr),
     /*  83325 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83329 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83331 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83335 */     GIR_RootConstrainSelectedInstOperands,
     /*  83336 */     // GIR_Coverage, 17927,
     /*  83336 */     GIR_EraseRootFromParent_Done,
     /*  83337 */   // Label 1783: @83337
     /*  83337 */   GIM_Reject,
     /*  83338 */ // Label 1775: @83338
     /*  83338 */ GIM_Reject,
     /*  83339 */ // Label 1484: @83339
     /*  83339 */ GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(83420),
     /*  83344 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  83347 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  83355 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83359 */   GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(83389), // Rule ID 4396 //
     /*  83364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_NoEGPR),
     /*  83367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83374 */     // (st VK8:{ *:[v8i1] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (KMOVBmk addr:{ *:[iPTR] }:$dst, VK8:{ *:[v8i1] }:$src)
     /*  83374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVBmk),
     /*  83377 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83381 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83383 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83387 */     GIR_RootConstrainSelectedInstOperands,
     /*  83388 */     // GIR_Coverage, 4396,
     /*  83388 */     GIR_EraseRootFromParent_Done,
     /*  83389 */   // Label 1785: @83389
     /*  83389 */   GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(83419), // Rule ID 4398 //
     /*  83394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEGPR_In64BitMode),
     /*  83397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83404 */     // (st VK8:{ *:[v8i1] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (KMOVBmk_EVEX addr:{ *:[iPTR] }:$dst, VK8:{ *:[v8i1] }:$src)
     /*  83404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVBmk_EVEX),
     /*  83407 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83411 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83413 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83417 */     GIR_RootConstrainSelectedInstOperands,
     /*  83418 */     // GIR_Coverage, 4398,
     /*  83418 */     GIR_EraseRootFromParent_Done,
     /*  83419 */   // Label 1786: @83419
     /*  83419 */   GIM_Reject,
     /*  83420 */ // Label 1784: @83420
     /*  83420 */ GIM_Reject,
     /*  83421 */ // Label 1485: @83421
     /*  83421 */ GIM_Try, /*On fail goto*//*Label 1787*/ GIMT_Encode4(83994),
     /*  83426 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  83429 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83433 */   GIM_Try, /*On fail goto*//*Label 1788*/ GIMT_Encode4(83475), // Rule ID 17933 //
     /*  83438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83445 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83449 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83460 */     // (st VR128:{ *:[v8f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8f16] }:$src)
     /*  83460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSmr),
     /*  83463 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83467 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83469 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83473 */     GIR_RootConstrainSelectedInstOperands,
     /*  83474 */     // GIR_Coverage, 17933,
     /*  83474 */     GIR_EraseRootFromParent_Done,
     /*  83475 */   // Label 1788: @83475
     /*  83475 */   GIM_Try, /*On fail goto*//*Label 1789*/ GIMT_Encode4(83513), // Rule ID 17934 //
     /*  83480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83487 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83498 */     // (st VR128:{ *:[v8f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8f16] }:$src)
     /*  83498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSmr),
     /*  83501 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83505 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83507 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83511 */     GIR_RootConstrainSelectedInstOperands,
     /*  83512 */     // GIR_Coverage, 17934,
     /*  83512 */     GIR_EraseRootFromParent_Done,
     /*  83513 */   // Label 1789: @83513
     /*  83513 */   GIM_Try, /*On fail goto*//*Label 1790*/ GIMT_Encode4(83555), // Rule ID 17949 //
     /*  83518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  83521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83525 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83529 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83540 */     // (st VR128:{ *:[v8i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (MOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8i16] }:$src)
     /*  83540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSmr),
     /*  83543 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83547 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83549 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83553 */     GIR_RootConstrainSelectedInstOperands,
     /*  83554 */     // GIR_Coverage, 17949,
     /*  83554 */     GIR_EraseRootFromParent_Done,
     /*  83555 */   // Label 1790: @83555
     /*  83555 */   GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(83593), // Rule ID 17953 //
     /*  83560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  83563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83567 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83578 */     // (st VR128:{ *:[v8i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8i16] }:$src)
     /*  83578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSmr),
     /*  83581 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83585 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83587 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83591 */     GIR_RootConstrainSelectedInstOperands,
     /*  83592 */     // GIR_Coverage, 17953,
     /*  83592 */     GIR_EraseRootFromParent_Done,
     /*  83593 */   // Label 1791: @83593
     /*  83593 */   GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(83635), // Rule ID 17957 //
     /*  83598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  83601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83605 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83609 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83620 */     // (st VR128:{ *:[v8f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (MOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8f16] }:$src)
     /*  83620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSmr),
     /*  83623 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83627 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83629 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83633 */     GIR_RootConstrainSelectedInstOperands,
     /*  83634 */     // GIR_Coverage, 17957,
     /*  83634 */     GIR_EraseRootFromParent_Done,
     /*  83635 */   // Label 1792: @83635
     /*  83635 */   GIM_Try, /*On fail goto*//*Label 1793*/ GIMT_Encode4(83673), // Rule ID 17958 //
     /*  83640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  83643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83647 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83658 */     // (st VR128:{ *:[v8f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8f16] }:$src)
     /*  83658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSmr),
     /*  83661 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83665 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83667 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83671 */     GIR_RootConstrainSelectedInstOperands,
     /*  83672 */     // GIR_Coverage, 17958,
     /*  83672 */     GIR_EraseRootFromParent_Done,
     /*  83673 */   // Label 1793: @83673
     /*  83673 */   GIM_Try, /*On fail goto*//*Label 1794*/ GIMT_Encode4(83715), // Rule ID 18328 //
     /*  83678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83685 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83689 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83700 */     // (st VR128:{ *:[v8i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQAmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8i16] }:$src)
     /*  83700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQAmr),
     /*  83703 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83707 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83709 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83713 */     GIR_RootConstrainSelectedInstOperands,
     /*  83714 */     // GIR_Coverage, 18328,
     /*  83714 */     GIR_EraseRootFromParent_Done,
     /*  83715 */   // Label 1794: @83715
     /*  83715 */   GIM_Try, /*On fail goto*//*Label 1795*/ GIMT_Encode4(83757), // Rule ID 18329 //
     /*  83720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83727 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83731 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83742 */     // (st VR128:{ *:[v8f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQAmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8f16] }:$src)
     /*  83742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQAmr),
     /*  83745 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83749 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83751 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83755 */     GIR_RootConstrainSelectedInstOperands,
     /*  83756 */     // GIR_Coverage, 18329,
     /*  83756 */     GIR_EraseRootFromParent_Done,
     /*  83757 */   // Label 1795: @83757
     /*  83757 */   GIM_Try, /*On fail goto*//*Label 1796*/ GIMT_Encode4(83795), // Rule ID 18332 //
     /*  83762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83769 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83780 */     // (st VR128:{ *:[v8i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQUmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8i16] }:$src)
     /*  83780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUmr),
     /*  83783 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83787 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83789 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83793 */     GIR_RootConstrainSelectedInstOperands,
     /*  83794 */     // GIR_Coverage, 18332,
     /*  83794 */     GIR_EraseRootFromParent_Done,
     /*  83795 */   // Label 1796: @83795
     /*  83795 */   GIM_Try, /*On fail goto*//*Label 1797*/ GIMT_Encode4(83833), // Rule ID 18333 //
     /*  83800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83807 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83818 */     // (st VR128:{ *:[v8f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQUmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8f16] }:$src)
     /*  83818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUmr),
     /*  83821 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83825 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83827 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83831 */     GIR_RootConstrainSelectedInstOperands,
     /*  83832 */     // GIR_Coverage, 18333,
     /*  83832 */     GIR_EraseRootFromParent_Done,
     /*  83833 */   // Label 1797: @83833
     /*  83833 */   GIM_Try, /*On fail goto*//*Label 1798*/ GIMT_Encode4(83875), // Rule ID 19821 //
     /*  83838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  83841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  83845 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83849 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83860 */     // (st VR128X:{ *:[v8i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Z128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v8i16] }:$src)
     /*  83860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128mr),
     /*  83863 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83867 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83869 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83873 */     GIR_RootConstrainSelectedInstOperands,
     /*  83874 */     // GIR_Coverage, 19821,
     /*  83874 */     GIR_EraseRootFromParent_Done,
     /*  83875 */   // Label 1798: @83875
     /*  83875 */   GIM_Try, /*On fail goto*//*Label 1799*/ GIMT_Encode4(83917), // Rule ID 19822 //
     /*  83880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  83883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  83887 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83891 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83902 */     // (st VR128X:{ *:[v8f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSZ128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v8f16] }:$src)
     /*  83902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ128mr),
     /*  83905 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83909 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83911 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83915 */     GIR_RootConstrainSelectedInstOperands,
     /*  83916 */     // GIR_Coverage, 19822,
     /*  83916 */     GIR_EraseRootFromParent_Done,
     /*  83917 */   // Label 1799: @83917
     /*  83917 */   GIM_Try, /*On fail goto*//*Label 1800*/ GIMT_Encode4(83955), // Rule ID 19825 //
     /*  83922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  83925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  83929 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83940 */     // (st VR128X:{ *:[v8i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Z128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v8i16] }:$src)
     /*  83940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z128mr),
     /*  83943 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83947 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83949 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83953 */     GIR_RootConstrainSelectedInstOperands,
     /*  83954 */     // GIR_Coverage, 19825,
     /*  83954 */     GIR_EraseRootFromParent_Done,
     /*  83955 */   // Label 1800: @83955
     /*  83955 */   GIM_Try, /*On fail goto*//*Label 1801*/ GIMT_Encode4(83993), // Rule ID 19826 //
     /*  83960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  83963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  83967 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83978 */     // (st VR128X:{ *:[v8f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSZ128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v8f16] }:$src)
     /*  83978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ128mr),
     /*  83981 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83985 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83987 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83991 */     GIR_RootConstrainSelectedInstOperands,
     /*  83992 */     // GIR_Coverage, 19826,
     /*  83992 */     GIR_EraseRootFromParent_Done,
     /*  83993 */   // Label 1801: @83993
     /*  83993 */   GIM_Reject,
     /*  83994 */ // Label 1787: @83994
     /*  83994 */ GIM_Reject,
     /*  83995 */ // Label 1486: @83995
     /*  83995 */ GIM_Try, /*On fail goto*//*Label 1802*/ GIMT_Encode4(84328),
     /*  84000 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  84003 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  84007 */   GIM_Try, /*On fail goto*//*Label 1803*/ GIMT_Encode4(84049), // Rule ID 1719 //
     /*  84012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  84015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  84019 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84023 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84034 */     // (st VR256:{ *:[v8f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v8f32] }:$src)
     /*  84034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYmr),
     /*  84037 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84041 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84043 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84047 */     GIR_RootConstrainSelectedInstOperands,
     /*  84048 */     // GIR_Coverage, 1719,
     /*  84048 */     GIR_EraseRootFromParent_Done,
     /*  84049 */   // Label 1803: @84049
     /*  84049 */   GIM_Try, /*On fail goto*//*Label 1804*/ GIMT_Encode4(84087), // Rule ID 1721 //
     /*  84054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  84057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  84061 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84072 */     // (st VR256:{ *:[v8f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v8f32] }:$src)
     /*  84072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYmr),
     /*  84075 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84079 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84081 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84085 */     GIR_RootConstrainSelectedInstOperands,
     /*  84086 */     // GIR_Coverage, 1721,
     /*  84086 */     GIR_EraseRootFromParent_Done,
     /*  84087 */   // Label 1804: @84087
     /*  84087 */   GIM_Try, /*On fail goto*//*Label 1805*/ GIMT_Encode4(84129), // Rule ID 4477 //
     /*  84092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  84095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  84099 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84103 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84114 */     // (st VR256X:{ *:[v8f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSZ256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v8f32] }:$src)
     /*  84114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ256mr),
     /*  84117 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84121 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84123 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84127 */     GIR_RootConstrainSelectedInstOperands,
     /*  84128 */     // GIR_Coverage, 4477,
     /*  84128 */     GIR_EraseRootFromParent_Done,
     /*  84129 */   // Label 1805: @84129
     /*  84129 */   GIM_Try, /*On fail goto*//*Label 1806*/ GIMT_Encode4(84167), // Rule ID 4507 //
     /*  84134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  84137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  84141 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84152 */     // (st VR256X:{ *:[v8f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSZ256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v8f32] }:$src)
     /*  84152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ256mr),
     /*  84155 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84159 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84161 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84165 */     GIR_RootConstrainSelectedInstOperands,
     /*  84166 */     // GIR_Coverage, 4507,
     /*  84166 */     GIR_EraseRootFromParent_Done,
     /*  84167 */   // Label 1806: @84167
     /*  84167 */   GIM_Try, /*On fail goto*//*Label 1807*/ GIMT_Encode4(84209), // Rule ID 17924 //
     /*  84172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  84175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  84179 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84183 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84194 */     // (st VR256:{ *:[v8i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v8i32] }:$src)
     /*  84194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYmr),
     /*  84197 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84201 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84203 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84207 */     GIR_RootConstrainSelectedInstOperands,
     /*  84208 */     // GIR_Coverage, 17924,
     /*  84208 */     GIR_EraseRootFromParent_Done,
     /*  84209 */   // Label 1807: @84209
     /*  84209 */   GIM_Try, /*On fail goto*//*Label 1808*/ GIMT_Encode4(84247), // Rule ID 17928 //
     /*  84214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  84217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  84221 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84232 */     // (st VR256:{ *:[v8i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v8i32] }:$src)
     /*  84232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYmr),
     /*  84235 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84239 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84241 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84245 */     GIR_RootConstrainSelectedInstOperands,
     /*  84246 */     // GIR_Coverage, 17928,
     /*  84246 */     GIR_EraseRootFromParent_Done,
     /*  84247 */   // Label 1808: @84247
     /*  84247 */   GIM_Try, /*On fail goto*//*Label 1809*/ GIMT_Encode4(84289), // Rule ID 19836 //
     /*  84252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  84255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  84259 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84263 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84274 */     // (st VR256X:{ *:[v8i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Z256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v8i32] }:$src)
     /*  84274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256mr),
     /*  84277 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84281 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84283 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84287 */     GIR_RootConstrainSelectedInstOperands,
     /*  84288 */     // GIR_Coverage, 19836,
     /*  84288 */     GIR_EraseRootFromParent_Done,
     /*  84289 */   // Label 1809: @84289
     /*  84289 */   GIM_Try, /*On fail goto*//*Label 1810*/ GIMT_Encode4(84327), // Rule ID 19840 //
     /*  84294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  84297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  84301 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84312 */     // (st VR256X:{ *:[v8i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Z256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v8i32] }:$src)
     /*  84312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z256mr),
     /*  84315 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84319 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84321 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84325 */     GIR_RootConstrainSelectedInstOperands,
     /*  84326 */     // GIR_Coverage, 19840,
     /*  84326 */     GIR_EraseRootFromParent_Done,
     /*  84327 */   // Label 1810: @84327
     /*  84327 */   GIM_Reject,
     /*  84328 */ // Label 1802: @84328
     /*  84328 */ GIM_Reject,
     /*  84329 */ // Label 1487: @84329
     /*  84329 */ GIM_Try, /*On fail goto*//*Label 1811*/ GIMT_Encode4(84502),
     /*  84334 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  84337 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  84341 */   GIM_Try, /*On fail goto*//*Label 1812*/ GIMT_Encode4(84383), // Rule ID 4494 //
     /*  84346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  84349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  84353 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84357 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84368 */     // (st VR512:{ *:[v8f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPDZmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v8f64] }:$src)
     /*  84368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZmr),
     /*  84371 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84375 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84377 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84381 */     GIR_RootConstrainSelectedInstOperands,
     /*  84382 */     // GIR_Coverage, 4494,
     /*  84382 */     GIR_EraseRootFromParent_Done,
     /*  84383 */   // Label 1812: @84383
     /*  84383 */   GIM_Try, /*On fail goto*//*Label 1813*/ GIMT_Encode4(84421), // Rule ID 4518 //
     /*  84388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  84391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  84395 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84406 */     // (st VR512:{ *:[v8f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPDZmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v8f64] }:$src)
     /*  84406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDZmr),
     /*  84409 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84413 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84415 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84419 */     GIR_RootConstrainSelectedInstOperands,
     /*  84420 */     // GIR_Coverage, 4518,
     /*  84420 */     GIR_EraseRootFromParent_Done,
     /*  84421 */   // Label 1813: @84421
     /*  84421 */   GIM_Try, /*On fail goto*//*Label 1814*/ GIMT_Encode4(84463), // Rule ID 4548 //
     /*  84426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  84429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  84433 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84437 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84448 */     // (st VR512:{ *:[v8i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Zmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v8i64] }:$src)
     /*  84448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zmr),
     /*  84451 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84455 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84457 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84461 */     GIR_RootConstrainSelectedInstOperands,
     /*  84462 */     // GIR_Coverage, 4548,
     /*  84462 */     GIR_EraseRootFromParent_Done,
     /*  84463 */   // Label 1814: @84463
     /*  84463 */   GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(84501), // Rule ID 4590 //
     /*  84468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  84471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  84475 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84486 */     // (st VR512:{ *:[v8i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Zmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v8i64] }:$src)
     /*  84486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Zmr),
     /*  84489 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84493 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84495 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84499 */     GIR_RootConstrainSelectedInstOperands,
     /*  84500 */     // GIR_Coverage, 4590,
     /*  84500 */     GIR_EraseRootFromParent_Done,
     /*  84501 */   // Label 1815: @84501
     /*  84501 */   GIM_Reject,
     /*  84502 */ // Label 1811: @84502
     /*  84502 */ GIM_Reject,
     /*  84503 */ // Label 1488: @84503
     /*  84503 */ GIM_Try, /*On fail goto*//*Label 1816*/ GIMT_Encode4(84584),
     /*  84508 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  84511 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  84515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  84519 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84523 */   GIM_Try, /*On fail goto*//*Label 1817*/ GIMT_Encode4(84553), // Rule ID 4400 //
     /*  84528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_NoEGPR),
     /*  84531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84538 */     // (st VK16:{ *:[v16i1] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (KMOVWmk addr:{ *:[iPTR] }:$dst, VK16:{ *:[v16i1] }:$src)
     /*  84538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVWmk),
     /*  84541 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84545 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84547 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84551 */     GIR_RootConstrainSelectedInstOperands,
     /*  84552 */     // GIR_Coverage, 4400,
     /*  84552 */     GIR_EraseRootFromParent_Done,
     /*  84553 */   // Label 1817: @84553
     /*  84553 */   GIM_Try, /*On fail goto*//*Label 1818*/ GIMT_Encode4(84583), // Rule ID 4402 //
     /*  84558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEGPR_In64BitMode),
     /*  84561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84568 */     // (st VK16:{ *:[v16i1] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (KMOVWmk_EVEX addr:{ *:[iPTR] }:$dst, VK16:{ *:[v16i1] }:$src)
     /*  84568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVWmk_EVEX),
     /*  84571 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84575 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84577 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84581 */     GIR_RootConstrainSelectedInstOperands,
     /*  84582 */     // GIR_Coverage, 4402,
     /*  84582 */     GIR_EraseRootFromParent_Done,
     /*  84583 */   // Label 1818: @84583
     /*  84583 */   GIM_Reject,
     /*  84584 */ // Label 1816: @84584
     /*  84584 */ GIM_Reject,
     /*  84585 */ // Label 1489: @84585
     /*  84585 */ GIM_Try, /*On fail goto*//*Label 1819*/ GIMT_Encode4(84838),
     /*  84590 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  84593 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  84597 */   GIM_Try, /*On fail goto*//*Label 1820*/ GIMT_Encode4(84639), // Rule ID 17950 //
     /*  84602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  84605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  84609 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84613 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84624 */     // (st VR128:{ *:[v16i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (MOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v16i8] }:$src)
     /*  84624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSmr),
     /*  84627 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84631 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84633 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84637 */     GIR_RootConstrainSelectedInstOperands,
     /*  84638 */     // GIR_Coverage, 17950,
     /*  84638 */     GIR_EraseRootFromParent_Done,
     /*  84639 */   // Label 1820: @84639
     /*  84639 */   GIM_Try, /*On fail goto*//*Label 1821*/ GIMT_Encode4(84677), // Rule ID 17954 //
     /*  84644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  84647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  84651 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84662 */     // (st VR128:{ *:[v16i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v16i8] }:$src)
     /*  84662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSmr),
     /*  84665 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84669 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84671 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84675 */     GIR_RootConstrainSelectedInstOperands,
     /*  84676 */     // GIR_Coverage, 17954,
     /*  84676 */     GIR_EraseRootFromParent_Done,
     /*  84677 */   // Label 1821: @84677
     /*  84677 */   GIM_Try, /*On fail goto*//*Label 1822*/ GIMT_Encode4(84719), // Rule ID 18330 //
     /*  84682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  84685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  84689 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84693 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84704 */     // (st VR128:{ *:[v16i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQAmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v16i8] }:$src)
     /*  84704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQAmr),
     /*  84707 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84711 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84713 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84717 */     GIR_RootConstrainSelectedInstOperands,
     /*  84718 */     // GIR_Coverage, 18330,
     /*  84718 */     GIR_EraseRootFromParent_Done,
     /*  84719 */   // Label 1822: @84719
     /*  84719 */   GIM_Try, /*On fail goto*//*Label 1823*/ GIMT_Encode4(84757), // Rule ID 18334 //
     /*  84724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  84727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  84731 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84742 */     // (st VR128:{ *:[v16i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQUmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v16i8] }:$src)
     /*  84742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUmr),
     /*  84745 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84749 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84751 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84755 */     GIR_RootConstrainSelectedInstOperands,
     /*  84756 */     // GIR_Coverage, 18334,
     /*  84756 */     GIR_EraseRootFromParent_Done,
     /*  84757 */   // Label 1823: @84757
     /*  84757 */   GIM_Try, /*On fail goto*//*Label 1824*/ GIMT_Encode4(84799), // Rule ID 19823 //
     /*  84762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  84765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  84769 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84773 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84784 */     // (st VR128X:{ *:[v16i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Z128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v16i8] }:$src)
     /*  84784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128mr),
     /*  84787 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84791 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84793 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84797 */     GIR_RootConstrainSelectedInstOperands,
     /*  84798 */     // GIR_Coverage, 19823,
     /*  84798 */     GIR_EraseRootFromParent_Done,
     /*  84799 */   // Label 1824: @84799
     /*  84799 */   GIM_Try, /*On fail goto*//*Label 1825*/ GIMT_Encode4(84837), // Rule ID 19827 //
     /*  84804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  84807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  84811 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84822 */     // (st VR128X:{ *:[v16i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Z128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v16i8] }:$src)
     /*  84822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z128mr),
     /*  84825 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84829 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84831 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84835 */     GIR_RootConstrainSelectedInstOperands,
     /*  84836 */     // GIR_Coverage, 19827,
     /*  84836 */     GIR_EraseRootFromParent_Done,
     /*  84837 */   // Label 1825: @84837
     /*  84837 */   GIM_Reject,
     /*  84838 */ // Label 1819: @84838
     /*  84838 */ GIM_Reject,
     /*  84839 */ // Label 1490: @84839
     /*  84839 */ GIM_Try, /*On fail goto*//*Label 1826*/ GIMT_Encode4(85172),
     /*  84844 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  84847 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  84851 */   GIM_Try, /*On fail goto*//*Label 1827*/ GIMT_Encode4(84893), // Rule ID 17925 //
     /*  84856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  84859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  84863 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84867 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84878 */     // (st VR256:{ *:[v16i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v16i16] }:$src)
     /*  84878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYmr),
     /*  84881 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84885 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84887 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84891 */     GIR_RootConstrainSelectedInstOperands,
     /*  84892 */     // GIR_Coverage, 17925,
     /*  84892 */     GIR_EraseRootFromParent_Done,
     /*  84893 */   // Label 1827: @84893
     /*  84893 */   GIM_Try, /*On fail goto*//*Label 1828*/ GIMT_Encode4(84931), // Rule ID 17929 //
     /*  84898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  84901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  84905 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84916 */     // (st VR256:{ *:[v16i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v16i16] }:$src)
     /*  84916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYmr),
     /*  84919 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84923 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84925 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84929 */     GIR_RootConstrainSelectedInstOperands,
     /*  84930 */     // GIR_Coverage, 17929,
     /*  84930 */     GIR_EraseRootFromParent_Done,
     /*  84931 */   // Label 1828: @84931
     /*  84931 */   GIM_Try, /*On fail goto*//*Label 1829*/ GIMT_Encode4(84973), // Rule ID 17937 //
     /*  84936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  84939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  84943 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84947 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84958 */     // (st VR256:{ *:[v16f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v16f16] }:$src)
     /*  84958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYmr),
     /*  84961 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84965 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84967 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84971 */     GIR_RootConstrainSelectedInstOperands,
     /*  84972 */     // GIR_Coverage, 17937,
     /*  84972 */     GIR_EraseRootFromParent_Done,
     /*  84973 */   // Label 1829: @84973
     /*  84973 */   GIM_Try, /*On fail goto*//*Label 1830*/ GIMT_Encode4(85011), // Rule ID 17938 //
     /*  84978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  84981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  84985 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84996 */     // (st VR256:{ *:[v16f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v16f16] }:$src)
     /*  84996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYmr),
     /*  84999 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85003 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85005 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85009 */     GIR_RootConstrainSelectedInstOperands,
     /*  85010 */     // GIR_Coverage, 17938,
     /*  85010 */     GIR_EraseRootFromParent_Done,
     /*  85011 */   // Label 1830: @85011
     /*  85011 */   GIM_Try, /*On fail goto*//*Label 1831*/ GIMT_Encode4(85053), // Rule ID 19837 //
     /*  85016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  85019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  85023 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85027 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  85031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85038 */     // (st VR256X:{ *:[v16i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Z256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v16i16] }:$src)
     /*  85038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256mr),
     /*  85041 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85045 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85047 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85051 */     GIR_RootConstrainSelectedInstOperands,
     /*  85052 */     // GIR_Coverage, 19837,
     /*  85052 */     GIR_EraseRootFromParent_Done,
     /*  85053 */   // Label 1831: @85053
     /*  85053 */   GIM_Try, /*On fail goto*//*Label 1832*/ GIMT_Encode4(85095), // Rule ID 19838 //
     /*  85058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  85061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  85065 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85069 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  85073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85080 */     // (st VR256X:{ *:[v16f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSZ256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v16f16] }:$src)
     /*  85080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ256mr),
     /*  85083 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85087 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85089 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85093 */     GIR_RootConstrainSelectedInstOperands,
     /*  85094 */     // GIR_Coverage, 19838,
     /*  85094 */     GIR_EraseRootFromParent_Done,
     /*  85095 */   // Label 1832: @85095
     /*  85095 */   GIM_Try, /*On fail goto*//*Label 1833*/ GIMT_Encode4(85133), // Rule ID 19841 //
     /*  85100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  85103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  85107 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85118 */     // (st VR256X:{ *:[v16i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Z256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v16i16] }:$src)
     /*  85118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z256mr),
     /*  85121 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85125 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85127 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85131 */     GIR_RootConstrainSelectedInstOperands,
     /*  85132 */     // GIR_Coverage, 19841,
     /*  85132 */     GIR_EraseRootFromParent_Done,
     /*  85133 */   // Label 1833: @85133
     /*  85133 */   GIM_Try, /*On fail goto*//*Label 1834*/ GIMT_Encode4(85171), // Rule ID 19842 //
     /*  85138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  85141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  85145 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85156 */     // (st VR256X:{ *:[v16f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSZ256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v16f16] }:$src)
     /*  85156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ256mr),
     /*  85159 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85163 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85165 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85169 */     GIR_RootConstrainSelectedInstOperands,
     /*  85170 */     // GIR_Coverage, 19842,
     /*  85170 */     GIR_EraseRootFromParent_Done,
     /*  85171 */   // Label 1834: @85171
     /*  85171 */   GIM_Reject,
     /*  85172 */ // Label 1826: @85172
     /*  85172 */ GIM_Reject,
     /*  85173 */ // Label 1491: @85173
     /*  85173 */ GIM_Try, /*On fail goto*//*Label 1835*/ GIMT_Encode4(85346),
     /*  85178 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  85181 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  85185 */   GIM_Try, /*On fail goto*//*Label 1836*/ GIMT_Encode4(85227), // Rule ID 4476 //
     /*  85190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  85193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  85197 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85201 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  85205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85212 */     // (st VR512:{ *:[v16f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSZmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v16f32] }:$src)
     /*  85212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZmr),
     /*  85215 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85219 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85221 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85225 */     GIR_RootConstrainSelectedInstOperands,
     /*  85226 */     // GIR_Coverage, 4476,
     /*  85226 */     GIR_EraseRootFromParent_Done,
     /*  85227 */   // Label 1836: @85227
     /*  85227 */   GIM_Try, /*On fail goto*//*Label 1837*/ GIMT_Encode4(85265), // Rule ID 4506 //
     /*  85232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  85235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  85239 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85250 */     // (st VR512:{ *:[v16f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSZmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v16f32] }:$src)
     /*  85250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZmr),
     /*  85253 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85257 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85259 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85263 */     GIR_RootConstrainSelectedInstOperands,
     /*  85264 */     // GIR_Coverage, 4506,
     /*  85264 */     GIR_EraseRootFromParent_Done,
     /*  85265 */   // Label 1837: @85265
     /*  85265 */   GIM_Try, /*On fail goto*//*Label 1838*/ GIMT_Encode4(85307), // Rule ID 19804 //
     /*  85270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  85273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  85277 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85281 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  85285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85292 */     // (st VR512:{ *:[v16i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Zmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v16i32] }:$src)
     /*  85292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zmr),
     /*  85295 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85299 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85301 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85305 */     GIR_RootConstrainSelectedInstOperands,
     /*  85306 */     // GIR_Coverage, 19804,
     /*  85306 */     GIR_EraseRootFromParent_Done,
     /*  85307 */   // Label 1838: @85307
     /*  85307 */   GIM_Try, /*On fail goto*//*Label 1839*/ GIMT_Encode4(85345), // Rule ID 19808 //
     /*  85312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  85315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  85319 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85330 */     // (st VR512:{ *:[v16i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Zmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v16i32] }:$src)
     /*  85330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Zmr),
     /*  85333 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85337 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85343 */     GIR_RootConstrainSelectedInstOperands,
     /*  85344 */     // GIR_Coverage, 19808,
     /*  85344 */     GIR_EraseRootFromParent_Done,
     /*  85345 */   // Label 1839: @85345
     /*  85345 */   GIM_Reject,
     /*  85346 */ // Label 1835: @85346
     /*  85346 */ GIM_Reject,
     /*  85347 */ // Label 1492: @85347
     /*  85347 */ GIM_Try, /*On fail goto*//*Label 1840*/ GIMT_Encode4(85428),
     /*  85352 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  85355 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  85359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  85363 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85367 */   GIM_Try, /*On fail goto*//*Label 1841*/ GIMT_Encode4(85397), // Rule ID 4404 //
     /*  85372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_NoEGPR),
     /*  85375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85382 */     // (st VK32:{ *:[v32i1] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (KMOVDmk addr:{ *:[iPTR] }:$dst, VK32:{ *:[v32i1] }:$src)
     /*  85382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVDmk),
     /*  85385 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85389 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85391 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85395 */     GIR_RootConstrainSelectedInstOperands,
     /*  85396 */     // GIR_Coverage, 4404,
     /*  85396 */     GIR_EraseRootFromParent_Done,
     /*  85397 */   // Label 1841: @85397
     /*  85397 */   GIM_Try, /*On fail goto*//*Label 1842*/ GIMT_Encode4(85427), // Rule ID 4408 //
     /*  85402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEGPR_In64BitMode),
     /*  85405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85412 */     // (st VK32:{ *:[v32i1] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (KMOVDmk_EVEX addr:{ *:[iPTR] }:$dst, VK32:{ *:[v32i1] }:$src)
     /*  85412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVDmk_EVEX),
     /*  85415 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85419 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85421 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85425 */     GIR_RootConstrainSelectedInstOperands,
     /*  85426 */     // GIR_Coverage, 4408,
     /*  85426 */     GIR_EraseRootFromParent_Done,
     /*  85427 */   // Label 1842: @85427
     /*  85427 */   GIM_Reject,
     /*  85428 */ // Label 1840: @85428
     /*  85428 */ GIM_Reject,
     /*  85429 */ // Label 1493: @85429
     /*  85429 */ GIM_Try, /*On fail goto*//*Label 1843*/ GIMT_Encode4(85602),
     /*  85434 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  85437 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  85441 */   GIM_Try, /*On fail goto*//*Label 1844*/ GIMT_Encode4(85483), // Rule ID 17926 //
     /*  85446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  85449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  85453 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85457 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  85461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85468 */     // (st VR256:{ *:[v32i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v32i8] }:$src)
     /*  85468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYmr),
     /*  85471 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85475 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85477 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85481 */     GIR_RootConstrainSelectedInstOperands,
     /*  85482 */     // GIR_Coverage, 17926,
     /*  85482 */     GIR_EraseRootFromParent_Done,
     /*  85483 */   // Label 1844: @85483
     /*  85483 */   GIM_Try, /*On fail goto*//*Label 1845*/ GIMT_Encode4(85521), // Rule ID 17930 //
     /*  85488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  85491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  85495 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85506 */     // (st VR256:{ *:[v32i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v32i8] }:$src)
     /*  85506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYmr),
     /*  85509 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85513 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85515 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85519 */     GIR_RootConstrainSelectedInstOperands,
     /*  85520 */     // GIR_Coverage, 17930,
     /*  85520 */     GIR_EraseRootFromParent_Done,
     /*  85521 */   // Label 1845: @85521
     /*  85521 */   GIM_Try, /*On fail goto*//*Label 1846*/ GIMT_Encode4(85563), // Rule ID 19839 //
     /*  85526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  85529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  85533 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85537 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  85541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85548 */     // (st VR256X:{ *:[v32i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Z256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v32i8] }:$src)
     /*  85548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256mr),
     /*  85551 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85555 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85557 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85561 */     GIR_RootConstrainSelectedInstOperands,
     /*  85562 */     // GIR_Coverage, 19839,
     /*  85562 */     GIR_EraseRootFromParent_Done,
     /*  85563 */   // Label 1846: @85563
     /*  85563 */   GIM_Try, /*On fail goto*//*Label 1847*/ GIMT_Encode4(85601), // Rule ID 19843 //
     /*  85568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  85571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  85575 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85586 */     // (st VR256X:{ *:[v32i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Z256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v32i8] }:$src)
     /*  85586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z256mr),
     /*  85589 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85593 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85595 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85599 */     GIR_RootConstrainSelectedInstOperands,
     /*  85600 */     // GIR_Coverage, 19843,
     /*  85600 */     GIR_EraseRootFromParent_Done,
     /*  85601 */   // Label 1847: @85601
     /*  85601 */   GIM_Reject,
     /*  85602 */ // Label 1843: @85602
     /*  85602 */ GIM_Reject,
     /*  85603 */ // Label 1494: @85603
     /*  85603 */ GIM_Try, /*On fail goto*//*Label 1848*/ GIMT_Encode4(85776),
     /*  85608 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  85611 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  85615 */   GIM_Try, /*On fail goto*//*Label 1849*/ GIMT_Encode4(85657), // Rule ID 19805 //
     /*  85620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  85623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  85627 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85631 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  85635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85642 */     // (st VR512:{ *:[v32i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Zmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v32i16] }:$src)
     /*  85642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zmr),
     /*  85645 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85649 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85655 */     GIR_RootConstrainSelectedInstOperands,
     /*  85656 */     // GIR_Coverage, 19805,
     /*  85656 */     GIR_EraseRootFromParent_Done,
     /*  85657 */   // Label 1849: @85657
     /*  85657 */   GIM_Try, /*On fail goto*//*Label 1850*/ GIMT_Encode4(85699), // Rule ID 19806 //
     /*  85662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  85665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  85669 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85673 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  85677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85684 */     // (st VR512:{ *:[v32f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSZmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v32f16] }:$src)
     /*  85684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZmr),
     /*  85687 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85691 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85693 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85697 */     GIR_RootConstrainSelectedInstOperands,
     /*  85698 */     // GIR_Coverage, 19806,
     /*  85698 */     GIR_EraseRootFromParent_Done,
     /*  85699 */   // Label 1850: @85699
     /*  85699 */   GIM_Try, /*On fail goto*//*Label 1851*/ GIMT_Encode4(85737), // Rule ID 19809 //
     /*  85704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  85707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  85711 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85722 */     // (st VR512:{ *:[v32i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Zmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v32i16] }:$src)
     /*  85722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Zmr),
     /*  85725 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85729 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85731 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85735 */     GIR_RootConstrainSelectedInstOperands,
     /*  85736 */     // GIR_Coverage, 19809,
     /*  85736 */     GIR_EraseRootFromParent_Done,
     /*  85737 */   // Label 1851: @85737
     /*  85737 */   GIM_Try, /*On fail goto*//*Label 1852*/ GIMT_Encode4(85775), // Rule ID 19810 //
     /*  85742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  85745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  85749 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85760 */     // (st VR512:{ *:[v32f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSZmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v32f16] }:$src)
     /*  85760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZmr),
     /*  85763 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85767 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85769 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85773 */     GIR_RootConstrainSelectedInstOperands,
     /*  85774 */     // GIR_Coverage, 19810,
     /*  85774 */     GIR_EraseRootFromParent_Done,
     /*  85775 */   // Label 1852: @85775
     /*  85775 */   GIM_Reject,
     /*  85776 */ // Label 1848: @85776
     /*  85776 */ GIM_Reject,
     /*  85777 */ // Label 1495: @85777
     /*  85777 */ GIM_Try, /*On fail goto*//*Label 1853*/ GIMT_Encode4(85858),
     /*  85782 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  85785 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  85789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  85793 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85797 */   GIM_Try, /*On fail goto*//*Label 1854*/ GIMT_Encode4(85827), // Rule ID 4406 //
     /*  85802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_NoEGPR),
     /*  85805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85812 */     // (st VK64:{ *:[v64i1] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (KMOVQmk addr:{ *:[iPTR] }:$dst, VK64:{ *:[v64i1] }:$src)
     /*  85812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVQmk),
     /*  85815 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85819 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85821 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85825 */     GIR_RootConstrainSelectedInstOperands,
     /*  85826 */     // GIR_Coverage, 4406,
     /*  85826 */     GIR_EraseRootFromParent_Done,
     /*  85827 */   // Label 1854: @85827
     /*  85827 */   GIM_Try, /*On fail goto*//*Label 1855*/ GIMT_Encode4(85857), // Rule ID 4410 //
     /*  85832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEGPR_In64BitMode),
     /*  85835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85842 */     // (st VK64:{ *:[v64i1] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (KMOVQmk_EVEX addr:{ *:[iPTR] }:$dst, VK64:{ *:[v64i1] }:$src)
     /*  85842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVQmk_EVEX),
     /*  85845 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85849 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85851 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85855 */     GIR_RootConstrainSelectedInstOperands,
     /*  85856 */     // GIR_Coverage, 4410,
     /*  85856 */     GIR_EraseRootFromParent_Done,
     /*  85857 */   // Label 1855: @85857
     /*  85857 */   GIM_Reject,
     /*  85858 */ // Label 1853: @85858
     /*  85858 */ GIM_Reject,
     /*  85859 */ // Label 1496: @85859
     /*  85859 */ GIM_Try, /*On fail goto*//*Label 1856*/ GIMT_Encode4(85952),
     /*  85864 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  85867 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  85871 */   GIM_Try, /*On fail goto*//*Label 1857*/ GIMT_Encode4(85913), // Rule ID 19807 //
     /*  85876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  85879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  85883 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85887 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  85891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85898 */     // (st VR512:{ *:[v64i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Zmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v64i8] }:$src)
     /*  85898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zmr),
     /*  85901 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85905 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85907 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85911 */     GIR_RootConstrainSelectedInstOperands,
     /*  85912 */     // GIR_Coverage, 19807,
     /*  85912 */     GIR_EraseRootFromParent_Done,
     /*  85913 */   // Label 1857: @85913
     /*  85913 */   GIM_Try, /*On fail goto*//*Label 1858*/ GIMT_Encode4(85951), // Rule ID 19811 //
     /*  85918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  85921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  85925 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85936 */     // (st VR512:{ *:[v64i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Zmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v64i8] }:$src)
     /*  85936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Zmr),
     /*  85939 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85943 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85945 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85949 */     GIR_RootConstrainSelectedInstOperands,
     /*  85950 */     // GIR_Coverage, 19811,
     /*  85950 */     GIR_EraseRootFromParent_Done,
     /*  85951 */   // Label 1858: @85951
     /*  85951 */   GIM_Reject,
     /*  85952 */ // Label 1856: @85952
     /*  85952 */ GIM_Reject,
     /*  85953 */ // Label 1497: @85953
     /*  85953 */ GIM_Reject,
     /*  85954 */ // Label 14: @85954
     /*  85954 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(5), /*)*//*default:*//*Label 1863*/ GIMT_Encode4(86189),
     /*  85965 */ /*GILLT_s8*//*Label 1859*/ GIMT_Encode4(85981),
     /*  85969 */ /*GILLT_s16*//*Label 1860*/ GIMT_Encode4(86033),
     /*  85973 */ /*GILLT_s32*//*Label 1861*/ GIMT_Encode4(86085),
     /*  85977 */ /*GILLT_s64*//*Label 1862*/ GIMT_Encode4(86137),
     /*  85981 */ // Label 1859: @85981
     /*  85981 */ GIM_Try, /*On fail goto*//*Label 1864*/ GIMT_Encode4(86032), // Rule ID 45 //
     /*  85986 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /*  85989 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  85996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  86000 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86004 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  86008 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86015 */   // (atomic_swap:{ *:[i8] } addr:{ *:[iPTR] }:$ptr, GR8:{ *:[i8] }:$val)<<P:Predicate_atomic_swap_i8>>  =>  (XCHG8rm:{ *:[i8] } GR8:{ *:[i8] }:$val, addr:{ *:[iPTR] }:$ptr)
     /*  86015 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XCHG8rm),
     /*  86018 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86020 */   GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  86022 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // ptr
     /*  86026 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86030 */   GIR_RootConstrainSelectedInstOperands,
     /*  86031 */   // GIR_Coverage, 45,
     /*  86031 */   GIR_EraseRootFromParent_Done,
     /*  86032 */ // Label 1864: @86032
     /*  86032 */ GIM_Reject,
     /*  86033 */ // Label 1860: @86033
     /*  86033 */ GIM_Try, /*On fail goto*//*Label 1865*/ GIMT_Encode4(86084), // Rule ID 46 //
     /*  86038 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  86041 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  86048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  86052 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86056 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  86060 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86067 */   // (atomic_swap:{ *:[i16] } addr:{ *:[iPTR] }:$ptr, GR16:{ *:[i16] }:$val)<<P:Predicate_atomic_swap_i16>>  =>  (XCHG16rm:{ *:[i16] } GR16:{ *:[i16] }:$val, addr:{ *:[iPTR] }:$ptr)
     /*  86067 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XCHG16rm),
     /*  86070 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86072 */   GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  86074 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // ptr
     /*  86078 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86082 */   GIR_RootConstrainSelectedInstOperands,
     /*  86083 */   // GIR_Coverage, 46,
     /*  86083 */   GIR_EraseRootFromParent_Done,
     /*  86084 */ // Label 1865: @86084
     /*  86084 */ GIM_Reject,
     /*  86085 */ // Label 1861: @86085
     /*  86085 */ GIM_Try, /*On fail goto*//*Label 1866*/ GIMT_Encode4(86136), // Rule ID 47 //
     /*  86090 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  86093 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  86100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  86104 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86108 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  86112 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86119 */   // (atomic_swap:{ *:[i32] } addr:{ *:[iPTR] }:$ptr, GR32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i32>>  =>  (XCHG32rm:{ *:[i32] } GR32:{ *:[i32] }:$val, addr:{ *:[iPTR] }:$ptr)
     /*  86119 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XCHG32rm),
     /*  86122 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86124 */   GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  86126 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // ptr
     /*  86130 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86134 */   GIR_RootConstrainSelectedInstOperands,
     /*  86135 */   // GIR_Coverage, 47,
     /*  86135 */   GIR_EraseRootFromParent_Done,
     /*  86136 */ // Label 1866: @86136
     /*  86136 */ GIM_Reject,
     /*  86137 */ // Label 1862: @86137
     /*  86137 */ GIM_Try, /*On fail goto*//*Label 1867*/ GIMT_Encode4(86188), // Rule ID 48 //
     /*  86142 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  86145 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  86152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  86156 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86160 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  86164 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86171 */   // (atomic_swap:{ *:[i64] } addr:{ *:[iPTR] }:$ptr, GR64:{ *:[i64] }:$val)<<P:Predicate_atomic_swap_i64>>  =>  (XCHG64rm:{ *:[i64] } GR64:{ *:[i64] }:$val, addr:{ *:[iPTR] }:$ptr)
     /*  86171 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XCHG64rm),
     /*  86174 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86176 */   GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  86178 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // ptr
     /*  86182 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86186 */   GIR_RootConstrainSelectedInstOperands,
     /*  86187 */   // GIR_Coverage, 48,
     /*  86187 */   GIR_EraseRootFromParent_Done,
     /*  86188 */ // Label 1867: @86188
     /*  86188 */ GIM_Reject,
     /*  86189 */ // Label 1863: @86189
     /*  86189 */ GIM_Reject,
     /*  86190 */ // Label 15: @86190
     /*  86190 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(5), /*)*//*default:*//*Label 1872*/ GIMT_Encode4(86437),
     /*  86201 */ /*GILLT_s8*//*Label 1868*/ GIMT_Encode4(86217),
     /*  86205 */ /*GILLT_s16*//*Label 1869*/ GIMT_Encode4(86272),
     /*  86209 */ /*GILLT_s32*//*Label 1870*/ GIMT_Encode4(86327),
     /*  86213 */ /*GILLT_s64*//*Label 1871*/ GIMT_Encode4(86382),
     /*  86217 */ // Label 1868: @86217
     /*  86217 */ GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(86271), // Rule ID 17298 //
     /*  86222 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /*  86225 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  86232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  86236 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86240 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  86244 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86251 */   // (atomic_load_add:{ *:[i8] } addr:{ *:[iPTR] }:$ptr, GR8:{ *:[i8] }:$val)<<P:Predicate_atomic_load_add_i8>>  =>  (LXADD8:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$val, addr:{ *:[iPTR] }:$ptr)
     /*  86251 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LXADD8),
     /*  86254 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86256 */   GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  86258 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // ptr
     /*  86262 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  86265 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86269 */   GIR_RootConstrainSelectedInstOperands,
     /*  86270 */   // GIR_Coverage, 17298,
     /*  86270 */   GIR_EraseRootFromParent_Done,
     /*  86271 */ // Label 1873: @86271
     /*  86271 */ GIM_Reject,
     /*  86272 */ // Label 1869: @86272
     /*  86272 */ GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(86326), // Rule ID 17299 //
     /*  86277 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  86280 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  86287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  86291 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86295 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  86299 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86306 */   // (atomic_load_add:{ *:[i16] } addr:{ *:[iPTR] }:$ptr, GR16:{ *:[i16] }:$val)<<P:Predicate_atomic_load_add_i16>>  =>  (LXADD16:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$val, addr:{ *:[iPTR] }:$ptr)
     /*  86306 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LXADD16),
     /*  86309 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86311 */   GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  86313 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // ptr
     /*  86317 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  86320 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86324 */   GIR_RootConstrainSelectedInstOperands,
     /*  86325 */   // GIR_Coverage, 17299,
     /*  86325 */   GIR_EraseRootFromParent_Done,
     /*  86326 */ // Label 1874: @86326
     /*  86326 */ GIM_Reject,
     /*  86327 */ // Label 1870: @86327
     /*  86327 */ GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(86381), // Rule ID 17300 //
     /*  86332 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  86335 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  86342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  86346 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86350 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  86354 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86361 */   // (atomic_load_add:{ *:[i32] } addr:{ *:[iPTR] }:$ptr, GR32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i32>>  =>  (LXADD32:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$val, addr:{ *:[iPTR] }:$ptr)
     /*  86361 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LXADD32),
     /*  86364 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86366 */   GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  86368 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // ptr
     /*  86372 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  86375 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86379 */   GIR_RootConstrainSelectedInstOperands,
     /*  86380 */   // GIR_Coverage, 17300,
     /*  86380 */   GIR_EraseRootFromParent_Done,
     /*  86381 */ // Label 1875: @86381
     /*  86381 */ GIM_Reject,
     /*  86382 */ // Label 1871: @86382
     /*  86382 */ GIM_Try, /*On fail goto*//*Label 1876*/ GIMT_Encode4(86436), // Rule ID 17301 //
     /*  86387 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  86390 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  86397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  86401 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86405 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  86409 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86416 */   // (atomic_load_add:{ *:[i64] } addr:{ *:[iPTR] }:$ptr, GR64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_add_i64>>  =>  (LXADD64:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$val, addr:{ *:[iPTR] }:$ptr)
     /*  86416 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LXADD64),
     /*  86419 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86421 */   GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  86423 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // ptr
     /*  86427 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  86430 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86434 */   GIR_RootConstrainSelectedInstOperands,
     /*  86435 */   // GIR_Coverage, 17301,
     /*  86435 */   GIR_EraseRootFromParent_Done,
     /*  86436 */ // Label 1876: @86436
     /*  86436 */ GIM_Reject,
     /*  86437 */ // Label 1872: @86437
     /*  86437 */ GIM_Reject,
     /*  86438 */ // Label 16: @86438
     /*  86438 */ GIM_Try, /*On fail goto*//*Label 1877*/ GIMT_Encode4(86593),
     /*  86443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  86446 */   GIM_Try, /*On fail goto*//*Label 1878*/ GIMT_Encode4(86496), // Rule ID 156 //
     /*  86451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPREFETCHI_In64BitMode),
     /*  86454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  86457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  86460 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/0,
     /*  86464 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  86468 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 3,
     /*  86472 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  86476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/0, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86483 */     // (prefetch addr:{ *:[iPTR] }:$src, 0:{ *:[i32] }, 3:{ *:[i32] }, 0:{ *:[i32] })  =>  (PREFETCHIT0 addr:{ *:[iPTR] }:$src)
     /*  86483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PREFETCHIT0),
     /*  86486 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86490 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86494 */     GIR_RootConstrainSelectedInstOperands,
     /*  86495 */     // GIR_Coverage, 156,
     /*  86495 */     GIR_EraseRootFromParent_Done,
     /*  86496 */   // Label 1878: @86496
     /*  86496 */   GIM_Try, /*On fail goto*//*Label 1879*/ GIMT_Encode4(86546), // Rule ID 157 //
     /*  86501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPREFETCHI_In64BitMode),
     /*  86504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  86507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  86510 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/0,
     /*  86514 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  86518 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 2,
     /*  86522 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  86526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/0, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86533 */     // (prefetch addr:{ *:[iPTR] }:$src, 0:{ *:[i32] }, 2:{ *:[i32] }, 0:{ *:[i32] })  =>  (PREFETCHIT1 addr:{ *:[iPTR] }:$src)
     /*  86533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PREFETCHIT1),
     /*  86536 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86540 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86544 */     GIR_RootConstrainSelectedInstOperands,
     /*  86545 */     // GIR_Coverage, 157,
     /*  86545 */     GIR_EraseRootFromParent_Done,
     /*  86546 */   // Label 1879: @86546
     /*  86546 */   GIM_Try, /*On fail goto*//*Label 1880*/ GIMT_Encode4(86592), // Rule ID 16983 //
     /*  86551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPrefetchW),
     /*  86554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  86557 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/0,
     /*  86561 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 1,
     /*  86565 */     // MIs[0] Operand 2
     /*  86565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  86568 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  86572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/0, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86579 */     // (prefetch addr:{ *:[iPTR] }:$addr, 1:{ *:[i32] }, (timm:{ *:[i32] })<<P:Predicate_PrefetchWLevel>>, 1:{ *:[i32] })  =>  (PREFETCHW addr:{ *:[iPTR] }:$addr)
     /*  86579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PREFETCHW),
     /*  86582 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // addr
     /*  86586 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86590 */     GIR_RootConstrainSelectedInstOperands,
     /*  86591 */     // GIR_Coverage, 16983,
     /*  86591 */     GIR_EraseRootFromParent_Done,
     /*  86592 */   // Label 1880: @86592
     /*  86592 */   GIM_Reject,
     /*  86593 */ // Label 1877: @86593
     /*  86593 */ GIM_Try, /*On fail goto*//*Label 1881*/ GIMT_Encode4(86756),
     /*  86598 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  86601 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  86604 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/0,
     /*  86608 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  86611 */   GIM_Try, /*On fail goto*//*Label 1882*/ GIMT_Encode4(86647), // Rule ID 2505 //
     /*  86616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSEPrefetch),
     /*  86619 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 3,
     /*  86623 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  86627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/0, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86634 */     // (prefetch addr:{ *:[iPTR] }:$src, (timm:{ *:[i32] }), 3:{ *:[i32] }, 1:{ *:[i32] })  =>  (PREFETCHT0 addr:{ *:[iPTR] }:$src)
     /*  86634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PREFETCHT0),
     /*  86637 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86641 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86645 */     GIR_RootConstrainSelectedInstOperands,
     /*  86646 */     // GIR_Coverage, 2505,
     /*  86646 */     GIR_EraseRootFromParent_Done,
     /*  86647 */   // Label 1882: @86647
     /*  86647 */   GIM_Try, /*On fail goto*//*Label 1883*/ GIMT_Encode4(86683), // Rule ID 2506 //
     /*  86652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSEPrefetch),
     /*  86655 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 2,
     /*  86659 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  86663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/0, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86670 */     // (prefetch addr:{ *:[iPTR] }:$src, (timm:{ *:[i32] }), 2:{ *:[i32] }, 1:{ *:[i32] })  =>  (PREFETCHT1 addr:{ *:[iPTR] }:$src)
     /*  86670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PREFETCHT1),
     /*  86673 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86677 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86681 */     GIR_RootConstrainSelectedInstOperands,
     /*  86682 */     // GIR_Coverage, 2506,
     /*  86682 */     GIR_EraseRootFromParent_Done,
     /*  86683 */   // Label 1883: @86683
     /*  86683 */   GIM_Try, /*On fail goto*//*Label 1884*/ GIMT_Encode4(86719), // Rule ID 2507 //
     /*  86688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSEPrefetch),
     /*  86691 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  86695 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  86699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/0, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86706 */     // (prefetch addr:{ *:[iPTR] }:$src, (timm:{ *:[i32] }), 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (PREFETCHT2 addr:{ *:[iPTR] }:$src)
     /*  86706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PREFETCHT2),
     /*  86709 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86713 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86717 */     GIR_RootConstrainSelectedInstOperands,
     /*  86718 */     // GIR_Coverage, 2507,
     /*  86718 */     GIR_EraseRootFromParent_Done,
     /*  86719 */   // Label 1884: @86719
     /*  86719 */   GIM_Try, /*On fail goto*//*Label 1885*/ GIMT_Encode4(86755), // Rule ID 2508 //
     /*  86724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSEPrefetch),
     /*  86727 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  86731 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  86735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/0, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86742 */     // (prefetch addr:{ *:[iPTR] }:$src, (timm:{ *:[i32] }), 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (PREFETCHNTA addr:{ *:[iPTR] }:$src)
     /*  86742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PREFETCHNTA),
     /*  86745 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86749 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86753 */     GIR_RootConstrainSelectedInstOperands,
     /*  86754 */     // GIR_Coverage, 2508,
     /*  86754 */     GIR_EraseRootFromParent_Done,
     /*  86755 */   // Label 1885: @86755
     /*  86755 */   GIM_Reject,
     /*  86756 */ // Label 1881: @86756
     /*  86756 */ GIM_Reject,
     /*  86757 */ // Label 17: @86757
     /*  86757 */ GIM_Try, /*On fail goto*//*Label 1886*/ GIMT_Encode4(89086),
     /*  86762 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  86765 */   GIM_Try, /*On fail goto*//*Label 1887*/ GIMT_Encode4(86832), // Rule ID 1530 //
     /*  86770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  86773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphsubwd),
     /*  86778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  86781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  86788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  86796 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86799 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  86803 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  86807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86809 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86816 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15057:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHSUBWDrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  86816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBWDrm),
     /*  86819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86821 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86825 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  86830 */     GIR_RootConstrainSelectedInstOperands,
     /*  86831 */     // GIR_Coverage, 1530,
     /*  86831 */     GIR_EraseRootFromParent_Done,
     /*  86832 */   // Label 1887: @86832
     /*  86832 */   GIM_Try, /*On fail goto*//*Label 1888*/ GIMT_Encode4(86899), // Rule ID 1532 //
     /*  86837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  86840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphsubdq),
     /*  86845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  86848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  86851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  86855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  86863 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86866 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  86870 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  86874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86876 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86883 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15056:{ *:[iPTR] }, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHSUBDQrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  86883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBDQrm),
     /*  86886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86888 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86892 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  86897 */     GIR_RootConstrainSelectedInstOperands,
     /*  86898 */     // GIR_Coverage, 1532,
     /*  86898 */     GIR_EraseRootFromParent_Done,
     /*  86899 */   // Label 1888: @86899
     /*  86899 */   GIM_Try, /*On fail goto*//*Label 1889*/ GIMT_Encode4(86966), // Rule ID 1534 //
     /*  86904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  86907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphsubbw),
     /*  86912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  86915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  86918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  86922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  86930 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86933 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  86937 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  86941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86943 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86950 */     // (intrinsic_wo_chain:{ *:[v8i16] } 15055:{ *:[iPTR] }, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHSUBBWrm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  86950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBBWrm),
     /*  86953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86955 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86959 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  86964 */     GIR_RootConstrainSelectedInstOperands,
     /*  86965 */     // GIR_Coverage, 1534,
     /*  86965 */     GIR_EraseRootFromParent_Done,
     /*  86966 */   // Label 1889: @86966
     /*  86966 */   GIM_Try, /*On fail goto*//*Label 1890*/ GIMT_Encode4(87033), // Rule ID 1536 //
     /*  86971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  86974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddwq),
     /*  86979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  86982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  86989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  86997 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87000 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87004 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87008 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87010 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87017 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15054:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDWQrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  87017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDWQrm),
     /*  87020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87022 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87026 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87031 */     GIR_RootConstrainSelectedInstOperands,
     /*  87032 */     // GIR_Coverage, 1536,
     /*  87032 */     GIR_EraseRootFromParent_Done,
     /*  87033 */   // Label 1890: @87033
     /*  87033 */   GIM_Try, /*On fail goto*//*Label 1891*/ GIMT_Encode4(87100), // Rule ID 1538 //
     /*  87038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddwd),
     /*  87046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  87049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87064 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87067 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87071 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87077 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87084 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15053:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDWDrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  87084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDWDrm),
     /*  87087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87089 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87093 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87098 */     GIR_RootConstrainSelectedInstOperands,
     /*  87099 */     // GIR_Coverage, 1538,
     /*  87099 */     GIR_EraseRootFromParent_Done,
     /*  87100 */   // Label 1891: @87100
     /*  87100 */   GIM_Try, /*On fail goto*//*Label 1892*/ GIMT_Encode4(87167), // Rule ID 1540 //
     /*  87105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphadduwq),
     /*  87113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  87116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87131 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87134 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87138 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87144 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87151 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15052:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDUWQrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  87151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUWQrm),
     /*  87154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87156 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87160 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87165 */     GIR_RootConstrainSelectedInstOperands,
     /*  87166 */     // GIR_Coverage, 1540,
     /*  87166 */     GIR_EraseRootFromParent_Done,
     /*  87167 */   // Label 1892: @87167
     /*  87167 */   GIM_Try, /*On fail goto*//*Label 1893*/ GIMT_Encode4(87234), // Rule ID 1542 //
     /*  87172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphadduwd),
     /*  87180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  87183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87198 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87201 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87205 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87211 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87218 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15051:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDUWDrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  87218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUWDrm),
     /*  87221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87223 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87227 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87232 */     GIR_RootConstrainSelectedInstOperands,
     /*  87233 */     // GIR_Coverage, 1542,
     /*  87233 */     GIR_EraseRootFromParent_Done,
     /*  87234 */   // Label 1893: @87234
     /*  87234 */   GIM_Try, /*On fail goto*//*Label 1894*/ GIMT_Encode4(87301), // Rule ID 1544 //
     /*  87239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddudq),
     /*  87247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  87250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  87253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87265 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87268 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87272 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87278 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87285 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15050:{ *:[iPTR] }, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDUDQrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  87285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUDQrm),
     /*  87288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87290 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87294 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87299 */     GIR_RootConstrainSelectedInstOperands,
     /*  87300 */     // GIR_Coverage, 1544,
     /*  87300 */     GIR_EraseRootFromParent_Done,
     /*  87301 */   // Label 1894: @87301
     /*  87301 */   GIM_Try, /*On fail goto*//*Label 1895*/ GIMT_Encode4(87368), // Rule ID 1546 //
     /*  87306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddubw),
     /*  87314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87332 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87335 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87339 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87345 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87352 */     // (intrinsic_wo_chain:{ *:[v8i16] } 15049:{ *:[iPTR] }, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDUBWrm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  87352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUBWrm),
     /*  87355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87357 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87361 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87366 */     GIR_RootConstrainSelectedInstOperands,
     /*  87367 */     // GIR_Coverage, 1546,
     /*  87367 */     GIR_EraseRootFromParent_Done,
     /*  87368 */   // Label 1895: @87368
     /*  87368 */   GIM_Try, /*On fail goto*//*Label 1896*/ GIMT_Encode4(87435), // Rule ID 1548 //
     /*  87373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddubq),
     /*  87381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  87384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87399 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87402 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87406 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87412 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87419 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15048:{ *:[iPTR] }, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDUBQrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  87419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUBQrm),
     /*  87422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87424 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87428 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87433 */     GIR_RootConstrainSelectedInstOperands,
     /*  87434 */     // GIR_Coverage, 1548,
     /*  87434 */     GIR_EraseRootFromParent_Done,
     /*  87435 */   // Label 1896: @87435
     /*  87435 */   GIM_Try, /*On fail goto*//*Label 1897*/ GIMT_Encode4(87502), // Rule ID 1550 //
     /*  87440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddubd),
     /*  87448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  87451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87466 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87469 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87473 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87479 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87486 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15047:{ *:[iPTR] }, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDUBDrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  87486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUBDrm),
     /*  87489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87491 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87495 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87500 */     GIR_RootConstrainSelectedInstOperands,
     /*  87501 */     // GIR_Coverage, 1550,
     /*  87501 */     GIR_EraseRootFromParent_Done,
     /*  87502 */   // Label 1897: @87502
     /*  87502 */   GIM_Try, /*On fail goto*//*Label 1898*/ GIMT_Encode4(87569), // Rule ID 1552 //
     /*  87507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphadddq),
     /*  87515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  87518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  87521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87533 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87536 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87540 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87544 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87546 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87553 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15046:{ *:[iPTR] }, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDDQrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  87553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDDQrm),
     /*  87556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87558 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87562 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87567 */     GIR_RootConstrainSelectedInstOperands,
     /*  87568 */     // GIR_Coverage, 1552,
     /*  87568 */     GIR_EraseRootFromParent_Done,
     /*  87569 */   // Label 1898: @87569
     /*  87569 */   GIM_Try, /*On fail goto*//*Label 1899*/ GIMT_Encode4(87636), // Rule ID 1554 //
     /*  87574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddbw),
     /*  87582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87600 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87603 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87607 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87613 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87620 */     // (intrinsic_wo_chain:{ *:[v8i16] } 15045:{ *:[iPTR] }, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDBWrm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  87620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDBWrm),
     /*  87623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87625 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87629 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87634 */     GIR_RootConstrainSelectedInstOperands,
     /*  87635 */     // GIR_Coverage, 1554,
     /*  87635 */     GIR_EraseRootFromParent_Done,
     /*  87636 */   // Label 1899: @87636
     /*  87636 */   GIM_Try, /*On fail goto*//*Label 1900*/ GIMT_Encode4(87703), // Rule ID 1556 //
     /*  87641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddbq),
     /*  87649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  87652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87667 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87670 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87674 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87678 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87680 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87687 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15044:{ *:[iPTR] }, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDBQrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  87687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDBQrm),
     /*  87690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87692 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87696 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87701 */     GIR_RootConstrainSelectedInstOperands,
     /*  87702 */     // GIR_Coverage, 1556,
     /*  87702 */     GIR_EraseRootFromParent_Done,
     /*  87703 */   // Label 1900: @87703
     /*  87703 */   GIM_Try, /*On fail goto*//*Label 1901*/ GIMT_Encode4(87770), // Rule ID 1558 //
     /*  87708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddbd),
     /*  87716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  87719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87734 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87737 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87741 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87747 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87754 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15043:{ *:[iPTR] }, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDBDrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  87754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDBDrm),
     /*  87757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87759 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87763 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87768 */     GIR_RootConstrainSelectedInstOperands,
     /*  87769 */     // GIR_Coverage, 1558,
     /*  87769 */     GIR_EraseRootFromParent_Done,
     /*  87770 */   // Label 1901: @87770
     /*  87770 */   GIM_Try, /*On fail goto*//*Label 1902*/ GIMT_Encode4(87837), // Rule ID 1564 //
     /*  87775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_ps),
     /*  87783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  87786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  87789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87801 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87804 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87808 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87812 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87814 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87821 */     // (intrinsic_wo_chain:{ *:[v4f32] } 15035:{ *:[iPTR] }, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFRCZPSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /*  87821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPSrm),
     /*  87824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87826 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87830 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87835 */     GIR_RootConstrainSelectedInstOperands,
     /*  87836 */     // GIR_Coverage, 1564,
     /*  87836 */     GIR_EraseRootFromParent_Done,
     /*  87837 */   // Label 1902: @87837
     /*  87837 */   GIM_Try, /*On fail goto*//*Label 1903*/ GIMT_Encode4(87904), // Rule ID 1566 //
     /*  87842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_ps_256),
     /*  87850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  87853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  87856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  87860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87868 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87871 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87875 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87881 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87888 */     // (intrinsic_wo_chain:{ *:[v8f32] } 15036:{ *:[iPTR] }, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFRCZPSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /*  87888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPSYrm),
     /*  87891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87893 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87897 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87902 */     GIR_RootConstrainSelectedInstOperands,
     /*  87903 */     // GIR_Coverage, 1566,
     /*  87903 */     GIR_EraseRootFromParent_Done,
     /*  87904 */   // Label 1903: @87904
     /*  87904 */   GIM_Try, /*On fail goto*//*Label 1904*/ GIMT_Encode4(87971), // Rule ID 1572 //
     /*  87909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_pd),
     /*  87917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  87920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  87923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87935 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87938 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87942 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87946 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87948 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87955 */     // (intrinsic_wo_chain:{ *:[v2f64] } 15033:{ *:[iPTR] }, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFRCZPDrm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /*  87955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPDrm),
     /*  87958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87960 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87964 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87969 */     GIR_RootConstrainSelectedInstOperands,
     /*  87970 */     // GIR_Coverage, 1572,
     /*  87970 */     GIR_EraseRootFromParent_Done,
     /*  87971 */   // Label 1904: @87971
     /*  87971 */   GIM_Try, /*On fail goto*//*Label 1905*/ GIMT_Encode4(88038), // Rule ID 1574 //
     /*  87976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_pd_256),
     /*  87984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  87987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  87990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  87994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  88002 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  88005 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  88009 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  88013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88015 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  88022 */     // (intrinsic_wo_chain:{ *:[v4f64] } 15034:{ *:[iPTR] }, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFRCZPDYrm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /*  88022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPDYrm),
     /*  88025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88027 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  88031 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  88036 */     GIR_RootConstrainSelectedInstOperands,
     /*  88037 */     // GIR_Coverage, 1574,
     /*  88037 */     GIR_EraseRootFromParent_Done,
     /*  88038 */   // Label 1905: @88038
     /*  88038 */   GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(88105), // Rule ID 3364 //
     /*  88043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX),
     /*  88046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesimc),
     /*  88051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  88065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  88069 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  88072 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  88076 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  88080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88082 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  88089 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13408:{ *:[iPTR] }, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESIMCrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)
     /*  88089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESIMCrm),
     /*  88092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88094 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  88098 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  88103 */     GIR_RootConstrainSelectedInstOperands,
     /*  88104 */     // GIR_Coverage, 3364,
     /*  88104 */     GIR_EraseRootFromParent_Done,
     /*  88105 */   // Label 1906: @88105
     /*  88105 */   GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(88141), // Rule ID 1529 //
     /*  88110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphsubwd),
     /*  88118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88132 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15057:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src)  =>  (VPHSUBWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src)
     /*  88132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBWDrr),
     /*  88135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88137 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88139 */     GIR_RootConstrainSelectedInstOperands,
     /*  88140 */     // GIR_Coverage, 1529,
     /*  88140 */     GIR_EraseRootFromParent_Done,
     /*  88141 */   // Label 1907: @88141
     /*  88141 */   GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(88177), // Rule ID 1531 //
     /*  88146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphsubdq),
     /*  88154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  88160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88168 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15056:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src)  =>  (VPHSUBDQrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src)
     /*  88168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBDQrr),
     /*  88171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88173 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88175 */     GIR_RootConstrainSelectedInstOperands,
     /*  88176 */     // GIR_Coverage, 1531,
     /*  88176 */     GIR_EraseRootFromParent_Done,
     /*  88177 */   // Label 1908: @88177
     /*  88177 */   GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(88213), // Rule ID 1533 //
     /*  88182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphsubbw),
     /*  88190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88204 */     // (intrinsic_wo_chain:{ *:[v8i16] } 15055:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHSUBBWrr:{ *:[v8i16] } VR128:{ *:[v16i8] }:$src)
     /*  88204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBBWrr),
     /*  88207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88209 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88211 */     GIR_RootConstrainSelectedInstOperands,
     /*  88212 */     // GIR_Coverage, 1533,
     /*  88212 */     GIR_EraseRootFromParent_Done,
     /*  88213 */   // Label 1909: @88213
     /*  88213 */   GIM_Try, /*On fail goto*//*Label 1910*/ GIMT_Encode4(88249), // Rule ID 1535 //
     /*  88218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddwq),
     /*  88226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88240 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15054:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src)  =>  (VPHADDWQrr:{ *:[v2i64] } VR128:{ *:[v8i16] }:$src)
     /*  88240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDWQrr),
     /*  88243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88245 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88247 */     GIR_RootConstrainSelectedInstOperands,
     /*  88248 */     // GIR_Coverage, 1535,
     /*  88248 */     GIR_EraseRootFromParent_Done,
     /*  88249 */   // Label 1910: @88249
     /*  88249 */   GIM_Try, /*On fail goto*//*Label 1911*/ GIMT_Encode4(88285), // Rule ID 1537 //
     /*  88254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddwd),
     /*  88262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88276 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15053:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src)  =>  (VPHADDWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src)
     /*  88276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDWDrr),
     /*  88279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88281 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88283 */     GIR_RootConstrainSelectedInstOperands,
     /*  88284 */     // GIR_Coverage, 1537,
     /*  88284 */     GIR_EraseRootFromParent_Done,
     /*  88285 */   // Label 1911: @88285
     /*  88285 */   GIM_Try, /*On fail goto*//*Label 1912*/ GIMT_Encode4(88321), // Rule ID 1539 //
     /*  88290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphadduwq),
     /*  88298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88312 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15052:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src)  =>  (VPHADDUWQrr:{ *:[v2i64] } VR128:{ *:[v8i16] }:$src)
     /*  88312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUWQrr),
     /*  88315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88317 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88319 */     GIR_RootConstrainSelectedInstOperands,
     /*  88320 */     // GIR_Coverage, 1539,
     /*  88320 */     GIR_EraseRootFromParent_Done,
     /*  88321 */   // Label 1912: @88321
     /*  88321 */   GIM_Try, /*On fail goto*//*Label 1913*/ GIMT_Encode4(88357), // Rule ID 1541 //
     /*  88326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphadduwd),
     /*  88334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88348 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15051:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src)  =>  (VPHADDUWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src)
     /*  88348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUWDrr),
     /*  88351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88353 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88355 */     GIR_RootConstrainSelectedInstOperands,
     /*  88356 */     // GIR_Coverage, 1541,
     /*  88356 */     GIR_EraseRootFromParent_Done,
     /*  88357 */   // Label 1913: @88357
     /*  88357 */   GIM_Try, /*On fail goto*//*Label 1914*/ GIMT_Encode4(88393), // Rule ID 1543 //
     /*  88362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddudq),
     /*  88370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  88376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88384 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15050:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src)  =>  (VPHADDUDQrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src)
     /*  88384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUDQrr),
     /*  88387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88389 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88391 */     GIR_RootConstrainSelectedInstOperands,
     /*  88392 */     // GIR_Coverage, 1543,
     /*  88392 */     GIR_EraseRootFromParent_Done,
     /*  88393 */   // Label 1914: @88393
     /*  88393 */   GIM_Try, /*On fail goto*//*Label 1915*/ GIMT_Encode4(88429), // Rule ID 1545 //
     /*  88398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddubw),
     /*  88406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88420 */     // (intrinsic_wo_chain:{ *:[v8i16] } 15049:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHADDUBWrr:{ *:[v8i16] } VR128:{ *:[v16i8] }:$src)
     /*  88420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUBWrr),
     /*  88423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88425 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88427 */     GIR_RootConstrainSelectedInstOperands,
     /*  88428 */     // GIR_Coverage, 1545,
     /*  88428 */     GIR_EraseRootFromParent_Done,
     /*  88429 */   // Label 1915: @88429
     /*  88429 */   GIM_Try, /*On fail goto*//*Label 1916*/ GIMT_Encode4(88465), // Rule ID 1547 //
     /*  88434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddubq),
     /*  88442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88456 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15048:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHADDUBQrr:{ *:[v2i64] } VR128:{ *:[v16i8] }:$src)
     /*  88456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUBQrr),
     /*  88459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88461 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88463 */     GIR_RootConstrainSelectedInstOperands,
     /*  88464 */     // GIR_Coverage, 1547,
     /*  88464 */     GIR_EraseRootFromParent_Done,
     /*  88465 */   // Label 1916: @88465
     /*  88465 */   GIM_Try, /*On fail goto*//*Label 1917*/ GIMT_Encode4(88501), // Rule ID 1549 //
     /*  88470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddubd),
     /*  88478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88492 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15047:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHADDUBDrr:{ *:[v4i32] } VR128:{ *:[v16i8] }:$src)
     /*  88492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUBDrr),
     /*  88495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88497 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88499 */     GIR_RootConstrainSelectedInstOperands,
     /*  88500 */     // GIR_Coverage, 1549,
     /*  88500 */     GIR_EraseRootFromParent_Done,
     /*  88501 */   // Label 1917: @88501
     /*  88501 */   GIM_Try, /*On fail goto*//*Label 1918*/ GIMT_Encode4(88537), // Rule ID 1551 //
     /*  88506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphadddq),
     /*  88514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  88520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88528 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15046:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src)  =>  (VPHADDDQrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src)
     /*  88528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDDQrr),
     /*  88531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88533 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88535 */     GIR_RootConstrainSelectedInstOperands,
     /*  88536 */     // GIR_Coverage, 1551,
     /*  88536 */     GIR_EraseRootFromParent_Done,
     /*  88537 */   // Label 1918: @88537
     /*  88537 */   GIM_Try, /*On fail goto*//*Label 1919*/ GIMT_Encode4(88573), // Rule ID 1553 //
     /*  88542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddbw),
     /*  88550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88564 */     // (intrinsic_wo_chain:{ *:[v8i16] } 15045:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHADDBWrr:{ *:[v8i16] } VR128:{ *:[v16i8] }:$src)
     /*  88564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDBWrr),
     /*  88567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88569 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88571 */     GIR_RootConstrainSelectedInstOperands,
     /*  88572 */     // GIR_Coverage, 1553,
     /*  88572 */     GIR_EraseRootFromParent_Done,
     /*  88573 */   // Label 1919: @88573
     /*  88573 */   GIM_Try, /*On fail goto*//*Label 1920*/ GIMT_Encode4(88609), // Rule ID 1555 //
     /*  88578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddbq),
     /*  88586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88600 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15044:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHADDBQrr:{ *:[v2i64] } VR128:{ *:[v16i8] }:$src)
     /*  88600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDBQrr),
     /*  88603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88605 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88607 */     GIR_RootConstrainSelectedInstOperands,
     /*  88608 */     // GIR_Coverage, 1555,
     /*  88608 */     GIR_EraseRootFromParent_Done,
     /*  88609 */   // Label 1920: @88609
     /*  88609 */   GIM_Try, /*On fail goto*//*Label 1921*/ GIMT_Encode4(88645), // Rule ID 1557 //
     /*  88614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddbd),
     /*  88622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88636 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15043:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHADDBDrr:{ *:[v4i32] } VR128:{ *:[v16i8] }:$src)
     /*  88636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDBDrr),
     /*  88639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88641 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88643 */     GIR_RootConstrainSelectedInstOperands,
     /*  88644 */     // GIR_Coverage, 1557,
     /*  88644 */     GIR_EraseRootFromParent_Done,
     /*  88645 */   // Label 1921: @88645
     /*  88645 */   GIM_Try, /*On fail goto*//*Label 1922*/ GIMT_Encode4(88681), // Rule ID 1559 //
     /*  88650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_ss),
     /*  88658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  88664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88672 */     // (intrinsic_wo_chain:{ *:[v4f32] } 15038:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src)  =>  (VFRCZSSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)
     /*  88672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZSSrr),
     /*  88675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88677 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88679 */     GIR_RootConstrainSelectedInstOperands,
     /*  88680 */     // GIR_Coverage, 1559,
     /*  88680 */     GIR_EraseRootFromParent_Done,
     /*  88681 */   // Label 1922: @88681
     /*  88681 */   GIM_Try, /*On fail goto*//*Label 1923*/ GIMT_Encode4(88717), // Rule ID 1563 //
     /*  88686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_ps),
     /*  88694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  88700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88708 */     // (intrinsic_wo_chain:{ *:[v4f32] } 15035:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src)  =>  (VFRCZPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)
     /*  88708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPSrr),
     /*  88711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88713 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88715 */     GIR_RootConstrainSelectedInstOperands,
     /*  88716 */     // GIR_Coverage, 1563,
     /*  88716 */     GIR_EraseRootFromParent_Done,
     /*  88717 */   // Label 1923: @88717
     /*  88717 */   GIM_Try, /*On fail goto*//*Label 1924*/ GIMT_Encode4(88753), // Rule ID 1565 //
     /*  88722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_ps_256),
     /*  88730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  88733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  88736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  88740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  88744 */     // (intrinsic_wo_chain:{ *:[v8f32] } 15036:{ *:[iPTR] }, VR256:{ *:[v8f32] }:$src)  =>  (VFRCZPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src)
     /*  88744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPSYrr),
     /*  88747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88749 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88751 */     GIR_RootConstrainSelectedInstOperands,
     /*  88752 */     // GIR_Coverage, 1565,
     /*  88752 */     GIR_EraseRootFromParent_Done,
     /*  88753 */   // Label 1924: @88753
     /*  88753 */   GIM_Try, /*On fail goto*//*Label 1925*/ GIMT_Encode4(88789), // Rule ID 1567 //
     /*  88758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_sd),
     /*  88766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88780 */     // (intrinsic_wo_chain:{ *:[v2f64] } 15037:{ *:[iPTR] }, VR128:{ *:[v2f64] }:$src)  =>  (VFRCZSDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)
     /*  88780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZSDrr),
     /*  88783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88785 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88787 */     GIR_RootConstrainSelectedInstOperands,
     /*  88788 */     // GIR_Coverage, 1567,
     /*  88788 */     GIR_EraseRootFromParent_Done,
     /*  88789 */   // Label 1925: @88789
     /*  88789 */   GIM_Try, /*On fail goto*//*Label 1926*/ GIMT_Encode4(88825), // Rule ID 1571 //
     /*  88794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_pd),
     /*  88802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88816 */     // (intrinsic_wo_chain:{ *:[v2f64] } 15033:{ *:[iPTR] }, VR128:{ *:[v2f64] }:$src)  =>  (VFRCZPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)
     /*  88816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPDrr),
     /*  88819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88821 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88823 */     GIR_RootConstrainSelectedInstOperands,
     /*  88824 */     // GIR_Coverage, 1571,
     /*  88824 */     GIR_EraseRootFromParent_Done,
     /*  88825 */   // Label 1926: @88825
     /*  88825 */   GIM_Try, /*On fail goto*//*Label 1927*/ GIMT_Encode4(88861), // Rule ID 1573 //
     /*  88830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_pd_256),
     /*  88838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  88841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  88844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  88848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  88852 */     // (intrinsic_wo_chain:{ *:[v4f64] } 15034:{ *:[iPTR] }, VR256:{ *:[v4f64] }:$src)  =>  (VFRCZPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src)
     /*  88852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPDYrr),
     /*  88855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88857 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88859 */     GIR_RootConstrainSelectedInstOperands,
     /*  88860 */     // GIR_Coverage, 1573,
     /*  88860 */     GIR_EraseRootFromParent_Done,
     /*  88861 */   // Label 1927: @88861
     /*  88861 */   GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(88897), // Rule ID 3363 //
     /*  88866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX),
     /*  88869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesimc),
     /*  88874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88888 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13408:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1)  =>  (VAESIMCrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1)
     /*  88888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESIMCrr),
     /*  88891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88893 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  88895 */     GIR_RootConstrainSelectedInstOperands,
     /*  88896 */     // GIR_Coverage, 3363,
     /*  88896 */     GIR_EraseRootFromParent_Done,
     /*  88897 */   // Label 1928: @88897
     /*  88897 */   GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(88933), // Rule ID 3365 //
     /*  88902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_NoAVX),
     /*  88905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesimc),
     /*  88910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88924 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13408:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1)  =>  (AESIMCrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1)
     /*  88924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AESIMCrr),
     /*  88927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88929 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  88931 */     GIR_RootConstrainSelectedInstOperands,
     /*  88932 */     // GIR_Coverage, 3365,
     /*  88932 */     GIR_EraseRootFromParent_Done,
     /*  88933 */   // Label 1929: @88933
     /*  88933 */   GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(88971), // Rule ID 18266 //
     /*  88938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  88941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse_rsqrt_ss),
     /*  88946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  88952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88960 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14743:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src)  =>  (RSQRTSSr_Int:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src, VR128:{ *:[v4f32] }:$src)
     /*  88960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RSQRTSSr_Int),
     /*  88963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88965 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88967 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88969 */     GIR_RootConstrainSelectedInstOperands,
     /*  88970 */     // GIR_Coverage, 18266,
     /*  88970 */     GIR_EraseRootFromParent_Done,
     /*  88971 */   // Label 1930: @88971
     /*  88971 */   GIM_Try, /*On fail goto*//*Label 1931*/ GIMT_Encode4(89009), // Rule ID 18270 //
     /*  88976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  88979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse_rsqrt_ss),
     /*  88984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  88990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88998 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14743:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src)  =>  (VRSQRTSSr_Int:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src, VR128:{ *:[v4f32] }:$src)
     /*  88998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VRSQRTSSr_Int),
     /*  89001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89003 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  89005 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  89007 */     GIR_RootConstrainSelectedInstOperands,
     /*  89008 */     // GIR_Coverage, 18270,
     /*  89008 */     GIR_EraseRootFromParent_Done,
     /*  89009 */   // Label 1931: @89009
     /*  89009 */   GIM_Try, /*On fail goto*//*Label 1932*/ GIMT_Encode4(89047), // Rule ID 18286 //
     /*  89014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  89017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse_rcp_ss),
     /*  89022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  89025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89036 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14741:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src)  =>  (RCPSSr_Int:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src, VR128:{ *:[v4f32] }:$src)
     /*  89036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RCPSSr_Int),
     /*  89039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89041 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  89043 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  89045 */     GIR_RootConstrainSelectedInstOperands,
     /*  89046 */     // GIR_Coverage, 18286,
     /*  89046 */     GIR_EraseRootFromParent_Done,
     /*  89047 */   // Label 1932: @89047
     /*  89047 */   GIM_Try, /*On fail goto*//*Label 1933*/ GIMT_Encode4(89085), // Rule ID 18290 //
     /*  89052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  89055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse_rcp_ss),
     /*  89060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  89063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89074 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14741:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src)  =>  (VRCPSSr_Int:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src, VR128:{ *:[v4f32] }:$src)
     /*  89074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VRCPSSr_Int),
     /*  89077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89079 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  89081 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  89083 */     GIR_RootConstrainSelectedInstOperands,
     /*  89084 */     // GIR_Coverage, 18290,
     /*  89084 */     GIR_EraseRootFromParent_Done,
     /*  89085 */   // Label 1933: @89085
     /*  89085 */   GIM_Reject,
     /*  89086 */ // Label 1886: @89086
     /*  89086 */ GIM_Try, /*On fail goto*//*Label 1934*/ GIMT_Encode4(95867),
     /*  89091 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /*  89094 */   GIM_Try, /*On fail goto*//*Label 1935*/ GIMT_Encode4(89166), // Rule ID 3368 //
     /*  89099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX),
     /*  89102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aeskeygenassist),
     /*  89107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  89110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  89113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  89121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89125 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89128 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89132 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89136 */     // MIs[0] src2
     /*  89136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  89139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89141 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89148 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13409:{ *:[iPTR] }, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i8] }):$src2)  =>  (VAESKEYGENASSIST128rm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1, (timm:{ *:[i8] }):$src2)
     /*  89148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESKEYGENASSIST128rm),
     /*  89151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89153 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  89157 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  89159 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89164 */     GIR_RootConstrainSelectedInstOperands,
     /*  89165 */     // GIR_Coverage, 3368,
     /*  89165 */     GIR_EraseRootFromParent_Done,
     /*  89166 */   // Label 1935: @89166
     /*  89166 */   GIM_Try, /*On fail goto*//*Label 1936*/ GIMT_Encode4(89242), // Rule ID 16790 //
     /*  89171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /*  89174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4128),
     /*  89179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  89182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  89192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  89196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89204 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89207 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89211 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89217 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89224 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15012:{ *:[iPTR] }, VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4KEY4Z128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Z128rm),
     /*  89227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89229 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89231 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89235 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89240 */     GIR_RootConstrainSelectedInstOperands,
     /*  89241 */     // GIR_Coverage, 16790,
     /*  89241 */     GIR_EraseRootFromParent_Done,
     /*  89242 */   // Label 1936: @89242
     /*  89242 */   GIM_Try, /*On fail goto*//*Label 1937*/ GIMT_Encode4(89318), // Rule ID 16792 //
     /*  89247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /*  89250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4256),
     /*  89255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  89258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  89261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  89264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  89268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  89272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89280 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89283 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89287 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89293 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89300 */     // (intrinsic_wo_chain:{ *:[v8i32] } 15013:{ *:[iPTR] }, VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4KEY4Z256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Z256rm),
     /*  89303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89305 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89307 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89311 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89316 */     GIR_RootConstrainSelectedInstOperands,
     /*  89317 */     // GIR_Coverage, 16792,
     /*  89317 */     GIR_EraseRootFromParent_Done,
     /*  89318 */   // Label 1937: @89318
     /*  89318 */   GIM_Try, /*On fail goto*//*Label 1938*/ GIMT_Encode4(89394), // Rule ID 16796 //
     /*  89323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /*  89326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4128),
     /*  89331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  89334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  89344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  89348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89356 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89359 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89363 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89369 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89376 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15015:{ *:[iPTR] }, VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4RNDS4Z128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Z128rm),
     /*  89379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89381 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89383 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89387 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89392 */     GIR_RootConstrainSelectedInstOperands,
     /*  89393 */     // GIR_Coverage, 16796,
     /*  89393 */     GIR_EraseRootFromParent_Done,
     /*  89394 */   // Label 1938: @89394
     /*  89394 */   GIM_Try, /*On fail goto*//*Label 1939*/ GIMT_Encode4(89470), // Rule ID 16798 //
     /*  89399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /*  89402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4256),
     /*  89407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  89410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  89413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  89416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  89420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  89424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89432 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89435 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89439 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89445 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89452 */     // (intrinsic_wo_chain:{ *:[v8i32] } 15016:{ *:[iPTR] }, VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4RNDS4Z256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Z256rm),
     /*  89455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89457 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89459 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89463 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89468 */     GIR_RootConstrainSelectedInstOperands,
     /*  89469 */     // GIR_Coverage, 16798,
     /*  89469 */     GIR_EraseRootFromParent_Done,
     /*  89470 */   // Label 1939: @89470
     /*  89470 */   GIM_Try, /*On fail goto*//*Label 1940*/ GIMT_Encode4(89546), // Rule ID 3023 //
     /*  89475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  89478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_b_128),
     /*  89483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  89492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89508 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89511 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89515 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89521 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89528 */     // (intrinsic_wo_chain:{ *:[v16i8] } 14881:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSIGNBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNBrm),
     /*  89531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89533 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89535 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89539 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89544 */     GIR_RootConstrainSelectedInstOperands,
     /*  89545 */     // GIR_Coverage, 3023,
     /*  89545 */     GIR_EraseRootFromParent_Done,
     /*  89546 */   // Label 1940: @89546
     /*  89546 */   GIM_Try, /*On fail goto*//*Label 1941*/ GIMT_Encode4(89622), // Rule ID 3025 //
     /*  89551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  89554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_w_128),
     /*  89559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89584 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89587 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89591 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89597 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89604 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14885:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSIGNWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNWrm),
     /*  89607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89609 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89611 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89615 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89620 */     GIR_RootConstrainSelectedInstOperands,
     /*  89621 */     // GIR_Coverage, 3025,
     /*  89621 */     GIR_EraseRootFromParent_Done,
     /*  89622 */   // Label 1941: @89622
     /*  89622 */   GIM_Try, /*On fail goto*//*Label 1942*/ GIMT_Encode4(89698), // Rule ID 3027 //
     /*  89627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  89630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_d_128),
     /*  89635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  89638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89660 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89663 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89667 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89673 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89680 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14883:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSIGNDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNDrm),
     /*  89683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89685 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89687 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89691 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89696 */     GIR_RootConstrainSelectedInstOperands,
     /*  89697 */     // GIR_Coverage, 3027,
     /*  89697 */     GIR_EraseRootFromParent_Done,
     /*  89698 */   // Label 1942: @89698
     /*  89698 */   GIM_Try, /*On fail goto*//*Label 1943*/ GIMT_Encode4(89774), // Rule ID 3029 //
     /*  89703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  89706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_phadd_sw_128),
     /*  89711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89736 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89739 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89743 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89747 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89749 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89756 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14865:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDSWrm),
     /*  89759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89761 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89763 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89767 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89772 */     GIR_RootConstrainSelectedInstOperands,
     /*  89773 */     // GIR_Coverage, 3029,
     /*  89773 */     GIR_EraseRootFromParent_Done,
     /*  89774 */   // Label 1943: @89774
     /*  89774 */   GIM_Try, /*On fail goto*//*Label 1944*/ GIMT_Encode4(89850), // Rule ID 3031 //
     /*  89779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  89782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_phsub_sw_128),
     /*  89787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89812 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89815 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89819 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89825 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89832 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14871:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHSUBSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBSWrm),
     /*  89835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89837 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89839 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89843 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89848 */     GIR_RootConstrainSelectedInstOperands,
     /*  89849 */     // GIR_Coverage, 3031,
     /*  89849 */     GIR_EraseRootFromParent_Done,
     /*  89850 */   // Label 1944: @89850
     /*  89850 */   GIM_Try, /*On fail goto*//*Label 1945*/ GIMT_Encode4(89926), // Rule ID 3047 //
     /*  89855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  89858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_psign_b),
     /*  89863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s8,
     /*  89866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /*  89869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s8,
     /*  89872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  89876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  89880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89888 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89891 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89895 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89901 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89908 */     // (intrinsic_wo_chain:{ *:[v32i8] } 13772:{ *:[iPTR] }, VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSIGNBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNBYrm),
     /*  89911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89913 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89915 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89919 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89924 */     GIR_RootConstrainSelectedInstOperands,
     /*  89925 */     // GIR_Coverage, 3047,
     /*  89925 */     GIR_EraseRootFromParent_Done,
     /*  89926 */   // Label 1945: @89926
     /*  89926 */   GIM_Try, /*On fail goto*//*Label 1946*/ GIMT_Encode4(90002), // Rule ID 3049 //
     /*  89931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  89934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_psign_w),
     /*  89939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /*  89942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  89945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /*  89948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  89952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  89956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89964 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89967 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89971 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89977 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89984 */     // (intrinsic_wo_chain:{ *:[v16i16] } 13774:{ *:[iPTR] }, VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSIGNWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNWYrm),
     /*  89987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89989 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89991 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89995 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90000 */     GIR_RootConstrainSelectedInstOperands,
     /*  90001 */     // GIR_Coverage, 3049,
     /*  90001 */     GIR_EraseRootFromParent_Done,
     /*  90002 */   // Label 1946: @90002
     /*  90002 */   GIM_Try, /*On fail goto*//*Label 1947*/ GIMT_Encode4(90078), // Rule ID 3051 //
     /*  90007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  90010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_psign_d),
     /*  90015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  90018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  90021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  90024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  90028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  90032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90040 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90043 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90047 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90053 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90060 */     // (intrinsic_wo_chain:{ *:[v8i32] } 13773:{ *:[iPTR] }, VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSIGNDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNDYrm),
     /*  90063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90065 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90067 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90071 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90076 */     GIR_RootConstrainSelectedInstOperands,
     /*  90077 */     // GIR_Coverage, 3051,
     /*  90077 */     GIR_EraseRootFromParent_Done,
     /*  90078 */   // Label 1947: @90078
     /*  90078 */   GIM_Try, /*On fail goto*//*Label 1948*/ GIMT_Encode4(90154), // Rule ID 3053 //
     /*  90083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  90086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_phadd_sw),
     /*  90091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /*  90094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  90097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /*  90100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  90104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  90108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90116 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90119 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90123 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90129 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90136 */     // (intrinsic_wo_chain:{ *:[v16i16] } 13759:{ *:[iPTR] }, VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDSWYrm),
     /*  90139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90141 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90143 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90147 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90152 */     GIR_RootConstrainSelectedInstOperands,
     /*  90153 */     // GIR_Coverage, 3053,
     /*  90153 */     GIR_EraseRootFromParent_Done,
     /*  90154 */   // Label 1948: @90154
     /*  90154 */   GIM_Try, /*On fail goto*//*Label 1949*/ GIMT_Encode4(90230), // Rule ID 3055 //
     /*  90159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  90162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_phsub_sw),
     /*  90167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /*  90170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  90173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /*  90176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  90180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  90184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90192 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90195 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90199 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90205 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90212 */     // (intrinsic_wo_chain:{ *:[v16i16] } 13762:{ *:[iPTR] }, VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHSUBSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBSWYrm),
     /*  90215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90217 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90219 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90223 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90228 */     GIR_RootConstrainSelectedInstOperands,
     /*  90229 */     // GIR_Coverage, 3055,
     /*  90229 */     GIR_EraseRootFromParent_Done,
     /*  90230 */   // Label 1949: @90230
     /*  90230 */   GIM_Try, /*On fail goto*//*Label 1950*/ GIMT_Encode4(90306), // Rule ID 3310 //
     /*  90235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /*  90238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_8),
     /*  90243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  90246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  90249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /*  90252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90268 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90271 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90275 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90281 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90288 */     // (intrinsic_wo_chain:{ *:[i32] } 14839:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CRC32r32m8:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32m8),
     /*  90291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90293 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90295 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90299 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90304 */     GIR_RootConstrainSelectedInstOperands,
     /*  90305 */     // GIR_Coverage, 3310,
     /*  90305 */     GIR_EraseRootFromParent_Done,
     /*  90306 */   // Label 1950: @90306
     /*  90306 */   GIM_Try, /*On fail goto*//*Label 1951*/ GIMT_Encode4(90382), // Rule ID 3312 //
     /*  90311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /*  90314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_16),
     /*  90319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  90322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  90325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  90328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90344 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90347 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90351 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90357 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90364 */     // (intrinsic_wo_chain:{ *:[i32] } 14837:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CRC32r32m16:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32m16),
     /*  90367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90369 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90371 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90375 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90380 */     GIR_RootConstrainSelectedInstOperands,
     /*  90381 */     // GIR_Coverage, 3312,
     /*  90381 */     GIR_EraseRootFromParent_Done,
     /*  90382 */   // Label 1951: @90382
     /*  90382 */   GIM_Try, /*On fail goto*//*Label 1952*/ GIMT_Encode4(90458), // Rule ID 3314 //
     /*  90387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /*  90390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_32),
     /*  90395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  90398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  90401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  90404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90420 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90423 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90427 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90433 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90440 */     // (intrinsic_wo_chain:{ *:[i32] } 14838:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CRC32r32m32:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32m32),
     /*  90443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90445 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90447 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90451 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90456 */     GIR_RootConstrainSelectedInstOperands,
     /*  90457 */     // GIR_Coverage, 3314,
     /*  90457 */     GIR_EraseRootFromParent_Done,
     /*  90458 */   // Label 1952: @90458
     /*  90458 */   GIM_Try, /*On fail goto*//*Label 1953*/ GIMT_Encode4(90534), // Rule ID 3316 //
     /*  90463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /*  90466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_64_64),
     /*  90471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  90474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  90477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  90480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  90484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  90488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90496 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90499 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90503 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90509 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90516 */     // (intrinsic_wo_chain:{ *:[i64] } 14840:{ *:[iPTR] }, GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CRC32r64m64:{ *:[i64] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r64m64),
     /*  90519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90521 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90523 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90527 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90532 */     GIR_RootConstrainSelectedInstOperands,
     /*  90533 */     // GIR_Coverage, 3316,
     /*  90533 */     GIR_EraseRootFromParent_Done,
     /*  90534 */   // Label 1953: @90534
     /*  90534 */   GIM_Try, /*On fail goto*//*Label 1954*/ GIMT_Encode4(90610), // Rule ID 3318 //
     /*  90539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /*  90542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_8),
     /*  90547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  90550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  90553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /*  90556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90572 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90575 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90579 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90585 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90592 */     // (intrinsic_wo_chain:{ *:[i32] } 14839:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CRC32r32m8_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32m8_EVEX),
     /*  90595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90597 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90599 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90603 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90608 */     GIR_RootConstrainSelectedInstOperands,
     /*  90609 */     // GIR_Coverage, 3318,
     /*  90609 */     GIR_EraseRootFromParent_Done,
     /*  90610 */   // Label 1954: @90610
     /*  90610 */   GIM_Try, /*On fail goto*//*Label 1955*/ GIMT_Encode4(90686), // Rule ID 3320 //
     /*  90615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /*  90618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_16),
     /*  90623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  90626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  90629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  90632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90648 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90651 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90655 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90661 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90668 */     // (intrinsic_wo_chain:{ *:[i32] } 14837:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CRC32r32m16_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32m16_EVEX),
     /*  90671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90673 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90675 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90679 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90684 */     GIR_RootConstrainSelectedInstOperands,
     /*  90685 */     // GIR_Coverage, 3320,
     /*  90685 */     GIR_EraseRootFromParent_Done,
     /*  90686 */   // Label 1955: @90686
     /*  90686 */   GIM_Try, /*On fail goto*//*Label 1956*/ GIMT_Encode4(90762), // Rule ID 3322 //
     /*  90691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /*  90694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_32),
     /*  90699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  90702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  90705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  90708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90724 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90727 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90731 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90737 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90744 */     // (intrinsic_wo_chain:{ *:[i32] } 14838:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CRC32r32m32_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32m32_EVEX),
     /*  90747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90749 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90751 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90755 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90760 */     GIR_RootConstrainSelectedInstOperands,
     /*  90761 */     // GIR_Coverage, 3322,
     /*  90761 */     GIR_EraseRootFromParent_Done,
     /*  90762 */   // Label 1956: @90762
     /*  90762 */   GIM_Try, /*On fail goto*//*Label 1957*/ GIMT_Encode4(90838), // Rule ID 3324 //
     /*  90767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /*  90770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_64_64),
     /*  90775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  90778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  90781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  90784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  90788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  90792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90800 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90803 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90807 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90813 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90820 */     // (intrinsic_wo_chain:{ *:[i64] } 14840:{ *:[iPTR] }, GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CRC32r64m64_EVEX:{ *:[i64] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r64m64_EVEX),
     /*  90823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90825 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90827 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90831 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90836 */     GIR_RootConstrainSelectedInstOperands,
     /*  90837 */     // GIR_Coverage, 3324,
     /*  90837 */     GIR_EraseRootFromParent_Done,
     /*  90838 */   // Label 1957: @90838
     /*  90838 */   GIM_Try, /*On fail goto*//*Label 1958*/ GIMT_Encode4(90914), // Rule ID 3340 //
     /*  90843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /*  90846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc),
     /*  90851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  90854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  90857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  90860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  90864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  90868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90876 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90879 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90883 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90889 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90896 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13402:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCrm),
     /*  90899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90901 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90903 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90907 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90912 */     GIR_RootConstrainSelectedInstOperands,
     /*  90913 */     // GIR_Coverage, 3340,
     /*  90913 */     GIR_EraseRootFromParent_Done,
     /*  90914 */   // Label 1958: @90914
     /*  90914 */   GIM_Try, /*On fail goto*//*Label 1959*/ GIMT_Encode4(90990), // Rule ID 3342 //
     /*  90919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /*  90922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast),
     /*  90927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  90930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  90933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  90936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  90940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  90944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90952 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90955 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90959 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90965 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90972 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13405:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCLASTrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTrm),
     /*  90975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90977 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90979 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90983 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90988 */     GIR_RootConstrainSelectedInstOperands,
     /*  90989 */     // GIR_Coverage, 3342,
     /*  90989 */     GIR_EraseRootFromParent_Done,
     /*  90990 */   // Label 1959: @90990
     /*  90990 */   GIM_Try, /*On fail goto*//*Label 1960*/ GIMT_Encode4(91066), // Rule ID 3344 //
     /*  90995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /*  90998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec),
     /*  91003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  91006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  91009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  91012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  91016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  91020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91028 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91031 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91035 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91041 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91048 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13396:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECrm),
     /*  91051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91053 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91055 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91059 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91064 */     GIR_RootConstrainSelectedInstOperands,
     /*  91065 */     // GIR_Coverage, 3344,
     /*  91065 */     GIR_EraseRootFromParent_Done,
     /*  91066 */   // Label 1960: @91066
     /*  91066 */   GIM_Try, /*On fail goto*//*Label 1961*/ GIMT_Encode4(91142), // Rule ID 3346 //
     /*  91071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /*  91074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast),
     /*  91079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  91082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  91085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  91088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  91092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  91096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91104 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91107 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91111 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91117 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91124 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13399:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECLASTrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTrm),
     /*  91127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91129 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91131 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91135 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91140 */     GIR_RootConstrainSelectedInstOperands,
     /*  91141 */     // GIR_Coverage, 3346,
     /*  91141 */     GIR_EraseRootFromParent_Done,
     /*  91142 */   // Label 1961: @91142
     /*  91142 */   GIM_Try, /*On fail goto*//*Label 1962*/ GIMT_Encode4(91218), // Rule ID 3348 //
     /*  91147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /*  91150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc_256),
     /*  91155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  91158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  91161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  91164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91180 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91183 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91187 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91193 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91200 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13403:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCYrm),
     /*  91203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91205 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91207 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91211 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91216 */     GIR_RootConstrainSelectedInstOperands,
     /*  91217 */     // GIR_Coverage, 3348,
     /*  91217 */     GIR_EraseRootFromParent_Done,
     /*  91218 */   // Label 1962: @91218
     /*  91218 */   GIM_Try, /*On fail goto*//*Label 1963*/ GIMT_Encode4(91294), // Rule ID 3350 //
     /*  91223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /*  91226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast_256),
     /*  91231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  91234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  91237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  91240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91256 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91259 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91263 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91269 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91276 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13406:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCLASTYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTYrm),
     /*  91279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91281 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91283 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91287 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91292 */     GIR_RootConstrainSelectedInstOperands,
     /*  91293 */     // GIR_Coverage, 3350,
     /*  91293 */     GIR_EraseRootFromParent_Done,
     /*  91294 */   // Label 1963: @91294
     /*  91294 */   GIM_Try, /*On fail goto*//*Label 1964*/ GIMT_Encode4(91370), // Rule ID 3352 //
     /*  91299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /*  91302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec_256),
     /*  91307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  91310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  91313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  91316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91332 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91335 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91339 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91345 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91352 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13397:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECYrm),
     /*  91355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91357 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91359 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91363 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91368 */     GIR_RootConstrainSelectedInstOperands,
     /*  91369 */     // GIR_Coverage, 3352,
     /*  91369 */     GIR_EraseRootFromParent_Done,
     /*  91370 */   // Label 1964: @91370
     /*  91370 */   GIM_Try, /*On fail goto*//*Label 1965*/ GIMT_Encode4(91446), // Rule ID 3354 //
     /*  91375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /*  91378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast_256),
     /*  91383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  91386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  91389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  91392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91408 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91411 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91415 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91421 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91428 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13400:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECLASTYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTYrm),
     /*  91431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91433 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91435 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91439 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91444 */     GIR_RootConstrainSelectedInstOperands,
     /*  91445 */     // GIR_Coverage, 3354,
     /*  91445 */     GIR_EraseRootFromParent_Done,
     /*  91446 */   // Label 1965: @91446
     /*  91446 */   GIM_Try, /*On fail goto*//*Label 1966*/ GIMT_Encode4(91522), // Rule ID 3565 //
     /*  91451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /*  91454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4128),
     /*  91459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  91462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  91465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  91468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  91472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  91476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91484 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91487 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91491 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91497 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91504 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15012:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4KEY4rm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4rm),
     /*  91507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91509 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91511 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91515 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91520 */     GIR_RootConstrainSelectedInstOperands,
     /*  91521 */     // GIR_Coverage, 3565,
     /*  91521 */     GIR_EraseRootFromParent_Done,
     /*  91522 */   // Label 1966: @91522
     /*  91522 */   GIM_Try, /*On fail goto*//*Label 1967*/ GIMT_Encode4(91598), // Rule ID 3567 //
     /*  91527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /*  91530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4256),
     /*  91535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  91538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  91541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  91544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91560 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91563 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91567 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91573 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91580 */     // (intrinsic_wo_chain:{ *:[v8i32] } 15013:{ *:[iPTR] }, VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4KEY4Yrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Yrm),
     /*  91583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91585 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91587 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91591 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91596 */     GIR_RootConstrainSelectedInstOperands,
     /*  91597 */     // GIR_Coverage, 3567,
     /*  91597 */     GIR_EraseRootFromParent_Done,
     /*  91598 */   // Label 1967: @91598
     /*  91598 */   GIM_Try, /*On fail goto*//*Label 1968*/ GIMT_Encode4(91674), // Rule ID 3569 //
     /*  91603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /*  91606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4128),
     /*  91611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  91614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  91617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  91620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  91624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  91628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91636 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91639 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91643 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91649 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91656 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15015:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4RNDS4rm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4rm),
     /*  91659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91661 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91663 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91667 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91672 */     GIR_RootConstrainSelectedInstOperands,
     /*  91673 */     // GIR_Coverage, 3569,
     /*  91673 */     GIR_EraseRootFromParent_Done,
     /*  91674 */   // Label 1968: @91674
     /*  91674 */   GIM_Try, /*On fail goto*//*Label 1969*/ GIMT_Encode4(91750), // Rule ID 3571 //
     /*  91679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /*  91682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4256),
     /*  91687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  91690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  91693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  91696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91712 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91715 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91719 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91725 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91732 */     // (intrinsic_wo_chain:{ *:[v8i32] } 15016:{ *:[iPTR] }, VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4RNDS4Yrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Yrm),
     /*  91735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91737 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91739 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91743 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91748 */     GIR_RootConstrainSelectedInstOperands,
     /*  91749 */     // GIR_Coverage, 3571,
     /*  91749 */     GIR_EraseRootFromParent_Done,
     /*  91750 */   // Label 1969: @91750
     /*  91750 */   GIM_Try, /*On fail goto*//*Label 1970*/ GIMT_Encode4(91826), // Rule ID 14061 //
     /*  91755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  91758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc),
     /*  91763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  91766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  91769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  91772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  91776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  91780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91788 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91791 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91795 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91801 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91808 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13402:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCZ128rm),
     /*  91811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91813 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91815 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91819 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91824 */     GIR_RootConstrainSelectedInstOperands,
     /*  91825 */     // GIR_Coverage, 14061,
     /*  91825 */     GIR_EraseRootFromParent_Done,
     /*  91826 */   // Label 1970: @91826
     /*  91826 */   GIM_Try, /*On fail goto*//*Label 1971*/ GIMT_Encode4(91902), // Rule ID 14063 //
     /*  91831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  91834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc_256),
     /*  91839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  91842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  91845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  91848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  91852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  91856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91864 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91867 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91871 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91877 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91884 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13403:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCZ256rm),
     /*  91887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91889 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91891 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91895 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91900 */     GIR_RootConstrainSelectedInstOperands,
     /*  91901 */     // GIR_Coverage, 14063,
     /*  91901 */     GIR_EraseRootFromParent_Done,
     /*  91902 */   // Label 1971: @91902
     /*  91902 */   GIM_Try, /*On fail goto*//*Label 1972*/ GIMT_Encode4(91978), // Rule ID 14065 //
     /*  91907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /*  91910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc_512),
     /*  91915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  91918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  91921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  91924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  91928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  91932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91940 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91943 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91947 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91953 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91960 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13404:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCZrm),
     /*  91963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91965 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91967 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91971 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91976 */     GIR_RootConstrainSelectedInstOperands,
     /*  91977 */     // GIR_Coverage, 14065,
     /*  91977 */     GIR_EraseRootFromParent_Done,
     /*  91978 */   // Label 1972: @91978
     /*  91978 */   GIM_Try, /*On fail goto*//*Label 1973*/ GIMT_Encode4(92054), // Rule ID 14067 //
     /*  91983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  91986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast),
     /*  91991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  91994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  91997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  92000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  92004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  92008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  92016 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92019 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  92023 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  92027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92029 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  92036 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13405:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCLASTZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  92036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTZ128rm),
     /*  92039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92041 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92043 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  92047 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92052 */     GIR_RootConstrainSelectedInstOperands,
     /*  92053 */     // GIR_Coverage, 14067,
     /*  92053 */     GIR_EraseRootFromParent_Done,
     /*  92054 */   // Label 1973: @92054
     /*  92054 */   GIM_Try, /*On fail goto*//*Label 1974*/ GIMT_Encode4(92130), // Rule ID 14069 //
     /*  92059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  92062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast_256),
     /*  92067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  92070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  92073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  92076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  92080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  92084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  92092 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92095 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  92099 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  92103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92105 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  92112 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13406:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCLASTZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  92112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTZ256rm),
     /*  92115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92117 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92119 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  92123 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92128 */     GIR_RootConstrainSelectedInstOperands,
     /*  92129 */     // GIR_Coverage, 14069,
     /*  92129 */     GIR_EraseRootFromParent_Done,
     /*  92130 */   // Label 1974: @92130
     /*  92130 */   GIM_Try, /*On fail goto*//*Label 1975*/ GIMT_Encode4(92206), // Rule ID 14071 //
     /*  92135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /*  92138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast_512),
     /*  92143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  92146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  92149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  92152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  92156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  92160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  92168 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92171 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  92175 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  92179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92181 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  92188 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13407:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCLASTZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  92188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTZrm),
     /*  92191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92193 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92195 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  92199 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92204 */     GIR_RootConstrainSelectedInstOperands,
     /*  92205 */     // GIR_Coverage, 14071,
     /*  92205 */     GIR_EraseRootFromParent_Done,
     /*  92206 */   // Label 1975: @92206
     /*  92206 */   GIM_Try, /*On fail goto*//*Label 1976*/ GIMT_Encode4(92282), // Rule ID 14073 //
     /*  92211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  92214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec),
     /*  92219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  92222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  92225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  92228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  92232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  92236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  92244 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92247 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  92251 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  92255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92257 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  92264 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13396:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  92264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECZ128rm),
     /*  92267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92269 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92271 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  92275 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92280 */     GIR_RootConstrainSelectedInstOperands,
     /*  92281 */     // GIR_Coverage, 14073,
     /*  92281 */     GIR_EraseRootFromParent_Done,
     /*  92282 */   // Label 1976: @92282
     /*  92282 */   GIM_Try, /*On fail goto*//*Label 1977*/ GIMT_Encode4(92358), // Rule ID 14075 //
     /*  92287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  92290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec_256),
     /*  92295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  92298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  92301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  92304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  92308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  92312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  92320 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92323 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  92327 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  92331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92333 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  92340 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13397:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  92340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECZ256rm),
     /*  92343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92345 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92347 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  92351 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92356 */     GIR_RootConstrainSelectedInstOperands,
     /*  92357 */     // GIR_Coverage, 14075,
     /*  92357 */     GIR_EraseRootFromParent_Done,
     /*  92358 */   // Label 1977: @92358
     /*  92358 */   GIM_Try, /*On fail goto*//*Label 1978*/ GIMT_Encode4(92434), // Rule ID 14077 //
     /*  92363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /*  92366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec_512),
     /*  92371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  92374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  92377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  92380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  92384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  92388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  92396 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92399 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  92403 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  92407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92409 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  92416 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13398:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  92416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECZrm),
     /*  92419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92421 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92423 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  92427 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92432 */     GIR_RootConstrainSelectedInstOperands,
     /*  92433 */     // GIR_Coverage, 14077,
     /*  92433 */     GIR_EraseRootFromParent_Done,
     /*  92434 */   // Label 1978: @92434
     /*  92434 */   GIM_Try, /*On fail goto*//*Label 1979*/ GIMT_Encode4(92510), // Rule ID 14079 //
     /*  92439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  92442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast),
     /*  92447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  92450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  92453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  92456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  92460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  92464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  92472 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92475 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  92479 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  92483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92485 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  92492 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13399:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECLASTZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  92492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTZ128rm),
     /*  92495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92497 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92499 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  92503 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92508 */     GIR_RootConstrainSelectedInstOperands,
     /*  92509 */     // GIR_Coverage, 14079,
     /*  92509 */     GIR_EraseRootFromParent_Done,
     /*  92510 */   // Label 1979: @92510
     /*  92510 */   GIM_Try, /*On fail goto*//*Label 1980*/ GIMT_Encode4(92586), // Rule ID 14081 //
     /*  92515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  92518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast_256),
     /*  92523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  92526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  92529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  92532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  92536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  92540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  92548 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92551 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  92555 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  92559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92561 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  92568 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13400:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECLASTZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  92568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTZ256rm),
     /*  92571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92573 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92575 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  92579 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92584 */     GIR_RootConstrainSelectedInstOperands,
     /*  92585 */     // GIR_Coverage, 14081,
     /*  92585 */     GIR_EraseRootFromParent_Done,
     /*  92586 */   // Label 1980: @92586
     /*  92586 */   GIM_Try, /*On fail goto*//*Label 1981*/ GIMT_Encode4(92662), // Rule ID 14083 //
     /*  92591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /*  92594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast_512),
     /*  92599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  92602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  92605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  92608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  92612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  92616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  92624 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92627 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  92631 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  92635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92637 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  92644 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13401:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECLASTZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  92644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTZrm),
     /*  92647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92649 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92651 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  92655 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92660 */     GIR_RootConstrainSelectedInstOperands,
     /*  92661 */     // GIR_Coverage, 14083,
     /*  92661 */     GIR_EraseRootFromParent_Done,
     /*  92662 */   // Label 1981: @92662
     /*  92662 */   GIM_Try, /*On fail goto*//*Label 1982*/ GIMT_Encode4(92738), // Rule ID 16794 //
     /*  92667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_512_HasSM4),
     /*  92670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4512),
     /*  92675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /*  92678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  92681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /*  92684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  92688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  92692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  92700 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92703 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  92707 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  92711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92713 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  92720 */     // (intrinsic_wo_chain:{ *:[v16i32] } 15014:{ *:[iPTR] }, VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4KEY4Zrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  92720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Zrm),
     /*  92723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92725 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92727 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  92731 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92736 */     GIR_RootConstrainSelectedInstOperands,
     /*  92737 */     // GIR_Coverage, 16794,
     /*  92737 */     GIR_EraseRootFromParent_Done,
     /*  92738 */   // Label 1982: @92738
     /*  92738 */   GIM_Try, /*On fail goto*//*Label 1983*/ GIMT_Encode4(92814), // Rule ID 16800 //
     /*  92743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_512_HasSM4),
     /*  92746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4512),
     /*  92751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /*  92754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  92757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /*  92760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  92764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  92768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  92776 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92779 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  92783 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  92787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92789 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  92796 */     // (intrinsic_wo_chain:{ *:[v16i32] } 15017:{ *:[iPTR] }, VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4RNDS4Zrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  92796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Zrm),
     /*  92799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92801 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92803 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  92807 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92812 */     GIR_RootConstrainSelectedInstOperands,
     /*  92813 */     // GIR_Coverage, 16800,
     /*  92813 */     GIR_EraseRootFromParent_Done,
     /*  92814 */   // Label 1983: @92814
     /*  92814 */   GIM_Try, /*On fail goto*//*Label 1984*/ GIMT_Encode4(92855), // Rule ID 3367 //
     /*  92819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX),
     /*  92822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aeskeygenassist),
     /*  92827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  92830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  92833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92841 */     // MIs[0] src2
     /*  92841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  92844 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13409:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, (timm:{ *:[i8] }):$src2)  =>  (VAESKEYGENASSIST128rr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, (timm:{ *:[i8] }):$src2)
     /*  92844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESKEYGENASSIST128rr),
     /*  92847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92849 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92851 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  92853 */     GIR_RootConstrainSelectedInstOperands,
     /*  92854 */     // GIR_Coverage, 3367,
     /*  92854 */     GIR_EraseRootFromParent_Done,
     /*  92855 */   // Label 1984: @92855
     /*  92855 */   GIM_Try, /*On fail goto*//*Label 1985*/ GIMT_Encode4(92896), // Rule ID 3369 //
     /*  92860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_NoAVX),
     /*  92863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aeskeygenassist),
     /*  92868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  92871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  92874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92882 */     // MIs[0] src2
     /*  92882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  92885 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13409:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, (timm:{ *:[i8] }):$src2)  =>  (AESKEYGENASSIST128rr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, (timm:{ *:[i8] }):$src2)
     /*  92885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AESKEYGENASSIST128rr),
     /*  92888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92890 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92892 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  92894 */     GIR_RootConstrainSelectedInstOperands,
     /*  92895 */     // GIR_Coverage, 3369,
     /*  92895 */     GIR_EraseRootFromParent_Done,
     /*  92896 */   // Label 1985: @92896
     /*  92896 */   GIM_Try, /*On fail goto*//*Label 1986*/ GIMT_Encode4(92941), // Rule ID 16789 //
     /*  92901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /*  92904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4128),
     /*  92909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  92912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  92915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  92918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  92922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  92926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  92930 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15012:{ *:[iPTR] }, VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VSM4KEY4Z128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /*  92930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Z128rr),
     /*  92933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92935 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92937 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  92939 */     GIR_RootConstrainSelectedInstOperands,
     /*  92940 */     // GIR_Coverage, 16789,
     /*  92940 */     GIR_EraseRootFromParent_Done,
     /*  92941 */   // Label 1986: @92941
     /*  92941 */   GIM_Try, /*On fail goto*//*Label 1987*/ GIMT_Encode4(92986), // Rule ID 16791 //
     /*  92946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /*  92949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4256),
     /*  92954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  92957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  92960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  92963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  92967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  92971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  92975 */     // (intrinsic_wo_chain:{ *:[v8i32] } 15013:{ *:[iPTR] }, VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VSM4KEY4Z256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /*  92975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Z256rr),
     /*  92978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92980 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92982 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  92984 */     GIR_RootConstrainSelectedInstOperands,
     /*  92985 */     // GIR_Coverage, 16791,
     /*  92985 */     GIR_EraseRootFromParent_Done,
     /*  92986 */   // Label 1987: @92986
     /*  92986 */   GIM_Try, /*On fail goto*//*Label 1988*/ GIMT_Encode4(93031), // Rule ID 16795 //
     /*  92991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /*  92994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4128),
     /*  92999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  93005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  93008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  93012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  93016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  93020 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15015:{ *:[iPTR] }, VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VSM4RNDS4Z128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /*  93020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Z128rr),
     /*  93023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93025 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93027 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93029 */     GIR_RootConstrainSelectedInstOperands,
     /*  93030 */     // GIR_Coverage, 16795,
     /*  93030 */     GIR_EraseRootFromParent_Done,
     /*  93031 */   // Label 1988: @93031
     /*  93031 */   GIM_Try, /*On fail goto*//*Label 1989*/ GIMT_Encode4(93076), // Rule ID 16797 //
     /*  93036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /*  93039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4256),
     /*  93044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  93047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  93050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  93053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  93057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  93061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  93065 */     // (intrinsic_wo_chain:{ *:[v8i32] } 15016:{ *:[iPTR] }, VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VSM4RNDS4Z256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /*  93065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Z256rr),
     /*  93068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93070 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93072 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93074 */     GIR_RootConstrainSelectedInstOperands,
     /*  93075 */     // GIR_Coverage, 16797,
     /*  93075 */     GIR_EraseRootFromParent_Done,
     /*  93076 */   // Label 1989: @93076
     /*  93076 */   GIM_Try, /*On fail goto*//*Label 1990*/ GIMT_Encode4(93121), // Rule ID 3022 //
     /*  93081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  93084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_b_128),
     /*  93089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  93092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  93095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  93098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93110 */     // (intrinsic_wo_chain:{ *:[v16i8] } 14881:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPSIGNBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  93110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNBrr),
     /*  93113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93115 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93117 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93119 */     GIR_RootConstrainSelectedInstOperands,
     /*  93120 */     // GIR_Coverage, 3022,
     /*  93120 */     GIR_EraseRootFromParent_Done,
     /*  93121 */   // Label 1990: @93121
     /*  93121 */   GIM_Try, /*On fail goto*//*Label 1991*/ GIMT_Encode4(93166), // Rule ID 3024 //
     /*  93126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  93129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_w_128),
     /*  93134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  93137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  93143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93155 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14885:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPSIGNWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  93155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNWrr),
     /*  93158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93160 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93162 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93164 */     GIR_RootConstrainSelectedInstOperands,
     /*  93165 */     // GIR_Coverage, 3024,
     /*  93165 */     GIR_EraseRootFromParent_Done,
     /*  93166 */   // Label 1991: @93166
     /*  93166 */   GIM_Try, /*On fail goto*//*Label 1992*/ GIMT_Encode4(93211), // Rule ID 3026 //
     /*  93171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  93174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_d_128),
     /*  93179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  93185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  93188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93200 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14883:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPSIGNDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  93200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNDrr),
     /*  93203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93205 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93207 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93209 */     GIR_RootConstrainSelectedInstOperands,
     /*  93210 */     // GIR_Coverage, 3026,
     /*  93210 */     GIR_EraseRootFromParent_Done,
     /*  93211 */   // Label 1992: @93211
     /*  93211 */   GIM_Try, /*On fail goto*//*Label 1993*/ GIMT_Encode4(93256), // Rule ID 3028 //
     /*  93216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  93219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_phadd_sw_128),
     /*  93224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  93227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  93233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93245 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14865:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPHADDSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  93245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDSWrr),
     /*  93248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93250 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93252 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93254 */     GIR_RootConstrainSelectedInstOperands,
     /*  93255 */     // GIR_Coverage, 3028,
     /*  93255 */     GIR_EraseRootFromParent_Done,
     /*  93256 */   // Label 1993: @93256
     /*  93256 */   GIM_Try, /*On fail goto*//*Label 1994*/ GIMT_Encode4(93301), // Rule ID 3030 //
     /*  93261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  93264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_phsub_sw_128),
     /*  93269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  93272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  93278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93290 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14871:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPHSUBSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  93290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBSWrr),
     /*  93293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93295 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93297 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93299 */     GIR_RootConstrainSelectedInstOperands,
     /*  93300 */     // GIR_Coverage, 3030,
     /*  93300 */     GIR_EraseRootFromParent_Done,
     /*  93301 */   // Label 1994: @93301
     /*  93301 */   GIM_Try, /*On fail goto*//*Label 1995*/ GIMT_Encode4(93346), // Rule ID 3046 //
     /*  93306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  93309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_psign_b),
     /*  93314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s8,
     /*  93317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /*  93320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s8,
     /*  93323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93335 */     // (intrinsic_wo_chain:{ *:[v32i8] } 13772:{ *:[iPTR] }, VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPSIGNBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*  93335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNBYrr),
     /*  93338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93340 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93342 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93344 */     GIR_RootConstrainSelectedInstOperands,
     /*  93345 */     // GIR_Coverage, 3046,
     /*  93345 */     GIR_EraseRootFromParent_Done,
     /*  93346 */   // Label 1995: @93346
     /*  93346 */   GIM_Try, /*On fail goto*//*Label 1996*/ GIMT_Encode4(93391), // Rule ID 3048 //
     /*  93351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  93354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_psign_w),
     /*  93359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /*  93362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  93365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /*  93368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93380 */     // (intrinsic_wo_chain:{ *:[v16i16] } 13774:{ *:[iPTR] }, VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPSIGNWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  93380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNWYrr),
     /*  93383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93385 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93387 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93389 */     GIR_RootConstrainSelectedInstOperands,
     /*  93390 */     // GIR_Coverage, 3048,
     /*  93390 */     GIR_EraseRootFromParent_Done,
     /*  93391 */   // Label 1996: @93391
     /*  93391 */   GIM_Try, /*On fail goto*//*Label 1997*/ GIMT_Encode4(93436), // Rule ID 3050 //
     /*  93396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  93399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_psign_d),
     /*  93404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  93407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  93410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  93413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93425 */     // (intrinsic_wo_chain:{ *:[v8i32] } 13773:{ *:[iPTR] }, VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPSIGNDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  93425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNDYrr),
     /*  93428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93430 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93432 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93434 */     GIR_RootConstrainSelectedInstOperands,
     /*  93435 */     // GIR_Coverage, 3050,
     /*  93435 */     GIR_EraseRootFromParent_Done,
     /*  93436 */   // Label 1997: @93436
     /*  93436 */   GIM_Try, /*On fail goto*//*Label 1998*/ GIMT_Encode4(93481), // Rule ID 3052 //
     /*  93441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  93444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_phadd_sw),
     /*  93449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /*  93452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  93455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /*  93458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93470 */     // (intrinsic_wo_chain:{ *:[v16i16] } 13759:{ *:[iPTR] }, VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPHADDSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  93470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDSWYrr),
     /*  93473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93475 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93477 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93479 */     GIR_RootConstrainSelectedInstOperands,
     /*  93480 */     // GIR_Coverage, 3052,
     /*  93480 */     GIR_EraseRootFromParent_Done,
     /*  93481 */   // Label 1998: @93481
     /*  93481 */   GIM_Try, /*On fail goto*//*Label 1999*/ GIMT_Encode4(93526), // Rule ID 3054 //
     /*  93486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  93489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_phsub_sw),
     /*  93494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /*  93497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  93500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /*  93503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93515 */     // (intrinsic_wo_chain:{ *:[v16i16] } 13762:{ *:[iPTR] }, VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPHSUBSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  93515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBSWYrr),
     /*  93518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93520 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93522 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93524 */     GIR_RootConstrainSelectedInstOperands,
     /*  93525 */     // GIR_Coverage, 3054,
     /*  93525 */     GIR_EraseRootFromParent_Done,
     /*  93526 */   // Label 1999: @93526
     /*  93526 */   GIM_Try, /*On fail goto*//*Label 2000*/ GIMT_Encode4(93571), // Rule ID 3064 //
     /*  93531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /*  93534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_b_128),
     /*  93539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  93542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  93545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  93548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93560 */     // (intrinsic_wo_chain:{ *:[v16i8] } 14881:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PSIGNBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  93560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PSIGNBrr),
     /*  93563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93565 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93567 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93569 */     GIR_RootConstrainSelectedInstOperands,
     /*  93570 */     // GIR_Coverage, 3064,
     /*  93570 */     GIR_EraseRootFromParent_Done,
     /*  93571 */   // Label 2000: @93571
     /*  93571 */   GIM_Try, /*On fail goto*//*Label 2001*/ GIMT_Encode4(93616), // Rule ID 3066 //
     /*  93576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /*  93579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_w_128),
     /*  93584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  93587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  93593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93605 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14885:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PSIGNWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  93605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PSIGNWrr),
     /*  93608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93610 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93612 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93614 */     GIR_RootConstrainSelectedInstOperands,
     /*  93615 */     // GIR_Coverage, 3066,
     /*  93615 */     GIR_EraseRootFromParent_Done,
     /*  93616 */   // Label 2001: @93616
     /*  93616 */   GIM_Try, /*On fail goto*//*Label 2002*/ GIMT_Encode4(93661), // Rule ID 3068 //
     /*  93621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /*  93624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_d_128),
     /*  93629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  93635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  93638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93650 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14883:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PSIGNDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  93650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PSIGNDrr),
     /*  93653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93655 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93657 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93659 */     GIR_RootConstrainSelectedInstOperands,
     /*  93660 */     // GIR_Coverage, 3068,
     /*  93660 */     GIR_EraseRootFromParent_Done,
     /*  93661 */   // Label 2002: @93661
     /*  93661 */   GIM_Try, /*On fail goto*//*Label 2003*/ GIMT_Encode4(93706), // Rule ID 3072 //
     /*  93666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /*  93669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_phadd_sw_128),
     /*  93674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  93677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  93683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93695 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14865:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PHADDSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  93695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PHADDSWrr),
     /*  93698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93700 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93702 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93704 */     GIR_RootConstrainSelectedInstOperands,
     /*  93705 */     // GIR_Coverage, 3072,
     /*  93705 */     GIR_EraseRootFromParent_Done,
     /*  93706 */   // Label 2003: @93706
     /*  93706 */   GIM_Try, /*On fail goto*//*Label 2004*/ GIMT_Encode4(93751), // Rule ID 3074 //
     /*  93711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /*  93714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_phsub_sw_128),
     /*  93719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  93722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  93728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93740 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14871:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PHSUBSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  93740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PHSUBSWrr),
     /*  93743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93745 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93747 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93749 */     GIR_RootConstrainSelectedInstOperands,
     /*  93750 */     // GIR_Coverage, 3074,
     /*  93750 */     GIR_EraseRootFromParent_Done,
     /*  93751 */   // Label 2004: @93751
     /*  93751 */   GIM_Try, /*On fail goto*//*Label 2005*/ GIMT_Encode4(93796), // Rule ID 3309 //
     /*  93756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /*  93759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_8),
     /*  93764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /*  93773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  93785 */     // (intrinsic_wo_chain:{ *:[i32] } 14839:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (CRC32r32r8:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  93785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32r8),
     /*  93788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93790 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93792 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93794 */     GIR_RootConstrainSelectedInstOperands,
     /*  93795 */     // GIR_Coverage, 3309,
     /*  93795 */     GIR_EraseRootFromParent_Done,
     /*  93796 */   // Label 2005: @93796
     /*  93796 */   GIM_Try, /*On fail goto*//*Label 2006*/ GIMT_Encode4(93841), // Rule ID 3311 //
     /*  93801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /*  93804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_16),
     /*  93809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  93818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  93830 */     // (intrinsic_wo_chain:{ *:[i32] } 14837:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (CRC32r32r16:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  93830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32r16),
     /*  93833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93835 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93837 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93839 */     GIR_RootConstrainSelectedInstOperands,
     /*  93840 */     // GIR_Coverage, 3311,
     /*  93840 */     GIR_EraseRootFromParent_Done,
     /*  93841 */   // Label 2006: @93841
     /*  93841 */   GIM_Try, /*On fail goto*//*Label 2007*/ GIMT_Encode4(93886), // Rule ID 3313 //
     /*  93846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /*  93849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_32),
     /*  93854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93875 */     // (intrinsic_wo_chain:{ *:[i32] } 14838:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (CRC32r32r32:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  93875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32r32),
     /*  93878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93880 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93882 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93884 */     GIR_RootConstrainSelectedInstOperands,
     /*  93885 */     // GIR_Coverage, 3313,
     /*  93885 */     GIR_EraseRootFromParent_Done,
     /*  93886 */   // Label 2007: @93886
     /*  93886 */   GIM_Try, /*On fail goto*//*Label 2008*/ GIMT_Encode4(93931), // Rule ID 3315 //
     /*  93891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /*  93894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_64_64),
     /*  93899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  93902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  93905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  93908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  93912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  93916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  93920 */     // (intrinsic_wo_chain:{ *:[i64] } 14840:{ *:[iPTR] }, GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (CRC32r64r64:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  93920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r64r64),
     /*  93923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93925 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93927 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93929 */     GIR_RootConstrainSelectedInstOperands,
     /*  93930 */     // GIR_Coverage, 3315,
     /*  93930 */     GIR_EraseRootFromParent_Done,
     /*  93931 */   // Label 2008: @93931
     /*  93931 */   GIM_Try, /*On fail goto*//*Label 2009*/ GIMT_Encode4(93976), // Rule ID 3317 //
     /*  93936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /*  93939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_8),
     /*  93944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /*  93953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  93965 */     // (intrinsic_wo_chain:{ *:[i32] } 14839:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (CRC32r32r8_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  93965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32r8_EVEX),
     /*  93968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93970 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93972 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93974 */     GIR_RootConstrainSelectedInstOperands,
     /*  93975 */     // GIR_Coverage, 3317,
     /*  93975 */     GIR_EraseRootFromParent_Done,
     /*  93976 */   // Label 2009: @93976
     /*  93976 */   GIM_Try, /*On fail goto*//*Label 2010*/ GIMT_Encode4(94021), // Rule ID 3319 //
     /*  93981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /*  93984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_16),
     /*  93989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  93998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  94002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  94006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  94010 */     // (intrinsic_wo_chain:{ *:[i32] } 14837:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (CRC32r32r16_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  94010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32r16_EVEX),
     /*  94013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94015 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94017 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94019 */     GIR_RootConstrainSelectedInstOperands,
     /*  94020 */     // GIR_Coverage, 3319,
     /*  94020 */     GIR_EraseRootFromParent_Done,
     /*  94021 */   // Label 2010: @94021
     /*  94021 */   GIM_Try, /*On fail goto*//*Label 2011*/ GIMT_Encode4(94066), // Rule ID 3321 //
     /*  94026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /*  94029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_32),
     /*  94034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  94047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  94051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  94055 */     // (intrinsic_wo_chain:{ *:[i32] } 14838:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (CRC32r32r32_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  94055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32r32_EVEX),
     /*  94058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94060 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94062 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94064 */     GIR_RootConstrainSelectedInstOperands,
     /*  94065 */     // GIR_Coverage, 3321,
     /*  94065 */     GIR_EraseRootFromParent_Done,
     /*  94066 */   // Label 2011: @94066
     /*  94066 */   GIM_Try, /*On fail goto*//*Label 2012*/ GIMT_Encode4(94111), // Rule ID 3323 //
     /*  94071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /*  94074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_64_64),
     /*  94079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  94082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  94085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  94088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  94092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  94096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  94100 */     // (intrinsic_wo_chain:{ *:[i64] } 14840:{ *:[iPTR] }, GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (CRC32r64r64_EVEX:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  94100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r64r64_EVEX),
     /*  94103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94105 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94107 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94109 */     GIR_RootConstrainSelectedInstOperands,
     /*  94110 */     // GIR_Coverage, 3323,
     /*  94110 */     GIR_EraseRootFromParent_Done,
     /*  94111 */   // Label 2012: @94111
     /*  94111 */   GIM_Try, /*On fail goto*//*Label 2013*/ GIMT_Encode4(94156), // Rule ID 3327 //
     /*  94116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /*  94119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha1nexte),
     /*  94124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  94127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  94133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94145 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14709:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (SHA1NEXTErr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  94145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA1NEXTErr),
     /*  94148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94150 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94152 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94154 */     GIR_RootConstrainSelectedInstOperands,
     /*  94155 */     // GIR_Coverage, 3327,
     /*  94155 */     GIR_EraseRootFromParent_Done,
     /*  94156 */   // Label 2013: @94156
     /*  94156 */   GIM_Try, /*On fail goto*//*Label 2014*/ GIMT_Encode4(94201), // Rule ID 3329 //
     /*  94161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /*  94164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha1msg1),
     /*  94169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  94172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  94178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94190 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14707:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (SHA1MSG1rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  94190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA1MSG1rr),
     /*  94193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94195 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94197 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94199 */     GIR_RootConstrainSelectedInstOperands,
     /*  94200 */     // GIR_Coverage, 3329,
     /*  94200 */     GIR_EraseRootFromParent_Done,
     /*  94201 */   // Label 2014: @94201
     /*  94201 */   GIM_Try, /*On fail goto*//*Label 2015*/ GIMT_Encode4(94246), // Rule ID 3331 //
     /*  94206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /*  94209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha1msg2),
     /*  94214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  94217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  94223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94235 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14708:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (SHA1MSG2rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  94235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA1MSG2rr),
     /*  94238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94240 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94242 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94244 */     GIR_RootConstrainSelectedInstOperands,
     /*  94245 */     // GIR_Coverage, 3331,
     /*  94245 */     GIR_EraseRootFromParent_Done,
     /*  94246 */   // Label 2015: @94246
     /*  94246 */   GIM_Try, /*On fail goto*//*Label 2016*/ GIMT_Encode4(94291), // Rule ID 3335 //
     /*  94251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /*  94254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha256msg1),
     /*  94259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  94262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  94268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94280 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14711:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (SHA256MSG1rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  94280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA256MSG1rr),
     /*  94283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94285 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94287 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94289 */     GIR_RootConstrainSelectedInstOperands,
     /*  94290 */     // GIR_Coverage, 3335,
     /*  94290 */     GIR_EraseRootFromParent_Done,
     /*  94291 */   // Label 2016: @94291
     /*  94291 */   GIM_Try, /*On fail goto*//*Label 2017*/ GIMT_Encode4(94336), // Rule ID 3337 //
     /*  94296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /*  94299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha256msg2),
     /*  94304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  94307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  94313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94325 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14712:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (SHA256MSG2rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  94325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA256MSG2rr),
     /*  94328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94330 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94332 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94334 */     GIR_RootConstrainSelectedInstOperands,
     /*  94335 */     // GIR_Coverage, 3337,
     /*  94335 */     GIR_EraseRootFromParent_Done,
     /*  94336 */   // Label 2017: @94336
     /*  94336 */   GIM_Try, /*On fail goto*//*Label 2018*/ GIMT_Encode4(94381), // Rule ID 3339 //
     /*  94341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /*  94344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc),
     /*  94349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94370 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13402:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VAESENCrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  94370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCrr),
     /*  94373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94375 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94377 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94379 */     GIR_RootConstrainSelectedInstOperands,
     /*  94380 */     // GIR_Coverage, 3339,
     /*  94380 */     GIR_EraseRootFromParent_Done,
     /*  94381 */   // Label 2018: @94381
     /*  94381 */   GIM_Try, /*On fail goto*//*Label 2019*/ GIMT_Encode4(94426), // Rule ID 3341 //
     /*  94386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /*  94389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast),
     /*  94394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94415 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13405:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VAESENCLASTrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  94415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTrr),
     /*  94418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94420 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94422 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94424 */     GIR_RootConstrainSelectedInstOperands,
     /*  94425 */     // GIR_Coverage, 3341,
     /*  94425 */     GIR_EraseRootFromParent_Done,
     /*  94426 */   // Label 2019: @94426
     /*  94426 */   GIM_Try, /*On fail goto*//*Label 2020*/ GIMT_Encode4(94471), // Rule ID 3343 //
     /*  94431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /*  94434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec),
     /*  94439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94460 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13396:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VAESDECrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  94460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECrr),
     /*  94463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94465 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94467 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94469 */     GIR_RootConstrainSelectedInstOperands,
     /*  94470 */     // GIR_Coverage, 3343,
     /*  94470 */     GIR_EraseRootFromParent_Done,
     /*  94471 */   // Label 2020: @94471
     /*  94471 */   GIM_Try, /*On fail goto*//*Label 2021*/ GIMT_Encode4(94516), // Rule ID 3345 //
     /*  94476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /*  94479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast),
     /*  94484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94505 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13399:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VAESDECLASTrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  94505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTrr),
     /*  94508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94510 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94512 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94514 */     GIR_RootConstrainSelectedInstOperands,
     /*  94515 */     // GIR_Coverage, 3345,
     /*  94515 */     GIR_EraseRootFromParent_Done,
     /*  94516 */   // Label 2021: @94516
     /*  94516 */   GIM_Try, /*On fail goto*//*Label 2022*/ GIMT_Encode4(94561), // Rule ID 3347 //
     /*  94521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /*  94524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc_256),
     /*  94529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  94532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  94535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  94538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94550 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13403:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VAESENCYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  94550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCYrr),
     /*  94553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94555 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94557 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94559 */     GIR_RootConstrainSelectedInstOperands,
     /*  94560 */     // GIR_Coverage, 3347,
     /*  94560 */     GIR_EraseRootFromParent_Done,
     /*  94561 */   // Label 2022: @94561
     /*  94561 */   GIM_Try, /*On fail goto*//*Label 2023*/ GIMT_Encode4(94606), // Rule ID 3349 //
     /*  94566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /*  94569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast_256),
     /*  94574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  94577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  94580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  94583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94595 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13406:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VAESENCLASTYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  94595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTYrr),
     /*  94598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94600 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94602 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94604 */     GIR_RootConstrainSelectedInstOperands,
     /*  94605 */     // GIR_Coverage, 3349,
     /*  94605 */     GIR_EraseRootFromParent_Done,
     /*  94606 */   // Label 2023: @94606
     /*  94606 */   GIM_Try, /*On fail goto*//*Label 2024*/ GIMT_Encode4(94651), // Rule ID 3351 //
     /*  94611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /*  94614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec_256),
     /*  94619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  94622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  94625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  94628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94640 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13397:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VAESDECYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  94640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECYrr),
     /*  94643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94645 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94647 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94649 */     GIR_RootConstrainSelectedInstOperands,
     /*  94650 */     // GIR_Coverage, 3351,
     /*  94650 */     GIR_EraseRootFromParent_Done,
     /*  94651 */   // Label 2024: @94651
     /*  94651 */   GIM_Try, /*On fail goto*//*Label 2025*/ GIMT_Encode4(94696), // Rule ID 3353 //
     /*  94656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /*  94659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast_256),
     /*  94664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  94667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  94670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  94673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94685 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13400:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VAESDECLASTYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  94685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTYrr),
     /*  94688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94690 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94692 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94694 */     GIR_RootConstrainSelectedInstOperands,
     /*  94695 */     // GIR_Coverage, 3353,
     /*  94695 */     GIR_EraseRootFromParent_Done,
     /*  94696 */   // Label 2025: @94696
     /*  94696 */   GIM_Try, /*On fail goto*//*Label 2026*/ GIMT_Encode4(94741), // Rule ID 3355 //
     /*  94701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_NoAVX),
     /*  94704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc),
     /*  94709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94730 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13402:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (AESENCrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  94730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AESENCrr),
     /*  94733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94735 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94737 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94739 */     GIR_RootConstrainSelectedInstOperands,
     /*  94740 */     // GIR_Coverage, 3355,
     /*  94740 */     GIR_EraseRootFromParent_Done,
     /*  94741 */   // Label 2026: @94741
     /*  94741 */   GIM_Try, /*On fail goto*//*Label 2027*/ GIMT_Encode4(94786), // Rule ID 3357 //
     /*  94746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_NoAVX),
     /*  94749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast),
     /*  94754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94775 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13405:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (AESENCLASTrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  94775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AESENCLASTrr),
     /*  94778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94780 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94782 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94784 */     GIR_RootConstrainSelectedInstOperands,
     /*  94785 */     // GIR_Coverage, 3357,
     /*  94785 */     GIR_EraseRootFromParent_Done,
     /*  94786 */   // Label 2027: @94786
     /*  94786 */   GIM_Try, /*On fail goto*//*Label 2028*/ GIMT_Encode4(94831), // Rule ID 3359 //
     /*  94791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_NoAVX),
     /*  94794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec),
     /*  94799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94820 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13396:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (AESDECrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  94820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AESDECrr),
     /*  94823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94825 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94827 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94829 */     GIR_RootConstrainSelectedInstOperands,
     /*  94830 */     // GIR_Coverage, 3359,
     /*  94830 */     GIR_EraseRootFromParent_Done,
     /*  94831 */   // Label 2028: @94831
     /*  94831 */   GIM_Try, /*On fail goto*//*Label 2029*/ GIMT_Encode4(94876), // Rule ID 3361 //
     /*  94836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_NoAVX),
     /*  94839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast),
     /*  94844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94865 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13399:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (AESDECLASTrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  94865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AESDECLASTrr),
     /*  94868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94870 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94872 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94874 */     GIR_RootConstrainSelectedInstOperands,
     /*  94875 */     // GIR_Coverage, 3361,
     /*  94875 */     GIR_EraseRootFromParent_Done,
     /*  94876 */   // Label 2029: @94876
     /*  94876 */   GIM_Try, /*On fail goto*//*Label 2030*/ GIMT_Encode4(94921), // Rule ID 3378 //
     /*  94881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE4A),
     /*  94884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse4a_extrq),
     /*  94889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  94898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94910 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14855:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src, VR128:{ *:[v16i8] }:$mask)  =>  (EXTRQ:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src, VR128:{ *:[v16i8] }:$mask)
     /*  94910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::EXTRQ),
     /*  94913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94915 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  94917 */     GIR_RootToRootCopy, /*OpIdx*/3, // mask
     /*  94919 */     GIR_RootConstrainSelectedInstOperands,
     /*  94920 */     // GIR_Coverage, 3378,
     /*  94920 */     GIR_EraseRootFromParent_Done,
     /*  94921 */   // Label 2030: @94921
     /*  94921 */   GIM_Try, /*On fail goto*//*Label 2031*/ GIMT_Encode4(94966), // Rule ID 3380 //
     /*  94926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE4A),
     /*  94929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse4a_insertq),
     /*  94934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94955 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14857:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src, VR128:{ *:[v2i64] }:$mask)  =>  (INSERTQ:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src, VR128:{ *:[v2i64] }:$mask)
     /*  94955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INSERTQ),
     /*  94958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94960 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  94962 */     GIR_RootToRootCopy, /*OpIdx*/3, // mask
     /*  94964 */     GIR_RootConstrainSelectedInstOperands,
     /*  94965 */     // GIR_Coverage, 3380,
     /*  94965 */     GIR_EraseRootFromParent_Done,
     /*  94966 */   // Label 2031: @94966
     /*  94966 */   GIM_Try, /*On fail goto*//*Label 2032*/ GIMT_Encode4(95011), // Rule ID 3555 //
     /*  94971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA512),
     /*  94974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsha512msg1),
     /*  94979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  94982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  94985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  95000 */     // (intrinsic_wo_chain:{ *:[v4i64] } 15006:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VSHA512MSG1rr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  95000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSHA512MSG1rr),
     /*  95003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95005 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95007 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95009 */     GIR_RootConstrainSelectedInstOperands,
     /*  95010 */     // GIR_Coverage, 3555,
     /*  95010 */     GIR_EraseRootFromParent_Done,
     /*  95011 */   // Label 2032: @95011
     /*  95011 */   GIM_Try, /*On fail goto*//*Label 2033*/ GIMT_Encode4(95056), // Rule ID 3556 //
     /*  95016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA512),
     /*  95019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsha512msg2),
     /*  95024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  95027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  95030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  95033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  95037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  95041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  95045 */     // (intrinsic_wo_chain:{ *:[v4i64] } 15007:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VSHA512MSG2rr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  95045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSHA512MSG2rr),
     /*  95048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95050 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95052 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95054 */     GIR_RootConstrainSelectedInstOperands,
     /*  95055 */     // GIR_Coverage, 3556,
     /*  95055 */     GIR_EraseRootFromParent_Done,
     /*  95056 */   // Label 2033: @95056
     /*  95056 */   GIM_Try, /*On fail goto*//*Label 2034*/ GIMT_Encode4(95101), // Rule ID 3564 //
     /*  95061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /*  95064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4128),
     /*  95069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  95072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  95082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  95086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  95090 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15012:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VSM4KEY4rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  95090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4rr),
     /*  95093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95095 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95097 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95099 */     GIR_RootConstrainSelectedInstOperands,
     /*  95100 */     // GIR_Coverage, 3564,
     /*  95100 */     GIR_EraseRootFromParent_Done,
     /*  95101 */   // Label 2034: @95101
     /*  95101 */   GIM_Try, /*On fail goto*//*Label 2035*/ GIMT_Encode4(95146), // Rule ID 3566 //
     /*  95106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /*  95109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4256),
     /*  95114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  95117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  95120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  95123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  95127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  95131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  95135 */     // (intrinsic_wo_chain:{ *:[v8i32] } 15013:{ *:[iPTR] }, VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VSM4KEY4Yrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  95135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Yrr),
     /*  95138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95140 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95142 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95144 */     GIR_RootConstrainSelectedInstOperands,
     /*  95145 */     // GIR_Coverage, 3566,
     /*  95145 */     GIR_EraseRootFromParent_Done,
     /*  95146 */   // Label 2035: @95146
     /*  95146 */   GIM_Try, /*On fail goto*//*Label 2036*/ GIMT_Encode4(95191), // Rule ID 3568 //
     /*  95151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /*  95154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4128),
     /*  95159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  95162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  95172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  95176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  95180 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15015:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VSM4RNDS4rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  95180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4rr),
     /*  95183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95185 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95187 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95189 */     GIR_RootConstrainSelectedInstOperands,
     /*  95190 */     // GIR_Coverage, 3568,
     /*  95190 */     GIR_EraseRootFromParent_Done,
     /*  95191 */   // Label 2036: @95191
     /*  95191 */   GIM_Try, /*On fail goto*//*Label 2037*/ GIMT_Encode4(95236), // Rule ID 3570 //
     /*  95196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /*  95199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4256),
     /*  95204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  95207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  95210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  95213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  95217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  95221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  95225 */     // (intrinsic_wo_chain:{ *:[v8i32] } 15016:{ *:[iPTR] }, VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VSM4RNDS4Yrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  95225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Yrr),
     /*  95228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95230 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95232 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95234 */     GIR_RootConstrainSelectedInstOperands,
     /*  95235 */     // GIR_Coverage, 3570,
     /*  95235 */     GIR_EraseRootFromParent_Done,
     /*  95236 */   // Label 2037: @95236
     /*  95236 */   GIM_Try, /*On fail goto*//*Label 2038*/ GIMT_Encode4(95281), // Rule ID 14060 //
     /*  95241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  95244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc),
     /*  95249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  95252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  95255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  95258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95270 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13402:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VAESENCZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*  95270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCZ128rr),
     /*  95273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95275 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95277 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95279 */     GIR_RootConstrainSelectedInstOperands,
     /*  95280 */     // GIR_Coverage, 14060,
     /*  95280 */     GIR_EraseRootFromParent_Done,
     /*  95281 */   // Label 2038: @95281
     /*  95281 */   GIM_Try, /*On fail goto*//*Label 2039*/ GIMT_Encode4(95326), // Rule ID 14062 //
     /*  95286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  95289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc_256),
     /*  95294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  95297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  95300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  95303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95315 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13403:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VAESENCZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*  95315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCZ256rr),
     /*  95318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95320 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95322 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95324 */     GIR_RootConstrainSelectedInstOperands,
     /*  95325 */     // GIR_Coverage, 14062,
     /*  95325 */     GIR_EraseRootFromParent_Done,
     /*  95326 */   // Label 2039: @95326
     /*  95326 */   GIM_Try, /*On fail goto*//*Label 2040*/ GIMT_Encode4(95371), // Rule ID 14064 //
     /*  95331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /*  95334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc_512),
     /*  95339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  95342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  95345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  95348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95360 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13404:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VAESENCZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  95360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCZrr),
     /*  95363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95365 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95367 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95369 */     GIR_RootConstrainSelectedInstOperands,
     /*  95370 */     // GIR_Coverage, 14064,
     /*  95370 */     GIR_EraseRootFromParent_Done,
     /*  95371 */   // Label 2040: @95371
     /*  95371 */   GIM_Try, /*On fail goto*//*Label 2041*/ GIMT_Encode4(95416), // Rule ID 14066 //
     /*  95376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  95379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast),
     /*  95384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  95387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  95390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  95393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95405 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13405:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VAESENCLASTZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*  95405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTZ128rr),
     /*  95408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95410 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95412 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95414 */     GIR_RootConstrainSelectedInstOperands,
     /*  95415 */     // GIR_Coverage, 14066,
     /*  95415 */     GIR_EraseRootFromParent_Done,
     /*  95416 */   // Label 2041: @95416
     /*  95416 */   GIM_Try, /*On fail goto*//*Label 2042*/ GIMT_Encode4(95461), // Rule ID 14068 //
     /*  95421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  95424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast_256),
     /*  95429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  95432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  95435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  95438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95450 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13406:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VAESENCLASTZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*  95450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTZ256rr),
     /*  95453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95455 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95457 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95459 */     GIR_RootConstrainSelectedInstOperands,
     /*  95460 */     // GIR_Coverage, 14068,
     /*  95460 */     GIR_EraseRootFromParent_Done,
     /*  95461 */   // Label 2042: @95461
     /*  95461 */   GIM_Try, /*On fail goto*//*Label 2043*/ GIMT_Encode4(95506), // Rule ID 14070 //
     /*  95466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /*  95469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast_512),
     /*  95474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  95477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  95480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  95483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95495 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13407:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VAESENCLASTZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  95495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTZrr),
     /*  95498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95500 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95502 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95504 */     GIR_RootConstrainSelectedInstOperands,
     /*  95505 */     // GIR_Coverage, 14070,
     /*  95505 */     GIR_EraseRootFromParent_Done,
     /*  95506 */   // Label 2043: @95506
     /*  95506 */   GIM_Try, /*On fail goto*//*Label 2044*/ GIMT_Encode4(95551), // Rule ID 14072 //
     /*  95511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  95514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec),
     /*  95519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  95522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  95525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  95528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95540 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13396:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VAESDECZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*  95540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECZ128rr),
     /*  95543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95545 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95547 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95549 */     GIR_RootConstrainSelectedInstOperands,
     /*  95550 */     // GIR_Coverage, 14072,
     /*  95550 */     GIR_EraseRootFromParent_Done,
     /*  95551 */   // Label 2044: @95551
     /*  95551 */   GIM_Try, /*On fail goto*//*Label 2045*/ GIMT_Encode4(95596), // Rule ID 14074 //
     /*  95556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  95559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec_256),
     /*  95564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  95567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  95570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  95573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95585 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13397:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VAESDECZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*  95585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECZ256rr),
     /*  95588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95590 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95592 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95594 */     GIR_RootConstrainSelectedInstOperands,
     /*  95595 */     // GIR_Coverage, 14074,
     /*  95595 */     GIR_EraseRootFromParent_Done,
     /*  95596 */   // Label 2045: @95596
     /*  95596 */   GIM_Try, /*On fail goto*//*Label 2046*/ GIMT_Encode4(95641), // Rule ID 14076 //
     /*  95601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /*  95604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec_512),
     /*  95609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  95612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  95615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  95618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95630 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13398:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VAESDECZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  95630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECZrr),
     /*  95633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95635 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95637 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95639 */     GIR_RootConstrainSelectedInstOperands,
     /*  95640 */     // GIR_Coverage, 14076,
     /*  95640 */     GIR_EraseRootFromParent_Done,
     /*  95641 */   // Label 2046: @95641
     /*  95641 */   GIM_Try, /*On fail goto*//*Label 2047*/ GIMT_Encode4(95686), // Rule ID 14078 //
     /*  95646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  95649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast),
     /*  95654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  95657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  95660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  95663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95675 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13399:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VAESDECLASTZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*  95675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTZ128rr),
     /*  95678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95680 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95682 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95684 */     GIR_RootConstrainSelectedInstOperands,
     /*  95685 */     // GIR_Coverage, 14078,
     /*  95685 */     GIR_EraseRootFromParent_Done,
     /*  95686 */   // Label 2047: @95686
     /*  95686 */   GIM_Try, /*On fail goto*//*Label 2048*/ GIMT_Encode4(95731), // Rule ID 14080 //
     /*  95691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  95694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast_256),
     /*  95699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  95702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  95705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  95708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95720 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13400:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VAESDECLASTZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*  95720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTZ256rr),
     /*  95723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95725 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95727 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95729 */     GIR_RootConstrainSelectedInstOperands,
     /*  95730 */     // GIR_Coverage, 14080,
     /*  95730 */     GIR_EraseRootFromParent_Done,
     /*  95731 */   // Label 2048: @95731
     /*  95731 */   GIM_Try, /*On fail goto*//*Label 2049*/ GIMT_Encode4(95776), // Rule ID 14082 //
     /*  95736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /*  95739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast_512),
     /*  95744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  95747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  95750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  95753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95765 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13401:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VAESDECLASTZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  95765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTZrr),
     /*  95768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95770 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95772 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95774 */     GIR_RootConstrainSelectedInstOperands,
     /*  95775 */     // GIR_Coverage, 14082,
     /*  95775 */     GIR_EraseRootFromParent_Done,
     /*  95776 */   // Label 2049: @95776
     /*  95776 */   GIM_Try, /*On fail goto*//*Label 2050*/ GIMT_Encode4(95821), // Rule ID 16793 //
     /*  95781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_512_HasSM4),
     /*  95784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4512),
     /*  95789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /*  95792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  95795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /*  95798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95810 */     // (intrinsic_wo_chain:{ *:[v16i32] } 15014:{ *:[iPTR] }, VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VSM4KEY4Zrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /*  95810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Zrr),
     /*  95813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95815 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95817 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95819 */     GIR_RootConstrainSelectedInstOperands,
     /*  95820 */     // GIR_Coverage, 16793,
     /*  95820 */     GIR_EraseRootFromParent_Done,
     /*  95821 */   // Label 2050: @95821
     /*  95821 */   GIM_Try, /*On fail goto*//*Label 2051*/ GIMT_Encode4(95866), // Rule ID 16799 //
     /*  95826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_512_HasSM4),
     /*  95829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4512),
     /*  95834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /*  95837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  95840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /*  95843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95855 */     // (intrinsic_wo_chain:{ *:[v16i32] } 15017:{ *:[iPTR] }, VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VSM4RNDS4Zrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /*  95855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Zrr),
     /*  95858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95860 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95862 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95864 */     GIR_RootConstrainSelectedInstOperands,
     /*  95865 */     // GIR_Coverage, 16799,
     /*  95865 */     GIR_EraseRootFromParent_Done,
     /*  95866 */   // Label 2051: @95866
     /*  95866 */   GIM_Reject,
     /*  95867 */ // Label 1934: @95867
     /*  95867 */ GIM_Try, /*On fail goto*//*Label 2052*/ GIMT_Encode4(100453),
     /*  95872 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /*  95875 */   GIM_Try, /*On fail goto*//*Label 2053*/ GIMT_Encode4(95956), // Rule ID 23534 //
     /*  95880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  95883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dpps),
     /*  95888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  95891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  95901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  95905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  95909 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95912 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  95916 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  95920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  95924 */     // MIs[0] src3
     /*  95924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95929 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  95936 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14824:{ *:[iPTR] }, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1, (timm:{ *:[i8] }):$src3)  =>  (VDPPSrmi:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  95936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPSrmi),
     /*  95939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95941 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  95943 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  95947 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  95949 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  95954 */     GIR_RootConstrainSelectedInstOperands,
     /*  95955 */     // GIR_Coverage, 23534,
     /*  95955 */     GIR_EraseRootFromParent_Done,
     /*  95956 */   // Label 2053: @95956
     /*  95956 */   GIM_Try, /*On fail goto*//*Label 2054*/ GIMT_Encode4(96037), // Rule ID 23535 //
     /*  95961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  95964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dppd),
     /*  95969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  95972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  95975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  95978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  95982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  95986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  95990 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95993 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  95997 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96005 */     // MIs[0] src3
     /*  96005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  96008 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96010 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96017 */     // (intrinsic_wo_chain:{ *:[v2f64] } 14823:{ *:[iPTR] }, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1, (timm:{ *:[i8] }):$src3)  =>  (VDPPDrmi:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  96017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPDrmi),
     /*  96020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96022 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  96024 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96028 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96030 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96035 */     GIR_RootConstrainSelectedInstOperands,
     /*  96036 */     // GIR_Coverage, 23535,
     /*  96036 */     GIR_EraseRootFromParent_Done,
     /*  96037 */   // Label 2054: @96037
     /*  96037 */   GIM_Try, /*On fail goto*//*Label 2055*/ GIMT_Encode4(96118), // Rule ID 23536 //
     /*  96042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  96045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx_dp_ps_256),
     /*  96050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  96053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  96056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  96059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  96063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  96067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96071 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96074 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96078 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  96086 */     // MIs[0] src3
     /*  96086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  96089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96091 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96098 */     // (intrinsic_wo_chain:{ *:[v8f32] } 13434:{ *:[iPTR] }, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1, (timm:{ *:[i8] }):$src3)  =>  (VDPPSYrmi:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  96098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPSYrmi),
     /*  96101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96103 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  96105 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96109 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96111 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96116 */     GIR_RootConstrainSelectedInstOperands,
     /*  96117 */     // GIR_Coverage, 23536,
     /*  96117 */     GIR_EraseRootFromParent_Done,
     /*  96118 */   // Label 2055: @96118
     /*  96118 */   GIM_Try, /*On fail goto*//*Label 2056*/ GIMT_Encode4(96199), // Rule ID 3254 //
     /*  96123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  96126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dpps),
     /*  96131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  96134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  96137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  96140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  96152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96156 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96159 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96163 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96167 */     // MIs[0] src3
     /*  96167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  96170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96172 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96179 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14824:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i8] }):$src3)  =>  (VDPPSrmi:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  96179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPSrmi),
     /*  96182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96184 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  96186 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96190 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96192 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96197 */     GIR_RootConstrainSelectedInstOperands,
     /*  96198 */     // GIR_Coverage, 3254,
     /*  96198 */     GIR_EraseRootFromParent_Done,
     /*  96199 */   // Label 2056: @96199
     /*  96199 */   GIM_Try, /*On fail goto*//*Label 2057*/ GIMT_Encode4(96280), // Rule ID 3256 //
     /*  96204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  96207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dppd),
     /*  96212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  96215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  96218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  96221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  96233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96237 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96240 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96244 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96248 */     // MIs[0] src3
     /*  96248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  96251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96253 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96260 */     // (intrinsic_wo_chain:{ *:[v2f64] } 14823:{ *:[iPTR] }, VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i8] }):$src3)  =>  (VDPPDrmi:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  96260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPDrmi),
     /*  96263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96265 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  96267 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96271 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96273 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96278 */     GIR_RootConstrainSelectedInstOperands,
     /*  96279 */     // GIR_Coverage, 3256,
     /*  96279 */     GIR_EraseRootFromParent_Done,
     /*  96280 */   // Label 2057: @96280
     /*  96280 */   GIM_Try, /*On fail goto*//*Label 2058*/ GIMT_Encode4(96361), // Rule ID 3258 //
     /*  96285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  96288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx_dp_ps_256),
     /*  96293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  96296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  96299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  96302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  96306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  96310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  96314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96318 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96321 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96325 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96329 */     // MIs[0] src3
     /*  96329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  96332 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96334 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96341 */     // (intrinsic_wo_chain:{ *:[v8f32] } 13434:{ *:[iPTR] }, VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i8] }):$src3)  =>  (VDPPSYrmi:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  96341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPSYrmi),
     /*  96344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96346 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  96348 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96352 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96359 */     GIR_RootConstrainSelectedInstOperands,
     /*  96360 */     // GIR_Coverage, 3258,
     /*  96360 */     GIR_EraseRootFromParent_Done,
     /*  96361 */   // Label 2058: @96361
     /*  96361 */   GIM_Try, /*On fail goto*//*Label 2059*/ GIMT_Encode4(96442), // Rule ID 3374 //
     /*  96366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_HasPCLMUL_NoVLX_Or_NoVPCLMULQDQ),
     /*  96369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq),
     /*  96374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  96377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  96380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  96383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  96395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96399 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96402 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96406 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96410 */     // MIs[0] src3
     /*  96410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  96413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96415 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96422 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14675:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQrmi:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  96422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQrmi),
     /*  96425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96427 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  96429 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96433 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96435 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96440 */     GIR_RootConstrainSelectedInstOperands,
     /*  96441 */     // GIR_Coverage, 3374,
     /*  96441 */     GIR_EraseRootFromParent_Done,
     /*  96442 */   // Label 2059: @96442
     /*  96442 */   GIM_Try, /*On fail goto*//*Label 2060*/ GIMT_Encode4(96523), // Rule ID 3376 //
     /*  96447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVPCLMULQDQ_NoVLX),
     /*  96450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq_256),
     /*  96455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  96458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  96461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  96464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  96468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  96472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  96476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96480 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96483 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96487 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96491 */     // MIs[0] src3
     /*  96491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  96494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96496 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96503 */     // (intrinsic_wo_chain:{ *:[v4i64] } 14676:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQYrmi:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  96503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQYrmi),
     /*  96506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96508 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  96510 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96514 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96516 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96521 */     GIR_RootConstrainSelectedInstOperands,
     /*  96522 */     // GIR_Coverage, 3376,
     /*  96522 */     GIR_EraseRootFromParent_Done,
     /*  96523 */   // Label 2060: @96523
     /*  96523 */   GIM_Try, /*On fail goto*//*Label 2061*/ GIMT_Encode4(96604), // Rule ID 14085 //
     /*  96528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVPCLMULQDQ),
     /*  96531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq_512),
     /*  96536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  96539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  96542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  96545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  96549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  96553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  96557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96561 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96564 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96568 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96572 */     // MIs[0] src3
     /*  96572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  96575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96577 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96584 */     // (intrinsic_wo_chain:{ *:[v8i64] } 14677:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQZrmi:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  96584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQZrmi),
     /*  96587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96589 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  96591 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96595 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96597 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96602 */     GIR_RootConstrainSelectedInstOperands,
     /*  96603 */     // GIR_Coverage, 14085,
     /*  96603 */     GIR_EraseRootFromParent_Done,
     /*  96604 */   // Label 2061: @96604
     /*  96604 */   GIM_Try, /*On fail goto*//*Label 2062*/ GIMT_Encode4(96685), // Rule ID 14087 //
     /*  96609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPCLMULQDQ),
     /*  96612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq),
     /*  96617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  96620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  96623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  96626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  96630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  96634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  96638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96642 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96645 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96649 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96653 */     // MIs[0] src3
     /*  96653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  96656 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96658 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96665 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14675:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQZ128rmi:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  96665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQZ128rmi),
     /*  96668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96670 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  96672 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96676 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96678 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96683 */     GIR_RootConstrainSelectedInstOperands,
     /*  96684 */     // GIR_Coverage, 14087,
     /*  96684 */     GIR_EraseRootFromParent_Done,
     /*  96685 */   // Label 2062: @96685
     /*  96685 */   GIM_Try, /*On fail goto*//*Label 2063*/ GIMT_Encode4(96766), // Rule ID 14089 //
     /*  96690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPCLMULQDQ),
     /*  96693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq_256),
     /*  96698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  96701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  96704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  96707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  96711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  96715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  96719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96723 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96726 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96730 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96734 */     // MIs[0] src3
     /*  96734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  96737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96739 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96746 */     // (intrinsic_wo_chain:{ *:[v4i64] } 14676:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQZ256rmi:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  96746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQZ256rmi),
     /*  96749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96751 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  96753 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96757 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96759 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96764 */     GIR_RootConstrainSelectedInstOperands,
     /*  96765 */     // GIR_Coverage, 14089,
     /*  96765 */     GIR_EraseRootFromParent_Done,
     /*  96766 */   // Label 2063: @96766
     /*  96766 */   GIM_Try, /*On fail goto*//*Label 2064*/ GIMT_Encode4(96851), // Rule ID 23336 //
     /*  96771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  96774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmadcswd),
     /*  96779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  96782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  96785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  96791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  96799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96803 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96806 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96810 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96822 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96824 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96831 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15069:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v4i32] }:$src3)  =>  (VPMADCSWDrm:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  96831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMADCSWDrm),
     /*  96834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96836 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  96838 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96842 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96844 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96849 */     GIR_RootConstrainSelectedInstOperands,
     /*  96850 */     // GIR_Coverage, 23336,
     /*  96850 */     GIR_EraseRootFromParent_Done,
     /*  96851 */   // Label 2064: @96851
     /*  96851 */   GIM_Try, /*On fail goto*//*Label 2065*/ GIMT_Encode4(96936), // Rule ID 23337 //
     /*  96856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  96859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmadcsswd),
     /*  96864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  96867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  96870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  96876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  96884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96888 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96891 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96895 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96909 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96916 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15068:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v4i32] }:$src3)  =>  (VPMADCSSWDrm:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  96916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMADCSSWDrm),
     /*  96919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96921 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  96923 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96927 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96929 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96934 */     GIR_RootConstrainSelectedInstOperands,
     /*  96935 */     // GIR_Coverage, 23337,
     /*  96935 */     GIR_EraseRootFromParent_Done,
     /*  96936 */   // Label 2065: @96936
     /*  96936 */   GIM_Try, /*On fail goto*//*Label 2066*/ GIMT_Encode4(97021), // Rule ID 23338 //
     /*  96941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  96944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsww),
     /*  96949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  96955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  96961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  96969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96973 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96976 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96980 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96992 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96994 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97001 */     // (intrinsic_wo_chain:{ *:[v8i16] } 15067:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src3)  =>  (VPMACSWWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /*  97001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWWrm),
     /*  97004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97006 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  97008 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97012 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97014 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97019 */     GIR_RootConstrainSelectedInstOperands,
     /*  97020 */     // GIR_Coverage, 23338,
     /*  97020 */     GIR_EraseRootFromParent_Done,
     /*  97021 */   // Label 2066: @97021
     /*  97021 */   GIM_Try, /*On fail goto*//*Label 2067*/ GIMT_Encode4(97106), // Rule ID 23339 //
     /*  97026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacswd),
     /*  97034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  97040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  97046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97058 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97061 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97065 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97079 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97086 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15066:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSWDrm:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  97086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWDrm),
     /*  97089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97091 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  97093 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97097 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97099 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97104 */     GIR_RootConstrainSelectedInstOperands,
     /*  97105 */     // GIR_Coverage, 23339,
     /*  97105 */     GIR_EraseRootFromParent_Done,
     /*  97106 */   // Label 2067: @97106
     /*  97106 */   GIM_Try, /*On fail goto*//*Label 2068*/ GIMT_Encode4(97191), // Rule ID 23340 //
     /*  97111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssww),
     /*  97119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  97122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  97125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  97131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97143 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97146 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97150 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97164 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97171 */     // (intrinsic_wo_chain:{ *:[v8i16] } 15065:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src3)  =>  (VPMACSSWWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /*  97171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSWWrm),
     /*  97174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97176 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  97178 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97182 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97184 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97189 */     GIR_RootConstrainSelectedInstOperands,
     /*  97190 */     // GIR_Coverage, 23340,
     /*  97190 */     GIR_EraseRootFromParent_Done,
     /*  97191 */   // Label 2068: @97191
     /*  97191 */   GIM_Try, /*On fail goto*//*Label 2069*/ GIMT_Encode4(97276), // Rule ID 23341 //
     /*  97196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsswd),
     /*  97204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  97210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  97216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97228 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97231 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97235 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97249 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97256 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15064:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSSWDrm:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  97256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSWDrm),
     /*  97259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97261 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  97263 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97267 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97269 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97274 */     GIR_RootConstrainSelectedInstOperands,
     /*  97275 */     // GIR_Coverage, 23341,
     /*  97275 */     GIR_EraseRootFromParent_Done,
     /*  97276 */   // Label 2069: @97276
     /*  97276 */   GIM_Try, /*On fail goto*//*Label 2070*/ GIMT_Encode4(97361), // Rule ID 23342 //
     /*  97281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdql),
     /*  97289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  97292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  97295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  97301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97313 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97316 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97320 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97332 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97334 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97341 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15063:{ *:[iPTR] }, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSSDQLrm:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  97341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDQLrm),
     /*  97344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97346 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  97348 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97352 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97359 */     GIR_RootConstrainSelectedInstOperands,
     /*  97360 */     // GIR_Coverage, 23342,
     /*  97360 */     GIR_EraseRootFromParent_Done,
     /*  97361 */   // Label 2070: @97361
     /*  97361 */   GIM_Try, /*On fail goto*//*Label 2071*/ GIMT_Encode4(97446), // Rule ID 23343 //
     /*  97366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdqh),
     /*  97374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  97377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  97380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  97386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97398 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97401 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97405 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97419 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97426 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15062:{ *:[iPTR] }, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSSDQHrm:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  97426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDQHrm),
     /*  97429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97431 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  97433 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97437 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97439 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97444 */     GIR_RootConstrainSelectedInstOperands,
     /*  97445 */     // GIR_Coverage, 23343,
     /*  97445 */     GIR_EraseRootFromParent_Done,
     /*  97446 */   // Label 2071: @97446
     /*  97446 */   GIM_Try, /*On fail goto*//*Label 2072*/ GIMT_Encode4(97531), // Rule ID 23344 //
     /*  97451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdd),
     /*  97459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  97465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  97471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97483 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97486 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97490 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97502 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97504 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97511 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15061:{ *:[iPTR] }, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSSDDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  97511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDDrm),
     /*  97514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97516 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  97518 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97522 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97524 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97529 */     GIR_RootConstrainSelectedInstOperands,
     /*  97530 */     // GIR_Coverage, 23344,
     /*  97530 */     GIR_EraseRootFromParent_Done,
     /*  97531 */   // Label 2072: @97531
     /*  97531 */   GIM_Try, /*On fail goto*//*Label 2073*/ GIMT_Encode4(97616), // Rule ID 23345 //
     /*  97536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdql),
     /*  97544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  97547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  97550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  97556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97568 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97571 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97575 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97589 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97596 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15060:{ *:[iPTR] }, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSDQLrm:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  97596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDQLrm),
     /*  97599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97601 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  97603 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97607 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97609 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97614 */     GIR_RootConstrainSelectedInstOperands,
     /*  97615 */     // GIR_Coverage, 23345,
     /*  97615 */     GIR_EraseRootFromParent_Done,
     /*  97616 */   // Label 2073: @97616
     /*  97616 */   GIM_Try, /*On fail goto*//*Label 2074*/ GIMT_Encode4(97701), // Rule ID 23346 //
     /*  97621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdqh),
     /*  97629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  97632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  97635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  97641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97653 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97656 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97660 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97674 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97681 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15059:{ *:[iPTR] }, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSDQHrm:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  97681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDQHrm),
     /*  97684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97686 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  97688 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97692 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97694 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97699 */     GIR_RootConstrainSelectedInstOperands,
     /*  97700 */     // GIR_Coverage, 23346,
     /*  97700 */     GIR_EraseRootFromParent_Done,
     /*  97701 */   // Label 2074: @97701
     /*  97701 */   GIM_Try, /*On fail goto*//*Label 2075*/ GIMT_Encode4(97786), // Rule ID 23347 //
     /*  97706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdd),
     /*  97714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  97720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  97726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97738 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97741 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97745 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97759 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97766 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15058:{ *:[iPTR] }, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSDDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  97766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDDrm),
     /*  97769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97771 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  97773 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97777 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97779 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97784 */     GIR_RootConstrainSelectedInstOperands,
     /*  97785 */     // GIR_Coverage, 23347,
     /*  97785 */     GIR_EraseRootFromParent_Done,
     /*  97786 */   // Label 2075: @97786
     /*  97786 */   GIM_Try, /*On fail goto*//*Label 2076*/ GIMT_Encode4(97871), // Rule ID 1620 //
     /*  97791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmadcswd),
     /*  97799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  97805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  97811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  97823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97827 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97830 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97834 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97842 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97844 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97851 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15069:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src3)  =>  (VPMADCSWDrm:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  97851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMADCSWDrm),
     /*  97854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97856 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  97858 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97862 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97864 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97869 */     GIR_RootConstrainSelectedInstOperands,
     /*  97870 */     // GIR_Coverage, 1620,
     /*  97870 */     GIR_EraseRootFromParent_Done,
     /*  97871 */   // Label 2076: @97871
     /*  97871 */   GIM_Try, /*On fail goto*//*Label 2077*/ GIMT_Encode4(97956), // Rule ID 1622 //
     /*  97876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmadcsswd),
     /*  97884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  97890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  97896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  97908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97912 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97915 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97919 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97929 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97936 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15068:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src3)  =>  (VPMADCSSWDrm:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  97936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMADCSSWDrm),
     /*  97939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97941 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  97943 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97947 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97949 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97954 */     GIR_RootConstrainSelectedInstOperands,
     /*  97955 */     // GIR_Coverage, 1622,
     /*  97955 */     GIR_EraseRootFromParent_Done,
     /*  97956 */   // Label 2077: @97956
     /*  97956 */   GIM_Try, /*On fail goto*//*Label 2078*/ GIMT_Encode4(98041), // Rule ID 1624 //
     /*  97961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsww),
     /*  97969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  97972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  97975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  97981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  97993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97997 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98000 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98004 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98014 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98021 */     // (intrinsic_wo_chain:{ *:[v8i16] } 15067:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src3)  =>  (VPMACSWWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /*  98021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWWrm),
     /*  98024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98026 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98028 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  98032 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98034 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98039 */     GIR_RootConstrainSelectedInstOperands,
     /*  98040 */     // GIR_Coverage, 1624,
     /*  98040 */     GIR_EraseRootFromParent_Done,
     /*  98041 */   // Label 2078: @98041
     /*  98041 */   GIM_Try, /*On fail goto*//*Label 2079*/ GIMT_Encode4(98126), // Rule ID 1626 //
     /*  98046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  98049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacswd),
     /*  98054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  98060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  98063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  98066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  98078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  98082 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98085 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98089 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98099 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98106 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15066:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSWDrm:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  98106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWDrm),
     /*  98109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98111 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98113 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  98117 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98119 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98124 */     GIR_RootConstrainSelectedInstOperands,
     /*  98125 */     // GIR_Coverage, 1626,
     /*  98125 */     GIR_EraseRootFromParent_Done,
     /*  98126 */   // Label 2079: @98126
     /*  98126 */   GIM_Try, /*On fail goto*//*Label 2080*/ GIMT_Encode4(98211), // Rule ID 1628 //
     /*  98131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  98134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssww),
     /*  98139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  98142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  98145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  98148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  98151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  98163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  98167 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98170 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98174 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98184 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98191 */     // (intrinsic_wo_chain:{ *:[v8i16] } 15065:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src3)  =>  (VPMACSSWWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /*  98191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSWWrm),
     /*  98194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98196 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98198 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  98202 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98204 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98209 */     GIR_RootConstrainSelectedInstOperands,
     /*  98210 */     // GIR_Coverage, 1628,
     /*  98210 */     GIR_EraseRootFromParent_Done,
     /*  98211 */   // Label 2080: @98211
     /*  98211 */   GIM_Try, /*On fail goto*//*Label 2081*/ GIMT_Encode4(98296), // Rule ID 1630 //
     /*  98216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  98219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsswd),
     /*  98224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  98230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  98233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  98236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  98248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  98252 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98255 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98259 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98269 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98276 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15064:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSSWDrm:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  98276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSWDrm),
     /*  98279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98281 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98283 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  98287 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98289 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98294 */     GIR_RootConstrainSelectedInstOperands,
     /*  98295 */     // GIR_Coverage, 1630,
     /*  98295 */     GIR_EraseRootFromParent_Done,
     /*  98296 */   // Label 2081: @98296
     /*  98296 */   GIM_Try, /*On fail goto*//*Label 2082*/ GIMT_Encode4(98381), // Rule ID 1632 //
     /*  98301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  98304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdql),
     /*  98309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  98315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  98321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  98333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  98337 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98340 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98344 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98354 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98361 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15063:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSSDQLrm:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  98361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDQLrm),
     /*  98364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98366 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98368 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  98372 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98374 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98379 */     GIR_RootConstrainSelectedInstOperands,
     /*  98380 */     // GIR_Coverage, 1632,
     /*  98380 */     GIR_EraseRootFromParent_Done,
     /*  98381 */   // Label 2082: @98381
     /*  98381 */   GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(98466), // Rule ID 1634 //
     /*  98386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  98389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdqh),
     /*  98394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  98400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  98406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  98418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  98422 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98425 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98429 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98439 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98446 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15062:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSSDQHrm:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  98446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDQHrm),
     /*  98449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98451 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98453 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  98457 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98459 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98464 */     GIR_RootConstrainSelectedInstOperands,
     /*  98465 */     // GIR_Coverage, 1634,
     /*  98465 */     GIR_EraseRootFromParent_Done,
     /*  98466 */   // Label 2083: @98466
     /*  98466 */   GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(98551), // Rule ID 1636 //
     /*  98471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  98474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdd),
     /*  98479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  98485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  98491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  98503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  98507 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98510 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98514 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98522 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98524 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98531 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15061:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSSDDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  98531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDDrm),
     /*  98534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98536 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98538 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  98542 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98544 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98549 */     GIR_RootConstrainSelectedInstOperands,
     /*  98550 */     // GIR_Coverage, 1636,
     /*  98550 */     GIR_EraseRootFromParent_Done,
     /*  98551 */   // Label 2084: @98551
     /*  98551 */   GIM_Try, /*On fail goto*//*Label 2085*/ GIMT_Encode4(98636), // Rule ID 1638 //
     /*  98556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  98559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdql),
     /*  98564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  98570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  98576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  98588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  98592 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98595 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98599 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98609 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98616 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15060:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSDQLrm:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  98616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDQLrm),
     /*  98619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98621 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98623 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  98627 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98629 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98634 */     GIR_RootConstrainSelectedInstOperands,
     /*  98635 */     // GIR_Coverage, 1638,
     /*  98635 */     GIR_EraseRootFromParent_Done,
     /*  98636 */   // Label 2085: @98636
     /*  98636 */   GIM_Try, /*On fail goto*//*Label 2086*/ GIMT_Encode4(98721), // Rule ID 1640 //
     /*  98641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  98644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdqh),
     /*  98649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  98655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  98661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  98673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  98677 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98680 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98684 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98694 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98701 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15059:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSDQHrm:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  98701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDQHrm),
     /*  98704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98706 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98708 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  98712 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98714 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98719 */     GIR_RootConstrainSelectedInstOperands,
     /*  98720 */     // GIR_Coverage, 1640,
     /*  98720 */     GIR_EraseRootFromParent_Done,
     /*  98721 */   // Label 2086: @98721
     /*  98721 */   GIM_Try, /*On fail goto*//*Label 2087*/ GIMT_Encode4(98806), // Rule ID 1642 //
     /*  98726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  98729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdd),
     /*  98734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  98740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  98746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  98758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  98762 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98765 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98769 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98779 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98786 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15058:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSDDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  98786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDDrm),
     /*  98789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98791 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98793 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  98797 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98799 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98804 */     GIR_RootConstrainSelectedInstOperands,
     /*  98805 */     // GIR_Coverage, 1642,
     /*  98805 */     GIR_EraseRootFromParent_Done,
     /*  98806 */   // Label 2087: @98806
     /*  98806 */   GIM_Try, /*On fail goto*//*Label 2088*/ GIMT_Encode4(98891), // Rule ID 3559 //
     /*  98811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM3),
     /*  98814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm3msg1),
     /*  98819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  98825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  98831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  98847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  98851 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98854 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98858 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98862 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98864 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98871 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15009:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM3MSG1rm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /*  98871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM3MSG1rm),
     /*  98874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98876 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98878 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  98880 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /*  98884 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98889 */     GIR_RootConstrainSelectedInstOperands,
     /*  98890 */     // GIR_Coverage, 3559,
     /*  98890 */     GIR_EraseRootFromParent_Done,
     /*  98891 */   // Label 2088: @98891
     /*  98891 */   GIM_Try, /*On fail goto*//*Label 2089*/ GIMT_Encode4(98976), // Rule ID 3561 //
     /*  98896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM3),
     /*  98899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm3msg2),
     /*  98904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  98910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  98916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  98932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  98936 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98939 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98943 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98949 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98956 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15010:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM3MSG2rm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /*  98956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM3MSG2rm),
     /*  98959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98961 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98963 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  98965 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /*  98969 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98974 */     GIR_RootConstrainSelectedInstOperands,
     /*  98975 */     // GIR_Coverage, 3561,
     /*  98975 */     GIR_EraseRootFromParent_Done,
     /*  98976 */   // Label 2089: @98976
     /*  98976 */   GIM_Try, /*On fail goto*//*Label 2090*/ GIMT_Encode4(99026), // Rule ID 3253 //
     /*  98981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  98984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dpps),
     /*  98989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  98995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99010 */     // MIs[0] src3
     /*  99010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99013 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14824:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VDPPSrri:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  99013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPSrri),
     /*  99016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99018 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99020 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99022 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99024 */     GIR_RootConstrainSelectedInstOperands,
     /*  99025 */     // GIR_Coverage, 3253,
     /*  99025 */     GIR_EraseRootFromParent_Done,
     /*  99026 */   // Label 2090: @99026
     /*  99026 */   GIM_Try, /*On fail goto*//*Label 2091*/ GIMT_Encode4(99076), // Rule ID 3255 //
     /*  99031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  99034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dppd),
     /*  99039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  99042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  99045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  99048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99060 */     // MIs[0] src3
     /*  99060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99063 */     // (intrinsic_wo_chain:{ *:[v2f64] } 14823:{ *:[iPTR] }, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VDPPDrri:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  99063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPDrri),
     /*  99066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99068 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99070 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99072 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99074 */     GIR_RootConstrainSelectedInstOperands,
     /*  99075 */     // GIR_Coverage, 3255,
     /*  99075 */     GIR_EraseRootFromParent_Done,
     /*  99076 */   // Label 2091: @99076
     /*  99076 */   GIM_Try, /*On fail goto*//*Label 2092*/ GIMT_Encode4(99126), // Rule ID 3257 //
     /*  99081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  99084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx_dp_ps_256),
     /*  99089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  99092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  99095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  99098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  99102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  99106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  99110 */     // MIs[0] src3
     /*  99110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99113 */     // (intrinsic_wo_chain:{ *:[v8f32] } 13434:{ *:[iPTR] }, VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VDPPSYrri:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  99113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPSYrri),
     /*  99116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99118 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99120 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99122 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99124 */     GIR_RootConstrainSelectedInstOperands,
     /*  99125 */     // GIR_Coverage, 3257,
     /*  99125 */     GIR_EraseRootFromParent_Done,
     /*  99126 */   // Label 2092: @99126
     /*  99126 */   GIM_Try, /*On fail goto*//*Label 2093*/ GIMT_Encode4(99176), // Rule ID 3263 //
     /*  99131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /*  99134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dpps),
     /*  99139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  99142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  99145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  99148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99160 */     // MIs[0] src3
     /*  99160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99163 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14824:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (DPPSrri:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  99163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DPPSrri),
     /*  99166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99168 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99170 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99172 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99174 */     GIR_RootConstrainSelectedInstOperands,
     /*  99175 */     // GIR_Coverage, 3263,
     /*  99175 */     GIR_EraseRootFromParent_Done,
     /*  99176 */   // Label 2093: @99176
     /*  99176 */   GIM_Try, /*On fail goto*//*Label 2094*/ GIMT_Encode4(99226), // Rule ID 3265 //
     /*  99181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /*  99184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dppd),
     /*  99189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  99192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  99195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  99198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99210 */     // MIs[0] src3
     /*  99210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99213 */     // (intrinsic_wo_chain:{ *:[v2f64] } 14823:{ *:[iPTR] }, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (DPPDrri:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  99213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DPPDrri),
     /*  99216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99218 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99220 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99222 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99224 */     GIR_RootConstrainSelectedInstOperands,
     /*  99225 */     // GIR_Coverage, 3265,
     /*  99225 */     GIR_EraseRootFromParent_Done,
     /*  99226 */   // Label 2094: @99226
     /*  99226 */   GIM_Try, /*On fail goto*//*Label 2095*/ GIMT_Encode4(99276), // Rule ID 3325 //
     /*  99231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /*  99234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha1rnds4),
     /*  99239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  99242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  99245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  99248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99260 */     // MIs[0] src3
     /*  99260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99263 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14710:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (SHA1RNDS4rri:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  99263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA1RNDS4rri),
     /*  99266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99268 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99270 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99272 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99274 */     GIR_RootConstrainSelectedInstOperands,
     /*  99275 */     // GIR_Coverage, 3325,
     /*  99275 */     GIR_EraseRootFromParent_Done,
     /*  99276 */   // Label 2095: @99276
     /*  99276 */   GIM_Try, /*On fail goto*//*Label 2096*/ GIMT_Encode4(99326), // Rule ID 3371 //
     /*  99281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPCLMUL_NoAVX),
     /*  99284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq),
     /*  99289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  99292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  99295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  99298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99310 */     // MIs[0] src3
     /*  99310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99313 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14675:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (PCLMULQDQrri:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  99313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PCLMULQDQrri),
     /*  99316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99318 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99320 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99322 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99324 */     GIR_RootConstrainSelectedInstOperands,
     /*  99325 */     // GIR_Coverage, 3371,
     /*  99325 */     GIR_EraseRootFromParent_Done,
     /*  99326 */   // Label 2096: @99326
     /*  99326 */   GIM_Try, /*On fail goto*//*Label 2097*/ GIMT_Encode4(99376), // Rule ID 3373 //
     /*  99331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_HasPCLMUL_NoVLX_Or_NoVPCLMULQDQ),
     /*  99334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq),
     /*  99339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  99342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  99345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  99348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99360 */     // MIs[0] src3
     /*  99360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99363 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14675:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQrri:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  99363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQrri),
     /*  99366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99368 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99370 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99372 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99374 */     GIR_RootConstrainSelectedInstOperands,
     /*  99375 */     // GIR_Coverage, 3373,
     /*  99375 */     GIR_EraseRootFromParent_Done,
     /*  99376 */   // Label 2097: @99376
     /*  99376 */   GIM_Try, /*On fail goto*//*Label 2098*/ GIMT_Encode4(99426), // Rule ID 3375 //
     /*  99381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVPCLMULQDQ_NoVLX),
     /*  99384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq_256),
     /*  99389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  99392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  99395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  99398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  99402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  99406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  99410 */     // MIs[0] src3
     /*  99410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99413 */     // (intrinsic_wo_chain:{ *:[v4i64] } 14676:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQYrri:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  99413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQYrri),
     /*  99416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99418 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99420 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99422 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99424 */     GIR_RootConstrainSelectedInstOperands,
     /*  99425 */     // GIR_Coverage, 3375,
     /*  99425 */     GIR_EraseRootFromParent_Done,
     /*  99426 */   // Label 2098: @99426
     /*  99426 */   GIM_Try, /*On fail goto*//*Label 2099*/ GIMT_Encode4(99476), // Rule ID 14084 //
     /*  99431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVPCLMULQDQ),
     /*  99434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq_512),
     /*  99439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  99442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  99445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  99448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  99452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  99456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  99460 */     // MIs[0] src3
     /*  99460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99463 */     // (intrinsic_wo_chain:{ *:[v8i64] } 14677:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQZrri:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  99463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQZrri),
     /*  99466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99468 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99470 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99472 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99474 */     GIR_RootConstrainSelectedInstOperands,
     /*  99475 */     // GIR_Coverage, 14084,
     /*  99475 */     GIR_EraseRootFromParent_Done,
     /*  99476 */   // Label 2099: @99476
     /*  99476 */   GIM_Try, /*On fail goto*//*Label 2100*/ GIMT_Encode4(99526), // Rule ID 14086 //
     /*  99481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPCLMULQDQ),
     /*  99484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq),
     /*  99489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  99492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  99495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  99498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  99502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  99506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  99510 */     // MIs[0] src3
     /*  99510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99513 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14675:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQZ128rri:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  99513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQZ128rri),
     /*  99516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99518 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99520 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99522 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99524 */     GIR_RootConstrainSelectedInstOperands,
     /*  99525 */     // GIR_Coverage, 14086,
     /*  99525 */     GIR_EraseRootFromParent_Done,
     /*  99526 */   // Label 2100: @99526
     /*  99526 */   GIM_Try, /*On fail goto*//*Label 2101*/ GIMT_Encode4(99576), // Rule ID 14088 //
     /*  99531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPCLMULQDQ),
     /*  99534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq_256),
     /*  99539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  99542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  99545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  99548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  99552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  99556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  99560 */     // MIs[0] src3
     /*  99560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99563 */     // (intrinsic_wo_chain:{ *:[v4i64] } 14676:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQZ256rri:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  99563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQZ256rri),
     /*  99566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99568 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99570 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99572 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99574 */     GIR_RootConstrainSelectedInstOperands,
     /*  99575 */     // GIR_Coverage, 14088,
     /*  99575 */     GIR_EraseRootFromParent_Done,
     /*  99576 */   // Label 2101: @99576
     /*  99576 */   GIM_Try, /*On fail goto*//*Label 2102*/ GIMT_Encode4(99630), // Rule ID 1619 //
     /*  99581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmadcswd),
     /*  99589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  99592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  99595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  99598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  99601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99617 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15069:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VPMADCSWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  99617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMADCSWDrr),
     /*  99620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99622 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99624 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99626 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99628 */     GIR_RootConstrainSelectedInstOperands,
     /*  99629 */     // GIR_Coverage, 1619,
     /*  99629 */     GIR_EraseRootFromParent_Done,
     /*  99630 */   // Label 2102: @99630
     /*  99630 */   GIM_Try, /*On fail goto*//*Label 2103*/ GIMT_Encode4(99684), // Rule ID 1621 //
     /*  99635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmadcsswd),
     /*  99643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  99646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  99649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  99652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  99655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99671 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15068:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VPMADCSSWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  99671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMADCSSWDrr),
     /*  99674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99676 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99678 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99680 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99682 */     GIR_RootConstrainSelectedInstOperands,
     /*  99683 */     // GIR_Coverage, 1621,
     /*  99683 */     GIR_EraseRootFromParent_Done,
     /*  99684 */   // Label 2103: @99684
     /*  99684 */   GIM_Try, /*On fail goto*//*Label 2104*/ GIMT_Encode4(99738), // Rule ID 1623 //
     /*  99689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsww),
     /*  99697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  99700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  99703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  99706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  99709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99725 */     // (intrinsic_wo_chain:{ *:[v8i16] } 15067:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v8i16] }:$src3)  =>  (VPMACSWWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /*  99725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWWrr),
     /*  99728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99730 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99732 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99734 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99736 */     GIR_RootConstrainSelectedInstOperands,
     /*  99737 */     // GIR_Coverage, 1623,
     /*  99737 */     GIR_EraseRootFromParent_Done,
     /*  99738 */   // Label 2104: @99738
     /*  99738 */   GIM_Try, /*On fail goto*//*Label 2105*/ GIMT_Encode4(99792), // Rule ID 1625 //
     /*  99743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacswd),
     /*  99751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  99754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  99757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  99760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  99763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99779 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15066:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  99779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWDrr),
     /*  99782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99784 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99786 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99788 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99790 */     GIR_RootConstrainSelectedInstOperands,
     /*  99791 */     // GIR_Coverage, 1625,
     /*  99791 */     GIR_EraseRootFromParent_Done,
     /*  99792 */   // Label 2105: @99792
     /*  99792 */   GIM_Try, /*On fail goto*//*Label 2106*/ GIMT_Encode4(99846), // Rule ID 1627 //
     /*  99797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssww),
     /*  99805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  99808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  99811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  99814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  99817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99833 */     // (intrinsic_wo_chain:{ *:[v8i16] } 15065:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v8i16] }:$src3)  =>  (VPMACSSWWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /*  99833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSWWrr),
     /*  99836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99838 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99840 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99842 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99844 */     GIR_RootConstrainSelectedInstOperands,
     /*  99845 */     // GIR_Coverage, 1627,
     /*  99845 */     GIR_EraseRootFromParent_Done,
     /*  99846 */   // Label 2106: @99846
     /*  99846 */   GIM_Try, /*On fail goto*//*Label 2107*/ GIMT_Encode4(99900), // Rule ID 1629 //
     /*  99851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsswd),
     /*  99859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  99862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  99865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  99868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  99871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99887 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15064:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSSWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  99887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSWDrr),
     /*  99890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99892 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99894 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99896 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99898 */     GIR_RootConstrainSelectedInstOperands,
     /*  99899 */     // GIR_Coverage, 1629,
     /*  99899 */     GIR_EraseRootFromParent_Done,
     /*  99900 */   // Label 2107: @99900
     /*  99900 */   GIM_Try, /*On fail goto*//*Label 2108*/ GIMT_Encode4(99954), // Rule ID 1631 //
     /*  99905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdql),
     /*  99913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  99916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  99919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  99922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  99925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99941 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15063:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSSDQLrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  99941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDQLrr),
     /*  99944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99946 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99948 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99950 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99952 */     GIR_RootConstrainSelectedInstOperands,
     /*  99953 */     // GIR_Coverage, 1631,
     /*  99953 */     GIR_EraseRootFromParent_Done,
     /*  99954 */   // Label 2108: @99954
     /*  99954 */   GIM_Try, /*On fail goto*//*Label 2109*/ GIMT_Encode4(100008), // Rule ID 1633 //
     /*  99959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdqh),
     /*  99967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  99970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  99973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  99976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  99979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99995 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15062:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSSDQHrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  99995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDQHrr),
     /*  99998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100000 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 100002 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 100004 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 100006 */     GIR_RootConstrainSelectedInstOperands,
     /* 100007 */     // GIR_Coverage, 1633,
     /* 100007 */     GIR_EraseRootFromParent_Done,
     /* 100008 */   // Label 2109: @100008
     /* 100008 */   GIM_Try, /*On fail goto*//*Label 2110*/ GIMT_Encode4(100062), // Rule ID 1635 //
     /* 100013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 100016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdd),
     /* 100021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 100024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 100027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 100030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 100033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100049 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15061:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSSDDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /* 100049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDDrr),
     /* 100052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100054 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 100056 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 100058 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 100060 */     GIR_RootConstrainSelectedInstOperands,
     /* 100061 */     // GIR_Coverage, 1635,
     /* 100061 */     GIR_EraseRootFromParent_Done,
     /* 100062 */   // Label 2110: @100062
     /* 100062 */   GIM_Try, /*On fail goto*//*Label 2111*/ GIMT_Encode4(100116), // Rule ID 1637 //
     /* 100067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 100070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdql),
     /* 100075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 100078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 100081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 100084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 100087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100103 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15060:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSDQLrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /* 100103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDQLrr),
     /* 100106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100108 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 100110 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 100112 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 100114 */     GIR_RootConstrainSelectedInstOperands,
     /* 100115 */     // GIR_Coverage, 1637,
     /* 100115 */     GIR_EraseRootFromParent_Done,
     /* 100116 */   // Label 2111: @100116
     /* 100116 */   GIM_Try, /*On fail goto*//*Label 2112*/ GIMT_Encode4(100170), // Rule ID 1639 //
     /* 100121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 100124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdqh),
     /* 100129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 100132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 100135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 100138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 100141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100157 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15059:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSDQHrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /* 100157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDQHrr),
     /* 100160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100162 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 100164 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 100166 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 100168 */     GIR_RootConstrainSelectedInstOperands,
     /* 100169 */     // GIR_Coverage, 1639,
     /* 100169 */     GIR_EraseRootFromParent_Done,
     /* 100170 */   // Label 2112: @100170
     /* 100170 */   GIM_Try, /*On fail goto*//*Label 2113*/ GIMT_Encode4(100224), // Rule ID 1641 //
     /* 100175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 100178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdd),
     /* 100183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 100186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 100189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 100192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 100195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100211 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15058:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSDDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /* 100211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDDrr),
     /* 100214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100216 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 100218 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 100220 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 100222 */     GIR_RootConstrainSelectedInstOperands,
     /* 100223 */     // GIR_Coverage, 1641,
     /* 100223 */     GIR_EraseRootFromParent_Done,
     /* 100224 */   // Label 2113: @100224
     /* 100224 */   GIM_Try, /*On fail goto*//*Label 2114*/ GIMT_Encode4(100290), // Rule ID 3333 //
     /* 100229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /* 100232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha256rnds2),
     /* 100237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 100240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 100243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 100246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 100249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100265 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14713:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, XMM0:{ *:[v4i32] })  =>  (SHA256RNDS2rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 100265 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 100269 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::XMM0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100275 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XMM0
     /* 100279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA256RNDS2rr),
     /* 100282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100284 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 100286 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 100288 */     GIR_RootConstrainSelectedInstOperands,
     /* 100289 */     // GIR_Coverage, 3333,
     /* 100289 */     GIR_EraseRootFromParent_Done,
     /* 100290 */   // Label 2114: @100290
     /* 100290 */   GIM_Try, /*On fail goto*//*Label 2115*/ GIMT_Encode4(100344), // Rule ID 3557 //
     /* 100295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA512),
     /* 100298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsha512rnds2),
     /* 100303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 100306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 100309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 100312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 100315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 100319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 100323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 100327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100331 */     // (intrinsic_wo_chain:{ *:[v4i64] } 15008:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2, VR128:{ *:[v2i64] }:$src3)  =>  (VSHA512RNDS2rr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /* 100331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSHA512RNDS2rr),
     /* 100334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100336 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 100338 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 100340 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 100342 */     GIR_RootConstrainSelectedInstOperands,
     /* 100343 */     // GIR_Coverage, 3557,
     /* 100343 */     GIR_EraseRootFromParent_Done,
     /* 100344 */   // Label 2115: @100344
     /* 100344 */   GIM_Try, /*On fail goto*//*Label 2116*/ GIMT_Encode4(100398), // Rule ID 3558 //
     /* 100349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM3),
     /* 100352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm3msg1),
     /* 100357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 100360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 100363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 100366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 100369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100385 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15009:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VSM3MSG1rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /* 100385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM3MSG1rr),
     /* 100388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100390 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 100392 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 100394 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 100396 */     GIR_RootConstrainSelectedInstOperands,
     /* 100397 */     // GIR_Coverage, 3558,
     /* 100397 */     GIR_EraseRootFromParent_Done,
     /* 100398 */   // Label 2116: @100398
     /* 100398 */   GIM_Try, /*On fail goto*//*Label 2117*/ GIMT_Encode4(100452), // Rule ID 3560 //
     /* 100403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM3),
     /* 100406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm3msg2),
     /* 100411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 100414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 100417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 100420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 100423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100439 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15010:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VSM3MSG2rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /* 100439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM3MSG2rr),
     /* 100442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100444 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 100446 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 100448 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 100450 */     GIR_RootConstrainSelectedInstOperands,
     /* 100451 */     // GIR_Coverage, 3560,
     /* 100451 */     GIR_EraseRootFromParent_Done,
     /* 100452 */   // Label 2117: @100452
     /* 100452 */   GIM_Reject,
     /* 100453 */ // Label 2052: @100453
     /* 100453 */ GIM_Try, /*On fail goto*//*Label 2118*/ GIMT_Encode4(100582),
     /* 100458 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 100461 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm3rnds2),
     /* 100466 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 100469 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 100472 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 100475 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 100478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100482 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100486 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100490 */   GIM_Try, /*On fail goto*//*Label 2119*/ GIMT_Encode4(100551), // Rule ID 3563 //
     /* 100495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM3),
     /* 100498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 100502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 100506 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100509 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 100513 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 100517 */     // MIs[0] src4
     /* 100517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 100520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100522 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 100529 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15011:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i32] }):$src4)  =>  (VSM3RNDS2rmi:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, addr:{ *:[iPTR] }:$src3, (timm:{ *:[i32] }):$src4)
     /* 100529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM3RNDS2rmi),
     /* 100532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100534 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 100536 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 100538 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 100542 */     GIR_RootToRootCopy, /*OpIdx*/5, // src4
     /* 100544 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 100549 */     GIR_RootConstrainSelectedInstOperands,
     /* 100550 */     // GIR_Coverage, 3563,
     /* 100550 */     GIR_EraseRootFromParent_Done,
     /* 100551 */   // Label 2119: @100551
     /* 100551 */   GIM_Try, /*On fail goto*//*Label 2120*/ GIMT_Encode4(100581), // Rule ID 3562 //
     /* 100556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM3),
     /* 100559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100563 */     // MIs[0] src4
     /* 100563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 100566 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15011:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3, (timm:{ *:[i32] }):$src4)  =>  (VSM3RNDS2rri:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3, (timm:{ *:[i32] }):$src4)
     /* 100566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM3RNDS2rri),
     /* 100569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100571 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 100573 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 100575 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 100577 */     GIR_RootToRootCopy, /*OpIdx*/5, // src4
     /* 100579 */     GIR_RootConstrainSelectedInstOperands,
     /* 100580 */     // GIR_Coverage, 3562,
     /* 100580 */     GIR_EraseRootFromParent_Done,
     /* 100581 */   // Label 2120: @100581
     /* 100581 */   GIM_Reject,
     /* 100582 */ // Label 2118: @100582
     /* 100582 */ GIM_Reject,
     /* 100583 */ // Label 18: @100583
     /* 100583 */ GIM_Try, /*On fail goto*//*Label 2121*/ GIMT_Encode4(101142),
     /* 100588 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
     /* 100591 */   GIM_Try, /*On fail goto*//*Label 2122*/ GIMT_Encode4(100613), // Rule ID 149 //
     /* 100596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSERIALIZE),
     /* 100599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_serialize),
     /* 100604 */     // (intrinsic_void 14705:{ *:[iPTR] })  =>  (SERIALIZE)
     /* 100604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SERIALIZE),
     /* 100607 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100611 */     GIR_RootConstrainSelectedInstOperands,
     /* 100612 */     // GIR_Coverage, 149,
     /* 100612 */     GIR_EraseRootFromParent_Done,
     /* 100613 */   // Label 2122: @100613
     /* 100613 */   GIM_Try, /*On fail goto*//*Label 2123*/ GIMT_Encode4(100635), // Rule ID 150 //
     /* 100618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTSXLDTRK),
     /* 100621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsusldtrk),
     /* 100626 */     // (intrinsic_void 15093:{ *:[iPTR] })  =>  (XSUSLDTRK)
     /* 100626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSUSLDTRK),
     /* 100629 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100633 */     GIR_RootConstrainSelectedInstOperands,
     /* 100634 */     // GIR_Coverage, 150,
     /* 100634 */     GIR_EraseRootFromParent_Done,
     /* 100635 */   // Label 2123: @100635
     /* 100635 */   GIM_Try, /*On fail goto*//*Label 2124*/ GIMT_Encode4(100657), // Rule ID 151 //
     /* 100640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTSXLDTRK),
     /* 100643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xresldtrk),
     /* 100648 */     // (intrinsic_void 15079:{ *:[iPTR] })  =>  (XRESLDTRK)
     /* 100648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XRESLDTRK),
     /* 100651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100655 */     GIR_RootConstrainSelectedInstOperands,
     /* 100656 */     // GIR_Coverage, 151,
     /* 100656 */     GIR_EraseRootFromParent_Done,
     /* 100657 */   // Label 2124: @100657
     /* 100657 */   GIM_Try, /*On fail goto*//*Label 2125*/ GIMT_Encode4(100679), // Rule ID 152 //
     /* 100662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUINTR_In64BitMode),
     /* 100665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_clui),
     /* 100670 */     // (intrinsic_void 14563:{ *:[iPTR] })  =>  (CLUI)
     /* 100670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CLUI),
     /* 100673 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100677 */     GIR_RootConstrainSelectedInstOperands,
     /* 100678 */     // GIR_Coverage, 152,
     /* 100678 */     GIR_EraseRootFromParent_Done,
     /* 100679 */   // Label 2125: @100679
     /* 100679 */   GIM_Try, /*On fail goto*//*Label 2126*/ GIMT_Encode4(100701), // Rule ID 153 //
     /* 100684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUINTR_In64BitMode),
     /* 100687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_stui),
     /* 100692 */     // (intrinsic_void 14887:{ *:[iPTR] })  =>  (STUI)
     /* 100692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::STUI),
     /* 100695 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100699 */     GIR_RootConstrainSelectedInstOperands,
     /* 100700 */     // GIR_Coverage, 153,
     /* 100700 */     GIR_EraseRootFromParent_Done,
     /* 100701 */   // Label 2126: @100701
     /* 100701 */   GIM_Try, /*On fail goto*//*Label 2127*/ GIMT_Encode4(100720), // Rule ID 2510 //
     /* 100706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_pause),
     /* 100711 */     // (intrinsic_void 14782:{ *:[iPTR] })  =>  (PAUSE)
     /* 100711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PAUSE),
     /* 100714 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100718 */     GIR_RootConstrainSelectedInstOperands,
     /* 100719 */     // GIR_Coverage, 2510,
     /* 100719 */     GIR_EraseRootFromParent_Done,
     /* 100720 */   // Label 2127: @100720
     /* 100720 */   GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(100742), // Rule ID 2511 //
     /* 100725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE1),
     /* 100728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse_sfence),
     /* 100733 */     // (intrinsic_void 14744:{ *:[iPTR] })  =>  (SFENCE)
     /* 100733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SFENCE),
     /* 100736 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100740 */     GIR_RootConstrainSelectedInstOperands,
     /* 100741 */     // GIR_Coverage, 2511,
     /* 100741 */     GIR_EraseRootFromParent_Done,
     /* 100742 */   // Label 2128: @100742
     /* 100742 */   GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(100764), // Rule ID 2512 //
     /* 100747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE2),
     /* 100750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_lfence),
     /* 100755 */     // (intrinsic_void 14771:{ *:[iPTR] })  =>  (LFENCE)
     /* 100755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LFENCE),
     /* 100758 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100762 */     GIR_RootConstrainSelectedInstOperands,
     /* 100763 */     // GIR_Coverage, 2512,
     /* 100763 */     GIR_EraseRootFromParent_Done,
     /* 100764 */   // Label 2129: @100764
     /* 100764 */   GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(100786), // Rule ID 2513 //
     /* 100769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMFence),
     /* 100772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_mfence),
     /* 100777 */     // (intrinsic_void 14775:{ *:[iPTR] })  =>  (MFENCE)
     /* 100777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MFENCE),
     /* 100780 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100784 */     GIR_RootConstrainSelectedInstOperands,
     /* 100785 */     // GIR_Coverage, 2513,
     /* 100785 */     GIR_EraseRootFromParent_Done,
     /* 100786 */   // Label 2130: @100786
     /* 100786 */   GIM_Try, /*On fail goto*//*Label 2131*/ GIMT_Encode4(100852), // Rule ID 3427 //
     /* 100791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 100794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx_vzeroall),
     /* 100799 */     // (intrinsic_void 13477:{ *:[iPTR] })  =>  (VZEROALL)
     /* 100799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VZEROALL),
     /* 100802 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM0*/0,
     /* 100805 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM1*/1,
     /* 100808 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM2*/2,
     /* 100811 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM3*/3,
     /* 100814 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM4*/4,
     /* 100817 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM5*/5,
     /* 100820 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM6*/6,
     /* 100823 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM7*/7,
     /* 100826 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM8*/8,
     /* 100829 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM9*/9,
     /* 100832 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM10*/10,
     /* 100835 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM11*/11,
     /* 100838 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM12*/12,
     /* 100841 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM13*/13,
     /* 100844 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM14*/14,
     /* 100847 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM15*/15,
     /* 100850 */     GIR_RootConstrainSelectedInstOperands,
     /* 100851 */     // GIR_Coverage, 3427,
     /* 100851 */     GIR_EraseRootFromParent_Done,
     /* 100852 */   // Label 2131: @100852
     /* 100852 */   GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(100918), // Rule ID 3428 //
     /* 100857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 100860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx_vzeroupper),
     /* 100865 */     // (intrinsic_void 13478:{ *:[iPTR] })  =>  (VZEROUPPER)
     /* 100865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VZEROUPPER),
     /* 100868 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM0*/0,
     /* 100871 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM1*/1,
     /* 100874 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM2*/2,
     /* 100877 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM3*/3,
     /* 100880 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM4*/4,
     /* 100883 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM5*/5,
     /* 100886 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM6*/6,
     /* 100889 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM7*/7,
     /* 100892 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM8*/8,
     /* 100895 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM9*/9,
     /* 100898 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM10*/10,
     /* 100901 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM11*/11,
     /* 100904 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM12*/12,
     /* 100907 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM13*/13,
     /* 100910 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM14*/14,
     /* 100913 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM15*/15,
     /* 100916 */     GIR_RootConstrainSelectedInstOperands,
     /* 100917 */     // GIR_Coverage, 3428,
     /* 100917 */     GIR_EraseRootFromParent_Done,
     /* 100918 */   // Label 2132: @100918
     /* 100918 */   GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(100988), // Rule ID 16802 //
     /* 100923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMMX),
     /* 100926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_mmx_emms),
     /* 100931 */     // (intrinsic_void 14598:{ *:[iPTR] })  =>  (MMX_EMMS:{ *:[x86mmx] })
     /* 100931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MMX_EMMS),
     /* 100934 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM0*/0,
     /* 100937 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM1*/1,
     /* 100940 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM2*/2,
     /* 100943 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM3*/3,
     /* 100946 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM4*/4,
     /* 100949 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM5*/5,
     /* 100952 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM6*/6,
     /* 100955 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM7*/7,
     /* 100958 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST0*/8,
     /* 100961 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST1*/9,
     /* 100964 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST2*/10,
     /* 100967 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST3*/11,
     /* 100970 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST4*/12,
     /* 100973 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST5*/13,
     /* 100976 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST6*/14,
     /* 100979 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST7*/15,
     /* 100982 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100986 */     GIR_RootConstrainSelectedInstOperands,
     /* 100987 */     // GIR_Coverage, 16802,
     /* 100987 */     GIR_EraseRootFromParent_Done,
     /* 100988 */   // Label 2133: @100988
     /* 100988 */   GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(101010), // Rule ID 16985 //
     /* 100993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRTM),
     /* 100996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xend),
     /* 101001 */     // (intrinsic_void 15031:{ *:[iPTR] })  =>  (XEND)
     /* 101001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XEND),
     /* 101004 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101008 */     GIR_RootConstrainSelectedInstOperands,
     /* 101009 */     // GIR_Coverage, 16985,
     /* 101009 */     GIR_EraseRootFromParent_Done,
     /* 101010 */   // Label 2134: @101010
     /* 101010 */   GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(101056), // Rule ID 16997 //
     /* 101015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTILE_In64BitMode),
     /* 101018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tilerelease),
     /* 101023 */     // (intrinsic_void 14957:{ *:[iPTR] })  =>  (TILERELEASE:{ *:[x86amx] })
     /* 101023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TILERELEASE),
     /* 101026 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM0*/0,
     /* 101029 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM1*/1,
     /* 101032 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM2*/2,
     /* 101035 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM3*/3,
     /* 101038 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM4*/4,
     /* 101041 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM5*/5,
     /* 101044 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM6*/6,
     /* 101047 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM7*/7,
     /* 101050 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101054 */     GIR_RootConstrainSelectedInstOperands,
     /* 101055 */     // GIR_Coverage, 16997,
     /* 101055 */     GIR_EraseRootFromParent_Done,
     /* 101056 */   // Label 2135: @101056
     /* 101056 */   GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(101075), // Rule ID 17086 //
     /* 101061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wbinvd),
     /* 101066 */     // (intrinsic_void 15018:{ *:[iPTR] })  =>  (WBINVD)
     /* 101066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WBINVD),
     /* 101069 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101073 */     GIR_RootConstrainSelectedInstOperands,
     /* 101074 */     // GIR_Coverage, 17086,
     /* 101074 */     GIR_EraseRootFromParent_Done,
     /* 101075 */   // Label 2136: @101075
     /* 101075 */   GIM_Try, /*On fail goto*//*Label 2137*/ GIMT_Encode4(101097), // Rule ID 17087 //
     /* 101080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasWBNOINVD),
     /* 101083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wbnoinvd),
     /* 101088 */     // (intrinsic_void 15019:{ *:[iPTR] })  =>  (WBNOINVD)
     /* 101088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WBNOINVD),
     /* 101091 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101095 */     GIR_RootConstrainSelectedInstOperands,
     /* 101096 */     // GIR_Coverage, 17087,
     /* 101096 */     GIR_EraseRootFromParent_Done,
     /* 101097 */   // Label 2137: @101097
     /* 101097 */   GIM_Try, /*On fail goto*//*Label 2138*/ GIMT_Encode4(101119), // Rule ID 17092 //
     /* 101102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_saveprevssp),
     /* 101107 */     // (intrinsic_void 14700:{ *:[iPTR] })  =>  (SAVEPREVSSP)
     /* 101107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAVEPREVSSP),
     /* 101110 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::SSP*/0,
     /* 101113 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101117 */     GIR_RootConstrainSelectedInstOperands,
     /* 101118 */     // GIR_Coverage, 17092,
     /* 101118 */     GIR_EraseRootFromParent_Done,
     /* 101119 */   // Label 2138: @101119
     /* 101119 */   GIM_Try, /*On fail goto*//*Label 2139*/ GIMT_Encode4(101141), // Rule ID 17102 //
     /* 101124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_setssbsy),
     /* 101129 */     // (intrinsic_void 14706:{ *:[iPTR] })  =>  (SETSSBSY)
     /* 101129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SETSSBSY),
     /* 101132 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::SSP*/0,
     /* 101135 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101139 */     GIR_RootConstrainSelectedInstOperands,
     /* 101140 */     // GIR_Coverage, 17102,
     /* 101140 */     GIR_EraseRootFromParent_Done,
     /* 101141 */   // Label 2139: @101141
     /* 101141 */   GIM_Reject,
     /* 101142 */ // Label 2121: @101142
     /* 101142 */ GIM_Try, /*On fail goto*//*Label 2140*/ GIMT_Encode4(103030),
     /* 101147 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /* 101150 */   GIM_Try, /*On fail goto*//*Label 2141*/ GIMT_Encode4(101208), // Rule ID 17130 //
     /* 101155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPTWRITE_In64BitMode),
     /* 101158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ptwrite64),
     /* 101163 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 101166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 101174 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101177 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 101181 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 101185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101187 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101194 */     // (intrinsic_void 14680:{ *:[iPTR] }, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (PTWRITE64m addr:{ *:[iPTR] }:$dst)
     /* 101194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTWRITE64m),
     /* 101197 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 101201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 101206 */     GIR_RootConstrainSelectedInstOperands,
     /* 101207 */     // GIR_Coverage, 17130,
     /* 101207 */     GIR_EraseRootFromParent_Done,
     /* 101208 */   // Label 2141: @101208
     /* 101208 */   GIM_Try, /*On fail goto*//*Label 2142*/ GIMT_Encode4(101266), // Rule ID 17129 //
     /* 101213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPTWRITE),
     /* 101216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ptwrite32),
     /* 101221 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 101224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 101232 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101235 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 101239 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 101243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101245 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101252 */     // (intrinsic_void 14679:{ *:[iPTR] }, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (PTWRITEm addr:{ *:[iPTR] }:$dst)
     /* 101252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTWRITEm),
     /* 101255 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 101259 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 101264 */     GIR_RootConstrainSelectedInstOperands,
     /* 101265 */     // GIR_Coverage, 17129,
     /* 101265 */     GIR_EraseRootFromParent_Done,
     /* 101266 */   // Label 2142: @101266
     /* 101266 */   GIM_Try, /*On fail goto*//*Label 2143*/ GIMT_Encode4(101303), // Rule ID 162 //
     /* 101271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCLFLUSHOPT),
     /* 101274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_clflushopt),
     /* 101279 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101290 */     // (intrinsic_void 14561:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (CLFLUSHOPT addr:{ *:[iPTR] }:$src)
     /* 101290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CLFLUSHOPT),
     /* 101293 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101297 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101301 */     GIR_RootConstrainSelectedInstOperands,
     /* 101302 */     // GIR_Coverage, 162,
     /* 101302 */     GIR_EraseRootFromParent_Done,
     /* 101303 */   // Label 2143: @101303
     /* 101303 */   GIM_Try, /*On fail goto*//*Label 2144*/ GIMT_Encode4(101340), // Rule ID 163 //
     /* 101308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCLWB),
     /* 101311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_clwb),
     /* 101316 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101327 */     // (intrinsic_void 14564:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (CLWB addr:{ *:[iPTR] }:$src)
     /* 101327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CLWB),
     /* 101330 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101334 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101338 */     GIR_RootConstrainSelectedInstOperands,
     /* 101339 */     // GIR_Coverage, 163,
     /* 101339 */     GIR_EraseRootFromParent_Done,
     /* 101340 */   // Label 2144: @101340
     /* 101340 */   GIM_Try, /*On fail goto*//*Label 2145*/ GIMT_Encode4(101377), // Rule ID 164 //
     /* 101345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCLDEMOTE),
     /* 101348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_cldemote),
     /* 101353 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101364 */     // (intrinsic_void 14560:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (CLDEMOTE addr:{ *:[iPTR] }:$src)
     /* 101364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CLDEMOTE),
     /* 101367 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101371 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101375 */     GIR_RootConstrainSelectedInstOperands,
     /* 101376 */     // GIR_Coverage, 164,
     /* 101376 */     GIR_EraseRootFromParent_Done,
     /* 101377 */   // Label 2145: @101377
     /* 101377 */   GIM_Try, /*On fail goto*//*Label 2146*/ GIMT_Encode4(101414), // Rule ID 169 //
     /* 101382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVRS),
     /* 101385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_prefetchrs),
     /* 101390 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101401 */     // (intrinsic_void 14678:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (PREFETCHRST2 addr:{ *:[iPTR] }:$src)
     /* 101401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PREFETCHRST2),
     /* 101404 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101408 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101412 */     GIR_RootConstrainSelectedInstOperands,
     /* 101413 */     // GIR_Coverage, 169,
     /* 101413 */     GIR_EraseRootFromParent_Done,
     /* 101414 */   // Label 2146: @101414
     /* 101414 */   GIM_Try, /*On fail goto*//*Label 2147*/ GIMT_Encode4(101451), // Rule ID 1133 //
     /* 101419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFXSR),
     /* 101422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_fxsave),
     /* 101427 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101438 */     // (intrinsic_void 14584:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst)  =>  (FXSAVE addr:{ *:[iPTR] }:$dst)
     /* 101438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::FXSAVE),
     /* 101441 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 101445 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101449 */     GIR_RootConstrainSelectedInstOperands,
     /* 101450 */     // GIR_Coverage, 1133,
     /* 101450 */     GIR_EraseRootFromParent_Done,
     /* 101451 */   // Label 2147: @101451
     /* 101451 */   GIM_Try, /*On fail goto*//*Label 2148*/ GIMT_Encode4(101488), // Rule ID 1134 //
     /* 101456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFXSR_In64BitMode),
     /* 101459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_fxsave64),
     /* 101464 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101475 */     // (intrinsic_void 14585:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst)  =>  (FXSAVE64 addr:{ *:[iPTR] }:$dst)
     /* 101475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::FXSAVE64),
     /* 101478 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 101482 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101486 */     GIR_RootConstrainSelectedInstOperands,
     /* 101487 */     // GIR_Coverage, 1134,
     /* 101487 */     GIR_EraseRootFromParent_Done,
     /* 101488 */   // Label 2148: @101488
     /* 101488 */   GIM_Try, /*On fail goto*//*Label 2149*/ GIMT_Encode4(101531), // Rule ID 1135 //
     /* 101493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFXSR),
     /* 101496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_fxrstor),
     /* 101501 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101512 */     // (intrinsic_void 14582:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (FXRSTOR:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /* 101512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::FXRSTOR),
     /* 101515 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101519 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 101522 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPCW*/1,
     /* 101525 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101529 */     GIR_RootConstrainSelectedInstOperands,
     /* 101530 */     // GIR_Coverage, 1135,
     /* 101530 */     GIR_EraseRootFromParent_Done,
     /* 101531 */   // Label 2149: @101531
     /* 101531 */   GIM_Try, /*On fail goto*//*Label 2150*/ GIMT_Encode4(101574), // Rule ID 1136 //
     /* 101536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFXSR_In64BitMode),
     /* 101539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_fxrstor64),
     /* 101544 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101555 */     // (intrinsic_void 14583:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (FXRSTOR64:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /* 101555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::FXRSTOR64),
     /* 101558 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101562 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 101565 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPCW*/1,
     /* 101568 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101572 */     GIR_RootConstrainSelectedInstOperands,
     /* 101573 */     // GIR_Coverage, 1136,
     /* 101573 */     GIR_EraseRootFromParent_Done,
     /* 101574 */   // Label 2150: @101574
     /* 101574 */   GIM_Try, /*On fail goto*//*Label 2151*/ GIMT_Encode4(101611), // Rule ID 2509 //
     /* 101579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCLFLUSH),
     /* 101582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_clflush),
     /* 101587 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101598 */     // (intrinsic_void 14752:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (CLFLUSH addr:{ *:[iPTR] }:$src)
     /* 101598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CLFLUSH),
     /* 101601 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101609 */     GIR_RootConstrainSelectedInstOperands,
     /* 101610 */     // GIR_Coverage, 2509,
     /* 101610 */     GIR_EraseRootFromParent_Done,
     /* 101611 */   // Label 2151: @101611
     /* 101611 */   GIM_Try, /*On fail goto*//*Label 2152*/ GIMT_Encode4(101651), // Rule ID 2514 //
     /* 101616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 101619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse_ldmxcsr),
     /* 101624 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101635 */     // (intrinsic_void 14733:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VLDMXCSR addr:{ *:[iPTR] }:$src)
     /* 101635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VLDMXCSR),
     /* 101638 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101642 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MXCSR*/0,
     /* 101645 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101649 */     GIR_RootConstrainSelectedInstOperands,
     /* 101650 */     // GIR_Coverage, 2514,
     /* 101650 */     GIR_EraseRootFromParent_Done,
     /* 101651 */   // Label 2152: @101651
     /* 101651 */   GIM_Try, /*On fail goto*//*Label 2153*/ GIMT_Encode4(101688), // Rule ID 2515 //
     /* 101656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 101659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse_stmxcsr),
     /* 101664 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101675 */     // (intrinsic_void 14745:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst)  =>  (VSTMXCSR addr:{ *:[iPTR] }:$dst)
     /* 101675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSTMXCSR),
     /* 101678 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 101682 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101686 */     GIR_RootConstrainSelectedInstOperands,
     /* 101687 */     // GIR_Coverage, 2515,
     /* 101687 */     GIR_EraseRootFromParent_Done,
     /* 101688 */   // Label 2153: @101688
     /* 101688 */   GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(101725), // Rule ID 2516 //
     /* 101693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse_ldmxcsr),
     /* 101698 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101709 */     // (intrinsic_void 14733:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (LDMXCSR addr:{ *:[iPTR] }:$src)
     /* 101709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LDMXCSR),
     /* 101712 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101716 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MXCSR*/0,
     /* 101719 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101723 */     GIR_RootConstrainSelectedInstOperands,
     /* 101724 */     // GIR_Coverage, 2516,
     /* 101724 */     GIR_EraseRootFromParent_Done,
     /* 101725 */   // Label 2154: @101725
     /* 101725 */   GIM_Try, /*On fail goto*//*Label 2155*/ GIMT_Encode4(101759), // Rule ID 2517 //
     /* 101730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse_stmxcsr),
     /* 101735 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101746 */     // (intrinsic_void 14745:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst)  =>  (STMXCSR addr:{ *:[iPTR] }:$dst)
     /* 101746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::STMXCSR),
     /* 101749 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 101753 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101757 */     GIR_RootConstrainSelectedInstOperands,
     /* 101758 */     // GIR_Coverage, 2517,
     /* 101758 */     GIR_EraseRootFromParent_Done,
     /* 101759 */   // Label 2155: @101759
     /* 101759 */   GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(101820), // Rule ID 16993 //
     /* 101764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTILE_In64BitMode_NoEGPR),
     /* 101767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ldtilecfg),
     /* 101772 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101783 */     // (intrinsic_void 14590:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (LDTILECFG:{ *:[x86amx] } addr:{ *:[iPTR] }:$src)
     /* 101783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LDTILECFG),
     /* 101786 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101790 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM0*/0,
     /* 101793 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM1*/1,
     /* 101796 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM2*/2,
     /* 101799 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM3*/3,
     /* 101802 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM4*/4,
     /* 101805 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM5*/5,
     /* 101808 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM6*/6,
     /* 101811 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM7*/7,
     /* 101814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101818 */     GIR_RootConstrainSelectedInstOperands,
     /* 101819 */     // GIR_Coverage, 16993,
     /* 101819 */     GIR_EraseRootFromParent_Done,
     /* 101820 */   // Label 2156: @101820
     /* 101820 */   GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(101857), // Rule ID 16994 //
     /* 101825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTILE_In64BitMode_NoEGPR),
     /* 101828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sttilecfg),
     /* 101833 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101844 */     // (intrinsic_void 14886:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (STTILECFG addr:{ *:[iPTR] }:$src)
     /* 101844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::STTILECFG),
     /* 101847 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101851 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101855 */     GIR_RootConstrainSelectedInstOperands,
     /* 101856 */     // GIR_Coverage, 16994,
     /* 101856 */     GIR_EraseRootFromParent_Done,
     /* 101857 */   // Label 2157: @101857
     /* 101857 */   GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(101918), // Rule ID 16995 //
     /* 101862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTILE_HasEGPR_In64BitMode),
     /* 101865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ldtilecfg),
     /* 101870 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101881 */     // (intrinsic_void 14590:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (LDTILECFG_EVEX:{ *:[x86amx] } addr:{ *:[iPTR] }:$src)
     /* 101881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LDTILECFG_EVEX),
     /* 101884 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101888 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM0*/0,
     /* 101891 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM1*/1,
     /* 101894 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM2*/2,
     /* 101897 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM3*/3,
     /* 101900 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM4*/4,
     /* 101903 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM5*/5,
     /* 101906 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM6*/6,
     /* 101909 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM7*/7,
     /* 101912 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101916 */     GIR_RootConstrainSelectedInstOperands,
     /* 101917 */     // GIR_Coverage, 16995,
     /* 101917 */     GIR_EraseRootFromParent_Done,
     /* 101918 */   // Label 2158: @101918
     /* 101918 */   GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(101955), // Rule ID 16996 //
     /* 101923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTILE_HasEGPR_In64BitMode),
     /* 101926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sttilecfg),
     /* 101931 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101942 */     // (intrinsic_void 14886:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (STTILECFG_EVEX addr:{ *:[iPTR] }:$src)
     /* 101942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::STTILECFG_EVEX),
     /* 101945 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101949 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101953 */     GIR_RootConstrainSelectedInstOperands,
     /* 101954 */     // GIR_Coverage, 16996,
     /* 101954 */     GIR_EraseRootFromParent_Done,
     /* 101955 */   // Label 2159: @101955
     /* 101955 */   GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(101992), // Rule ID 17093 //
     /* 101960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_rstorssp),
     /* 101965 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101976 */     // (intrinsic_void 14699:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (RSTORSSP addr:{ *:[iPTR] }:$src)
     /* 101976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RSTORSSP),
     /* 101979 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101983 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::SSP*/0,
     /* 101986 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101990 */     GIR_RootConstrainSelectedInstOperands,
     /* 101991 */     // GIR_Coverage, 17093,
     /* 101991 */     GIR_EraseRootFromParent_Done,
     /* 101992 */   // Label 2160: @101992
     /* 101992 */   GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(102029), // Rule ID 17103 //
     /* 101997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_clrssbsy),
     /* 102002 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 102013 */     // (intrinsic_void 14562:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (CLRSSBSY addr:{ *:[iPTR] }:$src)
     /* 102013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CLRSSBSY),
     /* 102016 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 102020 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::SSP*/0,
     /* 102023 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102027 */     GIR_RootConstrainSelectedInstOperands,
     /* 102028 */     // GIR_Coverage, 17103,
     /* 102028 */     GIR_EraseRootFromParent_Done,
     /* 102029 */   // Label 2161: @102029
     /* 102029 */   GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(102059), // Rule ID 17075 //
     /* 102034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_int),
     /* 102039 */     // MIs[0] Operand 1
     /* 102039 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(3),
     /* 102050 */     // (intrinsic_void 14588:{ *:[iPTR] }, 3:{ *:[i8] })  =>  (INT3)
     /* 102050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INT3),
     /* 102053 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102057 */     GIR_RootConstrainSelectedInstOperands,
     /* 102058 */     // GIR_Coverage, 17075,
     /* 102058 */     GIR_EraseRootFromParent_Done,
     /* 102059 */   // Label 2162: @102059
     /* 102059 */   GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(102086), // Rule ID 16987 //
     /* 102064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRTM),
     /* 102067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xabort),
     /* 102072 */     // MIs[0] imm
     /* 102072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 102075 */     // (intrinsic_void 15029:{ *:[iPTR] }, (timm:{ *:[i8] }):$imm)  =>  (XABORT (timm:{ *:[i8] }):$imm)
     /* 102075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XABORT),
     /* 102078 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 102080 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102084 */     GIR_RootConstrainSelectedInstOperands,
     /* 102085 */     // GIR_Coverage, 16987,
     /* 102085 */     GIR_EraseRootFromParent_Done,
     /* 102086 */   // Label 2163: @102086
     /* 102086 */   GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(102113), // Rule ID 16999 //
     /* 102091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTILE_In64BitMode),
     /* 102094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tilezero),
     /* 102099 */     // MIs[0] src
     /* 102099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 102102 */     // (intrinsic_void 14960:{ *:[iPTR] }, (timm:{ *:[i8] }):$src)  =>  (PTILEZERO (timm:{ *:[i8] }):$src)
     /* 102102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTILEZERO),
     /* 102105 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102107 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102111 */     GIR_RootConstrainSelectedInstOperands,
     /* 102112 */     // GIR_Coverage, 16999,
     /* 102112 */     GIR_EraseRootFromParent_Done,
     /* 102113 */   // Label 2164: @102113
     /* 102113 */   GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(102137), // Rule ID 17077 //
     /* 102118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_int),
     /* 102123 */     // MIs[0] trap
     /* 102123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 102126 */     // (intrinsic_void 14588:{ *:[iPTR] }, (timm:{ *:[i8] }):$trap)  =>  (INT (timm:{ *:[i8] }):$trap)
     /* 102126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INT),
     /* 102129 */     GIR_RootToRootCopy, /*OpIdx*/1, // trap
     /* 102131 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102135 */     GIR_RootConstrainSelectedInstOperands,
     /* 102136 */     // GIR_Coverage, 17077,
     /* 102136 */     GIR_EraseRootFromParent_Done,
     /* 102137 */   // Label 2165: @102137
     /* 102137 */   GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(102171), // Rule ID 1 //
     /* 102142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode),
     /* 102145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_flags_read_u32),
     /* 102150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 102153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102157 */     // (intrinsic_w_chain:{ *:[i32] } 14574:{ *:[iPTR] })  =>  (RDFLAGS32:{ *:[i32] }:{ *:[i32] })
     /* 102157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDFLAGS32),
     /* 102160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102162 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ESP*/0,
     /* 102165 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102169 */     GIR_RootConstrainSelectedInstOperands,
     /* 102170 */     // GIR_Coverage, 1,
     /* 102170 */     GIR_EraseRootFromParent_Done,
     /* 102171 */   // Label 2166: @102171
     /* 102171 */   GIM_Try, /*On fail goto*//*Label 2167*/ GIMT_Encode4(102205), // Rule ID 2 //
     /* 102176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /* 102179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_flags_read_u64),
     /* 102184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 102187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102191 */     // (intrinsic_w_chain:{ *:[i64] } 14575:{ *:[iPTR] })  =>  (RDFLAGS64:{ *:[i64] }:{ *:[i32] })
     /* 102191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDFLAGS64),
     /* 102194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102196 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ESP*/0,
     /* 102199 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102203 */     GIR_RootConstrainSelectedInstOperands,
     /* 102204 */     // GIR_Coverage, 2,
     /* 102204 */     GIR_EraseRootFromParent_Done,
     /* 102205 */   // Label 2167: @102205
     /* 102205 */   GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(102236), // Rule ID 115 //
     /* 102210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 102213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_slwpcb),
     /* 102218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 102221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102225 */     // (intrinsic_w_chain:{ *:[i32] } 14714:{ *:[iPTR] })  =>  (SLWPCB:{ *:[i32] })
     /* 102225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SLWPCB),
     /* 102228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102230 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102234 */     GIR_RootConstrainSelectedInstOperands,
     /* 102235 */     // GIR_Coverage, 115,
     /* 102235 */     GIR_EraseRootFromParent_Done,
     /* 102236 */   // Label 2168: @102236
     /* 102236 */   GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(102267), // Rule ID 117 //
     /* 102241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 102244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_slwpcb),
     /* 102249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 102252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102256 */     // (intrinsic_w_chain:{ *:[i64] } 14714:{ *:[iPTR] })  =>  (SLWPCB64:{ *:[i64] })
     /* 102256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SLWPCB64),
     /* 102259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102261 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102265 */     GIR_RootConstrainSelectedInstOperands,
     /* 102266 */     // GIR_Coverage, 117,
     /* 102266 */     GIR_EraseRootFromParent_Done,
     /* 102267 */   // Label 2169: @102267
     /* 102267 */   GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(102298), // Rule ID 16984 //
     /* 102272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRTM),
     /* 102275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xbegin),
     /* 102280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 102283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102287 */     // (intrinsic_w_chain:{ *:[i32] } 15030:{ *:[iPTR] })  =>  (XBEGIN:{ *:[i32] })
     /* 102287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XBEGIN),
     /* 102290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102292 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102296 */     GIR_RootConstrainSelectedInstOperands,
     /* 102297 */     // GIR_Coverage, 16984,
     /* 102297 */     GIR_EraseRootFromParent_Done,
     /* 102298 */   // Label 2170: @102298
     /* 102298 */   GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(102329), // Rule ID 17119 //
     /* 102303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 102306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdfsbase_32),
     /* 102311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 102314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102318 */     // (intrinsic_w_chain:{ *:[i32] } 14681:{ *:[iPTR] })  =>  (RDFSBASE:{ *:[i32] })
     /* 102318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDFSBASE),
     /* 102321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102323 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102327 */     GIR_RootConstrainSelectedInstOperands,
     /* 102328 */     // GIR_Coverage, 17119,
     /* 102328 */     GIR_EraseRootFromParent_Done,
     /* 102329 */   // Label 2171: @102329
     /* 102329 */   GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(102360), // Rule ID 17120 //
     /* 102334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 102337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdfsbase_64),
     /* 102342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 102345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102349 */     // (intrinsic_w_chain:{ *:[i64] } 14682:{ *:[iPTR] })  =>  (RDFSBASE64:{ *:[i64] })
     /* 102349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDFSBASE64),
     /* 102352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102358 */     GIR_RootConstrainSelectedInstOperands,
     /* 102359 */     // GIR_Coverage, 17120,
     /* 102359 */     GIR_EraseRootFromParent_Done,
     /* 102360 */   // Label 2172: @102360
     /* 102360 */   GIM_Try, /*On fail goto*//*Label 2173*/ GIMT_Encode4(102391), // Rule ID 17121 //
     /* 102365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 102368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdgsbase_32),
     /* 102373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 102376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102380 */     // (intrinsic_w_chain:{ *:[i32] } 14683:{ *:[iPTR] })  =>  (RDGSBASE:{ *:[i32] })
     /* 102380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDGSBASE),
     /* 102383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102385 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102389 */     GIR_RootConstrainSelectedInstOperands,
     /* 102390 */     // GIR_Coverage, 17121,
     /* 102390 */     GIR_EraseRootFromParent_Done,
     /* 102391 */   // Label 2173: @102391
     /* 102391 */   GIM_Try, /*On fail goto*//*Label 2174*/ GIMT_Encode4(102422), // Rule ID 17122 //
     /* 102396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 102399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdgsbase_64),
     /* 102404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 102407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102411 */     // (intrinsic_w_chain:{ *:[i64] } 14684:{ *:[iPTR] })  =>  (RDGSBASE64:{ *:[i64] })
     /* 102411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDGSBASE64),
     /* 102414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102420 */     GIR_RootConstrainSelectedInstOperands,
     /* 102421 */     // GIR_Coverage, 17122,
     /* 102421 */     GIR_EraseRootFromParent_Done,
     /* 102422 */   // Label 2174: @102422
     /* 102422 */   GIM_Try, /*On fail goto*//*Label 2175*/ GIMT_Encode4(102453), // Rule ID 17128 //
     /* 102427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDPID_Not64BitMode),
     /* 102430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdpid),
     /* 102435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 102438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102442 */     // (intrinsic_w_chain:{ *:[i32] } 14685:{ *:[iPTR] })  =>  (RDPID32:{ *:[i32] })
     /* 102442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDPID32),
     /* 102445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102447 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102451 */     GIR_RootConstrainSelectedInstOperands,
     /* 102452 */     // GIR_Coverage, 17128,
     /* 102452 */     GIR_EraseRootFromParent_Done,
     /* 102453 */   // Label 2175: @102453
     /* 102453 */   GIM_Try, /*On fail goto*//*Label 2176*/ GIMT_Encode4(102510), // Rule ID 22381 //
     /* 102458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDPID_In64BitMode),
     /* 102461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdpid),
     /* 102466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 102469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102473 */     // (intrinsic_w_chain:{ *:[i32] } 14685:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[i32] } (RDPID64:{ *:[i64] }), sub_32bit:{ *:[i32] })
     /* 102473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 102476 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::RDPID64),
     /* 102480 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102485 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 102490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102492 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_32bit),
     /* 102499 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /* 102504 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 102509 */     // GIR_Coverage, 22381,
     /* 102509 */     GIR_EraseRootFromParent_Done,
     /* 102510 */   // Label 2176: @102510
     /* 102510 */   GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(102550), // Rule ID 3 //
     /* 102515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode),
     /* 102518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_flags_write_u32),
     /* 102523 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 102526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102530 */     // (intrinsic_void 14576:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (WRFLAGS32:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /* 102530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRFLAGS32),
     /* 102533 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102535 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ESP*/0,
     /* 102538 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/1,
     /* 102541 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::DF*/2,
     /* 102544 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102548 */     GIR_RootConstrainSelectedInstOperands,
     /* 102549 */     // GIR_Coverage, 3,
     /* 102549 */     GIR_EraseRootFromParent_Done,
     /* 102550 */   // Label 2177: @102550
     /* 102550 */   GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(102590), // Rule ID 4 //
     /* 102555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /* 102558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_flags_write_u64),
     /* 102563 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 102566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102570 */     // (intrinsic_void 14577:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (WRFLAGS64:{ *:[i64] } GR64:{ *:[i64] }:$src)
     /* 102570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRFLAGS64),
     /* 102573 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102575 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::RSP*/0,
     /* 102578 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/1,
     /* 102581 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::DF*/2,
     /* 102584 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102588 */     GIR_RootConstrainSelectedInstOperands,
     /* 102589 */     // GIR_Coverage, 4,
     /* 102589 */     GIR_EraseRootFromParent_Done,
     /* 102590 */   // Label 2178: @102590
     /* 102590 */   GIM_Try, /*On fail goto*//*Label 2179*/ GIMT_Encode4(102621), // Rule ID 154 //
     /* 102595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUINTR_In64BitMode),
     /* 102598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_senduipi),
     /* 102603 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 102606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102610 */     // (intrinsic_void 14704:{ *:[iPTR] }, GR64:{ *:[i64] }:$arg)  =>  (SENDUIPI GR64:{ *:[i64] }:$arg)
     /* 102610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SENDUIPI),
     /* 102613 */     GIR_RootToRootCopy, /*OpIdx*/1, // arg
     /* 102615 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102619 */     GIR_RootConstrainSelectedInstOperands,
     /* 102620 */     // GIR_Coverage, 154,
     /* 102620 */     GIR_EraseRootFromParent_Done,
     /* 102621 */   // Label 2179: @102621
     /* 102621 */   GIM_Try, /*On fail goto*//*Label 2180*/ GIMT_Encode4(102652), // Rule ID 17088 //
     /* 102626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_incsspd),
     /* 102631 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 102634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102638 */     // (intrinsic_void 14586:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (INCSSPD GR32:{ *:[i32] }:$src)
     /* 102638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INCSSPD),
     /* 102641 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102643 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::SSP*/0,
     /* 102646 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102650 */     GIR_RootConstrainSelectedInstOperands,
     /* 102651 */     // GIR_Coverage, 17088,
     /* 102651 */     GIR_EraseRootFromParent_Done,
     /* 102652 */   // Label 2180: @102652
     /* 102652 */   GIM_Try, /*On fail goto*//*Label 2181*/ GIMT_Encode4(102683), // Rule ID 17089 //
     /* 102657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_incsspq),
     /* 102662 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 102665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102669 */     // (intrinsic_void 14587:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (INCSSPQ GR64:{ *:[i64] }:$src)
     /* 102669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INCSSPQ),
     /* 102672 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102674 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::SSP*/0,
     /* 102677 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102681 */     GIR_RootConstrainSelectedInstOperands,
     /* 102682 */     // GIR_Coverage, 17089,
     /* 102682 */     GIR_EraseRootFromParent_Done,
     /* 102683 */   // Label 2181: @102683
     /* 102683 */   GIM_Try, /*On fail goto*//*Label 2182*/ GIMT_Encode4(102714), // Rule ID 17123 //
     /* 102688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 102691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrfsbase_32),
     /* 102696 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 102699 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102703 */     // (intrinsic_void 15020:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (WRFSBASE GR32:{ *:[i32] }:$src)
     /* 102703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRFSBASE),
     /* 102706 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102708 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102712 */     GIR_RootConstrainSelectedInstOperands,
     /* 102713 */     // GIR_Coverage, 17123,
     /* 102713 */     GIR_EraseRootFromParent_Done,
     /* 102714 */   // Label 2182: @102714
     /* 102714 */   GIM_Try, /*On fail goto*//*Label 2183*/ GIMT_Encode4(102745), // Rule ID 17124 //
     /* 102719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 102722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrfsbase_64),
     /* 102727 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 102730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102734 */     // (intrinsic_void 15021:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (WRFSBASE64 GR64:{ *:[i64] }:$src)
     /* 102734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRFSBASE64),
     /* 102737 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102739 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102743 */     GIR_RootConstrainSelectedInstOperands,
     /* 102744 */     // GIR_Coverage, 17124,
     /* 102744 */     GIR_EraseRootFromParent_Done,
     /* 102745 */   // Label 2183: @102745
     /* 102745 */   GIM_Try, /*On fail goto*//*Label 2184*/ GIMT_Encode4(102776), // Rule ID 17125 //
     /* 102750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 102753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrgsbase_32),
     /* 102758 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 102761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102765 */     // (intrinsic_void 15022:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (WRGSBASE GR32:{ *:[i32] }:$src)
     /* 102765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRGSBASE),
     /* 102768 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102770 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102774 */     GIR_RootConstrainSelectedInstOperands,
     /* 102775 */     // GIR_Coverage, 17125,
     /* 102775 */     GIR_EraseRootFromParent_Done,
     /* 102776 */   // Label 2184: @102776
     /* 102776 */   GIM_Try, /*On fail goto*//*Label 2185*/ GIMT_Encode4(102807), // Rule ID 17126 //
     /* 102781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 102784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrgsbase_64),
     /* 102789 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 102792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102796 */     // (intrinsic_void 15023:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (WRGSBASE64 GR64:{ *:[i64] }:$src)
     /* 102796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRGSBASE64),
     /* 102799 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102801 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102805 */     GIR_RootConstrainSelectedInstOperands,
     /* 102806 */     // GIR_Coverage, 17126,
     /* 102806 */     GIR_EraseRootFromParent_Done,
     /* 102807 */   // Label 2185: @102807
     /* 102807 */   GIM_Try, /*On fail goto*//*Label 2186*/ GIMT_Encode4(102838), // Rule ID 17131 //
     /* 102812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPTWRITE),
     /* 102815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ptwrite32),
     /* 102820 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 102823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102827 */     // (intrinsic_void 14679:{ *:[iPTR] }, GR32:{ *:[i32] }:$dst)  =>  (PTWRITEr GR32:{ *:[i32] }:$dst)
     /* 102827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTWRITEr),
     /* 102830 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 102832 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102836 */     GIR_RootConstrainSelectedInstOperands,
     /* 102837 */     // GIR_Coverage, 17131,
     /* 102837 */     GIR_EraseRootFromParent_Done,
     /* 102838 */   // Label 2186: @102838
     /* 102838 */   GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(102869), // Rule ID 17132 //
     /* 102843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPTWRITE_In64BitMode),
     /* 102846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ptwrite64),
     /* 102851 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 102854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102858 */     // (intrinsic_void 14680:{ *:[iPTR] }, GR64:{ *:[i64] }:$dst)  =>  (PTWRITE64r GR64:{ *:[i64] }:$dst)
     /* 102858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTWRITE64r),
     /* 102861 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 102863 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102867 */     GIR_RootConstrainSelectedInstOperands,
     /* 102868 */     // GIR_Coverage, 17132,
     /* 102868 */     GIR_EraseRootFromParent_Done,
     /* 102869 */   // Label 2187: @102869
     /* 102869 */   GIM_Try, /*On fail goto*//*Label 2188*/ GIMT_Encode4(102901), // Rule ID 114 //
     /* 102874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 102877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_llwpcb),
     /* 102882 */     // MIs[0] src
     /* 102882 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /* 102886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102890 */     // (intrinsic_void 14592:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (LLWPCB GR32:{ *:[i32] }:$src)
     /* 102890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LLWPCB),
     /* 102893 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102895 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102899 */     GIR_RootConstrainSelectedInstOperands,
     /* 102900 */     // GIR_Coverage, 114,
     /* 102900 */     GIR_EraseRootFromParent_Done,
     /* 102901 */   // Label 2188: @102901
     /* 102901 */   GIM_Try, /*On fail goto*//*Label 2189*/ GIMT_Encode4(102933), // Rule ID 116 //
     /* 102906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 102909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_llwpcb),
     /* 102914 */     // MIs[0] src
     /* 102914 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 102918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102922 */     // (intrinsic_void 14592:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (LLWPCB64 GR64:{ *:[i64] }:$src)
     /* 102922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LLWPCB64),
     /* 102925 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102927 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102931 */     GIR_RootConstrainSelectedInstOperands,
     /* 102932 */     // GIR_Coverage, 116,
     /* 102932 */     GIR_EraseRootFromParent_Done,
     /* 102933 */   // Label 2189: @102933
     /* 102933 */   GIM_Try, /*On fail goto*//*Label 2190*/ GIMT_Encode4(102965), // Rule ID 126 //
     /* 102938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasWAITPKG_Not64BitMode),
     /* 102941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_umonitor),
     /* 102946 */     // MIs[0] src
     /* 102946 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/16,
     /* 102950 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 102954 */     // (intrinsic_void 14977:{ *:[iPTR] }, GR16:{ *:[i16] }:$src)  =>  (UMONITOR16 GR16:{ *:[i16] }:$src)
     /* 102954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::UMONITOR16),
     /* 102957 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102959 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102963 */     GIR_RootConstrainSelectedInstOperands,
     /* 102964 */     // GIR_Coverage, 126,
     /* 102964 */     GIR_EraseRootFromParent_Done,
     /* 102965 */   // Label 2190: @102965
     /* 102965 */   GIM_Try, /*On fail goto*//*Label 2191*/ GIMT_Encode4(102997), // Rule ID 127 //
     /* 102970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasWAITPKG),
     /* 102973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_umonitor),
     /* 102978 */     // MIs[0] src
     /* 102978 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /* 102982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102986 */     // (intrinsic_void 14977:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (UMONITOR32 GR32:{ *:[i32] }:$src)
     /* 102986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::UMONITOR32),
     /* 102989 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102991 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102995 */     GIR_RootConstrainSelectedInstOperands,
     /* 102996 */     // GIR_Coverage, 127,
     /* 102996 */     GIR_EraseRootFromParent_Done,
     /* 102997 */   // Label 2191: @102997
     /* 102997 */   GIM_Try, /*On fail goto*//*Label 2192*/ GIMT_Encode4(103029), // Rule ID 128 //
     /* 103002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasWAITPKG_In64BitMode),
     /* 103005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_umonitor),
     /* 103010 */     // MIs[0] src
     /* 103010 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 103014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 103018 */     // (intrinsic_void 14977:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (UMONITOR64 GR64:{ *:[i64] }:$src)
     /* 103018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::UMONITOR64),
     /* 103021 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 103023 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103027 */     GIR_RootConstrainSelectedInstOperands,
     /* 103028 */     // GIR_Coverage, 128,
     /* 103028 */     GIR_EraseRootFromParent_Done,
     /* 103029 */   // Label 2192: @103029
     /* 103029 */   GIM_Reject,
     /* 103030 */ // Label 2140: @103030
     /* 103030 */ GIM_Try, /*On fail goto*//*Label 2193*/ GIMT_Encode4(106024),
     /* 103035 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 103038 */   GIM_Try, /*On fail goto*//*Label 2194*/ GIMT_Encode4(103084), // Rule ID 165 //
     /* 103043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVRS_In64BitMode_NoEGPR),
     /* 103046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_movrsqi),
     /* 103051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 103054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 103058 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103069 */     // (intrinsic_w_chain:{ *:[i8] } 14672:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (MOVRS8rm:{ *:[i8] } addr:{ *:[iPTR] }:$src)
     /* 103069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVRS8rm),
     /* 103072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103074 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103078 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103082 */     GIR_RootConstrainSelectedInstOperands,
     /* 103083 */     // GIR_Coverage, 165,
     /* 103083 */     GIR_EraseRootFromParent_Done,
     /* 103084 */   // Label 2194: @103084
     /* 103084 */   GIM_Try, /*On fail goto*//*Label 2195*/ GIMT_Encode4(103130), // Rule ID 166 //
     /* 103089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVRS_In64BitMode_NoEGPR),
     /* 103092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_movrshi),
     /* 103097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 103100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 103104 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103115 */     // (intrinsic_w_chain:{ *:[i16] } 14671:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (MOVRS16rm:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /* 103115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVRS16rm),
     /* 103118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103120 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103124 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103128 */     GIR_RootConstrainSelectedInstOperands,
     /* 103129 */     // GIR_Coverage, 166,
     /* 103129 */     GIR_EraseRootFromParent_Done,
     /* 103130 */   // Label 2195: @103130
     /* 103130 */   GIM_Try, /*On fail goto*//*Label 2196*/ GIMT_Encode4(103176), // Rule ID 167 //
     /* 103135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVRS_In64BitMode_NoEGPR),
     /* 103138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_movrssi),
     /* 103143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 103146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 103150 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103161 */     // (intrinsic_w_chain:{ *:[i32] } 14673:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (MOVRS32rm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 103161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVRS32rm),
     /* 103164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103166 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103170 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103174 */     GIR_RootConstrainSelectedInstOperands,
     /* 103175 */     // GIR_Coverage, 167,
     /* 103175 */     GIR_EraseRootFromParent_Done,
     /* 103176 */   // Label 2196: @103176
     /* 103176 */   GIM_Try, /*On fail goto*//*Label 2197*/ GIMT_Encode4(103222), // Rule ID 168 //
     /* 103181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVRS_In64BitMode_NoEGPR),
     /* 103184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_movrsdi),
     /* 103189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 103192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 103196 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103207 */     // (intrinsic_w_chain:{ *:[i64] } 14670:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (MOVRS64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 103207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVRS64rm),
     /* 103210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103212 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103216 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103220 */     GIR_RootConstrainSelectedInstOperands,
     /* 103221 */     // GIR_Coverage, 168,
     /* 103221 */     GIR_EraseRootFromParent_Done,
     /* 103222 */   // Label 2197: @103222
     /* 103222 */   GIM_Try, /*On fail goto*//*Label 2198*/ GIMT_Encode4(103268), // Rule ID 170 //
     /* 103227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVRS_In64BitMode),
     /* 103230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_movrsqi),
     /* 103235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 103238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 103242 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103253 */     // (intrinsic_w_chain:{ *:[i8] } 14672:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (MOVRS8rm_EVEX:{ *:[i8] } addr:{ *:[iPTR] }:$src)
     /* 103253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVRS8rm_EVEX),
     /* 103256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103258 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103262 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103266 */     GIR_RootConstrainSelectedInstOperands,
     /* 103267 */     // GIR_Coverage, 170,
     /* 103267 */     GIR_EraseRootFromParent_Done,
     /* 103268 */   // Label 2198: @103268
     /* 103268 */   GIM_Try, /*On fail goto*//*Label 2199*/ GIMT_Encode4(103314), // Rule ID 171 //
     /* 103273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVRS_In64BitMode),
     /* 103276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_movrshi),
     /* 103281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 103284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 103288 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103299 */     // (intrinsic_w_chain:{ *:[i16] } 14671:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (MOVRS16rm_EVEX:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /* 103299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVRS16rm_EVEX),
     /* 103302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103304 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103308 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103312 */     GIR_RootConstrainSelectedInstOperands,
     /* 103313 */     // GIR_Coverage, 171,
     /* 103313 */     GIR_EraseRootFromParent_Done,
     /* 103314 */   // Label 2199: @103314
     /* 103314 */   GIM_Try, /*On fail goto*//*Label 2200*/ GIMT_Encode4(103360), // Rule ID 172 //
     /* 103319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVRS_In64BitMode),
     /* 103322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_movrssi),
     /* 103327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 103330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 103334 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103345 */     // (intrinsic_w_chain:{ *:[i32] } 14673:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (MOVRS32rm_EVEX:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 103345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVRS32rm_EVEX),
     /* 103348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103350 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103358 */     GIR_RootConstrainSelectedInstOperands,
     /* 103359 */     // GIR_Coverage, 172,
     /* 103359 */     GIR_EraseRootFromParent_Done,
     /* 103360 */   // Label 2200: @103360
     /* 103360 */   GIM_Try, /*On fail goto*//*Label 2201*/ GIMT_Encode4(103406), // Rule ID 173 //
     /* 103365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVRS_In64BitMode),
     /* 103368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_movrsdi),
     /* 103373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 103376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 103380 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103391 */     // (intrinsic_w_chain:{ *:[i64] } 14670:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (MOVRS64rm_EVEX:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 103391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVRS64rm_EVEX),
     /* 103394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103396 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103400 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103404 */     GIR_RootConstrainSelectedInstOperands,
     /* 103405 */     // GIR_Coverage, 173,
     /* 103405 */     GIR_EraseRootFromParent_Done,
     /* 103406 */   // Label 2201: @103406
     /* 103406 */   GIM_Try, /*On fail goto*//*Label 2202*/ GIMT_Encode4(103452), // Rule ID 2951 //
     /* 103411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 103414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse3_ldu_dq),
     /* 103419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 103422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 103426 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103437 */     // (intrinsic_w_chain:{ *:[v16i8] } 14818:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VLDDQUrm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /* 103437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VLDDQUrm),
     /* 103440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103442 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103446 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103450 */     GIR_RootConstrainSelectedInstOperands,
     /* 103451 */     // GIR_Coverage, 2951,
     /* 103451 */     GIR_EraseRootFromParent_Done,
     /* 103452 */   // Label 2202: @103452
     /* 103452 */   GIM_Try, /*On fail goto*//*Label 2203*/ GIMT_Encode4(103498), // Rule ID 2952 //
     /* 103457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 103460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx_ldu_dq_256),
     /* 103465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s8,
     /* 103468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 103472 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103483 */     // (intrinsic_w_chain:{ *:[v32i8] } 13439:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VLDDQUYrm:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)
     /* 103483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VLDDQUYrm),
     /* 103486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103488 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103492 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103496 */     GIR_RootConstrainSelectedInstOperands,
     /* 103497 */     // GIR_Coverage, 2952,
     /* 103497 */     GIR_EraseRootFromParent_Done,
     /* 103498 */   // Label 2203: @103498
     /* 103498 */   GIM_Try, /*On fail goto*//*Label 2204*/ GIMT_Encode4(103544), // Rule ID 2953 //
     /* 103503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE3),
     /* 103506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse3_ldu_dq),
     /* 103511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 103514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 103518 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103529 */     // (intrinsic_w_chain:{ *:[v16i8] } 14818:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (LDDQUrm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /* 103529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LDDQUrm),
     /* 103532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103534 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103538 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103542 */     GIR_RootConstrainSelectedInstOperands,
     /* 103543 */     // GIR_Coverage, 2953,
     /* 103543 */     GIR_EraseRootFromParent_Done,
     /* 103544 */   // Label 2204: @103544
     /* 103544 */   GIM_Try, /*On fail goto*//*Label 2205*/ GIMT_Encode4(103590), // Rule ID 3543 //
     /* 103549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vbcstnebf162ps128),
     /* 103557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 103560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 103564 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103575 */     // (intrinsic_w_chain:{ *:[v4f32] } 14981:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VBCSTNEBF162PSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 103575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VBCSTNEBF162PSrm),
     /* 103578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103580 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103584 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103588 */     GIR_RootConstrainSelectedInstOperands,
     /* 103589 */     // GIR_Coverage, 3543,
     /* 103589 */     GIR_EraseRootFromParent_Done,
     /* 103590 */   // Label 2205: @103590
     /* 103590 */   GIM_Try, /*On fail goto*//*Label 2206*/ GIMT_Encode4(103636), // Rule ID 3544 //
     /* 103595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vbcstnebf162ps256),
     /* 103603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 103606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 103610 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103621 */     // (intrinsic_w_chain:{ *:[v8f32] } 14982:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VBCSTNEBF162PSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 103621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VBCSTNEBF162PSYrm),
     /* 103624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103626 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103630 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103634 */     GIR_RootConstrainSelectedInstOperands,
     /* 103635 */     // GIR_Coverage, 3544,
     /* 103635 */     GIR_EraseRootFromParent_Done,
     /* 103636 */   // Label 2206: @103636
     /* 103636 */   GIM_Try, /*On fail goto*//*Label 2207*/ GIMT_Encode4(103682), // Rule ID 3545 //
     /* 103641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vbcstnesh2ps128),
     /* 103649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 103652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 103656 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103667 */     // (intrinsic_w_chain:{ *:[v4f32] } 14983:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VBCSTNESH2PSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 103667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VBCSTNESH2PSrm),
     /* 103670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103672 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103676 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103680 */     GIR_RootConstrainSelectedInstOperands,
     /* 103681 */     // GIR_Coverage, 3545,
     /* 103681 */     GIR_EraseRootFromParent_Done,
     /* 103682 */   // Label 2207: @103682
     /* 103682 */   GIM_Try, /*On fail goto*//*Label 2208*/ GIMT_Encode4(103728), // Rule ID 3546 //
     /* 103687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vbcstnesh2ps256),
     /* 103695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 103698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 103702 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103713 */     // (intrinsic_w_chain:{ *:[v8f32] } 14984:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VBCSTNESH2PSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 103713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VBCSTNESH2PSYrm),
     /* 103716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103718 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103722 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103726 */     GIR_RootConstrainSelectedInstOperands,
     /* 103727 */     // GIR_Coverage, 3546,
     /* 103727 */     GIR_EraseRootFromParent_Done,
     /* 103728 */   // Label 2208: @103728
     /* 103728 */   GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(103774), // Rule ID 3547 //
     /* 103733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vcvtneebf162ps128),
     /* 103741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 103744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 103748 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103759 */     // (intrinsic_w_chain:{ *:[v4f32] } 14985:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VCVTNEEBF162PSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 103759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTNEEBF162PSrm),
     /* 103762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103764 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103768 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103772 */     GIR_RootConstrainSelectedInstOperands,
     /* 103773 */     // GIR_Coverage, 3547,
     /* 103773 */     GIR_EraseRootFromParent_Done,
     /* 103774 */   // Label 2209: @103774
     /* 103774 */   GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(103820), // Rule ID 3548 //
     /* 103779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vcvtneebf162ps256),
     /* 103787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 103790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 103794 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103805 */     // (intrinsic_w_chain:{ *:[v8f32] } 14986:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VCVTNEEBF162PSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 103805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTNEEBF162PSYrm),
     /* 103808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103810 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103818 */     GIR_RootConstrainSelectedInstOperands,
     /* 103819 */     // GIR_Coverage, 3548,
     /* 103819 */     GIR_EraseRootFromParent_Done,
     /* 103820 */   // Label 2210: @103820
     /* 103820 */   GIM_Try, /*On fail goto*//*Label 2211*/ GIMT_Encode4(103866), // Rule ID 3549 //
     /* 103825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vcvtneeph2ps128),
     /* 103833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 103836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 103840 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103851 */     // (intrinsic_w_chain:{ *:[v4f32] } 14987:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VCVTNEEPH2PSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 103851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTNEEPH2PSrm),
     /* 103854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103856 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103860 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103864 */     GIR_RootConstrainSelectedInstOperands,
     /* 103865 */     // GIR_Coverage, 3549,
     /* 103865 */     GIR_EraseRootFromParent_Done,
     /* 103866 */   // Label 2211: @103866
     /* 103866 */   GIM_Try, /*On fail goto*//*Label 2212*/ GIMT_Encode4(103912), // Rule ID 3550 //
     /* 103871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vcvtneeph2ps256),
     /* 103879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 103882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 103886 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103897 */     // (intrinsic_w_chain:{ *:[v8f32] } 14988:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VCVTNEEPH2PSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 103897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTNEEPH2PSYrm),
     /* 103900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103902 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103906 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103910 */     GIR_RootConstrainSelectedInstOperands,
     /* 103911 */     // GIR_Coverage, 3550,
     /* 103911 */     GIR_EraseRootFromParent_Done,
     /* 103912 */   // Label 2212: @103912
     /* 103912 */   GIM_Try, /*On fail goto*//*Label 2213*/ GIMT_Encode4(103958), // Rule ID 3551 //
     /* 103917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vcvtneobf162ps128),
     /* 103925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 103928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 103932 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103943 */     // (intrinsic_w_chain:{ *:[v4f32] } 14989:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VCVTNEOBF162PSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 103943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTNEOBF162PSrm),
     /* 103946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103948 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103952 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103956 */     GIR_RootConstrainSelectedInstOperands,
     /* 103957 */     // GIR_Coverage, 3551,
     /* 103957 */     GIR_EraseRootFromParent_Done,
     /* 103958 */   // Label 2213: @103958
     /* 103958 */   GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(104004), // Rule ID 3552 //
     /* 103963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vcvtneobf162ps256),
     /* 103971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 103974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 103978 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103989 */     // (intrinsic_w_chain:{ *:[v8f32] } 14990:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VCVTNEOBF162PSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 103989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTNEOBF162PSYrm),
     /* 103992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103994 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103998 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104002 */     GIR_RootConstrainSelectedInstOperands,
     /* 104003 */     // GIR_Coverage, 3552,
     /* 104003 */     GIR_EraseRootFromParent_Done,
     /* 104004 */   // Label 2214: @104004
     /* 104004 */   GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(104050), // Rule ID 3553 //
     /* 104009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 104012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vcvtneoph2ps128),
     /* 104017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 104020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 104024 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104035 */     // (intrinsic_w_chain:{ *:[v4f32] } 14991:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VCVTNEOPH2PSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 104035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTNEOPH2PSrm),
     /* 104038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104040 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104044 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104048 */     GIR_RootConstrainSelectedInstOperands,
     /* 104049 */     // GIR_Coverage, 3553,
     /* 104049 */     GIR_EraseRootFromParent_Done,
     /* 104050 */   // Label 2215: @104050
     /* 104050 */   GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(104096), // Rule ID 3554 //
     /* 104055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 104058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vcvtneoph2ps256),
     /* 104063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 104066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 104070 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104081 */     // (intrinsic_w_chain:{ *:[v8f32] } 14992:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VCVTNEOPH2PSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 104081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTNEOPH2PSYrm),
     /* 104084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104086 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104090 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104094 */     GIR_RootConstrainSelectedInstOperands,
     /* 104095 */     // GIR_Coverage, 3554,
     /* 104095 */     GIR_EraseRootFromParent_Done,
     /* 104096 */   // Label 2216: @104096
     /* 104096 */   GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(104142), // Rule ID 16753 //
     /* 104101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_512_HasMOVRS_In64BitMode),
     /* 104104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsb512),
     /* 104109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v64s8,
     /* 104112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 104116 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104127 */     // (intrinsic_w_chain:{ *:[v64i8] } 13695:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSBZm:{ *:[v64i8] } addr:{ *:[iPTR] }:$src)
     /* 104127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSBZm),
     /* 104130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104132 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104136 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104140 */     GIR_RootConstrainSelectedInstOperands,
     /* 104141 */     // GIR_Coverage, 16753,
     /* 104141 */     GIR_EraseRootFromParent_Done,
     /* 104142 */   // Label 2217: @104142
     /* 104142 */   GIM_Try, /*On fail goto*//*Label 2218*/ GIMT_Encode4(104188), // Rule ID 16756 //
     /* 104147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasMOVRS_In64BitMode),
     /* 104150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsb128),
     /* 104155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 104158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 104162 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104173 */     // (intrinsic_w_chain:{ *:[v16i8] } 13693:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSBZ128m:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /* 104173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSBZ128m),
     /* 104176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104178 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104182 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104186 */     GIR_RootConstrainSelectedInstOperands,
     /* 104187 */     // GIR_Coverage, 16756,
     /* 104187 */     GIR_EraseRootFromParent_Done,
     /* 104188 */   // Label 2218: @104188
     /* 104188 */   GIM_Try, /*On fail goto*//*Label 2219*/ GIMT_Encode4(104234), // Rule ID 16759 //
     /* 104193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasMOVRS_In64BitMode),
     /* 104196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsb256),
     /* 104201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s8,
     /* 104204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 104208 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104219 */     // (intrinsic_w_chain:{ *:[v32i8] } 13694:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSBZ256m:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)
     /* 104219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSBZ256m),
     /* 104222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104224 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104228 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104232 */     GIR_RootConstrainSelectedInstOperands,
     /* 104233 */     // GIR_Coverage, 16759,
     /* 104233 */     GIR_EraseRootFromParent_Done,
     /* 104234 */   // Label 2219: @104234
     /* 104234 */   GIM_Try, /*On fail goto*//*Label 2220*/ GIMT_Encode4(104280), // Rule ID 16762 //
     /* 104239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_512_HasMOVRS_In64BitMode),
     /* 104242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsw512),
     /* 104247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s16,
     /* 104250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 104254 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104265 */     // (intrinsic_w_chain:{ *:[v32i16] } 13704:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSWZm:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)
     /* 104265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSWZm),
     /* 104268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104270 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104274 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104278 */     GIR_RootConstrainSelectedInstOperands,
     /* 104279 */     // GIR_Coverage, 16762,
     /* 104279 */     GIR_EraseRootFromParent_Done,
     /* 104280 */   // Label 2220: @104280
     /* 104280 */   GIM_Try, /*On fail goto*//*Label 2221*/ GIMT_Encode4(104326), // Rule ID 16765 //
     /* 104285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasMOVRS_In64BitMode),
     /* 104288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsw128),
     /* 104293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 104296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 104300 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104311 */     // (intrinsic_w_chain:{ *:[v8i16] } 13702:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSWZ128m:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /* 104311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSWZ128m),
     /* 104314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104316 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104320 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104324 */     GIR_RootConstrainSelectedInstOperands,
     /* 104325 */     // GIR_Coverage, 16765,
     /* 104325 */     GIR_EraseRootFromParent_Done,
     /* 104326 */   // Label 2221: @104326
     /* 104326 */   GIM_Try, /*On fail goto*//*Label 2222*/ GIMT_Encode4(104372), // Rule ID 16768 //
     /* 104331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasMOVRS_In64BitMode),
     /* 104334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsw256),
     /* 104339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /* 104342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 104346 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104357 */     // (intrinsic_w_chain:{ *:[v16i16] } 13703:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSWZ256m:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /* 104357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSWZ256m),
     /* 104360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104362 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104366 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104370 */     GIR_RootConstrainSelectedInstOperands,
     /* 104371 */     // GIR_Coverage, 16768,
     /* 104371 */     GIR_EraseRootFromParent_Done,
     /* 104372 */   // Label 2222: @104372
     /* 104372 */   GIM_Try, /*On fail goto*//*Label 2223*/ GIMT_Encode4(104418), // Rule ID 16771 //
     /* 104377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_512_HasMOVRS_In64BitMode),
     /* 104380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsd512),
     /* 104385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 104388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 104392 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104403 */     // (intrinsic_w_chain:{ *:[v16i32] } 13698:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSDZm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)
     /* 104403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSDZm),
     /* 104406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104408 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104412 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104416 */     GIR_RootConstrainSelectedInstOperands,
     /* 104417 */     // GIR_Coverage, 16771,
     /* 104417 */     GIR_EraseRootFromParent_Done,
     /* 104418 */   // Label 2223: @104418
     /* 104418 */   GIM_Try, /*On fail goto*//*Label 2224*/ GIMT_Encode4(104464), // Rule ID 16774 //
     /* 104423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasMOVRS_In64BitMode),
     /* 104426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsd128),
     /* 104431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 104434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 104438 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104449 */     // (intrinsic_w_chain:{ *:[v4i32] } 13696:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSDZ128m:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /* 104449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSDZ128m),
     /* 104452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104454 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104458 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104462 */     GIR_RootConstrainSelectedInstOperands,
     /* 104463 */     // GIR_Coverage, 16774,
     /* 104463 */     GIR_EraseRootFromParent_Done,
     /* 104464 */   // Label 2224: @104464
     /* 104464 */   GIM_Try, /*On fail goto*//*Label 2225*/ GIMT_Encode4(104510), // Rule ID 16777 //
     /* 104469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasMOVRS_In64BitMode),
     /* 104472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsd256),
     /* 104477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 104480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 104484 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104495 */     // (intrinsic_w_chain:{ *:[v8i32] } 13697:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSDZ256m:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /* 104495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSDZ256m),
     /* 104498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104500 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104504 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104508 */     GIR_RootConstrainSelectedInstOperands,
     /* 104509 */     // GIR_Coverage, 16777,
     /* 104509 */     GIR_EraseRootFromParent_Done,
     /* 104510 */   // Label 2225: @104510
     /* 104510 */   GIM_Try, /*On fail goto*//*Label 2226*/ GIMT_Encode4(104556), // Rule ID 16780 //
     /* 104515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_512_HasMOVRS_In64BitMode),
     /* 104518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsq512),
     /* 104523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /* 104526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 104530 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104541 */     // (intrinsic_w_chain:{ *:[v8i64] } 13701:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSQZm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /* 104541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSQZm),
     /* 104544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104546 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104550 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104554 */     GIR_RootConstrainSelectedInstOperands,
     /* 104555 */     // GIR_Coverage, 16780,
     /* 104555 */     GIR_EraseRootFromParent_Done,
     /* 104556 */   // Label 2226: @104556
     /* 104556 */   GIM_Try, /*On fail goto*//*Label 2227*/ GIMT_Encode4(104602), // Rule ID 16783 //
     /* 104561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasMOVRS_In64BitMode),
     /* 104564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsq128),
     /* 104569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 104572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 104576 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104587 */     // (intrinsic_w_chain:{ *:[v2i64] } 13699:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSQZ128m:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /* 104587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSQZ128m),
     /* 104590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104592 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104596 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104600 */     GIR_RootConstrainSelectedInstOperands,
     /* 104601 */     // GIR_Coverage, 16783,
     /* 104601 */     GIR_EraseRootFromParent_Done,
     /* 104602 */   // Label 2227: @104602
     /* 104602 */   GIM_Try, /*On fail goto*//*Label 2228*/ GIMT_Encode4(104648), // Rule ID 16786 //
     /* 104607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasMOVRS_In64BitMode),
     /* 104610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsq256),
     /* 104615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 104618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 104622 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104633 */     // (intrinsic_w_chain:{ *:[v4i64] } 13700:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSQZ256m:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /* 104633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSQZ256m),
     /* 104636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104638 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104642 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104646 */     GIR_RootConstrainSelectedInstOperands,
     /* 104647 */     // GIR_Coverage, 16786,
     /* 104647 */     GIR_EraseRootFromParent_Done,
     /* 104648 */   // Label 2228: @104648
     /* 104648 */   GIM_Try, /*On fail goto*//*Label 2229*/ GIMT_Encode4(104694), // Rule ID 17094 //
     /* 104653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoEGPR),
     /* 104656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrssd),
     /* 104661 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 104664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 104668 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104679 */     // (intrinsic_void 15025:{ *:[iPTR] }, GR32:{ *:[i32] }:$src, addr:{ *:[iPTR] }:$dst)  =>  (WRSSD addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /* 104679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRSSD),
     /* 104682 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 104686 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 104688 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104692 */     GIR_RootConstrainSelectedInstOperands,
     /* 104693 */     // GIR_Coverage, 17094,
     /* 104693 */     GIR_EraseRootFromParent_Done,
     /* 104694 */   // Label 2229: @104694
     /* 104694 */   GIM_Try, /*On fail goto*//*Label 2230*/ GIMT_Encode4(104740), // Rule ID 17095 //
     /* 104699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoEGPR),
     /* 104702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrssq),
     /* 104707 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 104710 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 104714 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104725 */     // (intrinsic_void 15026:{ *:[iPTR] }, GR64:{ *:[i64] }:$src, addr:{ *:[iPTR] }:$dst)  =>  (WRSSQ addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /* 104725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRSSQ),
     /* 104728 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 104732 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 104734 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104738 */     GIR_RootConstrainSelectedInstOperands,
     /* 104739 */     // GIR_Coverage, 17095,
     /* 104739 */     GIR_EraseRootFromParent_Done,
     /* 104740 */   // Label 2230: @104740
     /* 104740 */   GIM_Try, /*On fail goto*//*Label 2231*/ GIMT_Encode4(104786), // Rule ID 17096 //
     /* 104745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoEGPR),
     /* 104748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrussd),
     /* 104753 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 104756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 104760 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104771 */     // (intrinsic_void 15027:{ *:[iPTR] }, GR32:{ *:[i32] }:$src, addr:{ *:[iPTR] }:$dst)  =>  (WRUSSD addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /* 104771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRUSSD),
     /* 104774 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 104778 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 104780 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104784 */     GIR_RootConstrainSelectedInstOperands,
     /* 104785 */     // GIR_Coverage, 17096,
     /* 104785 */     GIR_EraseRootFromParent_Done,
     /* 104786 */   // Label 2231: @104786
     /* 104786 */   GIM_Try, /*On fail goto*//*Label 2232*/ GIMT_Encode4(104832), // Rule ID 17097 //
     /* 104791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoEGPR),
     /* 104794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrussq),
     /* 104799 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 104802 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 104806 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104817 */     // (intrinsic_void 15028:{ *:[iPTR] }, GR64:{ *:[i64] }:$src, addr:{ *:[iPTR] }:$dst)  =>  (WRUSSQ addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /* 104817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRUSSQ),
     /* 104820 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 104824 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 104826 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104830 */     GIR_RootConstrainSelectedInstOperands,
     /* 104831 */     // GIR_Coverage, 17097,
     /* 104831 */     GIR_EraseRootFromParent_Done,
     /* 104832 */   // Label 2232: @104832
     /* 104832 */   GIM_Try, /*On fail goto*//*Label 2233*/ GIMT_Encode4(104878), // Rule ID 17098 //
     /* 104837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_In64BitMode),
     /* 104840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrssd),
     /* 104845 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 104848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 104852 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104863 */     // (intrinsic_void 15025:{ *:[iPTR] }, GR32:{ *:[i32] }:$src, addr:{ *:[iPTR] }:$dst)  =>  (WRSSD_EVEX addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /* 104863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRSSD_EVEX),
     /* 104866 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 104870 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 104872 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104876 */     GIR_RootConstrainSelectedInstOperands,
     /* 104877 */     // GIR_Coverage, 17098,
     /* 104877 */     GIR_EraseRootFromParent_Done,
     /* 104878 */   // Label 2233: @104878
     /* 104878 */   GIM_Try, /*On fail goto*//*Label 2234*/ GIMT_Encode4(104924), // Rule ID 17099 //
     /* 104883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_In64BitMode),
     /* 104886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrssq),
     /* 104891 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 104894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 104898 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104909 */     // (intrinsic_void 15026:{ *:[iPTR] }, GR64:{ *:[i64] }:$src, addr:{ *:[iPTR] }:$dst)  =>  (WRSSQ_EVEX addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /* 104909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRSSQ_EVEX),
     /* 104912 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 104916 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 104918 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104922 */     GIR_RootConstrainSelectedInstOperands,
     /* 104923 */     // GIR_Coverage, 17099,
     /* 104923 */     GIR_EraseRootFromParent_Done,
     /* 104924 */   // Label 2234: @104924
     /* 104924 */   GIM_Try, /*On fail goto*//*Label 2235*/ GIMT_Encode4(104970), // Rule ID 17100 //
     /* 104929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_In64BitMode),
     /* 104932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrussd),
     /* 104937 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 104940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 104944 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104955 */     // (intrinsic_void 15027:{ *:[iPTR] }, GR32:{ *:[i32] }:$src, addr:{ *:[iPTR] }:$dst)  =>  (WRUSSD_EVEX addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /* 104955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRUSSD_EVEX),
     /* 104958 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 104962 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 104964 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104968 */     GIR_RootConstrainSelectedInstOperands,
     /* 104969 */     // GIR_Coverage, 17100,
     /* 104969 */     GIR_EraseRootFromParent_Done,
     /* 104970 */   // Label 2235: @104970
     /* 104970 */   GIM_Try, /*On fail goto*//*Label 2236*/ GIMT_Encode4(105016), // Rule ID 17101 //
     /* 104975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_In64BitMode),
     /* 104978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrussq),
     /* 104983 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 104986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 104990 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105001 */     // (intrinsic_void 15028:{ *:[iPTR] }, GR64:{ *:[i64] }:$src, addr:{ *:[iPTR] }:$dst)  =>  (WRUSSQ_EVEX addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /* 105001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRUSSQ_EVEX),
     /* 105004 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 105008 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 105010 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105014 */     GIR_RootConstrainSelectedInstOperands,
     /* 105015 */     // GIR_Coverage, 17101,
     /* 105015 */     GIR_EraseRootFromParent_Done,
     /* 105016 */   // Label 2236: @105016
     /* 105016 */   GIM_Try, /*On fail goto*//*Label 2237*/ GIMT_Encode4(105062), // Rule ID 17127 //
     /* 105021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasINVPCID_Not64BitMode),
     /* 105024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_invpcid),
     /* 105029 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 105032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 105036 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 105040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105047 */     // (intrinsic_void 14589:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)  =>  (INVPCID32 GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 105047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INVPCID32),
     /* 105050 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 105052 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 105056 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105060 */     GIR_RootConstrainSelectedInstOperands,
     /* 105061 */     // GIR_Coverage, 17127,
     /* 105061 */     GIR_EraseRootFromParent_Done,
     /* 105062 */   // Label 2237: @105062
     /* 105062 */   GIM_Try, /*On fail goto*//*Label 2238*/ GIMT_Encode4(105154), // Rule ID 22379 //
     /* 105067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasINVPCID_NoEGPR),
     /* 105070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_invpcid),
     /* 105075 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 105078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 105082 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 105086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105093 */     // (intrinsic_void 14589:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)  =>  (INVPCID64 (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOV32rr:{ *:[i32] } GR32:{ *:[i32] }:$src1), sub_32bit:{ *:[i32] }), addr:{ *:[iPTR] }:$src2)
     /* 105093 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 105096 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(X86::MOV32rr),
     /* 105100 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105105 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 105109 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105111 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105114 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 105118 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105123 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 105126 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 105129 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/6,
     /* 105132 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 105137 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 105142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INVPCID64),
     /* 105145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105148 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 105152 */     GIR_RootConstrainSelectedInstOperands,
     /* 105153 */     // GIR_Coverage, 22379,
     /* 105153 */     GIR_EraseRootFromParent_Done,
     /* 105154 */   // Label 2238: @105154
     /* 105154 */   GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(105246), // Rule ID 22380 //
     /* 105159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasINVPCID),
     /* 105162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_invpcid),
     /* 105167 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 105170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 105174 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 105178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105185 */     // (intrinsic_void 14589:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)  =>  (INVPCID64_EVEX (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOV32rr:{ *:[i32] } GR32:{ *:[i32] }:$src1), sub_32bit:{ *:[i32] }), addr:{ *:[iPTR] }:$src2)
     /* 105185 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 105188 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(X86::MOV32rr),
     /* 105192 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105197 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 105201 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105203 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105206 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 105210 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105215 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 105218 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 105221 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/6,
     /* 105224 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 105229 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 105234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INVPCID64_EVEX),
     /* 105237 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105240 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 105244 */     GIR_RootConstrainSelectedInstOperands,
     /* 105245 */     // GIR_Coverage, 22380,
     /* 105245 */     GIR_EraseRootFromParent_Done,
     /* 105246 */   // Label 2239: @105246
     /* 105246 */   GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(105292), // Rule ID 131 //
     /* 105251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVDIRI_NoEGPR),
     /* 105254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_directstore32),
     /* 105259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 105262 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 105270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105277 */     // (intrinsic_void 14568:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)  =>  (MOVDIRI32 addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /* 105277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVDIRI32),
     /* 105280 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 105284 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 105286 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105290 */     GIR_RootConstrainSelectedInstOperands,
     /* 105291 */     // GIR_Coverage, 131,
     /* 105291 */     GIR_EraseRootFromParent_Done,
     /* 105292 */   // Label 2240: @105292
     /* 105292 */   GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(105338), // Rule ID 132 //
     /* 105297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVDIRI_In64BitMode_NoEGPR),
     /* 105300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_directstore64),
     /* 105305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 105308 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105323 */     // (intrinsic_void 14569:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)  =>  (MOVDIRI64 addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /* 105323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVDIRI64),
     /* 105326 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 105330 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 105332 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105336 */     GIR_RootConstrainSelectedInstOperands,
     /* 105337 */     // GIR_Coverage, 132,
     /* 105337 */     GIR_EraseRootFromParent_Done,
     /* 105338 */   // Label 2241: @105338
     /* 105338 */   GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(105384), // Rule ID 133 //
     /* 105343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVDIRI_In64BitMode),
     /* 105346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_directstore32),
     /* 105351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 105354 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 105362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105369 */     // (intrinsic_void 14568:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)  =>  (MOVDIRI32_EVEX addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /* 105369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVDIRI32_EVEX),
     /* 105372 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 105376 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 105378 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105382 */     GIR_RootConstrainSelectedInstOperands,
     /* 105383 */     // GIR_Coverage, 133,
     /* 105383 */     GIR_EraseRootFromParent_Done,
     /* 105384 */   // Label 2242: @105384
     /* 105384 */   GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(105430), // Rule ID 134 //
     /* 105389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVDIRI_In64BitMode),
     /* 105392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_directstore64),
     /* 105397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 105400 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105415 */     // (intrinsic_void 14569:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)  =>  (MOVDIRI64_EVEX addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /* 105415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVDIRI64_EVEX),
     /* 105418 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 105422 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 105424 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105428 */     GIR_RootConstrainSelectedInstOperands,
     /* 105429 */     // GIR_Coverage, 134,
     /* 105429 */     GIR_EraseRootFromParent_Done,
     /* 105430 */   // Label 2243: @105430
     /* 105430 */   GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(105477), // Rule ID 135 //
     /* 105435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVDIR64B_NoEGPR),
     /* 105438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_movdir64b),
     /* 105443 */     // MIs[0] dst
     /* 105443 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /* 105447 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 105451 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 105455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105462 */     // (intrinsic_void 14669:{ *:[iPTR] }, GR32:{ *:[i32] }:$dst, addr:{ *:[iPTR] }:$src)  =>  (MOVDIR64B32 GR32:{ *:[i32] }:$dst, addr:{ *:[iPTR] }:$src)
     /* 105462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVDIR64B32),
     /* 105465 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 105467 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 105471 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105475 */     GIR_RootConstrainSelectedInstOperands,
     /* 105476 */     // GIR_Coverage, 135,
     /* 105476 */     GIR_EraseRootFromParent_Done,
     /* 105477 */   // Label 2244: @105477
     /* 105477 */   GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(105524), // Rule ID 136 //
     /* 105482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVDIR64B_In64BitMode_NoEGPR),
     /* 105485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_movdir64b),
     /* 105490 */     // MIs[0] dst
     /* 105490 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105498 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 105502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105509 */     // (intrinsic_void 14669:{ *:[iPTR] }, GR64:{ *:[i64] }:$dst, addr:{ *:[iPTR] }:$src)  =>  (MOVDIR64B64 GR64:{ *:[i64] }:$dst, addr:{ *:[iPTR] }:$src)
     /* 105509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVDIR64B64),
     /* 105512 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 105514 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 105518 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105522 */     GIR_RootConstrainSelectedInstOperands,
     /* 105523 */     // GIR_Coverage, 136,
     /* 105523 */     GIR_EraseRootFromParent_Done,
     /* 105524 */   // Label 2245: @105524
     /* 105524 */   GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(105571), // Rule ID 137 //
     /* 105529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVDIR64B_In64BitMode),
     /* 105532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_movdir64b),
     /* 105537 */     // MIs[0] dst
     /* 105537 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /* 105541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 105545 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 105549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105556 */     // (intrinsic_void 14669:{ *:[iPTR] }, GR32:{ *:[i32] }:$dst, addr:{ *:[iPTR] }:$src)  =>  (MOVDIR64B32_EVEX GR32:{ *:[i32] }:$dst, addr:{ *:[iPTR] }:$src)
     /* 105556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVDIR64B32_EVEX),
     /* 105559 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 105561 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 105565 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105569 */     GIR_RootConstrainSelectedInstOperands,
     /* 105570 */     // GIR_Coverage, 137,
     /* 105570 */     GIR_EraseRootFromParent_Done,
     /* 105571 */   // Label 2246: @105571
     /* 105571 */   GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(105618), // Rule ID 138 //
     /* 105576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVDIR64B_In64BitMode),
     /* 105579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_movdir64b),
     /* 105584 */     // MIs[0] dst
     /* 105584 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105592 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 105596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105603 */     // (intrinsic_void 14669:{ *:[iPTR] }, GR64:{ *:[i64] }:$dst, addr:{ *:[iPTR] }:$src)  =>  (MOVDIR64B64_EVEX GR64:{ *:[i64] }:$dst, addr:{ *:[iPTR] }:$src)
     /* 105603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVDIR64B64_EVEX),
     /* 105606 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 105608 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 105612 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105616 */     GIR_RootConstrainSelectedInstOperands,
     /* 105617 */     // GIR_Coverage, 138,
     /* 105617 */     GIR_EraseRootFromParent_Done,
     /* 105618 */   // Label 2247: @105618
     /* 105618 */   GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(105650), // Rule ID 17025 //
     /* 105623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTRANSPOSE_In64BitMode),
     /* 105626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ttransposed),
     /* 105631 */     // MIs[0] dst
     /* 105631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 105634 */     // MIs[0] src
     /* 105634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 105637 */     // (intrinsic_void 14975:{ *:[iPTR] }, (timm:{ *:[i8] }):$dst, (timm:{ *:[i8] }):$src)  =>  (PTTRANSPOSED (timm:{ *:[i8] }):$dst, (timm:{ *:[i8] }):$src)
     /* 105637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTTRANSPOSED),
     /* 105640 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 105642 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 105644 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105648 */     GIR_RootConstrainSelectedInstOperands,
     /* 105649 */     // GIR_Coverage, 17025,
     /* 105649 */     GIR_EraseRootFromParent_Done,
     /* 105650 */   // Label 2248: @105650
     /* 105650 */   GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(105682), // Rule ID 17037 //
     /* 105655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXCOMPLEX_HasAMXTRANSPOSE_In64BitMode),
     /* 105658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tconjtfp16),
     /* 105663 */     // MIs[0] dst
     /* 105663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 105666 */     // MIs[0] src
     /* 105666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 105669 */     // (intrinsic_void 14914:{ *:[iPTR] }, (timm:{ *:[i8] }):$dst, (timm:{ *:[i8] }):$src)  =>  (PTCONJTFP16 (timm:{ *:[i8] }):$dst, (timm:{ *:[i8] }):$src)
     /* 105669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCONJTFP16),
     /* 105672 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 105674 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 105676 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105680 */     GIR_RootConstrainSelectedInstOperands,
     /* 105681 */     // GIR_Coverage, 17037,
     /* 105681 */     GIR_EraseRootFromParent_Done,
     /* 105682 */   // Label 2249: @105682
     /* 105682 */   GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(105725), // Rule ID 17152 //
     /* 105687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::asan_check_memaccess),
     /* 105692 */     // MIs[0] addr
     /* 105692 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64PLTSafeRegClassID),
     /* 105700 */     // MIs[0] accessinfo
     /* 105700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 105703 */     // (intrinsic_void 9:{ *:[iPTR] }, GR64PLTSafe:{ *:[i64] }:$addr, (timm:{ *:[i32] }):$accessinfo)  =>  (ASAN_CHECK_MEMACCESS:{ *:[i64] } GR64PLTSafe:{ *:[i64] }:$addr, (timm:{ *:[i32] }):$accessinfo)
     /* 105703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ASAN_CHECK_MEMACCESS),
     /* 105706 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 105708 */     GIR_RootToRootCopy, /*OpIdx*/2, // accessinfo
     /* 105710 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::R10*/0,
     /* 105713 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::R11*/1,
     /* 105716 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/2,
     /* 105719 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105723 */     GIR_RootConstrainSelectedInstOperands,
     /* 105724 */     // GIR_Coverage, 17152,
     /* 105724 */     GIR_EraseRootFromParent_Done,
     /* 105725 */   // Label 2250: @105725
     /* 105725 */   GIM_Try, /*On fail goto*//*Label 2251*/ GIMT_Encode4(105765), // Rule ID 17078 //
     /* 105730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUSERMSR_NoEGPR),
     /* 105733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_urdmsr),
     /* 105738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 105741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 105744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105752 */     // (intrinsic_w_chain:{ *:[i64] } 14979:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (URDMSRrr:{ *:[i64] } GR64:{ *:[i64] }:$src)
     /* 105752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::URDMSRrr),
     /* 105755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105757 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 105759 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105763 */     GIR_RootConstrainSelectedInstOperands,
     /* 105764 */     // GIR_Coverage, 17078,
     /* 105764 */     GIR_EraseRootFromParent_Done,
     /* 105765 */   // Label 2251: @105765
     /* 105765 */   GIM_Try, /*On fail goto*//*Label 2252*/ GIMT_Encode4(105805), // Rule ID 17082 //
     /* 105770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasUSERMSR_In64BitMode),
     /* 105773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_urdmsr),
     /* 105778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 105781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 105784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105792 */     // (intrinsic_w_chain:{ *:[i64] } 14979:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (URDMSRrr_EVEX:{ *:[i64] } GR64:{ *:[i64] }:$src)
     /* 105792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::URDMSRrr_EVEX),
     /* 105795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105797 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 105799 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105803 */     GIR_RootConstrainSelectedInstOperands,
     /* 105804 */     // GIR_Coverage, 17082,
     /* 105804 */     GIR_EraseRootFromParent_Done,
     /* 105805 */   // Label 2252: @105805
     /* 105805 */   GIM_Try, /*On fail goto*//*Label 2253*/ GIMT_Encode4(105842), // Rule ID 17090 //
     /* 105810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdsspd),
     /* 105815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 105818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 105821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 105825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 105829 */     // (intrinsic_w_chain:{ *:[i32] } 14695:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (RDSSPD:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /* 105829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDSSPD),
     /* 105832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105834 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 105836 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105840 */     GIR_RootConstrainSelectedInstOperands,
     /* 105841 */     // GIR_Coverage, 17090,
     /* 105841 */     GIR_EraseRootFromParent_Done,
     /* 105842 */   // Label 2253: @105842
     /* 105842 */   GIM_Try, /*On fail goto*//*Label 2254*/ GIMT_Encode4(105879), // Rule ID 17091 //
     /* 105847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdsspq),
     /* 105852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 105855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 105858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105866 */     // (intrinsic_w_chain:{ *:[i64] } 14696:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (RDSSPQ:{ *:[i64] } GR64:{ *:[i64] }:$src)
     /* 105866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDSSPQ),
     /* 105869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105871 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 105873 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105877 */     GIR_RootConstrainSelectedInstOperands,
     /* 105878 */     // GIR_Coverage, 17091,
     /* 105878 */     GIR_EraseRootFromParent_Done,
     /* 105879 */   // Label 2254: @105879
     /* 105879 */   GIM_Try, /*On fail goto*//*Label 2255*/ GIMT_Encode4(105943), // Rule ID 3086 //
     /* 105884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE3),
     /* 105887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse3_mwait),
     /* 105892 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 105895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 105898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32_ArgRef_and_GR32_CBRegClassID),
     /* 105902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 105906 */     // (intrinsic_void 14820:{ *:[iPTR] }, ECX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (MWAITrr)
     /* 105906 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105910 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105916 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // EAX
     /* 105920 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105924 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::ECX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105930 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // ECX
     /* 105934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MWAITrr),
     /* 105937 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105941 */     GIR_RootConstrainSelectedInstOperands,
     /* 105942 */     // GIR_Coverage, 3086,
     /* 105942 */     GIR_EraseRootFromParent_Done,
     /* 105943 */   // Label 2255: @105943
     /* 105943 */   GIM_Try, /*On fail goto*//*Label 2256*/ GIMT_Encode4(105983), // Rule ID 17080 //
     /* 105948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUSERMSR_NoEGPR),
     /* 105951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_uwrmsr),
     /* 105956 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 105959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 105962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105970 */     // (intrinsic_void 14980:{ *:[iPTR] }, GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (UWRMSRrr GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 105970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::UWRMSRrr),
     /* 105973 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 105975 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 105977 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105981 */     GIR_RootConstrainSelectedInstOperands,
     /* 105982 */     // GIR_Coverage, 17080,
     /* 105982 */     GIR_EraseRootFromParent_Done,
     /* 105983 */   // Label 2256: @105983
     /* 105983 */   GIM_Try, /*On fail goto*//*Label 2257*/ GIMT_Encode4(106023), // Rule ID 17084 //
     /* 105988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasUSERMSR_In64BitMode),
     /* 105991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_uwrmsr),
     /* 105996 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 105999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 106002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 106006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 106010 */     // (intrinsic_void 14980:{ *:[iPTR] }, GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (UWRMSRrr_EVEX GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 106010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::UWRMSRrr_EVEX),
     /* 106013 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 106015 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 106017 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106021 */     GIR_RootConstrainSelectedInstOperands,
     /* 106022 */     // GIR_Coverage, 17084,
     /* 106022 */     GIR_EraseRootFromParent_Done,
     /* 106023 */   // Label 2257: @106023
     /* 106023 */   GIM_Reject,
     /* 106024 */ // Label 2193: @106024
     /* 106024 */ GIM_Try, /*On fail goto*//*Label 2258*/ GIMT_Encode4(109569),
     /* 106029 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 106032 */   GIM_Try, /*On fail goto*//*Label 2259*/ GIMT_Encode4(106104), // Rule ID 123 //
     /* 106037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 106040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_lwpval32),
     /* 106045 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 106048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 106051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 106055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 106059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 106063 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106066 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 106070 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 106074 */     // MIs[0] cntl
     /* 106074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 106077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106079 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106086 */     // (intrinsic_void 14596:{ *:[iPTR] }, GR32:{ *:[i32] }:$src0, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (timm:{ *:[i32] }):$cntl)  =>  (LWPVAL32rmi GR32:{ *:[i32] }:$src0, addr:{ *:[iPTR] }:$src1, (timm:{ *:[i32] }):$cntl)
     /* 106086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LWPVAL32rmi),
     /* 106089 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 106091 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 106095 */     GIR_RootToRootCopy, /*OpIdx*/3, // cntl
     /* 106097 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 106102 */     GIR_RootConstrainSelectedInstOperands,
     /* 106103 */     // GIR_Coverage, 123,
     /* 106103 */     GIR_EraseRootFromParent_Done,
     /* 106104 */   // Label 2259: @106104
     /* 106104 */   GIM_Try, /*On fail goto*//*Label 2260*/ GIMT_Encode4(106176), // Rule ID 125 //
     /* 106109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 106112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_lwpval64),
     /* 106117 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 106120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 106123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 106127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 106131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 106135 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106138 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 106142 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 106146 */     // MIs[0] cntl
     /* 106146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 106149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106151 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106158 */     // (intrinsic_void 14597:{ *:[iPTR] }, GR64:{ *:[i64] }:$src0, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (timm:{ *:[i32] }):$cntl)  =>  (LWPVAL64rmi GR64:{ *:[i64] }:$src0, addr:{ *:[iPTR] }:$src1, (timm:{ *:[i32] }):$cntl)
     /* 106158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LWPVAL64rmi),
     /* 106161 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 106163 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 106167 */     GIR_RootToRootCopy, /*OpIdx*/3, // cntl
     /* 106169 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 106174 */     GIR_RootConstrainSelectedInstOperands,
     /* 106175 */     // GIR_Coverage, 125,
     /* 106175 */     GIR_EraseRootFromParent_Done,
     /* 106176 */   // Label 2260: @106176
     /* 106176 */   GIM_Try, /*On fail goto*//*Label 2261*/ GIMT_Encode4(106231), // Rule ID 3387 //
     /* 106181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 106184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx_maskload_ps),
     /* 106189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 106192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 106195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106199 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 106203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106214 */     // (intrinsic_w_chain:{ *:[v4f32] } 13442:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src1)  =>  (VMASKMOVPSrm:{ *:[v4f32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 106214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVPSrm),
     /* 106217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106219 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 106221 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 106225 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106229 */     GIR_RootConstrainSelectedInstOperands,
     /* 106230 */     // GIR_Coverage, 3387,
     /* 106230 */     GIR_EraseRootFromParent_Done,
     /* 106231 */   // Label 2261: @106231
     /* 106231 */   GIM_Try, /*On fail goto*//*Label 2262*/ GIMT_Encode4(106286), // Rule ID 3388 //
     /* 106236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 106239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx_maskload_ps_256),
     /* 106244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 106247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 106250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106254 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 106258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106269 */     // (intrinsic_w_chain:{ *:[v8f32] } 13443:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v8i32] }:$src1)  =>  (VMASKMOVPSYrm:{ *:[v8f32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 106269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVPSYrm),
     /* 106272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106274 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 106276 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 106280 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106284 */     GIR_RootConstrainSelectedInstOperands,
     /* 106285 */     // GIR_Coverage, 3388,
     /* 106285 */     GIR_EraseRootFromParent_Done,
     /* 106286 */   // Label 2262: @106286
     /* 106286 */   GIM_Try, /*On fail goto*//*Label 2263*/ GIMT_Encode4(106341), // Rule ID 3391 //
     /* 106291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 106294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx_maskload_pd),
     /* 106299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 106302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 106305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106309 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 106313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106324 */     // (intrinsic_w_chain:{ *:[v2f64] } 13440:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src1)  =>  (VMASKMOVPDrm:{ *:[v2f64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 106324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVPDrm),
     /* 106327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106329 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 106331 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 106335 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106339 */     GIR_RootConstrainSelectedInstOperands,
     /* 106340 */     // GIR_Coverage, 3391,
     /* 106340 */     GIR_EraseRootFromParent_Done,
     /* 106341 */   // Label 2263: @106341
     /* 106341 */   GIM_Try, /*On fail goto*//*Label 2264*/ GIMT_Encode4(106396), // Rule ID 3392 //
     /* 106346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 106349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx_maskload_pd_256),
     /* 106354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 106357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 106360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106364 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 106368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106379 */     // (intrinsic_w_chain:{ *:[v4f64] } 13441:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v4i64] }:$src1)  =>  (VMASKMOVPDYrm:{ *:[v4f64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 106379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVPDYrm),
     /* 106382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106384 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 106386 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 106390 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106394 */     GIR_RootConstrainSelectedInstOperands,
     /* 106395 */     // GIR_Coverage, 3392,
     /* 106395 */     GIR_EraseRootFromParent_Done,
     /* 106396 */   // Label 2264: @106396
     /* 106396 */   GIM_Try, /*On fail goto*//*Label 2265*/ GIMT_Encode4(106451), // Rule ID 3465 //
     /* 106401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 106404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_maskload_d),
     /* 106409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 106412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 106415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106419 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 106423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106434 */     // (intrinsic_w_chain:{ *:[v4i32] } 13740:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src1)  =>  (VPMASKMOVDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 106434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMASKMOVDrm),
     /* 106437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106439 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 106441 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 106445 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106449 */     GIR_RootConstrainSelectedInstOperands,
     /* 106450 */     // GIR_Coverage, 3465,
     /* 106450 */     GIR_EraseRootFromParent_Done,
     /* 106451 */   // Label 2265: @106451
     /* 106451 */   GIM_Try, /*On fail goto*//*Label 2266*/ GIMT_Encode4(106506), // Rule ID 3466 //
     /* 106456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 106459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_maskload_d_256),
     /* 106464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 106467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 106470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106474 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 106478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106489 */     // (intrinsic_w_chain:{ *:[v8i32] } 13741:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v8i32] }:$src1)  =>  (VPMASKMOVDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 106489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMASKMOVDYrm),
     /* 106492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106494 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 106496 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 106500 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106504 */     GIR_RootConstrainSelectedInstOperands,
     /* 106505 */     // GIR_Coverage, 3466,
     /* 106505 */     GIR_EraseRootFromParent_Done,
     /* 106506 */   // Label 2266: @106506
     /* 106506 */   GIM_Try, /*On fail goto*//*Label 2267*/ GIMT_Encode4(106561), // Rule ID 3469 //
     /* 106511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 106514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_maskload_q),
     /* 106519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 106522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 106525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106529 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 106533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106544 */     // (intrinsic_w_chain:{ *:[v2i64] } 13742:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src1)  =>  (VPMASKMOVQrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 106544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMASKMOVQrm),
     /* 106547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106549 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 106551 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 106555 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106559 */     GIR_RootConstrainSelectedInstOperands,
     /* 106560 */     // GIR_Coverage, 3469,
     /* 106560 */     GIR_EraseRootFromParent_Done,
     /* 106561 */   // Label 2267: @106561
     /* 106561 */   GIM_Try, /*On fail goto*//*Label 2268*/ GIMT_Encode4(106616), // Rule ID 3470 //
     /* 106566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 106569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_maskload_q_256),
     /* 106574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 106577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 106580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106584 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 106588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106599 */     // (intrinsic_w_chain:{ *:[v4i64] } 13743:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v4i64] }:$src1)  =>  (VPMASKMOVQYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 106599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMASKMOVQYrm),
     /* 106602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106604 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 106606 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 106610 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106614 */     GIR_RootConstrainSelectedInstOperands,
     /* 106615 */     // GIR_Coverage, 3470,
     /* 106615 */     GIR_EraseRootFromParent_Done,
     /* 106616 */   // Label 2268: @106616
     /* 106616 */   GIM_Try, /*On fail goto*//*Label 2269*/ GIMT_Encode4(106671), // Rule ID 3389 //
     /* 106621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 106624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx_maskstore_ps),
     /* 106629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 106632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 106635 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106654 */     // (intrinsic_void 13446:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VMASKMOVPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 106654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVPSmr),
     /* 106657 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 106661 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 106663 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 106665 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106669 */     GIR_RootConstrainSelectedInstOperands,
     /* 106670 */     // GIR_Coverage, 3389,
     /* 106670 */     GIR_EraseRootFromParent_Done,
     /* 106671 */   // Label 2269: @106671
     /* 106671 */   GIM_Try, /*On fail goto*//*Label 2270*/ GIMT_Encode4(106726), // Rule ID 3390 //
     /* 106676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 106679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx_maskstore_ps_256),
     /* 106684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 106687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 106690 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106709 */     // (intrinsic_void 13447:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VMASKMOVPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 106709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVPSYmr),
     /* 106712 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 106716 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 106718 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 106720 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106724 */     GIR_RootConstrainSelectedInstOperands,
     /* 106725 */     // GIR_Coverage, 3390,
     /* 106725 */     GIR_EraseRootFromParent_Done,
     /* 106726 */   // Label 2270: @106726
     /* 106726 */   GIM_Try, /*On fail goto*//*Label 2271*/ GIMT_Encode4(106781), // Rule ID 3393 //
     /* 106731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 106734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx_maskstore_pd),
     /* 106739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 106742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 106745 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106764 */     // (intrinsic_void 13444:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VMASKMOVPDmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 106764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVPDmr),
     /* 106767 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 106771 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 106773 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 106775 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106779 */     GIR_RootConstrainSelectedInstOperands,
     /* 106780 */     // GIR_Coverage, 3393,
     /* 106780 */     GIR_EraseRootFromParent_Done,
     /* 106781 */   // Label 2271: @106781
     /* 106781 */   GIM_Try, /*On fail goto*//*Label 2272*/ GIMT_Encode4(106836), // Rule ID 3394 //
     /* 106786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 106789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx_maskstore_pd_256),
     /* 106794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 106797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 106800 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106819 */     // (intrinsic_void 13445:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VMASKMOVPDYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 106819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVPDYmr),
     /* 106822 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 106826 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 106828 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 106830 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106834 */     GIR_RootConstrainSelectedInstOperands,
     /* 106835 */     // GIR_Coverage, 3394,
     /* 106835 */     GIR_EraseRootFromParent_Done,
     /* 106836 */   // Label 2272: @106836
     /* 106836 */   GIM_Try, /*On fail goto*//*Label 2273*/ GIMT_Encode4(106891), // Rule ID 3467 //
     /* 106841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 106844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx2_maskstore_d),
     /* 106849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 106852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 106855 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106874 */     // (intrinsic_void 13744:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPMASKMOVDmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 106874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMASKMOVDmr),
     /* 106877 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 106881 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 106883 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 106885 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106889 */     GIR_RootConstrainSelectedInstOperands,
     /* 106890 */     // GIR_Coverage, 3467,
     /* 106890 */     GIR_EraseRootFromParent_Done,
     /* 106891 */   // Label 2273: @106891
     /* 106891 */   GIM_Try, /*On fail goto*//*Label 2274*/ GIMT_Encode4(106946), // Rule ID 3468 //
     /* 106896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 106899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx2_maskstore_d_256),
     /* 106904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 106907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 106910 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106929 */     // (intrinsic_void 13745:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPMASKMOVDYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 106929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMASKMOVDYmr),
     /* 106932 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 106936 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 106938 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 106940 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106944 */     GIR_RootConstrainSelectedInstOperands,
     /* 106945 */     // GIR_Coverage, 3468,
     /* 106945 */     GIR_EraseRootFromParent_Done,
     /* 106946 */   // Label 2274: @106946
     /* 106946 */   GIM_Try, /*On fail goto*//*Label 2275*/ GIMT_Encode4(107001), // Rule ID 3471 //
     /* 106951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 106954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx2_maskstore_q),
     /* 106959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 106962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 106965 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106984 */     // (intrinsic_void 13746:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VPMASKMOVQmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 106984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMASKMOVQmr),
     /* 106987 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 106991 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 106993 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 106995 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106999 */     GIR_RootConstrainSelectedInstOperands,
     /* 107000 */     // GIR_Coverage, 3471,
     /* 107000 */     GIR_EraseRootFromParent_Done,
     /* 107001 */   // Label 2275: @107001
     /* 107001 */   GIM_Try, /*On fail goto*//*Label 2276*/ GIMT_Encode4(107056), // Rule ID 3472 //
     /* 107006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 107009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx2_maskstore_q_256),
     /* 107014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 107017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 107020 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 107028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 107032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107039 */     // (intrinsic_void 13747:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VPMASKMOVQYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /* 107039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMASKMOVQYmr),
     /* 107042 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107046 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 107048 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 107050 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107054 */     GIR_RootConstrainSelectedInstOperands,
     /* 107055 */     // GIR_Coverage, 3472,
     /* 107055 */     GIR_EraseRootFromParent_Done,
     /* 107056 */   // Label 2276: @107056
     /* 107056 */   GIM_Try, /*On fail goto*//*Label 2277*/ GIMT_Encode4(107135), // Rule ID 17105 //
     /* 107061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVE),
     /* 107064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsave),
     /* 107069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107075 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107094 */     // (intrinsic_void 15084:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSAVE addr:{ *:[iPTR] }:$dst)
     /* 107094 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107098 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107104 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107108 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107112 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107118 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSAVE),
     /* 107125 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107129 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107133 */     GIR_RootConstrainSelectedInstOperands,
     /* 107134 */     // GIR_Coverage, 17105,
     /* 107134 */     GIR_EraseRootFromParent_Done,
     /* 107135 */   // Label 2277: @107135
     /* 107135 */   GIM_Try, /*On fail goto*//*Label 2278*/ GIMT_Encode4(107214), // Rule ID 17106 //
     /* 107140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVE_In64BitMode),
     /* 107143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsave64),
     /* 107148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107154 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107173 */     // (intrinsic_void 15085:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSAVE64 addr:{ *:[iPTR] }:$dst)
     /* 107173 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107177 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107183 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107191 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107197 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSAVE64),
     /* 107204 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107208 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107212 */     GIR_RootConstrainSelectedInstOperands,
     /* 107213 */     // GIR_Coverage, 17106,
     /* 107213 */     GIR_EraseRootFromParent_Done,
     /* 107214 */   // Label 2278: @107214
     /* 107214 */   GIM_Try, /*On fail goto*//*Label 2279*/ GIMT_Encode4(107293), // Rule ID 17107 //
     /* 107219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVE),
     /* 107222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xrstor),
     /* 107227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107233 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107252 */     // (intrinsic_void 15080:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XRSTOR addr:{ *:[iPTR] }:$dst)
     /* 107252 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107256 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107262 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107266 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107270 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107276 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XRSTOR),
     /* 107283 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107287 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107291 */     GIR_RootConstrainSelectedInstOperands,
     /* 107292 */     // GIR_Coverage, 17107,
     /* 107292 */     GIR_EraseRootFromParent_Done,
     /* 107293 */   // Label 2279: @107293
     /* 107293 */   GIM_Try, /*On fail goto*//*Label 2280*/ GIMT_Encode4(107372), // Rule ID 17108 //
     /* 107298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVE_In64BitMode),
     /* 107301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xrstor64),
     /* 107306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107312 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107331 */     // (intrinsic_void 15081:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XRSTOR64 addr:{ *:[iPTR] }:$dst)
     /* 107331 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107335 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107341 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107345 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107349 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107355 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XRSTOR64),
     /* 107362 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107366 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107370 */     GIR_RootConstrainSelectedInstOperands,
     /* 107371 */     // GIR_Coverage, 17108,
     /* 107371 */     GIR_EraseRootFromParent_Done,
     /* 107372 */   // Label 2280: @107372
     /* 107372 */   GIM_Try, /*On fail goto*//*Label 2281*/ GIMT_Encode4(107451), // Rule ID 17109 //
     /* 107377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVEOPT),
     /* 107380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsaveopt),
     /* 107385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107391 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107410 */     // (intrinsic_void 15088:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSAVEOPT addr:{ *:[iPTR] }:$dst)
     /* 107410 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107414 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107420 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107424 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107428 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107434 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSAVEOPT),
     /* 107441 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107445 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107449 */     GIR_RootConstrainSelectedInstOperands,
     /* 107450 */     // GIR_Coverage, 17109,
     /* 107450 */     GIR_EraseRootFromParent_Done,
     /* 107451 */   // Label 2281: @107451
     /* 107451 */   GIM_Try, /*On fail goto*//*Label 2282*/ GIMT_Encode4(107530), // Rule ID 17110 //
     /* 107456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVEOPT_In64BitMode),
     /* 107459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsaveopt64),
     /* 107464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107470 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107489 */     // (intrinsic_void 15089:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSAVEOPT64 addr:{ *:[iPTR] }:$dst)
     /* 107489 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107493 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107499 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107503 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107507 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107513 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSAVEOPT64),
     /* 107520 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107524 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107528 */     GIR_RootConstrainSelectedInstOperands,
     /* 107529 */     // GIR_Coverage, 17110,
     /* 107529 */     GIR_EraseRootFromParent_Done,
     /* 107530 */   // Label 2282: @107530
     /* 107530 */   GIM_Try, /*On fail goto*//*Label 2283*/ GIMT_Encode4(107609), // Rule ID 17111 //
     /* 107535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVEC),
     /* 107538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsavec),
     /* 107543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107549 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107568 */     // (intrinsic_void 15086:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSAVEC addr:{ *:[iPTR] }:$dst)
     /* 107568 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107572 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107578 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107582 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107586 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107592 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSAVEC),
     /* 107599 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107603 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107607 */     GIR_RootConstrainSelectedInstOperands,
     /* 107608 */     // GIR_Coverage, 17111,
     /* 107608 */     GIR_EraseRootFromParent_Done,
     /* 107609 */   // Label 2283: @107609
     /* 107609 */   GIM_Try, /*On fail goto*//*Label 2284*/ GIMT_Encode4(107688), // Rule ID 17112 //
     /* 107614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVEC_In64BitMode),
     /* 107617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsavec64),
     /* 107622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107628 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107647 */     // (intrinsic_void 15087:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSAVEC64 addr:{ *:[iPTR] }:$dst)
     /* 107647 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107651 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107657 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107665 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107671 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSAVEC64),
     /* 107678 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107682 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107686 */     GIR_RootConstrainSelectedInstOperands,
     /* 107687 */     // GIR_Coverage, 17112,
     /* 107687 */     GIR_EraseRootFromParent_Done,
     /* 107688 */   // Label 2284: @107688
     /* 107688 */   GIM_Try, /*On fail goto*//*Label 2285*/ GIMT_Encode4(107767), // Rule ID 17113 //
     /* 107693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVES),
     /* 107696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsaves),
     /* 107701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107707 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107726 */     // (intrinsic_void 15090:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSAVES addr:{ *:[iPTR] }:$dst)
     /* 107726 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107730 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107736 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107740 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107744 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107750 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSAVES),
     /* 107757 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107761 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107765 */     GIR_RootConstrainSelectedInstOperands,
     /* 107766 */     // GIR_Coverage, 17113,
     /* 107766 */     GIR_EraseRootFromParent_Done,
     /* 107767 */   // Label 2285: @107767
     /* 107767 */   GIM_Try, /*On fail goto*//*Label 2286*/ GIMT_Encode4(107846), // Rule ID 17114 //
     /* 107772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVE_In64BitMode),
     /* 107775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsaves64),
     /* 107780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107786 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107805 */     // (intrinsic_void 15091:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSAVES64 addr:{ *:[iPTR] }:$dst)
     /* 107805 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107809 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107815 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107823 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107829 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSAVES64),
     /* 107836 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107840 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107844 */     GIR_RootConstrainSelectedInstOperands,
     /* 107845 */     // GIR_Coverage, 17114,
     /* 107845 */     GIR_EraseRootFromParent_Done,
     /* 107846 */   // Label 2286: @107846
     /* 107846 */   GIM_Try, /*On fail goto*//*Label 2287*/ GIMT_Encode4(107925), // Rule ID 17115 //
     /* 107851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVES),
     /* 107854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xrstors),
     /* 107859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107865 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107884 */     // (intrinsic_void 15082:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XRSTORS addr:{ *:[iPTR] }:$dst)
     /* 107884 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107888 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107894 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107898 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107902 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107908 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XRSTORS),
     /* 107915 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107919 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107923 */     GIR_RootConstrainSelectedInstOperands,
     /* 107924 */     // GIR_Coverage, 17115,
     /* 107924 */     GIR_EraseRootFromParent_Done,
     /* 107925 */   // Label 2287: @107925
     /* 107925 */   GIM_Try, /*On fail goto*//*Label 2288*/ GIMT_Encode4(108004), // Rule ID 17116 //
     /* 107930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVES_In64BitMode),
     /* 107933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xrstors64),
     /* 107938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107944 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107963 */     // (intrinsic_void 15083:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XRSTORS64 addr:{ *:[iPTR] }:$dst)
     /* 107963 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107967 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107973 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107977 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107981 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107987 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XRSTORS64),
     /* 107994 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107998 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108002 */     GIR_RootConstrainSelectedInstOperands,
     /* 108003 */     // GIR_Coverage, 17116,
     /* 108003 */     GIR_EraseRootFromParent_Done,
     /* 108004 */   // Label 2288: @108004
     /* 108004 */   GIM_Try, /*On fail goto*//*Label 2289*/ GIMT_Encode4(108041), // Rule ID 17004 //
     /* 108009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXINT8_In64BitMode),
     /* 108012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbssd),
     /* 108017 */     // MIs[0] src1
     /* 108017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108020 */     // MIs[0] src2
     /* 108020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108023 */     // MIs[0] src3
     /* 108023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108026 */     // (intrinsic_void 14932:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBSSD (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBSSD),
     /* 108029 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108031 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108033 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108035 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108039 */     GIR_RootConstrainSelectedInstOperands,
     /* 108040 */     // GIR_Coverage, 17004,
     /* 108040 */     GIR_EraseRootFromParent_Done,
     /* 108041 */   // Label 2289: @108041
     /* 108041 */   GIM_Try, /*On fail goto*//*Label 2290*/ GIMT_Encode4(108078), // Rule ID 17005 //
     /* 108046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXINT8_In64BitMode),
     /* 108049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbsud),
     /* 108054 */     // MIs[0] src1
     /* 108054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108057 */     // MIs[0] src2
     /* 108057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108060 */     // MIs[0] src3
     /* 108060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108063 */     // (intrinsic_void 14934:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBSUD (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBSUD),
     /* 108066 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108068 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108070 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108072 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108076 */     GIR_RootConstrainSelectedInstOperands,
     /* 108077 */     // GIR_Coverage, 17005,
     /* 108077 */     GIR_EraseRootFromParent_Done,
     /* 108078 */   // Label 2290: @108078
     /* 108078 */   GIM_Try, /*On fail goto*//*Label 2291*/ GIMT_Encode4(108115), // Rule ID 17006 //
     /* 108083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXINT8_In64BitMode),
     /* 108086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbusd),
     /* 108091 */     // MIs[0] src1
     /* 108091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108094 */     // MIs[0] src2
     /* 108094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108097 */     // MIs[0] src3
     /* 108097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108100 */     // (intrinsic_void 14936:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBUSD (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBUSD),
     /* 108103 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108105 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108107 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108109 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108113 */     GIR_RootConstrainSelectedInstOperands,
     /* 108114 */     // GIR_Coverage, 17006,
     /* 108114 */     GIR_EraseRootFromParent_Done,
     /* 108115 */   // Label 2291: @108115
     /* 108115 */   GIM_Try, /*On fail goto*//*Label 2292*/ GIMT_Encode4(108152), // Rule ID 17007 //
     /* 108120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXINT8_In64BitMode),
     /* 108123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbuud),
     /* 108128 */     // MIs[0] src1
     /* 108128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108131 */     // MIs[0] src2
     /* 108131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108134 */     // MIs[0] src3
     /* 108134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108137 */     // (intrinsic_void 14938:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBUUD (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBUUD),
     /* 108140 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108142 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108144 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108146 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108150 */     GIR_RootConstrainSelectedInstOperands,
     /* 108151 */     // GIR_Coverage, 17007,
     /* 108151 */     GIR_EraseRootFromParent_Done,
     /* 108152 */   // Label 2292: @108152
     /* 108152 */   GIM_Try, /*On fail goto*//*Label 2293*/ GIMT_Encode4(108189), // Rule ID 17009 //
     /* 108157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXBF16_In64BitMode),
     /* 108160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbf16ps),
     /* 108165 */     // MIs[0] src1
     /* 108165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108168 */     // MIs[0] src2
     /* 108168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108171 */     // MIs[0] src3
     /* 108171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108174 */     // (intrinsic_void 14926:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBF16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBF16PS),
     /* 108177 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108179 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108181 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108183 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108187 */     GIR_RootConstrainSelectedInstOperands,
     /* 108188 */     // GIR_Coverage, 17009,
     /* 108188 */     GIR_EraseRootFromParent_Done,
     /* 108189 */   // Label 2293: @108189
     /* 108189 */   GIM_Try, /*On fail goto*//*Label 2294*/ GIMT_Encode4(108226), // Rule ID 17011 //
     /* 108194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXFP16_In64BitMode),
     /* 108197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpfp16ps),
     /* 108202 */     // MIs[0] src1
     /* 108202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108205 */     // MIs[0] src2
     /* 108205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108208 */     // MIs[0] src3
     /* 108208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108211 */     // (intrinsic_void 14940:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPFP16PS),
     /* 108214 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108216 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108218 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108220 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108224 */     GIR_RootConstrainSelectedInstOperands,
     /* 108225 */     // GIR_Coverage, 17011,
     /* 108225 */     GIR_EraseRootFromParent_Done,
     /* 108226 */   // Label 2294: @108226
     /* 108226 */   GIM_Try, /*On fail goto*//*Label 2295*/ GIMT_Encode4(108263), // Rule ID 17014 //
     /* 108231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXCOMPLEX_In64BitMode),
     /* 108234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tcmmimfp16ps),
     /* 108239 */     // MIs[0] src1
     /* 108239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108242 */     // MIs[0] src2
     /* 108242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108245 */     // MIs[0] src3
     /* 108245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108248 */     // (intrinsic_void 14908:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTCMMIMFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCMMIMFP16PS),
     /* 108251 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108253 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108255 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108257 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108261 */     GIR_RootConstrainSelectedInstOperands,
     /* 108262 */     // GIR_Coverage, 17014,
     /* 108262 */     GIR_EraseRootFromParent_Done,
     /* 108263 */   // Label 2295: @108263
     /* 108263 */   GIM_Try, /*On fail goto*//*Label 2296*/ GIMT_Encode4(108300), // Rule ID 17015 //
     /* 108268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXCOMPLEX_In64BitMode),
     /* 108271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tcmmrlfp16ps),
     /* 108276 */     // MIs[0] src1
     /* 108276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108279 */     // MIs[0] src2
     /* 108279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108282 */     // MIs[0] src3
     /* 108282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108285 */     // (intrinsic_void 14910:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTCMMRLFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCMMRLFP16PS),
     /* 108288 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108290 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108292 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108294 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108298 */     GIR_RootConstrainSelectedInstOperands,
     /* 108299 */     // GIR_Coverage, 17015,
     /* 108299 */     GIR_EraseRootFromParent_Done,
     /* 108300 */   // Label 2296: @108300
     /* 108300 */   GIM_Try, /*On fail goto*//*Label 2297*/ GIMT_Encode4(108337), // Rule ID 17016 //
     /* 108305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXFP8_In64BitMode),
     /* 108308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbf8ps),
     /* 108313 */     // MIs[0] src1
     /* 108313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108316 */     // MIs[0] src2
     /* 108316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108319 */     // MIs[0] src3
     /* 108319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108322 */     // (intrinsic_void 14928:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBF8PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBF8PS),
     /* 108325 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108327 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108329 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108331 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108335 */     GIR_RootConstrainSelectedInstOperands,
     /* 108336 */     // GIR_Coverage, 17016,
     /* 108336 */     GIR_EraseRootFromParent_Done,
     /* 108337 */   // Label 2297: @108337
     /* 108337 */   GIM_Try, /*On fail goto*//*Label 2298*/ GIMT_Encode4(108374), // Rule ID 17017 //
     /* 108342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXFP8_In64BitMode),
     /* 108345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbhf8ps),
     /* 108350 */     // MIs[0] src1
     /* 108350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108353 */     // MIs[0] src2
     /* 108353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108356 */     // MIs[0] src3
     /* 108356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108359 */     // (intrinsic_void 14930:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBHF8PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBHF8PS),
     /* 108362 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108364 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108366 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108368 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108372 */     GIR_RootConstrainSelectedInstOperands,
     /* 108373 */     // GIR_Coverage, 17017,
     /* 108373 */     GIR_EraseRootFromParent_Done,
     /* 108374 */   // Label 2298: @108374
     /* 108374 */   GIM_Try, /*On fail goto*//*Label 2299*/ GIMT_Encode4(108411), // Rule ID 17018 //
     /* 108379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXFP8_In64BitMode),
     /* 108382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdphbf8ps),
     /* 108387 */     // MIs[0] src1
     /* 108387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108390 */     // MIs[0] src2
     /* 108390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108393 */     // MIs[0] src3
     /* 108393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108396 */     // (intrinsic_void 14942:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPHBF8PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPHBF8PS),
     /* 108399 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108401 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108403 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108405 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108409 */     GIR_RootConstrainSelectedInstOperands,
     /* 108410 */     // GIR_Coverage, 17018,
     /* 108410 */     GIR_EraseRootFromParent_Done,
     /* 108411 */   // Label 2299: @108411
     /* 108411 */   GIM_Try, /*On fail goto*//*Label 2300*/ GIMT_Encode4(108448), // Rule ID 17019 //
     /* 108416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXFP8_In64BitMode),
     /* 108419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdphf8ps),
     /* 108424 */     // MIs[0] src1
     /* 108424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108427 */     // MIs[0] src2
     /* 108427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108430 */     // MIs[0] src3
     /* 108430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108433 */     // (intrinsic_void 14944:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPHF8PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPHF8PS),
     /* 108436 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108438 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108440 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108442 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108446 */     GIR_RootConstrainSelectedInstOperands,
     /* 108447 */     // GIR_Coverage, 17019,
     /* 108447 */     GIR_EraseRootFromParent_Done,
     /* 108448 */   // Label 2300: @108448
     /* 108448 */   GIM_Try, /*On fail goto*//*Label 2301*/ GIMT_Encode4(108485), // Rule ID 17027 //
     /* 108453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXBF16_HasAMXTRANSPOSE_In64BitMode),
     /* 108456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ttdpbf16ps),
     /* 108461 */     // MIs[0] src1
     /* 108461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108464 */     // MIs[0] src2
     /* 108464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108467 */     // MIs[0] src3
     /* 108467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108470 */     // (intrinsic_void 14969:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTTDPBF16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTTDPBF16PS),
     /* 108473 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108475 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108477 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108479 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108483 */     GIR_RootConstrainSelectedInstOperands,
     /* 108484 */     // GIR_Coverage, 17027,
     /* 108484 */     GIR_EraseRootFromParent_Done,
     /* 108485 */   // Label 2301: @108485
     /* 108485 */   GIM_Try, /*On fail goto*//*Label 2302*/ GIMT_Encode4(108522), // Rule ID 17029 //
     /* 108490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXFP16_HasAMXTRANSPOSE_In64BitMode),
     /* 108493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ttdpfp16ps),
     /* 108498 */     // MIs[0] src1
     /* 108498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108501 */     // MIs[0] src2
     /* 108501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108504 */     // MIs[0] src3
     /* 108504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108507 */     // (intrinsic_void 14971:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTTDPFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTTDPFP16PS),
     /* 108510 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108512 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108514 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108516 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108520 */     GIR_RootConstrainSelectedInstOperands,
     /* 108521 */     // GIR_Coverage, 17029,
     /* 108521 */     GIR_EraseRootFromParent_Done,
     /* 108522 */   // Label 2302: @108522
     /* 108522 */   GIM_Try, /*On fail goto*//*Label 2303*/ GIMT_Encode4(108559), // Rule ID 17034 //
     /* 108527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXCOMPLEX_HasAMXTRANSPOSE_In64BitMode),
     /* 108530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ttcmmimfp16ps),
     /* 108535 */     // MIs[0] src1
     /* 108535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108538 */     // MIs[0] src2
     /* 108538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108541 */     // MIs[0] src3
     /* 108541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108544 */     // (intrinsic_void 14965:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTTCMMIMFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTTCMMIMFP16PS),
     /* 108547 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108549 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108551 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108553 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108557 */     GIR_RootConstrainSelectedInstOperands,
     /* 108558 */     // GIR_Coverage, 17034,
     /* 108558 */     GIR_EraseRootFromParent_Done,
     /* 108559 */   // Label 2303: @108559
     /* 108559 */   GIM_Try, /*On fail goto*//*Label 2304*/ GIMT_Encode4(108596), // Rule ID 17035 //
     /* 108564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXCOMPLEX_HasAMXTRANSPOSE_In64BitMode),
     /* 108567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ttcmmrlfp16ps),
     /* 108572 */     // MIs[0] src1
     /* 108572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108575 */     // MIs[0] src2
     /* 108575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108578 */     // MIs[0] src3
     /* 108578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108581 */     // (intrinsic_void 14967:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTTCMMRLFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTTCMMRLFP16PS),
     /* 108584 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108586 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108588 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108590 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108594 */     GIR_RootConstrainSelectedInstOperands,
     /* 108595 */     // GIR_Coverage, 17035,
     /* 108595 */     GIR_EraseRootFromParent_Done,
     /* 108596 */   // Label 2304: @108596
     /* 108596 */   GIM_Try, /*On fail goto*//*Label 2305*/ GIMT_Encode4(108633), // Rule ID 17036 //
     /* 108601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXCOMPLEX_HasAMXTRANSPOSE_In64BitMode),
     /* 108604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tconjtcmmimfp16ps),
     /* 108609 */     // MIs[0] src1
     /* 108609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108612 */     // MIs[0] src2
     /* 108612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108615 */     // MIs[0] src3
     /* 108615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108618 */     // (intrinsic_void 14912:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTCONJTCMMIMFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCONJTCMMIMFP16PS),
     /* 108621 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108623 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108625 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108627 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108631 */     GIR_RootConstrainSelectedInstOperands,
     /* 108632 */     // GIR_Coverage, 17036,
     /* 108632 */     GIR_EraseRootFromParent_Done,
     /* 108633 */   // Label 2305: @108633
     /* 108633 */   GIM_Try, /*On fail goto*//*Label 2306*/ GIMT_Encode4(108670), // Rule ID 17055 //
     /* 108638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTF32_In64BitMode),
     /* 108641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tmmultf32ps),
     /* 108646 */     // MIs[0] src1
     /* 108646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108649 */     // MIs[0] src2
     /* 108649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108652 */     // MIs[0] src3
     /* 108652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108655 */     // (intrinsic_void 14962:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTMMULTF32PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTMMULTF32PS),
     /* 108658 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108660 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108662 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108664 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108668 */     GIR_RootConstrainSelectedInstOperands,
     /* 108669 */     // GIR_Coverage, 17055,
     /* 108669 */     GIR_EraseRootFromParent_Done,
     /* 108670 */   // Label 2306: @108670
     /* 108670 */   GIM_Try, /*On fail goto*//*Label 2307*/ GIMT_Encode4(108707), // Rule ID 17057 //
     /* 108675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTF32_HasAMXTRANSPOSE_In64BitMode),
     /* 108678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ttmmultf32ps),
     /* 108683 */     // MIs[0] src1
     /* 108683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108686 */     // MIs[0] src2
     /* 108686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108689 */     // MIs[0] src3
     /* 108689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108692 */     // (intrinsic_void 14973:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTTMMULTF32PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTTMMULTF32PS),
     /* 108695 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108697 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108699 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108701 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108705 */     GIR_RootConstrainSelectedInstOperands,
     /* 108706 */     // GIR_Coverage, 17057,
     /* 108706 */     GIR_EraseRootFromParent_Done,
     /* 108707 */   // Label 2307: @108707
     /* 108707 */   GIM_Try, /*On fail goto*//*Label 2308*/ GIMT_Encode4(108760), // Rule ID 17038 //
     /* 108712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 108715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tcvtrowd2ps),
     /* 108720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 108723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 108726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 108730 */     // MIs[0] src1
     /* 108730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 108737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 108741 */     // MIs[1] Operand 1
     /* 108741 */     // No operand predicates
     /* 108741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108743 */     // (intrinsic_w_chain:{ *:[v16f32] } 14916:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)  =>  (PTCVTROWD2PSrri:{ *:[v16f32] } (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)
     /* 108743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCVTROWD2PSrri),
     /* 108746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108748 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 108750 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 108753 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 108758 */     GIR_RootConstrainSelectedInstOperands,
     /* 108759 */     // GIR_Coverage, 17038,
     /* 108759 */     GIR_EraseRootFromParent_Done,
     /* 108760 */   // Label 2308: @108760
     /* 108760 */   GIM_Try, /*On fail goto*//*Label 2309*/ GIMT_Encode4(108813), // Rule ID 17047 //
     /* 108765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 108768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tcvtrowps2phh),
     /* 108773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s16,
     /* 108776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 108779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 108783 */     // MIs[0] src1
     /* 108783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 108790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 108794 */     // MIs[1] Operand 1
     /* 108794 */     // No operand predicates
     /* 108794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108796 */     // (intrinsic_w_chain:{ *:[v32f16] } 14922:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)  =>  (PTCVTROWPS2PHHrri:{ *:[v32f16] } (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)
     /* 108796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCVTROWPS2PHHrri),
     /* 108799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108801 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 108803 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 108806 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 108811 */     GIR_RootConstrainSelectedInstOperands,
     /* 108812 */     // GIR_Coverage, 17047,
     /* 108812 */     GIR_EraseRootFromParent_Done,
     /* 108813 */   // Label 2309: @108813
     /* 108813 */   GIM_Try, /*On fail goto*//*Label 2310*/ GIMT_Encode4(108866), // Rule ID 17049 //
     /* 108818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 108821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tcvtrowps2phl),
     /* 108826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s16,
     /* 108829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 108832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 108836 */     // MIs[0] src1
     /* 108836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 108843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 108847 */     // MIs[1] Operand 1
     /* 108847 */     // No operand predicates
     /* 108847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108849 */     // (intrinsic_w_chain:{ *:[v32f16] } 14924:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)  =>  (PTCVTROWPS2PHLrri:{ *:[v32f16] } (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)
     /* 108849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCVTROWPS2PHLrri),
     /* 108852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108854 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 108856 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 108859 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 108864 */     GIR_RootConstrainSelectedInstOperands,
     /* 108865 */     // GIR_Coverage, 17049,
     /* 108865 */     GIR_EraseRootFromParent_Done,
     /* 108866 */   // Label 2310: @108866
     /* 108866 */   GIM_Try, /*On fail goto*//*Label 2311*/ GIMT_Encode4(108919), // Rule ID 17050 //
     /* 108871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 108874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tilemovrow),
     /* 108879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 108882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 108885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 108889 */     // MIs[0] src1
     /* 108889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 108896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 108900 */     // MIs[1] Operand 1
     /* 108900 */     // No operand predicates
     /* 108900 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108902 */     // (intrinsic_w_chain:{ *:[v16i32] } 14955:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)  =>  (PTILEMOVROWrri:{ *:[v16i32] } (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)
     /* 108902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTILEMOVROWrri),
     /* 108905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108907 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 108909 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 108912 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 108917 */     GIR_RootConstrainSelectedInstOperands,
     /* 108918 */     // GIR_Coverage, 17050,
     /* 108918 */     GIR_EraseRootFromParent_Done,
     /* 108919 */   // Label 2311: @108919
     /* 108919 */   GIM_Try, /*On fail goto*//*Label 2312*/ GIMT_Encode4(108964), // Rule ID 17039 //
     /* 108924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 108927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tcvtrowd2ps),
     /* 108932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 108935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 108938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 108942 */     // MIs[0] src1
     /* 108942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 108949 */     // (intrinsic_w_chain:{ *:[v16f32] } 14916:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)  =>  (PTCVTROWD2PSrre:{ *:[v16f32] } (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)
     /* 108949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCVTROWD2PSrre),
     /* 108952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108954 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 108956 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 108958 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108962 */     GIR_RootConstrainSelectedInstOperands,
     /* 108963 */     // GIR_Coverage, 17039,
     /* 108963 */     GIR_EraseRootFromParent_Done,
     /* 108964 */   // Label 2312: @108964
     /* 108964 */   GIM_Try, /*On fail goto*//*Label 2313*/ GIMT_Encode4(109009), // Rule ID 17046 //
     /* 108969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 108972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tcvtrowps2phh),
     /* 108977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s16,
     /* 108980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 108983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 108987 */     // MIs[0] src1
     /* 108987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 108994 */     // (intrinsic_w_chain:{ *:[v32f16] } 14922:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)  =>  (PTCVTROWPS2PHHrre:{ *:[v32f16] } (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)
     /* 108994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCVTROWPS2PHHrre),
     /* 108997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108999 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 109001 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 109003 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109007 */     GIR_RootConstrainSelectedInstOperands,
     /* 109008 */     // GIR_Coverage, 17046,
     /* 109008 */     GIR_EraseRootFromParent_Done,
     /* 109009 */   // Label 2313: @109009
     /* 109009 */   GIM_Try, /*On fail goto*//*Label 2314*/ GIMT_Encode4(109054), // Rule ID 17048 //
     /* 109014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 109017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tcvtrowps2phl),
     /* 109022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s16,
     /* 109025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 109028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 109032 */     // MIs[0] src1
     /* 109032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 109035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 109039 */     // (intrinsic_w_chain:{ *:[v32f16] } 14924:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)  =>  (PTCVTROWPS2PHLrre:{ *:[v32f16] } (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)
     /* 109039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCVTROWPS2PHLrre),
     /* 109042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109044 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 109046 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 109048 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109052 */     GIR_RootConstrainSelectedInstOperands,
     /* 109053 */     // GIR_Coverage, 17048,
     /* 109053 */     GIR_EraseRootFromParent_Done,
     /* 109054 */   // Label 2314: @109054
     /* 109054 */   GIM_Try, /*On fail goto*//*Label 2315*/ GIMT_Encode4(109099), // Rule ID 17051 //
     /* 109059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 109062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tilemovrow),
     /* 109067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 109070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 109073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 109077 */     // MIs[0] src1
     /* 109077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 109080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 109084 */     // (intrinsic_w_chain:{ *:[v16i32] } 14955:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)  =>  (PTILEMOVROWrre:{ *:[v16i32] } (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)
     /* 109084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTILEMOVROWrre),
     /* 109087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109089 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 109091 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 109093 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109097 */     GIR_RootConstrainSelectedInstOperands,
     /* 109098 */     // GIR_Coverage, 17051,
     /* 109098 */     GIR_EraseRootFromParent_Done,
     /* 109099 */   // Label 2315: @109099
     /* 109099 */   GIM_Try, /*On fail goto*//*Label 2316*/ GIMT_Encode4(109144), // Rule ID 122 //
     /* 109104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 109107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_lwpval32),
     /* 109112 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 109115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 109118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 109122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 109126 */     // MIs[0] cntl
     /* 109126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 109129 */     // (intrinsic_void 14596:{ *:[iPTR] }, GR32:{ *:[i32] }:$src0, GR32:{ *:[i32] }:$src1, (timm:{ *:[i32] }):$cntl)  =>  (LWPVAL32rri GR32:{ *:[i32] }:$src0, GR32:{ *:[i32] }:$src1, (timm:{ *:[i32] }):$cntl)
     /* 109129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LWPVAL32rri),
     /* 109132 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 109134 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 109136 */     GIR_RootToRootCopy, /*OpIdx*/3, // cntl
     /* 109138 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109142 */     GIR_RootConstrainSelectedInstOperands,
     /* 109143 */     // GIR_Coverage, 122,
     /* 109143 */     GIR_EraseRootFromParent_Done,
     /* 109144 */   // Label 2316: @109144
     /* 109144 */   GIM_Try, /*On fail goto*//*Label 2317*/ GIMT_Encode4(109189), // Rule ID 124 //
     /* 109149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 109152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_lwpval64),
     /* 109157 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 109163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 109167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 109171 */     // MIs[0] cntl
     /* 109171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 109174 */     // (intrinsic_void 14597:{ *:[iPTR] }, GR64:{ *:[i64] }:$src0, GR32:{ *:[i32] }:$src1, (timm:{ *:[i32] }):$cntl)  =>  (LWPVAL64rri GR64:{ *:[i64] }:$src0, GR32:{ *:[i32] }:$src1, (timm:{ *:[i32] }):$cntl)
     /* 109174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LWPVAL64rri),
     /* 109177 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 109179 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 109181 */     GIR_RootToRootCopy, /*OpIdx*/3, // cntl
     /* 109183 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109187 */     GIR_RootConstrainSelectedInstOperands,
     /* 109188 */     // GIR_Coverage, 124,
     /* 109188 */     GIR_EraseRootFromParent_Done,
     /* 109189 */   // Label 2317: @109189
     /* 109189 */   GIM_Try, /*On fail goto*//*Label 2318*/ GIMT_Encode4(109271), // Rule ID 17104 //
     /* 109194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsetbv),
     /* 109199 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 109202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 109205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 109208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32_ArgRef_and_GR32_CBRegClassID),
     /* 109212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 109216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 109220 */     // (intrinsic_void 15092:{ *:[iPTR] }, ECX:{ *:[i32] }, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSETBV)
     /* 109220 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109224 */     GIR_AddRegister, /*InsnID*/3, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109230 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 109234 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109238 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109244 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 109248 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109252 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::ECX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109258 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // ECX
     /* 109262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSETBV),
     /* 109265 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109269 */     GIR_RootConstrainSelectedInstOperands,
     /* 109270 */     // GIR_Coverage, 17104,
     /* 109270 */     GIR_EraseRootFromParent_Done,
     /* 109271 */   // Label 2318: @109271
     /* 109271 */   GIM_Try, /*On fail goto*//*Label 2319*/ GIMT_Encode4(109320), // Rule ID 17293 //
     /* 109276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMWAITX),
     /* 109279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_mwaitx),
     /* 109284 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 109287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 109290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 109293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 109297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 109301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 109305 */     // (intrinsic_void 14674:{ *:[iPTR] }, GR32:{ *:[i32] }:$ecx, GR32:{ *:[i32] }:$eax, GR32:{ *:[i32] }:$ebx)  =>  (MWAITX GR32:{ *:[i32] }:$ecx, GR32:{ *:[i32] }:$eax, GR32:{ *:[i32] }:$ebx)
     /* 109305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MWAITX),
     /* 109308 */     GIR_RootToRootCopy, /*OpIdx*/1, // ecx
     /* 109310 */     GIR_RootToRootCopy, /*OpIdx*/2, // eax
     /* 109312 */     GIR_RootToRootCopy, /*OpIdx*/3, // ebx
     /* 109314 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109318 */     GIR_RootConstrainSelectedInstOperands,
     /* 109319 */     // GIR_Coverage, 17293,
     /* 109319 */     GIR_EraseRootFromParent_Done,
     /* 109320 */   // Label 2319: @109320
     /* 109320 */   GIM_Try, /*On fail goto*//*Label 2320*/ GIMT_Encode4(109382), // Rule ID 2903 //
     /* 109325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_In64BitMode),
     /* 109328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_maskmov_dqu),
     /* 109333 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 109336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 109339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 109343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 109347 */     // MIs[0] Operand 3
     /* 109347 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 109351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR64_with_sub_32bit_in_GR32_DIBP_and_GR32_SIDIRegClassID),
     /* 109355 */     // (intrinsic_void 14772:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask, RDI:{ *:[i64] })  =>  (VMASKMOVDQU64 VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask)
     /* 109355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109359 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::RDI), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109365 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // RDI
     /* 109369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVDQU64),
     /* 109372 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109374 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 109376 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109380 */     GIR_RootConstrainSelectedInstOperands,
     /* 109381 */     // GIR_Coverage, 2903,
     /* 109381 */     GIR_EraseRootFromParent_Done,
     /* 109382 */   // Label 2320: @109382
     /* 109382 */   GIM_Try, /*On fail goto*//*Label 2321*/ GIMT_Encode4(109444), // Rule ID 2904 //
     /* 109387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 109390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_maskmov_dqu),
     /* 109395 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 109398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 109401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 109405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 109409 */     // MIs[0] Operand 3
     /* 109409 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/32,
     /* 109413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_DIBP_and_GR32_SIDIRegClassID),
     /* 109417 */     // (intrinsic_void 14772:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask, EDI:{ *:[i32] })  =>  (VMASKMOVDQU VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask)
     /* 109417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109421 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDI), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109427 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // EDI
     /* 109431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVDQU),
     /* 109434 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109436 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 109438 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109442 */     GIR_RootConstrainSelectedInstOperands,
     /* 109443 */     // GIR_Coverage, 2904,
     /* 109443 */     GIR_EraseRootFromParent_Done,
     /* 109444 */   // Label 2321: @109444
     /* 109444 */   GIM_Try, /*On fail goto*//*Label 2322*/ GIMT_Encode4(109506), // Rule ID 2905 //
     /* 109449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode_UseSSE2),
     /* 109452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_maskmov_dqu),
     /* 109457 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 109460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 109463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 109467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 109471 */     // MIs[0] Operand 3
     /* 109471 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 109475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR64_with_sub_32bit_in_GR32_DIBP_and_GR32_SIDIRegClassID),
     /* 109479 */     // (intrinsic_void 14772:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask, RDI:{ *:[i64] })  =>  (MASKMOVDQU64 VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask)
     /* 109479 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109483 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::RDI), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109489 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // RDI
     /* 109493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MASKMOVDQU64),
     /* 109496 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109498 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 109500 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109504 */     GIR_RootConstrainSelectedInstOperands,
     /* 109505 */     // GIR_Coverage, 2905,
     /* 109505 */     GIR_EraseRootFromParent_Done,
     /* 109506 */   // Label 2322: @109506
     /* 109506 */   GIM_Try, /*On fail goto*//*Label 2323*/ GIMT_Encode4(109568), // Rule ID 2906 //
     /* 109511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 109514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_maskmov_dqu),
     /* 109519 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 109522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 109525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 109529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 109533 */     // MIs[0] Operand 3
     /* 109533 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/32,
     /* 109537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_DIBP_and_GR32_SIDIRegClassID),
     /* 109541 */     // (intrinsic_void 14772:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask, EDI:{ *:[i32] })  =>  (MASKMOVDQU VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask)
     /* 109541 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109545 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDI), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109551 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // EDI
     /* 109555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MASKMOVDQU),
     /* 109558 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109560 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 109562 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109566 */     GIR_RootConstrainSelectedInstOperands,
     /* 109567 */     // GIR_Coverage, 2906,
     /* 109567 */     GIR_EraseRootFromParent_Done,
     /* 109568 */   // Label 2323: @109568
     /* 109568 */   GIM_Reject,
     /* 109569 */ // Label 2258: @109569
     /* 109569 */ GIM_Try, /*On fail goto*//*Label 2324*/ GIMT_Encode4(109657), // Rule ID 16988 //
     /* 109574 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasKL),
     /* 109577 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 109580 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_loadiwkey),
     /* 109585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 109588 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 109591 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 109594 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 109597 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 109601 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 109605 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 109609 */   GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 109613 */   // (intrinsic_void 14593:{ *:[iPTR] }, XMM0:{ *:[v2i64] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2, EAX:{ *:[i32] })  =>  (LOADIWKEY:{ *:[i32] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 109613 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109617 */   GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109623 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // EAX
     /* 109627 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109631 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::XMM0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109637 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // XMM0
     /* 109641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LOADIWKEY),
     /* 109644 */   GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 109646 */   GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 109648 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 109651 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109655 */   GIR_RootConstrainSelectedInstOperands,
     /* 109656 */   // GIR_Coverage, 16988,
     /* 109656 */   GIR_EraseRootFromParent_Done,
     /* 109657 */ // Label 2324: @109657
     /* 109657 */ GIM_Reject,
     /* 109658 */ // Label 19: @109658
     /* 109658 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 2328*/ GIMT_Encode4(110092),
     /* 109669 */ /*GILLT_s16*//*Label 2325*/ GIMT_Encode4(109681),
     /* 109673 */ /*GILLT_s32*//*Label 2326*/ GIMT_Encode4(109739),
     /* 109677 */ /*GILLT_s64*//*Label 2327*/ GIMT_Encode4(109914),
     /* 109681 */ // Label 2325: @109681
     /* 109681 */ GIM_Try, /*On fail goto*//*Label 2329*/ GIMT_Encode4(109738), // Rule ID 22590 //
     /* 109686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 109689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 109693 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 109697 */   // (anyext:{ *:[i16] } GR8:{ *:[i8] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVZX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src), sub_16bit:{ *:[i32] })
     /* 109697 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 109700 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /* 109704 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109709 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109713 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 109715 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109718 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109720 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 109727 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 109732 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 109737 */   // GIR_Coverage, 22590,
     /* 109737 */   GIR_EraseRootFromParent_Done,
     /* 109738 */ // Label 2329: @109738
     /* 109738 */ GIM_Reject,
     /* 109739 */ // Label 2326: @109739
     /* 109739 */ GIM_Try, /*On fail goto*//*Label 2330*/ GIMT_Encode4(109785), // Rule ID 19437 //
     /* 109744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 109747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 109751 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109755 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 109759 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 109763 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 109768 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109770 */   // (anyext:{ *:[i32] } (bitconvert:{ *:[i16] } VK16:{ *:[v16i1] }:$src))  =>  (COPY_TO_REGCLASS:{ *:[i32] } VK16:{ *:[v16i1] }:$src, GR32:{ *:[i32] })
     /* 109770 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109773 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109775 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 109779 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /* 109784 */   // GIR_Coverage, 19437,
     /* 109784 */   GIR_EraseRootFromParent_Done,
     /* 109785 */ // Label 2330: @109785
     /* 109785 */ GIM_Try, /*On fail goto*//*Label 2331*/ GIMT_Encode4(109831), // Rule ID 19440 //
     /* 109790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 109793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 109797 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109801 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 109805 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 109809 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 109814 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109816 */   // (anyext:{ *:[i32] } (bitconvert:{ *:[i8] } VK8:{ *:[v8i1] }:$src))  =>  (COPY_TO_REGCLASS:{ *:[i32] } VK8:{ *:[v8i1] }:$src, GR32:{ *:[i32] })
     /* 109816 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109819 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109821 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 109825 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /* 109830 */   // GIR_Coverage, 19440,
     /* 109830 */   GIR_EraseRootFromParent_Done,
     /* 109831 */ // Label 2331: @109831
     /* 109831 */ GIM_Try, /*On fail goto*//*Label 2332*/ GIMT_Encode4(109854), // Rule ID 22591 //
     /* 109836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 109839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 109843 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 109847 */   // (anyext:{ *:[i32] } GR8:{ *:[i8] }:$src)  =>  (MOVZX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /* 109847 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /* 109852 */   GIR_RootConstrainSelectedInstOperands,
     /* 109853 */   // GIR_Coverage, 22591,
     /* 109853 */   GIR_Done,
     /* 109854 */ // Label 2332: @109854
     /* 109854 */ GIM_Try, /*On fail goto*//*Label 2333*/ GIMT_Encode4(109913), // Rule ID 22592 //
     /* 109859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 109862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 109866 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 109870 */   // (anyext:{ *:[i32] } GR16:{ *:[i16] }:$src)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR16:{ *:[i16] }:$src, sub_16bit:{ *:[i32] })
     /* 109870 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 109873 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 109877 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109882 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 109884 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 109887 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109889 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109892 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109894 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 109897 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 109902 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 109907 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /* 109912 */   // GIR_Coverage, 22592,
     /* 109912 */   GIR_EraseRootFromParent_Done,
     /* 109913 */ // Label 2333: @109913
     /* 109913 */ GIM_Reject,
     /* 109914 */ // Label 2327: @109914
     /* 109914 */ GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(109973), // Rule ID 22593 //
     /* 109919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 109922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 109926 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 109930 */   // (anyext:{ *:[i64] } GR8:{ *:[i8] }:$src)  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src), sub_32bit:{ *:[i32] })
     /* 109930 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 109933 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /* 109937 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109942 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109946 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 109948 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 109951 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109953 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109956 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109959 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 109962 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 109967 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 109972 */   // GIR_Coverage, 22593,
     /* 109972 */   GIR_EraseRootFromParent_Done,
     /* 109973 */ // Label 2334: @109973
     /* 109973 */ GIM_Try, /*On fail goto*//*Label 2335*/ GIMT_Encode4(110032), // Rule ID 22594 //
     /* 109978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 109981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 109985 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 109989 */   // (anyext:{ *:[i64] } GR16:{ *:[i16] }:$src)  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rr16:{ *:[i32] } GR16:{ *:[i16] }:$src), sub_32bit:{ *:[i32] })
     /* 109989 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 109992 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr16),
     /* 109996 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110001 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 110005 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110007 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 110010 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110012 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110015 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110018 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 110021 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 110026 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 110031 */   // GIR_Coverage, 22594,
     /* 110031 */   GIR_EraseRootFromParent_Done,
     /* 110032 */ // Label 2335: @110032
     /* 110032 */ GIM_Try, /*On fail goto*//*Label 2336*/ GIMT_Encode4(110091), // Rule ID 22595 //
     /* 110037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 110040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 110044 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 110048 */   // (anyext:{ *:[i64] } GR32:{ *:[i32] }:$src)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR32:{ *:[i32] }:$src, sub_32bit:{ *:[i32] })
     /* 110048 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 110051 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110055 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110060 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 110065 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110067 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110070 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110072 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 110075 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 110080 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR64RegClassID),
     /* 110085 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 110090 */   // GIR_Coverage, 22595,
     /* 110090 */   GIR_EraseRootFromParent_Done,
     /* 110091 */ // Label 2336: @110091
     /* 110091 */ GIM_Reject,
     /* 110092 */ // Label 2328: @110092
     /* 110092 */ GIM_Reject,
     /* 110093 */ // Label 20: @110093
     /* 110093 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 2345*/ GIMT_Encode4(111181),
     /* 110104 */ /*GILLT_s8*//*Label 2337*/ GIMT_Encode4(110188),
     /* 110108 */ /*GILLT_s16*//*Label 2338*/ GIMT_Encode4(110472), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 110140 */ /*GILLT_v4s32*//*Label 2339*/ GIMT_Encode4(110511), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 110152 */ /*GILLT_v8s16*//*Label 2340*/ GIMT_Encode4(110651),
     /* 110156 */ /*GILLT_v8s32*//*Label 2341*/ GIMT_Encode4(110814), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 110168 */ /*GILLT_v16s8*//*Label 2342*/ GIMT_Encode4(110841),
     /* 110172 */ /*GILLT_v16s16*//*Label 2343*/ GIMT_Encode4(111127), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 110184 */ /*GILLT_v32s8*//*Label 2344*/ GIMT_Encode4(111154),
     /* 110188 */ // Label 2337: @110188
     /* 110188 */ GIM_Try, /*On fail goto*//*Label 2346*/ GIMT_Encode4(110263), // Rule ID 19432 //
     /* 110193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 110196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 110200 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110204 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 110208 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 110212 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 110217 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110219 */   // (trunc:{ *:[i8] } (bitconvert:{ *:[i16] } VK16:{ *:[v16i1] }:$src))  =>  (EXTRACT_SUBREG:{ *:[i8] } (COPY_TO_REGCLASS:{ *:[i32] } VK16:{ *:[v16i1] }:$src, GR32:{ *:[i32] }), sub_8bit:{ *:[i32] })
     /* 110219 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110222 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110226 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110231 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 110235 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /* 110240 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110243 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110245 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_8bit),
     /* 110252 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /* 110257 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 110262 */   // GIR_Coverage, 19432,
     /* 110262 */   GIR_EraseRootFromParent_Done,
     /* 110263 */ // Label 2346: @110263
     /* 110263 */ GIM_Try, /*On fail goto*//*Label 2347*/ GIMT_Encode4(110326), // Rule ID 22652 //
     /* 110268 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode),
     /* 110271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 110274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 110278 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 110282 */   // (trunc:{ *:[i8] } GR32:{ *:[i32] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i8] } (COPY_TO_REGCLASS:{ *:[i32] } GR32:{ *:[i32] }:$src, GR32_ABCD:{ *:[i32] }), sub_8bit:{ *:[i32] })
     /* 110282 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110285 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110289 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110294 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 110298 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR32_ABCDRegClassID),
     /* 110303 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110306 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110308 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_8bit),
     /* 110315 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 110320 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32_ABCDRegClassID),
     /* 110325 */   // GIR_Coverage, 22652,
     /* 110325 */   GIR_EraseRootFromParent_Done,
     /* 110326 */ // Label 2347: @110326
     /* 110326 */ GIM_Try, /*On fail goto*//*Label 2348*/ GIMT_Encode4(110389), // Rule ID 22653 //
     /* 110331 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode),
     /* 110334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 110337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 110341 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 110345 */   // (trunc:{ *:[i8] } GR16:{ *:[i16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i8] } (COPY_TO_REGCLASS:{ *:[i16] } GR16:{ *:[i16] }:$src, GR16_ABCD:{ *:[i32] }), sub_8bit:{ *:[i32] })
     /* 110345 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 110348 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110352 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110357 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 110361 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16_ABCDRegClassID),
     /* 110366 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110369 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110371 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_8bit),
     /* 110378 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 110383 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR16_ABCDRegClassID),
     /* 110388 */   // GIR_Coverage, 22653,
     /* 110388 */   GIR_EraseRootFromParent_Done,
     /* 110389 */ // Label 2348: @110389
     /* 110389 */ GIM_Try, /*On fail goto*//*Label 2349*/ GIMT_Encode4(110430), // Rule ID 22657 //
     /* 110394 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /* 110397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 110400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 110404 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 110408 */   // (trunc:{ *:[i8] } GR32:{ *:[i32] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i8] } GR32:{ *:[i32] }:$src, sub_8bit:{ *:[i32] })
     /* 110408 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110411 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110413 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src
     /* 110419 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /* 110424 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 110429 */   // GIR_Coverage, 22657,
     /* 110429 */   GIR_EraseRootFromParent_Done,
     /* 110430 */ // Label 2349: @110430
     /* 110430 */ GIM_Try, /*On fail goto*//*Label 2350*/ GIMT_Encode4(110471), // Rule ID 22658 //
     /* 110435 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /* 110438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 110441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 110445 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 110449 */   // (trunc:{ *:[i8] } GR16:{ *:[i16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i8] } GR16:{ *:[i16] }:$src, sub_8bit:{ *:[i32] })
     /* 110449 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110452 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110454 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src
     /* 110460 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /* 110465 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /* 110470 */   // GIR_Coverage, 22658,
     /* 110470 */   GIR_EraseRootFromParent_Done,
     /* 110471 */ // Label 2350: @110471
     /* 110471 */ GIM_Reject,
     /* 110472 */ // Label 2338: @110472
     /* 110472 */ GIM_Try, /*On fail goto*//*Label 2351*/ GIMT_Encode4(110510), // Rule ID 22651 //
     /* 110477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 110480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 110484 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 110488 */   // (trunc:{ *:[i16] } GR32:{ *:[i32] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } GR32:{ *:[i32] }:$src, sub_16bit:{ *:[i32] })
     /* 110488 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110491 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110493 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(4), // src
     /* 110499 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 110504 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 110509 */   // GIR_Coverage, 22651,
     /* 110509 */   GIR_EraseRootFromParent_Done,
     /* 110510 */ // Label 2351: @110510
     /* 110510 */ GIM_Reject,
     /* 110511 */ // Label 2339: @110511
     /* 110511 */ GIM_Try, /*On fail goto*//*Label 2352*/ GIMT_Encode4(110650),
     /* 110516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 110519 */   GIM_Try, /*On fail goto*//*Label 2353*/ GIMT_Encode4(110542), // Rule ID 12262 //
     /* 110524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 110527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 110531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 110535 */     // (trunc:{ *:[v4i32] } VR256X:{ *:[v4i64] }:$src)  =>  (VPMOVQDZ256rr:{ *:[v4i32] } VR256X:{ *:[v4i64] }:$src)
     /* 110535 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVQDZ256rr),
     /* 110540 */     GIR_RootConstrainSelectedInstOperands,
     /* 110541 */     // GIR_Coverage, 12262,
     /* 110541 */     GIR_Done,
     /* 110542 */   // Label 2353: @110542
     /* 110542 */   GIM_Try, /*On fail goto*//*Label 2354*/ GIMT_Encode4(110649), // Rule ID 21557 //
     /* 110547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 110550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 110554 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 110558 */     // (trunc:{ *:[v4i32] } VR256X:{ *:[v4i64] }:$src)  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VPMOVQDZrr:{ *:[v8i32] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src, sub_ymm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 110558 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 110561 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110565 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110570 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 110572 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 110575 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 110579 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110584 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 110587 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 110591 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 110594 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 110599 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 110604 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 110609 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s32,
     /* 110612 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVQDZrr),
     /* 110616 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110621 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 110624 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110631 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 110638 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 110643 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256XRegClassID),
     /* 110648 */     // GIR_Coverage, 21557,
     /* 110648 */     GIR_EraseRootFromParent_Done,
     /* 110649 */   // Label 2354: @110649
     /* 110649 */   GIM_Reject,
     /* 110650 */ // Label 2352: @110650
     /* 110650 */ GIM_Reject,
     /* 110651 */ // Label 2340: @110651
     /* 110651 */ GIM_Try, /*On fail goto*//*Label 2355*/ GIMT_Encode4(110677), // Rule ID 12238 //
     /* 110656 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 110659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 110662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 110666 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 110670 */   // (trunc:{ *:[v8i16] } VR512:{ *:[v8i64] }:$src)  =>  (VPMOVQWZrr:{ *:[v8i16] } VR512:{ *:[v8i64] }:$src)
     /* 110670 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVQWZrr),
     /* 110675 */   GIR_RootConstrainSelectedInstOperands,
     /* 110676 */   // GIR_Coverage, 12238,
     /* 110676 */   GIR_Done,
     /* 110677 */ // Label 2355: @110677
     /* 110677 */ GIM_Try, /*On fail goto*//*Label 2356*/ GIMT_Encode4(110703), // Rule ID 12316 //
     /* 110682 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 110685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 110688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 110692 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 110696 */   // (trunc:{ *:[v8i16] } VR256X:{ *:[v8i32] }:$src)  =>  (VPMOVDWZ256rr:{ *:[v8i16] } VR256X:{ *:[v8i32] }:$src)
     /* 110696 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVDWZ256rr),
     /* 110701 */   GIR_RootConstrainSelectedInstOperands,
     /* 110702 */   // GIR_Coverage, 12316,
     /* 110702 */   GIR_Done,
     /* 110703 */ // Label 2356: @110703
     /* 110703 */ GIM_Try, /*On fail goto*//*Label 2357*/ GIMT_Encode4(110813), // Rule ID 21556 //
     /* 110708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 110711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 110714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 110718 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 110722 */   // (trunc:{ *:[v8i16] } VR256X:{ *:[v8i32] }:$src)  =>  (EXTRACT_SUBREG:{ *:[v8i16] } (VPMOVDWZrr:{ *:[v16i16] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src, sub_ymm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 110722 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 110725 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110729 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110734 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 110736 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 110739 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 110743 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110748 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 110751 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 110755 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 110758 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 110763 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 110768 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 110773 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s16,
     /* 110776 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVDWZrr),
     /* 110780 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110785 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 110788 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110790 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110793 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110795 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 110802 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 110807 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256XRegClassID),
     /* 110812 */   // GIR_Coverage, 21556,
     /* 110812 */   GIR_EraseRootFromParent_Done,
     /* 110813 */ // Label 2357: @110813
     /* 110813 */ GIM_Reject,
     /* 110814 */ // Label 2341: @110814
     /* 110814 */ GIM_Try, /*On fail goto*//*Label 2358*/ GIMT_Encode4(110840), // Rule ID 12265 //
     /* 110819 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 110822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 110825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 110829 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 110833 */   // (trunc:{ *:[v8i32] } VR512:{ *:[v8i64] }:$src)  =>  (VPMOVQDZrr:{ *:[v8i32] } VR512:{ *:[v8i64] }:$src)
     /* 110833 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVQDZrr),
     /* 110838 */   GIR_RootConstrainSelectedInstOperands,
     /* 110839 */   // GIR_Coverage, 12265,
     /* 110839 */   GIR_Done,
     /* 110840 */ // Label 2358: @110840
     /* 110840 */ GIM_Reject,
     /* 110841 */ // Label 2342: @110841
     /* 110841 */ GIM_Try, /*On fail goto*//*Label 2359*/ GIMT_Encode4(110917), // Rule ID 21650 //
     /* 110846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_NoBWI),
     /* 110849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 110852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 110856 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110860 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 110864 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110867 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 110871 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 110875 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110877 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 110884 */   // (trunc:{ *:[v16i8] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVDBZrr:{ *:[v16i8] } (VPMOVZXWDZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src))
     /* 110884 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 110887 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDZrm),
     /* 110891 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110896 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /* 110900 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 110905 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110907 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVDBZrr),
     /* 110910 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110912 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110915 */   GIR_RootConstrainSelectedInstOperands,
     /* 110916 */   // GIR_Coverage, 21650,
     /* 110916 */   GIR_EraseRootFromParent_Done,
     /* 110917 */ // Label 2359: @110917
     /* 110917 */ GIM_Try, /*On fail goto*//*Label 2360*/ GIMT_Encode4(110943), // Rule ID 12292 //
     /* 110922 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 110925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 110928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 110932 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 110936 */   // (trunc:{ *:[v16i8] } VR512:{ *:[v16i32] }:$src)  =>  (VPMOVDBZrr:{ *:[v16i8] } VR512:{ *:[v16i32] }:$src)
     /* 110936 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVDBZrr),
     /* 110941 */   GIR_RootConstrainSelectedInstOperands,
     /* 110942 */   // GIR_Coverage, 12292,
     /* 110942 */   GIR_Done,
     /* 110943 */ // Label 2360: @110943
     /* 110943 */ GIM_Try, /*On fail goto*//*Label 2361*/ GIMT_Encode4(110969), // Rule ID 12343 //
     /* 110948 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 110951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 110954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 110958 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 110962 */   // (trunc:{ *:[v16i8] } VR256X:{ *:[v16i16] }:$src)  =>  (VPMOVWBZ256rr:{ *:[v16i8] } VR256X:{ *:[v16i16] }:$src)
     /* 110962 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVWBZ256rr),
     /* 110967 */   GIR_RootConstrainSelectedInstOperands,
     /* 110968 */   // GIR_Coverage, 12343,
     /* 110968 */   GIR_Done,
     /* 110969 */ // Label 2361: @110969
     /* 110969 */ GIM_Try, /*On fail goto*//*Label 2362*/ GIMT_Encode4(111079), // Rule ID 21558 //
     /* 110974 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 110977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 110980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 110984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 110988 */   // (trunc:{ *:[v16i8] } VR256X:{ *:[v16i16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[v16i8] } (VPMOVWBZrr:{ *:[v32i8] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR256X:{ *:[v16i16] }:$src, sub_ymm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 110988 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 110991 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110995 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111000 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 111002 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 111005 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 111009 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111014 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 111017 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 111021 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 111024 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 111029 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 111034 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 111039 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s8,
     /* 111042 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVWBZrr),
     /* 111046 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111051 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 111054 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111056 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111059 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111061 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 111068 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 111073 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256XRegClassID),
     /* 111078 */   // GIR_Coverage, 21558,
     /* 111078 */   GIR_EraseRootFromParent_Done,
     /* 111079 */ // Label 2362: @111079
     /* 111079 */ GIM_Try, /*On fail goto*//*Label 2363*/ GIMT_Encode4(111126), // Rule ID 21649 //
     /* 111084 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_NoBWI),
     /* 111087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 111090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 111094 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 111098 */   // (trunc:{ *:[v16i8] } VR256X:{ *:[v16i16] }:$src)  =>  (VPMOVDBZrr:{ *:[v16i8] } (VPMOVZXWDZrr:{ *:[v16i32] } VR256X:{ *:[v16i16] }:$src))
     /* 111098 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 111101 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDZrr),
     /* 111105 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111110 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 111114 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111116 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVDBZrr),
     /* 111119 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111121 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111124 */   GIR_RootConstrainSelectedInstOperands,
     /* 111125 */   // GIR_Coverage, 21649,
     /* 111125 */   GIR_EraseRootFromParent_Done,
     /* 111126 */ // Label 2363: @111126
     /* 111126 */ GIM_Reject,
     /* 111127 */ // Label 2343: @111127
     /* 111127 */ GIM_Try, /*On fail goto*//*Label 2364*/ GIMT_Encode4(111153), // Rule ID 12319 //
     /* 111132 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 111135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 111138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 111142 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 111146 */   // (trunc:{ *:[v16i16] } VR512:{ *:[v16i32] }:$src)  =>  (VPMOVDWZrr:{ *:[v16i16] } VR512:{ *:[v16i32] }:$src)
     /* 111146 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVDWZrr),
     /* 111151 */   GIR_RootConstrainSelectedInstOperands,
     /* 111152 */   // GIR_Coverage, 12319,
     /* 111152 */   GIR_Done,
     /* 111153 */ // Label 2364: @111153
     /* 111153 */ GIM_Reject,
     /* 111154 */ // Label 2344: @111154
     /* 111154 */ GIM_Try, /*On fail goto*//*Label 2365*/ GIMT_Encode4(111180), // Rule ID 12346 //
     /* 111159 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 111162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 111165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 111169 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 111173 */   // (trunc:{ *:[v32i8] } VR512:{ *:[v32i16] }:$src)  =>  (VPMOVWBZrr:{ *:[v32i8] } VR512:{ *:[v32i16] }:$src)
     /* 111173 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVWBZrr),
     /* 111178 */   GIR_RootConstrainSelectedInstOperands,
     /* 111179 */   // GIR_Coverage, 12346,
     /* 111179 */   GIR_Done,
     /* 111180 */ // Label 2365: @111180
     /* 111180 */ GIM_Reject,
     /* 111181 */ // Label 2345: @111181
     /* 111181 */ GIM_Reject,
     /* 111182 */ // Label 21: @111182
     /* 111182 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(5), /*)*//*default:*//*Label 2370*/ GIMT_Encode4(111787),
     /* 111193 */ /*GILLT_s8*//*Label 2366*/ GIMT_Encode4(111209),
     /* 111197 */ /*GILLT_s16*//*Label 2367*/ GIMT_Encode4(111291),
     /* 111201 */ /*GILLT_s32*//*Label 2368*/ GIMT_Encode4(111491),
     /* 111205 */ /*GILLT_s64*//*Label 2369*/ GIMT_Encode4(111633),
     /* 111209 */ // Label 2366: @111209
     /* 111209 */ GIM_Try, /*On fail goto*//*Label 2371*/ GIMT_Encode4(111290),
     /* 111214 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 111218 */   GIM_Try, /*On fail goto*//*Label 2372*/ GIMT_Encode4(111274), // Rule ID 22384 //
     /* 111223 */     // MIs[0] Operand 1
     /* 111223 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(0),
     /* 111234 */     // 0:{ *:[i8] }  =>  (EXTRACT_SUBREG:{ *:[i8] } (MOV32r0:{ *:[i32] }:{ *:[i32] }), sub_8bit:{ *:[i32] })
     /* 111234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOV32r0),
     /* 111241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111246 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 111249 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111256 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_8bit),
     /* 111263 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /* 111268 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 111273 */     // GIR_Coverage, 22384,
     /* 111273 */     GIR_EraseRootFromParent_Done,
     /* 111274 */   // Label 2372: @111274
     /* 111274 */   GIM_Try, /*On fail goto*//*Label 2373*/ GIMT_Encode4(111289), // Rule ID 19 //
     /* 111279 */     // MIs[0] Operand 1
     /* 111279 */     // No operand predicates
     /* 111279 */     // (imm:{ *:[i8] }):$src  =>  (MOV8ri:{ *:[i8] } (imm:{ *:[i8] }):$src)
     /* 111279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8ri),
     /* 111282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111284 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 111287 */     GIR_RootConstrainSelectedInstOperands,
     /* 111288 */     // GIR_Coverage, 19,
     /* 111288 */     GIR_EraseRootFromParent_Done,
     /* 111289 */   // Label 2373: @111289
     /* 111289 */   GIM_Reject,
     /* 111290 */ // Label 2371: @111290
     /* 111290 */ GIM_Reject,
     /* 111291 */ // Label 2367: @111291
     /* 111291 */ GIM_Try, /*On fail goto*//*Label 2374*/ GIMT_Encode4(111490),
     /* 111296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 111300 */   GIM_Try, /*On fail goto*//*Label 2375*/ GIMT_Encode4(111356), // Rule ID 22385 //
     /* 111305 */     // MIs[0] Operand 1
     /* 111305 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(0),
     /* 111316 */     // 0:{ *:[i16] }  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOV32r0:{ *:[i32] }:{ *:[i32] }), sub_16bit:{ *:[i32] })
     /* 111316 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111319 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOV32r0),
     /* 111323 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111328 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 111331 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111338 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 111345 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 111350 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 111355 */     // GIR_Coverage, 22385,
     /* 111355 */     GIR_EraseRootFromParent_Done,
     /* 111356 */   // Label 2375: @111356
     /* 111356 */   GIM_Try, /*On fail goto*//*Label 2376*/ GIMT_Encode4(111415), // Rule ID 22387 //
     /* 111361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode_OptForSize),
     /* 111364 */     // MIs[0] Operand 1
     /* 111364 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(1),
     /* 111375 */     // 1:{ *:[i16] }  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOV32r1:{ *:[i32] }:{ *:[i32] }), sub_16bit:{ *:[i32] })
     /* 111375 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111378 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOV32r1),
     /* 111382 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111387 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 111390 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111397 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 111404 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 111409 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 111414 */     // GIR_Coverage, 22387,
     /* 111414 */     GIR_EraseRootFromParent_Done,
     /* 111415 */   // Label 2376: @111415
     /* 111415 */   GIM_Try, /*On fail goto*//*Label 2377*/ GIMT_Encode4(111474), // Rule ID 22388 //
     /* 111420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode_OptForSize),
     /* 111423 */     // MIs[0] Operand 1
     /* 111423 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(-1),
     /* 111434 */     // -1:{ *:[i16] }  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOV32r_1:{ *:[i32] }:{ *:[i32] }), sub_16bit:{ *:[i32] })
     /* 111434 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111437 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOV32r_1),
     /* 111441 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111446 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 111449 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111456 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 111463 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 111468 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 111473 */     // GIR_Coverage, 22388,
     /* 111473 */     GIR_EraseRootFromParent_Done,
     /* 111474 */   // Label 2377: @111474
     /* 111474 */   GIM_Try, /*On fail goto*//*Label 2378*/ GIMT_Encode4(111489), // Rule ID 20 //
     /* 111479 */     // MIs[0] Operand 1
     /* 111479 */     // No operand predicates
     /* 111479 */     // (imm:{ *:[i16] }):$src  =>  (MOV16ri:{ *:[i16] } (imm:{ *:[i16] }):$src)
     /* 111479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV16ri),
     /* 111482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111484 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 111487 */     GIR_RootConstrainSelectedInstOperands,
     /* 111488 */     // GIR_Coverage, 20,
     /* 111488 */     GIR_EraseRootFromParent_Done,
     /* 111489 */   // Label 2378: @111489
     /* 111489 */   GIM_Reject,
     /* 111490 */ // Label 2374: @111490
     /* 111490 */ GIM_Reject,
     /* 111491 */ // Label 2368: @111491
     /* 111491 */ GIM_Try, /*On fail goto*//*Label 2379*/ GIMT_Encode4(111521), // Rule ID 17153 //
     /* 111496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 111500 */   // MIs[0] Operand 1
     /* 111500 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(0),
     /* 111511 */   // 0:{ *:[i32] }  =>  (MOV32r0:{ *:[i32] }:{ *:[i32] })
     /* 111511 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32r0),
     /* 111514 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111516 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 111519 */   GIR_RootConstrainSelectedInstOperands,
     /* 111520 */   // GIR_Coverage, 17153,
     /* 111520 */   GIR_EraseRootFromParent_Done,
     /* 111521 */ // Label 2379: @111521
     /* 111521 */ GIM_Try, /*On fail goto*//*Label 2380*/ GIMT_Encode4(111554), // Rule ID 17154 //
     /* 111526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode_OptForSize),
     /* 111529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 111533 */   // MIs[0] Operand 1
     /* 111533 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(1),
     /* 111544 */   // 1:{ *:[i32] }  =>  (MOV32r1:{ *:[i32] }:{ *:[i32] })
     /* 111544 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32r1),
     /* 111547 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111549 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 111552 */   GIR_RootConstrainSelectedInstOperands,
     /* 111553 */   // GIR_Coverage, 17154,
     /* 111553 */   GIR_EraseRootFromParent_Done,
     /* 111554 */ // Label 2380: @111554
     /* 111554 */ GIM_Try, /*On fail goto*//*Label 2381*/ GIMT_Encode4(111587), // Rule ID 17155 //
     /* 111559 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode_OptForSize),
     /* 111562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 111566 */   // MIs[0] Operand 1
     /* 111566 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(-1),
     /* 111577 */   // -1:{ *:[i32] }  =>  (MOV32r_1:{ *:[i32] }:{ *:[i32] })
     /* 111577 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32r_1),
     /* 111580 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111582 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 111585 */   GIR_RootConstrainSelectedInstOperands,
     /* 111586 */   // GIR_Coverage, 17155,
     /* 111586 */   GIR_EraseRootFromParent_Done,
     /* 111587 */ // Label 2381: @111587
     /* 111587 */ GIM_Try, /*On fail goto*//*Label 2382*/ GIMT_Encode4(111613), // Rule ID 17156 //
     /* 111592 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotWin64WithoutFP_OptForMinSize),
     /* 111595 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i32immSExt8),
     /* 111599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 111603 */   // MIs[0] Operand 1
     /* 111603 */   // No operand predicates
     /* 111603 */   // (imm:{ *:[i32] })<<P:Predicate_i32immSExt8>>:$src  =>  (MOV32ImmSExti8:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /* 111603 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32ImmSExti8),
     /* 111606 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111608 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 111611 */   GIR_RootConstrainSelectedInstOperands,
     /* 111612 */   // GIR_Coverage, 17156,
     /* 111612 */   GIR_EraseRootFromParent_Done,
     /* 111613 */ // Label 2382: @111613
     /* 111613 */ GIM_Try, /*On fail goto*//*Label 2383*/ GIMT_Encode4(111632), // Rule ID 21 //
     /* 111618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 111622 */   // MIs[0] Operand 1
     /* 111622 */   // No operand predicates
     /* 111622 */   // (imm:{ *:[i32] }):$src  =>  (MOV32ri:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /* 111622 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32ri),
     /* 111625 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111627 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 111630 */   GIR_RootConstrainSelectedInstOperands,
     /* 111631 */   // GIR_Coverage, 21,
     /* 111631 */   GIR_EraseRootFromParent_Done,
     /* 111632 */ // Label 2383: @111632
     /* 111632 */ GIM_Reject,
     /* 111633 */ // Label 2369: @111633
     /* 111633 */ GIM_Try, /*On fail goto*//*Label 2384*/ GIMT_Encode4(111695), // Rule ID 22386 //
     /* 111638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 111642 */   // MIs[0] Operand 1
     /* 111642 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(0),
     /* 111653 */   // 0:{ *:[i64] }  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOV32r0:{ *:[i32] }:{ *:[i32] }), sub_32bit:{ *:[i32] })
     /* 111653 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111656 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOV32r0),
     /* 111660 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111665 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 111668 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111670 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111673 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111675 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111678 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111681 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 111684 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 111689 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 111694 */   // GIR_Coverage, 22386,
     /* 111694 */   GIR_EraseRootFromParent_Done,
     /* 111695 */ // Label 2384: @111695
     /* 111695 */ GIM_Try, /*On fail goto*//*Label 2385*/ GIMT_Encode4(111721), // Rule ID 17157 //
     /* 111700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotWin64WithoutFP_OptForMinSize),
     /* 111703 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt8),
     /* 111707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 111711 */   // MIs[0] Operand 1
     /* 111711 */   // No operand predicates
     /* 111711 */   // (imm:{ *:[i64] })<<P:Predicate_i64immSExt8>>:$src  =>  (MOV64ImmSExti8:{ *:[i64] } (imm:{ *:[i64] }):$src)
     /* 111711 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV64ImmSExti8),
     /* 111714 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111716 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 111719 */   GIR_RootConstrainSelectedInstOperands,
     /* 111720 */   // GIR_Coverage, 17157,
     /* 111720 */   GIR_EraseRootFromParent_Done,
     /* 111721 */ // Label 2385: @111721
     /* 111721 */ GIM_Try, /*On fail goto*//*Label 2386*/ GIMT_Encode4(111744), // Rule ID 17158 //
     /* 111726 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immZExt32),
     /* 111730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 111734 */   // MIs[0] Operand 1
     /* 111734 */   // No operand predicates
     /* 111734 */   // (imm:{ *:[i64] })<<P:Predicate_i64immZExt32>>:$src  =>  (MOV32ri64:{ *:[i64] } (imm:{ *:[i64] }):$src)
     /* 111734 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32ri64),
     /* 111737 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111739 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 111742 */   GIR_RootConstrainSelectedInstOperands,
     /* 111743 */   // GIR_Coverage, 17158,
     /* 111743 */   GIR_EraseRootFromParent_Done,
     /* 111744 */ // Label 2386: @111744
     /* 111744 */ GIM_Try, /*On fail goto*//*Label 2387*/ GIMT_Encode4(111767), // Rule ID 22 //
     /* 111749 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /* 111753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 111757 */   // MIs[0] Operand 1
     /* 111757 */   // No operand predicates
     /* 111757 */   // (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src  =>  (MOV64ri32:{ *:[i64] } (imm:{ *:[i64] }):$src)
     /* 111757 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV64ri32),
     /* 111760 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111762 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 111765 */   GIR_RootConstrainSelectedInstOperands,
     /* 111766 */   // GIR_Coverage, 22,
     /* 111766 */   GIR_EraseRootFromParent_Done,
     /* 111767 */ // Label 2387: @111767
     /* 111767 */ GIM_Try, /*On fail goto*//*Label 2388*/ GIMT_Encode4(111786), // Rule ID 23 //
     /* 111772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 111776 */   // MIs[0] Operand 1
     /* 111776 */   // No operand predicates
     /* 111776 */   // (imm:{ *:[i64] }):$src  =>  (MOV64ri:{ *:[i64] } (imm:{ *:[i64] }):$src)
     /* 111776 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV64ri),
     /* 111779 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111781 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 111784 */   GIR_RootConstrainSelectedInstOperands,
     /* 111785 */   // GIR_Coverage, 23,
     /* 111785 */   GIR_EraseRootFromParent_Done,
     /* 111786 */ // Label 2388: @111786
     /* 111786 */ GIM_Reject,
     /* 111787 */ // Label 2370: @111787
     /* 111787 */ GIM_Reject,
     /* 111788 */ // Label 22: @111788
     /* 111788 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(6), /*)*//*default:*//*Label 2392*/ GIMT_Encode4(112240),
     /* 111799 */ /*GILLT_s32*//*Label 2389*/ GIMT_Encode4(111811),
     /* 111803 */ /*GILLT_s64*//*Label 2390*/ GIMT_Encode4(111956),
     /* 111807 */ /*GILLT_s80*//*Label 2391*/ GIMT_Encode4(112101),
     /* 111811 */ // Label 2389: @111811
     /* 111811 */ GIM_Try, /*On fail goto*//*Label 2393*/ GIMT_Encode4(111837), // Rule ID 1116 //
     /* 111816 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 111819 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 111823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 111827 */   // MIs[0] Operand 1
     /* 111827 */   // No operand predicates
     /* 111827 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>  =>  (LD_Fp032:{ *:[f32] }:{ *:[i16] })
     /* 111827 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp032),
     /* 111830 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111832 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 111835 */   GIR_RootConstrainSelectedInstOperands,
     /* 111836 */   // GIR_Coverage, 1116,
     /* 111836 */   GIR_EraseRootFromParent_Done,
     /* 111837 */ // Label 2393: @111837
     /* 111837 */ GIM_Try, /*On fail goto*//*Label 2394*/ GIMT_Encode4(111863), // Rule ID 1117 //
     /* 111842 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 111845 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm1),
     /* 111849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 111853 */   // MIs[0] Operand 1
     /* 111853 */   // No operand predicates
     /* 111853 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm1>>  =>  (LD_Fp132:{ *:[f32] }:{ *:[i16] })
     /* 111853 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp132),
     /* 111856 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111858 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 111861 */   GIR_RootConstrainSelectedInstOperands,
     /* 111862 */   // GIR_Coverage, 1117,
     /* 111862 */   GIR_EraseRootFromParent_Done,
     /* 111863 */ // Label 2394: @111863
     /* 111863 */ GIM_Try, /*On fail goto*//*Label 2395*/ GIMT_Encode4(111909), // Rule ID 17720 //
     /* 111868 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 111871 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimmneg0),
     /* 111875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 111879 */   // MIs[0] Operand 1
     /* 111879 */   // No operand predicates
     /* 111879 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimmneg0>>  =>  (CHS_Fp32:{ *:[f32] }:{ *:[i16] } (LD_Fp032:{ *:[f32] }:{ *:[i16] }))
     /* 111879 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111882 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::LD_Fp032),
     /* 111886 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111891 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::FPSW*/0,
     /* 111894 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111896 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CHS_Fp32),
     /* 111899 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111901 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111904 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 111907 */   GIR_RootConstrainSelectedInstOperands,
     /* 111908 */   // GIR_Coverage, 17720,
     /* 111908 */   GIR_EraseRootFromParent_Done,
     /* 111909 */ // Label 2395: @111909
     /* 111909 */ GIM_Try, /*On fail goto*//*Label 2396*/ GIMT_Encode4(111955), // Rule ID 17721 //
     /* 111914 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 111917 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimmneg1),
     /* 111921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 111925 */   // MIs[0] Operand 1
     /* 111925 */   // No operand predicates
     /* 111925 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimmneg1>>  =>  (CHS_Fp32:{ *:[f32] }:{ *:[i16] } (LD_Fp132:{ *:[f32] }:{ *:[i16] }))
     /* 111925 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111928 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::LD_Fp132),
     /* 111932 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111937 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::FPSW*/0,
     /* 111940 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111942 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CHS_Fp32),
     /* 111945 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111947 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111950 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 111953 */   GIR_RootConstrainSelectedInstOperands,
     /* 111954 */   // GIR_Coverage, 17721,
     /* 111954 */   GIR_EraseRootFromParent_Done,
     /* 111955 */ // Label 2396: @111955
     /* 111955 */ GIM_Reject,
     /* 111956 */ // Label 2390: @111956
     /* 111956 */ GIM_Try, /*On fail goto*//*Label 2397*/ GIMT_Encode4(111982), // Rule ID 1118 //
     /* 111961 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 111964 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 111968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 111972 */   // MIs[0] Operand 1
     /* 111972 */   // No operand predicates
     /* 111972 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>  =>  (LD_Fp064:{ *:[f64] }:{ *:[i16] })
     /* 111972 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp064),
     /* 111975 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111977 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 111980 */   GIR_RootConstrainSelectedInstOperands,
     /* 111981 */   // GIR_Coverage, 1118,
     /* 111981 */   GIR_EraseRootFromParent_Done,
     /* 111982 */ // Label 2397: @111982
     /* 111982 */ GIM_Try, /*On fail goto*//*Label 2398*/ GIMT_Encode4(112008), // Rule ID 1119 //
     /* 111987 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 111990 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm1),
     /* 111994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 111998 */   // MIs[0] Operand 1
     /* 111998 */   // No operand predicates
     /* 111998 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm1>>  =>  (LD_Fp164:{ *:[f64] }:{ *:[i16] })
     /* 111998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp164),
     /* 112001 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112003 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 112006 */   GIR_RootConstrainSelectedInstOperands,
     /* 112007 */   // GIR_Coverage, 1119,
     /* 112007 */   GIR_EraseRootFromParent_Done,
     /* 112008 */ // Label 2398: @112008
     /* 112008 */ GIM_Try, /*On fail goto*//*Label 2399*/ GIMT_Encode4(112054), // Rule ID 17722 //
     /* 112013 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 112016 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimmneg0),
     /* 112020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 112024 */   // MIs[0] Operand 1
     /* 112024 */   // No operand predicates
     /* 112024 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimmneg0>>  =>  (CHS_Fp64:{ *:[f64] }:{ *:[i16] } (LD_Fp064:{ *:[f64] }:{ *:[i16] }))
     /* 112024 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 112027 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::LD_Fp064),
     /* 112031 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112036 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::FPSW*/0,
     /* 112039 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112041 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CHS_Fp64),
     /* 112044 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112046 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112049 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 112052 */   GIR_RootConstrainSelectedInstOperands,
     /* 112053 */   // GIR_Coverage, 17722,
     /* 112053 */   GIR_EraseRootFromParent_Done,
     /* 112054 */ // Label 2399: @112054
     /* 112054 */ GIM_Try, /*On fail goto*//*Label 2400*/ GIMT_Encode4(112100), // Rule ID 17723 //
     /* 112059 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 112062 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimmneg1),
     /* 112066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 112070 */   // MIs[0] Operand 1
     /* 112070 */   // No operand predicates
     /* 112070 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimmneg1>>  =>  (CHS_Fp64:{ *:[f64] }:{ *:[i16] } (LD_Fp164:{ *:[f64] }:{ *:[i16] }))
     /* 112070 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 112073 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::LD_Fp164),
     /* 112077 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112082 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::FPSW*/0,
     /* 112085 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112087 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CHS_Fp64),
     /* 112090 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112092 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112095 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 112098 */   GIR_RootConstrainSelectedInstOperands,
     /* 112099 */   // GIR_Coverage, 17723,
     /* 112099 */   GIR_EraseRootFromParent_Done,
     /* 112100 */ // Label 2400: @112100
     /* 112100 */ GIM_Reject,
     /* 112101 */ // Label 2391: @112101
     /* 112101 */ GIM_Try, /*On fail goto*//*Label 2401*/ GIMT_Encode4(112127), // Rule ID 1120 //
     /* 112106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 112109 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 112113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 112117 */   // MIs[0] Operand 1
     /* 112117 */   // No operand predicates
     /* 112117 */   // (fpimm:{ *:[f80] })<<P:Predicate_fpimm0>>  =>  (LD_Fp080:{ *:[f80] }:{ *:[i16] })
     /* 112117 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp080),
     /* 112120 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112122 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 112125 */   GIR_RootConstrainSelectedInstOperands,
     /* 112126 */   // GIR_Coverage, 1120,
     /* 112126 */   GIR_EraseRootFromParent_Done,
     /* 112127 */ // Label 2401: @112127
     /* 112127 */ GIM_Try, /*On fail goto*//*Label 2402*/ GIMT_Encode4(112153), // Rule ID 1121 //
     /* 112132 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 112135 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm1),
     /* 112139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 112143 */   // MIs[0] Operand 1
     /* 112143 */   // No operand predicates
     /* 112143 */   // (fpimm:{ *:[f80] })<<P:Predicate_fpimm1>>  =>  (LD_Fp180:{ *:[f80] }:{ *:[i16] })
     /* 112143 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp180),
     /* 112146 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112148 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 112151 */   GIR_RootConstrainSelectedInstOperands,
     /* 112152 */   // GIR_Coverage, 1121,
     /* 112152 */   GIR_EraseRootFromParent_Done,
     /* 112153 */ // Label 2402: @112153
     /* 112153 */ GIM_Try, /*On fail goto*//*Label 2403*/ GIMT_Encode4(112196), // Rule ID 17724 //
     /* 112158 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimmneg0),
     /* 112162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 112166 */   // MIs[0] Operand 1
     /* 112166 */   // No operand predicates
     /* 112166 */   // (fpimm:{ *:[f80] })<<P:Predicate_fpimmneg0>>  =>  (CHS_Fp80:{ *:[f80] }:{ *:[i16] } (LD_Fp080:{ *:[f80] }:{ *:[i16] }))
     /* 112166 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s80,
     /* 112169 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::LD_Fp080),
     /* 112173 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112178 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::FPSW*/0,
     /* 112181 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112183 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CHS_Fp80),
     /* 112186 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112188 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112191 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 112194 */   GIR_RootConstrainSelectedInstOperands,
     /* 112195 */   // GIR_Coverage, 17724,
     /* 112195 */   GIR_EraseRootFromParent_Done,
     /* 112196 */ // Label 2403: @112196
     /* 112196 */ GIM_Try, /*On fail goto*//*Label 2404*/ GIMT_Encode4(112239), // Rule ID 17725 //
     /* 112201 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimmneg1),
     /* 112205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 112209 */   // MIs[0] Operand 1
     /* 112209 */   // No operand predicates
     /* 112209 */   // (fpimm:{ *:[f80] })<<P:Predicate_fpimmneg1>>  =>  (CHS_Fp80:{ *:[f80] }:{ *:[i16] } (LD_Fp180:{ *:[f80] }:{ *:[i16] }))
     /* 112209 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s80,
     /* 112212 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::LD_Fp180),
     /* 112216 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112221 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::FPSW*/0,
     /* 112224 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112226 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CHS_Fp80),
     /* 112229 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112231 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112234 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 112237 */   GIR_RootConstrainSelectedInstOperands,
     /* 112238 */   // GIR_Coverage, 17725,
     /* 112238 */   GIR_EraseRootFromParent_Done,
     /* 112239 */ // Label 2404: @112239
     /* 112239 */ GIM_Reject,
     /* 112240 */ // Label 2392: @112240
     /* 112240 */ GIM_Reject,
     /* 112241 */ // Label 23: @112241
     /* 112241 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(25), /*)*//*default:*//*Label 2420*/ GIMT_Encode4(113912),
     /* 112252 */ /*GILLT_s16*//*Label 2405*/ GIMT_Encode4(112344),
     /* 112256 */ /*GILLT_s32*//*Label 2406*/ GIMT_Encode4(112402),
     /* 112260 */ /*GILLT_s64*//*Label 2407*/ GIMT_Encode4(112449), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 112276 */ /*GILLT_v2s64*//*Label 2408*/ GIMT_Encode4(112522), GIMT_Encode4(0),
     /* 112284 */ /*GILLT_v4s32*//*Label 2409*/ GIMT_Encode4(112549),
     /* 112288 */ /*GILLT_v4s64*//*Label 2410*/ GIMT_Encode4(112576), GIMT_Encode4(0),
     /* 112296 */ /*GILLT_v8s16*//*Label 2411*/ GIMT_Encode4(112773),
     /* 112300 */ /*GILLT_v8s32*//*Label 2412*/ GIMT_Encode4(112842),
     /* 112304 */ /*GILLT_v8s64*//*Label 2413*/ GIMT_Encode4(113039), GIMT_Encode4(0),
     /* 112312 */ /*GILLT_v16s8*//*Label 2414*/ GIMT_Encode4(113236),
     /* 112316 */ /*GILLT_v16s16*//*Label 2415*/ GIMT_Encode4(113305),
     /* 112320 */ /*GILLT_v16s32*//*Label 2416*/ GIMT_Encode4(113549), GIMT_Encode4(0),
     /* 112328 */ /*GILLT_v32s8*//*Label 2417*/ GIMT_Encode4(113746),
     /* 112332 */ /*GILLT_v32s16*//*Label 2418*/ GIMT_Encode4(113773), GIMT_Encode4(0),
     /* 112340 */ /*GILLT_v64s8*//*Label 2419*/ GIMT_Encode4(113885),
     /* 112344 */ // Label 2405: @112344
     /* 112344 */ GIM_Try, /*On fail goto*//*Label 2421*/ GIMT_Encode4(112401), // Rule ID 22647 //
     /* 112349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 112352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 112356 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 112360 */   // (sext:{ *:[i16] } GR8:{ *:[i8] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVSX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src), sub_16bit:{ *:[i32] })
     /* 112360 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 112363 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVSX32rr8),
     /* 112367 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112372 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 112376 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112378 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112381 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112383 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 112390 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 112395 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 112400 */   // GIR_Coverage, 22647,
     /* 112400 */   GIR_EraseRootFromParent_Done,
     /* 112401 */ // Label 2421: @112401
     /* 112401 */ GIM_Reject,
     /* 112402 */ // Label 2406: @112402
     /* 112402 */ GIM_Try, /*On fail goto*//*Label 2422*/ GIMT_Encode4(112425), // Rule ID 614 //
     /* 112407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 112410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 112414 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 112418 */   // (sext:{ *:[i32] } GR8:{ *:[i8] }:$src)  =>  (MOVSX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /* 112418 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSX32rr8),
     /* 112423 */   GIR_RootConstrainSelectedInstOperands,
     /* 112424 */   // GIR_Coverage, 614,
     /* 112424 */   GIR_Done,
     /* 112425 */ // Label 2422: @112425
     /* 112425 */ GIM_Try, /*On fail goto*//*Label 2423*/ GIMT_Encode4(112448), // Rule ID 616 //
     /* 112430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 112433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 112437 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 112441 */   // (sext:{ *:[i32] } GR16:{ *:[i16] }:$src)  =>  (MOVSX32rr16:{ *:[i32] } GR16:{ *:[i16] }:$src)
     /* 112441 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSX32rr16),
     /* 112446 */   GIR_RootConstrainSelectedInstOperands,
     /* 112447 */   // GIR_Coverage, 616,
     /* 112447 */   GIR_Done,
     /* 112448 */ // Label 2423: @112448
     /* 112448 */ GIM_Reject,
     /* 112449 */ // Label 2407: @112449
     /* 112449 */ GIM_Try, /*On fail goto*//*Label 2424*/ GIMT_Encode4(112472), // Rule ID 622 //
     /* 112454 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 112457 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 112461 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 112465 */   // (sext:{ *:[i64] } GR8:{ *:[i8] }:$src)  =>  (MOVSX64rr8:{ *:[i64] } GR8:{ *:[i8] }:$src)
     /* 112465 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSX64rr8),
     /* 112470 */   GIR_RootConstrainSelectedInstOperands,
     /* 112471 */   // GIR_Coverage, 622,
     /* 112471 */   GIR_Done,
     /* 112472 */ // Label 2424: @112472
     /* 112472 */ GIM_Try, /*On fail goto*//*Label 2425*/ GIMT_Encode4(112495), // Rule ID 624 //
     /* 112477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 112480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 112484 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 112488 */   // (sext:{ *:[i64] } GR16:{ *:[i16] }:$src)  =>  (MOVSX64rr16:{ *:[i64] } GR16:{ *:[i16] }:$src)
     /* 112488 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSX64rr16),
     /* 112493 */   GIR_RootConstrainSelectedInstOperands,
     /* 112494 */   // GIR_Coverage, 624,
     /* 112494 */   GIR_Done,
     /* 112495 */ // Label 2425: @112495
     /* 112495 */ GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(112521), // Rule ID 626 //
     /* 112500 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /* 112503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 112506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 112510 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 112514 */   // (sext:{ *:[i64] } GR32:{ *:[i32] }:$src)  =>  (MOVSX64rr32:{ *:[i64] } GR32:{ *:[i32] }:$src)
     /* 112514 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSX64rr32),
     /* 112519 */   GIR_RootConstrainSelectedInstOperands,
     /* 112520 */   // GIR_Coverage, 626,
     /* 112520 */   GIR_Done,
     /* 112521 */ // Label 2426: @112521
     /* 112521 */ GIM_Reject,
     /* 112522 */ // Label 2408: @112522
     /* 112522 */ GIM_Try, /*On fail goto*//*Label 2427*/ GIMT_Encode4(112548), // Rule ID 12594 //
     /* 112527 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 112530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /* 112533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 112537 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 112541 */   // (sext:{ *:[v2i64] } VK2:{ *:[v2i1] }:$src)  =>  (VPMOVM2QZ128rk:{ *:[v2i64] } VK2:{ *:[v2i1] }:$src)
     /* 112541 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2QZ128rk),
     /* 112546 */   GIR_RootConstrainSelectedInstOperands,
     /* 112547 */   // GIR_Coverage, 12594,
     /* 112547 */   GIR_Done,
     /* 112548 */ // Label 2427: @112548
     /* 112548 */ GIM_Reject,
     /* 112549 */ // Label 2409: @112549
     /* 112549 */ GIM_Try, /*On fail goto*//*Label 2428*/ GIMT_Encode4(112575), // Rule ID 12591 //
     /* 112554 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 112557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 112560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 112564 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 112568 */   // (sext:{ *:[v4i32] } VK4:{ *:[v4i1] }:$src)  =>  (VPMOVM2DZ128rk:{ *:[v4i32] } VK4:{ *:[v4i1] }:$src)
     /* 112568 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2DZ128rk),
     /* 112573 */   GIR_RootConstrainSelectedInstOperands,
     /* 112574 */   // GIR_Coverage, 12591,
     /* 112574 */   GIR_Done,
     /* 112575 */ // Label 2428: @112575
     /* 112575 */ GIM_Reject,
     /* 112576 */ // Label 2410: @112576
     /* 112576 */ GIM_Try, /*On fail goto*//*Label 2429*/ GIMT_Encode4(112635), // Rule ID 18390 //
     /* 112581 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 112584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 112591 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112595 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 112599 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112602 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 112606 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 112610 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112612 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 112619 */   // (sext:{ *:[v4i64] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXDQYrm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /* 112619 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXDQYrm),
     /* 112622 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112624 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 112628 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112633 */   GIR_RootConstrainSelectedInstOperands,
     /* 112634 */   // GIR_Coverage, 18390,
     /* 112634 */   GIR_EraseRootFromParent_Done,
     /* 112635 */ // Label 2429: @112635
     /* 112635 */ GIM_Try, /*On fail goto*//*Label 2430*/ GIMT_Encode4(112694), // Rule ID 21585 //
     /* 112640 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 112643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 112650 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112654 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 112658 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112661 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 112665 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 112669 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112671 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 112678 */   // (sext:{ *:[v4i64] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXDQZ256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /* 112678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXDQZ256rm),
     /* 112681 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112683 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 112687 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112692 */   GIR_RootConstrainSelectedInstOperands,
     /* 112693 */   // GIR_Coverage, 21585,
     /* 112693 */   GIR_EraseRootFromParent_Done,
     /* 112694 */ // Label 2430: @112694
     /* 112694 */ GIM_Try, /*On fail goto*//*Label 2431*/ GIMT_Encode4(112720), // Rule ID 12571 //
     /* 112699 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 112702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 112709 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 112713 */   // (sext:{ *:[v4i64] } VR128X:{ *:[v4i32] }:$src)  =>  (VPMOVSXDQZ256rr:{ *:[v4i64] } VR128X:{ *:[v4i32] }:$src)
     /* 112713 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXDQZ256rr),
     /* 112718 */   GIR_RootConstrainSelectedInstOperands,
     /* 112719 */   // GIR_Coverage, 12571,
     /* 112719 */   GIR_Done,
     /* 112720 */ // Label 2431: @112720
     /* 112720 */ GIM_Try, /*On fail goto*//*Label 2432*/ GIMT_Encode4(112746), // Rule ID 12593 //
     /* 112725 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 112728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 112731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 112735 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 112739 */   // (sext:{ *:[v4i64] } VK4:{ *:[v4i1] }:$src)  =>  (VPMOVM2QZ256rk:{ *:[v4i64] } VK4:{ *:[v4i1] }:$src)
     /* 112739 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2QZ256rk),
     /* 112744 */   GIR_RootConstrainSelectedInstOperands,
     /* 112745 */   // GIR_Coverage, 12593,
     /* 112745 */   GIR_Done,
     /* 112746 */ // Label 2432: @112746
     /* 112746 */ GIM_Try, /*On fail goto*//*Label 2433*/ GIMT_Encode4(112772), // Rule ID 18378 //
     /* 112751 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 112754 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 112761 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 112765 */   // (sext:{ *:[v4i64] } VR128:{ *:[v4i32] }:$src)  =>  (VPMOVSXDQYrr:{ *:[v4i64] } VR128:{ *:[v4i32] }:$src)
     /* 112765 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXDQYrr),
     /* 112770 */   GIR_RootConstrainSelectedInstOperands,
     /* 112771 */   // GIR_Coverage, 18378,
     /* 112771 */   GIR_Done,
     /* 112772 */ // Label 2433: @112772
     /* 112772 */ GIM_Reject,
     /* 112773 */ // Label 2411: @112773
     /* 112773 */ GIM_Try, /*On fail goto*//*Label 2434*/ GIMT_Encode4(112841),
     /* 112778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 112781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 112785 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 112789 */   GIM_Try, /*On fail goto*//*Label 2435*/ GIMT_Encode4(112804), // Rule ID 12588 //
     /* 112794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 112797 */     // (sext:{ *:[v8i16] } VK8:{ *:[v8i1] }:$src)  =>  (VPMOVM2WZ128rk:{ *:[v8i16] } VK8:{ *:[v8i1] }:$src)
     /* 112797 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2WZ128rk),
     /* 112802 */     GIR_RootConstrainSelectedInstOperands,
     /* 112803 */     // GIR_Coverage, 12588,
     /* 112803 */     GIR_Done,
     /* 112804 */   // Label 2435: @112804
     /* 112804 */   GIM_Try, /*On fail goto*//*Label 2436*/ GIMT_Encode4(112840), // Rule ID 21661 //
     /* 112809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX_NoBWI),
     /* 112812 */     // (sext:{ *:[v8i16] } VK8:{ *:[v8i1] }:$src)  =>  (VPMOVDWZ256rr:{ *:[v8i16] } (VPMOVM2DZ256rk:{ *:[v8i32] } VK8:{ *:[v8i1] }:$src))
     /* 112812 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s32,
     /* 112815 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVM2DZ256rk),
     /* 112819 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112824 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 112828 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVDWZ256rr),
     /* 112833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112835 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112838 */     GIR_RootConstrainSelectedInstOperands,
     /* 112839 */     // GIR_Coverage, 21661,
     /* 112839 */     GIR_EraseRootFromParent_Done,
     /* 112840 */   // Label 2436: @112840
     /* 112840 */   GIM_Reject,
     /* 112841 */ // Label 2434: @112841
     /* 112841 */ GIM_Reject,
     /* 112842 */ // Label 2412: @112842
     /* 112842 */ GIM_Try, /*On fail goto*//*Label 2437*/ GIMT_Encode4(112901), // Rule ID 18386 //
     /* 112847 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 112850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 112857 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112861 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 112865 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112868 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 112872 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 112876 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112878 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 112885 */   // (sext:{ *:[v8i32] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXWDYrm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /* 112885 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWDYrm),
     /* 112888 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112890 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 112894 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112899 */   GIR_RootConstrainSelectedInstOperands,
     /* 112900 */   // GIR_Coverage, 18386,
     /* 112900 */   GIR_EraseRootFromParent_Done,
     /* 112901 */ // Label 2437: @112901
     /* 112901 */ GIM_Try, /*On fail goto*//*Label 2438*/ GIMT_Encode4(112960), // Rule ID 21584 //
     /* 112906 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 112909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 112916 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112920 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 112924 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112927 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 112931 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 112935 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112937 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 112944 */   // (sext:{ *:[v8i32] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXWDZ256rm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /* 112944 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWDZ256rm),
     /* 112947 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112949 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 112953 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112958 */   GIR_RootConstrainSelectedInstOperands,
     /* 112959 */   // GIR_Coverage, 21584,
     /* 112959 */   GIR_EraseRootFromParent_Done,
     /* 112960 */ // Label 2438: @112960
     /* 112960 */ GIM_Try, /*On fail goto*//*Label 2439*/ GIMT_Encode4(112986), // Rule ID 12535 //
     /* 112965 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 112968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 112975 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 112979 */   // (sext:{ *:[v8i32] } VR128X:{ *:[v8i16] }:$src)  =>  (VPMOVSXWDZ256rr:{ *:[v8i32] } VR128X:{ *:[v8i16] }:$src)
     /* 112979 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWDZ256rr),
     /* 112984 */   GIR_RootConstrainSelectedInstOperands,
     /* 112985 */   // GIR_Coverage, 12535,
     /* 112985 */   GIR_Done,
     /* 112986 */ // Label 2439: @112986
     /* 112986 */ GIM_Try, /*On fail goto*//*Label 2440*/ GIMT_Encode4(113012), // Rule ID 12590 //
     /* 112991 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 112994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 112997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 113001 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 113005 */   // (sext:{ *:[v8i32] } VK8:{ *:[v8i1] }:$src)  =>  (VPMOVM2DZ256rk:{ *:[v8i32] } VK8:{ *:[v8i1] }:$src)
     /* 113005 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2DZ256rk),
     /* 113010 */   GIR_RootConstrainSelectedInstOperands,
     /* 113011 */   // GIR_Coverage, 12590,
     /* 113011 */   GIR_Done,
     /* 113012 */ // Label 2440: @113012
     /* 113012 */ GIM_Try, /*On fail goto*//*Label 2441*/ GIMT_Encode4(113038), // Rule ID 18376 //
     /* 113017 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 113020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 113023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 113027 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 113031 */   // (sext:{ *:[v8i32] } VR128:{ *:[v8i16] }:$src)  =>  (VPMOVSXWDYrr:{ *:[v8i32] } VR128:{ *:[v8i16] }:$src)
     /* 113031 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWDYrr),
     /* 113036 */   GIR_RootConstrainSelectedInstOperands,
     /* 113037 */   // GIR_Coverage, 18376,
     /* 113037 */   GIR_Done,
     /* 113038 */ // Label 2441: @113038
     /* 113038 */ GIM_Reject,
     /* 113039 */ // Label 2413: @113039
     /* 113039 */ GIM_Try, /*On fail goto*//*Label 2442*/ GIMT_Encode4(113098), // Rule ID 21589 //
     /* 113044 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 113047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 113050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113054 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113058 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 113062 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113065 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 113069 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 113073 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113075 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 113082 */   // (sext:{ *:[v8i64] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXWQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /* 113082 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWQZrm),
     /* 113085 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113087 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 113091 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113096 */   GIR_RootConstrainSelectedInstOperands,
     /* 113097 */   // GIR_Coverage, 21589,
     /* 113097 */   GIR_EraseRootFromParent_Done,
     /* 113098 */ // Label 2442: @113098
     /* 113098 */ GIM_Try, /*On fail goto*//*Label 2443*/ GIMT_Encode4(113157), // Rule ID 21590 //
     /* 113103 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 113106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 113109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113113 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113117 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 113121 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113124 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 113128 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 113132 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113134 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 113141 */   // (sext:{ *:[v8i64] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXDQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /* 113141 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXDQZrm),
     /* 113144 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113146 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 113150 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113155 */   GIR_RootConstrainSelectedInstOperands,
     /* 113156 */   // GIR_Coverage, 21590,
     /* 113156 */   GIR_EraseRootFromParent_Done,
     /* 113157 */ // Label 2443: @113157
     /* 113157 */ GIM_Try, /*On fail goto*//*Label 2444*/ GIMT_Encode4(113183), // Rule ID 12559 //
     /* 113162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 113165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 113168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113172 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 113176 */   // (sext:{ *:[v8i64] } VR128X:{ *:[v8i16] }:$src)  =>  (VPMOVSXWQZrr:{ *:[v8i64] } VR128X:{ *:[v8i16] }:$src)
     /* 113176 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWQZrr),
     /* 113181 */   GIR_RootConstrainSelectedInstOperands,
     /* 113182 */   // GIR_Coverage, 12559,
     /* 113182 */   GIR_Done,
     /* 113183 */ // Label 2444: @113183
     /* 113183 */ GIM_Try, /*On fail goto*//*Label 2445*/ GIMT_Encode4(113209), // Rule ID 12577 //
     /* 113188 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 113191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 113194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113198 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 113202 */   // (sext:{ *:[v8i64] } VR256X:{ *:[v8i32] }:$src)  =>  (VPMOVSXDQZrr:{ *:[v8i64] } VR256X:{ *:[v8i32] }:$src)
     /* 113202 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXDQZrr),
     /* 113207 */   GIR_RootConstrainSelectedInstOperands,
     /* 113208 */   // GIR_Coverage, 12577,
     /* 113208 */   GIR_Done,
     /* 113209 */ // Label 2445: @113209
     /* 113209 */ GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(113235), // Rule ID 12592 //
     /* 113214 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 113217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 113220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113224 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 113228 */   // (sext:{ *:[v8i64] } VK8:{ *:[v8i1] }:$src)  =>  (VPMOVM2QZrk:{ *:[v8i64] } VK8:{ *:[v8i1] }:$src)
     /* 113228 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2QZrk),
     /* 113233 */   GIR_RootConstrainSelectedInstOperands,
     /* 113234 */   // GIR_Coverage, 12592,
     /* 113234 */   GIR_Done,
     /* 113235 */ // Label 2446: @113235
     /* 113235 */ GIM_Reject,
     /* 113236 */ // Label 2414: @113236
     /* 113236 */ GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(113304),
     /* 113241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 113244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 113248 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 113252 */   GIM_Try, /*On fail goto*//*Label 2448*/ GIMT_Encode4(113267), // Rule ID 12585 //
     /* 113257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 113260 */     // (sext:{ *:[v16i8] } VK16:{ *:[v16i1] }:$src)  =>  (VPMOVM2BZ128rk:{ *:[v16i8] } VK16:{ *:[v16i1] }:$src)
     /* 113260 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2BZ128rk),
     /* 113265 */     GIR_RootConstrainSelectedInstOperands,
     /* 113266 */     // GIR_Coverage, 12585,
     /* 113266 */     GIR_Done,
     /* 113267 */   // Label 2448: @113267
     /* 113267 */   GIM_Try, /*On fail goto*//*Label 2449*/ GIMT_Encode4(113303), // Rule ID 21659 //
     /* 113272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_NoBWI),
     /* 113275 */     // (sext:{ *:[v16i8] } VK16:{ *:[v16i1] }:$src)  =>  (VPMOVDBZrr:{ *:[v16i8] } (VPMOVM2DZrk:{ *:[v16i32] } VK16:{ *:[v16i1] }:$src))
     /* 113275 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 113278 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVM2DZrk),
     /* 113282 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113287 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 113291 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 113293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVDBZrr),
     /* 113296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113298 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113301 */     GIR_RootConstrainSelectedInstOperands,
     /* 113302 */     // GIR_Coverage, 21659,
     /* 113302 */     GIR_EraseRootFromParent_Done,
     /* 113303 */   // Label 2449: @113303
     /* 113303 */   GIM_Reject,
     /* 113304 */ // Label 2447: @113304
     /* 113304 */ GIM_Reject,
     /* 113305 */ // Label 2415: @113305
     /* 113305 */ GIM_Try, /*On fail goto*//*Label 2450*/ GIMT_Encode4(113364), // Rule ID 18380 //
     /* 113310 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 113313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 113316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 113320 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113324 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 113328 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113331 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 113335 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 113339 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113341 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 113348 */   // (sext:{ *:[v16i16] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXBWYrm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /* 113348 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBWYrm),
     /* 113351 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113353 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 113357 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113362 */   GIR_RootConstrainSelectedInstOperands,
     /* 113363 */   // GIR_Coverage, 18380,
     /* 113363 */   GIR_EraseRootFromParent_Done,
     /* 113364 */ // Label 2450: @113364
     /* 113364 */ GIM_Try, /*On fail goto*//*Label 2451*/ GIMT_Encode4(113423), // Rule ID 21583 //
     /* 113369 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 113372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 113375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 113379 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113383 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 113387 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113390 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 113394 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 113398 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113400 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 113407 */   // (sext:{ *:[v16i16] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXBWZ256rm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /* 113407 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBWZ256rm),
     /* 113410 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113412 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 113416 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113421 */   GIR_RootConstrainSelectedInstOperands,
     /* 113422 */   // GIR_Coverage, 21583,
     /* 113422 */   GIR_EraseRootFromParent_Done,
     /* 113423 */ // Label 2451: @113423
     /* 113423 */ GIM_Try, /*On fail goto*//*Label 2452*/ GIMT_Encode4(113449), // Rule ID 12481 //
     /* 113428 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 113431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 113434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 113438 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 113442 */   // (sext:{ *:[v16i16] } VR128X:{ *:[v16i8] }:$src)  =>  (VPMOVSXBWZ256rr:{ *:[v16i16] } VR128X:{ *:[v16i8] }:$src)
     /* 113442 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBWZ256rr),
     /* 113447 */   GIR_RootConstrainSelectedInstOperands,
     /* 113448 */   // GIR_Coverage, 12481,
     /* 113448 */   GIR_Done,
     /* 113449 */ // Label 2452: @113449
     /* 113449 */ GIM_Try, /*On fail goto*//*Label 2453*/ GIMT_Encode4(113475), // Rule ID 12587 //
     /* 113454 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 113457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 113460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 113464 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 113468 */   // (sext:{ *:[v16i16] } VK16:{ *:[v16i1] }:$src)  =>  (VPMOVM2WZ256rk:{ *:[v16i16] } VK16:{ *:[v16i1] }:$src)
     /* 113468 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2WZ256rk),
     /* 113473 */   GIR_RootConstrainSelectedInstOperands,
     /* 113474 */   // GIR_Coverage, 12587,
     /* 113474 */   GIR_Done,
     /* 113475 */ // Label 2453: @113475
     /* 113475 */ GIM_Try, /*On fail goto*//*Label 2454*/ GIMT_Encode4(113501), // Rule ID 18373 //
     /* 113480 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 113483 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 113486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 113490 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 113494 */   // (sext:{ *:[v16i16] } VR128:{ *:[v16i8] }:$src)  =>  (VPMOVSXBWYrr:{ *:[v16i16] } VR128:{ *:[v16i8] }:$src)
     /* 113494 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBWYrr),
     /* 113499 */   GIR_RootConstrainSelectedInstOperands,
     /* 113500 */   // GIR_Coverage, 18373,
     /* 113500 */   GIR_Done,
     /* 113501 */ // Label 2454: @113501
     /* 113501 */ GIM_Try, /*On fail goto*//*Label 2455*/ GIMT_Encode4(113548), // Rule ID 21660 //
     /* 113506 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_NoBWI),
     /* 113509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 113512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 113516 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 113520 */   // (sext:{ *:[v16i16] } VK16:{ *:[v16i1] }:$src)  =>  (VPMOVDWZrr:{ *:[v16i16] } (VPMOVM2DZrk:{ *:[v16i32] } VK16:{ *:[v16i1] }:$src))
     /* 113520 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 113523 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVM2DZrk),
     /* 113527 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113532 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 113536 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 113538 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVDWZrr),
     /* 113541 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113543 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113546 */   GIR_RootConstrainSelectedInstOperands,
     /* 113547 */   // GIR_Coverage, 21660,
     /* 113547 */   GIR_EraseRootFromParent_Done,
     /* 113548 */ // Label 2455: @113548
     /* 113548 */ GIM_Reject,
     /* 113549 */ // Label 2416: @113549
     /* 113549 */ GIM_Try, /*On fail goto*//*Label 2456*/ GIMT_Encode4(113608), // Rule ID 21587 //
     /* 113554 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 113557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 113560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113564 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113568 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 113572 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113575 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 113579 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 113583 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113585 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 113592 */   // (sext:{ *:[v16i32] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXBDZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)
     /* 113592 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBDZrm),
     /* 113595 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113597 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 113601 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113606 */   GIR_RootConstrainSelectedInstOperands,
     /* 113607 */   // GIR_Coverage, 21587,
     /* 113607 */   GIR_EraseRootFromParent_Done,
     /* 113608 */ // Label 2456: @113608
     /* 113608 */ GIM_Try, /*On fail goto*//*Label 2457*/ GIMT_Encode4(113667), // Rule ID 21588 //
     /* 113613 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 113616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 113619 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113623 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113627 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 113631 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113634 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 113638 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 113642 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113644 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 113651 */   // (sext:{ *:[v16i32] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXWDZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)
     /* 113651 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWDZrm),
     /* 113654 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113656 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 113660 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113665 */   GIR_RootConstrainSelectedInstOperands,
     /* 113666 */   // GIR_Coverage, 21588,
     /* 113666 */   GIR_EraseRootFromParent_Done,
     /* 113667 */ // Label 2457: @113667
     /* 113667 */ GIM_Try, /*On fail goto*//*Label 2458*/ GIMT_Encode4(113693), // Rule ID 12505 //
     /* 113672 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 113675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 113678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113682 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 113686 */   // (sext:{ *:[v16i32] } VR128X:{ *:[v16i8] }:$src)  =>  (VPMOVSXBDZrr:{ *:[v16i32] } VR128X:{ *:[v16i8] }:$src)
     /* 113686 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBDZrr),
     /* 113691 */   GIR_RootConstrainSelectedInstOperands,
     /* 113692 */   // GIR_Coverage, 12505,
     /* 113692 */   GIR_Done,
     /* 113693 */ // Label 2458: @113693
     /* 113693 */ GIM_Try, /*On fail goto*//*Label 2459*/ GIMT_Encode4(113719), // Rule ID 12541 //
     /* 113698 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 113701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 113704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113708 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 113712 */   // (sext:{ *:[v16i32] } VR256X:{ *:[v16i16] }:$src)  =>  (VPMOVSXWDZrr:{ *:[v16i32] } VR256X:{ *:[v16i16] }:$src)
     /* 113712 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWDZrr),
     /* 113717 */   GIR_RootConstrainSelectedInstOperands,
     /* 113718 */   // GIR_Coverage, 12541,
     /* 113718 */   GIR_Done,
     /* 113719 */ // Label 2459: @113719
     /* 113719 */ GIM_Try, /*On fail goto*//*Label 2460*/ GIMT_Encode4(113745), // Rule ID 12589 //
     /* 113724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 113727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 113730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113734 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 113738 */   // (sext:{ *:[v16i32] } VK16:{ *:[v16i1] }:$src)  =>  (VPMOVM2DZrk:{ *:[v16i32] } VK16:{ *:[v16i1] }:$src)
     /* 113738 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2DZrk),
     /* 113743 */   GIR_RootConstrainSelectedInstOperands,
     /* 113744 */   // GIR_Coverage, 12589,
     /* 113744 */   GIR_Done,
     /* 113745 */ // Label 2460: @113745
     /* 113745 */ GIM_Reject,
     /* 113746 */ // Label 2417: @113746
     /* 113746 */ GIM_Try, /*On fail goto*//*Label 2461*/ GIMT_Encode4(113772), // Rule ID 12584 //
     /* 113751 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 113754 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 113757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 113761 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 113765 */   // (sext:{ *:[v32i8] } VK32:{ *:[v32i1] }:$src)  =>  (VPMOVM2BZ256rk:{ *:[v32i8] } VK32:{ *:[v32i1] }:$src)
     /* 113765 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2BZ256rk),
     /* 113770 */   GIR_RootConstrainSelectedInstOperands,
     /* 113771 */   // GIR_Coverage, 12584,
     /* 113771 */   GIR_Done,
     /* 113772 */ // Label 2461: @113772
     /* 113772 */ GIM_Reject,
     /* 113773 */ // Label 2418: @113773
     /* 113773 */ GIM_Try, /*On fail goto*//*Label 2462*/ GIMT_Encode4(113832), // Rule ID 21586 //
     /* 113778 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 113781 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 113784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113788 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113792 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 113796 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113799 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 113803 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 113807 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113809 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 113816 */   // (sext:{ *:[v32i16] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXBWZrm:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)
     /* 113816 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBWZrm),
     /* 113819 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113821 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 113825 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113830 */   GIR_RootConstrainSelectedInstOperands,
     /* 113831 */   // GIR_Coverage, 21586,
     /* 113831 */   GIR_EraseRootFromParent_Done,
     /* 113832 */ // Label 2462: @113832
     /* 113832 */ GIM_Try, /*On fail goto*//*Label 2463*/ GIMT_Encode4(113858), // Rule ID 12487 //
     /* 113837 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 113840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 113843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113847 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 113851 */   // (sext:{ *:[v32i16] } VR256X:{ *:[v32i8] }:$src)  =>  (VPMOVSXBWZrr:{ *:[v32i16] } VR256X:{ *:[v32i8] }:$src)
     /* 113851 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBWZrr),
     /* 113856 */   GIR_RootConstrainSelectedInstOperands,
     /* 113857 */   // GIR_Coverage, 12487,
     /* 113857 */   GIR_Done,
     /* 113858 */ // Label 2463: @113858
     /* 113858 */ GIM_Try, /*On fail goto*//*Label 2464*/ GIMT_Encode4(113884), // Rule ID 12586 //
     /* 113863 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 113866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 113869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113873 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 113877 */   // (sext:{ *:[v32i16] } VK32:{ *:[v32i1] }:$src)  =>  (VPMOVM2WZrk:{ *:[v32i16] } VK32:{ *:[v32i1] }:$src)
     /* 113877 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2WZrk),
     /* 113882 */   GIR_RootConstrainSelectedInstOperands,
     /* 113883 */   // GIR_Coverage, 12586,
     /* 113883 */   GIR_Done,
     /* 113884 */ // Label 2464: @113884
     /* 113884 */ GIM_Reject,
     /* 113885 */ // Label 2419: @113885
     /* 113885 */ GIM_Try, /*On fail goto*//*Label 2465*/ GIMT_Encode4(113911), // Rule ID 12583 //
     /* 113890 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 113893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 113896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113900 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 113904 */   // (sext:{ *:[v64i8] } VK64:{ *:[v64i1] }:$src)  =>  (VPMOVM2BZrk:{ *:[v64i8] } VK64:{ *:[v64i1] }:$src)
     /* 113904 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2BZrk),
     /* 113909 */   GIR_RootConstrainSelectedInstOperands,
     /* 113910 */   // GIR_Coverage, 12583,
     /* 113910 */   GIR_Done,
     /* 113911 */ // Label 2465: @113911
     /* 113911 */ GIM_Reject,
     /* 113912 */ // Label 2420: @113912
     /* 113912 */ GIM_Reject,
     /* 113913 */ // Label 24: @113913
     /* 113913 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2468*/ GIMT_Encode4(114154),
     /* 113924 */ /*GILLT_s16*//*Label 2466*/ GIMT_Encode4(113932),
     /* 113928 */ /*GILLT_s32*//*Label 2467*/ GIMT_Encode4(114028),
     /* 113932 */ // Label 2466: @113932
     /* 113932 */ GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(114027), // Rule ID 22643 //
     /* 113937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 113940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 113944 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 113948 */   // MIs[0] Operand 2
     /* 113948 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 113959 */   // (sext_inreg:{ *:[i16] } GR16:{ *:[i16] }:$src, i8:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVSX32rr8:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i8] } GR16:{ *:[i16] }:$src, sub_8bit:{ *:[i32] })), sub_16bit:{ *:[i32] })
     /* 113959 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s8,
     /* 113962 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113966 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113971 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src
     /* 113977 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /* 113982 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /* 113987 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 113990 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVSX32rr8),
     /* 113994 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113999 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 114002 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114004 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114007 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114009 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 114016 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 114021 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 114026 */   // GIR_Coverage, 22643,
     /* 114026 */   GIR_EraseRootFromParent_Done,
     /* 114027 */ // Label 2469: @114027
     /* 114027 */ GIM_Reject,
     /* 114028 */ // Label 2467: @114028
     /* 114028 */ GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(114153),
     /* 114033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 114036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 114040 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 114044 */   GIM_Try, /*On fail goto*//*Label 2471*/ GIMT_Encode4(114098), // Rule ID 22641 //
     /* 114049 */     // MIs[0] Operand 2
     /* 114049 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 114060 */     // (sext_inreg:{ *:[i32] } GR32:{ *:[i32] }:$src, i16:{ *:[Other] })  =>  (MOVSX32rr16:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i16] } GR32:{ *:[i32] }:$src, sub_16bit:{ *:[i32] }))
     /* 114060 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 114063 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114067 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114072 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(4), // src
     /* 114078 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 114083 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 114088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSX32rr16),
     /* 114091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114093 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114096 */     GIR_RootConstrainSelectedInstOperands,
     /* 114097 */     // GIR_Coverage, 22641,
     /* 114097 */     GIR_EraseRootFromParent_Done,
     /* 114098 */   // Label 2471: @114098
     /* 114098 */   GIM_Try, /*On fail goto*//*Label 2472*/ GIMT_Encode4(114152), // Rule ID 22642 //
     /* 114103 */     // MIs[0] Operand 2
     /* 114103 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 114114 */     // (sext_inreg:{ *:[i32] } GR32:{ *:[i32] }:$src, i8:{ *:[Other] })  =>  (MOVSX32rr8:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i8] } GR32:{ *:[i32] }:$src, sub_8bit:{ *:[i32] }))
     /* 114114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 114117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114126 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src
     /* 114132 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /* 114137 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 114142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSX32rr8),
     /* 114145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114147 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114150 */     GIR_RootConstrainSelectedInstOperands,
     /* 114151 */     // GIR_Coverage, 22642,
     /* 114151 */     GIR_EraseRootFromParent_Done,
     /* 114152 */   // Label 2472: @114152
     /* 114152 */   GIM_Reject,
     /* 114153 */ // Label 2470: @114153
     /* 114153 */ GIM_Reject,
     /* 114154 */ // Label 2468: @114154
     /* 114154 */ GIM_Reject,
     /* 114155 */ // Label 25: @114155
     /* 114155 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 2482*/ GIMT_Encode4(116138),
     /* 114166 */ /*GILLT_s16*//*Label 2473*/ GIMT_Encode4(114250),
     /* 114170 */ /*GILLT_s32*//*Label 2474*/ GIMT_Encode4(114308),
     /* 114174 */ /*GILLT_s64*//*Label 2475*/ GIMT_Encode4(114660), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 114202 */ /*GILLT_v4s64*//*Label 2476*/ GIMT_Encode4(115207), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 114214 */ /*GILLT_v8s32*//*Label 2477*/ GIMT_Encode4(115375),
     /* 114218 */ /*GILLT_v8s64*//*Label 2478*/ GIMT_Encode4(115543), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 114230 */ /*GILLT_v16s16*//*Label 2479*/ GIMT_Encode4(115714),
     /* 114234 */ /*GILLT_v16s32*//*Label 2480*/ GIMT_Encode4(115882), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 114246 */ /*GILLT_v32s16*//*Label 2481*/ GIMT_Encode4(116053),
     /* 114250 */ // Label 2473: @114250
     /* 114250 */ GIM_Try, /*On fail goto*//*Label 2483*/ GIMT_Encode4(114307), // Rule ID 22649 //
     /* 114255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 114258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 114262 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 114266 */   // (zext:{ *:[i16] } GR8:{ *:[i8] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVZX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src), sub_16bit:{ *:[i32] })
     /* 114266 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114269 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /* 114273 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114278 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 114282 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114284 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114287 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114289 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 114296 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 114301 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 114306 */   // GIR_Coverage, 22649,
     /* 114306 */   GIR_EraseRootFromParent_Done,
     /* 114307 */ // Label 2483: @114307
     /* 114307 */ GIM_Reject,
     /* 114308 */ // Label 2474: @114308
     /* 114308 */ GIM_Try, /*On fail goto*//*Label 2484*/ GIMT_Encode4(114431), // Rule ID 22973 //
     /* 114313 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasZU),
     /* 114316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 114323 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114327 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 114331 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 114335 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 114339 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 114343 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 114347 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114350 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 114354 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 114358 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 114362 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 114366 */   // MIs[3] Operand 1
     /* 114366 */   // No operand predicates
     /* 114366 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 114368 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 114375 */   // (zext:{ *:[i32] } (mul:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i16] }):$src2))  =>  (SUBREG_TO_REG:{ *:[i32] } 0:{ *:[i32] }, (IMULZU16rmi:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i16] }):$src2), sub_16bit:{ *:[i32] })
     /* 114375 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 114378 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::IMULZU16rmi),
     /* 114382 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114387 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src1
     /* 114391 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // src2
     /* 114394 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 114397 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /* 114404 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114406 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 114409 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114411 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114414 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114417 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 114420 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 114425 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /* 114430 */   // GIR_Coverage, 22973,
     /* 114430 */   GIR_EraseRootFromParent_Done,
     /* 114431 */ // Label 2484: @114431
     /* 114431 */ GIM_Try, /*On fail goto*//*Label 2485*/ GIMT_Encode4(114526), // Rule ID 22972 //
     /* 114436 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasZU),
     /* 114439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 114446 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114450 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 114454 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 114458 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 114462 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 114467 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 114471 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 114475 */   // MIs[2] Operand 1
     /* 114475 */   // No operand predicates
     /* 114475 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 114477 */   // (zext:{ *:[i32] } (mul:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2))  =>  (SUBREG_TO_REG:{ *:[i32] } 0:{ *:[i32] }, (IMULZU16rri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2), sub_16bit:{ *:[i32] })
     /* 114477 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 114480 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::IMULZU16rri),
     /* 114484 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114489 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 114493 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // src2
     /* 114496 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 114499 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114501 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 114504 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114506 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114509 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114512 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 114515 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 114520 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /* 114525 */   // GIR_Coverage, 22972,
     /* 114525 */   GIR_EraseRootFromParent_Done,
     /* 114526 */ // Label 2485: @114526
     /* 114526 */ GIM_Try, /*On fail goto*//*Label 2486*/ GIMT_Encode4(114568), // Rule ID 19435 //
     /* 114531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 114538 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114542 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 114546 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 114550 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 114555 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114557 */   // (zext:{ *:[i32] } (bitconvert:{ *:[i16] } VK16:{ *:[v16i1] }:$src))  =>  (KMOVWrk:{ *:[i32] } VK16:{ *:[v16i1] }:$src)
     /* 114557 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVWrk),
     /* 114560 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114562 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 114566 */   GIR_RootConstrainSelectedInstOperands,
     /* 114567 */   // GIR_Coverage, 19435,
     /* 114567 */   GIR_EraseRootFromParent_Done,
     /* 114568 */ // Label 2486: @114568
     /* 114568 */ GIM_Try, /*On fail goto*//*Label 2487*/ GIMT_Encode4(114613), // Rule ID 19438 //
     /* 114573 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 114576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 114579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 114583 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114587 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 114591 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 114595 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 114600 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114602 */   // (zext:{ *:[i32] } (bitconvert:{ *:[i8] } VK8:{ *:[v8i1] }:$src))  =>  (KMOVBrk:{ *:[i32] } VK8:{ *:[v8i1] }:$src)
     /* 114602 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVBrk),
     /* 114605 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114607 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 114611 */   GIR_RootConstrainSelectedInstOperands,
     /* 114612 */   // GIR_Coverage, 19438,
     /* 114612 */   GIR_EraseRootFromParent_Done,
     /* 114613 */ // Label 2487: @114613
     /* 114613 */ GIM_Try, /*On fail goto*//*Label 2488*/ GIMT_Encode4(114636), // Rule ID 618 //
     /* 114618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 114621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 114625 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 114629 */   // (zext:{ *:[i32] } GR8:{ *:[i8] }:$src)  =>  (MOVZX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /* 114629 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /* 114634 */   GIR_RootConstrainSelectedInstOperands,
     /* 114635 */   // GIR_Coverage, 618,
     /* 114635 */   GIR_Done,
     /* 114636 */ // Label 2488: @114636
     /* 114636 */ GIM_Try, /*On fail goto*//*Label 2489*/ GIMT_Encode4(114659), // Rule ID 620 //
     /* 114641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 114648 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 114652 */   // (zext:{ *:[i32] } GR16:{ *:[i16] }:$src)  =>  (MOVZX32rr16:{ *:[i32] } GR16:{ *:[i16] }:$src)
     /* 114652 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr16),
     /* 114657 */   GIR_RootConstrainSelectedInstOperands,
     /* 114658 */   // GIR_Coverage, 620,
     /* 114658 */   GIR_Done,
     /* 114659 */ // Label 2489: @114659
     /* 114659 */ GIM_Reject,
     /* 114660 */ // Label 2475: @114660
     /* 114660 */ GIM_Try, /*On fail goto*//*Label 2490*/ GIMT_Encode4(114783), // Rule ID 22975 //
     /* 114665 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasZU),
     /* 114668 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 114675 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114679 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 114683 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 114687 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 114691 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 114695 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 114699 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114702 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 114706 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 114710 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 114714 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 114718 */   // MIs[3] Operand 1
     /* 114718 */   // No operand predicates
     /* 114718 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 114720 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 114727 */   // (zext:{ *:[i64] } (mul:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i16] }):$src2))  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (IMULZU16rmi:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i16] }):$src2), sub_16bit:{ *:[i32] })
     /* 114727 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 114730 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::IMULZU16rmi),
     /* 114734 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114739 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src1
     /* 114743 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // src2
     /* 114746 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 114749 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /* 114756 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114758 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 114761 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114763 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114766 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114769 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 114772 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 114777 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /* 114782 */   // GIR_Coverage, 22975,
     /* 114782 */   GIR_EraseRootFromParent_Done,
     /* 114783 */ // Label 2490: @114783
     /* 114783 */ GIM_Try, /*On fail goto*//*Label 2491*/ GIMT_Encode4(114878), // Rule ID 22974 //
     /* 114788 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasZU),
     /* 114791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 114798 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114802 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 114806 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 114810 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 114814 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 114819 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 114823 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 114827 */   // MIs[2] Operand 1
     /* 114827 */   // No operand predicates
     /* 114827 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 114829 */   // (zext:{ *:[i64] } (mul:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2))  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (IMULZU16rri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2), sub_16bit:{ *:[i32] })
     /* 114829 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 114832 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::IMULZU16rri),
     /* 114836 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114841 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 114845 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // src2
     /* 114848 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 114851 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114853 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 114856 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114858 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114861 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114864 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 114867 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 114872 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /* 114877 */   // GIR_Coverage, 22974,
     /* 114877 */   GIR_EraseRootFromParent_Done,
     /* 114878 */ // Label 2491: @114878
     /* 114878 */ GIM_Try, /*On fail goto*//*Label 2492*/ GIMT_Encode4(114952), // Rule ID 19436 //
     /* 114883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 114890 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114894 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 114898 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 114902 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 114907 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114909 */   // (zext:{ *:[i64] } (bitconvert:{ *:[i16] } VK16:{ *:[v16i1] }:$src))  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (KMOVWrk:{ *:[i32] } VK16:{ *:[v16i1] }:$src), sub_32bit:{ *:[i32] })
     /* 114909 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114912 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KMOVWrk),
     /* 114916 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114921 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 114925 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114927 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 114930 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114932 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114935 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114938 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 114941 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 114946 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 114951 */   // GIR_Coverage, 19436,
     /* 114951 */   GIR_EraseRootFromParent_Done,
     /* 114952 */ // Label 2492: @114952
     /* 114952 */ GIM_Try, /*On fail goto*//*Label 2493*/ GIMT_Encode4(115029), // Rule ID 19439 //
     /* 114957 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 114960 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 114963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 114967 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114971 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 114975 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 114979 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 114984 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114986 */   // (zext:{ *:[i64] } (bitconvert:{ *:[i8] } VK8:{ *:[v8i1] }:$src))  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (KMOVBrk:{ *:[i32] } VK8:{ *:[v8i1] }:$src), sub_32bit:{ *:[i32] })
     /* 114986 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114989 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KMOVBrk),
     /* 114993 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114998 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 115002 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115004 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 115007 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115009 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115012 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115015 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 115018 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 115023 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 115028 */   // GIR_Coverage, 19439,
     /* 115028 */   GIR_EraseRootFromParent_Done,
     /* 115029 */ // Label 2493: @115029
     /* 115029 */ GIM_Try, /*On fail goto*//*Label 2494*/ GIMT_Encode4(115088), // Rule ID 17590 //
     /* 115034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 115037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 115041 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 115045 */   // (zext:{ *:[i64] } GR8:{ *:[i8] }:$src)  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src), sub_32bit:{ *:[i32] })
     /* 115045 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115048 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /* 115052 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115057 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 115061 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115063 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 115066 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115068 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115071 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115074 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 115077 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 115082 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 115087 */   // GIR_Coverage, 17590,
     /* 115087 */   GIR_EraseRootFromParent_Done,
     /* 115088 */ // Label 2494: @115088
     /* 115088 */ GIM_Try, /*On fail goto*//*Label 2495*/ GIMT_Encode4(115147), // Rule ID 17592 //
     /* 115093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 115096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 115100 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 115104 */   // (zext:{ *:[i64] } GR16:{ *:[i16] }:$src)  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rr16:{ *:[i32] } GR16:{ *:[i16] }:$src), sub_32bit:{ *:[i32] })
     /* 115104 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115107 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr16),
     /* 115111 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115116 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 115120 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115122 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 115125 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115127 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115130 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115133 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 115136 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 115141 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 115146 */   // GIR_Coverage, 17592,
     /* 115146 */   GIR_EraseRootFromParent_Done,
     /* 115147 */ // Label 2495: @115147
     /* 115147 */ GIM_Try, /*On fail goto*//*Label 2496*/ GIMT_Encode4(115206), // Rule ID 17594 //
     /* 115152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 115159 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 115163 */   // (zext:{ *:[i64] } GR32:{ *:[i32] }:$src)  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOV32rr:{ *:[i32] } GR32:{ *:[i32] }:$src), sub_32bit:{ *:[i32] })
     /* 115163 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115166 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOV32rr),
     /* 115170 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115175 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 115179 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115181 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 115184 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115186 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115189 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115192 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 115195 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 115200 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 115205 */   // GIR_Coverage, 17594,
     /* 115205 */   GIR_EraseRootFromParent_Done,
     /* 115206 */ // Label 2496: @115206
     /* 115206 */ GIM_Reject,
     /* 115207 */ // Label 2476: @115207
     /* 115207 */ GIM_Try, /*On fail goto*//*Label 2497*/ GIMT_Encode4(115374),
     /* 115212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 115215 */   GIM_Try, /*On fail goto*//*Label 2498*/ GIMT_Encode4(115271), // Rule ID 18413 //
     /* 115220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 115223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 115227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115235 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115238 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115242 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115248 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115255 */     // (zext:{ *:[v4i64] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXDQYrm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /* 115255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXDQYrm),
     /* 115258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115260 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115264 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115269 */     GIR_RootConstrainSelectedInstOperands,
     /* 115270 */     // GIR_Coverage, 18413,
     /* 115270 */     GIR_EraseRootFromParent_Done,
     /* 115271 */   // Label 2498: @115271
     /* 115271 */   GIM_Try, /*On fail goto*//*Label 2499*/ GIMT_Encode4(115327), // Rule ID 21618 //
     /* 115276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 115279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 115283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115291 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115294 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115298 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115304 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115311 */     // (zext:{ *:[v4i64] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXDQZ256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /* 115311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXDQZ256rm),
     /* 115314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115316 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115320 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115325 */     GIR_RootConstrainSelectedInstOperands,
     /* 115326 */     // GIR_Coverage, 21618,
     /* 115326 */     GIR_EraseRootFromParent_Done,
     /* 115327 */   // Label 2499: @115327
     /* 115327 */   GIM_Try, /*On fail goto*//*Label 2500*/ GIMT_Encode4(115350), // Rule ID 12463 //
     /* 115332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 115335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 115339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 115343 */     // (zext:{ *:[v4i64] } VR128X:{ *:[v4i32] }:$src)  =>  (VPMOVZXDQZ256rr:{ *:[v4i64] } VR128X:{ *:[v4i32] }:$src)
     /* 115343 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXDQZ256rr),
     /* 115348 */     GIR_RootConstrainSelectedInstOperands,
     /* 115349 */     // GIR_Coverage, 12463,
     /* 115349 */     GIR_Done,
     /* 115350 */   // Label 2500: @115350
     /* 115350 */   GIM_Try, /*On fail goto*//*Label 2501*/ GIMT_Encode4(115373), // Rule ID 18401 //
     /* 115355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 115358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 115362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 115366 */     // (zext:{ *:[v4i64] } VR128:{ *:[v4i32] }:$src)  =>  (VPMOVZXDQYrr:{ *:[v4i64] } VR128:{ *:[v4i32] }:$src)
     /* 115366 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXDQYrr),
     /* 115371 */     GIR_RootConstrainSelectedInstOperands,
     /* 115372 */     // GIR_Coverage, 18401,
     /* 115372 */     GIR_Done,
     /* 115373 */   // Label 2501: @115373
     /* 115373 */   GIM_Reject,
     /* 115374 */ // Label 2497: @115374
     /* 115374 */ GIM_Reject,
     /* 115375 */ // Label 2477: @115375
     /* 115375 */ GIM_Try, /*On fail goto*//*Label 2502*/ GIMT_Encode4(115542),
     /* 115380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 115383 */   GIM_Try, /*On fail goto*//*Label 2503*/ GIMT_Encode4(115439), // Rule ID 18409 //
     /* 115388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 115391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 115395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115403 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115406 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115410 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115416 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115423 */     // (zext:{ *:[v8i32] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXWDYrm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /* 115423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDYrm),
     /* 115426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115428 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115432 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115437 */     GIR_RootConstrainSelectedInstOperands,
     /* 115438 */     // GIR_Coverage, 18409,
     /* 115438 */     GIR_EraseRootFromParent_Done,
     /* 115439 */   // Label 2503: @115439
     /* 115439 */   GIM_Try, /*On fail goto*//*Label 2504*/ GIMT_Encode4(115495), // Rule ID 21617 //
     /* 115444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 115447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 115451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115459 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115462 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115466 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115472 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115479 */     // (zext:{ *:[v8i32] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXWDZ256rm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /* 115479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDZ256rm),
     /* 115482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115484 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115488 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115493 */     GIR_RootConstrainSelectedInstOperands,
     /* 115494 */     // GIR_Coverage, 21617,
     /* 115494 */     GIR_EraseRootFromParent_Done,
     /* 115495 */   // Label 2504: @115495
     /* 115495 */   GIM_Try, /*On fail goto*//*Label 2505*/ GIMT_Encode4(115518), // Rule ID 12427 //
     /* 115500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 115503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 115507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 115511 */     // (zext:{ *:[v8i32] } VR128X:{ *:[v8i16] }:$src)  =>  (VPMOVZXWDZ256rr:{ *:[v8i32] } VR128X:{ *:[v8i16] }:$src)
     /* 115511 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDZ256rr),
     /* 115516 */     GIR_RootConstrainSelectedInstOperands,
     /* 115517 */     // GIR_Coverage, 12427,
     /* 115517 */     GIR_Done,
     /* 115518 */   // Label 2505: @115518
     /* 115518 */   GIM_Try, /*On fail goto*//*Label 2506*/ GIMT_Encode4(115541), // Rule ID 18399 //
     /* 115523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 115526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 115530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 115534 */     // (zext:{ *:[v8i32] } VR128:{ *:[v8i16] }:$src)  =>  (VPMOVZXWDYrr:{ *:[v8i32] } VR128:{ *:[v8i16] }:$src)
     /* 115534 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDYrr),
     /* 115539 */     GIR_RootConstrainSelectedInstOperands,
     /* 115540 */     // GIR_Coverage, 18399,
     /* 115540 */     GIR_Done,
     /* 115541 */   // Label 2506: @115541
     /* 115541 */   GIM_Reject,
     /* 115542 */ // Label 2502: @115542
     /* 115542 */ GIM_Reject,
     /* 115543 */ // Label 2478: @115543
     /* 115543 */ GIM_Try, /*On fail goto*//*Label 2507*/ GIMT_Encode4(115602), // Rule ID 21622 //
     /* 115548 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 115551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 115554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 115558 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115562 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115566 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115569 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115573 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115577 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115579 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115586 */   // (zext:{ *:[v8i64] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXWQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /* 115586 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWQZrm),
     /* 115589 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115591 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115595 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115600 */   GIR_RootConstrainSelectedInstOperands,
     /* 115601 */   // GIR_Coverage, 21622,
     /* 115601 */   GIR_EraseRootFromParent_Done,
     /* 115602 */ // Label 2507: @115602
     /* 115602 */ GIM_Try, /*On fail goto*//*Label 2508*/ GIMT_Encode4(115661), // Rule ID 21623 //
     /* 115607 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 115610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 115613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 115617 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115621 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115625 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115628 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115632 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115636 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115638 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115645 */   // (zext:{ *:[v8i64] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXDQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /* 115645 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXDQZrm),
     /* 115648 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115650 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115654 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115659 */   GIR_RootConstrainSelectedInstOperands,
     /* 115660 */   // GIR_Coverage, 21623,
     /* 115660 */   GIR_EraseRootFromParent_Done,
     /* 115661 */ // Label 2508: @115661
     /* 115661 */ GIM_Try, /*On fail goto*//*Label 2509*/ GIMT_Encode4(115687), // Rule ID 12451 //
     /* 115666 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 115669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 115672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 115676 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 115680 */   // (zext:{ *:[v8i64] } VR128X:{ *:[v8i16] }:$src)  =>  (VPMOVZXWQZrr:{ *:[v8i64] } VR128X:{ *:[v8i16] }:$src)
     /* 115680 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWQZrr),
     /* 115685 */   GIR_RootConstrainSelectedInstOperands,
     /* 115686 */   // GIR_Coverage, 12451,
     /* 115686 */   GIR_Done,
     /* 115687 */ // Label 2509: @115687
     /* 115687 */ GIM_Try, /*On fail goto*//*Label 2510*/ GIMT_Encode4(115713), // Rule ID 12469 //
     /* 115692 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 115695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 115698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 115702 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 115706 */   // (zext:{ *:[v8i64] } VR256X:{ *:[v8i32] }:$src)  =>  (VPMOVZXDQZrr:{ *:[v8i64] } VR256X:{ *:[v8i32] }:$src)
     /* 115706 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXDQZrr),
     /* 115711 */   GIR_RootConstrainSelectedInstOperands,
     /* 115712 */   // GIR_Coverage, 12469,
     /* 115712 */   GIR_Done,
     /* 115713 */ // Label 2510: @115713
     /* 115713 */ GIM_Reject,
     /* 115714 */ // Label 2479: @115714
     /* 115714 */ GIM_Try, /*On fail goto*//*Label 2511*/ GIMT_Encode4(115881),
     /* 115719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 115722 */   GIM_Try, /*On fail goto*//*Label 2512*/ GIMT_Encode4(115778), // Rule ID 18403 //
     /* 115727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 115730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 115734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115742 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115745 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115749 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115755 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115762 */     // (zext:{ *:[v16i16] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXBWYrm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /* 115762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBWYrm),
     /* 115765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115767 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115771 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115776 */     GIR_RootConstrainSelectedInstOperands,
     /* 115777 */     // GIR_Coverage, 18403,
     /* 115777 */     GIR_EraseRootFromParent_Done,
     /* 115778 */   // Label 2512: @115778
     /* 115778 */   GIM_Try, /*On fail goto*//*Label 2513*/ GIMT_Encode4(115834), // Rule ID 21616 //
     /* 115783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 115786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 115790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115798 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115801 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115805 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115811 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115818 */     // (zext:{ *:[v16i16] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXBWZ256rm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /* 115818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBWZ256rm),
     /* 115821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115823 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115827 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115832 */     GIR_RootConstrainSelectedInstOperands,
     /* 115833 */     // GIR_Coverage, 21616,
     /* 115833 */     GIR_EraseRootFromParent_Done,
     /* 115834 */   // Label 2513: @115834
     /* 115834 */   GIM_Try, /*On fail goto*//*Label 2514*/ GIMT_Encode4(115857), // Rule ID 12373 //
     /* 115839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 115842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 115846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 115850 */     // (zext:{ *:[v16i16] } VR128X:{ *:[v16i8] }:$src)  =>  (VPMOVZXBWZ256rr:{ *:[v16i16] } VR128X:{ *:[v16i8] }:$src)
     /* 115850 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBWZ256rr),
     /* 115855 */     GIR_RootConstrainSelectedInstOperands,
     /* 115856 */     // GIR_Coverage, 12373,
     /* 115856 */     GIR_Done,
     /* 115857 */   // Label 2514: @115857
     /* 115857 */   GIM_Try, /*On fail goto*//*Label 2515*/ GIMT_Encode4(115880), // Rule ID 18396 //
     /* 115862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 115865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 115869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 115873 */     // (zext:{ *:[v16i16] } VR128:{ *:[v16i8] }:$src)  =>  (VPMOVZXBWYrr:{ *:[v16i16] } VR128:{ *:[v16i8] }:$src)
     /* 115873 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBWYrr),
     /* 115878 */     GIR_RootConstrainSelectedInstOperands,
     /* 115879 */     // GIR_Coverage, 18396,
     /* 115879 */     GIR_Done,
     /* 115880 */   // Label 2515: @115880
     /* 115880 */   GIM_Reject,
     /* 115881 */ // Label 2511: @115881
     /* 115881 */ GIM_Reject,
     /* 115882 */ // Label 2480: @115882
     /* 115882 */ GIM_Try, /*On fail goto*//*Label 2516*/ GIMT_Encode4(115941), // Rule ID 21620 //
     /* 115887 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 115890 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 115893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 115897 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115901 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115905 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115908 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115912 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115916 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115918 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115925 */   // (zext:{ *:[v16i32] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXBDZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)
     /* 115925 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBDZrm),
     /* 115928 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115930 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115934 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115939 */   GIR_RootConstrainSelectedInstOperands,
     /* 115940 */   // GIR_Coverage, 21620,
     /* 115940 */   GIR_EraseRootFromParent_Done,
     /* 115941 */ // Label 2516: @115941
     /* 115941 */ GIM_Try, /*On fail goto*//*Label 2517*/ GIMT_Encode4(116000), // Rule ID 21621 //
     /* 115946 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 115949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 115952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 115956 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115960 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115964 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115967 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115971 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115975 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115977 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115984 */   // (zext:{ *:[v16i32] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXWDZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)
     /* 115984 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDZrm),
     /* 115987 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115989 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115993 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115998 */   GIR_RootConstrainSelectedInstOperands,
     /* 115999 */   // GIR_Coverage, 21621,
     /* 115999 */   GIR_EraseRootFromParent_Done,
     /* 116000 */ // Label 2517: @116000
     /* 116000 */ GIM_Try, /*On fail goto*//*Label 2518*/ GIMT_Encode4(116026), // Rule ID 12397 //
     /* 116005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 116008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 116011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 116015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 116019 */   // (zext:{ *:[v16i32] } VR128X:{ *:[v16i8] }:$src)  =>  (VPMOVZXBDZrr:{ *:[v16i32] } VR128X:{ *:[v16i8] }:$src)
     /* 116019 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBDZrr),
     /* 116024 */   GIR_RootConstrainSelectedInstOperands,
     /* 116025 */   // GIR_Coverage, 12397,
     /* 116025 */   GIR_Done,
     /* 116026 */ // Label 2518: @116026
     /* 116026 */ GIM_Try, /*On fail goto*//*Label 2519*/ GIMT_Encode4(116052), // Rule ID 12433 //
     /* 116031 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 116034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 116037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 116041 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 116045 */   // (zext:{ *:[v16i32] } VR256X:{ *:[v16i16] }:$src)  =>  (VPMOVZXWDZrr:{ *:[v16i32] } VR256X:{ *:[v16i16] }:$src)
     /* 116045 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDZrr),
     /* 116050 */   GIR_RootConstrainSelectedInstOperands,
     /* 116051 */   // GIR_Coverage, 12433,
     /* 116051 */   GIR_Done,
     /* 116052 */ // Label 2519: @116052
     /* 116052 */ GIM_Reject,
     /* 116053 */ // Label 2481: @116053
     /* 116053 */ GIM_Try, /*On fail goto*//*Label 2520*/ GIMT_Encode4(116137),
     /* 116058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 116061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 116065 */   GIM_Try, /*On fail goto*//*Label 2521*/ GIMT_Encode4(116117), // Rule ID 21619 //
     /* 116070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 116073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 116081 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116084 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 116088 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 116092 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116094 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 116101 */     // (zext:{ *:[v32i16] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXBWZrm:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)
     /* 116101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBWZrm),
     /* 116104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116106 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 116110 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 116115 */     GIR_RootConstrainSelectedInstOperands,
     /* 116116 */     // GIR_Coverage, 21619,
     /* 116116 */     GIR_EraseRootFromParent_Done,
     /* 116117 */   // Label 2521: @116117
     /* 116117 */   GIM_Try, /*On fail goto*//*Label 2522*/ GIMT_Encode4(116136), // Rule ID 12379 //
     /* 116122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 116125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 116129 */     // (zext:{ *:[v32i16] } VR256X:{ *:[v32i8] }:$src)  =>  (VPMOVZXBWZrr:{ *:[v32i16] } VR256X:{ *:[v32i8] }:$src)
     /* 116129 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBWZrr),
     /* 116134 */     GIR_RootConstrainSelectedInstOperands,
     /* 116135 */     // GIR_Coverage, 12379,
     /* 116135 */     GIR_Done,
     /* 116136 */   // Label 2522: @116136
     /* 116136 */   GIM_Reject,
     /* 116137 */ // Label 2520: @116137
     /* 116137 */ GIM_Reject,
     /* 116138 */ // Label 2482: @116138
     /* 116138 */ GIM_Reject,
     /* 116139 */ // Label 26: @116139
     /* 116139 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(5), /*)*//*default:*//*Label 2527*/ GIMT_Encode4(118422),
     /* 116150 */ /*GILLT_s8*//*Label 2523*/ GIMT_Encode4(116166),
     /* 116154 */ /*GILLT_s16*//*Label 2524*/ GIMT_Encode4(116541),
     /* 116158 */ /*GILLT_s32*//*Label 2525*/ GIMT_Encode4(116916),
     /* 116162 */ /*GILLT_s64*//*Label 2526*/ GIMT_Encode4(117669),
     /* 116166 */ // Label 2523: @116166
     /* 116166 */ GIM_Try, /*On fail goto*//*Label 2528*/ GIMT_Encode4(116540),
     /* 116171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 116174 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 116177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 116181 */   GIM_Try, /*On fail goto*//*Label 2529*/ GIMT_Encode4(116248), // Rule ID 673 //
     /* 116186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 116189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 116197 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116200 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 116204 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 116208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 116212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116216 */     // MIs[2] Operand 1
     /* 116216 */     // No operand predicates
     /* 116216 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 116218 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 116225 */     // (shl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2)  =>  (SHL8mi_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 116225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8mi_ND),
     /* 116228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116230 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 116234 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 116237 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116240 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 116246 */     GIR_RootConstrainSelectedInstOperands,
     /* 116247 */     // GIR_Coverage, 673,
     /* 116247 */     GIR_EraseRootFromParent_Done,
     /* 116248 */   // Label 2529: @116248
     /* 116248 */   GIM_Try, /*On fail goto*//*Label 2530*/ GIMT_Encode4(116321), // Rule ID 689 //
     /* 116253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 116256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 116264 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116267 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 116271 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 116275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 116279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116281 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 116288 */     // (shl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] })  =>  (SHL8mCL_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 116288 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116292 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116298 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 116302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8mCL_ND),
     /* 116305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116307 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 116311 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116314 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 116319 */     GIR_RootConstrainSelectedInstOperands,
     /* 116320 */     // GIR_Coverage, 689,
     /* 116320 */     GIR_EraseRootFromParent_Done,
     /* 116321 */   // Label 2530: @116321
     /* 116321 */   GIM_Try, /*On fail goto*//*Label 2531*/ GIMT_Encode4(116351), // Rule ID 22674 //
     /* 116326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 116329 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 116333 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 116337 */     // (shl:{ *:[i8] } GR8:{ *:[i8] }:$src1, 1:{ *:[i8] })  =>  (ADD8rr:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src1)
     /* 116337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8rr),
     /* 116340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116342 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116344 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116346 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116349 */     GIR_RootConstrainSelectedInstOperands,
     /* 116350 */     // GIR_Coverage, 22674,
     /* 116350 */     GIR_EraseRootFromParent_Done,
     /* 116351 */   // Label 2531: @116351
     /* 116351 */   GIM_Try, /*On fail goto*//*Label 2532*/ GIMT_Encode4(116381), // Rule ID 22678 //
     /* 116356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 116359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 116363 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 116367 */     // (shl:{ *:[i8] } GR8:{ *:[i8] }:$src1, 1:{ *:[i8] })  =>  (ADD8rr_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src1)
     /* 116367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8rr_ND),
     /* 116370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116372 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116374 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116376 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116379 */     GIR_RootConstrainSelectedInstOperands,
     /* 116380 */     // GIR_Coverage, 22678,
     /* 116380 */     GIR_EraseRootFromParent_Done,
     /* 116381 */   // Label 2532: @116381
     /* 116381 */   GIM_Try, /*On fail goto*//*Label 2533*/ GIMT_Encode4(116418), // Rule ID 661 //
     /* 116386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 116389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 116393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 116397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116401 */     // MIs[1] Operand 1
     /* 116401 */     // No operand predicates
     /* 116401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116403 */     // (shl:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 116403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8ri),
     /* 116406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116408 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116410 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 116413 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116416 */     GIR_RootConstrainSelectedInstOperands,
     /* 116417 */     // GIR_Coverage, 661,
     /* 116417 */     GIR_EraseRootFromParent_Done,
     /* 116418 */   // Label 2533: @116418
     /* 116418 */   GIM_Try, /*On fail goto*//*Label 2534*/ GIMT_Encode4(116455), // Rule ID 665 //
     /* 116423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 116426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 116430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 116434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116438 */     // MIs[1] Operand 1
     /* 116438 */     // No operand predicates
     /* 116438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116440 */     // (shl:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 116440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8ri_ND),
     /* 116443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116445 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116447 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 116450 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116453 */     GIR_RootConstrainSelectedInstOperands,
     /* 116454 */     // GIR_Coverage, 665,
     /* 116454 */     GIR_EraseRootFromParent_Done,
     /* 116455 */   // Label 2534: @116455
     /* 116455 */   GIM_Try, /*On fail goto*//*Label 2535*/ GIMT_Encode4(116497), // Rule ID 677 //
     /* 116460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 116463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 116467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 116471 */     // (shl:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (SHL8rCL:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 116471 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116475 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116481 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 116485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8rCL),
     /* 116488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116490 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116492 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116495 */     GIR_RootConstrainSelectedInstOperands,
     /* 116496 */     // GIR_Coverage, 677,
     /* 116496 */     GIR_EraseRootFromParent_Done,
     /* 116497 */   // Label 2535: @116497
     /* 116497 */   GIM_Try, /*On fail goto*//*Label 2536*/ GIMT_Encode4(116539), // Rule ID 681 //
     /* 116502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 116505 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 116509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 116513 */     // (shl:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (SHL8rCL_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 116513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116517 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116523 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 116527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8rCL_ND),
     /* 116530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116532 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116534 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116537 */     GIR_RootConstrainSelectedInstOperands,
     /* 116538 */     // GIR_Coverage, 681,
     /* 116538 */     GIR_EraseRootFromParent_Done,
     /* 116539 */   // Label 2536: @116539
     /* 116539 */   GIM_Reject,
     /* 116540 */ // Label 2528: @116540
     /* 116540 */ GIM_Reject,
     /* 116541 */ // Label 2524: @116541
     /* 116541 */ GIM_Try, /*On fail goto*//*Label 2537*/ GIMT_Encode4(116915),
     /* 116546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 116549 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 116552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 116556 */   GIM_Try, /*On fail goto*//*Label 2538*/ GIMT_Encode4(116623), // Rule ID 674 //
     /* 116561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 116564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 116572 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116575 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 116579 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 116583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 116587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116591 */     // MIs[2] Operand 1
     /* 116591 */     // No operand predicates
     /* 116591 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 116593 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 116600 */     // (shl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2)  =>  (SHL16mi_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 116600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16mi_ND),
     /* 116603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116605 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 116609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 116612 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116615 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 116621 */     GIR_RootConstrainSelectedInstOperands,
     /* 116622 */     // GIR_Coverage, 674,
     /* 116622 */     GIR_EraseRootFromParent_Done,
     /* 116623 */   // Label 2538: @116623
     /* 116623 */   GIM_Try, /*On fail goto*//*Label 2539*/ GIMT_Encode4(116696), // Rule ID 690 //
     /* 116628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 116631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 116639 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116642 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 116646 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 116650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 116654 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116656 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 116663 */     // (shl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] })  =>  (SHL16mCL_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 116663 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116667 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116673 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 116677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16mCL_ND),
     /* 116680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116682 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 116686 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116689 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 116694 */     GIR_RootConstrainSelectedInstOperands,
     /* 116695 */     // GIR_Coverage, 690,
     /* 116695 */     GIR_EraseRootFromParent_Done,
     /* 116696 */   // Label 2539: @116696
     /* 116696 */   GIM_Try, /*On fail goto*//*Label 2540*/ GIMT_Encode4(116726), // Rule ID 22675 //
     /* 116701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 116704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 116708 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 116712 */     // (shl:{ *:[i16] } GR16:{ *:[i16] }:$src1, 1:{ *:[i8] })  =>  (ADD16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src1)
     /* 116712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16rr),
     /* 116715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116717 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116719 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116721 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116724 */     GIR_RootConstrainSelectedInstOperands,
     /* 116725 */     // GIR_Coverage, 22675,
     /* 116725 */     GIR_EraseRootFromParent_Done,
     /* 116726 */   // Label 2540: @116726
     /* 116726 */   GIM_Try, /*On fail goto*//*Label 2541*/ GIMT_Encode4(116756), // Rule ID 22679 //
     /* 116731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 116734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 116738 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 116742 */     // (shl:{ *:[i16] } GR16:{ *:[i16] }:$src1, 1:{ *:[i8] })  =>  (ADD16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src1)
     /* 116742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16rr_ND),
     /* 116745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116747 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116749 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116751 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116754 */     GIR_RootConstrainSelectedInstOperands,
     /* 116755 */     // GIR_Coverage, 22679,
     /* 116755 */     GIR_EraseRootFromParent_Done,
     /* 116756 */   // Label 2541: @116756
     /* 116756 */   GIM_Try, /*On fail goto*//*Label 2542*/ GIMT_Encode4(116793), // Rule ID 662 //
     /* 116761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 116764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 116768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 116772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116776 */     // MIs[1] Operand 1
     /* 116776 */     // No operand predicates
     /* 116776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116778 */     // (shl:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 116778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16ri),
     /* 116781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116783 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 116788 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116791 */     GIR_RootConstrainSelectedInstOperands,
     /* 116792 */     // GIR_Coverage, 662,
     /* 116792 */     GIR_EraseRootFromParent_Done,
     /* 116793 */   // Label 2542: @116793
     /* 116793 */   GIM_Try, /*On fail goto*//*Label 2543*/ GIMT_Encode4(116830), // Rule ID 666 //
     /* 116798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 116801 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 116805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 116809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116813 */     // MIs[1] Operand 1
     /* 116813 */     // No operand predicates
     /* 116813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116815 */     // (shl:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 116815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16ri_ND),
     /* 116818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116820 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116822 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 116825 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116828 */     GIR_RootConstrainSelectedInstOperands,
     /* 116829 */     // GIR_Coverage, 666,
     /* 116829 */     GIR_EraseRootFromParent_Done,
     /* 116830 */   // Label 2543: @116830
     /* 116830 */   GIM_Try, /*On fail goto*//*Label 2544*/ GIMT_Encode4(116872), // Rule ID 678 //
     /* 116835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 116838 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 116842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 116846 */     // (shl:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (SHL16rCL:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 116846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116850 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116856 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 116860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16rCL),
     /* 116863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116865 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116867 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116870 */     GIR_RootConstrainSelectedInstOperands,
     /* 116871 */     // GIR_Coverage, 678,
     /* 116871 */     GIR_EraseRootFromParent_Done,
     /* 116872 */   // Label 2544: @116872
     /* 116872 */   GIM_Try, /*On fail goto*//*Label 2545*/ GIMT_Encode4(116914), // Rule ID 682 //
     /* 116877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 116880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 116884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 116888 */     // (shl:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (SHL16rCL_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 116888 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116892 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116898 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 116902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16rCL_ND),
     /* 116905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116907 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116909 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116912 */     GIR_RootConstrainSelectedInstOperands,
     /* 116913 */     // GIR_Coverage, 682,
     /* 116913 */     GIR_EraseRootFromParent_Done,
     /* 116914 */   // Label 2545: @116914
     /* 116914 */   GIM_Reject,
     /* 116915 */ // Label 2537: @116915
     /* 116915 */ GIM_Reject,
     /* 116916 */ // Label 2525: @116916
     /* 116916 */ GIM_Try, /*On fail goto*//*Label 2546*/ GIMT_Encode4(117668),
     /* 116921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 116924 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 116927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 116931 */   GIM_Try, /*On fail goto*//*Label 2547*/ GIMT_Encode4(116998), // Rule ID 675 //
     /* 116936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 116939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 116947 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116950 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 116954 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 116958 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 116962 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116966 */     // MIs[2] Operand 1
     /* 116966 */     // No operand predicates
     /* 116966 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 116968 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 116975 */     // (shl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2)  =>  (SHL32mi_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 116975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32mi_ND),
     /* 116978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116980 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 116984 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 116987 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116990 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 116996 */     GIR_RootConstrainSelectedInstOperands,
     /* 116997 */     // GIR_Coverage, 675,
     /* 116997 */     GIR_EraseRootFromParent_Done,
     /* 116998 */   // Label 2547: @116998
     /* 116998 */   GIM_Try, /*On fail goto*//*Label 2548*/ GIMT_Encode4(117071), // Rule ID 691 //
     /* 117003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 117006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 117014 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117017 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 117021 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 117025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 117029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117031 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 117038 */     // (shl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] })  =>  (SHL32mCL_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 117038 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117042 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117048 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 117052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32mCL_ND),
     /* 117055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117057 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 117061 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117064 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117069 */     GIR_RootConstrainSelectedInstOperands,
     /* 117070 */     // GIR_Coverage, 691,
     /* 117070 */     GIR_EraseRootFromParent_Done,
     /* 117071 */   // Label 2548: @117071
     /* 117071 */   GIM_Try, /*On fail goto*//*Label 2549*/ GIMT_Encode4(117181), // Rule ID 17672 //
     /* 117076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 117079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 117087 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117090 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 117094 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 117098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 117102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117104 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 117111 */     // (shl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR8:{ *:[i8] }:$src2)  =>  (SHLX32rm:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 117111 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117114 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117118 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117123 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117125 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117128 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 117132 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117137 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 117140 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 117144 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 117147 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 117152 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 117157 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 117162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX32rm),
     /* 117165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117167 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 117171 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117174 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117179 */     GIR_RootConstrainSelectedInstOperands,
     /* 117180 */     // GIR_Coverage, 17672,
     /* 117180 */     GIR_EraseRootFromParent_Done,
     /* 117181 */   // Label 2549: @117181
     /* 117181 */   GIM_Try, /*On fail goto*//*Label 2550*/ GIMT_Encode4(117291), // Rule ID 17704 //
     /* 117186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 117189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 117197 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117200 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 117204 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 117208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 117212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117214 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 117221 */     // (shl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR8:{ *:[i8] }:$src2)  =>  (SHLX32rm_EVEX:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 117221 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117224 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117228 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117233 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117235 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117238 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 117242 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117247 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 117250 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 117254 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 117257 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 117262 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 117267 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 117272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX32rm_EVEX),
     /* 117275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117277 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 117281 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117284 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117289 */     GIR_RootConstrainSelectedInstOperands,
     /* 117290 */     // GIR_Coverage, 17704,
     /* 117290 */     GIR_EraseRootFromParent_Done,
     /* 117291 */   // Label 2550: @117291
     /* 117291 */   GIM_Try, /*On fail goto*//*Label 2551*/ GIMT_Encode4(117321), // Rule ID 22676 //
     /* 117296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 117299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 117303 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 117307 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, 1:{ *:[i8] })  =>  (ADD32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src1)
     /* 117307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32rr),
     /* 117310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117312 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117314 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117316 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117319 */     GIR_RootConstrainSelectedInstOperands,
     /* 117320 */     // GIR_Coverage, 22676,
     /* 117320 */     GIR_EraseRootFromParent_Done,
     /* 117321 */   // Label 2551: @117321
     /* 117321 */   GIM_Try, /*On fail goto*//*Label 2552*/ GIMT_Encode4(117351), // Rule ID 22680 //
     /* 117326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 117329 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 117333 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 117337 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, 1:{ *:[i8] })  =>  (ADD32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src1)
     /* 117337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32rr_ND),
     /* 117340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117342 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117344 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117346 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117349 */     GIR_RootConstrainSelectedInstOperands,
     /* 117350 */     // GIR_Coverage, 22680,
     /* 117350 */     GIR_EraseRootFromParent_Done,
     /* 117351 */   // Label 2552: @117351
     /* 117351 */   GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(117388), // Rule ID 663 //
     /* 117356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 117359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 117363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 117367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 117371 */     // MIs[1] Operand 1
     /* 117371 */     // No operand predicates
     /* 117371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117373 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 117373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32ri),
     /* 117376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117378 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117380 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 117383 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117386 */     GIR_RootConstrainSelectedInstOperands,
     /* 117387 */     // GIR_Coverage, 663,
     /* 117387 */     GIR_EraseRootFromParent_Done,
     /* 117388 */   // Label 2553: @117388
     /* 117388 */   GIM_Try, /*On fail goto*//*Label 2554*/ GIMT_Encode4(117425), // Rule ID 667 //
     /* 117393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 117396 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 117400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 117404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 117408 */     // MIs[1] Operand 1
     /* 117408 */     // No operand predicates
     /* 117408 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117410 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 117410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32ri_ND),
     /* 117413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117415 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 117420 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117423 */     GIR_RootConstrainSelectedInstOperands,
     /* 117424 */     // GIR_Coverage, 667,
     /* 117424 */     GIR_EraseRootFromParent_Done,
     /* 117425 */   // Label 2554: @117425
     /* 117425 */   GIM_Try, /*On fail goto*//*Label 2555*/ GIMT_Encode4(117504), // Rule ID 17668 //
     /* 117430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 117433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 117437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 117441 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHLX32rr:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 117441 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117444 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117448 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 117462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117467 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 117470 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 117474 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 117477 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 117482 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 117487 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 117492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX32rr),
     /* 117495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117497 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117499 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117502 */     GIR_RootConstrainSelectedInstOperands,
     /* 117503 */     // GIR_Coverage, 17668,
     /* 117503 */     GIR_EraseRootFromParent_Done,
     /* 117504 */   // Label 2555: @117504
     /* 117504 */   GIM_Try, /*On fail goto*//*Label 2556*/ GIMT_Encode4(117583), // Rule ID 17700 //
     /* 117509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 117512 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 117516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 117520 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHLX32rr_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 117520 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117523 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117527 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117532 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117534 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117537 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 117541 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117546 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 117549 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 117553 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 117556 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 117561 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 117566 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 117571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX32rr_EVEX),
     /* 117574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117576 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117578 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117581 */     GIR_RootConstrainSelectedInstOperands,
     /* 117582 */     // GIR_Coverage, 17700,
     /* 117582 */     GIR_EraseRootFromParent_Done,
     /* 117583 */   // Label 2556: @117583
     /* 117583 */   GIM_Try, /*On fail goto*//*Label 2557*/ GIMT_Encode4(117625), // Rule ID 679 //
     /* 117588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 117591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 117595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 117599 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SHL32rCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 117599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117603 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117609 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 117613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32rCL),
     /* 117616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117618 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117620 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117623 */     GIR_RootConstrainSelectedInstOperands,
     /* 117624 */     // GIR_Coverage, 679,
     /* 117624 */     GIR_EraseRootFromParent_Done,
     /* 117625 */   // Label 2557: @117625
     /* 117625 */   GIM_Try, /*On fail goto*//*Label 2558*/ GIMT_Encode4(117667), // Rule ID 683 //
     /* 117630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 117633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 117637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 117641 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SHL32rCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 117641 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117645 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117651 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 117655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32rCL_ND),
     /* 117658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117660 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117662 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117665 */     GIR_RootConstrainSelectedInstOperands,
     /* 117666 */     // GIR_Coverage, 683,
     /* 117666 */     GIR_EraseRootFromParent_Done,
     /* 117667 */   // Label 2558: @117667
     /* 117667 */   GIM_Reject,
     /* 117668 */ // Label 2546: @117668
     /* 117668 */ GIM_Reject,
     /* 117669 */ // Label 2526: @117669
     /* 117669 */ GIM_Try, /*On fail goto*//*Label 2559*/ GIMT_Encode4(118421),
     /* 117674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 117677 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 117680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 117684 */   GIM_Try, /*On fail goto*//*Label 2560*/ GIMT_Encode4(117751), // Rule ID 676 //
     /* 117689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 117692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 117700 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117703 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 117707 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 117711 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 117715 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 117719 */     // MIs[2] Operand 1
     /* 117719 */     // No operand predicates
     /* 117719 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 117721 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 117728 */     // (shl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2)  =>  (SHL64mi_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 117728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64mi_ND),
     /* 117731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117733 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 117737 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 117740 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117743 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 117749 */     GIR_RootConstrainSelectedInstOperands,
     /* 117750 */     // GIR_Coverage, 676,
     /* 117750 */     GIR_EraseRootFromParent_Done,
     /* 117751 */   // Label 2560: @117751
     /* 117751 */   GIM_Try, /*On fail goto*//*Label 2561*/ GIMT_Encode4(117824), // Rule ID 692 //
     /* 117756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 117759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 117767 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117770 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 117774 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 117778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 117782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117784 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 117791 */     // (shl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] })  =>  (SHL64mCL_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 117791 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117795 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117801 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 117805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64mCL_ND),
     /* 117808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117810 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 117814 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117817 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117822 */     GIR_RootConstrainSelectedInstOperands,
     /* 117823 */     // GIR_Coverage, 692,
     /* 117823 */     GIR_EraseRootFromParent_Done,
     /* 117824 */   // Label 2561: @117824
     /* 117824 */   GIM_Try, /*On fail goto*//*Label 2562*/ GIMT_Encode4(117934), // Rule ID 17673 //
     /* 117829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 117832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 117840 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117843 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 117847 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 117851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 117855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117857 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 117864 */     // (shl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2)  =>  (SHLX64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 117864 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 117867 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117871 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 117881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 117885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117890 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 117893 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 117897 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 117900 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 117905 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 117910 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 117915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX64rm),
     /* 117918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117920 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 117924 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117927 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117932 */     GIR_RootConstrainSelectedInstOperands,
     /* 117933 */     // GIR_Coverage, 17673,
     /* 117933 */     GIR_EraseRootFromParent_Done,
     /* 117934 */   // Label 2562: @117934
     /* 117934 */   GIM_Try, /*On fail goto*//*Label 2563*/ GIMT_Encode4(118044), // Rule ID 17705 //
     /* 117939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 117942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 117950 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117953 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 117957 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 117961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 117965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117967 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 117974 */     // (shl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2)  =>  (SHLX64rm_EVEX:{ *:[i64] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 117974 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 117977 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117981 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117986 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117988 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 117991 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 117995 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118000 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 118003 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 118007 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 118010 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 118015 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 118020 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 118025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX64rm_EVEX),
     /* 118028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118030 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 118034 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118037 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 118042 */     GIR_RootConstrainSelectedInstOperands,
     /* 118043 */     // GIR_Coverage, 17705,
     /* 118043 */     GIR_EraseRootFromParent_Done,
     /* 118044 */   // Label 2563: @118044
     /* 118044 */   GIM_Try, /*On fail goto*//*Label 2564*/ GIMT_Encode4(118074), // Rule ID 22677 //
     /* 118049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 118052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 118056 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 118060 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, 1:{ *:[i8] })  =>  (ADD64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src1)
     /* 118060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64rr),
     /* 118063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118065 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118067 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118069 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118072 */     GIR_RootConstrainSelectedInstOperands,
     /* 118073 */     // GIR_Coverage, 22677,
     /* 118073 */     GIR_EraseRootFromParent_Done,
     /* 118074 */   // Label 2564: @118074
     /* 118074 */   GIM_Try, /*On fail goto*//*Label 2565*/ GIMT_Encode4(118104), // Rule ID 22681 //
     /* 118079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 118082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 118086 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 118090 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, 1:{ *:[i8] })  =>  (ADD64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src1)
     /* 118090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64rr_ND),
     /* 118093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118095 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118097 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118099 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118102 */     GIR_RootConstrainSelectedInstOperands,
     /* 118103 */     // GIR_Coverage, 22681,
     /* 118103 */     GIR_EraseRootFromParent_Done,
     /* 118104 */   // Label 2565: @118104
     /* 118104 */   GIM_Try, /*On fail goto*//*Label 2566*/ GIMT_Encode4(118141), // Rule ID 664 //
     /* 118109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 118112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 118116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 118120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 118124 */     // MIs[1] Operand 1
     /* 118124 */     // No operand predicates
     /* 118124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118126 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 118126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64ri),
     /* 118129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118131 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 118136 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118139 */     GIR_RootConstrainSelectedInstOperands,
     /* 118140 */     // GIR_Coverage, 664,
     /* 118140 */     GIR_EraseRootFromParent_Done,
     /* 118141 */   // Label 2566: @118141
     /* 118141 */   GIM_Try, /*On fail goto*//*Label 2567*/ GIMT_Encode4(118178), // Rule ID 668 //
     /* 118146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118149 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 118153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 118157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 118161 */     // MIs[1] Operand 1
     /* 118161 */     // No operand predicates
     /* 118161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118163 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL64ri_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 118163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64ri_ND),
     /* 118166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118168 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118170 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 118173 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118176 */     GIR_RootConstrainSelectedInstOperands,
     /* 118177 */     // GIR_Coverage, 668,
     /* 118177 */     GIR_EraseRootFromParent_Done,
     /* 118178 */   // Label 2567: @118178
     /* 118178 */   GIM_Try, /*On fail goto*//*Label 2568*/ GIMT_Encode4(118257), // Rule ID 17669 //
     /* 118183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 118186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 118190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 118194 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHLX64rr:{ *:[i64] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 118194 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 118197 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118201 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118206 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118208 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 118211 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 118215 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118220 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 118223 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 118227 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 118230 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 118235 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 118240 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 118245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX64rr),
     /* 118248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118250 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118252 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118255 */     GIR_RootConstrainSelectedInstOperands,
     /* 118256 */     // GIR_Coverage, 17669,
     /* 118256 */     GIR_EraseRootFromParent_Done,
     /* 118257 */   // Label 2568: @118257
     /* 118257 */   GIM_Try, /*On fail goto*//*Label 2569*/ GIMT_Encode4(118336), // Rule ID 17701 //
     /* 118262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 118265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 118269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 118273 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHLX64rr_EVEX:{ *:[i64] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 118273 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 118276 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118280 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118285 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118287 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 118290 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 118294 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118299 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 118302 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 118306 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 118309 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 118314 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 118319 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 118324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX64rr_EVEX),
     /* 118327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118329 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118331 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118334 */     GIR_RootConstrainSelectedInstOperands,
     /* 118335 */     // GIR_Coverage, 17701,
     /* 118335 */     GIR_EraseRootFromParent_Done,
     /* 118336 */   // Label 2569: @118336
     /* 118336 */   GIM_Try, /*On fail goto*//*Label 2570*/ GIMT_Encode4(118378), // Rule ID 680 //
     /* 118341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 118344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 118348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 118352 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SHL64rCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 118352 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118356 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118362 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 118366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64rCL),
     /* 118369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118371 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118373 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118376 */     GIR_RootConstrainSelectedInstOperands,
     /* 118377 */     // GIR_Coverage, 680,
     /* 118377 */     GIR_EraseRootFromParent_Done,
     /* 118378 */   // Label 2570: @118378
     /* 118378 */   GIM_Try, /*On fail goto*//*Label 2571*/ GIMT_Encode4(118420), // Rule ID 684 //
     /* 118383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 118390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 118394 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SHL64rCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 118394 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118398 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118404 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 118408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64rCL_ND),
     /* 118411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118413 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118415 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118418 */     GIR_RootConstrainSelectedInstOperands,
     /* 118419 */     // GIR_Coverage, 684,
     /* 118419 */     GIR_EraseRootFromParent_Done,
     /* 118420 */   // Label 2571: @118420
     /* 118420 */   GIM_Reject,
     /* 118421 */ // Label 2559: @118421
     /* 118421 */ GIM_Reject,
     /* 118422 */ // Label 2527: @118422
     /* 118422 */ GIM_Reject,
     /* 118423 */ // Label 27: @118423
     /* 118423 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(5), /*)*//*default:*//*Label 2576*/ GIMT_Encode4(120466),
     /* 118434 */ /*GILLT_s8*//*Label 2572*/ GIMT_Encode4(118450),
     /* 118438 */ /*GILLT_s16*//*Label 2573*/ GIMT_Encode4(118765),
     /* 118442 */ /*GILLT_s32*//*Label 2574*/ GIMT_Encode4(119080),
     /* 118446 */ /*GILLT_s64*//*Label 2575*/ GIMT_Encode4(119773),
     /* 118450 */ // Label 2572: @118450
     /* 118450 */ GIM_Try, /*On fail goto*//*Label 2577*/ GIMT_Encode4(118764),
     /* 118455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 118458 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 118461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 118465 */   GIM_Try, /*On fail goto*//*Label 2578*/ GIMT_Encode4(118532), // Rule ID 705 //
     /* 118470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 118481 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118484 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 118488 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 118492 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 118496 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 118500 */     // MIs[2] Operand 1
     /* 118500 */     // No operand predicates
     /* 118500 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 118502 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 118509 */     // (srl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2)  =>  (SHR8mi_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 118509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8mi_ND),
     /* 118512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118514 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 118518 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 118521 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118524 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 118530 */     GIR_RootConstrainSelectedInstOperands,
     /* 118531 */     // GIR_Coverage, 705,
     /* 118531 */     GIR_EraseRootFromParent_Done,
     /* 118532 */   // Label 2578: @118532
     /* 118532 */   GIM_Try, /*On fail goto*//*Label 2579*/ GIMT_Encode4(118605), // Rule ID 721 //
     /* 118537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 118548 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118551 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 118555 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 118559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 118563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118565 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 118572 */     // (srl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] })  =>  (SHR8mCL_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 118572 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118576 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118582 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 118586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8mCL_ND),
     /* 118589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118591 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 118595 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118598 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 118603 */     GIR_RootConstrainSelectedInstOperands,
     /* 118604 */     // GIR_Coverage, 721,
     /* 118604 */     GIR_EraseRootFromParent_Done,
     /* 118605 */   // Label 2579: @118605
     /* 118605 */   GIM_Try, /*On fail goto*//*Label 2580*/ GIMT_Encode4(118642), // Rule ID 693 //
     /* 118610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 118613 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 118617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 118621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 118625 */     // MIs[1] Operand 1
     /* 118625 */     // No operand predicates
     /* 118625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118627 */     // (srl:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 118627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8ri),
     /* 118630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118632 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118634 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 118637 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118640 */     GIR_RootConstrainSelectedInstOperands,
     /* 118641 */     // GIR_Coverage, 693,
     /* 118641 */     GIR_EraseRootFromParent_Done,
     /* 118642 */   // Label 2580: @118642
     /* 118642 */   GIM_Try, /*On fail goto*//*Label 2581*/ GIMT_Encode4(118679), // Rule ID 697 //
     /* 118647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 118654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 118658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 118662 */     // MIs[1] Operand 1
     /* 118662 */     // No operand predicates
     /* 118662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118664 */     // (srl:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 118664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8ri_ND),
     /* 118667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118669 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118671 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 118674 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118677 */     GIR_RootConstrainSelectedInstOperands,
     /* 118678 */     // GIR_Coverage, 697,
     /* 118678 */     GIR_EraseRootFromParent_Done,
     /* 118679 */   // Label 2581: @118679
     /* 118679 */   GIM_Try, /*On fail goto*//*Label 2582*/ GIMT_Encode4(118721), // Rule ID 709 //
     /* 118684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 118687 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 118691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 118695 */     // (srl:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (SHR8rCL:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 118695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118699 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118705 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 118709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8rCL),
     /* 118712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118714 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118716 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118719 */     GIR_RootConstrainSelectedInstOperands,
     /* 118720 */     // GIR_Coverage, 709,
     /* 118720 */     GIR_EraseRootFromParent_Done,
     /* 118721 */   // Label 2582: @118721
     /* 118721 */   GIM_Try, /*On fail goto*//*Label 2583*/ GIMT_Encode4(118763), // Rule ID 713 //
     /* 118726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 118733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 118737 */     // (srl:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (SHR8rCL_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 118737 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118741 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118747 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 118751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8rCL_ND),
     /* 118754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118756 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118758 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118761 */     GIR_RootConstrainSelectedInstOperands,
     /* 118762 */     // GIR_Coverage, 713,
     /* 118762 */     GIR_EraseRootFromParent_Done,
     /* 118763 */   // Label 2583: @118763
     /* 118763 */   GIM_Reject,
     /* 118764 */ // Label 2577: @118764
     /* 118764 */ GIM_Reject,
     /* 118765 */ // Label 2573: @118765
     /* 118765 */ GIM_Try, /*On fail goto*//*Label 2584*/ GIMT_Encode4(119079),
     /* 118770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 118773 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 118776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 118780 */   GIM_Try, /*On fail goto*//*Label 2585*/ GIMT_Encode4(118847), // Rule ID 706 //
     /* 118785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 118796 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118799 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 118803 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 118807 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 118811 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 118815 */     // MIs[2] Operand 1
     /* 118815 */     // No operand predicates
     /* 118815 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 118817 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 118824 */     // (srl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2)  =>  (SHR16mi_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 118824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16mi_ND),
     /* 118827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118829 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 118833 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 118836 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118839 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 118845 */     GIR_RootConstrainSelectedInstOperands,
     /* 118846 */     // GIR_Coverage, 706,
     /* 118846 */     GIR_EraseRootFromParent_Done,
     /* 118847 */   // Label 2585: @118847
     /* 118847 */   GIM_Try, /*On fail goto*//*Label 2586*/ GIMT_Encode4(118920), // Rule ID 722 //
     /* 118852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 118863 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118866 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 118870 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 118874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 118878 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118880 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 118887 */     // (srl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] })  =>  (SHR16mCL_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 118887 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118891 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118897 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 118901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16mCL_ND),
     /* 118904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118906 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 118910 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118913 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 118918 */     GIR_RootConstrainSelectedInstOperands,
     /* 118919 */     // GIR_Coverage, 722,
     /* 118919 */     GIR_EraseRootFromParent_Done,
     /* 118920 */   // Label 2586: @118920
     /* 118920 */   GIM_Try, /*On fail goto*//*Label 2587*/ GIMT_Encode4(118957), // Rule ID 694 //
     /* 118925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 118928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 118932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 118936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 118940 */     // MIs[1] Operand 1
     /* 118940 */     // No operand predicates
     /* 118940 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118942 */     // (srl:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 118942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16ri),
     /* 118945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118947 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 118952 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118955 */     GIR_RootConstrainSelectedInstOperands,
     /* 118956 */     // GIR_Coverage, 694,
     /* 118956 */     GIR_EraseRootFromParent_Done,
     /* 118957 */   // Label 2587: @118957
     /* 118957 */   GIM_Try, /*On fail goto*//*Label 2588*/ GIMT_Encode4(118994), // Rule ID 698 //
     /* 118962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118965 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 118969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 118973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 118977 */     // MIs[1] Operand 1
     /* 118977 */     // No operand predicates
     /* 118977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118979 */     // (srl:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 118979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16ri_ND),
     /* 118982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118984 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118986 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 118989 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118992 */     GIR_RootConstrainSelectedInstOperands,
     /* 118993 */     // GIR_Coverage, 698,
     /* 118993 */     GIR_EraseRootFromParent_Done,
     /* 118994 */   // Label 2588: @118994
     /* 118994 */   GIM_Try, /*On fail goto*//*Label 2589*/ GIMT_Encode4(119036), // Rule ID 710 //
     /* 118999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 119002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 119006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 119010 */     // (srl:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (SHR16rCL:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 119010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119014 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119020 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 119024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16rCL),
     /* 119027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119029 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 119031 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119034 */     GIR_RootConstrainSelectedInstOperands,
     /* 119035 */     // GIR_Coverage, 710,
     /* 119035 */     GIR_EraseRootFromParent_Done,
     /* 119036 */   // Label 2589: @119036
     /* 119036 */   GIM_Try, /*On fail goto*//*Label 2590*/ GIMT_Encode4(119078), // Rule ID 714 //
     /* 119041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 119044 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 119048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 119052 */     // (srl:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (SHR16rCL_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 119052 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119056 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119062 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 119066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16rCL_ND),
     /* 119069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119071 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 119073 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119076 */     GIR_RootConstrainSelectedInstOperands,
     /* 119077 */     // GIR_Coverage, 714,
     /* 119077 */     GIR_EraseRootFromParent_Done,
     /* 119078 */   // Label 2590: @119078
     /* 119078 */   GIM_Reject,
     /* 119079 */ // Label 2584: @119079
     /* 119079 */ GIM_Reject,
     /* 119080 */ // Label 2574: @119080
     /* 119080 */ GIM_Try, /*On fail goto*//*Label 2591*/ GIMT_Encode4(119772),
     /* 119085 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 119088 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 119091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 119095 */   GIM_Try, /*On fail goto*//*Label 2592*/ GIMT_Encode4(119162), // Rule ID 707 //
     /* 119100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 119103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 119111 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119114 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 119118 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 119122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 119126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 119130 */     // MIs[2] Operand 1
     /* 119130 */     // No operand predicates
     /* 119130 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 119132 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 119139 */     // (srl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2)  =>  (SHR32mi_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 119139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32mi_ND),
     /* 119142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119144 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 119148 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 119151 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119154 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 119160 */     GIR_RootConstrainSelectedInstOperands,
     /* 119161 */     // GIR_Coverage, 707,
     /* 119161 */     GIR_EraseRootFromParent_Done,
     /* 119162 */   // Label 2592: @119162
     /* 119162 */   GIM_Try, /*On fail goto*//*Label 2593*/ GIMT_Encode4(119235), // Rule ID 723 //
     /* 119167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 119170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 119178 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119181 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 119185 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 119189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 119193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119195 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 119202 */     // (srl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] })  =>  (SHR32mCL_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 119202 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119206 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119212 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 119216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32mCL_ND),
     /* 119219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119221 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 119225 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119228 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 119233 */     GIR_RootConstrainSelectedInstOperands,
     /* 119234 */     // GIR_Coverage, 723,
     /* 119234 */     GIR_EraseRootFromParent_Done,
     /* 119235 */   // Label 2593: @119235
     /* 119235 */   GIM_Try, /*On fail goto*//*Label 2594*/ GIMT_Encode4(119345), // Rule ID 17664 //
     /* 119240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 119243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 119251 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119254 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 119258 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 119262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 119266 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119268 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 119275 */     // (srl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR8:{ *:[i8] }:$src2)  =>  (SHRX32rm:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 119275 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119278 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119282 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119287 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119289 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119292 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 119296 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119301 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 119304 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 119308 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 119311 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 119316 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 119321 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 119326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX32rm),
     /* 119329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119331 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 119335 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119338 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 119343 */     GIR_RootConstrainSelectedInstOperands,
     /* 119344 */     // GIR_Coverage, 17664,
     /* 119344 */     GIR_EraseRootFromParent_Done,
     /* 119345 */   // Label 2594: @119345
     /* 119345 */   GIM_Try, /*On fail goto*//*Label 2595*/ GIMT_Encode4(119455), // Rule ID 17696 //
     /* 119350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 119353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 119361 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119364 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 119368 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 119372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 119376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119378 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 119385 */     // (srl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR8:{ *:[i8] }:$src2)  =>  (SHRX32rm_EVEX:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 119385 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119388 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119392 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119397 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119399 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119402 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 119406 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119411 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 119414 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 119418 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 119421 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 119426 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 119431 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 119436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX32rm_EVEX),
     /* 119439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119441 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 119445 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119448 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 119453 */     GIR_RootConstrainSelectedInstOperands,
     /* 119454 */     // GIR_Coverage, 17696,
     /* 119454 */     GIR_EraseRootFromParent_Done,
     /* 119455 */   // Label 2595: @119455
     /* 119455 */   GIM_Try, /*On fail goto*//*Label 2596*/ GIMT_Encode4(119492), // Rule ID 695 //
     /* 119460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 119463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 119467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 119471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 119475 */     // MIs[1] Operand 1
     /* 119475 */     // No operand predicates
     /* 119475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119477 */     // (srl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 119477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32ri),
     /* 119480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119482 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 119484 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 119487 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119490 */     GIR_RootConstrainSelectedInstOperands,
     /* 119491 */     // GIR_Coverage, 695,
     /* 119491 */     GIR_EraseRootFromParent_Done,
     /* 119492 */   // Label 2596: @119492
     /* 119492 */   GIM_Try, /*On fail goto*//*Label 2597*/ GIMT_Encode4(119529), // Rule ID 699 //
     /* 119497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 119500 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 119504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 119508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 119512 */     // MIs[1] Operand 1
     /* 119512 */     // No operand predicates
     /* 119512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119514 */     // (srl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 119514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32ri_ND),
     /* 119517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119519 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 119521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 119524 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119527 */     GIR_RootConstrainSelectedInstOperands,
     /* 119528 */     // GIR_Coverage, 699,
     /* 119528 */     GIR_EraseRootFromParent_Done,
     /* 119529 */   // Label 2597: @119529
     /* 119529 */   GIM_Try, /*On fail goto*//*Label 2598*/ GIMT_Encode4(119608), // Rule ID 17660 //
     /* 119534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 119537 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 119541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 119545 */     // (srl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHRX32rr:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 119545 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119548 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119552 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119557 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119559 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 119566 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119571 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 119574 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 119578 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 119581 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 119586 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 119591 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 119596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX32rr),
     /* 119599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119601 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 119603 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119606 */     GIR_RootConstrainSelectedInstOperands,
     /* 119607 */     // GIR_Coverage, 17660,
     /* 119607 */     GIR_EraseRootFromParent_Done,
     /* 119608 */   // Label 2598: @119608
     /* 119608 */   GIM_Try, /*On fail goto*//*Label 2599*/ GIMT_Encode4(119687), // Rule ID 17692 //
     /* 119613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 119616 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 119620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 119624 */     // (srl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHRX32rr_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 119624 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119627 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119631 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119636 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119638 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119641 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 119645 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119650 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 119653 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 119657 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 119660 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 119665 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 119670 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 119675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX32rr_EVEX),
     /* 119678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119680 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 119682 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119685 */     GIR_RootConstrainSelectedInstOperands,
     /* 119686 */     // GIR_Coverage, 17692,
     /* 119686 */     GIR_EraseRootFromParent_Done,
     /* 119687 */   // Label 2599: @119687
     /* 119687 */   GIM_Try, /*On fail goto*//*Label 2600*/ GIMT_Encode4(119729), // Rule ID 711 //
     /* 119692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 119695 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 119699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 119703 */     // (srl:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SHR32rCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 119703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119707 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119713 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 119717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32rCL),
     /* 119720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119722 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 119724 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119727 */     GIR_RootConstrainSelectedInstOperands,
     /* 119728 */     // GIR_Coverage, 711,
     /* 119728 */     GIR_EraseRootFromParent_Done,
     /* 119729 */   // Label 2600: @119729
     /* 119729 */   GIM_Try, /*On fail goto*//*Label 2601*/ GIMT_Encode4(119771), // Rule ID 715 //
     /* 119734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 119737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 119741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 119745 */     // (srl:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SHR32rCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 119745 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119749 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119755 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 119759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32rCL_ND),
     /* 119762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119764 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 119766 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119769 */     GIR_RootConstrainSelectedInstOperands,
     /* 119770 */     // GIR_Coverage, 715,
     /* 119770 */     GIR_EraseRootFromParent_Done,
     /* 119771 */   // Label 2601: @119771
     /* 119771 */   GIM_Reject,
     /* 119772 */ // Label 2591: @119772
     /* 119772 */ GIM_Reject,
     /* 119773 */ // Label 2575: @119773
     /* 119773 */ GIM_Try, /*On fail goto*//*Label 2602*/ GIMT_Encode4(120465),
     /* 119778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 119781 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 119784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 119788 */   GIM_Try, /*On fail goto*//*Label 2603*/ GIMT_Encode4(119855), // Rule ID 708 //
     /* 119793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 119796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 119804 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119807 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 119811 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 119815 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 119819 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 119823 */     // MIs[2] Operand 1
     /* 119823 */     // No operand predicates
     /* 119823 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 119825 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 119832 */     // (srl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2)  =>  (SHR64mi_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 119832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64mi_ND),
     /* 119835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119837 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 119841 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 119844 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119847 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 119853 */     GIR_RootConstrainSelectedInstOperands,
     /* 119854 */     // GIR_Coverage, 708,
     /* 119854 */     GIR_EraseRootFromParent_Done,
     /* 119855 */   // Label 2603: @119855
     /* 119855 */   GIM_Try, /*On fail goto*//*Label 2604*/ GIMT_Encode4(119928), // Rule ID 724 //
     /* 119860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 119863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 119871 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119874 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 119878 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 119882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 119886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119888 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 119895 */     // (srl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] })  =>  (SHR64mCL_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 119895 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119899 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119905 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 119909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64mCL_ND),
     /* 119912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119914 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 119918 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119921 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 119926 */     GIR_RootConstrainSelectedInstOperands,
     /* 119927 */     // GIR_Coverage, 724,
     /* 119927 */     GIR_EraseRootFromParent_Done,
     /* 119928 */   // Label 2604: @119928
     /* 119928 */   GIM_Try, /*On fail goto*//*Label 2605*/ GIMT_Encode4(120038), // Rule ID 17665 //
     /* 119933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 119936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 119944 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119947 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 119951 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 119955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 119959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119961 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 119968 */     // (srl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2)  =>  (SHRX64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 119968 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 119971 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119975 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119980 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119982 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 119985 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 119989 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119994 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 119997 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 120001 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 120004 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 120009 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 120014 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 120019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX64rm),
     /* 120022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120024 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 120028 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120031 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 120036 */     GIR_RootConstrainSelectedInstOperands,
     /* 120037 */     // GIR_Coverage, 17665,
     /* 120037 */     GIR_EraseRootFromParent_Done,
     /* 120038 */   // Label 2605: @120038
     /* 120038 */   GIM_Try, /*On fail goto*//*Label 2606*/ GIMT_Encode4(120148), // Rule ID 17697 //
     /* 120043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 120046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 120054 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120057 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 120061 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 120065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 120069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120071 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 120078 */     // (srl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2)  =>  (SHRX64rm_EVEX:{ *:[i64] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 120078 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 120081 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120085 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120090 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120092 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 120095 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 120099 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120104 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 120107 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 120111 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 120114 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 120119 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 120124 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 120129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX64rm_EVEX),
     /* 120132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120134 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 120138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120141 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 120146 */     GIR_RootConstrainSelectedInstOperands,
     /* 120147 */     // GIR_Coverage, 17697,
     /* 120147 */     GIR_EraseRootFromParent_Done,
     /* 120148 */   // Label 2606: @120148
     /* 120148 */   GIM_Try, /*On fail goto*//*Label 2607*/ GIMT_Encode4(120185), // Rule ID 696 //
     /* 120153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 120156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 120160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 120164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 120168 */     // MIs[1] Operand 1
     /* 120168 */     // No operand predicates
     /* 120168 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120170 */     // (srl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 120170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64ri),
     /* 120173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120175 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120177 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 120180 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120183 */     GIR_RootConstrainSelectedInstOperands,
     /* 120184 */     // GIR_Coverage, 696,
     /* 120184 */     GIR_EraseRootFromParent_Done,
     /* 120185 */   // Label 2607: @120185
     /* 120185 */   GIM_Try, /*On fail goto*//*Label 2608*/ GIMT_Encode4(120222), // Rule ID 700 //
     /* 120190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 120193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 120197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 120201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 120205 */     // MIs[1] Operand 1
     /* 120205 */     // No operand predicates
     /* 120205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120207 */     // (srl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR64ri_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 120207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64ri_ND),
     /* 120210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120212 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120214 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 120217 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120220 */     GIR_RootConstrainSelectedInstOperands,
     /* 120221 */     // GIR_Coverage, 700,
     /* 120221 */     GIR_EraseRootFromParent_Done,
     /* 120222 */   // Label 2608: @120222
     /* 120222 */   GIM_Try, /*On fail goto*//*Label 2609*/ GIMT_Encode4(120301), // Rule ID 17661 //
     /* 120227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 120230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 120234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 120238 */     // (srl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHRX64rr:{ *:[i64] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 120238 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 120241 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120245 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120250 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120252 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 120255 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 120259 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120264 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 120267 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 120271 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 120274 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 120279 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 120284 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 120289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX64rr),
     /* 120292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120294 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120296 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120299 */     GIR_RootConstrainSelectedInstOperands,
     /* 120300 */     // GIR_Coverage, 17661,
     /* 120300 */     GIR_EraseRootFromParent_Done,
     /* 120301 */   // Label 2609: @120301
     /* 120301 */   GIM_Try, /*On fail goto*//*Label 2610*/ GIMT_Encode4(120380), // Rule ID 17693 //
     /* 120306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 120309 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 120313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 120317 */     // (srl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHRX64rr_EVEX:{ *:[i64] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 120317 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 120320 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120324 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120329 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 120334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 120338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120343 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 120346 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 120350 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 120353 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 120358 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 120363 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 120368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX64rr_EVEX),
     /* 120371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120373 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120378 */     GIR_RootConstrainSelectedInstOperands,
     /* 120379 */     // GIR_Coverage, 17693,
     /* 120379 */     GIR_EraseRootFromParent_Done,
     /* 120380 */   // Label 2610: @120380
     /* 120380 */   GIM_Try, /*On fail goto*//*Label 2611*/ GIMT_Encode4(120422), // Rule ID 712 //
     /* 120385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 120388 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 120392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 120396 */     // (srl:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SHR64rCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 120396 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120400 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120406 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 120410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64rCL),
     /* 120413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120415 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120417 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120420 */     GIR_RootConstrainSelectedInstOperands,
     /* 120421 */     // GIR_Coverage, 712,
     /* 120421 */     GIR_EraseRootFromParent_Done,
     /* 120422 */   // Label 2611: @120422
     /* 120422 */   GIM_Try, /*On fail goto*//*Label 2612*/ GIMT_Encode4(120464), // Rule ID 716 //
     /* 120427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 120430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 120434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 120438 */     // (srl:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SHR64rCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 120438 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120442 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120448 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 120452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64rCL_ND),
     /* 120455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120457 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120459 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120462 */     GIR_RootConstrainSelectedInstOperands,
     /* 120463 */     // GIR_Coverage, 716,
     /* 120463 */     GIR_EraseRootFromParent_Done,
     /* 120464 */   // Label 2612: @120464
     /* 120464 */   GIM_Reject,
     /* 120465 */ // Label 2602: @120465
     /* 120465 */ GIM_Reject,
     /* 120466 */ // Label 2576: @120466
     /* 120466 */ GIM_Reject,
     /* 120467 */ // Label 28: @120467
     /* 120467 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(5), /*)*//*default:*//*Label 2617*/ GIMT_Encode4(122510),
     /* 120478 */ /*GILLT_s8*//*Label 2613*/ GIMT_Encode4(120494),
     /* 120482 */ /*GILLT_s16*//*Label 2614*/ GIMT_Encode4(120809),
     /* 120486 */ /*GILLT_s32*//*Label 2615*/ GIMT_Encode4(121124),
     /* 120490 */ /*GILLT_s64*//*Label 2616*/ GIMT_Encode4(121817),
     /* 120494 */ // Label 2613: @120494
     /* 120494 */ GIM_Try, /*On fail goto*//*Label 2618*/ GIMT_Encode4(120808),
     /* 120499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 120502 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 120505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 120509 */   GIM_Try, /*On fail goto*//*Label 2619*/ GIMT_Encode4(120576), // Rule ID 737 //
     /* 120514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 120517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 120525 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120528 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 120532 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 120536 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 120540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 120544 */     // MIs[2] Operand 1
     /* 120544 */     // No operand predicates
     /* 120544 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 120546 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 120553 */     // (sra:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2)  =>  (SAR8mi_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 120553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8mi_ND),
     /* 120556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120558 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 120562 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 120565 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120568 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 120574 */     GIR_RootConstrainSelectedInstOperands,
     /* 120575 */     // GIR_Coverage, 737,
     /* 120575 */     GIR_EraseRootFromParent_Done,
     /* 120576 */   // Label 2619: @120576
     /* 120576 */   GIM_Try, /*On fail goto*//*Label 2620*/ GIMT_Encode4(120649), // Rule ID 753 //
     /* 120581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 120584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 120592 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120595 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 120599 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 120603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 120607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120609 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 120616 */     // (sra:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] })  =>  (SAR8mCL_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 120616 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120620 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120626 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 120630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8mCL_ND),
     /* 120633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120635 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 120639 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120642 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 120647 */     GIR_RootConstrainSelectedInstOperands,
     /* 120648 */     // GIR_Coverage, 753,
     /* 120648 */     GIR_EraseRootFromParent_Done,
     /* 120649 */   // Label 2620: @120649
     /* 120649 */   GIM_Try, /*On fail goto*//*Label 2621*/ GIMT_Encode4(120686), // Rule ID 725 //
     /* 120654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 120657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 120661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 120665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 120669 */     // MIs[1] Operand 1
     /* 120669 */     // No operand predicates
     /* 120669 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120671 */     // (sra:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 120671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8ri),
     /* 120674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120676 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120678 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 120681 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120684 */     GIR_RootConstrainSelectedInstOperands,
     /* 120685 */     // GIR_Coverage, 725,
     /* 120685 */     GIR_EraseRootFromParent_Done,
     /* 120686 */   // Label 2621: @120686
     /* 120686 */   GIM_Try, /*On fail goto*//*Label 2622*/ GIMT_Encode4(120723), // Rule ID 729 //
     /* 120691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 120694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 120698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 120702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 120706 */     // MIs[1] Operand 1
     /* 120706 */     // No operand predicates
     /* 120706 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120708 */     // (sra:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 120708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8ri_ND),
     /* 120711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120713 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 120718 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120721 */     GIR_RootConstrainSelectedInstOperands,
     /* 120722 */     // GIR_Coverage, 729,
     /* 120722 */     GIR_EraseRootFromParent_Done,
     /* 120723 */   // Label 2622: @120723
     /* 120723 */   GIM_Try, /*On fail goto*//*Label 2623*/ GIMT_Encode4(120765), // Rule ID 741 //
     /* 120728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 120731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 120735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 120739 */     // (sra:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (SAR8rCL:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 120739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120743 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120749 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 120753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8rCL),
     /* 120756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120758 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120760 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120763 */     GIR_RootConstrainSelectedInstOperands,
     /* 120764 */     // GIR_Coverage, 741,
     /* 120764 */     GIR_EraseRootFromParent_Done,
     /* 120765 */   // Label 2623: @120765
     /* 120765 */   GIM_Try, /*On fail goto*//*Label 2624*/ GIMT_Encode4(120807), // Rule ID 745 //
     /* 120770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 120773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 120777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 120781 */     // (sra:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (SAR8rCL_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 120781 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120785 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120791 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 120795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8rCL_ND),
     /* 120798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120800 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120802 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120805 */     GIR_RootConstrainSelectedInstOperands,
     /* 120806 */     // GIR_Coverage, 745,
     /* 120806 */     GIR_EraseRootFromParent_Done,
     /* 120807 */   // Label 2624: @120807
     /* 120807 */   GIM_Reject,
     /* 120808 */ // Label 2618: @120808
     /* 120808 */ GIM_Reject,
     /* 120809 */ // Label 2614: @120809
     /* 120809 */ GIM_Try, /*On fail goto*//*Label 2625*/ GIMT_Encode4(121123),
     /* 120814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 120817 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 120820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 120824 */   GIM_Try, /*On fail goto*//*Label 2626*/ GIMT_Encode4(120891), // Rule ID 738 //
     /* 120829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 120832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 120840 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120843 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 120847 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 120851 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 120855 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 120859 */     // MIs[2] Operand 1
     /* 120859 */     // No operand predicates
     /* 120859 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 120861 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 120868 */     // (sra:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2)  =>  (SAR16mi_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 120868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16mi_ND),
     /* 120871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120873 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 120877 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 120880 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120883 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 120889 */     GIR_RootConstrainSelectedInstOperands,
     /* 120890 */     // GIR_Coverage, 738,
     /* 120890 */     GIR_EraseRootFromParent_Done,
     /* 120891 */   // Label 2626: @120891
     /* 120891 */   GIM_Try, /*On fail goto*//*Label 2627*/ GIMT_Encode4(120964), // Rule ID 754 //
     /* 120896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 120899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 120907 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120910 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 120914 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 120918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 120922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120924 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 120931 */     // (sra:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] })  =>  (SAR16mCL_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 120931 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120935 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120941 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 120945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16mCL_ND),
     /* 120948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120950 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 120954 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120957 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 120962 */     GIR_RootConstrainSelectedInstOperands,
     /* 120963 */     // GIR_Coverage, 754,
     /* 120963 */     GIR_EraseRootFromParent_Done,
     /* 120964 */   // Label 2627: @120964
     /* 120964 */   GIM_Try, /*On fail goto*//*Label 2628*/ GIMT_Encode4(121001), // Rule ID 726 //
     /* 120969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 120972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 120976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 120980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 120984 */     // MIs[1] Operand 1
     /* 120984 */     // No operand predicates
     /* 120984 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120986 */     // (sra:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 120986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16ri),
     /* 120989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120991 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120993 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 120996 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120999 */     GIR_RootConstrainSelectedInstOperands,
     /* 121000 */     // GIR_Coverage, 726,
     /* 121000 */     GIR_EraseRootFromParent_Done,
     /* 121001 */   // Label 2628: @121001
     /* 121001 */   GIM_Try, /*On fail goto*//*Label 2629*/ GIMT_Encode4(121038), // Rule ID 730 //
     /* 121006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 121009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 121013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 121017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 121021 */     // MIs[1] Operand 1
     /* 121021 */     // No operand predicates
     /* 121021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121023 */     // (sra:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 121023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16ri_ND),
     /* 121026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121028 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 121030 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 121033 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121036 */     GIR_RootConstrainSelectedInstOperands,
     /* 121037 */     // GIR_Coverage, 730,
     /* 121037 */     GIR_EraseRootFromParent_Done,
     /* 121038 */   // Label 2629: @121038
     /* 121038 */   GIM_Try, /*On fail goto*//*Label 2630*/ GIMT_Encode4(121080), // Rule ID 742 //
     /* 121043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 121046 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 121050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 121054 */     // (sra:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (SAR16rCL:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 121054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121058 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121064 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 121068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16rCL),
     /* 121071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121073 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 121075 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121078 */     GIR_RootConstrainSelectedInstOperands,
     /* 121079 */     // GIR_Coverage, 742,
     /* 121079 */     GIR_EraseRootFromParent_Done,
     /* 121080 */   // Label 2630: @121080
     /* 121080 */   GIM_Try, /*On fail goto*//*Label 2631*/ GIMT_Encode4(121122), // Rule ID 746 //
     /* 121085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 121088 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 121092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 121096 */     // (sra:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (SAR16rCL_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 121096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121100 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121106 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 121110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16rCL_ND),
     /* 121113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121115 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 121117 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121120 */     GIR_RootConstrainSelectedInstOperands,
     /* 121121 */     // GIR_Coverage, 746,
     /* 121121 */     GIR_EraseRootFromParent_Done,
     /* 121122 */   // Label 2631: @121122
     /* 121122 */   GIM_Reject,
     /* 121123 */ // Label 2625: @121123
     /* 121123 */ GIM_Reject,
     /* 121124 */ // Label 2615: @121124
     /* 121124 */ GIM_Try, /*On fail goto*//*Label 2632*/ GIMT_Encode4(121816),
     /* 121129 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 121132 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 121135 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 121139 */   GIM_Try, /*On fail goto*//*Label 2633*/ GIMT_Encode4(121206), // Rule ID 739 //
     /* 121144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 121147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 121155 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121158 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 121162 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 121166 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 121170 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 121174 */     // MIs[2] Operand 1
     /* 121174 */     // No operand predicates
     /* 121174 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 121176 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 121183 */     // (sra:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2)  =>  (SAR32mi_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 121183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32mi_ND),
     /* 121186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121188 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 121192 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 121195 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121198 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 121204 */     GIR_RootConstrainSelectedInstOperands,
     /* 121205 */     // GIR_Coverage, 739,
     /* 121205 */     GIR_EraseRootFromParent_Done,
     /* 121206 */   // Label 2633: @121206
     /* 121206 */   GIM_Try, /*On fail goto*//*Label 2634*/ GIMT_Encode4(121279), // Rule ID 755 //
     /* 121211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 121214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 121222 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121225 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 121229 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 121233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 121237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121239 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 121246 */     // (sra:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] })  =>  (SAR32mCL_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 121246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121250 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121256 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 121260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32mCL_ND),
     /* 121263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121265 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 121269 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121272 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 121277 */     GIR_RootConstrainSelectedInstOperands,
     /* 121278 */     // GIR_Coverage, 755,
     /* 121278 */     GIR_EraseRootFromParent_Done,
     /* 121279 */   // Label 2634: @121279
     /* 121279 */   GIM_Try, /*On fail goto*//*Label 2635*/ GIMT_Encode4(121389), // Rule ID 17656 //
     /* 121284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 121287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 121295 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121298 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 121302 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 121306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 121310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121312 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 121319 */     // (sra:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR8:{ *:[i8] }:$src2)  =>  (SARX32rm:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 121319 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121322 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121326 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121331 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121345 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 121348 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 121352 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 121355 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 121360 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 121365 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 121370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX32rm),
     /* 121373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121375 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 121379 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121382 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 121387 */     GIR_RootConstrainSelectedInstOperands,
     /* 121388 */     // GIR_Coverage, 17656,
     /* 121388 */     GIR_EraseRootFromParent_Done,
     /* 121389 */   // Label 2635: @121389
     /* 121389 */   GIM_Try, /*On fail goto*//*Label 2636*/ GIMT_Encode4(121499), // Rule ID 17688 //
     /* 121394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 121397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 121405 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121408 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 121412 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 121416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 121420 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121422 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 121429 */     // (sra:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR8:{ *:[i8] }:$src2)  =>  (SARX32rm_EVEX:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 121429 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121432 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121436 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121441 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121443 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121446 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121450 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121455 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 121458 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 121462 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 121465 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 121470 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 121475 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 121480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX32rm_EVEX),
     /* 121483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121485 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 121489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121492 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 121497 */     GIR_RootConstrainSelectedInstOperands,
     /* 121498 */     // GIR_Coverage, 17688,
     /* 121498 */     GIR_EraseRootFromParent_Done,
     /* 121499 */   // Label 2636: @121499
     /* 121499 */   GIM_Try, /*On fail goto*//*Label 2637*/ GIMT_Encode4(121536), // Rule ID 727 //
     /* 121504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 121507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 121511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 121515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 121519 */     // MIs[1] Operand 1
     /* 121519 */     // No operand predicates
     /* 121519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121521 */     // (sra:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 121521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32ri),
     /* 121524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121526 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 121528 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 121531 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121534 */     GIR_RootConstrainSelectedInstOperands,
     /* 121535 */     // GIR_Coverage, 727,
     /* 121535 */     GIR_EraseRootFromParent_Done,
     /* 121536 */   // Label 2637: @121536
     /* 121536 */   GIM_Try, /*On fail goto*//*Label 2638*/ GIMT_Encode4(121573), // Rule ID 731 //
     /* 121541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 121544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 121548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 121552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 121556 */     // MIs[1] Operand 1
     /* 121556 */     // No operand predicates
     /* 121556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121558 */     // (sra:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 121558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32ri_ND),
     /* 121561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121563 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 121565 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 121568 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121571 */     GIR_RootConstrainSelectedInstOperands,
     /* 121572 */     // GIR_Coverage, 731,
     /* 121572 */     GIR_EraseRootFromParent_Done,
     /* 121573 */   // Label 2638: @121573
     /* 121573 */   GIM_Try, /*On fail goto*//*Label 2639*/ GIMT_Encode4(121652), // Rule ID 17652 //
     /* 121578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 121581 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 121585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 121589 */     // (sra:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SARX32rr:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 121589 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121592 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121596 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121601 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121603 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121606 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121610 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121615 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 121618 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 121622 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 121625 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 121630 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 121635 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 121640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX32rr),
     /* 121643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121645 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 121647 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121650 */     GIR_RootConstrainSelectedInstOperands,
     /* 121651 */     // GIR_Coverage, 17652,
     /* 121651 */     GIR_EraseRootFromParent_Done,
     /* 121652 */   // Label 2639: @121652
     /* 121652 */   GIM_Try, /*On fail goto*//*Label 2640*/ GIMT_Encode4(121731), // Rule ID 17684 //
     /* 121657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 121660 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 121664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 121668 */     // (sra:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SARX32rr_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 121668 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121671 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121675 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121682 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121685 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121689 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121694 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 121697 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 121701 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 121704 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 121709 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 121714 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 121719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX32rr_EVEX),
     /* 121722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121724 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 121726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121729 */     GIR_RootConstrainSelectedInstOperands,
     /* 121730 */     // GIR_Coverage, 17684,
     /* 121730 */     GIR_EraseRootFromParent_Done,
     /* 121731 */   // Label 2640: @121731
     /* 121731 */   GIM_Try, /*On fail goto*//*Label 2641*/ GIMT_Encode4(121773), // Rule ID 743 //
     /* 121736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 121739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 121743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 121747 */     // (sra:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SAR32rCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 121747 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121751 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121757 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 121761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32rCL),
     /* 121764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121766 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 121768 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121771 */     GIR_RootConstrainSelectedInstOperands,
     /* 121772 */     // GIR_Coverage, 743,
     /* 121772 */     GIR_EraseRootFromParent_Done,
     /* 121773 */   // Label 2641: @121773
     /* 121773 */   GIM_Try, /*On fail goto*//*Label 2642*/ GIMT_Encode4(121815), // Rule ID 747 //
     /* 121778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 121781 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 121785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 121789 */     // (sra:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SAR32rCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 121789 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121793 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121799 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 121803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32rCL_ND),
     /* 121806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121808 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 121810 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121813 */     GIR_RootConstrainSelectedInstOperands,
     /* 121814 */     // GIR_Coverage, 747,
     /* 121814 */     GIR_EraseRootFromParent_Done,
     /* 121815 */   // Label 2642: @121815
     /* 121815 */   GIM_Reject,
     /* 121816 */ // Label 2632: @121816
     /* 121816 */ GIM_Reject,
     /* 121817 */ // Label 2616: @121817
     /* 121817 */ GIM_Try, /*On fail goto*//*Label 2643*/ GIMT_Encode4(122509),
     /* 121822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 121825 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 121828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 121832 */   GIM_Try, /*On fail goto*//*Label 2644*/ GIMT_Encode4(121899), // Rule ID 740 //
     /* 121837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 121840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 121848 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121851 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 121855 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 121859 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 121863 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 121867 */     // MIs[2] Operand 1
     /* 121867 */     // No operand predicates
     /* 121867 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 121869 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 121876 */     // (sra:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2)  =>  (SAR64mi_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 121876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64mi_ND),
     /* 121879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121881 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 121885 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 121888 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121891 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 121897 */     GIR_RootConstrainSelectedInstOperands,
     /* 121898 */     // GIR_Coverage, 740,
     /* 121898 */     GIR_EraseRootFromParent_Done,
     /* 121899 */   // Label 2644: @121899
     /* 121899 */   GIM_Try, /*On fail goto*//*Label 2645*/ GIMT_Encode4(121972), // Rule ID 756 //
     /* 121904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 121907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 121915 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121918 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 121922 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 121926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 121930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121932 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 121939 */     // (sra:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] })  =>  (SAR64mCL_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 121939 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121943 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121949 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 121953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64mCL_ND),
     /* 121956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121958 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 121962 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121965 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 121970 */     GIR_RootConstrainSelectedInstOperands,
     /* 121971 */     // GIR_Coverage, 756,
     /* 121971 */     GIR_EraseRootFromParent_Done,
     /* 121972 */   // Label 2645: @121972
     /* 121972 */   GIM_Try, /*On fail goto*//*Label 2646*/ GIMT_Encode4(122082), // Rule ID 17657 //
     /* 121977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 121980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 121988 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121991 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 121995 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 121999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 122003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122005 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 122012 */     // (sra:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2)  =>  (SARX64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 122012 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 122015 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 122019 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122024 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122026 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 122029 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 122033 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122038 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 122041 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 122045 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 122048 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 122053 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 122058 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 122063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX64rm),
     /* 122066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122068 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 122072 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122075 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 122080 */     GIR_RootConstrainSelectedInstOperands,
     /* 122081 */     // GIR_Coverage, 17657,
     /* 122081 */     GIR_EraseRootFromParent_Done,
     /* 122082 */   // Label 2646: @122082
     /* 122082 */   GIM_Try, /*On fail goto*//*Label 2647*/ GIMT_Encode4(122192), // Rule ID 17689 //
     /* 122087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 122090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 122098 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122101 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 122105 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 122109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 122113 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122115 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 122122 */     // (sra:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2)  =>  (SARX64rm_EVEX:{ *:[i64] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 122122 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 122125 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 122129 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122134 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122136 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 122139 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 122143 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122148 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 122151 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 122155 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 122158 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 122163 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 122168 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 122173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX64rm_EVEX),
     /* 122176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122178 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 122182 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122185 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 122190 */     GIR_RootConstrainSelectedInstOperands,
     /* 122191 */     // GIR_Coverage, 17689,
     /* 122191 */     GIR_EraseRootFromParent_Done,
     /* 122192 */   // Label 2647: @122192
     /* 122192 */   GIM_Try, /*On fail goto*//*Label 2648*/ GIMT_Encode4(122229), // Rule ID 728 //
     /* 122197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 122200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 122208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122212 */     // MIs[1] Operand 1
     /* 122212 */     // No operand predicates
     /* 122212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122214 */     // (sra:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 122214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64ri),
     /* 122217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122219 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122221 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 122224 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122227 */     GIR_RootConstrainSelectedInstOperands,
     /* 122228 */     // GIR_Coverage, 728,
     /* 122228 */     GIR_EraseRootFromParent_Done,
     /* 122229 */   // Label 2648: @122229
     /* 122229 */   GIM_Try, /*On fail goto*//*Label 2649*/ GIMT_Encode4(122266), // Rule ID 732 //
     /* 122234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 122245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122249 */     // MIs[1] Operand 1
     /* 122249 */     // No operand predicates
     /* 122249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122251 */     // (sra:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR64ri_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 122251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64ri_ND),
     /* 122254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122256 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122258 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 122261 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122264 */     GIR_RootConstrainSelectedInstOperands,
     /* 122265 */     // GIR_Coverage, 732,
     /* 122265 */     GIR_EraseRootFromParent_Done,
     /* 122266 */   // Label 2649: @122266
     /* 122266 */   GIM_Try, /*On fail goto*//*Label 2650*/ GIMT_Encode4(122345), // Rule ID 17653 //
     /* 122271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 122274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 122282 */     // (sra:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SARX64rr:{ *:[i64] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 122282 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 122285 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 122289 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122294 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122296 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 122299 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 122303 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122308 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 122311 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 122315 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 122318 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 122323 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 122328 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 122333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX64rr),
     /* 122336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122338 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122340 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122343 */     GIR_RootConstrainSelectedInstOperands,
     /* 122344 */     // GIR_Coverage, 17653,
     /* 122344 */     GIR_EraseRootFromParent_Done,
     /* 122345 */   // Label 2650: @122345
     /* 122345 */   GIM_Try, /*On fail goto*//*Label 2651*/ GIMT_Encode4(122424), // Rule ID 17685 //
     /* 122350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 122353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 122361 */     // (sra:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SARX64rr_EVEX:{ *:[i64] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 122361 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 122364 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 122368 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122373 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122375 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 122378 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 122382 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122387 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 122390 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 122394 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 122397 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 122402 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 122407 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 122412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX64rr_EVEX),
     /* 122415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122417 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122419 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122422 */     GIR_RootConstrainSelectedInstOperands,
     /* 122423 */     // GIR_Coverage, 17685,
     /* 122423 */     GIR_EraseRootFromParent_Done,
     /* 122424 */   // Label 2651: @122424
     /* 122424 */   GIM_Try, /*On fail goto*//*Label 2652*/ GIMT_Encode4(122466), // Rule ID 744 //
     /* 122429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 122432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 122440 */     // (sra:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SAR64rCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 122440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122444 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122450 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 122454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64rCL),
     /* 122457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122459 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122461 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122464 */     GIR_RootConstrainSelectedInstOperands,
     /* 122465 */     // GIR_Coverage, 744,
     /* 122465 */     GIR_EraseRootFromParent_Done,
     /* 122466 */   // Label 2652: @122466
     /* 122466 */   GIM_Try, /*On fail goto*//*Label 2653*/ GIMT_Encode4(122508), // Rule ID 748 //
     /* 122471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 122482 */     // (sra:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SAR64rCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 122482 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122486 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122492 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 122496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64rCL_ND),
     /* 122499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122501 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122503 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122506 */     GIR_RootConstrainSelectedInstOperands,
     /* 122507 */     // GIR_Coverage, 748,
     /* 122507 */     GIR_EraseRootFromParent_Done,
     /* 122508 */   // Label 2653: @122508
     /* 122508 */   GIM_Reject,
     /* 122509 */ // Label 2643: @122509
     /* 122509 */ GIM_Reject,
     /* 122510 */ // Label 2617: @122510
     /* 122510 */ GIM_Reject,
     /* 122511 */ // Label 29: @122511
     /* 122511 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 2656*/ GIMT_Encode4(123238),
     /* 122522 */ /*GILLT_s32*//*Label 2654*/ GIMT_Encode4(122530),
     /* 122526 */ /*GILLT_s64*//*Label 2655*/ GIMT_Encode4(122884),
     /* 122530 */ // Label 2654: @122530
     /* 122530 */ GIM_Try, /*On fail goto*//*Label 2657*/ GIMT_Encode4(122883),
     /* 122535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 122538 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 122541 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /* 122544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122548 */   GIM_Try, /*On fail goto*//*Label 2658*/ GIMT_Encode4(122621), // Rule ID 840 //
     /* 122553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 122564 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122567 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 122571 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 122575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122579 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 122583 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122587 */     // MIs[2] Operand 1
     /* 122587 */     // No operand predicates
     /* 122587 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 122589 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 122596 */     // (fshl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)  =>  (SHLD32mri8_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 122596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32mri8_ND),
     /* 122599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122601 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 122605 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 122607 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src3
     /* 122610 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122613 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 122619 */     GIR_RootConstrainSelectedInstOperands,
     /* 122620 */     // GIR_Coverage, 840,
     /* 122620 */     GIR_EraseRootFromParent_Done,
     /* 122621 */   // Label 2658: @122621
     /* 122621 */   GIM_Try, /*On fail goto*//*Label 2659*/ GIMT_Encode4(122700), // Rule ID 843 //
     /* 122626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 122637 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122640 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 122644 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 122648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 122656 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122658 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 122665 */     // (fshl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src2, CL:{ *:[i8] })  =>  (SHLD32mrCL_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 122665 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122669 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122675 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 122679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32mrCL_ND),
     /* 122682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122684 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 122688 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 122690 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122693 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 122698 */     GIR_RootConstrainSelectedInstOperands,
     /* 122699 */     // GIR_Coverage, 843,
     /* 122699 */     GIR_EraseRootFromParent_Done,
     /* 122700 */   // Label 2659: @122700
     /* 122700 */   GIM_Try, /*On fail goto*//*Label 2660*/ GIMT_Encode4(122743), // Rule ID 822 //
     /* 122705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 122708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 122720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122724 */     // MIs[1] Operand 1
     /* 122724 */     // No operand predicates
     /* 122724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122726 */     // (fshl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)  =>  (SHLD32rri8:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 122726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32rri8),
     /* 122729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122731 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122733 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 122735 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 122738 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122741 */     GIR_RootConstrainSelectedInstOperands,
     /* 122742 */     // GIR_Coverage, 822,
     /* 122742 */     GIR_EraseRootFromParent_Done,
     /* 122743 */   // Label 2660: @122743
     /* 122743 */   GIM_Try, /*On fail goto*//*Label 2661*/ GIMT_Encode4(122786), // Rule ID 828 //
     /* 122748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122751 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 122763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122767 */     // MIs[1] Operand 1
     /* 122767 */     // No operand predicates
     /* 122767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122769 */     // (fshl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)  =>  (SHLD32rri8_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 122769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32rri8_ND),
     /* 122772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122774 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122776 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 122778 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 122781 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122784 */     GIR_RootConstrainSelectedInstOperands,
     /* 122785 */     // GIR_Coverage, 828,
     /* 122785 */     GIR_EraseRootFromParent_Done,
     /* 122786 */   // Label 2661: @122786
     /* 122786 */   GIM_Try, /*On fail goto*//*Label 2662*/ GIMT_Encode4(122834), // Rule ID 825 //
     /* 122791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 122794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 122806 */     // (fshl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, CL:{ *:[i8] })  =>  (SHLD32rrCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 122806 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122810 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122816 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 122820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32rrCL),
     /* 122823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122825 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122827 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 122829 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122832 */     GIR_RootConstrainSelectedInstOperands,
     /* 122833 */     // GIR_Coverage, 825,
     /* 122833 */     GIR_EraseRootFromParent_Done,
     /* 122834 */   // Label 2662: @122834
     /* 122834 */   GIM_Try, /*On fail goto*//*Label 2663*/ GIMT_Encode4(122882), // Rule ID 831 //
     /* 122839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 122854 */     // (fshl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, CL:{ *:[i8] })  =>  (SHLD32rrCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 122854 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122858 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122864 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 122868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32rrCL_ND),
     /* 122871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122873 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122875 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 122877 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122880 */     GIR_RootConstrainSelectedInstOperands,
     /* 122881 */     // GIR_Coverage, 831,
     /* 122881 */     GIR_EraseRootFromParent_Done,
     /* 122882 */   // Label 2663: @122882
     /* 122882 */   GIM_Reject,
     /* 122883 */ // Label 2657: @122883
     /* 122883 */ GIM_Reject,
     /* 122884 */ // Label 2655: @122884
     /* 122884 */ GIM_Try, /*On fail goto*//*Label 2664*/ GIMT_Encode4(123237),
     /* 122889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 122892 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 122895 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /* 122898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122902 */   GIM_Try, /*On fail goto*//*Label 2665*/ GIMT_Encode4(122975), // Rule ID 841 //
     /* 122907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 122918 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122921 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 122925 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 122929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122933 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 122937 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122941 */     // MIs[2] Operand 1
     /* 122941 */     // No operand predicates
     /* 122941 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 122943 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 122950 */     // (fshl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)  =>  (SHLD64mri8_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 122950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64mri8_ND),
     /* 122953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122955 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 122959 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 122961 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src3
     /* 122964 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122967 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 122973 */     GIR_RootConstrainSelectedInstOperands,
     /* 122974 */     // GIR_Coverage, 841,
     /* 122974 */     GIR_EraseRootFromParent_Done,
     /* 122975 */   // Label 2665: @122975
     /* 122975 */   GIM_Try, /*On fail goto*//*Label 2666*/ GIMT_Encode4(123054), // Rule ID 844 //
     /* 122980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 122991 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122994 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 122998 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 123002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 123010 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123012 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 123019 */     // (fshl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src2, CL:{ *:[i8] })  =>  (SHLD64mrCL_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 123019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123023 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123029 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 123033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64mrCL_ND),
     /* 123036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123038 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 123042 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 123044 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123047 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 123052 */     GIR_RootConstrainSelectedInstOperands,
     /* 123053 */     // GIR_Coverage, 844,
     /* 123053 */     GIR_EraseRootFromParent_Done,
     /* 123054 */   // Label 2666: @123054
     /* 123054 */   GIM_Try, /*On fail goto*//*Label 2667*/ GIMT_Encode4(123097), // Rule ID 823 //
     /* 123059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 123062 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 123074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123078 */     // MIs[1] Operand 1
     /* 123078 */     // No operand predicates
     /* 123078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123080 */     // (fshl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)  =>  (SHLD64rri8:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 123080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64rri8),
     /* 123083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123085 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 123087 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 123089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 123092 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123095 */     GIR_RootConstrainSelectedInstOperands,
     /* 123096 */     // GIR_Coverage, 823,
     /* 123096 */     GIR_EraseRootFromParent_Done,
     /* 123097 */   // Label 2667: @123097
     /* 123097 */   GIM_Try, /*On fail goto*//*Label 2668*/ GIMT_Encode4(123140), // Rule ID 829 //
     /* 123102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 123117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123121 */     // MIs[1] Operand 1
     /* 123121 */     // No operand predicates
     /* 123121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123123 */     // (fshl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)  =>  (SHLD64rri8_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 123123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64rri8_ND),
     /* 123126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123128 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 123130 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 123132 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 123135 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123138 */     GIR_RootConstrainSelectedInstOperands,
     /* 123139 */     // GIR_Coverage, 829,
     /* 123139 */     GIR_EraseRootFromParent_Done,
     /* 123140 */   // Label 2668: @123140
     /* 123140 */   GIM_Try, /*On fail goto*//*Label 2669*/ GIMT_Encode4(123188), // Rule ID 826 //
     /* 123145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 123148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 123160 */     // (fshl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, CL:{ *:[i8] })  =>  (SHLD64rrCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 123160 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123164 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123170 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 123174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64rrCL),
     /* 123177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123179 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 123181 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 123183 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123186 */     GIR_RootConstrainSelectedInstOperands,
     /* 123187 */     // GIR_Coverage, 826,
     /* 123187 */     GIR_EraseRootFromParent_Done,
     /* 123188 */   // Label 2669: @123188
     /* 123188 */   GIM_Try, /*On fail goto*//*Label 2670*/ GIMT_Encode4(123236), // Rule ID 832 //
     /* 123193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123196 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 123208 */     // (fshl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, CL:{ *:[i8] })  =>  (SHLD64rrCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 123208 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123212 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123218 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 123222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64rrCL_ND),
     /* 123225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123227 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 123229 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 123231 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123234 */     GIR_RootConstrainSelectedInstOperands,
     /* 123235 */     // GIR_Coverage, 832,
     /* 123235 */     GIR_EraseRootFromParent_Done,
     /* 123236 */   // Label 2670: @123236
     /* 123236 */   GIM_Reject,
     /* 123237 */ // Label 2664: @123237
     /* 123237 */ GIM_Reject,
     /* 123238 */ // Label 2656: @123238
     /* 123238 */ GIM_Reject,
     /* 123239 */ // Label 30: @123239
     /* 123239 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 2673*/ GIMT_Encode4(123926),
     /* 123250 */ /*GILLT_s32*//*Label 2671*/ GIMT_Encode4(123258),
     /* 123254 */ /*GILLT_s64*//*Label 2672*/ GIMT_Encode4(123592),
     /* 123258 */ // Label 2671: @123258
     /* 123258 */ GIM_Try, /*On fail goto*//*Label 2674*/ GIMT_Encode4(123591),
     /* 123263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 123266 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 123269 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /* 123272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 123276 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 123280 */   GIM_Try, /*On fail goto*//*Label 2675*/ GIMT_Encode4(123349), // Rule ID 864 //
     /* 123285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 123292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 123296 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123299 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 123303 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 123307 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 123311 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123315 */     // MIs[2] Operand 1
     /* 123315 */     // No operand predicates
     /* 123315 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 123317 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 123324 */     // (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src3)  =>  (SHRD32mri8_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 123324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32mri8_ND),
     /* 123327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123329 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 123333 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123335 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src3
     /* 123338 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123341 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 123347 */     GIR_RootConstrainSelectedInstOperands,
     /* 123348 */     // GIR_Coverage, 864,
     /* 123348 */     GIR_EraseRootFromParent_Done,
     /* 123349 */   // Label 2675: @123349
     /* 123349 */   GIM_Try, /*On fail goto*//*Label 2676*/ GIMT_Encode4(123424), // Rule ID 867 //
     /* 123354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 123361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 123365 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123368 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 123372 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 123376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 123380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123382 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 123389 */     // (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] })  =>  (SHRD32mrCL_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 123389 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123393 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123399 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 123403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32mrCL_ND),
     /* 123406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123408 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 123412 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123414 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123417 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 123422 */     GIR_RootConstrainSelectedInstOperands,
     /* 123423 */     // GIR_Coverage, 867,
     /* 123423 */     GIR_EraseRootFromParent_Done,
     /* 123424 */   // Label 2676: @123424
     /* 123424 */   GIM_Try, /*On fail goto*//*Label 2677*/ GIMT_Encode4(123463), // Rule ID 846 //
     /* 123429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 123432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 123436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 123440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123444 */     // MIs[1] Operand 1
     /* 123444 */     // No operand predicates
     /* 123444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123446 */     // (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src3)  =>  (SHRD32rri8:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 123446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32rri8),
     /* 123449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123451 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 123453 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123455 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 123458 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123461 */     GIR_RootConstrainSelectedInstOperands,
     /* 123462 */     // GIR_Coverage, 846,
     /* 123462 */     GIR_EraseRootFromParent_Done,
     /* 123463 */   // Label 2677: @123463
     /* 123463 */   GIM_Try, /*On fail goto*//*Label 2678*/ GIMT_Encode4(123502), // Rule ID 852 //
     /* 123468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 123475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 123479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123483 */     // MIs[1] Operand 1
     /* 123483 */     // No operand predicates
     /* 123483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123485 */     // (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src3)  =>  (SHRD32rri8_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 123485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32rri8_ND),
     /* 123488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123490 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 123492 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123494 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 123497 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123500 */     GIR_RootConstrainSelectedInstOperands,
     /* 123501 */     // GIR_Coverage, 852,
     /* 123501 */     GIR_EraseRootFromParent_Done,
     /* 123502 */   // Label 2678: @123502
     /* 123502 */   GIM_Try, /*On fail goto*//*Label 2679*/ GIMT_Encode4(123546), // Rule ID 849 //
     /* 123507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 123510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 123514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 123518 */     // (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SHRD32rrCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 123518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123522 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123528 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 123532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32rrCL),
     /* 123535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123537 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 123539 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123541 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123544 */     GIR_RootConstrainSelectedInstOperands,
     /* 123545 */     // GIR_Coverage, 849,
     /* 123545 */     GIR_EraseRootFromParent_Done,
     /* 123546 */   // Label 2679: @123546
     /* 123546 */   GIM_Try, /*On fail goto*//*Label 2680*/ GIMT_Encode4(123590), // Rule ID 855 //
     /* 123551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 123558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 123562 */     // (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SHRD32rrCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 123562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123566 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123572 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 123576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32rrCL_ND),
     /* 123579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123581 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 123583 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123585 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123588 */     GIR_RootConstrainSelectedInstOperands,
     /* 123589 */     // GIR_Coverage, 855,
     /* 123589 */     GIR_EraseRootFromParent_Done,
     /* 123590 */   // Label 2680: @123590
     /* 123590 */   GIM_Reject,
     /* 123591 */ // Label 2674: @123591
     /* 123591 */ GIM_Reject,
     /* 123592 */ // Label 2672: @123592
     /* 123592 */ GIM_Try, /*On fail goto*//*Label 2681*/ GIMT_Encode4(123925),
     /* 123597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 123600 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 123603 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /* 123606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123610 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123614 */   GIM_Try, /*On fail goto*//*Label 2682*/ GIMT_Encode4(123683), // Rule ID 865 //
     /* 123619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 123626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 123630 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123633 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 123637 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 123641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 123645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123649 */     // MIs[2] Operand 1
     /* 123649 */     // No operand predicates
     /* 123649 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 123651 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 123658 */     // (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src3)  =>  (SHRD64mri8_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 123658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64mri8_ND),
     /* 123661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123663 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 123667 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src3
     /* 123672 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123675 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 123681 */     GIR_RootConstrainSelectedInstOperands,
     /* 123682 */     // GIR_Coverage, 865,
     /* 123682 */     GIR_EraseRootFromParent_Done,
     /* 123683 */   // Label 2682: @123683
     /* 123683 */   GIM_Try, /*On fail goto*//*Label 2683*/ GIMT_Encode4(123758), // Rule ID 868 //
     /* 123688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 123695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 123699 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123702 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 123706 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 123710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 123714 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123716 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 123723 */     // (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] })  =>  (SHRD64mrCL_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 123723 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123727 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123733 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 123737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64mrCL_ND),
     /* 123740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123742 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 123746 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123748 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123751 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 123756 */     GIR_RootConstrainSelectedInstOperands,
     /* 123757 */     // GIR_Coverage, 868,
     /* 123757 */     GIR_EraseRootFromParent_Done,
     /* 123758 */   // Label 2683: @123758
     /* 123758 */   GIM_Try, /*On fail goto*//*Label 2684*/ GIMT_Encode4(123797), // Rule ID 847 //
     /* 123763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 123766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 123774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123778 */     // MIs[1] Operand 1
     /* 123778 */     // No operand predicates
     /* 123778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123780 */     // (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src3)  =>  (SHRD64rri8:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 123780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64rri8),
     /* 123783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123785 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 123787 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123789 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 123792 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123795 */     GIR_RootConstrainSelectedInstOperands,
     /* 123796 */     // GIR_Coverage, 847,
     /* 123796 */     GIR_EraseRootFromParent_Done,
     /* 123797 */   // Label 2684: @123797
     /* 123797 */   GIM_Try, /*On fail goto*//*Label 2685*/ GIMT_Encode4(123836), // Rule ID 853 //
     /* 123802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 123813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123817 */     // MIs[1] Operand 1
     /* 123817 */     // No operand predicates
     /* 123817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123819 */     // (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src3)  =>  (SHRD64rri8_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 123819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64rri8_ND),
     /* 123822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123824 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 123826 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123828 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 123831 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123834 */     GIR_RootConstrainSelectedInstOperands,
     /* 123835 */     // GIR_Coverage, 853,
     /* 123835 */     GIR_EraseRootFromParent_Done,
     /* 123836 */   // Label 2685: @123836
     /* 123836 */   GIM_Try, /*On fail goto*//*Label 2686*/ GIMT_Encode4(123880), // Rule ID 850 //
     /* 123841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 123844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 123852 */     // (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SHRD64rrCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 123852 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123856 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123862 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 123866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64rrCL),
     /* 123869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123871 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 123873 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123875 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123878 */     GIR_RootConstrainSelectedInstOperands,
     /* 123879 */     // GIR_Coverage, 850,
     /* 123879 */     GIR_EraseRootFromParent_Done,
     /* 123880 */   // Label 2686: @123880
     /* 123880 */   GIM_Try, /*On fail goto*//*Label 2687*/ GIMT_Encode4(123924), // Rule ID 856 //
     /* 123885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 123896 */     // (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SHRD64rrCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 123896 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123900 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123906 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 123910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64rrCL_ND),
     /* 123913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123915 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 123917 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123919 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123922 */     GIR_RootConstrainSelectedInstOperands,
     /* 123923 */     // GIR_Coverage, 856,
     /* 123923 */     GIR_EraseRootFromParent_Done,
     /* 123924 */   // Label 2687: @123924
     /* 123924 */   GIM_Reject,
     /* 123925 */ // Label 2681: @123925
     /* 123925 */ GIM_Reject,
     /* 123926 */ // Label 2673: @123926
     /* 123926 */ GIM_Reject,
     /* 123927 */ // Label 31: @123927
     /* 123927 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(20), /*)*//*default:*//*Label 2698*/ GIMT_Encode4(127424),
     /* 123938 */ /*GILLT_s8*//*Label 2688*/ GIMT_Encode4(124014),
     /* 123942 */ /*GILLT_s16*//*Label 2689*/ GIMT_Encode4(124444),
     /* 123946 */ /*GILLT_s32*//*Label 2690*/ GIMT_Encode4(124874),
     /* 123950 */ /*GILLT_s64*//*Label 2691*/ GIMT_Encode4(125537), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123966 */ /*GILLT_v2s64*//*Label 2692*/ GIMT_Encode4(126200), GIMT_Encode4(0),
     /* 123974 */ /*GILLT_v4s32*//*Label 2693*/ GIMT_Encode4(126467),
     /* 123978 */ /*GILLT_v4s64*//*Label 2694*/ GIMT_Encode4(126734), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123990 */ /*GILLT_v8s32*//*Label 2695*/ GIMT_Encode4(126985),
     /* 123994 */ /*GILLT_v8s64*//*Label 2696*/ GIMT_Encode4(127236), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 124010 */ /*GILLT_v16s32*//*Label 2697*/ GIMT_Encode4(127330),
     /* 124014 */ // Label 2688: @124014
     /* 124014 */ GIM_Try, /*On fail goto*//*Label 2699*/ GIMT_Encode4(124443),
     /* 124019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 124022 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 124025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 124029 */   GIM_Try, /*On fail goto*//*Label 2700*/ GIMT_Encode4(124088), // Rule ID 17624 //
     /* 124034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 124037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 124045 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124048 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 124052 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 124056 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 7,
     /* 124060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124062 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 124069 */     // (rotr:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, 7:{ *:[i8] })  =>  (ROL8m1_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 124069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8m1_ND),
     /* 124072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124074 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 124078 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124081 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 124086 */     GIR_RootConstrainSelectedInstOperands,
     /* 124087 */     // GIR_Coverage, 17624,
     /* 124087 */     GIR_EraseRootFromParent_Done,
     /* 124088 */   // Label 2700: @124088
     /* 124088 */   GIM_Try, /*On fail goto*//*Label 2701*/ GIMT_Encode4(124155), // Rule ID 801 //
     /* 124093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 124096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 124104 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124107 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 124111 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 124115 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 124119 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 124123 */     // MIs[2] Operand 1
     /* 124123 */     // No operand predicates
     /* 124123 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 124125 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 124132 */     // (rotr:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2)  =>  (ROR8mi_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 124132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8mi_ND),
     /* 124135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124137 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 124141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 124144 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124147 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 124153 */     GIR_RootConstrainSelectedInstOperands,
     /* 124154 */     // GIR_Coverage, 801,
     /* 124154 */     GIR_EraseRootFromParent_Done,
     /* 124155 */   // Label 2701: @124155
     /* 124155 */   GIM_Try, /*On fail goto*//*Label 2702*/ GIMT_Encode4(124228), // Rule ID 817 //
     /* 124160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 124163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 124171 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124174 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 124178 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 124182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 124186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124188 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 124195 */     // (rotr:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] })  =>  (ROR8mCL_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 124195 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124199 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124205 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 124209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8mCL_ND),
     /* 124212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124214 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 124218 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124221 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 124226 */     GIR_RootConstrainSelectedInstOperands,
     /* 124227 */     // GIR_Coverage, 817,
     /* 124227 */     GIR_EraseRootFromParent_Done,
     /* 124228 */   // Label 2702: @124228
     /* 124228 */   GIM_Try, /*On fail goto*//*Label 2703*/ GIMT_Encode4(124256), // Rule ID 17600 //
     /* 124233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 124236 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 124240 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 7,
     /* 124244 */     // (rotr:{ *:[i8] } GR8:{ *:[i8] }:$src1, 7:{ *:[i8] })  =>  (ROL8r1:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 124244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8r1),
     /* 124247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124249 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124251 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124254 */     GIR_RootConstrainSelectedInstOperands,
     /* 124255 */     // GIR_Coverage, 17600,
     /* 124255 */     GIR_EraseRootFromParent_Done,
     /* 124256 */   // Label 2703: @124256
     /* 124256 */   GIM_Try, /*On fail goto*//*Label 2704*/ GIMT_Encode4(124284), // Rule ID 17608 //
     /* 124261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 124264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 124268 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 7,
     /* 124272 */     // (rotr:{ *:[i8] } GR8:{ *:[i8] }:$src1, 7:{ *:[i8] })  =>  (ROL8r1_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 124272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8r1_ND),
     /* 124275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124277 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124279 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124282 */     GIR_RootConstrainSelectedInstOperands,
     /* 124283 */     // GIR_Coverage, 17608,
     /* 124283 */     GIR_EraseRootFromParent_Done,
     /* 124284 */   // Label 2704: @124284
     /* 124284 */   GIM_Try, /*On fail goto*//*Label 2705*/ GIMT_Encode4(124321), // Rule ID 789 //
     /* 124289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 124292 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 124296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 124304 */     // MIs[1] Operand 1
     /* 124304 */     // No operand predicates
     /* 124304 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124306 */     // (rotr:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 124306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8ri),
     /* 124309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124311 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124313 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 124316 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124319 */     GIR_RootConstrainSelectedInstOperands,
     /* 124320 */     // GIR_Coverage, 789,
     /* 124320 */     GIR_EraseRootFromParent_Done,
     /* 124321 */   // Label 2705: @124321
     /* 124321 */   GIM_Try, /*On fail goto*//*Label 2706*/ GIMT_Encode4(124358), // Rule ID 793 //
     /* 124326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 124329 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 124333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 124341 */     // MIs[1] Operand 1
     /* 124341 */     // No operand predicates
     /* 124341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124343 */     // (rotr:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 124343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8ri_ND),
     /* 124346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124348 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124350 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 124353 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124356 */     GIR_RootConstrainSelectedInstOperands,
     /* 124357 */     // GIR_Coverage, 793,
     /* 124357 */     GIR_EraseRootFromParent_Done,
     /* 124358 */   // Label 2706: @124358
     /* 124358 */   GIM_Try, /*On fail goto*//*Label 2707*/ GIMT_Encode4(124400), // Rule ID 805 //
     /* 124363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 124366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 124370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 124374 */     // (rotr:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (ROR8rCL:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 124374 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124378 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124384 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 124388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8rCL),
     /* 124391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124393 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124395 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124398 */     GIR_RootConstrainSelectedInstOperands,
     /* 124399 */     // GIR_Coverage, 805,
     /* 124399 */     GIR_EraseRootFromParent_Done,
     /* 124400 */   // Label 2707: @124400
     /* 124400 */   GIM_Try, /*On fail goto*//*Label 2708*/ GIMT_Encode4(124442), // Rule ID 809 //
     /* 124405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 124408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 124412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 124416 */     // (rotr:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (ROR8rCL_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 124416 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124420 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124426 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 124430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8rCL_ND),
     /* 124433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124435 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124437 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124440 */     GIR_RootConstrainSelectedInstOperands,
     /* 124441 */     // GIR_Coverage, 809,
     /* 124441 */     GIR_EraseRootFromParent_Done,
     /* 124442 */   // Label 2708: @124442
     /* 124442 */   GIM_Reject,
     /* 124443 */ // Label 2699: @124443
     /* 124443 */ GIM_Reject,
     /* 124444 */ // Label 2689: @124444
     /* 124444 */ GIM_Try, /*On fail goto*//*Label 2709*/ GIMT_Encode4(124873),
     /* 124449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 124452 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 124455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 124459 */   GIM_Try, /*On fail goto*//*Label 2710*/ GIMT_Encode4(124518), // Rule ID 17625 //
     /* 124464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 124467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 124475 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124478 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 124482 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 124486 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 15,
     /* 124490 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124492 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 124499 */     // (rotr:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 15:{ *:[i8] })  =>  (ROL16m1_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 124499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16m1_ND),
     /* 124502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124504 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 124508 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124511 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 124516 */     GIR_RootConstrainSelectedInstOperands,
     /* 124517 */     // GIR_Coverage, 17625,
     /* 124517 */     GIR_EraseRootFromParent_Done,
     /* 124518 */   // Label 2710: @124518
     /* 124518 */   GIM_Try, /*On fail goto*//*Label 2711*/ GIMT_Encode4(124585), // Rule ID 802 //
     /* 124523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 124526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 124534 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124537 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 124541 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 124545 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 124549 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 124553 */     // MIs[2] Operand 1
     /* 124553 */     // No operand predicates
     /* 124553 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 124555 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 124562 */     // (rotr:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2)  =>  (ROR16mi_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 124562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16mi_ND),
     /* 124565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124567 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 124571 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 124574 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124577 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 124583 */     GIR_RootConstrainSelectedInstOperands,
     /* 124584 */     // GIR_Coverage, 802,
     /* 124584 */     GIR_EraseRootFromParent_Done,
     /* 124585 */   // Label 2711: @124585
     /* 124585 */   GIM_Try, /*On fail goto*//*Label 2712*/ GIMT_Encode4(124658), // Rule ID 818 //
     /* 124590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 124593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 124601 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124604 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 124608 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 124612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 124616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124618 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 124625 */     // (rotr:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] })  =>  (ROR16mCL_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 124625 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124629 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124635 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 124639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16mCL_ND),
     /* 124642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124644 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 124648 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 124656 */     GIR_RootConstrainSelectedInstOperands,
     /* 124657 */     // GIR_Coverage, 818,
     /* 124657 */     GIR_EraseRootFromParent_Done,
     /* 124658 */   // Label 2712: @124658
     /* 124658 */   GIM_Try, /*On fail goto*//*Label 2713*/ GIMT_Encode4(124686), // Rule ID 17601 //
     /* 124663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 124666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 124670 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 15,
     /* 124674 */     // (rotr:{ *:[i16] } GR16:{ *:[i16] }:$src1, 15:{ *:[i8] })  =>  (ROL16r1:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 124674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16r1),
     /* 124677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124679 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124681 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124684 */     GIR_RootConstrainSelectedInstOperands,
     /* 124685 */     // GIR_Coverage, 17601,
     /* 124685 */     GIR_EraseRootFromParent_Done,
     /* 124686 */   // Label 2713: @124686
     /* 124686 */   GIM_Try, /*On fail goto*//*Label 2714*/ GIMT_Encode4(124714), // Rule ID 17609 //
     /* 124691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 124694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 124698 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 15,
     /* 124702 */     // (rotr:{ *:[i16] } GR16:{ *:[i16] }:$src1, 15:{ *:[i8] })  =>  (ROL16r1_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 124702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16r1_ND),
     /* 124705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124707 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124709 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124712 */     GIR_RootConstrainSelectedInstOperands,
     /* 124713 */     // GIR_Coverage, 17609,
     /* 124713 */     GIR_EraseRootFromParent_Done,
     /* 124714 */   // Label 2714: @124714
     /* 124714 */   GIM_Try, /*On fail goto*//*Label 2715*/ GIMT_Encode4(124751), // Rule ID 790 //
     /* 124719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 124722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 124726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 124734 */     // MIs[1] Operand 1
     /* 124734 */     // No operand predicates
     /* 124734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124736 */     // (rotr:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 124736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16ri),
     /* 124739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124741 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124743 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 124746 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124749 */     GIR_RootConstrainSelectedInstOperands,
     /* 124750 */     // GIR_Coverage, 790,
     /* 124750 */     GIR_EraseRootFromParent_Done,
     /* 124751 */   // Label 2715: @124751
     /* 124751 */   GIM_Try, /*On fail goto*//*Label 2716*/ GIMT_Encode4(124788), // Rule ID 794 //
     /* 124756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 124759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 124763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 124771 */     // MIs[1] Operand 1
     /* 124771 */     // No operand predicates
     /* 124771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124773 */     // (rotr:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 124773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16ri_ND),
     /* 124776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124778 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124780 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 124783 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124786 */     GIR_RootConstrainSelectedInstOperands,
     /* 124787 */     // GIR_Coverage, 794,
     /* 124787 */     GIR_EraseRootFromParent_Done,
     /* 124788 */   // Label 2716: @124788
     /* 124788 */   GIM_Try, /*On fail goto*//*Label 2717*/ GIMT_Encode4(124830), // Rule ID 806 //
     /* 124793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 124796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 124800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 124804 */     // (rotr:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (ROR16rCL:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 124804 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124808 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124814 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 124818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16rCL),
     /* 124821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124823 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124825 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124828 */     GIR_RootConstrainSelectedInstOperands,
     /* 124829 */     // GIR_Coverage, 806,
     /* 124829 */     GIR_EraseRootFromParent_Done,
     /* 124830 */   // Label 2717: @124830
     /* 124830 */   GIM_Try, /*On fail goto*//*Label 2718*/ GIMT_Encode4(124872), // Rule ID 810 //
     /* 124835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 124838 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 124842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 124846 */     // (rotr:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (ROR16rCL_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 124846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124850 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124856 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 124860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16rCL_ND),
     /* 124863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124865 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124867 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124870 */     GIR_RootConstrainSelectedInstOperands,
     /* 124871 */     // GIR_Coverage, 810,
     /* 124871 */     GIR_EraseRootFromParent_Done,
     /* 124872 */   // Label 2718: @124872
     /* 124872 */   GIM_Reject,
     /* 124873 */ // Label 2709: @124873
     /* 124873 */ GIM_Reject,
     /* 124874 */ // Label 2690: @124874
     /* 124874 */ GIM_Try, /*On fail goto*//*Label 2719*/ GIMT_Encode4(125536),
     /* 124879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 124882 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 124885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 124889 */   GIM_Try, /*On fail goto*//*Label 2720*/ GIMT_Encode4(124948), // Rule ID 17626 //
     /* 124894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 124897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 124905 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124908 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 124912 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 124916 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 31,
     /* 124920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124922 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 124929 */     // (rotr:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 31:{ *:[i8] })  =>  (ROL32m1_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 124929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32m1_ND),
     /* 124932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124934 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 124938 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124941 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 124946 */     GIR_RootConstrainSelectedInstOperands,
     /* 124947 */     // GIR_Coverage, 17626,
     /* 124947 */     GIR_EraseRootFromParent_Done,
     /* 124948 */   // Label 2720: @124948
     /* 124948 */   GIM_Try, /*On fail goto*//*Label 2721*/ GIMT_Encode4(125015), // Rule ID 803 //
     /* 124953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 124956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 124964 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124967 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 124971 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 124975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 124979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 124983 */     // MIs[2] Operand 1
     /* 124983 */     // No operand predicates
     /* 124983 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 124985 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 124992 */     // (rotr:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2)  =>  (ROR32mi_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 124992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32mi_ND),
     /* 124995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124997 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 125001 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 125004 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125007 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 125013 */     GIR_RootConstrainSelectedInstOperands,
     /* 125014 */     // GIR_Coverage, 803,
     /* 125014 */     GIR_EraseRootFromParent_Done,
     /* 125015 */   // Label 2721: @125015
     /* 125015 */   GIM_Try, /*On fail goto*//*Label 2722*/ GIMT_Encode4(125079), // Rule ID 17648 //
     /* 125020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 125023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 125031 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125034 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 125038 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 125042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 125046 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125050 */     // MIs[2] Operand 1
     /* 125050 */     // No operand predicates
     /* 125050 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 125052 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 125059 */     // (rotr:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$shamt)  =>  (RORX32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 125059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX32mi),
     /* 125062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125064 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 125068 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 125071 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 125077 */     GIR_RootConstrainSelectedInstOperands,
     /* 125078 */     // GIR_Coverage, 17648,
     /* 125078 */     GIR_EraseRootFromParent_Done,
     /* 125079 */   // Label 2722: @125079
     /* 125079 */   GIM_Try, /*On fail goto*//*Label 2723*/ GIMT_Encode4(125143), // Rule ID 17680 //
     /* 125084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 125087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 125095 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125098 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 125102 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 125106 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 125110 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125114 */     // MIs[2] Operand 1
     /* 125114 */     // No operand predicates
     /* 125114 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 125116 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 125123 */     // (rotr:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$shamt)  =>  (RORX32mi_EVEX:{ *:[i32] } addr:{ *:[iPTR] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 125123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX32mi_EVEX),
     /* 125126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125128 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 125132 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 125135 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 125141 */     GIR_RootConstrainSelectedInstOperands,
     /* 125142 */     // GIR_Coverage, 17680,
     /* 125142 */     GIR_EraseRootFromParent_Done,
     /* 125143 */   // Label 2723: @125143
     /* 125143 */   GIM_Try, /*On fail goto*//*Label 2724*/ GIMT_Encode4(125216), // Rule ID 819 //
     /* 125148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 125151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 125159 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125162 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 125166 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 125170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 125174 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125176 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 125183 */     // (rotr:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] })  =>  (ROR32mCL_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 125183 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125187 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125193 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 125197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32mCL_ND),
     /* 125200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125202 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 125206 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125209 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 125214 */     GIR_RootConstrainSelectedInstOperands,
     /* 125215 */     // GIR_Coverage, 819,
     /* 125215 */     GIR_EraseRootFromParent_Done,
     /* 125216 */   // Label 2724: @125216
     /* 125216 */   GIM_Try, /*On fail goto*//*Label 2725*/ GIMT_Encode4(125250), // Rule ID 17644 //
     /* 125221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 125224 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 125228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125236 */     // MIs[1] Operand 1
     /* 125236 */     // No operand predicates
     /* 125236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125238 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src, (imm:{ *:[i8] }):$shamt)  =>  (RORX32ri:{ *:[i32] } GR32:{ *:[i32] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 125238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX32ri),
     /* 125241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125243 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 125245 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 125248 */     GIR_RootConstrainSelectedInstOperands,
     /* 125249 */     // GIR_Coverage, 17644,
     /* 125249 */     GIR_EraseRootFromParent_Done,
     /* 125250 */   // Label 2725: @125250
     /* 125250 */   GIM_Try, /*On fail goto*//*Label 2726*/ GIMT_Encode4(125284), // Rule ID 17676 //
     /* 125255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 125258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 125262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125270 */     // MIs[1] Operand 1
     /* 125270 */     // No operand predicates
     /* 125270 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125272 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src, (imm:{ *:[i8] }):$shamt)  =>  (RORX32ri_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 125272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX32ri_EVEX),
     /* 125275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125277 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 125279 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 125282 */     GIR_RootConstrainSelectedInstOperands,
     /* 125283 */     // GIR_Coverage, 17676,
     /* 125283 */     GIR_EraseRootFromParent_Done,
     /* 125284 */   // Label 2726: @125284
     /* 125284 */   GIM_Try, /*On fail goto*//*Label 2727*/ GIMT_Encode4(125321), // Rule ID 871 //
     /* 125289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFastSHLDRotate),
     /* 125292 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 125296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125304 */     // MIs[1] Operand 1
     /* 125304 */     // No operand predicates
     /* 125304 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125306 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$shamt)  =>  (SHRDROT32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$shamt)
     /* 125306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRDROT32ri),
     /* 125309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125311 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125313 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 125316 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125319 */     GIR_RootConstrainSelectedInstOperands,
     /* 125320 */     // GIR_Coverage, 871,
     /* 125320 */     GIR_EraseRootFromParent_Done,
     /* 125321 */   // Label 2727: @125321
     /* 125321 */   GIM_Try, /*On fail goto*//*Label 2728*/ GIMT_Encode4(125349), // Rule ID 17602 //
     /* 125326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 125329 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 125333 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 31,
     /* 125337 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, 31:{ *:[i8] })  =>  (ROL32r1:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 125337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32r1),
     /* 125340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125342 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125344 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125347 */     GIR_RootConstrainSelectedInstOperands,
     /* 125348 */     // GIR_Coverage, 17602,
     /* 125348 */     GIR_EraseRootFromParent_Done,
     /* 125349 */   // Label 2728: @125349
     /* 125349 */   GIM_Try, /*On fail goto*//*Label 2729*/ GIMT_Encode4(125377), // Rule ID 17610 //
     /* 125354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 125357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 125361 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 31,
     /* 125365 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, 31:{ *:[i8] })  =>  (ROL32r1_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 125365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32r1_ND),
     /* 125368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125370 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125372 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125375 */     GIR_RootConstrainSelectedInstOperands,
     /* 125376 */     // GIR_Coverage, 17610,
     /* 125376 */     GIR_EraseRootFromParent_Done,
     /* 125377 */   // Label 2729: @125377
     /* 125377 */   GIM_Try, /*On fail goto*//*Label 2730*/ GIMT_Encode4(125414), // Rule ID 791 //
     /* 125382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 125385 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 125389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125397 */     // MIs[1] Operand 1
     /* 125397 */     // No operand predicates
     /* 125397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125399 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 125399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32ri),
     /* 125402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125404 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125406 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 125409 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125412 */     GIR_RootConstrainSelectedInstOperands,
     /* 125413 */     // GIR_Coverage, 791,
     /* 125413 */     GIR_EraseRootFromParent_Done,
     /* 125414 */   // Label 2730: @125414
     /* 125414 */   GIM_Try, /*On fail goto*//*Label 2731*/ GIMT_Encode4(125451), // Rule ID 795 //
     /* 125419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 125422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 125426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125434 */     // MIs[1] Operand 1
     /* 125434 */     // No operand predicates
     /* 125434 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125436 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 125436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32ri_ND),
     /* 125439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125441 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125443 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 125446 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125449 */     GIR_RootConstrainSelectedInstOperands,
     /* 125450 */     // GIR_Coverage, 795,
     /* 125450 */     GIR_EraseRootFromParent_Done,
     /* 125451 */   // Label 2731: @125451
     /* 125451 */   GIM_Try, /*On fail goto*//*Label 2732*/ GIMT_Encode4(125493), // Rule ID 807 //
     /* 125456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 125459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 125463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 125467 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (ROR32rCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 125467 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125471 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125477 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 125481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32rCL),
     /* 125484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125486 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125488 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125491 */     GIR_RootConstrainSelectedInstOperands,
     /* 125492 */     // GIR_Coverage, 807,
     /* 125492 */     GIR_EraseRootFromParent_Done,
     /* 125493 */   // Label 2732: @125493
     /* 125493 */   GIM_Try, /*On fail goto*//*Label 2733*/ GIMT_Encode4(125535), // Rule ID 811 //
     /* 125498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 125501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 125505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 125509 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (ROR32rCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 125509 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125513 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125519 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 125523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32rCL_ND),
     /* 125526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125528 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125530 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125533 */     GIR_RootConstrainSelectedInstOperands,
     /* 125534 */     // GIR_Coverage, 811,
     /* 125534 */     GIR_EraseRootFromParent_Done,
     /* 125535 */   // Label 2733: @125535
     /* 125535 */   GIM_Reject,
     /* 125536 */ // Label 2719: @125536
     /* 125536 */ GIM_Reject,
     /* 125537 */ // Label 2691: @125537
     /* 125537 */ GIM_Try, /*On fail goto*//*Label 2734*/ GIMT_Encode4(126199),
     /* 125542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 125545 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 125548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 125552 */   GIM_Try, /*On fail goto*//*Label 2735*/ GIMT_Encode4(125611), // Rule ID 17627 //
     /* 125557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 125560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 125568 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125571 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 125575 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 125579 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 63,
     /* 125583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125585 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 125592 */     // (rotr:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 63:{ *:[i8] })  =>  (ROL64m1_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 125592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64m1_ND),
     /* 125595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125597 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 125601 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125604 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 125609 */     GIR_RootConstrainSelectedInstOperands,
     /* 125610 */     // GIR_Coverage, 17627,
     /* 125610 */     GIR_EraseRootFromParent_Done,
     /* 125611 */   // Label 2735: @125611
     /* 125611 */   GIM_Try, /*On fail goto*//*Label 2736*/ GIMT_Encode4(125678), // Rule ID 804 //
     /* 125616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 125619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 125627 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125630 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 125634 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 125638 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 125642 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125646 */     // MIs[2] Operand 1
     /* 125646 */     // No operand predicates
     /* 125646 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 125648 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 125655 */     // (rotr:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2)  =>  (ROR64mi_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 125655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64mi_ND),
     /* 125658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125660 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 125664 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 125667 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125670 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 125676 */     GIR_RootConstrainSelectedInstOperands,
     /* 125677 */     // GIR_Coverage, 804,
     /* 125677 */     GIR_EraseRootFromParent_Done,
     /* 125678 */   // Label 2736: @125678
     /* 125678 */   GIM_Try, /*On fail goto*//*Label 2737*/ GIMT_Encode4(125742), // Rule ID 17649 //
     /* 125683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 125686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 125694 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125697 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 125701 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 125705 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 125709 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125713 */     // MIs[2] Operand 1
     /* 125713 */     // No operand predicates
     /* 125713 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 125715 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 125722 */     // (rotr:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$shamt)  =>  (RORX64mi:{ *:[i64] } addr:{ *:[iPTR] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 125722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX64mi),
     /* 125725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125727 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 125731 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 125734 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 125740 */     GIR_RootConstrainSelectedInstOperands,
     /* 125741 */     // GIR_Coverage, 17649,
     /* 125741 */     GIR_EraseRootFromParent_Done,
     /* 125742 */   // Label 2737: @125742
     /* 125742 */   GIM_Try, /*On fail goto*//*Label 2738*/ GIMT_Encode4(125806), // Rule ID 17681 //
     /* 125747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 125750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 125758 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125761 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 125765 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 125769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 125773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125777 */     // MIs[2] Operand 1
     /* 125777 */     // No operand predicates
     /* 125777 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 125779 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 125786 */     // (rotr:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$shamt)  =>  (RORX64mi_EVEX:{ *:[i64] } addr:{ *:[iPTR] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 125786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX64mi_EVEX),
     /* 125789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125791 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 125795 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 125798 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 125804 */     GIR_RootConstrainSelectedInstOperands,
     /* 125805 */     // GIR_Coverage, 17681,
     /* 125805 */     GIR_EraseRootFromParent_Done,
     /* 125806 */   // Label 2738: @125806
     /* 125806 */   GIM_Try, /*On fail goto*//*Label 2739*/ GIMT_Encode4(125879), // Rule ID 820 //
     /* 125811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 125814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 125822 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125825 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 125829 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 125833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 125837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125839 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 125846 */     // (rotr:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] })  =>  (ROR64mCL_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 125846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125850 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125856 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 125860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64mCL_ND),
     /* 125863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125865 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 125869 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125872 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 125877 */     GIR_RootConstrainSelectedInstOperands,
     /* 125878 */     // GIR_Coverage, 820,
     /* 125878 */     GIR_EraseRootFromParent_Done,
     /* 125879 */   // Label 2739: @125879
     /* 125879 */   GIM_Try, /*On fail goto*//*Label 2740*/ GIMT_Encode4(125913), // Rule ID 17645 //
     /* 125884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 125887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 125891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125899 */     // MIs[1] Operand 1
     /* 125899 */     // No operand predicates
     /* 125899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125901 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src, (imm:{ *:[i8] }):$shamt)  =>  (RORX64ri:{ *:[i64] } GR64:{ *:[i64] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 125901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX64ri),
     /* 125904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125906 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 125908 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 125911 */     GIR_RootConstrainSelectedInstOperands,
     /* 125912 */     // GIR_Coverage, 17645,
     /* 125912 */     GIR_EraseRootFromParent_Done,
     /* 125913 */   // Label 2740: @125913
     /* 125913 */   GIM_Try, /*On fail goto*//*Label 2741*/ GIMT_Encode4(125947), // Rule ID 17677 //
     /* 125918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 125921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 125925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125933 */     // MIs[1] Operand 1
     /* 125933 */     // No operand predicates
     /* 125933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125935 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src, (imm:{ *:[i8] }):$shamt)  =>  (RORX64ri_EVEX:{ *:[i64] } GR64:{ *:[i64] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 125935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX64ri_EVEX),
     /* 125938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125940 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 125942 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 125945 */     GIR_RootConstrainSelectedInstOperands,
     /* 125946 */     // GIR_Coverage, 17677,
     /* 125946 */     GIR_EraseRootFromParent_Done,
     /* 125947 */   // Label 2741: @125947
     /* 125947 */   GIM_Try, /*On fail goto*//*Label 2742*/ GIMT_Encode4(125984), // Rule ID 872 //
     /* 125952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFastSHLDRotate),
     /* 125955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 125959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125967 */     // MIs[1] Operand 1
     /* 125967 */     // No operand predicates
     /* 125967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125969 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$shamt)  =>  (SHRDROT64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$shamt)
     /* 125969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRDROT64ri),
     /* 125972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125974 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125976 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 125979 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125982 */     GIR_RootConstrainSelectedInstOperands,
     /* 125983 */     // GIR_Coverage, 872,
     /* 125983 */     GIR_EraseRootFromParent_Done,
     /* 125984 */   // Label 2742: @125984
     /* 125984 */   GIM_Try, /*On fail goto*//*Label 2743*/ GIMT_Encode4(126012), // Rule ID 17603 //
     /* 125989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 125992 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 125996 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 63,
     /* 126000 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, 63:{ *:[i8] })  =>  (ROL64r1:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 126000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64r1),
     /* 126003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126005 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126007 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 126010 */     GIR_RootConstrainSelectedInstOperands,
     /* 126011 */     // GIR_Coverage, 17603,
     /* 126011 */     GIR_EraseRootFromParent_Done,
     /* 126012 */   // Label 2743: @126012
     /* 126012 */   GIM_Try, /*On fail goto*//*Label 2744*/ GIMT_Encode4(126040), // Rule ID 17611 //
     /* 126017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 126020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 126024 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 63,
     /* 126028 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, 63:{ *:[i8] })  =>  (ROL64r1_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 126028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64r1_ND),
     /* 126031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126033 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126035 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 126038 */     GIR_RootConstrainSelectedInstOperands,
     /* 126039 */     // GIR_Coverage, 17611,
     /* 126039 */     GIR_EraseRootFromParent_Done,
     /* 126040 */   // Label 2744: @126040
     /* 126040 */   GIM_Try, /*On fail goto*//*Label 2745*/ GIMT_Encode4(126077), // Rule ID 792 //
     /* 126045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 126048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 126052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 126056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126060 */     // MIs[1] Operand 1
     /* 126060 */     // No operand predicates
     /* 126060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126062 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 126062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64ri),
     /* 126065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126067 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 126072 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 126075 */     GIR_RootConstrainSelectedInstOperands,
     /* 126076 */     // GIR_Coverage, 792,
     /* 126076 */     GIR_EraseRootFromParent_Done,
     /* 126077 */   // Label 2745: @126077
     /* 126077 */   GIM_Try, /*On fail goto*//*Label 2746*/ GIMT_Encode4(126114), // Rule ID 796 //
     /* 126082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 126085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 126089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 126093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126097 */     // MIs[1] Operand 1
     /* 126097 */     // No operand predicates
     /* 126097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126099 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR64ri_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 126099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64ri_ND),
     /* 126102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126104 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126106 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 126109 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 126112 */     GIR_RootConstrainSelectedInstOperands,
     /* 126113 */     // GIR_Coverage, 796,
     /* 126113 */     GIR_EraseRootFromParent_Done,
     /* 126114 */   // Label 2746: @126114
     /* 126114 */   GIM_Try, /*On fail goto*//*Label 2747*/ GIMT_Encode4(126156), // Rule ID 808 //
     /* 126119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 126122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 126126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 126130 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (ROR64rCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 126130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126134 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126140 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 126144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64rCL),
     /* 126147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126149 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126151 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 126154 */     GIR_RootConstrainSelectedInstOperands,
     /* 126155 */     // GIR_Coverage, 808,
     /* 126155 */     GIR_EraseRootFromParent_Done,
     /* 126156 */   // Label 2747: @126156
     /* 126156 */   GIM_Try, /*On fail goto*//*Label 2748*/ GIMT_Encode4(126198), // Rule ID 812 //
     /* 126161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 126164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 126168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 126172 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (ROR64rCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 126172 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126176 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126182 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 126186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64rCL_ND),
     /* 126189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126191 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126193 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 126196 */     GIR_RootConstrainSelectedInstOperands,
     /* 126197 */     // GIR_Coverage, 812,
     /* 126197 */     GIR_EraseRootFromParent_Done,
     /* 126198 */   // Label 2748: @126198
     /* 126198 */   GIM_Reject,
     /* 126199 */ // Label 2734: @126199
     /* 126199 */ GIM_Reject,
     /* 126200 */ // Label 2692: @126200
     /* 126200 */ GIM_Try, /*On fail goto*//*Label 2749*/ GIMT_Encode4(126466),
     /* 126205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 126208 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 126211 */   GIM_Try, /*On fail goto*//*Label 2750*/ GIMT_Encode4(126273), // Rule ID 8005 //
     /* 126216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 126219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 126231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 126235 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126238 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 126242 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 126246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126248 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 126255 */     // (rotr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPRORVQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 126255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPRORVQZ128rm),
     /* 126258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126260 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126262 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 126266 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 126271 */     GIR_RootConstrainSelectedInstOperands,
     /* 126272 */     // GIR_Coverage, 8005,
     /* 126272 */     GIR_EraseRootFromParent_Done,
     /* 126273 */   // Label 2750: @126273
     /* 126273 */   GIM_Try, /*On fail goto*//*Label 2751*/ GIMT_Encode4(126300), // Rule ID 8002 //
     /* 126278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 126281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126293 */     // (rotr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPRORVQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 126293 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPRORVQZ128rr),
     /* 126298 */     GIR_RootConstrainSelectedInstOperands,
     /* 126299 */     // GIR_Coverage, 8002,
     /* 126299 */     GIR_Done,
     /* 126300 */   // Label 2751: @126300
     /* 126300 */   GIM_Try, /*On fail goto*//*Label 2752*/ GIMT_Encode4(126465), // Rule ID 20804 //
     /* 126305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 126308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 126312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126320 */     // (rotr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPRORVQZrr:{ *:[v8i64] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 126320 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 126323 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126327 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126332 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 126334 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 126337 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 126341 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126346 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 126349 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 126353 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 126356 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 126361 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126366 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 126371 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 126374 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126378 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126383 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 126385 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 126388 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 126392 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126397 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 126400 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 126404 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 126407 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 126412 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126417 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 126422 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 126425 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPRORVQZrr),
     /* 126429 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126434 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 126437 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 126440 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126447 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 126454 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 126459 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126464 */     // GIR_Coverage, 20804,
     /* 126464 */     GIR_EraseRootFromParent_Done,
     /* 126465 */   // Label 2752: @126465
     /* 126465 */   GIM_Reject,
     /* 126466 */ // Label 2749: @126466
     /* 126466 */ GIM_Reject,
     /* 126467 */ // Label 2693: @126467
     /* 126467 */ GIM_Try, /*On fail goto*//*Label 2753*/ GIMT_Encode4(126733),
     /* 126472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 126475 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 126478 */   GIM_Try, /*On fail goto*//*Label 2754*/ GIMT_Encode4(126540), // Rule ID 7978 //
     /* 126483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 126486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 126498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 126502 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126505 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 126509 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 126513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126515 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 126522 */     // (rotr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPRORVDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 126522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPRORVDZ128rm),
     /* 126525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126527 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126529 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 126533 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 126538 */     GIR_RootConstrainSelectedInstOperands,
     /* 126539 */     // GIR_Coverage, 7978,
     /* 126539 */     GIR_EraseRootFromParent_Done,
     /* 126540 */   // Label 2754: @126540
     /* 126540 */   GIM_Try, /*On fail goto*//*Label 2755*/ GIMT_Encode4(126567), // Rule ID 7975 //
     /* 126545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 126548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126560 */     // (rotr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPRORVDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 126560 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPRORVDZ128rr),
     /* 126565 */     GIR_RootConstrainSelectedInstOperands,
     /* 126566 */     // GIR_Coverage, 7975,
     /* 126566 */     GIR_Done,
     /* 126567 */   // Label 2755: @126567
     /* 126567 */   GIM_Try, /*On fail goto*//*Label 2756*/ GIMT_Encode4(126732), // Rule ID 20806 //
     /* 126572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 126575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 126579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126587 */     // (rotr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VPRORVDZrr:{ *:[v16i32] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 126587 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 126590 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126594 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126599 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 126601 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 126604 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 126608 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126613 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 126616 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 126620 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 126623 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 126628 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126633 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 126638 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 126641 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126645 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126650 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 126652 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 126655 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 126659 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126664 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 126667 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 126671 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 126674 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 126679 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126684 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 126689 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 126692 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPRORVDZrr),
     /* 126696 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126701 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 126704 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 126707 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126714 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 126721 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 126726 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126731 */     // GIR_Coverage, 20806,
     /* 126731 */     GIR_EraseRootFromParent_Done,
     /* 126732 */   // Label 2756: @126732
     /* 126732 */   GIM_Reject,
     /* 126733 */ // Label 2753: @126733
     /* 126733 */ GIM_Reject,
     /* 126734 */ // Label 2694: @126734
     /* 126734 */ GIM_Try, /*On fail goto*//*Label 2757*/ GIMT_Encode4(126984),
     /* 126739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 126742 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 126745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 126749 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 126753 */   GIM_Try, /*On fail goto*//*Label 2758*/ GIMT_Encode4(126807), // Rule ID 7996 //
     /* 126758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 126761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 126765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 126769 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126772 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 126776 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 126780 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126782 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 126789 */     // (rotr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPRORVQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 126789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPRORVQZ256rm),
     /* 126792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126794 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126796 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 126800 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 126805 */     GIR_RootConstrainSelectedInstOperands,
     /* 126806 */     // GIR_Coverage, 7996,
     /* 126806 */     GIR_EraseRootFromParent_Done,
     /* 126807 */   // Label 2758: @126807
     /* 126807 */   GIM_Try, /*On fail goto*//*Label 2759*/ GIMT_Encode4(126826), // Rule ID 7993 //
     /* 126812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 126815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 126819 */     // (rotr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPRORVQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 126819 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPRORVQZ256rr),
     /* 126824 */     GIR_RootConstrainSelectedInstOperands,
     /* 126825 */     // GIR_Coverage, 7993,
     /* 126825 */     GIR_Done,
     /* 126826 */   // Label 2759: @126826
     /* 126826 */   GIM_Try, /*On fail goto*//*Label 2760*/ GIMT_Encode4(126983), // Rule ID 20805 //
     /* 126831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 126834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 126838 */     // (rotr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPRORVQZrr:{ *:[v8i64] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 126838 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 126841 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126845 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126850 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 126852 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 126855 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 126859 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126864 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 126867 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 126871 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 126874 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 126879 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126884 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 126889 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 126892 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126896 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126901 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 126903 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 126906 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 126910 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126915 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 126918 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 126922 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 126925 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 126930 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126935 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 126940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 126943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPRORVQZrr),
     /* 126947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126952 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 126955 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 126958 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126965 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 126972 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 126977 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126982 */     // GIR_Coverage, 20805,
     /* 126982 */     GIR_EraseRootFromParent_Done,
     /* 126983 */   // Label 2760: @126983
     /* 126983 */   GIM_Reject,
     /* 126984 */ // Label 2757: @126984
     /* 126984 */ GIM_Reject,
     /* 126985 */ // Label 2695: @126985
     /* 126985 */ GIM_Try, /*On fail goto*//*Label 2761*/ GIMT_Encode4(127235),
     /* 126990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 126993 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 126996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 127000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 127004 */   GIM_Try, /*On fail goto*//*Label 2762*/ GIMT_Encode4(127058), // Rule ID 7969 //
     /* 127009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 127012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 127016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 127020 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127023 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 127027 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 127031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127033 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 127040 */     // (rotr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPRORVDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 127040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPRORVDZ256rm),
     /* 127043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127045 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127047 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 127051 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 127056 */     GIR_RootConstrainSelectedInstOperands,
     /* 127057 */     // GIR_Coverage, 7969,
     /* 127057 */     GIR_EraseRootFromParent_Done,
     /* 127058 */   // Label 2762: @127058
     /* 127058 */   GIM_Try, /*On fail goto*//*Label 2763*/ GIMT_Encode4(127077), // Rule ID 7966 //
     /* 127063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 127066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 127070 */     // (rotr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPRORVDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 127070 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPRORVDZ256rr),
     /* 127075 */     GIR_RootConstrainSelectedInstOperands,
     /* 127076 */     // GIR_Coverage, 7966,
     /* 127076 */     GIR_Done,
     /* 127077 */   // Label 2763: @127077
     /* 127077 */   GIM_Try, /*On fail goto*//*Label 2764*/ GIMT_Encode4(127234), // Rule ID 20807 //
     /* 127082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 127085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 127089 */     // (rotr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VPRORVDZrr:{ *:[v16i32] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 127089 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 127092 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127096 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127101 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 127103 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 127106 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 127110 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127115 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 127118 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 127122 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 127125 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 127130 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 127135 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 127140 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 127143 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127147 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 127154 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 127157 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 127161 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127166 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 127169 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 127173 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 127176 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 127181 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 127186 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 127191 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 127194 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPRORVDZrr),
     /* 127198 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127203 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 127206 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 127209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127216 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 127223 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 127228 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 127233 */     // GIR_Coverage, 20807,
     /* 127233 */     GIR_EraseRootFromParent_Done,
     /* 127234 */   // Label 2764: @127234
     /* 127234 */   GIM_Reject,
     /* 127235 */ // Label 2761: @127235
     /* 127235 */ GIM_Reject,
     /* 127236 */ // Label 2696: @127236
     /* 127236 */ GIM_Try, /*On fail goto*//*Label 2765*/ GIMT_Encode4(127329),
     /* 127241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 127244 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 127247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 127251 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 127255 */   GIM_Try, /*On fail goto*//*Label 2766*/ GIMT_Encode4(127309), // Rule ID 7987 //
     /* 127260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 127263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 127267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 127271 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127274 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 127278 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 127282 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127284 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 127291 */     // (rotr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPRORVQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 127291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPRORVQZrm),
     /* 127294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127296 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127298 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 127302 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 127307 */     GIR_RootConstrainSelectedInstOperands,
     /* 127308 */     // GIR_Coverage, 7987,
     /* 127308 */     GIR_EraseRootFromParent_Done,
     /* 127309 */   // Label 2766: @127309
     /* 127309 */   GIM_Try, /*On fail goto*//*Label 2767*/ GIMT_Encode4(127328), // Rule ID 7984 //
     /* 127314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 127317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 127321 */     // (rotr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPRORVQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 127321 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPRORVQZrr),
     /* 127326 */     GIR_RootConstrainSelectedInstOperands,
     /* 127327 */     // GIR_Coverage, 7984,
     /* 127327 */     GIR_Done,
     /* 127328 */   // Label 2767: @127328
     /* 127328 */   GIM_Reject,
     /* 127329 */ // Label 2765: @127329
     /* 127329 */ GIM_Reject,
     /* 127330 */ // Label 2697: @127330
     /* 127330 */ GIM_Try, /*On fail goto*//*Label 2768*/ GIMT_Encode4(127423),
     /* 127335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 127338 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 127341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 127345 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 127349 */   GIM_Try, /*On fail goto*//*Label 2769*/ GIMT_Encode4(127403), // Rule ID 7960 //
     /* 127354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 127357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 127361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 127365 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127368 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 127372 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 127376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127378 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 127385 */     // (rotr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPRORVDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 127385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPRORVDZrm),
     /* 127388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127390 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127392 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 127396 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 127401 */     GIR_RootConstrainSelectedInstOperands,
     /* 127402 */     // GIR_Coverage, 7960,
     /* 127402 */     GIR_EraseRootFromParent_Done,
     /* 127403 */   // Label 2769: @127403
     /* 127403 */   GIM_Try, /*On fail goto*//*Label 2770*/ GIMT_Encode4(127422), // Rule ID 7957 //
     /* 127408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 127411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 127415 */     // (rotr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPRORVDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 127415 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPRORVDZrr),
     /* 127420 */     GIR_RootConstrainSelectedInstOperands,
     /* 127421 */     // GIR_Coverage, 7957,
     /* 127421 */     GIR_Done,
     /* 127422 */   // Label 2770: @127422
     /* 127422 */   GIM_Reject,
     /* 127423 */ // Label 2768: @127423
     /* 127423 */ GIM_Reject,
     /* 127424 */ // Label 2698: @127424
     /* 127424 */ GIM_Reject,
     /* 127425 */ // Label 32: @127425
     /* 127425 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(20), /*)*//*default:*//*Label 2783*/ GIMT_Encode4(131144),
     /* 127436 */ /*GILLT_s8*//*Label 2771*/ GIMT_Encode4(127512),
     /* 127440 */ /*GILLT_s16*//*Label 2772*/ GIMT_Encode4(127942),
     /* 127444 */ /*GILLT_s32*//*Label 2773*/ GIMT_Encode4(128372),
     /* 127448 */ /*GILLT_s64*//*Label 2774*/ GIMT_Encode4(128839), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127464 */ /*GILLT_v2s64*//*Label 2775*/ GIMT_Encode4(129306), GIMT_Encode4(0),
     /* 127472 */ /*GILLT_v4s32*//*Label 2776*/ GIMT_Encode4(129724),
     /* 127476 */ /*GILLT_v4s64*//*Label 2777*/ GIMT_Encode4(130142), GIMT_Encode4(0),
     /* 127484 */ /*GILLT_v8s16*//*Label 2778*/ GIMT_Encode4(130393),
     /* 127488 */ /*GILLT_v8s32*//*Label 2779*/ GIMT_Encode4(130549),
     /* 127492 */ /*GILLT_v8s64*//*Label 2780*/ GIMT_Encode4(130800), GIMT_Encode4(0),
     /* 127500 */ /*GILLT_v16s8*//*Label 2781*/ GIMT_Encode4(130894), GIMT_Encode4(0),
     /* 127508 */ /*GILLT_v16s32*//*Label 2782*/ GIMT_Encode4(131050),
     /* 127512 */ // Label 2771: @127512
     /* 127512 */ GIM_Try, /*On fail goto*//*Label 2784*/ GIMT_Encode4(127941),
     /* 127517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 127520 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 127523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 127527 */   GIM_Try, /*On fail goto*//*Label 2785*/ GIMT_Encode4(127586), // Rule ID 17620 //
     /* 127532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 127535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 127543 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127546 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 127550 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 127554 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 7,
     /* 127558 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127560 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 127567 */     // (rotl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, 7:{ *:[i8] })  =>  (ROR8m1_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 127567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8m1_ND),
     /* 127570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127572 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 127576 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127579 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 127584 */     GIR_RootConstrainSelectedInstOperands,
     /* 127585 */     // GIR_Coverage, 17620,
     /* 127585 */     GIR_EraseRootFromParent_Done,
     /* 127586 */   // Label 2785: @127586
     /* 127586 */   GIM_Try, /*On fail goto*//*Label 2786*/ GIMT_Encode4(127653), // Rule ID 769 //
     /* 127591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 127594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 127602 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127605 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 127609 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 127613 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 127617 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 127621 */     // MIs[2] Operand 1
     /* 127621 */     // No operand predicates
     /* 127621 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 127623 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 127630 */     // (rotl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2)  =>  (ROL8mi_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 127630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8mi_ND),
     /* 127633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127635 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 127639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 127642 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127645 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 127651 */     GIR_RootConstrainSelectedInstOperands,
     /* 127652 */     // GIR_Coverage, 769,
     /* 127652 */     GIR_EraseRootFromParent_Done,
     /* 127653 */   // Label 2786: @127653
     /* 127653 */   GIM_Try, /*On fail goto*//*Label 2787*/ GIMT_Encode4(127726), // Rule ID 785 //
     /* 127658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 127661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 127669 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127672 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 127676 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 127680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 127684 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127686 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 127693 */     // (rotl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] })  =>  (ROL8mCL_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 127693 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127697 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127703 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 127707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8mCL_ND),
     /* 127710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127712 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 127716 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127719 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 127724 */     GIR_RootConstrainSelectedInstOperands,
     /* 127725 */     // GIR_Coverage, 785,
     /* 127725 */     GIR_EraseRootFromParent_Done,
     /* 127726 */   // Label 2787: @127726
     /* 127726 */   GIM_Try, /*On fail goto*//*Label 2788*/ GIMT_Encode4(127754), // Rule ID 17596 //
     /* 127731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 127734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 127738 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 7,
     /* 127742 */     // (rotl:{ *:[i8] } GR8:{ *:[i8] }:$src1, 7:{ *:[i8] })  =>  (ROR8r1:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 127742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8r1),
     /* 127745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127747 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127749 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127752 */     GIR_RootConstrainSelectedInstOperands,
     /* 127753 */     // GIR_Coverage, 17596,
     /* 127753 */     GIR_EraseRootFromParent_Done,
     /* 127754 */   // Label 2788: @127754
     /* 127754 */   GIM_Try, /*On fail goto*//*Label 2789*/ GIMT_Encode4(127782), // Rule ID 17604 //
     /* 127759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 127762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 127766 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 7,
     /* 127770 */     // (rotl:{ *:[i8] } GR8:{ *:[i8] }:$src1, 7:{ *:[i8] })  =>  (ROR8r1_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 127770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8r1_ND),
     /* 127773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127775 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127777 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127780 */     GIR_RootConstrainSelectedInstOperands,
     /* 127781 */     // GIR_Coverage, 17604,
     /* 127781 */     GIR_EraseRootFromParent_Done,
     /* 127782 */   // Label 2789: @127782
     /* 127782 */   GIM_Try, /*On fail goto*//*Label 2790*/ GIMT_Encode4(127819), // Rule ID 757 //
     /* 127787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 127790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 127794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 127798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 127802 */     // MIs[1] Operand 1
     /* 127802 */     // No operand predicates
     /* 127802 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127804 */     // (rotl:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 127804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8ri),
     /* 127807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127809 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 127814 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127817 */     GIR_RootConstrainSelectedInstOperands,
     /* 127818 */     // GIR_Coverage, 757,
     /* 127818 */     GIR_EraseRootFromParent_Done,
     /* 127819 */   // Label 2790: @127819
     /* 127819 */   GIM_Try, /*On fail goto*//*Label 2791*/ GIMT_Encode4(127856), // Rule ID 761 //
     /* 127824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 127827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 127831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 127835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 127839 */     // MIs[1] Operand 1
     /* 127839 */     // No operand predicates
     /* 127839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127841 */     // (rotl:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 127841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8ri_ND),
     /* 127844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127846 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127848 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 127851 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127854 */     GIR_RootConstrainSelectedInstOperands,
     /* 127855 */     // GIR_Coverage, 761,
     /* 127855 */     GIR_EraseRootFromParent_Done,
     /* 127856 */   // Label 2791: @127856
     /* 127856 */   GIM_Try, /*On fail goto*//*Label 2792*/ GIMT_Encode4(127898), // Rule ID 773 //
     /* 127861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 127864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 127868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 127872 */     // (rotl:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (ROL8rCL:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 127872 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127876 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127882 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 127886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8rCL),
     /* 127889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127891 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127893 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127896 */     GIR_RootConstrainSelectedInstOperands,
     /* 127897 */     // GIR_Coverage, 773,
     /* 127897 */     GIR_EraseRootFromParent_Done,
     /* 127898 */   // Label 2792: @127898
     /* 127898 */   GIM_Try, /*On fail goto*//*Label 2793*/ GIMT_Encode4(127940), // Rule ID 777 //
     /* 127903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 127906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 127910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 127914 */     // (rotl:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (ROL8rCL_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 127914 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127918 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127924 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 127928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8rCL_ND),
     /* 127931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127933 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127935 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127938 */     GIR_RootConstrainSelectedInstOperands,
     /* 127939 */     // GIR_Coverage, 777,
     /* 127939 */     GIR_EraseRootFromParent_Done,
     /* 127940 */   // Label 2793: @127940
     /* 127940 */   GIM_Reject,
     /* 127941 */ // Label 2784: @127941
     /* 127941 */ GIM_Reject,
     /* 127942 */ // Label 2772: @127942
     /* 127942 */ GIM_Try, /*On fail goto*//*Label 2794*/ GIMT_Encode4(128371),
     /* 127947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 127950 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 127953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 127957 */   GIM_Try, /*On fail goto*//*Label 2795*/ GIMT_Encode4(128016), // Rule ID 17621 //
     /* 127962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 127965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 127973 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127976 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 127980 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 127984 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 15,
     /* 127988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127990 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 127997 */     // (rotl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 15:{ *:[i8] })  =>  (ROR16m1_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 127997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16m1_ND),
     /* 128000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128002 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 128006 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128009 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 128014 */     GIR_RootConstrainSelectedInstOperands,
     /* 128015 */     // GIR_Coverage, 17621,
     /* 128015 */     GIR_EraseRootFromParent_Done,
     /* 128016 */   // Label 2795: @128016
     /* 128016 */   GIM_Try, /*On fail goto*//*Label 2796*/ GIMT_Encode4(128083), // Rule ID 770 //
     /* 128021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 128024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 128032 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128035 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 128039 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 128043 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 128047 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 128051 */     // MIs[2] Operand 1
     /* 128051 */     // No operand predicates
     /* 128051 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 128053 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 128060 */     // (rotl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2)  =>  (ROL16mi_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 128060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16mi_ND),
     /* 128063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128065 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 128069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 128072 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128075 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 128081 */     GIR_RootConstrainSelectedInstOperands,
     /* 128082 */     // GIR_Coverage, 770,
     /* 128082 */     GIR_EraseRootFromParent_Done,
     /* 128083 */   // Label 2796: @128083
     /* 128083 */   GIM_Try, /*On fail goto*//*Label 2797*/ GIMT_Encode4(128156), // Rule ID 786 //
     /* 128088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 128091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 128099 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128102 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 128106 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 128110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 128114 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128116 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 128123 */     // (rotl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] })  =>  (ROL16mCL_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 128123 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128127 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128133 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 128137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16mCL_ND),
     /* 128140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128142 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 128146 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128149 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 128154 */     GIR_RootConstrainSelectedInstOperands,
     /* 128155 */     // GIR_Coverage, 786,
     /* 128155 */     GIR_EraseRootFromParent_Done,
     /* 128156 */   // Label 2797: @128156
     /* 128156 */   GIM_Try, /*On fail goto*//*Label 2798*/ GIMT_Encode4(128184), // Rule ID 17597 //
     /* 128161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 128164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 128168 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 15,
     /* 128172 */     // (rotl:{ *:[i16] } GR16:{ *:[i16] }:$src1, 15:{ *:[i8] })  =>  (ROR16r1:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 128172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16r1),
     /* 128175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128177 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128179 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128182 */     GIR_RootConstrainSelectedInstOperands,
     /* 128183 */     // GIR_Coverage, 17597,
     /* 128183 */     GIR_EraseRootFromParent_Done,
     /* 128184 */   // Label 2798: @128184
     /* 128184 */   GIM_Try, /*On fail goto*//*Label 2799*/ GIMT_Encode4(128212), // Rule ID 17605 //
     /* 128189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 128192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 128196 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 15,
     /* 128200 */     // (rotl:{ *:[i16] } GR16:{ *:[i16] }:$src1, 15:{ *:[i8] })  =>  (ROR16r1_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 128200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16r1_ND),
     /* 128203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128205 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128207 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128210 */     GIR_RootConstrainSelectedInstOperands,
     /* 128211 */     // GIR_Coverage, 17605,
     /* 128211 */     GIR_EraseRootFromParent_Done,
     /* 128212 */   // Label 2799: @128212
     /* 128212 */   GIM_Try, /*On fail goto*//*Label 2800*/ GIMT_Encode4(128249), // Rule ID 758 //
     /* 128217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 128220 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 128224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 128228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 128232 */     // MIs[1] Operand 1
     /* 128232 */     // No operand predicates
     /* 128232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128234 */     // (rotl:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 128234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16ri),
     /* 128237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128239 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128241 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 128244 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128247 */     GIR_RootConstrainSelectedInstOperands,
     /* 128248 */     // GIR_Coverage, 758,
     /* 128248 */     GIR_EraseRootFromParent_Done,
     /* 128249 */   // Label 2800: @128249
     /* 128249 */   GIM_Try, /*On fail goto*//*Label 2801*/ GIMT_Encode4(128286), // Rule ID 762 //
     /* 128254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 128257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 128261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 128265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 128269 */     // MIs[1] Operand 1
     /* 128269 */     // No operand predicates
     /* 128269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128271 */     // (rotl:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 128271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16ri_ND),
     /* 128274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128276 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128278 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 128281 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128284 */     GIR_RootConstrainSelectedInstOperands,
     /* 128285 */     // GIR_Coverage, 762,
     /* 128285 */     GIR_EraseRootFromParent_Done,
     /* 128286 */   // Label 2801: @128286
     /* 128286 */   GIM_Try, /*On fail goto*//*Label 2802*/ GIMT_Encode4(128328), // Rule ID 774 //
     /* 128291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 128294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 128298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 128302 */     // (rotl:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (ROL16rCL:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 128302 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128306 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128312 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 128316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16rCL),
     /* 128319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128321 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128323 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128326 */     GIR_RootConstrainSelectedInstOperands,
     /* 128327 */     // GIR_Coverage, 774,
     /* 128327 */     GIR_EraseRootFromParent_Done,
     /* 128328 */   // Label 2802: @128328
     /* 128328 */   GIM_Try, /*On fail goto*//*Label 2803*/ GIMT_Encode4(128370), // Rule ID 778 //
     /* 128333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 128336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 128340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 128344 */     // (rotl:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (ROL16rCL_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 128344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128348 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128354 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 128358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16rCL_ND),
     /* 128361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128363 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128365 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128368 */     GIR_RootConstrainSelectedInstOperands,
     /* 128369 */     // GIR_Coverage, 778,
     /* 128369 */     GIR_EraseRootFromParent_Done,
     /* 128370 */   // Label 2803: @128370
     /* 128370 */   GIM_Reject,
     /* 128371 */ // Label 2794: @128371
     /* 128371 */ GIM_Reject,
     /* 128372 */ // Label 2773: @128372
     /* 128372 */ GIM_Try, /*On fail goto*//*Label 2804*/ GIMT_Encode4(128838),
     /* 128377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 128380 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 128383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 128387 */   GIM_Try, /*On fail goto*//*Label 2805*/ GIMT_Encode4(128446), // Rule ID 17622 //
     /* 128392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 128395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 128403 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128406 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 128410 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 128414 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 31,
     /* 128418 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128420 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 128427 */     // (rotl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 31:{ *:[i8] })  =>  (ROR32m1_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 128427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32m1_ND),
     /* 128430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128432 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 128436 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128439 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 128444 */     GIR_RootConstrainSelectedInstOperands,
     /* 128445 */     // GIR_Coverage, 17622,
     /* 128445 */     GIR_EraseRootFromParent_Done,
     /* 128446 */   // Label 2805: @128446
     /* 128446 */   GIM_Try, /*On fail goto*//*Label 2806*/ GIMT_Encode4(128513), // Rule ID 771 //
     /* 128451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 128454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 128462 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128465 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 128469 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 128473 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 128477 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 128481 */     // MIs[2] Operand 1
     /* 128481 */     // No operand predicates
     /* 128481 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 128483 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 128490 */     // (rotl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2)  =>  (ROL32mi_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 128490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32mi_ND),
     /* 128493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128495 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 128499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 128502 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128505 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 128511 */     GIR_RootConstrainSelectedInstOperands,
     /* 128512 */     // GIR_Coverage, 771,
     /* 128512 */     GIR_EraseRootFromParent_Done,
     /* 128513 */   // Label 2806: @128513
     /* 128513 */   GIM_Try, /*On fail goto*//*Label 2807*/ GIMT_Encode4(128586), // Rule ID 787 //
     /* 128518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 128521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 128529 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128532 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 128536 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 128540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 128544 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128546 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 128553 */     // (rotl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] })  =>  (ROL32mCL_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 128553 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128557 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128563 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 128567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32mCL_ND),
     /* 128570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128572 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 128576 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128579 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 128584 */     GIR_RootConstrainSelectedInstOperands,
     /* 128585 */     // GIR_Coverage, 787,
     /* 128585 */     GIR_EraseRootFromParent_Done,
     /* 128586 */   // Label 2807: @128586
     /* 128586 */   GIM_Try, /*On fail goto*//*Label 2808*/ GIMT_Encode4(128623), // Rule ID 869 //
     /* 128591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFastSHLDRotate),
     /* 128594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 128598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 128602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 128606 */     // MIs[1] Operand 1
     /* 128606 */     // No operand predicates
     /* 128606 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128608 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$shamt)  =>  (SHLDROT32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$shamt)
     /* 128608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLDROT32ri),
     /* 128611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128613 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128615 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 128618 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128621 */     GIR_RootConstrainSelectedInstOperands,
     /* 128622 */     // GIR_Coverage, 869,
     /* 128622 */     GIR_EraseRootFromParent_Done,
     /* 128623 */   // Label 2808: @128623
     /* 128623 */   GIM_Try, /*On fail goto*//*Label 2809*/ GIMT_Encode4(128651), // Rule ID 17598 //
     /* 128628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 128631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 128635 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 31,
     /* 128639 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, 31:{ *:[i8] })  =>  (ROR32r1:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 128639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32r1),
     /* 128642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128644 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128646 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128649 */     GIR_RootConstrainSelectedInstOperands,
     /* 128650 */     // GIR_Coverage, 17598,
     /* 128650 */     GIR_EraseRootFromParent_Done,
     /* 128651 */   // Label 2809: @128651
     /* 128651 */   GIM_Try, /*On fail goto*//*Label 2810*/ GIMT_Encode4(128679), // Rule ID 17606 //
     /* 128656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 128659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 128663 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 31,
     /* 128667 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, 31:{ *:[i8] })  =>  (ROR32r1_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 128667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32r1_ND),
     /* 128670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128672 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128674 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128677 */     GIR_RootConstrainSelectedInstOperands,
     /* 128678 */     // GIR_Coverage, 17606,
     /* 128678 */     GIR_EraseRootFromParent_Done,
     /* 128679 */   // Label 2810: @128679
     /* 128679 */   GIM_Try, /*On fail goto*//*Label 2811*/ GIMT_Encode4(128716), // Rule ID 759 //
     /* 128684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 128687 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 128691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 128695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 128699 */     // MIs[1] Operand 1
     /* 128699 */     // No operand predicates
     /* 128699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128701 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 128701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32ri),
     /* 128704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128706 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128708 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 128711 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128714 */     GIR_RootConstrainSelectedInstOperands,
     /* 128715 */     // GIR_Coverage, 759,
     /* 128715 */     GIR_EraseRootFromParent_Done,
     /* 128716 */   // Label 2811: @128716
     /* 128716 */   GIM_Try, /*On fail goto*//*Label 2812*/ GIMT_Encode4(128753), // Rule ID 763 //
     /* 128721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 128724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 128728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 128732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 128736 */     // MIs[1] Operand 1
     /* 128736 */     // No operand predicates
     /* 128736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128738 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 128738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32ri_ND),
     /* 128741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128743 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128745 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 128748 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128751 */     GIR_RootConstrainSelectedInstOperands,
     /* 128752 */     // GIR_Coverage, 763,
     /* 128752 */     GIR_EraseRootFromParent_Done,
     /* 128753 */   // Label 2812: @128753
     /* 128753 */   GIM_Try, /*On fail goto*//*Label 2813*/ GIMT_Encode4(128795), // Rule ID 775 //
     /* 128758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 128761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 128765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 128769 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (ROL32rCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 128769 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128773 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128779 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 128783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32rCL),
     /* 128786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128788 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128790 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128793 */     GIR_RootConstrainSelectedInstOperands,
     /* 128794 */     // GIR_Coverage, 775,
     /* 128794 */     GIR_EraseRootFromParent_Done,
     /* 128795 */   // Label 2813: @128795
     /* 128795 */   GIM_Try, /*On fail goto*//*Label 2814*/ GIMT_Encode4(128837), // Rule ID 779 //
     /* 128800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 128803 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 128807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 128811 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (ROL32rCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 128811 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128815 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128821 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 128825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32rCL_ND),
     /* 128828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128830 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128832 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128835 */     GIR_RootConstrainSelectedInstOperands,
     /* 128836 */     // GIR_Coverage, 779,
     /* 128836 */     GIR_EraseRootFromParent_Done,
     /* 128837 */   // Label 2814: @128837
     /* 128837 */   GIM_Reject,
     /* 128838 */ // Label 2804: @128838
     /* 128838 */ GIM_Reject,
     /* 128839 */ // Label 2774: @128839
     /* 128839 */ GIM_Try, /*On fail goto*//*Label 2815*/ GIMT_Encode4(129305),
     /* 128844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 128847 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 128850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 128854 */   GIM_Try, /*On fail goto*//*Label 2816*/ GIMT_Encode4(128913), // Rule ID 17623 //
     /* 128859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 128862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 128870 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128873 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 128877 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 128881 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 63,
     /* 128885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128887 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 128894 */     // (rotl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 63:{ *:[i8] })  =>  (ROR64m1_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 128894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64m1_ND),
     /* 128897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128899 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 128903 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128906 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 128911 */     GIR_RootConstrainSelectedInstOperands,
     /* 128912 */     // GIR_Coverage, 17623,
     /* 128912 */     GIR_EraseRootFromParent_Done,
     /* 128913 */   // Label 2816: @128913
     /* 128913 */   GIM_Try, /*On fail goto*//*Label 2817*/ GIMT_Encode4(128980), // Rule ID 772 //
     /* 128918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 128921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 128929 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128932 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 128936 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 128940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 128944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 128948 */     // MIs[2] Operand 1
     /* 128948 */     // No operand predicates
     /* 128948 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 128950 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 128957 */     // (rotl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2)  =>  (ROL64mi_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 128957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64mi_ND),
     /* 128960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128962 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 128966 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 128969 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128972 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 128978 */     GIR_RootConstrainSelectedInstOperands,
     /* 128979 */     // GIR_Coverage, 772,
     /* 128979 */     GIR_EraseRootFromParent_Done,
     /* 128980 */   // Label 2817: @128980
     /* 128980 */   GIM_Try, /*On fail goto*//*Label 2818*/ GIMT_Encode4(129053), // Rule ID 788 //
     /* 128985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 128988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 128996 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128999 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 129003 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 129007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 129011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129013 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 129020 */     // (rotl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] })  =>  (ROL64mCL_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 129020 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 129024 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129030 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 129034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64mCL_ND),
     /* 129037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129039 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 129043 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 129046 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 129051 */     GIR_RootConstrainSelectedInstOperands,
     /* 129052 */     // GIR_Coverage, 788,
     /* 129052 */     GIR_EraseRootFromParent_Done,
     /* 129053 */   // Label 2818: @129053
     /* 129053 */   GIM_Try, /*On fail goto*//*Label 2819*/ GIMT_Encode4(129090), // Rule ID 870 //
     /* 129058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFastSHLDRotate),
     /* 129061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 129065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 129069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 129073 */     // MIs[1] Operand 1
     /* 129073 */     // No operand predicates
     /* 129073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129075 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$shamt)  =>  (SHLDROT64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$shamt)
     /* 129075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLDROT64ri),
     /* 129078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129080 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 129082 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 129085 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 129088 */     GIR_RootConstrainSelectedInstOperands,
     /* 129089 */     // GIR_Coverage, 870,
     /* 129089 */     GIR_EraseRootFromParent_Done,
     /* 129090 */   // Label 2819: @129090
     /* 129090 */   GIM_Try, /*On fail goto*//*Label 2820*/ GIMT_Encode4(129118), // Rule ID 17599 //
     /* 129095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 129098 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 129102 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 63,
     /* 129106 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, 63:{ *:[i8] })  =>  (ROR64r1:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 129106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64r1),
     /* 129109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129111 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 129113 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 129116 */     GIR_RootConstrainSelectedInstOperands,
     /* 129117 */     // GIR_Coverage, 17599,
     /* 129117 */     GIR_EraseRootFromParent_Done,
     /* 129118 */   // Label 2820: @129118
     /* 129118 */   GIM_Try, /*On fail goto*//*Label 2821*/ GIMT_Encode4(129146), // Rule ID 17607 //
     /* 129123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 129126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 129130 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 63,
     /* 129134 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, 63:{ *:[i8] })  =>  (ROR64r1_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 129134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64r1_ND),
     /* 129137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129139 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 129141 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 129144 */     GIR_RootConstrainSelectedInstOperands,
     /* 129145 */     // GIR_Coverage, 17607,
     /* 129145 */     GIR_EraseRootFromParent_Done,
     /* 129146 */   // Label 2821: @129146
     /* 129146 */   GIM_Try, /*On fail goto*//*Label 2822*/ GIMT_Encode4(129183), // Rule ID 760 //
     /* 129151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 129154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 129158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 129162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 129166 */     // MIs[1] Operand 1
     /* 129166 */     // No operand predicates
     /* 129166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129168 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 129168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64ri),
     /* 129171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129173 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 129175 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 129178 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 129181 */     GIR_RootConstrainSelectedInstOperands,
     /* 129182 */     // GIR_Coverage, 760,
     /* 129182 */     GIR_EraseRootFromParent_Done,
     /* 129183 */   // Label 2822: @129183
     /* 129183 */   GIM_Try, /*On fail goto*//*Label 2823*/ GIMT_Encode4(129220), // Rule ID 764 //
     /* 129188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 129191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 129195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 129199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 129203 */     // MIs[1] Operand 1
     /* 129203 */     // No operand predicates
     /* 129203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129205 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL64ri_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 129205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64ri_ND),
     /* 129208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129210 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 129212 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 129215 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 129218 */     GIR_RootConstrainSelectedInstOperands,
     /* 129219 */     // GIR_Coverage, 764,
     /* 129219 */     GIR_EraseRootFromParent_Done,
     /* 129220 */   // Label 2823: @129220
     /* 129220 */   GIM_Try, /*On fail goto*//*Label 2824*/ GIMT_Encode4(129262), // Rule ID 776 //
     /* 129225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 129228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 129232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 129236 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (ROL64rCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 129236 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 129240 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129246 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 129250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64rCL),
     /* 129253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129255 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 129257 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 129260 */     GIR_RootConstrainSelectedInstOperands,
     /* 129261 */     // GIR_Coverage, 776,
     /* 129261 */     GIR_EraseRootFromParent_Done,
     /* 129262 */   // Label 2824: @129262
     /* 129262 */   GIM_Try, /*On fail goto*//*Label 2825*/ GIMT_Encode4(129304), // Rule ID 780 //
     /* 129267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 129270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 129274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 129278 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (ROL64rCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 129278 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 129282 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129288 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 129292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64rCL_ND),
     /* 129295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129297 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 129299 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 129302 */     GIR_RootConstrainSelectedInstOperands,
     /* 129303 */     // GIR_Coverage, 780,
     /* 129303 */     GIR_EraseRootFromParent_Done,
     /* 129304 */   // Label 2825: @129304
     /* 129304 */   GIM_Reject,
     /* 129305 */ // Label 2815: @129305
     /* 129305 */ GIM_Reject,
     /* 129306 */ // Label 2775: @129306
     /* 129306 */ GIM_Try, /*On fail goto*//*Label 2826*/ GIMT_Encode4(129723),
     /* 129311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 129314 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 129317 */   GIM_Try, /*On fail goto*//*Label 2827*/ GIMT_Encode4(129379), // Rule ID 1583 //
     /* 129322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 129325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 129337 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129340 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 129344 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 129348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129354 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 129361 */     // (rotl:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2i64] }:$src2)  =>  (VPROTQmr:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 129361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROTQmr),
     /* 129364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129366 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 129370 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 129372 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 129377 */     GIR_RootConstrainSelectedInstOperands,
     /* 129378 */     // GIR_Coverage, 1583,
     /* 129378 */     GIR_EraseRootFromParent_Done,
     /* 129379 */   // Label 2827: @129379
     /* 129379 */   GIM_Try, /*On fail goto*//*Label 2828*/ GIMT_Encode4(129441), // Rule ID 1582 //
     /* 129384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 129387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 129399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 129403 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129406 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 129410 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 129414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129416 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 129423 */     // (rotl:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROTQrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 129423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROTQrm),
     /* 129426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129428 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 129430 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 129434 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 129439 */     GIR_RootConstrainSelectedInstOperands,
     /* 129440 */     // GIR_Coverage, 1582,
     /* 129440 */     GIR_EraseRootFromParent_Done,
     /* 129441 */   // Label 2828: @129441
     /* 129441 */   GIM_Try, /*On fail goto*//*Label 2829*/ GIMT_Encode4(129503), // Rule ID 8059 //
     /* 129446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 129449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 129461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 129465 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129468 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 129472 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 129476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129478 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 129485 */     // (rotl:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROLVQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 129485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROLVQZ128rm),
     /* 129488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129490 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 129492 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 129496 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 129501 */     GIR_RootConstrainSelectedInstOperands,
     /* 129502 */     // GIR_Coverage, 8059,
     /* 129502 */     GIR_EraseRootFromParent_Done,
     /* 129503 */   // Label 2829: @129503
     /* 129503 */   GIM_Try, /*On fail goto*//*Label 2830*/ GIMT_Encode4(129530), // Rule ID 1581 //
     /* 129508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 129511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129523 */     // (rotl:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VPROTQrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 129523 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROTQrr),
     /* 129528 */     GIR_RootConstrainSelectedInstOperands,
     /* 129529 */     // GIR_Coverage, 1581,
     /* 129529 */     GIR_Done,
     /* 129530 */   // Label 2830: @129530
     /* 129530 */   GIM_Try, /*On fail goto*//*Label 2831*/ GIMT_Encode4(129557), // Rule ID 8056 //
     /* 129535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 129538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129550 */     // (rotl:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPROLVQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 129550 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROLVQZ128rr),
     /* 129555 */     GIR_RootConstrainSelectedInstOperands,
     /* 129556 */     // GIR_Coverage, 8056,
     /* 129556 */     GIR_Done,
     /* 129557 */   // Label 2831: @129557
     /* 129557 */   GIM_Try, /*On fail goto*//*Label 2832*/ GIMT_Encode4(129722), // Rule ID 20796 //
     /* 129562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 129565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 129569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129577 */     // (rotl:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPROLVQZrr:{ *:[v8i64] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 129577 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 129580 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 129584 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129589 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 129591 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 129594 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 129598 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129603 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 129606 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 129610 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 129613 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 129618 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 129623 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 129628 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 129631 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 129635 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129640 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 129642 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 129645 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 129649 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129654 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 129657 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 129661 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 129664 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 129669 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 129674 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 129679 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 129682 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPROLVQZrr),
     /* 129686 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129691 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 129694 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 129697 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 129702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129704 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 129711 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 129716 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 129721 */     // GIR_Coverage, 20796,
     /* 129721 */     GIR_EraseRootFromParent_Done,
     /* 129722 */   // Label 2832: @129722
     /* 129722 */   GIM_Reject,
     /* 129723 */ // Label 2826: @129723
     /* 129723 */ GIM_Reject,
     /* 129724 */ // Label 2776: @129724
     /* 129724 */ GIM_Try, /*On fail goto*//*Label 2833*/ GIMT_Encode4(130141),
     /* 129729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 129732 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 129735 */   GIM_Try, /*On fail goto*//*Label 2834*/ GIMT_Encode4(129797), // Rule ID 1580 //
     /* 129740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 129743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 129755 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129758 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 129762 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 129766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129770 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129772 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 129779 */     // (rotl:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src2)  =>  (VPROTDmr:{ *:[v4i32] } addr:{ *:[iPTR] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 129779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROTDmr),
     /* 129782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129784 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 129788 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 129790 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 129795 */     GIR_RootConstrainSelectedInstOperands,
     /* 129796 */     // GIR_Coverage, 1580,
     /* 129796 */     GIR_EraseRootFromParent_Done,
     /* 129797 */   // Label 2834: @129797
     /* 129797 */   GIM_Try, /*On fail goto*//*Label 2835*/ GIMT_Encode4(129859), // Rule ID 1579 //
     /* 129802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 129805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 129817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 129821 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129824 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 129828 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 129832 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129834 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 129841 */     // (rotl:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROTDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 129841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROTDrm),
     /* 129844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129846 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 129848 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 129852 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 129857 */     GIR_RootConstrainSelectedInstOperands,
     /* 129858 */     // GIR_Coverage, 1579,
     /* 129858 */     GIR_EraseRootFromParent_Done,
     /* 129859 */   // Label 2835: @129859
     /* 129859 */   GIM_Try, /*On fail goto*//*Label 2836*/ GIMT_Encode4(129921), // Rule ID 8032 //
     /* 129864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 129867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 129879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 129883 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129886 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 129890 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 129894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129896 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 129903 */     // (rotl:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROLVDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 129903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROLVDZ128rm),
     /* 129906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129908 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 129910 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 129914 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 129919 */     GIR_RootConstrainSelectedInstOperands,
     /* 129920 */     // GIR_Coverage, 8032,
     /* 129920 */     GIR_EraseRootFromParent_Done,
     /* 129921 */   // Label 2836: @129921
     /* 129921 */   GIM_Try, /*On fail goto*//*Label 2837*/ GIMT_Encode4(129948), // Rule ID 1578 //
     /* 129926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 129929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129941 */     // (rotl:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPROTDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 129941 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROTDrr),
     /* 129946 */     GIR_RootConstrainSelectedInstOperands,
     /* 129947 */     // GIR_Coverage, 1578,
     /* 129947 */     GIR_Done,
     /* 129948 */   // Label 2837: @129948
     /* 129948 */   GIM_Try, /*On fail goto*//*Label 2838*/ GIMT_Encode4(129975), // Rule ID 8029 //
     /* 129953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 129956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129968 */     // (rotl:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPROLVDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 129968 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROLVDZ128rr),
     /* 129973 */     GIR_RootConstrainSelectedInstOperands,
     /* 129974 */     // GIR_Coverage, 8029,
     /* 129974 */     GIR_Done,
     /* 129975 */   // Label 2838: @129975
     /* 129975 */   GIM_Try, /*On fail goto*//*Label 2839*/ GIMT_Encode4(130140), // Rule ID 20798 //
     /* 129980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 129983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 129987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129995 */     // (rotl:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VPROLVDZrr:{ *:[v16i32] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 129995 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 129998 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 130002 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130007 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 130009 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 130012 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 130016 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130021 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 130024 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 130028 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 130031 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 130036 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 130041 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 130046 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 130049 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 130053 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 130060 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 130063 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 130067 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130072 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 130075 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 130079 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 130082 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 130087 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 130092 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 130097 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 130100 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPROLVDZrr),
     /* 130104 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130109 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 130112 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 130115 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130122 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 130129 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 130134 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 130139 */     // GIR_Coverage, 20798,
     /* 130139 */     GIR_EraseRootFromParent_Done,
     /* 130140 */   // Label 2839: @130140
     /* 130140 */   GIM_Reject,
     /* 130141 */ // Label 2833: @130141
     /* 130141 */ GIM_Reject,
     /* 130142 */ // Label 2777: @130142
     /* 130142 */ GIM_Try, /*On fail goto*//*Label 2840*/ GIMT_Encode4(130392),
     /* 130147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 130150 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 130153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 130157 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 130161 */   GIM_Try, /*On fail goto*//*Label 2841*/ GIMT_Encode4(130215), // Rule ID 8050 //
     /* 130166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 130169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 130173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 130177 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 130180 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 130184 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 130188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130190 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 130197 */     // (rotl:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROLVQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 130197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROLVQZ256rm),
     /* 130200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130202 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 130204 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 130208 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130213 */     GIR_RootConstrainSelectedInstOperands,
     /* 130214 */     // GIR_Coverage, 8050,
     /* 130214 */     GIR_EraseRootFromParent_Done,
     /* 130215 */   // Label 2841: @130215
     /* 130215 */   GIM_Try, /*On fail goto*//*Label 2842*/ GIMT_Encode4(130234), // Rule ID 8047 //
     /* 130220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 130223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 130227 */     // (rotl:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPROLVQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 130227 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROLVQZ256rr),
     /* 130232 */     GIR_RootConstrainSelectedInstOperands,
     /* 130233 */     // GIR_Coverage, 8047,
     /* 130233 */     GIR_Done,
     /* 130234 */   // Label 2842: @130234
     /* 130234 */   GIM_Try, /*On fail goto*//*Label 2843*/ GIMT_Encode4(130391), // Rule ID 20797 //
     /* 130239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 130242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 130246 */     // (rotl:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPROLVQZrr:{ *:[v8i64] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 130246 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 130249 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 130253 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130258 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 130260 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 130263 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 130267 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130272 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 130275 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 130279 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 130282 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 130287 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 130292 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 130297 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 130300 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 130304 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130309 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 130311 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 130314 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 130318 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130323 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 130326 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 130330 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 130333 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 130338 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 130343 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 130348 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 130351 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPROLVQZrr),
     /* 130355 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130360 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 130363 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 130366 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130373 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 130380 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 130385 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 130390 */     // GIR_Coverage, 20797,
     /* 130390 */     GIR_EraseRootFromParent_Done,
     /* 130391 */   // Label 2843: @130391
     /* 130391 */   GIM_Reject,
     /* 130392 */ // Label 2840: @130392
     /* 130392 */ GIM_Reject,
     /* 130393 */ // Label 2778: @130393
     /* 130393 */ GIM_Try, /*On fail goto*//*Label 2844*/ GIMT_Encode4(130548),
     /* 130398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 130401 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 130404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 130408 */   GIM_Try, /*On fail goto*//*Label 2845*/ GIMT_Encode4(130466), // Rule ID 1586 //
     /* 130413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 130416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 130420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 130424 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 130427 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 130431 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 130435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 130439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130441 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 130448 */     // (rotl:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src2)  =>  (VPROTWmr:{ *:[v8i16] } addr:{ *:[iPTR] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 130448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROTWmr),
     /* 130451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130453 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 130457 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 130459 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130464 */     GIR_RootConstrainSelectedInstOperands,
     /* 130465 */     // GIR_Coverage, 1586,
     /* 130465 */     GIR_EraseRootFromParent_Done,
     /* 130466 */   // Label 2845: @130466
     /* 130466 */   GIM_Try, /*On fail goto*//*Label 2846*/ GIMT_Encode4(130524), // Rule ID 1585 //
     /* 130471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 130474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 130478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 130482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 130486 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 130489 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 130493 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 130497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130499 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 130506 */     // (rotl:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROTWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 130506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROTWrm),
     /* 130509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130511 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 130513 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 130517 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130522 */     GIR_RootConstrainSelectedInstOperands,
     /* 130523 */     // GIR_Coverage, 1585,
     /* 130523 */     GIR_EraseRootFromParent_Done,
     /* 130524 */   // Label 2846: @130524
     /* 130524 */   GIM_Try, /*On fail goto*//*Label 2847*/ GIMT_Encode4(130547), // Rule ID 1584 //
     /* 130529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 130532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 130536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 130540 */     // (rotl:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPROTWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 130540 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROTWrr),
     /* 130545 */     GIR_RootConstrainSelectedInstOperands,
     /* 130546 */     // GIR_Coverage, 1584,
     /* 130546 */     GIR_Done,
     /* 130547 */   // Label 2847: @130547
     /* 130547 */   GIM_Reject,
     /* 130548 */ // Label 2844: @130548
     /* 130548 */ GIM_Reject,
     /* 130549 */ // Label 2779: @130549
     /* 130549 */ GIM_Try, /*On fail goto*//*Label 2848*/ GIMT_Encode4(130799),
     /* 130554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 130557 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 130560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 130564 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 130568 */   GIM_Try, /*On fail goto*//*Label 2849*/ GIMT_Encode4(130622), // Rule ID 8023 //
     /* 130573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 130576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 130580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 130584 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 130587 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 130591 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 130595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130597 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 130604 */     // (rotl:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROLVDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 130604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROLVDZ256rm),
     /* 130607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130609 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 130611 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 130615 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130620 */     GIR_RootConstrainSelectedInstOperands,
     /* 130621 */     // GIR_Coverage, 8023,
     /* 130621 */     GIR_EraseRootFromParent_Done,
     /* 130622 */   // Label 2849: @130622
     /* 130622 */   GIM_Try, /*On fail goto*//*Label 2850*/ GIMT_Encode4(130641), // Rule ID 8020 //
     /* 130627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 130630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 130634 */     // (rotl:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPROLVDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 130634 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROLVDZ256rr),
     /* 130639 */     GIR_RootConstrainSelectedInstOperands,
     /* 130640 */     // GIR_Coverage, 8020,
     /* 130640 */     GIR_Done,
     /* 130641 */   // Label 2850: @130641
     /* 130641 */   GIM_Try, /*On fail goto*//*Label 2851*/ GIMT_Encode4(130798), // Rule ID 20799 //
     /* 130646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 130649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 130653 */     // (rotl:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VPROLVDZrr:{ *:[v16i32] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 130653 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 130656 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 130660 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130665 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 130667 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 130670 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 130674 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130679 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 130682 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 130686 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 130689 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 130694 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 130699 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 130704 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 130707 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 130711 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 130718 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 130721 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 130725 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130730 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 130733 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 130737 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 130740 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 130745 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 130750 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 130755 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 130758 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPROLVDZrr),
     /* 130762 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130767 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 130770 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 130773 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130780 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 130787 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 130792 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 130797 */     // GIR_Coverage, 20799,
     /* 130797 */     GIR_EraseRootFromParent_Done,
     /* 130798 */   // Label 2851: @130798
     /* 130798 */   GIM_Reject,
     /* 130799 */ // Label 2848: @130799
     /* 130799 */ GIM_Reject,
     /* 130800 */ // Label 2780: @130800
     /* 130800 */ GIM_Try, /*On fail goto*//*Label 2852*/ GIMT_Encode4(130893),
     /* 130805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 130808 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 130811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 130815 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 130819 */   GIM_Try, /*On fail goto*//*Label 2853*/ GIMT_Encode4(130873), // Rule ID 8041 //
     /* 130824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 130827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 130831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 130835 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 130838 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 130842 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 130846 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130848 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 130855 */     // (rotl:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROLVQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 130855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROLVQZrm),
     /* 130858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130860 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 130862 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 130866 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130871 */     GIR_RootConstrainSelectedInstOperands,
     /* 130872 */     // GIR_Coverage, 8041,
     /* 130872 */     GIR_EraseRootFromParent_Done,
     /* 130873 */   // Label 2853: @130873
     /* 130873 */   GIM_Try, /*On fail goto*//*Label 2854*/ GIMT_Encode4(130892), // Rule ID 8038 //
     /* 130878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 130881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 130885 */     // (rotl:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPROLVQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 130885 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROLVQZrr),
     /* 130890 */     GIR_RootConstrainSelectedInstOperands,
     /* 130891 */     // GIR_Coverage, 8038,
     /* 130891 */     GIR_Done,
     /* 130892 */   // Label 2854: @130892
     /* 130892 */   GIM_Reject,
     /* 130893 */ // Label 2852: @130893
     /* 130893 */ GIM_Reject,
     /* 130894 */ // Label 2781: @130894
     /* 130894 */ GIM_Try, /*On fail goto*//*Label 2855*/ GIMT_Encode4(131049),
     /* 130899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 130902 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 130905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 130909 */   GIM_Try, /*On fail goto*//*Label 2856*/ GIMT_Encode4(130967), // Rule ID 1577 //
     /* 130914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 130917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 130921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 130925 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 130928 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 130932 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 130936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 130940 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130942 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 130949 */     // (rotl:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src2)  =>  (VPROTBmr:{ *:[v16i8] } addr:{ *:[iPTR] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 130949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROTBmr),
     /* 130952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130954 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 130958 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 130960 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130965 */     GIR_RootConstrainSelectedInstOperands,
     /* 130966 */     // GIR_Coverage, 1577,
     /* 130966 */     GIR_EraseRootFromParent_Done,
     /* 130967 */   // Label 2856: @130967
     /* 130967 */   GIM_Try, /*On fail goto*//*Label 2857*/ GIMT_Encode4(131025), // Rule ID 1576 //
     /* 130972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 130975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 130979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 130983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 130987 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 130990 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 130994 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 130998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131000 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 131007 */     // (rotl:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROTBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 131007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROTBrm),
     /* 131010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131012 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 131014 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 131018 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 131023 */     GIR_RootConstrainSelectedInstOperands,
     /* 131024 */     // GIR_Coverage, 1576,
     /* 131024 */     GIR_EraseRootFromParent_Done,
     /* 131025 */   // Label 2857: @131025
     /* 131025 */   GIM_Try, /*On fail goto*//*Label 2858*/ GIMT_Encode4(131048), // Rule ID 1575 //
     /* 131030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 131033 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 131037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 131041 */     // (rotl:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPROTBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 131041 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROTBrr),
     /* 131046 */     GIR_RootConstrainSelectedInstOperands,
     /* 131047 */     // GIR_Coverage, 1575,
     /* 131047 */     GIR_Done,
     /* 131048 */   // Label 2858: @131048
     /* 131048 */   GIM_Reject,
     /* 131049 */ // Label 2855: @131049
     /* 131049 */ GIM_Reject,
     /* 131050 */ // Label 2782: @131050
     /* 131050 */ GIM_Try, /*On fail goto*//*Label 2859*/ GIMT_Encode4(131143),
     /* 131055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 131058 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 131061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 131065 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 131069 */   GIM_Try, /*On fail goto*//*Label 2860*/ GIMT_Encode4(131123), // Rule ID 8014 //
     /* 131074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 131077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 131085 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 131088 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 131092 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 131096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131098 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 131105 */     // (rotl:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROLVDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 131105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROLVDZrm),
     /* 131108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131110 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 131112 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 131116 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 131121 */     GIR_RootConstrainSelectedInstOperands,
     /* 131122 */     // GIR_Coverage, 8014,
     /* 131122 */     GIR_EraseRootFromParent_Done,
     /* 131123 */   // Label 2860: @131123
     /* 131123 */   GIM_Try, /*On fail goto*//*Label 2861*/ GIMT_Encode4(131142), // Rule ID 8011 //
     /* 131128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 131131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 131135 */     // (rotl:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPROLVDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 131135 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROLVDZrr),
     /* 131140 */     GIR_RootConstrainSelectedInstOperands,
     /* 131141 */     // GIR_Coverage, 8011,
     /* 131141 */     GIR_Done,
     /* 131142 */   // Label 2861: @131142
     /* 131142 */   GIM_Reject,
     /* 131143 */ // Label 2859: @131143
     /* 131143 */ GIM_Reject,
     /* 131144 */ // Label 2783: @131144
     /* 131144 */ GIM_Reject,
     /* 131145 */ // Label 33: @131145
     /* 131145 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(24), /*)*//*default:*//*Label 2868*/ GIMT_Encode4(132801),
     /* 131156 */ /*GILLT_v2s1*//*Label 2862*/ GIMT_Encode4(131224), GIMT_Encode4(0),
     /* 131164 */ /*GILLT_v4s1*//*Label 2863*/ GIMT_Encode4(131385), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 131176 */ /*GILLT_v8s1*//*Label 2864*/ GIMT_Encode4(131732), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 131192 */ /*GILLT_v16s1*//*Label 2865*/ GIMT_Encode4(132129), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 131208 */ /*GILLT_v32s1*//*Label 2866*/ GIMT_Encode4(132526), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 131220 */ /*GILLT_v64s1*//*Label 2867*/ GIMT_Encode4(132750),
     /* 131224 */ // Label 2862: @131224
     /* 131224 */ GIM_Try, /*On fail goto*//*Label 2869*/ GIMT_Encode4(131384),
     /* 131229 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 131232 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 131235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 131239 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131244 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 131248 */   GIM_Try, /*On fail goto*//*Label 2870*/ GIMT_Encode4(131279), // Rule ID 12606 //
     /* 131253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 131256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131260 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131266 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131270 */     // (setcc:{ *:[v2i1] } immAllZerosV:{ *:[v2i64] }, VR128X:{ *:[v2i64] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVQ2MZ128kr:{ *:[v2i1] } VR128X:{ *:[v2i64] }:$src)
     /* 131270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVQ2MZ128kr),
     /* 131273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131275 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 131277 */     GIR_RootConstrainSelectedInstOperands,
     /* 131278 */     // GIR_Coverage, 12606,
     /* 131278 */     GIR_EraseRootFromParent_Done,
     /* 131279 */   // Label 2870: @131279
     /* 131279 */   GIM_Try, /*On fail goto*//*Label 2871*/ GIMT_Encode4(131383), // Rule ID 21658 //
     /* 131284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEVEX512_NoVLX),
     /* 131287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131291 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131297 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131301 */     // (setcc:{ *:[v2i1] } immAllZerosV:{ *:[v2i64] }, VR128X:{ *:[v2i64] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (VPMOVQ2MZkr:{ *:[v8i1] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src, sub_xmm:{ *:[i32] })), VK2:{ *:[i32] })
     /* 131301 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 131304 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 131308 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131313 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 131315 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 131318 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 131322 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131327 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 131330 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 131334 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 131337 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 131342 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 131347 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 131352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s1,
     /* 131355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVQ2MZkr),
     /* 131359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131364 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 131367 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131374 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131377 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 131382 */     // GIR_Coverage, 21658,
     /* 131382 */     GIR_EraseRootFromParent_Done,
     /* 131383 */   // Label 2871: @131383
     /* 131383 */   GIM_Reject,
     /* 131384 */ // Label 2869: @131384
     /* 131384 */ GIM_Reject,
     /* 131385 */ // Label 2863: @131385
     /* 131385 */ GIM_Try, /*On fail goto*//*Label 2872*/ GIMT_Encode4(131435), // Rule ID 12603 //
     /* 131390 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 131393 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 131396 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 131399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 131403 */   // MIs[0] Operand 1
     /* 131403 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131408 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131412 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131418 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131420 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 131424 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131426 */   // (setcc:{ *:[v4i1] } immAllZerosV:{ *:[v4i32] }, VR128X:{ *:[v4i32] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVD2MZ128kr:{ *:[v4i1] } VR128X:{ *:[v4i32] }:$src)
     /* 131426 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVD2MZ128kr),
     /* 131429 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131431 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 131433 */   GIR_RootConstrainSelectedInstOperands,
     /* 131434 */   // GIR_Coverage, 12603,
     /* 131434 */   GIR_EraseRootFromParent_Done,
     /* 131435 */ // Label 2872: @131435
     /* 131435 */ GIM_Try, /*On fail goto*//*Label 2873*/ GIMT_Encode4(131485), // Rule ID 12605 //
     /* 131440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 131443 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 131446 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 131449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 131453 */   // MIs[0] Operand 1
     /* 131453 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131458 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131462 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131468 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131470 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 131474 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131476 */   // (setcc:{ *:[v4i1] } immAllZerosV:{ *:[v4i64] }, VR256X:{ *:[v4i64] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVQ2MZ256kr:{ *:[v4i1] } VR256X:{ *:[v4i64] }:$src)
     /* 131476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVQ2MZ256kr),
     /* 131479 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131481 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 131483 */   GIR_RootConstrainSelectedInstOperands,
     /* 131484 */   // GIR_Coverage, 12605,
     /* 131484 */   GIR_EraseRootFromParent_Done,
     /* 131485 */ // Label 2873: @131485
     /* 131485 */ GIM_Try, /*On fail goto*//*Label 2874*/ GIMT_Encode4(131608), // Rule ID 21656 //
     /* 131490 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEVEX512_NoVLX),
     /* 131493 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 131496 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 131499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 131503 */   // MIs[0] Operand 1
     /* 131503 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131508 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131512 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131518 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131520 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 131524 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131526 */   // (setcc:{ *:[v4i1] } immAllZerosV:{ *:[v4i32] }, VR128X:{ *:[v4i32] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (VPMOVD2MZkr:{ *:[v16i1] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src, sub_xmm:{ *:[i32] })), VK4:{ *:[i32] })
     /* 131526 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 131529 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 131533 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131538 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 131540 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 131543 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 131547 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131552 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 131555 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 131559 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 131562 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 131567 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 131572 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 131577 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 131580 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVD2MZkr),
     /* 131584 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131589 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 131592 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131594 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131597 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131599 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131602 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 131607 */   // GIR_Coverage, 21656,
     /* 131607 */   GIR_EraseRootFromParent_Done,
     /* 131608 */ // Label 2874: @131608
     /* 131608 */ GIM_Try, /*On fail goto*//*Label 2875*/ GIMT_Encode4(131731), // Rule ID 21657 //
     /* 131613 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEVEX512_NoVLX),
     /* 131616 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 131619 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 131622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 131626 */   // MIs[0] Operand 1
     /* 131626 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131631 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131635 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131641 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131643 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 131647 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131649 */   // (setcc:{ *:[v4i1] } immAllZerosV:{ *:[v4i64] }, VR256X:{ *:[v4i64] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (VPMOVQ2MZkr:{ *:[v8i1] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src, sub_ymm:{ *:[i32] })), VK4:{ *:[i32] })
     /* 131649 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 131652 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 131656 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131661 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 131663 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 131666 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 131670 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131675 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 131678 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 131682 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 131685 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 131690 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 131695 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 131700 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s1,
     /* 131703 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVQ2MZkr),
     /* 131707 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131712 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 131715 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131717 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131720 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131722 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131725 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 131730 */   // GIR_Coverage, 21657,
     /* 131730 */   GIR_EraseRootFromParent_Done,
     /* 131731 */ // Label 2875: @131731
     /* 131731 */ GIM_Reject,
     /* 131732 */ // Label 2864: @131732
     /* 131732 */ GIM_Try, /*On fail goto*//*Label 2876*/ GIMT_Encode4(131782), // Rule ID 12600 //
     /* 131737 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 131740 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 131743 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 131746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 131750 */   // MIs[0] Operand 1
     /* 131750 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131755 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131759 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131765 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131767 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 131771 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131773 */   // (setcc:{ *:[v8i1] } immAllZerosV:{ *:[v8i16] }, VR128X:{ *:[v8i16] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVW2MZ128kr:{ *:[v8i1] } VR128X:{ *:[v8i16] }:$src)
     /* 131773 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVW2MZ128kr),
     /* 131776 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131778 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 131780 */   GIR_RootConstrainSelectedInstOperands,
     /* 131781 */   // GIR_Coverage, 12600,
     /* 131781 */   GIR_EraseRootFromParent_Done,
     /* 131782 */ // Label 2876: @131782
     /* 131782 */ GIM_Try, /*On fail goto*//*Label 2877*/ GIMT_Encode4(131832), // Rule ID 12602 //
     /* 131787 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 131790 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 131793 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 131796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 131800 */   // MIs[0] Operand 1
     /* 131800 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131805 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131809 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131815 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131817 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 131821 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131823 */   // (setcc:{ *:[v8i1] } immAllZerosV:{ *:[v8i32] }, VR256X:{ *:[v8i32] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVD2MZ256kr:{ *:[v8i1] } VR256X:{ *:[v8i32] }:$src)
     /* 131823 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVD2MZ256kr),
     /* 131826 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131828 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 131830 */   GIR_RootConstrainSelectedInstOperands,
     /* 131831 */   // GIR_Coverage, 12602,
     /* 131831 */   GIR_EraseRootFromParent_Done,
     /* 131832 */ // Label 2877: @131832
     /* 131832 */ GIM_Try, /*On fail goto*//*Label 2878*/ GIMT_Encode4(131882), // Rule ID 12604 //
     /* 131837 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 131840 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 131843 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /* 131846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 131850 */   // MIs[0] Operand 1
     /* 131850 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131855 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131859 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131865 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131867 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 131871 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131873 */   // (setcc:{ *:[v8i1] } immAllZerosV:{ *:[v8i64] }, VR512:{ *:[v8i64] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVQ2MZkr:{ *:[v8i1] } VR512:{ *:[v8i64] }:$src)
     /* 131873 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVQ2MZkr),
     /* 131876 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131878 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 131880 */   GIR_RootConstrainSelectedInstOperands,
     /* 131881 */   // GIR_Coverage, 12604,
     /* 131881 */   GIR_EraseRootFromParent_Done,
     /* 131882 */ // Label 2878: @131882
     /* 131882 */ GIM_Try, /*On fail goto*//*Label 2879*/ GIMT_Encode4(132005), // Rule ID 21654 //
     /* 131887 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 131890 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 131893 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 131896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 131900 */   // MIs[0] Operand 1
     /* 131900 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131905 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131909 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131915 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131917 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 131921 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131923 */   // (setcc:{ *:[v8i1] } immAllZerosV:{ *:[v8i16] }, VR128X:{ *:[v8i16] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (VPMOVW2MZkr:{ *:[v32i1] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR128X:{ *:[v8i16] }:$src, sub_xmm:{ *:[i32] })), VK8:{ *:[i32] })
     /* 131923 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 131926 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 131930 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131935 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 131937 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 131940 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 131944 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131949 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 131952 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 131956 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 131959 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 131964 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 131969 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 131974 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s1,
     /* 131977 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVW2MZkr),
     /* 131981 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131986 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 131989 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131991 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131994 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131996 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131999 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 132004 */   // GIR_Coverage, 21654,
     /* 132004 */   GIR_EraseRootFromParent_Done,
     /* 132005 */ // Label 2879: @132005
     /* 132005 */ GIM_Try, /*On fail goto*//*Label 2880*/ GIMT_Encode4(132128), // Rule ID 21655 //
     /* 132010 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEVEX512_NoVLX),
     /* 132013 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 132016 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 132019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 132023 */   // MIs[0] Operand 1
     /* 132023 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 132028 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 132032 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132038 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132040 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 132044 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132046 */   // (setcc:{ *:[v8i1] } immAllZerosV:{ *:[v8i32] }, VR256X:{ *:[v8i32] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (VPMOVD2MZkr:{ *:[v16i1] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src, sub_ymm:{ *:[i32] })), VK8:{ *:[i32] })
     /* 132046 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 132049 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 132053 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132058 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 132060 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 132063 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 132067 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132072 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 132075 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 132079 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 132082 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 132087 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 132092 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 132097 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 132100 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVD2MZkr),
     /* 132104 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132109 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132112 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132114 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132117 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132119 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132122 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 132127 */   // GIR_Coverage, 21655,
     /* 132127 */   GIR_EraseRootFromParent_Done,
     /* 132128 */ // Label 2880: @132128
     /* 132128 */ GIM_Reject,
     /* 132129 */ // Label 2865: @132129
     /* 132129 */ GIM_Try, /*On fail goto*//*Label 2881*/ GIMT_Encode4(132179), // Rule ID 12597 //
     /* 132134 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 132137 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 132140 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 132143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 132147 */   // MIs[0] Operand 1
     /* 132147 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 132152 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 132156 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132162 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132164 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 132168 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132170 */   // (setcc:{ *:[v16i1] } immAllZerosV:{ *:[v16i8] }, VR128X:{ *:[v16i8] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVB2MZ128kr:{ *:[v16i1] } VR128X:{ *:[v16i8] }:$src)
     /* 132170 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVB2MZ128kr),
     /* 132173 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132175 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 132177 */   GIR_RootConstrainSelectedInstOperands,
     /* 132178 */   // GIR_Coverage, 12597,
     /* 132178 */   GIR_EraseRootFromParent_Done,
     /* 132179 */ // Label 2881: @132179
     /* 132179 */ GIM_Try, /*On fail goto*//*Label 2882*/ GIMT_Encode4(132229), // Rule ID 12599 //
     /* 132184 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 132187 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 132190 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 132193 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 132197 */   // MIs[0] Operand 1
     /* 132197 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 132202 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 132206 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132212 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132214 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 132218 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132220 */   // (setcc:{ *:[v16i1] } immAllZerosV:{ *:[v16i16] }, VR256X:{ *:[v16i16] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVW2MZ256kr:{ *:[v16i1] } VR256X:{ *:[v16i16] }:$src)
     /* 132220 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVW2MZ256kr),
     /* 132223 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132225 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 132227 */   GIR_RootConstrainSelectedInstOperands,
     /* 132228 */   // GIR_Coverage, 12599,
     /* 132228 */   GIR_EraseRootFromParent_Done,
     /* 132229 */ // Label 2882: @132229
     /* 132229 */ GIM_Try, /*On fail goto*//*Label 2883*/ GIMT_Encode4(132279), // Rule ID 12601 //
     /* 132234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 132237 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 132240 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /* 132243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 132247 */   // MIs[0] Operand 1
     /* 132247 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 132252 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 132256 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132262 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132264 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 132268 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132270 */   // (setcc:{ *:[v16i1] } immAllZerosV:{ *:[v16i32] }, VR512:{ *:[v16i32] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVD2MZkr:{ *:[v16i1] } VR512:{ *:[v16i32] }:$src)
     /* 132270 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVD2MZkr),
     /* 132273 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132275 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 132277 */   GIR_RootConstrainSelectedInstOperands,
     /* 132278 */   // GIR_Coverage, 12601,
     /* 132278 */   GIR_EraseRootFromParent_Done,
     /* 132279 */ // Label 2883: @132279
     /* 132279 */ GIM_Try, /*On fail goto*//*Label 2884*/ GIMT_Encode4(132402), // Rule ID 21652 //
     /* 132284 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 132287 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 132290 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 132293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 132297 */   // MIs[0] Operand 1
     /* 132297 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 132302 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 132306 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132312 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132314 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 132318 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132320 */   // (setcc:{ *:[v16i1] } immAllZerosV:{ *:[v16i8] }, VR128X:{ *:[v16i8] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (VPMOVB2MZkr:{ *:[v64i1] } (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR128X:{ *:[v16i8] }:$src, sub_xmm:{ *:[i32] })), VK16:{ *:[i32] })
     /* 132320 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 132323 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 132327 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132332 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 132334 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s8,
     /* 132337 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 132341 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132346 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 132349 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 132353 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 132356 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 132361 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 132366 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 132371 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s1,
     /* 132374 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVB2MZkr),
     /* 132378 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132383 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132386 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132388 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132391 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132393 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132396 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 132401 */   // GIR_Coverage, 21652,
     /* 132401 */   GIR_EraseRootFromParent_Done,
     /* 132402 */ // Label 2884: @132402
     /* 132402 */ GIM_Try, /*On fail goto*//*Label 2885*/ GIMT_Encode4(132525), // Rule ID 21653 //
     /* 132407 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 132410 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 132413 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 132416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 132420 */   // MIs[0] Operand 1
     /* 132420 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 132425 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 132429 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132435 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132437 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 132441 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132443 */   // (setcc:{ *:[v16i1] } immAllZerosV:{ *:[v16i16] }, VR256X:{ *:[v16i16] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (VPMOVW2MZkr:{ *:[v32i1] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR256X:{ *:[v16i16] }:$src, sub_ymm:{ *:[i32] })), VK16:{ *:[i32] })
     /* 132443 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 132446 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 132450 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132455 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 132457 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 132460 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 132464 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132469 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 132472 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 132476 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 132479 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 132484 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 132489 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 132494 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s1,
     /* 132497 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVW2MZkr),
     /* 132501 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132506 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132509 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132511 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132514 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132516 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132519 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 132524 */   // GIR_Coverage, 21653,
     /* 132524 */   GIR_EraseRootFromParent_Done,
     /* 132525 */ // Label 2885: @132525
     /* 132525 */ GIM_Reject,
     /* 132526 */ // Label 2866: @132526
     /* 132526 */ GIM_Try, /*On fail goto*//*Label 2886*/ GIMT_Encode4(132576), // Rule ID 12596 //
     /* 132531 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 132534 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 132537 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s8,
     /* 132540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 132544 */   // MIs[0] Operand 1
     /* 132544 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 132549 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 132553 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132559 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132561 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 132565 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132567 */   // (setcc:{ *:[v32i1] } immAllZerosV:{ *:[v32i8] }, VR256X:{ *:[v32i8] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVB2MZ256kr:{ *:[v32i1] } VR256X:{ *:[v32i8] }:$src)
     /* 132567 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVB2MZ256kr),
     /* 132570 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132572 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 132574 */   GIR_RootConstrainSelectedInstOperands,
     /* 132575 */   // GIR_Coverage, 12596,
     /* 132575 */   GIR_EraseRootFromParent_Done,
     /* 132576 */ // Label 2886: @132576
     /* 132576 */ GIM_Try, /*On fail goto*//*Label 2887*/ GIMT_Encode4(132626), // Rule ID 12598 //
     /* 132581 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 132584 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 132587 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s16,
     /* 132590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 132594 */   // MIs[0] Operand 1
     /* 132594 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 132599 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 132603 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132609 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132611 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 132615 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132617 */   // (setcc:{ *:[v32i1] } immAllZerosV:{ *:[v32i16] }, VR512:{ *:[v32i16] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVW2MZkr:{ *:[v32i1] } VR512:{ *:[v32i16] }:$src)
     /* 132617 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVW2MZkr),
     /* 132620 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132622 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 132624 */   GIR_RootConstrainSelectedInstOperands,
     /* 132625 */   // GIR_Coverage, 12598,
     /* 132625 */   GIR_EraseRootFromParent_Done,
     /* 132626 */ // Label 2887: @132626
     /* 132626 */ GIM_Try, /*On fail goto*//*Label 2888*/ GIMT_Encode4(132749), // Rule ID 21651 //
     /* 132631 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 132634 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 132637 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s8,
     /* 132640 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 132644 */   // MIs[0] Operand 1
     /* 132644 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 132649 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 132653 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132659 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132661 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 132665 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132667 */   // (setcc:{ *:[v32i1] } immAllZerosV:{ *:[v32i8] }, VR256X:{ *:[v32i8] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v32i1] } (VPMOVB2MZkr:{ *:[v64i1] } (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR256X:{ *:[v32i8] }:$src, sub_ymm:{ *:[i32] })), VK32:{ *:[i32] })
     /* 132667 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 132670 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 132674 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132679 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 132681 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s8,
     /* 132684 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 132688 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132693 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 132696 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 132700 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 132703 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 132708 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 132713 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 132718 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s1,
     /* 132721 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVB2MZkr),
     /* 132725 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132730 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132733 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132735 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132738 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132740 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132743 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK32RegClassID),
     /* 132748 */   // GIR_Coverage, 21651,
     /* 132748 */   GIR_EraseRootFromParent_Done,
     /* 132749 */ // Label 2888: @132749
     /* 132749 */ GIM_Reject,
     /* 132750 */ // Label 2867: @132750
     /* 132750 */ GIM_Try, /*On fail goto*//*Label 2889*/ GIMT_Encode4(132800), // Rule ID 12595 //
     /* 132755 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 132758 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 132761 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v64s8,
     /* 132764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 132768 */   // MIs[0] Operand 1
     /* 132768 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 132773 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 132777 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132783 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132785 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 132789 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132791 */   // (setcc:{ *:[v64i1] } immAllZerosV:{ *:[v64i8] }, VR512:{ *:[v64i8] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVB2MZkr:{ *:[v64i1] } VR512:{ *:[v64i8] }:$src)
     /* 132791 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVB2MZkr),
     /* 132794 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132796 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 132798 */   GIR_RootConstrainSelectedInstOperands,
     /* 132799 */   // GIR_Coverage, 12595,
     /* 132799 */   GIR_EraseRootFromParent_Done,
     /* 132800 */ // Label 2889: @132800
     /* 132800 */ GIM_Reject,
     /* 132801 */ // Label 2868: @132801
     /* 132801 */ GIM_Reject,
     /* 132802 */ // Label 34: @132802
     /* 132802 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 2902*/ GIMT_Encode4(140467),
     /* 132813 */ /*GILLT_v2s64*//*Label 2890*/ GIMT_Encode4(132881), GIMT_Encode4(0),
     /* 132821 */ /*GILLT_v4s32*//*Label 2891*/ GIMT_Encode4(133745),
     /* 132825 */ /*GILLT_v4s64*//*Label 2892*/ GIMT_Encode4(134609), GIMT_Encode4(0),
     /* 132833 */ /*GILLT_v8s16*//*Label 2893*/ GIMT_Encode4(135389),
     /* 132837 */ /*GILLT_v8s32*//*Label 2894*/ GIMT_Encode4(136547),
     /* 132841 */ /*GILLT_v8s64*//*Label 2895*/ GIMT_Encode4(137327), GIMT_Encode4(0),
     /* 132849 */ /*GILLT_v16s8*//*Label 2896*/ GIMT_Encode4(137708),
     /* 132853 */ /*GILLT_v16s16*//*Label 2897*/ GIMT_Encode4(138148),
     /* 132857 */ /*GILLT_v16s32*//*Label 2898*/ GIMT_Encode4(139218), GIMT_Encode4(0),
     /* 132865 */ /*GILLT_v32s8*//*Label 2899*/ GIMT_Encode4(139559),
     /* 132869 */ /*GILLT_v32s16*//*Label 2900*/ GIMT_Encode4(139963), GIMT_Encode4(0),
     /* 132877 */ /*GILLT_v64s8*//*Label 2901*/ GIMT_Encode4(140381),
     /* 132881 */ // Label 2890: @132881
     /* 132881 */ GIM_Try, /*On fail goto*//*Label 2903*/ GIMT_Encode4(133744),
     /* 132886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /* 132889 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 132892 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 132895 */   GIM_Try, /*On fail goto*//*Label 2904*/ GIMT_Encode4(132940), // Rule ID 4489 //
     /* 132900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 132903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 132907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 132911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 132915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 132919 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132925 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132929 */     // (vselect:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src, immAllZerosV:{ *:[v2f64] })  =>  (VMOVAPDZ128rrkz:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src)
     /* 132929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ128rrkz),
     /* 132932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132934 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 132936 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 132938 */     GIR_RootConstrainSelectedInstOperands,
     /* 132939 */     // GIR_Coverage, 4489,
     /* 132939 */     GIR_EraseRootFromParent_Done,
     /* 132940 */   // Label 2904: @132940
     /* 132940 */   GIM_Try, /*On fail goto*//*Label 2905*/ GIMT_Encode4(132985), // Rule ID 4543 //
     /* 132945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 132948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 132952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 132956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 132960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 132964 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132970 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132972 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132974 */     // (vselect:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src, immAllZerosV:{ *:[v2i64] })  =>  (VMOVDQA64Z128rrkz:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src)
     /* 132974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128rrkz),
     /* 132977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132979 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 132981 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 132983 */     GIR_RootConstrainSelectedInstOperands,
     /* 132984 */     // GIR_Coverage, 4543,
     /* 132984 */     GIR_EraseRootFromParent_Done,
     /* 132985 */   // Label 2905: @132985
     /* 132985 */   GIM_Try, /*On fail goto*//*Label 2906*/ GIMT_Encode4(133134), // Rule ID 19777 //
     /* 132990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 132993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 132997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 133001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 133009 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 133015 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 133017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133019 */     // (vselect:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src1, immAllZerosV:{ *:[v2f64] })  =>  (EXTRACT_SUBREG:{ *:[v2f64] } (VMOVAPDZrrkz:{ *:[v8f64] } (COPY_TO_REGCLASS:{ *:[v8i1] } VK2WM:{ *:[v2i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8f64] } (IMPLICIT_DEF:{ *:[v8f64] }), VR128X:{ *:[v2f64] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 133019 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 133022 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 133026 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133031 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 133033 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 133036 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 133040 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133045 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 133048 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 133052 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 133055 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 133060 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133065 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 133070 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s1,
     /* 133073 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133077 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133082 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 133086 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 133091 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 133094 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZrrkz),
     /* 133098 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133103 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 133106 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 133109 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 133111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133116 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 133123 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 133128 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133133 */     // GIR_Coverage, 19777,
     /* 133133 */     GIR_EraseRootFromParent_Done,
     /* 133134 */   // Label 2906: @133134
     /* 133134 */   GIM_Try, /*On fail goto*//*Label 2907*/ GIMT_Encode4(133283), // Rule ID 19779 //
     /* 133139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 133142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 133146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 133150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 133158 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 133164 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 133166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133168 */     // (vselect:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src1, immAllZerosV:{ *:[v2i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VMOVDQA64Zrrkz:{ *:[v8i64] } (COPY_TO_REGCLASS:{ *:[v8i1] } VK2WM:{ *:[v2i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 133168 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 133171 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 133175 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133180 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 133182 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 133185 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 133189 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133194 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 133197 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 133201 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 133204 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 133209 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133214 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 133219 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s1,
     /* 133222 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133226 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133231 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 133235 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 133240 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 133243 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrkz),
     /* 133247 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133252 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 133255 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 133258 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 133260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133265 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 133272 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 133277 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133282 */     // GIR_Coverage, 19779,
     /* 133282 */     GIR_EraseRootFromParent_Done,
     /* 133283 */   // Label 2907: @133283
     /* 133283 */   GIM_Try, /*On fail goto*//*Label 2908*/ GIMT_Encode4(133320), // Rule ID 4491 //
     /* 133288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 133291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 133299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133307 */     // (vselect:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src0)  =>  (VMOVAPDZ128rrk:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src0, VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src1)
     /* 133307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ128rrk),
     /* 133310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133312 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 133314 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 133316 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 133318 */     GIR_RootConstrainSelectedInstOperands,
     /* 133319 */     // GIR_Coverage, 4491,
     /* 133319 */     GIR_EraseRootFromParent_Done,
     /* 133320 */   // Label 2908: @133320
     /* 133320 */   GIM_Try, /*On fail goto*//*Label 2909*/ GIMT_Encode4(133357), // Rule ID 4545 //
     /* 133325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 133328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133332 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 133336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133344 */     // (vselect:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src0)  =>  (VMOVDQA64Z128rrk:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src0, VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src1)
     /* 133344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128rrk),
     /* 133347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133349 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 133351 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 133353 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 133355 */     GIR_RootConstrainSelectedInstOperands,
     /* 133356 */     // GIR_Coverage, 4545,
     /* 133356 */     GIR_EraseRootFromParent_Done,
     /* 133357 */   // Label 2909: @133357
     /* 133357 */   GIM_Try, /*On fail goto*//*Label 2910*/ GIMT_Encode4(133550), // Rule ID 19776 //
     /* 133362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 133365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 133369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 133373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133381 */     // (vselect:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v2f64] } (VMOVAPDZrrk:{ *:[v8f64] } (INSERT_SUBREG:{ *:[v8f64] } (IMPLICIT_DEF:{ *:[v8f64] }), VR128X:{ *:[v2f64] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v8i1] } VK2WM:{ *:[v2i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8f64] } (IMPLICIT_DEF:{ *:[v8f64] }), VR128X:{ *:[v2f64] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 133381 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /* 133384 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 133388 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 133395 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 133398 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 133402 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133407 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 133410 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 133414 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 133417 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 133422 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133427 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 133432 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s1,
     /* 133435 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133439 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133444 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 133448 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 133453 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 133456 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 133460 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133465 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 133467 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 133470 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 133474 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133479 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 133482 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 133486 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 133489 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 133494 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133499 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 133504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 133507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZrrk),
     /* 133511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133516 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 133519 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 133522 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 133525 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 133527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133532 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 133539 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 133544 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133549 */     // GIR_Coverage, 19776,
     /* 133549 */     GIR_EraseRootFromParent_Done,
     /* 133550 */   // Label 2910: @133550
     /* 133550 */   GIM_Try, /*On fail goto*//*Label 2911*/ GIMT_Encode4(133743), // Rule ID 19778 //
     /* 133555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 133558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 133562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 133566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133574 */     // (vselect:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VMOVDQA64Zrrk:{ *:[v8i64] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v8i1] } VK2WM:{ *:[v2i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 133574 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /* 133577 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 133581 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 133588 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 133591 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 133595 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133600 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 133603 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 133607 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 133610 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 133615 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133620 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 133625 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s1,
     /* 133628 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133632 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133637 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 133641 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 133646 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 133649 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 133653 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 133660 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 133663 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 133667 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133672 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 133675 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 133679 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 133682 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 133687 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133692 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 133697 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 133700 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrk),
     /* 133704 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133709 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 133712 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 133715 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 133718 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 133720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133725 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 133732 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 133737 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133742 */     // GIR_Coverage, 19778,
     /* 133742 */     GIR_EraseRootFromParent_Done,
     /* 133743 */   // Label 2911: @133743
     /* 133743 */   GIM_Reject,
     /* 133744 */ // Label 2903: @133744
     /* 133744 */ GIM_Reject,
     /* 133745 */ // Label 2891: @133745
     /* 133745 */ GIM_Try, /*On fail goto*//*Label 2912*/ GIMT_Encode4(134608),
     /* 133750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 133753 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 133756 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 133759 */   GIM_Try, /*On fail goto*//*Label 2913*/ GIMT_Encode4(133804), // Rule ID 4471 //
     /* 133764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 133767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 133775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 133783 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 133789 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 133791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133793 */     // (vselect:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src, immAllZerosV:{ *:[v4f32] })  =>  (VMOVAPSZ128rrkz:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src)
     /* 133793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ128rrkz),
     /* 133796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133798 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 133800 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 133802 */     GIR_RootConstrainSelectedInstOperands,
     /* 133803 */     // GIR_Coverage, 4471,
     /* 133803 */     GIR_EraseRootFromParent_Done,
     /* 133804 */   // Label 2913: @133804
     /* 133804 */   GIM_Try, /*On fail goto*//*Label 2914*/ GIMT_Encode4(133849), // Rule ID 4529 //
     /* 133809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 133812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 133820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 133828 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 133834 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 133836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133838 */     // (vselect:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src, immAllZerosV:{ *:[v4i32] })  =>  (VMOVDQA32Z128rrkz:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src)
     /* 133838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Z128rrkz),
     /* 133841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133843 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 133845 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 133847 */     GIR_RootConstrainSelectedInstOperands,
     /* 133848 */     // GIR_Coverage, 4529,
     /* 133848 */     GIR_EraseRootFromParent_Done,
     /* 133849 */   // Label 2914: @133849
     /* 133849 */   GIM_Try, /*On fail goto*//*Label 2915*/ GIMT_Encode4(133998), // Rule ID 19769 //
     /* 133854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 133857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 133861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 133865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 133873 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 133879 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 133881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133883 */     // (vselect:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src1, immAllZerosV:{ *:[v4f32] })  =>  (EXTRACT_SUBREG:{ *:[v4f32] } (VMOVAPSZrrkz:{ *:[v16f32] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4WM:{ *:[v4i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16f32] } (IMPLICIT_DEF:{ *:[v16f32] }), VR128X:{ *:[v4f32] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 133883 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 133886 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 133890 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133895 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 133897 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 133900 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 133904 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133909 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 133912 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 133916 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 133919 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 133924 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133929 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 133934 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 133937 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133941 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133946 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 133950 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 133955 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 133958 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrrkz),
     /* 133962 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133967 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 133970 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 133973 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 133975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133980 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 133987 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 133992 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133997 */     // GIR_Coverage, 19769,
     /* 133997 */     GIR_EraseRootFromParent_Done,
     /* 133998 */   // Label 2915: @133998
     /* 133998 */   GIM_Try, /*On fail goto*//*Label 2916*/ GIMT_Encode4(134147), // Rule ID 19771 //
     /* 134003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 134006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 134010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 134014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 134018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 134022 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 134028 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 134030 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134032 */     // (vselect:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src1, immAllZerosV:{ *:[v4i32] })  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VMOVDQA32Zrrkz:{ *:[v16i32] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4WM:{ *:[v4i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 134032 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 134035 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 134039 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134044 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 134046 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 134049 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 134053 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134058 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 134061 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 134065 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 134068 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 134073 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134078 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 134083 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 134086 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134090 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134095 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 134099 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 134104 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 134107 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrkz),
     /* 134111 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134116 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 134119 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 134122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 134124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134129 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 134136 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 134141 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134146 */     // GIR_Coverage, 19771,
     /* 134146 */     GIR_EraseRootFromParent_Done,
     /* 134147 */   // Label 2916: @134147
     /* 134147 */   GIM_Try, /*On fail goto*//*Label 2917*/ GIMT_Encode4(134184), // Rule ID 4473 //
     /* 134152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 134155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 134159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 134163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 134167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 134171 */     // (vselect:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src0)  =>  (VMOVAPSZ128rrk:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src0, VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src1)
     /* 134171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ128rrk),
     /* 134174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134176 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 134178 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 134180 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 134182 */     GIR_RootConstrainSelectedInstOperands,
     /* 134183 */     // GIR_Coverage, 4473,
     /* 134183 */     GIR_EraseRootFromParent_Done,
     /* 134184 */   // Label 2917: @134184
     /* 134184 */   GIM_Try, /*On fail goto*//*Label 2918*/ GIMT_Encode4(134221), // Rule ID 4530 //
     /* 134189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 134192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 134196 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 134200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 134204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 134208 */     // (vselect:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src0)  =>  (VMOVDQA32Z128rrk:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src0, VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src1)
     /* 134208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Z128rrk),
     /* 134211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134213 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 134215 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 134217 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 134219 */     GIR_RootConstrainSelectedInstOperands,
     /* 134220 */     // GIR_Coverage, 4530,
     /* 134220 */     GIR_EraseRootFromParent_Done,
     /* 134221 */   // Label 2918: @134221
     /* 134221 */   GIM_Try, /*On fail goto*//*Label 2919*/ GIMT_Encode4(134414), // Rule ID 19768 //
     /* 134226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 134229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 134233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 134237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 134241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 134245 */     // (vselect:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v4f32] } (VMOVAPSZrrk:{ *:[v16f32] } (INSERT_SUBREG:{ *:[v16f32] } (IMPLICIT_DEF:{ *:[v16f32] }), VR128X:{ *:[v4f32] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4WM:{ *:[v4i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16f32] } (IMPLICIT_DEF:{ *:[v16f32] }), VR128X:{ *:[v4f32] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 134245 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v16s32,
     /* 134248 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 134252 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134257 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 134259 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 134262 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 134266 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134271 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 134274 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 134278 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 134281 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 134286 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134291 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 134296 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s1,
     /* 134299 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134303 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134308 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 134312 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 134317 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 134320 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 134324 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134329 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 134331 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 134334 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 134338 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134343 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 134346 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 134350 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 134353 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 134358 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134363 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 134368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 134371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrrk),
     /* 134375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134380 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 134383 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 134386 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 134389 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 134391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134396 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 134403 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 134408 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134413 */     // GIR_Coverage, 19768,
     /* 134413 */     GIR_EraseRootFromParent_Done,
     /* 134414 */   // Label 2919: @134414
     /* 134414 */   GIM_Try, /*On fail goto*//*Label 2920*/ GIMT_Encode4(134607), // Rule ID 19770 //
     /* 134419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 134422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 134426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 134430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 134434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 134438 */     // (vselect:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VMOVDQA32Zrrk:{ *:[v16i32] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4WM:{ *:[v4i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 134438 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v16s32,
     /* 134441 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 134445 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134450 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 134452 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 134455 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 134459 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134464 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 134467 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 134471 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 134474 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 134479 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134484 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 134489 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s1,
     /* 134492 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134496 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134501 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 134505 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 134510 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 134513 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 134517 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134522 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 134524 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 134527 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 134531 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134536 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 134539 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 134543 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 134546 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 134551 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134556 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 134561 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 134564 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrk),
     /* 134568 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134573 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 134576 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 134579 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 134582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 134584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134589 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 134596 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 134601 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134606 */     // GIR_Coverage, 19770,
     /* 134606 */     GIR_EraseRootFromParent_Done,
     /* 134607 */   // Label 2920: @134607
     /* 134607 */   GIM_Reject,
     /* 134608 */ // Label 2912: @134608
     /* 134608 */ GIM_Reject,
     /* 134609 */ // Label 2892: @134609
     /* 134609 */ GIM_Try, /*On fail goto*//*Label 2921*/ GIMT_Encode4(135388),
     /* 134614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 134617 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 134620 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 134623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 134627 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 134631 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 134635 */   GIM_Try, /*On fail goto*//*Label 2922*/ GIMT_Encode4(134668), // Rule ID 4484 //
     /* 134640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 134643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 134647 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 134653 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 134655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134657 */     // (vselect:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src, immAllZerosV:{ *:[v4f64] })  =>  (VMOVAPDZ256rrkz:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src)
     /* 134657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ256rrkz),
     /* 134660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134662 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 134664 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 134666 */     GIR_RootConstrainSelectedInstOperands,
     /* 134667 */     // GIR_Coverage, 4484,
     /* 134667 */     GIR_EraseRootFromParent_Done,
     /* 134668 */   // Label 2922: @134668
     /* 134668 */   GIM_Try, /*On fail goto*//*Label 2923*/ GIMT_Encode4(134701), // Rule ID 4538 //
     /* 134673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 134676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 134680 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 134686 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 134688 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134690 */     // (vselect:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src, immAllZerosV:{ *:[v4i64] })  =>  (VMOVDQA64Z256rrkz:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src)
     /* 134690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256rrkz),
     /* 134693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134695 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 134697 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 134699 */     GIR_RootConstrainSelectedInstOperands,
     /* 134700 */     // GIR_Coverage, 4538,
     /* 134700 */     GIR_EraseRootFromParent_Done,
     /* 134701 */   // Label 2923: @134701
     /* 134701 */   GIM_Try, /*On fail goto*//*Label 2924*/ GIMT_Encode4(134838), // Rule ID 19781 //
     /* 134706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 134709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 134713 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 134719 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 134721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134723 */     // (vselect:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src1, immAllZerosV:{ *:[v4f64] })  =>  (EXTRACT_SUBREG:{ *:[v4f64] } (VMOVAPDZrrkz:{ *:[v8f64] } (COPY_TO_REGCLASS:{ *:[v8i1] } VK4WM:{ *:[v4i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8f64] } (IMPLICIT_DEF:{ *:[v8f64] }), VR256X:{ *:[v4f64] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 134723 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 134726 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 134730 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134735 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 134737 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 134740 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 134744 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134749 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 134752 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 134756 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 134759 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 134764 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134769 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 134774 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s1,
     /* 134777 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134781 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134786 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 134790 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 134795 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 134798 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZrrkz),
     /* 134802 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134807 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 134810 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 134813 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 134815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134820 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 134827 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 134832 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134837 */     // GIR_Coverage, 19781,
     /* 134837 */     GIR_EraseRootFromParent_Done,
     /* 134838 */   // Label 2924: @134838
     /* 134838 */   GIM_Try, /*On fail goto*//*Label 2925*/ GIMT_Encode4(134975), // Rule ID 19783 //
     /* 134843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 134846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 134850 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 134856 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 134858 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134860 */     // (vselect:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src1, immAllZerosV:{ *:[v4i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VMOVDQA64Zrrkz:{ *:[v8i64] } (COPY_TO_REGCLASS:{ *:[v8i1] } VK4WM:{ *:[v4i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 134860 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 134863 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 134867 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134872 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 134874 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 134877 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 134881 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134886 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 134889 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 134893 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 134896 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 134901 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134906 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 134911 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s1,
     /* 134914 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134918 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134923 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 134927 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 134932 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 134935 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrkz),
     /* 134939 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134944 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 134947 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 134950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 134952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134957 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 134964 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 134969 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134974 */     // GIR_Coverage, 19783,
     /* 134974 */     GIR_EraseRootFromParent_Done,
     /* 134975 */   // Label 2925: @134975
     /* 134975 */   GIM_Try, /*On fail goto*//*Label 2926*/ GIMT_Encode4(135000), // Rule ID 4486 //
     /* 134980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 134983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 134987 */     // (vselect:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src0)  =>  (VMOVAPDZ256rrk:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src0, VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src1)
     /* 134987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ256rrk),
     /* 134990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134992 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 134994 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 134996 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 134998 */     GIR_RootConstrainSelectedInstOperands,
     /* 134999 */     // GIR_Coverage, 4486,
     /* 134999 */     GIR_EraseRootFromParent_Done,
     /* 135000 */   // Label 2926: @135000
     /* 135000 */   GIM_Try, /*On fail goto*//*Label 2927*/ GIMT_Encode4(135025), // Rule ID 4540 //
     /* 135005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 135008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 135012 */     // (vselect:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src0)  =>  (VMOVDQA64Z256rrk:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src0, VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src1)
     /* 135012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256rrk),
     /* 135015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135017 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 135019 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 135021 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 135023 */     GIR_RootConstrainSelectedInstOperands,
     /* 135024 */     // GIR_Coverage, 4540,
     /* 135024 */     GIR_EraseRootFromParent_Done,
     /* 135025 */   // Label 2927: @135025
     /* 135025 */   GIM_Try, /*On fail goto*//*Label 2928*/ GIMT_Encode4(135206), // Rule ID 19780 //
     /* 135030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 135033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 135037 */     // (vselect:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v4f64] } (VMOVAPDZrrk:{ *:[v8f64] } (INSERT_SUBREG:{ *:[v8f64] } (IMPLICIT_DEF:{ *:[v8f64] }), VR256X:{ *:[v4f64] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v8i1] } VK4WM:{ *:[v4i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8f64] } (IMPLICIT_DEF:{ *:[v8f64] }), VR256X:{ *:[v4f64] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 135037 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /* 135040 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 135044 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135049 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 135051 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 135054 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 135058 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135063 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 135066 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 135070 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 135073 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 135078 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 135083 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 135088 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s1,
     /* 135091 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135095 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135100 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 135104 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135109 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 135112 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 135116 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135121 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 135123 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 135126 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 135130 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135135 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 135138 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 135142 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 135145 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 135150 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 135155 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 135160 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 135163 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZrrk),
     /* 135167 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135172 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 135175 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 135178 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 135181 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 135183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135188 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 135195 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 135200 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 135205 */     // GIR_Coverage, 19780,
     /* 135205 */     GIR_EraseRootFromParent_Done,
     /* 135206 */   // Label 2928: @135206
     /* 135206 */   GIM_Try, /*On fail goto*//*Label 2929*/ GIMT_Encode4(135387), // Rule ID 19782 //
     /* 135211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 135214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 135218 */     // (vselect:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VMOVDQA64Zrrk:{ *:[v8i64] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v8i1] } VK4WM:{ *:[v4i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 135218 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /* 135221 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 135225 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135230 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 135232 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 135235 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 135239 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135244 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 135247 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 135251 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 135254 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 135259 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 135264 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 135269 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s1,
     /* 135272 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135276 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135281 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 135285 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135290 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 135293 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 135297 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135302 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 135304 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 135307 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 135311 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135316 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 135319 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 135323 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 135326 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 135331 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 135336 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 135341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 135344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrk),
     /* 135348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135353 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 135356 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 135359 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 135362 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 135364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135369 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 135376 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 135381 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 135386 */     // GIR_Coverage, 19782,
     /* 135386 */     GIR_EraseRootFromParent_Done,
     /* 135387 */   // Label 2929: @135387
     /* 135387 */   GIM_Reject,
     /* 135388 */ // Label 2921: @135388
     /* 135388 */ GIM_Reject,
     /* 135389 */ // Label 2893: @135389
     /* 135389 */ GIM_Try, /*On fail goto*//*Label 2930*/ GIMT_Encode4(136546),
     /* 135394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 135397 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 135400 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 135403 */   GIM_Try, /*On fail goto*//*Label 2931*/ GIMT_Encode4(135482), // Rule ID 19867 //
     /* 135408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 135411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135415 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 135423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 135427 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135430 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 135434 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 135438 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /* 135442 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 135446 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 135452 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /* 135454 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 135456 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 135463 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>, immAllZerosV:{ *:[v8f16] })  =>  (VMOVDQU16Z128rmkz:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 135463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rmkz),
     /* 135466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135468 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 135470 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 135474 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 135480 */     GIR_RootConstrainSelectedInstOperands,
     /* 135481 */     // GIR_Coverage, 19867,
     /* 135481 */     GIR_EraseRootFromParent_Done,
     /* 135482 */   // Label 2931: @135482
     /* 135482 */   GIM_Try, /*On fail goto*//*Label 2932*/ GIMT_Encode4(135557), // Rule ID 19869 //
     /* 135487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 135490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 135502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 135506 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135509 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 135513 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 135517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 135521 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 135527 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /* 135529 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 135531 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 135538 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, immAllZerosV:{ *:[v8f16] })  =>  (VMOVDQU16Z128rmkz:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 135538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rmkz),
     /* 135541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135543 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 135545 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 135549 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 135555 */     GIR_RootConstrainSelectedInstOperands,
     /* 135556 */     // GIR_Coverage, 19869,
     /* 135556 */     GIR_EraseRootFromParent_Done,
     /* 135557 */   // Label 2932: @135557
     /* 135557 */   GIM_Try, /*On fail goto*//*Label 2933*/ GIMT_Encode4(135629), // Rule ID 19866 //
     /* 135562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 135565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 135577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 135581 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135584 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 135588 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 135592 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /* 135596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135602 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 135609 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>, VR128X:{ *:[v8f16] }:$src0)  =>  (VMOVDQU16Z128rmk:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src0, VK8WM:{ *:[v8i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 135609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rmk),
     /* 135612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135614 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 135616 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 135618 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 135622 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 135627 */     GIR_RootConstrainSelectedInstOperands,
     /* 135628 */     // GIR_Coverage, 19866,
     /* 135628 */     GIR_EraseRootFromParent_Done,
     /* 135629 */   // Label 2933: @135629
     /* 135629 */   GIM_Try, /*On fail goto*//*Label 2934*/ GIMT_Encode4(135697), // Rule ID 19868 //
     /* 135634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 135637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 135649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 135653 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135656 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 135660 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 135664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135670 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 135677 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8f16] }:$src0)  =>  (VMOVDQU16Z128rmk:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src0, VK8WM:{ *:[v8i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 135677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rmk),
     /* 135680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135682 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 135684 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 135686 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 135690 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 135695 */     GIR_RootConstrainSelectedInstOperands,
     /* 135696 */     // GIR_Coverage, 19868,
     /* 135696 */     GIR_EraseRootFromParent_Done,
     /* 135697 */   // Label 2934: @135697
     /* 135697 */   GIM_Try, /*On fail goto*//*Label 2935*/ GIMT_Encode4(135742), // Rule ID 4571 //
     /* 135702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 135705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 135721 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 135727 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 135729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135731 */     // (vselect:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src, immAllZerosV:{ *:[v8i16] })  =>  (VMOVDQU16Z128rrkz:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src)
     /* 135731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rrkz),
     /* 135734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135736 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 135738 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 135740 */     GIR_RootConstrainSelectedInstOperands,
     /* 135741 */     // GIR_Coverage, 4571,
     /* 135741 */     GIR_EraseRootFromParent_Done,
     /* 135742 */   // Label 2935: @135742
     /* 135742 */   GIM_Try, /*On fail goto*//*Label 2936*/ GIMT_Encode4(135891), // Rule ID 19789 //
     /* 135747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 135750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 135754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 135766 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 135772 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 135774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135776 */     // (vselect:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src1, immAllZerosV:{ *:[v8i16] })  =>  (EXTRACT_SUBREG:{ *:[v8i16] } (VMOVDQU16Zrrkz:{ *:[v32i16] } (COPY_TO_REGCLASS:{ *:[v32i1] } VK8WM:{ *:[v8i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR128X:{ *:[v8i16] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 135776 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s16,
     /* 135779 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 135783 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135788 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 135790 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 135793 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 135797 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135802 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 135805 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 135809 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 135812 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 135817 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 135822 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 135827 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s1,
     /* 135830 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135834 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135839 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 135843 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 135848 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 135851 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrkz),
     /* 135855 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135860 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 135863 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 135866 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 135868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135873 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 135880 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 135885 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 135890 */     // GIR_Coverage, 19789,
     /* 135890 */     GIR_EraseRootFromParent_Done,
     /* 135891 */   // Label 2936: @135891
     /* 135891 */   GIM_Try, /*On fail goto*//*Label 2937*/ GIMT_Encode4(136040), // Rule ID 19793 //
     /* 135896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 135899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 135903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 135915 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 135921 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 135923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135925 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8f16] }:$src1, immAllZerosV:{ *:[v8f16] })  =>  (EXTRACT_SUBREG:{ *:[v8f16] } (VMOVDQU16Zrrkz:{ *:[v32f16] } (COPY_TO_REGCLASS:{ *:[v32i1] } VK8WM:{ *:[v8i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32f16] } (IMPLICIT_DEF:{ *:[v32f16] }), VR128X:{ *:[v8f16] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 135925 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s16,
     /* 135928 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 135932 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135937 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 135939 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 135942 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 135946 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135951 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 135954 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 135958 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 135961 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 135966 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 135971 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 135976 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s1,
     /* 135979 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135983 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135988 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 135992 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 135997 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 136000 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrkz),
     /* 136004 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136009 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 136012 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 136015 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 136017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136022 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 136029 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 136034 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136039 */     // GIR_Coverage, 19793,
     /* 136039 */     GIR_EraseRootFromParent_Done,
     /* 136040 */   // Label 2937: @136040
     /* 136040 */   GIM_Try, /*On fail goto*//*Label 2938*/ GIMT_Encode4(136085), // Rule ID 19865 //
     /* 136045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 136048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 136052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 136056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 136060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 136064 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 136070 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 136072 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136074 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8f16] }:$src1, immAllZerosV:{ *:[v8f16] })  =>  (VMOVDQU16Z128rrkz:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8f16] }:$src1)
     /* 136074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rrkz),
     /* 136077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136079 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 136081 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 136083 */     GIR_RootConstrainSelectedInstOperands,
     /* 136084 */     // GIR_Coverage, 19865,
     /* 136084 */     GIR_EraseRootFromParent_Done,
     /* 136085 */   // Label 2938: @136085
     /* 136085 */   GIM_Try, /*On fail goto*//*Label 2939*/ GIMT_Encode4(136122), // Rule ID 4572 //
     /* 136090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 136093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 136097 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 136101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 136105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 136109 */     // (vselect:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src0)  =>  (VMOVDQU16Z128rrk:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src0, VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src1)
     /* 136109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rrk),
     /* 136112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136114 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 136116 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 136118 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 136120 */     GIR_RootConstrainSelectedInstOperands,
     /* 136121 */     // GIR_Coverage, 4572,
     /* 136121 */     GIR_EraseRootFromParent_Done,
     /* 136122 */   // Label 2939: @136122
     /* 136122 */   GIM_Try, /*On fail goto*//*Label 2940*/ GIMT_Encode4(136315), // Rule ID 19788 //
     /* 136127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 136130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 136134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 136138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 136142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 136146 */     // (vselect:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v8i16] } (VMOVDQU16Zrrk:{ *:[v32i16] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR128X:{ *:[v8i16] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v32i1] } VK8WM:{ *:[v8i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR128X:{ *:[v8i16] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 136146 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v32s16,
     /* 136149 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 136153 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136158 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 136160 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v32s16,
     /* 136163 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 136167 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136172 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 136175 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 136179 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 136182 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 136187 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136192 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 136197 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s1,
     /* 136200 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136204 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136209 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 136213 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 136218 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 136221 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 136225 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136230 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 136232 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 136235 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 136239 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136244 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 136247 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 136251 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 136254 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 136259 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136264 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 136269 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 136272 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrk),
     /* 136276 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136281 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 136284 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 136287 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 136290 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 136292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136297 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 136304 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 136309 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136314 */     // GIR_Coverage, 19788,
     /* 136314 */     GIR_EraseRootFromParent_Done,
     /* 136315 */   // Label 2940: @136315
     /* 136315 */   GIM_Try, /*On fail goto*//*Label 2941*/ GIMT_Encode4(136508), // Rule ID 19792 //
     /* 136320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 136323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 136327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 136331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 136335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 136339 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v8f16] } (VMOVDQU16Zrrk:{ *:[v32f16] } (INSERT_SUBREG:{ *:[v32f16] } (IMPLICIT_DEF:{ *:[v32f16] }), VR128X:{ *:[v8f16] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v32i1] } VK8WM:{ *:[v8i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32f16] } (IMPLICIT_DEF:{ *:[v32f16] }), VR128X:{ *:[v8f16] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 136339 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v32s16,
     /* 136342 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 136346 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136351 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 136353 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v32s16,
     /* 136356 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 136360 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136365 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 136368 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 136372 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 136375 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 136380 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136385 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 136390 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s1,
     /* 136393 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136397 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136402 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 136406 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 136411 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 136414 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 136418 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136423 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 136425 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 136428 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 136432 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136437 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 136440 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 136444 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 136447 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 136452 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136457 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 136462 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 136465 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrk),
     /* 136469 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136474 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 136477 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 136480 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 136483 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 136485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136490 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 136497 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 136502 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136507 */     // GIR_Coverage, 19792,
     /* 136507 */     GIR_EraseRootFromParent_Done,
     /* 136508 */   // Label 2941: @136508
     /* 136508 */   GIM_Try, /*On fail goto*//*Label 2942*/ GIMT_Encode4(136545), // Rule ID 19864 //
     /* 136513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 136516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 136520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 136524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 136528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 136532 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src0)  =>  (VMOVDQU16Z128rrk:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src0, VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8f16] }:$src1)
     /* 136532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rrk),
     /* 136535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136537 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 136539 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 136541 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 136543 */     GIR_RootConstrainSelectedInstOperands,
     /* 136544 */     // GIR_Coverage, 19864,
     /* 136544 */     GIR_EraseRootFromParent_Done,
     /* 136545 */   // Label 2942: @136545
     /* 136545 */   GIM_Reject,
     /* 136546 */ // Label 2930: @136546
     /* 136546 */ GIM_Reject,
     /* 136547 */ // Label 2894: @136547
     /* 136547 */ GIM_Try, /*On fail goto*//*Label 2943*/ GIMT_Encode4(137326),
     /* 136552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 136555 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 136558 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 136561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 136565 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 136569 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 136573 */   GIM_Try, /*On fail goto*//*Label 2944*/ GIMT_Encode4(136606), // Rule ID 4466 //
     /* 136578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 136581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 136585 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 136591 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 136593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136595 */     // (vselect:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src, immAllZerosV:{ *:[v8f32] })  =>  (VMOVAPSZ256rrkz:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src)
     /* 136595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ256rrkz),
     /* 136598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136600 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 136602 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 136604 */     GIR_RootConstrainSelectedInstOperands,
     /* 136605 */     // GIR_Coverage, 4466,
     /* 136605 */     GIR_EraseRootFromParent_Done,
     /* 136606 */   // Label 2944: @136606
     /* 136606 */   GIM_Try, /*On fail goto*//*Label 2945*/ GIMT_Encode4(136639), // Rule ID 4525 //
     /* 136611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 136614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 136618 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 136624 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 136626 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136628 */     // (vselect:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src, immAllZerosV:{ *:[v8i32] })  =>  (VMOVDQA32Z256rrkz:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src)
     /* 136628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Z256rrkz),
     /* 136631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136633 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 136635 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 136637 */     GIR_RootConstrainSelectedInstOperands,
     /* 136638 */     // GIR_Coverage, 4525,
     /* 136638 */     GIR_EraseRootFromParent_Done,
     /* 136639 */   // Label 2945: @136639
     /* 136639 */   GIM_Try, /*On fail goto*//*Label 2946*/ GIMT_Encode4(136776), // Rule ID 19773 //
     /* 136644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 136647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 136651 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 136657 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 136659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136661 */     // (vselect:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src1, immAllZerosV:{ *:[v8f32] })  =>  (EXTRACT_SUBREG:{ *:[v8f32] } (VMOVAPSZrrkz:{ *:[v16f32] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8WM:{ *:[v8i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16f32] } (IMPLICIT_DEF:{ *:[v16f32] }), VR256X:{ *:[v8f32] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 136661 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 136664 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 136668 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136673 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 136675 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 136678 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 136682 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136687 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 136690 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 136694 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 136697 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 136702 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136707 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 136712 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 136715 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136719 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136724 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 136728 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 136733 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 136736 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrrkz),
     /* 136740 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136745 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 136748 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 136751 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 136753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136758 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 136765 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 136770 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136775 */     // GIR_Coverage, 19773,
     /* 136775 */     GIR_EraseRootFromParent_Done,
     /* 136776 */   // Label 2946: @136776
     /* 136776 */   GIM_Try, /*On fail goto*//*Label 2947*/ GIMT_Encode4(136913), // Rule ID 19775 //
     /* 136781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 136784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 136788 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 136794 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 136796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136798 */     // (vselect:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src1, immAllZerosV:{ *:[v8i32] })  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VMOVDQA32Zrrkz:{ *:[v16i32] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8WM:{ *:[v8i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 136798 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 136801 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 136805 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136810 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 136812 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 136815 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 136819 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136824 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 136827 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 136831 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 136834 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 136839 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136844 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 136849 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 136852 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136856 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136861 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 136865 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 136870 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 136873 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrkz),
     /* 136877 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136882 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 136885 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 136888 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 136890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136895 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 136902 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 136907 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136912 */     // GIR_Coverage, 19775,
     /* 136912 */     GIR_EraseRootFromParent_Done,
     /* 136913 */   // Label 2947: @136913
     /* 136913 */   GIM_Try, /*On fail goto*//*Label 2948*/ GIMT_Encode4(136938), // Rule ID 4468 //
     /* 136918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 136921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 136925 */     // (vselect:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src0)  =>  (VMOVAPSZ256rrk:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src0, VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src1)
     /* 136925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ256rrk),
     /* 136928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136930 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 136932 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 136934 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 136936 */     GIR_RootConstrainSelectedInstOperands,
     /* 136937 */     // GIR_Coverage, 4468,
     /* 136937 */     GIR_EraseRootFromParent_Done,
     /* 136938 */   // Label 2948: @136938
     /* 136938 */   GIM_Try, /*On fail goto*//*Label 2949*/ GIMT_Encode4(136963), // Rule ID 4526 //
     /* 136943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 136946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 136950 */     // (vselect:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src0)  =>  (VMOVDQA32Z256rrk:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src0, VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src1)
     /* 136950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Z256rrk),
     /* 136953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136955 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 136957 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 136959 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 136961 */     GIR_RootConstrainSelectedInstOperands,
     /* 136962 */     // GIR_Coverage, 4526,
     /* 136962 */     GIR_EraseRootFromParent_Done,
     /* 136963 */   // Label 2949: @136963
     /* 136963 */   GIM_Try, /*On fail goto*//*Label 2950*/ GIMT_Encode4(137144), // Rule ID 19772 //
     /* 136968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 136971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 136975 */     // (vselect:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v8f32] } (VMOVAPSZrrk:{ *:[v16f32] } (INSERT_SUBREG:{ *:[v16f32] } (IMPLICIT_DEF:{ *:[v16f32] }), VR256X:{ *:[v8f32] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8WM:{ *:[v8i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16f32] } (IMPLICIT_DEF:{ *:[v16f32] }), VR256X:{ *:[v8f32] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 136975 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v16s32,
     /* 136978 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 136982 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136987 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 136989 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 136992 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 136996 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137001 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 137004 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 137008 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 137011 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 137016 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 137021 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 137026 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s1,
     /* 137029 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137033 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137038 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 137042 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 137047 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 137050 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 137054 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137059 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 137061 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 137064 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 137068 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137073 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 137076 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 137080 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 137083 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 137088 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 137093 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 137098 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 137101 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrrk),
     /* 137105 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137110 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 137113 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 137116 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 137119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 137121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137126 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 137133 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 137138 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 137143 */     // GIR_Coverage, 19772,
     /* 137143 */     GIR_EraseRootFromParent_Done,
     /* 137144 */   // Label 2950: @137144
     /* 137144 */   GIM_Try, /*On fail goto*//*Label 2951*/ GIMT_Encode4(137325), // Rule ID 19774 //
     /* 137149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 137152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 137156 */     // (vselect:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VMOVDQA32Zrrk:{ *:[v16i32] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8WM:{ *:[v8i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 137156 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v16s32,
     /* 137159 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 137163 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137168 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 137170 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 137173 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 137177 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137182 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 137185 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 137189 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 137192 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 137197 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 137202 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 137207 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s1,
     /* 137210 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137214 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137219 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 137223 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 137228 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 137231 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 137235 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137240 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 137242 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 137245 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 137249 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137254 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 137257 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 137261 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 137264 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 137269 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 137274 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 137279 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 137282 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrk),
     /* 137286 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137291 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 137294 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 137297 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 137300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 137302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137307 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 137314 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 137319 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 137324 */     // GIR_Coverage, 19774,
     /* 137324 */     GIR_EraseRootFromParent_Done,
     /* 137325 */   // Label 2951: @137325
     /* 137325 */   GIM_Reject,
     /* 137326 */ // Label 2943: @137326
     /* 137326 */ GIM_Reject,
     /* 137327 */ // Label 2895: @137327
     /* 137327 */ GIM_Try, /*On fail goto*//*Label 2952*/ GIMT_Encode4(137707),
     /* 137332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 137335 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 137338 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /* 137341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 137345 */   GIM_Try, /*On fail goto*//*Label 2953*/ GIMT_Encode4(137414), // Rule ID 19766 //
     /* 137350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 137354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 137358 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 137362 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 137366 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 137371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 137375 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 137381 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 137383 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 137387 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 137393 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /* 137395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 137399 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 137401 */     // (vselect:{ *:[v8i64] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$mask, immAllOnesV:{ *:[v8i1] }), immAllZerosV:{ *:[v8i64] }, VR512:{ *:[v8i64] }:$src)  =>  (VMOVDQA64Zrrkz:{ *:[v8i64] } VK8:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src)
     /* 137401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrkz),
     /* 137404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // mask
     /* 137410 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 137412 */     GIR_RootConstrainSelectedInstOperands,
     /* 137413 */     // GIR_Coverage, 19766,
     /* 137413 */     GIR_EraseRootFromParent_Done,
     /* 137414 */   // Label 2953: @137414
     /* 137414 */   GIM_Try, /*On fail goto*//*Label 2954*/ GIMT_Encode4(137461), // Rule ID 3599 //
     /* 137419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 137422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 137426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 137430 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 137436 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 137438 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 137442 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 137448 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /* 137450 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 137452 */     // (vselect:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, immAllOnesV:{ *:[v8i64] }, immAllZerosV:{ *:[v8i64] })  =>  (AVX512_512_SEXT_MASK_64:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask)
     /* 137452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AVX512_512_SEXT_MASK_64),
     /* 137455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137457 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 137459 */     GIR_RootConstrainSelectedInstOperands,
     /* 137460 */     // GIR_Coverage, 3599,
     /* 137460 */     GIR_EraseRootFromParent_Done,
     /* 137461 */   // Label 2954: @137461
     /* 137461 */   GIM_Try, /*On fail goto*//*Label 2955*/ GIMT_Encode4(137558), // Rule ID 19764 //
     /* 137466 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 137470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 137474 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 137480 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 137482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 137486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137488 */     // (vselect:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, immAllZerosV:{ *:[v8i64] }, VR512:{ *:[v8i64] }:$src)  =>  (VMOVDQA64Zrrkz:{ *:[v8i64] } (COPY_TO_REGCLASS:{ *:[v8i1] } (KNOTWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$mask, VK16:{ *:[i32] })), VK8:{ *:[i32] }), VR512:{ *:[v8i64] }:$src)
     /* 137488 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 137491 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137495 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137500 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 137504 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 137509 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 137512 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /* 137516 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137521 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 137524 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 137526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s1,
     /* 137529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137538 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 137541 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 137546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrkz),
     /* 137549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137551 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137554 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 137556 */     GIR_RootConstrainSelectedInstOperands,
     /* 137557 */     // GIR_Coverage, 19764,
     /* 137557 */     GIR_EraseRootFromParent_Done,
     /* 137558 */   // Label 2955: @137558
     /* 137558 */   GIM_Try, /*On fail goto*//*Label 2956*/ GIMT_Encode4(137599), // Rule ID 4479 //
     /* 137563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 137566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 137570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 137574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 137578 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 137584 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 137586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137588 */     // (vselect:{ *:[v8f64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src, immAllZerosV:{ *:[v8f64] })  =>  (VMOVAPDZrrkz:{ *:[v8f64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src)
     /* 137588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZrrkz),
     /* 137591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137593 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 137595 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 137597 */     GIR_RootConstrainSelectedInstOperands,
     /* 137598 */     // GIR_Coverage, 4479,
     /* 137598 */     GIR_EraseRootFromParent_Done,
     /* 137599 */   // Label 2956: @137599
     /* 137599 */   GIM_Try, /*On fail goto*//*Label 2957*/ GIMT_Encode4(137640), // Rule ID 4533 //
     /* 137604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 137607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 137611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 137615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 137619 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 137625 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 137627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137629 */     // (vselect:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src, immAllZerosV:{ *:[v8i64] })  =>  (VMOVDQA64Zrrkz:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src)
     /* 137629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrkz),
     /* 137632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137634 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 137636 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 137638 */     GIR_RootConstrainSelectedInstOperands,
     /* 137639 */     // GIR_Coverage, 4533,
     /* 137639 */     GIR_EraseRootFromParent_Done,
     /* 137640 */   // Label 2957: @137640
     /* 137640 */   GIM_Try, /*On fail goto*//*Label 2958*/ GIMT_Encode4(137673), // Rule ID 4481 //
     /* 137645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 137648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 137652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 137656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 137660 */     // (vselect:{ *:[v8f64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src0)  =>  (VMOVAPDZrrk:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src0, VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src1)
     /* 137660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZrrk),
     /* 137663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137665 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 137667 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 137669 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 137671 */     GIR_RootConstrainSelectedInstOperands,
     /* 137672 */     // GIR_Coverage, 4481,
     /* 137672 */     GIR_EraseRootFromParent_Done,
     /* 137673 */   // Label 2958: @137673
     /* 137673 */   GIM_Try, /*On fail goto*//*Label 2959*/ GIMT_Encode4(137706), // Rule ID 4535 //
     /* 137678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 137681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 137685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 137689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 137693 */     // (vselect:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src0)  =>  (VMOVDQA64Zrrk:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src0, VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src1)
     /* 137693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrk),
     /* 137696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137698 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 137700 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 137702 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 137704 */     GIR_RootConstrainSelectedInstOperands,
     /* 137705 */     // GIR_Coverage, 4535,
     /* 137705 */     GIR_EraseRootFromParent_Done,
     /* 137706 */   // Label 2959: @137706
     /* 137706 */   GIM_Reject,
     /* 137707 */ // Label 2952: @137707
     /* 137707 */ GIM_Reject,
     /* 137708 */ // Label 2896: @137708
     /* 137708 */ GIM_Try, /*On fail goto*//*Label 2960*/ GIMT_Encode4(138147),
     /* 137713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 137716 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 137719 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 137722 */   GIM_Try, /*On fail goto*//*Label 2961*/ GIMT_Encode4(137767), // Rule ID 4559 //
     /* 137727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 137730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 137734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 137738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 137742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 137746 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 137752 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 137754 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137756 */     // (vselect:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src, immAllZerosV:{ *:[v16i8] })  =>  (VMOVDQU8Z128rrkz:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src)
     /* 137756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Z128rrkz),
     /* 137759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137761 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 137763 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 137765 */     GIR_RootConstrainSelectedInstOperands,
     /* 137766 */     // GIR_Coverage, 4559,
     /* 137766 */     GIR_EraseRootFromParent_Done,
     /* 137767 */   // Label 2961: @137767
     /* 137767 */   GIM_Try, /*On fail goto*//*Label 2962*/ GIMT_Encode4(137916), // Rule ID 19785 //
     /* 137772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 137775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 137779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 137783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 137787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 137791 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 137797 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 137799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137801 */     // (vselect:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src1, immAllZerosV:{ *:[v16i8] })  =>  (EXTRACT_SUBREG:{ *:[v16i8] } (VMOVDQU8Zrrkz:{ *:[v64i8] } (COPY_TO_REGCLASS:{ *:[v64i1] } VK16WM:{ *:[v16i1] }:$mask, VK64WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR128X:{ *:[v16i8] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 137801 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v64s8,
     /* 137804 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 137808 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137813 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 137815 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 137818 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 137822 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137827 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 137830 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 137834 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 137837 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 137842 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 137847 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 137852 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s1,
     /* 137855 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137859 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137864 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 137868 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK64WMRegClassID),
     /* 137873 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 137876 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Zrrkz),
     /* 137880 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137885 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 137888 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 137891 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 137893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137898 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 137905 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 137910 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 137915 */     // GIR_Coverage, 19785,
     /* 137915 */     GIR_EraseRootFromParent_Done,
     /* 137916 */   // Label 2962: @137916
     /* 137916 */   GIM_Try, /*On fail goto*//*Label 2963*/ GIMT_Encode4(137953), // Rule ID 4560 //
     /* 137921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 137924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 137928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 137932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 137936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 137940 */     // (vselect:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src0)  =>  (VMOVDQU8Z128rrk:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src0, VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src1)
     /* 137940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Z128rrk),
     /* 137943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137945 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 137947 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 137949 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 137951 */     GIR_RootConstrainSelectedInstOperands,
     /* 137952 */     // GIR_Coverage, 4560,
     /* 137952 */     GIR_EraseRootFromParent_Done,
     /* 137953 */   // Label 2963: @137953
     /* 137953 */   GIM_Try, /*On fail goto*//*Label 2964*/ GIMT_Encode4(138146), // Rule ID 19784 //
     /* 137958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 137961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 137965 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 137969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 137973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 137977 */     // (vselect:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v16i8] } (VMOVDQU8Zrrk:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR128X:{ *:[v16i8] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v64i1] } VK16WM:{ *:[v16i1] }:$mask, VK64WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR128X:{ *:[v16i8] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 137977 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v64s8,
     /* 137980 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 137984 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137989 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 137991 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v64s8,
     /* 137994 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 137998 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138003 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 138006 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 138010 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 138013 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 138018 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138023 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 138028 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v64s1,
     /* 138031 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138035 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138040 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 138044 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK64WMRegClassID),
     /* 138049 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 138052 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 138056 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138061 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 138063 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s8,
     /* 138066 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 138070 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138075 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 138078 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 138082 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 138085 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 138090 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138095 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 138100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 138103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Zrrk),
     /* 138107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138112 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 138115 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 138118 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 138121 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 138123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138128 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 138135 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 138140 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138145 */     // GIR_Coverage, 19784,
     /* 138145 */     GIR_EraseRootFromParent_Done,
     /* 138146 */   // Label 2964: @138146
     /* 138146 */   GIM_Reject,
     /* 138147 */ // Label 2960: @138147
     /* 138147 */ GIM_Reject,
     /* 138148 */ // Label 2897: @138148
     /* 138148 */ GIM_Try, /*On fail goto*//*Label 2965*/ GIMT_Encode4(139217),
     /* 138153 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 138156 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 138159 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 138162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138166 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 138170 */   GIM_Try, /*On fail goto*//*Label 2966*/ GIMT_Encode4(138241), // Rule ID 19857 //
     /* 138175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 138178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 138182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 138186 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138189 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 138193 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 138197 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /* 138201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 138205 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 138211 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /* 138213 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 138215 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 138222 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>, immAllZerosV:{ *:[v16f16] })  =>  (VMOVDQU16Z256rmkz:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 138222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rmkz),
     /* 138225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138227 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 138229 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 138233 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 138239 */     GIR_RootConstrainSelectedInstOperands,
     /* 138240 */     // GIR_Coverage, 19857,
     /* 138240 */     GIR_EraseRootFromParent_Done,
     /* 138241 */   // Label 2966: @138241
     /* 138241 */   GIM_Try, /*On fail goto*//*Label 2967*/ GIMT_Encode4(138308), // Rule ID 19859 //
     /* 138246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 138249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 138253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 138257 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138260 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 138264 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 138268 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 138272 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 138278 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /* 138280 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 138282 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 138289 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, immAllZerosV:{ *:[v16f16] })  =>  (VMOVDQU16Z256rmkz:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 138289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rmkz),
     /* 138292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138294 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 138296 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 138300 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 138306 */     GIR_RootConstrainSelectedInstOperands,
     /* 138307 */     // GIR_Coverage, 19859,
     /* 138307 */     GIR_EraseRootFromParent_Done,
     /* 138308 */   // Label 2967: @138308
     /* 138308 */   GIM_Try, /*On fail goto*//*Label 2968*/ GIMT_Encode4(138372), // Rule ID 19856 //
     /* 138313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 138316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 138320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 138324 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138327 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 138331 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 138335 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /* 138339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138345 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 138352 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>, VR256X:{ *:[v16f16] }:$src0)  =>  (VMOVDQU16Z256rmk:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src0, VK16WM:{ *:[v16i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 138352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rmk),
     /* 138355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138357 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 138359 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 138361 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 138365 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 138370 */     GIR_RootConstrainSelectedInstOperands,
     /* 138371 */     // GIR_Coverage, 19856,
     /* 138371 */     GIR_EraseRootFromParent_Done,
     /* 138372 */   // Label 2968: @138372
     /* 138372 */   GIM_Try, /*On fail goto*//*Label 2969*/ GIMT_Encode4(138432), // Rule ID 19858 //
     /* 138377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 138380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 138384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 138388 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138391 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 138395 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 138399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138405 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 138412 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16f16] }:$src0)  =>  (VMOVDQU16Z256rmk:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src0, VK16WM:{ *:[v16i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 138412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rmk),
     /* 138415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138417 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 138419 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 138421 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 138425 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 138430 */     GIR_RootConstrainSelectedInstOperands,
     /* 138431 */     // GIR_Coverage, 19858,
     /* 138431 */     GIR_EraseRootFromParent_Done,
     /* 138432 */   // Label 2969: @138432
     /* 138432 */   GIM_Try, /*On fail goto*//*Label 2970*/ GIMT_Encode4(138469), // Rule ID 4567 //
     /* 138437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 138440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 138448 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 138454 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 138456 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138458 */     // (vselect:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src, immAllZerosV:{ *:[v16i16] })  =>  (VMOVDQU16Z256rrkz:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src)
     /* 138458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rrkz),
     /* 138461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138463 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 138465 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 138467 */     GIR_RootConstrainSelectedInstOperands,
     /* 138468 */     // GIR_Coverage, 4567,
     /* 138468 */     GIR_EraseRootFromParent_Done,
     /* 138469 */   // Label 2970: @138469
     /* 138469 */   GIM_Try, /*On fail goto*//*Label 2971*/ GIMT_Encode4(138610), // Rule ID 19791 //
     /* 138474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 138477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 138485 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 138491 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 138493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138495 */     // (vselect:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src1, immAllZerosV:{ *:[v16i16] })  =>  (EXTRACT_SUBREG:{ *:[v16i16] } (VMOVDQU16Zrrkz:{ *:[v32i16] } (COPY_TO_REGCLASS:{ *:[v32i1] } VK16WM:{ *:[v16i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR256X:{ *:[v16i16] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 138495 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s16,
     /* 138498 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 138502 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138507 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 138509 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 138512 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 138516 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138521 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 138524 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 138528 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 138531 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 138536 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138541 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 138546 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s1,
     /* 138549 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138553 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138558 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 138562 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 138567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 138570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrkz),
     /* 138574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138579 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 138582 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 138585 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 138587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138592 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 138599 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 138604 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138609 */     // GIR_Coverage, 19791,
     /* 138609 */     GIR_EraseRootFromParent_Done,
     /* 138610 */   // Label 2971: @138610
     /* 138610 */   GIM_Try, /*On fail goto*//*Label 2972*/ GIMT_Encode4(138751), // Rule ID 19795 //
     /* 138615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 138618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 138626 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 138632 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 138634 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138636 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16f16] }:$src1, immAllZerosV:{ *:[v16f16] })  =>  (EXTRACT_SUBREG:{ *:[v16f16] } (VMOVDQU16Zrrkz:{ *:[v32f16] } (COPY_TO_REGCLASS:{ *:[v32i1] } VK16WM:{ *:[v16i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32f16] } (IMPLICIT_DEF:{ *:[v32f16] }), VR256X:{ *:[v16f16] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 138636 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s16,
     /* 138639 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 138643 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138648 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 138650 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 138653 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 138657 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138662 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 138665 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 138669 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 138672 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 138677 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138682 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 138687 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s1,
     /* 138690 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138694 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138699 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 138703 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 138708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 138711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrkz),
     /* 138715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138720 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 138723 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 138726 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 138728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138733 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 138740 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 138745 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138750 */     // GIR_Coverage, 19795,
     /* 138750 */     GIR_EraseRootFromParent_Done,
     /* 138751 */   // Label 2972: @138751
     /* 138751 */   GIM_Try, /*On fail goto*//*Label 2973*/ GIMT_Encode4(138788), // Rule ID 19855 //
     /* 138756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 138759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 138767 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 138773 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 138775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138777 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16f16] }:$src1, immAllZerosV:{ *:[v16f16] })  =>  (VMOVDQU16Z256rrkz:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16f16] }:$src1)
     /* 138777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rrkz),
     /* 138780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138782 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 138784 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 138786 */     GIR_RootConstrainSelectedInstOperands,
     /* 138787 */     // GIR_Coverage, 19855,
     /* 138787 */     GIR_EraseRootFromParent_Done,
     /* 138788 */   // Label 2973: @138788
     /* 138788 */   GIM_Try, /*On fail goto*//*Label 2974*/ GIMT_Encode4(138817), // Rule ID 4568 //
     /* 138793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 138796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138804 */     // (vselect:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src0)  =>  (VMOVDQU16Z256rrk:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src0, VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src1)
     /* 138804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rrk),
     /* 138807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138809 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 138811 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 138813 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 138815 */     GIR_RootConstrainSelectedInstOperands,
     /* 138816 */     // GIR_Coverage, 4568,
     /* 138816 */     GIR_EraseRootFromParent_Done,
     /* 138817 */   // Label 2974: @138817
     /* 138817 */   GIM_Try, /*On fail goto*//*Label 2975*/ GIMT_Encode4(139002), // Rule ID 19790 //
     /* 138822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 138825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138833 */     // (vselect:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v16i16] } (VMOVDQU16Zrrk:{ *:[v32i16] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR256X:{ *:[v16i16] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v32i1] } VK16WM:{ *:[v16i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR256X:{ *:[v16i16] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 138833 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v32s16,
     /* 138836 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 138840 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138845 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 138847 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v32s16,
     /* 138850 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 138854 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138859 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 138862 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 138866 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 138869 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 138874 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138879 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 138884 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s1,
     /* 138887 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138891 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138896 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 138900 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 138905 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 138908 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 138912 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138917 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 138919 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 138922 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 138926 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138931 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 138934 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 138938 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 138941 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 138946 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138951 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 138956 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 138959 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrk),
     /* 138963 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138968 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 138971 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 138974 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 138977 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 138979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138984 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 138991 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 138996 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 139001 */     // GIR_Coverage, 19790,
     /* 139001 */     GIR_EraseRootFromParent_Done,
     /* 139002 */   // Label 2975: @139002
     /* 139002 */   GIM_Try, /*On fail goto*//*Label 2976*/ GIMT_Encode4(139187), // Rule ID 19794 //
     /* 139007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 139010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 139014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 139018 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v16f16] } (VMOVDQU16Zrrk:{ *:[v32f16] } (INSERT_SUBREG:{ *:[v32f16] } (IMPLICIT_DEF:{ *:[v32f16] }), VR256X:{ *:[v16f16] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v32i1] } VK16WM:{ *:[v16i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32f16] } (IMPLICIT_DEF:{ *:[v32f16] }), VR256X:{ *:[v16f16] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 139018 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v32s16,
     /* 139021 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 139025 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139030 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 139032 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v32s16,
     /* 139035 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 139039 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139044 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 139047 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 139051 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 139054 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 139059 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 139064 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 139069 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s1,
     /* 139072 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139076 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139081 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 139085 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 139090 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 139093 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 139097 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139102 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 139104 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 139107 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 139111 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139116 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 139119 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 139123 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 139126 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 139131 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 139136 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 139141 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 139144 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrk),
     /* 139148 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139153 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 139156 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 139159 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 139162 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 139164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139169 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 139176 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 139181 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 139186 */     // GIR_Coverage, 19794,
     /* 139186 */     GIR_EraseRootFromParent_Done,
     /* 139187 */   // Label 2976: @139187
     /* 139187 */   GIM_Try, /*On fail goto*//*Label 2977*/ GIMT_Encode4(139216), // Rule ID 19854 //
     /* 139192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 139195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 139199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 139203 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src0)  =>  (VMOVDQU16Z256rrk:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src0, VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16f16] }:$src1)
     /* 139203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rrk),
     /* 139206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139208 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 139210 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139212 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 139214 */     GIR_RootConstrainSelectedInstOperands,
     /* 139215 */     // GIR_Coverage, 19854,
     /* 139215 */     GIR_EraseRootFromParent_Done,
     /* 139216 */   // Label 2977: @139216
     /* 139216 */   GIM_Reject,
     /* 139217 */ // Label 2965: @139217
     /* 139217 */ GIM_Reject,
     /* 139218 */ // Label 2898: @139218
     /* 139218 */ GIM_Try, /*On fail goto*//*Label 2978*/ GIMT_Encode4(139558),
     /* 139223 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 139226 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 139229 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /* 139232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139236 */   GIM_Try, /*On fail goto*//*Label 2979*/ GIMT_Encode4(139305), // Rule ID 19767 //
     /* 139241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 139245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 139249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 139253 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s1,
     /* 139257 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 139262 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 139266 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 139272 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 139274 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 139278 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 139284 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /* 139286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139290 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 139292 */     // (vselect:{ *:[v16i32] } (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$mask, immAllOnesV:{ *:[v16i1] }), immAllZerosV:{ *:[v16i32] }, VR512:{ *:[v16i32] }:$src)  =>  (VMOVDQA32Zrrkz:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src)
     /* 139292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrkz),
     /* 139295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // mask
     /* 139301 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 139303 */     GIR_RootConstrainSelectedInstOperands,
     /* 139304 */     // GIR_Coverage, 19767,
     /* 139304 */     GIR_EraseRootFromParent_Done,
     /* 139305 */   // Label 2979: @139305
     /* 139305 */   GIM_Try, /*On fail goto*//*Label 2980*/ GIMT_Encode4(139352), // Rule ID 3598 //
     /* 139310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 139313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 139317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 139321 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 139327 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 139329 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 139333 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 139339 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /* 139341 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 139343 */     // (vselect:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, immAllOnesV:{ *:[v16i32] }, immAllZerosV:{ *:[v16i32] })  =>  (AVX512_512_SEXT_MASK_32:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask)
     /* 139343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AVX512_512_SEXT_MASK_32),
     /* 139346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139348 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139350 */     GIR_RootConstrainSelectedInstOperands,
     /* 139351 */     // GIR_Coverage, 3598,
     /* 139351 */     GIR_EraseRootFromParent_Done,
     /* 139352 */   // Label 2980: @139352
     /* 139352 */   GIM_Try, /*On fail goto*//*Label 2981*/ GIMT_Encode4(139409), // Rule ID 19765 //
     /* 139357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 139361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 139365 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 139371 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 139373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139379 */     // (vselect:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, immAllZerosV:{ *:[v16i32] }, VR512:{ *:[v16i32] }:$src)  =>  (VMOVDQA32Zrrkz:{ *:[v16i32] } (KNOTWkk:{ *:[v16i1] } VK16WM:{ *:[v16i1] }:$mask), VR512:{ *:[v16i32] }:$src)
     /* 139379 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 139382 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /* 139386 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139391 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 139395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 139397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrkz),
     /* 139400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139405 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 139407 */     GIR_RootConstrainSelectedInstOperands,
     /* 139408 */     // GIR_Coverage, 19765,
     /* 139408 */     GIR_EraseRootFromParent_Done,
     /* 139409 */   // Label 2981: @139409
     /* 139409 */   GIM_Try, /*On fail goto*//*Label 2982*/ GIMT_Encode4(139450), // Rule ID 4461 //
     /* 139414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 139417 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 139421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 139429 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 139435 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 139437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139439 */     // (vselect:{ *:[v16f32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src, immAllZerosV:{ *:[v16f32] })  =>  (VMOVAPSZrrkz:{ *:[v16f32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src)
     /* 139439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrrkz),
     /* 139442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139444 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139446 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 139448 */     GIR_RootConstrainSelectedInstOperands,
     /* 139449 */     // GIR_Coverage, 4461,
     /* 139449 */     GIR_EraseRootFromParent_Done,
     /* 139450 */   // Label 2982: @139450
     /* 139450 */   GIM_Try, /*On fail goto*//*Label 2983*/ GIMT_Encode4(139491), // Rule ID 4521 //
     /* 139455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 139458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 139462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 139470 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 139476 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 139478 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139480 */     // (vselect:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src, immAllZerosV:{ *:[v16i32] })  =>  (VMOVDQA32Zrrkz:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src)
     /* 139480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrkz),
     /* 139483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139485 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139487 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 139489 */     GIR_RootConstrainSelectedInstOperands,
     /* 139490 */     // GIR_Coverage, 4521,
     /* 139490 */     GIR_EraseRootFromParent_Done,
     /* 139491 */   // Label 2983: @139491
     /* 139491 */   GIM_Try, /*On fail goto*//*Label 2984*/ GIMT_Encode4(139524), // Rule ID 4463 //
     /* 139496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 139499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 139503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139511 */     // (vselect:{ *:[v16f32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src0)  =>  (VMOVAPSZrrk:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src0, VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src1)
     /* 139511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrrk),
     /* 139514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139516 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 139518 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139520 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 139522 */     GIR_RootConstrainSelectedInstOperands,
     /* 139523 */     // GIR_Coverage, 4463,
     /* 139523 */     GIR_EraseRootFromParent_Done,
     /* 139524 */   // Label 2984: @139524
     /* 139524 */   GIM_Try, /*On fail goto*//*Label 2985*/ GIMT_Encode4(139557), // Rule ID 4522 //
     /* 139529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 139532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 139536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139544 */     // (vselect:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src0)  =>  (VMOVDQA32Zrrk:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src0, VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src1)
     /* 139544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrk),
     /* 139547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139549 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 139551 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139553 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 139555 */     GIR_RootConstrainSelectedInstOperands,
     /* 139556 */     // GIR_Coverage, 4522,
     /* 139556 */     GIR_EraseRootFromParent_Done,
     /* 139557 */   // Label 2985: @139557
     /* 139557 */   GIM_Reject,
     /* 139558 */ // Label 2978: @139558
     /* 139558 */ GIM_Reject,
     /* 139559 */ // Label 2899: @139559
     /* 139559 */ GIM_Try, /*On fail goto*//*Label 2986*/ GIMT_Encode4(139962),
     /* 139564 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 139567 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 139570 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s8,
     /* 139573 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 139577 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32WMRegClassID),
     /* 139581 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 139585 */   GIM_Try, /*On fail goto*//*Label 2987*/ GIMT_Encode4(139618), // Rule ID 4555 //
     /* 139590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 139593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 139597 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 139603 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 139605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139607 */     // (vselect:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src, immAllZerosV:{ *:[v32i8] })  =>  (VMOVDQU8Z256rrkz:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src)
     /* 139607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Z256rrkz),
     /* 139610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139612 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139614 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 139616 */     GIR_RootConstrainSelectedInstOperands,
     /* 139617 */     // GIR_Coverage, 4555,
     /* 139617 */     GIR_EraseRootFromParent_Done,
     /* 139618 */   // Label 2987: @139618
     /* 139618 */   GIM_Try, /*On fail goto*//*Label 2988*/ GIMT_Encode4(139755), // Rule ID 19787 //
     /* 139623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 139626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 139630 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 139636 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 139638 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139640 */     // (vselect:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src1, immAllZerosV:{ *:[v32i8] })  =>  (EXTRACT_SUBREG:{ *:[v32i8] } (VMOVDQU8Zrrkz:{ *:[v64i8] } (COPY_TO_REGCLASS:{ *:[v64i1] } VK32WM:{ *:[v32i1] }:$mask, VK64WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR256X:{ *:[v32i8] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 139640 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v64s8,
     /* 139643 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 139647 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 139654 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 139657 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 139661 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139666 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 139669 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 139673 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 139676 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 139681 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 139686 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 139691 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s1,
     /* 139694 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139698 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139703 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 139707 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK64WMRegClassID),
     /* 139712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 139715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Zrrkz),
     /* 139719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139724 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 139727 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 139730 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 139732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139737 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 139744 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 139749 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 139754 */     // GIR_Coverage, 19787,
     /* 139754 */     GIR_EraseRootFromParent_Done,
     /* 139755 */   // Label 2988: @139755
     /* 139755 */   GIM_Try, /*On fail goto*//*Label 2989*/ GIMT_Encode4(139780), // Rule ID 4556 //
     /* 139760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 139763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 139767 */     // (vselect:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src0)  =>  (VMOVDQU8Z256rrk:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src0, VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src1)
     /* 139767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Z256rrk),
     /* 139770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139772 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 139774 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139776 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 139778 */     GIR_RootConstrainSelectedInstOperands,
     /* 139779 */     // GIR_Coverage, 4556,
     /* 139779 */     GIR_EraseRootFromParent_Done,
     /* 139780 */   // Label 2989: @139780
     /* 139780 */   GIM_Try, /*On fail goto*//*Label 2990*/ GIMT_Encode4(139961), // Rule ID 19786 //
     /* 139785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 139788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 139792 */     // (vselect:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v32i8] } (VMOVDQU8Zrrk:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR256X:{ *:[v32i8] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v64i1] } VK32WM:{ *:[v32i1] }:$mask, VK64WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR256X:{ *:[v32i8] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 139792 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v64s8,
     /* 139795 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 139799 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 139806 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v64s8,
     /* 139809 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 139813 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139818 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 139821 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 139825 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 139828 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 139833 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 139838 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 139843 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v64s1,
     /* 139846 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139850 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139855 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 139859 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK64WMRegClassID),
     /* 139864 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 139867 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 139871 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 139878 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s8,
     /* 139881 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 139885 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139890 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 139893 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 139897 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 139900 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 139905 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 139910 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 139915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 139918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Zrrk),
     /* 139922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139927 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 139930 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 139933 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 139936 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 139938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139943 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 139950 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 139955 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 139960 */     // GIR_Coverage, 19786,
     /* 139960 */     GIR_EraseRootFromParent_Done,
     /* 139961 */   // Label 2990: @139961
     /* 139961 */   GIM_Reject,
     /* 139962 */ // Label 2986: @139962
     /* 139962 */ GIM_Reject,
     /* 139963 */ // Label 2900: @139963
     /* 139963 */ GIM_Try, /*On fail goto*//*Label 2991*/ GIMT_Encode4(140380),
     /* 139968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 139971 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 139974 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s16,
     /* 139977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139981 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32WMRegClassID),
     /* 139985 */   GIM_Try, /*On fail goto*//*Label 2992*/ GIMT_Encode4(140056), // Rule ID 19847 //
     /* 139990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 139993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 139997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140001 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140004 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140008 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140012 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /* 140016 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 140020 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 140026 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /* 140028 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 140030 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140037 */     // (vselect:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>, immAllZerosV:{ *:[v32f16] })  =>  (VMOVDQU16Zrmkz:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 140037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrmkz),
     /* 140040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140042 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 140044 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 140048 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 140054 */     GIR_RootConstrainSelectedInstOperands,
     /* 140055 */     // GIR_Coverage, 19847,
     /* 140055 */     GIR_EraseRootFromParent_Done,
     /* 140056 */   // Label 2992: @140056
     /* 140056 */   GIM_Try, /*On fail goto*//*Label 2993*/ GIMT_Encode4(140123), // Rule ID 19849 //
     /* 140061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 140064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 140068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140072 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140075 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140079 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140083 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 140087 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 140093 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /* 140095 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 140097 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140104 */     // (vselect:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, immAllZerosV:{ *:[v32f16] })  =>  (VMOVDQU16Zrmkz:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 140104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrmkz),
     /* 140107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140109 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 140111 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 140115 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 140121 */     GIR_RootConstrainSelectedInstOperands,
     /* 140122 */     // GIR_Coverage, 19849,
     /* 140122 */     GIR_EraseRootFromParent_Done,
     /* 140123 */   // Label 2993: @140123
     /* 140123 */   GIM_Try, /*On fail goto*//*Label 2994*/ GIMT_Encode4(140187), // Rule ID 19846 //
     /* 140128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 140131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 140135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140139 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140142 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140146 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140150 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /* 140154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140158 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140160 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140167 */     // (vselect:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>, VR512:{ *:[v32f16] }:$src0)  =>  (VMOVDQU16Zrmk:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src0, VK32WM:{ *:[v32i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 140167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrmk),
     /* 140170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140172 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 140174 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 140176 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 140180 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140185 */     GIR_RootConstrainSelectedInstOperands,
     /* 140186 */     // GIR_Coverage, 19846,
     /* 140186 */     GIR_EraseRootFromParent_Done,
     /* 140187 */   // Label 2994: @140187
     /* 140187 */   GIM_Try, /*On fail goto*//*Label 2995*/ GIMT_Encode4(140247), // Rule ID 19848 //
     /* 140192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 140195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 140199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140203 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140206 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140210 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140220 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140227 */     // (vselect:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32f16] }:$src0)  =>  (VMOVDQU16Zrmk:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src0, VK32WM:{ *:[v32i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 140227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrmk),
     /* 140230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140232 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 140234 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 140236 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 140240 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140245 */     GIR_RootConstrainSelectedInstOperands,
     /* 140246 */     // GIR_Coverage, 19848,
     /* 140246 */     GIR_EraseRootFromParent_Done,
     /* 140247 */   // Label 2995: @140247
     /* 140247 */   GIM_Try, /*On fail goto*//*Label 2996*/ GIMT_Encode4(140284), // Rule ID 4563 //
     /* 140252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 140255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 140263 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 140269 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 140271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140273 */     // (vselect:{ *:[v32i16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src, immAllZerosV:{ *:[v32i16] })  =>  (VMOVDQU16Zrrkz:{ *:[v32i16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src)
     /* 140273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrkz),
     /* 140276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140278 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 140280 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 140282 */     GIR_RootConstrainSelectedInstOperands,
     /* 140283 */     // GIR_Coverage, 4563,
     /* 140283 */     GIR_EraseRootFromParent_Done,
     /* 140284 */   // Label 2996: @140284
     /* 140284 */   GIM_Try, /*On fail goto*//*Label 2997*/ GIMT_Encode4(140321), // Rule ID 19845 //
     /* 140289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 140292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 140300 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 140306 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 140308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140310 */     // (vselect:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32f16] }:$src1, immAllZerosV:{ *:[v32f16] })  =>  (VMOVDQU16Zrrkz:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32f16] }:$src1)
     /* 140310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrkz),
     /* 140313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140315 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 140317 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 140319 */     GIR_RootConstrainSelectedInstOperands,
     /* 140320 */     // GIR_Coverage, 19845,
     /* 140320 */     GIR_EraseRootFromParent_Done,
     /* 140321 */   // Label 2997: @140321
     /* 140321 */   GIM_Try, /*On fail goto*//*Label 2998*/ GIMT_Encode4(140350), // Rule ID 4564 //
     /* 140326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 140329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140337 */     // (vselect:{ *:[v32i16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src0)  =>  (VMOVDQU16Zrrk:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src0, VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src1)
     /* 140337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrk),
     /* 140340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140342 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 140344 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 140346 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 140348 */     GIR_RootConstrainSelectedInstOperands,
     /* 140349 */     // GIR_Coverage, 4564,
     /* 140349 */     GIR_EraseRootFromParent_Done,
     /* 140350 */   // Label 2998: @140350
     /* 140350 */   GIM_Try, /*On fail goto*//*Label 2999*/ GIMT_Encode4(140379), // Rule ID 19844 //
     /* 140355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 140358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140366 */     // (vselect:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src0)  =>  (VMOVDQU16Zrrk:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src0, VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32f16] }:$src1)
     /* 140366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrk),
     /* 140369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140371 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 140373 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 140375 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 140377 */     GIR_RootConstrainSelectedInstOperands,
     /* 140378 */     // GIR_Coverage, 19844,
     /* 140378 */     GIR_EraseRootFromParent_Done,
     /* 140379 */   // Label 2999: @140379
     /* 140379 */   GIM_Reject,
     /* 140380 */ // Label 2991: @140380
     /* 140380 */ GIM_Reject,
     /* 140381 */ // Label 2901: @140381
     /* 140381 */ GIM_Try, /*On fail goto*//*Label 3000*/ GIMT_Encode4(140466),
     /* 140386 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 140389 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 140392 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v64s8,
     /* 140395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140399 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64WMRegClassID),
     /* 140403 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140407 */   GIM_Try, /*On fail goto*//*Label 3001*/ GIMT_Encode4(140440), // Rule ID 4551 //
     /* 140412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 140415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 140419 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 140425 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 140427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140429 */     // (vselect:{ *:[v64i8] } VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src, immAllZerosV:{ *:[v64i8] })  =>  (VMOVDQU8Zrrkz:{ *:[v64i8] } VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src)
     /* 140429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Zrrkz),
     /* 140432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140434 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 140436 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 140438 */     GIR_RootConstrainSelectedInstOperands,
     /* 140439 */     // GIR_Coverage, 4551,
     /* 140439 */     GIR_EraseRootFromParent_Done,
     /* 140440 */   // Label 3001: @140440
     /* 140440 */   GIM_Try, /*On fail goto*//*Label 3002*/ GIMT_Encode4(140465), // Rule ID 4552 //
     /* 140445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 140448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140452 */     // (vselect:{ *:[v64i8] } VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src0)  =>  (VMOVDQU8Zrrk:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src0, VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src1)
     /* 140452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Zrrk),
     /* 140455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140457 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 140459 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 140461 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 140463 */     GIR_RootConstrainSelectedInstOperands,
     /* 140464 */     // GIR_Coverage, 4552,
     /* 140464 */     GIR_EraseRootFromParent_Done,
     /* 140465 */   // Label 3002: @140465
     /* 140465 */   GIM_Reject,
     /* 140466 */ // Label 3000: @140466
     /* 140466 */ GIM_Reject,
     /* 140467 */ // Label 2902: @140467
     /* 140467 */ GIM_Reject,
     /* 140468 */ // Label 35: @140468
     /* 140468 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(13), GIMT_Encode2(23), /*)*//*default:*//*Label 3006*/ GIMT_Encode4(141332),
     /* 140479 */ /*GILLT_v8s16*//*Label 3003*/ GIMT_Encode4(140519), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 140499 */ /*GILLT_v16s16*//*Label 3004*/ GIMT_Encode4(140861), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 140515 */ /*GILLT_v32s16*//*Label 3005*/ GIMT_Encode4(141176),
     /* 140519 */ // Label 3003: @140519
     /* 140519 */ GIM_Try, /*On fail goto*//*Label 3007*/ GIMT_Encode4(140860),
     /* 140524 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 140527 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 140530 */   GIM_Try, /*On fail goto*//*Label 3008*/ GIMT_Encode4(140592), // Rule ID 23456 //
     /* 140535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 140538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140550 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140553 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140557 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140567 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140574 */     // (mulhu:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPMULHUWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 140574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWrm),
     /* 140577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140579 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 140581 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 140585 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140590 */     GIR_RootConstrainSelectedInstOperands,
     /* 140591 */     // GIR_Coverage, 23456,
     /* 140591 */     GIR_EraseRootFromParent_Done,
     /* 140592 */   // Label 3008: @140592
     /* 140592 */   GIM_Try, /*On fail goto*//*Label 3009*/ GIMT_Encode4(140654), // Rule ID 23846 //
     /* 140597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 140600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 140604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140612 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140615 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140619 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 140627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140629 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140636 */     // (mulhu:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPMULHUWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 140636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZ128rm),
     /* 140639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140641 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 140643 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 140647 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140652 */     GIR_RootConstrainSelectedInstOperands,
     /* 140653 */     // GIR_Coverage, 23846,
     /* 140653 */     GIR_EraseRootFromParent_Done,
     /* 140654 */   // Label 3009: @140654
     /* 140654 */   GIM_Try, /*On fail goto*//*Label 3010*/ GIMT_Encode4(140716), // Rule ID 2577 //
     /* 140659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 140662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 140674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140678 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140681 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140685 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140691 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140698 */     // (mulhu:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHUWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 140698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWrm),
     /* 140701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140703 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 140705 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 140709 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140714 */     GIR_RootConstrainSelectedInstOperands,
     /* 140715 */     // GIR_Coverage, 2577,
     /* 140715 */     GIR_EraseRootFromParent_Done,
     /* 140716 */   // Label 3010: @140716
     /* 140716 */   GIM_Try, /*On fail goto*//*Label 3011*/ GIMT_Encode4(140778), // Rule ID 5062 //
     /* 140721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 140724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 140728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 140732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 140736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140740 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140743 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140747 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140753 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140760 */     // (mulhu:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHUWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 140760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZ128rm),
     /* 140763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140765 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 140767 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 140771 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140776 */     GIR_RootConstrainSelectedInstOperands,
     /* 140777 */     // GIR_Coverage, 5062,
     /* 140777 */     GIR_EraseRootFromParent_Done,
     /* 140778 */   // Label 3011: @140778
     /* 140778 */   GIM_Try, /*On fail goto*//*Label 3012*/ GIMT_Encode4(140805), // Rule ID 2576 //
     /* 140783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 140786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140798 */     // (mulhu:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMULHUWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 140798 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHUWrr),
     /* 140803 */     GIR_RootConstrainSelectedInstOperands,
     /* 140804 */     // GIR_Coverage, 2576,
     /* 140804 */     GIR_Done,
     /* 140805 */   // Label 3012: @140805
     /* 140805 */   GIM_Try, /*On fail goto*//*Label 3013*/ GIMT_Encode4(140832), // Rule ID 2578 //
     /* 140810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 140813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140817 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140825 */     // (mulhu:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMULHUWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 140825 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMULHUWrr),
     /* 140830 */     GIR_RootConstrainSelectedInstOperands,
     /* 140831 */     // GIR_Coverage, 2578,
     /* 140831 */     GIR_Done,
     /* 140832 */   // Label 3013: @140832
     /* 140832 */   GIM_Try, /*On fail goto*//*Label 3014*/ GIMT_Encode4(140859), // Rule ID 5059 //
     /* 140837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 140840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 140844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 140848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 140852 */     // (mulhu:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMULHUWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 140852 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZ128rr),
     /* 140857 */     GIR_RootConstrainSelectedInstOperands,
     /* 140858 */     // GIR_Coverage, 5059,
     /* 140858 */     GIR_Done,
     /* 140859 */   // Label 3014: @140859
     /* 140859 */   GIM_Reject,
     /* 140860 */ // Label 3007: @140860
     /* 140860 */ GIM_Reject,
     /* 140861 */ // Label 3004: @140861
     /* 140861 */ GIM_Try, /*On fail goto*//*Label 3015*/ GIMT_Encode4(141175),
     /* 140866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 140869 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 140872 */   GIM_Try, /*On fail goto*//*Label 3016*/ GIMT_Encode4(140934), // Rule ID 23458 //
     /* 140877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 140880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 140884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140892 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140895 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140899 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 140907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140909 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140916 */     // (mulhu:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPMULHUWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 140916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWYrm),
     /* 140919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140921 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 140923 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 140927 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140932 */     GIR_RootConstrainSelectedInstOperands,
     /* 140933 */     // GIR_Coverage, 23458,
     /* 140933 */     GIR_EraseRootFromParent_Done,
     /* 140934 */   // Label 3016: @140934
     /* 140934 */   GIM_Try, /*On fail goto*//*Label 3017*/ GIMT_Encode4(140996), // Rule ID 23843 //
     /* 140939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 140942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 140946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140954 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140957 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140961 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 140969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140971 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140978 */     // (mulhu:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPMULHUWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 140978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZ256rm),
     /* 140981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140983 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 140985 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 140989 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140994 */     GIR_RootConstrainSelectedInstOperands,
     /* 140995 */     // GIR_Coverage, 23843,
     /* 140995 */     GIR_EraseRootFromParent_Done,
     /* 140996 */   // Label 3017: @140996
     /* 140996 */   GIM_Try, /*On fail goto*//*Label 3018*/ GIMT_Encode4(141058), // Rule ID 2581 //
     /* 141001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 141004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 141008 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 141012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 141016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141020 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141023 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141027 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141033 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141040 */     // (mulhu:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHUWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWYrm),
     /* 141043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141045 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 141047 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141051 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141056 */     GIR_RootConstrainSelectedInstOperands,
     /* 141057 */     // GIR_Coverage, 2581,
     /* 141057 */     GIR_EraseRootFromParent_Done,
     /* 141058 */   // Label 3018: @141058
     /* 141058 */   GIM_Try, /*On fail goto*//*Label 3019*/ GIMT_Encode4(141120), // Rule ID 5056 //
     /* 141063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 141066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 141070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 141074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 141078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141082 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141085 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141089 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141095 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141102 */     // (mulhu:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHUWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZ256rm),
     /* 141105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141107 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 141109 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141113 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141118 */     GIR_RootConstrainSelectedInstOperands,
     /* 141119 */     // GIR_Coverage, 5056,
     /* 141119 */     GIR_EraseRootFromParent_Done,
     /* 141120 */   // Label 3019: @141120
     /* 141120 */   GIM_Try, /*On fail goto*//*Label 3020*/ GIMT_Encode4(141147), // Rule ID 2580 //
     /* 141125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 141128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 141132 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 141136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 141140 */     // (mulhu:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMULHUWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 141140 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHUWYrr),
     /* 141145 */     GIR_RootConstrainSelectedInstOperands,
     /* 141146 */     // GIR_Coverage, 2580,
     /* 141146 */     GIR_Done,
     /* 141147 */   // Label 3020: @141147
     /* 141147 */   GIM_Try, /*On fail goto*//*Label 3021*/ GIMT_Encode4(141174), // Rule ID 5053 //
     /* 141152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 141155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 141159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 141163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 141167 */     // (mulhu:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMULHUWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 141167 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZ256rr),
     /* 141172 */     GIR_RootConstrainSelectedInstOperands,
     /* 141173 */     // GIR_Coverage, 5053,
     /* 141173 */     GIR_Done,
     /* 141174 */   // Label 3021: @141174
     /* 141174 */   GIM_Reject,
     /* 141175 */ // Label 3015: @141175
     /* 141175 */ GIM_Reject,
     /* 141176 */ // Label 3005: @141176
     /* 141176 */ GIM_Try, /*On fail goto*//*Label 3022*/ GIMT_Encode4(141331),
     /* 141181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 141184 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 141187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 141191 */   GIM_Try, /*On fail goto*//*Label 3023*/ GIMT_Encode4(141249), // Rule ID 23840 //
     /* 141196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 141199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141207 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141210 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141214 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 141222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141224 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141231 */     // (mulhu:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPMULHUWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZrm),
     /* 141234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141236 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 141238 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141242 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141247 */     GIR_RootConstrainSelectedInstOperands,
     /* 141248 */     // GIR_Coverage, 23840,
     /* 141248 */     GIR_EraseRootFromParent_Done,
     /* 141249 */   // Label 3023: @141249
     /* 141249 */   GIM_Try, /*On fail goto*//*Label 3024*/ GIMT_Encode4(141307), // Rule ID 5050 //
     /* 141254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 141257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 141261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 141265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141269 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141272 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141276 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141282 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141289 */     // (mulhu:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHUWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZrm),
     /* 141292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141294 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 141296 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141300 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141305 */     GIR_RootConstrainSelectedInstOperands,
     /* 141306 */     // GIR_Coverage, 5050,
     /* 141306 */     GIR_EraseRootFromParent_Done,
     /* 141307 */   // Label 3024: @141307
     /* 141307 */   GIM_Try, /*On fail goto*//*Label 3025*/ GIMT_Encode4(141330), // Rule ID 5047 //
     /* 141312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 141315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 141319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 141323 */     // (mulhu:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMULHUWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 141323 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZrr),
     /* 141328 */     GIR_RootConstrainSelectedInstOperands,
     /* 141329 */     // GIR_Coverage, 5047,
     /* 141329 */     GIR_Done,
     /* 141330 */   // Label 3025: @141330
     /* 141330 */   GIM_Reject,
     /* 141331 */ // Label 3022: @141331
     /* 141331 */ GIM_Reject,
     /* 141332 */ // Label 3006: @141332
     /* 141332 */ GIM_Reject,
     /* 141333 */ // Label 36: @141333
     /* 141333 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(13), GIMT_Encode2(23), /*)*//*default:*//*Label 3029*/ GIMT_Encode4(142197),
     /* 141344 */ /*GILLT_v8s16*//*Label 3026*/ GIMT_Encode4(141384), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 141364 */ /*GILLT_v16s16*//*Label 3027*/ GIMT_Encode4(141726), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 141380 */ /*GILLT_v32s16*//*Label 3028*/ GIMT_Encode4(142041),
     /* 141384 */ // Label 3026: @141384
     /* 141384 */ GIM_Try, /*On fail goto*//*Label 3030*/ GIMT_Encode4(141725),
     /* 141389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 141392 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 141395 */   GIM_Try, /*On fail goto*//*Label 3031*/ GIMT_Encode4(141457), // Rule ID 23459 //
     /* 141400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 141403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141415 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141418 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141422 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141430 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141432 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141439 */     // (mulhs:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPMULHWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWrm),
     /* 141442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141444 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 141446 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141450 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141455 */     GIR_RootConstrainSelectedInstOperands,
     /* 141456 */     // GIR_Coverage, 23459,
     /* 141456 */     GIR_EraseRootFromParent_Done,
     /* 141457 */   // Label 3031: @141457
     /* 141457 */   GIM_Try, /*On fail goto*//*Label 3032*/ GIMT_Encode4(141519), // Rule ID 23837 //
     /* 141462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 141465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 141469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141477 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141480 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141484 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 141492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141494 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141501 */     // (mulhs:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPMULHWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWZ128rm),
     /* 141504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141506 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 141508 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141512 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141517 */     GIR_RootConstrainSelectedInstOperands,
     /* 141518 */     // GIR_Coverage, 23837,
     /* 141518 */     GIR_EraseRootFromParent_Done,
     /* 141519 */   // Label 3032: @141519
     /* 141519 */   GIM_Try, /*On fail goto*//*Label 3033*/ GIMT_Encode4(141581), // Rule ID 2583 //
     /* 141524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 141527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 141539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141543 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141546 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141550 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141556 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141563 */     // (mulhs:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWrm),
     /* 141566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141568 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 141570 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141574 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141579 */     GIR_RootConstrainSelectedInstOperands,
     /* 141580 */     // GIR_Coverage, 2583,
     /* 141580 */     GIR_EraseRootFromParent_Done,
     /* 141581 */   // Label 3033: @141581
     /* 141581 */   GIM_Try, /*On fail goto*//*Label 3034*/ GIMT_Encode4(141643), // Rule ID 5044 //
     /* 141586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 141589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 141593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 141597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 141601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141605 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141608 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141612 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141618 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141625 */     // (mulhs:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWZ128rm),
     /* 141628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141630 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 141632 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141636 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141641 */     GIR_RootConstrainSelectedInstOperands,
     /* 141642 */     // GIR_Coverage, 5044,
     /* 141642 */     GIR_EraseRootFromParent_Done,
     /* 141643 */   // Label 3034: @141643
     /* 141643 */   GIM_Try, /*On fail goto*//*Label 3035*/ GIMT_Encode4(141670), // Rule ID 2582 //
     /* 141648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 141651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141663 */     // (mulhs:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMULHWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 141663 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHWrr),
     /* 141668 */     GIR_RootConstrainSelectedInstOperands,
     /* 141669 */     // GIR_Coverage, 2582,
     /* 141669 */     GIR_Done,
     /* 141670 */   // Label 3035: @141670
     /* 141670 */   GIM_Try, /*On fail goto*//*Label 3036*/ GIMT_Encode4(141697), // Rule ID 2584 //
     /* 141675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 141678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141682 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141690 */     // (mulhs:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMULHWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 141690 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMULHWrr),
     /* 141695 */     GIR_RootConstrainSelectedInstOperands,
     /* 141696 */     // GIR_Coverage, 2584,
     /* 141696 */     GIR_Done,
     /* 141697 */   // Label 3036: @141697
     /* 141697 */   GIM_Try, /*On fail goto*//*Label 3037*/ GIMT_Encode4(141724), // Rule ID 5041 //
     /* 141702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 141705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 141709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 141713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 141717 */     // (mulhs:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMULHWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 141717 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHWZ128rr),
     /* 141722 */     GIR_RootConstrainSelectedInstOperands,
     /* 141723 */     // GIR_Coverage, 5041,
     /* 141723 */     GIR_Done,
     /* 141724 */   // Label 3037: @141724
     /* 141724 */   GIM_Reject,
     /* 141725 */ // Label 3030: @141725
     /* 141725 */ GIM_Reject,
     /* 141726 */ // Label 3027: @141726
     /* 141726 */ GIM_Try, /*On fail goto*//*Label 3038*/ GIMT_Encode4(142040),
     /* 141731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 141734 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 141737 */   GIM_Try, /*On fail goto*//*Label 3039*/ GIMT_Encode4(141799), // Rule ID 23461 //
     /* 141742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 141745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 141749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141757 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141760 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141764 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 141772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141774 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141781 */     // (mulhs:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPMULHWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWYrm),
     /* 141784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141786 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 141788 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141792 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141797 */     GIR_RootConstrainSelectedInstOperands,
     /* 141798 */     // GIR_Coverage, 23461,
     /* 141798 */     GIR_EraseRootFromParent_Done,
     /* 141799 */   // Label 3039: @141799
     /* 141799 */   GIM_Try, /*On fail goto*//*Label 3040*/ GIMT_Encode4(141861), // Rule ID 23834 //
     /* 141804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 141807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 141811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141819 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141822 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141826 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 141834 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141836 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141843 */     // (mulhs:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPMULHWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWZ256rm),
     /* 141846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141848 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 141850 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141854 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141859 */     GIR_RootConstrainSelectedInstOperands,
     /* 141860 */     // GIR_Coverage, 23834,
     /* 141860 */     GIR_EraseRootFromParent_Done,
     /* 141861 */   // Label 3040: @141861
     /* 141861 */   GIM_Try, /*On fail goto*//*Label 3041*/ GIMT_Encode4(141923), // Rule ID 2587 //
     /* 141866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 141869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 141873 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 141877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 141881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141885 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141888 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141892 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141898 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141905 */     // (mulhs:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWYrm),
     /* 141908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141910 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 141912 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141916 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141921 */     GIR_RootConstrainSelectedInstOperands,
     /* 141922 */     // GIR_Coverage, 2587,
     /* 141922 */     GIR_EraseRootFromParent_Done,
     /* 141923 */   // Label 3041: @141923
     /* 141923 */   GIM_Try, /*On fail goto*//*Label 3042*/ GIMT_Encode4(141985), // Rule ID 5038 //
     /* 141928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 141931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 141935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 141939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 141943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141947 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141950 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141954 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141960 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141967 */     // (mulhs:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWZ256rm),
     /* 141970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141972 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 141974 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141978 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141983 */     GIR_RootConstrainSelectedInstOperands,
     /* 141984 */     // GIR_Coverage, 5038,
     /* 141984 */     GIR_EraseRootFromParent_Done,
     /* 141985 */   // Label 3042: @141985
     /* 141985 */   GIM_Try, /*On fail goto*//*Label 3043*/ GIMT_Encode4(142012), // Rule ID 2586 //
     /* 141990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 141993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 141997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 142001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 142005 */     // (mulhs:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMULHWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 142005 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHWYrr),
     /* 142010 */     GIR_RootConstrainSelectedInstOperands,
     /* 142011 */     // GIR_Coverage, 2586,
     /* 142011 */     GIR_Done,
     /* 142012 */   // Label 3043: @142012
     /* 142012 */   GIM_Try, /*On fail goto*//*Label 3044*/ GIMT_Encode4(142039), // Rule ID 5035 //
     /* 142017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 142020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 142024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 142028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 142032 */     // (mulhs:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMULHWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 142032 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHWZ256rr),
     /* 142037 */     GIR_RootConstrainSelectedInstOperands,
     /* 142038 */     // GIR_Coverage, 5035,
     /* 142038 */     GIR_Done,
     /* 142039 */   // Label 3044: @142039
     /* 142039 */   GIM_Reject,
     /* 142040 */ // Label 3038: @142040
     /* 142040 */ GIM_Reject,
     /* 142041 */ // Label 3028: @142041
     /* 142041 */ GIM_Try, /*On fail goto*//*Label 3045*/ GIMT_Encode4(142196),
     /* 142046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 142049 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 142052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 142056 */   GIM_Try, /*On fail goto*//*Label 3046*/ GIMT_Encode4(142114), // Rule ID 23831 //
     /* 142061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 142064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142072 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142075 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142079 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 142087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142089 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142096 */     // (mulhs:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPMULHWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWZrm),
     /* 142099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142101 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 142103 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142107 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142112 */     GIR_RootConstrainSelectedInstOperands,
     /* 142113 */     // GIR_Coverage, 23831,
     /* 142113 */     GIR_EraseRootFromParent_Done,
     /* 142114 */   // Label 3046: @142114
     /* 142114 */   GIM_Try, /*On fail goto*//*Label 3047*/ GIMT_Encode4(142172), // Rule ID 5032 //
     /* 142119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 142122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 142126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 142130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142134 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142137 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142141 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142147 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142154 */     // (mulhs:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWZrm),
     /* 142157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142159 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 142161 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142165 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142170 */     GIR_RootConstrainSelectedInstOperands,
     /* 142171 */     // GIR_Coverage, 5032,
     /* 142171 */     GIR_EraseRootFromParent_Done,
     /* 142172 */   // Label 3047: @142172
     /* 142172 */   GIM_Try, /*On fail goto*//*Label 3048*/ GIMT_Encode4(142195), // Rule ID 5029 //
     /* 142177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 142180 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 142184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 142188 */     // (mulhs:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMULHWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 142188 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHWZrr),
     /* 142193 */     GIR_RootConstrainSelectedInstOperands,
     /* 142194 */     // GIR_Coverage, 5029,
     /* 142194 */     GIR_Done,
     /* 142195 */   // Label 3048: @142195
     /* 142195 */   GIM_Reject,
     /* 142196 */ // Label 3045: @142196
     /* 142196 */ GIM_Reject,
     /* 142197 */ // Label 3029: @142197
     /* 142197 */ GIM_Reject,
     /* 142198 */ // Label 37: @142198
     /* 142198 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(13), GIMT_Encode2(25), /*)*//*default:*//*Label 3055*/ GIMT_Encode4(143883),
     /* 142209 */ /*GILLT_v8s16*//*Label 3049*/ GIMT_Encode4(142257), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 142225 */ /*GILLT_v16s8*//*Label 3050*/ GIMT_Encode4(142599),
     /* 142229 */ /*GILLT_v16s16*//*Label 3051*/ GIMT_Encode4(142941), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 142241 */ /*GILLT_v32s8*//*Label 3052*/ GIMT_Encode4(143256),
     /* 142245 */ /*GILLT_v32s16*//*Label 3053*/ GIMT_Encode4(143571), GIMT_Encode4(0),
     /* 142253 */ /*GILLT_v64s8*//*Label 3054*/ GIMT_Encode4(143727),
     /* 142257 */ // Label 3049: @142257
     /* 142257 */ GIM_Try, /*On fail goto*//*Label 3056*/ GIMT_Encode4(142598),
     /* 142262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 142265 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 142268 */   GIM_Try, /*On fail goto*//*Label 3057*/ GIMT_Encode4(142330), // Rule ID 23450 //
     /* 142273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 142276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142288 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142291 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142295 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142305 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142312 */     // (uaddsat:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPADDUSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWrm),
     /* 142315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142317 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 142319 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142323 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142328 */     GIR_RootConstrainSelectedInstOperands,
     /* 142329 */     // GIR_Coverage, 23450,
     /* 142329 */     GIR_EraseRootFromParent_Done,
     /* 142330 */   // Label 3057: @142330
     /* 142330 */   GIM_Try, /*On fail goto*//*Label 3058*/ GIMT_Encode4(142392), // Rule ID 23774 //
     /* 142335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 142338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142350 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142353 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142357 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142367 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142374 */     // (uaddsat:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPADDUSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZ128rm),
     /* 142377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142379 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 142381 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142385 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142390 */     GIR_RootConstrainSelectedInstOperands,
     /* 142391 */     // GIR_Coverage, 23774,
     /* 142391 */     GIR_EraseRootFromParent_Done,
     /* 142392 */   // Label 3058: @142392
     /* 142392 */   GIM_Try, /*On fail goto*//*Label 3059*/ GIMT_Encode4(142454), // Rule ID 2565 //
     /* 142397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 142400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 142412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142416 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142419 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142423 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142429 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142436 */     // (uaddsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWrm),
     /* 142439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142441 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 142443 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142447 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142452 */     GIR_RootConstrainSelectedInstOperands,
     /* 142453 */     // GIR_Coverage, 2565,
     /* 142453 */     GIR_EraseRootFromParent_Done,
     /* 142454 */   // Label 3059: @142454
     /* 142454 */   GIM_Try, /*On fail goto*//*Label 3060*/ GIMT_Encode4(142516), // Rule ID 4900 //
     /* 142459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 142462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142466 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 142474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142478 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142481 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142485 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142491 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142498 */     // (uaddsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZ128rm),
     /* 142501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142503 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 142505 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142509 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142514 */     GIR_RootConstrainSelectedInstOperands,
     /* 142515 */     // GIR_Coverage, 4900,
     /* 142515 */     GIR_EraseRootFromParent_Done,
     /* 142516 */   // Label 3060: @142516
     /* 142516 */   GIM_Try, /*On fail goto*//*Label 3061*/ GIMT_Encode4(142543), // Rule ID 2564 //
     /* 142521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 142524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142536 */     // (uaddsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPADDUSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 142536 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSWrr),
     /* 142541 */     GIR_RootConstrainSelectedInstOperands,
     /* 142542 */     // GIR_Coverage, 2564,
     /* 142542 */     GIR_Done,
     /* 142543 */   // Label 3061: @142543
     /* 142543 */   GIM_Try, /*On fail goto*//*Label 3062*/ GIMT_Encode4(142570), // Rule ID 2566 //
     /* 142548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 142551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142555 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142563 */     // (uaddsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PADDUSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 142563 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDUSWrr),
     /* 142568 */     GIR_RootConstrainSelectedInstOperands,
     /* 142569 */     // GIR_Coverage, 2566,
     /* 142569 */     GIR_Done,
     /* 142570 */   // Label 3062: @142570
     /* 142570 */   GIM_Try, /*On fail goto*//*Label 3063*/ GIMT_Encode4(142597), // Rule ID 4897 //
     /* 142575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 142578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142590 */     // (uaddsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPADDUSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 142590 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZ128rr),
     /* 142595 */     GIR_RootConstrainSelectedInstOperands,
     /* 142596 */     // GIR_Coverage, 4897,
     /* 142596 */     GIR_Done,
     /* 142597 */   // Label 3063: @142597
     /* 142597 */   GIM_Reject,
     /* 142598 */ // Label 3056: @142598
     /* 142598 */ GIM_Reject,
     /* 142599 */ // Label 3050: @142599
     /* 142599 */ GIM_Try, /*On fail goto*//*Label 3064*/ GIMT_Encode4(142940),
     /* 142604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 142607 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 142610 */   GIM_Try, /*On fail goto*//*Label 3065*/ GIMT_Encode4(142672), // Rule ID 23447 //
     /* 142615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 142618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142630 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142633 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142637 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142647 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142654 */     // (uaddsat:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPADDUSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBrm),
     /* 142657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142659 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 142661 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142665 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142670 */     GIR_RootConstrainSelectedInstOperands,
     /* 142671 */     // GIR_Coverage, 23447,
     /* 142671 */     GIR_EraseRootFromParent_Done,
     /* 142672 */   // Label 3065: @142672
     /* 142672 */   GIM_Try, /*On fail goto*//*Label 3066*/ GIMT_Encode4(142734), // Rule ID 23783 //
     /* 142677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 142680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142692 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142695 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142699 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142709 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142716 */     // (uaddsat:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPADDUSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZ128rm),
     /* 142719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142721 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 142723 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142727 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142732 */     GIR_RootConstrainSelectedInstOperands,
     /* 142733 */     // GIR_Coverage, 23783,
     /* 142733 */     GIR_EraseRootFromParent_Done,
     /* 142734 */   // Label 3066: @142734
     /* 142734 */   GIM_Try, /*On fail goto*//*Label 3067*/ GIMT_Encode4(142796), // Rule ID 2559 //
     /* 142739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 142742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 142754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142758 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142761 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142765 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142771 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142778 */     // (uaddsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBrm),
     /* 142781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142783 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 142785 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142789 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142794 */     GIR_RootConstrainSelectedInstOperands,
     /* 142795 */     // GIR_Coverage, 2559,
     /* 142795 */     GIR_EraseRootFromParent_Done,
     /* 142796 */   // Label 3067: @142796
     /* 142796 */   GIM_Try, /*On fail goto*//*Label 3068*/ GIMT_Encode4(142858), // Rule ID 4918 //
     /* 142801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 142804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 142816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142820 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142823 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142827 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142833 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142840 */     // (uaddsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZ128rm),
     /* 142843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142845 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 142847 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142851 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142856 */     GIR_RootConstrainSelectedInstOperands,
     /* 142857 */     // GIR_Coverage, 4918,
     /* 142857 */     GIR_EraseRootFromParent_Done,
     /* 142858 */   // Label 3068: @142858
     /* 142858 */   GIM_Try, /*On fail goto*//*Label 3069*/ GIMT_Encode4(142885), // Rule ID 2558 //
     /* 142863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 142866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142878 */     // (uaddsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPADDUSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 142878 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSBrr),
     /* 142883 */     GIR_RootConstrainSelectedInstOperands,
     /* 142884 */     // GIR_Coverage, 2558,
     /* 142884 */     GIR_Done,
     /* 142885 */   // Label 3069: @142885
     /* 142885 */   GIM_Try, /*On fail goto*//*Label 3070*/ GIMT_Encode4(142912), // Rule ID 2560 //
     /* 142890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 142893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142905 */     // (uaddsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PADDUSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 142905 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDUSBrr),
     /* 142910 */     GIR_RootConstrainSelectedInstOperands,
     /* 142911 */     // GIR_Coverage, 2560,
     /* 142911 */     GIR_Done,
     /* 142912 */   // Label 3070: @142912
     /* 142912 */   GIM_Try, /*On fail goto*//*Label 3071*/ GIMT_Encode4(142939), // Rule ID 4915 //
     /* 142917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 142920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142932 */     // (uaddsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPADDUSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 142932 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZ128rr),
     /* 142937 */     GIR_RootConstrainSelectedInstOperands,
     /* 142938 */     // GIR_Coverage, 4915,
     /* 142938 */     GIR_Done,
     /* 142939 */   // Label 3071: @142939
     /* 142939 */   GIM_Reject,
     /* 142940 */ // Label 3064: @142940
     /* 142940 */ GIM_Reject,
     /* 142941 */ // Label 3051: @142941
     /* 142941 */ GIM_Try, /*On fail goto*//*Label 3072*/ GIMT_Encode4(143255),
     /* 142946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 142949 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 142952 */   GIM_Try, /*On fail goto*//*Label 3073*/ GIMT_Encode4(143014), // Rule ID 23452 //
     /* 142957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 142960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 142964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142972 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142975 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142979 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 142987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142989 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142996 */     // (uaddsat:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPADDUSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWYrm),
     /* 142999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143001 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 143003 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143007 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143012 */     GIR_RootConstrainSelectedInstOperands,
     /* 143013 */     // GIR_Coverage, 23452,
     /* 143013 */     GIR_EraseRootFromParent_Done,
     /* 143014 */   // Label 3073: @143014
     /* 143014 */   GIM_Try, /*On fail goto*//*Label 3074*/ GIMT_Encode4(143076), // Rule ID 23771 //
     /* 143019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 143022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143034 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143037 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143041 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143049 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143051 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143058 */     // (uaddsat:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPADDUSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZ256rm),
     /* 143061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143063 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 143065 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143069 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143074 */     GIR_RootConstrainSelectedInstOperands,
     /* 143075 */     // GIR_Coverage, 23771,
     /* 143075 */     GIR_EraseRootFromParent_Done,
     /* 143076 */   // Label 3074: @143076
     /* 143076 */   GIM_Try, /*On fail goto*//*Label 3075*/ GIMT_Encode4(143138), // Rule ID 2569 //
     /* 143081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 143084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143088 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 143096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143100 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143103 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143107 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143113 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143120 */     // (uaddsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWYrm),
     /* 143123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143125 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 143127 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143131 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143136 */     GIR_RootConstrainSelectedInstOperands,
     /* 143137 */     // GIR_Coverage, 2569,
     /* 143137 */     GIR_EraseRootFromParent_Done,
     /* 143138 */   // Label 3075: @143138
     /* 143138 */   GIM_Try, /*On fail goto*//*Label 3076*/ GIMT_Encode4(143200), // Rule ID 4894 //
     /* 143143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 143146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 143158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143162 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143165 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143169 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143175 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143182 */     // (uaddsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZ256rm),
     /* 143185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143187 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 143189 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143193 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143198 */     GIR_RootConstrainSelectedInstOperands,
     /* 143199 */     // GIR_Coverage, 4894,
     /* 143199 */     GIR_EraseRootFromParent_Done,
     /* 143200 */   // Label 3076: @143200
     /* 143200 */   GIM_Try, /*On fail goto*//*Label 3077*/ GIMT_Encode4(143227), // Rule ID 2568 //
     /* 143205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 143208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143220 */     // (uaddsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPADDUSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 143220 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSWYrr),
     /* 143225 */     GIR_RootConstrainSelectedInstOperands,
     /* 143226 */     // GIR_Coverage, 2568,
     /* 143226 */     GIR_Done,
     /* 143227 */   // Label 3077: @143227
     /* 143227 */   GIM_Try, /*On fail goto*//*Label 3078*/ GIMT_Encode4(143254), // Rule ID 4891 //
     /* 143232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 143235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143247 */     // (uaddsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPADDUSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 143247 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZ256rr),
     /* 143252 */     GIR_RootConstrainSelectedInstOperands,
     /* 143253 */     // GIR_Coverage, 4891,
     /* 143253 */     GIR_Done,
     /* 143254 */   // Label 3078: @143254
     /* 143254 */   GIM_Reject,
     /* 143255 */ // Label 3072: @143255
     /* 143255 */ GIM_Reject,
     /* 143256 */ // Label 3052: @143256
     /* 143256 */ GIM_Try, /*On fail goto*//*Label 3079*/ GIMT_Encode4(143570),
     /* 143261 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 143264 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 143267 */   GIM_Try, /*On fail goto*//*Label 3080*/ GIMT_Encode4(143329), // Rule ID 23449 //
     /* 143272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 143275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143287 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143290 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143294 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143304 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143311 */     // (uaddsat:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPADDUSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBYrm),
     /* 143314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143316 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 143318 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143322 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143327 */     GIR_RootConstrainSelectedInstOperands,
     /* 143328 */     // GIR_Coverage, 23449,
     /* 143328 */     GIR_EraseRootFromParent_Done,
     /* 143329 */   // Label 3080: @143329
     /* 143329 */   GIM_Try, /*On fail goto*//*Label 3081*/ GIMT_Encode4(143391), // Rule ID 23780 //
     /* 143334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 143337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143349 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143352 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143356 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143364 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143366 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143373 */     // (uaddsat:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPADDUSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZ256rm),
     /* 143376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143378 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 143380 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143384 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143389 */     GIR_RootConstrainSelectedInstOperands,
     /* 143390 */     // GIR_Coverage, 23780,
     /* 143390 */     GIR_EraseRootFromParent_Done,
     /* 143391 */   // Label 3081: @143391
     /* 143391 */   GIM_Try, /*On fail goto*//*Label 3082*/ GIMT_Encode4(143453), // Rule ID 2563 //
     /* 143396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 143399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143403 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 143411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143415 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143418 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143422 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143428 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143435 */     // (uaddsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBYrm),
     /* 143438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143440 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 143442 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143446 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143451 */     GIR_RootConstrainSelectedInstOperands,
     /* 143452 */     // GIR_Coverage, 2563,
     /* 143452 */     GIR_EraseRootFromParent_Done,
     /* 143453 */   // Label 3082: @143453
     /* 143453 */   GIM_Try, /*On fail goto*//*Label 3083*/ GIMT_Encode4(143515), // Rule ID 4912 //
     /* 143458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 143461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 143473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143477 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143480 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143484 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143488 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143490 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143497 */     // (uaddsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZ256rm),
     /* 143500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143502 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 143504 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143508 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143513 */     GIR_RootConstrainSelectedInstOperands,
     /* 143514 */     // GIR_Coverage, 4912,
     /* 143514 */     GIR_EraseRootFromParent_Done,
     /* 143515 */   // Label 3083: @143515
     /* 143515 */   GIM_Try, /*On fail goto*//*Label 3084*/ GIMT_Encode4(143542), // Rule ID 2562 //
     /* 143520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 143523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143527 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143535 */     // (uaddsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPADDUSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 143535 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSBYrr),
     /* 143540 */     GIR_RootConstrainSelectedInstOperands,
     /* 143541 */     // GIR_Coverage, 2562,
     /* 143541 */     GIR_Done,
     /* 143542 */   // Label 3084: @143542
     /* 143542 */   GIM_Try, /*On fail goto*//*Label 3085*/ GIMT_Encode4(143569), // Rule ID 4909 //
     /* 143547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 143550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143554 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143562 */     // (uaddsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPADDUSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 143562 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZ256rr),
     /* 143567 */     GIR_RootConstrainSelectedInstOperands,
     /* 143568 */     // GIR_Coverage, 4909,
     /* 143568 */     GIR_Done,
     /* 143569 */   // Label 3085: @143569
     /* 143569 */   GIM_Reject,
     /* 143570 */ // Label 3079: @143570
     /* 143570 */ GIM_Reject,
     /* 143571 */ // Label 3053: @143571
     /* 143571 */ GIM_Try, /*On fail goto*//*Label 3086*/ GIMT_Encode4(143726),
     /* 143576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 143579 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 143582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 143586 */   GIM_Try, /*On fail goto*//*Label 3087*/ GIMT_Encode4(143644), // Rule ID 23768 //
     /* 143591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 143594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143602 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143605 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143609 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 143617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143619 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143626 */     // (uaddsat:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPADDUSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZrm),
     /* 143629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143631 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 143633 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143637 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143642 */     GIR_RootConstrainSelectedInstOperands,
     /* 143643 */     // GIR_Coverage, 23768,
     /* 143643 */     GIR_EraseRootFromParent_Done,
     /* 143644 */   // Label 3087: @143644
     /* 143644 */   GIM_Try, /*On fail goto*//*Label 3088*/ GIMT_Encode4(143702), // Rule ID 4888 //
     /* 143649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 143652 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 143656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 143660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143664 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143667 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143671 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143677 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143684 */     // (uaddsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZrm),
     /* 143687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143689 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 143691 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143695 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143700 */     GIR_RootConstrainSelectedInstOperands,
     /* 143701 */     // GIR_Coverage, 4888,
     /* 143701 */     GIR_EraseRootFromParent_Done,
     /* 143702 */   // Label 3088: @143702
     /* 143702 */   GIM_Try, /*On fail goto*//*Label 3089*/ GIMT_Encode4(143725), // Rule ID 4885 //
     /* 143707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 143710 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 143714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 143718 */     // (uaddsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPADDUSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 143718 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZrr),
     /* 143723 */     GIR_RootConstrainSelectedInstOperands,
     /* 143724 */     // GIR_Coverage, 4885,
     /* 143724 */     GIR_Done,
     /* 143725 */   // Label 3089: @143725
     /* 143725 */   GIM_Reject,
     /* 143726 */ // Label 3086: @143726
     /* 143726 */ GIM_Reject,
     /* 143727 */ // Label 3054: @143727
     /* 143727 */ GIM_Try, /*On fail goto*//*Label 3090*/ GIMT_Encode4(143882),
     /* 143732 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 143735 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 143738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 143742 */   GIM_Try, /*On fail goto*//*Label 3091*/ GIMT_Encode4(143800), // Rule ID 23777 //
     /* 143747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 143750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143758 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143761 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143765 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 143773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143775 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143782 */     // (uaddsat:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPADDUSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZrm),
     /* 143785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143787 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 143789 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143793 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143798 */     GIR_RootConstrainSelectedInstOperands,
     /* 143799 */     // GIR_Coverage, 23777,
     /* 143799 */     GIR_EraseRootFromParent_Done,
     /* 143800 */   // Label 3091: @143800
     /* 143800 */   GIM_Try, /*On fail goto*//*Label 3092*/ GIMT_Encode4(143858), // Rule ID 4906 //
     /* 143805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 143808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 143812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 143816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143820 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143823 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143827 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143833 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143840 */     // (uaddsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZrm),
     /* 143843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143845 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 143847 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143851 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143856 */     GIR_RootConstrainSelectedInstOperands,
     /* 143857 */     // GIR_Coverage, 4906,
     /* 143857 */     GIR_EraseRootFromParent_Done,
     /* 143858 */   // Label 3092: @143858
     /* 143858 */   GIM_Try, /*On fail goto*//*Label 3093*/ GIMT_Encode4(143881), // Rule ID 4903 //
     /* 143863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 143866 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 143870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 143874 */     // (uaddsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPADDUSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 143874 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZrr),
     /* 143879 */     GIR_RootConstrainSelectedInstOperands,
     /* 143880 */     // GIR_Coverage, 4903,
     /* 143880 */     GIR_Done,
     /* 143881 */   // Label 3093: @143881
     /* 143881 */   GIM_Reject,
     /* 143882 */ // Label 3090: @143882
     /* 143882 */ GIM_Reject,
     /* 143883 */ // Label 3055: @143883
     /* 143883 */ GIM_Reject,
     /* 143884 */ // Label 38: @143884
     /* 143884 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(13), GIMT_Encode2(25), /*)*//*default:*//*Label 3100*/ GIMT_Encode4(145569),
     /* 143895 */ /*GILLT_v8s16*//*Label 3094*/ GIMT_Encode4(143943), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 143911 */ /*GILLT_v16s8*//*Label 3095*/ GIMT_Encode4(144285),
     /* 143915 */ /*GILLT_v16s16*//*Label 3096*/ GIMT_Encode4(144627), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 143927 */ /*GILLT_v32s8*//*Label 3097*/ GIMT_Encode4(144942),
     /* 143931 */ /*GILLT_v32s16*//*Label 3098*/ GIMT_Encode4(145257), GIMT_Encode4(0),
     /* 143939 */ /*GILLT_v64s8*//*Label 3099*/ GIMT_Encode4(145413),
     /* 143943 */ // Label 3094: @143943
     /* 143943 */ GIM_Try, /*On fail goto*//*Label 3101*/ GIMT_Encode4(144284),
     /* 143948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 143951 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 143954 */   GIM_Try, /*On fail goto*//*Label 3102*/ GIMT_Encode4(144016), // Rule ID 23444 //
     /* 143959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 143962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 143966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143974 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143977 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143981 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 143989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143991 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143998 */     // (saddsat:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPADDSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWrm),
     /* 144001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144003 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 144005 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144009 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144014 */     GIR_RootConstrainSelectedInstOperands,
     /* 144015 */     // GIR_Coverage, 23444,
     /* 144015 */     GIR_EraseRootFromParent_Done,
     /* 144016 */   // Label 3102: @144016
     /* 144016 */   GIM_Try, /*On fail goto*//*Label 3103*/ GIMT_Encode4(144078), // Rule ID 23756 //
     /* 144021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 144024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144036 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144039 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144043 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144053 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144060 */     // (saddsat:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPADDSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWZ128rm),
     /* 144063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144065 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 144067 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144071 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144076 */     GIR_RootConstrainSelectedInstOperands,
     /* 144077 */     // GIR_Coverage, 23756,
     /* 144077 */     GIR_EraseRootFromParent_Done,
     /* 144078 */   // Label 3103: @144078
     /* 144078 */   GIM_Try, /*On fail goto*//*Label 3104*/ GIMT_Encode4(144140), // Rule ID 2553 //
     /* 144083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 144086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 144098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144102 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144105 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144109 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144113 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144115 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144122 */     // (saddsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWrm),
     /* 144125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144127 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 144129 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144133 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144138 */     GIR_RootConstrainSelectedInstOperands,
     /* 144139 */     // GIR_Coverage, 2553,
     /* 144139 */     GIR_EraseRootFromParent_Done,
     /* 144140 */   // Label 3104: @144140
     /* 144140 */   GIM_Try, /*On fail goto*//*Label 3105*/ GIMT_Encode4(144202), // Rule ID 4828 //
     /* 144145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 144148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144152 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 144160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144164 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144167 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144171 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144177 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144184 */     // (saddsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWZ128rm),
     /* 144187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144189 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 144191 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144195 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144200 */     GIR_RootConstrainSelectedInstOperands,
     /* 144201 */     // GIR_Coverage, 4828,
     /* 144201 */     GIR_EraseRootFromParent_Done,
     /* 144202 */   // Label 3105: @144202
     /* 144202 */   GIM_Try, /*On fail goto*//*Label 3106*/ GIMT_Encode4(144229), // Rule ID 2552 //
     /* 144207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 144210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144222 */     // (saddsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPADDSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 144222 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSWrr),
     /* 144227 */     GIR_RootConstrainSelectedInstOperands,
     /* 144228 */     // GIR_Coverage, 2552,
     /* 144228 */     GIR_Done,
     /* 144229 */   // Label 3106: @144229
     /* 144229 */   GIM_Try, /*On fail goto*//*Label 3107*/ GIMT_Encode4(144256), // Rule ID 2554 //
     /* 144234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 144237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144249 */     // (saddsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PADDSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 144249 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDSWrr),
     /* 144254 */     GIR_RootConstrainSelectedInstOperands,
     /* 144255 */     // GIR_Coverage, 2554,
     /* 144255 */     GIR_Done,
     /* 144256 */   // Label 3107: @144256
     /* 144256 */   GIM_Try, /*On fail goto*//*Label 3108*/ GIMT_Encode4(144283), // Rule ID 4825 //
     /* 144261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 144264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144268 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144276 */     // (saddsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPADDSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 144276 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSWZ128rr),
     /* 144281 */     GIR_RootConstrainSelectedInstOperands,
     /* 144282 */     // GIR_Coverage, 4825,
     /* 144282 */     GIR_Done,
     /* 144283 */   // Label 3108: @144283
     /* 144283 */   GIM_Reject,
     /* 144284 */ // Label 3101: @144284
     /* 144284 */ GIM_Reject,
     /* 144285 */ // Label 3095: @144285
     /* 144285 */ GIM_Try, /*On fail goto*//*Label 3109*/ GIMT_Encode4(144626),
     /* 144290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 144293 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 144296 */   GIM_Try, /*On fail goto*//*Label 3110*/ GIMT_Encode4(144358), // Rule ID 23441 //
     /* 144301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 144304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144316 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144319 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144323 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144333 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144340 */     // (saddsat:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPADDSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBrm),
     /* 144343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144345 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 144347 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144351 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144356 */     GIR_RootConstrainSelectedInstOperands,
     /* 144357 */     // GIR_Coverage, 23441,
     /* 144357 */     GIR_EraseRootFromParent_Done,
     /* 144358 */   // Label 3110: @144358
     /* 144358 */   GIM_Try, /*On fail goto*//*Label 3111*/ GIMT_Encode4(144420), // Rule ID 23765 //
     /* 144363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 144366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144378 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144381 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144385 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144395 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144402 */     // (saddsat:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPADDSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBZ128rm),
     /* 144405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144407 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 144409 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144413 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144418 */     GIR_RootConstrainSelectedInstOperands,
     /* 144419 */     // GIR_Coverage, 23765,
     /* 144419 */     GIR_EraseRootFromParent_Done,
     /* 144420 */   // Label 3111: @144420
     /* 144420 */   GIM_Try, /*On fail goto*//*Label 3112*/ GIMT_Encode4(144482), // Rule ID 2547 //
     /* 144425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 144428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 144440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144444 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144447 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144451 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144457 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144464 */     // (saddsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBrm),
     /* 144467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144469 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 144471 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144475 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144480 */     GIR_RootConstrainSelectedInstOperands,
     /* 144481 */     // GIR_Coverage, 2547,
     /* 144481 */     GIR_EraseRootFromParent_Done,
     /* 144482 */   // Label 3112: @144482
     /* 144482 */   GIM_Try, /*On fail goto*//*Label 3113*/ GIMT_Encode4(144544), // Rule ID 4846 //
     /* 144487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 144490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 144502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144506 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144509 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144513 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144519 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144526 */     // (saddsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBZ128rm),
     /* 144529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144531 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 144533 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144537 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144542 */     GIR_RootConstrainSelectedInstOperands,
     /* 144543 */     // GIR_Coverage, 4846,
     /* 144543 */     GIR_EraseRootFromParent_Done,
     /* 144544 */   // Label 3113: @144544
     /* 144544 */   GIM_Try, /*On fail goto*//*Label 3114*/ GIMT_Encode4(144571), // Rule ID 2546 //
     /* 144549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 144552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144564 */     // (saddsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPADDSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 144564 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSBrr),
     /* 144569 */     GIR_RootConstrainSelectedInstOperands,
     /* 144570 */     // GIR_Coverage, 2546,
     /* 144570 */     GIR_Done,
     /* 144571 */   // Label 3114: @144571
     /* 144571 */   GIM_Try, /*On fail goto*//*Label 3115*/ GIMT_Encode4(144598), // Rule ID 2548 //
     /* 144576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 144579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144591 */     // (saddsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PADDSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 144591 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDSBrr),
     /* 144596 */     GIR_RootConstrainSelectedInstOperands,
     /* 144597 */     // GIR_Coverage, 2548,
     /* 144597 */     GIR_Done,
     /* 144598 */   // Label 3115: @144598
     /* 144598 */   GIM_Try, /*On fail goto*//*Label 3116*/ GIMT_Encode4(144625), // Rule ID 4843 //
     /* 144603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 144606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144610 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144618 */     // (saddsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPADDSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 144618 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSBZ128rr),
     /* 144623 */     GIR_RootConstrainSelectedInstOperands,
     /* 144624 */     // GIR_Coverage, 4843,
     /* 144624 */     GIR_Done,
     /* 144625 */   // Label 3116: @144625
     /* 144625 */   GIM_Reject,
     /* 144626 */ // Label 3109: @144626
     /* 144626 */ GIM_Reject,
     /* 144627 */ // Label 3096: @144627
     /* 144627 */ GIM_Try, /*On fail goto*//*Label 3117*/ GIMT_Encode4(144941),
     /* 144632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 144635 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 144638 */   GIM_Try, /*On fail goto*//*Label 3118*/ GIMT_Encode4(144700), // Rule ID 23446 //
     /* 144643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 144646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144658 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144661 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144665 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144675 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144682 */     // (saddsat:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPADDSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWYrm),
     /* 144685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144687 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 144689 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144693 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144698 */     GIR_RootConstrainSelectedInstOperands,
     /* 144699 */     // GIR_Coverage, 23446,
     /* 144699 */     GIR_EraseRootFromParent_Done,
     /* 144700 */   // Label 3118: @144700
     /* 144700 */   GIM_Try, /*On fail goto*//*Label 3119*/ GIMT_Encode4(144762), // Rule ID 23753 //
     /* 144705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 144708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144720 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144723 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144727 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144737 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144744 */     // (saddsat:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPADDSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWZ256rm),
     /* 144747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144749 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 144751 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144755 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144760 */     GIR_RootConstrainSelectedInstOperands,
     /* 144761 */     // GIR_Coverage, 23753,
     /* 144761 */     GIR_EraseRootFromParent_Done,
     /* 144762 */   // Label 3119: @144762
     /* 144762 */   GIM_Try, /*On fail goto*//*Label 3120*/ GIMT_Encode4(144824), // Rule ID 2557 //
     /* 144767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 144770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 144782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144786 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144789 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144793 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144799 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144806 */     // (saddsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWYrm),
     /* 144809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144811 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 144813 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144817 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144822 */     GIR_RootConstrainSelectedInstOperands,
     /* 144823 */     // GIR_Coverage, 2557,
     /* 144823 */     GIR_EraseRootFromParent_Done,
     /* 144824 */   // Label 3120: @144824
     /* 144824 */   GIM_Try, /*On fail goto*//*Label 3121*/ GIMT_Encode4(144886), // Rule ID 4822 //
     /* 144829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 144832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 144844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144848 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144851 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144855 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144861 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144868 */     // (saddsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWZ256rm),
     /* 144871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144873 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 144875 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144879 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144884 */     GIR_RootConstrainSelectedInstOperands,
     /* 144885 */     // GIR_Coverage, 4822,
     /* 144885 */     GIR_EraseRootFromParent_Done,
     /* 144886 */   // Label 3121: @144886
     /* 144886 */   GIM_Try, /*On fail goto*//*Label 3122*/ GIMT_Encode4(144913), // Rule ID 2556 //
     /* 144891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 144894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144906 */     // (saddsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPADDSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 144906 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSWYrr),
     /* 144911 */     GIR_RootConstrainSelectedInstOperands,
     /* 144912 */     // GIR_Coverage, 2556,
     /* 144912 */     GIR_Done,
     /* 144913 */   // Label 3122: @144913
     /* 144913 */   GIM_Try, /*On fail goto*//*Label 3123*/ GIMT_Encode4(144940), // Rule ID 4819 //
     /* 144918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 144921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144933 */     // (saddsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPADDSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 144933 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSWZ256rr),
     /* 144938 */     GIR_RootConstrainSelectedInstOperands,
     /* 144939 */     // GIR_Coverage, 4819,
     /* 144939 */     GIR_Done,
     /* 144940 */   // Label 3123: @144940
     /* 144940 */   GIM_Reject,
     /* 144941 */ // Label 3117: @144941
     /* 144941 */ GIM_Reject,
     /* 144942 */ // Label 3097: @144942
     /* 144942 */ GIM_Try, /*On fail goto*//*Label 3124*/ GIMT_Encode4(145256),
     /* 144947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 144950 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 144953 */   GIM_Try, /*On fail goto*//*Label 3125*/ GIMT_Encode4(145015), // Rule ID 23443 //
     /* 144958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 144961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144973 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144976 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144980 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144990 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144997 */     // (saddsat:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPADDSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBYrm),
     /* 145000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145002 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 145004 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145008 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145013 */     GIR_RootConstrainSelectedInstOperands,
     /* 145014 */     // GIR_Coverage, 23443,
     /* 145014 */     GIR_EraseRootFromParent_Done,
     /* 145015 */   // Label 3125: @145015
     /* 145015 */   GIM_Try, /*On fail goto*//*Label 3126*/ GIMT_Encode4(145077), // Rule ID 23762 //
     /* 145020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 145023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 145027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 145031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145035 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145038 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145042 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 145050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145052 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145059 */     // (saddsat:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPADDSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBZ256rm),
     /* 145062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145064 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 145066 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145070 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145075 */     GIR_RootConstrainSelectedInstOperands,
     /* 145076 */     // GIR_Coverage, 23762,
     /* 145076 */     GIR_EraseRootFromParent_Done,
     /* 145077 */   // Label 3126: @145077
     /* 145077 */   GIM_Try, /*On fail goto*//*Label 3127*/ GIMT_Encode4(145139), // Rule ID 2551 //
     /* 145082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 145085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 145089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 145093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 145097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145101 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145104 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145108 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145114 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145121 */     // (saddsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBYrm),
     /* 145124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145126 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 145128 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145132 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145137 */     GIR_RootConstrainSelectedInstOperands,
     /* 145138 */     // GIR_Coverage, 2551,
     /* 145138 */     GIR_EraseRootFromParent_Done,
     /* 145139 */   // Label 3127: @145139
     /* 145139 */   GIM_Try, /*On fail goto*//*Label 3128*/ GIMT_Encode4(145201), // Rule ID 4840 //
     /* 145144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 145147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 145151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 145155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 145159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145163 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145166 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145170 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145174 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145176 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145183 */     // (saddsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBZ256rm),
     /* 145186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145188 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 145190 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145194 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145199 */     GIR_RootConstrainSelectedInstOperands,
     /* 145200 */     // GIR_Coverage, 4840,
     /* 145200 */     GIR_EraseRootFromParent_Done,
     /* 145201 */   // Label 3128: @145201
     /* 145201 */   GIM_Try, /*On fail goto*//*Label 3129*/ GIMT_Encode4(145228), // Rule ID 2550 //
     /* 145206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 145209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 145213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 145217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 145221 */     // (saddsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPADDSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 145221 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSBYrr),
     /* 145226 */     GIR_RootConstrainSelectedInstOperands,
     /* 145227 */     // GIR_Coverage, 2550,
     /* 145227 */     GIR_Done,
     /* 145228 */   // Label 3129: @145228
     /* 145228 */   GIM_Try, /*On fail goto*//*Label 3130*/ GIMT_Encode4(145255), // Rule ID 4837 //
     /* 145233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 145236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 145240 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 145244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 145248 */     // (saddsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPADDSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 145248 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSBZ256rr),
     /* 145253 */     GIR_RootConstrainSelectedInstOperands,
     /* 145254 */     // GIR_Coverage, 4837,
     /* 145254 */     GIR_Done,
     /* 145255 */   // Label 3130: @145255
     /* 145255 */   GIM_Reject,
     /* 145256 */ // Label 3124: @145256
     /* 145256 */ GIM_Reject,
     /* 145257 */ // Label 3098: @145257
     /* 145257 */ GIM_Try, /*On fail goto*//*Label 3131*/ GIMT_Encode4(145412),
     /* 145262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 145265 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 145268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145272 */   GIM_Try, /*On fail goto*//*Label 3132*/ GIMT_Encode4(145330), // Rule ID 23750 //
     /* 145277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 145280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 145284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145288 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145291 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145295 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145305 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145312 */     // (saddsat:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPADDSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWZrm),
     /* 145315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145317 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 145319 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145323 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145328 */     GIR_RootConstrainSelectedInstOperands,
     /* 145329 */     // GIR_Coverage, 23750,
     /* 145329 */     GIR_EraseRootFromParent_Done,
     /* 145330 */   // Label 3132: @145330
     /* 145330 */   GIM_Try, /*On fail goto*//*Label 3133*/ GIMT_Encode4(145388), // Rule ID 4816 //
     /* 145335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 145338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 145346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145350 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145353 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145357 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145363 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145370 */     // (saddsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWZrm),
     /* 145373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145375 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 145377 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145381 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145386 */     GIR_RootConstrainSelectedInstOperands,
     /* 145387 */     // GIR_Coverage, 4816,
     /* 145387 */     GIR_EraseRootFromParent_Done,
     /* 145388 */   // Label 3133: @145388
     /* 145388 */   GIM_Try, /*On fail goto*//*Label 3134*/ GIMT_Encode4(145411), // Rule ID 4813 //
     /* 145393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 145396 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145404 */     // (saddsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPADDSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 145404 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSWZrr),
     /* 145409 */     GIR_RootConstrainSelectedInstOperands,
     /* 145410 */     // GIR_Coverage, 4813,
     /* 145410 */     GIR_Done,
     /* 145411 */   // Label 3134: @145411
     /* 145411 */   GIM_Reject,
     /* 145412 */ // Label 3131: @145412
     /* 145412 */ GIM_Reject,
     /* 145413 */ // Label 3099: @145413
     /* 145413 */ GIM_Try, /*On fail goto*//*Label 3135*/ GIMT_Encode4(145568),
     /* 145418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 145421 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 145424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145428 */   GIM_Try, /*On fail goto*//*Label 3136*/ GIMT_Encode4(145486), // Rule ID 23759 //
     /* 145433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 145436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 145440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145444 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145447 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145451 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145461 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145468 */     // (saddsat:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPADDSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBZrm),
     /* 145471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145473 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 145475 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145479 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145484 */     GIR_RootConstrainSelectedInstOperands,
     /* 145485 */     // GIR_Coverage, 23759,
     /* 145485 */     GIR_EraseRootFromParent_Done,
     /* 145486 */   // Label 3136: @145486
     /* 145486 */   GIM_Try, /*On fail goto*//*Label 3137*/ GIMT_Encode4(145544), // Rule ID 4834 //
     /* 145491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 145494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 145502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145506 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145509 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145513 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145519 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145526 */     // (saddsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBZrm),
     /* 145529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145531 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 145533 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145537 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145542 */     GIR_RootConstrainSelectedInstOperands,
     /* 145543 */     // GIR_Coverage, 4834,
     /* 145543 */     GIR_EraseRootFromParent_Done,
     /* 145544 */   // Label 3137: @145544
     /* 145544 */   GIM_Try, /*On fail goto*//*Label 3138*/ GIMT_Encode4(145567), // Rule ID 4831 //
     /* 145549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 145552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145560 */     // (saddsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPADDSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 145560 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSBZrr),
     /* 145565 */     GIR_RootConstrainSelectedInstOperands,
     /* 145566 */     // GIR_Coverage, 4831,
     /* 145566 */     GIR_Done,
     /* 145567 */   // Label 3138: @145567
     /* 145567 */   GIM_Reject,
     /* 145568 */ // Label 3135: @145568
     /* 145568 */ GIM_Reject,
     /* 145569 */ // Label 3100: @145569
     /* 145569 */ GIM_Reject,
     /* 145570 */ // Label 39: @145570
     /* 145570 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(13), GIMT_Encode2(25), /*)*//*default:*//*Label 3145*/ GIMT_Encode4(146635),
     /* 145581 */ /*GILLT_v8s16*//*Label 3139*/ GIMT_Encode4(145629), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 145597 */ /*GILLT_v16s8*//*Label 3140*/ GIMT_Encode4(145847),
     /* 145601 */ /*GILLT_v16s16*//*Label 3141*/ GIMT_Encode4(146065), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 145613 */ /*GILLT_v32s8*//*Label 3142*/ GIMT_Encode4(146256),
     /* 145617 */ /*GILLT_v32s16*//*Label 3143*/ GIMT_Encode4(146447), GIMT_Encode4(0),
     /* 145625 */ /*GILLT_v64s8*//*Label 3144*/ GIMT_Encode4(146541),
     /* 145629 */ // Label 3139: @145629
     /* 145629 */ GIM_Try, /*On fail goto*//*Label 3146*/ GIMT_Encode4(145846),
     /* 145634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 145637 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 145640 */   GIM_Try, /*On fail goto*//*Label 3147*/ GIMT_Encode4(145702), // Rule ID 2631 //
     /* 145645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 145648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145652 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 145660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145664 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145667 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145671 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145677 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145684 */     // (usubsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWrm),
     /* 145687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145689 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 145691 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145695 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145700 */     GIR_RootConstrainSelectedInstOperands,
     /* 145701 */     // GIR_Coverage, 2631,
     /* 145701 */     GIR_EraseRootFromParent_Done,
     /* 145702 */   // Label 3147: @145702
     /* 145702 */   GIM_Try, /*On fail goto*//*Label 3148*/ GIMT_Encode4(145764), // Rule ID 4936 //
     /* 145707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 145710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 145714 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 145718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 145722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145726 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145729 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145733 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145739 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145746 */     // (usubsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWZ128rm),
     /* 145749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145751 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 145753 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145757 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145762 */     GIR_RootConstrainSelectedInstOperands,
     /* 145763 */     // GIR_Coverage, 4936,
     /* 145763 */     GIR_EraseRootFromParent_Done,
     /* 145764 */   // Label 3148: @145764
     /* 145764 */   GIM_Try, /*On fail goto*//*Label 3149*/ GIMT_Encode4(145791), // Rule ID 2630 //
     /* 145769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 145772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145776 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145784 */     // (usubsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPSUBUSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 145784 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWrr),
     /* 145789 */     GIR_RootConstrainSelectedInstOperands,
     /* 145790 */     // GIR_Coverage, 2630,
     /* 145790 */     GIR_Done,
     /* 145791 */   // Label 3149: @145791
     /* 145791 */   GIM_Try, /*On fail goto*//*Label 3150*/ GIMT_Encode4(145818), // Rule ID 2632 //
     /* 145796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 145799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145803 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145811 */     // (usubsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PSUBUSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 145811 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBUSWrr),
     /* 145816 */     GIR_RootConstrainSelectedInstOperands,
     /* 145817 */     // GIR_Coverage, 2632,
     /* 145817 */     GIR_Done,
     /* 145818 */   // Label 3150: @145818
     /* 145818 */   GIM_Try, /*On fail goto*//*Label 3151*/ GIMT_Encode4(145845), // Rule ID 4933 //
     /* 145823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 145826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 145830 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 145834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 145838 */     // (usubsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPSUBUSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 145838 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWZ128rr),
     /* 145843 */     GIR_RootConstrainSelectedInstOperands,
     /* 145844 */     // GIR_Coverage, 4933,
     /* 145844 */     GIR_Done,
     /* 145845 */   // Label 3151: @145845
     /* 145845 */   GIM_Reject,
     /* 145846 */ // Label 3146: @145846
     /* 145846 */ GIM_Reject,
     /* 145847 */ // Label 3140: @145847
     /* 145847 */ GIM_Try, /*On fail goto*//*Label 3152*/ GIMT_Encode4(146064),
     /* 145852 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 145855 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 145858 */   GIM_Try, /*On fail goto*//*Label 3153*/ GIMT_Encode4(145920), // Rule ID 2625 //
     /* 145863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 145866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 145878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145882 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145885 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145889 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145895 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145902 */     // (usubsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBrm),
     /* 145905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145907 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 145909 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145913 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145918 */     GIR_RootConstrainSelectedInstOperands,
     /* 145919 */     // GIR_Coverage, 2625,
     /* 145919 */     GIR_EraseRootFromParent_Done,
     /* 145920 */   // Label 3153: @145920
     /* 145920 */   GIM_Try, /*On fail goto*//*Label 3154*/ GIMT_Encode4(145982), // Rule ID 4954 //
     /* 145925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 145928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 145932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 145936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 145940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145944 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145947 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145951 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145957 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145964 */     // (usubsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBZ128rm),
     /* 145967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145969 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 145971 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145975 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145980 */     GIR_RootConstrainSelectedInstOperands,
     /* 145981 */     // GIR_Coverage, 4954,
     /* 145981 */     GIR_EraseRootFromParent_Done,
     /* 145982 */   // Label 3154: @145982
     /* 145982 */   GIM_Try, /*On fail goto*//*Label 3155*/ GIMT_Encode4(146009), // Rule ID 2624 //
     /* 145987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 145990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146002 */     // (usubsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPSUBUSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 146002 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBrr),
     /* 146007 */     GIR_RootConstrainSelectedInstOperands,
     /* 146008 */     // GIR_Coverage, 2624,
     /* 146008 */     GIR_Done,
     /* 146009 */   // Label 3155: @146009
     /* 146009 */   GIM_Try, /*On fail goto*//*Label 3156*/ GIMT_Encode4(146036), // Rule ID 2626 //
     /* 146014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 146017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146029 */     // (usubsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PSUBUSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 146029 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBUSBrr),
     /* 146034 */     GIR_RootConstrainSelectedInstOperands,
     /* 146035 */     // GIR_Coverage, 2626,
     /* 146035 */     GIR_Done,
     /* 146036 */   // Label 3156: @146036
     /* 146036 */   GIM_Try, /*On fail goto*//*Label 3157*/ GIMT_Encode4(146063), // Rule ID 4951 //
     /* 146041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 146044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146056 */     // (usubsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPSUBUSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 146056 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBZ128rr),
     /* 146061 */     GIR_RootConstrainSelectedInstOperands,
     /* 146062 */     // GIR_Coverage, 4951,
     /* 146062 */     GIR_Done,
     /* 146063 */   // Label 3157: @146063
     /* 146063 */   GIM_Reject,
     /* 146064 */ // Label 3152: @146064
     /* 146064 */ GIM_Reject,
     /* 146065 */ // Label 3141: @146065
     /* 146065 */ GIM_Try, /*On fail goto*//*Label 3158*/ GIMT_Encode4(146255),
     /* 146070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 146073 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 146076 */   GIM_Try, /*On fail goto*//*Label 3159*/ GIMT_Encode4(146138), // Rule ID 2635 //
     /* 146081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 146084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146088 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146100 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146103 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 146107 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 146111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146113 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 146120 */     // (usubsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 146120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWYrm),
     /* 146123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146125 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 146127 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 146131 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 146136 */     GIR_RootConstrainSelectedInstOperands,
     /* 146137 */     // GIR_Coverage, 2635,
     /* 146137 */     GIR_EraseRootFromParent_Done,
     /* 146138 */   // Label 3159: @146138
     /* 146138 */   GIM_Try, /*On fail goto*//*Label 3160*/ GIMT_Encode4(146200), // Rule ID 4930 //
     /* 146143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 146146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146162 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146165 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 146169 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 146173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146175 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 146182 */     // (usubsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 146182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWZ256rm),
     /* 146185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146187 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 146189 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 146193 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 146198 */     GIR_RootConstrainSelectedInstOperands,
     /* 146199 */     // GIR_Coverage, 4930,
     /* 146199 */     GIR_EraseRootFromParent_Done,
     /* 146200 */   // Label 3160: @146200
     /* 146200 */   GIM_Try, /*On fail goto*//*Label 3161*/ GIMT_Encode4(146227), // Rule ID 2634 //
     /* 146205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 146208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146220 */     // (usubsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPSUBUSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 146220 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWYrr),
     /* 146225 */     GIR_RootConstrainSelectedInstOperands,
     /* 146226 */     // GIR_Coverage, 2634,
     /* 146226 */     GIR_Done,
     /* 146227 */   // Label 3161: @146227
     /* 146227 */   GIM_Try, /*On fail goto*//*Label 3162*/ GIMT_Encode4(146254), // Rule ID 4927 //
     /* 146232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 146235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146247 */     // (usubsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPSUBUSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 146247 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWZ256rr),
     /* 146252 */     GIR_RootConstrainSelectedInstOperands,
     /* 146253 */     // GIR_Coverage, 4927,
     /* 146253 */     GIR_Done,
     /* 146254 */   // Label 3162: @146254
     /* 146254 */   GIM_Reject,
     /* 146255 */ // Label 3158: @146255
     /* 146255 */ GIM_Reject,
     /* 146256 */ // Label 3142: @146256
     /* 146256 */ GIM_Try, /*On fail goto*//*Label 3163*/ GIMT_Encode4(146446),
     /* 146261 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 146264 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 146267 */   GIM_Try, /*On fail goto*//*Label 3164*/ GIMT_Encode4(146329), // Rule ID 2629 //
     /* 146272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 146275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146291 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146294 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 146298 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 146302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146304 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 146311 */     // (usubsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 146311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBYrm),
     /* 146314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146316 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 146318 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 146322 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 146327 */     GIR_RootConstrainSelectedInstOperands,
     /* 146328 */     // GIR_Coverage, 2629,
     /* 146328 */     GIR_EraseRootFromParent_Done,
     /* 146329 */   // Label 3164: @146329
     /* 146329 */   GIM_Try, /*On fail goto*//*Label 3165*/ GIMT_Encode4(146391), // Rule ID 4948 //
     /* 146334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 146337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146341 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146353 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146356 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 146360 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 146364 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146366 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 146373 */     // (usubsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 146373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBZ256rm),
     /* 146376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146378 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 146380 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 146384 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 146389 */     GIR_RootConstrainSelectedInstOperands,
     /* 146390 */     // GIR_Coverage, 4948,
     /* 146390 */     GIR_EraseRootFromParent_Done,
     /* 146391 */   // Label 3165: @146391
     /* 146391 */   GIM_Try, /*On fail goto*//*Label 3166*/ GIMT_Encode4(146418), // Rule ID 2628 //
     /* 146396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 146399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146403 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146411 */     // (usubsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPSUBUSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 146411 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBYrr),
     /* 146416 */     GIR_RootConstrainSelectedInstOperands,
     /* 146417 */     // GIR_Coverage, 2628,
     /* 146417 */     GIR_Done,
     /* 146418 */   // Label 3166: @146418
     /* 146418 */   GIM_Try, /*On fail goto*//*Label 3167*/ GIMT_Encode4(146445), // Rule ID 4945 //
     /* 146423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 146426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146438 */     // (usubsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPSUBUSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 146438 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBZ256rr),
     /* 146443 */     GIR_RootConstrainSelectedInstOperands,
     /* 146444 */     // GIR_Coverage, 4945,
     /* 146444 */     GIR_Done,
     /* 146445 */   // Label 3167: @146445
     /* 146445 */   GIM_Reject,
     /* 146446 */ // Label 3163: @146446
     /* 146446 */ GIM_Reject,
     /* 146447 */ // Label 3143: @146447
     /* 146447 */ GIM_Try, /*On fail goto*//*Label 3168*/ GIMT_Encode4(146540),
     /* 146452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 146455 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 146458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 146462 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 146466 */   GIM_Try, /*On fail goto*//*Label 3169*/ GIMT_Encode4(146520), // Rule ID 4924 //
     /* 146471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 146474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146482 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146485 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 146489 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 146493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146495 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 146502 */     // (usubsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 146502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWZrm),
     /* 146505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146507 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 146509 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 146513 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 146518 */     GIR_RootConstrainSelectedInstOperands,
     /* 146519 */     // GIR_Coverage, 4924,
     /* 146519 */     GIR_EraseRootFromParent_Done,
     /* 146520 */   // Label 3169: @146520
     /* 146520 */   GIM_Try, /*On fail goto*//*Label 3170*/ GIMT_Encode4(146539), // Rule ID 4921 //
     /* 146525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 146528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 146532 */     // (usubsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPSUBUSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 146532 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWZrr),
     /* 146537 */     GIR_RootConstrainSelectedInstOperands,
     /* 146538 */     // GIR_Coverage, 4921,
     /* 146538 */     GIR_Done,
     /* 146539 */   // Label 3170: @146539
     /* 146539 */   GIM_Reject,
     /* 146540 */ // Label 3168: @146540
     /* 146540 */ GIM_Reject,
     /* 146541 */ // Label 3144: @146541
     /* 146541 */ GIM_Try, /*On fail goto*//*Label 3171*/ GIMT_Encode4(146634),
     /* 146546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 146549 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 146552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 146556 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 146560 */   GIM_Try, /*On fail goto*//*Label 3172*/ GIMT_Encode4(146614), // Rule ID 4942 //
     /* 146565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 146568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146576 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146579 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 146583 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 146587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146589 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 146596 */     // (usubsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 146596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBZrm),
     /* 146599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146601 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 146603 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 146607 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 146612 */     GIR_RootConstrainSelectedInstOperands,
     /* 146613 */     // GIR_Coverage, 4942,
     /* 146613 */     GIR_EraseRootFromParent_Done,
     /* 146614 */   // Label 3172: @146614
     /* 146614 */   GIM_Try, /*On fail goto*//*Label 3173*/ GIMT_Encode4(146633), // Rule ID 4939 //
     /* 146619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 146622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 146626 */     // (usubsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPSUBUSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 146626 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBZrr),
     /* 146631 */     GIR_RootConstrainSelectedInstOperands,
     /* 146632 */     // GIR_Coverage, 4939,
     /* 146632 */     GIR_Done,
     /* 146633 */   // Label 3173: @146633
     /* 146633 */   GIM_Reject,
     /* 146634 */ // Label 3171: @146634
     /* 146634 */ GIM_Reject,
     /* 146635 */ // Label 3145: @146635
     /* 146635 */ GIM_Reject,
     /* 146636 */ // Label 40: @146636
     /* 146636 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(13), GIMT_Encode2(25), /*)*//*default:*//*Label 3180*/ GIMT_Encode4(147701),
     /* 146647 */ /*GILLT_v8s16*//*Label 3174*/ GIMT_Encode4(146695), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 146663 */ /*GILLT_v16s8*//*Label 3175*/ GIMT_Encode4(146913),
     /* 146667 */ /*GILLT_v16s16*//*Label 3176*/ GIMT_Encode4(147131), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 146679 */ /*GILLT_v32s8*//*Label 3177*/ GIMT_Encode4(147322),
     /* 146683 */ /*GILLT_v32s16*//*Label 3178*/ GIMT_Encode4(147513), GIMT_Encode4(0),
     /* 146691 */ /*GILLT_v64s8*//*Label 3179*/ GIMT_Encode4(147607),
     /* 146695 */ // Label 3174: @146695
     /* 146695 */ GIM_Try, /*On fail goto*//*Label 3181*/ GIMT_Encode4(146912),
     /* 146700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 146703 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 146706 */   GIM_Try, /*On fail goto*//*Label 3182*/ GIMT_Encode4(146768), // Rule ID 2619 //
     /* 146711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 146714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146730 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146733 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 146737 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 146741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146743 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 146750 */     // (ssubsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 146750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSWrm),
     /* 146753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146755 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 146757 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 146761 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 146766 */     GIR_RootConstrainSelectedInstOperands,
     /* 146767 */     // GIR_Coverage, 2619,
     /* 146767 */     GIR_EraseRootFromParent_Done,
     /* 146768 */   // Label 3182: @146768
     /* 146768 */   GIM_Try, /*On fail goto*//*Label 3183*/ GIMT_Encode4(146830), // Rule ID 4864 //
     /* 146773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 146776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146792 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146795 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 146799 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 146803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146805 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 146812 */     // (ssubsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 146812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSWZ128rm),
     /* 146815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146817 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 146819 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 146823 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 146828 */     GIR_RootConstrainSelectedInstOperands,
     /* 146829 */     // GIR_Coverage, 4864,
     /* 146829 */     GIR_EraseRootFromParent_Done,
     /* 146830 */   // Label 3183: @146830
     /* 146830 */   GIM_Try, /*On fail goto*//*Label 3184*/ GIMT_Encode4(146857), // Rule ID 2618 //
     /* 146835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 146838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146850 */     // (ssubsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPSUBSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 146850 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSWrr),
     /* 146855 */     GIR_RootConstrainSelectedInstOperands,
     /* 146856 */     // GIR_Coverage, 2618,
     /* 146856 */     GIR_Done,
     /* 146857 */   // Label 3184: @146857
     /* 146857 */   GIM_Try, /*On fail goto*//*Label 3185*/ GIMT_Encode4(146884), // Rule ID 2620 //
     /* 146862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 146865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146877 */     // (ssubsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PSUBSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 146877 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBSWrr),
     /* 146882 */     GIR_RootConstrainSelectedInstOperands,
     /* 146883 */     // GIR_Coverage, 2620,
     /* 146883 */     GIR_Done,
     /* 146884 */   // Label 3185: @146884
     /* 146884 */   GIM_Try, /*On fail goto*//*Label 3186*/ GIMT_Encode4(146911), // Rule ID 4861 //
     /* 146889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 146892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146904 */     // (ssubsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPSUBSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 146904 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSWZ128rr),
     /* 146909 */     GIR_RootConstrainSelectedInstOperands,
     /* 146910 */     // GIR_Coverage, 4861,
     /* 146910 */     GIR_Done,
     /* 146911 */   // Label 3186: @146911
     /* 146911 */   GIM_Reject,
     /* 146912 */ // Label 3181: @146912
     /* 146912 */ GIM_Reject,
     /* 146913 */ // Label 3175: @146913
     /* 146913 */ GIM_Try, /*On fail goto*//*Label 3187*/ GIMT_Encode4(147130),
     /* 146918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 146921 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 146924 */   GIM_Try, /*On fail goto*//*Label 3188*/ GIMT_Encode4(146986), // Rule ID 2613 //
     /* 146929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 146932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146948 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146951 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 146955 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 146959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146961 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 146968 */     // (ssubsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 146968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSBrm),
     /* 146971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146973 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 146975 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 146979 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 146984 */     GIR_RootConstrainSelectedInstOperands,
     /* 146985 */     // GIR_Coverage, 2613,
     /* 146985 */     GIR_EraseRootFromParent_Done,
     /* 146986 */   // Label 3188: @146986
     /* 146986 */   GIM_Try, /*On fail goto*//*Label 3189*/ GIMT_Encode4(147048), // Rule ID 4882 //
     /* 146991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 146994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 147002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 147006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147010 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147013 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 147017 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 147021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147023 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147030 */     // (ssubsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSBZ128rm),
     /* 147033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147035 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 147037 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147041 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 147046 */     GIR_RootConstrainSelectedInstOperands,
     /* 147047 */     // GIR_Coverage, 4882,
     /* 147047 */     GIR_EraseRootFromParent_Done,
     /* 147048 */   // Label 3189: @147048
     /* 147048 */   GIM_Try, /*On fail goto*//*Label 3190*/ GIMT_Encode4(147075), // Rule ID 2612 //
     /* 147053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 147056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 147060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 147064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 147068 */     // (ssubsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPSUBSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 147068 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSBrr),
     /* 147073 */     GIR_RootConstrainSelectedInstOperands,
     /* 147074 */     // GIR_Coverage, 2612,
     /* 147074 */     GIR_Done,
     /* 147075 */   // Label 3190: @147075
     /* 147075 */   GIM_Try, /*On fail goto*//*Label 3191*/ GIMT_Encode4(147102), // Rule ID 2614 //
     /* 147080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 147083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 147087 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 147091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 147095 */     // (ssubsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PSUBSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 147095 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBSBrr),
     /* 147100 */     GIR_RootConstrainSelectedInstOperands,
     /* 147101 */     // GIR_Coverage, 2614,
     /* 147101 */     GIR_Done,
     /* 147102 */   // Label 3191: @147102
     /* 147102 */   GIM_Try, /*On fail goto*//*Label 3192*/ GIMT_Encode4(147129), // Rule ID 4879 //
     /* 147107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 147110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 147114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 147118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 147122 */     // (ssubsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPSUBSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 147122 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSBZ128rr),
     /* 147127 */     GIR_RootConstrainSelectedInstOperands,
     /* 147128 */     // GIR_Coverage, 4879,
     /* 147128 */     GIR_Done,
     /* 147129 */   // Label 3192: @147129
     /* 147129 */   GIM_Reject,
     /* 147130 */ // Label 3187: @147130
     /* 147130 */ GIM_Reject,
     /* 147131 */ // Label 3176: @147131
     /* 147131 */ GIM_Try, /*On fail goto*//*Label 3193*/ GIMT_Encode4(147321),
     /* 147136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 147139 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 147142 */   GIM_Try, /*On fail goto*//*Label 3194*/ GIMT_Encode4(147204), // Rule ID 2623 //
     /* 147147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 147150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 147154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 147158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 147162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147166 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147169 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 147173 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 147177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147179 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147186 */     // (ssubsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSWYrm),
     /* 147189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147191 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 147193 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147197 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 147202 */     GIR_RootConstrainSelectedInstOperands,
     /* 147203 */     // GIR_Coverage, 2623,
     /* 147203 */     GIR_EraseRootFromParent_Done,
     /* 147204 */   // Label 3194: @147204
     /* 147204 */   GIM_Try, /*On fail goto*//*Label 3195*/ GIMT_Encode4(147266), // Rule ID 4858 //
     /* 147209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 147212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 147216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 147220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 147224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147228 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147231 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 147235 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 147239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147241 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147248 */     // (ssubsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSWZ256rm),
     /* 147251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147253 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 147255 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147259 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 147264 */     GIR_RootConstrainSelectedInstOperands,
     /* 147265 */     // GIR_Coverage, 4858,
     /* 147265 */     GIR_EraseRootFromParent_Done,
     /* 147266 */   // Label 3195: @147266
     /* 147266 */   GIM_Try, /*On fail goto*//*Label 3196*/ GIMT_Encode4(147293), // Rule ID 2622 //
     /* 147271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 147274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 147278 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 147282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 147286 */     // (ssubsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPSUBSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 147286 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSWYrr),
     /* 147291 */     GIR_RootConstrainSelectedInstOperands,
     /* 147292 */     // GIR_Coverage, 2622,
     /* 147292 */     GIR_Done,
     /* 147293 */   // Label 3196: @147293
     /* 147293 */   GIM_Try, /*On fail goto*//*Label 3197*/ GIMT_Encode4(147320), // Rule ID 4855 //
     /* 147298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 147301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 147305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 147309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 147313 */     // (ssubsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPSUBSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 147313 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSWZ256rr),
     /* 147318 */     GIR_RootConstrainSelectedInstOperands,
     /* 147319 */     // GIR_Coverage, 4855,
     /* 147319 */     GIR_Done,
     /* 147320 */   // Label 3197: @147320
     /* 147320 */   GIM_Reject,
     /* 147321 */ // Label 3193: @147321
     /* 147321 */ GIM_Reject,
     /* 147322 */ // Label 3177: @147322
     /* 147322 */ GIM_Try, /*On fail goto*//*Label 3198*/ GIMT_Encode4(147512),
     /* 147327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 147330 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 147333 */   GIM_Try, /*On fail goto*//*Label 3199*/ GIMT_Encode4(147395), // Rule ID 2617 //
     /* 147338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 147341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 147345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 147349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 147353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147357 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147360 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 147364 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 147368 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147370 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147377 */     // (ssubsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSBYrm),
     /* 147380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147382 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 147384 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147388 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 147393 */     GIR_RootConstrainSelectedInstOperands,
     /* 147394 */     // GIR_Coverage, 2617,
     /* 147394 */     GIR_EraseRootFromParent_Done,
     /* 147395 */   // Label 3199: @147395
     /* 147395 */   GIM_Try, /*On fail goto*//*Label 3200*/ GIMT_Encode4(147457), // Rule ID 4876 //
     /* 147400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 147403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 147407 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 147411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 147415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147419 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147422 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 147426 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 147430 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147432 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147439 */     // (ssubsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSBZ256rm),
     /* 147442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147444 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 147446 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147450 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 147455 */     GIR_RootConstrainSelectedInstOperands,
     /* 147456 */     // GIR_Coverage, 4876,
     /* 147456 */     GIR_EraseRootFromParent_Done,
     /* 147457 */   // Label 3200: @147457
     /* 147457 */   GIM_Try, /*On fail goto*//*Label 3201*/ GIMT_Encode4(147484), // Rule ID 2616 //
     /* 147462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 147465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 147469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 147473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 147477 */     // (ssubsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPSUBSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 147477 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSBYrr),
     /* 147482 */     GIR_RootConstrainSelectedInstOperands,
     /* 147483 */     // GIR_Coverage, 2616,
     /* 147483 */     GIR_Done,
     /* 147484 */   // Label 3201: @147484
     /* 147484 */   GIM_Try, /*On fail goto*//*Label 3202*/ GIMT_Encode4(147511), // Rule ID 4873 //
     /* 147489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 147492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 147496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 147500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 147504 */     // (ssubsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPSUBSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 147504 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSBZ256rr),
     /* 147509 */     GIR_RootConstrainSelectedInstOperands,
     /* 147510 */     // GIR_Coverage, 4873,
     /* 147510 */     GIR_Done,
     /* 147511 */   // Label 3202: @147511
     /* 147511 */   GIM_Reject,
     /* 147512 */ // Label 3198: @147512
     /* 147512 */ GIM_Reject,
     /* 147513 */ // Label 3178: @147513
     /* 147513 */ GIM_Try, /*On fail goto*//*Label 3203*/ GIMT_Encode4(147606),
     /* 147518 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 147521 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 147524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 147528 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 147532 */   GIM_Try, /*On fail goto*//*Label 3204*/ GIMT_Encode4(147586), // Rule ID 4852 //
     /* 147537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 147540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 147544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147548 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147551 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 147555 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 147559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147561 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147568 */     // (ssubsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSWZrm),
     /* 147571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147573 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 147575 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147579 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 147584 */     GIR_RootConstrainSelectedInstOperands,
     /* 147585 */     // GIR_Coverage, 4852,
     /* 147585 */     GIR_EraseRootFromParent_Done,
     /* 147586 */   // Label 3204: @147586
     /* 147586 */   GIM_Try, /*On fail goto*//*Label 3205*/ GIMT_Encode4(147605), // Rule ID 4849 //
     /* 147591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 147594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 147598 */     // (ssubsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPSUBSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 147598 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSWZrr),
     /* 147603 */     GIR_RootConstrainSelectedInstOperands,
     /* 147604 */     // GIR_Coverage, 4849,
     /* 147604 */     GIR_Done,
     /* 147605 */   // Label 3205: @147605
     /* 147605 */   GIM_Reject,
     /* 147606 */ // Label 3203: @147606
     /* 147606 */ GIM_Reject,
     /* 147607 */ // Label 3179: @147607
     /* 147607 */ GIM_Try, /*On fail goto*//*Label 3206*/ GIMT_Encode4(147700),
     /* 147612 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 147615 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 147618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 147622 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 147626 */   GIM_Try, /*On fail goto*//*Label 3207*/ GIMT_Encode4(147680), // Rule ID 4870 //
     /* 147631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 147634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 147638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147642 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147645 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 147649 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 147653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147655 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147662 */     // (ssubsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSBZrm),
     /* 147665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147667 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 147669 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147673 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 147678 */     GIR_RootConstrainSelectedInstOperands,
     /* 147679 */     // GIR_Coverage, 4870,
     /* 147679 */     GIR_EraseRootFromParent_Done,
     /* 147680 */   // Label 3207: @147680
     /* 147680 */   GIM_Try, /*On fail goto*//*Label 3208*/ GIMT_Encode4(147699), // Rule ID 4867 //
     /* 147685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 147688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 147692 */     // (ssubsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPSUBSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 147692 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSBZrr),
     /* 147697 */     GIR_RootConstrainSelectedInstOperands,
     /* 147698 */     // GIR_Coverage, 4867,
     /* 147698 */     GIR_Done,
     /* 147699 */   // Label 3208: @147699
     /* 147699 */   GIM_Reject,
     /* 147700 */ // Label 3206: @147700
     /* 147700 */ GIM_Reject,
     /* 147701 */ // Label 3180: @147701
     /* 147701 */ GIM_Reject,
     /* 147702 */ // Label 41: @147702
     /* 147702 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 3222*/ GIMT_Encode4(153615),
     /* 147713 */ /*GILLT_s16*//*Label 3209*/ GIMT_Encode4(147797),
     /* 147717 */ /*GILLT_s32*//*Label 3210*/ GIMT_Encode4(147957),
     /* 147721 */ /*GILLT_s64*//*Label 3211*/ GIMT_Encode4(149354),
     /* 147725 */ /*GILLT_s80*//*Label 3212*/ GIMT_Encode4(150895), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 147737 */ /*GILLT_v2s64*//*Label 3213*/ GIMT_Encode4(151461), GIMT_Encode4(0),
     /* 147745 */ /*GILLT_v4s32*//*Label 3214*/ GIMT_Encode4(151815),
     /* 147749 */ /*GILLT_v4s64*//*Label 3215*/ GIMT_Encode4(152169), GIMT_Encode4(0),
     /* 147757 */ /*GILLT_v8s16*//*Label 3216*/ GIMT_Encode4(152492),
     /* 147761 */ /*GILLT_v8s32*//*Label 3217*/ GIMT_Encode4(152652),
     /* 147765 */ /*GILLT_v8s64*//*Label 3218*/ GIMT_Encode4(152975), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 147777 */ /*GILLT_v16s16*//*Label 3219*/ GIMT_Encode4(153135),
     /* 147781 */ /*GILLT_v16s32*//*Label 3220*/ GIMT_Encode4(153295), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 147793 */ /*GILLT_v32s16*//*Label 3221*/ GIMT_Encode4(153455),
     /* 147797 */ // Label 3209: @147797
     /* 147797 */ GIM_Try, /*On fail goto*//*Label 3223*/ GIMT_Encode4(147956),
     /* 147802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 147805 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 147808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 147812 */   GIM_Try, /*On fail goto*//*Label 3224*/ GIMT_Encode4(147870), // Rule ID 24250 //
     /* 147817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 147820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147828 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147831 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 147835 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 147839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 147843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147845 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147852 */     // (fadd:{ *:[f16] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR16X:{ *:[f16] }:$src1)  =>  (VADDSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSHZrm),
     /* 147855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147857 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 147859 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147863 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 147868 */     GIR_RootConstrainSelectedInstOperands,
     /* 147869 */     // GIR_Coverage, 24250,
     /* 147869 */     GIR_EraseRootFromParent_Done,
     /* 147870 */   // Label 3224: @147870
     /* 147870 */   GIM_Try, /*On fail goto*//*Label 3225*/ GIMT_Encode4(147928), // Rule ID 5955 //
     /* 147875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 147878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 147882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 147886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147890 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147893 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 147897 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 147901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147903 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147910 */     // (fadd:{ *:[f16] } FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSHZrm),
     /* 147913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147915 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 147917 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147921 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 147926 */     GIR_RootConstrainSelectedInstOperands,
     /* 147927 */     // GIR_Coverage, 5955,
     /* 147927 */     GIR_EraseRootFromParent_Done,
     /* 147928 */   // Label 3225: @147928
     /* 147928 */   GIM_Try, /*On fail goto*//*Label 3226*/ GIMT_Encode4(147955), // Rule ID 5953 //
     /* 147933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 147936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 147940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 147944 */     // (fadd:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VADDSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 147944 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSHZrr),
     /* 147949 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 147953 */     GIR_RootConstrainSelectedInstOperands,
     /* 147954 */     // GIR_Coverage, 5953,
     /* 147954 */     GIR_Done,
     /* 147955 */   // Label 3226: @147955
     /* 147955 */   GIM_Reject,
     /* 147956 */ // Label 3223: @147956
     /* 147956 */ GIM_Reject,
     /* 147957 */ // Label 3210: @147957
     /* 147957 */ GIM_Try, /*On fail goto*//*Label 3227*/ GIMT_Encode4(149353),
     /* 147962 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 147965 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 147968 */   GIM_Try, /*On fail goto*//*Label 3228*/ GIMT_Encode4(148050), // Rule ID 26018 //
     /* 147973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 147976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 147980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 147988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 147992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 147996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148000 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 148003 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 148007 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148014 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 148018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148022 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 148024 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148031 */     // (fadd:{ *:[f32] } (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>), FR32:{ *:[f32] }:$src1)  =>  (ADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSSrm),
     /* 148034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148036 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 148038 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148042 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 148048 */     GIR_RootConstrainSelectedInstOperands,
     /* 148049 */     // GIR_Coverage, 26018,
     /* 148049 */     GIR_EraseRootFromParent_Done,
     /* 148050 */   // Label 3228: @148050
     /* 148050 */   GIM_Try, /*On fail goto*//*Label 3229*/ GIMT_Encode4(148132), // Rule ID 26019 //
     /* 148055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 148058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 148070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 148074 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 148078 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148082 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 148085 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 148089 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148096 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 148100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148104 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 148106 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148113 */     // (fadd:{ *:[f32] } (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>), FR32:{ *:[f32] }:$src1)  =>  (VADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSrm),
     /* 148116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148118 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 148120 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148124 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 148130 */     GIR_RootConstrainSelectedInstOperands,
     /* 148131 */     // GIR_Coverage, 26019,
     /* 148131 */     GIR_EraseRootFromParent_Done,
     /* 148132 */   // Label 3229: @148132
     /* 148132 */   GIM_Try, /*On fail goto*//*Label 3230*/ GIMT_Encode4(148214), // Rule ID 26020 //
     /* 148137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 148140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 148144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 148152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 148156 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 148160 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148164 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 148167 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 148171 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148178 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 148182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 148186 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 148188 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148195 */     // (fadd:{ *:[f32] } (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>), FR32X:{ *:[f32] }:$src1)  =>  (VADDSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSZrm),
     /* 148198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148200 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 148202 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148206 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 148212 */     GIR_RootConstrainSelectedInstOperands,
     /* 148213 */     // GIR_Coverage, 26020,
     /* 148213 */     GIR_EraseRootFromParent_Done,
     /* 148214 */   // Label 3230: @148214
     /* 148214 */   GIM_Try, /*On fail goto*//*Label 3231*/ GIMT_Encode4(148296), // Rule ID 22467 //
     /* 148219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 148222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 148234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 148238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 148242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 148246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148250 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 148253 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 148257 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148264 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 148268 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 148270 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148277 */     // (fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (ADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSSrm),
     /* 148280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148282 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 148284 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148288 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 148294 */     GIR_RootConstrainSelectedInstOperands,
     /* 148295 */     // GIR_Coverage, 22467,
     /* 148295 */     GIR_EraseRootFromParent_Done,
     /* 148296 */   // Label 3231: @148296
     /* 148296 */   GIM_Try, /*On fail goto*//*Label 3232*/ GIMT_Encode4(148378), // Rule ID 22468 //
     /* 148301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 148304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148308 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 148316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 148320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 148324 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 148328 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148332 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 148335 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 148339 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148346 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 148350 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 148352 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148359 */     // (fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (VADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSrm),
     /* 148362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148364 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 148366 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148370 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 148376 */     GIR_RootConstrainSelectedInstOperands,
     /* 148377 */     // GIR_Coverage, 22468,
     /* 148377 */     GIR_EraseRootFromParent_Done,
     /* 148378 */   // Label 3232: @148378
     /* 148378 */   GIM_Try, /*On fail goto*//*Label 3233*/ GIMT_Encode4(148460), // Rule ID 22469 //
     /* 148383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 148386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 148390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 148394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 148398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 148402 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 148406 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 148410 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148414 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 148417 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 148421 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148428 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 148432 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 148434 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148441 */     // (fadd:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (VADDSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSZrm),
     /* 148444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148446 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 148448 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148452 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 148458 */     GIR_RootConstrainSelectedInstOperands,
     /* 148459 */     // GIR_Coverage, 22469,
     /* 148459 */     GIR_EraseRootFromParent_Done,
     /* 148460 */   // Label 3233: @148460
     /* 148460 */   GIM_Try, /*On fail goto*//*Label 3234*/ GIMT_Encode4(148525), // Rule ID 23247 //
     /* 148465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 148468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 148472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 148480 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 148487 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 148491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 148495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148497 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148504 */     // (fadd:{ *:[f32] } (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP32:{ *:[f32] }:$src1)  =>  (ADD_FpI16m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI16m32),
     /* 148507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148509 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 148511 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148515 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 148518 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 148523 */     GIR_RootConstrainSelectedInstOperands,
     /* 148524 */     // GIR_Coverage, 23247,
     /* 148524 */     GIR_EraseRootFromParent_Done,
     /* 148525 */   // Label 3234: @148525
     /* 148525 */   GIM_Try, /*On fail goto*//*Label 3235*/ GIMT_Encode4(148590), // Rule ID 23249 //
     /* 148530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 148533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 148537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 148545 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148552 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 148556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 148560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148562 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148569 */     // (fadd:{ *:[f32] } (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP32:{ *:[f32] }:$src1)  =>  (ADD_FpI32m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI32m32),
     /* 148572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148574 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 148576 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148580 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 148583 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 148588 */     GIR_RootConstrainSelectedInstOperands,
     /* 148589 */     // GIR_Coverage, 23249,
     /* 148589 */     GIR_EraseRootFromParent_Done,
     /* 148590 */   // Label 3235: @148590
     /* 148590 */   GIM_Try, /*On fail goto*//*Label 3236*/ GIMT_Encode4(148655), // Rule ID 23237 //
     /* 148595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 148598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 148602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148610 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148613 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 148617 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 148621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 148625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148627 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148634 */     // (fadd:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP32:{ *:[f32] }:$src1)  =>  (ADD_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp32m),
     /* 148637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148639 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 148641 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148645 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 148648 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 148653 */     GIR_RootConstrainSelectedInstOperands,
     /* 148654 */     // GIR_Coverage, 23237,
     /* 148654 */     GIR_EraseRootFromParent_Done,
     /* 148655 */   // Label 3236: @148655
     /* 148655 */   GIM_Try, /*On fail goto*//*Label 3237*/ GIMT_Encode4(148717), // Rule ID 23382 //
     /* 148660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 148663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148675 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148678 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 148682 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 148686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148692 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148699 */     // (fadd:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (VADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSrm),
     /* 148702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148704 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 148706 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148710 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 148715 */     GIR_RootConstrainSelectedInstOperands,
     /* 148716 */     // GIR_Coverage, 23382,
     /* 148716 */     GIR_EraseRootFromParent_Done,
     /* 148717 */   // Label 3237: @148717
     /* 148717 */   GIM_Try, /*On fail goto*//*Label 3238*/ GIMT_Encode4(148779), // Rule ID 23386 //
     /* 148722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 148725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148737 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148740 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 148744 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 148748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148752 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148754 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148761 */     // (fadd:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (ADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSSrm),
     /* 148764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148766 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 148768 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148772 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 148777 */     GIR_RootConstrainSelectedInstOperands,
     /* 148778 */     // GIR_Coverage, 23386,
     /* 148778 */     GIR_EraseRootFromParent_Done,
     /* 148779 */   // Label 3238: @148779
     /* 148779 */   GIM_Try, /*On fail goto*//*Label 3239*/ GIMT_Encode4(148841), // Rule ID 24246 //
     /* 148784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 148787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 148791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148799 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148802 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 148806 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 148810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 148814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148816 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148823 */     // (fadd:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32X:{ *:[f32] }:$src1)  =>  (VADDSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSZrm),
     /* 148826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148828 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 148830 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148834 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 148839 */     GIR_RootConstrainSelectedInstOperands,
     /* 148840 */     // GIR_Coverage, 24246,
     /* 148840 */     GIR_EraseRootFromParent_Done,
     /* 148841 */   // Label 3239: @148841
     /* 148841 */   GIM_Try, /*On fail goto*//*Label 3240*/ GIMT_Encode4(148906), // Rule ID 921 //
     /* 148846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 148849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 148853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 148857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 148861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 148865 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 148872 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 148876 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148878 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148885 */     // (fadd:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (ADD_FpI16m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI16m32),
     /* 148888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148890 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 148892 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148896 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 148899 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 148904 */     GIR_RootConstrainSelectedInstOperands,
     /* 148905 */     // GIR_Coverage, 921,
     /* 148905 */     GIR_EraseRootFromParent_Done,
     /* 148906 */   // Label 3240: @148906
     /* 148906 */   GIM_Try, /*On fail goto*//*Label 3241*/ GIMT_Encode4(148971), // Rule ID 923 //
     /* 148911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 148914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 148918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 148922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 148926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 148930 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148937 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 148941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148943 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148950 */     // (fadd:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (ADD_FpI32m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI32m32),
     /* 148953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148955 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 148957 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148961 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 148964 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 148969 */     GIR_RootConstrainSelectedInstOperands,
     /* 148970 */     // GIR_Coverage, 923,
     /* 148970 */     GIR_EraseRootFromParent_Done,
     /* 148971 */   // Label 3241: @148971
     /* 148971 */   GIM_Try, /*On fail goto*//*Label 3242*/ GIMT_Encode4(149036), // Rule ID 911 //
     /* 148976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 148979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 148983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 148987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 148991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148995 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148998 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 149002 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 149006 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149008 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149015 */     // (fadd:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADD_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp32m),
     /* 149018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149020 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 149022 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149026 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 149029 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 149034 */     GIR_RootConstrainSelectedInstOperands,
     /* 149035 */     // GIR_Coverage, 911,
     /* 149035 */     GIR_EraseRootFromParent_Done,
     /* 149036 */   // Label 3242: @149036
     /* 149036 */   GIM_Try, /*On fail goto*//*Label 3243*/ GIMT_Encode4(149098), // Rule ID 2161 //
     /* 149041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 149044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 149048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 149052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149060 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149063 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 149067 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 149071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149073 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149080 */     // (fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSrm),
     /* 149083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149085 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 149087 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149091 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 149096 */     GIR_RootConstrainSelectedInstOperands,
     /* 149097 */     // GIR_Coverage, 2161,
     /* 149097 */     GIR_EraseRootFromParent_Done,
     /* 149098 */   // Label 3243: @149098
     /* 149098 */   GIM_Try, /*On fail goto*//*Label 3244*/ GIMT_Encode4(149160), // Rule ID 2169 //
     /* 149103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 149106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 149110 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 149114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149122 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149125 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 149129 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 149133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149135 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149142 */     // (fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSSrm),
     /* 149145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149147 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 149149 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149153 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 149158 */     GIR_RootConstrainSelectedInstOperands,
     /* 149159 */     // GIR_Coverage, 2169,
     /* 149159 */     GIR_EraseRootFromParent_Done,
     /* 149160 */   // Label 3244: @149160
     /* 149160 */   GIM_Try, /*On fail goto*//*Label 3245*/ GIMT_Encode4(149222), // Rule ID 5917 //
     /* 149165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 149168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 149172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 149176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149184 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149187 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 149191 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 149195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149197 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149204 */     // (fadd:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSZrm),
     /* 149207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149209 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 149211 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149215 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 149220 */     GIR_RootConstrainSelectedInstOperands,
     /* 149221 */     // GIR_Coverage, 5917,
     /* 149221 */     GIR_EraseRootFromParent_Done,
     /* 149222 */   // Label 3245: @149222
     /* 149222 */   GIM_Try, /*On fail goto*//*Label 3246*/ GIMT_Encode4(149259), // Rule ID 887 //
     /* 149227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 149230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 149234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 149238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 149242 */     // (fadd:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (ADD_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 149242 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD_Fp32),
     /* 149247 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 149253 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 149257 */     GIR_RootConstrainSelectedInstOperands,
     /* 149258 */     // GIR_Coverage, 887,
     /* 149258 */     GIR_Done,
     /* 149259 */   // Label 3246: @149259
     /* 149259 */   GIM_Try, /*On fail goto*//*Label 3247*/ GIMT_Encode4(149290), // Rule ID 2159 //
     /* 149264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 149267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 149271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 149275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 149279 */     // (fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VADDSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 149279 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSSrr),
     /* 149284 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 149288 */     GIR_RootConstrainSelectedInstOperands,
     /* 149289 */     // GIR_Coverage, 2159,
     /* 149289 */     GIR_Done,
     /* 149290 */   // Label 3247: @149290
     /* 149290 */   GIM_Try, /*On fail goto*//*Label 3248*/ GIMT_Encode4(149321), // Rule ID 2167 //
     /* 149295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 149298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 149302 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 149306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 149310 */     // (fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (ADDSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 149310 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDSSrr),
     /* 149315 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 149319 */     GIR_RootConstrainSelectedInstOperands,
     /* 149320 */     // GIR_Coverage, 2167,
     /* 149320 */     GIR_Done,
     /* 149321 */   // Label 3248: @149321
     /* 149321 */   GIM_Try, /*On fail goto*//*Label 3249*/ GIMT_Encode4(149352), // Rule ID 5915 //
     /* 149326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 149329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 149333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 149337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 149341 */     // (fadd:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VADDSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 149341 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSSZrr),
     /* 149346 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 149350 */     GIR_RootConstrainSelectedInstOperands,
     /* 149351 */     // GIR_Coverage, 5915,
     /* 149351 */     GIR_Done,
     /* 149352 */   // Label 3249: @149352
     /* 149352 */   GIM_Reject,
     /* 149353 */ // Label 3227: @149353
     /* 149353 */ GIM_Reject,
     /* 149354 */ // Label 3211: @149354
     /* 149354 */ GIM_Try, /*On fail goto*//*Label 3250*/ GIMT_Encode4(150894),
     /* 149359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 149362 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 149365 */   GIM_Try, /*On fail goto*//*Label 3251*/ GIMT_Encode4(149447), // Rule ID 26021 //
     /* 149370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 149373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 149385 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 149389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 149393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149397 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 149400 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 149404 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 149411 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 149415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149419 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 149421 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149428 */     // (fadd:{ *:[f64] } (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>), FR64:{ *:[f64] }:$src1)  =>  (ADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSDrm),
     /* 149431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149433 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 149435 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149439 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 149445 */     GIR_RootConstrainSelectedInstOperands,
     /* 149446 */     // GIR_Coverage, 26021,
     /* 149446 */     GIR_EraseRootFromParent_Done,
     /* 149447 */   // Label 3251: @149447
     /* 149447 */   GIM_Try, /*On fail goto*//*Label 3252*/ GIMT_Encode4(149529), // Rule ID 26022 //
     /* 149452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 149455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 149467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 149471 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 149475 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149479 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 149482 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 149486 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 149493 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 149497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149501 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 149503 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149510 */     // (fadd:{ *:[f64] } (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>), FR64:{ *:[f64] }:$src1)  =>  (VADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDrm),
     /* 149513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149515 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 149517 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149521 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 149527 */     GIR_RootConstrainSelectedInstOperands,
     /* 149528 */     // GIR_Coverage, 26022,
     /* 149528 */     GIR_EraseRootFromParent_Done,
     /* 149529 */   // Label 3252: @149529
     /* 149529 */   GIM_Try, /*On fail goto*//*Label 3253*/ GIMT_Encode4(149611), // Rule ID 26023 //
     /* 149534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 149537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 149541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 149549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 149553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 149557 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149561 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 149564 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 149568 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 149575 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 149579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 149583 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 149585 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149592 */     // (fadd:{ *:[f64] } (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>), FR64X:{ *:[f64] }:$src1)  =>  (VADDSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDZrm),
     /* 149595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149597 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 149599 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149603 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 149609 */     GIR_RootConstrainSelectedInstOperands,
     /* 149610 */     // GIR_Coverage, 26023,
     /* 149610 */     GIR_EraseRootFromParent_Done,
     /* 149611 */   // Label 3253: @149611
     /* 149611 */   GIM_Try, /*On fail goto*//*Label 3254*/ GIMT_Encode4(149693), // Rule ID 22470 //
     /* 149616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 149619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 149635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 149639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 149643 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149647 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 149650 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 149654 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 149661 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 149665 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 149667 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149674 */     // (fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (ADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSDrm),
     /* 149677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149679 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 149681 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149685 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 149691 */     GIR_RootConstrainSelectedInstOperands,
     /* 149692 */     // GIR_Coverage, 22470,
     /* 149692 */     GIR_EraseRootFromParent_Done,
     /* 149693 */   // Label 3254: @149693
     /* 149693 */   GIM_Try, /*On fail goto*//*Label 3255*/ GIMT_Encode4(149775), // Rule ID 22471 //
     /* 149698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 149701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 149717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 149721 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 149725 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149729 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 149732 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 149736 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 149743 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 149747 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 149749 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149756 */     // (fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (VADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDrm),
     /* 149759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149761 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 149763 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149767 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 149773 */     GIR_RootConstrainSelectedInstOperands,
     /* 149774 */     // GIR_Coverage, 22471,
     /* 149774 */     GIR_EraseRootFromParent_Done,
     /* 149775 */   // Label 3255: @149775
     /* 149775 */   GIM_Try, /*On fail goto*//*Label 3256*/ GIMT_Encode4(149857), // Rule ID 22472 //
     /* 149780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 149783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 149787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 149791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 149799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 149803 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 149807 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149811 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 149814 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 149818 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 149825 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 149829 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 149831 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149838 */     // (fadd:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (VADDSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDZrm),
     /* 149841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149843 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 149845 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149849 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 149855 */     GIR_RootConstrainSelectedInstOperands,
     /* 149856 */     // GIR_Coverage, 22472,
     /* 149856 */     GIR_EraseRootFromParent_Done,
     /* 149857 */   // Label 3256: @149857
     /* 149857 */   GIM_Try, /*On fail goto*//*Label 3257*/ GIMT_Encode4(149922), // Rule ID 23251 //
     /* 149862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 149865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 149869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 149877 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 149884 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 149888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 149892 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149894 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149901 */     // (fadd:{ *:[f64] } (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP64:{ *:[f64] }:$src1)  =>  (ADD_FpI16m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI16m64),
     /* 149904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149906 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 149908 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149912 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 149915 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 149920 */     GIR_RootConstrainSelectedInstOperands,
     /* 149921 */     // GIR_Coverage, 23251,
     /* 149921 */     GIR_EraseRootFromParent_Done,
     /* 149922 */   // Label 3257: @149922
     /* 149922 */   GIM_Try, /*On fail goto*//*Label 3258*/ GIMT_Encode4(149987), // Rule ID 23253 //
     /* 149927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 149930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 149934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 149942 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 149949 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 149953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 149957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149959 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149966 */     // (fadd:{ *:[f64] } (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP64:{ *:[f64] }:$src1)  =>  (ADD_FpI32m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI32m64),
     /* 149969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149971 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 149973 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149977 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 149980 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 149985 */     GIR_RootConstrainSelectedInstOperands,
     /* 149986 */     // GIR_Coverage, 23253,
     /* 149986 */     GIR_EraseRootFromParent_Done,
     /* 149987 */   // Label 3258: @149987
     /* 149987 */   GIM_Try, /*On fail goto*//*Label 3259*/ GIMT_Encode4(150052), // Rule ID 23239 //
     /* 149992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 149995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 149999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150007 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150010 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150014 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 150022 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150024 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150031 */     // (fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP64:{ *:[f64] }:$src1)  =>  (ADD_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64m),
     /* 150034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150036 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 150038 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150042 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 150045 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150050 */     GIR_RootConstrainSelectedInstOperands,
     /* 150051 */     // GIR_Coverage, 23239,
     /* 150051 */     GIR_EraseRootFromParent_Done,
     /* 150052 */   // Label 3259: @150052
     /* 150052 */   GIM_Try, /*On fail goto*//*Label 3260*/ GIMT_Encode4(150124), // Rule ID 23241 //
     /* 150057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 150060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 150064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150072 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150075 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150079 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 150086 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 150094 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150096 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150103 */     // (fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP64:{ *:[f64] }:$src1)  =>  (ADD_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64m32),
     /* 150106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150108 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 150110 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150114 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 150117 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150122 */     GIR_RootConstrainSelectedInstOperands,
     /* 150123 */     // GIR_Coverage, 23241,
     /* 150123 */     GIR_EraseRootFromParent_Done,
     /* 150124 */   // Label 3260: @150124
     /* 150124 */   GIM_Try, /*On fail goto*//*Label 3261*/ GIMT_Encode4(150186), // Rule ID 23384 //
     /* 150129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 150132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 150136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150144 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150147 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150151 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 150159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150161 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150168 */     // (fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (VADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDrm),
     /* 150171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150173 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 150175 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150179 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150184 */     GIR_RootConstrainSelectedInstOperands,
     /* 150185 */     // GIR_Coverage, 23384,
     /* 150185 */     GIR_EraseRootFromParent_Done,
     /* 150186 */   // Label 3261: @150186
     /* 150186 */   GIM_Try, /*On fail goto*//*Label 3262*/ GIMT_Encode4(150248), // Rule ID 23388 //
     /* 150191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 150194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 150198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150206 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150209 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150213 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 150221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150223 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150230 */     // (fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (ADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSDrm),
     /* 150233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150235 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 150237 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150241 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150246 */     GIR_RootConstrainSelectedInstOperands,
     /* 150247 */     // GIR_Coverage, 23388,
     /* 150247 */     GIR_EraseRootFromParent_Done,
     /* 150248 */   // Label 3262: @150248
     /* 150248 */   GIM_Try, /*On fail goto*//*Label 3263*/ GIMT_Encode4(150310), // Rule ID 24248 //
     /* 150253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 150256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 150260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150268 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150271 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150275 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 150283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150285 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150292 */     // (fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64X:{ *:[f64] }:$src1)  =>  (VADDSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDZrm),
     /* 150295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150297 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 150299 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150303 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150308 */     GIR_RootConstrainSelectedInstOperands,
     /* 150309 */     // GIR_Coverage, 24248,
     /* 150309 */     GIR_EraseRootFromParent_Done,
     /* 150310 */   // Label 3263: @150310
     /* 150310 */   GIM_Try, /*On fail goto*//*Label 3264*/ GIMT_Encode4(150375), // Rule ID 925 //
     /* 150315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 150318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 150322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 150326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 150330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 150334 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150341 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150347 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150354 */     // (fadd:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (ADD_FpI16m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI16m64),
     /* 150357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150359 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 150361 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150365 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 150368 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150373 */     GIR_RootConstrainSelectedInstOperands,
     /* 150374 */     // GIR_Coverage, 925,
     /* 150374 */     GIR_EraseRootFromParent_Done,
     /* 150375 */   // Label 3264: @150375
     /* 150375 */   GIM_Try, /*On fail goto*//*Label 3265*/ GIMT_Encode4(150440), // Rule ID 927 //
     /* 150380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 150383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 150387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 150391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 150395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 150399 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 150406 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150412 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150419 */     // (fadd:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (ADD_FpI32m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI32m64),
     /* 150422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150424 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 150426 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150430 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 150433 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150438 */     GIR_RootConstrainSelectedInstOperands,
     /* 150439 */     // GIR_Coverage, 927,
     /* 150439 */     GIR_EraseRootFromParent_Done,
     /* 150440 */   // Label 3265: @150440
     /* 150440 */   GIM_Try, /*On fail goto*//*Label 3266*/ GIMT_Encode4(150505), // Rule ID 913 //
     /* 150445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 150448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 150452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 150456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 150460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150464 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150467 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150471 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150477 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150484 */     // (fadd:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADD_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64m),
     /* 150487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150489 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 150491 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150495 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 150498 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150503 */     GIR_RootConstrainSelectedInstOperands,
     /* 150504 */     // GIR_Coverage, 913,
     /* 150504 */     GIR_EraseRootFromParent_Done,
     /* 150505 */   // Label 3266: @150505
     /* 150505 */   GIM_Try, /*On fail goto*//*Label 3267*/ GIMT_Encode4(150577), // Rule ID 915 //
     /* 150510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 150513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 150517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 150521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 150525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150529 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150532 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150536 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 150543 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150549 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150556 */     // (fadd:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (ADD_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64m32),
     /* 150559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150561 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 150563 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150567 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 150570 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150575 */     GIR_RootConstrainSelectedInstOperands,
     /* 150576 */     // GIR_Coverage, 915,
     /* 150576 */     GIR_EraseRootFromParent_Done,
     /* 150577 */   // Label 3267: @150577
     /* 150577 */   GIM_Try, /*On fail goto*//*Label 3268*/ GIMT_Encode4(150639), // Rule ID 2165 //
     /* 150582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 150585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 150589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 150593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 150597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150601 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150604 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150608 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150612 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150614 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150621 */     // (fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDrm),
     /* 150624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150626 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 150628 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150632 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150637 */     GIR_RootConstrainSelectedInstOperands,
     /* 150638 */     // GIR_Coverage, 2165,
     /* 150638 */     GIR_EraseRootFromParent_Done,
     /* 150639 */   // Label 3268: @150639
     /* 150639 */   GIM_Try, /*On fail goto*//*Label 3269*/ GIMT_Encode4(150701), // Rule ID 2173 //
     /* 150644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 150647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 150651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 150655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 150659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150663 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150666 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150670 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150676 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150683 */     // (fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSDrm),
     /* 150686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150688 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 150690 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150694 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150699 */     GIR_RootConstrainSelectedInstOperands,
     /* 150700 */     // GIR_Coverage, 2173,
     /* 150700 */     GIR_EraseRootFromParent_Done,
     /* 150701 */   // Label 3269: @150701
     /* 150701 */   GIM_Try, /*On fail goto*//*Label 3270*/ GIMT_Encode4(150763), // Rule ID 5936 //
     /* 150706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 150709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 150713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 150717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 150721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150725 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150728 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150732 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150738 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150745 */     // (fadd:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDZrm),
     /* 150748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150750 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 150752 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150756 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150761 */     GIR_RootConstrainSelectedInstOperands,
     /* 150762 */     // GIR_Coverage, 5936,
     /* 150762 */     GIR_EraseRootFromParent_Done,
     /* 150763 */   // Label 3270: @150763
     /* 150763 */   GIM_Try, /*On fail goto*//*Label 3271*/ GIMT_Encode4(150800), // Rule ID 889 //
     /* 150768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 150771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 150775 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 150779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 150783 */     // (fadd:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (ADD_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 150783 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64),
     /* 150788 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 150794 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 150798 */     GIR_RootConstrainSelectedInstOperands,
     /* 150799 */     // GIR_Coverage, 889,
     /* 150799 */     GIR_Done,
     /* 150800 */   // Label 3271: @150800
     /* 150800 */   GIM_Try, /*On fail goto*//*Label 3272*/ GIMT_Encode4(150831), // Rule ID 2163 //
     /* 150805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 150808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 150812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 150816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 150820 */     // (fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VADDSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 150820 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSDrr),
     /* 150825 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 150829 */     GIR_RootConstrainSelectedInstOperands,
     /* 150830 */     // GIR_Coverage, 2163,
     /* 150830 */     GIR_Done,
     /* 150831 */   // Label 3272: @150831
     /* 150831 */   GIM_Try, /*On fail goto*//*Label 3273*/ GIMT_Encode4(150862), // Rule ID 2171 //
     /* 150836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 150839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 150843 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 150847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 150851 */     // (fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (ADDSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 150851 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDSDrr),
     /* 150856 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 150860 */     GIR_RootConstrainSelectedInstOperands,
     /* 150861 */     // GIR_Coverage, 2171,
     /* 150861 */     GIR_Done,
     /* 150862 */   // Label 3273: @150862
     /* 150862 */   GIM_Try, /*On fail goto*//*Label 3274*/ GIMT_Encode4(150893), // Rule ID 5934 //
     /* 150867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 150870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 150874 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 150878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 150882 */     // (fadd:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VADDSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 150882 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSDZrr),
     /* 150887 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 150891 */     GIR_RootConstrainSelectedInstOperands,
     /* 150892 */     // GIR_Coverage, 5934,
     /* 150892 */     GIR_Done,
     /* 150893 */   // Label 3274: @150893
     /* 150893 */   GIM_Reject,
     /* 150894 */ // Label 3250: @150894
     /* 150894 */ GIM_Reject,
     /* 150895 */ // Label 3212: @150895
     /* 150895 */ GIM_Try, /*On fail goto*//*Label 3275*/ GIMT_Encode4(151460),
     /* 150900 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 150903 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 150906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 150910 */   GIM_Try, /*On fail goto*//*Label 3276*/ GIMT_Encode4(150971), // Rule ID 23255 //
     /* 150915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 150918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 150926 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150933 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 150941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150943 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150950 */     // (fadd:{ *:[f80] } (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP80:{ *:[f80] }:$src1)  =>  (ADD_FpI16m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI16m80),
     /* 150953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150955 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 150957 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150961 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 150964 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150969 */     GIR_RootConstrainSelectedInstOperands,
     /* 150970 */     // GIR_Coverage, 23255,
     /* 150970 */     GIR_EraseRootFromParent_Done,
     /* 150971 */   // Label 3276: @150971
     /* 150971 */   GIM_Try, /*On fail goto*//*Label 3277*/ GIMT_Encode4(151032), // Rule ID 23257 //
     /* 150976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 150979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 150987 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 150994 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 151002 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151004 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151011 */     // (fadd:{ *:[f80] } (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP80:{ *:[f80] }:$src1)  =>  (ADD_FpI32m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI32m80),
     /* 151014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151016 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 151018 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151022 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 151025 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151030 */     GIR_RootConstrainSelectedInstOperands,
     /* 151031 */     // GIR_Coverage, 23257,
     /* 151031 */     GIR_EraseRootFromParent_Done,
     /* 151032 */   // Label 3277: @151032
     /* 151032 */   GIM_Try, /*On fail goto*//*Label 3278*/ GIMT_Encode4(151100), // Rule ID 23243 //
     /* 151037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 151040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151048 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151051 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151055 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 151062 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 151070 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151072 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151079 */     // (fadd:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP80:{ *:[f80] }:$src1)  =>  (ADD_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80m32),
     /* 151082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151084 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 151086 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151090 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 151093 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151098 */     GIR_RootConstrainSelectedInstOperands,
     /* 151099 */     // GIR_Coverage, 23243,
     /* 151099 */     GIR_EraseRootFromParent_Done,
     /* 151100 */   // Label 3278: @151100
     /* 151100 */   GIM_Try, /*On fail goto*//*Label 3279*/ GIMT_Encode4(151168), // Rule ID 23245 //
     /* 151105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 151108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151116 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151119 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151123 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 151130 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 151138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151140 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151147 */     // (fadd:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>, RFP80:{ *:[f80] }:$src1)  =>  (ADD_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80m64),
     /* 151150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151152 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 151154 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151158 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 151161 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151166 */     GIR_RootConstrainSelectedInstOperands,
     /* 151167 */     // GIR_Coverage, 23245,
     /* 151167 */     GIR_EraseRootFromParent_Done,
     /* 151168 */   // Label 3279: @151168
     /* 151168 */   GIM_Try, /*On fail goto*//*Label 3280*/ GIMT_Encode4(151229), // Rule ID 929 //
     /* 151173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 151176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 151180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 151184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 151188 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151195 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151201 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151208 */     // (fadd:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (ADD_FpI16m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI16m80),
     /* 151211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151213 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 151215 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151219 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 151222 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151227 */     GIR_RootConstrainSelectedInstOperands,
     /* 151228 */     // GIR_Coverage, 929,
     /* 151228 */     GIR_EraseRootFromParent_Done,
     /* 151229 */   // Label 3280: @151229
     /* 151229 */   GIM_Try, /*On fail goto*//*Label 3281*/ GIMT_Encode4(151290), // Rule ID 931 //
     /* 151234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 151237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 151241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 151245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 151249 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 151256 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151262 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151269 */     // (fadd:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (ADD_FpI32m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI32m80),
     /* 151272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151274 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 151276 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151280 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 151283 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151288 */     GIR_RootConstrainSelectedInstOperands,
     /* 151289 */     // GIR_Coverage, 931,
     /* 151289 */     GIR_EraseRootFromParent_Done,
     /* 151290 */   // Label 3281: @151290
     /* 151290 */   GIM_Try, /*On fail goto*//*Label 3282*/ GIMT_Encode4(151358), // Rule ID 917 //
     /* 151295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 151298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 151302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 151306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151310 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151313 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151317 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 151324 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151328 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151330 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151337 */     // (fadd:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (ADD_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80m32),
     /* 151340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151342 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 151344 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151348 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 151351 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151356 */     GIR_RootConstrainSelectedInstOperands,
     /* 151357 */     // GIR_Coverage, 917,
     /* 151357 */     GIR_EraseRootFromParent_Done,
     /* 151358 */   // Label 3282: @151358
     /* 151358 */   GIM_Try, /*On fail goto*//*Label 3283*/ GIMT_Encode4(151426), // Rule ID 919 //
     /* 151363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 151366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 151370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 151374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151378 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151381 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151385 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 151392 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151398 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151405 */     // (fadd:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>)  =>  (ADD_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80m64),
     /* 151408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151410 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 151412 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151416 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 151419 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151424 */     GIR_RootConstrainSelectedInstOperands,
     /* 151425 */     // GIR_Coverage, 919,
     /* 151425 */     GIR_EraseRootFromParent_Done,
     /* 151426 */   // Label 3283: @151426
     /* 151426 */   GIM_Try, /*On fail goto*//*Label 3284*/ GIMT_Encode4(151459), // Rule ID 891 //
     /* 151431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 151434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 151438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 151442 */     // (fadd:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (ADD_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 151442 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80),
     /* 151447 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 151453 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 151457 */     GIR_RootConstrainSelectedInstOperands,
     /* 151458 */     // GIR_Coverage, 891,
     /* 151458 */     GIR_Done,
     /* 151459 */   // Label 3284: @151459
     /* 151459 */   GIM_Reject,
     /* 151460 */ // Label 3275: @151460
     /* 151460 */ GIM_Reject,
     /* 151461 */ // Label 3213: @151461
     /* 151461 */ GIM_Try, /*On fail goto*//*Label 3285*/ GIMT_Encode4(151814),
     /* 151466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 151469 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 151472 */   GIM_Try, /*On fail goto*//*Label 3286*/ GIMT_Encode4(151534), // Rule ID 23372 //
     /* 151477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 151480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 151484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151492 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151495 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151499 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 151507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151509 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151516 */     // (fadd:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1)  =>  (VADDPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDrm),
     /* 151519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151521 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 151523 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151527 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151532 */     GIR_RootConstrainSelectedInstOperands,
     /* 151533 */     // GIR_Coverage, 23372,
     /* 151533 */     GIR_EraseRootFromParent_Done,
     /* 151534 */   // Label 3286: @151534
     /* 151534 */   GIM_Try, /*On fail goto*//*Label 3287*/ GIMT_Encode4(151596), // Rule ID 24296 //
     /* 151539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 151542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 151546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151554 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151557 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151561 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 151569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151571 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151578 */     // (fadd:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2f64] }:$src1)  =>  (VADDPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZ128rm),
     /* 151581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151583 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 151585 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151589 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151594 */     GIR_RootConstrainSelectedInstOperands,
     /* 151595 */     // GIR_Coverage, 24296,
     /* 151595 */     GIR_EraseRootFromParent_Done,
     /* 151596 */   // Label 3287: @151596
     /* 151596 */   GIM_Try, /*On fail goto*//*Label 3288*/ GIMT_Encode4(151658), // Rule ID 2141 //
     /* 151601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 151604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 151608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 151612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 151616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151620 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151623 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151627 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151633 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151640 */     // (fadd:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDrm),
     /* 151643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151645 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 151647 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151656 */     GIR_RootConstrainSelectedInstOperands,
     /* 151657 */     // GIR_Coverage, 2141,
     /* 151657 */     GIR_EraseRootFromParent_Done,
     /* 151658 */   // Label 3288: @151658
     /* 151658 */   GIM_Try, /*On fail goto*//*Label 3289*/ GIMT_Encode4(151720), // Rule ID 6309 //
     /* 151663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 151666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 151670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 151674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 151678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151682 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151685 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151689 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151695 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151702 */     // (fadd:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZ128rm),
     /* 151705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151707 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 151709 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151713 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151718 */     GIR_RootConstrainSelectedInstOperands,
     /* 151719 */     // GIR_Coverage, 6309,
     /* 151719 */     GIR_EraseRootFromParent_Done,
     /* 151720 */   // Label 3289: @151720
     /* 151720 */   GIM_Try, /*On fail goto*//*Label 3290*/ GIMT_Encode4(151751), // Rule ID 2139 //
     /* 151725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 151728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 151732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 151736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 151740 */     // (fadd:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VADDPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 151740 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDrr),
     /* 151745 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 151749 */     GIR_RootConstrainSelectedInstOperands,
     /* 151750 */     // GIR_Coverage, 2139,
     /* 151750 */     GIR_Done,
     /* 151751 */   // Label 3290: @151751
     /* 151751 */   GIM_Try, /*On fail goto*//*Label 3291*/ GIMT_Encode4(151782), // Rule ID 2155 //
     /* 151756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 151759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 151763 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 151767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 151771 */     // (fadd:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (ADDPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 151771 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDPDrr),
     /* 151776 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 151780 */     GIR_RootConstrainSelectedInstOperands,
     /* 151781 */     // GIR_Coverage, 2155,
     /* 151781 */     GIR_Done,
     /* 151782 */   // Label 3291: @151782
     /* 151782 */   GIM_Try, /*On fail goto*//*Label 3292*/ GIMT_Encode4(151813), // Rule ID 6305 //
     /* 151787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 151790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 151794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 151798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 151802 */     // (fadd:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VADDPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 151802 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDZ128rr),
     /* 151807 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 151811 */     GIR_RootConstrainSelectedInstOperands,
     /* 151812 */     // GIR_Coverage, 6305,
     /* 151812 */     GIR_Done,
     /* 151813 */   // Label 3292: @151813
     /* 151813 */   GIM_Reject,
     /* 151814 */ // Label 3285: @151814
     /* 151814 */ GIM_Reject,
     /* 151815 */ // Label 3214: @151815
     /* 151815 */ GIM_Try, /*On fail goto*//*Label 3293*/ GIMT_Encode4(152168),
     /* 151820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 151823 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 151826 */   GIM_Try, /*On fail goto*//*Label 3294*/ GIMT_Encode4(151888), // Rule ID 23370 //
     /* 151831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 151834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 151838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151846 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151849 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151853 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 151861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151863 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151870 */     // (fadd:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1)  =>  (VADDPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSrm),
     /* 151873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151875 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 151877 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151881 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151886 */     GIR_RootConstrainSelectedInstOperands,
     /* 151887 */     // GIR_Coverage, 23370,
     /* 151887 */     GIR_EraseRootFromParent_Done,
     /* 151888 */   // Label 3294: @151888
     /* 151888 */   GIM_Try, /*On fail goto*//*Label 3295*/ GIMT_Encode4(151950), // Rule ID 24280 //
     /* 151893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 151896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 151900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151908 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151911 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151915 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 151923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151925 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151932 */     // (fadd:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4f32] }:$src1)  =>  (VADDPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZ128rm),
     /* 151935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151937 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 151939 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151943 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151948 */     GIR_RootConstrainSelectedInstOperands,
     /* 151949 */     // GIR_Coverage, 24280,
     /* 151949 */     GIR_EraseRootFromParent_Done,
     /* 151950 */   // Label 3295: @151950
     /* 151950 */   GIM_Try, /*On fail goto*//*Label 3296*/ GIMT_Encode4(152012), // Rule ID 2137 //
     /* 151955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 151958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 151962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 151966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 151970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151974 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151977 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151981 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151987 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151994 */     // (fadd:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSrm),
     /* 151997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151999 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 152001 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152005 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152010 */     GIR_RootConstrainSelectedInstOperands,
     /* 152011 */     // GIR_Coverage, 2137,
     /* 152011 */     GIR_EraseRootFromParent_Done,
     /* 152012 */   // Label 3296: @152012
     /* 152012 */   GIM_Try, /*On fail goto*//*Label 3297*/ GIMT_Encode4(152074), // Rule ID 6285 //
     /* 152017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 152020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 152024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 152028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152036 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152039 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152043 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152049 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152056 */     // (fadd:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZ128rm),
     /* 152059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152061 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 152063 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152067 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152072 */     GIR_RootConstrainSelectedInstOperands,
     /* 152073 */     // GIR_Coverage, 6285,
     /* 152073 */     GIR_EraseRootFromParent_Done,
     /* 152074 */   // Label 3297: @152074
     /* 152074 */   GIM_Try, /*On fail goto*//*Label 3298*/ GIMT_Encode4(152105), // Rule ID 2135 //
     /* 152079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 152082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 152086 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 152090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 152094 */     // (fadd:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VADDPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 152094 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSrr),
     /* 152099 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 152103 */     GIR_RootConstrainSelectedInstOperands,
     /* 152104 */     // GIR_Coverage, 2135,
     /* 152104 */     GIR_Done,
     /* 152105 */   // Label 3298: @152105
     /* 152105 */   GIM_Try, /*On fail goto*//*Label 3299*/ GIMT_Encode4(152136), // Rule ID 2151 //
     /* 152110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 152113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 152117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 152121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 152125 */     // (fadd:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (ADDPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 152125 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDPSrr),
     /* 152130 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 152134 */     GIR_RootConstrainSelectedInstOperands,
     /* 152135 */     // GIR_Coverage, 2151,
     /* 152135 */     GIR_Done,
     /* 152136 */   // Label 3299: @152136
     /* 152136 */   GIM_Try, /*On fail goto*//*Label 3300*/ GIMT_Encode4(152167), // Rule ID 6281 //
     /* 152141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 152144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 152148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 152152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 152156 */     // (fadd:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VADDPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 152156 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSZ128rr),
     /* 152161 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 152165 */     GIR_RootConstrainSelectedInstOperands,
     /* 152166 */     // GIR_Coverage, 6281,
     /* 152166 */     GIR_Done,
     /* 152167 */   // Label 3300: @152167
     /* 152167 */   GIM_Reject,
     /* 152168 */ // Label 3293: @152168
     /* 152168 */ GIM_Reject,
     /* 152169 */ // Label 3215: @152169
     /* 152169 */ GIM_Try, /*On fail goto*//*Label 3301*/ GIMT_Encode4(152491),
     /* 152174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 152177 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 152180 */   GIM_Try, /*On fail goto*//*Label 3302*/ GIMT_Encode4(152242), // Rule ID 23376 //
     /* 152185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 152188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 152192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 152196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152200 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152203 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152207 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 152215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152217 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152224 */     // (fadd:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1)  =>  (VADDPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDYrm),
     /* 152227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152229 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 152231 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152235 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152240 */     GIR_RootConstrainSelectedInstOperands,
     /* 152241 */     // GIR_Coverage, 23376,
     /* 152241 */     GIR_EraseRootFromParent_Done,
     /* 152242 */   // Label 3302: @152242
     /* 152242 */   GIM_Try, /*On fail goto*//*Label 3303*/ GIMT_Encode4(152304), // Rule ID 24304 //
     /* 152247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 152250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 152254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 152258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152262 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152265 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152269 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 152277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152279 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152286 */     // (fadd:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4f64] }:$src1)  =>  (VADDPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZ256rm),
     /* 152289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152291 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 152293 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152297 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152302 */     GIR_RootConstrainSelectedInstOperands,
     /* 152303 */     // GIR_Coverage, 24304,
     /* 152303 */     GIR_EraseRootFromParent_Done,
     /* 152304 */   // Label 3303: @152304
     /* 152304 */   GIM_Try, /*On fail goto*//*Label 3304*/ GIMT_Encode4(152366), // Rule ID 2149 //
     /* 152309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 152312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 152316 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 152320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152328 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152331 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152335 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152341 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152348 */     // (fadd:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDYrm),
     /* 152351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152353 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 152355 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152359 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152364 */     GIR_RootConstrainSelectedInstOperands,
     /* 152365 */     // GIR_Coverage, 2149,
     /* 152365 */     GIR_EraseRootFromParent_Done,
     /* 152366 */   // Label 3304: @152366
     /* 152366 */   GIM_Try, /*On fail goto*//*Label 3305*/ GIMT_Encode4(152428), // Rule ID 6321 //
     /* 152371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 152374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 152378 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 152382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152390 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152393 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152397 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152403 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152410 */     // (fadd:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZ256rm),
     /* 152413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152415 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 152417 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152421 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152426 */     GIR_RootConstrainSelectedInstOperands,
     /* 152427 */     // GIR_Coverage, 6321,
     /* 152427 */     GIR_EraseRootFromParent_Done,
     /* 152428 */   // Label 3305: @152428
     /* 152428 */   GIM_Try, /*On fail goto*//*Label 3306*/ GIMT_Encode4(152459), // Rule ID 2147 //
     /* 152433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 152436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 152440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 152444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 152448 */     // (fadd:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VADDPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 152448 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDYrr),
     /* 152453 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 152457 */     GIR_RootConstrainSelectedInstOperands,
     /* 152458 */     // GIR_Coverage, 2147,
     /* 152458 */     GIR_Done,
     /* 152459 */   // Label 3306: @152459
     /* 152459 */   GIM_Try, /*On fail goto*//*Label 3307*/ GIMT_Encode4(152490), // Rule ID 6317 //
     /* 152464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 152467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 152471 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 152475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 152479 */     // (fadd:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VADDPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 152479 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDZ256rr),
     /* 152484 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 152488 */     GIR_RootConstrainSelectedInstOperands,
     /* 152489 */     // GIR_Coverage, 6317,
     /* 152489 */     GIR_Done,
     /* 152490 */   // Label 3307: @152490
     /* 152490 */   GIM_Reject,
     /* 152491 */ // Label 3301: @152491
     /* 152491 */ GIM_Reject,
     /* 152492 */ // Label 3216: @152492
     /* 152492 */ GIM_Try, /*On fail goto*//*Label 3308*/ GIMT_Encode4(152651),
     /* 152497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152500 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 152503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 152507 */   GIM_Try, /*On fail goto*//*Label 3309*/ GIMT_Encode4(152565), // Rule ID 24320 //
     /* 152512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 152515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 152519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152523 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152526 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152530 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 152538 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152540 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152547 */     // (fadd:{ *:[v8f16] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8f16] }:$src1)  =>  (VADDPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZ128rm),
     /* 152550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152552 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 152554 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152558 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152563 */     GIR_RootConstrainSelectedInstOperands,
     /* 152564 */     // GIR_Coverage, 24320,
     /* 152564 */     GIR_EraseRootFromParent_Done,
     /* 152565 */   // Label 3309: @152565
     /* 152565 */   GIM_Try, /*On fail goto*//*Label 3310*/ GIMT_Encode4(152623), // Rule ID 6345 //
     /* 152570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 152573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 152577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152585 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152588 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152592 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152598 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152605 */     // (fadd:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZ128rm),
     /* 152608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152610 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 152612 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152616 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152621 */     GIR_RootConstrainSelectedInstOperands,
     /* 152622 */     // GIR_Coverage, 6345,
     /* 152622 */     GIR_EraseRootFromParent_Done,
     /* 152623 */   // Label 3310: @152623
     /* 152623 */   GIM_Try, /*On fail goto*//*Label 3311*/ GIMT_Encode4(152650), // Rule ID 6341 //
     /* 152628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 152631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 152635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 152639 */     // (fadd:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VADDPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 152639 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPHZ128rr),
     /* 152644 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 152648 */     GIR_RootConstrainSelectedInstOperands,
     /* 152649 */     // GIR_Coverage, 6341,
     /* 152649 */     GIR_Done,
     /* 152650 */   // Label 3311: @152650
     /* 152650 */   GIM_Reject,
     /* 152651 */ // Label 3308: @152651
     /* 152651 */ GIM_Reject,
     /* 152652 */ // Label 3217: @152652
     /* 152652 */ GIM_Try, /*On fail goto*//*Label 3312*/ GIMT_Encode4(152974),
     /* 152657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 152660 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 152663 */   GIM_Try, /*On fail goto*//*Label 3313*/ GIMT_Encode4(152725), // Rule ID 23374 //
     /* 152668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 152671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 152675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 152679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152683 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152686 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152690 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 152698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152700 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152707 */     // (fadd:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1)  =>  (VADDPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSYrm),
     /* 152710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152712 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 152714 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152718 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152723 */     GIR_RootConstrainSelectedInstOperands,
     /* 152724 */     // GIR_Coverage, 23374,
     /* 152724 */     GIR_EraseRootFromParent_Done,
     /* 152725 */   // Label 3313: @152725
     /* 152725 */   GIM_Try, /*On fail goto*//*Label 3314*/ GIMT_Encode4(152787), // Rule ID 24288 //
     /* 152730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 152733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 152737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 152741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152745 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152748 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152752 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 152760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152762 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152769 */     // (fadd:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8f32] }:$src1)  =>  (VADDPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZ256rm),
     /* 152772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152774 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 152776 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152780 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152785 */     GIR_RootConstrainSelectedInstOperands,
     /* 152786 */     // GIR_Coverage, 24288,
     /* 152786 */     GIR_EraseRootFromParent_Done,
     /* 152787 */   // Label 3314: @152787
     /* 152787 */   GIM_Try, /*On fail goto*//*Label 3315*/ GIMT_Encode4(152849), // Rule ID 2145 //
     /* 152792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 152795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 152799 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 152803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152811 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152814 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152818 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152822 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152824 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152831 */     // (fadd:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSYrm),
     /* 152834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152836 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 152838 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152842 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152847 */     GIR_RootConstrainSelectedInstOperands,
     /* 152848 */     // GIR_Coverage, 2145,
     /* 152848 */     GIR_EraseRootFromParent_Done,
     /* 152849 */   // Label 3315: @152849
     /* 152849 */   GIM_Try, /*On fail goto*//*Label 3316*/ GIMT_Encode4(152911), // Rule ID 6297 //
     /* 152854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 152857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 152861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 152865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152873 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152876 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152880 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152886 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152893 */     // (fadd:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZ256rm),
     /* 152896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152898 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 152900 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152904 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152909 */     GIR_RootConstrainSelectedInstOperands,
     /* 152910 */     // GIR_Coverage, 6297,
     /* 152910 */     GIR_EraseRootFromParent_Done,
     /* 152911 */   // Label 3316: @152911
     /* 152911 */   GIM_Try, /*On fail goto*//*Label 3317*/ GIMT_Encode4(152942), // Rule ID 2143 //
     /* 152916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 152919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 152923 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 152927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 152931 */     // (fadd:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VADDPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 152931 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSYrr),
     /* 152936 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 152940 */     GIR_RootConstrainSelectedInstOperands,
     /* 152941 */     // GIR_Coverage, 2143,
     /* 152941 */     GIR_Done,
     /* 152942 */   // Label 3317: @152942
     /* 152942 */   GIM_Try, /*On fail goto*//*Label 3318*/ GIMT_Encode4(152973), // Rule ID 6293 //
     /* 152947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 152950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 152954 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 152958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 152962 */     // (fadd:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VADDPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 152962 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSZ256rr),
     /* 152967 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 152971 */     GIR_RootConstrainSelectedInstOperands,
     /* 152972 */     // GIR_Coverage, 6293,
     /* 152972 */     GIR_Done,
     /* 152973 */   // Label 3318: @152973
     /* 152973 */   GIM_Reject,
     /* 152974 */ // Label 3312: @152974
     /* 152974 */ GIM_Reject,
     /* 152975 */ // Label 3218: @152975
     /* 152975 */ GIM_Try, /*On fail goto*//*Label 3319*/ GIMT_Encode4(153134),
     /* 152980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 152983 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 152986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 152990 */   GIM_Try, /*On fail goto*//*Label 3320*/ GIMT_Encode4(153048), // Rule ID 24272 //
     /* 152995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 152998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 153002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153006 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153009 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 153013 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 153017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 153021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153023 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153030 */     // (fadd:{ *:[v8f64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8f64] }:$src1)  =>  (VADDPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZrm),
     /* 153033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153035 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 153037 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153041 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 153046 */     GIR_RootConstrainSelectedInstOperands,
     /* 153047 */     // GIR_Coverage, 24272,
     /* 153047 */     GIR_EraseRootFromParent_Done,
     /* 153048 */   // Label 3320: @153048
     /* 153048 */   GIM_Try, /*On fail goto*//*Label 3321*/ GIMT_Encode4(153106), // Rule ID 6273 //
     /* 153053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 153056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 153060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153068 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153071 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 153075 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 153079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153081 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153088 */     // (fadd:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZrm),
     /* 153091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153093 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 153095 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153099 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 153104 */     GIR_RootConstrainSelectedInstOperands,
     /* 153105 */     // GIR_Coverage, 6273,
     /* 153105 */     GIR_EraseRootFromParent_Done,
     /* 153106 */   // Label 3321: @153106
     /* 153106 */   GIM_Try, /*On fail goto*//*Label 3322*/ GIMT_Encode4(153133), // Rule ID 6269 //
     /* 153111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 153114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 153118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 153122 */     // (fadd:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VADDPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 153122 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDZrr),
     /* 153127 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 153131 */     GIR_RootConstrainSelectedInstOperands,
     /* 153132 */     // GIR_Coverage, 6269,
     /* 153132 */     GIR_Done,
     /* 153133 */   // Label 3322: @153133
     /* 153133 */   GIM_Reject,
     /* 153134 */ // Label 3319: @153134
     /* 153134 */ GIM_Reject,
     /* 153135 */ // Label 3219: @153135
     /* 153135 */ GIM_Try, /*On fail goto*//*Label 3323*/ GIMT_Encode4(153294),
     /* 153140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 153143 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 153146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 153150 */   GIM_Try, /*On fail goto*//*Label 3324*/ GIMT_Encode4(153208), // Rule ID 24328 //
     /* 153155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 153158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 153162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153166 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153169 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 153173 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 153177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 153181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153183 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153190 */     // (fadd:{ *:[v16f16] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16f16] }:$src1)  =>  (VADDPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZ256rm),
     /* 153193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153195 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 153197 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 153206 */     GIR_RootConstrainSelectedInstOperands,
     /* 153207 */     // GIR_Coverage, 24328,
     /* 153207 */     GIR_EraseRootFromParent_Done,
     /* 153208 */   // Label 3324: @153208
     /* 153208 */   GIM_Try, /*On fail goto*//*Label 3325*/ GIMT_Encode4(153266), // Rule ID 6357 //
     /* 153213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 153216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 153220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153228 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153231 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 153235 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 153239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153241 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153248 */     // (fadd:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZ256rm),
     /* 153251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153253 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 153255 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153259 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 153264 */     GIR_RootConstrainSelectedInstOperands,
     /* 153265 */     // GIR_Coverage, 6357,
     /* 153265 */     GIR_EraseRootFromParent_Done,
     /* 153266 */   // Label 3325: @153266
     /* 153266 */   GIM_Try, /*On fail goto*//*Label 3326*/ GIMT_Encode4(153293), // Rule ID 6353 //
     /* 153271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 153274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 153278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 153282 */     // (fadd:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VADDPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 153282 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPHZ256rr),
     /* 153287 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 153291 */     GIR_RootConstrainSelectedInstOperands,
     /* 153292 */     // GIR_Coverage, 6353,
     /* 153292 */     GIR_Done,
     /* 153293 */   // Label 3326: @153293
     /* 153293 */   GIM_Reject,
     /* 153294 */ // Label 3323: @153294
     /* 153294 */ GIM_Reject,
     /* 153295 */ // Label 3220: @153295
     /* 153295 */ GIM_Try, /*On fail goto*//*Label 3327*/ GIMT_Encode4(153454),
     /* 153300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 153303 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 153306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 153310 */   GIM_Try, /*On fail goto*//*Label 3328*/ GIMT_Encode4(153368), // Rule ID 24264 //
     /* 153315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 153318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 153322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153326 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153329 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 153333 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 153337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 153341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153343 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153350 */     // (fadd:{ *:[v16f32] } (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16f32] }:$src1)  =>  (VADDPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZrm),
     /* 153353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153355 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 153357 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153361 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 153366 */     GIR_RootConstrainSelectedInstOperands,
     /* 153367 */     // GIR_Coverage, 24264,
     /* 153367 */     GIR_EraseRootFromParent_Done,
     /* 153368 */   // Label 3328: @153368
     /* 153368 */   GIM_Try, /*On fail goto*//*Label 3329*/ GIMT_Encode4(153426), // Rule ID 6261 //
     /* 153373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 153376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 153380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153388 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153391 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 153395 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 153399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153401 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153408 */     // (fadd:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZrm),
     /* 153411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153413 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 153415 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153419 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 153424 */     GIR_RootConstrainSelectedInstOperands,
     /* 153425 */     // GIR_Coverage, 6261,
     /* 153425 */     GIR_EraseRootFromParent_Done,
     /* 153426 */   // Label 3329: @153426
     /* 153426 */   GIM_Try, /*On fail goto*//*Label 3330*/ GIMT_Encode4(153453), // Rule ID 6257 //
     /* 153431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 153434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 153438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 153442 */     // (fadd:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VADDPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 153442 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSZrr),
     /* 153447 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 153451 */     GIR_RootConstrainSelectedInstOperands,
     /* 153452 */     // GIR_Coverage, 6257,
     /* 153452 */     GIR_Done,
     /* 153453 */   // Label 3330: @153453
     /* 153453 */   GIM_Reject,
     /* 153454 */ // Label 3327: @153454
     /* 153454 */ GIM_Reject,
     /* 153455 */ // Label 3221: @153455
     /* 153455 */ GIM_Try, /*On fail goto*//*Label 3331*/ GIMT_Encode4(153614),
     /* 153460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 153463 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 153466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 153470 */   GIM_Try, /*On fail goto*//*Label 3332*/ GIMT_Encode4(153528), // Rule ID 24312 //
     /* 153475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 153478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 153482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153486 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153489 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 153493 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 153497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 153501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153503 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153510 */     // (fadd:{ *:[v32f16] } (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32f16] }:$src1)  =>  (VADDPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZrm),
     /* 153513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153515 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 153517 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153521 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 153526 */     GIR_RootConstrainSelectedInstOperands,
     /* 153527 */     // GIR_Coverage, 24312,
     /* 153527 */     GIR_EraseRootFromParent_Done,
     /* 153528 */   // Label 3332: @153528
     /* 153528 */   GIM_Try, /*On fail goto*//*Label 3333*/ GIMT_Encode4(153586), // Rule ID 6333 //
     /* 153533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 153536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 153540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153548 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153551 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 153555 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 153559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153561 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153568 */     // (fadd:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZrm),
     /* 153571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153573 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 153575 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153579 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 153584 */     GIR_RootConstrainSelectedInstOperands,
     /* 153585 */     // GIR_Coverage, 6333,
     /* 153585 */     GIR_EraseRootFromParent_Done,
     /* 153586 */   // Label 3333: @153586
     /* 153586 */   GIM_Try, /*On fail goto*//*Label 3334*/ GIMT_Encode4(153613), // Rule ID 6329 //
     /* 153591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 153594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 153598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 153602 */     // (fadd:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VADDPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 153602 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPHZrr),
     /* 153607 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 153611 */     GIR_RootConstrainSelectedInstOperands,
     /* 153612 */     // GIR_Coverage, 6329,
     /* 153612 */     GIR_Done,
     /* 153613 */   // Label 3334: @153613
     /* 153613 */   GIM_Reject,
     /* 153614 */ // Label 3331: @153614
     /* 153614 */ GIM_Reject,
     /* 153615 */ // Label 3222: @153615
     /* 153615 */ GIM_Reject,
     /* 153616 */ // Label 42: @153616
     /* 153616 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 3348*/ GIMT_Encode4(157797),
     /* 153627 */ /*GILLT_s16*//*Label 3335*/ GIMT_Encode4(153711),
     /* 153631 */ /*GILLT_s32*//*Label 3336*/ GIMT_Encode4(153809),
     /* 153635 */ /*GILLT_s64*//*Label 3337*/ GIMT_Encode4(154774),
     /* 153639 */ /*GILLT_s80*//*Label 3338*/ GIMT_Encode4(155883), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 153651 */ /*GILLT_v2s64*//*Label 3339*/ GIMT_Encode4(156449), GIMT_Encode4(0),
     /* 153659 */ /*GILLT_v4s32*//*Label 3340*/ GIMT_Encode4(156679),
     /* 153663 */ /*GILLT_v4s64*//*Label 3341*/ GIMT_Encode4(156909), GIMT_Encode4(0),
     /* 153671 */ /*GILLT_v8s16*//*Label 3342*/ GIMT_Encode4(157108),
     /* 153675 */ /*GILLT_v8s32*//*Label 3343*/ GIMT_Encode4(157206),
     /* 153679 */ /*GILLT_v8s64*//*Label 3344*/ GIMT_Encode4(157405), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 153691 */ /*GILLT_v16s16*//*Label 3345*/ GIMT_Encode4(157503),
     /* 153695 */ /*GILLT_v16s32*//*Label 3346*/ GIMT_Encode4(157601), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 153707 */ /*GILLT_v32s16*//*Label 3347*/ GIMT_Encode4(157699),
     /* 153711 */ // Label 3335: @153711
     /* 153711 */ GIM_Try, /*On fail goto*//*Label 3349*/ GIMT_Encode4(153808),
     /* 153716 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 153719 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 153722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 153726 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 153730 */   GIM_Try, /*On fail goto*//*Label 3350*/ GIMT_Encode4(153784), // Rule ID 6069 //
     /* 153735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 153738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153746 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153749 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 153753 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 153757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153759 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153766 */     // (fsub:{ *:[f16] } FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSHZrm),
     /* 153769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153771 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 153773 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153777 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 153782 */     GIR_RootConstrainSelectedInstOperands,
     /* 153783 */     // GIR_Coverage, 6069,
     /* 153783 */     GIR_EraseRootFromParent_Done,
     /* 153784 */   // Label 3350: @153784
     /* 153784 */   GIM_Try, /*On fail goto*//*Label 3351*/ GIMT_Encode4(153807), // Rule ID 6067 //
     /* 153789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 153792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 153796 */     // (fsub:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VSUBSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 153796 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSHZrr),
     /* 153801 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 153805 */     GIR_RootConstrainSelectedInstOperands,
     /* 153806 */     // GIR_Coverage, 6067,
     /* 153806 */     GIR_Done,
     /* 153807 */   // Label 3351: @153807
     /* 153807 */   GIM_Reject,
     /* 153808 */ // Label 3349: @153808
     /* 153808 */ GIM_Reject,
     /* 153809 */ // Label 3336: @153809
     /* 153809 */ GIM_Try, /*On fail goto*//*Label 3352*/ GIMT_Encode4(154773),
     /* 153814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 153817 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 153820 */   GIM_Try, /*On fail goto*//*Label 3353*/ GIMT_Encode4(153902), // Rule ID 22473 //
     /* 153825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 153828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 153832 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 153836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 153844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 153848 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 153852 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153856 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 153859 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 153863 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 153870 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 153874 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 153876 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153883 */     // (fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (SUBSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBSSrm),
     /* 153886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153888 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 153890 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153894 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 153900 */     GIR_RootConstrainSelectedInstOperands,
     /* 153901 */     // GIR_Coverage, 22473,
     /* 153901 */     GIR_EraseRootFromParent_Done,
     /* 153902 */   // Label 3353: @153902
     /* 153902 */   GIM_Try, /*On fail goto*//*Label 3354*/ GIMT_Encode4(153984), // Rule ID 22474 //
     /* 153907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 153910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 153914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 153918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 153926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 153930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 153934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153938 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 153941 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 153945 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 153952 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 153956 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 153958 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153965 */     // (fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (VSUBSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSSrm),
     /* 153968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153970 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 153972 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153976 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 153982 */     GIR_RootConstrainSelectedInstOperands,
     /* 153983 */     // GIR_Coverage, 22474,
     /* 153983 */     GIR_EraseRootFromParent_Done,
     /* 153984 */   // Label 3354: @153984
     /* 153984 */   GIM_Try, /*On fail goto*//*Label 3355*/ GIMT_Encode4(154066), // Rule ID 22475 //
     /* 153989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 153992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 153996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 154000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 154008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 154012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 154016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154020 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 154023 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 154027 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 154034 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 154038 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154040 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154047 */     // (fsub:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (VSUBSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSSZrm),
     /* 154050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154052 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 154054 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154058 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 154064 */     GIR_RootConstrainSelectedInstOperands,
     /* 154065 */     // GIR_Coverage, 22475,
     /* 154065 */     GIR_EraseRootFromParent_Done,
     /* 154066 */   // Label 3355: @154066
     /* 154066 */   GIM_Try, /*On fail goto*//*Label 3356*/ GIMT_Encode4(154131), // Rule ID 965 //
     /* 154071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 154074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 154078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 154082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 154086 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 154093 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 154101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154103 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154110 */     // (fsub:{ *:[f32] } (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP32:{ *:[f32] }:$src1)  =>  (SUBR_FpI16m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_FpI16m32),
     /* 154113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154115 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 154117 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154121 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 154124 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154129 */     GIR_RootConstrainSelectedInstOperands,
     /* 154130 */     // GIR_Coverage, 965,
     /* 154130 */     GIR_EraseRootFromParent_Done,
     /* 154131 */   // Label 3356: @154131
     /* 154131 */   GIM_Try, /*On fail goto*//*Label 3357*/ GIMT_Encode4(154196), // Rule ID 967 //
     /* 154136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 154139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 154143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 154147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 154151 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 154158 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 154166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154168 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154175 */     // (fsub:{ *:[f32] } (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP32:{ *:[f32] }:$src1)  =>  (SUBR_FpI32m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_FpI32m32),
     /* 154178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154180 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 154182 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154186 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 154189 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154194 */     GIR_RootConstrainSelectedInstOperands,
     /* 154195 */     // GIR_Coverage, 967,
     /* 154195 */     GIR_EraseRootFromParent_Done,
     /* 154196 */   // Label 3357: @154196
     /* 154196 */   GIM_Try, /*On fail goto*//*Label 3358*/ GIMT_Encode4(154261), // Rule ID 955 //
     /* 154201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 154204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 154208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 154212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154216 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154219 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 154223 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 154231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154233 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154240 */     // (fsub:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP32:{ *:[f32] }:$src1)  =>  (SUBR_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp32m),
     /* 154243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154245 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 154247 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154251 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 154254 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154259 */     GIR_RootConstrainSelectedInstOperands,
     /* 154260 */     // GIR_Coverage, 955,
     /* 154260 */     GIR_EraseRootFromParent_Done,
     /* 154261 */   // Label 3358: @154261
     /* 154261 */   GIM_Try, /*On fail goto*//*Label 3359*/ GIMT_Encode4(154326), // Rule ID 943 //
     /* 154266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 154269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 154273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 154277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 154285 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 154292 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154298 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154305 */     // (fsub:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (SUB_FpI16m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_FpI16m32),
     /* 154308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154310 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 154312 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154316 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 154319 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154324 */     GIR_RootConstrainSelectedInstOperands,
     /* 154325 */     // GIR_Coverage, 943,
     /* 154325 */     GIR_EraseRootFromParent_Done,
     /* 154326 */   // Label 3359: @154326
     /* 154326 */   GIM_Try, /*On fail goto*//*Label 3360*/ GIMT_Encode4(154391), // Rule ID 945 //
     /* 154331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 154334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 154338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 154342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 154350 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 154357 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154363 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154370 */     // (fsub:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (SUB_FpI32m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_FpI32m32),
     /* 154373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154375 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 154377 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154381 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 154384 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154389 */     GIR_RootConstrainSelectedInstOperands,
     /* 154390 */     // GIR_Coverage, 945,
     /* 154390 */     GIR_EraseRootFromParent_Done,
     /* 154391 */   // Label 3360: @154391
     /* 154391 */   GIM_Try, /*On fail goto*//*Label 3361*/ GIMT_Encode4(154456), // Rule ID 933 //
     /* 154396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 154399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 154403 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 154407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154415 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154418 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 154422 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154428 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154435 */     // (fsub:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUB_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp32m),
     /* 154438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154440 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 154442 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154446 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 154449 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154454 */     GIR_RootConstrainSelectedInstOperands,
     /* 154455 */     // GIR_Coverage, 933,
     /* 154455 */     GIR_EraseRootFromParent_Done,
     /* 154456 */   // Label 3361: @154456
     /* 154456 */   GIM_Try, /*On fail goto*//*Label 3362*/ GIMT_Encode4(154518), // Rule ID 2241 //
     /* 154461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 154464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 154468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 154472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154480 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154483 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 154487 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154493 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154500 */     // (fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSSrm),
     /* 154503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154505 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 154507 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154511 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154516 */     GIR_RootConstrainSelectedInstOperands,
     /* 154517 */     // GIR_Coverage, 2241,
     /* 154517 */     GIR_EraseRootFromParent_Done,
     /* 154518 */   // Label 3362: @154518
     /* 154518 */   GIM_Try, /*On fail goto*//*Label 3363*/ GIMT_Encode4(154580), // Rule ID 2249 //
     /* 154523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 154526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 154530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 154534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154542 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154545 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 154549 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154555 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154562 */     // (fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUBSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBSSrm),
     /* 154565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154567 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 154569 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154573 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154578 */     GIR_RootConstrainSelectedInstOperands,
     /* 154579 */     // GIR_Coverage, 2249,
     /* 154579 */     GIR_EraseRootFromParent_Done,
     /* 154580 */   // Label 3363: @154580
     /* 154580 */   GIM_Try, /*On fail goto*//*Label 3364*/ GIMT_Encode4(154642), // Rule ID 6031 //
     /* 154585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 154588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 154592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 154596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154604 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154607 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 154611 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154617 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154624 */     // (fsub:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSSZrm),
     /* 154627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154629 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 154631 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154635 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154640 */     GIR_RootConstrainSelectedInstOperands,
     /* 154641 */     // GIR_Coverage, 6031,
     /* 154641 */     GIR_EraseRootFromParent_Done,
     /* 154642 */   // Label 3364: @154642
     /* 154642 */   GIM_Try, /*On fail goto*//*Label 3365*/ GIMT_Encode4(154679), // Rule ID 893 //
     /* 154647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 154650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 154654 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 154658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 154662 */     // (fsub:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (SUB_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 154662 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB_Fp32),
     /* 154667 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 154673 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 154677 */     GIR_RootConstrainSelectedInstOperands,
     /* 154678 */     // GIR_Coverage, 893,
     /* 154678 */     GIR_Done,
     /* 154679 */   // Label 3365: @154679
     /* 154679 */   GIM_Try, /*On fail goto*//*Label 3366*/ GIMT_Encode4(154710), // Rule ID 2239 //
     /* 154684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 154687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 154691 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 154695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 154699 */     // (fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VSUBSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 154699 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSSrr),
     /* 154704 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 154708 */     GIR_RootConstrainSelectedInstOperands,
     /* 154709 */     // GIR_Coverage, 2239,
     /* 154709 */     GIR_Done,
     /* 154710 */   // Label 3366: @154710
     /* 154710 */   GIM_Try, /*On fail goto*//*Label 3367*/ GIMT_Encode4(154741), // Rule ID 2247 //
     /* 154715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 154718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 154722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 154726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 154730 */     // (fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (SUBSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 154730 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBSSrr),
     /* 154735 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 154739 */     GIR_RootConstrainSelectedInstOperands,
     /* 154740 */     // GIR_Coverage, 2247,
     /* 154740 */     GIR_Done,
     /* 154741 */   // Label 3367: @154741
     /* 154741 */   GIM_Try, /*On fail goto*//*Label 3368*/ GIMT_Encode4(154772), // Rule ID 6029 //
     /* 154746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 154749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 154753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 154757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 154761 */     // (fsub:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VSUBSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 154761 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSSZrr),
     /* 154766 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 154770 */     GIR_RootConstrainSelectedInstOperands,
     /* 154771 */     // GIR_Coverage, 6029,
     /* 154771 */     GIR_Done,
     /* 154772 */   // Label 3368: @154772
     /* 154772 */   GIM_Reject,
     /* 154773 */ // Label 3352: @154773
     /* 154773 */ GIM_Reject,
     /* 154774 */ // Label 3337: @154774
     /* 154774 */ GIM_Try, /*On fail goto*//*Label 3369*/ GIMT_Encode4(155882),
     /* 154779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 154782 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 154785 */   GIM_Try, /*On fail goto*//*Label 3370*/ GIMT_Encode4(154867), // Rule ID 22476 //
     /* 154790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 154793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 154797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 154801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 154809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 154813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 154817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154821 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 154824 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 154828 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 154835 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 154839 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154841 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154848 */     // (fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (SUBSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBSDrm),
     /* 154851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154853 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 154855 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154859 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 154865 */     GIR_RootConstrainSelectedInstOperands,
     /* 154866 */     // GIR_Coverage, 22476,
     /* 154866 */     GIR_EraseRootFromParent_Done,
     /* 154867 */   // Label 3370: @154867
     /* 154867 */   GIM_Try, /*On fail goto*//*Label 3371*/ GIMT_Encode4(154949), // Rule ID 22477 //
     /* 154872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 154875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 154879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 154883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 154891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 154895 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 154899 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154903 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 154906 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 154910 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 154917 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 154921 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154923 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154930 */     // (fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (VSUBSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSDrm),
     /* 154933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154935 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 154937 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154941 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 154947 */     GIR_RootConstrainSelectedInstOperands,
     /* 154948 */     // GIR_Coverage, 22477,
     /* 154948 */     GIR_EraseRootFromParent_Done,
     /* 154949 */   // Label 3371: @154949
     /* 154949 */   GIM_Try, /*On fail goto*//*Label 3372*/ GIMT_Encode4(155031), // Rule ID 22478 //
     /* 154954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 154957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 154961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 154965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 154973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 154977 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 154981 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154985 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 154988 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 154992 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 154999 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 155003 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 155005 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155012 */     // (fsub:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (VSUBSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSDZrm),
     /* 155015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155017 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 155019 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155023 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 155029 */     GIR_RootConstrainSelectedInstOperands,
     /* 155030 */     // GIR_Coverage, 22478,
     /* 155030 */     GIR_EraseRootFromParent_Done,
     /* 155031 */   // Label 3372: @155031
     /* 155031 */   GIM_Try, /*On fail goto*//*Label 3373*/ GIMT_Encode4(155096), // Rule ID 969 //
     /* 155036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 155039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 155047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 155051 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 155058 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155066 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155068 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155075 */     // (fsub:{ *:[f64] } (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP64:{ *:[f64] }:$src1)  =>  (SUBR_FpI16m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_FpI16m64),
     /* 155078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155080 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 155082 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155086 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 155089 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155094 */     GIR_RootConstrainSelectedInstOperands,
     /* 155095 */     // GIR_Coverage, 969,
     /* 155095 */     GIR_EraseRootFromParent_Done,
     /* 155096 */   // Label 3373: @155096
     /* 155096 */   GIM_Try, /*On fail goto*//*Label 3374*/ GIMT_Encode4(155161), // Rule ID 971 //
     /* 155101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 155104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 155112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 155116 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 155123 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155133 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155140 */     // (fsub:{ *:[f64] } (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP64:{ *:[f64] }:$src1)  =>  (SUBR_FpI32m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_FpI32m64),
     /* 155143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155145 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 155147 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155151 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 155154 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155159 */     GIR_RootConstrainSelectedInstOperands,
     /* 155160 */     // GIR_Coverage, 971,
     /* 155160 */     GIR_EraseRootFromParent_Done,
     /* 155161 */   // Label 3374: @155161
     /* 155161 */   GIM_Try, /*On fail goto*//*Label 3375*/ GIMT_Encode4(155226), // Rule ID 957 //
     /* 155166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 155169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 155177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 155181 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155184 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 155188 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155196 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155198 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155205 */     // (fsub:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP64:{ *:[f64] }:$src1)  =>  (SUBR_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp64m),
     /* 155208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155210 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 155212 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155216 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 155219 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155224 */     GIR_RootConstrainSelectedInstOperands,
     /* 155225 */     // GIR_Coverage, 957,
     /* 155225 */     GIR_EraseRootFromParent_Done,
     /* 155226 */   // Label 3375: @155226
     /* 155226 */   GIM_Try, /*On fail goto*//*Label 3376*/ GIMT_Encode4(155298), // Rule ID 959 //
     /* 155231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 155234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 155242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 155246 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155249 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 155253 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 155260 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155270 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155277 */     // (fsub:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP64:{ *:[f64] }:$src1)  =>  (SUBR_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp64m32),
     /* 155280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155282 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 155284 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155288 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 155291 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155296 */     GIR_RootConstrainSelectedInstOperands,
     /* 155297 */     // GIR_Coverage, 959,
     /* 155297 */     GIR_EraseRootFromParent_Done,
     /* 155298 */   // Label 3376: @155298
     /* 155298 */   GIM_Try, /*On fail goto*//*Label 3377*/ GIMT_Encode4(155363), // Rule ID 947 //
     /* 155303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 155306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 155322 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 155329 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155335 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155342 */     // (fsub:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (SUB_FpI16m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_FpI16m64),
     /* 155345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155347 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 155349 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155353 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 155356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155361 */     GIR_RootConstrainSelectedInstOperands,
     /* 155362 */     // GIR_Coverage, 947,
     /* 155362 */     GIR_EraseRootFromParent_Done,
     /* 155363 */   // Label 3377: @155363
     /* 155363 */   GIM_Try, /*On fail goto*//*Label 3378*/ GIMT_Encode4(155428), // Rule ID 949 //
     /* 155368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 155371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 155387 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 155394 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155400 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155407 */     // (fsub:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (SUB_FpI32m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_FpI32m64),
     /* 155410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155412 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 155414 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155418 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 155421 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155426 */     GIR_RootConstrainSelectedInstOperands,
     /* 155427 */     // GIR_Coverage, 949,
     /* 155427 */     GIR_EraseRootFromParent_Done,
     /* 155428 */   // Label 3378: @155428
     /* 155428 */   GIM_Try, /*On fail goto*//*Label 3379*/ GIMT_Encode4(155493), // Rule ID 935 //
     /* 155433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 155436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 155452 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155455 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 155459 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155465 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155472 */     // (fsub:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUB_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp64m),
     /* 155475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155477 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 155479 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155483 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 155486 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155491 */     GIR_RootConstrainSelectedInstOperands,
     /* 155492 */     // GIR_Coverage, 935,
     /* 155492 */     GIR_EraseRootFromParent_Done,
     /* 155493 */   // Label 3379: @155493
     /* 155493 */   GIM_Try, /*On fail goto*//*Label 3380*/ GIMT_Encode4(155565), // Rule ID 937 //
     /* 155498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 155501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155505 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 155517 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155520 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 155524 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 155531 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155537 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155544 */     // (fsub:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (SUB_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp64m32),
     /* 155547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155549 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 155551 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155555 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 155558 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155563 */     GIR_RootConstrainSelectedInstOperands,
     /* 155564 */     // GIR_Coverage, 937,
     /* 155564 */     GIR_EraseRootFromParent_Done,
     /* 155565 */   // Label 3380: @155565
     /* 155565 */   GIM_Try, /*On fail goto*//*Label 3381*/ GIMT_Encode4(155627), // Rule ID 2245 //
     /* 155570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 155573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 155577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 155581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 155589 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155592 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 155596 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155602 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155609 */     // (fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSDrm),
     /* 155612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155614 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 155616 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155620 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155625 */     GIR_RootConstrainSelectedInstOperands,
     /* 155626 */     // GIR_Coverage, 2245,
     /* 155626 */     GIR_EraseRootFromParent_Done,
     /* 155627 */   // Label 3381: @155627
     /* 155627 */   GIM_Try, /*On fail goto*//*Label 3382*/ GIMT_Encode4(155689), // Rule ID 2253 //
     /* 155632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 155635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 155639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 155643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 155651 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155654 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 155658 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155664 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155671 */     // (fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUBSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBSDrm),
     /* 155674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155676 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 155678 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155682 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155687 */     GIR_RootConstrainSelectedInstOperands,
     /* 155688 */     // GIR_Coverage, 2253,
     /* 155688 */     GIR_EraseRootFromParent_Done,
     /* 155689 */   // Label 3382: @155689
     /* 155689 */   GIM_Try, /*On fail goto*//*Label 3383*/ GIMT_Encode4(155751), // Rule ID 6050 //
     /* 155694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 155697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 155701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 155705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 155713 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155716 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 155720 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155726 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155733 */     // (fsub:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSDZrm),
     /* 155736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155738 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 155740 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155744 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155749 */     GIR_RootConstrainSelectedInstOperands,
     /* 155750 */     // GIR_Coverage, 6050,
     /* 155750 */     GIR_EraseRootFromParent_Done,
     /* 155751 */   // Label 3383: @155751
     /* 155751 */   GIM_Try, /*On fail goto*//*Label 3384*/ GIMT_Encode4(155788), // Rule ID 895 //
     /* 155756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 155759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155763 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155771 */     // (fsub:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (SUB_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 155771 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB_Fp64),
     /* 155776 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 155782 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 155786 */     GIR_RootConstrainSelectedInstOperands,
     /* 155787 */     // GIR_Coverage, 895,
     /* 155787 */     GIR_Done,
     /* 155788 */   // Label 3384: @155788
     /* 155788 */   GIM_Try, /*On fail goto*//*Label 3385*/ GIMT_Encode4(155819), // Rule ID 2243 //
     /* 155793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 155796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 155800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 155804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 155808 */     // (fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VSUBSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 155808 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSDrr),
     /* 155813 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 155817 */     GIR_RootConstrainSelectedInstOperands,
     /* 155818 */     // GIR_Coverage, 2243,
     /* 155818 */     GIR_Done,
     /* 155819 */   // Label 3385: @155819
     /* 155819 */   GIM_Try, /*On fail goto*//*Label 3386*/ GIMT_Encode4(155850), // Rule ID 2251 //
     /* 155824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 155827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 155831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 155835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 155839 */     // (fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (SUBSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 155839 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBSDrr),
     /* 155844 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 155848 */     GIR_RootConstrainSelectedInstOperands,
     /* 155849 */     // GIR_Coverage, 2251,
     /* 155849 */     GIR_Done,
     /* 155850 */   // Label 3386: @155850
     /* 155850 */   GIM_Try, /*On fail goto*//*Label 3387*/ GIMT_Encode4(155881), // Rule ID 6048 //
     /* 155855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 155858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 155862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 155866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 155870 */     // (fsub:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VSUBSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 155870 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSDZrr),
     /* 155875 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 155879 */     GIR_RootConstrainSelectedInstOperands,
     /* 155880 */     // GIR_Coverage, 6048,
     /* 155880 */     GIR_Done,
     /* 155881 */   // Label 3387: @155881
     /* 155881 */   GIM_Reject,
     /* 155882 */ // Label 3369: @155882
     /* 155882 */ GIM_Reject,
     /* 155883 */ // Label 3338: @155883
     /* 155883 */ GIM_Try, /*On fail goto*//*Label 3388*/ GIMT_Encode4(156448),
     /* 155888 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 155891 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 155894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 155898 */   GIM_Try, /*On fail goto*//*Label 3389*/ GIMT_Encode4(155959), // Rule ID 973 //
     /* 155903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 155906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 155910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 155914 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 155921 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 155929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155931 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155938 */     // (fsub:{ *:[f80] } (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP80:{ *:[f80] }:$src1)  =>  (SUBR_FpI16m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_FpI16m80),
     /* 155941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155943 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 155945 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155949 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 155952 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155957 */     GIR_RootConstrainSelectedInstOperands,
     /* 155958 */     // GIR_Coverage, 973,
     /* 155958 */     GIR_EraseRootFromParent_Done,
     /* 155959 */   // Label 3389: @155959
     /* 155959 */   GIM_Try, /*On fail goto*//*Label 3390*/ GIMT_Encode4(156020), // Rule ID 975 //
     /* 155964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 155967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 155971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 155975 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 155982 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 155990 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155992 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155999 */     // (fsub:{ *:[f80] } (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP80:{ *:[f80] }:$src1)  =>  (SUBR_FpI32m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_FpI32m80),
     /* 156002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156004 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 156006 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156010 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 156013 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 156018 */     GIR_RootConstrainSelectedInstOperands,
     /* 156019 */     // GIR_Coverage, 975,
     /* 156019 */     GIR_EraseRootFromParent_Done,
     /* 156020 */   // Label 3390: @156020
     /* 156020 */   GIM_Try, /*On fail goto*//*Label 3391*/ GIMT_Encode4(156088), // Rule ID 961 //
     /* 156025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 156028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 156032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156036 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156039 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 156043 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 156050 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 156054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 156058 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156060 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156067 */     // (fsub:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP80:{ *:[f80] }:$src1)  =>  (SUBR_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp80m32),
     /* 156070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156072 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 156074 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156078 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 156081 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 156086 */     GIR_RootConstrainSelectedInstOperands,
     /* 156087 */     // GIR_Coverage, 961,
     /* 156087 */     GIR_EraseRootFromParent_Done,
     /* 156088 */   // Label 3391: @156088
     /* 156088 */   GIM_Try, /*On fail goto*//*Label 3392*/ GIMT_Encode4(156156), // Rule ID 963 //
     /* 156093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 156096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 156100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156104 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156107 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 156111 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 156118 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 156122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 156126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156128 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156135 */     // (fsub:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>, RFP80:{ *:[f80] }:$src1)  =>  (SUBR_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp80m64),
     /* 156138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156140 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 156142 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156146 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 156149 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 156154 */     GIR_RootConstrainSelectedInstOperands,
     /* 156155 */     // GIR_Coverage, 963,
     /* 156155 */     GIR_EraseRootFromParent_Done,
     /* 156156 */   // Label 3392: @156156
     /* 156156 */   GIM_Try, /*On fail goto*//*Label 3393*/ GIMT_Encode4(156217), // Rule ID 951 //
     /* 156161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 156164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 156168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 156176 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 156183 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 156187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156189 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156196 */     // (fsub:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (SUB_FpI16m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_FpI16m80),
     /* 156199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156201 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 156203 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156207 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 156210 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 156215 */     GIR_RootConstrainSelectedInstOperands,
     /* 156216 */     // GIR_Coverage, 951,
     /* 156216 */     GIR_EraseRootFromParent_Done,
     /* 156217 */   // Label 3393: @156217
     /* 156217 */   GIM_Try, /*On fail goto*//*Label 3394*/ GIMT_Encode4(156278), // Rule ID 953 //
     /* 156222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 156225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 156229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 156237 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 156244 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 156248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156250 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156257 */     // (fsub:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (SUB_FpI32m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_FpI32m80),
     /* 156260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156262 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 156264 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156268 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 156271 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 156276 */     GIR_RootConstrainSelectedInstOperands,
     /* 156277 */     // GIR_Coverage, 953,
     /* 156277 */     GIR_EraseRootFromParent_Done,
     /* 156278 */   // Label 3394: @156278
     /* 156278 */   GIM_Try, /*On fail goto*//*Label 3395*/ GIMT_Encode4(156346), // Rule ID 939 //
     /* 156283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 156286 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 156290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156298 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156301 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 156305 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 156312 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 156316 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156318 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156325 */     // (fsub:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (SUB_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp80m32),
     /* 156328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156330 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 156332 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156336 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 156339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 156344 */     GIR_RootConstrainSelectedInstOperands,
     /* 156345 */     // GIR_Coverage, 939,
     /* 156345 */     GIR_EraseRootFromParent_Done,
     /* 156346 */   // Label 3395: @156346
     /* 156346 */   GIM_Try, /*On fail goto*//*Label 3396*/ GIMT_Encode4(156414), // Rule ID 941 //
     /* 156351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 156354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 156358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156366 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156369 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 156373 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 156380 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 156384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156386 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156393 */     // (fsub:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>)  =>  (SUB_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp80m64),
     /* 156396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156398 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 156400 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156404 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 156407 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 156412 */     GIR_RootConstrainSelectedInstOperands,
     /* 156413 */     // GIR_Coverage, 941,
     /* 156413 */     GIR_EraseRootFromParent_Done,
     /* 156414 */   // Label 3396: @156414
     /* 156414 */   GIM_Try, /*On fail goto*//*Label 3397*/ GIMT_Encode4(156447), // Rule ID 897 //
     /* 156419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 156422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 156426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 156430 */     // (fsub:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (SUB_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 156430 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB_Fp80),
     /* 156435 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 156441 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 156445 */     GIR_RootConstrainSelectedInstOperands,
     /* 156446 */     // GIR_Coverage, 897,
     /* 156446 */     GIR_Done,
     /* 156447 */   // Label 3397: @156447
     /* 156447 */   GIM_Reject,
     /* 156448 */ // Label 3388: @156448
     /* 156448 */ GIM_Reject,
     /* 156449 */ // Label 3339: @156449
     /* 156449 */ GIM_Try, /*On fail goto*//*Label 3398*/ GIMT_Encode4(156678),
     /* 156454 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 156457 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 156460 */   GIM_Try, /*On fail goto*//*Label 3399*/ GIMT_Encode4(156522), // Rule ID 2221 //
     /* 156465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 156468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 156472 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 156476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156484 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156487 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 156491 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 156495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156497 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156504 */     // (fsub:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDrm),
     /* 156507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156509 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 156511 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156515 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 156520 */     GIR_RootConstrainSelectedInstOperands,
     /* 156521 */     // GIR_Coverage, 2221,
     /* 156521 */     GIR_EraseRootFromParent_Done,
     /* 156522 */   // Label 3399: @156522
     /* 156522 */   GIM_Try, /*On fail goto*//*Label 3400*/ GIMT_Encode4(156584), // Rule ID 6543 //
     /* 156527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 156530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 156534 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 156538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156546 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156549 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 156553 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 156557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156559 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156566 */     // (fsub:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ128rm),
     /* 156569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156571 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 156573 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156577 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 156582 */     GIR_RootConstrainSelectedInstOperands,
     /* 156583 */     // GIR_Coverage, 6543,
     /* 156583 */     GIR_EraseRootFromParent_Done,
     /* 156584 */   // Label 3400: @156584
     /* 156584 */   GIM_Try, /*On fail goto*//*Label 3401*/ GIMT_Encode4(156615), // Rule ID 2219 //
     /* 156589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 156592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 156596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 156600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 156604 */     // (fsub:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VSUBPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 156604 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDrr),
     /* 156609 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 156613 */     GIR_RootConstrainSelectedInstOperands,
     /* 156614 */     // GIR_Coverage, 2219,
     /* 156614 */     GIR_Done,
     /* 156615 */   // Label 3401: @156615
     /* 156615 */   GIM_Try, /*On fail goto*//*Label 3402*/ GIMT_Encode4(156646), // Rule ID 2235 //
     /* 156620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 156623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 156627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 156631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 156635 */     // (fsub:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (SUBPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 156635 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBPDrr),
     /* 156640 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 156644 */     GIR_RootConstrainSelectedInstOperands,
     /* 156645 */     // GIR_Coverage, 2235,
     /* 156645 */     GIR_Done,
     /* 156646 */   // Label 3402: @156646
     /* 156646 */   GIM_Try, /*On fail goto*//*Label 3403*/ GIMT_Encode4(156677), // Rule ID 6539 //
     /* 156651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 156654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 156658 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 156662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 156666 */     // (fsub:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VSUBPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 156666 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ128rr),
     /* 156671 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 156675 */     GIR_RootConstrainSelectedInstOperands,
     /* 156676 */     // GIR_Coverage, 6539,
     /* 156676 */     GIR_Done,
     /* 156677 */   // Label 3403: @156677
     /* 156677 */   GIM_Reject,
     /* 156678 */ // Label 3398: @156678
     /* 156678 */ GIM_Reject,
     /* 156679 */ // Label 3340: @156679
     /* 156679 */ GIM_Try, /*On fail goto*//*Label 3404*/ GIMT_Encode4(156908),
     /* 156684 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 156687 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 156690 */   GIM_Try, /*On fail goto*//*Label 3405*/ GIMT_Encode4(156752), // Rule ID 2217 //
     /* 156695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 156698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 156702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 156706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156714 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156717 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 156721 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 156725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156727 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156734 */     // (fsub:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSrm),
     /* 156737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156739 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 156741 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156745 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 156750 */     GIR_RootConstrainSelectedInstOperands,
     /* 156751 */     // GIR_Coverage, 2217,
     /* 156751 */     GIR_EraseRootFromParent_Done,
     /* 156752 */   // Label 3405: @156752
     /* 156752 */   GIM_Try, /*On fail goto*//*Label 3406*/ GIMT_Encode4(156814), // Rule ID 6519 //
     /* 156757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 156760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 156764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 156768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156776 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156779 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 156783 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 156787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156789 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156796 */     // (fsub:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ128rm),
     /* 156799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156801 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 156803 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156807 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 156812 */     GIR_RootConstrainSelectedInstOperands,
     /* 156813 */     // GIR_Coverage, 6519,
     /* 156813 */     GIR_EraseRootFromParent_Done,
     /* 156814 */   // Label 3406: @156814
     /* 156814 */   GIM_Try, /*On fail goto*//*Label 3407*/ GIMT_Encode4(156845), // Rule ID 2215 //
     /* 156819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 156822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 156826 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 156830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 156834 */     // (fsub:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VSUBPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 156834 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSrr),
     /* 156839 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 156843 */     GIR_RootConstrainSelectedInstOperands,
     /* 156844 */     // GIR_Coverage, 2215,
     /* 156844 */     GIR_Done,
     /* 156845 */   // Label 3407: @156845
     /* 156845 */   GIM_Try, /*On fail goto*//*Label 3408*/ GIMT_Encode4(156876), // Rule ID 2231 //
     /* 156850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 156853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 156857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 156861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 156865 */     // (fsub:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (SUBPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 156865 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBPSrr),
     /* 156870 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 156874 */     GIR_RootConstrainSelectedInstOperands,
     /* 156875 */     // GIR_Coverage, 2231,
     /* 156875 */     GIR_Done,
     /* 156876 */   // Label 3408: @156876
     /* 156876 */   GIM_Try, /*On fail goto*//*Label 3409*/ GIMT_Encode4(156907), // Rule ID 6515 //
     /* 156881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 156884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 156888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 156892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 156896 */     // (fsub:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VSUBPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 156896 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ128rr),
     /* 156901 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 156905 */     GIR_RootConstrainSelectedInstOperands,
     /* 156906 */     // GIR_Coverage, 6515,
     /* 156906 */     GIR_Done,
     /* 156907 */   // Label 3409: @156907
     /* 156907 */   GIM_Reject,
     /* 156908 */ // Label 3404: @156908
     /* 156908 */ GIM_Reject,
     /* 156909 */ // Label 3341: @156909
     /* 156909 */ GIM_Try, /*On fail goto*//*Label 3410*/ GIMT_Encode4(157107),
     /* 156914 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 156917 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 156920 */   GIM_Try, /*On fail goto*//*Label 3411*/ GIMT_Encode4(156982), // Rule ID 2229 //
     /* 156925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 156928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 156932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 156936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156944 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156947 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 156951 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 156955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156957 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156964 */     // (fsub:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDYrm),
     /* 156967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156969 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 156971 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156975 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 156980 */     GIR_RootConstrainSelectedInstOperands,
     /* 156981 */     // GIR_Coverage, 2229,
     /* 156981 */     GIR_EraseRootFromParent_Done,
     /* 156982 */   // Label 3411: @156982
     /* 156982 */   GIM_Try, /*On fail goto*//*Label 3412*/ GIMT_Encode4(157044), // Rule ID 6555 //
     /* 156987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 156990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 156994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 156998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157006 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157009 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 157013 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 157017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157019 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157026 */     // (fsub:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ256rm),
     /* 157029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157031 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 157033 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157037 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 157042 */     GIR_RootConstrainSelectedInstOperands,
     /* 157043 */     // GIR_Coverage, 6555,
     /* 157043 */     GIR_EraseRootFromParent_Done,
     /* 157044 */   // Label 3412: @157044
     /* 157044 */   GIM_Try, /*On fail goto*//*Label 3413*/ GIMT_Encode4(157075), // Rule ID 2227 //
     /* 157049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 157052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 157056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 157060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 157064 */     // (fsub:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VSUBPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 157064 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDYrr),
     /* 157069 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 157073 */     GIR_RootConstrainSelectedInstOperands,
     /* 157074 */     // GIR_Coverage, 2227,
     /* 157074 */     GIR_Done,
     /* 157075 */   // Label 3413: @157075
     /* 157075 */   GIM_Try, /*On fail goto*//*Label 3414*/ GIMT_Encode4(157106), // Rule ID 6551 //
     /* 157080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 157083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 157087 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 157091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 157095 */     // (fsub:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VSUBPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 157095 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ256rr),
     /* 157100 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 157104 */     GIR_RootConstrainSelectedInstOperands,
     /* 157105 */     // GIR_Coverage, 6551,
     /* 157105 */     GIR_Done,
     /* 157106 */   // Label 3414: @157106
     /* 157106 */   GIM_Reject,
     /* 157107 */ // Label 3410: @157107
     /* 157107 */ GIM_Reject,
     /* 157108 */ // Label 3342: @157108
     /* 157108 */ GIM_Try, /*On fail goto*//*Label 3415*/ GIMT_Encode4(157205),
     /* 157113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 157116 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 157119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 157123 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 157127 */   GIM_Try, /*On fail goto*//*Label 3416*/ GIMT_Encode4(157181), // Rule ID 6579 //
     /* 157132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 157135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157143 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157146 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 157150 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 157154 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157156 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157163 */     // (fsub:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ128rm),
     /* 157166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157168 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 157170 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157174 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 157179 */     GIR_RootConstrainSelectedInstOperands,
     /* 157180 */     // GIR_Coverage, 6579,
     /* 157180 */     GIR_EraseRootFromParent_Done,
     /* 157181 */   // Label 3416: @157181
     /* 157181 */   GIM_Try, /*On fail goto*//*Label 3417*/ GIMT_Encode4(157204), // Rule ID 6575 //
     /* 157186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 157189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 157193 */     // (fsub:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VSUBPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 157193 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ128rr),
     /* 157198 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 157202 */     GIR_RootConstrainSelectedInstOperands,
     /* 157203 */     // GIR_Coverage, 6575,
     /* 157203 */     GIR_Done,
     /* 157204 */   // Label 3417: @157204
     /* 157204 */   GIM_Reject,
     /* 157205 */ // Label 3415: @157205
     /* 157205 */ GIM_Reject,
     /* 157206 */ // Label 3343: @157206
     /* 157206 */ GIM_Try, /*On fail goto*//*Label 3418*/ GIMT_Encode4(157404),
     /* 157211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 157214 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 157217 */   GIM_Try, /*On fail goto*//*Label 3419*/ GIMT_Encode4(157279), // Rule ID 2225 //
     /* 157222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 157225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 157229 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 157233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157241 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157244 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 157248 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 157252 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157254 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157261 */     // (fsub:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSYrm),
     /* 157264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157266 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 157268 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157272 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 157277 */     GIR_RootConstrainSelectedInstOperands,
     /* 157278 */     // GIR_Coverage, 2225,
     /* 157278 */     GIR_EraseRootFromParent_Done,
     /* 157279 */   // Label 3419: @157279
     /* 157279 */   GIM_Try, /*On fail goto*//*Label 3420*/ GIMT_Encode4(157341), // Rule ID 6531 //
     /* 157284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 157287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 157291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 157295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157303 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157306 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 157310 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 157314 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157316 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157323 */     // (fsub:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ256rm),
     /* 157326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157328 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 157330 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157334 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 157339 */     GIR_RootConstrainSelectedInstOperands,
     /* 157340 */     // GIR_Coverage, 6531,
     /* 157340 */     GIR_EraseRootFromParent_Done,
     /* 157341 */   // Label 3420: @157341
     /* 157341 */   GIM_Try, /*On fail goto*//*Label 3421*/ GIMT_Encode4(157372), // Rule ID 2223 //
     /* 157346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 157349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 157353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 157357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 157361 */     // (fsub:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VSUBPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 157361 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSYrr),
     /* 157366 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 157370 */     GIR_RootConstrainSelectedInstOperands,
     /* 157371 */     // GIR_Coverage, 2223,
     /* 157371 */     GIR_Done,
     /* 157372 */   // Label 3421: @157372
     /* 157372 */   GIM_Try, /*On fail goto*//*Label 3422*/ GIMT_Encode4(157403), // Rule ID 6527 //
     /* 157377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 157380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 157384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 157388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 157392 */     // (fsub:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VSUBPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 157392 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ256rr),
     /* 157397 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 157401 */     GIR_RootConstrainSelectedInstOperands,
     /* 157402 */     // GIR_Coverage, 6527,
     /* 157402 */     GIR_Done,
     /* 157403 */   // Label 3422: @157403
     /* 157403 */   GIM_Reject,
     /* 157404 */ // Label 3418: @157404
     /* 157404 */ GIM_Reject,
     /* 157405 */ // Label 3344: @157405
     /* 157405 */ GIM_Try, /*On fail goto*//*Label 3423*/ GIMT_Encode4(157502),
     /* 157410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 157413 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 157416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 157420 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 157424 */   GIM_Try, /*On fail goto*//*Label 3424*/ GIMT_Encode4(157478), // Rule ID 6507 //
     /* 157429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 157432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157440 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157443 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 157447 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 157451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157453 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157460 */     // (fsub:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDZrm),
     /* 157463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157465 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 157467 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157471 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 157476 */     GIR_RootConstrainSelectedInstOperands,
     /* 157477 */     // GIR_Coverage, 6507,
     /* 157477 */     GIR_EraseRootFromParent_Done,
     /* 157478 */   // Label 3424: @157478
     /* 157478 */   GIM_Try, /*On fail goto*//*Label 3425*/ GIMT_Encode4(157501), // Rule ID 6503 //
     /* 157483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 157486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 157490 */     // (fsub:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VSUBPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 157490 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDZrr),
     /* 157495 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 157499 */     GIR_RootConstrainSelectedInstOperands,
     /* 157500 */     // GIR_Coverage, 6503,
     /* 157500 */     GIR_Done,
     /* 157501 */   // Label 3425: @157501
     /* 157501 */   GIM_Reject,
     /* 157502 */ // Label 3423: @157502
     /* 157502 */ GIM_Reject,
     /* 157503 */ // Label 3345: @157503
     /* 157503 */ GIM_Try, /*On fail goto*//*Label 3426*/ GIMT_Encode4(157600),
     /* 157508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 157511 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 157514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 157518 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 157522 */   GIM_Try, /*On fail goto*//*Label 3427*/ GIMT_Encode4(157576), // Rule ID 6591 //
     /* 157527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 157530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157538 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157541 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 157545 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 157549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157551 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157558 */     // (fsub:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ256rm),
     /* 157561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157563 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 157565 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157569 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 157574 */     GIR_RootConstrainSelectedInstOperands,
     /* 157575 */     // GIR_Coverage, 6591,
     /* 157575 */     GIR_EraseRootFromParent_Done,
     /* 157576 */   // Label 3427: @157576
     /* 157576 */   GIM_Try, /*On fail goto*//*Label 3428*/ GIMT_Encode4(157599), // Rule ID 6587 //
     /* 157581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 157584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 157588 */     // (fsub:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VSUBPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 157588 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ256rr),
     /* 157593 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 157597 */     GIR_RootConstrainSelectedInstOperands,
     /* 157598 */     // GIR_Coverage, 6587,
     /* 157598 */     GIR_Done,
     /* 157599 */   // Label 3428: @157599
     /* 157599 */   GIM_Reject,
     /* 157600 */ // Label 3426: @157600
     /* 157600 */ GIM_Reject,
     /* 157601 */ // Label 3346: @157601
     /* 157601 */ GIM_Try, /*On fail goto*//*Label 3429*/ GIMT_Encode4(157698),
     /* 157606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 157609 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 157612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 157616 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 157620 */   GIM_Try, /*On fail goto*//*Label 3430*/ GIMT_Encode4(157674), // Rule ID 6495 //
     /* 157625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 157628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157636 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157639 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 157643 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 157647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157649 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157656 */     // (fsub:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSZrm),
     /* 157659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157661 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 157663 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157667 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 157672 */     GIR_RootConstrainSelectedInstOperands,
     /* 157673 */     // GIR_Coverage, 6495,
     /* 157673 */     GIR_EraseRootFromParent_Done,
     /* 157674 */   // Label 3430: @157674
     /* 157674 */   GIM_Try, /*On fail goto*//*Label 3431*/ GIMT_Encode4(157697), // Rule ID 6491 //
     /* 157679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 157682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 157686 */     // (fsub:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VSUBPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 157686 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSZrr),
     /* 157691 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 157695 */     GIR_RootConstrainSelectedInstOperands,
     /* 157696 */     // GIR_Coverage, 6491,
     /* 157696 */     GIR_Done,
     /* 157697 */   // Label 3431: @157697
     /* 157697 */   GIM_Reject,
     /* 157698 */ // Label 3429: @157698
     /* 157698 */ GIM_Reject,
     /* 157699 */ // Label 3347: @157699
     /* 157699 */ GIM_Try, /*On fail goto*//*Label 3432*/ GIMT_Encode4(157796),
     /* 157704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 157707 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 157710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 157714 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 157718 */   GIM_Try, /*On fail goto*//*Label 3433*/ GIMT_Encode4(157772), // Rule ID 6567 //
     /* 157723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 157726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157734 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157737 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 157741 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 157745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157747 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157754 */     // (fsub:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPHZrm),
     /* 157757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157759 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 157761 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157765 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 157770 */     GIR_RootConstrainSelectedInstOperands,
     /* 157771 */     // GIR_Coverage, 6567,
     /* 157771 */     GIR_EraseRootFromParent_Done,
     /* 157772 */   // Label 3433: @157772
     /* 157772 */   GIM_Try, /*On fail goto*//*Label 3434*/ GIMT_Encode4(157795), // Rule ID 6563 //
     /* 157777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 157780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 157784 */     // (fsub:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VSUBPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 157784 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPHZrr),
     /* 157789 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 157793 */     GIR_RootConstrainSelectedInstOperands,
     /* 157794 */     // GIR_Coverage, 6563,
     /* 157794 */     GIR_Done,
     /* 157795 */   // Label 3434: @157795
     /* 157795 */   GIM_Reject,
     /* 157796 */ // Label 3432: @157796
     /* 157796 */ GIM_Reject,
     /* 157797 */ // Label 3348: @157797
     /* 157797 */ GIM_Reject,
     /* 157798 */ // Label 43: @157798
     /* 157798 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 3448*/ GIMT_Encode4(163711),
     /* 157809 */ /*GILLT_s16*//*Label 3435*/ GIMT_Encode4(157893),
     /* 157813 */ /*GILLT_s32*//*Label 3436*/ GIMT_Encode4(158053),
     /* 157817 */ /*GILLT_s64*//*Label 3437*/ GIMT_Encode4(159450),
     /* 157821 */ /*GILLT_s80*//*Label 3438*/ GIMT_Encode4(160991), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 157833 */ /*GILLT_v2s64*//*Label 3439*/ GIMT_Encode4(161557), GIMT_Encode4(0),
     /* 157841 */ /*GILLT_v4s32*//*Label 3440*/ GIMT_Encode4(161911),
     /* 157845 */ /*GILLT_v4s64*//*Label 3441*/ GIMT_Encode4(162265), GIMT_Encode4(0),
     /* 157853 */ /*GILLT_v8s16*//*Label 3442*/ GIMT_Encode4(162588),
     /* 157857 */ /*GILLT_v8s32*//*Label 3443*/ GIMT_Encode4(162748),
     /* 157861 */ /*GILLT_v8s64*//*Label 3444*/ GIMT_Encode4(163071), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 157873 */ /*GILLT_v16s16*//*Label 3445*/ GIMT_Encode4(163231),
     /* 157877 */ /*GILLT_v16s32*//*Label 3446*/ GIMT_Encode4(163391), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 157889 */ /*GILLT_v32s16*//*Label 3447*/ GIMT_Encode4(163551),
     /* 157893 */ // Label 3435: @157893
     /* 157893 */ GIM_Try, /*On fail goto*//*Label 3449*/ GIMT_Encode4(158052),
     /* 157898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 157901 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 157904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 157908 */   GIM_Try, /*On fail goto*//*Label 3450*/ GIMT_Encode4(157966), // Rule ID 24256 //
     /* 157913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 157916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 157920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157924 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157927 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 157931 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 157935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 157939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157941 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157948 */     // (fmul:{ *:[f16] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR16X:{ *:[f16] }:$src1)  =>  (VMULSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSHZrm),
     /* 157951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157953 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 157955 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157959 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 157964 */     GIR_RootConstrainSelectedInstOperands,
     /* 157965 */     // GIR_Coverage, 24256,
     /* 157965 */     GIR_EraseRootFromParent_Done,
     /* 157966 */   // Label 3450: @157966
     /* 157966 */   GIM_Try, /*On fail goto*//*Label 3451*/ GIMT_Encode4(158024), // Rule ID 6012 //
     /* 157971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 157974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 157978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157986 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157989 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 157993 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 157997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157999 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158006 */     // (fmul:{ *:[f16] } FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSHZrm),
     /* 158009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158011 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 158013 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158017 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158022 */     GIR_RootConstrainSelectedInstOperands,
     /* 158023 */     // GIR_Coverage, 6012,
     /* 158023 */     GIR_EraseRootFromParent_Done,
     /* 158024 */   // Label 3451: @158024
     /* 158024 */   GIM_Try, /*On fail goto*//*Label 3452*/ GIMT_Encode4(158051), // Rule ID 6010 //
     /* 158029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 158032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 158036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 158040 */     // (fmul:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VMULSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 158040 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSHZrr),
     /* 158045 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 158049 */     GIR_RootConstrainSelectedInstOperands,
     /* 158050 */     // GIR_Coverage, 6010,
     /* 158050 */     GIR_Done,
     /* 158051 */   // Label 3452: @158051
     /* 158051 */   GIM_Reject,
     /* 158052 */ // Label 3449: @158052
     /* 158052 */ GIM_Reject,
     /* 158053 */ // Label 3436: @158053
     /* 158053 */ GIM_Try, /*On fail goto*//*Label 3453*/ GIMT_Encode4(159449),
     /* 158058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 158061 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 158064 */   GIM_Try, /*On fail goto*//*Label 3454*/ GIMT_Encode4(158146), // Rule ID 26024 //
     /* 158069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 158072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 158076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 158080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 158084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 158088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 158092 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158096 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 158099 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 158103 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 158110 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 158114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 158118 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 158120 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158127 */     // (fmul:{ *:[f32] } (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>), FR32:{ *:[f32] }:$src1)  =>  (MULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSSrm),
     /* 158130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158132 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 158134 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158138 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 158144 */     GIR_RootConstrainSelectedInstOperands,
     /* 158145 */     // GIR_Coverage, 26024,
     /* 158145 */     GIR_EraseRootFromParent_Done,
     /* 158146 */   // Label 3454: @158146
     /* 158146 */   GIM_Try, /*On fail goto*//*Label 3455*/ GIMT_Encode4(158228), // Rule ID 26025 //
     /* 158151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 158154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 158158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 158162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 158166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 158170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 158174 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158178 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 158181 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 158185 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 158192 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 158196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 158200 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 158202 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158209 */     // (fmul:{ *:[f32] } (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>), FR32:{ *:[f32] }:$src1)  =>  (VMULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSrm),
     /* 158212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158214 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 158216 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158220 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 158226 */     GIR_RootConstrainSelectedInstOperands,
     /* 158227 */     // GIR_Coverage, 26025,
     /* 158227 */     GIR_EraseRootFromParent_Done,
     /* 158228 */   // Label 3455: @158228
     /* 158228 */   GIM_Try, /*On fail goto*//*Label 3456*/ GIMT_Encode4(158310), // Rule ID 26026 //
     /* 158233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 158236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 158240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 158244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 158248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 158252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 158256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158260 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 158263 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 158267 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 158274 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 158278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 158282 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 158284 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158291 */     // (fmul:{ *:[f32] } (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>), FR32X:{ *:[f32] }:$src1)  =>  (VMULSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSZrm),
     /* 158294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158296 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 158298 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158302 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 158308 */     GIR_RootConstrainSelectedInstOperands,
     /* 158309 */     // GIR_Coverage, 26026,
     /* 158309 */     GIR_EraseRootFromParent_Done,
     /* 158310 */   // Label 3456: @158310
     /* 158310 */   GIM_Try, /*On fail goto*//*Label 3457*/ GIMT_Encode4(158392), // Rule ID 22479 //
     /* 158315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 158318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 158322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 158326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 158334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 158338 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 158342 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158346 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 158349 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 158353 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 158360 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 158364 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 158366 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158373 */     // (fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (MULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSSrm),
     /* 158376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158378 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 158380 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158384 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 158390 */     GIR_RootConstrainSelectedInstOperands,
     /* 158391 */     // GIR_Coverage, 22479,
     /* 158391 */     GIR_EraseRootFromParent_Done,
     /* 158392 */   // Label 3457: @158392
     /* 158392 */   GIM_Try, /*On fail goto*//*Label 3458*/ GIMT_Encode4(158474), // Rule ID 22480 //
     /* 158397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 158400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 158404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 158408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 158416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 158420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 158424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158428 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 158431 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 158435 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 158442 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 158446 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 158448 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158455 */     // (fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (VMULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSrm),
     /* 158458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158460 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 158462 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158466 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 158472 */     GIR_RootConstrainSelectedInstOperands,
     /* 158473 */     // GIR_Coverage, 22480,
     /* 158473 */     GIR_EraseRootFromParent_Done,
     /* 158474 */   // Label 3458: @158474
     /* 158474 */   GIM_Try, /*On fail goto*//*Label 3459*/ GIMT_Encode4(158556), // Rule ID 22481 //
     /* 158479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 158482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 158486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 158490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 158498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 158502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 158506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158510 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 158513 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 158517 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 158524 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 158528 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 158530 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158537 */     // (fmul:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (VMULSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSZrm),
     /* 158540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158542 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 158544 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158548 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 158554 */     GIR_RootConstrainSelectedInstOperands,
     /* 158555 */     // GIR_Coverage, 22481,
     /* 158555 */     GIR_EraseRootFromParent_Done,
     /* 158556 */   // Label 3459: @158556
     /* 158556 */   GIM_Try, /*On fail goto*//*Label 3460*/ GIMT_Encode4(158621), // Rule ID 23269 //
     /* 158561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 158564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 158568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 158572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 158576 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 158583 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 158591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158593 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158600 */     // (fmul:{ *:[f32] } (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP32:{ *:[f32] }:$src1)  =>  (MUL_FpI16m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI16m32),
     /* 158603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158605 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 158607 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158611 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 158614 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158619 */     GIR_RootConstrainSelectedInstOperands,
     /* 158620 */     // GIR_Coverage, 23269,
     /* 158620 */     GIR_EraseRootFromParent_Done,
     /* 158621 */   // Label 3460: @158621
     /* 158621 */   GIM_Try, /*On fail goto*//*Label 3461*/ GIMT_Encode4(158686), // Rule ID 23271 //
     /* 158626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 158629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 158633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 158637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 158641 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 158648 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 158656 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158658 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158665 */     // (fmul:{ *:[f32] } (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP32:{ *:[f32] }:$src1)  =>  (MUL_FpI32m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI32m32),
     /* 158668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158670 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 158672 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158676 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 158679 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158684 */     GIR_RootConstrainSelectedInstOperands,
     /* 158685 */     // GIR_Coverage, 23271,
     /* 158685 */     GIR_EraseRootFromParent_Done,
     /* 158686 */   // Label 3461: @158686
     /* 158686 */   GIM_Try, /*On fail goto*//*Label 3462*/ GIMT_Encode4(158751), // Rule ID 23259 //
     /* 158691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 158694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 158698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 158702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158706 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 158709 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 158713 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 158721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158723 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158730 */     // (fmul:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP32:{ *:[f32] }:$src1)  =>  (MUL_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp32m),
     /* 158733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158735 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 158737 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158741 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 158744 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158749 */     GIR_RootConstrainSelectedInstOperands,
     /* 158750 */     // GIR_Coverage, 23259,
     /* 158750 */     GIR_EraseRootFromParent_Done,
     /* 158751 */   // Label 3462: @158751
     /* 158751 */   GIM_Try, /*On fail goto*//*Label 3463*/ GIMT_Encode4(158813), // Rule ID 23402 //
     /* 158756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 158759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 158763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 158767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158771 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 158774 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 158778 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 158786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158788 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158795 */     // (fmul:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (VMULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSrm),
     /* 158798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158800 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 158802 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158806 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158811 */     GIR_RootConstrainSelectedInstOperands,
     /* 158812 */     // GIR_Coverage, 23402,
     /* 158812 */     GIR_EraseRootFromParent_Done,
     /* 158813 */   // Label 3463: @158813
     /* 158813 */   GIM_Try, /*On fail goto*//*Label 3464*/ GIMT_Encode4(158875), // Rule ID 23406 //
     /* 158818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 158821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 158825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 158829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158833 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 158836 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 158840 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 158848 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158850 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158857 */     // (fmul:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (MULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSSrm),
     /* 158860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158862 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 158864 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158868 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158873 */     GIR_RootConstrainSelectedInstOperands,
     /* 158874 */     // GIR_Coverage, 23406,
     /* 158874 */     GIR_EraseRootFromParent_Done,
     /* 158875 */   // Label 3464: @158875
     /* 158875 */   GIM_Try, /*On fail goto*//*Label 3465*/ GIMT_Encode4(158937), // Rule ID 24252 //
     /* 158880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 158883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 158887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 158891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158895 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 158898 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 158902 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 158910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158912 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158919 */     // (fmul:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32X:{ *:[f32] }:$src1)  =>  (VMULSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSZrm),
     /* 158922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158924 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 158926 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158930 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158935 */     GIR_RootConstrainSelectedInstOperands,
     /* 158936 */     // GIR_Coverage, 24252,
     /* 158936 */     GIR_EraseRootFromParent_Done,
     /* 158937 */   // Label 3465: @158937
     /* 158937 */   GIM_Try, /*On fail goto*//*Label 3466*/ GIMT_Encode4(159002), // Rule ID 987 //
     /* 158942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 158945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 158949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 158953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 158961 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 158968 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158972 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158974 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158981 */     // (fmul:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (MUL_FpI16m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI16m32),
     /* 158984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158986 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 158988 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158992 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 158995 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 159000 */     GIR_RootConstrainSelectedInstOperands,
     /* 159001 */     // GIR_Coverage, 987,
     /* 159001 */     GIR_EraseRootFromParent_Done,
     /* 159002 */   // Label 3466: @159002
     /* 159002 */   GIM_Try, /*On fail goto*//*Label 3467*/ GIMT_Encode4(159067), // Rule ID 989 //
     /* 159007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 159010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 159014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 159018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 159026 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 159033 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 159037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159039 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159046 */     // (fmul:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (MUL_FpI32m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI32m32),
     /* 159049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159051 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 159053 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159057 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 159060 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 159065 */     GIR_RootConstrainSelectedInstOperands,
     /* 159066 */     // GIR_Coverage, 989,
     /* 159066 */     GIR_EraseRootFromParent_Done,
     /* 159067 */   // Label 3467: @159067
     /* 159067 */   GIM_Try, /*On fail goto*//*Label 3468*/ GIMT_Encode4(159132), // Rule ID 977 //
     /* 159072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 159075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 159079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 159083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159091 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 159094 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 159098 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 159102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159104 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159111 */     // (fmul:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MUL_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp32m),
     /* 159114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159116 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 159118 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159122 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 159125 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 159130 */     GIR_RootConstrainSelectedInstOperands,
     /* 159131 */     // GIR_Coverage, 977,
     /* 159131 */     GIR_EraseRootFromParent_Done,
     /* 159132 */   // Label 3468: @159132
     /* 159132 */   GIM_Try, /*On fail goto*//*Label 3469*/ GIMT_Encode4(159194), // Rule ID 2201 //
     /* 159137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 159140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 159144 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 159148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159156 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 159159 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 159163 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 159167 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159169 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159176 */     // (fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSrm),
     /* 159179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159181 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 159183 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159187 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 159192 */     GIR_RootConstrainSelectedInstOperands,
     /* 159193 */     // GIR_Coverage, 2201,
     /* 159193 */     GIR_EraseRootFromParent_Done,
     /* 159194 */   // Label 3469: @159194
     /* 159194 */   GIM_Try, /*On fail goto*//*Label 3470*/ GIMT_Encode4(159256), // Rule ID 2209 //
     /* 159199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 159202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 159206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 159210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159218 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 159221 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 159225 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 159229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159231 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159238 */     // (fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSSrm),
     /* 159241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159243 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 159245 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159249 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 159254 */     GIR_RootConstrainSelectedInstOperands,
     /* 159255 */     // GIR_Coverage, 2209,
     /* 159255 */     GIR_EraseRootFromParent_Done,
     /* 159256 */   // Label 3470: @159256
     /* 159256 */   GIM_Try, /*On fail goto*//*Label 3471*/ GIMT_Encode4(159318), // Rule ID 5974 //
     /* 159261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 159264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 159268 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 159272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159280 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 159283 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 159287 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 159291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159293 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159300 */     // (fmul:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSZrm),
     /* 159303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159305 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 159307 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159311 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 159316 */     GIR_RootConstrainSelectedInstOperands,
     /* 159317 */     // GIR_Coverage, 5974,
     /* 159317 */     GIR_EraseRootFromParent_Done,
     /* 159318 */   // Label 3471: @159318
     /* 159318 */   GIM_Try, /*On fail goto*//*Label 3472*/ GIMT_Encode4(159355), // Rule ID 899 //
     /* 159323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 159326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 159330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 159334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 159338 */     // (fmul:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (MUL_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 159338 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MUL_Fp32),
     /* 159343 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 159349 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 159353 */     GIR_RootConstrainSelectedInstOperands,
     /* 159354 */     // GIR_Coverage, 899,
     /* 159354 */     GIR_Done,
     /* 159355 */   // Label 3472: @159355
     /* 159355 */   GIM_Try, /*On fail goto*//*Label 3473*/ GIMT_Encode4(159386), // Rule ID 2199 //
     /* 159360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 159363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 159367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 159371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 159375 */     // (fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VMULSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 159375 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSSrr),
     /* 159380 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 159384 */     GIR_RootConstrainSelectedInstOperands,
     /* 159385 */     // GIR_Coverage, 2199,
     /* 159385 */     GIR_Done,
     /* 159386 */   // Label 3473: @159386
     /* 159386 */   GIM_Try, /*On fail goto*//*Label 3474*/ GIMT_Encode4(159417), // Rule ID 2207 //
     /* 159391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 159394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 159398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 159402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 159406 */     // (fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (MULSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 159406 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULSSrr),
     /* 159411 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 159415 */     GIR_RootConstrainSelectedInstOperands,
     /* 159416 */     // GIR_Coverage, 2207,
     /* 159416 */     GIR_Done,
     /* 159417 */   // Label 3474: @159417
     /* 159417 */   GIM_Try, /*On fail goto*//*Label 3475*/ GIMT_Encode4(159448), // Rule ID 5972 //
     /* 159422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 159425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 159429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 159433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 159437 */     // (fmul:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VMULSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 159437 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSSZrr),
     /* 159442 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 159446 */     GIR_RootConstrainSelectedInstOperands,
     /* 159447 */     // GIR_Coverage, 5972,
     /* 159447 */     GIR_Done,
     /* 159448 */   // Label 3475: @159448
     /* 159448 */   GIM_Reject,
     /* 159449 */ // Label 3453: @159449
     /* 159449 */ GIM_Reject,
     /* 159450 */ // Label 3437: @159450
     /* 159450 */ GIM_Try, /*On fail goto*//*Label 3476*/ GIMT_Encode4(160990),
     /* 159455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 159458 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159461 */   GIM_Try, /*On fail goto*//*Label 3477*/ GIMT_Encode4(159543), // Rule ID 26027 //
     /* 159466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 159469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 159473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 159477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 159481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 159485 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 159489 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159493 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 159496 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 159500 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 159507 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 159511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 159515 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159517 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159524 */     // (fmul:{ *:[f64] } (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>), FR64:{ *:[f64] }:$src1)  =>  (MULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSDrm),
     /* 159527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159529 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 159531 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159535 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 159541 */     GIR_RootConstrainSelectedInstOperands,
     /* 159542 */     // GIR_Coverage, 26027,
     /* 159542 */     GIR_EraseRootFromParent_Done,
     /* 159543 */   // Label 3477: @159543
     /* 159543 */   GIM_Try, /*On fail goto*//*Label 3478*/ GIMT_Encode4(159625), // Rule ID 26028 //
     /* 159548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 159551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 159555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 159559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 159563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 159567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 159571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159575 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 159578 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 159582 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 159589 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 159593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 159597 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159599 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159606 */     // (fmul:{ *:[f64] } (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>), FR64:{ *:[f64] }:$src1)  =>  (VMULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDrm),
     /* 159609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159611 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 159613 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159617 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 159623 */     GIR_RootConstrainSelectedInstOperands,
     /* 159624 */     // GIR_Coverage, 26028,
     /* 159624 */     GIR_EraseRootFromParent_Done,
     /* 159625 */   // Label 3478: @159625
     /* 159625 */   GIM_Try, /*On fail goto*//*Label 3479*/ GIMT_Encode4(159707), // Rule ID 26029 //
     /* 159630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 159633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 159637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 159641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 159645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 159649 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 159653 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159657 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 159660 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 159664 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 159671 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 159675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 159679 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159681 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159688 */     // (fmul:{ *:[f64] } (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>), FR64X:{ *:[f64] }:$src1)  =>  (VMULSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDZrm),
     /* 159691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159693 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 159695 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159699 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 159705 */     GIR_RootConstrainSelectedInstOperands,
     /* 159706 */     // GIR_Coverage, 26029,
     /* 159706 */     GIR_EraseRootFromParent_Done,
     /* 159707 */   // Label 3479: @159707
     /* 159707 */   GIM_Try, /*On fail goto*//*Label 3480*/ GIMT_Encode4(159789), // Rule ID 22482 //
     /* 159712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 159715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 159719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 159723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 159731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 159735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 159739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159743 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 159746 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 159750 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 159757 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 159761 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159763 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159770 */     // (fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (MULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSDrm),
     /* 159773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159775 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 159777 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159781 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 159787 */     GIR_RootConstrainSelectedInstOperands,
     /* 159788 */     // GIR_Coverage, 22482,
     /* 159788 */     GIR_EraseRootFromParent_Done,
     /* 159789 */   // Label 3480: @159789
     /* 159789 */   GIM_Try, /*On fail goto*//*Label 3481*/ GIMT_Encode4(159871), // Rule ID 22483 //
     /* 159794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 159797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 159801 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 159805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 159813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 159817 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 159821 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159825 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 159828 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 159832 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 159839 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 159843 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159845 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159852 */     // (fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (VMULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDrm),
     /* 159855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159857 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 159859 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159863 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 159869 */     GIR_RootConstrainSelectedInstOperands,
     /* 159870 */     // GIR_Coverage, 22483,
     /* 159870 */     GIR_EraseRootFromParent_Done,
     /* 159871 */   // Label 3481: @159871
     /* 159871 */   GIM_Try, /*On fail goto*//*Label 3482*/ GIMT_Encode4(159953), // Rule ID 22484 //
     /* 159876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 159879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 159883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 159887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 159895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 159899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 159903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159907 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 159910 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 159914 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 159921 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 159925 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159927 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159934 */     // (fmul:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (VMULSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDZrm),
     /* 159937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159939 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 159941 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159945 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 159951 */     GIR_RootConstrainSelectedInstOperands,
     /* 159952 */     // GIR_Coverage, 22484,
     /* 159952 */     GIR_EraseRootFromParent_Done,
     /* 159953 */   // Label 3482: @159953
     /* 159953 */   GIM_Try, /*On fail goto*//*Label 3483*/ GIMT_Encode4(160018), // Rule ID 23273 //
     /* 159958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 159961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 159965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 159969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 159973 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 159980 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 159984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 159988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159990 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159997 */     // (fmul:{ *:[f64] } (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP64:{ *:[f64] }:$src1)  =>  (MUL_FpI16m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI16m64),
     /* 160000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160002 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 160004 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160008 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 160011 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160016 */     GIR_RootConstrainSelectedInstOperands,
     /* 160017 */     // GIR_Coverage, 23273,
     /* 160017 */     GIR_EraseRootFromParent_Done,
     /* 160018 */   // Label 3483: @160018
     /* 160018 */   GIM_Try, /*On fail goto*//*Label 3484*/ GIMT_Encode4(160083), // Rule ID 23275 //
     /* 160023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 160026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 160030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 160034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 160038 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 160045 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 160053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160055 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160062 */     // (fmul:{ *:[f64] } (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP64:{ *:[f64] }:$src1)  =>  (MUL_FpI32m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI32m64),
     /* 160065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160067 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 160069 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160073 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 160076 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160081 */     GIR_RootConstrainSelectedInstOperands,
     /* 160082 */     // GIR_Coverage, 23275,
     /* 160082 */     GIR_EraseRootFromParent_Done,
     /* 160083 */   // Label 3484: @160083
     /* 160083 */   GIM_Try, /*On fail goto*//*Label 3485*/ GIMT_Encode4(160148), // Rule ID 23261 //
     /* 160088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 160091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 160095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 160099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160103 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160106 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160110 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 160118 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160120 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160127 */     // (fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP64:{ *:[f64] }:$src1)  =>  (MUL_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64m),
     /* 160130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160132 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 160134 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160138 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 160141 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160146 */     GIR_RootConstrainSelectedInstOperands,
     /* 160147 */     // GIR_Coverage, 23261,
     /* 160147 */     GIR_EraseRootFromParent_Done,
     /* 160148 */   // Label 3485: @160148
     /* 160148 */   GIM_Try, /*On fail goto*//*Label 3486*/ GIMT_Encode4(160220), // Rule ID 23263 //
     /* 160153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 160156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 160160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 160164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160168 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160171 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160175 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 160182 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 160190 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160192 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160199 */     // (fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP64:{ *:[f64] }:$src1)  =>  (MUL_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64m32),
     /* 160202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160204 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 160206 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160210 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 160213 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160218 */     GIR_RootConstrainSelectedInstOperands,
     /* 160219 */     // GIR_Coverage, 23263,
     /* 160219 */     GIR_EraseRootFromParent_Done,
     /* 160220 */   // Label 3486: @160220
     /* 160220 */   GIM_Try, /*On fail goto*//*Label 3487*/ GIMT_Encode4(160282), // Rule ID 23404 //
     /* 160225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 160228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 160232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 160236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160240 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160243 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160247 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 160255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160257 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160264 */     // (fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (VMULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDrm),
     /* 160267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160269 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 160271 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160275 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160280 */     GIR_RootConstrainSelectedInstOperands,
     /* 160281 */     // GIR_Coverage, 23404,
     /* 160281 */     GIR_EraseRootFromParent_Done,
     /* 160282 */   // Label 3487: @160282
     /* 160282 */   GIM_Try, /*On fail goto*//*Label 3488*/ GIMT_Encode4(160344), // Rule ID 23408 //
     /* 160287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 160290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 160294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 160298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160302 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160305 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160309 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 160317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160319 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160326 */     // (fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (MULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSDrm),
     /* 160329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160331 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 160333 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160337 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160342 */     GIR_RootConstrainSelectedInstOperands,
     /* 160343 */     // GIR_Coverage, 23408,
     /* 160343 */     GIR_EraseRootFromParent_Done,
     /* 160344 */   // Label 3488: @160344
     /* 160344 */   GIM_Try, /*On fail goto*//*Label 3489*/ GIMT_Encode4(160406), // Rule ID 24254 //
     /* 160349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 160352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 160356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 160360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160364 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160367 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160371 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 160379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160381 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160388 */     // (fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64X:{ *:[f64] }:$src1)  =>  (VMULSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDZrm),
     /* 160391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160393 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 160395 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160399 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160404 */     GIR_RootConstrainSelectedInstOperands,
     /* 160405 */     // GIR_Coverage, 24254,
     /* 160405 */     GIR_EraseRootFromParent_Done,
     /* 160406 */   // Label 3489: @160406
     /* 160406 */   GIM_Try, /*On fail goto*//*Label 3490*/ GIMT_Encode4(160471), // Rule ID 991 //
     /* 160411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 160414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 160418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 160422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 160430 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 160437 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160443 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160450 */     // (fmul:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (MUL_FpI16m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI16m64),
     /* 160453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160455 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 160457 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160461 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 160464 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160469 */     GIR_RootConstrainSelectedInstOperands,
     /* 160470 */     // GIR_Coverage, 991,
     /* 160470 */     GIR_EraseRootFromParent_Done,
     /* 160471 */   // Label 3490: @160471
     /* 160471 */   GIM_Try, /*On fail goto*//*Label 3491*/ GIMT_Encode4(160536), // Rule ID 993 //
     /* 160476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 160479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 160483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 160487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 160495 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 160502 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160506 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160508 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160515 */     // (fmul:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (MUL_FpI32m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI32m64),
     /* 160518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160520 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 160522 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160526 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 160529 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160534 */     GIR_RootConstrainSelectedInstOperands,
     /* 160535 */     // GIR_Coverage, 993,
     /* 160535 */     GIR_EraseRootFromParent_Done,
     /* 160536 */   // Label 3491: @160536
     /* 160536 */   GIM_Try, /*On fail goto*//*Label 3492*/ GIMT_Encode4(160601), // Rule ID 979 //
     /* 160541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 160544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 160548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 160552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160560 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160563 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160567 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160573 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160580 */     // (fmul:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MUL_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64m),
     /* 160583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160585 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 160587 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160591 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 160594 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160599 */     GIR_RootConstrainSelectedInstOperands,
     /* 160600 */     // GIR_Coverage, 979,
     /* 160600 */     GIR_EraseRootFromParent_Done,
     /* 160601 */   // Label 3492: @160601
     /* 160601 */   GIM_Try, /*On fail goto*//*Label 3493*/ GIMT_Encode4(160673), // Rule ID 981 //
     /* 160606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 160609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 160613 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 160617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160625 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160628 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160632 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 160639 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160645 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160652 */     // (fmul:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (MUL_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64m32),
     /* 160655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160657 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 160659 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160663 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 160666 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160671 */     GIR_RootConstrainSelectedInstOperands,
     /* 160672 */     // GIR_Coverage, 981,
     /* 160672 */     GIR_EraseRootFromParent_Done,
     /* 160673 */   // Label 3493: @160673
     /* 160673 */   GIM_Try, /*On fail goto*//*Label 3494*/ GIMT_Encode4(160735), // Rule ID 2205 //
     /* 160678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 160681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 160685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 160689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160697 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160700 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160704 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160708 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160710 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160717 */     // (fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDrm),
     /* 160720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160722 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 160724 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160728 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160733 */     GIR_RootConstrainSelectedInstOperands,
     /* 160734 */     // GIR_Coverage, 2205,
     /* 160734 */     GIR_EraseRootFromParent_Done,
     /* 160735 */   // Label 3494: @160735
     /* 160735 */   GIM_Try, /*On fail goto*//*Label 3495*/ GIMT_Encode4(160797), // Rule ID 2213 //
     /* 160740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 160743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 160747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 160751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160759 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160762 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160766 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160770 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160772 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160779 */     // (fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSDrm),
     /* 160782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160784 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 160786 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160790 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160795 */     GIR_RootConstrainSelectedInstOperands,
     /* 160796 */     // GIR_Coverage, 2213,
     /* 160796 */     GIR_EraseRootFromParent_Done,
     /* 160797 */   // Label 3495: @160797
     /* 160797 */   GIM_Try, /*On fail goto*//*Label 3496*/ GIMT_Encode4(160859), // Rule ID 5993 //
     /* 160802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 160805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 160809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 160813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160821 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160824 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160828 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160832 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160834 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160841 */     // (fmul:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDZrm),
     /* 160844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160846 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 160848 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160852 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160857 */     GIR_RootConstrainSelectedInstOperands,
     /* 160858 */     // GIR_Coverage, 5993,
     /* 160858 */     GIR_EraseRootFromParent_Done,
     /* 160859 */   // Label 3496: @160859
     /* 160859 */   GIM_Try, /*On fail goto*//*Label 3497*/ GIMT_Encode4(160896), // Rule ID 901 //
     /* 160864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 160867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 160871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 160875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 160879 */     // (fmul:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (MUL_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 160879 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64),
     /* 160884 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 160890 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 160894 */     GIR_RootConstrainSelectedInstOperands,
     /* 160895 */     // GIR_Coverage, 901,
     /* 160895 */     GIR_Done,
     /* 160896 */   // Label 3497: @160896
     /* 160896 */   GIM_Try, /*On fail goto*//*Label 3498*/ GIMT_Encode4(160927), // Rule ID 2203 //
     /* 160901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 160904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 160908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 160912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 160916 */     // (fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VMULSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 160916 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSDrr),
     /* 160921 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 160925 */     GIR_RootConstrainSelectedInstOperands,
     /* 160926 */     // GIR_Coverage, 2203,
     /* 160926 */     GIR_Done,
     /* 160927 */   // Label 3498: @160927
     /* 160927 */   GIM_Try, /*On fail goto*//*Label 3499*/ GIMT_Encode4(160958), // Rule ID 2211 //
     /* 160932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 160935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 160939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 160943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 160947 */     // (fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (MULSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 160947 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULSDrr),
     /* 160952 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 160956 */     GIR_RootConstrainSelectedInstOperands,
     /* 160957 */     // GIR_Coverage, 2211,
     /* 160957 */     GIR_Done,
     /* 160958 */   // Label 3499: @160958
     /* 160958 */   GIM_Try, /*On fail goto*//*Label 3500*/ GIMT_Encode4(160989), // Rule ID 5991 //
     /* 160963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 160966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 160970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 160974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 160978 */     // (fmul:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VMULSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 160978 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSDZrr),
     /* 160983 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 160987 */     GIR_RootConstrainSelectedInstOperands,
     /* 160988 */     // GIR_Coverage, 5991,
     /* 160988 */     GIR_Done,
     /* 160989 */   // Label 3500: @160989
     /* 160989 */   GIM_Reject,
     /* 160990 */ // Label 3476: @160990
     /* 160990 */ GIM_Reject,
     /* 160991 */ // Label 3438: @160991
     /* 160991 */ GIM_Try, /*On fail goto*//*Label 3501*/ GIMT_Encode4(161556),
     /* 160996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 160999 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 161002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 161006 */   GIM_Try, /*On fail goto*//*Label 3502*/ GIMT_Encode4(161067), // Rule ID 23277 //
     /* 161011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 161014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 161018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 161022 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 161029 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 161037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161039 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161046 */     // (fmul:{ *:[f80] } (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP80:{ *:[f80] }:$src1)  =>  (MUL_FpI16m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 161046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI16m80),
     /* 161049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161051 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 161053 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 161057 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 161060 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161065 */     GIR_RootConstrainSelectedInstOperands,
     /* 161066 */     // GIR_Coverage, 23277,
     /* 161066 */     GIR_EraseRootFromParent_Done,
     /* 161067 */   // Label 3502: @161067
     /* 161067 */   GIM_Try, /*On fail goto*//*Label 3503*/ GIMT_Encode4(161128), // Rule ID 23279 //
     /* 161072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 161075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 161079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 161083 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 161090 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 161098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161100 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161107 */     // (fmul:{ *:[f80] } (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP80:{ *:[f80] }:$src1)  =>  (MUL_FpI32m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 161107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI32m80),
     /* 161110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161112 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 161114 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 161118 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 161121 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161126 */     GIR_RootConstrainSelectedInstOperands,
     /* 161127 */     // GIR_Coverage, 23279,
     /* 161127 */     GIR_EraseRootFromParent_Done,
     /* 161128 */   // Label 3503: @161128
     /* 161128 */   GIM_Try, /*On fail goto*//*Label 3504*/ GIMT_Encode4(161196), // Rule ID 23265 //
     /* 161133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 161136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 161140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161144 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161147 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161151 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 161158 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 161166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161168 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161175 */     // (fmul:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP80:{ *:[f80] }:$src1)  =>  (MUL_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 161175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80m32),
     /* 161178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161180 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 161182 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 161186 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 161189 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161194 */     GIR_RootConstrainSelectedInstOperands,
     /* 161195 */     // GIR_Coverage, 23265,
     /* 161195 */     GIR_EraseRootFromParent_Done,
     /* 161196 */   // Label 3504: @161196
     /* 161196 */   GIM_Try, /*On fail goto*//*Label 3505*/ GIMT_Encode4(161264), // Rule ID 23267 //
     /* 161201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 161204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 161208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161212 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161215 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161219 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 161226 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 161234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161236 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161243 */     // (fmul:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>, RFP80:{ *:[f80] }:$src1)  =>  (MUL_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 161243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80m64),
     /* 161246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161248 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 161250 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 161254 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 161257 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161262 */     GIR_RootConstrainSelectedInstOperands,
     /* 161263 */     // GIR_Coverage, 23267,
     /* 161263 */     GIR_EraseRootFromParent_Done,
     /* 161264 */   // Label 3505: @161264
     /* 161264 */   GIM_Try, /*On fail goto*//*Label 3506*/ GIMT_Encode4(161325), // Rule ID 995 //
     /* 161269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 161272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 161276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 161280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 161284 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 161291 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161297 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161304 */     // (fmul:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (MUL_FpI16m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 161304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI16m80),
     /* 161307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161309 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 161311 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 161315 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 161318 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161323 */     GIR_RootConstrainSelectedInstOperands,
     /* 161324 */     // GIR_Coverage, 995,
     /* 161324 */     GIR_EraseRootFromParent_Done,
     /* 161325 */   // Label 3506: @161325
     /* 161325 */   GIM_Try, /*On fail goto*//*Label 3507*/ GIMT_Encode4(161386), // Rule ID 997 //
     /* 161330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 161333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 161337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 161341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 161345 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 161352 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161356 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161358 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161365 */     // (fmul:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (MUL_FpI32m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 161365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI32m80),
     /* 161368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161370 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 161372 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 161376 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 161379 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161384 */     GIR_RootConstrainSelectedInstOperands,
     /* 161385 */     // GIR_Coverage, 997,
     /* 161385 */     GIR_EraseRootFromParent_Done,
     /* 161386 */   // Label 3507: @161386
     /* 161386 */   GIM_Try, /*On fail goto*//*Label 3508*/ GIMT_Encode4(161454), // Rule ID 983 //
     /* 161391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 161394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 161398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 161402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161406 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161409 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161413 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 161420 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161426 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161433 */     // (fmul:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (MUL_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 161433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80m32),
     /* 161436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161438 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 161440 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 161444 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 161447 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161452 */     GIR_RootConstrainSelectedInstOperands,
     /* 161453 */     // GIR_Coverage, 983,
     /* 161453 */     GIR_EraseRootFromParent_Done,
     /* 161454 */   // Label 3508: @161454
     /* 161454 */   GIM_Try, /*On fail goto*//*Label 3509*/ GIMT_Encode4(161522), // Rule ID 985 //
     /* 161459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 161462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 161466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 161470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161474 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161477 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161481 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 161488 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161494 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161501 */     // (fmul:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>)  =>  (MUL_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 161501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80m64),
     /* 161504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161506 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 161508 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 161512 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 161515 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161520 */     GIR_RootConstrainSelectedInstOperands,
     /* 161521 */     // GIR_Coverage, 985,
     /* 161521 */     GIR_EraseRootFromParent_Done,
     /* 161522 */   // Label 3509: @161522
     /* 161522 */   GIM_Try, /*On fail goto*//*Label 3510*/ GIMT_Encode4(161555), // Rule ID 903 //
     /* 161527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 161530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 161534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 161538 */     // (fmul:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (MUL_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 161538 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80),
     /* 161543 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 161549 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 161553 */     GIR_RootConstrainSelectedInstOperands,
     /* 161554 */     // GIR_Coverage, 903,
     /* 161554 */     GIR_Done,
     /* 161555 */   // Label 3510: @161555
     /* 161555 */   GIM_Reject,
     /* 161556 */ // Label 3501: @161556
     /* 161556 */ GIM_Reject,
     /* 161557 */ // Label 3439: @161557
     /* 161557 */ GIM_Try, /*On fail goto*//*Label 3511*/ GIMT_Encode4(161910),
     /* 161562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 161565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 161568 */   GIM_Try, /*On fail goto*//*Label 3512*/ GIMT_Encode4(161630), // Rule ID 23392 //
     /* 161573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 161576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 161580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 161584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161588 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161591 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161595 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 161603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161605 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161612 */     // (fmul:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1)  =>  (VMULPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 161612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDrm),
     /* 161615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161617 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 161619 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 161623 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161628 */     GIR_RootConstrainSelectedInstOperands,
     /* 161629 */     // GIR_Coverage, 23392,
     /* 161629 */     GIR_EraseRootFromParent_Done,
     /* 161630 */   // Label 3512: @161630
     /* 161630 */   GIM_Try, /*On fail goto*//*Label 3513*/ GIMT_Encode4(161692), // Rule ID 24368 //
     /* 161635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 161638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 161642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 161646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161650 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161653 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161657 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 161665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161667 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161674 */     // (fmul:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2f64] }:$src1)  =>  (VMULPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 161674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZ128rm),
     /* 161677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161679 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 161681 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 161685 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161690 */     GIR_RootConstrainSelectedInstOperands,
     /* 161691 */     // GIR_Coverage, 24368,
     /* 161691 */     GIR_EraseRootFromParent_Done,
     /* 161692 */   // Label 3513: @161692
     /* 161692 */   GIM_Try, /*On fail goto*//*Label 3514*/ GIMT_Encode4(161754), // Rule ID 2181 //
     /* 161697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 161700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 161704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 161708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 161712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161716 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161719 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161723 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161729 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161736 */     // (fmul:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 161736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDrm),
     /* 161739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161741 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 161743 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 161747 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161752 */     GIR_RootConstrainSelectedInstOperands,
     /* 161753 */     // GIR_Coverage, 2181,
     /* 161753 */     GIR_EraseRootFromParent_Done,
     /* 161754 */   // Label 3514: @161754
     /* 161754 */   GIM_Try, /*On fail goto*//*Label 3515*/ GIMT_Encode4(161816), // Rule ID 6426 //
     /* 161759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 161762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 161766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 161770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 161774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161778 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161781 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161785 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161791 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161798 */     // (fmul:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 161798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZ128rm),
     /* 161801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161803 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 161805 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 161809 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161814 */     GIR_RootConstrainSelectedInstOperands,
     /* 161815 */     // GIR_Coverage, 6426,
     /* 161815 */     GIR_EraseRootFromParent_Done,
     /* 161816 */   // Label 3515: @161816
     /* 161816 */   GIM_Try, /*On fail goto*//*Label 3516*/ GIMT_Encode4(161847), // Rule ID 2179 //
     /* 161821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 161824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 161828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 161832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 161836 */     // (fmul:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VMULPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 161836 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDrr),
     /* 161841 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 161845 */     GIR_RootConstrainSelectedInstOperands,
     /* 161846 */     // GIR_Coverage, 2179,
     /* 161846 */     GIR_Done,
     /* 161847 */   // Label 3516: @161847
     /* 161847 */   GIM_Try, /*On fail goto*//*Label 3517*/ GIMT_Encode4(161878), // Rule ID 2195 //
     /* 161852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 161855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 161859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 161863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 161867 */     // (fmul:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (MULPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 161867 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULPDrr),
     /* 161872 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 161876 */     GIR_RootConstrainSelectedInstOperands,
     /* 161877 */     // GIR_Coverage, 2195,
     /* 161877 */     GIR_Done,
     /* 161878 */   // Label 3517: @161878
     /* 161878 */   GIM_Try, /*On fail goto*//*Label 3518*/ GIMT_Encode4(161909), // Rule ID 6422 //
     /* 161883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 161886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 161890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 161894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 161898 */     // (fmul:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VMULPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 161898 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDZ128rr),
     /* 161903 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 161907 */     GIR_RootConstrainSelectedInstOperands,
     /* 161908 */     // GIR_Coverage, 6422,
     /* 161908 */     GIR_Done,
     /* 161909 */   // Label 3518: @161909
     /* 161909 */   GIM_Reject,
     /* 161910 */ // Label 3511: @161910
     /* 161910 */ GIM_Reject,
     /* 161911 */ // Label 3440: @161911
     /* 161911 */ GIM_Try, /*On fail goto*//*Label 3519*/ GIMT_Encode4(162264),
     /* 161916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161919 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 161922 */   GIM_Try, /*On fail goto*//*Label 3520*/ GIMT_Encode4(161984), // Rule ID 23390 //
     /* 161927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 161930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 161934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 161938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161942 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161945 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161949 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 161957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161959 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161966 */     // (fmul:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1)  =>  (VMULPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 161966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSrm),
     /* 161969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161971 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 161973 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 161977 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161982 */     GIR_RootConstrainSelectedInstOperands,
     /* 161983 */     // GIR_Coverage, 23390,
     /* 161983 */     GIR_EraseRootFromParent_Done,
     /* 161984 */   // Label 3520: @161984
     /* 161984 */   GIM_Try, /*On fail goto*//*Label 3521*/ GIMT_Encode4(162046), // Rule ID 24352 //
     /* 161989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 161992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 161996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 162000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162004 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162007 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162011 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 162019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162021 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162028 */     // (fmul:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4f32] }:$src1)  =>  (VMULPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 162028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZ128rm),
     /* 162031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162033 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 162035 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 162039 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162044 */     GIR_RootConstrainSelectedInstOperands,
     /* 162045 */     // GIR_Coverage, 24352,
     /* 162045 */     GIR_EraseRootFromParent_Done,
     /* 162046 */   // Label 3521: @162046
     /* 162046 */   GIM_Try, /*On fail goto*//*Label 3522*/ GIMT_Encode4(162108), // Rule ID 2177 //
     /* 162051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 162054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 162058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 162062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 162066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162070 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162073 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162077 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162083 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162090 */     // (fmul:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 162090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSrm),
     /* 162093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162095 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 162097 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 162101 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162106 */     GIR_RootConstrainSelectedInstOperands,
     /* 162107 */     // GIR_Coverage, 2177,
     /* 162107 */     GIR_EraseRootFromParent_Done,
     /* 162108 */   // Label 3522: @162108
     /* 162108 */   GIM_Try, /*On fail goto*//*Label 3523*/ GIMT_Encode4(162170), // Rule ID 6402 //
     /* 162113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 162116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 162120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 162124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 162128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162132 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162135 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162139 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162145 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162152 */     // (fmul:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 162152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZ128rm),
     /* 162155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162157 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 162159 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 162163 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162168 */     GIR_RootConstrainSelectedInstOperands,
     /* 162169 */     // GIR_Coverage, 6402,
     /* 162169 */     GIR_EraseRootFromParent_Done,
     /* 162170 */   // Label 3523: @162170
     /* 162170 */   GIM_Try, /*On fail goto*//*Label 3524*/ GIMT_Encode4(162201), // Rule ID 2175 //
     /* 162175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 162178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 162182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 162186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 162190 */     // (fmul:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VMULPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 162190 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSrr),
     /* 162195 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 162199 */     GIR_RootConstrainSelectedInstOperands,
     /* 162200 */     // GIR_Coverage, 2175,
     /* 162200 */     GIR_Done,
     /* 162201 */   // Label 3524: @162201
     /* 162201 */   GIM_Try, /*On fail goto*//*Label 3525*/ GIMT_Encode4(162232), // Rule ID 2191 //
     /* 162206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 162209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 162213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 162217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 162221 */     // (fmul:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (MULPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 162221 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULPSrr),
     /* 162226 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 162230 */     GIR_RootConstrainSelectedInstOperands,
     /* 162231 */     // GIR_Coverage, 2191,
     /* 162231 */     GIR_Done,
     /* 162232 */   // Label 3525: @162232
     /* 162232 */   GIM_Try, /*On fail goto*//*Label 3526*/ GIMT_Encode4(162263), // Rule ID 6398 //
     /* 162237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 162240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 162244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 162248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 162252 */     // (fmul:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VMULPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 162252 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSZ128rr),
     /* 162257 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 162261 */     GIR_RootConstrainSelectedInstOperands,
     /* 162262 */     // GIR_Coverage, 6398,
     /* 162262 */     GIR_Done,
     /* 162263 */   // Label 3526: @162263
     /* 162263 */   GIM_Reject,
     /* 162264 */ // Label 3519: @162264
     /* 162264 */ GIM_Reject,
     /* 162265 */ // Label 3441: @162265
     /* 162265 */ GIM_Try, /*On fail goto*//*Label 3527*/ GIMT_Encode4(162587),
     /* 162270 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 162273 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 162276 */   GIM_Try, /*On fail goto*//*Label 3528*/ GIMT_Encode4(162338), // Rule ID 23396 //
     /* 162281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 162284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 162288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 162292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162296 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162299 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162303 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 162311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162313 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162320 */     // (fmul:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1)  =>  (VMULPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 162320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDYrm),
     /* 162323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162325 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 162327 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 162331 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162336 */     GIR_RootConstrainSelectedInstOperands,
     /* 162337 */     // GIR_Coverage, 23396,
     /* 162337 */     GIR_EraseRootFromParent_Done,
     /* 162338 */   // Label 3528: @162338
     /* 162338 */   GIM_Try, /*On fail goto*//*Label 3529*/ GIMT_Encode4(162400), // Rule ID 24376 //
     /* 162343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 162346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 162350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 162354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162358 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162361 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162365 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 162373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162375 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162382 */     // (fmul:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4f64] }:$src1)  =>  (VMULPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 162382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZ256rm),
     /* 162385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162387 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 162389 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 162393 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162398 */     GIR_RootConstrainSelectedInstOperands,
     /* 162399 */     // GIR_Coverage, 24376,
     /* 162399 */     GIR_EraseRootFromParent_Done,
     /* 162400 */   // Label 3529: @162400
     /* 162400 */   GIM_Try, /*On fail goto*//*Label 3530*/ GIMT_Encode4(162462), // Rule ID 2189 //
     /* 162405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 162408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 162412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 162416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 162420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162424 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162427 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162431 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162437 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162444 */     // (fmul:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 162444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDYrm),
     /* 162447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162449 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 162451 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 162455 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162460 */     GIR_RootConstrainSelectedInstOperands,
     /* 162461 */     // GIR_Coverage, 2189,
     /* 162461 */     GIR_EraseRootFromParent_Done,
     /* 162462 */   // Label 3530: @162462
     /* 162462 */   GIM_Try, /*On fail goto*//*Label 3531*/ GIMT_Encode4(162524), // Rule ID 6438 //
     /* 162467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 162470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 162474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 162478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 162482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162486 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162489 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162493 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162499 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162506 */     // (fmul:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 162506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZ256rm),
     /* 162509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162511 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 162513 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 162517 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162522 */     GIR_RootConstrainSelectedInstOperands,
     /* 162523 */     // GIR_Coverage, 6438,
     /* 162523 */     GIR_EraseRootFromParent_Done,
     /* 162524 */   // Label 3531: @162524
     /* 162524 */   GIM_Try, /*On fail goto*//*Label 3532*/ GIMT_Encode4(162555), // Rule ID 2187 //
     /* 162529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 162532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 162536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 162540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 162544 */     // (fmul:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VMULPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 162544 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDYrr),
     /* 162549 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 162553 */     GIR_RootConstrainSelectedInstOperands,
     /* 162554 */     // GIR_Coverage, 2187,
     /* 162554 */     GIR_Done,
     /* 162555 */   // Label 3532: @162555
     /* 162555 */   GIM_Try, /*On fail goto*//*Label 3533*/ GIMT_Encode4(162586), // Rule ID 6434 //
     /* 162560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 162563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 162567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 162571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 162575 */     // (fmul:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VMULPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 162575 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDZ256rr),
     /* 162580 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 162584 */     GIR_RootConstrainSelectedInstOperands,
     /* 162585 */     // GIR_Coverage, 6434,
     /* 162585 */     GIR_Done,
     /* 162586 */   // Label 3533: @162586
     /* 162586 */   GIM_Reject,
     /* 162587 */ // Label 3527: @162587
     /* 162587 */ GIM_Reject,
     /* 162588 */ // Label 3442: @162588
     /* 162588 */ GIM_Try, /*On fail goto*//*Label 3534*/ GIMT_Encode4(162747),
     /* 162593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 162596 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 162603 */   GIM_Try, /*On fail goto*//*Label 3535*/ GIMT_Encode4(162661), // Rule ID 24392 //
     /* 162608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 162611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 162615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162619 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162622 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162626 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 162634 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162636 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162643 */     // (fmul:{ *:[v8f16] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8f16] }:$src1)  =>  (VMULPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 162643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZ128rm),
     /* 162646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162648 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 162650 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 162654 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162659 */     GIR_RootConstrainSelectedInstOperands,
     /* 162660 */     // GIR_Coverage, 24392,
     /* 162660 */     GIR_EraseRootFromParent_Done,
     /* 162661 */   // Label 3535: @162661
     /* 162661 */   GIM_Try, /*On fail goto*//*Label 3536*/ GIMT_Encode4(162719), // Rule ID 6462 //
     /* 162666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 162669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 162673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 162677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162681 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162684 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162688 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162694 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162701 */     // (fmul:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 162701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZ128rm),
     /* 162704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162706 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 162708 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 162712 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162717 */     GIR_RootConstrainSelectedInstOperands,
     /* 162718 */     // GIR_Coverage, 6462,
     /* 162718 */     GIR_EraseRootFromParent_Done,
     /* 162719 */   // Label 3536: @162719
     /* 162719 */   GIM_Try, /*On fail goto*//*Label 3537*/ GIMT_Encode4(162746), // Rule ID 6458 //
     /* 162724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 162727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 162731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 162735 */     // (fmul:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VMULPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 162735 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPHZ128rr),
     /* 162740 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 162744 */     GIR_RootConstrainSelectedInstOperands,
     /* 162745 */     // GIR_Coverage, 6458,
     /* 162745 */     GIR_Done,
     /* 162746 */   // Label 3537: @162746
     /* 162746 */   GIM_Reject,
     /* 162747 */ // Label 3534: @162747
     /* 162747 */ GIM_Reject,
     /* 162748 */ // Label 3443: @162748
     /* 162748 */ GIM_Try, /*On fail goto*//*Label 3538*/ GIMT_Encode4(163070),
     /* 162753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 162756 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 162759 */   GIM_Try, /*On fail goto*//*Label 3539*/ GIMT_Encode4(162821), // Rule ID 23394 //
     /* 162764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 162767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 162771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 162775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162779 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162782 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162786 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 162794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162796 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162803 */     // (fmul:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1)  =>  (VMULPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 162803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSYrm),
     /* 162806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162808 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 162810 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 162814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162819 */     GIR_RootConstrainSelectedInstOperands,
     /* 162820 */     // GIR_Coverage, 23394,
     /* 162820 */     GIR_EraseRootFromParent_Done,
     /* 162821 */   // Label 3539: @162821
     /* 162821 */   GIM_Try, /*On fail goto*//*Label 3540*/ GIMT_Encode4(162883), // Rule ID 24360 //
     /* 162826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 162829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 162833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 162837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162841 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162844 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162848 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 162856 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162858 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162865 */     // (fmul:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8f32] }:$src1)  =>  (VMULPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 162865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZ256rm),
     /* 162868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162870 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 162872 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 162876 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162881 */     GIR_RootConstrainSelectedInstOperands,
     /* 162882 */     // GIR_Coverage, 24360,
     /* 162882 */     GIR_EraseRootFromParent_Done,
     /* 162883 */   // Label 3540: @162883
     /* 162883 */   GIM_Try, /*On fail goto*//*Label 3541*/ GIMT_Encode4(162945), // Rule ID 2185 //
     /* 162888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 162891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 162895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 162899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 162903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162907 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162910 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162914 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162920 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162927 */     // (fmul:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 162927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSYrm),
     /* 162930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162932 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 162934 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 162938 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162943 */     GIR_RootConstrainSelectedInstOperands,
     /* 162944 */     // GIR_Coverage, 2185,
     /* 162944 */     GIR_EraseRootFromParent_Done,
     /* 162945 */   // Label 3541: @162945
     /* 162945 */   GIM_Try, /*On fail goto*//*Label 3542*/ GIMT_Encode4(163007), // Rule ID 6414 //
     /* 162950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 162953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 162957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 162961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 162965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162969 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162972 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162976 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162980 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162982 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162989 */     // (fmul:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 162989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZ256rm),
     /* 162992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162994 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 162996 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 163000 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163005 */     GIR_RootConstrainSelectedInstOperands,
     /* 163006 */     // GIR_Coverage, 6414,
     /* 163006 */     GIR_EraseRootFromParent_Done,
     /* 163007 */   // Label 3542: @163007
     /* 163007 */   GIM_Try, /*On fail goto*//*Label 3543*/ GIMT_Encode4(163038), // Rule ID 2183 //
     /* 163012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 163015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 163019 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 163023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 163027 */     // (fmul:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VMULPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 163027 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSYrr),
     /* 163032 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 163036 */     GIR_RootConstrainSelectedInstOperands,
     /* 163037 */     // GIR_Coverage, 2183,
     /* 163037 */     GIR_Done,
     /* 163038 */   // Label 3543: @163038
     /* 163038 */   GIM_Try, /*On fail goto*//*Label 3544*/ GIMT_Encode4(163069), // Rule ID 6410 //
     /* 163043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 163046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 163050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 163054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 163058 */     // (fmul:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VMULPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 163058 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSZ256rr),
     /* 163063 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 163067 */     GIR_RootConstrainSelectedInstOperands,
     /* 163068 */     // GIR_Coverage, 6410,
     /* 163068 */     GIR_Done,
     /* 163069 */   // Label 3544: @163069
     /* 163069 */   GIM_Reject,
     /* 163070 */ // Label 3538: @163070
     /* 163070 */ GIM_Reject,
     /* 163071 */ // Label 3444: @163071
     /* 163071 */ GIM_Try, /*On fail goto*//*Label 3545*/ GIMT_Encode4(163230),
     /* 163076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 163079 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 163082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 163086 */   GIM_Try, /*On fail goto*//*Label 3546*/ GIMT_Encode4(163144), // Rule ID 24344 //
     /* 163091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 163094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 163098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163102 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163105 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163109 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 163117 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163119 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163126 */     // (fmul:{ *:[v8f64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8f64] }:$src1)  =>  (VMULPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 163126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZrm),
     /* 163129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163131 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 163133 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 163137 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163142 */     GIR_RootConstrainSelectedInstOperands,
     /* 163143 */     // GIR_Coverage, 24344,
     /* 163143 */     GIR_EraseRootFromParent_Done,
     /* 163144 */   // Label 3546: @163144
     /* 163144 */   GIM_Try, /*On fail goto*//*Label 3547*/ GIMT_Encode4(163202), // Rule ID 6390 //
     /* 163149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 163152 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 163156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 163160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163164 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163167 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163171 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163177 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163184 */     // (fmul:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 163184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZrm),
     /* 163187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163189 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 163191 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 163195 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163200 */     GIR_RootConstrainSelectedInstOperands,
     /* 163201 */     // GIR_Coverage, 6390,
     /* 163201 */     GIR_EraseRootFromParent_Done,
     /* 163202 */   // Label 3547: @163202
     /* 163202 */   GIM_Try, /*On fail goto*//*Label 3548*/ GIMT_Encode4(163229), // Rule ID 6386 //
     /* 163207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 163210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 163214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 163218 */     // (fmul:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VMULPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 163218 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDZrr),
     /* 163223 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 163227 */     GIR_RootConstrainSelectedInstOperands,
     /* 163228 */     // GIR_Coverage, 6386,
     /* 163228 */     GIR_Done,
     /* 163229 */   // Label 3548: @163229
     /* 163229 */   GIM_Reject,
     /* 163230 */ // Label 3545: @163230
     /* 163230 */ GIM_Reject,
     /* 163231 */ // Label 3445: @163231
     /* 163231 */ GIM_Try, /*On fail goto*//*Label 3549*/ GIMT_Encode4(163390),
     /* 163236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 163239 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 163242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 163246 */   GIM_Try, /*On fail goto*//*Label 3550*/ GIMT_Encode4(163304), // Rule ID 24400 //
     /* 163251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 163254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 163258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163262 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163265 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163269 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 163277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163279 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163286 */     // (fmul:{ *:[v16f16] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16f16] }:$src1)  =>  (VMULPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 163286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZ256rm),
     /* 163289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163291 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 163293 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 163297 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163302 */     GIR_RootConstrainSelectedInstOperands,
     /* 163303 */     // GIR_Coverage, 24400,
     /* 163303 */     GIR_EraseRootFromParent_Done,
     /* 163304 */   // Label 3550: @163304
     /* 163304 */   GIM_Try, /*On fail goto*//*Label 3551*/ GIMT_Encode4(163362), // Rule ID 6474 //
     /* 163309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 163312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 163316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 163320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163324 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163327 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163331 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163337 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163344 */     // (fmul:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 163344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZ256rm),
     /* 163347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163349 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 163351 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 163355 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163360 */     GIR_RootConstrainSelectedInstOperands,
     /* 163361 */     // GIR_Coverage, 6474,
     /* 163361 */     GIR_EraseRootFromParent_Done,
     /* 163362 */   // Label 3551: @163362
     /* 163362 */   GIM_Try, /*On fail goto*//*Label 3552*/ GIMT_Encode4(163389), // Rule ID 6470 //
     /* 163367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 163370 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 163374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 163378 */     // (fmul:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VMULPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 163378 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPHZ256rr),
     /* 163383 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 163387 */     GIR_RootConstrainSelectedInstOperands,
     /* 163388 */     // GIR_Coverage, 6470,
     /* 163388 */     GIR_Done,
     /* 163389 */   // Label 3552: @163389
     /* 163389 */   GIM_Reject,
     /* 163390 */ // Label 3549: @163390
     /* 163390 */ GIM_Reject,
     /* 163391 */ // Label 3446: @163391
     /* 163391 */ GIM_Try, /*On fail goto*//*Label 3553*/ GIMT_Encode4(163550),
     /* 163396 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 163399 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 163402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 163406 */   GIM_Try, /*On fail goto*//*Label 3554*/ GIMT_Encode4(163464), // Rule ID 24336 //
     /* 163411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 163414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 163418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163422 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163425 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163429 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 163437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163439 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163446 */     // (fmul:{ *:[v16f32] } (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16f32] }:$src1)  =>  (VMULPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 163446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZrm),
     /* 163449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163451 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 163453 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 163457 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163462 */     GIR_RootConstrainSelectedInstOperands,
     /* 163463 */     // GIR_Coverage, 24336,
     /* 163463 */     GIR_EraseRootFromParent_Done,
     /* 163464 */   // Label 3554: @163464
     /* 163464 */   GIM_Try, /*On fail goto*//*Label 3555*/ GIMT_Encode4(163522), // Rule ID 6378 //
     /* 163469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 163472 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 163476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 163480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163484 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163487 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163491 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163497 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163504 */     // (fmul:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 163504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZrm),
     /* 163507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163509 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 163511 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 163515 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163520 */     GIR_RootConstrainSelectedInstOperands,
     /* 163521 */     // GIR_Coverage, 6378,
     /* 163521 */     GIR_EraseRootFromParent_Done,
     /* 163522 */   // Label 3555: @163522
     /* 163522 */   GIM_Try, /*On fail goto*//*Label 3556*/ GIMT_Encode4(163549), // Rule ID 6374 //
     /* 163527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 163530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 163534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 163538 */     // (fmul:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VMULPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 163538 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSZrr),
     /* 163543 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 163547 */     GIR_RootConstrainSelectedInstOperands,
     /* 163548 */     // GIR_Coverage, 6374,
     /* 163548 */     GIR_Done,
     /* 163549 */   // Label 3556: @163549
     /* 163549 */   GIM_Reject,
     /* 163550 */ // Label 3553: @163550
     /* 163550 */ GIM_Reject,
     /* 163551 */ // Label 3447: @163551
     /* 163551 */ GIM_Try, /*On fail goto*//*Label 3557*/ GIMT_Encode4(163710),
     /* 163556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 163559 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 163562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 163566 */   GIM_Try, /*On fail goto*//*Label 3558*/ GIMT_Encode4(163624), // Rule ID 24384 //
     /* 163571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 163574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 163578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163582 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163585 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163589 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 163597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163599 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163606 */     // (fmul:{ *:[v32f16] } (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32f16] }:$src1)  =>  (VMULPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 163606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZrm),
     /* 163609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163611 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 163613 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 163617 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163622 */     GIR_RootConstrainSelectedInstOperands,
     /* 163623 */     // GIR_Coverage, 24384,
     /* 163623 */     GIR_EraseRootFromParent_Done,
     /* 163624 */   // Label 3558: @163624
     /* 163624 */   GIM_Try, /*On fail goto*//*Label 3559*/ GIMT_Encode4(163682), // Rule ID 6450 //
     /* 163629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 163632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 163636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 163640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163644 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163647 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163651 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163657 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163664 */     // (fmul:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 163664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZrm),
     /* 163667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163669 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 163671 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 163675 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163680 */     GIR_RootConstrainSelectedInstOperands,
     /* 163681 */     // GIR_Coverage, 6450,
     /* 163681 */     GIR_EraseRootFromParent_Done,
     /* 163682 */   // Label 3559: @163682
     /* 163682 */   GIM_Try, /*On fail goto*//*Label 3560*/ GIMT_Encode4(163709), // Rule ID 6446 //
     /* 163687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 163690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 163694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 163698 */     // (fmul:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VMULPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 163698 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPHZrr),
     /* 163703 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 163707 */     GIR_RootConstrainSelectedInstOperands,
     /* 163708 */     // GIR_Coverage, 6446,
     /* 163708 */     GIR_Done,
     /* 163709 */   // Label 3560: @163709
     /* 163709 */   GIM_Reject,
     /* 163710 */ // Label 3557: @163710
     /* 163710 */ GIM_Reject,
     /* 163711 */ // Label 3448: @163711
     /* 163711 */ GIM_Reject,
     /* 163712 */ // Label 44: @163712
     /* 163712 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 3573*/ GIMT_Encode4(169699),
     /* 163723 */ /*GILLT_s16*//*Label 3561*/ GIMT_Encode4(163807),
     /* 163727 */ /*GILLT_s32*//*Label 3562*/ GIMT_Encode4(164052),
     /* 163731 */ /*GILLT_s64*//*Label 3563*/ GIMT_Encode4(164789), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 163747 */ /*GILLT_v2s64*//*Label 3564*/ GIMT_Encode4(165526), GIMT_Encode4(0),
     /* 163755 */ /*GILLT_v4s32*//*Label 3565*/ GIMT_Encode4(166263),
     /* 163759 */ /*GILLT_v4s64*//*Label 3566*/ GIMT_Encode4(167000), GIMT_Encode4(0),
     /* 163767 */ /*GILLT_v8s16*//*Label 3567*/ GIMT_Encode4(167737),
     /* 163771 */ /*GILLT_v8s32*//*Label 3568*/ GIMT_Encode4(167982),
     /* 163775 */ /*GILLT_v8s64*//*Label 3569*/ GIMT_Encode4(168719), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 163787 */ /*GILLT_v16s16*//*Label 3570*/ GIMT_Encode4(168964),
     /* 163791 */ /*GILLT_v16s32*//*Label 3571*/ GIMT_Encode4(169209), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 163803 */ /*GILLT_v32s16*//*Label 3572*/ GIMT_Encode4(169454),
     /* 163807 */ // Label 3561: @163807
     /* 163807 */ GIM_Try, /*On fail goto*//*Label 3574*/ GIMT_Encode4(164051),
     /* 163812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 163815 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 163818 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 163821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 163825 */   GIM_Try, /*On fail goto*//*Label 3575*/ GIMT_Encode4(163889), // Rule ID 10158 //
     /* 163830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 163833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 163837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163841 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163844 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163848 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 163856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 163860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163862 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163869 */     // (fma:{ *:[f16] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VFMADD132SHZm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 163869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SHZm),
     /* 163872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163874 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 163876 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 163878 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 163882 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163887 */     GIR_RootConstrainSelectedInstOperands,
     /* 163888 */     // GIR_Coverage, 10158,
     /* 163888 */     GIR_EraseRootFromParent_Done,
     /* 163889 */   // Label 3575: @163889
     /* 163889 */   GIM_Try, /*On fail goto*//*Label 3576*/ GIMT_Encode4(163953), // Rule ID 10156 //
     /* 163894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 163897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 163901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 163905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163909 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163912 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163916 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 163924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163926 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163933 */     // (fma:{ *:[f16] } FR16X:{ *:[f16] }:$src2, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR16X:{ *:[f16] }:$src1)  =>  (VFMADD231SHZm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 163933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SHZm),
     /* 163936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163938 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 163940 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 163942 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 163946 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163951 */     GIR_RootConstrainSelectedInstOperands,
     /* 163952 */     // GIR_Coverage, 10156,
     /* 163952 */     GIR_EraseRootFromParent_Done,
     /* 163953 */   // Label 3576: @163953
     /* 163953 */   GIM_Try, /*On fail goto*//*Label 3577*/ GIMT_Encode4(164017), // Rule ID 10153 //
     /* 163958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 163961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 163965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 163969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163977 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163980 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163984 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163990 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163997 */     // (fma:{ *:[f16] } FR16X:{ *:[f16] }:$src2, FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SHZm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 163997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SHZm),
     /* 164000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164002 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164004 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 164006 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164010 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164015 */     GIR_RootConstrainSelectedInstOperands,
     /* 164016 */     // GIR_Coverage, 10153,
     /* 164016 */     GIR_EraseRootFromParent_Done,
     /* 164017 */   // Label 3577: @164017
     /* 164017 */   GIM_Try, /*On fail goto*//*Label 3578*/ GIMT_Encode4(164050), // Rule ID 10151 //
     /* 164022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 164025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 164029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 164033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 164037 */     // (fma:{ *:[f16] } FR16X:{ *:[f16] }:$src2, FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src3)  =>  (VFMADD213SHZr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2, FR16X:{ *:[f16] }:$src3)
     /* 164037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SHZr),
     /* 164040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164042 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164044 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 164046 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 164048 */     GIR_RootConstrainSelectedInstOperands,
     /* 164049 */     // GIR_Coverage, 10151,
     /* 164049 */     GIR_EraseRootFromParent_Done,
     /* 164050 */   // Label 3578: @164050
     /* 164050 */   GIM_Reject,
     /* 164051 */ // Label 3574: @164051
     /* 164051 */ GIM_Reject,
     /* 164052 */ // Label 3562: @164052
     /* 164052 */ GIM_Try, /*On fail goto*//*Label 3579*/ GIMT_Encode4(164788),
     /* 164057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 164060 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 164063 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 164066 */   GIM_Try, /*On fail goto*//*Label 3580*/ GIMT_Encode4(164134), // Rule ID 1304 //
     /* 164071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 164074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164086 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164089 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164093 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164107 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164114 */     // (fma:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VFMADD132SSm:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SSm),
     /* 164117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164119 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164121 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 164123 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164127 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164132 */     GIR_RootConstrainSelectedInstOperands,
     /* 164133 */     // GIR_Coverage, 1304,
     /* 164133 */     GIR_EraseRootFromParent_Done,
     /* 164134 */   // Label 3580: @164134
     /* 164134 */   GIM_Try, /*On fail goto*//*Label 3581*/ GIMT_Encode4(164202), // Rule ID 10140 //
     /* 164139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 164142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 164146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164154 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164157 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164161 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 164169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 164173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164175 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164182 */     // (fma:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VFMADD132SSZm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SSZm),
     /* 164185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164187 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164189 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 164191 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164195 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164200 */     GIR_RootConstrainSelectedInstOperands,
     /* 164201 */     // GIR_Coverage, 10140,
     /* 164201 */     GIR_EraseRootFromParent_Done,
     /* 164202 */   // Label 3581: @164202
     /* 164202 */   GIM_Try, /*On fail goto*//*Label 3582*/ GIMT_Encode4(164270), // Rule ID 23281 //
     /* 164207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 164210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164222 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164225 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164229 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164243 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164250 */     // (fma:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src3)  =>  (VFMADDSS4mr:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 164250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSS4mr),
     /* 164253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164255 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164257 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 164261 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 164263 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164268 */     GIR_RootConstrainSelectedInstOperands,
     /* 164269 */     // GIR_Coverage, 23281,
     /* 164269 */     GIR_EraseRootFromParent_Done,
     /* 164270 */   // Label 3582: @164270
     /* 164270 */   GIM_Try, /*On fail goto*//*Label 3583*/ GIMT_Encode4(164338), // Rule ID 1302 //
     /* 164275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 164278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 164290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164294 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164297 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164301 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164311 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164318 */     // (fma:{ *:[f32] } FR32:{ *:[f32] }:$src2, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (VFMADD231SSm:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SSm),
     /* 164321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164323 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 164325 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 164327 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164331 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164336 */     GIR_RootConstrainSelectedInstOperands,
     /* 164337 */     // GIR_Coverage, 1302,
     /* 164337 */     GIR_EraseRootFromParent_Done,
     /* 164338 */   // Label 3583: @164338
     /* 164338 */   GIM_Try, /*On fail goto*//*Label 3584*/ GIMT_Encode4(164406), // Rule ID 1366 //
     /* 164343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 164346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 164358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164362 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164365 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164369 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164379 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164386 */     // (fma:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src3)  =>  (VFMADDSS4mr:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 164386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSS4mr),
     /* 164389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164391 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 164393 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 164397 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 164399 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164404 */     GIR_RootConstrainSelectedInstOperands,
     /* 164405 */     // GIR_Coverage, 1366,
     /* 164405 */     GIR_EraseRootFromParent_Done,
     /* 164406 */   // Label 3584: @164406
     /* 164406 */   GIM_Try, /*On fail goto*//*Label 3585*/ GIMT_Encode4(164474), // Rule ID 10138 //
     /* 164411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 164414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 164418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 164422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 164426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164430 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164433 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164437 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 164445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164447 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164454 */     // (fma:{ *:[f32] } FR32X:{ *:[f32] }:$src2, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32X:{ *:[f32] }:$src1)  =>  (VFMADD231SSZm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SSZm),
     /* 164457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164459 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 164461 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 164463 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164467 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164472 */     GIR_RootConstrainSelectedInstOperands,
     /* 164473 */     // GIR_Coverage, 10138,
     /* 164473 */     GIR_EraseRootFromParent_Done,
     /* 164474 */   // Label 3585: @164474
     /* 164474 */   GIM_Try, /*On fail goto*//*Label 3586*/ GIMT_Encode4(164542), // Rule ID 1300 //
     /* 164479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 164482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164502 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164505 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164509 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164515 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164522 */     // (fma:{ *:[f32] } FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SSm:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSm),
     /* 164525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164527 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164529 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 164531 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164535 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164540 */     GIR_RootConstrainSelectedInstOperands,
     /* 164541 */     // GIR_Coverage, 1300,
     /* 164541 */     GIR_EraseRootFromParent_Done,
     /* 164542 */   // Label 3586: @164542
     /* 164542 */   GIM_Try, /*On fail goto*//*Label 3587*/ GIMT_Encode4(164610), // Rule ID 1364 //
     /* 164547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 164550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164554 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164570 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164573 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164577 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164583 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164590 */     // (fma:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDSS4rm:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSS4rm),
     /* 164593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164595 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 164597 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 164599 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164603 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164608 */     GIR_RootConstrainSelectedInstOperands,
     /* 164609 */     // GIR_Coverage, 1364,
     /* 164609 */     GIR_EraseRootFromParent_Done,
     /* 164610 */   // Label 3587: @164610
     /* 164610 */   GIM_Try, /*On fail goto*//*Label 3588*/ GIMT_Encode4(164678), // Rule ID 10135 //
     /* 164615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 164618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 164622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 164626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 164630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164638 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164641 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164645 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164651 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164658 */     // (fma:{ *:[f32] } FR32X:{ *:[f32] }:$src2, FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SSZm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSZm),
     /* 164661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164663 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164665 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 164667 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164671 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164676 */     GIR_RootConstrainSelectedInstOperands,
     /* 164677 */     // GIR_Coverage, 10135,
     /* 164677 */     GIR_EraseRootFromParent_Done,
     /* 164678 */   // Label 3588: @164678
     /* 164678 */   GIM_Try, /*On fail goto*//*Label 3589*/ GIMT_Encode4(164715), // Rule ID 1298 //
     /* 164683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 164686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164702 */     // (fma:{ *:[f32] } FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src3)  =>  (VFMADD213SSr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 164702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSr),
     /* 164705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164707 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164709 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 164711 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 164713 */     GIR_RootConstrainSelectedInstOperands,
     /* 164714 */     // GIR_Coverage, 1298,
     /* 164714 */     GIR_EraseRootFromParent_Done,
     /* 164715 */   // Label 3589: @164715
     /* 164715 */   GIM_Try, /*On fail goto*//*Label 3590*/ GIMT_Encode4(164750), // Rule ID 1362 //
     /* 164720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 164723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164739 */     // (fma:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src3)  =>  (VFMADDSS4rr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 164739 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDSS4rr),
     /* 164744 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 164748 */     GIR_RootConstrainSelectedInstOperands,
     /* 164749 */     // GIR_Coverage, 1362,
     /* 164749 */     GIR_Done,
     /* 164750 */   // Label 3590: @164750
     /* 164750 */   GIM_Try, /*On fail goto*//*Label 3591*/ GIMT_Encode4(164787), // Rule ID 10133 //
     /* 164755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 164758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 164762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 164766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 164770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 164774 */     // (fma:{ *:[f32] } FR32X:{ *:[f32] }:$src2, FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src3)  =>  (VFMADD213SSZr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2, FR32X:{ *:[f32] }:$src3)
     /* 164774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSZr),
     /* 164777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164779 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164781 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 164783 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 164785 */     GIR_RootConstrainSelectedInstOperands,
     /* 164786 */     // GIR_Coverage, 10133,
     /* 164786 */     GIR_EraseRootFromParent_Done,
     /* 164787 */   // Label 3591: @164787
     /* 164787 */   GIM_Reject,
     /* 164788 */ // Label 3579: @164788
     /* 164788 */ GIM_Reject,
     /* 164789 */ // Label 3563: @164789
     /* 164789 */ GIM_Try, /*On fail goto*//*Label 3592*/ GIMT_Encode4(165525),
     /* 164794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 164797 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 164800 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 164803 */   GIM_Try, /*On fail goto*//*Label 3593*/ GIMT_Encode4(164871), // Rule ID 1312 //
     /* 164808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 164811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 164815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164823 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164826 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164830 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 164838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 164842 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164844 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164851 */     // (fma:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VFMADD132SDm:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SDm),
     /* 164854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164856 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164858 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 164860 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164864 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164869 */     GIR_RootConstrainSelectedInstOperands,
     /* 164870 */     // GIR_Coverage, 1312,
     /* 164870 */     GIR_EraseRootFromParent_Done,
     /* 164871 */   // Label 3593: @164871
     /* 164871 */   GIM_Try, /*On fail goto*//*Label 3594*/ GIMT_Encode4(164939), // Rule ID 10149 //
     /* 164876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 164879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 164883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164891 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164894 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164898 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 164906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 164910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164912 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164919 */     // (fma:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VFMADD132SDZm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SDZm),
     /* 164922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164924 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164926 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 164928 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164932 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164937 */     GIR_RootConstrainSelectedInstOperands,
     /* 164938 */     // GIR_Coverage, 10149,
     /* 164938 */     GIR_EraseRootFromParent_Done,
     /* 164939 */   // Label 3594: @164939
     /* 164939 */   GIM_Try, /*On fail goto*//*Label 3595*/ GIMT_Encode4(165007), // Rule ID 23309 //
     /* 164944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 164947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 164951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164959 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164962 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164966 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 164974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 164978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164980 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164987 */     // (fma:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src3)  =>  (VFMADDSD4mr:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 164987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSD4mr),
     /* 164990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164992 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164994 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 164998 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 165000 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165005 */     GIR_RootConstrainSelectedInstOperands,
     /* 165006 */     // GIR_Coverage, 23309,
     /* 165006 */     GIR_EraseRootFromParent_Done,
     /* 165007 */   // Label 3595: @165007
     /* 165007 */   GIM_Try, /*On fail goto*//*Label 3596*/ GIMT_Encode4(165075), // Rule ID 1310 //
     /* 165012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 165015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165019 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 165027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165031 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165034 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165038 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165046 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165048 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165055 */     // (fma:{ *:[f64] } FR64:{ *:[f64] }:$src2, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (VFMADD231SDm:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SDm),
     /* 165058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165060 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 165062 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 165064 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165068 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165073 */     GIR_RootConstrainSelectedInstOperands,
     /* 165074 */     // GIR_Coverage, 1310,
     /* 165074 */     GIR_EraseRootFromParent_Done,
     /* 165075 */   // Label 3596: @165075
     /* 165075 */   GIM_Try, /*On fail goto*//*Label 3597*/ GIMT_Encode4(165143), // Rule ID 1450 //
     /* 165080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 165083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165087 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 165095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165099 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165102 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165106 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165114 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165116 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165123 */     // (fma:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src3)  =>  (VFMADDSD4mr:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 165123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSD4mr),
     /* 165126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165128 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 165130 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 165134 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 165136 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165141 */     GIR_RootConstrainSelectedInstOperands,
     /* 165142 */     // GIR_Coverage, 1450,
     /* 165142 */     GIR_EraseRootFromParent_Done,
     /* 165143 */   // Label 3597: @165143
     /* 165143 */   GIM_Try, /*On fail goto*//*Label 3598*/ GIMT_Encode4(165211), // Rule ID 10147 //
     /* 165148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 165151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 165155 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 165159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 165163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165167 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165170 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165174 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 165182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165184 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165191 */     // (fma:{ *:[f64] } FR64X:{ *:[f64] }:$src2, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64X:{ *:[f64] }:$src1)  =>  (VFMADD231SDZm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SDZm),
     /* 165194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165196 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 165198 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 165200 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165204 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165209 */     GIR_RootConstrainSelectedInstOperands,
     /* 165210 */     // GIR_Coverage, 10147,
     /* 165210 */     GIR_EraseRootFromParent_Done,
     /* 165211 */   // Label 3598: @165211
     /* 165211 */   GIM_Try, /*On fail goto*//*Label 3599*/ GIMT_Encode4(165279), // Rule ID 1308 //
     /* 165216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 165219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165239 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165242 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165246 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165250 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165252 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165259 */     // (fma:{ *:[f64] } FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SDm:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDm),
     /* 165262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165264 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 165266 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 165268 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165272 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165277 */     GIR_RootConstrainSelectedInstOperands,
     /* 165278 */     // GIR_Coverage, 1308,
     /* 165278 */     GIR_EraseRootFromParent_Done,
     /* 165279 */   // Label 3599: @165279
     /* 165279 */   GIM_Try, /*On fail goto*//*Label 3600*/ GIMT_Encode4(165347), // Rule ID 1448 //
     /* 165284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 165287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165307 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165310 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165314 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165318 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165320 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165327 */     // (fma:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDSD4rm:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSD4rm),
     /* 165330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165332 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 165334 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 165336 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165340 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165345 */     GIR_RootConstrainSelectedInstOperands,
     /* 165346 */     // GIR_Coverage, 1448,
     /* 165346 */     GIR_EraseRootFromParent_Done,
     /* 165347 */   // Label 3600: @165347
     /* 165347 */   GIM_Try, /*On fail goto*//*Label 3601*/ GIMT_Encode4(165415), // Rule ID 10144 //
     /* 165352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 165355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 165359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 165363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 165367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165375 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165378 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165382 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165386 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165388 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165395 */     // (fma:{ *:[f64] } FR64X:{ *:[f64] }:$src2, FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SDZm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDZm),
     /* 165398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165400 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 165402 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 165404 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165408 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165413 */     GIR_RootConstrainSelectedInstOperands,
     /* 165414 */     // GIR_Coverage, 10144,
     /* 165414 */     GIR_EraseRootFromParent_Done,
     /* 165415 */   // Label 3601: @165415
     /* 165415 */   GIM_Try, /*On fail goto*//*Label 3602*/ GIMT_Encode4(165452), // Rule ID 1306 //
     /* 165420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 165423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165439 */     // (fma:{ *:[f64] } FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src3)  =>  (VFMADD213SDr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 165439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDr),
     /* 165442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165444 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 165446 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 165448 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 165450 */     GIR_RootConstrainSelectedInstOperands,
     /* 165451 */     // GIR_Coverage, 1306,
     /* 165451 */     GIR_EraseRootFromParent_Done,
     /* 165452 */   // Label 3602: @165452
     /* 165452 */   GIM_Try, /*On fail goto*//*Label 3603*/ GIMT_Encode4(165487), // Rule ID 1446 //
     /* 165457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 165460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165476 */     // (fma:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src3)  =>  (VFMADDSD4rr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 165476 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDSD4rr),
     /* 165481 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 165485 */     GIR_RootConstrainSelectedInstOperands,
     /* 165486 */     // GIR_Coverage, 1446,
     /* 165486 */     GIR_Done,
     /* 165487 */   // Label 3603: @165487
     /* 165487 */   GIM_Try, /*On fail goto*//*Label 3604*/ GIMT_Encode4(165524), // Rule ID 10142 //
     /* 165492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 165495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 165499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 165503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 165507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 165511 */     // (fma:{ *:[f64] } FR64X:{ *:[f64] }:$src2, FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src3)  =>  (VFMADD213SDZr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2, FR64X:{ *:[f64] }:$src3)
     /* 165511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDZr),
     /* 165514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165516 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 165518 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 165520 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 165522 */     GIR_RootConstrainSelectedInstOperands,
     /* 165523 */     // GIR_Coverage, 10142,
     /* 165523 */     GIR_EraseRootFromParent_Done,
     /* 165524 */   // Label 3604: @165524
     /* 165524 */   GIM_Reject,
     /* 165525 */ // Label 3592: @165525
     /* 165525 */ GIM_Reject,
     /* 165526 */ // Label 3564: @165526
     /* 165526 */ GIM_Try, /*On fail goto*//*Label 3605*/ GIMT_Encode4(166262),
     /* 165531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 165534 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 165537 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 165540 */   GIM_Try, /*On fail goto*//*Label 3606*/ GIMT_Encode4(165608), // Rule ID 1192 //
     /* 165545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 165548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 165552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165560 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165563 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165567 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 165575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 165579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165581 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165588 */     // (fma:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VFMADD132PDm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDm),
     /* 165591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165593 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 165595 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 165597 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165601 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165606 */     GIR_RootConstrainSelectedInstOperands,
     /* 165607 */     // GIR_Coverage, 1192,
     /* 165607 */     GIR_EraseRootFromParent_Done,
     /* 165608 */   // Label 3606: @165608
     /* 165608 */   GIM_Try, /*On fail goto*//*Label 3607*/ GIMT_Encode4(165676), // Rule ID 9681 //
     /* 165613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 165616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 165620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165628 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165631 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165635 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 165643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 165647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165649 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165656 */     // (fma:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VFMADD132PDZ128m:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDZ128m),
     /* 165659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165661 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 165663 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 165665 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165669 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165674 */     GIR_RootConstrainSelectedInstOperands,
     /* 165675 */     // GIR_Coverage, 9681,
     /* 165675 */     GIR_EraseRootFromParent_Done,
     /* 165676 */   // Label 3607: @165676
     /* 165676 */   GIM_Try, /*On fail goto*//*Label 3608*/ GIMT_Encode4(165744), // Rule ID 23317 //
     /* 165681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 165684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 165688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165696 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165699 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165703 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 165711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 165715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165717 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165724 */     // (fma:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADDPD4mr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 165724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4mr),
     /* 165727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165729 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 165731 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 165735 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 165737 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165742 */     GIR_RootConstrainSelectedInstOperands,
     /* 165743 */     // GIR_Coverage, 23317,
     /* 165743 */     GIR_EraseRootFromParent_Done,
     /* 165744 */   // Label 3608: @165744
     /* 165744 */   GIM_Try, /*On fail goto*//*Label 3609*/ GIMT_Encode4(165812), // Rule ID 1190 //
     /* 165749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 165752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 165756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 165760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 165764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165768 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165771 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165775 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 165783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165785 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165792 */     // (fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src2, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1)  =>  (VFMADD231PDm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDm),
     /* 165795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165797 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 165799 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 165801 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165805 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165810 */     GIR_RootConstrainSelectedInstOperands,
     /* 165811 */     // GIR_Coverage, 1190,
     /* 165811 */     GIR_EraseRootFromParent_Done,
     /* 165812 */   // Label 3609: @165812
     /* 165812 */   GIM_Try, /*On fail goto*//*Label 3610*/ GIMT_Encode4(165880), // Rule ID 1474 //
     /* 165817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 165820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 165824 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 165828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 165832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165836 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165839 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165843 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 165851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165853 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165860 */     // (fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADDPD4mr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 165860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4mr),
     /* 165863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165865 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 165867 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 165871 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 165873 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165878 */     GIR_RootConstrainSelectedInstOperands,
     /* 165879 */     // GIR_Coverage, 1474,
     /* 165879 */     GIR_EraseRootFromParent_Done,
     /* 165880 */   // Label 3610: @165880
     /* 165880 */   GIM_Try, /*On fail goto*//*Label 3611*/ GIMT_Encode4(165948), // Rule ID 9141 //
     /* 165885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 165888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 165892 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 165896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 165900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165904 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165907 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165911 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 165919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165921 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165928 */     // (fma:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src2, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2f64] }:$src1)  =>  (VFMADD231PDZ128m:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDZ128m),
     /* 165931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165933 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 165935 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 165937 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165941 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165946 */     GIR_RootConstrainSelectedInstOperands,
     /* 165947 */     // GIR_Coverage, 9141,
     /* 165947 */     GIR_EraseRootFromParent_Done,
     /* 165948 */   // Label 3611: @165948
     /* 165948 */   GIM_Try, /*On fail goto*//*Label 3612*/ GIMT_Encode4(166016), // Rule ID 1188 //
     /* 165953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 165956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 165960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 165964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 165968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165976 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165979 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165983 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165989 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165996 */     // (fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDm),
     /* 165999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166001 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166003 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166005 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166009 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166014 */     GIR_RootConstrainSelectedInstOperands,
     /* 166015 */     // GIR_Coverage, 1188,
     /* 166015 */     GIR_EraseRootFromParent_Done,
     /* 166016 */   // Label 3612: @166016
     /* 166016 */   GIM_Try, /*On fail goto*//*Label 3613*/ GIMT_Encode4(166084), // Rule ID 1472 //
     /* 166021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 166024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166044 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166047 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166051 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166057 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166064 */     // (fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDPD4rm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4rm),
     /* 166067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166069 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 166071 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 166073 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166077 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166082 */     GIR_RootConstrainSelectedInstOperands,
     /* 166083 */     // GIR_Coverage, 1472,
     /* 166083 */     GIR_EraseRootFromParent_Done,
     /* 166084 */   // Label 3613: @166084
     /* 166084 */   GIM_Try, /*On fail goto*//*Label 3614*/ GIMT_Encode4(166152), // Rule ID 8514 //
     /* 166089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 166092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166112 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166115 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166119 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166125 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166132 */     // (fma:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src2, VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDZ128m:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ128m),
     /* 166135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166137 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166139 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166141 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166145 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166150 */     GIR_RootConstrainSelectedInstOperands,
     /* 166151 */     // GIR_Coverage, 8514,
     /* 166151 */     GIR_EraseRootFromParent_Done,
     /* 166152 */   // Label 3614: @166152
     /* 166152 */   GIM_Try, /*On fail goto*//*Label 3615*/ GIMT_Encode4(166189), // Rule ID 1186 //
     /* 166157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 166160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166176 */     // (fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADD213PDr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 166176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDr),
     /* 166179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166181 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166183 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166185 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 166187 */     GIR_RootConstrainSelectedInstOperands,
     /* 166188 */     // GIR_Coverage, 1186,
     /* 166188 */     GIR_EraseRootFromParent_Done,
     /* 166189 */   // Label 3615: @166189
     /* 166189 */   GIM_Try, /*On fail goto*//*Label 3616*/ GIMT_Encode4(166224), // Rule ID 1470 //
     /* 166194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 166197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166201 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166213 */     // (fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADDPD4rr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 166213 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4rr),
     /* 166218 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 166222 */     GIR_RootConstrainSelectedInstOperands,
     /* 166223 */     // GIR_Coverage, 1470,
     /* 166223 */     GIR_Done,
     /* 166224 */   // Label 3616: @166224
     /* 166224 */   GIM_Try, /*On fail goto*//*Label 3617*/ GIMT_Encode4(166261), // Rule ID 8510 //
     /* 166229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 166232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166236 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166248 */     // (fma:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src2, VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src3)  =>  (VFMADD213PDZ128r:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2, VR128X:{ *:[v2f64] }:$src3)
     /* 166248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ128r),
     /* 166251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166253 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166255 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166257 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 166259 */     GIR_RootConstrainSelectedInstOperands,
     /* 166260 */     // GIR_Coverage, 8510,
     /* 166260 */     GIR_EraseRootFromParent_Done,
     /* 166261 */   // Label 3617: @166261
     /* 166261 */   GIM_Reject,
     /* 166262 */ // Label 3605: @166262
     /* 166262 */ GIM_Reject,
     /* 166263 */ // Label 3565: @166263
     /* 166263 */ GIM_Try, /*On fail goto*//*Label 3618*/ GIMT_Encode4(166999),
     /* 166268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 166271 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166274 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 166277 */   GIM_Try, /*On fail goto*//*Label 3619*/ GIMT_Encode4(166345), // Rule ID 1144 //
     /* 166282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 166285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166297 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166300 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166304 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166316 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166318 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166325 */     // (fma:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VFMADD132PSm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSm),
     /* 166328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166330 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166332 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 166334 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166338 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166343 */     GIR_RootConstrainSelectedInstOperands,
     /* 166344 */     // GIR_Coverage, 1144,
     /* 166344 */     GIR_EraseRootFromParent_Done,
     /* 166345 */   // Label 3619: @166345
     /* 166345 */   GIM_Try, /*On fail goto*//*Label 3620*/ GIMT_Encode4(166413), // Rule ID 9649 //
     /* 166350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 166353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166365 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166368 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166372 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166386 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166393 */     // (fma:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VFMADD132PSZ128m:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSZ128m),
     /* 166396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166398 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166400 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 166402 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166406 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166411 */     GIR_RootConstrainSelectedInstOperands,
     /* 166412 */     // GIR_Coverage, 9649,
     /* 166412 */     GIR_EraseRootFromParent_Done,
     /* 166413 */   // Label 3620: @166413
     /* 166413 */   GIM_Try, /*On fail goto*//*Label 3621*/ GIMT_Encode4(166481), // Rule ID 23289 //
     /* 166418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 166421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166433 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166436 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166440 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166454 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166461 */     // (fma:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADDPS4mr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 166461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4mr),
     /* 166464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166466 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166468 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 166472 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 166474 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166479 */     GIR_RootConstrainSelectedInstOperands,
     /* 166480 */     // GIR_Coverage, 23289,
     /* 166480 */     GIR_EraseRootFromParent_Done,
     /* 166481 */   // Label 3621: @166481
     /* 166481 */   GIM_Try, /*On fail goto*//*Label 3622*/ GIMT_Encode4(166549), // Rule ID 1142 //
     /* 166486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 166489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 166501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166505 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166508 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166512 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166522 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166529 */     // (fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src2, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1)  =>  (VFMADD231PSm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSm),
     /* 166532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166534 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 166536 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166538 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166542 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166547 */     GIR_RootConstrainSelectedInstOperands,
     /* 166548 */     // GIR_Coverage, 1142,
     /* 166548 */     GIR_EraseRootFromParent_Done,
     /* 166549 */   // Label 3622: @166549
     /* 166549 */   GIM_Try, /*On fail goto*//*Label 3623*/ GIMT_Encode4(166617), // Rule ID 1390 //
     /* 166554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 166557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 166569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166573 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166576 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166580 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166590 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166597 */     // (fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADDPS4mr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 166597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4mr),
     /* 166600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166602 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 166604 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 166608 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 166610 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166615 */     GIR_RootConstrainSelectedInstOperands,
     /* 166616 */     // GIR_Coverage, 1390,
     /* 166616 */     GIR_EraseRootFromParent_Done,
     /* 166617 */   // Label 3623: @166617
     /* 166617 */   GIM_Try, /*On fail goto*//*Label 3624*/ GIMT_Encode4(166685), // Rule ID 9109 //
     /* 166622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 166625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 166637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166641 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166644 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166648 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166656 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166658 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166665 */     // (fma:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src2, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4f32] }:$src1)  =>  (VFMADD231PSZ128m:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSZ128m),
     /* 166668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166670 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 166672 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166674 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166678 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166683 */     GIR_RootConstrainSelectedInstOperands,
     /* 166684 */     // GIR_Coverage, 9109,
     /* 166684 */     GIR_EraseRootFromParent_Done,
     /* 166685 */   // Label 3624: @166685
     /* 166685 */   GIM_Try, /*On fail goto*//*Label 3625*/ GIMT_Encode4(166753), // Rule ID 1140 //
     /* 166690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 166693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166713 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166716 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166720 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166726 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166733 */     // (fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSm),
     /* 166736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166738 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166740 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166742 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166746 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166751 */     GIR_RootConstrainSelectedInstOperands,
     /* 166752 */     // GIR_Coverage, 1140,
     /* 166752 */     GIR_EraseRootFromParent_Done,
     /* 166753 */   // Label 3625: @166753
     /* 166753 */   GIM_Try, /*On fail goto*//*Label 3626*/ GIMT_Encode4(166821), // Rule ID 1388 //
     /* 166758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 166761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166781 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166784 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166788 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166794 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166801 */     // (fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDPS4rm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4rm),
     /* 166804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166806 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 166808 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 166810 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166819 */     GIR_RootConstrainSelectedInstOperands,
     /* 166820 */     // GIR_Coverage, 1388,
     /* 166820 */     GIR_EraseRootFromParent_Done,
     /* 166821 */   // Label 3626: @166821
     /* 166821 */   GIM_Try, /*On fail goto*//*Label 3627*/ GIMT_Encode4(166889), // Rule ID 8475 //
     /* 166826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 166829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166849 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166852 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166856 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166862 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166869 */     // (fma:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src2, VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSZ128m:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ128m),
     /* 166872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166874 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166876 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166878 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166882 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166887 */     GIR_RootConstrainSelectedInstOperands,
     /* 166888 */     // GIR_Coverage, 8475,
     /* 166888 */     GIR_EraseRootFromParent_Done,
     /* 166889 */   // Label 3627: @166889
     /* 166889 */   GIM_Try, /*On fail goto*//*Label 3628*/ GIMT_Encode4(166926), // Rule ID 1138 //
     /* 166894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 166897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166913 */     // (fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADD213PSr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 166913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSr),
     /* 166916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166918 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166920 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166922 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 166924 */     GIR_RootConstrainSelectedInstOperands,
     /* 166925 */     // GIR_Coverage, 1138,
     /* 166925 */     GIR_EraseRootFromParent_Done,
     /* 166926 */   // Label 3628: @166926
     /* 166926 */   GIM_Try, /*On fail goto*//*Label 3629*/ GIMT_Encode4(166961), // Rule ID 1386 //
     /* 166931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 166934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166950 */     // (fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADDPS4rr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 166950 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4rr),
     /* 166955 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 166959 */     GIR_RootConstrainSelectedInstOperands,
     /* 166960 */     // GIR_Coverage, 1386,
     /* 166960 */     GIR_Done,
     /* 166961 */   // Label 3629: @166961
     /* 166961 */   GIM_Try, /*On fail goto*//*Label 3630*/ GIMT_Encode4(166998), // Rule ID 8471 //
     /* 166966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 166969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166985 */     // (fma:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src2, VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src3)  =>  (VFMADD213PSZ128r:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2, VR128X:{ *:[v4f32] }:$src3)
     /* 166985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ128r),
     /* 166988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166990 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166992 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166994 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 166996 */     GIR_RootConstrainSelectedInstOperands,
     /* 166997 */     // GIR_Coverage, 8471,
     /* 166997 */     GIR_EraseRootFromParent_Done,
     /* 166998 */   // Label 3630: @166998
     /* 166998 */   GIM_Reject,
     /* 166999 */ // Label 3618: @166999
     /* 166999 */ GIM_Reject,
     /* 167000 */ // Label 3566: @167000
     /* 167000 */ GIM_Try, /*On fail goto*//*Label 3631*/ GIMT_Encode4(167736),
     /* 167005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 167008 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 167011 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 167014 */   GIM_Try, /*On fail goto*//*Label 3632*/ GIMT_Encode4(167082), // Rule ID 1200 //
     /* 167019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 167022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 167030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167034 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167037 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167041 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167055 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167062 */     // (fma:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VFMADD132PDYm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 167062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDYm),
     /* 167065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167067 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 167069 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 167071 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 167075 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167080 */     GIR_RootConstrainSelectedInstOperands,
     /* 167081 */     // GIR_Coverage, 1200,
     /* 167081 */     GIR_EraseRootFromParent_Done,
     /* 167082 */   // Label 3632: @167082
     /* 167082 */   GIM_Try, /*On fail goto*//*Label 3633*/ GIMT_Encode4(167150), // Rule ID 9671 //
     /* 167087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 167090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 167094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 167098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167102 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167105 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167109 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 167117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 167121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167123 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167130 */     // (fma:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VFMADD132PDZ256m:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 167130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDZ256m),
     /* 167133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167135 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 167137 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 167139 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 167143 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167148 */     GIR_RootConstrainSelectedInstOperands,
     /* 167149 */     // GIR_Coverage, 9671,
     /* 167149 */     GIR_EraseRootFromParent_Done,
     /* 167150 */   // Label 3633: @167150
     /* 167150 */   GIM_Try, /*On fail goto*//*Label 3634*/ GIMT_Encode4(167218), // Rule ID 23319 //
     /* 167155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 167158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 167166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167170 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167173 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167177 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167191 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167198 */     // (fma:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADDPD4Ymr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 167198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4Ymr),
     /* 167201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167203 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 167205 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 167209 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 167211 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167216 */     GIR_RootConstrainSelectedInstOperands,
     /* 167217 */     // GIR_Coverage, 23319,
     /* 167217 */     GIR_EraseRootFromParent_Done,
     /* 167218 */   // Label 3634: @167218
     /* 167218 */   GIM_Try, /*On fail goto*//*Label 3635*/ GIMT_Encode4(167286), // Rule ID 1198 //
     /* 167223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 167226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 167238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167242 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167245 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167249 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167259 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167266 */     // (fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src2, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1)  =>  (VFMADD231PDYm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 167266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDYm),
     /* 167269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167271 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 167273 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 167275 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 167279 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167284 */     GIR_RootConstrainSelectedInstOperands,
     /* 167285 */     // GIR_Coverage, 1198,
     /* 167285 */     GIR_EraseRootFromParent_Done,
     /* 167286 */   // Label 3635: @167286
     /* 167286 */   GIM_Try, /*On fail goto*//*Label 3636*/ GIMT_Encode4(167354), // Rule ID 1480 //
     /* 167291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 167294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 167306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167310 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167313 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167317 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167327 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167334 */     // (fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADDPD4Ymr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 167334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4Ymr),
     /* 167337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167339 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 167341 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 167345 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 167347 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167352 */     GIR_RootConstrainSelectedInstOperands,
     /* 167353 */     // GIR_Coverage, 1480,
     /* 167353 */     GIR_EraseRootFromParent_Done,
     /* 167354 */   // Label 3636: @167354
     /* 167354 */   GIM_Try, /*On fail goto*//*Label 3637*/ GIMT_Encode4(167422), // Rule ID 9131 //
     /* 167359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 167362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 167366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 167370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 167374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167378 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167381 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167385 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 167393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167395 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167402 */     // (fma:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src2, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4f64] }:$src1)  =>  (VFMADD231PDZ256m:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 167402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDZ256m),
     /* 167405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167407 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 167409 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 167411 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 167415 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167420 */     GIR_RootConstrainSelectedInstOperands,
     /* 167421 */     // GIR_Coverage, 9131,
     /* 167421 */     GIR_EraseRootFromParent_Done,
     /* 167422 */   // Label 3637: @167422
     /* 167422 */   GIM_Try, /*On fail goto*//*Label 3638*/ GIMT_Encode4(167490), // Rule ID 1196 //
     /* 167427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 167430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 167446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167450 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167453 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167457 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167463 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167470 */     // (fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDYm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 167470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDYm),
     /* 167473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167475 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 167477 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 167479 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 167483 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167488 */     GIR_RootConstrainSelectedInstOperands,
     /* 167489 */     // GIR_Coverage, 1196,
     /* 167489 */     GIR_EraseRootFromParent_Done,
     /* 167490 */   // Label 3638: @167490
     /* 167490 */   GIM_Try, /*On fail goto*//*Label 3639*/ GIMT_Encode4(167558), // Rule ID 1478 //
     /* 167495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 167498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 167514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167518 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167521 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167525 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167531 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167538 */     // (fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDPD4Yrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 167538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4Yrm),
     /* 167541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167543 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 167545 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 167547 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 167551 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167556 */     GIR_RootConstrainSelectedInstOperands,
     /* 167557 */     // GIR_Coverage, 1478,
     /* 167557 */     GIR_EraseRootFromParent_Done,
     /* 167558 */   // Label 3639: @167558
     /* 167558 */   GIM_Try, /*On fail goto*//*Label 3640*/ GIMT_Encode4(167626), // Rule ID 8502 //
     /* 167563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 167566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 167570 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 167574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 167578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 167582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167586 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167589 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167593 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167599 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167606 */     // (fma:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src2, VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDZ256m:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 167606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ256m),
     /* 167609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167611 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 167613 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 167615 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 167619 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167624 */     GIR_RootConstrainSelectedInstOperands,
     /* 167625 */     // GIR_Coverage, 8502,
     /* 167625 */     GIR_EraseRootFromParent_Done,
     /* 167626 */   // Label 3640: @167626
     /* 167626 */   GIM_Try, /*On fail goto*//*Label 3641*/ GIMT_Encode4(167663), // Rule ID 1194 //
     /* 167631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 167634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167638 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167650 */     // (fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADD213PDYr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 167650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDYr),
     /* 167653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167655 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 167657 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 167659 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 167661 */     GIR_RootConstrainSelectedInstOperands,
     /* 167662 */     // GIR_Coverage, 1194,
     /* 167662 */     GIR_EraseRootFromParent_Done,
     /* 167663 */   // Label 3641: @167663
     /* 167663 */   GIM_Try, /*On fail goto*//*Label 3642*/ GIMT_Encode4(167698), // Rule ID 1476 //
     /* 167668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 167671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167687 */     // (fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADDPD4Yrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 167687 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4Yrr),
     /* 167692 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 167696 */     GIR_RootConstrainSelectedInstOperands,
     /* 167697 */     // GIR_Coverage, 1476,
     /* 167697 */     GIR_Done,
     /* 167698 */   // Label 3642: @167698
     /* 167698 */   GIM_Try, /*On fail goto*//*Label 3643*/ GIMT_Encode4(167735), // Rule ID 8498 //
     /* 167703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 167706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 167710 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 167714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 167718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 167722 */     // (fma:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src2, VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src3)  =>  (VFMADD213PDZ256r:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2, VR256X:{ *:[v4f64] }:$src3)
     /* 167722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ256r),
     /* 167725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167727 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 167729 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 167731 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 167733 */     GIR_RootConstrainSelectedInstOperands,
     /* 167734 */     // GIR_Coverage, 8498,
     /* 167734 */     GIR_EraseRootFromParent_Done,
     /* 167735 */   // Label 3643: @167735
     /* 167735 */   GIM_Reject,
     /* 167736 */ // Label 3631: @167736
     /* 167736 */ GIM_Reject,
     /* 167737 */ // Label 3567: @167737
     /* 167737 */ GIM_Try, /*On fail goto*//*Label 3644*/ GIMT_Encode4(167981),
     /* 167742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 167745 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 167748 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 167751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 167755 */   GIM_Try, /*On fail goto*//*Label 3645*/ GIMT_Encode4(167819), // Rule ID 9617 //
     /* 167760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 167763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 167767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167771 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167774 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167778 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 167786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 167790 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167792 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167799 */     // (fma:{ *:[v8f16] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VFMADD132PHZ128m:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 167799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PHZ128m),
     /* 167802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167804 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 167806 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 167808 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 167812 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167817 */     GIR_RootConstrainSelectedInstOperands,
     /* 167818 */     // GIR_Coverage, 9617,
     /* 167818 */     GIR_EraseRootFromParent_Done,
     /* 167819 */   // Label 3645: @167819
     /* 167819 */   GIM_Try, /*On fail goto*//*Label 3646*/ GIMT_Encode4(167883), // Rule ID 9077 //
     /* 167824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 167827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 167831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 167835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167839 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167842 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167846 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 167854 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167856 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167863 */     // (fma:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src2, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8f16] }:$src1)  =>  (VFMADD231PHZ128m:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 167863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PHZ128m),
     /* 167866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167868 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 167870 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 167872 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 167876 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167881 */     GIR_RootConstrainSelectedInstOperands,
     /* 167882 */     // GIR_Coverage, 9077,
     /* 167882 */     GIR_EraseRootFromParent_Done,
     /* 167883 */   // Label 3646: @167883
     /* 167883 */   GIM_Try, /*On fail goto*//*Label 3647*/ GIMT_Encode4(167947), // Rule ID 8436 //
     /* 167888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 167891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 167895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 167899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 167903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167907 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167910 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167914 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167920 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167927 */     // (fma:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src2, VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PHZ128m:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 167927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ128m),
     /* 167930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167932 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 167934 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 167936 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 167940 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167945 */     GIR_RootConstrainSelectedInstOperands,
     /* 167946 */     // GIR_Coverage, 8436,
     /* 167946 */     GIR_EraseRootFromParent_Done,
     /* 167947 */   // Label 3647: @167947
     /* 167947 */   GIM_Try, /*On fail goto*//*Label 3648*/ GIMT_Encode4(167980), // Rule ID 8432 //
     /* 167952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 167955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 167959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 167963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 167967 */     // (fma:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src2, VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src3)  =>  (VFMADD213PHZ128r:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2, VR128X:{ *:[v8f16] }:$src3)
     /* 167967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ128r),
     /* 167970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167972 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 167974 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 167976 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 167978 */     GIR_RootConstrainSelectedInstOperands,
     /* 167979 */     // GIR_Coverage, 8432,
     /* 167979 */     GIR_EraseRootFromParent_Done,
     /* 167980 */   // Label 3648: @167980
     /* 167980 */   GIM_Reject,
     /* 167981 */ // Label 3644: @167981
     /* 167981 */ GIM_Reject,
     /* 167982 */ // Label 3568: @167982
     /* 167982 */ GIM_Try, /*On fail goto*//*Label 3649*/ GIMT_Encode4(168718),
     /* 167987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 167990 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 167993 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 167996 */   GIM_Try, /*On fail goto*//*Label 3650*/ GIMT_Encode4(168064), // Rule ID 1152 //
     /* 168001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 168004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 168012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168016 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168019 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168023 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168037 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168044 */     // (fma:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VFMADD132PSYm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 168044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSYm),
     /* 168047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168049 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 168051 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 168053 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 168057 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168062 */     GIR_RootConstrainSelectedInstOperands,
     /* 168063 */     // GIR_Coverage, 1152,
     /* 168063 */     GIR_EraseRootFromParent_Done,
     /* 168064 */   // Label 3650: @168064
     /* 168064 */   GIM_Try, /*On fail goto*//*Label 3651*/ GIMT_Encode4(168132), // Rule ID 9639 //
     /* 168069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 168072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 168076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 168080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168084 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168087 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168091 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 168099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 168103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168105 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168112 */     // (fma:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VFMADD132PSZ256m:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 168112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSZ256m),
     /* 168115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168117 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 168119 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 168121 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 168125 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168130 */     GIR_RootConstrainSelectedInstOperands,
     /* 168131 */     // GIR_Coverage, 9639,
     /* 168131 */     GIR_EraseRootFromParent_Done,
     /* 168132 */   // Label 3651: @168132
     /* 168132 */   GIM_Try, /*On fail goto*//*Label 3652*/ GIMT_Encode4(168200), // Rule ID 23291 //
     /* 168137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 168140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 168148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168152 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168155 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168159 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168173 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168180 */     // (fma:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADDPS4Ymr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 168180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4Ymr),
     /* 168183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168185 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 168187 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 168191 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 168193 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168198 */     GIR_RootConstrainSelectedInstOperands,
     /* 168199 */     // GIR_Coverage, 23291,
     /* 168199 */     GIR_EraseRootFromParent_Done,
     /* 168200 */   // Label 3652: @168200
     /* 168200 */   GIM_Try, /*On fail goto*//*Label 3653*/ GIMT_Encode4(168268), // Rule ID 1150 //
     /* 168205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 168208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 168220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168224 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168227 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168231 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168241 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168248 */     // (fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src2, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1)  =>  (VFMADD231PSYm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 168248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSYm),
     /* 168251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168253 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 168255 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 168257 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 168261 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168266 */     GIR_RootConstrainSelectedInstOperands,
     /* 168267 */     // GIR_Coverage, 1150,
     /* 168267 */     GIR_EraseRootFromParent_Done,
     /* 168268 */   // Label 3653: @168268
     /* 168268 */   GIM_Try, /*On fail goto*//*Label 3654*/ GIMT_Encode4(168336), // Rule ID 1396 //
     /* 168273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 168276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 168288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168292 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168295 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168299 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168309 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168316 */     // (fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADDPS4Ymr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 168316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4Ymr),
     /* 168319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168321 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 168323 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 168327 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 168329 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168334 */     GIR_RootConstrainSelectedInstOperands,
     /* 168335 */     // GIR_Coverage, 1396,
     /* 168335 */     GIR_EraseRootFromParent_Done,
     /* 168336 */   // Label 3654: @168336
     /* 168336 */   GIM_Try, /*On fail goto*//*Label 3655*/ GIMT_Encode4(168404), // Rule ID 9099 //
     /* 168341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 168344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 168348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 168352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 168356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168360 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168363 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168367 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 168375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168377 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168384 */     // (fma:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src2, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8f32] }:$src1)  =>  (VFMADD231PSZ256m:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 168384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSZ256m),
     /* 168387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168389 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 168391 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 168393 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 168397 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168402 */     GIR_RootConstrainSelectedInstOperands,
     /* 168403 */     // GIR_Coverage, 9099,
     /* 168403 */     GIR_EraseRootFromParent_Done,
     /* 168404 */   // Label 3655: @168404
     /* 168404 */   GIM_Try, /*On fail goto*//*Label 3656*/ GIMT_Encode4(168472), // Rule ID 1148 //
     /* 168409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 168412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 168428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168432 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168435 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168439 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168445 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168452 */     // (fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSYm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 168452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSYm),
     /* 168455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168457 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 168459 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 168461 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 168465 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168470 */     GIR_RootConstrainSelectedInstOperands,
     /* 168471 */     // GIR_Coverage, 1148,
     /* 168471 */     GIR_EraseRootFromParent_Done,
     /* 168472 */   // Label 3656: @168472
     /* 168472 */   GIM_Try, /*On fail goto*//*Label 3657*/ GIMT_Encode4(168540), // Rule ID 1394 //
     /* 168477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 168480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 168496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168500 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168503 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168507 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168513 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168520 */     // (fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDPS4Yrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 168520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4Yrm),
     /* 168523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168525 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 168527 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 168529 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 168533 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168538 */     GIR_RootConstrainSelectedInstOperands,
     /* 168539 */     // GIR_Coverage, 1394,
     /* 168539 */     GIR_EraseRootFromParent_Done,
     /* 168540 */   // Label 3657: @168540
     /* 168540 */   GIM_Try, /*On fail goto*//*Label 3658*/ GIMT_Encode4(168608), // Rule ID 8463 //
     /* 168545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 168548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 168552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 168556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 168560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 168564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168568 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168571 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168575 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168581 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168588 */     // (fma:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src2, VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSZ256m:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 168588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ256m),
     /* 168591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168593 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 168595 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 168597 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 168601 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168606 */     GIR_RootConstrainSelectedInstOperands,
     /* 168607 */     // GIR_Coverage, 8463,
     /* 168607 */     GIR_EraseRootFromParent_Done,
     /* 168608 */   // Label 3658: @168608
     /* 168608 */   GIM_Try, /*On fail goto*//*Label 3659*/ GIMT_Encode4(168645), // Rule ID 1146 //
     /* 168613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 168616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168632 */     // (fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADD213PSYr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 168632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSYr),
     /* 168635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168637 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 168639 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 168641 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 168643 */     GIR_RootConstrainSelectedInstOperands,
     /* 168644 */     // GIR_Coverage, 1146,
     /* 168644 */     GIR_EraseRootFromParent_Done,
     /* 168645 */   // Label 3659: @168645
     /* 168645 */   GIM_Try, /*On fail goto*//*Label 3660*/ GIMT_Encode4(168680), // Rule ID 1392 //
     /* 168650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 168653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168669 */     // (fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADDPS4Yrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 168669 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4Yrr),
     /* 168674 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 168678 */     GIR_RootConstrainSelectedInstOperands,
     /* 168679 */     // GIR_Coverage, 1392,
     /* 168679 */     GIR_Done,
     /* 168680 */   // Label 3660: @168680
     /* 168680 */   GIM_Try, /*On fail goto*//*Label 3661*/ GIMT_Encode4(168717), // Rule ID 8459 //
     /* 168685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 168688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 168692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 168696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 168700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 168704 */     // (fma:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src2, VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src3)  =>  (VFMADD213PSZ256r:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2, VR256X:{ *:[v8f32] }:$src3)
     /* 168704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ256r),
     /* 168707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168709 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 168711 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 168713 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 168715 */     GIR_RootConstrainSelectedInstOperands,
     /* 168716 */     // GIR_Coverage, 8459,
     /* 168716 */     GIR_EraseRootFromParent_Done,
     /* 168717 */   // Label 3661: @168717
     /* 168717 */   GIM_Reject,
     /* 168718 */ // Label 3649: @168718
     /* 168718 */ GIM_Reject,
     /* 168719 */ // Label 3569: @168719
     /* 168719 */ GIM_Try, /*On fail goto*//*Label 3662*/ GIMT_Encode4(168963),
     /* 168724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 168727 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 168730 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /* 168733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 168737 */   GIM_Try, /*On fail goto*//*Label 3663*/ GIMT_Encode4(168801), // Rule ID 9659 //
     /* 168742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 168745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 168749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168753 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168756 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168760 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 168768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 168772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168774 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168781 */     // (fma:{ *:[v8f64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VFMADD132PDZm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 168781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDZm),
     /* 168784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168786 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 168788 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 168790 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 168794 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168799 */     GIR_RootConstrainSelectedInstOperands,
     /* 168800 */     // GIR_Coverage, 9659,
     /* 168800 */     GIR_EraseRootFromParent_Done,
     /* 168801 */   // Label 3663: @168801
     /* 168801 */   GIM_Try, /*On fail goto*//*Label 3664*/ GIMT_Encode4(168865), // Rule ID 9119 //
     /* 168806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 168809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 168813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 168817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168821 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168824 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168828 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 168836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168838 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168845 */     // (fma:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src2, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8f64] }:$src1)  =>  (VFMADD231PDZm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 168845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDZm),
     /* 168848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168850 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 168852 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 168854 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 168858 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168863 */     GIR_RootConstrainSelectedInstOperands,
     /* 168864 */     // GIR_Coverage, 9119,
     /* 168864 */     GIR_EraseRootFromParent_Done,
     /* 168865 */   // Label 3664: @168865
     /* 168865 */   GIM_Try, /*On fail goto*//*Label 3665*/ GIMT_Encode4(168929), // Rule ID 8487 //
     /* 168870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 168873 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 168877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 168881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 168885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168889 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168892 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168896 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168900 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168902 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168909 */     // (fma:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src2, VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDZm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 168909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZm),
     /* 168912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168914 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 168916 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 168918 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 168922 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168927 */     GIR_RootConstrainSelectedInstOperands,
     /* 168928 */     // GIR_Coverage, 8487,
     /* 168928 */     GIR_EraseRootFromParent_Done,
     /* 168929 */   // Label 3665: @168929
     /* 168929 */   GIM_Try, /*On fail goto*//*Label 3666*/ GIMT_Encode4(168962), // Rule ID 8483 //
     /* 168934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 168937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 168941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 168945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 168949 */     // (fma:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src2, VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src3)  =>  (VFMADD213PDZr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2, VR512:{ *:[v8f64] }:$src3)
     /* 168949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZr),
     /* 168952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168954 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 168956 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 168958 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 168960 */     GIR_RootConstrainSelectedInstOperands,
     /* 168961 */     // GIR_Coverage, 8483,
     /* 168961 */     GIR_EraseRootFromParent_Done,
     /* 168962 */   // Label 3666: @168962
     /* 168962 */   GIM_Reject,
     /* 168963 */ // Label 3662: @168963
     /* 168963 */ GIM_Reject,
     /* 168964 */ // Label 3570: @168964
     /* 168964 */ GIM_Try, /*On fail goto*//*Label 3667*/ GIMT_Encode4(169208),
     /* 168969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 168972 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 168975 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 168978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 168982 */   GIM_Try, /*On fail goto*//*Label 3668*/ GIMT_Encode4(169046), // Rule ID 9607 //
     /* 168987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 168990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 168994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168998 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169001 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169005 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 169013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 169017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169019 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169026 */     // (fma:{ *:[v16f16] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VFMADD132PHZ256m:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 169026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PHZ256m),
     /* 169029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169031 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 169033 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 169035 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 169039 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169044 */     GIR_RootConstrainSelectedInstOperands,
     /* 169045 */     // GIR_Coverage, 9607,
     /* 169045 */     GIR_EraseRootFromParent_Done,
     /* 169046 */   // Label 3668: @169046
     /* 169046 */   GIM_Try, /*On fail goto*//*Label 3669*/ GIMT_Encode4(169110), // Rule ID 9067 //
     /* 169051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 169054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 169058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169066 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169069 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169073 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 169081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169083 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169090 */     // (fma:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src2, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16f16] }:$src1)  =>  (VFMADD231PHZ256m:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 169090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PHZ256m),
     /* 169093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169095 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 169097 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 169099 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 169103 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169108 */     GIR_RootConstrainSelectedInstOperands,
     /* 169109 */     // GIR_Coverage, 9067,
     /* 169109 */     GIR_EraseRootFromParent_Done,
     /* 169110 */   // Label 3669: @169110
     /* 169110 */   GIM_Try, /*On fail goto*//*Label 3670*/ GIMT_Encode4(169174), // Rule ID 8424 //
     /* 169115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 169118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 169122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 169126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 169130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169134 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169137 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169141 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169147 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169154 */     // (fma:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src2, VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PHZ256m:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 169154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ256m),
     /* 169157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169159 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 169161 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 169163 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 169167 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169172 */     GIR_RootConstrainSelectedInstOperands,
     /* 169173 */     // GIR_Coverage, 8424,
     /* 169173 */     GIR_EraseRootFromParent_Done,
     /* 169174 */   // Label 3670: @169174
     /* 169174 */   GIM_Try, /*On fail goto*//*Label 3671*/ GIMT_Encode4(169207), // Rule ID 8420 //
     /* 169179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 169182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 169186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 169190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 169194 */     // (fma:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src2, VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src3)  =>  (VFMADD213PHZ256r:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2, VR256X:{ *:[v16f16] }:$src3)
     /* 169194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ256r),
     /* 169197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169199 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 169201 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 169203 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 169205 */     GIR_RootConstrainSelectedInstOperands,
     /* 169206 */     // GIR_Coverage, 8420,
     /* 169206 */     GIR_EraseRootFromParent_Done,
     /* 169207 */   // Label 3671: @169207
     /* 169207 */   GIM_Reject,
     /* 169208 */ // Label 3667: @169208
     /* 169208 */ GIM_Reject,
     /* 169209 */ // Label 3571: @169209
     /* 169209 */ GIM_Try, /*On fail goto*//*Label 3672*/ GIMT_Encode4(169453),
     /* 169214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 169217 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 169220 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /* 169223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169227 */   GIM_Try, /*On fail goto*//*Label 3673*/ GIMT_Encode4(169291), // Rule ID 9627 //
     /* 169232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 169235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 169239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169243 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169246 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169250 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169264 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169271 */     // (fma:{ *:[v16f32] } (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VFMADD132PSZm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 169271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSZm),
     /* 169274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169276 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 169278 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 169280 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 169284 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169289 */     GIR_RootConstrainSelectedInstOperands,
     /* 169290 */     // GIR_Coverage, 9627,
     /* 169290 */     GIR_EraseRootFromParent_Done,
     /* 169291 */   // Label 3673: @169291
     /* 169291 */   GIM_Try, /*On fail goto*//*Label 3674*/ GIMT_Encode4(169355), // Rule ID 9087 //
     /* 169296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 169299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169311 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169314 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169318 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169328 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169335 */     // (fma:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src2, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16f32] }:$src1)  =>  (VFMADD231PSZm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 169335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSZm),
     /* 169338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169340 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 169342 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 169344 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 169348 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169353 */     GIR_RootConstrainSelectedInstOperands,
     /* 169354 */     // GIR_Coverage, 9087,
     /* 169354 */     GIR_EraseRootFromParent_Done,
     /* 169355 */   // Label 3674: @169355
     /* 169355 */   GIM_Try, /*On fail goto*//*Label 3675*/ GIMT_Encode4(169419), // Rule ID 8448 //
     /* 169360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 169363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 169375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169379 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169382 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169386 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169392 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169399 */     // (fma:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src2, VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSZm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 169399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZm),
     /* 169402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169404 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 169406 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 169408 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 169412 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169417 */     GIR_RootConstrainSelectedInstOperands,
     /* 169418 */     // GIR_Coverage, 8448,
     /* 169418 */     GIR_EraseRootFromParent_Done,
     /* 169419 */   // Label 3675: @169419
     /* 169419 */   GIM_Try, /*On fail goto*//*Label 3676*/ GIMT_Encode4(169452), // Rule ID 8444 //
     /* 169424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 169427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169439 */     // (fma:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src2, VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src3)  =>  (VFMADD213PSZr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2, VR512:{ *:[v16f32] }:$src3)
     /* 169439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZr),
     /* 169442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169444 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 169446 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 169448 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 169450 */     GIR_RootConstrainSelectedInstOperands,
     /* 169451 */     // GIR_Coverage, 8444,
     /* 169451 */     GIR_EraseRootFromParent_Done,
     /* 169452 */   // Label 3676: @169452
     /* 169452 */   GIM_Reject,
     /* 169453 */ // Label 3672: @169453
     /* 169453 */ GIM_Reject,
     /* 169454 */ // Label 3572: @169454
     /* 169454 */ GIM_Try, /*On fail goto*//*Label 3677*/ GIMT_Encode4(169698),
     /* 169459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 169462 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 169465 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s16,
     /* 169468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169472 */   GIM_Try, /*On fail goto*//*Label 3678*/ GIMT_Encode4(169536), // Rule ID 9595 //
     /* 169477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 169480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 169484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169488 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169491 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169495 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169509 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169516 */     // (fma:{ *:[v32f16] } (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VFMADD132PHZm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 169516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PHZm),
     /* 169519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169521 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 169523 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 169525 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 169529 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169534 */     GIR_RootConstrainSelectedInstOperands,
     /* 169535 */     // GIR_Coverage, 9595,
     /* 169535 */     GIR_EraseRootFromParent_Done,
     /* 169536 */   // Label 3678: @169536
     /* 169536 */   GIM_Try, /*On fail goto*//*Label 3679*/ GIMT_Encode4(169600), // Rule ID 9055 //
     /* 169541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 169544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169556 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169559 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169563 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169573 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169580 */     // (fma:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src2, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32f16] }:$src1)  =>  (VFMADD231PHZm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 169580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PHZm),
     /* 169583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169585 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 169587 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 169589 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 169593 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169598 */     GIR_RootConstrainSelectedInstOperands,
     /* 169599 */     // GIR_Coverage, 9055,
     /* 169599 */     GIR_EraseRootFromParent_Done,
     /* 169600 */   // Label 3679: @169600
     /* 169600 */   GIM_Try, /*On fail goto*//*Label 3680*/ GIMT_Encode4(169664), // Rule ID 8409 //
     /* 169605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 169608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 169620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169624 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169627 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169631 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169637 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169644 */     // (fma:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src2, VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PHZm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 169644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZm),
     /* 169647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169649 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 169651 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 169653 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 169657 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169662 */     GIR_RootConstrainSelectedInstOperands,
     /* 169663 */     // GIR_Coverage, 8409,
     /* 169663 */     GIR_EraseRootFromParent_Done,
     /* 169664 */   // Label 3680: @169664
     /* 169664 */   GIM_Try, /*On fail goto*//*Label 3681*/ GIMT_Encode4(169697), // Rule ID 8405 //
     /* 169669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 169672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169684 */     // (fma:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src2, VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src3)  =>  (VFMADD213PHZr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2, VR512:{ *:[v32f16] }:$src3)
     /* 169684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZr),
     /* 169687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169689 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 169691 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 169693 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 169695 */     GIR_RootConstrainSelectedInstOperands,
     /* 169696 */     // GIR_Coverage, 8405,
     /* 169696 */     GIR_EraseRootFromParent_Done,
     /* 169697 */   // Label 3681: @169697
     /* 169697 */   GIM_Reject,
     /* 169698 */ // Label 3677: @169698
     /* 169698 */ GIM_Reject,
     /* 169699 */ // Label 3573: @169699
     /* 169699 */ GIM_Reject,
     /* 169700 */ // Label 45: @169700
     /* 169700 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 3695*/ GIMT_Encode4(173881),
     /* 169711 */ /*GILLT_s16*//*Label 3682*/ GIMT_Encode4(169795),
     /* 169715 */ /*GILLT_s32*//*Label 3683*/ GIMT_Encode4(169893),
     /* 169719 */ /*GILLT_s64*//*Label 3684*/ GIMT_Encode4(170858),
     /* 169723 */ /*GILLT_s80*//*Label 3685*/ GIMT_Encode4(171967), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 169735 */ /*GILLT_v2s64*//*Label 3686*/ GIMT_Encode4(172533), GIMT_Encode4(0),
     /* 169743 */ /*GILLT_v4s32*//*Label 3687*/ GIMT_Encode4(172763),
     /* 169747 */ /*GILLT_v4s64*//*Label 3688*/ GIMT_Encode4(172993), GIMT_Encode4(0),
     /* 169755 */ /*GILLT_v8s16*//*Label 3689*/ GIMT_Encode4(173192),
     /* 169759 */ /*GILLT_v8s32*//*Label 3690*/ GIMT_Encode4(173290),
     /* 169763 */ /*GILLT_v8s64*//*Label 3691*/ GIMT_Encode4(173489), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 169775 */ /*GILLT_v16s16*//*Label 3692*/ GIMT_Encode4(173587),
     /* 169779 */ /*GILLT_v16s32*//*Label 3693*/ GIMT_Encode4(173685), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 169791 */ /*GILLT_v32s16*//*Label 3694*/ GIMT_Encode4(173783),
     /* 169795 */ // Label 3682: @169795
     /* 169795 */ GIM_Try, /*On fail goto*//*Label 3696*/ GIMT_Encode4(169892),
     /* 169800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 169803 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 169806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 169810 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 169814 */   GIM_Try, /*On fail goto*//*Label 3697*/ GIMT_Encode4(169868), // Rule ID 6126 //
     /* 169819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 169822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169830 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169833 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169837 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169843 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169850 */     // (fdiv:{ *:[f16] } FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 169850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSHZrm),
     /* 169853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169855 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 169857 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 169861 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169866 */     GIR_RootConstrainSelectedInstOperands,
     /* 169867 */     // GIR_Coverage, 6126,
     /* 169867 */     GIR_EraseRootFromParent_Done,
     /* 169868 */   // Label 3697: @169868
     /* 169868 */   GIM_Try, /*On fail goto*//*Label 3698*/ GIMT_Encode4(169891), // Rule ID 6124 //
     /* 169873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 169876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 169880 */     // (fdiv:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VDIVSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 169880 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSHZrr),
     /* 169885 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 169889 */     GIR_RootConstrainSelectedInstOperands,
     /* 169890 */     // GIR_Coverage, 6124,
     /* 169890 */     GIR_Done,
     /* 169891 */   // Label 3698: @169891
     /* 169891 */   GIM_Reject,
     /* 169892 */ // Label 3696: @169892
     /* 169892 */ GIM_Reject,
     /* 169893 */ // Label 3683: @169893
     /* 169893 */ GIM_Try, /*On fail goto*//*Label 3699*/ GIMT_Encode4(170857),
     /* 169898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 169901 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 169904 */   GIM_Try, /*On fail goto*//*Label 3700*/ GIMT_Encode4(169986), // Rule ID 22485 //
     /* 169909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 169912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 169916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 169920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 169928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 169932 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 169936 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169940 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 169943 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 169947 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 169954 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 169958 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 169960 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169967 */     // (fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (DIVSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 169967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVSSrm),
     /* 169970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169972 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 169974 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 169978 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 169984 */     GIR_RootConstrainSelectedInstOperands,
     /* 169985 */     // GIR_Coverage, 22485,
     /* 169985 */     GIR_EraseRootFromParent_Done,
     /* 169986 */   // Label 3700: @169986
     /* 169986 */   GIM_Try, /*On fail goto*//*Label 3701*/ GIMT_Encode4(170068), // Rule ID 22486 //
     /* 169991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 169994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 169998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 170002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 170006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 170010 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 170014 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 170018 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 170022 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 170025 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 170029 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 170036 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 170040 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 170042 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170049 */     // (fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (VDIVSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 170049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSSrm),
     /* 170052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170054 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 170056 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 170060 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 170066 */     GIR_RootConstrainSelectedInstOperands,
     /* 170067 */     // GIR_Coverage, 22486,
     /* 170067 */     GIR_EraseRootFromParent_Done,
     /* 170068 */   // Label 3701: @170068
     /* 170068 */   GIM_Try, /*On fail goto*//*Label 3702*/ GIMT_Encode4(170150), // Rule ID 22487 //
     /* 170073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 170076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 170080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 170084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 170088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 170092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 170096 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 170100 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 170104 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 170107 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 170111 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 170118 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 170122 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 170124 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170131 */     // (fdiv:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (VDIVSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 170131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSSZrm),
     /* 170134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170136 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 170138 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 170142 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 170148 */     GIR_RootConstrainSelectedInstOperands,
     /* 170149 */     // GIR_Coverage, 22487,
     /* 170149 */     GIR_EraseRootFromParent_Done,
     /* 170150 */   // Label 3702: @170150
     /* 170150 */   GIM_Try, /*On fail goto*//*Label 3703*/ GIMT_Encode4(170215), // Rule ID 1031 //
     /* 170155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 170158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 170162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 170166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 170170 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 170177 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 170181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 170185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 170187 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170194 */     // (fdiv:{ *:[f32] } (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP32:{ *:[f32] }:$src1)  =>  (DIVR_FpI16m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 170194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_FpI16m32),
     /* 170197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170199 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 170201 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 170205 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 170208 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 170213 */     GIR_RootConstrainSelectedInstOperands,
     /* 170214 */     // GIR_Coverage, 1031,
     /* 170214 */     GIR_EraseRootFromParent_Done,
     /* 170215 */   // Label 3703: @170215
     /* 170215 */   GIM_Try, /*On fail goto*//*Label 3704*/ GIMT_Encode4(170280), // Rule ID 1033 //
     /* 170220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 170223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 170227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 170231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 170235 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 170242 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 170246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 170250 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 170252 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170259 */     // (fdiv:{ *:[f32] } (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP32:{ *:[f32] }:$src1)  =>  (DIVR_FpI32m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 170259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_FpI32m32),
     /* 170262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170264 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 170266 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 170270 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 170273 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 170278 */     GIR_RootConstrainSelectedInstOperands,
     /* 170279 */     // GIR_Coverage, 1033,
     /* 170279 */     GIR_EraseRootFromParent_Done,
     /* 170280 */   // Label 3704: @170280
     /* 170280 */   GIM_Try, /*On fail goto*//*Label 3705*/ GIMT_Encode4(170345), // Rule ID 1021 //
     /* 170285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 170288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 170292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 170296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 170300 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170303 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 170307 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 170311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 170315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 170317 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170324 */     // (fdiv:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP32:{ *:[f32] }:$src1)  =>  (DIVR_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 170324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp32m),
     /* 170327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170329 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 170331 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 170335 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 170338 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 170343 */     GIR_RootConstrainSelectedInstOperands,
     /* 170344 */     // GIR_Coverage, 1021,
     /* 170344 */     GIR_EraseRootFromParent_Done,
     /* 170345 */   // Label 3705: @170345
     /* 170345 */   GIM_Try, /*On fail goto*//*Label 3706*/ GIMT_Encode4(170410), // Rule ID 1009 //
     /* 170350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 170353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 170357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 170361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 170365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 170369 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 170376 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 170380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 170382 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170389 */     // (fdiv:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (DIV_FpI16m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 170389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_FpI16m32),
     /* 170392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170394 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 170396 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 170400 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 170403 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 170408 */     GIR_RootConstrainSelectedInstOperands,
     /* 170409 */     // GIR_Coverage, 1009,
     /* 170409 */     GIR_EraseRootFromParent_Done,
     /* 170410 */   // Label 3706: @170410
     /* 170410 */   GIM_Try, /*On fail goto*//*Label 3707*/ GIMT_Encode4(170475), // Rule ID 1011 //
     /* 170415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 170418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 170422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 170426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 170430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 170434 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 170441 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 170445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 170447 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170454 */     // (fdiv:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (DIV_FpI32m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 170454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_FpI32m32),
     /* 170457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170459 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 170461 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 170465 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 170468 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 170473 */     GIR_RootConstrainSelectedInstOperands,
     /* 170474 */     // GIR_Coverage, 1011,
     /* 170474 */     GIR_EraseRootFromParent_Done,
     /* 170475 */   // Label 3707: @170475
     /* 170475 */   GIM_Try, /*On fail goto*//*Label 3708*/ GIMT_Encode4(170540), // Rule ID 999 //
     /* 170480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 170483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 170487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 170491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 170495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 170499 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170502 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 170506 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 170510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 170512 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170519 */     // (fdiv:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (DIV_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 170519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp32m),
     /* 170522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170524 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 170526 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 170530 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 170533 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 170538 */     GIR_RootConstrainSelectedInstOperands,
     /* 170539 */     // GIR_Coverage, 999,
     /* 170539 */     GIR_EraseRootFromParent_Done,
     /* 170540 */   // Label 3708: @170540
     /* 170540 */   GIM_Try, /*On fail goto*//*Label 3709*/ GIMT_Encode4(170602), // Rule ID 2281 //
     /* 170545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 170548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 170552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 170556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 170560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 170564 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170567 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 170571 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 170575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 170577 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170584 */     // (fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 170584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSSrm),
     /* 170587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170589 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 170591 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 170595 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 170600 */     GIR_RootConstrainSelectedInstOperands,
     /* 170601 */     // GIR_Coverage, 2281,
     /* 170601 */     GIR_EraseRootFromParent_Done,
     /* 170602 */   // Label 3709: @170602
     /* 170602 */   GIM_Try, /*On fail goto*//*Label 3710*/ GIMT_Encode4(170664), // Rule ID 2289 //
     /* 170607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 170610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 170614 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 170618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 170622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 170626 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170629 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 170633 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 170637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 170639 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170646 */     // (fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (DIVSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 170646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVSSrm),
     /* 170649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170651 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 170653 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 170657 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 170662 */     GIR_RootConstrainSelectedInstOperands,
     /* 170663 */     // GIR_Coverage, 2289,
     /* 170663 */     GIR_EraseRootFromParent_Done,
     /* 170664 */   // Label 3710: @170664
     /* 170664 */   GIM_Try, /*On fail goto*//*Label 3711*/ GIMT_Encode4(170726), // Rule ID 6088 //
     /* 170669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 170672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 170676 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 170680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 170684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 170688 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170691 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 170695 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 170699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 170701 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170708 */     // (fdiv:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 170708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSSZrm),
     /* 170711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170713 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 170715 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 170719 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 170724 */     GIR_RootConstrainSelectedInstOperands,
     /* 170725 */     // GIR_Coverage, 6088,
     /* 170725 */     GIR_EraseRootFromParent_Done,
     /* 170726 */   // Label 3711: @170726
     /* 170726 */   GIM_Try, /*On fail goto*//*Label 3712*/ GIMT_Encode4(170763), // Rule ID 905 //
     /* 170731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 170734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 170738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 170742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 170746 */     // (fdiv:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (DIV_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 170746 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIV_Fp32),
     /* 170751 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 170757 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 170761 */     GIR_RootConstrainSelectedInstOperands,
     /* 170762 */     // GIR_Coverage, 905,
     /* 170762 */     GIR_Done,
     /* 170763 */   // Label 3712: @170763
     /* 170763 */   GIM_Try, /*On fail goto*//*Label 3713*/ GIMT_Encode4(170794), // Rule ID 2279 //
     /* 170768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 170771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 170775 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 170779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 170783 */     // (fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VDIVSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 170783 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSSrr),
     /* 170788 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 170792 */     GIR_RootConstrainSelectedInstOperands,
     /* 170793 */     // GIR_Coverage, 2279,
     /* 170793 */     GIR_Done,
     /* 170794 */   // Label 3713: @170794
     /* 170794 */   GIM_Try, /*On fail goto*//*Label 3714*/ GIMT_Encode4(170825), // Rule ID 2287 //
     /* 170799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 170802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 170806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 170810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 170814 */     // (fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (DIVSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 170814 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVSSrr),
     /* 170819 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 170823 */     GIR_RootConstrainSelectedInstOperands,
     /* 170824 */     // GIR_Coverage, 2287,
     /* 170824 */     GIR_Done,
     /* 170825 */   // Label 3714: @170825
     /* 170825 */   GIM_Try, /*On fail goto*//*Label 3715*/ GIMT_Encode4(170856), // Rule ID 6086 //
     /* 170830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 170833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 170837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 170841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 170845 */     // (fdiv:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VDIVSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 170845 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSSZrr),
     /* 170850 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 170854 */     GIR_RootConstrainSelectedInstOperands,
     /* 170855 */     // GIR_Coverage, 6086,
     /* 170855 */     GIR_Done,
     /* 170856 */   // Label 3715: @170856
     /* 170856 */   GIM_Reject,
     /* 170857 */ // Label 3699: @170857
     /* 170857 */ GIM_Reject,
     /* 170858 */ // Label 3684: @170858
     /* 170858 */ GIM_Try, /*On fail goto*//*Label 3716*/ GIMT_Encode4(171966),
     /* 170863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 170866 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 170869 */   GIM_Try, /*On fail goto*//*Label 3717*/ GIMT_Encode4(170951), // Rule ID 22488 //
     /* 170874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 170877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 170881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 170885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 170889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 170893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 170897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 170901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 170905 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 170908 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 170912 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 170919 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 170923 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 170925 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170932 */     // (fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (DIVSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 170932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVSDrm),
     /* 170935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170937 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 170939 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 170943 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 170949 */     GIR_RootConstrainSelectedInstOperands,
     /* 170950 */     // GIR_Coverage, 22488,
     /* 170950 */     GIR_EraseRootFromParent_Done,
     /* 170951 */   // Label 3717: @170951
     /* 170951 */   GIM_Try, /*On fail goto*//*Label 3718*/ GIMT_Encode4(171033), // Rule ID 22489 //
     /* 170956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 170959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 170963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 170967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 170971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 170975 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 170979 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 170983 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 170987 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 170990 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 170994 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 171001 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 171005 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 171007 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 171014 */     // (fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (VDIVSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 171014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSDrm),
     /* 171017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171019 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 171021 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 171025 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 171031 */     GIR_RootConstrainSelectedInstOperands,
     /* 171032 */     // GIR_Coverage, 22489,
     /* 171032 */     GIR_EraseRootFromParent_Done,
     /* 171033 */   // Label 3718: @171033
     /* 171033 */   GIM_Try, /*On fail goto*//*Label 3719*/ GIMT_Encode4(171115), // Rule ID 22490 //
     /* 171038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 171041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 171045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 171049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 171053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 171057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 171061 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 171065 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 171069 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 171072 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 171076 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 171083 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 171087 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 171089 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 171096 */     // (fdiv:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (VDIVSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 171096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSDZrm),
     /* 171099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171101 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 171103 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 171107 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 171113 */     GIR_RootConstrainSelectedInstOperands,
     /* 171114 */     // GIR_Coverage, 22490,
     /* 171114 */     GIR_EraseRootFromParent_Done,
     /* 171115 */   // Label 3719: @171115
     /* 171115 */   GIM_Try, /*On fail goto*//*Label 3720*/ GIMT_Encode4(171180), // Rule ID 1035 //
     /* 171120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 171123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 171131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 171135 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 171142 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 171146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 171152 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 171159 */     // (fdiv:{ *:[f64] } (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP64:{ *:[f64] }:$src1)  =>  (DIVR_FpI16m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 171159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_FpI16m64),
     /* 171162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171164 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 171166 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 171170 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 171173 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 171178 */     GIR_RootConstrainSelectedInstOperands,
     /* 171179 */     // GIR_Coverage, 1035,
     /* 171179 */     GIR_EraseRootFromParent_Done,
     /* 171180 */   // Label 3720: @171180
     /* 171180 */   GIM_Try, /*On fail goto*//*Label 3721*/ GIMT_Encode4(171245), // Rule ID 1037 //
     /* 171185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 171188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 171196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 171200 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 171207 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 171211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 171217 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 171224 */     // (fdiv:{ *:[f64] } (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP64:{ *:[f64] }:$src1)  =>  (DIVR_FpI32m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 171224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_FpI32m64),
     /* 171227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171229 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 171231 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 171235 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 171238 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 171243 */     GIR_RootConstrainSelectedInstOperands,
     /* 171244 */     // GIR_Coverage, 1037,
     /* 171244 */     GIR_EraseRootFromParent_Done,
     /* 171245 */   // Label 3721: @171245
     /* 171245 */   GIM_Try, /*On fail goto*//*Label 3722*/ GIMT_Encode4(171310), // Rule ID 1023 //
     /* 171250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 171253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 171261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 171265 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171268 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 171272 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 171276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 171282 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 171289 */     // (fdiv:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP64:{ *:[f64] }:$src1)  =>  (DIVR_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 171289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp64m),
     /* 171292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171294 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 171296 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 171300 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 171303 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 171308 */     GIR_RootConstrainSelectedInstOperands,
     /* 171309 */     // GIR_Coverage, 1023,
     /* 171309 */     GIR_EraseRootFromParent_Done,
     /* 171310 */   // Label 3722: @171310
     /* 171310 */   GIM_Try, /*On fail goto*//*Label 3723*/ GIMT_Encode4(171382), // Rule ID 1025 //
     /* 171315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 171318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 171326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 171330 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171333 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 171337 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 171344 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 171348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 171354 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 171361 */     // (fdiv:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP64:{ *:[f64] }:$src1)  =>  (DIVR_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 171361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp64m32),
     /* 171364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171366 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 171368 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 171372 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 171375 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 171380 */     GIR_RootConstrainSelectedInstOperands,
     /* 171381 */     // GIR_Coverage, 1025,
     /* 171381 */     GIR_EraseRootFromParent_Done,
     /* 171382 */   // Label 3723: @171382
     /* 171382 */   GIM_Try, /*On fail goto*//*Label 3724*/ GIMT_Encode4(171447), // Rule ID 1013 //
     /* 171387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 171390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 171402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 171406 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 171413 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 171417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 171419 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 171426 */     // (fdiv:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (DIV_FpI16m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 171426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_FpI16m64),
     /* 171429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171431 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 171433 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 171437 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 171440 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 171445 */     GIR_RootConstrainSelectedInstOperands,
     /* 171446 */     // GIR_Coverage, 1013,
     /* 171446 */     GIR_EraseRootFromParent_Done,
     /* 171447 */   // Label 3724: @171447
     /* 171447 */   GIM_Try, /*On fail goto*//*Label 3725*/ GIMT_Encode4(171512), // Rule ID 1015 //
     /* 171452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 171455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 171467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 171471 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 171478 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 171482 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 171484 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 171491 */     // (fdiv:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (DIV_FpI32m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 171491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_FpI32m64),
     /* 171494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171496 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 171498 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 171502 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 171505 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 171510 */     GIR_RootConstrainSelectedInstOperands,
     /* 171511 */     // GIR_Coverage, 1015,
     /* 171511 */     GIR_EraseRootFromParent_Done,
     /* 171512 */   // Label 3725: @171512
     /* 171512 */   GIM_Try, /*On fail goto*//*Label 3726*/ GIMT_Encode4(171577), // Rule ID 1001 //
     /* 171517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 171520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 171532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 171536 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171539 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 171543 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 171547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 171549 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 171556 */     // (fdiv:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (DIV_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 171556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp64m),
     /* 171559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171561 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 171563 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 171567 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 171570 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 171575 */     GIR_RootConstrainSelectedInstOperands,
     /* 171576 */     // GIR_Coverage, 1001,
     /* 171576 */     GIR_EraseRootFromParent_Done,
     /* 171577 */   // Label 3726: @171577
     /* 171577 */   GIM_Try, /*On fail goto*//*Label 3727*/ GIMT_Encode4(171649), // Rule ID 1003 //
     /* 171582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 171585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 171597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 171601 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171604 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 171608 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 171615 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 171619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 171621 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 171628 */     // (fdiv:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (DIV_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 171628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp64m32),
     /* 171631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171633 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 171635 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 171639 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 171642 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 171647 */     GIR_RootConstrainSelectedInstOperands,
     /* 171648 */     // GIR_Coverage, 1003,
     /* 171648 */     GIR_EraseRootFromParent_Done,
     /* 171649 */   // Label 3727: @171649
     /* 171649 */   GIM_Try, /*On fail goto*//*Label 3728*/ GIMT_Encode4(171711), // Rule ID 2285 //
     /* 171654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 171657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 171661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 171665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 171669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 171673 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171676 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 171680 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 171684 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 171686 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 171693 */     // (fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 171693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSDrm),
     /* 171696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171698 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 171700 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 171704 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 171709 */     GIR_RootConstrainSelectedInstOperands,
     /* 171710 */     // GIR_Coverage, 2285,
     /* 171710 */     GIR_EraseRootFromParent_Done,
     /* 171711 */   // Label 3728: @171711
     /* 171711 */   GIM_Try, /*On fail goto*//*Label 3729*/ GIMT_Encode4(171773), // Rule ID 2293 //
     /* 171716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 171719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 171723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 171727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 171731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 171735 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171738 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 171742 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 171746 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 171748 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 171755 */     // (fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (DIVSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 171755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVSDrm),
     /* 171758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171760 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 171762 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 171766 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 171771 */     GIR_RootConstrainSelectedInstOperands,
     /* 171772 */     // GIR_Coverage, 2293,
     /* 171772 */     GIR_EraseRootFromParent_Done,
     /* 171773 */   // Label 3729: @171773
     /* 171773 */   GIM_Try, /*On fail goto*//*Label 3730*/ GIMT_Encode4(171835), // Rule ID 6107 //
     /* 171778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 171781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 171785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 171789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 171793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 171797 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171800 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 171804 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 171808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 171810 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 171817 */     // (fdiv:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 171817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSDZrm),
     /* 171820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171822 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 171824 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 171828 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 171833 */     GIR_RootConstrainSelectedInstOperands,
     /* 171834 */     // GIR_Coverage, 6107,
     /* 171834 */     GIR_EraseRootFromParent_Done,
     /* 171835 */   // Label 3730: @171835
     /* 171835 */   GIM_Try, /*On fail goto*//*Label 3731*/ GIMT_Encode4(171872), // Rule ID 907 //
     /* 171840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 171843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171855 */     // (fdiv:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (DIV_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 171855 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIV_Fp64),
     /* 171860 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 171866 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 171870 */     GIR_RootConstrainSelectedInstOperands,
     /* 171871 */     // GIR_Coverage, 907,
     /* 171871 */     GIR_Done,
     /* 171872 */   // Label 3731: @171872
     /* 171872 */   GIM_Try, /*On fail goto*//*Label 3732*/ GIMT_Encode4(171903), // Rule ID 2283 //
     /* 171877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 171880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 171884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 171888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 171892 */     // (fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VDIVSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 171892 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSDrr),
     /* 171897 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 171901 */     GIR_RootConstrainSelectedInstOperands,
     /* 171902 */     // GIR_Coverage, 2283,
     /* 171902 */     GIR_Done,
     /* 171903 */   // Label 3732: @171903
     /* 171903 */   GIM_Try, /*On fail goto*//*Label 3733*/ GIMT_Encode4(171934), // Rule ID 2291 //
     /* 171908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 171911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 171915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 171919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 171923 */     // (fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (DIVSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 171923 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVSDrr),
     /* 171928 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 171932 */     GIR_RootConstrainSelectedInstOperands,
     /* 171933 */     // GIR_Coverage, 2291,
     /* 171933 */     GIR_Done,
     /* 171934 */   // Label 3733: @171934
     /* 171934 */   GIM_Try, /*On fail goto*//*Label 3734*/ GIMT_Encode4(171965), // Rule ID 6105 //
     /* 171939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 171942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 171946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 171950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 171954 */     // (fdiv:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VDIVSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 171954 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSDZrr),
     /* 171959 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 171963 */     GIR_RootConstrainSelectedInstOperands,
     /* 171964 */     // GIR_Coverage, 6105,
     /* 171964 */     GIR_Done,
     /* 171965 */   // Label 3734: @171965
     /* 171965 */   GIM_Reject,
     /* 171966 */ // Label 3716: @171966
     /* 171966 */ GIM_Reject,
     /* 171967 */ // Label 3685: @171967
     /* 171967 */ GIM_Try, /*On fail goto*//*Label 3735*/ GIMT_Encode4(172532),
     /* 171972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 171975 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 171978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 171982 */   GIM_Try, /*On fail goto*//*Label 3736*/ GIMT_Encode4(172043), // Rule ID 1039 //
     /* 171987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 171990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 171994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 171998 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 172005 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 172013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172015 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172022 */     // (fdiv:{ *:[f80] } (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP80:{ *:[f80] }:$src1)  =>  (DIVR_FpI16m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 172022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_FpI16m80),
     /* 172025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172027 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 172029 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 172033 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 172036 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172041 */     GIR_RootConstrainSelectedInstOperands,
     /* 172042 */     // GIR_Coverage, 1039,
     /* 172042 */     GIR_EraseRootFromParent_Done,
     /* 172043 */   // Label 3736: @172043
     /* 172043 */   GIM_Try, /*On fail goto*//*Label 3737*/ GIMT_Encode4(172104), // Rule ID 1041 //
     /* 172048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 172051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 172055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 172059 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 172066 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 172074 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172076 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172083 */     // (fdiv:{ *:[f80] } (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP80:{ *:[f80] }:$src1)  =>  (DIVR_FpI32m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 172083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_FpI32m80),
     /* 172086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172088 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 172090 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 172094 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 172097 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172102 */     GIR_RootConstrainSelectedInstOperands,
     /* 172103 */     // GIR_Coverage, 1041,
     /* 172103 */     GIR_EraseRootFromParent_Done,
     /* 172104 */   // Label 3737: @172104
     /* 172104 */   GIM_Try, /*On fail goto*//*Label 3738*/ GIMT_Encode4(172172), // Rule ID 1027 //
     /* 172109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 172112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 172116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172120 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172123 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172127 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 172134 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 172142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172144 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172151 */     // (fdiv:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP80:{ *:[f80] }:$src1)  =>  (DIVR_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 172151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp80m32),
     /* 172154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172156 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 172158 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 172162 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 172165 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172170 */     GIR_RootConstrainSelectedInstOperands,
     /* 172171 */     // GIR_Coverage, 1027,
     /* 172171 */     GIR_EraseRootFromParent_Done,
     /* 172172 */   // Label 3738: @172172
     /* 172172 */   GIM_Try, /*On fail goto*//*Label 3739*/ GIMT_Encode4(172240), // Rule ID 1029 //
     /* 172177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 172180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 172184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172188 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172191 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172195 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 172202 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 172210 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172212 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172219 */     // (fdiv:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>, RFP80:{ *:[f80] }:$src1)  =>  (DIVR_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 172219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp80m64),
     /* 172222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172224 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 172226 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 172230 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 172233 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172238 */     GIR_RootConstrainSelectedInstOperands,
     /* 172239 */     // GIR_Coverage, 1029,
     /* 172239 */     GIR_EraseRootFromParent_Done,
     /* 172240 */   // Label 3739: @172240
     /* 172240 */   GIM_Try, /*On fail goto*//*Label 3740*/ GIMT_Encode4(172301), // Rule ID 1017 //
     /* 172245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 172248 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 172252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 172256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 172260 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 172267 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172273 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172280 */     // (fdiv:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (DIV_FpI16m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 172280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_FpI16m80),
     /* 172283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172285 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 172287 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 172291 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 172294 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172299 */     GIR_RootConstrainSelectedInstOperands,
     /* 172300 */     // GIR_Coverage, 1017,
     /* 172300 */     GIR_EraseRootFromParent_Done,
     /* 172301 */   // Label 3740: @172301
     /* 172301 */   GIM_Try, /*On fail goto*//*Label 3741*/ GIMT_Encode4(172362), // Rule ID 1019 //
     /* 172306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 172309 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 172313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 172317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 172321 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 172328 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172332 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172334 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172341 */     // (fdiv:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (DIV_FpI32m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 172341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_FpI32m80),
     /* 172344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172346 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 172348 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 172352 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 172355 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172360 */     GIR_RootConstrainSelectedInstOperands,
     /* 172361 */     // GIR_Coverage, 1019,
     /* 172361 */     GIR_EraseRootFromParent_Done,
     /* 172362 */   // Label 3741: @172362
     /* 172362 */   GIM_Try, /*On fail goto*//*Label 3742*/ GIMT_Encode4(172430), // Rule ID 1005 //
     /* 172367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 172370 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 172374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 172378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172382 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172385 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172389 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 172396 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172400 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172402 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172409 */     // (fdiv:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (DIV_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 172409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp80m32),
     /* 172412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172414 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 172416 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 172420 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 172423 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172428 */     GIR_RootConstrainSelectedInstOperands,
     /* 172429 */     // GIR_Coverage, 1005,
     /* 172429 */     GIR_EraseRootFromParent_Done,
     /* 172430 */   // Label 3742: @172430
     /* 172430 */   GIM_Try, /*On fail goto*//*Label 3743*/ GIMT_Encode4(172498), // Rule ID 1007 //
     /* 172435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 172438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 172442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 172446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172450 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172453 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172457 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 172464 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172468 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172470 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172477 */     // (fdiv:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>)  =>  (DIV_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 172477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp80m64),
     /* 172480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172482 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 172484 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 172488 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 172491 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172496 */     GIR_RootConstrainSelectedInstOperands,
     /* 172497 */     // GIR_Coverage, 1007,
     /* 172497 */     GIR_EraseRootFromParent_Done,
     /* 172498 */   // Label 3743: @172498
     /* 172498 */   GIM_Try, /*On fail goto*//*Label 3744*/ GIMT_Encode4(172531), // Rule ID 909 //
     /* 172503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 172506 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 172510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 172514 */     // (fdiv:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (DIV_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 172514 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIV_Fp80),
     /* 172519 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 172525 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 172529 */     GIR_RootConstrainSelectedInstOperands,
     /* 172530 */     // GIR_Coverage, 909,
     /* 172530 */     GIR_Done,
     /* 172531 */   // Label 3744: @172531
     /* 172531 */   GIM_Reject,
     /* 172532 */ // Label 3735: @172532
     /* 172532 */ GIM_Reject,
     /* 172533 */ // Label 3686: @172533
     /* 172533 */ GIM_Try, /*On fail goto*//*Label 3745*/ GIMT_Encode4(172762),
     /* 172538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 172541 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 172544 */   GIM_Try, /*On fail goto*//*Label 3746*/ GIMT_Encode4(172606), // Rule ID 2261 //
     /* 172549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 172552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 172556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 172560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 172564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172568 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172571 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172575 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172581 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172588 */     // (fdiv:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 172588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDrm),
     /* 172591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172593 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 172595 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 172599 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172604 */     GIR_RootConstrainSelectedInstOperands,
     /* 172605 */     // GIR_Coverage, 2261,
     /* 172605 */     GIR_EraseRootFromParent_Done,
     /* 172606 */   // Label 3746: @172606
     /* 172606 */   GIM_Try, /*On fail goto*//*Label 3747*/ GIMT_Encode4(172668), // Rule ID 6660 //
     /* 172611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 172614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 172618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 172622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 172626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172630 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172633 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172637 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172643 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172650 */     // (fdiv:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 172650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ128rm),
     /* 172653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172655 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 172657 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 172661 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172666 */     GIR_RootConstrainSelectedInstOperands,
     /* 172667 */     // GIR_Coverage, 6660,
     /* 172667 */     GIR_EraseRootFromParent_Done,
     /* 172668 */   // Label 3747: @172668
     /* 172668 */   GIM_Try, /*On fail goto*//*Label 3748*/ GIMT_Encode4(172699), // Rule ID 2259 //
     /* 172673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 172676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 172680 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 172684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 172688 */     // (fdiv:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VDIVPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 172688 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDrr),
     /* 172693 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 172697 */     GIR_RootConstrainSelectedInstOperands,
     /* 172698 */     // GIR_Coverage, 2259,
     /* 172698 */     GIR_Done,
     /* 172699 */   // Label 3748: @172699
     /* 172699 */   GIM_Try, /*On fail goto*//*Label 3749*/ GIMT_Encode4(172730), // Rule ID 2275 //
     /* 172704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 172707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 172711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 172715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 172719 */     // (fdiv:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (DIVPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 172719 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVPDrr),
     /* 172724 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 172728 */     GIR_RootConstrainSelectedInstOperands,
     /* 172729 */     // GIR_Coverage, 2275,
     /* 172729 */     GIR_Done,
     /* 172730 */   // Label 3749: @172730
     /* 172730 */   GIM_Try, /*On fail goto*//*Label 3750*/ GIMT_Encode4(172761), // Rule ID 6656 //
     /* 172735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 172738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 172742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 172746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 172750 */     // (fdiv:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VDIVPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 172750 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ128rr),
     /* 172755 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 172759 */     GIR_RootConstrainSelectedInstOperands,
     /* 172760 */     // GIR_Coverage, 6656,
     /* 172760 */     GIR_Done,
     /* 172761 */   // Label 3750: @172761
     /* 172761 */   GIM_Reject,
     /* 172762 */ // Label 3745: @172762
     /* 172762 */ GIM_Reject,
     /* 172763 */ // Label 3687: @172763
     /* 172763 */ GIM_Try, /*On fail goto*//*Label 3751*/ GIMT_Encode4(172992),
     /* 172768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 172771 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172774 */   GIM_Try, /*On fail goto*//*Label 3752*/ GIMT_Encode4(172836), // Rule ID 2257 //
     /* 172779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 172782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 172786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 172790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 172794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172798 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172801 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172805 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172811 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172818 */     // (fdiv:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 172818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSrm),
     /* 172821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172823 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 172825 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 172829 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172834 */     GIR_RootConstrainSelectedInstOperands,
     /* 172835 */     // GIR_Coverage, 2257,
     /* 172835 */     GIR_EraseRootFromParent_Done,
     /* 172836 */   // Label 3752: @172836
     /* 172836 */   GIM_Try, /*On fail goto*//*Label 3753*/ GIMT_Encode4(172898), // Rule ID 6636 //
     /* 172841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 172844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 172848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 172852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 172856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172860 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172863 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172867 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172873 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172880 */     // (fdiv:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 172880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ128rm),
     /* 172883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172885 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 172887 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 172891 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172896 */     GIR_RootConstrainSelectedInstOperands,
     /* 172897 */     // GIR_Coverage, 6636,
     /* 172897 */     GIR_EraseRootFromParent_Done,
     /* 172898 */   // Label 3753: @172898
     /* 172898 */   GIM_Try, /*On fail goto*//*Label 3754*/ GIMT_Encode4(172929), // Rule ID 2255 //
     /* 172903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 172906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 172910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 172914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 172918 */     // (fdiv:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VDIVPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 172918 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSrr),
     /* 172923 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 172927 */     GIR_RootConstrainSelectedInstOperands,
     /* 172928 */     // GIR_Coverage, 2255,
     /* 172928 */     GIR_Done,
     /* 172929 */   // Label 3754: @172929
     /* 172929 */   GIM_Try, /*On fail goto*//*Label 3755*/ GIMT_Encode4(172960), // Rule ID 2271 //
     /* 172934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 172937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 172941 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 172945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 172949 */     // (fdiv:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (DIVPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 172949 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVPSrr),
     /* 172954 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 172958 */     GIR_RootConstrainSelectedInstOperands,
     /* 172959 */     // GIR_Coverage, 2271,
     /* 172959 */     GIR_Done,
     /* 172960 */   // Label 3755: @172960
     /* 172960 */   GIM_Try, /*On fail goto*//*Label 3756*/ GIMT_Encode4(172991), // Rule ID 6632 //
     /* 172965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 172968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 172972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 172976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 172980 */     // (fdiv:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VDIVPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 172980 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ128rr),
     /* 172985 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 172989 */     GIR_RootConstrainSelectedInstOperands,
     /* 172990 */     // GIR_Coverage, 6632,
     /* 172990 */     GIR_Done,
     /* 172991 */   // Label 3756: @172991
     /* 172991 */   GIM_Reject,
     /* 172992 */ // Label 3751: @172992
     /* 172992 */ GIM_Reject,
     /* 172993 */ // Label 3688: @172993
     /* 172993 */ GIM_Try, /*On fail goto*//*Label 3757*/ GIMT_Encode4(173191),
     /* 172998 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 173001 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 173004 */   GIM_Try, /*On fail goto*//*Label 3758*/ GIMT_Encode4(173066), // Rule ID 2269 //
     /* 173009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 173012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 173016 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 173020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 173024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 173028 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173031 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 173035 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 173039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173041 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173048 */     // (fdiv:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 173048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDYrm),
     /* 173051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173053 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 173055 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 173059 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173064 */     GIR_RootConstrainSelectedInstOperands,
     /* 173065 */     // GIR_Coverage, 2269,
     /* 173065 */     GIR_EraseRootFromParent_Done,
     /* 173066 */   // Label 3758: @173066
     /* 173066 */   GIM_Try, /*On fail goto*//*Label 3759*/ GIMT_Encode4(173128), // Rule ID 6672 //
     /* 173071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 173074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 173078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 173082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 173086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 173090 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173093 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 173097 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 173101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173103 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173110 */     // (fdiv:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 173110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ256rm),
     /* 173113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173115 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 173117 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 173121 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173126 */     GIR_RootConstrainSelectedInstOperands,
     /* 173127 */     // GIR_Coverage, 6672,
     /* 173127 */     GIR_EraseRootFromParent_Done,
     /* 173128 */   // Label 3759: @173128
     /* 173128 */   GIM_Try, /*On fail goto*//*Label 3760*/ GIMT_Encode4(173159), // Rule ID 2267 //
     /* 173133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 173136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 173140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 173144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 173148 */     // (fdiv:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VDIVPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 173148 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDYrr),
     /* 173153 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173157 */     GIR_RootConstrainSelectedInstOperands,
     /* 173158 */     // GIR_Coverage, 2267,
     /* 173158 */     GIR_Done,
     /* 173159 */   // Label 3760: @173159
     /* 173159 */   GIM_Try, /*On fail goto*//*Label 3761*/ GIMT_Encode4(173190), // Rule ID 6668 //
     /* 173164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 173167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 173171 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 173175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 173179 */     // (fdiv:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VDIVPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 173179 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ256rr),
     /* 173184 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173188 */     GIR_RootConstrainSelectedInstOperands,
     /* 173189 */     // GIR_Coverage, 6668,
     /* 173189 */     GIR_Done,
     /* 173190 */   // Label 3761: @173190
     /* 173190 */   GIM_Reject,
     /* 173191 */ // Label 3757: @173191
     /* 173191 */ GIM_Reject,
     /* 173192 */ // Label 3689: @173192
     /* 173192 */ GIM_Try, /*On fail goto*//*Label 3762*/ GIMT_Encode4(173289),
     /* 173197 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 173200 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 173203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 173207 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 173211 */   GIM_Try, /*On fail goto*//*Label 3763*/ GIMT_Encode4(173265), // Rule ID 6696 //
     /* 173216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 173219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 173223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 173227 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173230 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 173234 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 173238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173240 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173247 */     // (fdiv:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 173247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ128rm),
     /* 173250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173252 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 173254 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 173258 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173263 */     GIR_RootConstrainSelectedInstOperands,
     /* 173264 */     // GIR_Coverage, 6696,
     /* 173264 */     GIR_EraseRootFromParent_Done,
     /* 173265 */   // Label 3763: @173265
     /* 173265 */   GIM_Try, /*On fail goto*//*Label 3764*/ GIMT_Encode4(173288), // Rule ID 6692 //
     /* 173270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 173273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 173277 */     // (fdiv:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VDIVPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 173277 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ128rr),
     /* 173282 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173286 */     GIR_RootConstrainSelectedInstOperands,
     /* 173287 */     // GIR_Coverage, 6692,
     /* 173287 */     GIR_Done,
     /* 173288 */   // Label 3764: @173288
     /* 173288 */   GIM_Reject,
     /* 173289 */ // Label 3762: @173289
     /* 173289 */ GIM_Reject,
     /* 173290 */ // Label 3690: @173290
     /* 173290 */ GIM_Try, /*On fail goto*//*Label 3765*/ GIMT_Encode4(173488),
     /* 173295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 173298 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 173301 */   GIM_Try, /*On fail goto*//*Label 3766*/ GIMT_Encode4(173363), // Rule ID 2265 //
     /* 173306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 173309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 173313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 173317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 173321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 173325 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173328 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 173332 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 173336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173338 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173345 */     // (fdiv:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 173345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSYrm),
     /* 173348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173350 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 173352 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 173356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173361 */     GIR_RootConstrainSelectedInstOperands,
     /* 173362 */     // GIR_Coverage, 2265,
     /* 173362 */     GIR_EraseRootFromParent_Done,
     /* 173363 */   // Label 3766: @173363
     /* 173363 */   GIM_Try, /*On fail goto*//*Label 3767*/ GIMT_Encode4(173425), // Rule ID 6648 //
     /* 173368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 173371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 173375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 173379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 173383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 173387 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173390 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 173394 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 173398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173400 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173407 */     // (fdiv:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 173407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ256rm),
     /* 173410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173412 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 173414 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 173418 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173423 */     GIR_RootConstrainSelectedInstOperands,
     /* 173424 */     // GIR_Coverage, 6648,
     /* 173424 */     GIR_EraseRootFromParent_Done,
     /* 173425 */   // Label 3767: @173425
     /* 173425 */   GIM_Try, /*On fail goto*//*Label 3768*/ GIMT_Encode4(173456), // Rule ID 2263 //
     /* 173430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 173433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 173437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 173441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 173445 */     // (fdiv:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VDIVPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 173445 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSYrr),
     /* 173450 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173454 */     GIR_RootConstrainSelectedInstOperands,
     /* 173455 */     // GIR_Coverage, 2263,
     /* 173455 */     GIR_Done,
     /* 173456 */   // Label 3768: @173456
     /* 173456 */   GIM_Try, /*On fail goto*//*Label 3769*/ GIMT_Encode4(173487), // Rule ID 6644 //
     /* 173461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 173464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 173468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 173472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 173476 */     // (fdiv:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VDIVPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 173476 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ256rr),
     /* 173481 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173485 */     GIR_RootConstrainSelectedInstOperands,
     /* 173486 */     // GIR_Coverage, 6644,
     /* 173486 */     GIR_Done,
     /* 173487 */   // Label 3769: @173487
     /* 173487 */   GIM_Reject,
     /* 173488 */ // Label 3765: @173488
     /* 173488 */ GIM_Reject,
     /* 173489 */ // Label 3691: @173489
     /* 173489 */ GIM_Try, /*On fail goto*//*Label 3770*/ GIMT_Encode4(173586),
     /* 173494 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 173497 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 173500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 173504 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 173508 */   GIM_Try, /*On fail goto*//*Label 3771*/ GIMT_Encode4(173562), // Rule ID 6624 //
     /* 173513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 173516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 173520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 173524 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173527 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 173531 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 173535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173537 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173544 */     // (fdiv:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 173544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDZrm),
     /* 173547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173549 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 173551 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 173555 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173560 */     GIR_RootConstrainSelectedInstOperands,
     /* 173561 */     // GIR_Coverage, 6624,
     /* 173561 */     GIR_EraseRootFromParent_Done,
     /* 173562 */   // Label 3771: @173562
     /* 173562 */   GIM_Try, /*On fail goto*//*Label 3772*/ GIMT_Encode4(173585), // Rule ID 6620 //
     /* 173567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 173570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 173574 */     // (fdiv:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VDIVPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 173574 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDZrr),
     /* 173579 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173583 */     GIR_RootConstrainSelectedInstOperands,
     /* 173584 */     // GIR_Coverage, 6620,
     /* 173584 */     GIR_Done,
     /* 173585 */   // Label 3772: @173585
     /* 173585 */   GIM_Reject,
     /* 173586 */ // Label 3770: @173586
     /* 173586 */ GIM_Reject,
     /* 173587 */ // Label 3692: @173587
     /* 173587 */ GIM_Try, /*On fail goto*//*Label 3773*/ GIMT_Encode4(173684),
     /* 173592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 173595 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 173598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 173602 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 173606 */   GIM_Try, /*On fail goto*//*Label 3774*/ GIMT_Encode4(173660), // Rule ID 6708 //
     /* 173611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 173614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 173618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 173622 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173625 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 173629 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 173633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173635 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173642 */     // (fdiv:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 173642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ256rm),
     /* 173645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173647 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 173649 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 173653 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173658 */     GIR_RootConstrainSelectedInstOperands,
     /* 173659 */     // GIR_Coverage, 6708,
     /* 173659 */     GIR_EraseRootFromParent_Done,
     /* 173660 */   // Label 3774: @173660
     /* 173660 */   GIM_Try, /*On fail goto*//*Label 3775*/ GIMT_Encode4(173683), // Rule ID 6704 //
     /* 173665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 173668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 173672 */     // (fdiv:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VDIVPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 173672 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ256rr),
     /* 173677 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173681 */     GIR_RootConstrainSelectedInstOperands,
     /* 173682 */     // GIR_Coverage, 6704,
     /* 173682 */     GIR_Done,
     /* 173683 */   // Label 3775: @173683
     /* 173683 */   GIM_Reject,
     /* 173684 */ // Label 3773: @173684
     /* 173684 */ GIM_Reject,
     /* 173685 */ // Label 3693: @173685
     /* 173685 */ GIM_Try, /*On fail goto*//*Label 3776*/ GIMT_Encode4(173782),
     /* 173690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 173693 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 173696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 173700 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 173704 */   GIM_Try, /*On fail goto*//*Label 3777*/ GIMT_Encode4(173758), // Rule ID 6612 //
     /* 173709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 173712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 173716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 173720 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173723 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 173727 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 173731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173733 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173740 */     // (fdiv:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 173740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSZrm),
     /* 173743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173745 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 173747 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 173751 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173756 */     GIR_RootConstrainSelectedInstOperands,
     /* 173757 */     // GIR_Coverage, 6612,
     /* 173757 */     GIR_EraseRootFromParent_Done,
     /* 173758 */   // Label 3777: @173758
     /* 173758 */   GIM_Try, /*On fail goto*//*Label 3778*/ GIMT_Encode4(173781), // Rule ID 6608 //
     /* 173763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 173766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 173770 */     // (fdiv:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VDIVPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 173770 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSZrr),
     /* 173775 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173779 */     GIR_RootConstrainSelectedInstOperands,
     /* 173780 */     // GIR_Coverage, 6608,
     /* 173780 */     GIR_Done,
     /* 173781 */   // Label 3778: @173781
     /* 173781 */   GIM_Reject,
     /* 173782 */ // Label 3776: @173782
     /* 173782 */ GIM_Reject,
     /* 173783 */ // Label 3694: @173783
     /* 173783 */ GIM_Try, /*On fail goto*//*Label 3779*/ GIMT_Encode4(173880),
     /* 173788 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 173791 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 173794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 173798 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 173802 */   GIM_Try, /*On fail goto*//*Label 3780*/ GIMT_Encode4(173856), // Rule ID 6684 //
     /* 173807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 173810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 173814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 173818 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173821 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 173825 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 173829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173831 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173838 */     // (fdiv:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 173838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPHZrm),
     /* 173841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173843 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 173845 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 173849 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173854 */     GIR_RootConstrainSelectedInstOperands,
     /* 173855 */     // GIR_Coverage, 6684,
     /* 173855 */     GIR_EraseRootFromParent_Done,
     /* 173856 */   // Label 3780: @173856
     /* 173856 */   GIM_Try, /*On fail goto*//*Label 3781*/ GIMT_Encode4(173879), // Rule ID 6680 //
     /* 173861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 173864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 173868 */     // (fdiv:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VDIVPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 173868 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPHZrr),
     /* 173873 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173877 */     GIR_RootConstrainSelectedInstOperands,
     /* 173878 */     // GIR_Coverage, 6680,
     /* 173878 */     GIR_Done,
     /* 173879 */   // Label 3781: @173879
     /* 173879 */   GIM_Reject,
     /* 173880 */ // Label 3779: @173880
     /* 173880 */ GIM_Reject,
     /* 173881 */ // Label 3695: @173881
     /* 173881 */ GIM_Reject,
     /* 173882 */ // Label 46: @173882
     /* 173882 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(6), /*)*//*default:*//*Label 3785*/ GIMT_Encode4(174004),
     /* 173893 */ /*GILLT_s32*//*Label 3782*/ GIMT_Encode4(173905),
     /* 173897 */ /*GILLT_s64*//*Label 3783*/ GIMT_Encode4(173938),
     /* 173901 */ /*GILLT_s80*//*Label 3784*/ GIMT_Encode4(173971),
     /* 173905 */ // Label 3782: @173905
     /* 173905 */ GIM_Try, /*On fail goto*//*Label 3786*/ GIMT_Encode4(173937), // Rule ID 1042 //
     /* 173910 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 173913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 173916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 173920 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 173924 */   // (fneg:{ *:[f32] } RFP32:{ *:[f32] }:$src)  =>  (CHS_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src)
     /* 173924 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CHS_Fp32),
     /* 173929 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 173935 */   GIR_RootConstrainSelectedInstOperands,
     /* 173936 */   // GIR_Coverage, 1042,
     /* 173936 */   GIR_Done,
     /* 173937 */ // Label 3786: @173937
     /* 173937 */ GIM_Reject,
     /* 173938 */ // Label 3783: @173938
     /* 173938 */ GIM_Try, /*On fail goto*//*Label 3787*/ GIMT_Encode4(173970), // Rule ID 1043 //
     /* 173943 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 173946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 173949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 173953 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 173957 */   // (fneg:{ *:[f64] } RFP64:{ *:[f64] }:$src)  =>  (CHS_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src)
     /* 173957 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CHS_Fp64),
     /* 173962 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 173968 */   GIR_RootConstrainSelectedInstOperands,
     /* 173969 */   // GIR_Coverage, 1043,
     /* 173969 */   GIR_Done,
     /* 173970 */ // Label 3787: @173970
     /* 173970 */ GIM_Reject,
     /* 173971 */ // Label 3784: @173971
     /* 173971 */ GIM_Try, /*On fail goto*//*Label 3788*/ GIMT_Encode4(174003), // Rule ID 1044 //
     /* 173976 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 173979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 173982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 173986 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 173990 */   // (fneg:{ *:[f80] } RFP80:{ *:[f80] }:$src)  =>  (CHS_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src)
     /* 173990 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CHS_Fp80),
     /* 173995 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 174001 */   GIR_RootConstrainSelectedInstOperands,
     /* 174002 */   // GIR_Coverage, 1044,
     /* 174002 */   GIR_Done,
     /* 174003 */ // Label 3788: @174003
     /* 174003 */ GIM_Reject,
     /* 174004 */ // Label 3785: @174004
     /* 174004 */ GIM_Reject,
     /* 174005 */ // Label 47: @174005
     /* 174005 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(20), /*)*//*default:*//*Label 3796*/ GIMT_Encode4(174936),
     /* 174016 */ /*GILLT_s32*//*Label 3789*/ GIMT_Encode4(174084),
     /* 174020 */ /*GILLT_s64*//*Label 3790*/ GIMT_Encode4(174205),
     /* 174024 */ /*GILLT_s80*//*Label 3791*/ GIMT_Encode4(174688), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 174048 */ /*GILLT_v4s64*//*Label 3792*/ GIMT_Encode4(174749), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 174060 */ /*GILLT_v8s32*//*Label 3793*/ GIMT_Encode4(174813),
     /* 174064 */ /*GILLT_v8s64*//*Label 3794*/ GIMT_Encode4(174844), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 174080 */ /*GILLT_v16s32*//*Label 3795*/ GIMT_Encode4(174905),
     /* 174084 */ // Label 3789: @174084
     /* 174084 */ GIM_Try, /*On fail goto*//*Label 3797*/ GIMT_Encode4(174204),
     /* 174089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 174092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 174096 */   GIM_Try, /*On fail goto*//*Label 3798*/ GIMT_Encode4(174165), // Rule ID 21204 //
     /* 174101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_OptForSize),
     /* 174104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 174108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 174112 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174115 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 174119 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 174123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 174125 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 174132 */     // (fpextend:{ *:[f32] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSH2SSZrm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 174132 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 174135 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174139 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174144 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSH2SSZrm),
     /* 174149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174151 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174154 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 174158 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 174163 */     GIR_RootConstrainSelectedInstOperands,
     /* 174164 */     // GIR_Coverage, 21204,
     /* 174164 */     GIR_EraseRootFromParent_Done,
     /* 174165 */   // Label 3798: @174165
     /* 174165 */   GIM_Try, /*On fail goto*//*Label 3799*/ GIMT_Encode4(174203), // Rule ID 21202 //
     /* 174170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 174173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 174177 */     // (fpextend:{ *:[f32] } FR16X:{ *:[f16] }:$src)  =>  (VCVTSH2SSZrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR16X:{ *:[f16] }:$src)
     /* 174177 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 174180 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174184 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174189 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSH2SSZrr),
     /* 174194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174196 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174199 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 174201 */     GIR_RootConstrainSelectedInstOperands,
     /* 174202 */     // GIR_Coverage, 21202,
     /* 174202 */     GIR_EraseRootFromParent_Done,
     /* 174203 */   // Label 3799: @174203
     /* 174203 */   GIM_Reject,
     /* 174204 */ // Label 3797: @174204
     /* 174204 */ GIM_Reject,
     /* 174205 */ // Label 3790: @174205
     /* 174205 */ GIM_Try, /*On fail goto*//*Label 3800*/ GIMT_Encode4(174264), // Rule ID 1894 //
     /* 174210 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseSSE2),
     /* 174213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 174216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 174220 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 174224 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 174228 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174231 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 174235 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 174239 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 174241 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 174248 */   // (fpextend:{ *:[f64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSS2SDrm:{ *:[f64] } addr:{ *:[iPTR] }:$src)
     /* 174248 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSS2SDrm),
     /* 174251 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174253 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 174257 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 174262 */   GIR_RootConstrainSelectedInstOperands,
     /* 174263 */   // GIR_Coverage, 1894,
     /* 174263 */   GIR_EraseRootFromParent_Done,
     /* 174264 */ // Label 3800: @174264
     /* 174264 */ GIM_Try, /*On fail goto*//*Label 3801*/ GIMT_Encode4(174340), // Rule ID 18002 //
     /* 174269 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseAVX),
     /* 174272 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 174275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 174279 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 174283 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 174287 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174290 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 174294 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 174298 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 174300 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 174307 */   // (fpextend:{ *:[f64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSS2SDrm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 174307 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 174310 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174314 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174319 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174321 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SDrm),
     /* 174324 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174326 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174329 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 174333 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 174338 */   GIR_RootConstrainSelectedInstOperands,
     /* 174339 */   // GIR_Coverage, 18002,
     /* 174339 */   GIR_EraseRootFromParent_Done,
     /* 174340 */ // Label 3801: @174340
     /* 174340 */ GIM_Try, /*On fail goto*//*Label 3802*/ GIMT_Encode4(174416), // Rule ID 21198 //
     /* 174345 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_OptForSize),
     /* 174348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 174351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 174355 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 174359 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 174363 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174366 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 174370 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 174374 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 174376 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 174383 */   // (fpextend:{ *:[f64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSS2SDZrm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 174383 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 174386 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174390 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174395 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174397 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SDZrm),
     /* 174400 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174402 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174405 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 174409 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 174414 */   GIR_RootConstrainSelectedInstOperands,
     /* 174415 */   // GIR_Coverage, 21198,
     /* 174415 */   GIR_EraseRootFromParent_Done,
     /* 174416 */ // Label 3802: @174416
     /* 174416 */ GIM_Try, /*On fail goto*//*Label 3803*/ GIMT_Encode4(174492), // Rule ID 21208 //
     /* 174421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_OptForSize),
     /* 174424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 174427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 174431 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 174435 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 174439 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174442 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 174446 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 174450 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 174452 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 174459 */   // (fpextend:{ *:[f64] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSH2SDZrm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 174459 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 174462 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174466 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174471 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174473 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSH2SDZrm),
     /* 174476 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174478 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174481 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 174485 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 174490 */   GIR_RootConstrainSelectedInstOperands,
     /* 174491 */   // GIR_Coverage, 21208,
     /* 174491 */   GIR_EraseRootFromParent_Done,
     /* 174492 */ // Label 3803: @174492
     /* 174492 */ GIM_Try, /*On fail goto*//*Label 3804*/ GIMT_Encode4(174522), // Rule ID 1892 //
     /* 174497 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 174500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 174503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 174507 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 174511 */   // (fpextend:{ *:[f64] } FR32:{ *:[f32] }:$src)  =>  (CVTSS2SDrr:{ *:[f64] } FR32:{ *:[f32] }:$src)
     /* 174511 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSS2SDrr),
     /* 174516 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 174520 */   GIR_RootConstrainSelectedInstOperands,
     /* 174521 */   // GIR_Coverage, 1892,
     /* 174521 */   GIR_Done,
     /* 174522 */ // Label 3804: @174522
     /* 174522 */ GIM_Try, /*On fail goto*//*Label 3805*/ GIMT_Encode4(174552), // Rule ID 17727 //
     /* 174527 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 174530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 174533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 174537 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 174541 */   // (fpextend:{ *:[f64] } RFP32:{ *:[f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f64] } RFP32:{ *:[f32] }:$src, RFP64:{ *:[i32] })
     /* 174541 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174546 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::RFP64RegClassID),
     /* 174551 */   // GIR_Coverage, 17727,
     /* 174551 */   GIR_Done,
     /* 174552 */ // Label 3805: @174552
     /* 174552 */ GIM_Try, /*On fail goto*//*Label 3806*/ GIMT_Encode4(174597), // Rule ID 18000 //
     /* 174557 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 174560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 174563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 174567 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 174571 */   // (fpextend:{ *:[f64] } FR32:{ *:[f32] }:$src)  =>  (VCVTSS2SDrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR32:{ *:[f32] }:$src)
     /* 174571 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 174574 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174578 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174583 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174585 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SDrr),
     /* 174588 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174590 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174593 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 174595 */   GIR_RootConstrainSelectedInstOperands,
     /* 174596 */   // GIR_Coverage, 18000,
     /* 174596 */   GIR_EraseRootFromParent_Done,
     /* 174597 */ // Label 3806: @174597
     /* 174597 */ GIM_Try, /*On fail goto*//*Label 3807*/ GIMT_Encode4(174642), // Rule ID 21196 //
     /* 174602 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 174605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 174608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 174612 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 174616 */   // (fpextend:{ *:[f64] } FR32X:{ *:[f32] }:$src)  =>  (VCVTSS2SDZrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR32X:{ *:[f32] }:$src)
     /* 174616 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 174619 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174623 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174628 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174630 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SDZrr),
     /* 174633 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174635 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174638 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 174640 */   GIR_RootConstrainSelectedInstOperands,
     /* 174641 */   // GIR_Coverage, 21196,
     /* 174641 */   GIR_EraseRootFromParent_Done,
     /* 174642 */ // Label 3807: @174642
     /* 174642 */ GIM_Try, /*On fail goto*//*Label 3808*/ GIMT_Encode4(174687), // Rule ID 21206 //
     /* 174647 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 174650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 174653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 174657 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 174661 */   // (fpextend:{ *:[f64] } FR16X:{ *:[f16] }:$src)  =>  (VCVTSH2SDZrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR16X:{ *:[f16] }:$src)
     /* 174661 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 174664 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174668 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174673 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174675 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSH2SDZrr),
     /* 174678 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174680 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174683 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 174685 */   GIR_RootConstrainSelectedInstOperands,
     /* 174686 */   // GIR_Coverage, 21206,
     /* 174686 */   GIR_EraseRootFromParent_Done,
     /* 174687 */ // Label 3808: @174687
     /* 174687 */ GIM_Reject,
     /* 174688 */ // Label 3791: @174688
     /* 174688 */ GIM_Try, /*On fail goto*//*Label 3809*/ GIMT_Encode4(174718), // Rule ID 17729 //
     /* 174693 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 174696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 174699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 174703 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 174707 */   // (fpextend:{ *:[f80] } RFP32:{ *:[f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f80] } RFP32:{ *:[f32] }:$src, RFP80:{ *:[i32] })
     /* 174707 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174712 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::RFP80RegClassID),
     /* 174717 */   // GIR_Coverage, 17729,
     /* 174717 */   GIR_Done,
     /* 174718 */ // Label 3809: @174718
     /* 174718 */ GIM_Try, /*On fail goto*//*Label 3810*/ GIMT_Encode4(174748), // Rule ID 17731 //
     /* 174723 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 174726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 174729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 174733 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 174737 */   // (fpextend:{ *:[f80] } RFP64:{ *:[f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f80] } RFP64:{ *:[f64] }:$src, RFP80:{ *:[i32] })
     /* 174737 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174742 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::RFP80RegClassID),
     /* 174747 */   // GIR_Coverage, 17731,
     /* 174747 */   GIR_Done,
     /* 174748 */ // Label 3810: @174748
     /* 174748 */ GIM_Reject,
     /* 174749 */ // Label 3792: @174749
     /* 174749 */ GIM_Try, /*On fail goto*//*Label 3811*/ GIMT_Encode4(174812),
     /* 174754 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 174757 */   GIM_Try, /*On fail goto*//*Label 3812*/ GIMT_Encode4(174784), // Rule ID 1935 //
     /* 174762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 174765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 174769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 174773 */     // (fpextend:{ *:[v4f64] } VR128:{ *:[v4f32] }:$src)  =>  (VCVTPS2PDYrr:{ *:[v4f64] } VR128:{ *:[v4f32] }:$src)
     /* 174773 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2PDYrr),
     /* 174778 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 174782 */     GIR_RootConstrainSelectedInstOperands,
     /* 174783 */     // GIR_Coverage, 1935,
     /* 174783 */     GIR_Done,
     /* 174784 */   // Label 3812: @174784
     /* 174784 */   GIM_Try, /*On fail goto*//*Label 3813*/ GIMT_Encode4(174811), // Rule ID 10575 //
     /* 174789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 174792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 174796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 174800 */     // (fpextend:{ *:[v4f64] } VR128X:{ *:[v4f32] }:$src)  =>  (VCVTPS2PDZ256rr:{ *:[v4f64] } VR128X:{ *:[v4f32] }:$src)
     /* 174800 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2PDZ256rr),
     /* 174805 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 174809 */     GIR_RootConstrainSelectedInstOperands,
     /* 174810 */     // GIR_Coverage, 10575,
     /* 174810 */     GIR_Done,
     /* 174811 */   // Label 3813: @174811
     /* 174811 */   GIM_Reject,
     /* 174812 */ // Label 3811: @174812
     /* 174812 */ GIM_Reject,
     /* 174813 */ // Label 3793: @174813
     /* 174813 */ GIM_Try, /*On fail goto*//*Label 3814*/ GIMT_Encode4(174843), // Rule ID 10638 //
     /* 174818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 174821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 174824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 174828 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 174832 */   // (fpextend:{ *:[v8f32] } VR128X:{ *:[v8f16] }:$src)  =>  (VCVTPH2PSXZ256rr:{ *:[v8f32] } VR128X:{ *:[v8f16] }:$src)
     /* 174832 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2PSXZ256rr),
     /* 174837 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 174841 */   GIR_RootConstrainSelectedInstOperands,
     /* 174842 */   // GIR_Coverage, 10638,
     /* 174842 */   GIR_Done,
     /* 174843 */ // Label 3814: @174843
     /* 174843 */ GIM_Reject,
     /* 174844 */ // Label 3794: @174844
     /* 174844 */ GIM_Try, /*On fail goto*//*Label 3815*/ GIMT_Encode4(174874), // Rule ID 10550 //
     /* 174849 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 174852 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 174855 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 174859 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 174863 */   // (fpextend:{ *:[v8f64] } VR256X:{ *:[v8f32] }:$src)  =>  (VCVTPS2PDZrr:{ *:[v8f64] } VR256X:{ *:[v8f32] }:$src)
     /* 174863 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2PDZrr),
     /* 174868 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 174872 */   GIR_RootConstrainSelectedInstOperands,
     /* 174873 */   // GIR_Coverage, 10550,
     /* 174873 */   GIR_Done,
     /* 174874 */ // Label 3815: @174874
     /* 174874 */ GIM_Try, /*On fail goto*//*Label 3816*/ GIMT_Encode4(174904), // Rule ID 10664 //
     /* 174879 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 174882 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 174885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 174889 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 174893 */   // (fpextend:{ *:[v8f64] } VR128X:{ *:[v8f16] }:$src)  =>  (VCVTPH2PDZrr:{ *:[v8f64] } VR128X:{ *:[v8f16] }:$src)
     /* 174893 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2PDZrr),
     /* 174898 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 174902 */   GIR_RootConstrainSelectedInstOperands,
     /* 174903 */   // GIR_Coverage, 10664,
     /* 174903 */   GIR_Done,
     /* 174904 */ // Label 3816: @174904
     /* 174904 */ GIM_Reject,
     /* 174905 */ // Label 3795: @174905
     /* 174905 */ GIM_Try, /*On fail goto*//*Label 3817*/ GIMT_Encode4(174935), // Rule ID 10613 //
     /* 174910 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 174913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 174916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 174920 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 174924 */   // (fpextend:{ *:[v16f32] } VR256X:{ *:[v16f16] }:$src)  =>  (VCVTPH2PSXZrr:{ *:[v16f32] } VR256X:{ *:[v16f16] }:$src)
     /* 174924 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2PSXZrr),
     /* 174929 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 174933 */   GIR_RootConstrainSelectedInstOperands,
     /* 174934 */   // GIR_Coverage, 10613,
     /* 174934 */   GIR_Done,
     /* 174935 */ // Label 3817: @174935
     /* 174935 */ GIM_Reject,
     /* 174936 */ // Label 3796: @174936
     /* 174936 */ GIM_Reject,
     /* 174937 */ // Label 48: @174937
     /* 174937 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 3821*/ GIMT_Encode4(175322),
     /* 174948 */ /*GILLT_s16*//*Label 3818*/ GIMT_Encode4(174960),
     /* 174952 */ /*GILLT_s32*//*Label 3819*/ GIMT_Encode4(175051),
     /* 174956 */ /*GILLT_s64*//*Label 3820*/ GIMT_Encode4(175291),
     /* 174960 */ // Label 3818: @174960
     /* 174960 */ GIM_Try, /*On fail goto*//*Label 3822*/ GIMT_Encode4(175005), // Rule ID 21210 //
     /* 174965 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 174968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 174971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 174975 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 174979 */   // (fpround:{ *:[f16] } FR32X:{ *:[f32] }:$src)  =>  (VCVTSS2SHZrr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), FR32X:{ *:[f32] }:$src)
     /* 174979 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 174982 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174986 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174991 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174993 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SHZrr),
     /* 174996 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174998 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175001 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 175003 */   GIR_RootConstrainSelectedInstOperands,
     /* 175004 */   // GIR_Coverage, 21210,
     /* 175004 */   GIR_EraseRootFromParent_Done,
     /* 175005 */ // Label 3822: @175005
     /* 175005 */ GIM_Try, /*On fail goto*//*Label 3823*/ GIMT_Encode4(175050), // Rule ID 21212 //
     /* 175010 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 175013 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 175016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 175020 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 175024 */   // (fpround:{ *:[f16] } FR64X:{ *:[f64] }:$src)  =>  (VCVTSD2SHZrr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), FR64X:{ *:[f64] }:$src)
     /* 175024 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 175027 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 175031 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175036 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 175038 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SHZrr),
     /* 175041 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175043 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175046 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 175048 */   GIR_RootConstrainSelectedInstOperands,
     /* 175049 */   // GIR_Coverage, 21212,
     /* 175049 */   GIR_EraseRootFromParent_Done,
     /* 175050 */ // Label 3823: @175050
     /* 175050 */ GIM_Reject,
     /* 175051 */ // Label 3819: @175051
     /* 175051 */ GIM_Try, /*On fail goto*//*Label 3824*/ GIMT_Encode4(175110), // Rule ID 1882 //
     /* 175056 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseSSE2),
     /* 175059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 175062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 175066 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175070 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175074 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175077 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 175081 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 175085 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175087 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 175094 */   // (fpround:{ *:[f32] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSD2SSrm:{ *:[f32] } addr:{ *:[iPTR] }:$src)
     /* 175094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSD2SSrm),
     /* 175097 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175099 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 175103 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175108 */   GIR_RootConstrainSelectedInstOperands,
     /* 175109 */   // GIR_Coverage, 1882,
     /* 175109 */   GIR_EraseRootFromParent_Done,
     /* 175110 */ // Label 3824: @175110
     /* 175110 */ GIM_Try, /*On fail goto*//*Label 3825*/ GIMT_Encode4(175140), // Rule ID 1880 //
     /* 175115 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 175118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 175121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 175125 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 175129 */   // (fpround:{ *:[f32] } FR64:{ *:[f64] }:$src)  =>  (CVTSD2SSrr:{ *:[f32] } FR64:{ *:[f64] }:$src)
     /* 175129 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSD2SSrr),
     /* 175134 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 175138 */   GIR_RootConstrainSelectedInstOperands,
     /* 175139 */   // GIR_Coverage, 1880,
     /* 175139 */   GIR_Done,
     /* 175140 */ // Label 3825: @175140
     /* 175140 */ GIM_Try, /*On fail goto*//*Label 3826*/ GIMT_Encode4(175170), // Rule ID 17733 //
     /* 175145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 175148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 175151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 175155 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 175159 */   // (fpround:{ *:[f32] } RFP64:{ *:[f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f32] } RFP64:{ *:[f64] }:$src, RFP32:{ *:[i32] })
     /* 175159 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 175164 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::RFP32RegClassID),
     /* 175169 */   // GIR_Coverage, 17733,
     /* 175169 */   GIR_Done,
     /* 175170 */ // Label 3826: @175170
     /* 175170 */ GIM_Try, /*On fail goto*//*Label 3827*/ GIMT_Encode4(175200), // Rule ID 17735 //
     /* 175175 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 175178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 175181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 175185 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 175189 */   // (fpround:{ *:[f32] } RFP80:{ *:[f80] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f32] } RFP80:{ *:[f80] }:$src, RFP32:{ *:[i32] })
     /* 175189 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 175194 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::RFP32RegClassID),
     /* 175199 */   // GIR_Coverage, 17735,
     /* 175199 */   GIR_Done,
     /* 175200 */ // Label 3827: @175200
     /* 175200 */ GIM_Try, /*On fail goto*//*Label 3828*/ GIMT_Encode4(175245), // Rule ID 17998 //
     /* 175205 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 175208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 175211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 175215 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 175219 */   // (fpround:{ *:[f32] } FR64:{ *:[f64] }:$src)  =>  (VCVTSD2SSrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR64:{ *:[f64] }:$src)
     /* 175219 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 175222 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 175226 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175231 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 175233 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SSrr),
     /* 175236 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175238 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175241 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 175243 */   GIR_RootConstrainSelectedInstOperands,
     /* 175244 */   // GIR_Coverage, 17998,
     /* 175244 */   GIR_EraseRootFromParent_Done,
     /* 175245 */ // Label 3828: @175245
     /* 175245 */ GIM_Try, /*On fail goto*//*Label 3829*/ GIMT_Encode4(175290), // Rule ID 21200 //
     /* 175250 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 175253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 175256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 175260 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 175264 */   // (fpround:{ *:[f32] } FR64X:{ *:[f64] }:$src)  =>  (VCVTSD2SSZrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR64X:{ *:[f64] }:$src)
     /* 175264 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 175267 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 175271 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175276 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 175278 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SSZrr),
     /* 175281 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175283 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175286 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 175288 */   GIR_RootConstrainSelectedInstOperands,
     /* 175289 */   // GIR_Coverage, 21200,
     /* 175289 */   GIR_EraseRootFromParent_Done,
     /* 175290 */ // Label 3829: @175290
     /* 175290 */ GIM_Reject,
     /* 175291 */ // Label 3820: @175291
     /* 175291 */ GIM_Try, /*On fail goto*//*Label 3830*/ GIMT_Encode4(175321), // Rule ID 17737 //
     /* 175296 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 175299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 175302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 175306 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 175310 */   // (fpround:{ *:[f64] } RFP80:{ *:[f80] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f64] } RFP80:{ *:[f80] }:$src, RFP64:{ *:[i32] })
     /* 175310 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 175315 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::RFP64RegClassID),
     /* 175320 */   // GIR_Coverage, 17737,
     /* 175320 */   GIR_Done,
     /* 175321 */ // Label 3830: @175321
     /* 175321 */ GIM_Reject,
     /* 175322 */ // Label 3821: @175322
     /* 175322 */ GIM_Reject,
     /* 175323 */ // Label 49: @175323
     /* 175323 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 3834*/ GIMT_Encode4(176703),
     /* 175334 */ /*GILLT_s32*//*Label 3831*/ GIMT_Encode4(175366),
     /* 175338 */ /*GILLT_s64*//*Label 3832*/ GIMT_Encode4(175990), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 175362 */ /*GILLT_v4s32*//*Label 3833*/ GIMT_Encode4(176614),
     /* 175366 */ // Label 3831: @175366
     /* 175366 */ GIM_Try, /*On fail goto*//*Label 3835*/ GIMT_Encode4(175425), // Rule ID 1742 //
     /* 175371 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 175374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 175377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 175381 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175385 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175389 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175392 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 175396 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 175400 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175402 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 175409 */   // (fp_to_sint:{ *:[i32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSS2SIrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 175409 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SIrm),
     /* 175412 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175414 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 175418 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175423 */   GIR_RootConstrainSelectedInstOperands,
     /* 175424 */   // GIR_Coverage, 1742,
     /* 175424 */   GIR_EraseRootFromParent_Done,
     /* 175425 */ // Label 3835: @175425
     /* 175425 */ GIM_Try, /*On fail goto*//*Label 3836*/ GIMT_Encode4(175484), // Rule ID 1750 //
     /* 175430 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 175433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 175436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 175440 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175444 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175448 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175451 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 175455 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 175459 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175461 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 175468 */   // (fp_to_sint:{ *:[i32] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSD2SIrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 175468 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SIrm),
     /* 175471 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175473 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 175477 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175482 */   GIR_RootConstrainSelectedInstOperands,
     /* 175483 */   // GIR_Coverage, 1750,
     /* 175483 */   GIR_EraseRootFromParent_Done,
     /* 175484 */ // Label 3836: @175484
     /* 175484 */ GIM_Try, /*On fail goto*//*Label 3837*/ GIMT_Encode4(175543), // Rule ID 1766 //
     /* 175489 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 175492 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 175495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 175499 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175503 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175507 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175510 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 175514 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 175518 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175520 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 175527 */   // (fp_to_sint:{ *:[i32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTTSS2SIrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 175527 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTTSS2SIrm),
     /* 175530 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175532 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 175536 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175541 */   GIR_RootConstrainSelectedInstOperands,
     /* 175542 */   // GIR_Coverage, 1766,
     /* 175542 */   GIR_EraseRootFromParent_Done,
     /* 175543 */ // Label 3837: @175543
     /* 175543 */ GIM_Try, /*On fail goto*//*Label 3838*/ GIMT_Encode4(175602), // Rule ID 1774 //
     /* 175548 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 175551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 175554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 175558 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175562 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175566 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175569 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 175573 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 175577 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175579 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 175586 */   // (fp_to_sint:{ *:[i32] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTTSD2SIrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 175586 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTTSD2SIrm),
     /* 175589 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175591 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 175595 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175600 */   GIR_RootConstrainSelectedInstOperands,
     /* 175601 */   // GIR_Coverage, 1774,
     /* 175601 */   GIR_EraseRootFromParent_Done,
     /* 175602 */ // Label 3838: @175602
     /* 175602 */ GIM_Try, /*On fail goto*//*Label 3839*/ GIMT_Encode4(175661), // Rule ID 10363 //
     /* 175607 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 175610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 175613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 175617 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175621 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175625 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175628 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 175632 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 175636 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175638 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 175645 */   // (fp_to_sint:{ *:[i32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSS2SIZrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 175645 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SIZrm),
     /* 175648 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175650 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 175654 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175659 */   GIR_RootConstrainSelectedInstOperands,
     /* 175660 */   // GIR_Coverage, 10363,
     /* 175660 */   GIR_EraseRootFromParent_Done,
     /* 175661 */ // Label 3839: @175661
     /* 175661 */ GIM_Try, /*On fail goto*//*Label 3840*/ GIMT_Encode4(175720), // Rule ID 10381 //
     /* 175666 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 175669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 175672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 175676 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175680 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175684 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175687 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 175691 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 175695 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175697 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 175704 */   // (fp_to_sint:{ *:[i32] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSD2SIZrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 175704 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SIZrm),
     /* 175707 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175709 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 175713 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175718 */   GIR_RootConstrainSelectedInstOperands,
     /* 175719 */   // GIR_Coverage, 10381,
     /* 175719 */   GIR_EraseRootFromParent_Done,
     /* 175720 */ // Label 3840: @175720
     /* 175720 */ GIM_Try, /*On fail goto*//*Label 3841*/ GIMT_Encode4(175779), // Rule ID 15171 //
     /* 175725 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 175728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 175731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 175735 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175739 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175743 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175746 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 175750 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 175754 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175756 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 175763 */   // (fp_to_sint:{ *:[i32] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSH2SIZrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 175763 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SIZrm),
     /* 175766 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175768 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 175772 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175777 */   GIR_RootConstrainSelectedInstOperands,
     /* 175778 */   // GIR_Coverage, 15171,
     /* 175778 */   GIR_EraseRootFromParent_Done,
     /* 175779 */ // Label 3841: @175779
     /* 175779 */ GIM_Try, /*On fail goto*//*Label 3842*/ GIMT_Encode4(175809), // Rule ID 1740 //
     /* 175784 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 175787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 175790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 175794 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 175798 */   // (fp_to_sint:{ *:[i32] } FR32:{ *:[f32] }:$src)  =>  (VCVTTSS2SIrr:{ *:[i32] } FR32:{ *:[f32] }:$src)
     /* 175798 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SIrr),
     /* 175803 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 175807 */   GIR_RootConstrainSelectedInstOperands,
     /* 175808 */   // GIR_Coverage, 1740,
     /* 175808 */   GIR_Done,
     /* 175809 */ // Label 3842: @175809
     /* 175809 */ GIM_Try, /*On fail goto*//*Label 3843*/ GIMT_Encode4(175839), // Rule ID 1748 //
     /* 175814 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 175817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 175820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 175824 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 175828 */   // (fp_to_sint:{ *:[i32] } FR64:{ *:[f64] }:$src)  =>  (VCVTTSD2SIrr:{ *:[i32] } FR64:{ *:[f64] }:$src)
     /* 175828 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SIrr),
     /* 175833 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 175837 */   GIR_RootConstrainSelectedInstOperands,
     /* 175838 */   // GIR_Coverage, 1748,
     /* 175838 */   GIR_Done,
     /* 175839 */ // Label 3843: @175839
     /* 175839 */ GIM_Try, /*On fail goto*//*Label 3844*/ GIMT_Encode4(175869), // Rule ID 1764 //
     /* 175844 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 175847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 175850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 175854 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 175858 */   // (fp_to_sint:{ *:[i32] } FR32:{ *:[f32] }:$src)  =>  (CVTTSS2SIrr:{ *:[i32] } FR32:{ *:[f32] }:$src)
     /* 175858 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTTSS2SIrr),
     /* 175863 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 175867 */   GIR_RootConstrainSelectedInstOperands,
     /* 175868 */   // GIR_Coverage, 1764,
     /* 175868 */   GIR_Done,
     /* 175869 */ // Label 3844: @175869
     /* 175869 */ GIM_Try, /*On fail goto*//*Label 3845*/ GIMT_Encode4(175899), // Rule ID 1772 //
     /* 175874 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 175877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 175880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 175884 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 175888 */   // (fp_to_sint:{ *:[i32] } FR64:{ *:[f64] }:$src)  =>  (CVTTSD2SIrr:{ *:[i32] } FR64:{ *:[f64] }:$src)
     /* 175888 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTTSD2SIrr),
     /* 175893 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 175897 */   GIR_RootConstrainSelectedInstOperands,
     /* 175898 */   // GIR_Coverage, 1772,
     /* 175898 */   GIR_Done,
     /* 175899 */ // Label 3845: @175899
     /* 175899 */ GIM_Try, /*On fail goto*//*Label 3846*/ GIMT_Encode4(175929), // Rule ID 10361 //
     /* 175904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 175907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 175910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 175914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 175918 */   // (fp_to_sint:{ *:[i32] } FR32X:{ *:[f32] }:$src)  =>  (VCVTTSS2SIZrr:{ *:[i32] } FR32X:{ *:[f32] }:$src)
     /* 175918 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SIZrr),
     /* 175923 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 175927 */   GIR_RootConstrainSelectedInstOperands,
     /* 175928 */   // GIR_Coverage, 10361,
     /* 175928 */   GIR_Done,
     /* 175929 */ // Label 3846: @175929
     /* 175929 */ GIM_Try, /*On fail goto*//*Label 3847*/ GIMT_Encode4(175959), // Rule ID 10379 //
     /* 175934 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 175937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 175940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 175944 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 175948 */   // (fp_to_sint:{ *:[i32] } FR64X:{ *:[f64] }:$src)  =>  (VCVTTSD2SIZrr:{ *:[i32] } FR64X:{ *:[f64] }:$src)
     /* 175948 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SIZrr),
     /* 175953 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 175957 */   GIR_RootConstrainSelectedInstOperands,
     /* 175958 */   // GIR_Coverage, 10379,
     /* 175958 */   GIR_Done,
     /* 175959 */ // Label 3847: @175959
     /* 175959 */ GIM_Try, /*On fail goto*//*Label 3848*/ GIMT_Encode4(175989), // Rule ID 15169 //
     /* 175964 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 175967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 175970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 175974 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 175978 */   // (fp_to_sint:{ *:[i32] } FR16X:{ *:[f16] }:$src)  =>  (VCVTTSH2SIZrr:{ *:[i32] } FR16X:{ *:[f16] }:$src)
     /* 175978 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SIZrr),
     /* 175983 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 175987 */   GIR_RootConstrainSelectedInstOperands,
     /* 175988 */   // GIR_Coverage, 15169,
     /* 175988 */   GIR_Done,
     /* 175989 */ // Label 3848: @175989
     /* 175989 */ GIM_Reject,
     /* 175990 */ // Label 3832: @175990
     /* 175990 */ GIM_Try, /*On fail goto*//*Label 3849*/ GIMT_Encode4(176049), // Rule ID 1746 //
     /* 175995 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 175998 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 176001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 176005 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176009 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176013 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176016 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176020 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176024 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176026 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176033 */   // (fp_to_sint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSS2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 176033 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SI64rm),
     /* 176036 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176038 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176042 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176047 */   GIR_RootConstrainSelectedInstOperands,
     /* 176048 */   // GIR_Coverage, 1746,
     /* 176048 */   GIR_EraseRootFromParent_Done,
     /* 176049 */ // Label 3849: @176049
     /* 176049 */ GIM_Try, /*On fail goto*//*Label 3850*/ GIMT_Encode4(176108), // Rule ID 1754 //
     /* 176054 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 176057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 176060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 176064 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176068 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176072 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176075 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176079 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176083 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176085 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176092 */   // (fp_to_sint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSD2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 176092 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SI64rm),
     /* 176095 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176097 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176101 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176106 */   GIR_RootConstrainSelectedInstOperands,
     /* 176107 */   // GIR_Coverage, 1754,
     /* 176107 */   GIR_EraseRootFromParent_Done,
     /* 176108 */ // Label 3850: @176108
     /* 176108 */ GIM_Try, /*On fail goto*//*Label 3851*/ GIMT_Encode4(176167), // Rule ID 1770 //
     /* 176113 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 176116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 176119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 176123 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176127 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176131 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176134 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176138 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176142 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176144 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176151 */   // (fp_to_sint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTTSS2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 176151 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTTSS2SI64rm),
     /* 176154 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176156 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176160 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176165 */   GIR_RootConstrainSelectedInstOperands,
     /* 176166 */   // GIR_Coverage, 1770,
     /* 176166 */   GIR_EraseRootFromParent_Done,
     /* 176167 */ // Label 3851: @176167
     /* 176167 */ GIM_Try, /*On fail goto*//*Label 3852*/ GIMT_Encode4(176226), // Rule ID 1778 //
     /* 176172 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 176175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 176178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 176182 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176186 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176190 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176193 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176197 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176201 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176203 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176210 */   // (fp_to_sint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTTSD2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 176210 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTTSD2SI64rm),
     /* 176213 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176215 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176219 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176224 */   GIR_RootConstrainSelectedInstOperands,
     /* 176225 */   // GIR_Coverage, 1778,
     /* 176225 */   GIR_EraseRootFromParent_Done,
     /* 176226 */ // Label 3852: @176226
     /* 176226 */ GIM_Try, /*On fail goto*//*Label 3853*/ GIMT_Encode4(176285), // Rule ID 10372 //
     /* 176231 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 176234 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 176237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 176241 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176245 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176249 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176252 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176256 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176260 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176262 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176269 */   // (fp_to_sint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSS2SI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 176269 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SI64Zrm),
     /* 176272 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176274 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176278 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176283 */   GIR_RootConstrainSelectedInstOperands,
     /* 176284 */   // GIR_Coverage, 10372,
     /* 176284 */   GIR_EraseRootFromParent_Done,
     /* 176285 */ // Label 3853: @176285
     /* 176285 */ GIM_Try, /*On fail goto*//*Label 3854*/ GIMT_Encode4(176344), // Rule ID 10390 //
     /* 176290 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 176293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 176296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 176300 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176304 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176308 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176311 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176315 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176319 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176321 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176328 */   // (fp_to_sint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSD2SI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 176328 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SI64Zrm),
     /* 176331 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176333 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176337 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176342 */   GIR_RootConstrainSelectedInstOperands,
     /* 176343 */   // GIR_Coverage, 10390,
     /* 176343 */   GIR_EraseRootFromParent_Done,
     /* 176344 */ // Label 3854: @176344
     /* 176344 */ GIM_Try, /*On fail goto*//*Label 3855*/ GIMT_Encode4(176403), // Rule ID 15180 //
     /* 176349 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 176352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 176355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 176359 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176363 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176367 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176370 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176374 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176378 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176380 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176387 */   // (fp_to_sint:{ *:[i64] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSH2SI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 176387 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SI64Zrm),
     /* 176390 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176392 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176396 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176401 */   GIR_RootConstrainSelectedInstOperands,
     /* 176402 */   // GIR_Coverage, 15180,
     /* 176402 */   GIR_EraseRootFromParent_Done,
     /* 176403 */ // Label 3855: @176403
     /* 176403 */ GIM_Try, /*On fail goto*//*Label 3856*/ GIMT_Encode4(176433), // Rule ID 1744 //
     /* 176408 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 176411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 176414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 176418 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 176422 */   // (fp_to_sint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (VCVTTSS2SI64rr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /* 176422 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SI64rr),
     /* 176427 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176431 */   GIR_RootConstrainSelectedInstOperands,
     /* 176432 */   // GIR_Coverage, 1744,
     /* 176432 */   GIR_Done,
     /* 176433 */ // Label 3856: @176433
     /* 176433 */ GIM_Try, /*On fail goto*//*Label 3857*/ GIMT_Encode4(176463), // Rule ID 1752 //
     /* 176438 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 176441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 176444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 176448 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 176452 */   // (fp_to_sint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (VCVTTSD2SI64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /* 176452 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SI64rr),
     /* 176457 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176461 */   GIR_RootConstrainSelectedInstOperands,
     /* 176462 */   // GIR_Coverage, 1752,
     /* 176462 */   GIR_Done,
     /* 176463 */ // Label 3857: @176463
     /* 176463 */ GIM_Try, /*On fail goto*//*Label 3858*/ GIMT_Encode4(176493), // Rule ID 1768 //
     /* 176468 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 176471 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 176474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 176478 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 176482 */   // (fp_to_sint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (CVTTSS2SI64rr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /* 176482 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTTSS2SI64rr),
     /* 176487 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176491 */   GIR_RootConstrainSelectedInstOperands,
     /* 176492 */   // GIR_Coverage, 1768,
     /* 176492 */   GIR_Done,
     /* 176493 */ // Label 3858: @176493
     /* 176493 */ GIM_Try, /*On fail goto*//*Label 3859*/ GIMT_Encode4(176523), // Rule ID 1776 //
     /* 176498 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 176501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 176504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 176508 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 176512 */   // (fp_to_sint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (CVTTSD2SI64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /* 176512 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTTSD2SI64rr),
     /* 176517 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176521 */   GIR_RootConstrainSelectedInstOperands,
     /* 176522 */   // GIR_Coverage, 1776,
     /* 176522 */   GIR_Done,
     /* 176523 */ // Label 3859: @176523
     /* 176523 */ GIM_Try, /*On fail goto*//*Label 3860*/ GIMT_Encode4(176553), // Rule ID 10370 //
     /* 176528 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 176531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 176534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 176538 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 176542 */   // (fp_to_sint:{ *:[i64] } FR32X:{ *:[f32] }:$src)  =>  (VCVTTSS2SI64Zrr:{ *:[i64] } FR32X:{ *:[f32] }:$src)
     /* 176542 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SI64Zrr),
     /* 176547 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176551 */   GIR_RootConstrainSelectedInstOperands,
     /* 176552 */   // GIR_Coverage, 10370,
     /* 176552 */   GIR_Done,
     /* 176553 */ // Label 3860: @176553
     /* 176553 */ GIM_Try, /*On fail goto*//*Label 3861*/ GIMT_Encode4(176583), // Rule ID 10388 //
     /* 176558 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 176561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 176564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 176568 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 176572 */   // (fp_to_sint:{ *:[i64] } FR64X:{ *:[f64] }:$src)  =>  (VCVTTSD2SI64Zrr:{ *:[i64] } FR64X:{ *:[f64] }:$src)
     /* 176572 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SI64Zrr),
     /* 176577 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176581 */   GIR_RootConstrainSelectedInstOperands,
     /* 176582 */   // GIR_Coverage, 10388,
     /* 176582 */   GIR_Done,
     /* 176583 */ // Label 3861: @176583
     /* 176583 */ GIM_Try, /*On fail goto*//*Label 3862*/ GIMT_Encode4(176613), // Rule ID 15178 //
     /* 176588 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 176591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 176594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 176598 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 176602 */   // (fp_to_sint:{ *:[i64] } FR16X:{ *:[f16] }:$src)  =>  (VCVTTSH2SI64Zrr:{ *:[i64] } FR16X:{ *:[f16] }:$src)
     /* 176602 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SI64Zrr),
     /* 176607 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176611 */   GIR_RootConstrainSelectedInstOperands,
     /* 176612 */   // GIR_Coverage, 15178,
     /* 176612 */   GIR_Done,
     /* 176613 */ // Label 3862: @176613
     /* 176613 */ GIM_Reject,
     /* 176614 */ // Label 3833: @176614
     /* 176614 */ GIM_Try, /*On fail goto*//*Label 3863*/ GIMT_Encode4(176702),
     /* 176619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 176622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 176626 */   GIM_Try, /*On fail goto*//*Label 3864*/ GIMT_Encode4(176678), // Rule ID 18054 //
     /* 176631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 176634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176642 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176645 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176649 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176655 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176662 */     // (fp_to_sint:{ *:[v4i32] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTPD2DQYrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /* 176662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTPD2DQYrm),
     /* 176665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176667 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176671 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176676 */     GIR_RootConstrainSelectedInstOperands,
     /* 176677 */     // GIR_Coverage, 18054,
     /* 176677 */     GIR_EraseRootFromParent_Done,
     /* 176678 */   // Label 3864: @176678
     /* 176678 */   GIM_Try, /*On fail goto*//*Label 3865*/ GIMT_Encode4(176701), // Rule ID 18052 //
     /* 176683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 176686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 176690 */     // (fp_to_sint:{ *:[v4i32] } VR256:{ *:[v4f64] }:$src)  =>  (VCVTTPD2DQYrr:{ *:[v4i32] } VR256:{ *:[v4f64] }:$src)
     /* 176690 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTPD2DQYrr),
     /* 176695 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176699 */     GIR_RootConstrainSelectedInstOperands,
     /* 176700 */     // GIR_Coverage, 18052,
     /* 176700 */     GIR_Done,
     /* 176701 */   // Label 3865: @176701
     /* 176701 */   GIM_Reject,
     /* 176702 */ // Label 3863: @176702
     /* 176702 */ GIM_Reject,
     /* 176703 */ // Label 3834: @176703
     /* 176703 */ GIM_Reject,
     /* 176704 */ // Label 50: @176704
     /* 176704 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3868*/ GIMT_Encode4(177259),
     /* 176715 */ /*GILLT_s32*//*Label 3866*/ GIMT_Encode4(176723),
     /* 176719 */ /*GILLT_s64*//*Label 3867*/ GIMT_Encode4(176991),
     /* 176723 */ // Label 3866: @176723
     /* 176723 */ GIM_Try, /*On fail goto*//*Label 3869*/ GIMT_Encode4(176782), // Rule ID 10399 //
     /* 176728 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 176731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 176734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 176738 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176742 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176746 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176749 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176753 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176757 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176759 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176766 */   // (fp_to_uint:{ *:[i32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSS2USIZrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 176766 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2USIZrm),
     /* 176769 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176771 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176775 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176780 */   GIR_RootConstrainSelectedInstOperands,
     /* 176781 */   // GIR_Coverage, 10399,
     /* 176781 */   GIR_EraseRootFromParent_Done,
     /* 176782 */ // Label 3869: @176782
     /* 176782 */ GIM_Try, /*On fail goto*//*Label 3870*/ GIMT_Encode4(176841), // Rule ID 10417 //
     /* 176787 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 176790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 176793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 176797 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176801 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176805 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176808 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176812 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176816 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176818 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176825 */   // (fp_to_uint:{ *:[i32] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSD2USIZrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 176825 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2USIZrm),
     /* 176828 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176830 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176834 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176839 */   GIR_RootConstrainSelectedInstOperands,
     /* 176840 */   // GIR_Coverage, 10417,
     /* 176840 */   GIR_EraseRootFromParent_Done,
     /* 176841 */ // Label 3870: @176841
     /* 176841 */ GIM_Try, /*On fail goto*//*Label 3871*/ GIMT_Encode4(176900), // Rule ID 15189 //
     /* 176846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 176849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 176852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 176856 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176860 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176864 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176867 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176871 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176875 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176877 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176884 */   // (fp_to_uint:{ *:[i32] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSH2USIZrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 176884 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2USIZrm),
     /* 176887 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176889 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176893 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176898 */   GIR_RootConstrainSelectedInstOperands,
     /* 176899 */   // GIR_Coverage, 15189,
     /* 176899 */   GIR_EraseRootFromParent_Done,
     /* 176900 */ // Label 3871: @176900
     /* 176900 */ GIM_Try, /*On fail goto*//*Label 3872*/ GIMT_Encode4(176930), // Rule ID 10397 //
     /* 176905 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 176908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 176911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 176915 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 176919 */   // (fp_to_uint:{ *:[i32] } FR32X:{ *:[f32] }:$src)  =>  (VCVTTSS2USIZrr:{ *:[i32] } FR32X:{ *:[f32] }:$src)
     /* 176919 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2USIZrr),
     /* 176924 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176928 */   GIR_RootConstrainSelectedInstOperands,
     /* 176929 */   // GIR_Coverage, 10397,
     /* 176929 */   GIR_Done,
     /* 176930 */ // Label 3872: @176930
     /* 176930 */ GIM_Try, /*On fail goto*//*Label 3873*/ GIMT_Encode4(176960), // Rule ID 10415 //
     /* 176935 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 176938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 176941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 176945 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 176949 */   // (fp_to_uint:{ *:[i32] } FR64X:{ *:[f64] }:$src)  =>  (VCVTTSD2USIZrr:{ *:[i32] } FR64X:{ *:[f64] }:$src)
     /* 176949 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2USIZrr),
     /* 176954 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176958 */   GIR_RootConstrainSelectedInstOperands,
     /* 176959 */   // GIR_Coverage, 10415,
     /* 176959 */   GIR_Done,
     /* 176960 */ // Label 3873: @176960
     /* 176960 */ GIM_Try, /*On fail goto*//*Label 3874*/ GIMT_Encode4(176990), // Rule ID 15187 //
     /* 176965 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 176968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 176971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 176975 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 176979 */   // (fp_to_uint:{ *:[i32] } FR16X:{ *:[f16] }:$src)  =>  (VCVTTSH2USIZrr:{ *:[i32] } FR16X:{ *:[f16] }:$src)
     /* 176979 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2USIZrr),
     /* 176984 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176988 */   GIR_RootConstrainSelectedInstOperands,
     /* 176989 */   // GIR_Coverage, 15187,
     /* 176989 */   GIR_Done,
     /* 176990 */ // Label 3874: @176990
     /* 176990 */ GIM_Reject,
     /* 176991 */ // Label 3867: @176991
     /* 176991 */ GIM_Try, /*On fail goto*//*Label 3875*/ GIMT_Encode4(177050), // Rule ID 10408 //
     /* 176996 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 176999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 177002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 177006 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177010 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177014 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177017 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 177021 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177025 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177027 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177034 */   // (fp_to_uint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSS2USI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 177034 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2USI64Zrm),
     /* 177037 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177039 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 177043 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 177048 */   GIR_RootConstrainSelectedInstOperands,
     /* 177049 */   // GIR_Coverage, 10408,
     /* 177049 */   GIR_EraseRootFromParent_Done,
     /* 177050 */ // Label 3875: @177050
     /* 177050 */ GIM_Try, /*On fail goto*//*Label 3876*/ GIMT_Encode4(177109), // Rule ID 10426 //
     /* 177055 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 177058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 177061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 177065 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177069 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177073 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177076 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 177080 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177084 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177086 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177093 */   // (fp_to_uint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSD2USI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 177093 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2USI64Zrm),
     /* 177096 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177098 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 177102 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 177107 */   GIR_RootConstrainSelectedInstOperands,
     /* 177108 */   // GIR_Coverage, 10426,
     /* 177108 */   GIR_EraseRootFromParent_Done,
     /* 177109 */ // Label 3876: @177109
     /* 177109 */ GIM_Try, /*On fail goto*//*Label 3877*/ GIMT_Encode4(177168), // Rule ID 15198 //
     /* 177114 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 177117 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 177120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 177124 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177128 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177132 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177135 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 177139 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177143 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177145 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177152 */   // (fp_to_uint:{ *:[i64] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSH2USI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 177152 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2USI64Zrm),
     /* 177155 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177157 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 177161 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 177166 */   GIR_RootConstrainSelectedInstOperands,
     /* 177167 */   // GIR_Coverage, 15198,
     /* 177167 */   GIR_EraseRootFromParent_Done,
     /* 177168 */ // Label 3877: @177168
     /* 177168 */ GIM_Try, /*On fail goto*//*Label 3878*/ GIMT_Encode4(177198), // Rule ID 10406 //
     /* 177173 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 177176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 177179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 177183 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 177187 */   // (fp_to_uint:{ *:[i64] } FR32X:{ *:[f32] }:$src)  =>  (VCVTTSS2USI64Zrr:{ *:[i64] } FR32X:{ *:[f32] }:$src)
     /* 177187 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2USI64Zrr),
     /* 177192 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 177196 */   GIR_RootConstrainSelectedInstOperands,
     /* 177197 */   // GIR_Coverage, 10406,
     /* 177197 */   GIR_Done,
     /* 177198 */ // Label 3878: @177198
     /* 177198 */ GIM_Try, /*On fail goto*//*Label 3879*/ GIMT_Encode4(177228), // Rule ID 10424 //
     /* 177203 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 177206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 177209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 177213 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 177217 */   // (fp_to_uint:{ *:[i64] } FR64X:{ *:[f64] }:$src)  =>  (VCVTTSD2USI64Zrr:{ *:[i64] } FR64X:{ *:[f64] }:$src)
     /* 177217 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2USI64Zrr),
     /* 177222 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 177226 */   GIR_RootConstrainSelectedInstOperands,
     /* 177227 */   // GIR_Coverage, 10424,
     /* 177227 */   GIR_Done,
     /* 177228 */ // Label 3879: @177228
     /* 177228 */ GIM_Try, /*On fail goto*//*Label 3880*/ GIMT_Encode4(177258), // Rule ID 15196 //
     /* 177233 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 177236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 177239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 177243 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 177247 */   // (fp_to_uint:{ *:[i64] } FR16X:{ *:[f16] }:$src)  =>  (VCVTTSH2USI64Zrr:{ *:[i64] } FR16X:{ *:[f16] }:$src)
     /* 177247 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2USI64Zrr),
     /* 177252 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 177256 */   GIR_RootConstrainSelectedInstOperands,
     /* 177257 */   // GIR_Coverage, 15196,
     /* 177257 */   GIR_Done,
     /* 177258 */ // Label 3880: @177258
     /* 177258 */ GIM_Reject,
     /* 177259 */ // Label 3868: @177259
     /* 177259 */ GIM_Reject,
     /* 177260 */ // Label 51: @177260
     /* 177260 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 3893*/ GIMT_Encode4(180635),
     /* 177271 */ /*GILLT_s16*//*Label 3881*/ GIMT_Encode4(177355),
     /* 177275 */ /*GILLT_s32*//*Label 3882*/ GIMT_Encode4(177598),
     /* 177279 */ /*GILLT_s64*//*Label 3883*/ GIMT_Encode4(178261), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 177295 */ /*GILLT_v2s64*//*Label 3884*/ GIMT_Encode4(178920), GIMT_Encode4(0),
     /* 177303 */ /*GILLT_v4s32*//*Label 3885*/ GIMT_Encode4(179009),
     /* 177307 */ /*GILLT_v4s64*//*Label 3886*/ GIMT_Encode4(179307), GIMT_Encode4(0),
     /* 177315 */ /*GILLT_v8s16*//*Label 3887*/ GIMT_Encode4(179567),
     /* 177319 */ /*GILLT_v8s32*//*Label 3888*/ GIMT_Encode4(179835),
     /* 177323 */ /*GILLT_v8s64*//*Label 3889*/ GIMT_Encode4(180103), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 177335 */ /*GILLT_v16s16*//*Label 3890*/ GIMT_Encode4(180278),
     /* 177339 */ /*GILLT_v16s32*//*Label 3891*/ GIMT_Encode4(180457), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 177351 */ /*GILLT_v32s16*//*Label 3892*/ GIMT_Encode4(180546),
     /* 177355 */ // Label 3881: @177355
     /* 177355 */ GIM_Try, /*On fail goto*//*Label 3894*/ GIMT_Encode4(177431), // Rule ID 22179 //
     /* 177360 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 177363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 177366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 177370 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177374 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177378 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177381 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 177385 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177389 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177391 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177398 */   // (sint_to_fp:{ *:[f16] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSI642SHZrm:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), addr:{ *:[iPTR] }:$src)
     /* 177398 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 177401 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 177405 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177410 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 177412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SHZrm),
     /* 177415 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177417 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177420 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 177424 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 177429 */   GIR_RootConstrainSelectedInstOperands,
     /* 177430 */   // GIR_Coverage, 22179,
     /* 177430 */   GIR_EraseRootFromParent_Done,
     /* 177431 */ // Label 3894: @177431
     /* 177431 */ GIM_Try, /*On fail goto*//*Label 3895*/ GIMT_Encode4(177507), // Rule ID 22177 //
     /* 177436 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 177439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 177442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 177446 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177450 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177454 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177457 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177461 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 177465 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177467 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177474 */   // (sint_to_fp:{ *:[f16] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (VCVTSI2SHZrm:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), addr:{ *:[iPTR] }:$src)
     /* 177474 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 177477 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 177481 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177486 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 177488 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SHZrm),
     /* 177491 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177493 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177496 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 177500 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 177505 */   GIR_RootConstrainSelectedInstOperands,
     /* 177506 */   // GIR_Coverage, 22177,
     /* 177506 */   GIR_EraseRootFromParent_Done,
     /* 177507 */ // Label 3895: @177507
     /* 177507 */ GIM_Try, /*On fail goto*//*Label 3896*/ GIMT_Encode4(177552), // Rule ID 22181 //
     /* 177512 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 177515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 177518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 177522 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 177526 */   // (sint_to_fp:{ *:[f16] } GR32:{ *:[i32] }:$src)  =>  (VCVTSI2SHZrr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), GR32:{ *:[i32] }:$src)
     /* 177526 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 177529 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 177533 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177538 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 177540 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SHZrr),
     /* 177543 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177545 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177548 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 177550 */   GIR_RootConstrainSelectedInstOperands,
     /* 177551 */   // GIR_Coverage, 22181,
     /* 177551 */   GIR_EraseRootFromParent_Done,
     /* 177552 */ // Label 3896: @177552
     /* 177552 */ GIM_Try, /*On fail goto*//*Label 3897*/ GIMT_Encode4(177597), // Rule ID 22183 //
     /* 177557 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 177560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 177563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 177567 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 177571 */   // (sint_to_fp:{ *:[f16] } GR64:{ *:[i64] }:$src)  =>  (VCVTSI642SHZrr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), GR64:{ *:[i64] }:$src)
     /* 177571 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 177574 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 177578 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177583 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 177585 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SHZrr),
     /* 177588 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177590 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177593 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 177595 */   GIR_RootConstrainSelectedInstOperands,
     /* 177596 */   // GIR_Coverage, 22183,
     /* 177596 */   GIR_EraseRootFromParent_Done,
     /* 177597 */ // Label 3897: @177597
     /* 177597 */ GIM_Reject,
     /* 177598 */ // Label 3882: @177598
     /* 177598 */ GIM_Try, /*On fail goto*//*Label 3898*/ GIMT_Encode4(177657), // Rule ID 1794 //
     /* 177603 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 177606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 177609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 177613 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177617 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177621 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177624 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 177628 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177632 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177634 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177641 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSI642SSrm:{ *:[f32] } addr:{ *:[iPTR] }:$src)
     /* 177641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSI642SSrm),
     /* 177644 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177646 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 177650 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 177655 */   GIR_RootConstrainSelectedInstOperands,
     /* 177656 */   // GIR_Coverage, 1794,
     /* 177656 */   GIR_EraseRootFromParent_Done,
     /* 177657 */ // Label 3898: @177657
     /* 177657 */ GIM_Try, /*On fail goto*//*Label 3899*/ GIMT_Encode4(177733), // Rule ID 17976 //
     /* 177662 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 177665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 177668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 177672 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177676 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177680 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177683 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 177687 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177691 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177693 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177700 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSI642SSrm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 177700 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 177703 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 177707 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177712 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 177714 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SSrm),
     /* 177717 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177719 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177722 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 177726 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 177731 */   GIR_RootConstrainSelectedInstOperands,
     /* 177732 */   // GIR_Coverage, 17976,
     /* 177732 */   GIR_EraseRootFromParent_Done,
     /* 177733 */ // Label 3899: @177733
     /* 177733 */ GIM_Try, /*On fail goto*//*Label 3900*/ GIMT_Encode4(177809), // Rule ID 21130 //
     /* 177738 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 177741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 177744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 177748 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177752 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177756 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177759 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 177763 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177767 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177769 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177776 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSI642SSZrm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 177776 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 177779 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 177783 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177788 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 177790 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SSZrm),
     /* 177793 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177795 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177798 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 177802 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 177807 */   GIR_RootConstrainSelectedInstOperands,
     /* 177808 */   // GIR_Coverage, 21130,
     /* 177808 */   GIR_EraseRootFromParent_Done,
     /* 177809 */ // Label 3900: @177809
     /* 177809 */ GIM_Try, /*On fail goto*//*Label 3901*/ GIMT_Encode4(177868), // Rule ID 1790 //
     /* 177814 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 177817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 177820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 177824 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177828 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177832 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177835 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177839 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 177843 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177845 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177852 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (CVTSI2SSrm:{ *:[f32] } addr:{ *:[iPTR] }:$src)
     /* 177852 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSI2SSrm),
     /* 177855 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177857 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 177861 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 177866 */   GIR_RootConstrainSelectedInstOperands,
     /* 177867 */   // GIR_Coverage, 1790,
     /* 177867 */   GIR_EraseRootFromParent_Done,
     /* 177868 */ // Label 3901: @177868
     /* 177868 */ GIM_Try, /*On fail goto*//*Label 3902*/ GIMT_Encode4(177944), // Rule ID 17974 //
     /* 177873 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 177876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 177879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 177883 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177887 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177891 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177894 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177898 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 177902 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177904 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177911 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (VCVTSI2SSrm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 177911 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 177914 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 177918 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177923 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 177925 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SSrm),
     /* 177928 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177930 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177933 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 177937 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 177942 */   GIR_RootConstrainSelectedInstOperands,
     /* 177943 */   // GIR_Coverage, 17974,
     /* 177943 */   GIR_EraseRootFromParent_Done,
     /* 177944 */ // Label 3902: @177944
     /* 177944 */ GIM_Try, /*On fail goto*//*Label 3903*/ GIMT_Encode4(178020), // Rule ID 21128 //
     /* 177949 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 177952 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 177955 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 177959 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177963 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177967 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177970 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177974 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 177978 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177980 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177987 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (VCVTSI2SSZrm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 177987 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 177990 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 177994 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177999 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 178001 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SSZrm),
     /* 178004 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178006 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178009 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178013 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178018 */   GIR_RootConstrainSelectedInstOperands,
     /* 178019 */   // GIR_Coverage, 21128,
     /* 178019 */   GIR_EraseRootFromParent_Done,
     /* 178020 */ // Label 3903: @178020
     /* 178020 */ GIM_Try, /*On fail goto*//*Label 3904*/ GIMT_Encode4(178050), // Rule ID 1788 //
     /* 178025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 178028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 178031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 178035 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 178039 */   // (sint_to_fp:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (CVTSI2SSrr:{ *:[f32] } GR32:{ *:[i32] }:$src)
     /* 178039 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSI2SSrr),
     /* 178044 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 178048 */   GIR_RootConstrainSelectedInstOperands,
     /* 178049 */   // GIR_Coverage, 1788,
     /* 178049 */   GIR_Done,
     /* 178050 */ // Label 3904: @178050
     /* 178050 */ GIM_Try, /*On fail goto*//*Label 3905*/ GIMT_Encode4(178080), // Rule ID 1792 //
     /* 178055 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 178058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 178061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 178065 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 178069 */   // (sint_to_fp:{ *:[f32] } GR64:{ *:[i64] }:$src)  =>  (CVTSI642SSrr:{ *:[f32] } GR64:{ *:[i64] }:$src)
     /* 178069 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSI642SSrr),
     /* 178074 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 178078 */   GIR_RootConstrainSelectedInstOperands,
     /* 178079 */   // GIR_Coverage, 1792,
     /* 178079 */   GIR_Done,
     /* 178080 */ // Label 3905: @178080
     /* 178080 */ GIM_Try, /*On fail goto*//*Label 3906*/ GIMT_Encode4(178125), // Rule ID 17982 //
     /* 178085 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 178088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 178091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 178095 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 178099 */   // (sint_to_fp:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (VCVTSI2SSrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), GR32:{ *:[i32] }:$src)
     /* 178099 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 178102 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 178106 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178111 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 178113 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SSrr),
     /* 178116 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178118 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178121 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 178123 */   GIR_RootConstrainSelectedInstOperands,
     /* 178124 */   // GIR_Coverage, 17982,
     /* 178124 */   GIR_EraseRootFromParent_Done,
     /* 178125 */ // Label 3906: @178125
     /* 178125 */ GIM_Try, /*On fail goto*//*Label 3907*/ GIMT_Encode4(178170), // Rule ID 17984 //
     /* 178130 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 178133 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 178136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 178140 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 178144 */   // (sint_to_fp:{ *:[f32] } GR64:{ *:[i64] }:$src)  =>  (VCVTSI642SSrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), GR64:{ *:[i64] }:$src)
     /* 178144 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 178147 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 178151 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178156 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 178158 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SSrr),
     /* 178161 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178163 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178166 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 178168 */   GIR_RootConstrainSelectedInstOperands,
     /* 178169 */   // GIR_Coverage, 17984,
     /* 178169 */   GIR_EraseRootFromParent_Done,
     /* 178170 */ // Label 3907: @178170
     /* 178170 */ GIM_Try, /*On fail goto*//*Label 3908*/ GIMT_Encode4(178215), // Rule ID 21136 //
     /* 178175 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 178178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 178181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 178185 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 178189 */   // (sint_to_fp:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (VCVTSI2SSZrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), GR32:{ *:[i32] }:$src)
     /* 178189 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 178192 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 178196 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178201 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 178203 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SSZrr),
     /* 178206 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178208 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178211 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 178213 */   GIR_RootConstrainSelectedInstOperands,
     /* 178214 */   // GIR_Coverage, 21136,
     /* 178214 */   GIR_EraseRootFromParent_Done,
     /* 178215 */ // Label 3908: @178215
     /* 178215 */ GIM_Try, /*On fail goto*//*Label 3909*/ GIMT_Encode4(178260), // Rule ID 21138 //
     /* 178220 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 178223 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 178226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 178230 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 178234 */   // (sint_to_fp:{ *:[f32] } GR64:{ *:[i64] }:$src)  =>  (VCVTSI642SSZrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), GR64:{ *:[i64] }:$src)
     /* 178234 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 178237 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 178241 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178246 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 178248 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SSZrr),
     /* 178251 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178253 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178256 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 178258 */   GIR_RootConstrainSelectedInstOperands,
     /* 178259 */   // GIR_Coverage, 21138,
     /* 178259 */   GIR_EraseRootFromParent_Done,
     /* 178260 */ // Label 3909: @178260
     /* 178260 */ GIM_Reject,
     /* 178261 */ // Label 3883: @178261
     /* 178261 */ GIM_Try, /*On fail goto*//*Label 3910*/ GIMT_Encode4(178320), // Rule ID 1802 //
     /* 178266 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 178269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 178272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 178276 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 178280 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 178284 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178287 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 178291 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 178295 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178297 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 178304 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSI642SDrm:{ *:[f64] } addr:{ *:[iPTR] }:$src)
     /* 178304 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSI642SDrm),
     /* 178307 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178309 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178313 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178318 */   GIR_RootConstrainSelectedInstOperands,
     /* 178319 */   // GIR_Coverage, 1802,
     /* 178319 */   GIR_EraseRootFromParent_Done,
     /* 178320 */ // Label 3910: @178320
     /* 178320 */ GIM_Try, /*On fail goto*//*Label 3911*/ GIMT_Encode4(178396), // Rule ID 17980 //
     /* 178325 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 178328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 178331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 178335 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 178339 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 178343 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178346 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 178350 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 178354 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178356 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 178363 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSI642SDrm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 178363 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 178366 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 178370 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178375 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 178377 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SDrm),
     /* 178380 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178382 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178385 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178389 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178394 */   GIR_RootConstrainSelectedInstOperands,
     /* 178395 */   // GIR_Coverage, 17980,
     /* 178395 */   GIR_EraseRootFromParent_Done,
     /* 178396 */ // Label 3911: @178396
     /* 178396 */ GIM_Try, /*On fail goto*//*Label 3912*/ GIMT_Encode4(178472), // Rule ID 21134 //
     /* 178401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 178404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 178407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 178411 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 178415 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 178419 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178422 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 178426 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 178430 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178432 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 178439 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSI642SDZrm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 178439 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 178442 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 178446 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178451 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 178453 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SDZrm),
     /* 178456 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178458 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178461 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178465 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178470 */   GIR_RootConstrainSelectedInstOperands,
     /* 178471 */   // GIR_Coverage, 21134,
     /* 178471 */   GIR_EraseRootFromParent_Done,
     /* 178472 */ // Label 3912: @178472
     /* 178472 */ GIM_Try, /*On fail goto*//*Label 3913*/ GIMT_Encode4(178531), // Rule ID 1798 //
     /* 178477 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 178480 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 178483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 178487 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 178491 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 178495 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178498 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 178502 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 178506 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178508 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 178515 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (CVTSI2SDrm:{ *:[f64] } addr:{ *:[iPTR] }:$src)
     /* 178515 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSI2SDrm),
     /* 178518 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178520 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178524 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178529 */   GIR_RootConstrainSelectedInstOperands,
     /* 178530 */   // GIR_Coverage, 1798,
     /* 178530 */   GIR_EraseRootFromParent_Done,
     /* 178531 */ // Label 3913: @178531
     /* 178531 */ GIM_Try, /*On fail goto*//*Label 3914*/ GIMT_Encode4(178607), // Rule ID 17978 //
     /* 178536 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 178539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 178542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 178546 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 178550 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 178554 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178557 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 178561 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 178565 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178567 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 178574 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (VCVTSI2SDrm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 178574 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 178577 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 178581 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178586 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 178588 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SDrm),
     /* 178591 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178593 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178596 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178600 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178605 */   GIR_RootConstrainSelectedInstOperands,
     /* 178606 */   // GIR_Coverage, 17978,
     /* 178606 */   GIR_EraseRootFromParent_Done,
     /* 178607 */ // Label 3914: @178607
     /* 178607 */ GIM_Try, /*On fail goto*//*Label 3915*/ GIMT_Encode4(178683), // Rule ID 21132 //
     /* 178612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 178615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 178618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 178622 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 178626 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 178630 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178633 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 178637 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 178641 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178643 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 178650 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (VCVTSI2SDZrm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 178650 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 178653 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 178657 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178662 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 178664 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SDZrm),
     /* 178667 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178669 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178672 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178676 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178681 */   GIR_RootConstrainSelectedInstOperands,
     /* 178682 */   // GIR_Coverage, 21132,
     /* 178682 */   GIR_EraseRootFromParent_Done,
     /* 178683 */ // Label 3915: @178683
     /* 178683 */ GIM_Try, /*On fail goto*//*Label 3916*/ GIMT_Encode4(178709), // Rule ID 1796 //
     /* 178688 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 178691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 178694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 178698 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 178702 */   // (sint_to_fp:{ *:[f64] } GR32:{ *:[i32] }:$src)  =>  (CVTSI2SDrr:{ *:[f64] } GR32:{ *:[i32] }:$src)
     /* 178702 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSI2SDrr),
     /* 178707 */   GIR_RootConstrainSelectedInstOperands,
     /* 178708 */   // GIR_Coverage, 1796,
     /* 178708 */   GIR_Done,
     /* 178709 */ // Label 3916: @178709
     /* 178709 */ GIM_Try, /*On fail goto*//*Label 3917*/ GIMT_Encode4(178739), // Rule ID 1800 //
     /* 178714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 178717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 178720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 178724 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 178728 */   // (sint_to_fp:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (CVTSI642SDrr:{ *:[f64] } GR64:{ *:[i64] }:$src)
     /* 178728 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSI642SDrr),
     /* 178733 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 178737 */   GIR_RootConstrainSelectedInstOperands,
     /* 178738 */   // GIR_Coverage, 1800,
     /* 178738 */   GIR_Done,
     /* 178739 */ // Label 3917: @178739
     /* 178739 */ GIM_Try, /*On fail goto*//*Label 3918*/ GIMT_Encode4(178784), // Rule ID 17986 //
     /* 178744 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 178747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 178750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 178754 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 178758 */   // (sint_to_fp:{ *:[f64] } GR32:{ *:[i32] }:$src)  =>  (VCVTSI2SDrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), GR32:{ *:[i32] }:$src)
     /* 178758 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 178761 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 178765 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178770 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 178772 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SDrr),
     /* 178775 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178777 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178780 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 178782 */   GIR_RootConstrainSelectedInstOperands,
     /* 178783 */   // GIR_Coverage, 17986,
     /* 178783 */   GIR_EraseRootFromParent_Done,
     /* 178784 */ // Label 3918: @178784
     /* 178784 */ GIM_Try, /*On fail goto*//*Label 3919*/ GIMT_Encode4(178829), // Rule ID 17988 //
     /* 178789 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 178792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 178795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 178799 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 178803 */   // (sint_to_fp:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (VCVTSI642SDrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), GR64:{ *:[i64] }:$src)
     /* 178803 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 178806 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 178810 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178815 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 178817 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SDrr),
     /* 178820 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178822 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178825 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 178827 */   GIR_RootConstrainSelectedInstOperands,
     /* 178828 */   // GIR_Coverage, 17988,
     /* 178828 */   GIR_EraseRootFromParent_Done,
     /* 178829 */ // Label 3919: @178829
     /* 178829 */ GIM_Try, /*On fail goto*//*Label 3920*/ GIMT_Encode4(178874), // Rule ID 21140 //
     /* 178834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 178837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 178840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 178844 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 178848 */   // (sint_to_fp:{ *:[f64] } GR32:{ *:[i32] }:$src)  =>  (VCVTSI2SDZrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), GR32:{ *:[i32] }:$src)
     /* 178848 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 178851 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 178855 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178860 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 178862 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SDZrr),
     /* 178865 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178867 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178870 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 178872 */   GIR_RootConstrainSelectedInstOperands,
     /* 178873 */   // GIR_Coverage, 21140,
     /* 178873 */   GIR_EraseRootFromParent_Done,
     /* 178874 */ // Label 3920: @178874
     /* 178874 */ GIM_Try, /*On fail goto*//*Label 3921*/ GIMT_Encode4(178919), // Rule ID 21142 //
     /* 178879 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 178882 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 178885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 178889 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 178893 */   // (sint_to_fp:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (VCVTSI642SDZrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), GR64:{ *:[i64] }:$src)
     /* 178893 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 178896 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 178900 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178905 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 178907 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SDZrr),
     /* 178910 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178912 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178915 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 178917 */   GIR_RootConstrainSelectedInstOperands,
     /* 178918 */   // GIR_Coverage, 21142,
     /* 178918 */   GIR_EraseRootFromParent_Done,
     /* 178919 */ // Label 3921: @178919
     /* 178919 */ GIM_Reject,
     /* 178920 */ // Label 3884: @178920
     /* 178920 */ GIM_Try, /*On fail goto*//*Label 3922*/ GIMT_Encode4(179008),
     /* 178925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 178928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 178932 */   GIM_Try, /*On fail goto*//*Label 3923*/ GIMT_Encode4(178984), // Rule ID 11379 //
     /* 178937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 178940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 178944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 178948 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178951 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 178955 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 178959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178961 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 178968 */     // (sint_to_fp:{ *:[v2f64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTQQ2PDZ128rm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /* 178968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PDZ128rm),
     /* 178971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178973 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178977 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178982 */     GIR_RootConstrainSelectedInstOperands,
     /* 178983 */     // GIR_Coverage, 11379,
     /* 178983 */     GIR_EraseRootFromParent_Done,
     /* 178984 */   // Label 3923: @178984
     /* 178984 */   GIM_Try, /*On fail goto*//*Label 3924*/ GIMT_Encode4(179007), // Rule ID 11375 //
     /* 178989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 178992 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 178996 */     // (sint_to_fp:{ *:[v2f64] } VR128X:{ *:[v2i64] }:$src)  =>  (VCVTQQ2PDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2i64] }:$src)
     /* 178996 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PDZ128rr),
     /* 179001 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 179005 */     GIR_RootConstrainSelectedInstOperands,
     /* 179006 */     // GIR_Coverage, 11375,
     /* 179006 */     GIR_Done,
     /* 179007 */   // Label 3924: @179007
     /* 179007 */   GIM_Reject,
     /* 179008 */ // Label 3922: @179008
     /* 179008 */ GIM_Reject,
     /* 179009 */ // Label 3885: @179009
     /* 179009 */ GIM_Try, /*On fail goto*//*Label 3925*/ GIMT_Encode4(179068), // Rule ID 1870 //
     /* 179014 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 179017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 179024 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 179028 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179032 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179035 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179039 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179043 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179045 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179052 */   // (sint_to_fp:{ *:[v4f32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 179052 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSrm),
     /* 179055 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179057 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 179061 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179066 */   GIR_RootConstrainSelectedInstOperands,
     /* 179067 */   // GIR_Coverage, 1870,
     /* 179067 */   GIR_EraseRootFromParent_Done,
     /* 179068 */ // Label 3925: @179068
     /* 179068 */ GIM_Try, /*On fail goto*//*Label 3926*/ GIMT_Encode4(179127), // Rule ID 10755 //
     /* 179073 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 179076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179083 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 179087 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179091 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179094 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179098 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179102 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179104 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179111 */   // (sint_to_fp:{ *:[v4f32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PSZ128rm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 179111 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSZ128rm),
     /* 179114 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179116 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 179120 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179125 */   GIR_RootConstrainSelectedInstOperands,
     /* 179126 */   // GIR_Coverage, 10755,
     /* 179126 */   GIR_EraseRootFromParent_Done,
     /* 179127 */ // Label 3926: @179127
     /* 179127 */ GIM_Try, /*On fail goto*//*Label 3927*/ GIMT_Encode4(179186), // Rule ID 11511 //
     /* 179132 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 179135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 179138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179142 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 179146 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179150 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179153 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179157 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179161 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179163 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179170 */   // (sint_to_fp:{ *:[v4f32] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTQQ2PSZ256rm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 179170 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PSZ256rm),
     /* 179173 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179175 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 179179 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179184 */   GIR_RootConstrainSelectedInstOperands,
     /* 179185 */   // GIR_Coverage, 11511,
     /* 179185 */   GIR_EraseRootFromParent_Done,
     /* 179186 */ // Label 3927: @179186
     /* 179186 */ GIM_Try, /*On fail goto*//*Label 3928*/ GIMT_Encode4(179216), // Rule ID 1868 //
     /* 179191 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 179194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 179201 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 179205 */   // (sint_to_fp:{ *:[v4f32] } VR128:{ *:[v4i32] }:$src)  =>  (VCVTDQ2PSrr:{ *:[v4f32] } VR128:{ *:[v4i32] }:$src)
     /* 179205 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSrr),
     /* 179210 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 179214 */   GIR_RootConstrainSelectedInstOperands,
     /* 179215 */   // GIR_Coverage, 1868,
     /* 179215 */   GIR_Done,
     /* 179216 */ // Label 3928: @179216
     /* 179216 */ GIM_Try, /*On fail goto*//*Label 3929*/ GIMT_Encode4(179246), // Rule ID 1876 //
     /* 179221 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 179224 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 179231 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 179235 */   // (sint_to_fp:{ *:[v4f32] } VR128:{ *:[v4i32] }:$src)  =>  (CVTDQ2PSrr:{ *:[v4f32] } VR128:{ *:[v4i32] }:$src)
     /* 179235 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTDQ2PSrr),
     /* 179240 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 179244 */   GIR_RootConstrainSelectedInstOperands,
     /* 179245 */   // GIR_Coverage, 1876,
     /* 179245 */   GIR_Done,
     /* 179246 */ // Label 3929: @179246
     /* 179246 */ GIM_Try, /*On fail goto*//*Label 3930*/ GIMT_Encode4(179276), // Rule ID 10751 //
     /* 179251 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 179254 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179261 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179265 */   // (sint_to_fp:{ *:[v4f32] } VR128X:{ *:[v4i32] }:$src)  =>  (VCVTDQ2PSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4i32] }:$src)
     /* 179265 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSZ128rr),
     /* 179270 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 179274 */   GIR_RootConstrainSelectedInstOperands,
     /* 179275 */   // GIR_Coverage, 10751,
     /* 179275 */   GIR_Done,
     /* 179276 */ // Label 3930: @179276
     /* 179276 */ GIM_Try, /*On fail goto*//*Label 3931*/ GIMT_Encode4(179306), // Rule ID 11507 //
     /* 179281 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 179284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 179287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179291 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 179295 */   // (sint_to_fp:{ *:[v4f32] } VR256X:{ *:[v4i64] }:$src)  =>  (VCVTQQ2PSZ256rr:{ *:[v4f32] } VR256X:{ *:[v4i64] }:$src)
     /* 179295 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PSZ256rr),
     /* 179300 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 179304 */   GIR_RootConstrainSelectedInstOperands,
     /* 179305 */   // GIR_Coverage, 11507,
     /* 179305 */   GIR_Done,
     /* 179306 */ // Label 3931: @179306
     /* 179306 */ GIM_Reject,
     /* 179307 */ // Label 3886: @179307
     /* 179307 */ GIM_Try, /*On fail goto*//*Label 3932*/ GIMT_Encode4(179366), // Rule ID 1945 //
     /* 179312 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 179315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 179322 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 179326 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179330 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179333 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179337 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179341 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179343 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179350 */   // (sint_to_fp:{ *:[v4f64] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PDYrm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /* 179350 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PDYrm),
     /* 179353 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179355 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 179359 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179364 */   GIR_RootConstrainSelectedInstOperands,
     /* 179365 */   // GIR_Coverage, 1945,
     /* 179365 */   GIR_EraseRootFromParent_Done,
     /* 179366 */ // Label 3932: @179366
     /* 179366 */ GIM_Try, /*On fail goto*//*Label 3933*/ GIMT_Encode4(179425), // Rule ID 10728 //
     /* 179371 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 179374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 179381 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 179385 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179389 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179392 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179396 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179400 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179402 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179409 */   // (sint_to_fp:{ *:[v4f64] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PDZ256rm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /* 179409 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PDZ256rm),
     /* 179412 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179414 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 179418 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179423 */   GIR_RootConstrainSelectedInstOperands,
     /* 179424 */   // GIR_Coverage, 10728,
     /* 179424 */   GIR_EraseRootFromParent_Done,
     /* 179425 */ // Label 3933: @179425
     /* 179425 */ GIM_Try, /*On fail goto*//*Label 3934*/ GIMT_Encode4(179484), // Rule ID 11391 //
     /* 179430 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 179433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 179436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 179440 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 179444 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179448 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179451 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179455 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179459 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179461 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179468 */   // (sint_to_fp:{ *:[v4f64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTQQ2PDZ256rm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /* 179468 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PDZ256rm),
     /* 179471 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179473 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 179477 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179482 */   GIR_RootConstrainSelectedInstOperands,
     /* 179483 */   // GIR_Coverage, 11391,
     /* 179483 */   GIR_EraseRootFromParent_Done,
     /* 179484 */ // Label 3934: @179484
     /* 179484 */ GIM_Try, /*On fail goto*//*Label 3935*/ GIMT_Encode4(179510), // Rule ID 1947 //
     /* 179489 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 179492 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 179499 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 179503 */   // (sint_to_fp:{ *:[v4f64] } VR128:{ *:[v4i32] }:$src)  =>  (VCVTDQ2PDYrr:{ *:[v4f64] } VR128:{ *:[v4i32] }:$src)
     /* 179503 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PDYrr),
     /* 179508 */   GIR_RootConstrainSelectedInstOperands,
     /* 179509 */   // GIR_Coverage, 1947,
     /* 179509 */   GIR_Done,
     /* 179510 */ // Label 3935: @179510
     /* 179510 */ GIM_Try, /*On fail goto*//*Label 3936*/ GIMT_Encode4(179536), // Rule ID 10724 //
     /* 179515 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 179518 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 179525 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179529 */   // (sint_to_fp:{ *:[v4f64] } VR128X:{ *:[v4i32] }:$src)  =>  (VCVTDQ2PDZ256rr:{ *:[v4f64] } VR128X:{ *:[v4i32] }:$src)
     /* 179529 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PDZ256rr),
     /* 179534 */   GIR_RootConstrainSelectedInstOperands,
     /* 179535 */   // GIR_Coverage, 10724,
     /* 179535 */   GIR_Done,
     /* 179536 */ // Label 3936: @179536
     /* 179536 */ GIM_Try, /*On fail goto*//*Label 3937*/ GIMT_Encode4(179566), // Rule ID 11387 //
     /* 179541 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 179544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 179547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 179551 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 179555 */   // (sint_to_fp:{ *:[v4f64] } VR256X:{ *:[v4i64] }:$src)  =>  (VCVTQQ2PDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4i64] }:$src)
     /* 179555 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PDZ256rr),
     /* 179560 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 179564 */   GIR_RootConstrainSelectedInstOperands,
     /* 179565 */   // GIR_Coverage, 11387,
     /* 179565 */   GIR_Done,
     /* 179566 */ // Label 3937: @179566
     /* 179566 */ GIM_Reject,
     /* 179567 */ // Label 3887: @179567
     /* 179567 */ GIM_Try, /*On fail goto*//*Label 3938*/ GIMT_Encode4(179626), // Rule ID 11457 //
     /* 179572 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 179575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 179578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179582 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 179586 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179590 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179593 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179597 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179601 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179603 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179610 */   // (sint_to_fp:{ *:[v8f16] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PHZ256rm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /* 179610 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PHZ256rm),
     /* 179613 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179615 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 179619 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179624 */   GIR_RootConstrainSelectedInstOperands,
     /* 179625 */   // GIR_Coverage, 11457,
     /* 179625 */   GIR_EraseRootFromParent_Done,
     /* 179626 */ // Label 3938: @179626
     /* 179626 */ GIM_Try, /*On fail goto*//*Label 3939*/ GIMT_Encode4(179685), // Rule ID 14823 //
     /* 179631 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 179634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 179637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179641 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 179645 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179649 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179652 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179656 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179660 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179662 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179669 */   // (sint_to_fp:{ *:[v8f16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTW2PHZ128rm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /* 179669 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTW2PHZ128rm),
     /* 179672 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179674 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 179678 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179683 */   GIR_RootConstrainSelectedInstOperands,
     /* 179684 */   // GIR_Coverage, 14823,
     /* 179684 */   GIR_EraseRootFromParent_Done,
     /* 179685 */ // Label 3939: @179685
     /* 179685 */ GIM_Try, /*On fail goto*//*Label 3940*/ GIMT_Encode4(179744), // Rule ID 15123 //
     /* 179690 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 179693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 179696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179700 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 179704 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179708 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179711 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179715 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179719 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179721 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179728 */   // (sint_to_fp:{ *:[v8f16] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTQQ2PHZrm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /* 179728 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PHZrm),
     /* 179731 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179733 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 179737 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179742 */   GIR_RootConstrainSelectedInstOperands,
     /* 179743 */   // GIR_Coverage, 15123,
     /* 179743 */   GIR_EraseRootFromParent_Done,
     /* 179744 */ // Label 3940: @179744
     /* 179744 */ GIM_Try, /*On fail goto*//*Label 3941*/ GIMT_Encode4(179774), // Rule ID 11453 //
     /* 179749 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 179752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 179755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179759 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 179763 */   // (sint_to_fp:{ *:[v8f16] } VR256X:{ *:[v8i32] }:$src)  =>  (VCVTDQ2PHZ256rr:{ *:[v8f16] } VR256X:{ *:[v8i32] }:$src)
     /* 179763 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PHZ256rr),
     /* 179768 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 179772 */   GIR_RootConstrainSelectedInstOperands,
     /* 179773 */   // GIR_Coverage, 11453,
     /* 179773 */   GIR_Done,
     /* 179774 */ // Label 3941: @179774
     /* 179774 */ GIM_Try, /*On fail goto*//*Label 3942*/ GIMT_Encode4(179804), // Rule ID 14819 //
     /* 179779 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 179782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 179785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179789 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179793 */   // (sint_to_fp:{ *:[v8f16] } VR128X:{ *:[v8i16] }:$src)  =>  (VCVTW2PHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8i16] }:$src)
     /* 179793 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTW2PHZ128rr),
     /* 179798 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 179802 */   GIR_RootConstrainSelectedInstOperands,
     /* 179803 */   // GIR_Coverage, 14819,
     /* 179803 */   GIR_Done,
     /* 179804 */ // Label 3942: @179804
     /* 179804 */ GIM_Try, /*On fail goto*//*Label 3943*/ GIMT_Encode4(179834), // Rule ID 15119 //
     /* 179809 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 179812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 179815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179819 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 179823 */   // (sint_to_fp:{ *:[v8f16] } VR512:{ *:[v8i64] }:$src)  =>  (VCVTQQ2PHZrr:{ *:[v8f16] } VR512:{ *:[v8i64] }:$src)
     /* 179823 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PHZrr),
     /* 179828 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 179832 */   GIR_RootConstrainSelectedInstOperands,
     /* 179833 */   // GIR_Coverage, 15119,
     /* 179833 */   GIR_Done,
     /* 179834 */ // Label 3943: @179834
     /* 179834 */ GIM_Reject,
     /* 179835 */ // Label 3888: @179835
     /* 179835 */ GIM_Try, /*On fail goto*//*Label 3944*/ GIMT_Encode4(179894), // Rule ID 1874 //
     /* 179840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 179843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 179846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 179850 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 179854 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179858 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179861 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179865 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179869 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179871 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179878 */   // (sint_to_fp:{ *:[v8f32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 179878 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSYrm),
     /* 179881 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179883 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 179887 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179892 */   GIR_RootConstrainSelectedInstOperands,
     /* 179893 */   // GIR_Coverage, 1874,
     /* 179893 */   GIR_EraseRootFromParent_Done,
     /* 179894 */ // Label 3944: @179894
     /* 179894 */ GIM_Try, /*On fail goto*//*Label 3945*/ GIMT_Encode4(179953), // Rule ID 10767 //
     /* 179899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 179902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 179905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 179909 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 179913 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179917 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179920 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179924 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179928 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179930 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179937 */   // (sint_to_fp:{ *:[v8f32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PSZ256rm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 179937 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSZ256rm),
     /* 179940 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179942 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 179946 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179951 */   GIR_RootConstrainSelectedInstOperands,
     /* 179952 */   // GIR_Coverage, 10767,
     /* 179952 */   GIR_EraseRootFromParent_Done,
     /* 179953 */ // Label 3945: @179953
     /* 179953 */ GIM_Try, /*On fail goto*//*Label 3946*/ GIMT_Encode4(180012), // Rule ID 11496 //
     /* 179958 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 179961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 179964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 179968 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 179972 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179976 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179979 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179983 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179987 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179989 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179996 */   // (sint_to_fp:{ *:[v8f32] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTQQ2PSZrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 179996 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PSZrm),
     /* 179999 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180001 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 180005 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 180010 */   GIR_RootConstrainSelectedInstOperands,
     /* 180011 */   // GIR_Coverage, 11496,
     /* 180011 */   GIR_EraseRootFromParent_Done,
     /* 180012 */ // Label 3946: @180012
     /* 180012 */ GIM_Try, /*On fail goto*//*Label 3947*/ GIMT_Encode4(180042), // Rule ID 1872 //
     /* 180017 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 180020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 180023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 180027 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 180031 */   // (sint_to_fp:{ *:[v8f32] } VR256:{ *:[v8i32] }:$src)  =>  (VCVTDQ2PSYrr:{ *:[v8f32] } VR256:{ *:[v8i32] }:$src)
     /* 180031 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSYrr),
     /* 180036 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 180040 */   GIR_RootConstrainSelectedInstOperands,
     /* 180041 */   // GIR_Coverage, 1872,
     /* 180041 */   GIR_Done,
     /* 180042 */ // Label 3947: @180042
     /* 180042 */ GIM_Try, /*On fail goto*//*Label 3948*/ GIMT_Encode4(180072), // Rule ID 10763 //
     /* 180047 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 180050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 180053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 180057 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 180061 */   // (sint_to_fp:{ *:[v8f32] } VR256X:{ *:[v8i32] }:$src)  =>  (VCVTDQ2PSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8i32] }:$src)
     /* 180061 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSZ256rr),
     /* 180066 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 180070 */   GIR_RootConstrainSelectedInstOperands,
     /* 180071 */   // GIR_Coverage, 10763,
     /* 180071 */   GIR_Done,
     /* 180072 */ // Label 3948: @180072
     /* 180072 */ GIM_Try, /*On fail goto*//*Label 3949*/ GIMT_Encode4(180102), // Rule ID 11492 //
     /* 180077 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 180080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 180083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 180087 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 180091 */   // (sint_to_fp:{ *:[v8f32] } VR512:{ *:[v8i64] }:$src)  =>  (VCVTQQ2PSZrr:{ *:[v8f32] } VR512:{ *:[v8i64] }:$src)
     /* 180091 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PSZrr),
     /* 180096 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 180100 */   GIR_RootConstrainSelectedInstOperands,
     /* 180101 */   // GIR_Coverage, 11492,
     /* 180101 */   GIR_Done,
     /* 180102 */ // Label 3949: @180102
     /* 180102 */ GIM_Reject,
     /* 180103 */ // Label 3889: @180103
     /* 180103 */ GIM_Try, /*On fail goto*//*Label 3950*/ GIMT_Encode4(180162), // Rule ID 10704 //
     /* 180108 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 180111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 180114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 180118 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 180122 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 180126 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180129 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 180133 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 180137 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180139 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 180146 */   // (sint_to_fp:{ *:[v8f64] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PDZrm:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)
     /* 180146 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PDZrm),
     /* 180149 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180151 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 180155 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 180160 */   GIR_RootConstrainSelectedInstOperands,
     /* 180161 */   // GIR_Coverage, 10704,
     /* 180161 */   GIR_EraseRootFromParent_Done,
     /* 180162 */ // Label 3950: @180162
     /* 180162 */ GIM_Try, /*On fail goto*//*Label 3951*/ GIMT_Encode4(180221), // Rule ID 11364 //
     /* 180167 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 180170 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 180173 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 180177 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 180181 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 180185 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180188 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 180192 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 180196 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180198 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 180205 */   // (sint_to_fp:{ *:[v8f64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTQQ2PDZrm:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)
     /* 180205 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PDZrm),
     /* 180208 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180210 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 180214 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 180219 */   GIR_RootConstrainSelectedInstOperands,
     /* 180220 */   // GIR_Coverage, 11364,
     /* 180220 */   GIR_EraseRootFromParent_Done,
     /* 180221 */ // Label 3951: @180221
     /* 180221 */ GIM_Try, /*On fail goto*//*Label 3952*/ GIMT_Encode4(180247), // Rule ID 10700 //
     /* 180226 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 180229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 180232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 180236 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 180240 */   // (sint_to_fp:{ *:[v8f64] } VR256X:{ *:[v8i32] }:$src)  =>  (VCVTDQ2PDZrr:{ *:[v8f64] } VR256X:{ *:[v8i32] }:$src)
     /* 180240 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PDZrr),
     /* 180245 */   GIR_RootConstrainSelectedInstOperands,
     /* 180246 */   // GIR_Coverage, 10700,
     /* 180246 */   GIR_Done,
     /* 180247 */ // Label 3952: @180247
     /* 180247 */ GIM_Try, /*On fail goto*//*Label 3953*/ GIMT_Encode4(180277), // Rule ID 11360 //
     /* 180252 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 180255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 180258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 180262 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 180266 */   // (sint_to_fp:{ *:[v8f64] } VR512:{ *:[v8i64] }:$src)  =>  (VCVTQQ2PDZrr:{ *:[v8f64] } VR512:{ *:[v8i64] }:$src)
     /* 180266 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PDZrr),
     /* 180271 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 180275 */   GIR_RootConstrainSelectedInstOperands,
     /* 180276 */   // GIR_Coverage, 11360,
     /* 180276 */   GIR_Done,
     /* 180277 */ // Label 3953: @180277
     /* 180277 */ GIM_Reject,
     /* 180278 */ // Label 3890: @180278
     /* 180278 */ GIM_Try, /*On fail goto*//*Label 3954*/ GIMT_Encode4(180337), // Rule ID 11442 //
     /* 180283 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 180286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 180289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 180293 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 180297 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 180301 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180304 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 180308 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 180312 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180314 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 180321 */   // (sint_to_fp:{ *:[v16f16] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PHZrm:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /* 180321 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PHZrm),
     /* 180324 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180326 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 180330 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 180335 */   GIR_RootConstrainSelectedInstOperands,
     /* 180336 */   // GIR_Coverage, 11442,
     /* 180336 */   GIR_EraseRootFromParent_Done,
     /* 180337 */ // Label 3954: @180337
     /* 180337 */ GIM_Try, /*On fail goto*//*Label 3955*/ GIMT_Encode4(180396), // Rule ID 14835 //
     /* 180342 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 180345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 180348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 180352 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 180356 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 180360 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180363 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 180367 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 180371 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180373 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 180380 */   // (sint_to_fp:{ *:[v16f16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTW2PHZ256rm:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /* 180380 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTW2PHZ256rm),
     /* 180383 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180385 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 180389 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 180394 */   GIR_RootConstrainSelectedInstOperands,
     /* 180395 */   // GIR_Coverage, 14835,
     /* 180395 */   GIR_EraseRootFromParent_Done,
     /* 180396 */ // Label 3955: @180396
     /* 180396 */ GIM_Try, /*On fail goto*//*Label 3956*/ GIMT_Encode4(180426), // Rule ID 11438 //
     /* 180401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 180404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 180407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 180411 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 180415 */   // (sint_to_fp:{ *:[v16f16] } VR512:{ *:[v16i32] }:$src)  =>  (VCVTDQ2PHZrr:{ *:[v16f16] } VR512:{ *:[v16i32] }:$src)
     /* 180415 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PHZrr),
     /* 180420 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 180424 */   GIR_RootConstrainSelectedInstOperands,
     /* 180425 */   // GIR_Coverage, 11438,
     /* 180425 */   GIR_Done,
     /* 180426 */ // Label 3956: @180426
     /* 180426 */ GIM_Try, /*On fail goto*//*Label 3957*/ GIMT_Encode4(180456), // Rule ID 14831 //
     /* 180431 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 180434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 180437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 180441 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 180445 */   // (sint_to_fp:{ *:[v16f16] } VR256X:{ *:[v16i16] }:$src)  =>  (VCVTW2PHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16i16] }:$src)
     /* 180445 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTW2PHZ256rr),
     /* 180450 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 180454 */   GIR_RootConstrainSelectedInstOperands,
     /* 180455 */   // GIR_Coverage, 14831,
     /* 180455 */   GIR_Done,
     /* 180456 */ // Label 3957: @180456
     /* 180456 */ GIM_Reject,
     /* 180457 */ // Label 3891: @180457
     /* 180457 */ GIM_Try, /*On fail goto*//*Label 3958*/ GIMT_Encode4(180545),
     /* 180462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 180465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 180469 */   GIM_Try, /*On fail goto*//*Label 3959*/ GIMT_Encode4(180521), // Rule ID 10740 //
     /* 180474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 180477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 180481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 180485 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180488 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 180492 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 180496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180498 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 180505 */     // (sint_to_fp:{ *:[v16f32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PSZrm:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)
     /* 180505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSZrm),
     /* 180508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180510 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 180514 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 180519 */     GIR_RootConstrainSelectedInstOperands,
     /* 180520 */     // GIR_Coverage, 10740,
     /* 180520 */     GIR_EraseRootFromParent_Done,
     /* 180521 */   // Label 3959: @180521
     /* 180521 */   GIM_Try, /*On fail goto*//*Label 3960*/ GIMT_Encode4(180544), // Rule ID 10736 //
     /* 180526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 180529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 180533 */     // (sint_to_fp:{ *:[v16f32] } VR512:{ *:[v16i32] }:$src)  =>  (VCVTDQ2PSZrr:{ *:[v16f32] } VR512:{ *:[v16i32] }:$src)
     /* 180533 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSZrr),
     /* 180538 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 180542 */     GIR_RootConstrainSelectedInstOperands,
     /* 180543 */     // GIR_Coverage, 10736,
     /* 180543 */     GIR_Done,
     /* 180544 */   // Label 3960: @180544
     /* 180544 */   GIM_Reject,
     /* 180545 */ // Label 3958: @180545
     /* 180545 */ GIM_Reject,
     /* 180546 */ // Label 3892: @180546
     /* 180546 */ GIM_Try, /*On fail goto*//*Label 3961*/ GIMT_Encode4(180634),
     /* 180551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 180554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 180558 */   GIM_Try, /*On fail goto*//*Label 3962*/ GIMT_Encode4(180610), // Rule ID 14808 //
     /* 180563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 180566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 180570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 180574 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180577 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 180581 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 180585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180587 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 180594 */     // (sint_to_fp:{ *:[v32f16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTW2PHZrm:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)
     /* 180594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTW2PHZrm),
     /* 180597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180599 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 180603 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 180608 */     GIR_RootConstrainSelectedInstOperands,
     /* 180609 */     // GIR_Coverage, 14808,
     /* 180609 */     GIR_EraseRootFromParent_Done,
     /* 180610 */   // Label 3962: @180610
     /* 180610 */   GIM_Try, /*On fail goto*//*Label 3963*/ GIMT_Encode4(180633), // Rule ID 14804 //
     /* 180615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 180618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 180622 */     // (sint_to_fp:{ *:[v32f16] } VR512:{ *:[v32i16] }:$src)  =>  (VCVTW2PHZrr:{ *:[v32f16] } VR512:{ *:[v32i16] }:$src)
     /* 180622 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTW2PHZrr),
     /* 180627 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 180631 */     GIR_RootConstrainSelectedInstOperands,
     /* 180632 */     // GIR_Coverage, 14804,
     /* 180632 */     GIR_Done,
     /* 180633 */   // Label 3963: @180633
     /* 180633 */   GIM_Reject,
     /* 180634 */ // Label 3961: @180634
     /* 180634 */ GIM_Reject,
     /* 180635 */ // Label 3893: @180635
     /* 180635 */ GIM_Reject,
     /* 180636 */ // Label 52: @180636
     /* 180636 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 3976*/ GIMT_Encode4(182882),
     /* 180647 */ /*GILLT_s16*//*Label 3964*/ GIMT_Encode4(180731),
     /* 180651 */ /*GILLT_s32*//*Label 3965*/ GIMT_Encode4(180974),
     /* 180655 */ /*GILLT_s64*//*Label 3966*/ GIMT_Encode4(181217), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 180671 */ /*GILLT_v2s64*//*Label 3967*/ GIMT_Encode4(181460), GIMT_Encode4(0),
     /* 180679 */ /*GILLT_v4s32*//*Label 3968*/ GIMT_Encode4(181549),
     /* 180683 */ /*GILLT_v4s64*//*Label 3969*/ GIMT_Encode4(181728), GIMT_Encode4(0),
     /* 180691 */ /*GILLT_v8s16*//*Label 3970*/ GIMT_Encode4(181903),
     /* 180695 */ /*GILLT_v8s32*//*Label 3971*/ GIMT_Encode4(182171),
     /* 180699 */ /*GILLT_v8s64*//*Label 3972*/ GIMT_Encode4(182350), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 180711 */ /*GILLT_v16s16*//*Label 3973*/ GIMT_Encode4(182525),
     /* 180715 */ /*GILLT_v16s32*//*Label 3974*/ GIMT_Encode4(182704), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 180727 */ /*GILLT_v32s16*//*Label 3975*/ GIMT_Encode4(182793),
     /* 180731 */ // Label 3964: @180731
     /* 180731 */ GIM_Try, /*On fail goto*//*Label 3977*/ GIMT_Encode4(180807), // Rule ID 22187 //
     /* 180736 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 180739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 180742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 180746 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 180750 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 180754 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180757 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 180761 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 180765 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180767 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 180774 */   // (uint_to_fp:{ *:[f16] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUSI642SHZrm:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), addr:{ *:[iPTR] }:$src)
     /* 180774 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 180777 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 180781 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180786 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 180788 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI642SHZrm),
     /* 180791 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180793 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 180796 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 180800 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 180805 */   GIR_RootConstrainSelectedInstOperands,
     /* 180806 */   // GIR_Coverage, 22187,
     /* 180806 */   GIR_EraseRootFromParent_Done,
     /* 180807 */ // Label 3977: @180807
     /* 180807 */ GIM_Try, /*On fail goto*//*Label 3978*/ GIMT_Encode4(180883), // Rule ID 22185 //
     /* 180812 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 180815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 180818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 180822 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 180826 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 180830 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180833 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 180837 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 180841 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180843 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 180850 */   // (uint_to_fp:{ *:[f16] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (VCVTUSI2SHZrm:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), addr:{ *:[iPTR] }:$src)
     /* 180850 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 180853 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 180857 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180862 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 180864 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI2SHZrm),
     /* 180867 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180869 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 180872 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 180876 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 180881 */   GIR_RootConstrainSelectedInstOperands,
     /* 180882 */   // GIR_Coverage, 22185,
     /* 180882 */   GIR_EraseRootFromParent_Done,
     /* 180883 */ // Label 3978: @180883
     /* 180883 */ GIM_Try, /*On fail goto*//*Label 3979*/ GIMT_Encode4(180928), // Rule ID 22189 //
     /* 180888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 180891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 180894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 180898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 180902 */   // (uint_to_fp:{ *:[f16] } GR32:{ *:[i32] }:$src)  =>  (VCVTUSI2SHZrr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), GR32:{ *:[i32] }:$src)
     /* 180902 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 180905 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 180909 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180914 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 180916 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI2SHZrr),
     /* 180919 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180921 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 180924 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 180926 */   GIR_RootConstrainSelectedInstOperands,
     /* 180927 */   // GIR_Coverage, 22189,
     /* 180927 */   GIR_EraseRootFromParent_Done,
     /* 180928 */ // Label 3979: @180928
     /* 180928 */ GIM_Try, /*On fail goto*//*Label 3980*/ GIMT_Encode4(180973), // Rule ID 22191 //
     /* 180933 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 180936 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 180939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 180943 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 180947 */   // (uint_to_fp:{ *:[f16] } GR64:{ *:[i64] }:$src)  =>  (VCVTUSI642SHZrr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), GR64:{ *:[i64] }:$src)
     /* 180947 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 180950 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 180954 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180959 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 180961 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI642SHZrr),
     /* 180964 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180966 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 180969 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 180971 */   GIR_RootConstrainSelectedInstOperands,
     /* 180972 */   // GIR_Coverage, 22191,
     /* 180972 */   GIR_EraseRootFromParent_Done,
     /* 180973 */ // Label 3980: @180973
     /* 180973 */ GIM_Reject,
     /* 180974 */ // Label 3965: @180974
     /* 180974 */ GIM_Try, /*On fail goto*//*Label 3981*/ GIMT_Encode4(181050), // Rule ID 21146 //
     /* 180979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 180982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 180985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 180989 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 180993 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 180997 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181000 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181004 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181008 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181010 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181017 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUSI642SSZrm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 181017 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 181020 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 181024 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181029 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 181031 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI642SSZrm),
     /* 181034 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181036 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 181039 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 181043 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181048 */   GIR_RootConstrainSelectedInstOperands,
     /* 181049 */   // GIR_Coverage, 21146,
     /* 181049 */   GIR_EraseRootFromParent_Done,
     /* 181050 */ // Label 3981: @181050
     /* 181050 */ GIM_Try, /*On fail goto*//*Label 3982*/ GIMT_Encode4(181126), // Rule ID 21144 //
     /* 181055 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 181058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 181061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 181065 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 181069 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181073 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181076 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181080 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 181084 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181086 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181093 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (VCVTUSI2SSZrm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 181093 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 181096 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 181100 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181105 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 181107 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI2SSZrm),
     /* 181110 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181112 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 181115 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 181119 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181124 */   GIR_RootConstrainSelectedInstOperands,
     /* 181125 */   // GIR_Coverage, 21144,
     /* 181125 */   GIR_EraseRootFromParent_Done,
     /* 181126 */ // Label 3982: @181126
     /* 181126 */ GIM_Try, /*On fail goto*//*Label 3983*/ GIMT_Encode4(181171), // Rule ID 21152 //
     /* 181131 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 181134 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 181137 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 181141 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 181145 */   // (uint_to_fp:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (VCVTUSI2SSZrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), GR32:{ *:[i32] }:$src)
     /* 181145 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 181148 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 181152 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181157 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 181159 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI2SSZrr),
     /* 181162 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181164 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 181167 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 181169 */   GIR_RootConstrainSelectedInstOperands,
     /* 181170 */   // GIR_Coverage, 21152,
     /* 181170 */   GIR_EraseRootFromParent_Done,
     /* 181171 */ // Label 3983: @181171
     /* 181171 */ GIM_Try, /*On fail goto*//*Label 3984*/ GIMT_Encode4(181216), // Rule ID 21154 //
     /* 181176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 181179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 181182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 181186 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 181190 */   // (uint_to_fp:{ *:[f32] } GR64:{ *:[i64] }:$src)  =>  (VCVTUSI642SSZrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), GR64:{ *:[i64] }:$src)
     /* 181190 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 181193 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 181197 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181202 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 181204 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI642SSZrr),
     /* 181207 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181209 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 181212 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 181214 */   GIR_RootConstrainSelectedInstOperands,
     /* 181215 */   // GIR_Coverage, 21154,
     /* 181215 */   GIR_EraseRootFromParent_Done,
     /* 181216 */ // Label 3984: @181216
     /* 181216 */ GIM_Reject,
     /* 181217 */ // Label 3966: @181217
     /* 181217 */ GIM_Try, /*On fail goto*//*Label 3985*/ GIMT_Encode4(181293), // Rule ID 21150 //
     /* 181222 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 181225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 181228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 181232 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 181236 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181240 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181243 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181247 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181251 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181253 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181260 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUSI642SDZrm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 181260 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 181263 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 181267 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181272 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 181274 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI642SDZrm),
     /* 181277 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181279 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 181282 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 181286 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181291 */   GIR_RootConstrainSelectedInstOperands,
     /* 181292 */   // GIR_Coverage, 21150,
     /* 181292 */   GIR_EraseRootFromParent_Done,
     /* 181293 */ // Label 3985: @181293
     /* 181293 */ GIM_Try, /*On fail goto*//*Label 3986*/ GIMT_Encode4(181369), // Rule ID 21148 //
     /* 181298 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 181301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 181304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 181308 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 181312 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181316 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181319 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181323 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 181327 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181329 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181336 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (VCVTUSI2SDZrm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 181336 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 181339 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 181343 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181348 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 181350 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI2SDZrm),
     /* 181353 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181355 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 181358 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 181362 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181367 */   GIR_RootConstrainSelectedInstOperands,
     /* 181368 */   // GIR_Coverage, 21148,
     /* 181368 */   GIR_EraseRootFromParent_Done,
     /* 181369 */ // Label 3986: @181369
     /* 181369 */ GIM_Try, /*On fail goto*//*Label 3987*/ GIMT_Encode4(181414), // Rule ID 21156 //
     /* 181374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 181377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 181380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 181384 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 181388 */   // (uint_to_fp:{ *:[f64] } GR32:{ *:[i32] }:$src)  =>  (VCVTUSI2SDZrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), GR32:{ *:[i32] }:$src)
     /* 181388 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 181391 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 181395 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181400 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 181402 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI2SDZrr),
     /* 181405 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181407 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 181410 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 181412 */   GIR_RootConstrainSelectedInstOperands,
     /* 181413 */   // GIR_Coverage, 21156,
     /* 181413 */   GIR_EraseRootFromParent_Done,
     /* 181414 */ // Label 3987: @181414
     /* 181414 */ GIM_Try, /*On fail goto*//*Label 3988*/ GIMT_Encode4(181459), // Rule ID 21158 //
     /* 181419 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 181422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 181425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 181429 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 181433 */   // (uint_to_fp:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (VCVTUSI642SDZrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), GR64:{ *:[i64] }:$src)
     /* 181433 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 181436 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 181440 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181445 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 181447 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI642SDZrr),
     /* 181450 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181452 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 181455 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 181457 */   GIR_RootConstrainSelectedInstOperands,
     /* 181458 */   // GIR_Coverage, 21158,
     /* 181458 */   GIR_EraseRootFromParent_Done,
     /* 181459 */ // Label 3988: @181459
     /* 181459 */ GIM_Reject,
     /* 181460 */ // Label 3967: @181460
     /* 181460 */ GIM_Try, /*On fail goto*//*Label 3989*/ GIMT_Encode4(181548),
     /* 181465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 181468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181472 */   GIM_Try, /*On fail goto*//*Label 3990*/ GIMT_Encode4(181524), // Rule ID 11418 //
     /* 181477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 181480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 181484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181488 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181491 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181495 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181501 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181508 */     // (uint_to_fp:{ *:[v2f64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUQQ2PDZ128rm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /* 181508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PDZ128rm),
     /* 181511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181513 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 181517 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181522 */     GIR_RootConstrainSelectedInstOperands,
     /* 181523 */     // GIR_Coverage, 11418,
     /* 181523 */     GIR_EraseRootFromParent_Done,
     /* 181524 */   // Label 3990: @181524
     /* 181524 */   GIM_Try, /*On fail goto*//*Label 3991*/ GIMT_Encode4(181547), // Rule ID 11414 //
     /* 181529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 181532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181536 */     // (uint_to_fp:{ *:[v2f64] } VR128X:{ *:[v2i64] }:$src)  =>  (VCVTUQQ2PDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2i64] }:$src)
     /* 181536 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PDZ128rr),
     /* 181541 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 181545 */     GIR_RootConstrainSelectedInstOperands,
     /* 181546 */     // GIR_Coverage, 11414,
     /* 181546 */     GIR_Done,
     /* 181547 */   // Label 3991: @181547
     /* 181547 */   GIM_Reject,
     /* 181548 */ // Label 3989: @181548
     /* 181548 */ GIM_Reject,
     /* 181549 */ // Label 3968: @181549
     /* 181549 */ GIM_Try, /*On fail goto*//*Label 3992*/ GIMT_Encode4(181608), // Rule ID 10962 //
     /* 181554 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 181557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 181560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181564 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 181568 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181572 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181575 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181579 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181583 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181585 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181592 */   // (uint_to_fp:{ *:[v4f32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUDQ2PSZ128rm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 181592 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PSZ128rm),
     /* 181595 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181597 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 181601 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181606 */   GIR_RootConstrainSelectedInstOperands,
     /* 181607 */   // GIR_Coverage, 10962,
     /* 181607 */   GIR_EraseRootFromParent_Done,
     /* 181608 */ // Label 3992: @181608
     /* 181608 */ GIM_Try, /*On fail goto*//*Label 3993*/ GIMT_Encode4(181667), // Rule ID 11538 //
     /* 181613 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 181616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 181619 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181623 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 181627 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181631 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181634 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181638 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181642 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181644 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181651 */   // (uint_to_fp:{ *:[v4f32] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUQQ2PSZ256rm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 181651 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PSZ256rm),
     /* 181654 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181656 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 181660 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181665 */   GIR_RootConstrainSelectedInstOperands,
     /* 181666 */   // GIR_Coverage, 11538,
     /* 181666 */   GIR_EraseRootFromParent_Done,
     /* 181667 */ // Label 3993: @181667
     /* 181667 */ GIM_Try, /*On fail goto*//*Label 3994*/ GIMT_Encode4(181697), // Rule ID 10958 //
     /* 181672 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 181675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 181678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181682 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181686 */   // (uint_to_fp:{ *:[v4f32] } VR128X:{ *:[v4i32] }:$src)  =>  (VCVTUDQ2PSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4i32] }:$src)
     /* 181686 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PSZ128rr),
     /* 181691 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 181695 */   GIR_RootConstrainSelectedInstOperands,
     /* 181696 */   // GIR_Coverage, 10958,
     /* 181696 */   GIR_Done,
     /* 181697 */ // Label 3994: @181697
     /* 181697 */ GIM_Try, /*On fail goto*//*Label 3995*/ GIMT_Encode4(181727), // Rule ID 11534 //
     /* 181702 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 181705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 181708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181712 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 181716 */   // (uint_to_fp:{ *:[v4f32] } VR256X:{ *:[v4i64] }:$src)  =>  (VCVTUQQ2PSZ256rr:{ *:[v4f32] } VR256X:{ *:[v4i64] }:$src)
     /* 181716 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PSZ256rr),
     /* 181721 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 181725 */   GIR_RootConstrainSelectedInstOperands,
     /* 181726 */   // GIR_Coverage, 11534,
     /* 181726 */   GIR_Done,
     /* 181727 */ // Label 3995: @181727
     /* 181727 */ GIM_Reject,
     /* 181728 */ // Label 3969: @181728
     /* 181728 */ GIM_Try, /*On fail goto*//*Label 3996*/ GIMT_Encode4(181787), // Rule ID 10935 //
     /* 181733 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 181736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 181739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 181743 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 181747 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181751 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181754 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181758 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181762 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181764 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181771 */   // (uint_to_fp:{ *:[v4f64] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUDQ2PDZ256rm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /* 181771 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PDZ256rm),
     /* 181774 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181776 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 181780 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181785 */   GIR_RootConstrainSelectedInstOperands,
     /* 181786 */   // GIR_Coverage, 10935,
     /* 181786 */   GIR_EraseRootFromParent_Done,
     /* 181787 */ // Label 3996: @181787
     /* 181787 */ GIM_Try, /*On fail goto*//*Label 3997*/ GIMT_Encode4(181846), // Rule ID 11430 //
     /* 181792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 181795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 181798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 181802 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 181806 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181810 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181813 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181817 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181821 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181823 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181830 */   // (uint_to_fp:{ *:[v4f64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUQQ2PDZ256rm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /* 181830 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PDZ256rm),
     /* 181833 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181835 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 181839 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181844 */   GIR_RootConstrainSelectedInstOperands,
     /* 181845 */   // GIR_Coverage, 11430,
     /* 181845 */   GIR_EraseRootFromParent_Done,
     /* 181846 */ // Label 3997: @181846
     /* 181846 */ GIM_Try, /*On fail goto*//*Label 3998*/ GIMT_Encode4(181872), // Rule ID 10931 //
     /* 181851 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 181854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 181857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 181861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181865 */   // (uint_to_fp:{ *:[v4f64] } VR128X:{ *:[v4i32] }:$src)  =>  (VCVTUDQ2PDZ256rr:{ *:[v4f64] } VR128X:{ *:[v4i32] }:$src)
     /* 181865 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PDZ256rr),
     /* 181870 */   GIR_RootConstrainSelectedInstOperands,
     /* 181871 */   // GIR_Coverage, 10931,
     /* 181871 */   GIR_Done,
     /* 181872 */ // Label 3998: @181872
     /* 181872 */ GIM_Try, /*On fail goto*//*Label 3999*/ GIMT_Encode4(181902), // Rule ID 11426 //
     /* 181877 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 181880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 181883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 181887 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 181891 */   // (uint_to_fp:{ *:[v4f64] } VR256X:{ *:[v4i64] }:$src)  =>  (VCVTUQQ2PDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4i64] }:$src)
     /* 181891 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PDZ256rr),
     /* 181896 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 181900 */   GIR_RootConstrainSelectedInstOperands,
     /* 181901 */   // GIR_Coverage, 11426,
     /* 181901 */   GIR_Done,
     /* 181902 */ // Label 3999: @181902
     /* 181902 */ GIM_Reject,
     /* 181903 */ // Label 3970: @181903
     /* 181903 */ GIM_Try, /*On fail goto*//*Label 4000*/ GIMT_Encode4(181962), // Rule ID 11484 //
     /* 181908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 181911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 181914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181918 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 181922 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181926 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181929 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181933 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181937 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181939 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181946 */   // (uint_to_fp:{ *:[v8f16] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUDQ2PHZ256rm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /* 181946 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PHZ256rm),
     /* 181949 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181951 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 181955 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181960 */   GIR_RootConstrainSelectedInstOperands,
     /* 181961 */   // GIR_Coverage, 11484,
     /* 181961 */   GIR_EraseRootFromParent_Done,
     /* 181962 */ // Label 4000: @181962
     /* 181962 */ GIM_Try, /*On fail goto*//*Label 4001*/ GIMT_Encode4(182021), // Rule ID 14676 //
     /* 181967 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 181970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 181973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181977 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 181981 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181985 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181988 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181992 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181996 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181998 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182005 */   // (uint_to_fp:{ *:[v8f16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUW2PHZ128rm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /* 182005 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUW2PHZ128rm),
     /* 182008 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182010 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 182014 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182019 */   GIR_RootConstrainSelectedInstOperands,
     /* 182020 */   // GIR_Coverage, 14676,
     /* 182020 */   GIR_EraseRootFromParent_Done,
     /* 182021 */ // Label 4001: @182021
     /* 182021 */ GIM_Try, /*On fail goto*//*Label 4002*/ GIMT_Encode4(182080), // Rule ID 15138 //
     /* 182026 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 182029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 182032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 182036 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 182040 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182044 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182047 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182051 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182055 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182057 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182064 */   // (uint_to_fp:{ *:[v8f16] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUQQ2PHZrm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /* 182064 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PHZrm),
     /* 182067 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182069 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 182073 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182078 */   GIR_RootConstrainSelectedInstOperands,
     /* 182079 */   // GIR_Coverage, 15138,
     /* 182079 */   GIR_EraseRootFromParent_Done,
     /* 182080 */ // Label 4002: @182080
     /* 182080 */ GIM_Try, /*On fail goto*//*Label 4003*/ GIMT_Encode4(182110), // Rule ID 11480 //
     /* 182085 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 182088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 182091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 182095 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182099 */   // (uint_to_fp:{ *:[v8f16] } VR256X:{ *:[v8i32] }:$src)  =>  (VCVTUDQ2PHZ256rr:{ *:[v8f16] } VR256X:{ *:[v8i32] }:$src)
     /* 182099 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PHZ256rr),
     /* 182104 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 182108 */   GIR_RootConstrainSelectedInstOperands,
     /* 182109 */   // GIR_Coverage, 11480,
     /* 182109 */   GIR_Done,
     /* 182110 */ // Label 4003: @182110
     /* 182110 */ GIM_Try, /*On fail goto*//*Label 4004*/ GIMT_Encode4(182140), // Rule ID 14672 //
     /* 182115 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 182118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 182121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 182125 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 182129 */   // (uint_to_fp:{ *:[v8f16] } VR128X:{ *:[v8i16] }:$src)  =>  (VCVTUW2PHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8i16] }:$src)
     /* 182129 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUW2PHZ128rr),
     /* 182134 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 182138 */   GIR_RootConstrainSelectedInstOperands,
     /* 182139 */   // GIR_Coverage, 14672,
     /* 182139 */   GIR_Done,
     /* 182140 */ // Label 4004: @182140
     /* 182140 */ GIM_Try, /*On fail goto*//*Label 4005*/ GIMT_Encode4(182170), // Rule ID 15134 //
     /* 182145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 182148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 182151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 182155 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182159 */   // (uint_to_fp:{ *:[v8f16] } VR512:{ *:[v8i64] }:$src)  =>  (VCVTUQQ2PHZrr:{ *:[v8f16] } VR512:{ *:[v8i64] }:$src)
     /* 182159 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PHZrr),
     /* 182164 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 182168 */   GIR_RootConstrainSelectedInstOperands,
     /* 182169 */   // GIR_Coverage, 15134,
     /* 182169 */   GIR_Done,
     /* 182170 */ // Label 4005: @182170
     /* 182170 */ GIM_Reject,
     /* 182171 */ // Label 3971: @182171
     /* 182171 */ GIM_Try, /*On fail goto*//*Label 4006*/ GIMT_Encode4(182230), // Rule ID 10974 //
     /* 182176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 182179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 182182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182186 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 182190 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182194 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182197 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182201 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182205 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182207 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182214 */   // (uint_to_fp:{ *:[v8f32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUDQ2PSZ256rm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 182214 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PSZ256rm),
     /* 182217 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182219 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 182223 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182228 */   GIR_RootConstrainSelectedInstOperands,
     /* 182229 */   // GIR_Coverage, 10974,
     /* 182229 */   GIR_EraseRootFromParent_Done,
     /* 182230 */ // Label 4006: @182230
     /* 182230 */ GIM_Try, /*On fail goto*//*Label 4007*/ GIMT_Encode4(182289), // Rule ID 11523 //
     /* 182235 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 182238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 182241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182245 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 182249 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182253 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182256 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182260 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182264 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182266 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182273 */   // (uint_to_fp:{ *:[v8f32] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUQQ2PSZrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 182273 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PSZrm),
     /* 182276 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182278 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 182282 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182287 */   GIR_RootConstrainSelectedInstOperands,
     /* 182288 */   // GIR_Coverage, 11523,
     /* 182288 */   GIR_EraseRootFromParent_Done,
     /* 182289 */ // Label 4007: @182289
     /* 182289 */ GIM_Try, /*On fail goto*//*Label 4008*/ GIMT_Encode4(182319), // Rule ID 10970 //
     /* 182294 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 182297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 182300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182304 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182308 */   // (uint_to_fp:{ *:[v8f32] } VR256X:{ *:[v8i32] }:$src)  =>  (VCVTUDQ2PSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8i32] }:$src)
     /* 182308 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PSZ256rr),
     /* 182313 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 182317 */   GIR_RootConstrainSelectedInstOperands,
     /* 182318 */   // GIR_Coverage, 10970,
     /* 182318 */   GIR_Done,
     /* 182319 */ // Label 4008: @182319
     /* 182319 */ GIM_Try, /*On fail goto*//*Label 4009*/ GIMT_Encode4(182349), // Rule ID 11519 //
     /* 182324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 182327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 182330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182334 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182338 */   // (uint_to_fp:{ *:[v8f32] } VR512:{ *:[v8i64] }:$src)  =>  (VCVTUQQ2PSZrr:{ *:[v8f32] } VR512:{ *:[v8i64] }:$src)
     /* 182338 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PSZrr),
     /* 182343 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 182347 */   GIR_RootConstrainSelectedInstOperands,
     /* 182348 */   // GIR_Coverage, 11519,
     /* 182348 */   GIR_Done,
     /* 182349 */ // Label 4009: @182349
     /* 182349 */ GIM_Reject,
     /* 182350 */ // Label 3972: @182350
     /* 182350 */ GIM_Try, /*On fail goto*//*Label 4010*/ GIMT_Encode4(182409), // Rule ID 10911 //
     /* 182355 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 182358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 182361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182365 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 182369 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182373 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182376 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182380 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182384 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182386 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182393 */   // (uint_to_fp:{ *:[v8f64] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUDQ2PDZrm:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)
     /* 182393 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PDZrm),
     /* 182396 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182398 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 182402 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182407 */   GIR_RootConstrainSelectedInstOperands,
     /* 182408 */   // GIR_Coverage, 10911,
     /* 182408 */   GIR_EraseRootFromParent_Done,
     /* 182409 */ // Label 4010: @182409
     /* 182409 */ GIM_Try, /*On fail goto*//*Label 4011*/ GIMT_Encode4(182468), // Rule ID 11403 //
     /* 182414 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 182417 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 182420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182424 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 182428 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182432 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182435 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182439 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182443 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182445 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182452 */   // (uint_to_fp:{ *:[v8f64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUQQ2PDZrm:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)
     /* 182452 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PDZrm),
     /* 182455 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182457 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 182461 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182466 */   GIR_RootConstrainSelectedInstOperands,
     /* 182467 */   // GIR_Coverage, 11403,
     /* 182467 */   GIR_EraseRootFromParent_Done,
     /* 182468 */ // Label 4011: @182468
     /* 182468 */ GIM_Try, /*On fail goto*//*Label 4012*/ GIMT_Encode4(182494), // Rule ID 10907 //
     /* 182473 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 182476 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 182479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182483 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182487 */   // (uint_to_fp:{ *:[v8f64] } VR256X:{ *:[v8i32] }:$src)  =>  (VCVTUDQ2PDZrr:{ *:[v8f64] } VR256X:{ *:[v8i32] }:$src)
     /* 182487 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PDZrr),
     /* 182492 */   GIR_RootConstrainSelectedInstOperands,
     /* 182493 */   // GIR_Coverage, 10907,
     /* 182493 */   GIR_Done,
     /* 182494 */ // Label 4012: @182494
     /* 182494 */ GIM_Try, /*On fail goto*//*Label 4013*/ GIMT_Encode4(182524), // Rule ID 11399 //
     /* 182499 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 182502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 182505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182509 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182513 */   // (uint_to_fp:{ *:[v8f64] } VR512:{ *:[v8i64] }:$src)  =>  (VCVTUQQ2PDZrr:{ *:[v8f64] } VR512:{ *:[v8i64] }:$src)
     /* 182513 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PDZrr),
     /* 182518 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 182522 */   GIR_RootConstrainSelectedInstOperands,
     /* 182523 */   // GIR_Coverage, 11399,
     /* 182523 */   GIR_Done,
     /* 182524 */ // Label 4013: @182524
     /* 182524 */ GIM_Reject,
     /* 182525 */ // Label 3973: @182525
     /* 182525 */ GIM_Try, /*On fail goto*//*Label 4014*/ GIMT_Encode4(182584), // Rule ID 11469 //
     /* 182530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 182533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 182536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182540 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 182544 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182548 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182551 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182555 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182559 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182561 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182568 */   // (uint_to_fp:{ *:[v16f16] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUDQ2PHZrm:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /* 182568 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PHZrm),
     /* 182571 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182573 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 182577 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182582 */   GIR_RootConstrainSelectedInstOperands,
     /* 182583 */   // GIR_Coverage, 11469,
     /* 182583 */   GIR_EraseRootFromParent_Done,
     /* 182584 */ // Label 4014: @182584
     /* 182584 */ GIM_Try, /*On fail goto*//*Label 4015*/ GIMT_Encode4(182643), // Rule ID 14688 //
     /* 182589 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 182592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 182595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182599 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 182603 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182607 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182610 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182614 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182618 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182620 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182627 */   // (uint_to_fp:{ *:[v16f16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUW2PHZ256rm:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /* 182627 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUW2PHZ256rm),
     /* 182630 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182632 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 182636 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182641 */   GIR_RootConstrainSelectedInstOperands,
     /* 182642 */   // GIR_Coverage, 14688,
     /* 182642 */   GIR_EraseRootFromParent_Done,
     /* 182643 */ // Label 4015: @182643
     /* 182643 */ GIM_Try, /*On fail goto*//*Label 4016*/ GIMT_Encode4(182673), // Rule ID 11465 //
     /* 182648 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 182651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 182654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182658 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182662 */   // (uint_to_fp:{ *:[v16f16] } VR512:{ *:[v16i32] }:$src)  =>  (VCVTUDQ2PHZrr:{ *:[v16f16] } VR512:{ *:[v16i32] }:$src)
     /* 182662 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PHZrr),
     /* 182667 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 182671 */   GIR_RootConstrainSelectedInstOperands,
     /* 182672 */   // GIR_Coverage, 11465,
     /* 182672 */   GIR_Done,
     /* 182673 */ // Label 4016: @182673
     /* 182673 */ GIM_Try, /*On fail goto*//*Label 4017*/ GIMT_Encode4(182703), // Rule ID 14684 //
     /* 182678 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 182681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 182684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182688 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182692 */   // (uint_to_fp:{ *:[v16f16] } VR256X:{ *:[v16i16] }:$src)  =>  (VCVTUW2PHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16i16] }:$src)
     /* 182692 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUW2PHZ256rr),
     /* 182697 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 182701 */   GIR_RootConstrainSelectedInstOperands,
     /* 182702 */   // GIR_Coverage, 14684,
     /* 182702 */   GIR_Done,
     /* 182703 */ // Label 4017: @182703
     /* 182703 */ GIM_Reject,
     /* 182704 */ // Label 3974: @182704
     /* 182704 */ GIM_Try, /*On fail goto*//*Label 4018*/ GIMT_Encode4(182792),
     /* 182709 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 182712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182716 */   GIM_Try, /*On fail goto*//*Label 4019*/ GIMT_Encode4(182768), // Rule ID 10947 //
     /* 182721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 182724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 182728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182732 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182735 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182739 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182745 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182752 */     // (uint_to_fp:{ *:[v16f32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUDQ2PSZrm:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)
     /* 182752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PSZrm),
     /* 182755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182757 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 182761 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182766 */     GIR_RootConstrainSelectedInstOperands,
     /* 182767 */     // GIR_Coverage, 10947,
     /* 182767 */     GIR_EraseRootFromParent_Done,
     /* 182768 */   // Label 4019: @182768
     /* 182768 */   GIM_Try, /*On fail goto*//*Label 4020*/ GIMT_Encode4(182791), // Rule ID 10943 //
     /* 182773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 182776 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182780 */     // (uint_to_fp:{ *:[v16f32] } VR512:{ *:[v16i32] }:$src)  =>  (VCVTUDQ2PSZrr:{ *:[v16f32] } VR512:{ *:[v16i32] }:$src)
     /* 182780 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PSZrr),
     /* 182785 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 182789 */     GIR_RootConstrainSelectedInstOperands,
     /* 182790 */     // GIR_Coverage, 10943,
     /* 182790 */     GIR_Done,
     /* 182791 */   // Label 4020: @182791
     /* 182791 */   GIM_Reject,
     /* 182792 */ // Label 4018: @182792
     /* 182792 */ GIM_Reject,
     /* 182793 */ // Label 3975: @182793
     /* 182793 */ GIM_Try, /*On fail goto*//*Label 4021*/ GIMT_Encode4(182881),
     /* 182798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 182801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182805 */   GIM_Try, /*On fail goto*//*Label 4022*/ GIMT_Encode4(182857), // Rule ID 14661 //
     /* 182810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 182813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 182817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182821 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182824 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182828 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182832 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182834 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182841 */     // (uint_to_fp:{ *:[v32f16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUW2PHZrm:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)
     /* 182841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUW2PHZrm),
     /* 182844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182846 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 182850 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182855 */     GIR_RootConstrainSelectedInstOperands,
     /* 182856 */     // GIR_Coverage, 14661,
     /* 182856 */     GIR_EraseRootFromParent_Done,
     /* 182857 */   // Label 4022: @182857
     /* 182857 */   GIM_Try, /*On fail goto*//*Label 4023*/ GIMT_Encode4(182880), // Rule ID 14657 //
     /* 182862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 182865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182869 */     // (uint_to_fp:{ *:[v32f16] } VR512:{ *:[v32i16] }:$src)  =>  (VCVTUW2PHZrr:{ *:[v32f16] } VR512:{ *:[v32i16] }:$src)
     /* 182869 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUW2PHZrr),
     /* 182874 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 182878 */     GIR_RootConstrainSelectedInstOperands,
     /* 182879 */     // GIR_Coverage, 14657,
     /* 182879 */     GIR_Done,
     /* 182880 */   // Label 4023: @182880
     /* 182880 */   GIM_Reject,
     /* 182881 */ // Label 4021: @182881
     /* 182881 */ GIM_Reject,
     /* 182882 */ // Label 3976: @182882
     /* 182882 */ GIM_Reject,
     /* 182883 */ // Label 53: @182883
     /* 182883 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(6), /*)*//*default:*//*Label 4027*/ GIMT_Encode4(183005),
     /* 182894 */ /*GILLT_s32*//*Label 4024*/ GIMT_Encode4(182906),
     /* 182898 */ /*GILLT_s64*//*Label 4025*/ GIMT_Encode4(182939),
     /* 182902 */ /*GILLT_s80*//*Label 4026*/ GIMT_Encode4(182972),
     /* 182906 */ // Label 4024: @182906
     /* 182906 */ GIM_Try, /*On fail goto*//*Label 4028*/ GIMT_Encode4(182938), // Rule ID 1045 //
     /* 182911 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 182914 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 182917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 182921 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 182925 */   // (fabs:{ *:[f32] } RFP32:{ *:[f32] }:$src)  =>  (ABS_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src)
     /* 182925 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ABS_Fp32),
     /* 182930 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 182936 */   GIR_RootConstrainSelectedInstOperands,
     /* 182937 */   // GIR_Coverage, 1045,
     /* 182937 */   GIR_Done,
     /* 182938 */ // Label 4028: @182938
     /* 182938 */ GIM_Reject,
     /* 182939 */ // Label 4025: @182939
     /* 182939 */ GIM_Try, /*On fail goto*//*Label 4029*/ GIMT_Encode4(182971), // Rule ID 1046 //
     /* 182944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 182947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 182950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 182954 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 182958 */   // (fabs:{ *:[f64] } RFP64:{ *:[f64] }:$src)  =>  (ABS_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src)
     /* 182958 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ABS_Fp64),
     /* 182963 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 182969 */   GIR_RootConstrainSelectedInstOperands,
     /* 182970 */   // GIR_Coverage, 1046,
     /* 182970 */   GIR_Done,
     /* 182971 */ // Label 4029: @182971
     /* 182971 */ GIM_Reject,
     /* 182972 */ // Label 4026: @182972
     /* 182972 */ GIM_Try, /*On fail goto*//*Label 4030*/ GIMT_Encode4(183004), // Rule ID 1047 //
     /* 182977 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 182980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 182983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 182987 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 182991 */   // (fabs:{ *:[f80] } RFP80:{ *:[f80] }:$src)  =>  (ABS_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src)
     /* 182991 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ABS_Fp80),
     /* 182996 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 183002 */   GIR_RootConstrainSelectedInstOperands,
     /* 183003 */   // GIR_Coverage, 1047,
     /* 183003 */   GIR_Done,
     /* 183004 */ // Label 4030: @183004
     /* 183004 */ GIM_Reject,
     /* 183005 */ // Label 4027: @183005
     /* 183005 */ GIM_Reject,
     /* 183006 */ // Label 54: @183006
     /* 183006 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 4043*/ GIMT_Encode4(186326),
     /* 183017 */ /*GILLT_v2s64*//*Label 4031*/ GIMT_Encode4(183085), GIMT_Encode4(0),
     /* 183025 */ /*GILLT_v4s32*//*Label 4032*/ GIMT_Encode4(183414),
     /* 183029 */ /*GILLT_v4s64*//*Label 4033*/ GIMT_Encode4(183756), GIMT_Encode4(0),
     /* 183037 */ /*GILLT_v8s16*//*Label 4034*/ GIMT_Encode4(184073),
     /* 183041 */ /*GILLT_v8s32*//*Label 4035*/ GIMT_Encode4(184415),
     /* 183045 */ /*GILLT_v8s64*//*Label 4036*/ GIMT_Encode4(184730), GIMT_Encode4(0),
     /* 183053 */ /*GILLT_v16s8*//*Label 4037*/ GIMT_Encode4(184886),
     /* 183057 */ /*GILLT_v16s16*//*Label 4038*/ GIMT_Encode4(185228),
     /* 183061 */ /*GILLT_v16s32*//*Label 4039*/ GIMT_Encode4(185543), GIMT_Encode4(0),
     /* 183069 */ /*GILLT_v32s8*//*Label 4040*/ GIMT_Encode4(185699),
     /* 183073 */ /*GILLT_v32s16*//*Label 4041*/ GIMT_Encode4(186014), GIMT_Encode4(0),
     /* 183081 */ /*GILLT_v64s8*//*Label 4042*/ GIMT_Encode4(186170),
     /* 183085 */ // Label 4031: @183085
     /* 183085 */ GIM_Try, /*On fail goto*//*Label 4044*/ GIMT_Encode4(183413),
     /* 183090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 183093 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 183096 */   GIM_Try, /*On fail goto*//*Label 4045*/ GIMT_Encode4(183158), // Rule ID 24077 //
     /* 183101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 183104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 183112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 183116 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 183119 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 183123 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 183127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183133 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 183140 */     // (smin:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2i64] }:$src1)  =>  (VPMINSQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 183140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSQZ128rm),
     /* 183143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183145 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 183147 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 183151 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 183156 */     GIR_RootConstrainSelectedInstOperands,
     /* 183157 */     // GIR_Coverage, 24077,
     /* 183157 */     GIR_EraseRootFromParent_Done,
     /* 183158 */   // Label 4045: @183158
     /* 183158 */   GIM_Try, /*On fail goto*//*Label 4046*/ GIMT_Encode4(183220), // Rule ID 5590 //
     /* 183163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 183166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 183178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 183182 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 183185 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 183189 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 183193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183195 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 183202 */     // (smin:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 183202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSQZ128rm),
     /* 183205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183207 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 183209 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 183213 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 183218 */     GIR_RootConstrainSelectedInstOperands,
     /* 183219 */     // GIR_Coverage, 5590,
     /* 183219 */     GIR_EraseRootFromParent_Done,
     /* 183220 */   // Label 4046: @183220
     /* 183220 */   GIM_Try, /*On fail goto*//*Label 4047*/ GIMT_Encode4(183247), // Rule ID 5587 //
     /* 183225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 183228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183240 */     // (smin:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPMINSQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 183240 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSQZ128rr),
     /* 183245 */     GIR_RootConstrainSelectedInstOperands,
     /* 183246 */     // GIR_Coverage, 5587,
     /* 183246 */     GIR_Done,
     /* 183247 */   // Label 4047: @183247
     /* 183247 */   GIM_Try, /*On fail goto*//*Label 4048*/ GIMT_Encode4(183412), // Rule ID 20014 //
     /* 183252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 183255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 183259 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183267 */     // (smin:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPMINSQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 183267 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 183270 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183274 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 183281 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 183284 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 183288 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183293 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 183296 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 183300 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 183303 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 183308 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 183313 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 183318 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 183321 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183325 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183330 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 183332 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 183335 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 183339 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183344 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 183347 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 183351 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 183354 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 183359 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 183364 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 183369 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 183372 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMINSQZrr),
     /* 183376 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183381 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 183384 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 183387 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 183389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 183392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183394 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 183401 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 183406 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 183411 */     // GIR_Coverage, 20014,
     /* 183411 */     GIR_EraseRootFromParent_Done,
     /* 183412 */   // Label 4048: @183412
     /* 183412 */   GIM_Reject,
     /* 183413 */ // Label 4044: @183413
     /* 183413 */ GIM_Reject,
     /* 183414 */ // Label 4032: @183414
     /* 183414 */ GIM_Try, /*On fail goto*//*Label 4049*/ GIMT_Encode4(183755),
     /* 183419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 183422 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 183425 */   GIM_Try, /*On fail goto*//*Label 4050*/ GIMT_Encode4(183487), // Rule ID 23501 //
     /* 183430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 183433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 183441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 183445 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 183448 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 183452 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 183456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183462 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 183469 */     // (smin:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1)  =>  (VPMINSDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 183469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDrm),
     /* 183472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183474 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 183476 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 183480 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 183485 */     GIR_RootConstrainSelectedInstOperands,
     /* 183486 */     // GIR_Coverage, 23501,
     /* 183486 */     GIR_EraseRootFromParent_Done,
     /* 183487 */   // Label 4050: @183487
     /* 183487 */   GIM_Try, /*On fail goto*//*Label 4051*/ GIMT_Encode4(183549), // Rule ID 24059 //
     /* 183492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 183495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 183503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 183507 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 183510 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 183514 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 183518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183522 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183524 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 183531 */     // (smin:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4i32] }:$src1)  =>  (VPMINSDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 183531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDZ128rm),
     /* 183534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183536 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 183538 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 183542 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 183547 */     GIR_RootConstrainSelectedInstOperands,
     /* 183548 */     // GIR_Coverage, 24059,
     /* 183548 */     GIR_EraseRootFromParent_Done,
     /* 183549 */   // Label 4051: @183549
     /* 183549 */   GIM_Try, /*On fail goto*//*Label 4052*/ GIMT_Encode4(183611), // Rule ID 3186 //
     /* 183554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 183557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 183569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 183573 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 183576 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 183580 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 183584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183586 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 183593 */     // (smin:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 183593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDrm),
     /* 183596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183598 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 183600 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 183604 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 183609 */     GIR_RootConstrainSelectedInstOperands,
     /* 183610 */     // GIR_Coverage, 3186,
     /* 183610 */     GIR_EraseRootFromParent_Done,
     /* 183611 */   // Label 4052: @183611
     /* 183611 */   GIM_Try, /*On fail goto*//*Label 4053*/ GIMT_Encode4(183673), // Rule ID 5563 //
     /* 183616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 183619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 183631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 183635 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 183638 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 183642 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 183646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183648 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 183655 */     // (smin:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 183655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDZ128rm),
     /* 183658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183660 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 183662 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 183666 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 183671 */     GIR_RootConstrainSelectedInstOperands,
     /* 183672 */     // GIR_Coverage, 5563,
     /* 183672 */     GIR_EraseRootFromParent_Done,
     /* 183673 */   // Label 4053: @183673
     /* 183673 */   GIM_Try, /*On fail goto*//*Label 4054*/ GIMT_Encode4(183700), // Rule ID 3185 //
     /* 183678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 183681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183693 */     // (smin:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPMINSDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 183693 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSDrr),
     /* 183698 */     GIR_RootConstrainSelectedInstOperands,
     /* 183699 */     // GIR_Coverage, 3185,
     /* 183699 */     GIR_Done,
     /* 183700 */   // Label 4054: @183700
     /* 183700 */   GIM_Try, /*On fail goto*//*Label 4055*/ GIMT_Encode4(183727), // Rule ID 3223 //
     /* 183705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 183708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183720 */     // (smin:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PMINSDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 183720 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMINSDrr),
     /* 183725 */     GIR_RootConstrainSelectedInstOperands,
     /* 183726 */     // GIR_Coverage, 3223,
     /* 183726 */     GIR_Done,
     /* 183727 */   // Label 4055: @183727
     /* 183727 */   GIM_Try, /*On fail goto*//*Label 4056*/ GIMT_Encode4(183754), // Rule ID 5560 //
     /* 183732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 183735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183747 */     // (smin:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPMINSDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 183747 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSDZ128rr),
     /* 183752 */     GIR_RootConstrainSelectedInstOperands,
     /* 183753 */     // GIR_Coverage, 5560,
     /* 183753 */     GIR_Done,
     /* 183754 */   // Label 4056: @183754
     /* 183754 */   GIM_Reject,
     /* 183755 */ // Label 4049: @183755
     /* 183755 */ GIM_Reject,
     /* 183756 */ // Label 4033: @183756
     /* 183756 */ GIM_Try, /*On fail goto*//*Label 4057*/ GIMT_Encode4(184072),
     /* 183761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 183764 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 183767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 183771 */   GIM_Try, /*On fail goto*//*Label 4058*/ GIMT_Encode4(183829), // Rule ID 24071 //
     /* 183776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 183779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 183783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 183787 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 183790 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 183794 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 183798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 183802 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183804 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 183811 */     // (smin:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4i64] }:$src1)  =>  (VPMINSQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 183811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSQZ256rm),
     /* 183814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183816 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 183818 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 183822 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 183827 */     GIR_RootConstrainSelectedInstOperands,
     /* 183828 */     // GIR_Coverage, 24071,
     /* 183828 */     GIR_EraseRootFromParent_Done,
     /* 183829 */   // Label 4058: @183829
     /* 183829 */   GIM_Try, /*On fail goto*//*Label 4059*/ GIMT_Encode4(183887), // Rule ID 5581 //
     /* 183834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 183837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 183841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 183845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 183849 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 183852 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 183856 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 183860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183862 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 183869 */     // (smin:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 183869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSQZ256rm),
     /* 183872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183874 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 183876 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 183880 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 183885 */     GIR_RootConstrainSelectedInstOperands,
     /* 183886 */     // GIR_Coverage, 5581,
     /* 183886 */     GIR_EraseRootFromParent_Done,
     /* 183887 */   // Label 4059: @183887
     /* 183887 */   GIM_Try, /*On fail goto*//*Label 4060*/ GIMT_Encode4(183910), // Rule ID 5578 //
     /* 183892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 183895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 183899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 183903 */     // (smin:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPMINSQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 183903 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSQZ256rr),
     /* 183908 */     GIR_RootConstrainSelectedInstOperands,
     /* 183909 */     // GIR_Coverage, 5578,
     /* 183909 */     GIR_Done,
     /* 183910 */   // Label 4060: @183910
     /* 183910 */   GIM_Try, /*On fail goto*//*Label 4061*/ GIMT_Encode4(184071), // Rule ID 20012 //
     /* 183915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 183918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 183922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 183926 */     // (smin:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPMINSQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 183926 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 183929 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183933 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183938 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 183940 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 183943 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 183947 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183952 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 183955 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 183959 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 183962 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 183967 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 183972 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 183977 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 183980 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183984 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183989 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 183991 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 183994 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 183998 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184003 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 184006 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 184010 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 184013 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 184018 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 184023 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 184028 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 184031 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMINSQZrr),
     /* 184035 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184040 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 184043 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 184046 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 184048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 184051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184053 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 184060 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 184065 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 184070 */     // GIR_Coverage, 20012,
     /* 184070 */     GIR_EraseRootFromParent_Done,
     /* 184071 */   // Label 4061: @184071
     /* 184071 */   GIM_Reject,
     /* 184072 */ // Label 4057: @184072
     /* 184072 */ GIM_Reject,
     /* 184073 */ // Label 4034: @184073
     /* 184073 */ GIM_Try, /*On fail goto*//*Label 4062*/ GIMT_Encode4(184414),
     /* 184078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 184081 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 184084 */   GIM_Try, /*On fail goto*//*Label 4063*/ GIMT_Encode4(184146), // Rule ID 23465 //
     /* 184089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 184092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 184100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184104 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184107 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184111 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184121 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184128 */     // (smin:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPMINSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWrm),
     /* 184131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184133 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 184135 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184139 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184144 */     GIR_RootConstrainSelectedInstOperands,
     /* 184145 */     // GIR_Coverage, 23465,
     /* 184145 */     GIR_EraseRootFromParent_Done,
     /* 184146 */   // Label 4063: @184146
     /* 184146 */   GIM_Try, /*On fail goto*//*Label 4064*/ GIMT_Encode4(184208), // Rule ID 24044 //
     /* 184151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 184154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 184158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 184162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184166 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184169 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184173 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 184181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184183 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184190 */     // (smin:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPMINSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWZ128rm),
     /* 184193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184195 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 184197 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184206 */     GIR_RootConstrainSelectedInstOperands,
     /* 184207 */     // GIR_Coverage, 24044,
     /* 184207 */     GIR_EraseRootFromParent_Done,
     /* 184208 */   // Label 4064: @184208
     /* 184208 */   GIM_Try, /*On fail goto*//*Label 4065*/ GIMT_Encode4(184270), // Rule ID 2643 //
     /* 184213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 184216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184220 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 184228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184232 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184235 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184239 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184245 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184252 */     // (smin:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWrm),
     /* 184255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184257 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 184259 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184263 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184268 */     GIR_RootConstrainSelectedInstOperands,
     /* 184269 */     // GIR_Coverage, 2643,
     /* 184269 */     GIR_EraseRootFromParent_Done,
     /* 184270 */   // Label 4065: @184270
     /* 184270 */   GIM_Try, /*On fail goto*//*Label 4066*/ GIMT_Encode4(184332), // Rule ID 5539 //
     /* 184275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 184278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 184282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 184286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 184290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184294 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184297 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184301 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184307 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184314 */     // (smin:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWZ128rm),
     /* 184317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184319 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 184321 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184325 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184330 */     GIR_RootConstrainSelectedInstOperands,
     /* 184331 */     // GIR_Coverage, 5539,
     /* 184331 */     GIR_EraseRootFromParent_Done,
     /* 184332 */   // Label 4066: @184332
     /* 184332 */   GIM_Try, /*On fail goto*//*Label 4067*/ GIMT_Encode4(184359), // Rule ID 2642 //
     /* 184337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 184340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184352 */     // (smin:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMINSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 184352 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSWrr),
     /* 184357 */     GIR_RootConstrainSelectedInstOperands,
     /* 184358 */     // GIR_Coverage, 2642,
     /* 184358 */     GIR_Done,
     /* 184359 */   // Label 4067: @184359
     /* 184359 */   GIM_Try, /*On fail goto*//*Label 4068*/ GIMT_Encode4(184386), // Rule ID 2644 //
     /* 184364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 184367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184379 */     // (smin:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMINSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 184379 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMINSWrr),
     /* 184384 */     GIR_RootConstrainSelectedInstOperands,
     /* 184385 */     // GIR_Coverage, 2644,
     /* 184385 */     GIR_Done,
     /* 184386 */   // Label 4068: @184386
     /* 184386 */   GIM_Try, /*On fail goto*//*Label 4069*/ GIMT_Encode4(184413), // Rule ID 5536 //
     /* 184391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 184394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 184398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 184402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 184406 */     // (smin:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMINSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 184406 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSWZ128rr),
     /* 184411 */     GIR_RootConstrainSelectedInstOperands,
     /* 184412 */     // GIR_Coverage, 5536,
     /* 184412 */     GIR_Done,
     /* 184413 */   // Label 4069: @184413
     /* 184413 */   GIM_Reject,
     /* 184414 */ // Label 4062: @184414
     /* 184414 */ GIM_Reject,
     /* 184415 */ // Label 4035: @184415
     /* 184415 */ GIM_Try, /*On fail goto*//*Label 4070*/ GIMT_Encode4(184729),
     /* 184420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 184423 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 184426 */   GIM_Try, /*On fail goto*//*Label 4071*/ GIMT_Encode4(184488), // Rule ID 23510 //
     /* 184431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 184434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 184438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 184442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184446 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184449 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184453 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 184461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184463 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184470 */     // (smin:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VPMINSDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDYrm),
     /* 184473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184475 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 184477 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184481 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184486 */     GIR_RootConstrainSelectedInstOperands,
     /* 184487 */     // GIR_Coverage, 23510,
     /* 184487 */     GIR_EraseRootFromParent_Done,
     /* 184488 */   // Label 4071: @184488
     /* 184488 */   GIM_Try, /*On fail goto*//*Label 4072*/ GIMT_Encode4(184550), // Rule ID 24053 //
     /* 184493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 184496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 184500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 184504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184508 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184511 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184515 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 184523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184525 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184532 */     // (smin:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8i32] }:$src1)  =>  (VPMINSDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDZ256rm),
     /* 184535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184537 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 184539 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184543 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184548 */     GIR_RootConstrainSelectedInstOperands,
     /* 184549 */     // GIR_Coverage, 24053,
     /* 184549 */     GIR_EraseRootFromParent_Done,
     /* 184550 */   // Label 4072: @184550
     /* 184550 */   GIM_Try, /*On fail goto*//*Label 4073*/ GIMT_Encode4(184612), // Rule ID 3204 //
     /* 184555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 184558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 184562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 184566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 184570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184574 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184577 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184581 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184587 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184594 */     // (smin:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDYrm),
     /* 184597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184599 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 184601 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184610 */     GIR_RootConstrainSelectedInstOperands,
     /* 184611 */     // GIR_Coverage, 3204,
     /* 184611 */     GIR_EraseRootFromParent_Done,
     /* 184612 */   // Label 4073: @184612
     /* 184612 */   GIM_Try, /*On fail goto*//*Label 4074*/ GIMT_Encode4(184674), // Rule ID 5554 //
     /* 184617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 184620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 184624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 184628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 184632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184636 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184639 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184643 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184649 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184656 */     // (smin:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDZ256rm),
     /* 184659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184661 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 184663 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184667 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184672 */     GIR_RootConstrainSelectedInstOperands,
     /* 184673 */     // GIR_Coverage, 5554,
     /* 184673 */     GIR_EraseRootFromParent_Done,
     /* 184674 */   // Label 4074: @184674
     /* 184674 */   GIM_Try, /*On fail goto*//*Label 4075*/ GIMT_Encode4(184701), // Rule ID 3203 //
     /* 184679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 184682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 184686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 184690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 184694 */     // (smin:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPMINSDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 184694 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSDYrr),
     /* 184699 */     GIR_RootConstrainSelectedInstOperands,
     /* 184700 */     // GIR_Coverage, 3203,
     /* 184700 */     GIR_Done,
     /* 184701 */   // Label 4075: @184701
     /* 184701 */   GIM_Try, /*On fail goto*//*Label 4076*/ GIMT_Encode4(184728), // Rule ID 5551 //
     /* 184706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 184709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 184713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 184717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 184721 */     // (smin:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPMINSDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 184721 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSDZ256rr),
     /* 184726 */     GIR_RootConstrainSelectedInstOperands,
     /* 184727 */     // GIR_Coverage, 5551,
     /* 184727 */     GIR_Done,
     /* 184728 */   // Label 4076: @184728
     /* 184728 */   GIM_Reject,
     /* 184729 */ // Label 4070: @184729
     /* 184729 */ GIM_Reject,
     /* 184730 */ // Label 4036: @184730
     /* 184730 */ GIM_Try, /*On fail goto*//*Label 4077*/ GIMT_Encode4(184885),
     /* 184735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 184738 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 184741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 184745 */   GIM_Try, /*On fail goto*//*Label 4078*/ GIMT_Encode4(184803), // Rule ID 24065 //
     /* 184750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 184753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 184757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184761 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184764 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184768 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 184776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184778 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184785 */     // (smin:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8i64] }:$src1)  =>  (VPMINSQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSQZrm),
     /* 184788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184790 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 184792 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184796 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184801 */     GIR_RootConstrainSelectedInstOperands,
     /* 184802 */     // GIR_Coverage, 24065,
     /* 184802 */     GIR_EraseRootFromParent_Done,
     /* 184803 */   // Label 4078: @184803
     /* 184803 */   GIM_Try, /*On fail goto*//*Label 4079*/ GIMT_Encode4(184861), // Rule ID 5572 //
     /* 184808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 184811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 184815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 184819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184823 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184826 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184830 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184834 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184836 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184843 */     // (smin:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSQZrm),
     /* 184846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184848 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 184850 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184854 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184859 */     GIR_RootConstrainSelectedInstOperands,
     /* 184860 */     // GIR_Coverage, 5572,
     /* 184860 */     GIR_EraseRootFromParent_Done,
     /* 184861 */   // Label 4079: @184861
     /* 184861 */   GIM_Try, /*On fail goto*//*Label 4080*/ GIMT_Encode4(184884), // Rule ID 5569 //
     /* 184866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 184869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 184873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 184877 */     // (smin:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPMINSQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 184877 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSQZrr),
     /* 184882 */     GIR_RootConstrainSelectedInstOperands,
     /* 184883 */     // GIR_Coverage, 5569,
     /* 184883 */     GIR_Done,
     /* 184884 */   // Label 4080: @184884
     /* 184884 */   GIM_Reject,
     /* 184885 */ // Label 4077: @184885
     /* 184885 */ GIM_Reject,
     /* 184886 */ // Label 4037: @184886
     /* 184886 */ GIM_Try, /*On fail goto*//*Label 4081*/ GIMT_Encode4(185227),
     /* 184891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 184894 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 184897 */   GIM_Try, /*On fail goto*//*Label 4082*/ GIMT_Encode4(184959), // Rule ID 23506 //
     /* 184902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 184905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 184913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184917 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184920 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184924 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184932 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184934 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184941 */     // (smin:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPMINSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBrm),
     /* 184944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184946 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 184948 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184952 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184957 */     GIR_RootConstrainSelectedInstOperands,
     /* 184958 */     // GIR_Coverage, 23506,
     /* 184958 */     GIR_EraseRootFromParent_Done,
     /* 184959 */   // Label 4082: @184959
     /* 184959 */   GIM_Try, /*On fail goto*//*Label 4083*/ GIMT_Encode4(185021), // Rule ID 24035 //
     /* 184964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 184967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 184971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 184975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184979 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184982 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184986 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 184994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184996 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185003 */     // (smin:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPMINSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBZ128rm),
     /* 185006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185008 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 185010 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185014 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185019 */     GIR_RootConstrainSelectedInstOperands,
     /* 185020 */     // GIR_Coverage, 24035,
     /* 185020 */     GIR_EraseRootFromParent_Done,
     /* 185021 */   // Label 4083: @185021
     /* 185021 */   GIM_Try, /*On fail goto*//*Label 4084*/ GIMT_Encode4(185083), // Rule ID 3196 //
     /* 185026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 185029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 185033 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 185037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 185041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185045 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185048 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185052 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185058 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185065 */     // (smin:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBrm),
     /* 185068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185070 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 185072 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185076 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185081 */     GIR_RootConstrainSelectedInstOperands,
     /* 185082 */     // GIR_Coverage, 3196,
     /* 185082 */     GIR_EraseRootFromParent_Done,
     /* 185083 */   // Label 4084: @185083
     /* 185083 */   GIM_Try, /*On fail goto*//*Label 4085*/ GIMT_Encode4(185145), // Rule ID 5521 //
     /* 185088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 185091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 185095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 185099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 185103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185107 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185110 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185114 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185118 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185120 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185127 */     // (smin:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBZ128rm),
     /* 185130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185132 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 185134 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185138 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185143 */     GIR_RootConstrainSelectedInstOperands,
     /* 185144 */     // GIR_Coverage, 5521,
     /* 185144 */     GIR_EraseRootFromParent_Done,
     /* 185145 */   // Label 4085: @185145
     /* 185145 */   GIM_Try, /*On fail goto*//*Label 4086*/ GIMT_Encode4(185172), // Rule ID 3195 //
     /* 185150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 185153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 185157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 185161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 185165 */     // (smin:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPMINSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 185165 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSBrr),
     /* 185170 */     GIR_RootConstrainSelectedInstOperands,
     /* 185171 */     // GIR_Coverage, 3195,
     /* 185171 */     GIR_Done,
     /* 185172 */   // Label 4086: @185172
     /* 185172 */   GIM_Try, /*On fail goto*//*Label 4087*/ GIMT_Encode4(185199), // Rule ID 3221 //
     /* 185177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 185180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 185184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 185188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 185192 */     // (smin:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PMINSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 185192 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMINSBrr),
     /* 185197 */     GIR_RootConstrainSelectedInstOperands,
     /* 185198 */     // GIR_Coverage, 3221,
     /* 185198 */     GIR_Done,
     /* 185199 */   // Label 4087: @185199
     /* 185199 */   GIM_Try, /*On fail goto*//*Label 4088*/ GIMT_Encode4(185226), // Rule ID 5518 //
     /* 185204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 185207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 185211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 185215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 185219 */     // (smin:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPMINSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 185219 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSBZ128rr),
     /* 185224 */     GIR_RootConstrainSelectedInstOperands,
     /* 185225 */     // GIR_Coverage, 5518,
     /* 185225 */     GIR_Done,
     /* 185226 */   // Label 4088: @185226
     /* 185226 */   GIM_Reject,
     /* 185227 */ // Label 4081: @185227
     /* 185227 */ GIM_Reject,
     /* 185228 */ // Label 4038: @185228
     /* 185228 */ GIM_Try, /*On fail goto*//*Label 4089*/ GIMT_Encode4(185542),
     /* 185233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 185236 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 185239 */   GIM_Try, /*On fail goto*//*Label 4090*/ GIMT_Encode4(185301), // Rule ID 23467 //
     /* 185244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 185247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 185255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185259 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185262 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185266 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185274 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185276 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185283 */     // (smin:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPMINSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWYrm),
     /* 185286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185288 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 185290 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185294 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185299 */     GIR_RootConstrainSelectedInstOperands,
     /* 185300 */     // GIR_Coverage, 23467,
     /* 185300 */     GIR_EraseRootFromParent_Done,
     /* 185301 */   // Label 4090: @185301
     /* 185301 */   GIM_Try, /*On fail goto*//*Label 4091*/ GIMT_Encode4(185363), // Rule ID 24041 //
     /* 185306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 185309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 185317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185321 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185324 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185328 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185338 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185345 */     // (smin:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPMINSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWZ256rm),
     /* 185348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185350 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 185352 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185361 */     GIR_RootConstrainSelectedInstOperands,
     /* 185362 */     // GIR_Coverage, 24041,
     /* 185362 */     GIR_EraseRootFromParent_Done,
     /* 185363 */   // Label 4091: @185363
     /* 185363 */   GIM_Try, /*On fail goto*//*Label 4092*/ GIMT_Encode4(185425), // Rule ID 2647 //
     /* 185368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 185371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 185383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185387 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185390 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185394 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185400 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185407 */     // (smin:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWYrm),
     /* 185410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185412 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 185414 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185418 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185423 */     GIR_RootConstrainSelectedInstOperands,
     /* 185424 */     // GIR_Coverage, 2647,
     /* 185424 */     GIR_EraseRootFromParent_Done,
     /* 185425 */   // Label 4092: @185425
     /* 185425 */   GIM_Try, /*On fail goto*//*Label 4093*/ GIMT_Encode4(185487), // Rule ID 5533 //
     /* 185430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 185433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 185445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185449 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185452 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185456 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185462 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185469 */     // (smin:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWZ256rm),
     /* 185472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185474 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 185476 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185480 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185485 */     GIR_RootConstrainSelectedInstOperands,
     /* 185486 */     // GIR_Coverage, 5533,
     /* 185486 */     GIR_EraseRootFromParent_Done,
     /* 185487 */   // Label 4093: @185487
     /* 185487 */   GIM_Try, /*On fail goto*//*Label 4094*/ GIMT_Encode4(185514), // Rule ID 2646 //
     /* 185492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 185495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185507 */     // (smin:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMINSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 185507 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSWYrr),
     /* 185512 */     GIR_RootConstrainSelectedInstOperands,
     /* 185513 */     // GIR_Coverage, 2646,
     /* 185513 */     GIR_Done,
     /* 185514 */   // Label 4094: @185514
     /* 185514 */   GIM_Try, /*On fail goto*//*Label 4095*/ GIMT_Encode4(185541), // Rule ID 5530 //
     /* 185519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 185522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185534 */     // (smin:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMINSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 185534 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSWZ256rr),
     /* 185539 */     GIR_RootConstrainSelectedInstOperands,
     /* 185540 */     // GIR_Coverage, 5530,
     /* 185540 */     GIR_Done,
     /* 185541 */   // Label 4095: @185541
     /* 185541 */   GIM_Reject,
     /* 185542 */ // Label 4089: @185542
     /* 185542 */ GIM_Reject,
     /* 185543 */ // Label 4039: @185543
     /* 185543 */ GIM_Try, /*On fail goto*//*Label 4096*/ GIMT_Encode4(185698),
     /* 185548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 185551 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 185554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 185558 */   GIM_Try, /*On fail goto*//*Label 4097*/ GIMT_Encode4(185616), // Rule ID 24047 //
     /* 185563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 185566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 185570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185574 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185577 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185581 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 185589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185591 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185598 */     // (smin:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16i32] }:$src1)  =>  (VPMINSDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDZrm),
     /* 185601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185603 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 185605 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185609 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185614 */     GIR_RootConstrainSelectedInstOperands,
     /* 185615 */     // GIR_Coverage, 24047,
     /* 185615 */     GIR_EraseRootFromParent_Done,
     /* 185616 */   // Label 4097: @185616
     /* 185616 */   GIM_Try, /*On fail goto*//*Label 4098*/ GIMT_Encode4(185674), // Rule ID 5545 //
     /* 185621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 185624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 185628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 185632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185636 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185639 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185643 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185649 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185656 */     // (smin:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDZrm),
     /* 185659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185661 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 185663 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185667 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185672 */     GIR_RootConstrainSelectedInstOperands,
     /* 185673 */     // GIR_Coverage, 5545,
     /* 185673 */     GIR_EraseRootFromParent_Done,
     /* 185674 */   // Label 4098: @185674
     /* 185674 */   GIM_Try, /*On fail goto*//*Label 4099*/ GIMT_Encode4(185697), // Rule ID 5542 //
     /* 185679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 185682 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 185686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 185690 */     // (smin:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPMINSDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 185690 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSDZrr),
     /* 185695 */     GIR_RootConstrainSelectedInstOperands,
     /* 185696 */     // GIR_Coverage, 5542,
     /* 185696 */     GIR_Done,
     /* 185697 */   // Label 4099: @185697
     /* 185697 */   GIM_Reject,
     /* 185698 */ // Label 4096: @185698
     /* 185698 */ GIM_Reject,
     /* 185699 */ // Label 4040: @185699
     /* 185699 */ GIM_Try, /*On fail goto*//*Label 4100*/ GIMT_Encode4(186013),
     /* 185704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 185707 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 185710 */   GIM_Try, /*On fail goto*//*Label 4101*/ GIMT_Encode4(185772), // Rule ID 23515 //
     /* 185715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 185718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 185726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185730 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185733 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185737 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185747 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185754 */     // (smin:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPMINSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBYrm),
     /* 185757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185759 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 185761 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185765 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185770 */     GIR_RootConstrainSelectedInstOperands,
     /* 185771 */     // GIR_Coverage, 23515,
     /* 185771 */     GIR_EraseRootFromParent_Done,
     /* 185772 */   // Label 4101: @185772
     /* 185772 */   GIM_Try, /*On fail goto*//*Label 4102*/ GIMT_Encode4(185834), // Rule ID 24032 //
     /* 185777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 185780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 185788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185792 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185795 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185799 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185809 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185816 */     // (smin:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPMINSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBZ256rm),
     /* 185819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185821 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 185823 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185827 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185832 */     GIR_RootConstrainSelectedInstOperands,
     /* 185833 */     // GIR_Coverage, 24032,
     /* 185833 */     GIR_EraseRootFromParent_Done,
     /* 185834 */   // Label 4102: @185834
     /* 185834 */   GIM_Try, /*On fail goto*//*Label 4103*/ GIMT_Encode4(185896), // Rule ID 3214 //
     /* 185839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 185842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 185854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185858 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185861 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185865 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185871 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185878 */     // (smin:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBYrm),
     /* 185881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185883 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 185885 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185889 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185894 */     GIR_RootConstrainSelectedInstOperands,
     /* 185895 */     // GIR_Coverage, 3214,
     /* 185895 */     GIR_EraseRootFromParent_Done,
     /* 185896 */   // Label 4103: @185896
     /* 185896 */   GIM_Try, /*On fail goto*//*Label 4104*/ GIMT_Encode4(185958), // Rule ID 5515 //
     /* 185901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 185904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 185916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185920 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185923 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185927 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185933 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185940 */     // (smin:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBZ256rm),
     /* 185943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185945 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 185947 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185951 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185956 */     GIR_RootConstrainSelectedInstOperands,
     /* 185957 */     // GIR_Coverage, 5515,
     /* 185957 */     GIR_EraseRootFromParent_Done,
     /* 185958 */   // Label 4104: @185958
     /* 185958 */   GIM_Try, /*On fail goto*//*Label 4105*/ GIMT_Encode4(185985), // Rule ID 3213 //
     /* 185963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 185966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185978 */     // (smin:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPMINSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 185978 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSBYrr),
     /* 185983 */     GIR_RootConstrainSelectedInstOperands,
     /* 185984 */     // GIR_Coverage, 3213,
     /* 185984 */     GIR_Done,
     /* 185985 */   // Label 4105: @185985
     /* 185985 */   GIM_Try, /*On fail goto*//*Label 4106*/ GIMT_Encode4(186012), // Rule ID 5512 //
     /* 185990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 185993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 186001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 186005 */     // (smin:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPMINSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 186005 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSBZ256rr),
     /* 186010 */     GIR_RootConstrainSelectedInstOperands,
     /* 186011 */     // GIR_Coverage, 5512,
     /* 186011 */     GIR_Done,
     /* 186012 */   // Label 4106: @186012
     /* 186012 */   GIM_Reject,
     /* 186013 */ // Label 4100: @186013
     /* 186013 */ GIM_Reject,
     /* 186014 */ // Label 4041: @186014
     /* 186014 */ GIM_Try, /*On fail goto*//*Label 4107*/ GIMT_Encode4(186169),
     /* 186019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 186022 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 186025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 186029 */   GIM_Try, /*On fail goto*//*Label 4108*/ GIMT_Encode4(186087), // Rule ID 24038 //
     /* 186034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 186037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 186041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186045 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186048 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186052 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 186060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186062 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186069 */     // (smin:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPMINSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWZrm),
     /* 186072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186074 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 186076 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186080 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186085 */     GIR_RootConstrainSelectedInstOperands,
     /* 186086 */     // GIR_Coverage, 24038,
     /* 186086 */     GIR_EraseRootFromParent_Done,
     /* 186087 */   // Label 4108: @186087
     /* 186087 */   GIM_Try, /*On fail goto*//*Label 4109*/ GIMT_Encode4(186145), // Rule ID 5527 //
     /* 186092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 186095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 186099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 186103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186107 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186110 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186114 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186118 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186120 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186127 */     // (smin:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWZrm),
     /* 186130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186132 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 186134 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186138 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186143 */     GIR_RootConstrainSelectedInstOperands,
     /* 186144 */     // GIR_Coverage, 5527,
     /* 186144 */     GIR_EraseRootFromParent_Done,
     /* 186145 */   // Label 4109: @186145
     /* 186145 */   GIM_Try, /*On fail goto*//*Label 4110*/ GIMT_Encode4(186168), // Rule ID 5524 //
     /* 186150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 186153 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 186157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 186161 */     // (smin:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMINSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 186161 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSWZrr),
     /* 186166 */     GIR_RootConstrainSelectedInstOperands,
     /* 186167 */     // GIR_Coverage, 5524,
     /* 186167 */     GIR_Done,
     /* 186168 */   // Label 4110: @186168
     /* 186168 */   GIM_Reject,
     /* 186169 */ // Label 4107: @186169
     /* 186169 */ GIM_Reject,
     /* 186170 */ // Label 4042: @186170
     /* 186170 */ GIM_Try, /*On fail goto*//*Label 4111*/ GIMT_Encode4(186325),
     /* 186175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 186178 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 186181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 186185 */   GIM_Try, /*On fail goto*//*Label 4112*/ GIMT_Encode4(186243), // Rule ID 24029 //
     /* 186190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 186193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 186197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186201 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186204 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186208 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 186216 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186218 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186225 */     // (smin:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPMINSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBZrm),
     /* 186228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186230 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 186232 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186236 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186241 */     GIR_RootConstrainSelectedInstOperands,
     /* 186242 */     // GIR_Coverage, 24029,
     /* 186242 */     GIR_EraseRootFromParent_Done,
     /* 186243 */   // Label 4112: @186243
     /* 186243 */   GIM_Try, /*On fail goto*//*Label 4113*/ GIMT_Encode4(186301), // Rule ID 5509 //
     /* 186248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 186251 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 186255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 186259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186263 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186266 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186270 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186274 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186276 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186283 */     // (smin:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBZrm),
     /* 186286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186288 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 186290 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186294 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186299 */     GIR_RootConstrainSelectedInstOperands,
     /* 186300 */     // GIR_Coverage, 5509,
     /* 186300 */     GIR_EraseRootFromParent_Done,
     /* 186301 */   // Label 4113: @186301
     /* 186301 */   GIM_Try, /*On fail goto*//*Label 4114*/ GIMT_Encode4(186324), // Rule ID 5506 //
     /* 186306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 186309 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 186313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 186317 */     // (smin:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPMINSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 186317 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSBZrr),
     /* 186322 */     GIR_RootConstrainSelectedInstOperands,
     /* 186323 */     // GIR_Coverage, 5506,
     /* 186323 */     GIR_Done,
     /* 186324 */   // Label 4114: @186324
     /* 186324 */   GIM_Reject,
     /* 186325 */ // Label 4111: @186325
     /* 186325 */ GIM_Reject,
     /* 186326 */ // Label 4043: @186326
     /* 186326 */ GIM_Reject,
     /* 186327 */ // Label 55: @186327
     /* 186327 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 4127*/ GIMT_Encode4(189647),
     /* 186338 */ /*GILLT_v2s64*//*Label 4115*/ GIMT_Encode4(186406), GIMT_Encode4(0),
     /* 186346 */ /*GILLT_v4s32*//*Label 4116*/ GIMT_Encode4(186735),
     /* 186350 */ /*GILLT_v4s64*//*Label 4117*/ GIMT_Encode4(187077), GIMT_Encode4(0),
     /* 186358 */ /*GILLT_v8s16*//*Label 4118*/ GIMT_Encode4(187394),
     /* 186362 */ /*GILLT_v8s32*//*Label 4119*/ GIMT_Encode4(187736),
     /* 186366 */ /*GILLT_v8s64*//*Label 4120*/ GIMT_Encode4(188051), GIMT_Encode4(0),
     /* 186374 */ /*GILLT_v16s8*//*Label 4121*/ GIMT_Encode4(188207),
     /* 186378 */ /*GILLT_v16s16*//*Label 4122*/ GIMT_Encode4(188549),
     /* 186382 */ /*GILLT_v16s32*//*Label 4123*/ GIMT_Encode4(188864), GIMT_Encode4(0),
     /* 186390 */ /*GILLT_v32s8*//*Label 4124*/ GIMT_Encode4(189020),
     /* 186394 */ /*GILLT_v32s16*//*Label 4125*/ GIMT_Encode4(189335), GIMT_Encode4(0),
     /* 186402 */ /*GILLT_v64s8*//*Label 4126*/ GIMT_Encode4(189491),
     /* 186406 */ // Label 4115: @186406
     /* 186406 */ GIM_Try, /*On fail goto*//*Label 4128*/ GIMT_Encode4(186734),
     /* 186411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 186414 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 186417 */   GIM_Try, /*On fail goto*//*Label 4129*/ GIMT_Encode4(186479), // Rule ID 23969 //
     /* 186422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 186425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 186433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186437 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186440 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186444 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186454 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186461 */     // (smax:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2i64] }:$src1)  =>  (VPMAXSQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZ128rm),
     /* 186464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186466 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 186468 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186472 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186477 */     GIR_RootConstrainSelectedInstOperands,
     /* 186478 */     // GIR_Coverage, 23969,
     /* 186478 */     GIR_EraseRootFromParent_Done,
     /* 186479 */   // Label 4129: @186479
     /* 186479 */   GIM_Try, /*On fail goto*//*Label 4130*/ GIMT_Encode4(186541), // Rule ID 5410 //
     /* 186484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 186487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186491 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 186499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186503 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186506 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186510 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186514 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186516 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186523 */     // (smax:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZ128rm),
     /* 186526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186528 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 186530 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186534 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186539 */     GIR_RootConstrainSelectedInstOperands,
     /* 186540 */     // GIR_Coverage, 5410,
     /* 186540 */     GIR_EraseRootFromParent_Done,
     /* 186541 */   // Label 4130: @186541
     /* 186541 */   GIM_Try, /*On fail goto*//*Label 4131*/ GIMT_Encode4(186568), // Rule ID 5407 //
     /* 186546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 186549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186553 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186561 */     // (smax:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPMAXSQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 186561 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZ128rr),
     /* 186566 */     GIR_RootConstrainSelectedInstOperands,
     /* 186567 */     // GIR_Coverage, 5407,
     /* 186567 */     GIR_Done,
     /* 186568 */   // Label 4131: @186568
     /* 186568 */   GIM_Try, /*On fail goto*//*Label 4132*/ GIMT_Encode4(186733), // Rule ID 20010 //
     /* 186573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 186576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 186580 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186588 */     // (smax:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPMAXSQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 186588 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 186591 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 186595 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186600 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 186602 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 186605 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 186609 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186614 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 186617 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 186621 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 186624 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 186629 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 186634 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 186639 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 186642 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 186646 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186651 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 186653 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 186656 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 186660 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186665 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 186668 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 186672 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 186675 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 186680 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 186685 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 186690 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 186693 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZrr),
     /* 186697 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186702 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 186705 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 186708 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 186710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 186713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186715 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 186722 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 186727 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 186732 */     // GIR_Coverage, 20010,
     /* 186732 */     GIR_EraseRootFromParent_Done,
     /* 186733 */   // Label 4132: @186733
     /* 186733 */   GIM_Reject,
     /* 186734 */ // Label 4128: @186734
     /* 186734 */ GIM_Reject,
     /* 186735 */ // Label 4116: @186735
     /* 186735 */ GIM_Try, /*On fail goto*//*Label 4133*/ GIMT_Encode4(187076),
     /* 186740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 186743 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 186746 */   GIM_Try, /*On fail goto*//*Label 4134*/ GIMT_Encode4(186808), // Rule ID 23503 //
     /* 186751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 186754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 186758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 186762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186766 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186769 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186773 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 186781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186783 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186790 */     // (smax:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1)  =>  (VPMAXSDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDrm),
     /* 186793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186795 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 186797 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186801 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186806 */     GIR_RootConstrainSelectedInstOperands,
     /* 186807 */     // GIR_Coverage, 23503,
     /* 186807 */     GIR_EraseRootFromParent_Done,
     /* 186808 */   // Label 4134: @186808
     /* 186808 */   GIM_Try, /*On fail goto*//*Label 4135*/ GIMT_Encode4(186870), // Rule ID 23951 //
     /* 186813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 186816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 186824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186828 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186831 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186835 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186845 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186852 */     // (smax:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4i32] }:$src1)  =>  (VPMAXSDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZ128rm),
     /* 186855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186857 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 186859 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186863 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186868 */     GIR_RootConstrainSelectedInstOperands,
     /* 186869 */     // GIR_Coverage, 23951,
     /* 186869 */     GIR_EraseRootFromParent_Done,
     /* 186870 */   // Label 4135: @186870
     /* 186870 */   GIM_Try, /*On fail goto*//*Label 4136*/ GIMT_Encode4(186932), // Rule ID 3190 //
     /* 186875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 186878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 186882 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 186886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 186890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186894 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186897 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186901 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186907 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186914 */     // (smax:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDrm),
     /* 186917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186919 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 186921 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186925 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186930 */     GIR_RootConstrainSelectedInstOperands,
     /* 186931 */     // GIR_Coverage, 3190,
     /* 186931 */     GIR_EraseRootFromParent_Done,
     /* 186932 */   // Label 4136: @186932
     /* 186932 */   GIM_Try, /*On fail goto*//*Label 4137*/ GIMT_Encode4(186994), // Rule ID 5383 //
     /* 186937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 186940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 186952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186956 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186959 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186963 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186969 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186976 */     // (smax:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZ128rm),
     /* 186979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186981 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 186983 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186987 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186992 */     GIR_RootConstrainSelectedInstOperands,
     /* 186993 */     // GIR_Coverage, 5383,
     /* 186993 */     GIR_EraseRootFromParent_Done,
     /* 186994 */   // Label 4137: @186994
     /* 186994 */   GIM_Try, /*On fail goto*//*Label 4138*/ GIMT_Encode4(187021), // Rule ID 3189 //
     /* 186999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 187002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187014 */     // (smax:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPMAXSDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 187014 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSDrr),
     /* 187019 */     GIR_RootConstrainSelectedInstOperands,
     /* 187020 */     // GIR_Coverage, 3189,
     /* 187020 */     GIR_Done,
     /* 187021 */   // Label 4138: @187021
     /* 187021 */   GIM_Try, /*On fail goto*//*Label 4139*/ GIMT_Encode4(187048), // Rule ID 3231 //
     /* 187026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 187029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187033 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187041 */     // (smax:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PMAXSDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 187041 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMAXSDrr),
     /* 187046 */     GIR_RootConstrainSelectedInstOperands,
     /* 187047 */     // GIR_Coverage, 3231,
     /* 187047 */     GIR_Done,
     /* 187048 */   // Label 4139: @187048
     /* 187048 */   GIM_Try, /*On fail goto*//*Label 4140*/ GIMT_Encode4(187075), // Rule ID 5380 //
     /* 187053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 187056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187068 */     // (smax:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPMAXSDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 187068 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZ128rr),
     /* 187073 */     GIR_RootConstrainSelectedInstOperands,
     /* 187074 */     // GIR_Coverage, 5380,
     /* 187074 */     GIR_Done,
     /* 187075 */   // Label 4140: @187075
     /* 187075 */   GIM_Reject,
     /* 187076 */ // Label 4133: @187076
     /* 187076 */ GIM_Reject,
     /* 187077 */ // Label 4117: @187077
     /* 187077 */ GIM_Try, /*On fail goto*//*Label 4141*/ GIMT_Encode4(187393),
     /* 187082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 187085 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 187088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187092 */   GIM_Try, /*On fail goto*//*Label 4142*/ GIMT_Encode4(187150), // Rule ID 23963 //
     /* 187097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 187100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 187104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187108 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187111 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187115 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187125 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187132 */     // (smax:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4i64] }:$src1)  =>  (VPMAXSQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZ256rm),
     /* 187135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187137 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 187139 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187143 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187148 */     GIR_RootConstrainSelectedInstOperands,
     /* 187149 */     // GIR_Coverage, 23963,
     /* 187149 */     GIR_EraseRootFromParent_Done,
     /* 187150 */   // Label 4142: @187150
     /* 187150 */   GIM_Try, /*On fail goto*//*Label 4143*/ GIMT_Encode4(187208), // Rule ID 5401 //
     /* 187155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 187158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 187166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187170 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187173 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187177 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187183 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187190 */     // (smax:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZ256rm),
     /* 187193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187195 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 187197 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187206 */     GIR_RootConstrainSelectedInstOperands,
     /* 187207 */     // GIR_Coverage, 5401,
     /* 187207 */     GIR_EraseRootFromParent_Done,
     /* 187208 */   // Label 4143: @187208
     /* 187208 */   GIM_Try, /*On fail goto*//*Label 4144*/ GIMT_Encode4(187231), // Rule ID 5398 //
     /* 187213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 187216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187224 */     // (smax:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPMAXSQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 187224 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZ256rr),
     /* 187229 */     GIR_RootConstrainSelectedInstOperands,
     /* 187230 */     // GIR_Coverage, 5398,
     /* 187230 */     GIR_Done,
     /* 187231 */   // Label 4144: @187231
     /* 187231 */   GIM_Try, /*On fail goto*//*Label 4145*/ GIMT_Encode4(187392), // Rule ID 20008 //
     /* 187236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 187239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187247 */     // (smax:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPMAXSQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 187247 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 187250 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 187254 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 187261 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 187264 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 187268 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187273 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 187276 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 187280 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 187283 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 187288 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 187293 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 187298 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 187301 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 187305 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187310 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 187312 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 187315 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 187319 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187324 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 187327 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 187331 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 187334 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 187339 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 187344 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 187349 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 187352 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZrr),
     /* 187356 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187361 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 187364 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 187367 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 187369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 187372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187374 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 187381 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 187386 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 187391 */     // GIR_Coverage, 20008,
     /* 187391 */     GIR_EraseRootFromParent_Done,
     /* 187392 */   // Label 4145: @187392
     /* 187392 */   GIM_Reject,
     /* 187393 */ // Label 4141: @187393
     /* 187393 */ GIM_Reject,
     /* 187394 */ // Label 4118: @187394
     /* 187394 */ GIM_Try, /*On fail goto*//*Label 4146*/ GIMT_Encode4(187735),
     /* 187399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 187402 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 187405 */   GIM_Try, /*On fail goto*//*Label 4147*/ GIMT_Encode4(187467), // Rule ID 23471 //
     /* 187410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 187413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 187421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187425 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187428 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187432 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187442 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187449 */     // (smax:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPMAXSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWrm),
     /* 187452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187454 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 187456 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187460 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187465 */     GIR_RootConstrainSelectedInstOperands,
     /* 187466 */     // GIR_Coverage, 23471,
     /* 187466 */     GIR_EraseRootFromParent_Done,
     /* 187467 */   // Label 4147: @187467
     /* 187467 */   GIM_Try, /*On fail goto*//*Label 4148*/ GIMT_Encode4(187529), // Rule ID 23936 //
     /* 187472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 187475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 187483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187487 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187490 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187494 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187502 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187504 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187511 */     // (smax:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPMAXSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZ128rm),
     /* 187514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187516 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 187518 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187522 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187527 */     GIR_RootConstrainSelectedInstOperands,
     /* 187528 */     // GIR_Coverage, 23936,
     /* 187528 */     GIR_EraseRootFromParent_Done,
     /* 187529 */   // Label 4148: @187529
     /* 187529 */   GIM_Try, /*On fail goto*//*Label 4149*/ GIMT_Encode4(187591), // Rule ID 2655 //
     /* 187534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 187537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 187549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187553 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187556 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187560 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187564 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187566 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187573 */     // (smax:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWrm),
     /* 187576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187578 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 187580 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187584 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187589 */     GIR_RootConstrainSelectedInstOperands,
     /* 187590 */     // GIR_Coverage, 2655,
     /* 187590 */     GIR_EraseRootFromParent_Done,
     /* 187591 */   // Label 4149: @187591
     /* 187591 */   GIM_Try, /*On fail goto*//*Label 4150*/ GIMT_Encode4(187653), // Rule ID 5359 //
     /* 187596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 187599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187603 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 187611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187615 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187618 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187622 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187626 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187628 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187635 */     // (smax:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZ128rm),
     /* 187638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187640 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 187642 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187646 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187651 */     GIR_RootConstrainSelectedInstOperands,
     /* 187652 */     // GIR_Coverage, 5359,
     /* 187652 */     GIR_EraseRootFromParent_Done,
     /* 187653 */   // Label 4150: @187653
     /* 187653 */   GIM_Try, /*On fail goto*//*Label 4151*/ GIMT_Encode4(187680), // Rule ID 2654 //
     /* 187658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 187661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187673 */     // (smax:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMAXSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 187673 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSWrr),
     /* 187678 */     GIR_RootConstrainSelectedInstOperands,
     /* 187679 */     // GIR_Coverage, 2654,
     /* 187679 */     GIR_Done,
     /* 187680 */   // Label 4151: @187680
     /* 187680 */   GIM_Try, /*On fail goto*//*Label 4152*/ GIMT_Encode4(187707), // Rule ID 2656 //
     /* 187685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 187688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187700 */     // (smax:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMAXSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 187700 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMAXSWrr),
     /* 187705 */     GIR_RootConstrainSelectedInstOperands,
     /* 187706 */     // GIR_Coverage, 2656,
     /* 187706 */     GIR_Done,
     /* 187707 */   // Label 4152: @187707
     /* 187707 */   GIM_Try, /*On fail goto*//*Label 4153*/ GIMT_Encode4(187734), // Rule ID 5356 //
     /* 187712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 187715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187727 */     // (smax:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMAXSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 187727 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZ128rr),
     /* 187732 */     GIR_RootConstrainSelectedInstOperands,
     /* 187733 */     // GIR_Coverage, 5356,
     /* 187733 */     GIR_Done,
     /* 187734 */   // Label 4153: @187734
     /* 187734 */   GIM_Reject,
     /* 187735 */ // Label 4146: @187735
     /* 187735 */ GIM_Reject,
     /* 187736 */ // Label 4119: @187736
     /* 187736 */ GIM_Try, /*On fail goto*//*Label 4154*/ GIMT_Encode4(188050),
     /* 187741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 187744 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 187747 */   GIM_Try, /*On fail goto*//*Label 4155*/ GIMT_Encode4(187809), // Rule ID 23512 //
     /* 187752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 187755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 187759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 187763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187767 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187770 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187774 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 187782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187784 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187791 */     // (smax:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VPMAXSDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDYrm),
     /* 187794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187796 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 187798 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187802 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187807 */     GIR_RootConstrainSelectedInstOperands,
     /* 187808 */     // GIR_Coverage, 23512,
     /* 187808 */     GIR_EraseRootFromParent_Done,
     /* 187809 */   // Label 4155: @187809
     /* 187809 */   GIM_Try, /*On fail goto*//*Label 4156*/ GIMT_Encode4(187871), // Rule ID 23945 //
     /* 187814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 187817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 187825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187829 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187832 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187836 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187846 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187853 */     // (smax:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8i32] }:$src1)  =>  (VPMAXSDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZ256rm),
     /* 187856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187858 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 187860 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187864 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187869 */     GIR_RootConstrainSelectedInstOperands,
     /* 187870 */     // GIR_Coverage, 23945,
     /* 187870 */     GIR_EraseRootFromParent_Done,
     /* 187871 */   // Label 4156: @187871
     /* 187871 */   GIM_Try, /*On fail goto*//*Label 4157*/ GIMT_Encode4(187933), // Rule ID 3208 //
     /* 187876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 187879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 187883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 187887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 187891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187895 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187898 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187902 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187906 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187908 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187915 */     // (smax:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDYrm),
     /* 187918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187920 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 187922 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187926 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187931 */     GIR_RootConstrainSelectedInstOperands,
     /* 187932 */     // GIR_Coverage, 3208,
     /* 187932 */     GIR_EraseRootFromParent_Done,
     /* 187933 */   // Label 4157: @187933
     /* 187933 */   GIM_Try, /*On fail goto*//*Label 4158*/ GIMT_Encode4(187995), // Rule ID 5374 //
     /* 187938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 187941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 187953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187957 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187960 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187964 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187970 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187977 */     // (smax:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZ256rm),
     /* 187980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187982 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 187984 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187988 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187993 */     GIR_RootConstrainSelectedInstOperands,
     /* 187994 */     // GIR_Coverage, 5374,
     /* 187994 */     GIR_EraseRootFromParent_Done,
     /* 187995 */   // Label 4158: @187995
     /* 187995 */   GIM_Try, /*On fail goto*//*Label 4159*/ GIMT_Encode4(188022), // Rule ID 3207 //
     /* 188000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 188003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188015 */     // (smax:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPMAXSDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 188015 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSDYrr),
     /* 188020 */     GIR_RootConstrainSelectedInstOperands,
     /* 188021 */     // GIR_Coverage, 3207,
     /* 188021 */     GIR_Done,
     /* 188022 */   // Label 4159: @188022
     /* 188022 */   GIM_Try, /*On fail goto*//*Label 4160*/ GIMT_Encode4(188049), // Rule ID 5371 //
     /* 188027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 188030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188042 */     // (smax:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPMAXSDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 188042 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZ256rr),
     /* 188047 */     GIR_RootConstrainSelectedInstOperands,
     /* 188048 */     // GIR_Coverage, 5371,
     /* 188048 */     GIR_Done,
     /* 188049 */   // Label 4160: @188049
     /* 188049 */   GIM_Reject,
     /* 188050 */ // Label 4154: @188050
     /* 188050 */ GIM_Reject,
     /* 188051 */ // Label 4120: @188051
     /* 188051 */ GIM_Try, /*On fail goto*//*Label 4161*/ GIMT_Encode4(188206),
     /* 188056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 188059 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 188062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 188066 */   GIM_Try, /*On fail goto*//*Label 4162*/ GIMT_Encode4(188124), // Rule ID 23957 //
     /* 188071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 188074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 188078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188082 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188085 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188089 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 188097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188099 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188106 */     // (smax:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8i64] }:$src1)  =>  (VPMAXSQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZrm),
     /* 188109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188111 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 188113 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188117 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188122 */     GIR_RootConstrainSelectedInstOperands,
     /* 188123 */     // GIR_Coverage, 23957,
     /* 188123 */     GIR_EraseRootFromParent_Done,
     /* 188124 */   // Label 4162: @188124
     /* 188124 */   GIM_Try, /*On fail goto*//*Label 4163*/ GIMT_Encode4(188182), // Rule ID 5392 //
     /* 188129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 188132 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 188136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 188140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188144 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188147 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188151 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188157 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188164 */     // (smax:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZrm),
     /* 188167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188169 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 188171 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188175 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188180 */     GIR_RootConstrainSelectedInstOperands,
     /* 188181 */     // GIR_Coverage, 5392,
     /* 188181 */     GIR_EraseRootFromParent_Done,
     /* 188182 */   // Label 4163: @188182
     /* 188182 */   GIM_Try, /*On fail goto*//*Label 4164*/ GIMT_Encode4(188205), // Rule ID 5389 //
     /* 188187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 188190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 188194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 188198 */     // (smax:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPMAXSQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 188198 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZrr),
     /* 188203 */     GIR_RootConstrainSelectedInstOperands,
     /* 188204 */     // GIR_Coverage, 5389,
     /* 188204 */     GIR_Done,
     /* 188205 */   // Label 4164: @188205
     /* 188205 */   GIM_Reject,
     /* 188206 */ // Label 4161: @188206
     /* 188206 */ GIM_Reject,
     /* 188207 */ // Label 4121: @188207
     /* 188207 */ GIM_Try, /*On fail goto*//*Label 4165*/ GIMT_Encode4(188548),
     /* 188212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 188215 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 188218 */   GIM_Try, /*On fail goto*//*Label 4166*/ GIMT_Encode4(188280), // Rule ID 23508 //
     /* 188223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 188226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 188230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 188234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188238 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188241 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188245 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 188253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188255 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188262 */     // (smax:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPMAXSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBrm),
     /* 188265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188267 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 188269 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188273 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188278 */     GIR_RootConstrainSelectedInstOperands,
     /* 188279 */     // GIR_Coverage, 23508,
     /* 188279 */     GIR_EraseRootFromParent_Done,
     /* 188280 */   // Label 4166: @188280
     /* 188280 */   GIM_Try, /*On fail goto*//*Label 4167*/ GIMT_Encode4(188342), // Rule ID 23927 //
     /* 188285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 188288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 188292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 188296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188300 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188303 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188307 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 188315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188317 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188324 */     // (smax:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPMAXSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZ128rm),
     /* 188327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188329 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 188331 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188335 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188340 */     GIR_RootConstrainSelectedInstOperands,
     /* 188341 */     // GIR_Coverage, 23927,
     /* 188341 */     GIR_EraseRootFromParent_Done,
     /* 188342 */   // Label 4167: @188342
     /* 188342 */   GIM_Try, /*On fail goto*//*Label 4168*/ GIMT_Encode4(188404), // Rule ID 3200 //
     /* 188347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 188350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 188354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 188358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 188362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188366 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188369 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188373 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188379 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188386 */     // (smax:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBrm),
     /* 188389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188391 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 188393 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188397 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188402 */     GIR_RootConstrainSelectedInstOperands,
     /* 188403 */     // GIR_Coverage, 3200,
     /* 188403 */     GIR_EraseRootFromParent_Done,
     /* 188404 */   // Label 4168: @188404
     /* 188404 */   GIM_Try, /*On fail goto*//*Label 4169*/ GIMT_Encode4(188466), // Rule ID 5341 //
     /* 188409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 188412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 188416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 188420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 188424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188428 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188431 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188435 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188441 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188448 */     // (smax:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZ128rm),
     /* 188451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188453 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 188455 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188459 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188464 */     GIR_RootConstrainSelectedInstOperands,
     /* 188465 */     // GIR_Coverage, 5341,
     /* 188465 */     GIR_EraseRootFromParent_Done,
     /* 188466 */   // Label 4169: @188466
     /* 188466 */   GIM_Try, /*On fail goto*//*Label 4170*/ GIMT_Encode4(188493), // Rule ID 3199 //
     /* 188471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 188474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 188478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 188482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 188486 */     // (smax:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPMAXSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 188486 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSBrr),
     /* 188491 */     GIR_RootConstrainSelectedInstOperands,
     /* 188492 */     // GIR_Coverage, 3199,
     /* 188492 */     GIR_Done,
     /* 188493 */   // Label 4170: @188493
     /* 188493 */   GIM_Try, /*On fail goto*//*Label 4171*/ GIMT_Encode4(188520), // Rule ID 3229 //
     /* 188498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 188501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 188505 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 188509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 188513 */     // (smax:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PMAXSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 188513 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMAXSBrr),
     /* 188518 */     GIR_RootConstrainSelectedInstOperands,
     /* 188519 */     // GIR_Coverage, 3229,
     /* 188519 */     GIR_Done,
     /* 188520 */   // Label 4171: @188520
     /* 188520 */   GIM_Try, /*On fail goto*//*Label 4172*/ GIMT_Encode4(188547), // Rule ID 5338 //
     /* 188525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 188528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 188532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 188536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 188540 */     // (smax:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPMAXSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 188540 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZ128rr),
     /* 188545 */     GIR_RootConstrainSelectedInstOperands,
     /* 188546 */     // GIR_Coverage, 5338,
     /* 188546 */     GIR_Done,
     /* 188547 */   // Label 4172: @188547
     /* 188547 */   GIM_Reject,
     /* 188548 */ // Label 4165: @188548
     /* 188548 */ GIM_Reject,
     /* 188549 */ // Label 4122: @188549
     /* 188549 */ GIM_Try, /*On fail goto*//*Label 4173*/ GIMT_Encode4(188863),
     /* 188554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 188557 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 188560 */   GIM_Try, /*On fail goto*//*Label 4174*/ GIMT_Encode4(188622), // Rule ID 23473 //
     /* 188565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 188568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 188576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188580 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188583 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188587 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188597 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188604 */     // (smax:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPMAXSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWYrm),
     /* 188607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188609 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 188611 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188615 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188620 */     GIR_RootConstrainSelectedInstOperands,
     /* 188621 */     // GIR_Coverage, 23473,
     /* 188621 */     GIR_EraseRootFromParent_Done,
     /* 188622 */   // Label 4174: @188622
     /* 188622 */   GIM_Try, /*On fail goto*//*Label 4175*/ GIMT_Encode4(188684), // Rule ID 23933 //
     /* 188627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 188630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 188638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188642 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188645 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188649 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188659 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188666 */     // (smax:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPMAXSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZ256rm),
     /* 188669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188671 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 188673 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188677 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188682 */     GIR_RootConstrainSelectedInstOperands,
     /* 188683 */     // GIR_Coverage, 23933,
     /* 188683 */     GIR_EraseRootFromParent_Done,
     /* 188684 */   // Label 4175: @188684
     /* 188684 */   GIM_Try, /*On fail goto*//*Label 4176*/ GIMT_Encode4(188746), // Rule ID 2659 //
     /* 188689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 188692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 188704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188708 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188711 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188715 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188721 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188728 */     // (smax:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWYrm),
     /* 188731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188733 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 188735 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188739 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188744 */     GIR_RootConstrainSelectedInstOperands,
     /* 188745 */     // GIR_Coverage, 2659,
     /* 188745 */     GIR_EraseRootFromParent_Done,
     /* 188746 */   // Label 4176: @188746
     /* 188746 */   GIM_Try, /*On fail goto*//*Label 4177*/ GIMT_Encode4(188808), // Rule ID 5353 //
     /* 188751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 188754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188758 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 188766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188770 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188773 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188777 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188783 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188790 */     // (smax:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZ256rm),
     /* 188793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188795 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 188797 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188801 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188806 */     GIR_RootConstrainSelectedInstOperands,
     /* 188807 */     // GIR_Coverage, 5353,
     /* 188807 */     GIR_EraseRootFromParent_Done,
     /* 188808 */   // Label 4177: @188808
     /* 188808 */   GIM_Try, /*On fail goto*//*Label 4178*/ GIMT_Encode4(188835), // Rule ID 2658 //
     /* 188813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 188816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188820 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188828 */     // (smax:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMAXSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 188828 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSWYrr),
     /* 188833 */     GIR_RootConstrainSelectedInstOperands,
     /* 188834 */     // GIR_Coverage, 2658,
     /* 188834 */     GIR_Done,
     /* 188835 */   // Label 4178: @188835
     /* 188835 */   GIM_Try, /*On fail goto*//*Label 4179*/ GIMT_Encode4(188862), // Rule ID 5350 //
     /* 188840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 188843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188855 */     // (smax:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMAXSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 188855 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZ256rr),
     /* 188860 */     GIR_RootConstrainSelectedInstOperands,
     /* 188861 */     // GIR_Coverage, 5350,
     /* 188861 */     GIR_Done,
     /* 188862 */   // Label 4179: @188862
     /* 188862 */   GIM_Reject,
     /* 188863 */ // Label 4173: @188863
     /* 188863 */ GIM_Reject,
     /* 188864 */ // Label 4123: @188864
     /* 188864 */ GIM_Try, /*On fail goto*//*Label 4180*/ GIMT_Encode4(189019),
     /* 188869 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 188872 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 188875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 188879 */   GIM_Try, /*On fail goto*//*Label 4181*/ GIMT_Encode4(188937), // Rule ID 23939 //
     /* 188884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 188887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 188891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188895 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188898 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188902 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 188910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188912 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188919 */     // (smax:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16i32] }:$src1)  =>  (VPMAXSDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZrm),
     /* 188922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188924 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 188926 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188930 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188935 */     GIR_RootConstrainSelectedInstOperands,
     /* 188936 */     // GIR_Coverage, 23939,
     /* 188936 */     GIR_EraseRootFromParent_Done,
     /* 188937 */   // Label 4181: @188937
     /* 188937 */   GIM_Try, /*On fail goto*//*Label 4182*/ GIMT_Encode4(188995), // Rule ID 5365 //
     /* 188942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 188945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 188949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 188953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188957 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188960 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188964 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188970 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188977 */     // (smax:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZrm),
     /* 188980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188982 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 188984 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188988 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188993 */     GIR_RootConstrainSelectedInstOperands,
     /* 188994 */     // GIR_Coverage, 5365,
     /* 188994 */     GIR_EraseRootFromParent_Done,
     /* 188995 */   // Label 4182: @188995
     /* 188995 */   GIM_Try, /*On fail goto*//*Label 4183*/ GIMT_Encode4(189018), // Rule ID 5362 //
     /* 189000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 189003 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189011 */     // (smax:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPMAXSDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 189011 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZrr),
     /* 189016 */     GIR_RootConstrainSelectedInstOperands,
     /* 189017 */     // GIR_Coverage, 5362,
     /* 189017 */     GIR_Done,
     /* 189018 */   // Label 4183: @189018
     /* 189018 */   GIM_Reject,
     /* 189019 */ // Label 4180: @189019
     /* 189019 */ GIM_Reject,
     /* 189020 */ // Label 4124: @189020
     /* 189020 */ GIM_Try, /*On fail goto*//*Label 4184*/ GIMT_Encode4(189334),
     /* 189025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 189028 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 189031 */   GIM_Try, /*On fail goto*//*Label 4185*/ GIMT_Encode4(189093), // Rule ID 23517 //
     /* 189036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 189039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 189043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 189047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189051 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189054 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189058 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 189066 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189068 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189075 */     // (smax:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPMAXSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBYrm),
     /* 189078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189080 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 189082 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189086 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189091 */     GIR_RootConstrainSelectedInstOperands,
     /* 189092 */     // GIR_Coverage, 23517,
     /* 189092 */     GIR_EraseRootFromParent_Done,
     /* 189093 */   // Label 4185: @189093
     /* 189093 */   GIM_Try, /*On fail goto*//*Label 4186*/ GIMT_Encode4(189155), // Rule ID 23924 //
     /* 189098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 189101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 189105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 189109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189113 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189116 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189120 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 189128 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189130 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189137 */     // (smax:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPMAXSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZ256rm),
     /* 189140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189142 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 189144 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189148 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189153 */     GIR_RootConstrainSelectedInstOperands,
     /* 189154 */     // GIR_Coverage, 23924,
     /* 189154 */     GIR_EraseRootFromParent_Done,
     /* 189155 */   // Label 4186: @189155
     /* 189155 */   GIM_Try, /*On fail goto*//*Label 4187*/ GIMT_Encode4(189217), // Rule ID 3218 //
     /* 189160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 189163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 189167 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 189171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 189175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189179 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189182 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189186 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189190 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189192 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189199 */     // (smax:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBYrm),
     /* 189202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189204 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 189206 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189210 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189215 */     GIR_RootConstrainSelectedInstOperands,
     /* 189216 */     // GIR_Coverage, 3218,
     /* 189216 */     GIR_EraseRootFromParent_Done,
     /* 189217 */   // Label 4187: @189217
     /* 189217 */   GIM_Try, /*On fail goto*//*Label 4188*/ GIMT_Encode4(189279), // Rule ID 5335 //
     /* 189222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 189225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 189229 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 189233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 189237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189241 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189244 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189248 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189252 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189254 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189261 */     // (smax:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZ256rm),
     /* 189264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189266 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 189268 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189272 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189277 */     GIR_RootConstrainSelectedInstOperands,
     /* 189278 */     // GIR_Coverage, 5335,
     /* 189278 */     GIR_EraseRootFromParent_Done,
     /* 189279 */   // Label 4188: @189279
     /* 189279 */   GIM_Try, /*On fail goto*//*Label 4189*/ GIMT_Encode4(189306), // Rule ID 3217 //
     /* 189284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 189287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 189291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 189295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 189299 */     // (smax:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPMAXSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 189299 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSBYrr),
     /* 189304 */     GIR_RootConstrainSelectedInstOperands,
     /* 189305 */     // GIR_Coverage, 3217,
     /* 189305 */     GIR_Done,
     /* 189306 */   // Label 4189: @189306
     /* 189306 */   GIM_Try, /*On fail goto*//*Label 4190*/ GIMT_Encode4(189333), // Rule ID 5332 //
     /* 189311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 189314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 189318 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 189322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 189326 */     // (smax:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPMAXSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 189326 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZ256rr),
     /* 189331 */     GIR_RootConstrainSelectedInstOperands,
     /* 189332 */     // GIR_Coverage, 5332,
     /* 189332 */     GIR_Done,
     /* 189333 */   // Label 4190: @189333
     /* 189333 */   GIM_Reject,
     /* 189334 */ // Label 4184: @189334
     /* 189334 */ GIM_Reject,
     /* 189335 */ // Label 4125: @189335
     /* 189335 */ GIM_Try, /*On fail goto*//*Label 4191*/ GIMT_Encode4(189490),
     /* 189340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 189343 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 189346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189350 */   GIM_Try, /*On fail goto*//*Label 4192*/ GIMT_Encode4(189408), // Rule ID 23930 //
     /* 189355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 189358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 189362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189366 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189369 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189373 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189383 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189390 */     // (smax:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPMAXSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZrm),
     /* 189393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189395 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 189397 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189401 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189406 */     GIR_RootConstrainSelectedInstOperands,
     /* 189407 */     // GIR_Coverage, 23930,
     /* 189407 */     GIR_EraseRootFromParent_Done,
     /* 189408 */   // Label 4192: @189408
     /* 189408 */   GIM_Try, /*On fail goto*//*Label 4193*/ GIMT_Encode4(189466), // Rule ID 5347 //
     /* 189413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 189416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 189424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189428 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189431 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189435 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189441 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189448 */     // (smax:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZrm),
     /* 189451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189453 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 189455 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189459 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189464 */     GIR_RootConstrainSelectedInstOperands,
     /* 189465 */     // GIR_Coverage, 5347,
     /* 189465 */     GIR_EraseRootFromParent_Done,
     /* 189466 */   // Label 4193: @189466
     /* 189466 */   GIM_Try, /*On fail goto*//*Label 4194*/ GIMT_Encode4(189489), // Rule ID 5344 //
     /* 189471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 189474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189482 */     // (smax:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMAXSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 189482 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZrr),
     /* 189487 */     GIR_RootConstrainSelectedInstOperands,
     /* 189488 */     // GIR_Coverage, 5344,
     /* 189488 */     GIR_Done,
     /* 189489 */   // Label 4194: @189489
     /* 189489 */   GIM_Reject,
     /* 189490 */ // Label 4191: @189490
     /* 189490 */ GIM_Reject,
     /* 189491 */ // Label 4126: @189491
     /* 189491 */ GIM_Try, /*On fail goto*//*Label 4195*/ GIMT_Encode4(189646),
     /* 189496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 189499 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 189502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189506 */   GIM_Try, /*On fail goto*//*Label 4196*/ GIMT_Encode4(189564), // Rule ID 23921 //
     /* 189511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 189514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 189518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189522 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189525 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189529 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189539 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189546 */     // (smax:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPMAXSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZrm),
     /* 189549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189551 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 189553 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189557 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189562 */     GIR_RootConstrainSelectedInstOperands,
     /* 189563 */     // GIR_Coverage, 23921,
     /* 189563 */     GIR_EraseRootFromParent_Done,
     /* 189564 */   // Label 4196: @189564
     /* 189564 */   GIM_Try, /*On fail goto*//*Label 4197*/ GIMT_Encode4(189622), // Rule ID 5329 //
     /* 189569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 189572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 189580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189584 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189587 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189591 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189597 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189604 */     // (smax:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZrm),
     /* 189607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189609 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 189611 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189615 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189620 */     GIR_RootConstrainSelectedInstOperands,
     /* 189621 */     // GIR_Coverage, 5329,
     /* 189621 */     GIR_EraseRootFromParent_Done,
     /* 189622 */   // Label 4197: @189622
     /* 189622 */   GIM_Try, /*On fail goto*//*Label 4198*/ GIMT_Encode4(189645), // Rule ID 5326 //
     /* 189627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 189630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189638 */     // (smax:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPMAXSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 189638 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZrr),
     /* 189643 */     GIR_RootConstrainSelectedInstOperands,
     /* 189644 */     // GIR_Coverage, 5326,
     /* 189644 */     GIR_Done,
     /* 189645 */   // Label 4198: @189645
     /* 189645 */   GIM_Reject,
     /* 189646 */ // Label 4195: @189646
     /* 189646 */ GIM_Reject,
     /* 189647 */ // Label 4127: @189647
     /* 189647 */ GIM_Reject,
     /* 189648 */ // Label 56: @189648
     /* 189648 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 4211*/ GIMT_Encode4(192968),
     /* 189659 */ /*GILLT_v2s64*//*Label 4199*/ GIMT_Encode4(189727), GIMT_Encode4(0),
     /* 189667 */ /*GILLT_v4s32*//*Label 4200*/ GIMT_Encode4(190056),
     /* 189671 */ /*GILLT_v4s64*//*Label 4201*/ GIMT_Encode4(190398), GIMT_Encode4(0),
     /* 189679 */ /*GILLT_v8s16*//*Label 4202*/ GIMT_Encode4(190715),
     /* 189683 */ /*GILLT_v8s32*//*Label 4203*/ GIMT_Encode4(191057),
     /* 189687 */ /*GILLT_v8s64*//*Label 4204*/ GIMT_Encode4(191372), GIMT_Encode4(0),
     /* 189695 */ /*GILLT_v16s8*//*Label 4205*/ GIMT_Encode4(191528),
     /* 189699 */ /*GILLT_v16s16*//*Label 4206*/ GIMT_Encode4(191870),
     /* 189703 */ /*GILLT_v16s32*//*Label 4207*/ GIMT_Encode4(192185), GIMT_Encode4(0),
     /* 189711 */ /*GILLT_v32s8*//*Label 4208*/ GIMT_Encode4(192341),
     /* 189715 */ /*GILLT_v32s16*//*Label 4209*/ GIMT_Encode4(192656), GIMT_Encode4(0),
     /* 189723 */ /*GILLT_v64s8*//*Label 4210*/ GIMT_Encode4(192812),
     /* 189727 */ // Label 4199: @189727
     /* 189727 */ GIM_Try, /*On fail goto*//*Label 4212*/ GIMT_Encode4(190055),
     /* 189732 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 189735 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 189738 */   GIM_Try, /*On fail goto*//*Label 4213*/ GIMT_Encode4(189800), // Rule ID 24131 //
     /* 189743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 189746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 189754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189758 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189761 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189765 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189775 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189782 */     // (umin:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2i64] }:$src1)  =>  (VPMINUQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUQZ128rm),
     /* 189785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189787 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 189789 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189793 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189798 */     GIR_RootConstrainSelectedInstOperands,
     /* 189799 */     // GIR_Coverage, 24131,
     /* 189799 */     GIR_EraseRootFromParent_Done,
     /* 189800 */   // Label 4213: @189800
     /* 189800 */   GIM_Try, /*On fail goto*//*Label 4214*/ GIMT_Encode4(189862), // Rule ID 5680 //
     /* 189805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 189808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 189820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189824 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189827 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189831 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189837 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189844 */     // (umin:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUQZ128rm),
     /* 189847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189849 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 189851 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189855 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189860 */     GIR_RootConstrainSelectedInstOperands,
     /* 189861 */     // GIR_Coverage, 5680,
     /* 189861 */     GIR_EraseRootFromParent_Done,
     /* 189862 */   // Label 4214: @189862
     /* 189862 */   GIM_Try, /*On fail goto*//*Label 4215*/ GIMT_Encode4(189889), // Rule ID 5677 //
     /* 189867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 189870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189874 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189882 */     // (umin:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPMINUQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 189882 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUQZ128rr),
     /* 189887 */     GIR_RootConstrainSelectedInstOperands,
     /* 189888 */     // GIR_Coverage, 5677,
     /* 189888 */     GIR_Done,
     /* 189889 */   // Label 4215: @189889
     /* 189889 */   GIM_Try, /*On fail goto*//*Label 4216*/ GIMT_Encode4(190054), // Rule ID 20006 //
     /* 189894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 189897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 189901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189909 */     // (umin:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPMINUQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 189909 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 189912 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 189916 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189921 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 189923 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 189926 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 189930 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189935 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 189938 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 189942 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 189945 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 189950 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 189955 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 189960 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 189963 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 189967 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189972 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 189974 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 189977 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 189981 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189986 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 189989 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 189993 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 189996 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 190001 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 190006 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 190011 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 190014 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMINUQZrr),
     /* 190018 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190023 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 190026 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 190029 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 190031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 190034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190036 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 190043 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 190048 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 190053 */     // GIR_Coverage, 20006,
     /* 190053 */     GIR_EraseRootFromParent_Done,
     /* 190054 */   // Label 4216: @190054
     /* 190054 */   GIM_Reject,
     /* 190055 */ // Label 4212: @190055
     /* 190055 */ GIM_Reject,
     /* 190056 */ // Label 4200: @190056
     /* 190056 */ GIM_Try, /*On fail goto*//*Label 4217*/ GIMT_Encode4(190397),
     /* 190061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 190064 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 190067 */   GIM_Try, /*On fail goto*//*Label 4218*/ GIMT_Encode4(190129), // Rule ID 23502 //
     /* 190072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 190075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 190083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190087 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190090 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190094 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190104 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190111 */     // (umin:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1)  =>  (VPMINUDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDrm),
     /* 190114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190116 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 190118 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190122 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190127 */     GIR_RootConstrainSelectedInstOperands,
     /* 190128 */     // GIR_Coverage, 23502,
     /* 190128 */     GIR_EraseRootFromParent_Done,
     /* 190129 */   // Label 4218: @190129
     /* 190129 */   GIM_Try, /*On fail goto*//*Label 4219*/ GIMT_Encode4(190191), // Rule ID 24113 //
     /* 190134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 190137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 190145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190149 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190152 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190156 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190166 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190173 */     // (umin:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4i32] }:$src1)  =>  (VPMINUDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDZ128rm),
     /* 190176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190178 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 190180 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190184 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190189 */     GIR_RootConstrainSelectedInstOperands,
     /* 190190 */     // GIR_Coverage, 24113,
     /* 190190 */     GIR_EraseRootFromParent_Done,
     /* 190191 */   // Label 4219: @190191
     /* 190191 */   GIM_Try, /*On fail goto*//*Label 4220*/ GIMT_Encode4(190253), // Rule ID 3188 //
     /* 190196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 190199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190203 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 190211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190215 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190218 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190222 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190226 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190228 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190235 */     // (umin:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDrm),
     /* 190238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190240 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 190242 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190246 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190251 */     GIR_RootConstrainSelectedInstOperands,
     /* 190252 */     // GIR_Coverage, 3188,
     /* 190252 */     GIR_EraseRootFromParent_Done,
     /* 190253 */   // Label 4220: @190253
     /* 190253 */   GIM_Try, /*On fail goto*//*Label 4221*/ GIMT_Encode4(190315), // Rule ID 5653 //
     /* 190258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 190261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 190273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190277 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190280 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190284 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190288 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190290 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190297 */     // (umin:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDZ128rm),
     /* 190300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190302 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 190304 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190308 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190313 */     GIR_RootConstrainSelectedInstOperands,
     /* 190314 */     // GIR_Coverage, 5653,
     /* 190314 */     GIR_EraseRootFromParent_Done,
     /* 190315 */   // Label 4221: @190315
     /* 190315 */   GIM_Try, /*On fail goto*//*Label 4222*/ GIMT_Encode4(190342), // Rule ID 3187 //
     /* 190320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 190323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190335 */     // (umin:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPMINUDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 190335 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUDrr),
     /* 190340 */     GIR_RootConstrainSelectedInstOperands,
     /* 190341 */     // GIR_Coverage, 3187,
     /* 190341 */     GIR_Done,
     /* 190342 */   // Label 4222: @190342
     /* 190342 */   GIM_Try, /*On fail goto*//*Label 4223*/ GIMT_Encode4(190369), // Rule ID 3225 //
     /* 190347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 190350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190362 */     // (umin:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PMINUDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 190362 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMINUDrr),
     /* 190367 */     GIR_RootConstrainSelectedInstOperands,
     /* 190368 */     // GIR_Coverage, 3225,
     /* 190368 */     GIR_Done,
     /* 190369 */   // Label 4223: @190369
     /* 190369 */   GIM_Try, /*On fail goto*//*Label 4224*/ GIMT_Encode4(190396), // Rule ID 5650 //
     /* 190374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 190377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190389 */     // (umin:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPMINUDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 190389 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUDZ128rr),
     /* 190394 */     GIR_RootConstrainSelectedInstOperands,
     /* 190395 */     // GIR_Coverage, 5650,
     /* 190395 */     GIR_Done,
     /* 190396 */   // Label 4224: @190396
     /* 190396 */   GIM_Reject,
     /* 190397 */ // Label 4217: @190397
     /* 190397 */ GIM_Reject,
     /* 190398 */ // Label 4201: @190398
     /* 190398 */ GIM_Try, /*On fail goto*//*Label 4225*/ GIMT_Encode4(190714),
     /* 190403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 190406 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 190409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 190413 */   GIM_Try, /*On fail goto*//*Label 4226*/ GIMT_Encode4(190471), // Rule ID 24125 //
     /* 190418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 190421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 190425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190429 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190432 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190436 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 190444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190446 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190453 */     // (umin:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4i64] }:$src1)  =>  (VPMINUQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUQZ256rm),
     /* 190456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190458 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 190460 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190464 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190469 */     GIR_RootConstrainSelectedInstOperands,
     /* 190470 */     // GIR_Coverage, 24125,
     /* 190470 */     GIR_EraseRootFromParent_Done,
     /* 190471 */   // Label 4226: @190471
     /* 190471 */   GIM_Try, /*On fail goto*//*Label 4227*/ GIMT_Encode4(190529), // Rule ID 5671 //
     /* 190476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 190479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 190483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 190487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190491 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190494 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190498 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190502 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190504 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190511 */     // (umin:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUQZ256rm),
     /* 190514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190516 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 190518 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190522 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190527 */     GIR_RootConstrainSelectedInstOperands,
     /* 190528 */     // GIR_Coverage, 5671,
     /* 190528 */     GIR_EraseRootFromParent_Done,
     /* 190529 */   // Label 4227: @190529
     /* 190529 */   GIM_Try, /*On fail goto*//*Label 4228*/ GIMT_Encode4(190552), // Rule ID 5668 //
     /* 190534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 190537 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 190541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 190545 */     // (umin:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPMINUQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 190545 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUQZ256rr),
     /* 190550 */     GIR_RootConstrainSelectedInstOperands,
     /* 190551 */     // GIR_Coverage, 5668,
     /* 190551 */     GIR_Done,
     /* 190552 */   // Label 4228: @190552
     /* 190552 */   GIM_Try, /*On fail goto*//*Label 4229*/ GIMT_Encode4(190713), // Rule ID 20004 //
     /* 190557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 190560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 190564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 190568 */     // (umin:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPMINUQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 190568 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 190571 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 190575 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190580 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 190582 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 190585 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 190589 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190594 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 190597 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 190601 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 190604 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 190609 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 190614 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 190619 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 190622 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 190626 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190631 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 190633 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 190636 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 190640 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190645 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 190648 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 190652 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 190655 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 190660 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 190665 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 190670 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 190673 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMINUQZrr),
     /* 190677 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190682 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 190685 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 190688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 190690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 190693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190695 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 190702 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 190707 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 190712 */     // GIR_Coverage, 20004,
     /* 190712 */     GIR_EraseRootFromParent_Done,
     /* 190713 */   // Label 4229: @190713
     /* 190713 */   GIM_Reject,
     /* 190714 */ // Label 4225: @190714
     /* 190714 */ GIM_Reject,
     /* 190715 */ // Label 4202: @190715
     /* 190715 */ GIM_Try, /*On fail goto*//*Label 4230*/ GIMT_Encode4(191056),
     /* 190720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 190723 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 190726 */   GIM_Try, /*On fail goto*//*Label 4231*/ GIMT_Encode4(190788), // Rule ID 23507 //
     /* 190731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 190734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 190742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190746 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190749 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190753 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190763 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190770 */     // (umin:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPMINUWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWrm),
     /* 190773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190775 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 190777 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190781 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190786 */     GIR_RootConstrainSelectedInstOperands,
     /* 190787 */     // GIR_Coverage, 23507,
     /* 190787 */     GIR_EraseRootFromParent_Done,
     /* 190788 */   // Label 4231: @190788
     /* 190788 */   GIM_Try, /*On fail goto*//*Label 4232*/ GIMT_Encode4(190850), // Rule ID 24098 //
     /* 190793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 190796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 190804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190808 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190811 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190815 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190825 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190832 */     // (umin:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPMINUWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWZ128rm),
     /* 190835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190837 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 190839 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190843 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190848 */     GIR_RootConstrainSelectedInstOperands,
     /* 190849 */     // GIR_Coverage, 24098,
     /* 190849 */     GIR_EraseRootFromParent_Done,
     /* 190850 */   // Label 4232: @190850
     /* 190850 */   GIM_Try, /*On fail goto*//*Label 4233*/ GIMT_Encode4(190912), // Rule ID 3198 //
     /* 190855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 190858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 190870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190874 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190877 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190881 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190887 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190894 */     // (umin:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWrm),
     /* 190897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190899 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 190901 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190905 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190910 */     GIR_RootConstrainSelectedInstOperands,
     /* 190911 */     // GIR_Coverage, 3198,
     /* 190911 */     GIR_EraseRootFromParent_Done,
     /* 190912 */   // Label 4233: @190912
     /* 190912 */   GIM_Try, /*On fail goto*//*Label 4234*/ GIMT_Encode4(190974), // Rule ID 5629 //
     /* 190917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 190920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 190932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190936 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190939 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190943 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190949 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190956 */     // (umin:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWZ128rm),
     /* 190959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190961 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 190963 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190967 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190972 */     GIR_RootConstrainSelectedInstOperands,
     /* 190973 */     // GIR_Coverage, 5629,
     /* 190973 */     GIR_EraseRootFromParent_Done,
     /* 190974 */   // Label 4234: @190974
     /* 190974 */   GIM_Try, /*On fail goto*//*Label 4235*/ GIMT_Encode4(191001), // Rule ID 3197 //
     /* 190979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 190982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190994 */     // (umin:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMINUWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 190994 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUWrr),
     /* 190999 */     GIR_RootConstrainSelectedInstOperands,
     /* 191000 */     // GIR_Coverage, 3197,
     /* 191000 */     GIR_Done,
     /* 191001 */   // Label 4235: @191001
     /* 191001 */   GIM_Try, /*On fail goto*//*Label 4236*/ GIMT_Encode4(191028), // Rule ID 3227 //
     /* 191006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 191009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191021 */     // (umin:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMINUWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 191021 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMINUWrr),
     /* 191026 */     GIR_RootConstrainSelectedInstOperands,
     /* 191027 */     // GIR_Coverage, 3227,
     /* 191027 */     GIR_Done,
     /* 191028 */   // Label 4236: @191028
     /* 191028 */   GIM_Try, /*On fail goto*//*Label 4237*/ GIMT_Encode4(191055), // Rule ID 5626 //
     /* 191033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 191036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191048 */     // (umin:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMINUWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 191048 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUWZ128rr),
     /* 191053 */     GIR_RootConstrainSelectedInstOperands,
     /* 191054 */     // GIR_Coverage, 5626,
     /* 191054 */     GIR_Done,
     /* 191055 */   // Label 4237: @191055
     /* 191055 */   GIM_Reject,
     /* 191056 */ // Label 4230: @191056
     /* 191056 */ GIM_Reject,
     /* 191057 */ // Label 4203: @191057
     /* 191057 */ GIM_Try, /*On fail goto*//*Label 4238*/ GIMT_Encode4(191371),
     /* 191062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 191065 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 191068 */   GIM_Try, /*On fail goto*//*Label 4239*/ GIMT_Encode4(191130), // Rule ID 23511 //
     /* 191073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 191076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 191084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191088 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191091 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191095 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191105 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191112 */     // (umin:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VPMINUDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDYrm),
     /* 191115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191117 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 191119 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191123 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191128 */     GIR_RootConstrainSelectedInstOperands,
     /* 191129 */     // GIR_Coverage, 23511,
     /* 191129 */     GIR_EraseRootFromParent_Done,
     /* 191130 */   // Label 4239: @191130
     /* 191130 */   GIM_Try, /*On fail goto*//*Label 4240*/ GIMT_Encode4(191192), // Rule ID 24107 //
     /* 191135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 191138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 191142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 191146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191150 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191153 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191157 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 191165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191167 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191174 */     // (umin:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8i32] }:$src1)  =>  (VPMINUDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDZ256rm),
     /* 191177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191179 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 191181 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191185 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191190 */     GIR_RootConstrainSelectedInstOperands,
     /* 191191 */     // GIR_Coverage, 24107,
     /* 191191 */     GIR_EraseRootFromParent_Done,
     /* 191192 */   // Label 4240: @191192
     /* 191192 */   GIM_Try, /*On fail goto*//*Label 4241*/ GIMT_Encode4(191254), // Rule ID 3206 //
     /* 191197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 191200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 191212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191216 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191219 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191223 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191229 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191236 */     // (umin:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDYrm),
     /* 191239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191241 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 191243 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191247 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191252 */     GIR_RootConstrainSelectedInstOperands,
     /* 191253 */     // GIR_Coverage, 3206,
     /* 191253 */     GIR_EraseRootFromParent_Done,
     /* 191254 */   // Label 4241: @191254
     /* 191254 */   GIM_Try, /*On fail goto*//*Label 4242*/ GIMT_Encode4(191316), // Rule ID 5644 //
     /* 191259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 191262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 191266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 191270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 191274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191278 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191281 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191285 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191291 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191298 */     // (umin:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDZ256rm),
     /* 191301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191303 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 191305 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191309 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191314 */     GIR_RootConstrainSelectedInstOperands,
     /* 191315 */     // GIR_Coverage, 5644,
     /* 191315 */     GIR_EraseRootFromParent_Done,
     /* 191316 */   // Label 4242: @191316
     /* 191316 */   GIM_Try, /*On fail goto*//*Label 4243*/ GIMT_Encode4(191343), // Rule ID 3205 //
     /* 191321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 191324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191336 */     // (umin:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPMINUDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 191336 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUDYrr),
     /* 191341 */     GIR_RootConstrainSelectedInstOperands,
     /* 191342 */     // GIR_Coverage, 3205,
     /* 191342 */     GIR_Done,
     /* 191343 */   // Label 4243: @191343
     /* 191343 */   GIM_Try, /*On fail goto*//*Label 4244*/ GIMT_Encode4(191370), // Rule ID 5641 //
     /* 191348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 191351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 191355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 191359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 191363 */     // (umin:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPMINUDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 191363 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUDZ256rr),
     /* 191368 */     GIR_RootConstrainSelectedInstOperands,
     /* 191369 */     // GIR_Coverage, 5641,
     /* 191369 */     GIR_Done,
     /* 191370 */   // Label 4244: @191370
     /* 191370 */   GIM_Reject,
     /* 191371 */ // Label 4238: @191371
     /* 191371 */ GIM_Reject,
     /* 191372 */ // Label 4204: @191372
     /* 191372 */ GIM_Try, /*On fail goto*//*Label 4245*/ GIMT_Encode4(191527),
     /* 191377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 191380 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 191383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 191387 */   GIM_Try, /*On fail goto*//*Label 4246*/ GIMT_Encode4(191445), // Rule ID 24119 //
     /* 191392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 191395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 191399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191403 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191406 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191410 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 191418 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191420 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191427 */     // (umin:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8i64] }:$src1)  =>  (VPMINUQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUQZrm),
     /* 191430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191432 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 191434 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191438 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191443 */     GIR_RootConstrainSelectedInstOperands,
     /* 191444 */     // GIR_Coverage, 24119,
     /* 191444 */     GIR_EraseRootFromParent_Done,
     /* 191445 */   // Label 4246: @191445
     /* 191445 */   GIM_Try, /*On fail goto*//*Label 4247*/ GIMT_Encode4(191503), // Rule ID 5662 //
     /* 191450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 191453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 191457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 191461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191465 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191468 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191472 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191478 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191485 */     // (umin:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUQZrm),
     /* 191488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191490 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 191492 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191496 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191501 */     GIR_RootConstrainSelectedInstOperands,
     /* 191502 */     // GIR_Coverage, 5662,
     /* 191502 */     GIR_EraseRootFromParent_Done,
     /* 191503 */   // Label 4247: @191503
     /* 191503 */   GIM_Try, /*On fail goto*//*Label 4248*/ GIMT_Encode4(191526), // Rule ID 5659 //
     /* 191508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 191511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 191515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 191519 */     // (umin:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPMINUQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 191519 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUQZrr),
     /* 191524 */     GIR_RootConstrainSelectedInstOperands,
     /* 191525 */     // GIR_Coverage, 5659,
     /* 191525 */     GIR_Done,
     /* 191526 */   // Label 4248: @191526
     /* 191526 */   GIM_Reject,
     /* 191527 */ // Label 4245: @191527
     /* 191527 */ GIM_Reject,
     /* 191528 */ // Label 4205: @191528
     /* 191528 */ GIM_Try, /*On fail goto*//*Label 4249*/ GIMT_Encode4(191869),
     /* 191533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 191536 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 191539 */   GIM_Try, /*On fail goto*//*Label 4250*/ GIMT_Encode4(191601), // Rule ID 23462 //
     /* 191544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 191547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 191555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191559 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191562 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191566 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191574 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191576 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191583 */     // (umin:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPMINUBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBrm),
     /* 191586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191588 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 191590 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191594 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191599 */     GIR_RootConstrainSelectedInstOperands,
     /* 191600 */     // GIR_Coverage, 23462,
     /* 191600 */     GIR_EraseRootFromParent_Done,
     /* 191601 */   // Label 4250: @191601
     /* 191601 */   GIM_Try, /*On fail goto*//*Label 4251*/ GIMT_Encode4(191663), // Rule ID 24089 //
     /* 191606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 191609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 191617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191621 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191624 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191628 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191638 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191645 */     // (umin:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPMINUBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBZ128rm),
     /* 191648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191650 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 191652 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191656 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191661 */     GIR_RootConstrainSelectedInstOperands,
     /* 191662 */     // GIR_Coverage, 24089,
     /* 191662 */     GIR_EraseRootFromParent_Done,
     /* 191663 */   // Label 4251: @191663
     /* 191663 */   GIM_Try, /*On fail goto*//*Label 4252*/ GIMT_Encode4(191725), // Rule ID 2637 //
     /* 191668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 191671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 191683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191687 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191690 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191694 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191700 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191707 */     // (umin:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBrm),
     /* 191710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191712 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 191714 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191718 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191723 */     GIR_RootConstrainSelectedInstOperands,
     /* 191724 */     // GIR_Coverage, 2637,
     /* 191724 */     GIR_EraseRootFromParent_Done,
     /* 191725 */   // Label 4252: @191725
     /* 191725 */   GIM_Try, /*On fail goto*//*Label 4253*/ GIMT_Encode4(191787), // Rule ID 5611 //
     /* 191730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 191733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 191745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191749 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191752 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191756 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191762 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191769 */     // (umin:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBZ128rm),
     /* 191772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191774 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 191776 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191780 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191785 */     GIR_RootConstrainSelectedInstOperands,
     /* 191786 */     // GIR_Coverage, 5611,
     /* 191786 */     GIR_EraseRootFromParent_Done,
     /* 191787 */   // Label 4253: @191787
     /* 191787 */   GIM_Try, /*On fail goto*//*Label 4254*/ GIMT_Encode4(191814), // Rule ID 2636 //
     /* 191792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 191795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191799 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191807 */     // (umin:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPMINUBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 191807 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUBrr),
     /* 191812 */     GIR_RootConstrainSelectedInstOperands,
     /* 191813 */     // GIR_Coverage, 2636,
     /* 191813 */     GIR_Done,
     /* 191814 */   // Label 4254: @191814
     /* 191814 */   GIM_Try, /*On fail goto*//*Label 4255*/ GIMT_Encode4(191841), // Rule ID 2638 //
     /* 191819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 191822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191826 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191834 */     // (umin:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PMINUBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 191834 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMINUBrr),
     /* 191839 */     GIR_RootConstrainSelectedInstOperands,
     /* 191840 */     // GIR_Coverage, 2638,
     /* 191840 */     GIR_Done,
     /* 191841 */   // Label 4255: @191841
     /* 191841 */   GIM_Try, /*On fail goto*//*Label 4256*/ GIMT_Encode4(191868), // Rule ID 5608 //
     /* 191846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 191849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191861 */     // (umin:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPMINUBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 191861 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUBZ128rr),
     /* 191866 */     GIR_RootConstrainSelectedInstOperands,
     /* 191867 */     // GIR_Coverage, 5608,
     /* 191867 */     GIR_Done,
     /* 191868 */   // Label 4256: @191868
     /* 191868 */   GIM_Reject,
     /* 191869 */ // Label 4249: @191869
     /* 191869 */ GIM_Reject,
     /* 191870 */ // Label 4206: @191870
     /* 191870 */ GIM_Try, /*On fail goto*//*Label 4257*/ GIMT_Encode4(192184),
     /* 191875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 191878 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 191881 */   GIM_Try, /*On fail goto*//*Label 4258*/ GIMT_Encode4(191943), // Rule ID 23516 //
     /* 191886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 191889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 191897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191901 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191904 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191908 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191916 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191918 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191925 */     // (umin:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPMINUWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWYrm),
     /* 191928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191930 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 191932 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191936 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191941 */     GIR_RootConstrainSelectedInstOperands,
     /* 191942 */     // GIR_Coverage, 23516,
     /* 191942 */     GIR_EraseRootFromParent_Done,
     /* 191943 */   // Label 4258: @191943
     /* 191943 */   GIM_Try, /*On fail goto*//*Label 4259*/ GIMT_Encode4(192005), // Rule ID 24095 //
     /* 191948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 191951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 191955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 191959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191963 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191966 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191970 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 191978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191980 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191987 */     // (umin:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPMINUWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWZ256rm),
     /* 191990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191992 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 191994 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191998 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192003 */     GIR_RootConstrainSelectedInstOperands,
     /* 192004 */     // GIR_Coverage, 24095,
     /* 192004 */     GIR_EraseRootFromParent_Done,
     /* 192005 */   // Label 4259: @192005
     /* 192005 */   GIM_Try, /*On fail goto*//*Label 4260*/ GIMT_Encode4(192067), // Rule ID 3216 //
     /* 192010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 192013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 192025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192029 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192032 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192036 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192040 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192042 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192049 */     // (umin:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWYrm),
     /* 192052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192054 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 192056 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192060 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192065 */     GIR_RootConstrainSelectedInstOperands,
     /* 192066 */     // GIR_Coverage, 3216,
     /* 192066 */     GIR_EraseRootFromParent_Done,
     /* 192067 */   // Label 4260: @192067
     /* 192067 */   GIM_Try, /*On fail goto*//*Label 4261*/ GIMT_Encode4(192129), // Rule ID 5623 //
     /* 192072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 192075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 192087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192091 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192094 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192098 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192104 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192111 */     // (umin:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWZ256rm),
     /* 192114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192116 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 192118 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192122 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192127 */     GIR_RootConstrainSelectedInstOperands,
     /* 192128 */     // GIR_Coverage, 5623,
     /* 192128 */     GIR_EraseRootFromParent_Done,
     /* 192129 */   // Label 4261: @192129
     /* 192129 */   GIM_Try, /*On fail goto*//*Label 4262*/ GIMT_Encode4(192156), // Rule ID 3215 //
     /* 192134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 192137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192149 */     // (umin:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMINUWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 192149 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUWYrr),
     /* 192154 */     GIR_RootConstrainSelectedInstOperands,
     /* 192155 */     // GIR_Coverage, 3215,
     /* 192155 */     GIR_Done,
     /* 192156 */   // Label 4262: @192156
     /* 192156 */   GIM_Try, /*On fail goto*//*Label 4263*/ GIMT_Encode4(192183), // Rule ID 5620 //
     /* 192161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 192164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192176 */     // (umin:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMINUWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 192176 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUWZ256rr),
     /* 192181 */     GIR_RootConstrainSelectedInstOperands,
     /* 192182 */     // GIR_Coverage, 5620,
     /* 192182 */     GIR_Done,
     /* 192183 */   // Label 4263: @192183
     /* 192183 */   GIM_Reject,
     /* 192184 */ // Label 4257: @192184
     /* 192184 */ GIM_Reject,
     /* 192185 */ // Label 4207: @192185
     /* 192185 */ GIM_Try, /*On fail goto*//*Label 4264*/ GIMT_Encode4(192340),
     /* 192190 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 192193 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 192196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192200 */   GIM_Try, /*On fail goto*//*Label 4265*/ GIMT_Encode4(192258), // Rule ID 24101 //
     /* 192205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 192208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 192212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192216 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192219 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192223 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192233 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192240 */     // (umin:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16i32] }:$src1)  =>  (VPMINUDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDZrm),
     /* 192243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192245 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 192247 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192251 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192256 */     GIR_RootConstrainSelectedInstOperands,
     /* 192257 */     // GIR_Coverage, 24101,
     /* 192257 */     GIR_EraseRootFromParent_Done,
     /* 192258 */   // Label 4265: @192258
     /* 192258 */   GIM_Try, /*On fail goto*//*Label 4266*/ GIMT_Encode4(192316), // Rule ID 5635 //
     /* 192263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 192266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 192274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192278 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192281 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192285 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192291 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192298 */     // (umin:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDZrm),
     /* 192301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192303 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 192305 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192309 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192314 */     GIR_RootConstrainSelectedInstOperands,
     /* 192315 */     // GIR_Coverage, 5635,
     /* 192315 */     GIR_EraseRootFromParent_Done,
     /* 192316 */   // Label 4266: @192316
     /* 192316 */   GIM_Try, /*On fail goto*//*Label 4267*/ GIMT_Encode4(192339), // Rule ID 5632 //
     /* 192321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 192324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192332 */     // (umin:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPMINUDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 192332 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUDZrr),
     /* 192337 */     GIR_RootConstrainSelectedInstOperands,
     /* 192338 */     // GIR_Coverage, 5632,
     /* 192338 */     GIR_Done,
     /* 192339 */   // Label 4267: @192339
     /* 192339 */   GIM_Reject,
     /* 192340 */ // Label 4264: @192340
     /* 192340 */ GIM_Reject,
     /* 192341 */ // Label 4208: @192341
     /* 192341 */ GIM_Try, /*On fail goto*//*Label 4268*/ GIMT_Encode4(192655),
     /* 192346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 192349 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 192352 */   GIM_Try, /*On fail goto*//*Label 4269*/ GIMT_Encode4(192414), // Rule ID 23464 //
     /* 192357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 192360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 192368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192372 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192375 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192379 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192389 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192396 */     // (umin:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPMINUBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBYrm),
     /* 192399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192401 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 192403 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192407 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192412 */     GIR_RootConstrainSelectedInstOperands,
     /* 192413 */     // GIR_Coverage, 23464,
     /* 192413 */     GIR_EraseRootFromParent_Done,
     /* 192414 */   // Label 4269: @192414
     /* 192414 */   GIM_Try, /*On fail goto*//*Label 4270*/ GIMT_Encode4(192476), // Rule ID 24086 //
     /* 192419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 192422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 192430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192434 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192437 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192441 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192449 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192451 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192458 */     // (umin:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPMINUBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBZ256rm),
     /* 192461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192463 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 192465 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192469 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192474 */     GIR_RootConstrainSelectedInstOperands,
     /* 192475 */     // GIR_Coverage, 24086,
     /* 192475 */     GIR_EraseRootFromParent_Done,
     /* 192476 */   // Label 4270: @192476
     /* 192476 */   GIM_Try, /*On fail goto*//*Label 4271*/ GIMT_Encode4(192538), // Rule ID 2641 //
     /* 192481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 192484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192488 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 192496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192500 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192503 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192507 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192513 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192520 */     // (umin:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBYrm),
     /* 192523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192525 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 192527 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192531 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192536 */     GIR_RootConstrainSelectedInstOperands,
     /* 192537 */     // GIR_Coverage, 2641,
     /* 192537 */     GIR_EraseRootFromParent_Done,
     /* 192538 */   // Label 4271: @192538
     /* 192538 */   GIM_Try, /*On fail goto*//*Label 4272*/ GIMT_Encode4(192600), // Rule ID 5605 //
     /* 192543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 192546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 192558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192562 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192565 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192569 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192575 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192582 */     // (umin:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBZ256rm),
     /* 192585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192587 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 192589 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192593 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192598 */     GIR_RootConstrainSelectedInstOperands,
     /* 192599 */     // GIR_Coverage, 5605,
     /* 192599 */     GIR_EraseRootFromParent_Done,
     /* 192600 */   // Label 4272: @192600
     /* 192600 */   GIM_Try, /*On fail goto*//*Label 4273*/ GIMT_Encode4(192627), // Rule ID 2640 //
     /* 192605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 192608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192612 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192620 */     // (umin:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPMINUBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 192620 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUBYrr),
     /* 192625 */     GIR_RootConstrainSelectedInstOperands,
     /* 192626 */     // GIR_Coverage, 2640,
     /* 192626 */     GIR_Done,
     /* 192627 */   // Label 4273: @192627
     /* 192627 */   GIM_Try, /*On fail goto*//*Label 4274*/ GIMT_Encode4(192654), // Rule ID 5602 //
     /* 192632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 192635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192647 */     // (umin:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPMINUBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 192647 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUBZ256rr),
     /* 192652 */     GIR_RootConstrainSelectedInstOperands,
     /* 192653 */     // GIR_Coverage, 5602,
     /* 192653 */     GIR_Done,
     /* 192654 */   // Label 4274: @192654
     /* 192654 */   GIM_Reject,
     /* 192655 */ // Label 4268: @192655
     /* 192655 */ GIM_Reject,
     /* 192656 */ // Label 4209: @192656
     /* 192656 */ GIM_Try, /*On fail goto*//*Label 4275*/ GIMT_Encode4(192811),
     /* 192661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 192664 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 192667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192671 */   GIM_Try, /*On fail goto*//*Label 4276*/ GIMT_Encode4(192729), // Rule ID 24092 //
     /* 192676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 192679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 192683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192687 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192690 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192694 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192702 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192704 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192711 */     // (umin:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPMINUWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWZrm),
     /* 192714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192716 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 192718 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192722 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192727 */     GIR_RootConstrainSelectedInstOperands,
     /* 192728 */     // GIR_Coverage, 24092,
     /* 192728 */     GIR_EraseRootFromParent_Done,
     /* 192729 */   // Label 4276: @192729
     /* 192729 */   GIM_Try, /*On fail goto*//*Label 4277*/ GIMT_Encode4(192787), // Rule ID 5617 //
     /* 192734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 192737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 192745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192749 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192752 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192756 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192762 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192769 */     // (umin:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWZrm),
     /* 192772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192774 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 192776 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192780 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192785 */     GIR_RootConstrainSelectedInstOperands,
     /* 192786 */     // GIR_Coverage, 5617,
     /* 192786 */     GIR_EraseRootFromParent_Done,
     /* 192787 */   // Label 4277: @192787
     /* 192787 */   GIM_Try, /*On fail goto*//*Label 4278*/ GIMT_Encode4(192810), // Rule ID 5614 //
     /* 192792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 192795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192803 */     // (umin:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMINUWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 192803 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUWZrr),
     /* 192808 */     GIR_RootConstrainSelectedInstOperands,
     /* 192809 */     // GIR_Coverage, 5614,
     /* 192809 */     GIR_Done,
     /* 192810 */   // Label 4278: @192810
     /* 192810 */   GIM_Reject,
     /* 192811 */ // Label 4275: @192811
     /* 192811 */ GIM_Reject,
     /* 192812 */ // Label 4210: @192812
     /* 192812 */ GIM_Try, /*On fail goto*//*Label 4279*/ GIMT_Encode4(192967),
     /* 192817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 192820 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 192823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192827 */   GIM_Try, /*On fail goto*//*Label 4280*/ GIMT_Encode4(192885), // Rule ID 24083 //
     /* 192832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 192835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 192839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192843 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192846 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192850 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192858 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192860 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192867 */     // (umin:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPMINUBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBZrm),
     /* 192870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192872 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 192874 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192878 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192883 */     GIR_RootConstrainSelectedInstOperands,
     /* 192884 */     // GIR_Coverage, 24083,
     /* 192884 */     GIR_EraseRootFromParent_Done,
     /* 192885 */   // Label 4280: @192885
     /* 192885 */   GIM_Try, /*On fail goto*//*Label 4281*/ GIMT_Encode4(192943), // Rule ID 5599 //
     /* 192890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 192893 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 192901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192905 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192908 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192912 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192916 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192918 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192925 */     // (umin:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBZrm),
     /* 192928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192930 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 192932 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192936 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192941 */     GIR_RootConstrainSelectedInstOperands,
     /* 192942 */     // GIR_Coverage, 5599,
     /* 192942 */     GIR_EraseRootFromParent_Done,
     /* 192943 */   // Label 4281: @192943
     /* 192943 */   GIM_Try, /*On fail goto*//*Label 4282*/ GIMT_Encode4(192966), // Rule ID 5596 //
     /* 192948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 192951 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192959 */     // (umin:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPMINUBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 192959 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUBZrr),
     /* 192964 */     GIR_RootConstrainSelectedInstOperands,
     /* 192965 */     // GIR_Coverage, 5596,
     /* 192965 */     GIR_Done,
     /* 192966 */   // Label 4282: @192966
     /* 192966 */   GIM_Reject,
     /* 192967 */ // Label 4279: @192967
     /* 192967 */ GIM_Reject,
     /* 192968 */ // Label 4211: @192968
     /* 192968 */ GIM_Reject,
     /* 192969 */ // Label 57: @192969
     /* 192969 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 4295*/ GIMT_Encode4(196289),
     /* 192980 */ /*GILLT_v2s64*//*Label 4283*/ GIMT_Encode4(193048), GIMT_Encode4(0),
     /* 192988 */ /*GILLT_v4s32*//*Label 4284*/ GIMT_Encode4(193377),
     /* 192992 */ /*GILLT_v4s64*//*Label 4285*/ GIMT_Encode4(193719), GIMT_Encode4(0),
     /* 193000 */ /*GILLT_v8s16*//*Label 4286*/ GIMT_Encode4(194036),
     /* 193004 */ /*GILLT_v8s32*//*Label 4287*/ GIMT_Encode4(194378),
     /* 193008 */ /*GILLT_v8s64*//*Label 4288*/ GIMT_Encode4(194693), GIMT_Encode4(0),
     /* 193016 */ /*GILLT_v16s8*//*Label 4289*/ GIMT_Encode4(194849),
     /* 193020 */ /*GILLT_v16s16*//*Label 4290*/ GIMT_Encode4(195191),
     /* 193024 */ /*GILLT_v16s32*//*Label 4291*/ GIMT_Encode4(195506), GIMT_Encode4(0),
     /* 193032 */ /*GILLT_v32s8*//*Label 4292*/ GIMT_Encode4(195662),
     /* 193036 */ /*GILLT_v32s16*//*Label 4293*/ GIMT_Encode4(195977), GIMT_Encode4(0),
     /* 193044 */ /*GILLT_v64s8*//*Label 4294*/ GIMT_Encode4(196133),
     /* 193048 */ // Label 4283: @193048
     /* 193048 */ GIM_Try, /*On fail goto*//*Label 4296*/ GIMT_Encode4(193376),
     /* 193053 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 193056 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 193059 */   GIM_Try, /*On fail goto*//*Label 4297*/ GIMT_Encode4(193121), // Rule ID 24023 //
     /* 193064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 193067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 193075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 193079 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 193082 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 193086 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 193090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193094 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 193096 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 193103 */     // (umax:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2i64] }:$src1)  =>  (VPMAXUQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 193103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZ128rm),
     /* 193106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193108 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 193110 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 193114 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 193119 */     GIR_RootConstrainSelectedInstOperands,
     /* 193120 */     // GIR_Coverage, 24023,
     /* 193120 */     GIR_EraseRootFromParent_Done,
     /* 193121 */   // Label 4297: @193121
     /* 193121 */   GIM_Try, /*On fail goto*//*Label 4298*/ GIMT_Encode4(193183), // Rule ID 5500 //
     /* 193126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 193129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 193141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 193145 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 193148 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 193152 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 193156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 193158 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 193165 */     // (umax:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 193165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZ128rm),
     /* 193168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193170 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 193172 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 193176 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 193181 */     GIR_RootConstrainSelectedInstOperands,
     /* 193182 */     // GIR_Coverage, 5500,
     /* 193182 */     GIR_EraseRootFromParent_Done,
     /* 193183 */   // Label 4298: @193183
     /* 193183 */   GIM_Try, /*On fail goto*//*Label 4299*/ GIMT_Encode4(193210), // Rule ID 5497 //
     /* 193188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 193191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193203 */     // (umax:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPMAXUQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 193203 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZ128rr),
     /* 193208 */     GIR_RootConstrainSelectedInstOperands,
     /* 193209 */     // GIR_Coverage, 5497,
     /* 193209 */     GIR_Done,
     /* 193210 */   // Label 4299: @193210
     /* 193210 */   GIM_Try, /*On fail goto*//*Label 4300*/ GIMT_Encode4(193375), // Rule ID 20002 //
     /* 193215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 193218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 193222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193230 */     // (umax:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPMAXUQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 193230 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 193233 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 193237 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 193244 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 193247 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 193251 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193256 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 193259 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 193263 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 193266 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 193271 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 193276 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 193281 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 193284 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 193288 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193293 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 193295 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 193298 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 193302 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193307 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 193310 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 193314 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 193317 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 193322 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 193327 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 193332 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 193335 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZrr),
     /* 193339 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193344 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 193347 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 193350 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 193352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 193355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193357 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 193364 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 193369 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 193374 */     // GIR_Coverage, 20002,
     /* 193374 */     GIR_EraseRootFromParent_Done,
     /* 193375 */   // Label 4300: @193375
     /* 193375 */   GIM_Reject,
     /* 193376 */ // Label 4296: @193376
     /* 193376 */ GIM_Reject,
     /* 193377 */ // Label 4284: @193377
     /* 193377 */ GIM_Try, /*On fail goto*//*Label 4301*/ GIMT_Encode4(193718),
     /* 193382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 193385 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 193388 */   GIM_Try, /*On fail goto*//*Label 4302*/ GIMT_Encode4(193450), // Rule ID 23504 //
     /* 193393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 193396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 193404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 193408 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 193411 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 193415 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 193419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 193425 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 193432 */     // (umax:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1)  =>  (VPMAXUDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 193432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDrm),
     /* 193435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193437 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 193439 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 193443 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 193448 */     GIR_RootConstrainSelectedInstOperands,
     /* 193449 */     // GIR_Coverage, 23504,
     /* 193449 */     GIR_EraseRootFromParent_Done,
     /* 193450 */   // Label 4302: @193450
     /* 193450 */   GIM_Try, /*On fail goto*//*Label 4303*/ GIMT_Encode4(193512), // Rule ID 24005 //
     /* 193455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 193458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 193466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 193470 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 193473 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 193477 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 193481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 193487 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 193494 */     // (umax:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4i32] }:$src1)  =>  (VPMAXUDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 193494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZ128rm),
     /* 193497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193499 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 193501 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 193505 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 193510 */     GIR_RootConstrainSelectedInstOperands,
     /* 193511 */     // GIR_Coverage, 24005,
     /* 193511 */     GIR_EraseRootFromParent_Done,
     /* 193512 */   // Label 4303: @193512
     /* 193512 */   GIM_Try, /*On fail goto*//*Label 4304*/ GIMT_Encode4(193574), // Rule ID 3192 //
     /* 193517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 193520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 193532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 193536 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 193539 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 193543 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 193547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 193549 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 193556 */     // (umax:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 193556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDrm),
     /* 193559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193561 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 193563 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 193567 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 193572 */     GIR_RootConstrainSelectedInstOperands,
     /* 193573 */     // GIR_Coverage, 3192,
     /* 193573 */     GIR_EraseRootFromParent_Done,
     /* 193574 */   // Label 4304: @193574
     /* 193574 */   GIM_Try, /*On fail goto*//*Label 4305*/ GIMT_Encode4(193636), // Rule ID 5473 //
     /* 193579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 193582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 193594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 193598 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 193601 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 193605 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 193609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 193611 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 193618 */     // (umax:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 193618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZ128rm),
     /* 193621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193623 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 193625 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 193629 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 193634 */     GIR_RootConstrainSelectedInstOperands,
     /* 193635 */     // GIR_Coverage, 5473,
     /* 193635 */     GIR_EraseRootFromParent_Done,
     /* 193636 */   // Label 4305: @193636
     /* 193636 */   GIM_Try, /*On fail goto*//*Label 4306*/ GIMT_Encode4(193663), // Rule ID 3191 //
     /* 193641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 193644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193656 */     // (umax:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPMAXUDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 193656 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUDrr),
     /* 193661 */     GIR_RootConstrainSelectedInstOperands,
     /* 193662 */     // GIR_Coverage, 3191,
     /* 193662 */     GIR_Done,
     /* 193663 */   // Label 4306: @193663
     /* 193663 */   GIM_Try, /*On fail goto*//*Label 4307*/ GIMT_Encode4(193690), // Rule ID 3233 //
     /* 193668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 193671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193683 */     // (umax:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PMAXUDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 193683 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMAXUDrr),
     /* 193688 */     GIR_RootConstrainSelectedInstOperands,
     /* 193689 */     // GIR_Coverage, 3233,
     /* 193689 */     GIR_Done,
     /* 193690 */   // Label 4307: @193690
     /* 193690 */   GIM_Try, /*On fail goto*//*Label 4308*/ GIMT_Encode4(193717), // Rule ID 5470 //
     /* 193695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 193698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193710 */     // (umax:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPMAXUDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 193710 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZ128rr),
     /* 193715 */     GIR_RootConstrainSelectedInstOperands,
     /* 193716 */     // GIR_Coverage, 5470,
     /* 193716 */     GIR_Done,
     /* 193717 */   // Label 4308: @193717
     /* 193717 */   GIM_Reject,
     /* 193718 */ // Label 4301: @193718
     /* 193718 */ GIM_Reject,
     /* 193719 */ // Label 4285: @193719
     /* 193719 */ GIM_Try, /*On fail goto*//*Label 4309*/ GIMT_Encode4(194035),
     /* 193724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 193727 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 193730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 193734 */   GIM_Try, /*On fail goto*//*Label 4310*/ GIMT_Encode4(193792), // Rule ID 24017 //
     /* 193739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 193742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 193746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 193750 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 193753 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 193757 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 193761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 193765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 193767 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 193774 */     // (umax:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4i64] }:$src1)  =>  (VPMAXUQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 193774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZ256rm),
     /* 193777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193779 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 193781 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 193785 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 193790 */     GIR_RootConstrainSelectedInstOperands,
     /* 193791 */     // GIR_Coverage, 24017,
     /* 193791 */     GIR_EraseRootFromParent_Done,
     /* 193792 */   // Label 4310: @193792
     /* 193792 */   GIM_Try, /*On fail goto*//*Label 4311*/ GIMT_Encode4(193850), // Rule ID 5491 //
     /* 193797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 193800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 193804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 193808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 193812 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 193815 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 193819 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 193823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 193825 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 193832 */     // (umax:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 193832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZ256rm),
     /* 193835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193837 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 193839 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 193843 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 193848 */     GIR_RootConstrainSelectedInstOperands,
     /* 193849 */     // GIR_Coverage, 5491,
     /* 193849 */     GIR_EraseRootFromParent_Done,
     /* 193850 */   // Label 4311: @193850
     /* 193850 */   GIM_Try, /*On fail goto*//*Label 4312*/ GIMT_Encode4(193873), // Rule ID 5488 //
     /* 193855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 193858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 193862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 193866 */     // (umax:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPMAXUQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 193866 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZ256rr),
     /* 193871 */     GIR_RootConstrainSelectedInstOperands,
     /* 193872 */     // GIR_Coverage, 5488,
     /* 193872 */     GIR_Done,
     /* 193873 */   // Label 4312: @193873
     /* 193873 */   GIM_Try, /*On fail goto*//*Label 4313*/ GIMT_Encode4(194034), // Rule ID 20000 //
     /* 193878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 193881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 193885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 193889 */     // (umax:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPMAXUQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 193889 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 193892 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 193896 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193901 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 193903 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 193906 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 193910 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193915 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 193918 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 193922 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 193925 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 193930 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 193935 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 193940 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 193943 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 193947 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193952 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 193954 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 193957 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 193961 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193966 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 193969 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 193973 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 193976 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 193981 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 193986 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 193991 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 193994 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZrr),
     /* 193998 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194003 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 194006 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 194009 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 194011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 194014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194016 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 194023 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 194028 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 194033 */     // GIR_Coverage, 20000,
     /* 194033 */     GIR_EraseRootFromParent_Done,
     /* 194034 */   // Label 4313: @194034
     /* 194034 */   GIM_Reject,
     /* 194035 */ // Label 4309: @194035
     /* 194035 */ GIM_Reject,
     /* 194036 */ // Label 4286: @194036
     /* 194036 */ GIM_Try, /*On fail goto*//*Label 4314*/ GIMT_Encode4(194377),
     /* 194041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 194044 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 194047 */   GIM_Try, /*On fail goto*//*Label 4315*/ GIMT_Encode4(194109), // Rule ID 23509 //
     /* 194052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 194055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 194059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 194063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194067 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194070 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194074 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 194082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194084 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194091 */     // (umax:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPMAXUWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 194091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWrm),
     /* 194094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194096 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 194098 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 194102 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194107 */     GIR_RootConstrainSelectedInstOperands,
     /* 194108 */     // GIR_Coverage, 23509,
     /* 194108 */     GIR_EraseRootFromParent_Done,
     /* 194109 */   // Label 4315: @194109
     /* 194109 */   GIM_Try, /*On fail goto*//*Label 4316*/ GIMT_Encode4(194171), // Rule ID 23990 //
     /* 194114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 194117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 194121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 194125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194129 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194132 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194136 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 194144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194146 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194153 */     // (umax:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPMAXUWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 194153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZ128rm),
     /* 194156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194158 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 194160 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 194164 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194169 */     GIR_RootConstrainSelectedInstOperands,
     /* 194170 */     // GIR_Coverage, 23990,
     /* 194170 */     GIR_EraseRootFromParent_Done,
     /* 194171 */   // Label 4316: @194171
     /* 194171 */   GIM_Try, /*On fail goto*//*Label 4317*/ GIMT_Encode4(194233), // Rule ID 3202 //
     /* 194176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 194179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 194183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 194187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 194191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194195 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194198 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194202 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194206 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194208 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194215 */     // (umax:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 194215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWrm),
     /* 194218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194220 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 194222 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 194226 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194231 */     GIR_RootConstrainSelectedInstOperands,
     /* 194232 */     // GIR_Coverage, 3202,
     /* 194232 */     GIR_EraseRootFromParent_Done,
     /* 194233 */   // Label 4317: @194233
     /* 194233 */   GIM_Try, /*On fail goto*//*Label 4318*/ GIMT_Encode4(194295), // Rule ID 5449 //
     /* 194238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 194241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 194245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 194249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 194253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194257 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194260 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194264 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194270 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194277 */     // (umax:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 194277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZ128rm),
     /* 194280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194282 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 194284 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 194288 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194293 */     GIR_RootConstrainSelectedInstOperands,
     /* 194294 */     // GIR_Coverage, 5449,
     /* 194294 */     GIR_EraseRootFromParent_Done,
     /* 194295 */   // Label 4318: @194295
     /* 194295 */   GIM_Try, /*On fail goto*//*Label 4319*/ GIMT_Encode4(194322), // Rule ID 3201 //
     /* 194300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 194303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 194307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 194311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 194315 */     // (umax:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMAXUWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 194315 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUWrr),
     /* 194320 */     GIR_RootConstrainSelectedInstOperands,
     /* 194321 */     // GIR_Coverage, 3201,
     /* 194321 */     GIR_Done,
     /* 194322 */   // Label 4319: @194322
     /* 194322 */   GIM_Try, /*On fail goto*//*Label 4320*/ GIMT_Encode4(194349), // Rule ID 3235 //
     /* 194327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 194330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 194334 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 194338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 194342 */     // (umax:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMAXUWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 194342 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMAXUWrr),
     /* 194347 */     GIR_RootConstrainSelectedInstOperands,
     /* 194348 */     // GIR_Coverage, 3235,
     /* 194348 */     GIR_Done,
     /* 194349 */   // Label 4320: @194349
     /* 194349 */   GIM_Try, /*On fail goto*//*Label 4321*/ GIMT_Encode4(194376), // Rule ID 5446 //
     /* 194354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 194357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 194361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 194365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 194369 */     // (umax:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMAXUWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 194369 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZ128rr),
     /* 194374 */     GIR_RootConstrainSelectedInstOperands,
     /* 194375 */     // GIR_Coverage, 5446,
     /* 194375 */     GIR_Done,
     /* 194376 */   // Label 4321: @194376
     /* 194376 */   GIM_Reject,
     /* 194377 */ // Label 4314: @194377
     /* 194377 */ GIM_Reject,
     /* 194378 */ // Label 4287: @194378
     /* 194378 */ GIM_Try, /*On fail goto*//*Label 4322*/ GIMT_Encode4(194692),
     /* 194383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 194386 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 194389 */   GIM_Try, /*On fail goto*//*Label 4323*/ GIMT_Encode4(194451), // Rule ID 23513 //
     /* 194394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 194397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 194401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 194405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194409 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194412 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194416 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 194424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194426 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194433 */     // (umax:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VPMAXUDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 194433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDYrm),
     /* 194436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194438 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 194440 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 194444 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194449 */     GIR_RootConstrainSelectedInstOperands,
     /* 194450 */     // GIR_Coverage, 23513,
     /* 194450 */     GIR_EraseRootFromParent_Done,
     /* 194451 */   // Label 4323: @194451
     /* 194451 */   GIM_Try, /*On fail goto*//*Label 4324*/ GIMT_Encode4(194513), // Rule ID 23999 //
     /* 194456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 194459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 194463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 194467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194471 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194474 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194478 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 194486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194488 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194495 */     // (umax:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8i32] }:$src1)  =>  (VPMAXUDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 194495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZ256rm),
     /* 194498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194500 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 194502 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 194506 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194511 */     GIR_RootConstrainSelectedInstOperands,
     /* 194512 */     // GIR_Coverage, 23999,
     /* 194512 */     GIR_EraseRootFromParent_Done,
     /* 194513 */   // Label 4324: @194513
     /* 194513 */   GIM_Try, /*On fail goto*//*Label 4325*/ GIMT_Encode4(194575), // Rule ID 3210 //
     /* 194518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 194521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 194525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 194529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 194533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194537 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194540 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194544 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194550 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194557 */     // (umax:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 194557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDYrm),
     /* 194560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194562 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 194564 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 194568 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194573 */     GIR_RootConstrainSelectedInstOperands,
     /* 194574 */     // GIR_Coverage, 3210,
     /* 194574 */     GIR_EraseRootFromParent_Done,
     /* 194575 */   // Label 4325: @194575
     /* 194575 */   GIM_Try, /*On fail goto*//*Label 4326*/ GIMT_Encode4(194637), // Rule ID 5464 //
     /* 194580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 194583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 194587 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 194591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 194595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194599 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194602 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194606 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194612 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194619 */     // (umax:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 194619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZ256rm),
     /* 194622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194624 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 194626 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 194630 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194635 */     GIR_RootConstrainSelectedInstOperands,
     /* 194636 */     // GIR_Coverage, 5464,
     /* 194636 */     GIR_EraseRootFromParent_Done,
     /* 194637 */   // Label 4326: @194637
     /* 194637 */   GIM_Try, /*On fail goto*//*Label 4327*/ GIMT_Encode4(194664), // Rule ID 3209 //
     /* 194642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 194645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 194649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 194653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 194657 */     // (umax:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPMAXUDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 194657 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUDYrr),
     /* 194662 */     GIR_RootConstrainSelectedInstOperands,
     /* 194663 */     // GIR_Coverage, 3209,
     /* 194663 */     GIR_Done,
     /* 194664 */   // Label 4327: @194664
     /* 194664 */   GIM_Try, /*On fail goto*//*Label 4328*/ GIMT_Encode4(194691), // Rule ID 5461 //
     /* 194669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 194672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 194676 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 194680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 194684 */     // (umax:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPMAXUDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 194684 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZ256rr),
     /* 194689 */     GIR_RootConstrainSelectedInstOperands,
     /* 194690 */     // GIR_Coverage, 5461,
     /* 194690 */     GIR_Done,
     /* 194691 */   // Label 4328: @194691
     /* 194691 */   GIM_Reject,
     /* 194692 */ // Label 4322: @194692
     /* 194692 */ GIM_Reject,
     /* 194693 */ // Label 4288: @194693
     /* 194693 */ GIM_Try, /*On fail goto*//*Label 4329*/ GIMT_Encode4(194848),
     /* 194698 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 194701 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 194704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 194708 */   GIM_Try, /*On fail goto*//*Label 4330*/ GIMT_Encode4(194766), // Rule ID 24011 //
     /* 194713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 194716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 194720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194724 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194727 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194731 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 194739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194741 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194748 */     // (umax:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8i64] }:$src1)  =>  (VPMAXUQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 194748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZrm),
     /* 194751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194753 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 194755 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 194759 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194764 */     GIR_RootConstrainSelectedInstOperands,
     /* 194765 */     // GIR_Coverage, 24011,
     /* 194765 */     GIR_EraseRootFromParent_Done,
     /* 194766 */   // Label 4330: @194766
     /* 194766 */   GIM_Try, /*On fail goto*//*Label 4331*/ GIMT_Encode4(194824), // Rule ID 5482 //
     /* 194771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 194774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 194778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 194782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194786 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194789 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194793 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194799 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194806 */     // (umax:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 194806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZrm),
     /* 194809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194811 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 194813 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 194817 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194822 */     GIR_RootConstrainSelectedInstOperands,
     /* 194823 */     // GIR_Coverage, 5482,
     /* 194823 */     GIR_EraseRootFromParent_Done,
     /* 194824 */   // Label 4331: @194824
     /* 194824 */   GIM_Try, /*On fail goto*//*Label 4332*/ GIMT_Encode4(194847), // Rule ID 5479 //
     /* 194829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 194832 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 194836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 194840 */     // (umax:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPMAXUQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 194840 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZrr),
     /* 194845 */     GIR_RootConstrainSelectedInstOperands,
     /* 194846 */     // GIR_Coverage, 5479,
     /* 194846 */     GIR_Done,
     /* 194847 */   // Label 4332: @194847
     /* 194847 */   GIM_Reject,
     /* 194848 */ // Label 4329: @194848
     /* 194848 */ GIM_Reject,
     /* 194849 */ // Label 4289: @194849
     /* 194849 */ GIM_Try, /*On fail goto*//*Label 4333*/ GIMT_Encode4(195190),
     /* 194854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 194857 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 194860 */   GIM_Try, /*On fail goto*//*Label 4334*/ GIMT_Encode4(194922), // Rule ID 23468 //
     /* 194865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 194868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 194872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 194876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194880 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194883 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194887 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 194895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194897 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194904 */     // (umax:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPMAXUBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 194904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBrm),
     /* 194907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194909 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 194911 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 194915 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194920 */     GIR_RootConstrainSelectedInstOperands,
     /* 194921 */     // GIR_Coverage, 23468,
     /* 194921 */     GIR_EraseRootFromParent_Done,
     /* 194922 */   // Label 4334: @194922
     /* 194922 */   GIM_Try, /*On fail goto*//*Label 4335*/ GIMT_Encode4(194984), // Rule ID 23981 //
     /* 194927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 194930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 194934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 194938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194942 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194945 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194949 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 194957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194959 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194966 */     // (umax:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPMAXUBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 194966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZ128rm),
     /* 194969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194971 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 194973 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 194977 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194982 */     GIR_RootConstrainSelectedInstOperands,
     /* 194983 */     // GIR_Coverage, 23981,
     /* 194983 */     GIR_EraseRootFromParent_Done,
     /* 194984 */   // Label 4335: @194984
     /* 194984 */   GIM_Try, /*On fail goto*//*Label 4336*/ GIMT_Encode4(195046), // Rule ID 2649 //
     /* 194989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 194992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 194996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 195000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 195004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 195008 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 195011 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 195015 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 195019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 195021 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 195028 */     // (umax:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 195028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBrm),
     /* 195031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195033 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 195035 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 195039 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 195044 */     GIR_RootConstrainSelectedInstOperands,
     /* 195045 */     // GIR_Coverage, 2649,
     /* 195045 */     GIR_EraseRootFromParent_Done,
     /* 195046 */   // Label 4336: @195046
     /* 195046 */   GIM_Try, /*On fail goto*//*Label 4337*/ GIMT_Encode4(195108), // Rule ID 5431 //
     /* 195051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 195054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 195058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 195062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 195066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 195070 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 195073 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 195077 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 195081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 195083 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 195090 */     // (umax:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 195090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZ128rm),
     /* 195093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195095 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 195097 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 195101 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 195106 */     GIR_RootConstrainSelectedInstOperands,
     /* 195107 */     // GIR_Coverage, 5431,
     /* 195107 */     GIR_EraseRootFromParent_Done,
     /* 195108 */   // Label 4337: @195108
     /* 195108 */   GIM_Try, /*On fail goto*//*Label 4338*/ GIMT_Encode4(195135), // Rule ID 2648 //
     /* 195113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 195116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 195120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 195124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 195128 */     // (umax:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPMAXUBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 195128 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUBrr),
     /* 195133 */     GIR_RootConstrainSelectedInstOperands,
     /* 195134 */     // GIR_Coverage, 2648,
     /* 195134 */     GIR_Done,
     /* 195135 */   // Label 4338: @195135
     /* 195135 */   GIM_Try, /*On fail goto*//*Label 4339*/ GIMT_Encode4(195162), // Rule ID 2650 //
     /* 195140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 195143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 195147 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 195151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 195155 */     // (umax:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PMAXUBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 195155 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMAXUBrr),
     /* 195160 */     GIR_RootConstrainSelectedInstOperands,
     /* 195161 */     // GIR_Coverage, 2650,
     /* 195161 */     GIR_Done,
     /* 195162 */   // Label 4339: @195162
     /* 195162 */   GIM_Try, /*On fail goto*//*Label 4340*/ GIMT_Encode4(195189), // Rule ID 5428 //
     /* 195167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 195170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 195174 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 195178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 195182 */     // (umax:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPMAXUBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 195182 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZ128rr),
     /* 195187 */     GIR_RootConstrainSelectedInstOperands,
     /* 195188 */     // GIR_Coverage, 5428,
     /* 195188 */     GIR_Done,
     /* 195189 */   // Label 4340: @195189
     /* 195189 */   GIM_Reject,
     /* 195190 */ // Label 4333: @195190
     /* 195190 */ GIM_Reject,
     /* 195191 */ // Label 4290: @195191
     /* 195191 */ GIM_Try, /*On fail goto*//*Label 4341*/ GIMT_Encode4(195505),
     /* 195196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 195199 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 195202 */   GIM_Try, /*On fail goto*//*Label 4342*/ GIMT_Encode4(195264), // Rule ID 23518 //
     /* 195207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 195210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 195214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 195218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 195222 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 195225 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 195229 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 195233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 195237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 195239 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 195246 */     // (umax:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPMAXUWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 195246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWYrm),
     /* 195249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195251 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 195253 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 195257 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 195262 */     GIR_RootConstrainSelectedInstOperands,
     /* 195263 */     // GIR_Coverage, 23518,
     /* 195263 */     GIR_EraseRootFromParent_Done,
     /* 195264 */   // Label 4342: @195264
     /* 195264 */   GIM_Try, /*On fail goto*//*Label 4343*/ GIMT_Encode4(195326), // Rule ID 23987 //
     /* 195269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 195272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 195276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 195280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 195284 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 195287 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 195291 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 195295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 195299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 195301 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 195308 */     // (umax:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPMAXUWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 195308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZ256rm),
     /* 195311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195313 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 195315 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 195319 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 195324 */     GIR_RootConstrainSelectedInstOperands,
     /* 195325 */     // GIR_Coverage, 23987,
     /* 195325 */     GIR_EraseRootFromParent_Done,
     /* 195326 */   // Label 4343: @195326
     /* 195326 */   GIM_Try, /*On fail goto*//*Label 4344*/ GIMT_Encode4(195388), // Rule ID 3220 //
     /* 195331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 195334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 195338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 195342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 195346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 195350 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 195353 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 195357 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 195361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 195363 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 195370 */     // (umax:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 195370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWYrm),
     /* 195373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195375 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 195377 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 195381 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 195386 */     GIR_RootConstrainSelectedInstOperands,
     /* 195387 */     // GIR_Coverage, 3220,
     /* 195387 */     GIR_EraseRootFromParent_Done,
     /* 195388 */   // Label 4344: @195388
     /* 195388 */   GIM_Try, /*On fail goto*//*Label 4345*/ GIMT_Encode4(195450), // Rule ID 5443 //
     /* 195393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 195396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 195400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 195404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 195408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 195412 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 195415 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 195419 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 195423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 195425 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 195432 */     // (umax:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 195432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZ256rm),
     /* 195435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195437 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 195439 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 195443 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 195448 */     GIR_RootConstrainSelectedInstOperands,
     /* 195449 */     // GIR_Coverage, 5443,
     /* 195449 */     GIR_EraseRootFromParent_Done,
     /* 195450 */   // Label 4345: @195450
     /* 195450 */   GIM_Try, /*On fail goto*//*Label 4346*/ GIMT_Encode4(195477), // Rule ID 3219 //
     /* 195455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 195458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 195462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 195466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 195470 */     // (umax:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMAXUWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 195470 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUWYrr),
     /* 195475 */     GIR_RootConstrainSelectedInstOperands,
     /* 195476 */     // GIR_Coverage, 3219,
     /* 195476 */     GIR_Done,
     /* 195477 */   // Label 4346: @195477
     /* 195477 */   GIM_Try, /*On fail goto*//*Label 4347*/ GIMT_Encode4(195504), // Rule ID 5440 //
     /* 195482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 195485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 195489 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 195493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 195497 */     // (umax:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMAXUWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 195497 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZ256rr),
     /* 195502 */     GIR_RootConstrainSelectedInstOperands,
     /* 195503 */     // GIR_Coverage, 5440,
     /* 195503 */     GIR_Done,
     /* 195504 */   // Label 4347: @195504
     /* 195504 */   GIM_Reject,
     /* 195505 */ // Label 4341: @195505
     /* 195505 */ GIM_Reject,
     /* 195506 */ // Label 4291: @195506
     /* 195506 */ GIM_Try, /*On fail goto*//*Label 4348*/ GIMT_Encode4(195661),
     /* 195511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 195514 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 195517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 195521 */   GIM_Try, /*On fail goto*//*Label 4349*/ GIMT_Encode4(195579), // Rule ID 23993 //
     /* 195526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 195529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 195533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 195537 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 195540 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 195544 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 195548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 195552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 195554 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 195561 */     // (umax:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16i32] }:$src1)  =>  (VPMAXUDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 195561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZrm),
     /* 195564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195566 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 195568 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 195572 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 195577 */     GIR_RootConstrainSelectedInstOperands,
     /* 195578 */     // GIR_Coverage, 23993,
     /* 195578 */     GIR_EraseRootFromParent_Done,
     /* 195579 */   // Label 4349: @195579
     /* 195579 */   GIM_Try, /*On fail goto*//*Label 4350*/ GIMT_Encode4(195637), // Rule ID 5455 //
     /* 195584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 195587 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 195591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 195595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 195599 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 195602 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 195606 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 195610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 195612 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 195619 */     // (umax:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 195619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZrm),
     /* 195622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195624 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 195626 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 195630 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 195635 */     GIR_RootConstrainSelectedInstOperands,
     /* 195636 */     // GIR_Coverage, 5455,
     /* 195636 */     GIR_EraseRootFromParent_Done,
     /* 195637 */   // Label 4350: @195637
     /* 195637 */   GIM_Try, /*On fail goto*//*Label 4351*/ GIMT_Encode4(195660), // Rule ID 5452 //
     /* 195642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 195645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 195649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 195653 */     // (umax:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPMAXUDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 195653 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZrr),
     /* 195658 */     GIR_RootConstrainSelectedInstOperands,
     /* 195659 */     // GIR_Coverage, 5452,
     /* 195659 */     GIR_Done,
     /* 195660 */   // Label 4351: @195660
     /* 195660 */   GIM_Reject,
     /* 195661 */ // Label 4348: @195661
     /* 195661 */ GIM_Reject,
     /* 195662 */ // Label 4292: @195662
     /* 195662 */ GIM_Try, /*On fail goto*//*Label 4352*/ GIMT_Encode4(195976),
     /* 195667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 195670 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 195673 */   GIM_Try, /*On fail goto*//*Label 4353*/ GIMT_Encode4(195735), // Rule ID 23470 //
     /* 195678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 195681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 195685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 195689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 195693 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 195696 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 195700 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 195704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 195708 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 195710 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 195717 */     // (umax:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPMAXUBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 195717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBYrm),
     /* 195720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195722 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 195724 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 195728 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 195733 */     GIR_RootConstrainSelectedInstOperands,
     /* 195734 */     // GIR_Coverage, 23470,
     /* 195734 */     GIR_EraseRootFromParent_Done,
     /* 195735 */   // Label 4353: @195735
     /* 195735 */   GIM_Try, /*On fail goto*//*Label 4354*/ GIMT_Encode4(195797), // Rule ID 23978 //
     /* 195740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 195743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 195747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 195751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 195755 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 195758 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 195762 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 195766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 195770 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 195772 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 195779 */     // (umax:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPMAXUBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 195779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZ256rm),
     /* 195782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195784 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 195786 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 195790 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 195795 */     GIR_RootConstrainSelectedInstOperands,
     /* 195796 */     // GIR_Coverage, 23978,
     /* 195796 */     GIR_EraseRootFromParent_Done,
     /* 195797 */   // Label 4354: @195797
     /* 195797 */   GIM_Try, /*On fail goto*//*Label 4355*/ GIMT_Encode4(195859), // Rule ID 2653 //
     /* 195802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 195805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 195809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 195813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 195817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 195821 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 195824 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 195828 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 195832 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 195834 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 195841 */     // (umax:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 195841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBYrm),
     /* 195844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195846 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 195848 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 195852 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 195857 */     GIR_RootConstrainSelectedInstOperands,
     /* 195858 */     // GIR_Coverage, 2653,
     /* 195858 */     GIR_EraseRootFromParent_Done,
     /* 195859 */   // Label 4355: @195859
     /* 195859 */   GIM_Try, /*On fail goto*//*Label 4356*/ GIMT_Encode4(195921), // Rule ID 5425 //
     /* 195864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 195867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 195871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 195875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 195879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 195883 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 195886 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 195890 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 195894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 195896 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 195903 */     // (umax:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 195903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZ256rm),
     /* 195906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195908 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 195910 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 195914 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 195919 */     GIR_RootConstrainSelectedInstOperands,
     /* 195920 */     // GIR_Coverage, 5425,
     /* 195920 */     GIR_EraseRootFromParent_Done,
     /* 195921 */   // Label 4356: @195921
     /* 195921 */   GIM_Try, /*On fail goto*//*Label 4357*/ GIMT_Encode4(195948), // Rule ID 2652 //
     /* 195926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 195929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 195933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 195937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 195941 */     // (umax:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPMAXUBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 195941 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUBYrr),
     /* 195946 */     GIR_RootConstrainSelectedInstOperands,
     /* 195947 */     // GIR_Coverage, 2652,
     /* 195947 */     GIR_Done,
     /* 195948 */   // Label 4357: @195948
     /* 195948 */   GIM_Try, /*On fail goto*//*Label 4358*/ GIMT_Encode4(195975), // Rule ID 5422 //
     /* 195953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 195956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 195960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 195964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 195968 */     // (umax:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPMAXUBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 195968 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZ256rr),
     /* 195973 */     GIR_RootConstrainSelectedInstOperands,
     /* 195974 */     // GIR_Coverage, 5422,
     /* 195974 */     GIR_Done,
     /* 195975 */   // Label 4358: @195975
     /* 195975 */   GIM_Reject,
     /* 195976 */ // Label 4352: @195976
     /* 195976 */ GIM_Reject,
     /* 195977 */ // Label 4293: @195977
     /* 195977 */ GIM_Try, /*On fail goto*//*Label 4359*/ GIMT_Encode4(196132),
     /* 195982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 195985 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 195988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 195992 */   GIM_Try, /*On fail goto*//*Label 4360*/ GIMT_Encode4(196050), // Rule ID 23984 //
     /* 195997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 196000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 196004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 196008 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 196011 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 196015 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 196019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 196025 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 196032 */     // (umax:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPMAXUWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 196032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZrm),
     /* 196035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196037 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 196039 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 196043 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 196048 */     GIR_RootConstrainSelectedInstOperands,
     /* 196049 */     // GIR_Coverage, 23984,
     /* 196049 */     GIR_EraseRootFromParent_Done,
     /* 196050 */   // Label 4360: @196050
     /* 196050 */   GIM_Try, /*On fail goto*//*Label 4361*/ GIMT_Encode4(196108), // Rule ID 5437 //
     /* 196055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 196058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 196066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 196070 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 196073 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 196077 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 196081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 196083 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 196090 */     // (umax:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 196090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZrm),
     /* 196093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196095 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 196097 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 196101 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 196106 */     GIR_RootConstrainSelectedInstOperands,
     /* 196107 */     // GIR_Coverage, 5437,
     /* 196107 */     GIR_EraseRootFromParent_Done,
     /* 196108 */   // Label 4361: @196108
     /* 196108 */   GIM_Try, /*On fail goto*//*Label 4362*/ GIMT_Encode4(196131), // Rule ID 5434 //
     /* 196113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 196116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196124 */     // (umax:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMAXUWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 196124 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZrr),
     /* 196129 */     GIR_RootConstrainSelectedInstOperands,
     /* 196130 */     // GIR_Coverage, 5434,
     /* 196130 */     GIR_Done,
     /* 196131 */   // Label 4362: @196131
     /* 196131 */   GIM_Reject,
     /* 196132 */ // Label 4359: @196132
     /* 196132 */ GIM_Reject,
     /* 196133 */ // Label 4294: @196133
     /* 196133 */ GIM_Try, /*On fail goto*//*Label 4363*/ GIMT_Encode4(196288),
     /* 196138 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 196141 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 196144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196148 */   GIM_Try, /*On fail goto*//*Label 4364*/ GIMT_Encode4(196206), // Rule ID 23975 //
     /* 196153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 196156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 196160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 196164 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 196167 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 196171 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 196175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 196181 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 196188 */     // (umax:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPMAXUBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 196188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZrm),
     /* 196191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196193 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 196195 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 196199 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 196204 */     GIR_RootConstrainSelectedInstOperands,
     /* 196205 */     // GIR_Coverage, 23975,
     /* 196205 */     GIR_EraseRootFromParent_Done,
     /* 196206 */   // Label 4364: @196206
     /* 196206 */   GIM_Try, /*On fail goto*//*Label 4365*/ GIMT_Encode4(196264), // Rule ID 5419 //
     /* 196211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 196214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 196222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 196226 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 196229 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 196233 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 196237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 196239 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 196246 */     // (umax:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 196246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZrm),
     /* 196249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196251 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 196253 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 196257 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 196262 */     GIR_RootConstrainSelectedInstOperands,
     /* 196263 */     // GIR_Coverage, 5419,
     /* 196263 */     GIR_EraseRootFromParent_Done,
     /* 196264 */   // Label 4365: @196264
     /* 196264 */   GIM_Try, /*On fail goto*//*Label 4366*/ GIMT_Encode4(196287), // Rule ID 5416 //
     /* 196269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 196272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196280 */     // (umax:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPMAXUBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 196280 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZrr),
     /* 196285 */     GIR_RootConstrainSelectedInstOperands,
     /* 196286 */     // GIR_Coverage, 5416,
     /* 196286 */     GIR_Done,
     /* 196287 */   // Label 4366: @196287
     /* 196287 */   GIM_Reject,
     /* 196288 */ // Label 4363: @196288
     /* 196288 */ GIM_Reject,
     /* 196289 */ // Label 4295: @196289
     /* 196289 */ GIM_Reject,
     /* 196290 */ // Label 58: @196290
     /* 196290 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 4379*/ GIMT_Encode4(198170),
     /* 196301 */ /*GILLT_v2s64*//*Label 4367*/ GIMT_Encode4(196369), GIMT_Encode4(0),
     /* 196309 */ /*GILLT_v4s32*//*Label 4368*/ GIMT_Encode4(196565),
     /* 196313 */ /*GILLT_v4s64*//*Label 4369*/ GIMT_Encode4(196756), GIMT_Encode4(0),
     /* 196321 */ /*GILLT_v8s16*//*Label 4370*/ GIMT_Encode4(196944),
     /* 196325 */ /*GILLT_v8s32*//*Label 4371*/ GIMT_Encode4(197135),
     /* 196329 */ /*GILLT_v8s64*//*Label 4372*/ GIMT_Encode4(197303), GIMT_Encode4(0),
     /* 196337 */ /*GILLT_v16s8*//*Label 4373*/ GIMT_Encode4(197388),
     /* 196341 */ /*GILLT_v16s16*//*Label 4374*/ GIMT_Encode4(197579),
     /* 196345 */ /*GILLT_v16s32*//*Label 4375*/ GIMT_Encode4(197747), GIMT_Encode4(0),
     /* 196353 */ /*GILLT_v32s8*//*Label 4376*/ GIMT_Encode4(197832),
     /* 196357 */ /*GILLT_v32s16*//*Label 4377*/ GIMT_Encode4(198000), GIMT_Encode4(0),
     /* 196365 */ /*GILLT_v64s8*//*Label 4378*/ GIMT_Encode4(198085),
     /* 196369 */ // Label 4367: @196369
     /* 196369 */ GIM_Try, /*On fail goto*//*Label 4380*/ GIMT_Encode4(196564),
     /* 196374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 196377 */   GIM_Try, /*On fail goto*//*Label 4381*/ GIMT_Encode4(196433), // Rule ID 13267 //
     /* 196382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 196385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 196389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 196393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 196397 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 196400 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 196404 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 196408 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 196410 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 196417 */     // (abs:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSQZ128rm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)
     /* 196417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSQZ128rm),
     /* 196420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196422 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 196426 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 196431 */     GIR_RootConstrainSelectedInstOperands,
     /* 196432 */     // GIR_Coverage, 13267,
     /* 196432 */     GIR_EraseRootFromParent_Done,
     /* 196433 */   // Label 4381: @196433
     /* 196433 */   GIM_Try, /*On fail goto*//*Label 4382*/ GIMT_Encode4(196456), // Rule ID 13264 //
     /* 196438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 196441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 196445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 196449 */     // (abs:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)  =>  (VPABSQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)
     /* 196449 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSQZ128rr),
     /* 196454 */     GIR_RootConstrainSelectedInstOperands,
     /* 196455 */     // GIR_Coverage, 13264,
     /* 196455 */     GIR_Done,
     /* 196456 */   // Label 4382: @196456
     /* 196456 */   GIM_Try, /*On fail goto*//*Label 4383*/ GIMT_Encode4(196563), // Rule ID 21824 //
     /* 196461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 196464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 196468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 196472 */     // (abs:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPABSQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 196472 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 196475 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 196479 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 196486 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 196489 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 196493 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196498 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 196501 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 196505 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 196508 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 196513 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 196518 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 196523 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 196526 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPABSQZrr),
     /* 196530 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196535 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 196538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 196540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196545 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 196552 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 196557 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 196562 */     // GIR_Coverage, 21824,
     /* 196562 */     GIR_EraseRootFromParent_Done,
     /* 196563 */   // Label 4383: @196563
     /* 196563 */   GIM_Reject,
     /* 196564 */ // Label 4380: @196564
     /* 196564 */ GIM_Reject,
     /* 196565 */ // Label 4368: @196565
     /* 196565 */ GIM_Try, /*On fail goto*//*Label 4384*/ GIMT_Encode4(196755),
     /* 196570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 196573 */   GIM_Try, /*On fail goto*//*Label 4385*/ GIMT_Encode4(196629), // Rule ID 2995 //
     /* 196578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 196581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 196585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 196589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 196593 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 196596 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 196600 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 196604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 196606 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 196613 */     // (abs:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSDrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /* 196613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSDrm),
     /* 196616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196618 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 196622 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 196627 */     GIR_RootConstrainSelectedInstOperands,
     /* 196628 */     // GIR_Coverage, 2995,
     /* 196628 */     GIR_EraseRootFromParent_Done,
     /* 196629 */   // Label 4385: @196629
     /* 196629 */   GIM_Try, /*On fail goto*//*Label 4386*/ GIMT_Encode4(196685), // Rule ID 13294 //
     /* 196634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 196637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 196641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 196645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 196649 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 196652 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 196656 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 196660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 196662 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 196669 */     // (abs:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSDZ128rm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src1)
     /* 196669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSDZ128rm),
     /* 196672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196674 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 196678 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 196683 */     GIR_RootConstrainSelectedInstOperands,
     /* 196684 */     // GIR_Coverage, 13294,
     /* 196684 */     GIR_EraseRootFromParent_Done,
     /* 196685 */   // Label 4386: @196685
     /* 196685 */   GIM_Try, /*On fail goto*//*Label 4387*/ GIMT_Encode4(196708), // Rule ID 2994 //
     /* 196690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 196693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 196697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 196701 */     // (abs:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src)  =>  (VPABSDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src)
     /* 196701 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSDrr),
     /* 196706 */     GIR_RootConstrainSelectedInstOperands,
     /* 196707 */     // GIR_Coverage, 2994,
     /* 196707 */     GIR_Done,
     /* 196708 */   // Label 4387: @196708
     /* 196708 */   GIM_Try, /*On fail goto*//*Label 4388*/ GIMT_Encode4(196731), // Rule ID 3006 //
     /* 196713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /* 196716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 196720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 196724 */     // (abs:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src)  =>  (PABSDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src)
     /* 196724 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PABSDrr),
     /* 196729 */     GIR_RootConstrainSelectedInstOperands,
     /* 196730 */     // GIR_Coverage, 3006,
     /* 196730 */     GIR_Done,
     /* 196731 */   // Label 4388: @196731
     /* 196731 */   GIM_Try, /*On fail goto*//*Label 4389*/ GIMT_Encode4(196754), // Rule ID 13291 //
     /* 196736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 196739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 196743 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 196747 */     // (abs:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)  =>  (VPABSDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)
     /* 196747 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSDZ128rr),
     /* 196752 */     GIR_RootConstrainSelectedInstOperands,
     /* 196753 */     // GIR_Coverage, 13291,
     /* 196753 */     GIR_Done,
     /* 196754 */   // Label 4389: @196754
     /* 196754 */   GIM_Reject,
     /* 196755 */ // Label 4384: @196755
     /* 196755 */ GIM_Reject,
     /* 196756 */ // Label 4369: @196756
     /* 196756 */ GIM_Try, /*On fail goto*//*Label 4390*/ GIMT_Encode4(196943),
     /* 196761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 196764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 196768 */   GIM_Try, /*On fail goto*//*Label 4391*/ GIMT_Encode4(196820), // Rule ID 13258 //
     /* 196773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 196776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 196780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 196784 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 196787 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 196791 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 196795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 196797 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 196804 */     // (abs:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSQZ256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src1)
     /* 196804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSQZ256rm),
     /* 196807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196809 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 196813 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 196818 */     GIR_RootConstrainSelectedInstOperands,
     /* 196819 */     // GIR_Coverage, 13258,
     /* 196819 */     GIR_EraseRootFromParent_Done,
     /* 196820 */   // Label 4391: @196820
     /* 196820 */   GIM_Try, /*On fail goto*//*Label 4392*/ GIMT_Encode4(196839), // Rule ID 13255 //
     /* 196825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 196828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 196832 */     // (abs:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)  =>  (VPABSQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)
     /* 196832 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSQZ256rr),
     /* 196837 */     GIR_RootConstrainSelectedInstOperands,
     /* 196838 */     // GIR_Coverage, 13255,
     /* 196838 */     GIR_Done,
     /* 196839 */   // Label 4392: @196839
     /* 196839 */   GIM_Try, /*On fail goto*//*Label 4393*/ GIMT_Encode4(196942), // Rule ID 21823 //
     /* 196844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 196847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 196851 */     // (abs:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPABSQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 196851 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 196854 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 196858 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196863 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 196865 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 196868 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 196872 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196877 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 196880 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 196884 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 196887 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 196892 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 196897 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 196902 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 196905 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPABSQZrr),
     /* 196909 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196914 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 196917 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 196919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196924 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 196931 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 196936 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 196941 */     // GIR_Coverage, 21823,
     /* 196941 */     GIR_EraseRootFromParent_Done,
     /* 196942 */   // Label 4393: @196942
     /* 196942 */   GIM_Reject,
     /* 196943 */ // Label 4390: @196943
     /* 196943 */ GIM_Reject,
     /* 196944 */ // Label 4370: @196944
     /* 196944 */ GIM_Try, /*On fail goto*//*Label 4394*/ GIMT_Encode4(197134),
     /* 196949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 196952 */   GIM_Try, /*On fail goto*//*Label 4395*/ GIMT_Encode4(197008), // Rule ID 2993 //
     /* 196957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 196960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 196964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 196968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 196972 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 196975 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 196979 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 196983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 196985 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 196992 */     // (abs:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSWrm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /* 196992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSWrm),
     /* 196995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196997 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 197001 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 197006 */     GIR_RootConstrainSelectedInstOperands,
     /* 197007 */     // GIR_Coverage, 2993,
     /* 197007 */     GIR_EraseRootFromParent_Done,
     /* 197008 */   // Label 4395: @197008
     /* 197008 */   GIM_Try, /*On fail goto*//*Label 4396*/ GIMT_Encode4(197064), // Rule ID 13315 //
     /* 197013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 197016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 197020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 197024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 197028 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 197031 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 197035 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 197039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 197041 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 197048 */     // (abs:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSWZ128rm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src1)
     /* 197048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSWZ128rm),
     /* 197051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197053 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 197057 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 197062 */     GIR_RootConstrainSelectedInstOperands,
     /* 197063 */     // GIR_Coverage, 13315,
     /* 197063 */     GIR_EraseRootFromParent_Done,
     /* 197064 */   // Label 4396: @197064
     /* 197064 */   GIM_Try, /*On fail goto*//*Label 4397*/ GIMT_Encode4(197087), // Rule ID 2992 //
     /* 197069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 197072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 197076 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 197080 */     // (abs:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src)  =>  (VPABSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src)
     /* 197080 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSWrr),
     /* 197085 */     GIR_RootConstrainSelectedInstOperands,
     /* 197086 */     // GIR_Coverage, 2992,
     /* 197086 */     GIR_Done,
     /* 197087 */   // Label 4397: @197087
     /* 197087 */   GIM_Try, /*On fail goto*//*Label 4398*/ GIMT_Encode4(197110), // Rule ID 3004 //
     /* 197092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /* 197095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 197099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 197103 */     // (abs:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src)  =>  (PABSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src)
     /* 197103 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PABSWrr),
     /* 197108 */     GIR_RootConstrainSelectedInstOperands,
     /* 197109 */     // GIR_Coverage, 3004,
     /* 197109 */     GIR_Done,
     /* 197110 */   // Label 4398: @197110
     /* 197110 */   GIM_Try, /*On fail goto*//*Label 4399*/ GIMT_Encode4(197133), // Rule ID 13312 //
     /* 197115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 197118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 197122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 197126 */     // (abs:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1)  =>  (VPABSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1)
     /* 197126 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSWZ128rr),
     /* 197131 */     GIR_RootConstrainSelectedInstOperands,
     /* 197132 */     // GIR_Coverage, 13312,
     /* 197132 */     GIR_Done,
     /* 197133 */   // Label 4399: @197133
     /* 197133 */   GIM_Reject,
     /* 197134 */ // Label 4394: @197134
     /* 197134 */ GIM_Reject,
     /* 197135 */ // Label 4371: @197135
     /* 197135 */ GIM_Try, /*On fail goto*//*Label 4400*/ GIMT_Encode4(197302),
     /* 197140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 197143 */   GIM_Try, /*On fail goto*//*Label 4401*/ GIMT_Encode4(197199), // Rule ID 3001 //
     /* 197148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 197151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 197155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 197159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 197163 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 197166 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 197170 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 197174 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 197176 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 197183 */     // (abs:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSDYrm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /* 197183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSDYrm),
     /* 197186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197188 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 197192 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 197197 */     GIR_RootConstrainSelectedInstOperands,
     /* 197198 */     // GIR_Coverage, 3001,
     /* 197198 */     GIR_EraseRootFromParent_Done,
     /* 197199 */   // Label 4401: @197199
     /* 197199 */   GIM_Try, /*On fail goto*//*Label 4402*/ GIMT_Encode4(197255), // Rule ID 13285 //
     /* 197204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 197207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 197211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 197215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 197219 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 197222 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 197226 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 197230 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 197232 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 197239 */     // (abs:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSDZ256rm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src1)
     /* 197239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSDZ256rm),
     /* 197242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197244 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 197248 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 197253 */     GIR_RootConstrainSelectedInstOperands,
     /* 197254 */     // GIR_Coverage, 13285,
     /* 197254 */     GIR_EraseRootFromParent_Done,
     /* 197255 */   // Label 4402: @197255
     /* 197255 */   GIM_Try, /*On fail goto*//*Label 4403*/ GIMT_Encode4(197278), // Rule ID 3000 //
     /* 197260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 197263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 197267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 197271 */     // (abs:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src)  =>  (VPABSDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src)
     /* 197271 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSDYrr),
     /* 197276 */     GIR_RootConstrainSelectedInstOperands,
     /* 197277 */     // GIR_Coverage, 3000,
     /* 197277 */     GIR_Done,
     /* 197278 */   // Label 4403: @197278
     /* 197278 */   GIM_Try, /*On fail goto*//*Label 4404*/ GIMT_Encode4(197301), // Rule ID 13282 //
     /* 197283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 197286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 197290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 197294 */     // (abs:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)  =>  (VPABSDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)
     /* 197294 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSDZ256rr),
     /* 197299 */     GIR_RootConstrainSelectedInstOperands,
     /* 197300 */     // GIR_Coverage, 13282,
     /* 197300 */     GIR_Done,
     /* 197301 */   // Label 4404: @197301
     /* 197301 */   GIM_Reject,
     /* 197302 */ // Label 4400: @197302
     /* 197302 */ GIM_Reject,
     /* 197303 */ // Label 4372: @197303
     /* 197303 */ GIM_Try, /*On fail goto*//*Label 4405*/ GIMT_Encode4(197387),
     /* 197308 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 197311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 197315 */   GIM_Try, /*On fail goto*//*Label 4406*/ GIMT_Encode4(197367), // Rule ID 13249 //
     /* 197320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 197323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 197327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 197331 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 197334 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 197338 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 197342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 197344 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 197351 */     // (abs:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src1)
     /* 197351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSQZrm),
     /* 197354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197356 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 197360 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 197365 */     GIR_RootConstrainSelectedInstOperands,
     /* 197366 */     // GIR_Coverage, 13249,
     /* 197366 */     GIR_EraseRootFromParent_Done,
     /* 197367 */   // Label 4406: @197367
     /* 197367 */   GIM_Try, /*On fail goto*//*Label 4407*/ GIMT_Encode4(197386), // Rule ID 13246 //
     /* 197372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 197375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 197379 */     // (abs:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1)  =>  (VPABSQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1)
     /* 197379 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSQZrr),
     /* 197384 */     GIR_RootConstrainSelectedInstOperands,
     /* 197385 */     // GIR_Coverage, 13246,
     /* 197385 */     GIR_Done,
     /* 197386 */   // Label 4407: @197386
     /* 197386 */   GIM_Reject,
     /* 197387 */ // Label 4405: @197387
     /* 197387 */ GIM_Reject,
     /* 197388 */ // Label 4373: @197388
     /* 197388 */ GIM_Try, /*On fail goto*//*Label 4408*/ GIMT_Encode4(197578),
     /* 197393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 197396 */   GIM_Try, /*On fail goto*//*Label 4409*/ GIMT_Encode4(197452), // Rule ID 2991 //
     /* 197401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 197404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 197408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 197412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 197416 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 197419 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 197423 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 197427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 197429 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 197436 */     // (abs:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSBrm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /* 197436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSBrm),
     /* 197439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197441 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 197445 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 197450 */     GIR_RootConstrainSelectedInstOperands,
     /* 197451 */     // GIR_Coverage, 2991,
     /* 197451 */     GIR_EraseRootFromParent_Done,
     /* 197452 */   // Label 4409: @197452
     /* 197452 */   GIM_Try, /*On fail goto*//*Label 4410*/ GIMT_Encode4(197508), // Rule ID 13333 //
     /* 197457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 197460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 197464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 197468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 197472 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 197475 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 197479 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 197483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 197485 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 197492 */     // (abs:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSBZ128rm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src1)
     /* 197492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSBZ128rm),
     /* 197495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197497 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 197501 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 197506 */     GIR_RootConstrainSelectedInstOperands,
     /* 197507 */     // GIR_Coverage, 13333,
     /* 197507 */     GIR_EraseRootFromParent_Done,
     /* 197508 */   // Label 4410: @197508
     /* 197508 */   GIM_Try, /*On fail goto*//*Label 4411*/ GIMT_Encode4(197531), // Rule ID 2990 //
     /* 197513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 197516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 197520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 197524 */     // (abs:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src)  =>  (VPABSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src)
     /* 197524 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSBrr),
     /* 197529 */     GIR_RootConstrainSelectedInstOperands,
     /* 197530 */     // GIR_Coverage, 2990,
     /* 197530 */     GIR_Done,
     /* 197531 */   // Label 4411: @197531
     /* 197531 */   GIM_Try, /*On fail goto*//*Label 4412*/ GIMT_Encode4(197554), // Rule ID 3002 //
     /* 197536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /* 197539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 197543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 197547 */     // (abs:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src)  =>  (PABSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src)
     /* 197547 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PABSBrr),
     /* 197552 */     GIR_RootConstrainSelectedInstOperands,
     /* 197553 */     // GIR_Coverage, 3002,
     /* 197553 */     GIR_Done,
     /* 197554 */   // Label 4412: @197554
     /* 197554 */   GIM_Try, /*On fail goto*//*Label 4413*/ GIMT_Encode4(197577), // Rule ID 13330 //
     /* 197559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 197562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 197566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 197570 */     // (abs:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1)  =>  (VPABSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1)
     /* 197570 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSBZ128rr),
     /* 197575 */     GIR_RootConstrainSelectedInstOperands,
     /* 197576 */     // GIR_Coverage, 13330,
     /* 197576 */     GIR_Done,
     /* 197577 */   // Label 4413: @197577
     /* 197577 */   GIM_Reject,
     /* 197578 */ // Label 4408: @197578
     /* 197578 */ GIM_Reject,
     /* 197579 */ // Label 4374: @197579
     /* 197579 */ GIM_Try, /*On fail goto*//*Label 4414*/ GIMT_Encode4(197746),
     /* 197584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 197587 */   GIM_Try, /*On fail goto*//*Label 4415*/ GIMT_Encode4(197643), // Rule ID 2999 //
     /* 197592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 197595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 197599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 197603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 197607 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 197610 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 197614 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 197618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 197620 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 197627 */     // (abs:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSWYrm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /* 197627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSWYrm),
     /* 197630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197632 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 197636 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 197641 */     GIR_RootConstrainSelectedInstOperands,
     /* 197642 */     // GIR_Coverage, 2999,
     /* 197642 */     GIR_EraseRootFromParent_Done,
     /* 197643 */   // Label 4415: @197643
     /* 197643 */   GIM_Try, /*On fail goto*//*Label 4416*/ GIMT_Encode4(197699), // Rule ID 13309 //
     /* 197648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 197651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 197655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 197659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 197663 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 197666 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 197670 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 197674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 197676 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 197683 */     // (abs:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSWZ256rm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src1)
     /* 197683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSWZ256rm),
     /* 197686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197688 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 197692 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 197697 */     GIR_RootConstrainSelectedInstOperands,
     /* 197698 */     // GIR_Coverage, 13309,
     /* 197698 */     GIR_EraseRootFromParent_Done,
     /* 197699 */   // Label 4416: @197699
     /* 197699 */   GIM_Try, /*On fail goto*//*Label 4417*/ GIMT_Encode4(197722), // Rule ID 2998 //
     /* 197704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 197707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 197711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 197715 */     // (abs:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src)  =>  (VPABSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src)
     /* 197715 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSWYrr),
     /* 197720 */     GIR_RootConstrainSelectedInstOperands,
     /* 197721 */     // GIR_Coverage, 2998,
     /* 197721 */     GIR_Done,
     /* 197722 */   // Label 4417: @197722
     /* 197722 */   GIM_Try, /*On fail goto*//*Label 4418*/ GIMT_Encode4(197745), // Rule ID 13306 //
     /* 197727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 197730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 197734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 197738 */     // (abs:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1)  =>  (VPABSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1)
     /* 197738 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSWZ256rr),
     /* 197743 */     GIR_RootConstrainSelectedInstOperands,
     /* 197744 */     // GIR_Coverage, 13306,
     /* 197744 */     GIR_Done,
     /* 197745 */   // Label 4418: @197745
     /* 197745 */   GIM_Reject,
     /* 197746 */ // Label 4414: @197746
     /* 197746 */ GIM_Reject,
     /* 197747 */ // Label 4375: @197747
     /* 197747 */ GIM_Try, /*On fail goto*//*Label 4419*/ GIMT_Encode4(197831),
     /* 197752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 197755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 197759 */   GIM_Try, /*On fail goto*//*Label 4420*/ GIMT_Encode4(197811), // Rule ID 13276 //
     /* 197764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 197767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 197771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 197775 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 197778 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 197782 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 197786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 197788 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 197795 */     // (abs:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSDZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src1)
     /* 197795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSDZrm),
     /* 197798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197800 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 197804 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 197809 */     GIR_RootConstrainSelectedInstOperands,
     /* 197810 */     // GIR_Coverage, 13276,
     /* 197810 */     GIR_EraseRootFromParent_Done,
     /* 197811 */   // Label 4420: @197811
     /* 197811 */   GIM_Try, /*On fail goto*//*Label 4421*/ GIMT_Encode4(197830), // Rule ID 13273 //
     /* 197816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 197819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 197823 */     // (abs:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1)  =>  (VPABSDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1)
     /* 197823 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSDZrr),
     /* 197828 */     GIR_RootConstrainSelectedInstOperands,
     /* 197829 */     // GIR_Coverage, 13273,
     /* 197829 */     GIR_Done,
     /* 197830 */   // Label 4421: @197830
     /* 197830 */   GIM_Reject,
     /* 197831 */ // Label 4419: @197831
     /* 197831 */ GIM_Reject,
     /* 197832 */ // Label 4376: @197832
     /* 197832 */ GIM_Try, /*On fail goto*//*Label 4422*/ GIMT_Encode4(197999),
     /* 197837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 197840 */   GIM_Try, /*On fail goto*//*Label 4423*/ GIMT_Encode4(197896), // Rule ID 2997 //
     /* 197845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 197848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 197852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 197856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 197860 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 197863 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 197867 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 197871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 197873 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 197880 */     // (abs:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSBYrm:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)
     /* 197880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSBYrm),
     /* 197883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197885 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 197889 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 197894 */     GIR_RootConstrainSelectedInstOperands,
     /* 197895 */     // GIR_Coverage, 2997,
     /* 197895 */     GIR_EraseRootFromParent_Done,
     /* 197896 */   // Label 4423: @197896
     /* 197896 */   GIM_Try, /*On fail goto*//*Label 4424*/ GIMT_Encode4(197952), // Rule ID 13327 //
     /* 197901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 197904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 197908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 197912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 197916 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 197919 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 197923 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 197927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 197929 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 197936 */     // (abs:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSBZ256rm:{ *:[v32i8] } addr:{ *:[iPTR] }:$src1)
     /* 197936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSBZ256rm),
     /* 197939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197941 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 197945 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 197950 */     GIR_RootConstrainSelectedInstOperands,
     /* 197951 */     // GIR_Coverage, 13327,
     /* 197951 */     GIR_EraseRootFromParent_Done,
     /* 197952 */   // Label 4424: @197952
     /* 197952 */   GIM_Try, /*On fail goto*//*Label 4425*/ GIMT_Encode4(197975), // Rule ID 2996 //
     /* 197957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 197960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 197964 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 197968 */     // (abs:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src)  =>  (VPABSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src)
     /* 197968 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSBYrr),
     /* 197973 */     GIR_RootConstrainSelectedInstOperands,
     /* 197974 */     // GIR_Coverage, 2996,
     /* 197974 */     GIR_Done,
     /* 197975 */   // Label 4425: @197975
     /* 197975 */   GIM_Try, /*On fail goto*//*Label 4426*/ GIMT_Encode4(197998), // Rule ID 13324 //
     /* 197980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 197983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 197987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 197991 */     // (abs:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1)  =>  (VPABSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1)
     /* 197991 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSBZ256rr),
     /* 197996 */     GIR_RootConstrainSelectedInstOperands,
     /* 197997 */     // GIR_Coverage, 13324,
     /* 197997 */     GIR_Done,
     /* 197998 */   // Label 4426: @197998
     /* 197998 */   GIM_Reject,
     /* 197999 */ // Label 4422: @197999
     /* 197999 */ GIM_Reject,
     /* 198000 */ // Label 4377: @198000
     /* 198000 */ GIM_Try, /*On fail goto*//*Label 4427*/ GIMT_Encode4(198084),
     /* 198005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 198008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 198012 */   GIM_Try, /*On fail goto*//*Label 4428*/ GIMT_Encode4(198064), // Rule ID 13303 //
     /* 198017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 198020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 198024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 198028 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 198031 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 198035 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 198039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198041 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 198048 */     // (abs:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSWZrm:{ *:[v32i16] } addr:{ *:[iPTR] }:$src1)
     /* 198048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSWZrm),
     /* 198051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198053 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 198057 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 198062 */     GIR_RootConstrainSelectedInstOperands,
     /* 198063 */     // GIR_Coverage, 13303,
     /* 198063 */     GIR_EraseRootFromParent_Done,
     /* 198064 */   // Label 4428: @198064
     /* 198064 */   GIM_Try, /*On fail goto*//*Label 4429*/ GIMT_Encode4(198083), // Rule ID 13300 //
     /* 198069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 198072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 198076 */     // (abs:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1)  =>  (VPABSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1)
     /* 198076 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSWZrr),
     /* 198081 */     GIR_RootConstrainSelectedInstOperands,
     /* 198082 */     // GIR_Coverage, 13300,
     /* 198082 */     GIR_Done,
     /* 198083 */   // Label 4429: @198083
     /* 198083 */   GIM_Reject,
     /* 198084 */ // Label 4427: @198084
     /* 198084 */ GIM_Reject,
     /* 198085 */ // Label 4378: @198085
     /* 198085 */ GIM_Try, /*On fail goto*//*Label 4430*/ GIMT_Encode4(198169),
     /* 198090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 198093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 198097 */   GIM_Try, /*On fail goto*//*Label 4431*/ GIMT_Encode4(198149), // Rule ID 13321 //
     /* 198102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 198105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 198109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 198113 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 198116 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 198120 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 198124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198126 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 198133 */     // (abs:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSBZrm:{ *:[v64i8] } addr:{ *:[iPTR] }:$src1)
     /* 198133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSBZrm),
     /* 198136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198138 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 198142 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 198147 */     GIR_RootConstrainSelectedInstOperands,
     /* 198148 */     // GIR_Coverage, 13321,
     /* 198148 */     GIR_EraseRootFromParent_Done,
     /* 198149 */   // Label 4431: @198149
     /* 198149 */   GIM_Try, /*On fail goto*//*Label 4432*/ GIMT_Encode4(198168), // Rule ID 13318 //
     /* 198154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 198157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 198161 */     // (abs:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1)  =>  (VPABSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1)
     /* 198161 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSBZrr),
     /* 198166 */     GIR_RootConstrainSelectedInstOperands,
     /* 198167 */     // GIR_Coverage, 13318,
     /* 198167 */     GIR_Done,
     /* 198168 */   // Label 4432: @198168
     /* 198168 */   GIM_Reject,
     /* 198169 */ // Label 4430: @198169
     /* 198169 */ GIM_Reject,
     /* 198170 */ // Label 4379: @198170
     /* 198170 */ GIM_Reject,
     /* 198171 */ // Label 59: @198171
     /* 198171 */ GIM_Try, /*On fail goto*//*Label 4433*/ GIMT_Encode4(198186), // Rule ID 630 //
     /* 198176 */   // MIs[0] dst
     /* 198176 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 198179 */   // (br (bb:{ *:[Other] }):$dst)  =>  (JMP_1 (bb:{ *:[Other] }):$dst)
     /* 198179 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::JMP_1),
     /* 198184 */   GIR_RootConstrainSelectedInstOperands,
     /* 198185 */   // GIR_Coverage, 630,
     /* 198185 */   GIR_Done,
     /* 198186 */ // Label 4433: @198186
     /* 198186 */ GIM_Reject,
     /* 198187 */ // Label 60: @198187
     /* 198187 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(22), /*)*//*default:*//*Label 4448*/ GIMT_Encode4(201115),
     /* 198198 */ /*GILLT_s1*//*Label 4434*/ GIMT_Encode4(198286), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 198226 */ /*GILLT_v2s1*//*Label 4435*/ GIMT_Encode4(198527),
     /* 198230 */ /*GILLT_v2s64*//*Label 4436*/ GIMT_Encode4(198728),
     /* 198234 */ /*GILLT_v4s1*//*Label 4437*/ GIMT_Encode4(199209),
     /* 198238 */ /*GILLT_v4s32*//*Label 4438*/ GIMT_Encode4(199370),
     /* 198242 */ /*GILLT_v4s64*//*Label 4439*/ GIMT_Encode4(199851),
     /* 198246 */ /*GILLT_v8s1*//*Label 4440*/ GIMT_Encode4(199934),
     /* 198250 */ /*GILLT_v8s16*//*Label 4441*/ GIMT_Encode4(200055),
     /* 198254 */ /*GILLT_v8s32*//*Label 4442*/ GIMT_Encode4(200536), GIMT_Encode4(0),
     /* 198262 */ /*GILLT_v16s1*//*Label 4443*/ GIMT_Encode4(200619),
     /* 198266 */ /*GILLT_v16s8*//*Label 4444*/ GIMT_Encode4(200700),
     /* 198270 */ /*GILLT_v16s16*//*Label 4445*/ GIMT_Encode4(200941), GIMT_Encode4(0),
     /* 198278 */ /*GILLT_v32s1*//*Label 4446*/ GIMT_Encode4(201024),
     /* 198282 */ /*GILLT_v32s8*//*Label 4447*/ GIMT_Encode4(201065),
     /* 198286 */ // Label 4434: @198286
     /* 198286 */ GIM_Try, /*On fail goto*//*Label 4449*/ GIMT_Encode4(198326), // Rule ID 19602 //
     /* 198291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /* 198294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 198298 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 198302 */   // MIs[0] Operand 2
     /* 198302 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 198313 */   // (extract_subvector:{ *:[v1i1] } VK2:{ *:[v2i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } VK2:{ *:[v2i1] }:$src, VK1:{ *:[i32] })
     /* 198313 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 198316 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198318 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198320 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 198325 */   // GIR_Coverage, 19602,
     /* 198325 */   GIR_EraseRootFromParent_Done,
     /* 198326 */ // Label 4449: @198326
     /* 198326 */ GIM_Try, /*On fail goto*//*Label 4450*/ GIMT_Encode4(198366), // Rule ID 19604 //
     /* 198331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 198334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 198338 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 198342 */   // MIs[0] Operand 2
     /* 198342 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 198353 */   // (extract_subvector:{ *:[v1i1] } VK4:{ *:[v4i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } VK4:{ *:[v4i1] }:$src, VK1:{ *:[i32] })
     /* 198353 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 198356 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198358 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198360 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 198365 */   // GIR_Coverage, 19604,
     /* 198365 */   GIR_EraseRootFromParent_Done,
     /* 198366 */ // Label 4450: @198366
     /* 198366 */ GIM_Try, /*On fail goto*//*Label 4451*/ GIMT_Encode4(198406), // Rule ID 19606 //
     /* 198371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 198374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 198378 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 198382 */   // MIs[0] Operand 2
     /* 198382 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 198393 */   // (extract_subvector:{ *:[v1i1] } VK8:{ *:[v8i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } VK8:{ *:[v8i1] }:$src, VK1:{ *:[i32] })
     /* 198393 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 198396 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198398 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198400 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 198405 */   // GIR_Coverage, 19606,
     /* 198405 */   GIR_EraseRootFromParent_Done,
     /* 198406 */ // Label 4451: @198406
     /* 198406 */ GIM_Try, /*On fail goto*//*Label 4452*/ GIMT_Encode4(198446), // Rule ID 19608 //
     /* 198411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 198414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 198418 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 198422 */   // MIs[0] Operand 2
     /* 198422 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 198433 */   // (extract_subvector:{ *:[v1i1] } VK16:{ *:[v16i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } VK16:{ *:[v16i1] }:$src, VK1:{ *:[i32] })
     /* 198433 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 198436 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198438 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198440 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 198445 */   // GIR_Coverage, 19608,
     /* 198445 */   GIR_EraseRootFromParent_Done,
     /* 198446 */ // Label 4452: @198446
     /* 198446 */ GIM_Try, /*On fail goto*//*Label 4453*/ GIMT_Encode4(198486), // Rule ID 19610 //
     /* 198451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 198454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 198458 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 198462 */   // MIs[0] Operand 2
     /* 198462 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 198473 */   // (extract_subvector:{ *:[v1i1] } VK32:{ *:[v32i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } VK32:{ *:[v32i1] }:$src, VK1:{ *:[i32] })
     /* 198473 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 198476 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198478 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198480 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 198485 */   // GIR_Coverage, 19610,
     /* 198485 */   GIR_EraseRootFromParent_Done,
     /* 198486 */ // Label 4453: @198486
     /* 198486 */ GIM_Try, /*On fail goto*//*Label 4454*/ GIMT_Encode4(198526), // Rule ID 19612 //
     /* 198491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 198494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 198498 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 198502 */   // MIs[0] Operand 2
     /* 198502 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 198513 */   // (extract_subvector:{ *:[v1i1] } VK64:{ *:[v64i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } VK64:{ *:[v64i1] }:$src, VK1:{ *:[i32] })
     /* 198513 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 198516 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198518 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198520 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 198525 */   // GIR_Coverage, 19612,
     /* 198525 */   GIR_EraseRootFromParent_Done,
     /* 198526 */ // Label 4454: @198526
     /* 198526 */ GIM_Reject,
     /* 198527 */ // Label 4435: @198527
     /* 198527 */ GIM_Try, /*On fail goto*//*Label 4455*/ GIMT_Encode4(198567), // Rule ID 19614 //
     /* 198532 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 198535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 198539 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 198543 */   // MIs[0] Operand 2
     /* 198543 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 198554 */   // (extract_subvector:{ *:[v2i1] } VK4:{ *:[v4i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } VK4:{ *:[v4i1] }:$src, VK2:{ *:[i32] })
     /* 198554 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 198557 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198559 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198561 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 198566 */   // GIR_Coverage, 19614,
     /* 198566 */   GIR_EraseRootFromParent_Done,
     /* 198567 */ // Label 4455: @198567
     /* 198567 */ GIM_Try, /*On fail goto*//*Label 4456*/ GIMT_Encode4(198607), // Rule ID 19616 //
     /* 198572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 198575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 198579 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 198583 */   // MIs[0] Operand 2
     /* 198583 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 198594 */   // (extract_subvector:{ *:[v2i1] } VK8:{ *:[v8i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } VK8:{ *:[v8i1] }:$src, VK2:{ *:[i32] })
     /* 198594 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 198597 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198599 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198601 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 198606 */   // GIR_Coverage, 19616,
     /* 198606 */   GIR_EraseRootFromParent_Done,
     /* 198607 */ // Label 4456: @198607
     /* 198607 */ GIM_Try, /*On fail goto*//*Label 4457*/ GIMT_Encode4(198647), // Rule ID 19618 //
     /* 198612 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 198615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 198619 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 198623 */   // MIs[0] Operand 2
     /* 198623 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 198634 */   // (extract_subvector:{ *:[v2i1] } VK16:{ *:[v16i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } VK16:{ *:[v16i1] }:$src, VK2:{ *:[i32] })
     /* 198634 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 198637 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198639 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198641 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 198646 */   // GIR_Coverage, 19618,
     /* 198646 */   GIR_EraseRootFromParent_Done,
     /* 198647 */ // Label 4457: @198647
     /* 198647 */ GIM_Try, /*On fail goto*//*Label 4458*/ GIMT_Encode4(198687), // Rule ID 19620 //
     /* 198652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 198655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 198659 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 198663 */   // MIs[0] Operand 2
     /* 198663 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 198674 */   // (extract_subvector:{ *:[v2i1] } VK32:{ *:[v32i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } VK32:{ *:[v32i1] }:$src, VK2:{ *:[i32] })
     /* 198674 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 198677 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198679 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198681 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 198686 */   // GIR_Coverage, 19620,
     /* 198686 */   GIR_EraseRootFromParent_Done,
     /* 198687 */ // Label 4458: @198687
     /* 198687 */ GIM_Try, /*On fail goto*//*Label 4459*/ GIMT_Encode4(198727), // Rule ID 19622 //
     /* 198692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 198695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 198699 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 198703 */   // MIs[0] Operand 2
     /* 198703 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 198714 */   // (extract_subvector:{ *:[v2i1] } VK64:{ *:[v64i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } VK64:{ *:[v64i1] }:$src, VK2:{ *:[i32] })
     /* 198714 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 198717 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198719 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198721 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 198726 */   // GIR_Coverage, 19622,
     /* 198726 */   GIR_EraseRootFromParent_Done,
     /* 198727 */ // Label 4459: @198727
     /* 198727 */ GIM_Reject,
     /* 198728 */ // Label 4436: @198728
     /* 198728 */ GIM_Try, /*On fail goto*//*Label 4460*/ GIMT_Encode4(198799), // Rule ID 19053 //
     /* 198733 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 198736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 198739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 198743 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 198747 */   // MIs[0] Operand 2
     /* 198747 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 198758 */   // (extract_subvector:{ *:[v2i64] } VR512:{ *:[v8i64] }:$src, 2:{ *:[iPTR] })  =>  (VEXTRACTI128rri:{ *:[v2i64] } (EXTRACT_SUBREG:{ *:[v4i64] } VR512:{ *:[v8i64] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 198758 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /* 198761 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 198765 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198770 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 198776 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 198781 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 198786 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI128rri),
     /* 198789 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198791 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 198794 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198797 */   GIR_RootConstrainSelectedInstOperands,
     /* 198798 */   // GIR_Coverage, 19053,
     /* 198798 */   GIR_EraseRootFromParent_Done,
     /* 198799 */ // Label 4460: @198799
     /* 198799 */ GIM_Try, /*On fail goto*//*Label 4461*/ GIMT_Encode4(198870), // Rule ID 19054 //
     /* 198804 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 198807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 198810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 198814 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 198818 */   // MIs[0] Operand 2
     /* 198818 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 198829 */   // (extract_subvector:{ *:[v2f64] } VR512:{ *:[v8f64] }:$src, 2:{ *:[iPTR] })  =>  (VEXTRACTF128rri:{ *:[v2f64] } (EXTRACT_SUBREG:{ *:[v4f64] } VR512:{ *:[v8f64] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 198829 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /* 198832 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 198836 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198841 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 198847 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 198852 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 198857 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTF128rri),
     /* 198860 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198862 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 198865 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198868 */   GIR_RootConstrainSelectedInstOperands,
     /* 198869 */   // GIR_Coverage, 19054,
     /* 198869 */   GIR_EraseRootFromParent_Done,
     /* 198870 */ // Label 4461: @198870
     /* 198870 */ GIM_Try, /*On fail goto*//*Label 4462*/ GIMT_Encode4(198941), // Rule ID 19060 //
     /* 198875 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 198878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 198881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 198885 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 198889 */   // MIs[0] Operand 2
     /* 198889 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 198900 */   // (extract_subvector:{ *:[v2i64] } VR512:{ *:[v8i64] }:$src, 2:{ *:[iPTR] })  =>  (VEXTRACTI32X4Z256rri:{ *:[v2i64] } (EXTRACT_SUBREG:{ *:[v4i64] } VR512:{ *:[v8i64] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 198900 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /* 198903 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 198907 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198912 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 198918 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 198923 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 198928 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI32X4Z256rri),
     /* 198931 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198933 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 198936 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198939 */   GIR_RootConstrainSelectedInstOperands,
     /* 198940 */   // GIR_Coverage, 19060,
     /* 198940 */   GIR_EraseRootFromParent_Done,
     /* 198941 */ // Label 4462: @198941
     /* 198941 */ GIM_Try, /*On fail goto*//*Label 4463*/ GIMT_Encode4(199012), // Rule ID 19061 //
     /* 198946 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 198949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 198952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 198956 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 198960 */   // MIs[0] Operand 2
     /* 198960 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 198971 */   // (extract_subvector:{ *:[v2f64] } VR512:{ *:[v8f64] }:$src, 2:{ *:[iPTR] })  =>  (VEXTRACTF32X4Z256rri:{ *:[v2f64] } (EXTRACT_SUBREG:{ *:[v4f64] } VR512:{ *:[v8f64] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 198971 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /* 198974 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 198978 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198983 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 198989 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 198994 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 198999 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTF32X4Z256rri),
     /* 199002 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199004 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 199007 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199010 */   GIR_RootConstrainSelectedInstOperands,
     /* 199011 */   // GIR_Coverage, 19061,
     /* 199011 */   GIR_EraseRootFromParent_Done,
     /* 199012 */ // Label 4463: @199012
     /* 199012 */ GIM_Try, /*On fail goto*//*Label 4464*/ GIMT_Encode4(199061), // Rule ID 23007 //
     /* 199017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 199020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 199024 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 199028 */   // MIs[0] Operand 2
     /* 199028 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 199039 */   // (extract_subvector:{ *:[v2i64] } VR256:{ *:[v4i64] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v2i64] } VR256:{ *:[v4i64] }:$src, sub_xmm:{ *:[i32] })
     /* 199039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199042 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199044 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 199050 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 199055 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 199060 */   // GIR_Coverage, 23007,
     /* 199060 */   GIR_EraseRootFromParent_Done,
     /* 199061 */ // Label 4464: @199061
     /* 199061 */ GIM_Try, /*On fail goto*//*Label 4465*/ GIMT_Encode4(199110), // Rule ID 23010 //
     /* 199066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 199069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 199073 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 199077 */   // MIs[0] Operand 2
     /* 199077 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 199088 */   // (extract_subvector:{ *:[v2f64] } VR256:{ *:[v4f64] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v2f64] } VR256:{ *:[v4f64] }:$src, sub_xmm:{ *:[i32] })
     /* 199088 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199091 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199093 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 199099 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 199104 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 199109 */   // GIR_Coverage, 23010,
     /* 199109 */   GIR_EraseRootFromParent_Done,
     /* 199110 */ // Label 4465: @199110
     /* 199110 */ GIM_Try, /*On fail goto*//*Label 4466*/ GIMT_Encode4(199159), // Rule ID 23028 //
     /* 199115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 199118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 199122 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 199126 */   // MIs[0] Operand 2
     /* 199126 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 199137 */   // (extract_subvector:{ *:[v2i64] } VR512:{ *:[v8i64] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v2i64] } VR512:{ *:[v8i64] }:$src, sub_xmm:{ *:[i32] })
     /* 199137 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199140 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199142 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 199148 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 199153 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 199158 */   // GIR_Coverage, 23028,
     /* 199158 */   GIR_EraseRootFromParent_Done,
     /* 199159 */ // Label 4466: @199159
     /* 199159 */ GIM_Try, /*On fail goto*//*Label 4467*/ GIMT_Encode4(199208), // Rule ID 23031 //
     /* 199164 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 199167 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 199171 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 199175 */   // MIs[0] Operand 2
     /* 199175 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 199186 */   // (extract_subvector:{ *:[v2f64] } VR512:{ *:[v8f64] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v2f64] } VR512:{ *:[v8f64] }:$src, sub_xmm:{ *:[i32] })
     /* 199186 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199189 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199191 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 199197 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 199202 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 199207 */   // GIR_Coverage, 23031,
     /* 199207 */   GIR_EraseRootFromParent_Done,
     /* 199208 */ // Label 4467: @199208
     /* 199208 */ GIM_Reject,
     /* 199209 */ // Label 4437: @199209
     /* 199209 */ GIM_Try, /*On fail goto*//*Label 4468*/ GIMT_Encode4(199249), // Rule ID 19624 //
     /* 199214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 199217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 199221 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 199225 */   // MIs[0] Operand 2
     /* 199225 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 199236 */   // (extract_subvector:{ *:[v4i1] } VK8:{ *:[v8i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } VK8:{ *:[v8i1] }:$src, VK4:{ *:[i32] })
     /* 199236 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199239 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199241 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199243 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 199248 */   // GIR_Coverage, 19624,
     /* 199248 */   GIR_EraseRootFromParent_Done,
     /* 199249 */ // Label 4468: @199249
     /* 199249 */ GIM_Try, /*On fail goto*//*Label 4469*/ GIMT_Encode4(199289), // Rule ID 19626 //
     /* 199254 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 199257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 199261 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 199265 */   // MIs[0] Operand 2
     /* 199265 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 199276 */   // (extract_subvector:{ *:[v4i1] } VK16:{ *:[v16i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } VK16:{ *:[v16i1] }:$src, VK4:{ *:[i32] })
     /* 199276 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199279 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199281 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199283 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 199288 */   // GIR_Coverage, 19626,
     /* 199288 */   GIR_EraseRootFromParent_Done,
     /* 199289 */ // Label 4469: @199289
     /* 199289 */ GIM_Try, /*On fail goto*//*Label 4470*/ GIMT_Encode4(199329), // Rule ID 19628 //
     /* 199294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 199297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 199301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 199305 */   // MIs[0] Operand 2
     /* 199305 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 199316 */   // (extract_subvector:{ *:[v4i1] } VK32:{ *:[v32i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } VK32:{ *:[v32i1] }:$src, VK4:{ *:[i32] })
     /* 199316 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199319 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199321 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199323 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 199328 */   // GIR_Coverage, 19628,
     /* 199328 */   GIR_EraseRootFromParent_Done,
     /* 199329 */ // Label 4470: @199329
     /* 199329 */ GIM_Try, /*On fail goto*//*Label 4471*/ GIMT_Encode4(199369), // Rule ID 19630 //
     /* 199334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 199337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 199341 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 199345 */   // MIs[0] Operand 2
     /* 199345 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 199356 */   // (extract_subvector:{ *:[v4i1] } VK64:{ *:[v64i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } VK64:{ *:[v64i1] }:$src, VK4:{ *:[i32] })
     /* 199356 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199359 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199361 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199363 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 199368 */   // GIR_Coverage, 19630,
     /* 199368 */   GIR_EraseRootFromParent_Done,
     /* 199369 */ // Label 4471: @199369
     /* 199369 */ GIM_Reject,
     /* 199370 */ // Label 4438: @199370
     /* 199370 */ GIM_Try, /*On fail goto*//*Label 4472*/ GIMT_Encode4(199441), // Rule ID 19055 //
     /* 199375 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 199378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 199381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 199385 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 199389 */   // MIs[0] Operand 2
     /* 199389 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 199400 */   // (extract_subvector:{ *:[v4i32] } VR512:{ *:[v16i32] }:$src, 4:{ *:[iPTR] })  =>  (VEXTRACTI128rri:{ *:[v4i32] } (EXTRACT_SUBREG:{ *:[v8i32] } VR512:{ *:[v16i32] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 199400 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s32,
     /* 199403 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199407 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199412 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 199418 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 199423 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 199428 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI128rri),
     /* 199431 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199433 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 199436 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199439 */   GIR_RootConstrainSelectedInstOperands,
     /* 199440 */   // GIR_Coverage, 19055,
     /* 199440 */   GIR_EraseRootFromParent_Done,
     /* 199441 */ // Label 4472: @199441
     /* 199441 */ GIM_Try, /*On fail goto*//*Label 4473*/ GIMT_Encode4(199512), // Rule ID 19056 //
     /* 199446 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 199449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 199452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 199456 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 199460 */   // MIs[0] Operand 2
     /* 199460 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 199471 */   // (extract_subvector:{ *:[v4f32] } VR512:{ *:[v16f32] }:$src, 4:{ *:[iPTR] })  =>  (VEXTRACTF128rri:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v8f32] } VR512:{ *:[v16f32] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 199471 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s32,
     /* 199474 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199478 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199483 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 199489 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 199494 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 199499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTF128rri),
     /* 199502 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199504 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 199507 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199510 */   GIR_RootConstrainSelectedInstOperands,
     /* 199511 */   // GIR_Coverage, 19056,
     /* 199511 */   GIR_EraseRootFromParent_Done,
     /* 199512 */ // Label 4473: @199512
     /* 199512 */ GIM_Try, /*On fail goto*//*Label 4474*/ GIMT_Encode4(199583), // Rule ID 19062 //
     /* 199517 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 199520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 199523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 199527 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 199531 */   // MIs[0] Operand 2
     /* 199531 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 199542 */   // (extract_subvector:{ *:[v4i32] } VR512:{ *:[v16i32] }:$src, 4:{ *:[iPTR] })  =>  (VEXTRACTI32X4Z256rri:{ *:[v4i32] } (EXTRACT_SUBREG:{ *:[v8i32] } VR512:{ *:[v16i32] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 199542 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s32,
     /* 199545 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199549 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199554 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 199560 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 199565 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 199570 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI32X4Z256rri),
     /* 199573 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199575 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 199578 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199581 */   GIR_RootConstrainSelectedInstOperands,
     /* 199582 */   // GIR_Coverage, 19062,
     /* 199582 */   GIR_EraseRootFromParent_Done,
     /* 199583 */ // Label 4474: @199583
     /* 199583 */ GIM_Try, /*On fail goto*//*Label 4475*/ GIMT_Encode4(199654), // Rule ID 19063 //
     /* 199588 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 199591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 199594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 199598 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 199602 */   // MIs[0] Operand 2
     /* 199602 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 199613 */   // (extract_subvector:{ *:[v4f32] } VR512:{ *:[v16f32] }:$src, 4:{ *:[iPTR] })  =>  (VEXTRACTF32X4Z256rri:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v8f32] } VR512:{ *:[v16f32] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 199613 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s32,
     /* 199616 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199620 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199625 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 199631 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 199636 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 199641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTF32X4Z256rri),
     /* 199644 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199646 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 199649 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199652 */   GIR_RootConstrainSelectedInstOperands,
     /* 199653 */   // GIR_Coverage, 19063,
     /* 199653 */   GIR_EraseRootFromParent_Done,
     /* 199654 */ // Label 4475: @199654
     /* 199654 */ GIM_Try, /*On fail goto*//*Label 4476*/ GIMT_Encode4(199703), // Rule ID 23001 //
     /* 199659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 199662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 199666 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 199670 */   // MIs[0] Operand 2
     /* 199670 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 199681 */   // (extract_subvector:{ *:[v4i32] } VR256:{ *:[v8i32] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v4i32] } VR256:{ *:[v8i32] }:$src, sub_xmm:{ *:[i32] })
     /* 199681 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199684 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199686 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 199692 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 199697 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 199702 */   // GIR_Coverage, 23001,
     /* 199702 */   GIR_EraseRootFromParent_Done,
     /* 199703 */ // Label 4476: @199703
     /* 199703 */ GIM_Try, /*On fail goto*//*Label 4477*/ GIMT_Encode4(199752), // Rule ID 23004 //
     /* 199708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 199711 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 199715 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 199719 */   // MIs[0] Operand 2
     /* 199719 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 199730 */   // (extract_subvector:{ *:[v4f32] } VR256:{ *:[v8f32] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v4f32] } VR256:{ *:[v8f32] }:$src, sub_xmm:{ *:[i32] })
     /* 199730 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199733 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199735 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 199741 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 199746 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 199751 */   // GIR_Coverage, 23004,
     /* 199751 */   GIR_EraseRootFromParent_Done,
     /* 199752 */ // Label 4477: @199752
     /* 199752 */ GIM_Try, /*On fail goto*//*Label 4478*/ GIMT_Encode4(199801), // Rule ID 23022 //
     /* 199757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 199760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 199764 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 199768 */   // MIs[0] Operand 2
     /* 199768 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 199779 */   // (extract_subvector:{ *:[v4i32] } VR512:{ *:[v16i32] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v4i32] } VR512:{ *:[v16i32] }:$src, sub_xmm:{ *:[i32] })
     /* 199779 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199782 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199784 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 199790 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 199795 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 199800 */   // GIR_Coverage, 23022,
     /* 199800 */   GIR_EraseRootFromParent_Done,
     /* 199801 */ // Label 4478: @199801
     /* 199801 */ GIM_Try, /*On fail goto*//*Label 4479*/ GIMT_Encode4(199850), // Rule ID 23025 //
     /* 199806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 199809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 199813 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 199817 */   // MIs[0] Operand 2
     /* 199817 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 199828 */   // (extract_subvector:{ *:[v4f32] } VR512:{ *:[v16f32] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v4f32] } VR512:{ *:[v16f32] }:$src, sub_xmm:{ *:[i32] })
     /* 199828 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199831 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199833 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 199839 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 199844 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 199849 */   // GIR_Coverage, 23025,
     /* 199849 */   GIR_EraseRootFromParent_Done,
     /* 199850 */ // Label 4479: @199850
     /* 199850 */ GIM_Reject,
     /* 199851 */ // Label 4439: @199851
     /* 199851 */ GIM_Try, /*On fail goto*//*Label 4480*/ GIMT_Encode4(199933),
     /* 199856 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 199859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 199863 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 199867 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 199878 */   GIM_Try, /*On fail goto*//*Label 4481*/ GIMT_Encode4(199905), // Rule ID 23049 //
     /* 199883 */     // (extract_subvector:{ *:[v4i64] } VR512:{ *:[v8i64] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v4i64] } VR512:{ *:[v8i64] }:$src, sub_ymm:{ *:[i32] })
     /* 199883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199888 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 199894 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 199899 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 199904 */     // GIR_Coverage, 23049,
     /* 199904 */     GIR_EraseRootFromParent_Done,
     /* 199905 */   // Label 4481: @199905
     /* 199905 */   GIM_Try, /*On fail goto*//*Label 4482*/ GIMT_Encode4(199932), // Rule ID 23052 //
     /* 199910 */     // (extract_subvector:{ *:[v4f64] } VR512:{ *:[v8f64] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v4f64] } VR512:{ *:[v8f64] }:$src, sub_ymm:{ *:[i32] })
     /* 199910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199915 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 199921 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 199926 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 199931 */     // GIR_Coverage, 23052,
     /* 199931 */     GIR_EraseRootFromParent_Done,
     /* 199932 */   // Label 4482: @199932
     /* 199932 */   GIM_Reject,
     /* 199933 */ // Label 4480: @199933
     /* 199933 */ GIM_Reject,
     /* 199934 */ // Label 4440: @199934
     /* 199934 */ GIM_Try, /*On fail goto*//*Label 4483*/ GIMT_Encode4(199974), // Rule ID 19632 //
     /* 199939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 199942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 199946 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 199950 */   // MIs[0] Operand 2
     /* 199950 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 199961 */   // (extract_subvector:{ *:[v8i1] } VK16:{ *:[v16i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } VK16:{ *:[v16i1] }:$src, VK8:{ *:[i32] })
     /* 199961 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199964 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199966 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199968 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 199973 */   // GIR_Coverage, 19632,
     /* 199973 */   GIR_EraseRootFromParent_Done,
     /* 199974 */ // Label 4483: @199974
     /* 199974 */ GIM_Try, /*On fail goto*//*Label 4484*/ GIMT_Encode4(200014), // Rule ID 19634 //
     /* 199979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 199982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 199986 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 199990 */   // MIs[0] Operand 2
     /* 199990 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 200001 */   // (extract_subvector:{ *:[v8i1] } VK32:{ *:[v32i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } VK32:{ *:[v32i1] }:$src, VK8:{ *:[i32] })
     /* 200001 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200004 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200006 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 200008 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 200013 */   // GIR_Coverage, 19634,
     /* 200013 */   GIR_EraseRootFromParent_Done,
     /* 200014 */ // Label 4484: @200014
     /* 200014 */ GIM_Try, /*On fail goto*//*Label 4485*/ GIMT_Encode4(200054), // Rule ID 19636 //
     /* 200019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 200022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 200026 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 200030 */   // MIs[0] Operand 2
     /* 200030 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 200041 */   // (extract_subvector:{ *:[v8i1] } VK64:{ *:[v64i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } VK64:{ *:[v64i1] }:$src, VK8:{ *:[i32] })
     /* 200041 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200044 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200046 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 200048 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 200053 */   // GIR_Coverage, 19636,
     /* 200053 */   GIR_EraseRootFromParent_Done,
     /* 200054 */ // Label 4485: @200054
     /* 200054 */ GIM_Reject,
     /* 200055 */ // Label 4441: @200055
     /* 200055 */ GIM_Try, /*On fail goto*//*Label 4486*/ GIMT_Encode4(200126), // Rule ID 19057 //
     /* 200060 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 200063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 200066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 200070 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 200074 */   // MIs[0] Operand 2
     /* 200074 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 200085 */   // (extract_subvector:{ *:[v8i16] } VR512:{ *:[v32i16] }:$src, 8:{ *:[iPTR] })  =>  (VEXTRACTI128rri:{ *:[v8i16] } (EXTRACT_SUBREG:{ *:[v16i16] } VR512:{ *:[v32i16] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 200085 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s16,
     /* 200088 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200092 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200097 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 200103 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 200108 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 200113 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI128rri),
     /* 200116 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200118 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 200121 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200124 */   GIR_RootConstrainSelectedInstOperands,
     /* 200125 */   // GIR_Coverage, 19057,
     /* 200125 */   GIR_EraseRootFromParent_Done,
     /* 200126 */ // Label 4486: @200126
     /* 200126 */ GIM_Try, /*On fail goto*//*Label 4487*/ GIMT_Encode4(200197), // Rule ID 19058 //
     /* 200131 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 200134 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 200137 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 200141 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 200145 */   // MIs[0] Operand 2
     /* 200145 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 200156 */   // (extract_subvector:{ *:[v8f16] } VR512:{ *:[v32f16] }:$src, 8:{ *:[iPTR] })  =>  (VEXTRACTF128rri:{ *:[v8f16] } (EXTRACT_SUBREG:{ *:[v16f16] } VR512:{ *:[v32f16] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 200156 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s16,
     /* 200159 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200163 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200168 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 200174 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 200179 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 200184 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTF128rri),
     /* 200187 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200189 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 200192 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200195 */   GIR_RootConstrainSelectedInstOperands,
     /* 200196 */   // GIR_Coverage, 19058,
     /* 200196 */   GIR_EraseRootFromParent_Done,
     /* 200197 */ // Label 4487: @200197
     /* 200197 */ GIM_Try, /*On fail goto*//*Label 4488*/ GIMT_Encode4(200268), // Rule ID 19064 //
     /* 200202 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 200205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 200208 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 200212 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 200216 */   // MIs[0] Operand 2
     /* 200216 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 200227 */   // (extract_subvector:{ *:[v8i16] } VR512:{ *:[v32i16] }:$src, 8:{ *:[iPTR] })  =>  (VEXTRACTI32X4Z256rri:{ *:[v8i16] } (EXTRACT_SUBREG:{ *:[v16i16] } VR512:{ *:[v32i16] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 200227 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s16,
     /* 200230 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200234 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200239 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 200245 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 200250 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 200255 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI32X4Z256rri),
     /* 200258 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200260 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 200263 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200266 */   GIR_RootConstrainSelectedInstOperands,
     /* 200267 */   // GIR_Coverage, 19064,
     /* 200267 */   GIR_EraseRootFromParent_Done,
     /* 200268 */ // Label 4488: @200268
     /* 200268 */ GIM_Try, /*On fail goto*//*Label 4489*/ GIMT_Encode4(200339), // Rule ID 19065 //
     /* 200273 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 200276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 200279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 200283 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 200287 */   // MIs[0] Operand 2
     /* 200287 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 200298 */   // (extract_subvector:{ *:[v8f16] } VR512:{ *:[v32f16] }:$src, 8:{ *:[iPTR] })  =>  (VEXTRACTF32X4Z256rri:{ *:[v8f16] } (EXTRACT_SUBREG:{ *:[v16f16] } VR512:{ *:[v32f16] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 200298 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s16,
     /* 200301 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200305 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200310 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 200316 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 200321 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 200326 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTF32X4Z256rri),
     /* 200329 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200331 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 200334 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200337 */   GIR_RootConstrainSelectedInstOperands,
     /* 200338 */   // GIR_Coverage, 19065,
     /* 200338 */   GIR_EraseRootFromParent_Done,
     /* 200339 */ // Label 4489: @200339
     /* 200339 */ GIM_Try, /*On fail goto*//*Label 4490*/ GIMT_Encode4(200388), // Rule ID 23013 //
     /* 200344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 200347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 200351 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 200355 */   // MIs[0] Operand 2
     /* 200355 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 200366 */   // (extract_subvector:{ *:[v8i16] } VR256:{ *:[v16i16] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v8i16] } VR256:{ *:[v16i16] }:$src, sub_xmm:{ *:[i32] })
     /* 200366 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200369 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200371 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 200377 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 200382 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 200387 */   // GIR_Coverage, 23013,
     /* 200387 */   GIR_EraseRootFromParent_Done,
     /* 200388 */ // Label 4490: @200388
     /* 200388 */ GIM_Try, /*On fail goto*//*Label 4491*/ GIMT_Encode4(200437), // Rule ID 23019 //
     /* 200393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 200396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 200400 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 200404 */   // MIs[0] Operand 2
     /* 200404 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 200415 */   // (extract_subvector:{ *:[v8f16] } VR256:{ *:[v16f16] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v8f16] } VR256:{ *:[v16f16] }:$src, sub_xmm:{ *:[i32] })
     /* 200415 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200418 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200420 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 200426 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 200431 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 200436 */   // GIR_Coverage, 23019,
     /* 200436 */   GIR_EraseRootFromParent_Done,
     /* 200437 */ // Label 4491: @200437
     /* 200437 */ GIM_Try, /*On fail goto*//*Label 4492*/ GIMT_Encode4(200486), // Rule ID 23034 //
     /* 200442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 200445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 200449 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 200453 */   // MIs[0] Operand 2
     /* 200453 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 200464 */   // (extract_subvector:{ *:[v8i16] } VR512:{ *:[v32i16] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v8i16] } VR512:{ *:[v32i16] }:$src, sub_xmm:{ *:[i32] })
     /* 200464 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200467 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200469 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 200475 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 200480 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 200485 */   // GIR_Coverage, 23034,
     /* 200485 */   GIR_EraseRootFromParent_Done,
     /* 200486 */ // Label 4492: @200486
     /* 200486 */ GIM_Try, /*On fail goto*//*Label 4493*/ GIMT_Encode4(200535), // Rule ID 23040 //
     /* 200491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 200494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 200498 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 200502 */   // MIs[0] Operand 2
     /* 200502 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 200513 */   // (extract_subvector:{ *:[v8f16] } VR512:{ *:[v32f16] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v8f16] } VR512:{ *:[v32f16] }:$src, sub_xmm:{ *:[i32] })
     /* 200513 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200516 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200518 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 200524 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 200529 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 200534 */   // GIR_Coverage, 23040,
     /* 200534 */   GIR_EraseRootFromParent_Done,
     /* 200535 */ // Label 4493: @200535
     /* 200535 */ GIM_Reject,
     /* 200536 */ // Label 4442: @200536
     /* 200536 */ GIM_Try, /*On fail goto*//*Label 4494*/ GIMT_Encode4(200618),
     /* 200541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 200544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 200548 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 200552 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 200563 */   GIM_Try, /*On fail goto*//*Label 4495*/ GIMT_Encode4(200590), // Rule ID 23043 //
     /* 200568 */     // (extract_subvector:{ *:[v8i32] } VR512:{ *:[v16i32] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v8i32] } VR512:{ *:[v16i32] }:$src, sub_ymm:{ *:[i32] })
     /* 200568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200573 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 200579 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 200584 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 200589 */     // GIR_Coverage, 23043,
     /* 200589 */     GIR_EraseRootFromParent_Done,
     /* 200590 */   // Label 4495: @200590
     /* 200590 */   GIM_Try, /*On fail goto*//*Label 4496*/ GIMT_Encode4(200617), // Rule ID 23046 //
     /* 200595 */     // (extract_subvector:{ *:[v8f32] } VR512:{ *:[v16f32] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v8f32] } VR512:{ *:[v16f32] }:$src, sub_ymm:{ *:[i32] })
     /* 200595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200600 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 200606 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 200611 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 200616 */     // GIR_Coverage, 23046,
     /* 200616 */     GIR_EraseRootFromParent_Done,
     /* 200617 */   // Label 4496: @200617
     /* 200617 */   GIM_Reject,
     /* 200618 */ // Label 4494: @200618
     /* 200618 */ GIM_Reject,
     /* 200619 */ // Label 4443: @200619
     /* 200619 */ GIM_Try, /*On fail goto*//*Label 4497*/ GIMT_Encode4(200659), // Rule ID 19638 //
     /* 200624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 200627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 200631 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 200635 */   // MIs[0] Operand 2
     /* 200635 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 200646 */   // (extract_subvector:{ *:[v16i1] } VK32:{ *:[v32i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } VK32:{ *:[v32i1] }:$src, VK16:{ *:[i32] })
     /* 200646 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200649 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200651 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 200653 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 200658 */   // GIR_Coverage, 19638,
     /* 200658 */   GIR_EraseRootFromParent_Done,
     /* 200659 */ // Label 4497: @200659
     /* 200659 */ GIM_Try, /*On fail goto*//*Label 4498*/ GIMT_Encode4(200699), // Rule ID 19640 //
     /* 200664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 200667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 200671 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 200675 */   // MIs[0] Operand 2
     /* 200675 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 200686 */   // (extract_subvector:{ *:[v16i1] } VK64:{ *:[v64i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } VK64:{ *:[v64i1] }:$src, VK16:{ *:[i32] })
     /* 200686 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200689 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200691 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 200693 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 200698 */   // GIR_Coverage, 19640,
     /* 200698 */   GIR_EraseRootFromParent_Done,
     /* 200699 */ // Label 4498: @200699
     /* 200699 */ GIM_Reject,
     /* 200700 */ // Label 4444: @200700
     /* 200700 */ GIM_Try, /*On fail goto*//*Label 4499*/ GIMT_Encode4(200771), // Rule ID 19059 //
     /* 200705 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 200708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 200711 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 200715 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 200719 */   // MIs[0] Operand 2
     /* 200719 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 200730 */   // (extract_subvector:{ *:[v16i8] } VR512:{ *:[v64i8] }:$src, 16:{ *:[iPTR] })  =>  (VEXTRACTI128rri:{ *:[v16i8] } (EXTRACT_SUBREG:{ *:[v32i8] } VR512:{ *:[v64i8] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 200730 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s8,
     /* 200733 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200737 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200742 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 200748 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 200753 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 200758 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI128rri),
     /* 200761 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200763 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 200766 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200769 */   GIR_RootConstrainSelectedInstOperands,
     /* 200770 */   // GIR_Coverage, 19059,
     /* 200770 */   GIR_EraseRootFromParent_Done,
     /* 200771 */ // Label 4499: @200771
     /* 200771 */ GIM_Try, /*On fail goto*//*Label 4500*/ GIMT_Encode4(200842), // Rule ID 19066 //
     /* 200776 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 200779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 200782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 200786 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 200790 */   // MIs[0] Operand 2
     /* 200790 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 200801 */   // (extract_subvector:{ *:[v16i8] } VR512:{ *:[v64i8] }:$src, 16:{ *:[iPTR] })  =>  (VEXTRACTI32X4Z256rri:{ *:[v16i8] } (EXTRACT_SUBREG:{ *:[v32i8] } VR512:{ *:[v64i8] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 200801 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s8,
     /* 200804 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200808 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200813 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 200819 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 200824 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 200829 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI32X4Z256rri),
     /* 200832 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200834 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 200837 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200840 */   GIR_RootConstrainSelectedInstOperands,
     /* 200841 */   // GIR_Coverage, 19066,
     /* 200841 */   GIR_EraseRootFromParent_Done,
     /* 200842 */ // Label 4500: @200842
     /* 200842 */ GIM_Try, /*On fail goto*//*Label 4501*/ GIMT_Encode4(200891), // Rule ID 23016 //
     /* 200847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 200850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 200854 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 200858 */   // MIs[0] Operand 2
     /* 200858 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 200869 */   // (extract_subvector:{ *:[v16i8] } VR256:{ *:[v32i8] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v16i8] } VR256:{ *:[v32i8] }:$src, sub_xmm:{ *:[i32] })
     /* 200869 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200872 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200874 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 200880 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 200885 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 200890 */   // GIR_Coverage, 23016,
     /* 200890 */   GIR_EraseRootFromParent_Done,
     /* 200891 */ // Label 4501: @200891
     /* 200891 */ GIM_Try, /*On fail goto*//*Label 4502*/ GIMT_Encode4(200940), // Rule ID 23037 //
     /* 200896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 200899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 200903 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 200907 */   // MIs[0] Operand 2
     /* 200907 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 200918 */   // (extract_subvector:{ *:[v16i8] } VR512:{ *:[v64i8] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v16i8] } VR512:{ *:[v64i8] }:$src, sub_xmm:{ *:[i32] })
     /* 200918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200921 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200923 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 200929 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 200934 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 200939 */   // GIR_Coverage, 23037,
     /* 200939 */   GIR_EraseRootFromParent_Done,
     /* 200940 */ // Label 4502: @200940
     /* 200940 */ GIM_Reject,
     /* 200941 */ // Label 4445: @200941
     /* 200941 */ GIM_Try, /*On fail goto*//*Label 4503*/ GIMT_Encode4(201023),
     /* 200946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 200949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 200953 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 200957 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 200968 */   GIM_Try, /*On fail goto*//*Label 4504*/ GIMT_Encode4(200995), // Rule ID 23055 //
     /* 200973 */     // (extract_subvector:{ *:[v16i16] } VR512:{ *:[v32i16] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v16i16] } VR512:{ *:[v32i16] }:$src, sub_ymm:{ *:[i32] })
     /* 200973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200978 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 200984 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 200989 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 200994 */     // GIR_Coverage, 23055,
     /* 200994 */     GIR_EraseRootFromParent_Done,
     /* 200995 */   // Label 4504: @200995
     /* 200995 */   GIM_Try, /*On fail goto*//*Label 4505*/ GIMT_Encode4(201022), // Rule ID 23061 //
     /* 201000 */     // (extract_subvector:{ *:[v16f16] } VR512:{ *:[v32f16] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v16f16] } VR512:{ *:[v32f16] }:$src, sub_ymm:{ *:[i32] })
     /* 201000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 201003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201005 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 201011 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 201016 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 201021 */     // GIR_Coverage, 23061,
     /* 201021 */     GIR_EraseRootFromParent_Done,
     /* 201022 */   // Label 4505: @201022
     /* 201022 */   GIM_Reject,
     /* 201023 */ // Label 4503: @201023
     /* 201023 */ GIM_Reject,
     /* 201024 */ // Label 4446: @201024
     /* 201024 */ GIM_Try, /*On fail goto*//*Label 4506*/ GIMT_Encode4(201064), // Rule ID 19642 //
     /* 201029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 201032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 201036 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 201040 */   // MIs[0] Operand 2
     /* 201040 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 201051 */   // (extract_subvector:{ *:[v32i1] } VK64:{ *:[v64i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v32i1] } VK64:{ *:[v64i1] }:$src, VK32:{ *:[i32] })
     /* 201051 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 201054 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201056 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201058 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK32RegClassID),
     /* 201063 */   // GIR_Coverage, 19642,
     /* 201063 */   GIR_EraseRootFromParent_Done,
     /* 201064 */ // Label 4506: @201064
     /* 201064 */ GIM_Reject,
     /* 201065 */ // Label 4447: @201065
     /* 201065 */ GIM_Try, /*On fail goto*//*Label 4507*/ GIMT_Encode4(201114), // Rule ID 23058 //
     /* 201070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 201073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 201077 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 201081 */   // MIs[0] Operand 2
     /* 201081 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 201092 */   // (extract_subvector:{ *:[v32i8] } VR512:{ *:[v64i8] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v32i8] } VR512:{ *:[v64i8] }:$src, sub_ymm:{ *:[i32] })
     /* 201092 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 201095 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201097 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 201103 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 201108 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 201113 */   // GIR_Coverage, 23058,
     /* 201113 */   GIR_EraseRootFromParent_Done,
     /* 201114 */ // Label 4507: @201114
     /* 201114 */ GIM_Reject,
     /* 201115 */ // Label 4448: @201115
     /* 201115 */ GIM_Reject,
     /* 201116 */ // Label 61: @201116
     /* 201116 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 4520*/ GIMT_Encode4(203097),
     /* 201127 */ /*GILLT_v2s64*//*Label 4508*/ GIMT_Encode4(201195), GIMT_Encode4(0),
     /* 201135 */ /*GILLT_v4s32*//*Label 4509*/ GIMT_Encode4(201397),
     /* 201139 */ /*GILLT_v4s64*//*Label 4510*/ GIMT_Encode4(201599), GIMT_Encode4(0),
     /* 201147 */ /*GILLT_v8s16*//*Label 4511*/ GIMT_Encode4(201801),
     /* 201151 */ /*GILLT_v8s32*//*Label 4512*/ GIMT_Encode4(201916),
     /* 201155 */ /*GILLT_v8s64*//*Label 4513*/ GIMT_Encode4(202118), GIMT_Encode4(0),
     /* 201163 */ /*GILLT_v16s8*//*Label 4514*/ GIMT_Encode4(202320),
     /* 201167 */ /*GILLT_v16s16*//*Label 4515*/ GIMT_Encode4(202435),
     /* 201171 */ /*GILLT_v16s32*//*Label 4516*/ GIMT_Encode4(202550), GIMT_Encode4(0),
     /* 201179 */ /*GILLT_v32s8*//*Label 4517*/ GIMT_Encode4(202752),
     /* 201183 */ /*GILLT_v32s16*//*Label 4518*/ GIMT_Encode4(202867), GIMT_Encode4(0),
     /* 201191 */ /*GILLT_v64s8*//*Label 4519*/ GIMT_Encode4(202982),
     /* 201195 */ // Label 4508: @201195
     /* 201195 */ GIM_Try, /*On fail goto*//*Label 4521*/ GIMT_Encode4(201396),
     /* 201200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 201203 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /* 201206 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 201209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 201213 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 201217 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 201221 */   GIM_Try, /*On fail goto*//*Label 4522*/ GIMT_Encode4(201254), // Rule ID 21696 //
     /* 201226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 201233 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 201239 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 201241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201243 */     // (vector_compress:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src, VK2WM:{ *:[v2i1] }:$mask, immAllZerosV:{ *:[v2i64] })  =>  (VPCOMPRESSQZ128rrkz:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src)
     /* 201243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZ128rrkz),
     /* 201246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201248 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201250 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201252 */     GIR_RootConstrainSelectedInstOperands,
     /* 201253 */     // GIR_Coverage, 21696,
     /* 201253 */     GIR_EraseRootFromParent_Done,
     /* 201254 */   // Label 4522: @201254
     /* 201254 */   GIM_Try, /*On fail goto*//*Label 4523*/ GIMT_Encode4(201287), // Rule ID 21732 //
     /* 201259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 201266 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 201272 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 201274 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201276 */     // (vector_compress:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src, VK2WM:{ *:[v2i1] }:$mask, immAllZerosV:{ *:[v2f64] })  =>  (VCOMPRESSPDZ128rrkz:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src)
     /* 201276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZ128rrkz),
     /* 201279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201281 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201283 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201285 */     GIR_RootConstrainSelectedInstOperands,
     /* 201286 */     // GIR_Coverage, 21732,
     /* 201286 */     GIR_EraseRootFromParent_Done,
     /* 201287 */   // Label 4523: @201287
     /* 201287 */   GIM_Try, /*On fail goto*//*Label 4524*/ GIMT_Encode4(201316), // Rule ID 21695 //
     /* 201292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 201299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 201303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201305 */     // (vector_compress:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src, VK2WM:{ *:[v2i1] }:$mask, (undef:{ *:[v2i64] }))  =>  (VPCOMPRESSQZ128rrkz:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src)
     /* 201305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZ128rrkz),
     /* 201308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201310 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201312 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201314 */     GIR_RootConstrainSelectedInstOperands,
     /* 201315 */     // GIR_Coverage, 21695,
     /* 201315 */     GIR_EraseRootFromParent_Done,
     /* 201316 */   // Label 4524: @201316
     /* 201316 */   GIM_Try, /*On fail goto*//*Label 4525*/ GIMT_Encode4(201345), // Rule ID 21731 //
     /* 201321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 201328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 201332 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201334 */     // (vector_compress:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src, VK2WM:{ *:[v2i1] }:$mask, (undef:{ *:[v2f64] }))  =>  (VCOMPRESSPDZ128rrkz:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src)
     /* 201334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZ128rrkz),
     /* 201337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201339 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201341 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201343 */     GIR_RootConstrainSelectedInstOperands,
     /* 201344 */     // GIR_Coverage, 21731,
     /* 201344 */     GIR_EraseRootFromParent_Done,
     /* 201345 */   // Label 4525: @201345
     /* 201345 */   GIM_Try, /*On fail goto*//*Label 4526*/ GIMT_Encode4(201370), // Rule ID 21697 //
     /* 201350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 201357 */     // (vector_compress:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src, VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$passthru)  =>  (VPCOMPRESSQZ128rrk:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$passthru, VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src)
     /* 201357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZ128rrk),
     /* 201360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201362 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 201364 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201366 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201368 */     GIR_RootConstrainSelectedInstOperands,
     /* 201369 */     // GIR_Coverage, 21697,
     /* 201369 */     GIR_EraseRootFromParent_Done,
     /* 201370 */   // Label 4526: @201370
     /* 201370 */   GIM_Try, /*On fail goto*//*Label 4527*/ GIMT_Encode4(201395), // Rule ID 21733 //
     /* 201375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 201382 */     // (vector_compress:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src, VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$passthru)  =>  (VCOMPRESSPDZ128rrk:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$passthru, VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src)
     /* 201382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZ128rrk),
     /* 201385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201387 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 201389 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201391 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201393 */     GIR_RootConstrainSelectedInstOperands,
     /* 201394 */     // GIR_Coverage, 21733,
     /* 201394 */     GIR_EraseRootFromParent_Done,
     /* 201395 */   // Label 4527: @201395
     /* 201395 */   GIM_Reject,
     /* 201396 */ // Label 4521: @201396
     /* 201396 */ GIM_Reject,
     /* 201397 */ // Label 4509: @201397
     /* 201397 */ GIM_Try, /*On fail goto*//*Label 4528*/ GIMT_Encode4(201598),
     /* 201402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 201405 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /* 201408 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 201411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 201415 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 201419 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 201423 */   GIM_Try, /*On fail goto*//*Label 4529*/ GIMT_Encode4(201456), // Rule ID 21678 //
     /* 201428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 201435 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 201441 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 201443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201445 */     // (vector_compress:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src, VK4WM:{ *:[v4i1] }:$mask, immAllZerosV:{ *:[v4i32] })  =>  (VPCOMPRESSDZ128rrkz:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src)
     /* 201445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZ128rrkz),
     /* 201448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201450 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201452 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201454 */     GIR_RootConstrainSelectedInstOperands,
     /* 201455 */     // GIR_Coverage, 21678,
     /* 201455 */     GIR_EraseRootFromParent_Done,
     /* 201456 */   // Label 4529: @201456
     /* 201456 */   GIM_Try, /*On fail goto*//*Label 4530*/ GIMT_Encode4(201489), // Rule ID 21714 //
     /* 201461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 201468 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 201474 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 201476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201478 */     // (vector_compress:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src, VK4WM:{ *:[v4i1] }:$mask, immAllZerosV:{ *:[v4f32] })  =>  (VCOMPRESSPSZ128rrkz:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src)
     /* 201478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZ128rrkz),
     /* 201481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201483 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201485 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201487 */     GIR_RootConstrainSelectedInstOperands,
     /* 201488 */     // GIR_Coverage, 21714,
     /* 201488 */     GIR_EraseRootFromParent_Done,
     /* 201489 */   // Label 4530: @201489
     /* 201489 */   GIM_Try, /*On fail goto*//*Label 4531*/ GIMT_Encode4(201518), // Rule ID 21677 //
     /* 201494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 201501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 201505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201507 */     // (vector_compress:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src, VK4WM:{ *:[v4i1] }:$mask, (undef:{ *:[v4i32] }))  =>  (VPCOMPRESSDZ128rrkz:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src)
     /* 201507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZ128rrkz),
     /* 201510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201512 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201514 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201516 */     GIR_RootConstrainSelectedInstOperands,
     /* 201517 */     // GIR_Coverage, 21677,
     /* 201517 */     GIR_EraseRootFromParent_Done,
     /* 201518 */   // Label 4531: @201518
     /* 201518 */   GIM_Try, /*On fail goto*//*Label 4532*/ GIMT_Encode4(201547), // Rule ID 21713 //
     /* 201523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 201530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 201534 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201536 */     // (vector_compress:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src, VK4WM:{ *:[v4i1] }:$mask, (undef:{ *:[v4f32] }))  =>  (VCOMPRESSPSZ128rrkz:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src)
     /* 201536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZ128rrkz),
     /* 201539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201541 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201543 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201545 */     GIR_RootConstrainSelectedInstOperands,
     /* 201546 */     // GIR_Coverage, 21713,
     /* 201546 */     GIR_EraseRootFromParent_Done,
     /* 201547 */   // Label 4532: @201547
     /* 201547 */   GIM_Try, /*On fail goto*//*Label 4533*/ GIMT_Encode4(201572), // Rule ID 21679 //
     /* 201552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 201559 */     // (vector_compress:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src, VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$passthru)  =>  (VPCOMPRESSDZ128rrk:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$passthru, VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src)
     /* 201559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZ128rrk),
     /* 201562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201564 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 201566 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201568 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201570 */     GIR_RootConstrainSelectedInstOperands,
     /* 201571 */     // GIR_Coverage, 21679,
     /* 201571 */     GIR_EraseRootFromParent_Done,
     /* 201572 */   // Label 4533: @201572
     /* 201572 */   GIM_Try, /*On fail goto*//*Label 4534*/ GIMT_Encode4(201597), // Rule ID 21715 //
     /* 201577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 201584 */     // (vector_compress:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src, VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$passthru)  =>  (VCOMPRESSPSZ128rrk:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$passthru, VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src)
     /* 201584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZ128rrk),
     /* 201587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201589 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 201591 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201593 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201595 */     GIR_RootConstrainSelectedInstOperands,
     /* 201596 */     // GIR_Coverage, 21715,
     /* 201596 */     GIR_EraseRootFromParent_Done,
     /* 201597 */   // Label 4534: @201597
     /* 201597 */   GIM_Reject,
     /* 201598 */ // Label 4528: @201598
     /* 201598 */ GIM_Reject,
     /* 201599 */ // Label 4510: @201599
     /* 201599 */ GIM_Try, /*On fail goto*//*Label 4535*/ GIMT_Encode4(201800),
     /* 201604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 201607 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /* 201610 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 201613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 201617 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 201621 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 201625 */   GIM_Try, /*On fail goto*//*Label 4536*/ GIMT_Encode4(201658), // Rule ID 21690 //
     /* 201630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 201637 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 201643 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 201645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201647 */     // (vector_compress:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src, VK4WM:{ *:[v4i1] }:$mask, immAllZerosV:{ *:[v4i64] })  =>  (VPCOMPRESSQZ256rrkz:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src)
     /* 201647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZ256rrkz),
     /* 201650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201652 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201654 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201656 */     GIR_RootConstrainSelectedInstOperands,
     /* 201657 */     // GIR_Coverage, 21690,
     /* 201657 */     GIR_EraseRootFromParent_Done,
     /* 201658 */   // Label 4536: @201658
     /* 201658 */   GIM_Try, /*On fail goto*//*Label 4537*/ GIMT_Encode4(201691), // Rule ID 21726 //
     /* 201663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 201670 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 201676 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 201678 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201680 */     // (vector_compress:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src, VK4WM:{ *:[v4i1] }:$mask, immAllZerosV:{ *:[v4f64] })  =>  (VCOMPRESSPDZ256rrkz:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src)
     /* 201680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZ256rrkz),
     /* 201683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201685 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201687 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201689 */     GIR_RootConstrainSelectedInstOperands,
     /* 201690 */     // GIR_Coverage, 21726,
     /* 201690 */     GIR_EraseRootFromParent_Done,
     /* 201691 */   // Label 4537: @201691
     /* 201691 */   GIM_Try, /*On fail goto*//*Label 4538*/ GIMT_Encode4(201720), // Rule ID 21689 //
     /* 201696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 201703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 201707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201709 */     // (vector_compress:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src, VK4WM:{ *:[v4i1] }:$mask, (undef:{ *:[v4i64] }))  =>  (VPCOMPRESSQZ256rrkz:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src)
     /* 201709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZ256rrkz),
     /* 201712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201714 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201716 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201718 */     GIR_RootConstrainSelectedInstOperands,
     /* 201719 */     // GIR_Coverage, 21689,
     /* 201719 */     GIR_EraseRootFromParent_Done,
     /* 201720 */   // Label 4538: @201720
     /* 201720 */   GIM_Try, /*On fail goto*//*Label 4539*/ GIMT_Encode4(201749), // Rule ID 21725 //
     /* 201725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 201732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 201736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201738 */     // (vector_compress:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src, VK4WM:{ *:[v4i1] }:$mask, (undef:{ *:[v4f64] }))  =>  (VCOMPRESSPDZ256rrkz:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src)
     /* 201738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZ256rrkz),
     /* 201741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201743 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201745 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201747 */     GIR_RootConstrainSelectedInstOperands,
     /* 201748 */     // GIR_Coverage, 21725,
     /* 201748 */     GIR_EraseRootFromParent_Done,
     /* 201749 */   // Label 4539: @201749
     /* 201749 */   GIM_Try, /*On fail goto*//*Label 4540*/ GIMT_Encode4(201774), // Rule ID 21691 //
     /* 201754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 201761 */     // (vector_compress:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src, VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$passthru)  =>  (VPCOMPRESSQZ256rrk:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$passthru, VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src)
     /* 201761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZ256rrk),
     /* 201764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201766 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 201768 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201770 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201772 */     GIR_RootConstrainSelectedInstOperands,
     /* 201773 */     // GIR_Coverage, 21691,
     /* 201773 */     GIR_EraseRootFromParent_Done,
     /* 201774 */   // Label 4540: @201774
     /* 201774 */   GIM_Try, /*On fail goto*//*Label 4541*/ GIMT_Encode4(201799), // Rule ID 21727 //
     /* 201779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 201786 */     // (vector_compress:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src, VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$passthru)  =>  (VCOMPRESSPDZ256rrk:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$passthru, VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src)
     /* 201786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZ256rrk),
     /* 201789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201791 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 201793 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201795 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201797 */     GIR_RootConstrainSelectedInstOperands,
     /* 201798 */     // GIR_Coverage, 21727,
     /* 201798 */     GIR_EraseRootFromParent_Done,
     /* 201799 */   // Label 4541: @201799
     /* 201799 */   GIM_Reject,
     /* 201800 */ // Label 4535: @201800
     /* 201800 */ GIM_Reject,
     /* 201801 */ // Label 4511: @201801
     /* 201801 */ GIM_Try, /*On fail goto*//*Label 4542*/ GIMT_Encode4(201915),
     /* 201806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 201809 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 201812 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 201815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 201819 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 201823 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 201827 */   GIM_Try, /*On fail goto*//*Label 4543*/ GIMT_Encode4(201860), // Rule ID 22098 //
     /* 201832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 201835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 201839 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 201845 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 201847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201849 */     // (vector_compress:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src, VK8WM:{ *:[v8i1] }:$mask, immAllZerosV:{ *:[v8i16] })  =>  (VPCOMPRESSWZ128rrkz:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src)
     /* 201849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZ128rrkz),
     /* 201852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201854 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201856 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201858 */     GIR_RootConstrainSelectedInstOperands,
     /* 201859 */     // GIR_Coverage, 22098,
     /* 201859 */     GIR_EraseRootFromParent_Done,
     /* 201860 */   // Label 4543: @201860
     /* 201860 */   GIM_Try, /*On fail goto*//*Label 4544*/ GIMT_Encode4(201889), // Rule ID 22097 //
     /* 201865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 201868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 201872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 201876 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201878 */     // (vector_compress:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src, VK8WM:{ *:[v8i1] }:$mask, (undef:{ *:[v8i16] }))  =>  (VPCOMPRESSWZ128rrkz:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src)
     /* 201878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZ128rrkz),
     /* 201881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201883 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201885 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201887 */     GIR_RootConstrainSelectedInstOperands,
     /* 201888 */     // GIR_Coverage, 22097,
     /* 201888 */     GIR_EraseRootFromParent_Done,
     /* 201889 */   // Label 4544: @201889
     /* 201889 */   GIM_Try, /*On fail goto*//*Label 4545*/ GIMT_Encode4(201914), // Rule ID 22099 //
     /* 201894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 201897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 201901 */     // (vector_compress:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src, VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$passthru)  =>  (VPCOMPRESSWZ128rrk:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$passthru, VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src)
     /* 201901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZ128rrk),
     /* 201904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201906 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 201908 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201910 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201912 */     GIR_RootConstrainSelectedInstOperands,
     /* 201913 */     // GIR_Coverage, 22099,
     /* 201913 */     GIR_EraseRootFromParent_Done,
     /* 201914 */   // Label 4545: @201914
     /* 201914 */   GIM_Reject,
     /* 201915 */ // Label 4542: @201915
     /* 201915 */ GIM_Reject,
     /* 201916 */ // Label 4512: @201916
     /* 201916 */ GIM_Try, /*On fail goto*//*Label 4546*/ GIMT_Encode4(202117),
     /* 201921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 201924 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 201927 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 201930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 201934 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 201938 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 201942 */   GIM_Try, /*On fail goto*//*Label 4547*/ GIMT_Encode4(201975), // Rule ID 21672 //
     /* 201947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 201954 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 201960 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 201962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201964 */     // (vector_compress:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src, VK8WM:{ *:[v8i1] }:$mask, immAllZerosV:{ *:[v8i32] })  =>  (VPCOMPRESSDZ256rrkz:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src)
     /* 201964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZ256rrkz),
     /* 201967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201969 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201971 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201973 */     GIR_RootConstrainSelectedInstOperands,
     /* 201974 */     // GIR_Coverage, 21672,
     /* 201974 */     GIR_EraseRootFromParent_Done,
     /* 201975 */   // Label 4547: @201975
     /* 201975 */   GIM_Try, /*On fail goto*//*Label 4548*/ GIMT_Encode4(202008), // Rule ID 21708 //
     /* 201980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 201987 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 201993 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 201995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201997 */     // (vector_compress:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src, VK8WM:{ *:[v8i1] }:$mask, immAllZerosV:{ *:[v8f32] })  =>  (VCOMPRESSPSZ256rrkz:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src)
     /* 201997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZ256rrkz),
     /* 202000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202002 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202004 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202006 */     GIR_RootConstrainSelectedInstOperands,
     /* 202007 */     // GIR_Coverage, 21708,
     /* 202007 */     GIR_EraseRootFromParent_Done,
     /* 202008 */   // Label 4548: @202008
     /* 202008 */   GIM_Try, /*On fail goto*//*Label 4549*/ GIMT_Encode4(202037), // Rule ID 21671 //
     /* 202013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 202016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 202020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 202024 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202026 */     // (vector_compress:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src, VK8WM:{ *:[v8i1] }:$mask, (undef:{ *:[v8i32] }))  =>  (VPCOMPRESSDZ256rrkz:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src)
     /* 202026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZ256rrkz),
     /* 202029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202031 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202033 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202035 */     GIR_RootConstrainSelectedInstOperands,
     /* 202036 */     // GIR_Coverage, 21671,
     /* 202036 */     GIR_EraseRootFromParent_Done,
     /* 202037 */   // Label 4549: @202037
     /* 202037 */   GIM_Try, /*On fail goto*//*Label 4550*/ GIMT_Encode4(202066), // Rule ID 21707 //
     /* 202042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 202045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 202049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 202053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202055 */     // (vector_compress:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src, VK8WM:{ *:[v8i1] }:$mask, (undef:{ *:[v8f32] }))  =>  (VCOMPRESSPSZ256rrkz:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src)
     /* 202055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZ256rrkz),
     /* 202058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202060 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202062 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202064 */     GIR_RootConstrainSelectedInstOperands,
     /* 202065 */     // GIR_Coverage, 21707,
     /* 202065 */     GIR_EraseRootFromParent_Done,
     /* 202066 */   // Label 4550: @202066
     /* 202066 */   GIM_Try, /*On fail goto*//*Label 4551*/ GIMT_Encode4(202091), // Rule ID 21673 //
     /* 202071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 202074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 202078 */     // (vector_compress:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src, VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$passthru)  =>  (VPCOMPRESSDZ256rrk:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$passthru, VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src)
     /* 202078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZ256rrk),
     /* 202081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202083 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 202085 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202087 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202089 */     GIR_RootConstrainSelectedInstOperands,
     /* 202090 */     // GIR_Coverage, 21673,
     /* 202090 */     GIR_EraseRootFromParent_Done,
     /* 202091 */   // Label 4551: @202091
     /* 202091 */   GIM_Try, /*On fail goto*//*Label 4552*/ GIMT_Encode4(202116), // Rule ID 21709 //
     /* 202096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 202099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 202103 */     // (vector_compress:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src, VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$passthru)  =>  (VCOMPRESSPSZ256rrk:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$passthru, VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src)
     /* 202103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZ256rrk),
     /* 202106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202108 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 202110 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202112 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202114 */     GIR_RootConstrainSelectedInstOperands,
     /* 202115 */     // GIR_Coverage, 21709,
     /* 202115 */     GIR_EraseRootFromParent_Done,
     /* 202116 */   // Label 4552: @202116
     /* 202116 */   GIM_Reject,
     /* 202117 */ // Label 4546: @202117
     /* 202117 */ GIM_Reject,
     /* 202118 */ // Label 4513: @202118
     /* 202118 */ GIM_Try, /*On fail goto*//*Label 4553*/ GIMT_Encode4(202319),
     /* 202123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 202126 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 202129 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /* 202132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 202136 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 202140 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 202144 */   GIM_Try, /*On fail goto*//*Label 4554*/ GIMT_Encode4(202177), // Rule ID 21684 //
     /* 202149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 202152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 202156 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 202162 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 202164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202166 */     // (vector_compress:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src, VK8WM:{ *:[v8i1] }:$mask, immAllZerosV:{ *:[v8i64] })  =>  (VPCOMPRESSQZrrkz:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src)
     /* 202166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZrrkz),
     /* 202169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202171 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202173 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202175 */     GIR_RootConstrainSelectedInstOperands,
     /* 202176 */     // GIR_Coverage, 21684,
     /* 202176 */     GIR_EraseRootFromParent_Done,
     /* 202177 */   // Label 4554: @202177
     /* 202177 */   GIM_Try, /*On fail goto*//*Label 4555*/ GIMT_Encode4(202210), // Rule ID 21720 //
     /* 202182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 202185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 202189 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 202195 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 202197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202199 */     // (vector_compress:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src, VK8WM:{ *:[v8i1] }:$mask, immAllZerosV:{ *:[v8f64] })  =>  (VCOMPRESSPDZrrkz:{ *:[v8f64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src)
     /* 202199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZrrkz),
     /* 202202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202204 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202206 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202208 */     GIR_RootConstrainSelectedInstOperands,
     /* 202209 */     // GIR_Coverage, 21720,
     /* 202209 */     GIR_EraseRootFromParent_Done,
     /* 202210 */   // Label 4555: @202210
     /* 202210 */   GIM_Try, /*On fail goto*//*Label 4556*/ GIMT_Encode4(202239), // Rule ID 21683 //
     /* 202215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 202218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 202222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 202226 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202228 */     // (vector_compress:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src, VK8WM:{ *:[v8i1] }:$mask, (undef:{ *:[v8i64] }))  =>  (VPCOMPRESSQZrrkz:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src)
     /* 202228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZrrkz),
     /* 202231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202233 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202235 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202237 */     GIR_RootConstrainSelectedInstOperands,
     /* 202238 */     // GIR_Coverage, 21683,
     /* 202238 */     GIR_EraseRootFromParent_Done,
     /* 202239 */   // Label 4556: @202239
     /* 202239 */   GIM_Try, /*On fail goto*//*Label 4557*/ GIMT_Encode4(202268), // Rule ID 21719 //
     /* 202244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 202247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 202251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 202255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202257 */     // (vector_compress:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src, VK8WM:{ *:[v8i1] }:$mask, (undef:{ *:[v8f64] }))  =>  (VCOMPRESSPDZrrkz:{ *:[v8f64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src)
     /* 202257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZrrkz),
     /* 202260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202262 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202264 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202266 */     GIR_RootConstrainSelectedInstOperands,
     /* 202267 */     // GIR_Coverage, 21719,
     /* 202267 */     GIR_EraseRootFromParent_Done,
     /* 202268 */   // Label 4557: @202268
     /* 202268 */   GIM_Try, /*On fail goto*//*Label 4558*/ GIMT_Encode4(202293), // Rule ID 21685 //
     /* 202273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 202276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 202280 */     // (vector_compress:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src, VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$passthru)  =>  (VPCOMPRESSQZrrk:{ *:[v8i64] } VR512:{ *:[v8i64] }:$passthru, VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src)
     /* 202280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZrrk),
     /* 202283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202285 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 202287 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202289 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202291 */     GIR_RootConstrainSelectedInstOperands,
     /* 202292 */     // GIR_Coverage, 21685,
     /* 202292 */     GIR_EraseRootFromParent_Done,
     /* 202293 */   // Label 4558: @202293
     /* 202293 */   GIM_Try, /*On fail goto*//*Label 4559*/ GIMT_Encode4(202318), // Rule ID 21721 //
     /* 202298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 202301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 202305 */     // (vector_compress:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src, VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$passthru)  =>  (VCOMPRESSPDZrrk:{ *:[v8f64] } VR512:{ *:[v8f64] }:$passthru, VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src)
     /* 202305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZrrk),
     /* 202308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202310 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 202312 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202314 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202316 */     GIR_RootConstrainSelectedInstOperands,
     /* 202317 */     // GIR_Coverage, 21721,
     /* 202317 */     GIR_EraseRootFromParent_Done,
     /* 202318 */   // Label 4559: @202318
     /* 202318 */   GIM_Reject,
     /* 202319 */ // Label 4553: @202319
     /* 202319 */ GIM_Reject,
     /* 202320 */ // Label 4514: @202320
     /* 202320 */ GIM_Try, /*On fail goto*//*Label 4560*/ GIMT_Encode4(202434),
     /* 202325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 202328 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /* 202331 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 202334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 202338 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 202342 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 202346 */   GIM_Try, /*On fail goto*//*Label 4561*/ GIMT_Encode4(202379), // Rule ID 22080 //
     /* 202351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 202354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 202358 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 202364 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 202366 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202368 */     // (vector_compress:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src, VK16WM:{ *:[v16i1] }:$mask, immAllZerosV:{ *:[v16i8] })  =>  (VPCOMPRESSBZ128rrkz:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src)
     /* 202368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZ128rrkz),
     /* 202371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202373 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202375 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202377 */     GIR_RootConstrainSelectedInstOperands,
     /* 202378 */     // GIR_Coverage, 22080,
     /* 202378 */     GIR_EraseRootFromParent_Done,
     /* 202379 */   // Label 4561: @202379
     /* 202379 */   GIM_Try, /*On fail goto*//*Label 4562*/ GIMT_Encode4(202408), // Rule ID 22079 //
     /* 202384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 202387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 202391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 202395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202397 */     // (vector_compress:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src, VK16WM:{ *:[v16i1] }:$mask, (undef:{ *:[v16i8] }))  =>  (VPCOMPRESSBZ128rrkz:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src)
     /* 202397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZ128rrkz),
     /* 202400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202402 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202404 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202406 */     GIR_RootConstrainSelectedInstOperands,
     /* 202407 */     // GIR_Coverage, 22079,
     /* 202407 */     GIR_EraseRootFromParent_Done,
     /* 202408 */   // Label 4562: @202408
     /* 202408 */   GIM_Try, /*On fail goto*//*Label 4563*/ GIMT_Encode4(202433), // Rule ID 22081 //
     /* 202413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 202416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 202420 */     // (vector_compress:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src, VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$passthru)  =>  (VPCOMPRESSBZ128rrk:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$passthru, VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src)
     /* 202420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZ128rrk),
     /* 202423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202425 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 202427 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202429 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202431 */     GIR_RootConstrainSelectedInstOperands,
     /* 202432 */     // GIR_Coverage, 22081,
     /* 202432 */     GIR_EraseRootFromParent_Done,
     /* 202433 */   // Label 4563: @202433
     /* 202433 */   GIM_Reject,
     /* 202434 */ // Label 4560: @202434
     /* 202434 */ GIM_Reject,
     /* 202435 */ // Label 4515: @202435
     /* 202435 */ GIM_Try, /*On fail goto*//*Label 4564*/ GIMT_Encode4(202549),
     /* 202440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 202443 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /* 202446 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 202449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 202453 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 202457 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 202461 */   GIM_Try, /*On fail goto*//*Label 4565*/ GIMT_Encode4(202494), // Rule ID 22092 //
     /* 202466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 202469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 202473 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 202479 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 202481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202483 */     // (vector_compress:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src, VK16WM:{ *:[v16i1] }:$mask, immAllZerosV:{ *:[v16i16] })  =>  (VPCOMPRESSWZ256rrkz:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src)
     /* 202483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZ256rrkz),
     /* 202486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202488 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202490 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202492 */     GIR_RootConstrainSelectedInstOperands,
     /* 202493 */     // GIR_Coverage, 22092,
     /* 202493 */     GIR_EraseRootFromParent_Done,
     /* 202494 */   // Label 4565: @202494
     /* 202494 */   GIM_Try, /*On fail goto*//*Label 4566*/ GIMT_Encode4(202523), // Rule ID 22091 //
     /* 202499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 202502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 202506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 202510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202512 */     // (vector_compress:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src, VK16WM:{ *:[v16i1] }:$mask, (undef:{ *:[v16i16] }))  =>  (VPCOMPRESSWZ256rrkz:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src)
     /* 202512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZ256rrkz),
     /* 202515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202517 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202519 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202521 */     GIR_RootConstrainSelectedInstOperands,
     /* 202522 */     // GIR_Coverage, 22091,
     /* 202522 */     GIR_EraseRootFromParent_Done,
     /* 202523 */   // Label 4566: @202523
     /* 202523 */   GIM_Try, /*On fail goto*//*Label 4567*/ GIMT_Encode4(202548), // Rule ID 22093 //
     /* 202528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 202531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 202535 */     // (vector_compress:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src, VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$passthru)  =>  (VPCOMPRESSWZ256rrk:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$passthru, VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src)
     /* 202535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZ256rrk),
     /* 202538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202540 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 202542 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202544 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202546 */     GIR_RootConstrainSelectedInstOperands,
     /* 202547 */     // GIR_Coverage, 22093,
     /* 202547 */     GIR_EraseRootFromParent_Done,
     /* 202548 */   // Label 4567: @202548
     /* 202548 */   GIM_Reject,
     /* 202549 */ // Label 4564: @202549
     /* 202549 */ GIM_Reject,
     /* 202550 */ // Label 4516: @202550
     /* 202550 */ GIM_Try, /*On fail goto*//*Label 4568*/ GIMT_Encode4(202751),
     /* 202555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 202558 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /* 202561 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /* 202564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 202568 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 202572 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 202576 */   GIM_Try, /*On fail goto*//*Label 4569*/ GIMT_Encode4(202609), // Rule ID 21666 //
     /* 202581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 202584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 202588 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 202594 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 202596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202598 */     // (vector_compress:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src, VK16WM:{ *:[v16i1] }:$mask, immAllZerosV:{ *:[v16i32] })  =>  (VPCOMPRESSDZrrkz:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src)
     /* 202598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZrrkz),
     /* 202601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202603 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202605 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202607 */     GIR_RootConstrainSelectedInstOperands,
     /* 202608 */     // GIR_Coverage, 21666,
     /* 202608 */     GIR_EraseRootFromParent_Done,
     /* 202609 */   // Label 4569: @202609
     /* 202609 */   GIM_Try, /*On fail goto*//*Label 4570*/ GIMT_Encode4(202642), // Rule ID 21702 //
     /* 202614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 202617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 202621 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 202627 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 202629 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202631 */     // (vector_compress:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src, VK16WM:{ *:[v16i1] }:$mask, immAllZerosV:{ *:[v16f32] })  =>  (VCOMPRESSPSZrrkz:{ *:[v16f32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src)
     /* 202631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZrrkz),
     /* 202634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202636 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202638 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202640 */     GIR_RootConstrainSelectedInstOperands,
     /* 202641 */     // GIR_Coverage, 21702,
     /* 202641 */     GIR_EraseRootFromParent_Done,
     /* 202642 */   // Label 4570: @202642
     /* 202642 */   GIM_Try, /*On fail goto*//*Label 4571*/ GIMT_Encode4(202671), // Rule ID 21665 //
     /* 202647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 202650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 202654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 202658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202660 */     // (vector_compress:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src, VK16WM:{ *:[v16i1] }:$mask, (undef:{ *:[v16i32] }))  =>  (VPCOMPRESSDZrrkz:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src)
     /* 202660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZrrkz),
     /* 202663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202665 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202667 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202669 */     GIR_RootConstrainSelectedInstOperands,
     /* 202670 */     // GIR_Coverage, 21665,
     /* 202670 */     GIR_EraseRootFromParent_Done,
     /* 202671 */   // Label 4571: @202671
     /* 202671 */   GIM_Try, /*On fail goto*//*Label 4572*/ GIMT_Encode4(202700), // Rule ID 21701 //
     /* 202676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 202679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 202683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 202687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202689 */     // (vector_compress:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src, VK16WM:{ *:[v16i1] }:$mask, (undef:{ *:[v16f32] }))  =>  (VCOMPRESSPSZrrkz:{ *:[v16f32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src)
     /* 202689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZrrkz),
     /* 202692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202694 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202696 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202698 */     GIR_RootConstrainSelectedInstOperands,
     /* 202699 */     // GIR_Coverage, 21701,
     /* 202699 */     GIR_EraseRootFromParent_Done,
     /* 202700 */   // Label 4572: @202700
     /* 202700 */   GIM_Try, /*On fail goto*//*Label 4573*/ GIMT_Encode4(202725), // Rule ID 21667 //
     /* 202705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 202708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 202712 */     // (vector_compress:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src, VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$passthru)  =>  (VPCOMPRESSDZrrk:{ *:[v16i32] } VR512:{ *:[v16i32] }:$passthru, VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src)
     /* 202712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZrrk),
     /* 202715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202717 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 202719 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202721 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202723 */     GIR_RootConstrainSelectedInstOperands,
     /* 202724 */     // GIR_Coverage, 21667,
     /* 202724 */     GIR_EraseRootFromParent_Done,
     /* 202725 */   // Label 4573: @202725
     /* 202725 */   GIM_Try, /*On fail goto*//*Label 4574*/ GIMT_Encode4(202750), // Rule ID 21703 //
     /* 202730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 202733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 202737 */     // (vector_compress:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src, VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$passthru)  =>  (VCOMPRESSPSZrrk:{ *:[v16f32] } VR512:{ *:[v16f32] }:$passthru, VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src)
     /* 202737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZrrk),
     /* 202740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202742 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 202744 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202746 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202748 */     GIR_RootConstrainSelectedInstOperands,
     /* 202749 */     // GIR_Coverage, 21703,
     /* 202749 */     GIR_EraseRootFromParent_Done,
     /* 202750 */   // Label 4574: @202750
     /* 202750 */   GIM_Reject,
     /* 202751 */ // Label 4568: @202751
     /* 202751 */ GIM_Reject,
     /* 202752 */ // Label 4517: @202752
     /* 202752 */ GIM_Try, /*On fail goto*//*Label 4575*/ GIMT_Encode4(202866),
     /* 202757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 202760 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s1,
     /* 202763 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s8,
     /* 202766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 202770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 202774 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32WMRegClassID),
     /* 202778 */   GIM_Try, /*On fail goto*//*Label 4576*/ GIMT_Encode4(202811), // Rule ID 22074 //
     /* 202783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 202786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 202790 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 202796 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 202798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202800 */     // (vector_compress:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src, VK32WM:{ *:[v32i1] }:$mask, immAllZerosV:{ *:[v32i8] })  =>  (VPCOMPRESSBZ256rrkz:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src)
     /* 202800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZ256rrkz),
     /* 202803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202805 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202807 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202809 */     GIR_RootConstrainSelectedInstOperands,
     /* 202810 */     // GIR_Coverage, 22074,
     /* 202810 */     GIR_EraseRootFromParent_Done,
     /* 202811 */   // Label 4576: @202811
     /* 202811 */   GIM_Try, /*On fail goto*//*Label 4577*/ GIMT_Encode4(202840), // Rule ID 22073 //
     /* 202816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 202819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 202823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 202827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202829 */     // (vector_compress:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src, VK32WM:{ *:[v32i1] }:$mask, (undef:{ *:[v32i8] }))  =>  (VPCOMPRESSBZ256rrkz:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src)
     /* 202829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZ256rrkz),
     /* 202832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202834 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202836 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202838 */     GIR_RootConstrainSelectedInstOperands,
     /* 202839 */     // GIR_Coverage, 22073,
     /* 202839 */     GIR_EraseRootFromParent_Done,
     /* 202840 */   // Label 4577: @202840
     /* 202840 */   GIM_Try, /*On fail goto*//*Label 4578*/ GIMT_Encode4(202865), // Rule ID 22075 //
     /* 202845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 202848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 202852 */     // (vector_compress:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src, VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$passthru)  =>  (VPCOMPRESSBZ256rrk:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$passthru, VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src)
     /* 202852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZ256rrk),
     /* 202855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202857 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 202859 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202861 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202863 */     GIR_RootConstrainSelectedInstOperands,
     /* 202864 */     // GIR_Coverage, 22075,
     /* 202864 */     GIR_EraseRootFromParent_Done,
     /* 202865 */   // Label 4578: @202865
     /* 202865 */   GIM_Reject,
     /* 202866 */ // Label 4575: @202866
     /* 202866 */ GIM_Reject,
     /* 202867 */ // Label 4518: @202867
     /* 202867 */ GIM_Try, /*On fail goto*//*Label 4579*/ GIMT_Encode4(202981),
     /* 202872 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 202875 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s1,
     /* 202878 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s16,
     /* 202881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 202885 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 202889 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32WMRegClassID),
     /* 202893 */   GIM_Try, /*On fail goto*//*Label 4580*/ GIMT_Encode4(202926), // Rule ID 22086 //
     /* 202898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2),
     /* 202901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 202905 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 202911 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 202913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202915 */     // (vector_compress:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src, VK32WM:{ *:[v32i1] }:$mask, immAllZerosV:{ *:[v32i16] })  =>  (VPCOMPRESSWZrrkz:{ *:[v32i16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src)
     /* 202915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZrrkz),
     /* 202918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202920 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202922 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202924 */     GIR_RootConstrainSelectedInstOperands,
     /* 202925 */     // GIR_Coverage, 22086,
     /* 202925 */     GIR_EraseRootFromParent_Done,
     /* 202926 */   // Label 4580: @202926
     /* 202926 */   GIM_Try, /*On fail goto*//*Label 4581*/ GIMT_Encode4(202955), // Rule ID 22085 //
     /* 202931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2),
     /* 202934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 202938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 202942 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202944 */     // (vector_compress:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src, VK32WM:{ *:[v32i1] }:$mask, (undef:{ *:[v32i16] }))  =>  (VPCOMPRESSWZrrkz:{ *:[v32i16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src)
     /* 202944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZrrkz),
     /* 202947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202949 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202951 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202953 */     GIR_RootConstrainSelectedInstOperands,
     /* 202954 */     // GIR_Coverage, 22085,
     /* 202954 */     GIR_EraseRootFromParent_Done,
     /* 202955 */   // Label 4581: @202955
     /* 202955 */   GIM_Try, /*On fail goto*//*Label 4582*/ GIMT_Encode4(202980), // Rule ID 22087 //
     /* 202960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2),
     /* 202963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 202967 */     // (vector_compress:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src, VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$passthru)  =>  (VPCOMPRESSWZrrk:{ *:[v32i16] } VR512:{ *:[v32i16] }:$passthru, VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src)
     /* 202967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZrrk),
     /* 202970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202972 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 202974 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202976 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202978 */     GIR_RootConstrainSelectedInstOperands,
     /* 202979 */     // GIR_Coverage, 22087,
     /* 202979 */     GIR_EraseRootFromParent_Done,
     /* 202980 */   // Label 4582: @202980
     /* 202980 */   GIM_Reject,
     /* 202981 */ // Label 4579: @202981
     /* 202981 */ GIM_Reject,
     /* 202982 */ // Label 4519: @202982
     /* 202982 */ GIM_Try, /*On fail goto*//*Label 4583*/ GIMT_Encode4(203096),
     /* 202987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 202990 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s1,
     /* 202993 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v64s8,
     /* 202996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 203000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 203004 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64WMRegClassID),
     /* 203008 */   GIM_Try, /*On fail goto*//*Label 4584*/ GIMT_Encode4(203041), // Rule ID 22068 //
     /* 203013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2),
     /* 203016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 203020 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 203026 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 203028 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 203030 */     // (vector_compress:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src, VK64WM:{ *:[v64i1] }:$mask, immAllZerosV:{ *:[v64i8] })  =>  (VPCOMPRESSBZrrkz:{ *:[v64i8] } VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src)
     /* 203030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZrrkz),
     /* 203033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203035 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 203037 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 203039 */     GIR_RootConstrainSelectedInstOperands,
     /* 203040 */     // GIR_Coverage, 22068,
     /* 203040 */     GIR_EraseRootFromParent_Done,
     /* 203041 */   // Label 4584: @203041
     /* 203041 */   GIM_Try, /*On fail goto*//*Label 4585*/ GIMT_Encode4(203070), // Rule ID 22067 //
     /* 203046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2),
     /* 203049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 203053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 203057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 203059 */     // (vector_compress:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src, VK64WM:{ *:[v64i1] }:$mask, (undef:{ *:[v64i8] }))  =>  (VPCOMPRESSBZrrkz:{ *:[v64i8] } VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src)
     /* 203059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZrrkz),
     /* 203062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203064 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 203066 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 203068 */     GIR_RootConstrainSelectedInstOperands,
     /* 203069 */     // GIR_Coverage, 22067,
     /* 203069 */     GIR_EraseRootFromParent_Done,
     /* 203070 */   // Label 4585: @203070
     /* 203070 */   GIM_Try, /*On fail goto*//*Label 4586*/ GIMT_Encode4(203095), // Rule ID 22069 //
     /* 203075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2),
     /* 203078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 203082 */     // (vector_compress:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src, VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$passthru)  =>  (VPCOMPRESSBZrrk:{ *:[v64i8] } VR512:{ *:[v64i8] }:$passthru, VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src)
     /* 203082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZrrk),
     /* 203085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203087 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 203089 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 203091 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 203093 */     GIR_RootConstrainSelectedInstOperands,
     /* 203094 */     // GIR_Coverage, 22069,
     /* 203094 */     GIR_EraseRootFromParent_Done,
     /* 203095 */   // Label 4586: @203095
     /* 203095 */   GIM_Reject,
     /* 203096 */ // Label 4583: @203096
     /* 203096 */ GIM_Reject,
     /* 203097 */ // Label 4520: @203097
     /* 203097 */ GIM_Reject,
     /* 203098 */ // Label 62: @203098
     /* 203098 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 4590*/ GIMT_Encode4(203403),
     /* 203109 */ /*GILLT_s16*//*Label 4587*/ GIMT_Encode4(203121),
     /* 203113 */ /*GILLT_s32*//*Label 4588*/ GIMT_Encode4(203215),
     /* 203117 */ /*GILLT_s64*//*Label 4589*/ GIMT_Encode4(203309),
     /* 203121 */ // Label 4587: @203121
     /* 203121 */ GIM_Try, /*On fail goto*//*Label 4591*/ GIMT_Encode4(203214),
     /* 203126 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 203129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 203133 */   GIM_Try, /*On fail goto*//*Label 4592*/ GIMT_Encode4(203188), // Rule ID 77 //
     /* 203138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI),
     /* 203141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 203145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 203149 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 203152 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 203156 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 203160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 203162 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 203169 */     // (cttz:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (TZCNT16rm:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 203169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TZCNT16rm),
     /* 203172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203174 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 203178 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 203181 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 203186 */     GIR_RootConstrainSelectedInstOperands,
     /* 203187 */     // GIR_Coverage, 77,
     /* 203187 */     GIR_EraseRootFromParent_Done,
     /* 203188 */   // Label 4592: @203188
     /* 203188 */   GIM_Try, /*On fail goto*//*Label 4593*/ GIMT_Encode4(203213), // Rule ID 76 //
     /* 203193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI),
     /* 203196 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 203200 */     // (cttz:{ *:[i16] } GR16:{ *:[i16] }:$src1)  =>  (TZCNT16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 203200 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::TZCNT16rr),
     /* 203205 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 203211 */     GIR_RootConstrainSelectedInstOperands,
     /* 203212 */     // GIR_Coverage, 76,
     /* 203212 */     GIR_Done,
     /* 203213 */   // Label 4593: @203213
     /* 203213 */   GIM_Reject,
     /* 203214 */ // Label 4591: @203214
     /* 203214 */ GIM_Reject,
     /* 203215 */ // Label 4588: @203215
     /* 203215 */ GIM_Try, /*On fail goto*//*Label 4594*/ GIMT_Encode4(203308),
     /* 203220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 203223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 203227 */   GIM_Try, /*On fail goto*//*Label 4595*/ GIMT_Encode4(203282), // Rule ID 79 //
     /* 203232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI),
     /* 203235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 203239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 203243 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 203246 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 203250 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 203254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 203256 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 203263 */     // (cttz:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (TZCNT32rm:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 203263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TZCNT32rm),
     /* 203266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203268 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 203272 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 203275 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 203280 */     GIR_RootConstrainSelectedInstOperands,
     /* 203281 */     // GIR_Coverage, 79,
     /* 203281 */     GIR_EraseRootFromParent_Done,
     /* 203282 */   // Label 4595: @203282
     /* 203282 */   GIM_Try, /*On fail goto*//*Label 4596*/ GIMT_Encode4(203307), // Rule ID 78 //
     /* 203287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI),
     /* 203290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 203294 */     // (cttz:{ *:[i32] } GR32:{ *:[i32] }:$src1)  =>  (TZCNT32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 203294 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::TZCNT32rr),
     /* 203299 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 203305 */     GIR_RootConstrainSelectedInstOperands,
     /* 203306 */     // GIR_Coverage, 78,
     /* 203306 */     GIR_Done,
     /* 203307 */   // Label 4596: @203307
     /* 203307 */   GIM_Reject,
     /* 203308 */ // Label 4594: @203308
     /* 203308 */ GIM_Reject,
     /* 203309 */ // Label 4589: @203309
     /* 203309 */ GIM_Try, /*On fail goto*//*Label 4597*/ GIMT_Encode4(203402),
     /* 203314 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 203317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 203321 */   GIM_Try, /*On fail goto*//*Label 4598*/ GIMT_Encode4(203376), // Rule ID 81 //
     /* 203326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI),
     /* 203329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 203333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 203337 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 203340 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 203344 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 203348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 203350 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 203357 */     // (cttz:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (TZCNT64rm:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 203357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TZCNT64rm),
     /* 203360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203362 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 203366 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 203369 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 203374 */     GIR_RootConstrainSelectedInstOperands,
     /* 203375 */     // GIR_Coverage, 81,
     /* 203375 */     GIR_EraseRootFromParent_Done,
     /* 203376 */   // Label 4598: @203376
     /* 203376 */   GIM_Try, /*On fail goto*//*Label 4599*/ GIMT_Encode4(203401), // Rule ID 80 //
     /* 203381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI),
     /* 203384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 203388 */     // (cttz:{ *:[i64] } GR64:{ *:[i64] }:$src1)  =>  (TZCNT64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 203388 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::TZCNT64rr),
     /* 203393 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 203399 */     GIR_RootConstrainSelectedInstOperands,
     /* 203400 */     // GIR_Coverage, 80,
     /* 203400 */     GIR_Done,
     /* 203401 */   // Label 4599: @203401
     /* 203401 */   GIM_Reject,
     /* 203402 */ // Label 4597: @203402
     /* 203402 */ GIM_Reject,
     /* 203403 */ // Label 4590: @203403
     /* 203403 */ GIM_Reject,
     /* 203404 */ // Label 63: @203404
     /* 203404 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 4603*/ GIMT_Encode4(203790),
     /* 203415 */ /*GILLT_s16*//*Label 4600*/ GIMT_Encode4(203427),
     /* 203419 */ /*GILLT_s32*//*Label 4601*/ GIMT_Encode4(203548),
     /* 203423 */ /*GILLT_s64*//*Label 4602*/ GIMT_Encode4(203669),
     /* 203427 */ // Label 4600: @203427
     /* 203427 */ GIM_Try, /*On fail goto*//*Label 4604*/ GIMT_Encode4(203547),
     /* 203432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 203435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 203439 */   GIM_Try, /*On fail goto*//*Label 4605*/ GIMT_Encode4(203508), // Rule ID 22985 //
     /* 203444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 203448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 203452 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 203455 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 203459 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 203463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 203465 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 203472 */     // (cttz_zero_undef:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (BSF16rm:{ *:[i16] }:{ *:[i32] } (IMPLICIT_DEF:{ *:[i16] }), addr:{ *:[iPTR] }:$src)
     /* 203472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 203475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 203479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 203486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BSF16rm),
     /* 203489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203491 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 203494 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 203498 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 203501 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 203506 */     GIR_RootConstrainSelectedInstOperands,
     /* 203507 */     // GIR_Coverage, 22985,
     /* 203507 */     GIR_EraseRootFromParent_Done,
     /* 203508 */   // Label 4605: @203508
     /* 203508 */   GIM_Try, /*On fail goto*//*Label 4606*/ GIMT_Encode4(203546), // Rule ID 22982 //
     /* 203513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 203517 */     // (cttz_zero_undef:{ *:[i16] } GR16:{ *:[i16] }:$src)  =>  (BSF16rr:{ *:[i16] }:{ *:[i32] } (IMPLICIT_DEF:{ *:[i16] }), GR16:{ *:[i16] }:$src)
     /* 203517 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 203520 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 203524 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203529 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 203531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BSF16rr),
     /* 203534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203536 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 203539 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 203541 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 203544 */     GIR_RootConstrainSelectedInstOperands,
     /* 203545 */     // GIR_Coverage, 22982,
     /* 203545 */     GIR_EraseRootFromParent_Done,
     /* 203546 */   // Label 4606: @203546
     /* 203546 */   GIM_Reject,
     /* 203547 */ // Label 4604: @203547
     /* 203547 */ GIM_Reject,
     /* 203548 */ // Label 4601: @203548
     /* 203548 */ GIM_Try, /*On fail goto*//*Label 4607*/ GIMT_Encode4(203668),
     /* 203553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 203556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 203560 */   GIM_Try, /*On fail goto*//*Label 4608*/ GIMT_Encode4(203629), // Rule ID 22986 //
     /* 203565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 203569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 203573 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 203576 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 203580 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 203584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 203586 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 203593 */     // (cttz_zero_undef:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (BSF32rm:{ *:[i32] }:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), addr:{ *:[iPTR] }:$src)
     /* 203593 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 203596 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 203600 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203605 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 203607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BSF32rm),
     /* 203610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203612 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 203615 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 203619 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 203622 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 203627 */     GIR_RootConstrainSelectedInstOperands,
     /* 203628 */     // GIR_Coverage, 22986,
     /* 203628 */     GIR_EraseRootFromParent_Done,
     /* 203629 */   // Label 4608: @203629
     /* 203629 */   GIM_Try, /*On fail goto*//*Label 4609*/ GIMT_Encode4(203667), // Rule ID 22983 //
     /* 203634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 203638 */     // (cttz_zero_undef:{ *:[i32] } GR32:{ *:[i32] }:$src)  =>  (BSF32rr:{ *:[i32] }:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR32:{ *:[i32] }:$src)
     /* 203638 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 203641 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 203645 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203650 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 203652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BSF32rr),
     /* 203655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203657 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 203660 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 203662 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 203665 */     GIR_RootConstrainSelectedInstOperands,
     /* 203666 */     // GIR_Coverage, 22983,
     /* 203666 */     GIR_EraseRootFromParent_Done,
     /* 203667 */   // Label 4609: @203667
     /* 203667 */   GIM_Reject,
     /* 203668 */ // Label 4607: @203668
     /* 203668 */ GIM_Reject,
     /* 203669 */ // Label 4602: @203669
     /* 203669 */ GIM_Try, /*On fail goto*//*Label 4610*/ GIMT_Encode4(203789),
     /* 203674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 203677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 203681 */   GIM_Try, /*On fail goto*//*Label 4611*/ GIMT_Encode4(203750), // Rule ID 22987 //
     /* 203686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 203690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 203694 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 203697 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 203701 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 203705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 203707 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 203714 */     // (cttz_zero_undef:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (BSF64rm:{ *:[i64] }:{ *:[i32] } (IMPLICIT_DEF:{ *:[i64] }), addr:{ *:[iPTR] }:$src)
     /* 203714 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 203717 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 203721 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203726 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 203728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BSF64rm),
     /* 203731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203733 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 203736 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 203740 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 203743 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 203748 */     GIR_RootConstrainSelectedInstOperands,
     /* 203749 */     // GIR_Coverage, 22987,
     /* 203749 */     GIR_EraseRootFromParent_Done,
     /* 203750 */   // Label 4611: @203750
     /* 203750 */   GIM_Try, /*On fail goto*//*Label 4612*/ GIMT_Encode4(203788), // Rule ID 22984 //
     /* 203755 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 203759 */     // (cttz_zero_undef:{ *:[i64] } GR64:{ *:[i64] }:$src)  =>  (BSF64rr:{ *:[i64] }:{ *:[i32] } (IMPLICIT_DEF:{ *:[i64] }), GR64:{ *:[i64] }:$src)
     /* 203759 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 203762 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 203766 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203771 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 203773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BSF64rr),
     /* 203776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203778 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 203781 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 203783 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 203786 */     GIR_RootConstrainSelectedInstOperands,
     /* 203787 */     // GIR_Coverage, 22984,
     /* 203787 */     GIR_EraseRootFromParent_Done,
     /* 203788 */   // Label 4612: @203788
     /* 203788 */   GIM_Reject,
     /* 203789 */ // Label 4610: @203789
     /* 203789 */ GIM_Reject,
     /* 203790 */ // Label 4603: @203790
     /* 203790 */ GIM_Reject,
     /* 203791 */ // Label 64: @203791
     /* 203791 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(20), /*)*//*default:*//*Label 4622*/ GIMT_Encode4(205094),
     /* 203802 */ /*GILLT_s16*//*Label 4613*/ GIMT_Encode4(203874),
     /* 203806 */ /*GILLT_s32*//*Label 4614*/ GIMT_Encode4(203968),
     /* 203810 */ /*GILLT_s64*//*Label 4615*/ GIMT_Encode4(204062), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 203826 */ /*GILLT_v2s64*//*Label 4616*/ GIMT_Encode4(204156), GIMT_Encode4(0),
     /* 203834 */ /*GILLT_v4s32*//*Label 4617*/ GIMT_Encode4(204352),
     /* 203838 */ /*GILLT_v4s64*//*Label 4618*/ GIMT_Encode4(204548), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 203850 */ /*GILLT_v8s32*//*Label 4619*/ GIMT_Encode4(204736),
     /* 203854 */ /*GILLT_v8s64*//*Label 4620*/ GIMT_Encode4(204924), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 203870 */ /*GILLT_v16s32*//*Label 4621*/ GIMT_Encode4(205009),
     /* 203874 */ // Label 4613: @203874
     /* 203874 */ GIM_Try, /*On fail goto*//*Label 4623*/ GIMT_Encode4(203967),
     /* 203879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 203882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 203886 */   GIM_Try, /*On fail goto*//*Label 4624*/ GIMT_Encode4(203941), // Rule ID 71 //
     /* 203891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLZCNT),
     /* 203894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 203898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 203902 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 203905 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 203909 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 203913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 203915 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 203922 */     // (ctlz:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (LZCNT16rm:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 203922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LZCNT16rm),
     /* 203925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203927 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 203931 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 203934 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 203939 */     GIR_RootConstrainSelectedInstOperands,
     /* 203940 */     // GIR_Coverage, 71,
     /* 203940 */     GIR_EraseRootFromParent_Done,
     /* 203941 */   // Label 4624: @203941
     /* 203941 */   GIM_Try, /*On fail goto*//*Label 4625*/ GIMT_Encode4(203966), // Rule ID 70 //
     /* 203946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLZCNT),
     /* 203949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 203953 */     // (ctlz:{ *:[i16] } GR16:{ *:[i16] }:$src1)  =>  (LZCNT16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 203953 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::LZCNT16rr),
     /* 203958 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 203964 */     GIR_RootConstrainSelectedInstOperands,
     /* 203965 */     // GIR_Coverage, 70,
     /* 203965 */     GIR_Done,
     /* 203966 */   // Label 4625: @203966
     /* 203966 */   GIM_Reject,
     /* 203967 */ // Label 4623: @203967
     /* 203967 */ GIM_Reject,
     /* 203968 */ // Label 4614: @203968
     /* 203968 */ GIM_Try, /*On fail goto*//*Label 4626*/ GIMT_Encode4(204061),
     /* 203973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 203976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 203980 */   GIM_Try, /*On fail goto*//*Label 4627*/ GIMT_Encode4(204035), // Rule ID 73 //
     /* 203985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLZCNT),
     /* 203988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 203992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 203996 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 203999 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 204003 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 204007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 204009 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 204016 */     // (ctlz:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (LZCNT32rm:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 204016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LZCNT32rm),
     /* 204019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204021 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 204025 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 204028 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 204033 */     GIR_RootConstrainSelectedInstOperands,
     /* 204034 */     // GIR_Coverage, 73,
     /* 204034 */     GIR_EraseRootFromParent_Done,
     /* 204035 */   // Label 4627: @204035
     /* 204035 */   GIM_Try, /*On fail goto*//*Label 4628*/ GIMT_Encode4(204060), // Rule ID 72 //
     /* 204040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLZCNT),
     /* 204043 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 204047 */     // (ctlz:{ *:[i32] } GR32:{ *:[i32] }:$src1)  =>  (LZCNT32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 204047 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::LZCNT32rr),
     /* 204052 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 204058 */     GIR_RootConstrainSelectedInstOperands,
     /* 204059 */     // GIR_Coverage, 72,
     /* 204059 */     GIR_Done,
     /* 204060 */   // Label 4628: @204060
     /* 204060 */   GIM_Reject,
     /* 204061 */ // Label 4626: @204061
     /* 204061 */ GIM_Reject,
     /* 204062 */ // Label 4615: @204062
     /* 204062 */ GIM_Try, /*On fail goto*//*Label 4629*/ GIMT_Encode4(204155),
     /* 204067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 204070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 204074 */   GIM_Try, /*On fail goto*//*Label 4630*/ GIMT_Encode4(204129), // Rule ID 75 //
     /* 204079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLZCNT),
     /* 204082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 204086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 204090 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 204093 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 204097 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 204101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 204103 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 204110 */     // (ctlz:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LZCNT64rm:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 204110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LZCNT64rm),
     /* 204113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204115 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 204119 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 204122 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 204127 */     GIR_RootConstrainSelectedInstOperands,
     /* 204128 */     // GIR_Coverage, 75,
     /* 204128 */     GIR_EraseRootFromParent_Done,
     /* 204129 */   // Label 4630: @204129
     /* 204129 */   GIM_Try, /*On fail goto*//*Label 4631*/ GIMT_Encode4(204154), // Rule ID 74 //
     /* 204134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLZCNT),
     /* 204137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 204141 */     // (ctlz:{ *:[i64] } GR64:{ *:[i64] }:$src1)  =>  (LZCNT64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 204141 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::LZCNT64rr),
     /* 204146 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 204152 */     GIR_RootConstrainSelectedInstOperands,
     /* 204153 */     // GIR_Coverage, 74,
     /* 204153 */     GIR_Done,
     /* 204154 */   // Label 4631: @204154
     /* 204154 */   GIM_Reject,
     /* 204155 */ // Label 4629: @204155
     /* 204155 */ GIM_Reject,
     /* 204156 */ // Label 4616: @204156
     /* 204156 */ GIM_Try, /*On fail goto*//*Label 4632*/ GIMT_Encode4(204351),
     /* 204161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 204164 */   GIM_Try, /*On fail goto*//*Label 4633*/ GIMT_Encode4(204220), // Rule ID 13357 //
     /* 204169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 204172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 204176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 204180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 204184 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 204187 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 204191 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 204195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 204197 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 204204 */     // (ctlz:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPLZCNTQZ128rm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)
     /* 204204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZ128rm),
     /* 204207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204209 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 204213 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 204218 */     GIR_RootConstrainSelectedInstOperands,
     /* 204219 */     // GIR_Coverage, 13357,
     /* 204219 */     GIR_EraseRootFromParent_Done,
     /* 204220 */   // Label 4633: @204220
     /* 204220 */   GIM_Try, /*On fail goto*//*Label 4634*/ GIMT_Encode4(204243), // Rule ID 13354 //
     /* 204225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 204228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 204232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 204236 */     // (ctlz:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)  =>  (VPLZCNTQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)
     /* 204236 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZ128rr),
     /* 204241 */     GIR_RootConstrainSelectedInstOperands,
     /* 204242 */     // GIR_Coverage, 13354,
     /* 204242 */     GIR_Done,
     /* 204243 */   // Label 4634: @204243
     /* 204243 */   GIM_Try, /*On fail goto*//*Label 4635*/ GIMT_Encode4(204350), // Rule ID 21826 //
     /* 204248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasEVEX512_NoVLX),
     /* 204251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 204255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 204259 */     // (ctlz:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPLZCNTQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 204259 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 204262 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 204266 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204271 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 204273 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 204276 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 204280 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204285 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 204288 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 204292 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 204295 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 204300 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 204305 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 204310 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 204313 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZrr),
     /* 204317 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204322 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 204325 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 204327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 204330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204332 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 204339 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 204344 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 204349 */     // GIR_Coverage, 21826,
     /* 204349 */     GIR_EraseRootFromParent_Done,
     /* 204350 */   // Label 4635: @204350
     /* 204350 */   GIM_Reject,
     /* 204351 */ // Label 4632: @204351
     /* 204351 */ GIM_Reject,
     /* 204352 */ // Label 4617: @204352
     /* 204352 */ GIM_Try, /*On fail goto*//*Label 4636*/ GIMT_Encode4(204547),
     /* 204357 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 204360 */   GIM_Try, /*On fail goto*//*Label 4637*/ GIMT_Encode4(204416), // Rule ID 13384 //
     /* 204365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 204368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 204372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 204376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 204380 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 204383 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 204387 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 204391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 204393 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 204400 */     // (ctlz:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPLZCNTDZ128rm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src1)
     /* 204400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZ128rm),
     /* 204403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204405 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 204409 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 204414 */     GIR_RootConstrainSelectedInstOperands,
     /* 204415 */     // GIR_Coverage, 13384,
     /* 204415 */     GIR_EraseRootFromParent_Done,
     /* 204416 */   // Label 4637: @204416
     /* 204416 */   GIM_Try, /*On fail goto*//*Label 4638*/ GIMT_Encode4(204439), // Rule ID 13381 //
     /* 204421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 204424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 204428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 204432 */     // (ctlz:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)  =>  (VPLZCNTDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)
     /* 204432 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZ128rr),
     /* 204437 */     GIR_RootConstrainSelectedInstOperands,
     /* 204438 */     // GIR_Coverage, 13381,
     /* 204438 */     GIR_Done,
     /* 204439 */   // Label 4638: @204439
     /* 204439 */   GIM_Try, /*On fail goto*//*Label 4639*/ GIMT_Encode4(204546), // Rule ID 21828 //
     /* 204444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasEVEX512_NoVLX),
     /* 204447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 204451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 204455 */     // (ctlz:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VPLZCNTDZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 204455 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 204458 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 204462 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204467 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 204469 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 204472 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 204476 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204481 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 204484 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 204488 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 204491 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 204496 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 204501 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 204506 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 204509 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZrr),
     /* 204513 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204518 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 204521 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 204523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 204526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204528 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 204535 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 204540 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 204545 */     // GIR_Coverage, 21828,
     /* 204545 */     GIR_EraseRootFromParent_Done,
     /* 204546 */   // Label 4639: @204546
     /* 204546 */   GIM_Reject,
     /* 204547 */ // Label 4636: @204547
     /* 204547 */ GIM_Reject,
     /* 204548 */ // Label 4618: @204548
     /* 204548 */ GIM_Try, /*On fail goto*//*Label 4640*/ GIMT_Encode4(204735),
     /* 204553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 204556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 204560 */   GIM_Try, /*On fail goto*//*Label 4641*/ GIMT_Encode4(204612), // Rule ID 13348 //
     /* 204565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 204568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 204572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 204576 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 204579 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 204583 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 204587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 204589 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 204596 */     // (ctlz:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPLZCNTQZ256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src1)
     /* 204596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZ256rm),
     /* 204599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204601 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 204605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 204610 */     GIR_RootConstrainSelectedInstOperands,
     /* 204611 */     // GIR_Coverage, 13348,
     /* 204611 */     GIR_EraseRootFromParent_Done,
     /* 204612 */   // Label 4641: @204612
     /* 204612 */   GIM_Try, /*On fail goto*//*Label 4642*/ GIMT_Encode4(204631), // Rule ID 13345 //
     /* 204617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 204620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 204624 */     // (ctlz:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)  =>  (VPLZCNTQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)
     /* 204624 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZ256rr),
     /* 204629 */     GIR_RootConstrainSelectedInstOperands,
     /* 204630 */     // GIR_Coverage, 13345,
     /* 204630 */     GIR_Done,
     /* 204631 */   // Label 4642: @204631
     /* 204631 */   GIM_Try, /*On fail goto*//*Label 4643*/ GIMT_Encode4(204734), // Rule ID 21825 //
     /* 204636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasEVEX512_NoVLX),
     /* 204639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 204643 */     // (ctlz:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPLZCNTQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 204643 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 204646 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 204650 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204655 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 204657 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 204660 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 204664 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204669 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 204672 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 204676 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 204679 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 204684 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 204689 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 204694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 204697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZrr),
     /* 204701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204706 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 204709 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 204711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 204714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204716 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 204723 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 204728 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 204733 */     // GIR_Coverage, 21825,
     /* 204733 */     GIR_EraseRootFromParent_Done,
     /* 204734 */   // Label 4643: @204734
     /* 204734 */   GIM_Reject,
     /* 204735 */ // Label 4640: @204735
     /* 204735 */ GIM_Reject,
     /* 204736 */ // Label 4619: @204736
     /* 204736 */ GIM_Try, /*On fail goto*//*Label 4644*/ GIMT_Encode4(204923),
     /* 204741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 204744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 204748 */   GIM_Try, /*On fail goto*//*Label 4645*/ GIMT_Encode4(204800), // Rule ID 13375 //
     /* 204753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 204756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 204760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 204764 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 204767 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 204771 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 204775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 204777 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 204784 */     // (ctlz:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPLZCNTDZ256rm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src1)
     /* 204784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZ256rm),
     /* 204787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204789 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 204793 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 204798 */     GIR_RootConstrainSelectedInstOperands,
     /* 204799 */     // GIR_Coverage, 13375,
     /* 204799 */     GIR_EraseRootFromParent_Done,
     /* 204800 */   // Label 4645: @204800
     /* 204800 */   GIM_Try, /*On fail goto*//*Label 4646*/ GIMT_Encode4(204819), // Rule ID 13372 //
     /* 204805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 204808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 204812 */     // (ctlz:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)  =>  (VPLZCNTDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)
     /* 204812 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZ256rr),
     /* 204817 */     GIR_RootConstrainSelectedInstOperands,
     /* 204818 */     // GIR_Coverage, 13372,
     /* 204818 */     GIR_Done,
     /* 204819 */   // Label 4646: @204819
     /* 204819 */   GIM_Try, /*On fail goto*//*Label 4647*/ GIMT_Encode4(204922), // Rule ID 21827 //
     /* 204824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasEVEX512_NoVLX),
     /* 204827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 204831 */     // (ctlz:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VPLZCNTDZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 204831 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 204834 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 204838 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204843 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 204845 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 204848 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 204852 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204857 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 204860 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 204864 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 204867 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 204872 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 204877 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 204882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 204885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZrr),
     /* 204889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204894 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 204897 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 204899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 204902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204904 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 204911 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 204916 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 204921 */     // GIR_Coverage, 21827,
     /* 204921 */     GIR_EraseRootFromParent_Done,
     /* 204922 */   // Label 4647: @204922
     /* 204922 */   GIM_Reject,
     /* 204923 */ // Label 4644: @204923
     /* 204923 */ GIM_Reject,
     /* 204924 */ // Label 4620: @204924
     /* 204924 */ GIM_Try, /*On fail goto*//*Label 4648*/ GIMT_Encode4(205008),
     /* 204929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 204932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 204936 */   GIM_Try, /*On fail goto*//*Label 4649*/ GIMT_Encode4(204988), // Rule ID 13339 //
     /* 204941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI),
     /* 204944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 204948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 204952 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 204955 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 204959 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 204963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 204965 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 204972 */     // (ctlz:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPLZCNTQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src1)
     /* 204972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZrm),
     /* 204975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204977 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 204981 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 204986 */     GIR_RootConstrainSelectedInstOperands,
     /* 204987 */     // GIR_Coverage, 13339,
     /* 204987 */     GIR_EraseRootFromParent_Done,
     /* 204988 */   // Label 4649: @204988
     /* 204988 */   GIM_Try, /*On fail goto*//*Label 4650*/ GIMT_Encode4(205007), // Rule ID 13336 //
     /* 204993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI),
     /* 204996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 205000 */     // (ctlz:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1)  =>  (VPLZCNTQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1)
     /* 205000 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZrr),
     /* 205005 */     GIR_RootConstrainSelectedInstOperands,
     /* 205006 */     // GIR_Coverage, 13336,
     /* 205006 */     GIR_Done,
     /* 205007 */   // Label 4650: @205007
     /* 205007 */   GIM_Reject,
     /* 205008 */ // Label 4648: @205008
     /* 205008 */ GIM_Reject,
     /* 205009 */ // Label 4621: @205009
     /* 205009 */ GIM_Try, /*On fail goto*//*Label 4651*/ GIMT_Encode4(205093),
     /* 205014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 205017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 205021 */   GIM_Try, /*On fail goto*//*Label 4652*/ GIMT_Encode4(205073), // Rule ID 13366 //
     /* 205026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI),
     /* 205029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 205033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 205037 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 205040 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 205044 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 205048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 205050 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 205057 */     // (ctlz:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPLZCNTDZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src1)
     /* 205057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZrm),
     /* 205060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205062 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 205066 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 205071 */     GIR_RootConstrainSelectedInstOperands,
     /* 205072 */     // GIR_Coverage, 13366,
     /* 205072 */     GIR_EraseRootFromParent_Done,
     /* 205073 */   // Label 4652: @205073
     /* 205073 */   GIM_Try, /*On fail goto*//*Label 4653*/ GIMT_Encode4(205092), // Rule ID 13363 //
     /* 205078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI),
     /* 205081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 205085 */     // (ctlz:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1)  =>  (VPLZCNTDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1)
     /* 205085 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZrr),
     /* 205090 */     GIR_RootConstrainSelectedInstOperands,
     /* 205091 */     // GIR_Coverage, 13363,
     /* 205091 */     GIR_Done,
     /* 205092 */   // Label 4653: @205092
     /* 205092 */   GIM_Reject,
     /* 205093 */ // Label 4651: @205093
     /* 205093 */ GIM_Reject,
     /* 205094 */ // Label 4622: @205094
     /* 205094 */ GIM_Reject,
     /* 205095 */ // Label 65: @205095
     /* 205095 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(25), /*)*//*default:*//*Label 4669*/ GIMT_Encode4(207356),
     /* 205106 */ /*GILLT_s16*//*Label 4654*/ GIMT_Encode4(205198),
     /* 205110 */ /*GILLT_s32*//*Label 4655*/ GIMT_Encode4(205292),
     /* 205114 */ /*GILLT_s64*//*Label 4656*/ GIMT_Encode4(205386), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 205130 */ /*GILLT_v2s64*//*Label 4657*/ GIMT_Encode4(205480), GIMT_Encode4(0),
     /* 205138 */ /*GILLT_v4s32*//*Label 4658*/ GIMT_Encode4(205676),
     /* 205142 */ /*GILLT_v4s64*//*Label 4659*/ GIMT_Encode4(205872), GIMT_Encode4(0),
     /* 205150 */ /*GILLT_v8s16*//*Label 4660*/ GIMT_Encode4(206060),
     /* 205154 */ /*GILLT_v8s32*//*Label 4661*/ GIMT_Encode4(206256),
     /* 205158 */ /*GILLT_v8s64*//*Label 4662*/ GIMT_Encode4(206444), GIMT_Encode4(0),
     /* 205166 */ /*GILLT_v16s8*//*Label 4663*/ GIMT_Encode4(206529),
     /* 205170 */ /*GILLT_v16s16*//*Label 4664*/ GIMT_Encode4(206725),
     /* 205174 */ /*GILLT_v16s32*//*Label 4665*/ GIMT_Encode4(206913), GIMT_Encode4(0),
     /* 205182 */ /*GILLT_v32s8*//*Label 4666*/ GIMT_Encode4(206998),
     /* 205186 */ /*GILLT_v32s16*//*Label 4667*/ GIMT_Encode4(207186), GIMT_Encode4(0),
     /* 205194 */ /*GILLT_v64s8*//*Label 4668*/ GIMT_Encode4(207271),
     /* 205198 */ // Label 4654: @205198
     /* 205198 */ GIM_Try, /*On fail goto*//*Label 4670*/ GIMT_Encode4(205291),
     /* 205203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 205206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 205210 */   GIM_Try, /*On fail goto*//*Label 4671*/ GIMT_Encode4(205265), // Rule ID 3176 //
     /* 205215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPOPCNT),
     /* 205218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 205222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 205226 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 205229 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 205233 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 205237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 205239 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 205246 */     // (ctpop:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (POPCNT16rm:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 205246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::POPCNT16rm),
     /* 205249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205251 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 205255 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 205258 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 205263 */     GIR_RootConstrainSelectedInstOperands,
     /* 205264 */     // GIR_Coverage, 3176,
     /* 205264 */     GIR_EraseRootFromParent_Done,
     /* 205265 */   // Label 4671: @205265
     /* 205265 */   GIM_Try, /*On fail goto*//*Label 4672*/ GIMT_Encode4(205290), // Rule ID 3175 //
     /* 205270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPOPCNT),
     /* 205273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 205277 */     // (ctpop:{ *:[i16] } GR16:{ *:[i16] }:$src1)  =>  (POPCNT16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 205277 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::POPCNT16rr),
     /* 205282 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 205288 */     GIR_RootConstrainSelectedInstOperands,
     /* 205289 */     // GIR_Coverage, 3175,
     /* 205289 */     GIR_Done,
     /* 205290 */   // Label 4672: @205290
     /* 205290 */   GIM_Reject,
     /* 205291 */ // Label 4670: @205291
     /* 205291 */ GIM_Reject,
     /* 205292 */ // Label 4655: @205292
     /* 205292 */ GIM_Try, /*On fail goto*//*Label 4673*/ GIMT_Encode4(205385),
     /* 205297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 205300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 205304 */   GIM_Try, /*On fail goto*//*Label 4674*/ GIMT_Encode4(205359), // Rule ID 3178 //
     /* 205309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPOPCNT),
     /* 205312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 205316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 205320 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 205323 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 205327 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 205331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 205333 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 205340 */     // (ctpop:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (POPCNT32rm:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 205340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::POPCNT32rm),
     /* 205343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205345 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 205349 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 205352 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 205357 */     GIR_RootConstrainSelectedInstOperands,
     /* 205358 */     // GIR_Coverage, 3178,
     /* 205358 */     GIR_EraseRootFromParent_Done,
     /* 205359 */   // Label 4674: @205359
     /* 205359 */   GIM_Try, /*On fail goto*//*Label 4675*/ GIMT_Encode4(205384), // Rule ID 3177 //
     /* 205364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPOPCNT),
     /* 205367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 205371 */     // (ctpop:{ *:[i32] } GR32:{ *:[i32] }:$src1)  =>  (POPCNT32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 205371 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::POPCNT32rr),
     /* 205376 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 205382 */     GIR_RootConstrainSelectedInstOperands,
     /* 205383 */     // GIR_Coverage, 3177,
     /* 205383 */     GIR_Done,
     /* 205384 */   // Label 4675: @205384
     /* 205384 */   GIM_Reject,
     /* 205385 */ // Label 4673: @205385
     /* 205385 */ GIM_Reject,
     /* 205386 */ // Label 4656: @205386
     /* 205386 */ GIM_Try, /*On fail goto*//*Label 4676*/ GIMT_Encode4(205479),
     /* 205391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 205394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 205398 */   GIM_Try, /*On fail goto*//*Label 4677*/ GIMT_Encode4(205453), // Rule ID 3180 //
     /* 205403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPOPCNT),
     /* 205406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 205410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 205414 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 205417 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 205421 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 205425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 205427 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 205434 */     // (ctpop:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (POPCNT64rm:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 205434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::POPCNT64rm),
     /* 205437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205439 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 205443 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 205446 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 205451 */     GIR_RootConstrainSelectedInstOperands,
     /* 205452 */     // GIR_Coverage, 3180,
     /* 205452 */     GIR_EraseRootFromParent_Done,
     /* 205453 */   // Label 4677: @205453
     /* 205453 */   GIM_Try, /*On fail goto*//*Label 4678*/ GIMT_Encode4(205478), // Rule ID 3179 //
     /* 205458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPOPCNT),
     /* 205461 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 205465 */     // (ctpop:{ *:[i64] } GR64:{ *:[i64] }:$src1)  =>  (POPCNT64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 205465 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::POPCNT64rr),
     /* 205470 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 205476 */     GIR_RootConstrainSelectedInstOperands,
     /* 205477 */     // GIR_Coverage, 3179,
     /* 205477 */     GIR_Done,
     /* 205478 */   // Label 4678: @205478
     /* 205478 */   GIM_Reject,
     /* 205479 */ // Label 4676: @205479
     /* 205479 */ GIM_Reject,
     /* 205480 */ // Label 4657: @205480
     /* 205480 */ GIM_Try, /*On fail goto*//*Label 4679*/ GIMT_Encode4(205675),
     /* 205485 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 205488 */   GIM_Try, /*On fail goto*//*Label 4680*/ GIMT_Encode4(205544), // Rule ID 13465 //
     /* 205493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 205496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 205500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 205504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 205508 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 205511 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 205515 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 205519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 205521 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 205528 */     // (ctpop:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTQZ128rm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)
     /* 205528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZ128rm),
     /* 205531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205533 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 205537 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 205542 */     GIR_RootConstrainSelectedInstOperands,
     /* 205543 */     // GIR_Coverage, 13465,
     /* 205543 */     GIR_EraseRootFromParent_Done,
     /* 205544 */   // Label 4680: @205544
     /* 205544 */   GIM_Try, /*On fail goto*//*Label 4681*/ GIMT_Encode4(205567), // Rule ID 13462 //
     /* 205549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 205552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 205556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 205560 */     // (ctpop:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)  =>  (VPOPCNTQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)
     /* 205560 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZ128rr),
     /* 205565 */     GIR_RootConstrainSelectedInstOperands,
     /* 205566 */     // GIR_Coverage, 13462,
     /* 205566 */     GIR_Done,
     /* 205567 */   // Label 4681: @205567
     /* 205567 */   GIM_Try, /*On fail goto*//*Label 4682*/ GIMT_Encode4(205674), // Rule ID 21830 //
     /* 205572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_HasVPOPCNTDQ_NoVLX),
     /* 205575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 205579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 205583 */     // (ctpop:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPOPCNTQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 205583 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 205586 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 205590 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205595 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 205597 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 205600 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 205604 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205609 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 205612 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 205616 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 205619 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 205624 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 205629 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 205634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 205637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZrr),
     /* 205641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205646 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 205649 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 205651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 205654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205656 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 205663 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 205668 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 205673 */     // GIR_Coverage, 21830,
     /* 205673 */     GIR_EraseRootFromParent_Done,
     /* 205674 */   // Label 4682: @205674
     /* 205674 */   GIM_Reject,
     /* 205675 */ // Label 4679: @205675
     /* 205675 */ GIM_Reject,
     /* 205676 */ // Label 4658: @205676
     /* 205676 */ GIM_Try, /*On fail goto*//*Label 4683*/ GIMT_Encode4(205871),
     /* 205681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 205684 */   GIM_Try, /*On fail goto*//*Label 4684*/ GIMT_Encode4(205740), // Rule ID 13492 //
     /* 205689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 205692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 205696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 205700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 205704 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 205707 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 205711 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 205715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 205717 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 205724 */     // (ctpop:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTDZ128rm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src1)
     /* 205724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZ128rm),
     /* 205727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205729 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 205733 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 205738 */     GIR_RootConstrainSelectedInstOperands,
     /* 205739 */     // GIR_Coverage, 13492,
     /* 205739 */     GIR_EraseRootFromParent_Done,
     /* 205740 */   // Label 4684: @205740
     /* 205740 */   GIM_Try, /*On fail goto*//*Label 4685*/ GIMT_Encode4(205763), // Rule ID 13489 //
     /* 205745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 205748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 205752 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 205756 */     // (ctpop:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)  =>  (VPOPCNTDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)
     /* 205756 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZ128rr),
     /* 205761 */     GIR_RootConstrainSelectedInstOperands,
     /* 205762 */     // GIR_Coverage, 13489,
     /* 205762 */     GIR_Done,
     /* 205763 */   // Label 4685: @205763
     /* 205763 */   GIM_Try, /*On fail goto*//*Label 4686*/ GIMT_Encode4(205870), // Rule ID 21832 //
     /* 205768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_HasVPOPCNTDQ_NoVLX),
     /* 205771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 205775 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 205779 */     // (ctpop:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VPOPCNTDZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 205779 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 205782 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 205786 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205791 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 205793 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 205796 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 205800 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205805 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 205808 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 205812 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 205815 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 205820 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 205825 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 205830 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 205833 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZrr),
     /* 205837 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205842 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 205845 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 205847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 205850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205852 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 205859 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 205864 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 205869 */     // GIR_Coverage, 21832,
     /* 205869 */     GIR_EraseRootFromParent_Done,
     /* 205870 */   // Label 4686: @205870
     /* 205870 */   GIM_Reject,
     /* 205871 */ // Label 4683: @205871
     /* 205871 */ GIM_Reject,
     /* 205872 */ // Label 4659: @205872
     /* 205872 */ GIM_Try, /*On fail goto*//*Label 4687*/ GIMT_Encode4(206059),
     /* 205877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 205880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 205884 */   GIM_Try, /*On fail goto*//*Label 4688*/ GIMT_Encode4(205936), // Rule ID 13456 //
     /* 205889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 205892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 205896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 205900 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 205903 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 205907 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 205911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 205913 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 205920 */     // (ctpop:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTQZ256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src1)
     /* 205920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZ256rm),
     /* 205923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205925 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 205929 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 205934 */     GIR_RootConstrainSelectedInstOperands,
     /* 205935 */     // GIR_Coverage, 13456,
     /* 205935 */     GIR_EraseRootFromParent_Done,
     /* 205936 */   // Label 4688: @205936
     /* 205936 */   GIM_Try, /*On fail goto*//*Label 4689*/ GIMT_Encode4(205955), // Rule ID 13453 //
     /* 205941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 205944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 205948 */     // (ctpop:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)  =>  (VPOPCNTQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)
     /* 205948 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZ256rr),
     /* 205953 */     GIR_RootConstrainSelectedInstOperands,
     /* 205954 */     // GIR_Coverage, 13453,
     /* 205954 */     GIR_Done,
     /* 205955 */   // Label 4689: @205955
     /* 205955 */   GIM_Try, /*On fail goto*//*Label 4690*/ GIMT_Encode4(206058), // Rule ID 21829 //
     /* 205960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_HasVPOPCNTDQ_NoVLX),
     /* 205963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 205967 */     // (ctpop:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPOPCNTQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 205967 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 205970 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 205974 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205979 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 205981 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 205984 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 205988 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205993 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 205996 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 206000 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 206003 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 206008 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 206013 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 206018 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 206021 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZrr),
     /* 206025 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206030 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 206033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 206035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 206038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206040 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 206047 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 206052 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 206057 */     // GIR_Coverage, 21829,
     /* 206057 */     GIR_EraseRootFromParent_Done,
     /* 206058 */   // Label 4690: @206058
     /* 206058 */   GIM_Reject,
     /* 206059 */ // Label 4687: @206059
     /* 206059 */ GIM_Reject,
     /* 206060 */ // Label 4660: @206060
     /* 206060 */ GIM_Try, /*On fail goto*//*Label 4691*/ GIMT_Encode4(206255),
     /* 206065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 206068 */   GIM_Try, /*On fail goto*//*Label 4692*/ GIMT_Encode4(206124), // Rule ID 14519 //
     /* 206073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 206076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 206080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 206084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 206088 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 206091 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 206095 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 206099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206101 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 206108 */     // (ctpop:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTWZ128rm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src1)
     /* 206108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZ128rm),
     /* 206111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206113 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 206117 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 206122 */     GIR_RootConstrainSelectedInstOperands,
     /* 206123 */     // GIR_Coverage, 14519,
     /* 206123 */     GIR_EraseRootFromParent_Done,
     /* 206124 */   // Label 4692: @206124
     /* 206124 */   GIM_Try, /*On fail goto*//*Label 4693*/ GIMT_Encode4(206147), // Rule ID 14516 //
     /* 206129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 206132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 206136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 206140 */     // (ctpop:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1)  =>  (VPOPCNTWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1)
     /* 206140 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZ128rr),
     /* 206145 */     GIR_RootConstrainSelectedInstOperands,
     /* 206146 */     // GIR_Coverage, 14516,
     /* 206146 */     GIR_Done,
     /* 206147 */   // Label 4693: @206147
     /* 206147 */   GIM_Try, /*On fail goto*//*Label 4694*/ GIMT_Encode4(206254), // Rule ID 22139 //
     /* 206152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasEVEX512_NoVLX),
     /* 206155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 206159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 206163 */     // (ctpop:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v8i16] } (VPOPCNTWZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR128X:{ *:[v8i16] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 206163 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 206166 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 206170 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206175 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 206177 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 206180 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 206184 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206189 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 206192 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 206196 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 206199 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 206204 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 206209 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 206214 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 206217 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZrr),
     /* 206221 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206226 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 206229 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 206231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 206234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206236 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 206243 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 206248 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 206253 */     // GIR_Coverage, 22139,
     /* 206253 */     GIR_EraseRootFromParent_Done,
     /* 206254 */   // Label 4694: @206254
     /* 206254 */   GIM_Reject,
     /* 206255 */ // Label 4691: @206255
     /* 206255 */ GIM_Reject,
     /* 206256 */ // Label 4661: @206256
     /* 206256 */ GIM_Try, /*On fail goto*//*Label 4695*/ GIMT_Encode4(206443),
     /* 206261 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 206264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 206268 */   GIM_Try, /*On fail goto*//*Label 4696*/ GIMT_Encode4(206320), // Rule ID 13483 //
     /* 206273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 206276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 206280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 206284 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 206287 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 206291 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 206295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206297 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 206304 */     // (ctpop:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTDZ256rm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src1)
     /* 206304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZ256rm),
     /* 206307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206309 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 206313 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 206318 */     GIR_RootConstrainSelectedInstOperands,
     /* 206319 */     // GIR_Coverage, 13483,
     /* 206319 */     GIR_EraseRootFromParent_Done,
     /* 206320 */   // Label 4696: @206320
     /* 206320 */   GIM_Try, /*On fail goto*//*Label 4697*/ GIMT_Encode4(206339), // Rule ID 13480 //
     /* 206325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 206328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 206332 */     // (ctpop:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)  =>  (VPOPCNTDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)
     /* 206332 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZ256rr),
     /* 206337 */     GIR_RootConstrainSelectedInstOperands,
     /* 206338 */     // GIR_Coverage, 13480,
     /* 206338 */     GIR_Done,
     /* 206339 */   // Label 4697: @206339
     /* 206339 */   GIM_Try, /*On fail goto*//*Label 4698*/ GIMT_Encode4(206442), // Rule ID 21831 //
     /* 206344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_HasVPOPCNTDQ_NoVLX),
     /* 206347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 206351 */     // (ctpop:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VPOPCNTDZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 206351 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 206354 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 206358 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206363 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 206365 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 206368 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 206372 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206377 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 206380 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 206384 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 206387 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 206392 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 206397 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 206402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 206405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZrr),
     /* 206409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206414 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 206417 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 206419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 206422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206424 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 206431 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 206436 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 206441 */     // GIR_Coverage, 21831,
     /* 206441 */     GIR_EraseRootFromParent_Done,
     /* 206442 */   // Label 4698: @206442
     /* 206442 */   GIM_Reject,
     /* 206443 */ // Label 4695: @206443
     /* 206443 */ GIM_Reject,
     /* 206444 */ // Label 4662: @206444
     /* 206444 */ GIM_Try, /*On fail goto*//*Label 4699*/ GIMT_Encode4(206528),
     /* 206449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 206452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 206456 */   GIM_Try, /*On fail goto*//*Label 4700*/ GIMT_Encode4(206508), // Rule ID 13447 //
     /* 206461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVPOPCNTDQ),
     /* 206464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 206468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 206472 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 206475 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 206479 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 206483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206485 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 206492 */     // (ctpop:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src1)
     /* 206492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZrm),
     /* 206495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206497 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 206501 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 206506 */     GIR_RootConstrainSelectedInstOperands,
     /* 206507 */     // GIR_Coverage, 13447,
     /* 206507 */     GIR_EraseRootFromParent_Done,
     /* 206508 */   // Label 4700: @206508
     /* 206508 */   GIM_Try, /*On fail goto*//*Label 4701*/ GIMT_Encode4(206527), // Rule ID 13444 //
     /* 206513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVPOPCNTDQ),
     /* 206516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 206520 */     // (ctpop:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1)  =>  (VPOPCNTQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1)
     /* 206520 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZrr),
     /* 206525 */     GIR_RootConstrainSelectedInstOperands,
     /* 206526 */     // GIR_Coverage, 13444,
     /* 206526 */     GIR_Done,
     /* 206527 */   // Label 4701: @206527
     /* 206527 */   GIM_Reject,
     /* 206528 */ // Label 4699: @206528
     /* 206528 */ GIM_Reject,
     /* 206529 */ // Label 4663: @206529
     /* 206529 */ GIM_Try, /*On fail goto*//*Label 4702*/ GIMT_Encode4(206724),
     /* 206534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 206537 */   GIM_Try, /*On fail goto*//*Label 4703*/ GIMT_Encode4(206593), // Rule ID 14501 //
     /* 206542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 206545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 206549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 206553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 206557 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 206560 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 206564 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 206568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206570 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 206577 */     // (ctpop:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTBZ128rm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src1)
     /* 206577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZ128rm),
     /* 206580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206582 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 206586 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 206591 */     GIR_RootConstrainSelectedInstOperands,
     /* 206592 */     // GIR_Coverage, 14501,
     /* 206592 */     GIR_EraseRootFromParent_Done,
     /* 206593 */   // Label 4703: @206593
     /* 206593 */   GIM_Try, /*On fail goto*//*Label 4704*/ GIMT_Encode4(206616), // Rule ID 14498 //
     /* 206598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 206601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 206605 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 206609 */     // (ctpop:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1)  =>  (VPOPCNTBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1)
     /* 206609 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZ128rr),
     /* 206614 */     GIR_RootConstrainSelectedInstOperands,
     /* 206615 */     // GIR_Coverage, 14498,
     /* 206615 */     GIR_Done,
     /* 206616 */   // Label 4704: @206616
     /* 206616 */   GIM_Try, /*On fail goto*//*Label 4705*/ GIMT_Encode4(206723), // Rule ID 22137 //
     /* 206621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasEVEX512_NoVLX),
     /* 206624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 206628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 206632 */     // (ctpop:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v16i8] } (VPOPCNTBZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR128X:{ *:[v16i8] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 206632 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 206635 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 206639 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206644 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 206646 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s8,
     /* 206649 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 206653 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206658 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 206661 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 206665 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 206668 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 206673 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 206678 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 206683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 206686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZrr),
     /* 206690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206695 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 206698 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 206700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 206703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206705 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 206712 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 206717 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 206722 */     // GIR_Coverage, 22137,
     /* 206722 */     GIR_EraseRootFromParent_Done,
     /* 206723 */   // Label 4705: @206723
     /* 206723 */   GIM_Reject,
     /* 206724 */ // Label 4702: @206724
     /* 206724 */ GIM_Reject,
     /* 206725 */ // Label 4664: @206725
     /* 206725 */ GIM_Try, /*On fail goto*//*Label 4706*/ GIMT_Encode4(206912),
     /* 206730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 206733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 206737 */   GIM_Try, /*On fail goto*//*Label 4707*/ GIMT_Encode4(206789), // Rule ID 14513 //
     /* 206742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 206745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 206749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 206753 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 206756 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 206760 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 206764 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206766 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 206773 */     // (ctpop:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTWZ256rm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src1)
     /* 206773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZ256rm),
     /* 206776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206778 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 206782 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 206787 */     GIR_RootConstrainSelectedInstOperands,
     /* 206788 */     // GIR_Coverage, 14513,
     /* 206788 */     GIR_EraseRootFromParent_Done,
     /* 206789 */   // Label 4707: @206789
     /* 206789 */   GIM_Try, /*On fail goto*//*Label 4708*/ GIMT_Encode4(206808), // Rule ID 14510 //
     /* 206794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 206797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 206801 */     // (ctpop:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1)  =>  (VPOPCNTWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1)
     /* 206801 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZ256rr),
     /* 206806 */     GIR_RootConstrainSelectedInstOperands,
     /* 206807 */     // GIR_Coverage, 14510,
     /* 206807 */     GIR_Done,
     /* 206808 */   // Label 4708: @206808
     /* 206808 */   GIM_Try, /*On fail goto*//*Label 4709*/ GIMT_Encode4(206911), // Rule ID 22138 //
     /* 206813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasEVEX512_NoVLX),
     /* 206816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 206820 */     // (ctpop:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v16i16] } (VPOPCNTWZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR256X:{ *:[v16i16] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 206820 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 206823 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 206827 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206832 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 206834 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 206837 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 206841 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206846 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 206849 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 206853 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 206856 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 206861 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 206866 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 206871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 206874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZrr),
     /* 206878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206883 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 206886 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 206888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 206891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206893 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 206900 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 206905 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 206910 */     // GIR_Coverage, 22138,
     /* 206910 */     GIR_EraseRootFromParent_Done,
     /* 206911 */   // Label 4709: @206911
     /* 206911 */   GIM_Reject,
     /* 206912 */ // Label 4706: @206912
     /* 206912 */ GIM_Reject,
     /* 206913 */ // Label 4665: @206913
     /* 206913 */ GIM_Try, /*On fail goto*//*Label 4710*/ GIMT_Encode4(206997),
     /* 206918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 206921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 206925 */   GIM_Try, /*On fail goto*//*Label 4711*/ GIMT_Encode4(206977), // Rule ID 13474 //
     /* 206930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVPOPCNTDQ),
     /* 206933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 206937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 206941 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 206944 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 206948 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 206952 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206954 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 206961 */     // (ctpop:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTDZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src1)
     /* 206961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZrm),
     /* 206964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206966 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 206970 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 206975 */     GIR_RootConstrainSelectedInstOperands,
     /* 206976 */     // GIR_Coverage, 13474,
     /* 206976 */     GIR_EraseRootFromParent_Done,
     /* 206977 */   // Label 4711: @206977
     /* 206977 */   GIM_Try, /*On fail goto*//*Label 4712*/ GIMT_Encode4(206996), // Rule ID 13471 //
     /* 206982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVPOPCNTDQ),
     /* 206985 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 206989 */     // (ctpop:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1)  =>  (VPOPCNTDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1)
     /* 206989 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZrr),
     /* 206994 */     GIR_RootConstrainSelectedInstOperands,
     /* 206995 */     // GIR_Coverage, 13471,
     /* 206995 */     GIR_Done,
     /* 206996 */   // Label 4712: @206996
     /* 206996 */   GIM_Reject,
     /* 206997 */ // Label 4710: @206997
     /* 206997 */ GIM_Reject,
     /* 206998 */ // Label 4666: @206998
     /* 206998 */ GIM_Try, /*On fail goto*//*Label 4713*/ GIMT_Encode4(207185),
     /* 207003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 207006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 207010 */   GIM_Try, /*On fail goto*//*Label 4714*/ GIMT_Encode4(207062), // Rule ID 14495 //
     /* 207015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 207018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 207022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207026 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207029 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207033 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207039 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207046 */     // (ctpop:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTBZ256rm:{ *:[v32i8] } addr:{ *:[iPTR] }:$src1)
     /* 207046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZ256rm),
     /* 207049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207051 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 207055 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207060 */     GIR_RootConstrainSelectedInstOperands,
     /* 207061 */     // GIR_Coverage, 14495,
     /* 207061 */     GIR_EraseRootFromParent_Done,
     /* 207062 */   // Label 4714: @207062
     /* 207062 */   GIM_Try, /*On fail goto*//*Label 4715*/ GIMT_Encode4(207081), // Rule ID 14492 //
     /* 207067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 207070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 207074 */     // (ctpop:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1)  =>  (VPOPCNTBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1)
     /* 207074 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZ256rr),
     /* 207079 */     GIR_RootConstrainSelectedInstOperands,
     /* 207080 */     // GIR_Coverage, 14492,
     /* 207080 */     GIR_Done,
     /* 207081 */   // Label 4715: @207081
     /* 207081 */   GIM_Try, /*On fail goto*//*Label 4716*/ GIMT_Encode4(207184), // Rule ID 22136 //
     /* 207086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasEVEX512_NoVLX),
     /* 207089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 207093 */     // (ctpop:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v32i8] } (VPOPCNTBZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR256X:{ *:[v32i8] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 207093 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 207096 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 207100 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 207107 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s8,
     /* 207110 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 207114 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207119 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 207122 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 207126 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 207129 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 207134 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 207139 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 207144 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 207147 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZrr),
     /* 207151 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207156 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 207159 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 207161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 207164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207166 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 207173 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 207178 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 207183 */     // GIR_Coverage, 22136,
     /* 207183 */     GIR_EraseRootFromParent_Done,
     /* 207184 */   // Label 4716: @207184
     /* 207184 */   GIM_Reject,
     /* 207185 */ // Label 4713: @207185
     /* 207185 */ GIM_Reject,
     /* 207186 */ // Label 4667: @207186
     /* 207186 */ GIM_Try, /*On fail goto*//*Label 4717*/ GIMT_Encode4(207270),
     /* 207191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 207194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 207198 */   GIM_Try, /*On fail goto*//*Label 4718*/ GIMT_Encode4(207250), // Rule ID 14507 //
     /* 207203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG),
     /* 207206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 207210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207214 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207217 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207221 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207227 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207234 */     // (ctpop:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTWZrm:{ *:[v32i16] } addr:{ *:[iPTR] }:$src1)
     /* 207234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZrm),
     /* 207237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207239 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 207243 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207248 */     GIR_RootConstrainSelectedInstOperands,
     /* 207249 */     // GIR_Coverage, 14507,
     /* 207249 */     GIR_EraseRootFromParent_Done,
     /* 207250 */   // Label 4718: @207250
     /* 207250 */   GIM_Try, /*On fail goto*//*Label 4719*/ GIMT_Encode4(207269), // Rule ID 14504 //
     /* 207255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG),
     /* 207258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 207262 */     // (ctpop:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1)  =>  (VPOPCNTWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1)
     /* 207262 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZrr),
     /* 207267 */     GIR_RootConstrainSelectedInstOperands,
     /* 207268 */     // GIR_Coverage, 14504,
     /* 207268 */     GIR_Done,
     /* 207269 */   // Label 4719: @207269
     /* 207269 */   GIM_Reject,
     /* 207270 */ // Label 4717: @207270
     /* 207270 */ GIM_Reject,
     /* 207271 */ // Label 4668: @207271
     /* 207271 */ GIM_Try, /*On fail goto*//*Label 4720*/ GIMT_Encode4(207355),
     /* 207276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 207279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 207283 */   GIM_Try, /*On fail goto*//*Label 4721*/ GIMT_Encode4(207335), // Rule ID 14489 //
     /* 207288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG),
     /* 207291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 207295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207299 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207302 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207306 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207312 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207319 */     // (ctpop:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTBZrm:{ *:[v64i8] } addr:{ *:[iPTR] }:$src1)
     /* 207319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZrm),
     /* 207322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207324 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 207328 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207333 */     GIR_RootConstrainSelectedInstOperands,
     /* 207334 */     // GIR_Coverage, 14489,
     /* 207334 */     GIR_EraseRootFromParent_Done,
     /* 207335 */   // Label 4721: @207335
     /* 207335 */   GIM_Try, /*On fail goto*//*Label 4722*/ GIMT_Encode4(207354), // Rule ID 14486 //
     /* 207340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG),
     /* 207343 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 207347 */     // (ctpop:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1)  =>  (VPOPCNTBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1)
     /* 207347 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZrr),
     /* 207352 */     GIR_RootConstrainSelectedInstOperands,
     /* 207353 */     // GIR_Coverage, 14486,
     /* 207353 */     GIR_Done,
     /* 207354 */   // Label 4722: @207354
     /* 207354 */   GIM_Reject,
     /* 207355 */ // Label 4720: @207355
     /* 207355 */ GIM_Reject,
     /* 207356 */ // Label 4669: @207356
     /* 207356 */ GIM_Reject,
     /* 207357 */ // Label 66: @207357
     /* 207357 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 4726*/ GIMT_Encode4(207856),
     /* 207368 */ /*GILLT_s16*//*Label 4723*/ GIMT_Encode4(207380),
     /* 207372 */ /*GILLT_s32*//*Label 4724*/ GIMT_Encode4(207544),
     /* 207376 */ /*GILLT_s64*//*Label 4725*/ GIMT_Encode4(207700),
     /* 207380 */ // Label 4723: @207380
     /* 207380 */ GIM_Try, /*On fail goto*//*Label 4727*/ GIMT_Encode4(207543),
     /* 207385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 207388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 207392 */   GIM_Try, /*On fail goto*//*Label 4728*/ GIMT_Encode4(207444), // Rule ID 49 //
     /* 207397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_NoEGPR),
     /* 207400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 207404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207408 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207411 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207415 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 207419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207421 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207428 */     // (bswap:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (MOVBE16rm:{ *:[i16] } addr:{ *:[iPTR] }:$src1)
     /* 207428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE16rm),
     /* 207431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207433 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 207437 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207442 */     GIR_RootConstrainSelectedInstOperands,
     /* 207443 */     // GIR_Coverage, 49,
     /* 207443 */     GIR_EraseRootFromParent_Done,
     /* 207444 */   // Label 4728: @207444
     /* 207444 */   GIM_Try, /*On fail goto*//*Label 4729*/ GIMT_Encode4(207496), // Rule ID 55 //
     /* 207449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVBE_In64BitMode),
     /* 207452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 207456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207460 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207463 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207467 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 207471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207473 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207480 */     // (bswap:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (MOVBE16rm_EVEX:{ *:[i16] } addr:{ *:[iPTR] }:$src1)
     /* 207480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE16rm_EVEX),
     /* 207483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207485 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 207489 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207494 */     GIR_RootConstrainSelectedInstOperands,
     /* 207495 */     // GIR_Coverage, 55,
     /* 207495 */     GIR_EraseRootFromParent_Done,
     /* 207496 */   // Label 4729: @207496
     /* 207496 */   GIM_Try, /*On fail goto*//*Label 4730*/ GIMT_Encode4(207515), // Rule ID 61 //
     /* 207501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_HasNDD_In64BitMode),
     /* 207504 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 207508 */     // (bswap:{ *:[i16] } GR16:{ *:[i16] }:$src1)  =>  (MOVBE16rr:{ *:[i16] } GR16:{ *:[i16] }:$src1)
     /* 207508 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVBE16rr),
     /* 207513 */     GIR_RootConstrainSelectedInstOperands,
     /* 207514 */     // GIR_Coverage, 61,
     /* 207514 */     GIR_Done,
     /* 207515 */   // Label 4730: @207515
     /* 207515 */   GIM_Try, /*On fail goto*//*Label 4731*/ GIMT_Encode4(207542), // Rule ID 22988 //
     /* 207520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE),
     /* 207523 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 207527 */     // (bswap:{ *:[i16] } GR16:{ *:[i16] }:$src)  =>  (ROL16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src, 8:{ *:[i8] })
     /* 207527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16ri),
     /* 207530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207532 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 207534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 207537 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 207540 */     GIR_RootConstrainSelectedInstOperands,
     /* 207541 */     // GIR_Coverage, 22988,
     /* 207541 */     GIR_EraseRootFromParent_Done,
     /* 207542 */   // Label 4731: @207542
     /* 207542 */   GIM_Reject,
     /* 207543 */ // Label 4727: @207543
     /* 207543 */ GIM_Reject,
     /* 207544 */ // Label 4724: @207544
     /* 207544 */ GIM_Try, /*On fail goto*//*Label 4732*/ GIMT_Encode4(207699),
     /* 207549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 207552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 207556 */   GIM_Try, /*On fail goto*//*Label 4733*/ GIMT_Encode4(207608), // Rule ID 51 //
     /* 207561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_NoEGPR),
     /* 207564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 207568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207572 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207575 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207579 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 207583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207585 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207592 */     // (bswap:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (MOVBE32rm:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 207592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE32rm),
     /* 207595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207597 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 207601 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207606 */     GIR_RootConstrainSelectedInstOperands,
     /* 207607 */     // GIR_Coverage, 51,
     /* 207607 */     GIR_EraseRootFromParent_Done,
     /* 207608 */   // Label 4733: @207608
     /* 207608 */   GIM_Try, /*On fail goto*//*Label 4734*/ GIMT_Encode4(207660), // Rule ID 57 //
     /* 207613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVBE_In64BitMode),
     /* 207616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 207620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207624 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207627 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207631 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 207635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207637 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207644 */     // (bswap:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (MOVBE32rm_EVEX:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 207644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE32rm_EVEX),
     /* 207647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207649 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 207653 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207658 */     GIR_RootConstrainSelectedInstOperands,
     /* 207659 */     // GIR_Coverage, 57,
     /* 207659 */     GIR_EraseRootFromParent_Done,
     /* 207660 */   // Label 4734: @207660
     /* 207660 */   GIM_Try, /*On fail goto*//*Label 4735*/ GIMT_Encode4(207679), // Rule ID 5 //
     /* 207665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_Or_NoMOVBE),
     /* 207668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 207672 */     // (bswap:{ *:[i32] } GR32:{ *:[i32] }:$src)  =>  (BSWAP32r:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /* 207672 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::BSWAP32r),
     /* 207677 */     GIR_RootConstrainSelectedInstOperands,
     /* 207678 */     // GIR_Coverage, 5,
     /* 207678 */     GIR_Done,
     /* 207679 */   // Label 4735: @207679
     /* 207679 */   GIM_Try, /*On fail goto*//*Label 4736*/ GIMT_Encode4(207698), // Rule ID 62 //
     /* 207684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_HasNDD_In64BitMode),
     /* 207687 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 207691 */     // (bswap:{ *:[i32] } GR32:{ *:[i32] }:$src1)  =>  (MOVBE32rr:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 207691 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVBE32rr),
     /* 207696 */     GIR_RootConstrainSelectedInstOperands,
     /* 207697 */     // GIR_Coverage, 62,
     /* 207697 */     GIR_Done,
     /* 207698 */   // Label 4736: @207698
     /* 207698 */   GIM_Reject,
     /* 207699 */ // Label 4732: @207699
     /* 207699 */ GIM_Reject,
     /* 207700 */ // Label 4725: @207700
     /* 207700 */ GIM_Try, /*On fail goto*//*Label 4737*/ GIMT_Encode4(207855),
     /* 207705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 207708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 207712 */   GIM_Try, /*On fail goto*//*Label 4738*/ GIMT_Encode4(207764), // Rule ID 53 //
     /* 207717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_NoEGPR),
     /* 207720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 207724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207728 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207731 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207735 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207741 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207748 */     // (bswap:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MOVBE64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src1)
     /* 207748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE64rm),
     /* 207751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207753 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 207757 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207762 */     GIR_RootConstrainSelectedInstOperands,
     /* 207763 */     // GIR_Coverage, 53,
     /* 207763 */     GIR_EraseRootFromParent_Done,
     /* 207764 */   // Label 4738: @207764
     /* 207764 */   GIM_Try, /*On fail goto*//*Label 4739*/ GIMT_Encode4(207816), // Rule ID 59 //
     /* 207769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVBE_In64BitMode),
     /* 207772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 207776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207780 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207783 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207787 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207793 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207800 */     // (bswap:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MOVBE64rm_EVEX:{ *:[i64] } addr:{ *:[iPTR] }:$src1)
     /* 207800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE64rm_EVEX),
     /* 207803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207805 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 207809 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207814 */     GIR_RootConstrainSelectedInstOperands,
     /* 207815 */     // GIR_Coverage, 59,
     /* 207815 */     GIR_EraseRootFromParent_Done,
     /* 207816 */   // Label 4739: @207816
     /* 207816 */   GIM_Try, /*On fail goto*//*Label 4740*/ GIMT_Encode4(207835), // Rule ID 6 //
     /* 207821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_Or_NoMOVBE),
     /* 207824 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 207828 */     // (bswap:{ *:[i64] } GR64:{ *:[i64] }:$src)  =>  (BSWAP64r:{ *:[i64] } GR64:{ *:[i64] }:$src)
     /* 207828 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::BSWAP64r),
     /* 207833 */     GIR_RootConstrainSelectedInstOperands,
     /* 207834 */     // GIR_Coverage, 6,
     /* 207834 */     GIR_Done,
     /* 207835 */   // Label 4740: @207835
     /* 207835 */   GIM_Try, /*On fail goto*//*Label 4741*/ GIMT_Encode4(207854), // Rule ID 63 //
     /* 207840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_HasNDD_In64BitMode),
     /* 207843 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 207847 */     // (bswap:{ *:[i64] } GR64:{ *:[i64] }:$src1)  =>  (MOVBE64rr:{ *:[i64] } GR64:{ *:[i64] }:$src1)
     /* 207847 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVBE64rr),
     /* 207852 */     GIR_RootConstrainSelectedInstOperands,
     /* 207853 */     // GIR_Coverage, 63,
     /* 207853 */     GIR_Done,
     /* 207854 */   // Label 4741: @207854
     /* 207854 */   GIM_Reject,
     /* 207855 */ // Label 4737: @207855
     /* 207855 */ GIM_Reject,
     /* 207856 */ // Label 4726: @207856
     /* 207856 */ GIM_Reject,
     /* 207857 */ // Label 67: @207857
     /* 207857 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 4755*/ GIMT_Encode4(210025),
     /* 207868 */ /*GILLT_s16*//*Label 4742*/ GIMT_Encode4(207952),
     /* 207872 */ /*GILLT_s32*//*Label 4743*/ GIMT_Encode4(208073),
     /* 207876 */ /*GILLT_s64*//*Label 4744*/ GIMT_Encode4(208429),
     /* 207880 */ /*GILLT_s80*//*Label 4745*/ GIMT_Encode4(208785), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 207892 */ /*GILLT_v2s64*//*Label 4746*/ GIMT_Encode4(208822), GIMT_Encode4(0),
     /* 207900 */ /*GILLT_v4s32*//*Label 4747*/ GIMT_Encode4(209025),
     /* 207904 */ /*GILLT_v4s64*//*Label 4748*/ GIMT_Encode4(209228), GIMT_Encode4(0),
     /* 207912 */ /*GILLT_v8s16*//*Label 4749*/ GIMT_Encode4(209404),
     /* 207916 */ /*GILLT_v8s32*//*Label 4750*/ GIMT_Encode4(209493),
     /* 207920 */ /*GILLT_v8s64*//*Label 4751*/ GIMT_Encode4(209669), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 207932 */ /*GILLT_v16s16*//*Label 4752*/ GIMT_Encode4(209758),
     /* 207936 */ /*GILLT_v16s32*//*Label 4753*/ GIMT_Encode4(209847), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 207948 */ /*GILLT_v32s16*//*Label 4754*/ GIMT_Encode4(209936),
     /* 207952 */ // Label 4742: @207952
     /* 207952 */ GIM_Try, /*On fail goto*//*Label 4756*/ GIMT_Encode4(208072),
     /* 207957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 207960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 207964 */   GIM_Try, /*On fail goto*//*Label 4757*/ GIMT_Encode4(208033), // Rule ID 21421 //
     /* 207969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_OptForSize),
     /* 207972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 207976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207980 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207983 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207987 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207993 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208000 */     // (fsqrt:{ *:[f16] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSHZm:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), addr:{ *:[iPTR] }:$src)
     /* 208000 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 208003 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 208007 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 208014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSHZm),
     /* 208017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208019 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 208022 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 208026 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208031 */     GIR_RootConstrainSelectedInstOperands,
     /* 208032 */     // GIR_Coverage, 21421,
     /* 208032 */     GIR_EraseRootFromParent_Done,
     /* 208033 */   // Label 4757: @208033
     /* 208033 */   GIM_Try, /*On fail goto*//*Label 4758*/ GIMT_Encode4(208071), // Rule ID 21419 //
     /* 208038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 208041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 208045 */     // (fsqrt:{ *:[f16] } FR16X:{ *:[f16] }:$src)  =>  (VSQRTSHZr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), FR16X:{ *:[f16] }:$src)
     /* 208045 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 208048 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 208052 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208057 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 208059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSHZr),
     /* 208062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208064 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 208067 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 208069 */     GIR_RootConstrainSelectedInstOperands,
     /* 208070 */     // GIR_Coverage, 21419,
     /* 208070 */     GIR_EraseRootFromParent_Done,
     /* 208071 */   // Label 4758: @208071
     /* 208071 */   GIM_Reject,
     /* 208072 */ // Label 4756: @208072
     /* 208072 */ GIM_Reject,
     /* 208073 */ // Label 4743: @208073
     /* 208073 */ GIM_Try, /*On fail goto*//*Label 4759*/ GIMT_Encode4(208428),
     /* 208078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 208081 */   GIM_Try, /*On fail goto*//*Label 4760*/ GIMT_Encode4(208137), // Rule ID 2449 //
     /* 208086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseSSE1),
     /* 208089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 208093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 208097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208101 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208104 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208108 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208114 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208121 */     // (fsqrt:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SQRTSSm:{ *:[f32] } addr:{ *:[iPTR] }:$src1)
     /* 208121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SQRTSSm),
     /* 208124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208126 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 208130 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208135 */     GIR_RootConstrainSelectedInstOperands,
     /* 208136 */     // GIR_Coverage, 2449,
     /* 208136 */     GIR_EraseRootFromParent_Done,
     /* 208137 */   // Label 4760: @208137
     /* 208137 */   GIM_Try, /*On fail goto*//*Label 4761*/ GIMT_Encode4(208210), // Rule ID 18277 //
     /* 208142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseAVX),
     /* 208145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 208149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 208153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208157 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208160 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208164 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208168 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208170 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208177 */     // (fsqrt:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSSm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 208177 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 208180 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 208184 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208189 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 208191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSm),
     /* 208194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208196 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 208199 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 208203 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208208 */     GIR_RootConstrainSelectedInstOperands,
     /* 208209 */     // GIR_Coverage, 18277,
     /* 208209 */     GIR_EraseRootFromParent_Done,
     /* 208210 */   // Label 4761: @208210
     /* 208210 */   GIM_Try, /*On fail goto*//*Label 4762*/ GIMT_Encode4(208283), // Rule ID 21425 //
     /* 208215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_OptForSize),
     /* 208218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 208222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 208226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208230 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208233 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208237 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208243 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208250 */     // (fsqrt:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSSZm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 208250 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 208253 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 208257 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208262 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 208264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSZm),
     /* 208267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208269 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 208272 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 208276 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208281 */     GIR_RootConstrainSelectedInstOperands,
     /* 208282 */     // GIR_Coverage, 21425,
     /* 208282 */     GIR_EraseRootFromParent_Done,
     /* 208283 */   // Label 4762: @208283
     /* 208283 */   GIM_Try, /*On fail goto*//*Label 4763*/ GIMT_Encode4(208316), // Rule ID 1049 //
     /* 208288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 208291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 208295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 208299 */     // (fsqrt:{ *:[f32] } RFP32:{ *:[f32] }:$src)  =>  (SQRT_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src)
     /* 208299 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRT_Fp32),
     /* 208304 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 208310 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 208314 */     GIR_RootConstrainSelectedInstOperands,
     /* 208315 */     // GIR_Coverage, 1049,
     /* 208315 */     GIR_Done,
     /* 208316 */   // Label 4763: @208316
     /* 208316 */   GIM_Try, /*On fail goto*//*Label 4764*/ GIMT_Encode4(208343), // Rule ID 2447 //
     /* 208321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 208324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 208328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 208332 */     // (fsqrt:{ *:[f32] } FR32:{ *:[f32] }:$src1)  =>  (SQRTSSr:{ *:[f32] } FR32:{ *:[f32] }:$src1)
     /* 208332 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTSSr),
     /* 208337 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 208341 */     GIR_RootConstrainSelectedInstOperands,
     /* 208342 */     // GIR_Coverage, 2447,
     /* 208342 */     GIR_Done,
     /* 208343 */   // Label 4764: @208343
     /* 208343 */   GIM_Try, /*On fail goto*//*Label 4765*/ GIMT_Encode4(208385), // Rule ID 18275 //
     /* 208348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 208351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 208355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 208359 */     // (fsqrt:{ *:[f32] } FR32:{ *:[f32] }:$src)  =>  (VSQRTSSr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR32:{ *:[f32] }:$src)
     /* 208359 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 208362 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 208366 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208371 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 208373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSr),
     /* 208376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208378 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 208381 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 208383 */     GIR_RootConstrainSelectedInstOperands,
     /* 208384 */     // GIR_Coverage, 18275,
     /* 208384 */     GIR_EraseRootFromParent_Done,
     /* 208385 */   // Label 4765: @208385
     /* 208385 */   GIM_Try, /*On fail goto*//*Label 4766*/ GIMT_Encode4(208427), // Rule ID 21423 //
     /* 208390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 208393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 208397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 208401 */     // (fsqrt:{ *:[f32] } FR32X:{ *:[f32] }:$src)  =>  (VSQRTSSZr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR32X:{ *:[f32] }:$src)
     /* 208401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 208404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 208408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208413 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 208415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSZr),
     /* 208418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208420 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 208423 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 208425 */     GIR_RootConstrainSelectedInstOperands,
     /* 208426 */     // GIR_Coverage, 21423,
     /* 208426 */     GIR_EraseRootFromParent_Done,
     /* 208427 */   // Label 4766: @208427
     /* 208427 */   GIM_Reject,
     /* 208428 */ // Label 4759: @208428
     /* 208428 */ GIM_Reject,
     /* 208429 */ // Label 4744: @208429
     /* 208429 */ GIM_Try, /*On fail goto*//*Label 4767*/ GIMT_Encode4(208784),
     /* 208434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 208437 */   GIM_Try, /*On fail goto*//*Label 4768*/ GIMT_Encode4(208493), // Rule ID 2465 //
     /* 208442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseSSE2),
     /* 208445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 208449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 208453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208457 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208460 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208464 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208468 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208470 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208477 */     // (fsqrt:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SQRTSDm:{ *:[f64] } addr:{ *:[iPTR] }:$src1)
     /* 208477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SQRTSDm),
     /* 208480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208482 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 208486 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208491 */     GIR_RootConstrainSelectedInstOperands,
     /* 208492 */     // GIR_Coverage, 2465,
     /* 208492 */     GIR_EraseRootFromParent_Done,
     /* 208493 */   // Label 4768: @208493
     /* 208493 */   GIM_Try, /*On fail goto*//*Label 4769*/ GIMT_Encode4(208566), // Rule ID 18281 //
     /* 208498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseAVX),
     /* 208501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 208505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 208509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208513 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208516 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208520 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208524 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208526 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208533 */     // (fsqrt:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSDm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 208533 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 208536 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 208540 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208545 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 208547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDm),
     /* 208550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 208555 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 208559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208564 */     GIR_RootConstrainSelectedInstOperands,
     /* 208565 */     // GIR_Coverage, 18281,
     /* 208565 */     GIR_EraseRootFromParent_Done,
     /* 208566 */   // Label 4769: @208566
     /* 208566 */   GIM_Try, /*On fail goto*//*Label 4770*/ GIMT_Encode4(208639), // Rule ID 21429 //
     /* 208571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_OptForSize),
     /* 208574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 208578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 208582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208586 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208589 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208593 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208599 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208606 */     // (fsqrt:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSDZm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 208606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 208609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 208613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 208620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDZm),
     /* 208623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208625 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 208628 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 208632 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208637 */     GIR_RootConstrainSelectedInstOperands,
     /* 208638 */     // GIR_Coverage, 21429,
     /* 208638 */     GIR_EraseRootFromParent_Done,
     /* 208639 */   // Label 4770: @208639
     /* 208639 */   GIM_Try, /*On fail goto*//*Label 4771*/ GIMT_Encode4(208672), // Rule ID 1051 //
     /* 208644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 208647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 208651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 208655 */     // (fsqrt:{ *:[f64] } RFP64:{ *:[f64] }:$src)  =>  (SQRT_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src)
     /* 208655 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRT_Fp64),
     /* 208660 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 208666 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 208670 */     GIR_RootConstrainSelectedInstOperands,
     /* 208671 */     // GIR_Coverage, 1051,
     /* 208671 */     GIR_Done,
     /* 208672 */   // Label 4771: @208672
     /* 208672 */   GIM_Try, /*On fail goto*//*Label 4772*/ GIMT_Encode4(208699), // Rule ID 2463 //
     /* 208677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 208680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 208684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 208688 */     // (fsqrt:{ *:[f64] } FR64:{ *:[f64] }:$src1)  =>  (SQRTSDr:{ *:[f64] } FR64:{ *:[f64] }:$src1)
     /* 208688 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTSDr),
     /* 208693 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 208697 */     GIR_RootConstrainSelectedInstOperands,
     /* 208698 */     // GIR_Coverage, 2463,
     /* 208698 */     GIR_Done,
     /* 208699 */   // Label 4772: @208699
     /* 208699 */   GIM_Try, /*On fail goto*//*Label 4773*/ GIMT_Encode4(208741), // Rule ID 18279 //
     /* 208704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 208707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 208711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 208715 */     // (fsqrt:{ *:[f64] } FR64:{ *:[f64] }:$src)  =>  (VSQRTSDr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR64:{ *:[f64] }:$src)
     /* 208715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 208718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 208722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208727 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 208729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDr),
     /* 208732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 208737 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 208739 */     GIR_RootConstrainSelectedInstOperands,
     /* 208740 */     // GIR_Coverage, 18279,
     /* 208740 */     GIR_EraseRootFromParent_Done,
     /* 208741 */   // Label 4773: @208741
     /* 208741 */   GIM_Try, /*On fail goto*//*Label 4774*/ GIMT_Encode4(208783), // Rule ID 21427 //
     /* 208746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 208749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 208753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 208757 */     // (fsqrt:{ *:[f64] } FR64X:{ *:[f64] }:$src)  =>  (VSQRTSDZr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR64X:{ *:[f64] }:$src)
     /* 208757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 208760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 208764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208769 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 208771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDZr),
     /* 208774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208776 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 208779 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 208781 */     GIR_RootConstrainSelectedInstOperands,
     /* 208782 */     // GIR_Coverage, 21427,
     /* 208782 */     GIR_EraseRootFromParent_Done,
     /* 208783 */   // Label 4774: @208783
     /* 208783 */   GIM_Reject,
     /* 208784 */ // Label 4767: @208784
     /* 208784 */ GIM_Reject,
     /* 208785 */ // Label 4745: @208785
     /* 208785 */ GIM_Try, /*On fail goto*//*Label 4775*/ GIMT_Encode4(208821), // Rule ID 1053 //
     /* 208790 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 208793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 208796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 208800 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 208804 */   // (fsqrt:{ *:[f80] } RFP80:{ *:[f80] }:$src)  =>  (SQRT_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src)
     /* 208804 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRT_Fp80),
     /* 208809 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 208815 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 208819 */   GIR_RootConstrainSelectedInstOperands,
     /* 208820 */   // GIR_Coverage, 1053,
     /* 208820 */   GIR_Done,
     /* 208821 */ // Label 4775: @208821
     /* 208821 */ GIM_Reject,
     /* 208822 */ // Label 4746: @208822
     /* 208822 */ GIM_Try, /*On fail goto*//*Label 4776*/ GIMT_Encode4(209024),
     /* 208827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 208830 */   GIM_Try, /*On fail goto*//*Label 4777*/ GIMT_Encode4(208886), // Rule ID 2469 //
     /* 208835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 208838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 208842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 208846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208850 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208853 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208857 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208863 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208870 */     // (fsqrt:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /* 208870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDm),
     /* 208873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208875 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 208879 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208884 */     GIR_RootConstrainSelectedInstOperands,
     /* 208885 */     // GIR_Coverage, 2469,
     /* 208885 */     GIR_EraseRootFromParent_Done,
     /* 208886 */   // Label 4777: @208886
     /* 208886 */   GIM_Try, /*On fail goto*//*Label 4778*/ GIMT_Encode4(208942), // Rule ID 12087 //
     /* 208891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 208894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 208898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 208902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208906 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208909 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208913 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208919 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208926 */     // (fsqrt:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDZ128m:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /* 208926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ128m),
     /* 208929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208931 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 208935 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208940 */     GIR_RootConstrainSelectedInstOperands,
     /* 208941 */     // GIR_Coverage, 12087,
     /* 208941 */     GIR_EraseRootFromParent_Done,
     /* 208942 */   // Label 4778: @208942
     /* 208942 */   GIM_Try, /*On fail goto*//*Label 4779*/ GIMT_Encode4(208969), // Rule ID 2467 //
     /* 208947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 208950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 208954 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 208958 */     // (fsqrt:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)  =>  (VSQRTPDr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)
     /* 208958 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDr),
     /* 208963 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 208967 */     GIR_RootConstrainSelectedInstOperands,
     /* 208968 */     // GIR_Coverage, 2467,
     /* 208968 */     GIR_Done,
     /* 208969 */   // Label 4779: @208969
     /* 208969 */   GIM_Try, /*On fail goto*//*Label 4780*/ GIMT_Encode4(208996), // Rule ID 2475 //
     /* 208974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 208977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 208981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 208985 */     // (fsqrt:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)  =>  (SQRTPDr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)
     /* 208985 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTPDr),
     /* 208990 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 208994 */     GIR_RootConstrainSelectedInstOperands,
     /* 208995 */     // GIR_Coverage, 2475,
     /* 208995 */     GIR_Done,
     /* 208996 */   // Label 4780: @208996
     /* 208996 */   GIM_Try, /*On fail goto*//*Label 4781*/ GIMT_Encode4(209023), // Rule ID 12083 //
     /* 209001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 209004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 209008 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 209012 */     // (fsqrt:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src)  =>  (VSQRTPDZ128r:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src)
     /* 209012 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ128r),
     /* 209017 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209021 */     GIR_RootConstrainSelectedInstOperands,
     /* 209022 */     // GIR_Coverage, 12083,
     /* 209022 */     GIR_Done,
     /* 209023 */   // Label 4781: @209023
     /* 209023 */   GIM_Reject,
     /* 209024 */ // Label 4776: @209024
     /* 209024 */ GIM_Reject,
     /* 209025 */ // Label 4747: @209025
     /* 209025 */ GIM_Try, /*On fail goto*//*Label 4782*/ GIMT_Encode4(209227),
     /* 209030 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 209033 */   GIM_Try, /*On fail goto*//*Label 4783*/ GIMT_Encode4(209089), // Rule ID 2453 //
     /* 209038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 209041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 209045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 209049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209053 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209056 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209060 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209066 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209073 */     // (fsqrt:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 209073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSm),
     /* 209076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209078 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 209082 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209087 */     GIR_RootConstrainSelectedInstOperands,
     /* 209088 */     // GIR_Coverage, 2453,
     /* 209088 */     GIR_EraseRootFromParent_Done,
     /* 209089 */   // Label 4783: @209089
     /* 209089 */   GIM_Try, /*On fail goto*//*Label 4784*/ GIMT_Encode4(209145), // Rule ID 12063 //
     /* 209094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 209097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 209101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 209105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209109 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209112 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209116 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209120 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209122 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209129 */     // (fsqrt:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSZ128m:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 209129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ128m),
     /* 209132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209134 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 209138 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209143 */     GIR_RootConstrainSelectedInstOperands,
     /* 209144 */     // GIR_Coverage, 12063,
     /* 209144 */     GIR_EraseRootFromParent_Done,
     /* 209145 */   // Label 4784: @209145
     /* 209145 */   GIM_Try, /*On fail goto*//*Label 4785*/ GIMT_Encode4(209172), // Rule ID 2451 //
     /* 209150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 209153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 209157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 209161 */     // (fsqrt:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)  =>  (VSQRTPSr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)
     /* 209161 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSr),
     /* 209166 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209170 */     GIR_RootConstrainSelectedInstOperands,
     /* 209171 */     // GIR_Coverage, 2451,
     /* 209171 */     GIR_Done,
     /* 209172 */   // Label 4785: @209172
     /* 209172 */   GIM_Try, /*On fail goto*//*Label 4786*/ GIMT_Encode4(209199), // Rule ID 2459 //
     /* 209177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 209180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 209184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 209188 */     // (fsqrt:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)  =>  (SQRTPSr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)
     /* 209188 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTPSr),
     /* 209193 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209197 */     GIR_RootConstrainSelectedInstOperands,
     /* 209198 */     // GIR_Coverage, 2459,
     /* 209198 */     GIR_Done,
     /* 209199 */   // Label 4786: @209199
     /* 209199 */   GIM_Try, /*On fail goto*//*Label 4787*/ GIMT_Encode4(209226), // Rule ID 12059 //
     /* 209204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 209207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 209211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 209215 */     // (fsqrt:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src)  =>  (VSQRTPSZ128r:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src)
     /* 209215 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ128r),
     /* 209220 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209224 */     GIR_RootConstrainSelectedInstOperands,
     /* 209225 */     // GIR_Coverage, 12059,
     /* 209225 */     GIR_Done,
     /* 209226 */   // Label 4787: @209226
     /* 209226 */   GIM_Reject,
     /* 209227 */ // Label 4782: @209227
     /* 209227 */ GIM_Reject,
     /* 209228 */ // Label 4748: @209228
     /* 209228 */ GIM_Try, /*On fail goto*//*Label 4788*/ GIMT_Encode4(209403),
     /* 209233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 209236 */   GIM_Try, /*On fail goto*//*Label 4789*/ GIMT_Encode4(209292), // Rule ID 2473 //
     /* 209241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 209244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 209248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 209252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209256 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209259 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209263 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209269 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209276 */     // (fsqrt:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDYm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /* 209276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDYm),
     /* 209279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209281 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 209285 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209290 */     GIR_RootConstrainSelectedInstOperands,
     /* 209291 */     // GIR_Coverage, 2473,
     /* 209291 */     GIR_EraseRootFromParent_Done,
     /* 209292 */   // Label 4789: @209292
     /* 209292 */   GIM_Try, /*On fail goto*//*Label 4790*/ GIMT_Encode4(209348), // Rule ID 12099 //
     /* 209297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 209300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 209304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 209308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209312 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209315 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209319 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209325 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209332 */     // (fsqrt:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDZ256m:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /* 209332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ256m),
     /* 209335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209337 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 209341 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209346 */     GIR_RootConstrainSelectedInstOperands,
     /* 209347 */     // GIR_Coverage, 12099,
     /* 209347 */     GIR_EraseRootFromParent_Done,
     /* 209348 */   // Label 4790: @209348
     /* 209348 */   GIM_Try, /*On fail goto*//*Label 4791*/ GIMT_Encode4(209375), // Rule ID 2471 //
     /* 209353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 209356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 209360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 209364 */     // (fsqrt:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src)  =>  (VSQRTPDYr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src)
     /* 209364 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDYr),
     /* 209369 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209373 */     GIR_RootConstrainSelectedInstOperands,
     /* 209374 */     // GIR_Coverage, 2471,
     /* 209374 */     GIR_Done,
     /* 209375 */   // Label 4791: @209375
     /* 209375 */   GIM_Try, /*On fail goto*//*Label 4792*/ GIMT_Encode4(209402), // Rule ID 12095 //
     /* 209380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 209383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 209387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 209391 */     // (fsqrt:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src)  =>  (VSQRTPDZ256r:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src)
     /* 209391 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ256r),
     /* 209396 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209400 */     GIR_RootConstrainSelectedInstOperands,
     /* 209401 */     // GIR_Coverage, 12095,
     /* 209401 */     GIR_Done,
     /* 209402 */   // Label 4792: @209402
     /* 209402 */   GIM_Reject,
     /* 209403 */ // Label 4788: @209403
     /* 209403 */ GIM_Reject,
     /* 209404 */ // Label 4749: @209404
     /* 209404 */ GIM_Try, /*On fail goto*//*Label 4793*/ GIMT_Encode4(209492),
     /* 209409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 209412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 209416 */   GIM_Try, /*On fail goto*//*Label 4794*/ GIMT_Encode4(209468), // Rule ID 12015 //
     /* 209421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 209424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 209428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209432 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209435 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209439 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209445 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209452 */     // (fsqrt:{ *:[v8f16] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPHZ128m:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /* 209452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ128m),
     /* 209455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209457 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 209461 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209466 */     GIR_RootConstrainSelectedInstOperands,
     /* 209467 */     // GIR_Coverage, 12015,
     /* 209467 */     GIR_EraseRootFromParent_Done,
     /* 209468 */   // Label 4794: @209468
     /* 209468 */   GIM_Try, /*On fail goto*//*Label 4795*/ GIMT_Encode4(209491), // Rule ID 12011 //
     /* 209473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 209476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 209480 */     // (fsqrt:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src)  =>  (VSQRTPHZ128r:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src)
     /* 209480 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ128r),
     /* 209485 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209489 */     GIR_RootConstrainSelectedInstOperands,
     /* 209490 */     // GIR_Coverage, 12011,
     /* 209490 */     GIR_Done,
     /* 209491 */   // Label 4795: @209491
     /* 209491 */   GIM_Reject,
     /* 209492 */ // Label 4793: @209492
     /* 209492 */ GIM_Reject,
     /* 209493 */ // Label 4750: @209493
     /* 209493 */ GIM_Try, /*On fail goto*//*Label 4796*/ GIMT_Encode4(209668),
     /* 209498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 209501 */   GIM_Try, /*On fail goto*//*Label 4797*/ GIMT_Encode4(209557), // Rule ID 2457 //
     /* 209506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 209509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 209513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 209517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209521 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209524 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209528 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209534 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209541 */     // (fsqrt:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSYm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 209541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSYm),
     /* 209544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209546 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 209550 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209555 */     GIR_RootConstrainSelectedInstOperands,
     /* 209556 */     // GIR_Coverage, 2457,
     /* 209556 */     GIR_EraseRootFromParent_Done,
     /* 209557 */   // Label 4797: @209557
     /* 209557 */   GIM_Try, /*On fail goto*//*Label 4798*/ GIMT_Encode4(209613), // Rule ID 12075 //
     /* 209562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 209565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 209569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 209573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209577 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209580 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209584 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209590 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209597 */     // (fsqrt:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSZ256m:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 209597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ256m),
     /* 209600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209602 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 209606 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209611 */     GIR_RootConstrainSelectedInstOperands,
     /* 209612 */     // GIR_Coverage, 12075,
     /* 209612 */     GIR_EraseRootFromParent_Done,
     /* 209613 */   // Label 4798: @209613
     /* 209613 */   GIM_Try, /*On fail goto*//*Label 4799*/ GIMT_Encode4(209640), // Rule ID 2455 //
     /* 209618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 209621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 209625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 209629 */     // (fsqrt:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src)  =>  (VSQRTPSYr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src)
     /* 209629 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSYr),
     /* 209634 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209638 */     GIR_RootConstrainSelectedInstOperands,
     /* 209639 */     // GIR_Coverage, 2455,
     /* 209639 */     GIR_Done,
     /* 209640 */   // Label 4799: @209640
     /* 209640 */   GIM_Try, /*On fail goto*//*Label 4800*/ GIMT_Encode4(209667), // Rule ID 12071 //
     /* 209645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 209648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 209652 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 209656 */     // (fsqrt:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src)  =>  (VSQRTPSZ256r:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src)
     /* 209656 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ256r),
     /* 209661 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209665 */     GIR_RootConstrainSelectedInstOperands,
     /* 209666 */     // GIR_Coverage, 12071,
     /* 209666 */     GIR_Done,
     /* 209667 */   // Label 4800: @209667
     /* 209667 */   GIM_Reject,
     /* 209668 */ // Label 4796: @209668
     /* 209668 */ GIM_Reject,
     /* 209669 */ // Label 4751: @209669
     /* 209669 */ GIM_Try, /*On fail goto*//*Label 4801*/ GIMT_Encode4(209757),
     /* 209674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 209677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 209681 */   GIM_Try, /*On fail goto*//*Label 4802*/ GIMT_Encode4(209733), // Rule ID 12051 //
     /* 209686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 209689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 209693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209697 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209700 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209704 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209708 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209710 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209717 */     // (fsqrt:{ *:[v8f64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDZm:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)
     /* 209717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZm),
     /* 209720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209722 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 209726 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209731 */     GIR_RootConstrainSelectedInstOperands,
     /* 209732 */     // GIR_Coverage, 12051,
     /* 209732 */     GIR_EraseRootFromParent_Done,
     /* 209733 */   // Label 4802: @209733
     /* 209733 */   GIM_Try, /*On fail goto*//*Label 4803*/ GIMT_Encode4(209756), // Rule ID 12047 //
     /* 209738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 209741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 209745 */     // (fsqrt:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src)  =>  (VSQRTPDZr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src)
     /* 209745 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZr),
     /* 209750 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209754 */     GIR_RootConstrainSelectedInstOperands,
     /* 209755 */     // GIR_Coverage, 12047,
     /* 209755 */     GIR_Done,
     /* 209756 */   // Label 4803: @209756
     /* 209756 */   GIM_Reject,
     /* 209757 */ // Label 4801: @209757
     /* 209757 */ GIM_Reject,
     /* 209758 */ // Label 4752: @209758
     /* 209758 */ GIM_Try, /*On fail goto*//*Label 4804*/ GIMT_Encode4(209846),
     /* 209763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 209766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 209770 */   GIM_Try, /*On fail goto*//*Label 4805*/ GIMT_Encode4(209822), // Rule ID 12027 //
     /* 209775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 209778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 209782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209786 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209789 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209793 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209799 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209806 */     // (fsqrt:{ *:[v16f16] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPHZ256m:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /* 209806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ256m),
     /* 209809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209811 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 209815 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209820 */     GIR_RootConstrainSelectedInstOperands,
     /* 209821 */     // GIR_Coverage, 12027,
     /* 209821 */     GIR_EraseRootFromParent_Done,
     /* 209822 */   // Label 4805: @209822
     /* 209822 */   GIM_Try, /*On fail goto*//*Label 4806*/ GIMT_Encode4(209845), // Rule ID 12023 //
     /* 209827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 209830 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 209834 */     // (fsqrt:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src)  =>  (VSQRTPHZ256r:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src)
     /* 209834 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ256r),
     /* 209839 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209843 */     GIR_RootConstrainSelectedInstOperands,
     /* 209844 */     // GIR_Coverage, 12023,
     /* 209844 */     GIR_Done,
     /* 209845 */   // Label 4806: @209845
     /* 209845 */   GIM_Reject,
     /* 209846 */ // Label 4804: @209846
     /* 209846 */ GIM_Reject,
     /* 209847 */ // Label 4753: @209847
     /* 209847 */ GIM_Try, /*On fail goto*//*Label 4807*/ GIMT_Encode4(209935),
     /* 209852 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 209855 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 209859 */   GIM_Try, /*On fail goto*//*Label 4808*/ GIMT_Encode4(209911), // Rule ID 12039 //
     /* 209864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 209867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 209871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209875 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209878 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209882 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209888 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209895 */     // (fsqrt:{ *:[v16f32] } (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSZm:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)
     /* 209895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZm),
     /* 209898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209900 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 209904 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209909 */     GIR_RootConstrainSelectedInstOperands,
     /* 209910 */     // GIR_Coverage, 12039,
     /* 209910 */     GIR_EraseRootFromParent_Done,
     /* 209911 */   // Label 4808: @209911
     /* 209911 */   GIM_Try, /*On fail goto*//*Label 4809*/ GIMT_Encode4(209934), // Rule ID 12035 //
     /* 209916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 209919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 209923 */     // (fsqrt:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src)  =>  (VSQRTPSZr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src)
     /* 209923 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZr),
     /* 209928 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209932 */     GIR_RootConstrainSelectedInstOperands,
     /* 209933 */     // GIR_Coverage, 12035,
     /* 209933 */     GIR_Done,
     /* 209934 */   // Label 4809: @209934
     /* 209934 */   GIM_Reject,
     /* 209935 */ // Label 4807: @209935
     /* 209935 */ GIM_Reject,
     /* 209936 */ // Label 4754: @209936
     /* 209936 */ GIM_Try, /*On fail goto*//*Label 4810*/ GIMT_Encode4(210024),
     /* 209941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 209944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 209948 */   GIM_Try, /*On fail goto*//*Label 4811*/ GIMT_Encode4(210000), // Rule ID 12003 //
     /* 209953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 209956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 209960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209964 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209967 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209971 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209977 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209984 */     // (fsqrt:{ *:[v32f16] } (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPHZm:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)
     /* 209984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZm),
     /* 209987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209989 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 209993 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209998 */     GIR_RootConstrainSelectedInstOperands,
     /* 209999 */     // GIR_Coverage, 12003,
     /* 209999 */     GIR_EraseRootFromParent_Done,
     /* 210000 */   // Label 4811: @210000
     /* 210000 */   GIM_Try, /*On fail goto*//*Label 4812*/ GIMT_Encode4(210023), // Rule ID 11999 //
     /* 210005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 210008 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 210012 */     // (fsqrt:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src)  =>  (VSQRTPHZr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src)
     /* 210012 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZr),
     /* 210017 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 210021 */     GIR_RootConstrainSelectedInstOperands,
     /* 210022 */     // GIR_Coverage, 11999,
     /* 210022 */     GIR_Done,
     /* 210023 */   // Label 4812: @210023
     /* 210023 */   GIM_Reject,
     /* 210024 */ // Label 4810: @210024
     /* 210024 */ GIM_Reject,
     /* 210025 */ // Label 4755: @210025
     /* 210025 */ GIM_Reject,
     /* 210026 */ // Label 68: @210026
     /* 210026 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 4826*/ GIMT_Encode4(214955),
     /* 210037 */ /*GILLT_s16*//*Label 4813*/ GIMT_Encode4(210121),
     /* 210041 */ /*GILLT_s32*//*Label 4814*/ GIMT_Encode4(210281),
     /* 210045 */ /*GILLT_s64*//*Label 4815*/ GIMT_Encode4(211186),
     /* 210049 */ /*GILLT_s80*//*Label 4816*/ GIMT_Encode4(212235), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 210061 */ /*GILLT_v2s64*//*Label 4817*/ GIMT_Encode4(212801), GIMT_Encode4(0),
     /* 210069 */ /*GILLT_v4s32*//*Label 4818*/ GIMT_Encode4(213155),
     /* 210073 */ /*GILLT_v4s64*//*Label 4819*/ GIMT_Encode4(213509), GIMT_Encode4(0),
     /* 210081 */ /*GILLT_v8s16*//*Label 4820*/ GIMT_Encode4(213832),
     /* 210085 */ /*GILLT_v8s32*//*Label 4821*/ GIMT_Encode4(213992),
     /* 210089 */ /*GILLT_v8s64*//*Label 4822*/ GIMT_Encode4(214315), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 210101 */ /*GILLT_v16s16*//*Label 4823*/ GIMT_Encode4(214475),
     /* 210105 */ /*GILLT_v16s32*//*Label 4824*/ GIMT_Encode4(214635), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 210117 */ /*GILLT_v32s16*//*Label 4825*/ GIMT_Encode4(214795),
     /* 210121 */ // Label 4813: @210121
     /* 210121 */ GIM_Try, /*On fail goto*//*Label 4827*/ GIMT_Encode4(210280),
     /* 210126 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 210129 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 210132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 210136 */   GIM_Try, /*On fail goto*//*Label 4828*/ GIMT_Encode4(210194), // Rule ID 24249 //
     /* 210141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 210144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 210148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210152 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210155 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210159 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 210167 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210169 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210176 */     // (strict_fadd:{ *:[f16] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR16X:{ *:[f16] }:$src1)  =>  (VADDSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSHZrm),
     /* 210179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210181 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 210183 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210187 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210192 */     GIR_RootConstrainSelectedInstOperands,
     /* 210193 */     // GIR_Coverage, 24249,
     /* 210193 */     GIR_EraseRootFromParent_Done,
     /* 210194 */   // Label 4828: @210194
     /* 210194 */   GIM_Try, /*On fail goto*//*Label 4829*/ GIMT_Encode4(210252), // Rule ID 5954 //
     /* 210199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 210202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 210206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 210210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210214 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210217 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210221 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210227 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210234 */     // (strict_fadd:{ *:[f16] } FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSHZrm),
     /* 210237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210239 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 210241 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210245 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210250 */     GIR_RootConstrainSelectedInstOperands,
     /* 210251 */     // GIR_Coverage, 5954,
     /* 210251 */     GIR_EraseRootFromParent_Done,
     /* 210252 */   // Label 4829: @210252
     /* 210252 */   GIM_Try, /*On fail goto*//*Label 4830*/ GIMT_Encode4(210279), // Rule ID 5952 //
     /* 210257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 210260 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 210264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 210268 */     // (strict_fadd:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VADDSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 210268 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSHZrr),
     /* 210273 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 210277 */     GIR_RootConstrainSelectedInstOperands,
     /* 210278 */     // GIR_Coverage, 5952,
     /* 210278 */     GIR_Done,
     /* 210279 */   // Label 4830: @210279
     /* 210279 */   GIM_Reject,
     /* 210280 */ // Label 4827: @210280
     /* 210280 */ GIM_Reject,
     /* 210281 */ // Label 4814: @210281
     /* 210281 */ GIM_Try, /*On fail goto*//*Label 4831*/ GIMT_Encode4(211185),
     /* 210286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 210289 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 210292 */   GIM_Try, /*On fail goto*//*Label 4832*/ GIMT_Encode4(210357), // Rule ID 23246 //
     /* 210297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 210300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 210304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 210308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 210312 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 210319 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 210327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210329 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210336 */     // (strict_fadd:{ *:[f32] } (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP32:{ *:[f32] }:$src1)  =>  (ADD_FpI16m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI16m32),
     /* 210339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210341 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 210343 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210347 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 210350 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210355 */     GIR_RootConstrainSelectedInstOperands,
     /* 210356 */     // GIR_Coverage, 23246,
     /* 210356 */     GIR_EraseRootFromParent_Done,
     /* 210357 */   // Label 4832: @210357
     /* 210357 */   GIM_Try, /*On fail goto*//*Label 4833*/ GIMT_Encode4(210422), // Rule ID 23248 //
     /* 210362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 210365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 210369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 210373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 210377 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 210384 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 210392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210394 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210401 */     // (strict_fadd:{ *:[f32] } (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP32:{ *:[f32] }:$src1)  =>  (ADD_FpI32m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI32m32),
     /* 210404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210406 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 210408 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210412 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 210415 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210420 */     GIR_RootConstrainSelectedInstOperands,
     /* 210421 */     // GIR_Coverage, 23248,
     /* 210421 */     GIR_EraseRootFromParent_Done,
     /* 210422 */   // Label 4833: @210422
     /* 210422 */   GIM_Try, /*On fail goto*//*Label 4834*/ GIMT_Encode4(210487), // Rule ID 23236 //
     /* 210427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 210430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 210434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 210438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210442 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210445 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210449 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 210457 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210459 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210466 */     // (strict_fadd:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP32:{ *:[f32] }:$src1)  =>  (ADD_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp32m),
     /* 210469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210471 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 210473 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210477 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 210480 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210485 */     GIR_RootConstrainSelectedInstOperands,
     /* 210486 */     // GIR_Coverage, 23236,
     /* 210486 */     GIR_EraseRootFromParent_Done,
     /* 210487 */   // Label 4834: @210487
     /* 210487 */   GIM_Try, /*On fail goto*//*Label 4835*/ GIMT_Encode4(210549), // Rule ID 23381 //
     /* 210492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 210495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 210499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 210503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210507 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210510 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210514 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 210522 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210524 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210531 */     // (strict_fadd:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (VADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSrm),
     /* 210534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210536 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 210538 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210542 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210547 */     GIR_RootConstrainSelectedInstOperands,
     /* 210548 */     // GIR_Coverage, 23381,
     /* 210548 */     GIR_EraseRootFromParent_Done,
     /* 210549 */   // Label 4835: @210549
     /* 210549 */   GIM_Try, /*On fail goto*//*Label 4836*/ GIMT_Encode4(210611), // Rule ID 23385 //
     /* 210554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 210557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 210561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 210565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210569 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210572 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210576 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 210584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210586 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210593 */     // (strict_fadd:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (ADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSSrm),
     /* 210596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210598 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 210600 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210604 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210609 */     GIR_RootConstrainSelectedInstOperands,
     /* 210610 */     // GIR_Coverage, 23385,
     /* 210610 */     GIR_EraseRootFromParent_Done,
     /* 210611 */   // Label 4836: @210611
     /* 210611 */   GIM_Try, /*On fail goto*//*Label 4837*/ GIMT_Encode4(210673), // Rule ID 24245 //
     /* 210616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 210619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 210623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 210627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210631 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210634 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210638 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 210646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210648 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210655 */     // (strict_fadd:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32X:{ *:[f32] }:$src1)  =>  (VADDSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSZrm),
     /* 210658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210660 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 210662 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210666 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210671 */     GIR_RootConstrainSelectedInstOperands,
     /* 210672 */     // GIR_Coverage, 24245,
     /* 210672 */     GIR_EraseRootFromParent_Done,
     /* 210673 */   // Label 4837: @210673
     /* 210673 */   GIM_Try, /*On fail goto*//*Label 4838*/ GIMT_Encode4(210738), // Rule ID 920 //
     /* 210678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 210681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 210685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 210689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 210693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 210697 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 210704 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210708 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210710 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210717 */     // (strict_fadd:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (ADD_FpI16m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI16m32),
     /* 210720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210722 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 210724 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210728 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 210731 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210736 */     GIR_RootConstrainSelectedInstOperands,
     /* 210737 */     // GIR_Coverage, 920,
     /* 210737 */     GIR_EraseRootFromParent_Done,
     /* 210738 */   // Label 4838: @210738
     /* 210738 */   GIM_Try, /*On fail goto*//*Label 4839*/ GIMT_Encode4(210803), // Rule ID 922 //
     /* 210743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 210746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 210750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 210754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 210758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 210762 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 210769 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210775 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210782 */     // (strict_fadd:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (ADD_FpI32m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI32m32),
     /* 210785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210787 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 210789 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210793 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 210796 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210801 */     GIR_RootConstrainSelectedInstOperands,
     /* 210802 */     // GIR_Coverage, 922,
     /* 210802 */     GIR_EraseRootFromParent_Done,
     /* 210803 */   // Label 4839: @210803
     /* 210803 */   GIM_Try, /*On fail goto*//*Label 4840*/ GIMT_Encode4(210868), // Rule ID 910 //
     /* 210808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 210811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 210815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 210819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 210823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210827 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210830 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210834 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210838 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210840 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210847 */     // (strict_fadd:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADD_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp32m),
     /* 210850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210852 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 210854 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210858 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 210861 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210866 */     GIR_RootConstrainSelectedInstOperands,
     /* 210867 */     // GIR_Coverage, 910,
     /* 210867 */     GIR_EraseRootFromParent_Done,
     /* 210868 */   // Label 4840: @210868
     /* 210868 */   GIM_Try, /*On fail goto*//*Label 4841*/ GIMT_Encode4(210930), // Rule ID 2160 //
     /* 210873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 210876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 210880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 210884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 210888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210892 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210895 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210899 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210905 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210912 */     // (strict_fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSrm),
     /* 210915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210917 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 210919 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210923 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210928 */     GIR_RootConstrainSelectedInstOperands,
     /* 210929 */     // GIR_Coverage, 2160,
     /* 210929 */     GIR_EraseRootFromParent_Done,
     /* 210930 */   // Label 4841: @210930
     /* 210930 */   GIM_Try, /*On fail goto*//*Label 4842*/ GIMT_Encode4(210992), // Rule ID 2168 //
     /* 210935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 210938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 210942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 210946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 210950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210954 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210957 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210961 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210967 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210974 */     // (strict_fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSSrm),
     /* 210977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210979 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 210981 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210985 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210990 */     GIR_RootConstrainSelectedInstOperands,
     /* 210991 */     // GIR_Coverage, 2168,
     /* 210991 */     GIR_EraseRootFromParent_Done,
     /* 210992 */   // Label 4842: @210992
     /* 210992 */   GIM_Try, /*On fail goto*//*Label 4843*/ GIMT_Encode4(211054), // Rule ID 5916 //
     /* 210997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 211000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 211004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 211008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 211012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211016 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211019 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211023 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211029 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211036 */     // (strict_fadd:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSZrm),
     /* 211039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211041 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 211043 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211047 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211052 */     GIR_RootConstrainSelectedInstOperands,
     /* 211053 */     // GIR_Coverage, 5916,
     /* 211053 */     GIR_EraseRootFromParent_Done,
     /* 211054 */   // Label 4843: @211054
     /* 211054 */   GIM_Try, /*On fail goto*//*Label 4844*/ GIMT_Encode4(211091), // Rule ID 886 //
     /* 211059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 211062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 211066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 211070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 211074 */     // (strict_fadd:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (ADD_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 211074 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD_Fp32),
     /* 211079 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 211085 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 211089 */     GIR_RootConstrainSelectedInstOperands,
     /* 211090 */     // GIR_Coverage, 886,
     /* 211090 */     GIR_Done,
     /* 211091 */   // Label 4844: @211091
     /* 211091 */   GIM_Try, /*On fail goto*//*Label 4845*/ GIMT_Encode4(211122), // Rule ID 2158 //
     /* 211096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 211099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 211103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 211107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 211111 */     // (strict_fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VADDSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 211111 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSSrr),
     /* 211116 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 211120 */     GIR_RootConstrainSelectedInstOperands,
     /* 211121 */     // GIR_Coverage, 2158,
     /* 211121 */     GIR_Done,
     /* 211122 */   // Label 4845: @211122
     /* 211122 */   GIM_Try, /*On fail goto*//*Label 4846*/ GIMT_Encode4(211153), // Rule ID 2166 //
     /* 211127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 211130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 211134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 211138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 211142 */     // (strict_fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (ADDSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 211142 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDSSrr),
     /* 211147 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 211151 */     GIR_RootConstrainSelectedInstOperands,
     /* 211152 */     // GIR_Coverage, 2166,
     /* 211152 */     GIR_Done,
     /* 211153 */   // Label 4846: @211153
     /* 211153 */   GIM_Try, /*On fail goto*//*Label 4847*/ GIMT_Encode4(211184), // Rule ID 5914 //
     /* 211158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 211161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 211165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 211169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 211173 */     // (strict_fadd:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VADDSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 211173 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSSZrr),
     /* 211178 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 211182 */     GIR_RootConstrainSelectedInstOperands,
     /* 211183 */     // GIR_Coverage, 5914,
     /* 211183 */     GIR_Done,
     /* 211184 */   // Label 4847: @211184
     /* 211184 */   GIM_Reject,
     /* 211185 */ // Label 4831: @211185
     /* 211185 */ GIM_Reject,
     /* 211186 */ // Label 4815: @211186
     /* 211186 */ GIM_Try, /*On fail goto*//*Label 4848*/ GIMT_Encode4(212234),
     /* 211191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 211194 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 211197 */   GIM_Try, /*On fail goto*//*Label 4849*/ GIMT_Encode4(211262), // Rule ID 23250 //
     /* 211202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 211205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 211213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 211217 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 211224 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211234 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211241 */     // (strict_fadd:{ *:[f64] } (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP64:{ *:[f64] }:$src1)  =>  (ADD_FpI16m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI16m64),
     /* 211244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211246 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 211248 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211252 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 211255 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211260 */     GIR_RootConstrainSelectedInstOperands,
     /* 211261 */     // GIR_Coverage, 23250,
     /* 211261 */     GIR_EraseRootFromParent_Done,
     /* 211262 */   // Label 4849: @211262
     /* 211262 */   GIM_Try, /*On fail goto*//*Label 4850*/ GIMT_Encode4(211327), // Rule ID 23252 //
     /* 211267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 211270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 211278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 211282 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 211289 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211299 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211306 */     // (strict_fadd:{ *:[f64] } (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP64:{ *:[f64] }:$src1)  =>  (ADD_FpI32m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI32m64),
     /* 211309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211311 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 211313 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211317 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 211320 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211325 */     GIR_RootConstrainSelectedInstOperands,
     /* 211326 */     // GIR_Coverage, 23252,
     /* 211326 */     GIR_EraseRootFromParent_Done,
     /* 211327 */   // Label 4850: @211327
     /* 211327 */   GIM_Try, /*On fail goto*//*Label 4851*/ GIMT_Encode4(211392), // Rule ID 23238 //
     /* 211332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 211335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 211343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211347 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211350 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211354 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211362 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211364 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211371 */     // (strict_fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP64:{ *:[f64] }:$src1)  =>  (ADD_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64m),
     /* 211374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211376 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 211378 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211382 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 211385 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211390 */     GIR_RootConstrainSelectedInstOperands,
     /* 211391 */     // GIR_Coverage, 23238,
     /* 211391 */     GIR_EraseRootFromParent_Done,
     /* 211392 */   // Label 4851: @211392
     /* 211392 */   GIM_Try, /*On fail goto*//*Label 4852*/ GIMT_Encode4(211464), // Rule ID 23240 //
     /* 211397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 211400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 211408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211412 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211415 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211419 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 211426 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211434 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211436 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211443 */     // (strict_fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP64:{ *:[f64] }:$src1)  =>  (ADD_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64m32),
     /* 211446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211448 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 211450 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211454 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 211457 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211462 */     GIR_RootConstrainSelectedInstOperands,
     /* 211463 */     // GIR_Coverage, 23240,
     /* 211463 */     GIR_EraseRootFromParent_Done,
     /* 211464 */   // Label 4852: @211464
     /* 211464 */   GIM_Try, /*On fail goto*//*Label 4853*/ GIMT_Encode4(211526), // Rule ID 23383 //
     /* 211469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 211472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 211476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 211480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211484 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211487 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211491 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 211499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211501 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211508 */     // (strict_fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (VADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDrm),
     /* 211511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211513 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 211515 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211519 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211524 */     GIR_RootConstrainSelectedInstOperands,
     /* 211525 */     // GIR_Coverage, 23383,
     /* 211525 */     GIR_EraseRootFromParent_Done,
     /* 211526 */   // Label 4853: @211526
     /* 211526 */   GIM_Try, /*On fail goto*//*Label 4854*/ GIMT_Encode4(211588), // Rule ID 23387 //
     /* 211531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 211534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 211538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 211542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211546 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211549 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211553 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 211561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211563 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211570 */     // (strict_fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (ADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSDrm),
     /* 211573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211575 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 211577 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211581 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211586 */     GIR_RootConstrainSelectedInstOperands,
     /* 211587 */     // GIR_Coverage, 23387,
     /* 211587 */     GIR_EraseRootFromParent_Done,
     /* 211588 */   // Label 4854: @211588
     /* 211588 */   GIM_Try, /*On fail goto*//*Label 4855*/ GIMT_Encode4(211650), // Rule ID 24247 //
     /* 211593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 211596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 211600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 211604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211608 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211611 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211615 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 211623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211625 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211632 */     // (strict_fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64X:{ *:[f64] }:$src1)  =>  (VADDSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDZrm),
     /* 211635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211637 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 211639 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211643 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211648 */     GIR_RootConstrainSelectedInstOperands,
     /* 211649 */     // GIR_Coverage, 24247,
     /* 211649 */     GIR_EraseRootFromParent_Done,
     /* 211650 */   // Label 4855: @211650
     /* 211650 */   GIM_Try, /*On fail goto*//*Label 4856*/ GIMT_Encode4(211715), // Rule ID 924 //
     /* 211655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 211658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 211670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 211674 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 211681 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211687 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211694 */     // (strict_fadd:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (ADD_FpI16m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI16m64),
     /* 211697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211699 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 211701 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211705 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 211708 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211713 */     GIR_RootConstrainSelectedInstOperands,
     /* 211714 */     // GIR_Coverage, 924,
     /* 211714 */     GIR_EraseRootFromParent_Done,
     /* 211715 */   // Label 4856: @211715
     /* 211715 */   GIM_Try, /*On fail goto*//*Label 4857*/ GIMT_Encode4(211780), // Rule ID 926 //
     /* 211720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 211723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 211735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 211739 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 211746 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211750 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211752 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211759 */     // (strict_fadd:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (ADD_FpI32m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI32m64),
     /* 211762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211764 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 211766 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211770 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 211773 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211778 */     GIR_RootConstrainSelectedInstOperands,
     /* 211779 */     // GIR_Coverage, 926,
     /* 211779 */     GIR_EraseRootFromParent_Done,
     /* 211780 */   // Label 4857: @211780
     /* 211780 */   GIM_Try, /*On fail goto*//*Label 4858*/ GIMT_Encode4(211845), // Rule ID 912 //
     /* 211785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 211788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 211800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211804 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211807 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211811 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211817 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211824 */     // (strict_fadd:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADD_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64m),
     /* 211827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211829 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 211831 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211835 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 211838 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211843 */     GIR_RootConstrainSelectedInstOperands,
     /* 211844 */     // GIR_Coverage, 912,
     /* 211844 */     GIR_EraseRootFromParent_Done,
     /* 211845 */   // Label 4858: @211845
     /* 211845 */   GIM_Try, /*On fail goto*//*Label 4859*/ GIMT_Encode4(211917), // Rule ID 914 //
     /* 211850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 211853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 211865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211869 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211872 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211876 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 211883 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211889 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211896 */     // (strict_fadd:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (ADD_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64m32),
     /* 211899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211901 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 211903 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211907 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 211910 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211915 */     GIR_RootConstrainSelectedInstOperands,
     /* 211916 */     // GIR_Coverage, 914,
     /* 211916 */     GIR_EraseRootFromParent_Done,
     /* 211917 */   // Label 4859: @211917
     /* 211917 */   GIM_Try, /*On fail goto*//*Label 4860*/ GIMT_Encode4(211979), // Rule ID 2164 //
     /* 211922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 211925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 211929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 211933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 211937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211941 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211944 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211948 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211952 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211954 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211961 */     // (strict_fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDrm),
     /* 211964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211966 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 211968 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211972 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211977 */     GIR_RootConstrainSelectedInstOperands,
     /* 211978 */     // GIR_Coverage, 2164,
     /* 211978 */     GIR_EraseRootFromParent_Done,
     /* 211979 */   // Label 4860: @211979
     /* 211979 */   GIM_Try, /*On fail goto*//*Label 4861*/ GIMT_Encode4(212041), // Rule ID 2172 //
     /* 211984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 211987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 211991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 211995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 211999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 212003 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 212006 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 212010 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212016 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212023 */     // (strict_fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSDrm),
     /* 212026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212028 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 212030 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212034 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212039 */     GIR_RootConstrainSelectedInstOperands,
     /* 212040 */     // GIR_Coverage, 2172,
     /* 212040 */     GIR_EraseRootFromParent_Done,
     /* 212041 */   // Label 4861: @212041
     /* 212041 */   GIM_Try, /*On fail goto*//*Label 4862*/ GIMT_Encode4(212103), // Rule ID 5935 //
     /* 212046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 212049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 212053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 212057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 212065 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 212068 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 212072 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212076 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212078 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212085 */     // (strict_fadd:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDZrm),
     /* 212088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212090 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 212092 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212096 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212101 */     GIR_RootConstrainSelectedInstOperands,
     /* 212102 */     // GIR_Coverage, 5935,
     /* 212102 */     GIR_EraseRootFromParent_Done,
     /* 212103 */   // Label 4862: @212103
     /* 212103 */   GIM_Try, /*On fail goto*//*Label 4863*/ GIMT_Encode4(212140), // Rule ID 888 //
     /* 212108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 212111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 212115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 212119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 212123 */     // (strict_fadd:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (ADD_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 212123 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64),
     /* 212128 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 212134 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 212138 */     GIR_RootConstrainSelectedInstOperands,
     /* 212139 */     // GIR_Coverage, 888,
     /* 212139 */     GIR_Done,
     /* 212140 */   // Label 4863: @212140
     /* 212140 */   GIM_Try, /*On fail goto*//*Label 4864*/ GIMT_Encode4(212171), // Rule ID 2162 //
     /* 212145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 212148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 212152 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 212156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 212160 */     // (strict_fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VADDSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 212160 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSDrr),
     /* 212165 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 212169 */     GIR_RootConstrainSelectedInstOperands,
     /* 212170 */     // GIR_Coverage, 2162,
     /* 212170 */     GIR_Done,
     /* 212171 */   // Label 4864: @212171
     /* 212171 */   GIM_Try, /*On fail goto*//*Label 4865*/ GIMT_Encode4(212202), // Rule ID 2170 //
     /* 212176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 212179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 212183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 212187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 212191 */     // (strict_fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (ADDSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 212191 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDSDrr),
     /* 212196 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 212200 */     GIR_RootConstrainSelectedInstOperands,
     /* 212201 */     // GIR_Coverage, 2170,
     /* 212201 */     GIR_Done,
     /* 212202 */   // Label 4865: @212202
     /* 212202 */   GIM_Try, /*On fail goto*//*Label 4866*/ GIMT_Encode4(212233), // Rule ID 5933 //
     /* 212207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 212210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 212214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 212218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 212222 */     // (strict_fadd:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VADDSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 212222 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSDZrr),
     /* 212227 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 212231 */     GIR_RootConstrainSelectedInstOperands,
     /* 212232 */     // GIR_Coverage, 5933,
     /* 212232 */     GIR_Done,
     /* 212233 */   // Label 4866: @212233
     /* 212233 */   GIM_Reject,
     /* 212234 */ // Label 4848: @212234
     /* 212234 */ GIM_Reject,
     /* 212235 */ // Label 4816: @212235
     /* 212235 */ GIM_Try, /*On fail goto*//*Label 4867*/ GIMT_Encode4(212800),
     /* 212240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 212243 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 212246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 212250 */   GIM_Try, /*On fail goto*//*Label 4868*/ GIMT_Encode4(212311), // Rule ID 23254 //
     /* 212255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 212258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 212262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 212266 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 212273 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 212281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212283 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212290 */     // (strict_fadd:{ *:[f80] } (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP80:{ *:[f80] }:$src1)  =>  (ADD_FpI16m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI16m80),
     /* 212293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212295 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 212297 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212301 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 212304 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212309 */     GIR_RootConstrainSelectedInstOperands,
     /* 212310 */     // GIR_Coverage, 23254,
     /* 212310 */     GIR_EraseRootFromParent_Done,
     /* 212311 */   // Label 4868: @212311
     /* 212311 */   GIM_Try, /*On fail goto*//*Label 4869*/ GIMT_Encode4(212372), // Rule ID 23256 //
     /* 212316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 212319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 212323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 212327 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 212334 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 212342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212344 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212351 */     // (strict_fadd:{ *:[f80] } (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP80:{ *:[f80] }:$src1)  =>  (ADD_FpI32m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI32m80),
     /* 212354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212356 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 212358 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212362 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 212365 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212370 */     GIR_RootConstrainSelectedInstOperands,
     /* 212371 */     // GIR_Coverage, 23256,
     /* 212371 */     GIR_EraseRootFromParent_Done,
     /* 212372 */   // Label 4869: @212372
     /* 212372 */   GIM_Try, /*On fail goto*//*Label 4870*/ GIMT_Encode4(212440), // Rule ID 23242 //
     /* 212377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 212380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 212384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 212388 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 212391 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 212395 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 212402 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 212410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212412 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212419 */     // (strict_fadd:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP80:{ *:[f80] }:$src1)  =>  (ADD_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80m32),
     /* 212422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212424 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 212426 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212430 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 212433 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212438 */     GIR_RootConstrainSelectedInstOperands,
     /* 212439 */     // GIR_Coverage, 23242,
     /* 212439 */     GIR_EraseRootFromParent_Done,
     /* 212440 */   // Label 4870: @212440
     /* 212440 */   GIM_Try, /*On fail goto*//*Label 4871*/ GIMT_Encode4(212508), // Rule ID 23244 //
     /* 212445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 212448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 212452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 212456 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 212459 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 212463 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 212470 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 212478 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212480 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212487 */     // (strict_fadd:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>, RFP80:{ *:[f80] }:$src1)  =>  (ADD_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80m64),
     /* 212490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212492 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 212494 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212498 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 212501 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212506 */     GIR_RootConstrainSelectedInstOperands,
     /* 212507 */     // GIR_Coverage, 23244,
     /* 212507 */     GIR_EraseRootFromParent_Done,
     /* 212508 */   // Label 4871: @212508
     /* 212508 */   GIM_Try, /*On fail goto*//*Label 4872*/ GIMT_Encode4(212569), // Rule ID 928 //
     /* 212513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 212516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 212520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 212528 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 212535 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212541 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212548 */     // (strict_fadd:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (ADD_FpI16m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI16m80),
     /* 212551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212553 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 212555 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212559 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 212562 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212567 */     GIR_RootConstrainSelectedInstOperands,
     /* 212568 */     // GIR_Coverage, 928,
     /* 212568 */     GIR_EraseRootFromParent_Done,
     /* 212569 */   // Label 4872: @212569
     /* 212569 */   GIM_Try, /*On fail goto*//*Label 4873*/ GIMT_Encode4(212630), // Rule ID 930 //
     /* 212574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 212577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 212581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 212589 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 212596 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212602 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212609 */     // (strict_fadd:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (ADD_FpI32m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI32m80),
     /* 212612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212614 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 212616 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212620 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 212623 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212628 */     GIR_RootConstrainSelectedInstOperands,
     /* 212629 */     // GIR_Coverage, 930,
     /* 212629 */     GIR_EraseRootFromParent_Done,
     /* 212630 */   // Label 4873: @212630
     /* 212630 */   GIM_Try, /*On fail goto*//*Label 4874*/ GIMT_Encode4(212698), // Rule ID 916 //
     /* 212635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 212638 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 212642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 212650 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 212653 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 212657 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 212664 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212670 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212677 */     // (strict_fadd:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (ADD_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80m32),
     /* 212680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212682 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 212684 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212688 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 212691 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212696 */     GIR_RootConstrainSelectedInstOperands,
     /* 212697 */     // GIR_Coverage, 916,
     /* 212697 */     GIR_EraseRootFromParent_Done,
     /* 212698 */   // Label 4874: @212698
     /* 212698 */   GIM_Try, /*On fail goto*//*Label 4875*/ GIMT_Encode4(212766), // Rule ID 918 //
     /* 212703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 212706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 212710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 212718 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 212721 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 212725 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 212732 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212738 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212745 */     // (strict_fadd:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>)  =>  (ADD_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80m64),
     /* 212748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212750 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 212752 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212756 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 212759 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212764 */     GIR_RootConstrainSelectedInstOperands,
     /* 212765 */     // GIR_Coverage, 918,
     /* 212765 */     GIR_EraseRootFromParent_Done,
     /* 212766 */   // Label 4875: @212766
     /* 212766 */   GIM_Try, /*On fail goto*//*Label 4876*/ GIMT_Encode4(212799), // Rule ID 890 //
     /* 212771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 212774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 212778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 212782 */     // (strict_fadd:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (ADD_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 212782 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80),
     /* 212787 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 212793 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 212797 */     GIR_RootConstrainSelectedInstOperands,
     /* 212798 */     // GIR_Coverage, 890,
     /* 212798 */     GIR_Done,
     /* 212799 */   // Label 4876: @212799
     /* 212799 */   GIM_Reject,
     /* 212800 */ // Label 4867: @212800
     /* 212800 */ GIM_Reject,
     /* 212801 */ // Label 4817: @212801
     /* 212801 */ GIM_Try, /*On fail goto*//*Label 4877*/ GIMT_Encode4(213154),
     /* 212806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 212809 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 212812 */   GIM_Try, /*On fail goto*//*Label 4878*/ GIMT_Encode4(212874), // Rule ID 23371 //
     /* 212817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 212820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 212828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 212832 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 212835 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 212839 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212849 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212856 */     // (strict_fadd:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1)  =>  (VADDPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDrm),
     /* 212859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212861 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 212863 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212867 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212872 */     GIR_RootConstrainSelectedInstOperands,
     /* 212873 */     // GIR_Coverage, 23371,
     /* 212873 */     GIR_EraseRootFromParent_Done,
     /* 212874 */   // Label 4878: @212874
     /* 212874 */   GIM_Try, /*On fail goto*//*Label 4879*/ GIMT_Encode4(212936), // Rule ID 24295 //
     /* 212879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 212882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 212886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 212890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 212894 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 212897 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 212901 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 212909 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212911 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212918 */     // (strict_fadd:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2f64] }:$src1)  =>  (VADDPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZ128rm),
     /* 212921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212923 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 212925 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212929 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212934 */     GIR_RootConstrainSelectedInstOperands,
     /* 212935 */     // GIR_Coverage, 24295,
     /* 212935 */     GIR_EraseRootFromParent_Done,
     /* 212936 */   // Label 4879: @212936
     /* 212936 */   GIM_Try, /*On fail goto*//*Label 4880*/ GIMT_Encode4(212998), // Rule ID 2140 //
     /* 212941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 212944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 212960 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 212963 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 212967 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212973 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212980 */     // (strict_fadd:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDrm),
     /* 212983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212985 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 212987 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212991 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212996 */     GIR_RootConstrainSelectedInstOperands,
     /* 212997 */     // GIR_Coverage, 2140,
     /* 212997 */     GIR_EraseRootFromParent_Done,
     /* 212998 */   // Label 4880: @212998
     /* 212998 */   GIM_Try, /*On fail goto*//*Label 4881*/ GIMT_Encode4(213060), // Rule ID 6308 //
     /* 213003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 213006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213022 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213025 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213029 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213035 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213042 */     // (strict_fadd:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZ128rm),
     /* 213045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213047 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 213049 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213053 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213058 */     GIR_RootConstrainSelectedInstOperands,
     /* 213059 */     // GIR_Coverage, 6308,
     /* 213059 */     GIR_EraseRootFromParent_Done,
     /* 213060 */   // Label 4881: @213060
     /* 213060 */   GIM_Try, /*On fail goto*//*Label 4882*/ GIMT_Encode4(213091), // Rule ID 2138 //
     /* 213065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 213068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 213072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 213076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 213080 */     // (strict_fadd:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VADDPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 213080 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDrr),
     /* 213085 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 213089 */     GIR_RootConstrainSelectedInstOperands,
     /* 213090 */     // GIR_Coverage, 2138,
     /* 213090 */     GIR_Done,
     /* 213091 */   // Label 4882: @213091
     /* 213091 */   GIM_Try, /*On fail goto*//*Label 4883*/ GIMT_Encode4(213122), // Rule ID 2154 //
     /* 213096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 213099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 213103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 213107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 213111 */     // (strict_fadd:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (ADDPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 213111 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDPDrr),
     /* 213116 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 213120 */     GIR_RootConstrainSelectedInstOperands,
     /* 213121 */     // GIR_Coverage, 2154,
     /* 213121 */     GIR_Done,
     /* 213122 */   // Label 4883: @213122
     /* 213122 */   GIM_Try, /*On fail goto*//*Label 4884*/ GIMT_Encode4(213153), // Rule ID 6304 //
     /* 213127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 213130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213142 */     // (strict_fadd:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VADDPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 213142 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDZ128rr),
     /* 213147 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 213151 */     GIR_RootConstrainSelectedInstOperands,
     /* 213152 */     // GIR_Coverage, 6304,
     /* 213152 */     GIR_Done,
     /* 213153 */   // Label 4884: @213153
     /* 213153 */   GIM_Reject,
     /* 213154 */ // Label 4877: @213154
     /* 213154 */ GIM_Reject,
     /* 213155 */ // Label 4818: @213155
     /* 213155 */ GIM_Try, /*On fail goto*//*Label 4885*/ GIMT_Encode4(213508),
     /* 213160 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 213163 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 213166 */   GIM_Try, /*On fail goto*//*Label 4886*/ GIMT_Encode4(213228), // Rule ID 23369 //
     /* 213171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 213174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 213178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 213182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213186 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213189 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213193 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 213201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213203 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213210 */     // (strict_fadd:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1)  =>  (VADDPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSrm),
     /* 213213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213215 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 213217 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213221 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213226 */     GIR_RootConstrainSelectedInstOperands,
     /* 213227 */     // GIR_Coverage, 23369,
     /* 213227 */     GIR_EraseRootFromParent_Done,
     /* 213228 */   // Label 4886: @213228
     /* 213228 */   GIM_Try, /*On fail goto*//*Label 4887*/ GIMT_Encode4(213290), // Rule ID 24279 //
     /* 213233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 213236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 213244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213248 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213251 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213255 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213265 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213272 */     // (strict_fadd:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4f32] }:$src1)  =>  (VADDPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZ128rm),
     /* 213275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213277 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 213279 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213283 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213288 */     GIR_RootConstrainSelectedInstOperands,
     /* 213289 */     // GIR_Coverage, 24279,
     /* 213289 */     GIR_EraseRootFromParent_Done,
     /* 213290 */   // Label 4887: @213290
     /* 213290 */   GIM_Try, /*On fail goto*//*Label 4888*/ GIMT_Encode4(213352), // Rule ID 2136 //
     /* 213295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 213298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 213302 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 213306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213314 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213317 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213321 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213327 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213334 */     // (strict_fadd:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSrm),
     /* 213337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213339 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 213341 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213345 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213350 */     GIR_RootConstrainSelectedInstOperands,
     /* 213351 */     // GIR_Coverage, 2136,
     /* 213351 */     GIR_EraseRootFromParent_Done,
     /* 213352 */   // Label 4888: @213352
     /* 213352 */   GIM_Try, /*On fail goto*//*Label 4889*/ GIMT_Encode4(213414), // Rule ID 6284 //
     /* 213357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 213360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213376 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213379 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213383 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213389 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213396 */     // (strict_fadd:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZ128rm),
     /* 213399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213401 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 213403 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213407 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213412 */     GIR_RootConstrainSelectedInstOperands,
     /* 213413 */     // GIR_Coverage, 6284,
     /* 213413 */     GIR_EraseRootFromParent_Done,
     /* 213414 */   // Label 4889: @213414
     /* 213414 */   GIM_Try, /*On fail goto*//*Label 4890*/ GIMT_Encode4(213445), // Rule ID 2134 //
     /* 213419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 213422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 213426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 213430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 213434 */     // (strict_fadd:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VADDPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 213434 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSrr),
     /* 213439 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 213443 */     GIR_RootConstrainSelectedInstOperands,
     /* 213444 */     // GIR_Coverage, 2134,
     /* 213444 */     GIR_Done,
     /* 213445 */   // Label 4890: @213445
     /* 213445 */   GIM_Try, /*On fail goto*//*Label 4891*/ GIMT_Encode4(213476), // Rule ID 2150 //
     /* 213450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 213453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 213457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 213461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 213465 */     // (strict_fadd:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (ADDPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 213465 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDPSrr),
     /* 213470 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 213474 */     GIR_RootConstrainSelectedInstOperands,
     /* 213475 */     // GIR_Coverage, 2150,
     /* 213475 */     GIR_Done,
     /* 213476 */   // Label 4891: @213476
     /* 213476 */   GIM_Try, /*On fail goto*//*Label 4892*/ GIMT_Encode4(213507), // Rule ID 6280 //
     /* 213481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 213484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213488 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213496 */     // (strict_fadd:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VADDPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 213496 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSZ128rr),
     /* 213501 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 213505 */     GIR_RootConstrainSelectedInstOperands,
     /* 213506 */     // GIR_Coverage, 6280,
     /* 213506 */     GIR_Done,
     /* 213507 */   // Label 4892: @213507
     /* 213507 */   GIM_Reject,
     /* 213508 */ // Label 4885: @213508
     /* 213508 */ GIM_Reject,
     /* 213509 */ // Label 4819: @213509
     /* 213509 */ GIM_Try, /*On fail goto*//*Label 4893*/ GIMT_Encode4(213831),
     /* 213514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 213517 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 213520 */   GIM_Try, /*On fail goto*//*Label 4894*/ GIMT_Encode4(213582), // Rule ID 23375 //
     /* 213525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 213528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 213532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 213536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213540 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213543 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213547 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 213555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213557 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213564 */     // (strict_fadd:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1)  =>  (VADDPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDYrm),
     /* 213567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213569 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 213571 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213575 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213580 */     GIR_RootConstrainSelectedInstOperands,
     /* 213581 */     // GIR_Coverage, 23375,
     /* 213581 */     GIR_EraseRootFromParent_Done,
     /* 213582 */   // Label 4894: @213582
     /* 213582 */   GIM_Try, /*On fail goto*//*Label 4895*/ GIMT_Encode4(213644), // Rule ID 24303 //
     /* 213587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 213590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 213594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 213598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213602 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213605 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213609 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 213617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213619 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213626 */     // (strict_fadd:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4f64] }:$src1)  =>  (VADDPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZ256rm),
     /* 213629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213631 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 213633 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213637 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213642 */     GIR_RootConstrainSelectedInstOperands,
     /* 213643 */     // GIR_Coverage, 24303,
     /* 213643 */     GIR_EraseRootFromParent_Done,
     /* 213644 */   // Label 4895: @213644
     /* 213644 */   GIM_Try, /*On fail goto*//*Label 4896*/ GIMT_Encode4(213706), // Rule ID 2148 //
     /* 213649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 213652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 213656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 213660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213668 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213671 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213675 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213681 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213688 */     // (strict_fadd:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDYrm),
     /* 213691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213693 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 213695 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213699 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213704 */     GIR_RootConstrainSelectedInstOperands,
     /* 213705 */     // GIR_Coverage, 2148,
     /* 213705 */     GIR_EraseRootFromParent_Done,
     /* 213706 */   // Label 4896: @213706
     /* 213706 */   GIM_Try, /*On fail goto*//*Label 4897*/ GIMT_Encode4(213768), // Rule ID 6320 //
     /* 213711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 213714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 213718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 213722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213730 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213733 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213737 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213743 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213750 */     // (strict_fadd:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZ256rm),
     /* 213753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213755 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 213757 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213761 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213766 */     GIR_RootConstrainSelectedInstOperands,
     /* 213767 */     // GIR_Coverage, 6320,
     /* 213767 */     GIR_EraseRootFromParent_Done,
     /* 213768 */   // Label 4897: @213768
     /* 213768 */   GIM_Try, /*On fail goto*//*Label 4898*/ GIMT_Encode4(213799), // Rule ID 2146 //
     /* 213773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 213776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 213780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 213784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 213788 */     // (strict_fadd:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VADDPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 213788 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDYrr),
     /* 213793 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 213797 */     GIR_RootConstrainSelectedInstOperands,
     /* 213798 */     // GIR_Coverage, 2146,
     /* 213798 */     GIR_Done,
     /* 213799 */   // Label 4898: @213799
     /* 213799 */   GIM_Try, /*On fail goto*//*Label 4899*/ GIMT_Encode4(213830), // Rule ID 6316 //
     /* 213804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 213807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 213811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 213815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 213819 */     // (strict_fadd:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VADDPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 213819 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDZ256rr),
     /* 213824 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 213828 */     GIR_RootConstrainSelectedInstOperands,
     /* 213829 */     // GIR_Coverage, 6316,
     /* 213829 */     GIR_Done,
     /* 213830 */   // Label 4899: @213830
     /* 213830 */   GIM_Reject,
     /* 213831 */ // Label 4893: @213831
     /* 213831 */ GIM_Reject,
     /* 213832 */ // Label 4820: @213832
     /* 213832 */ GIM_Try, /*On fail goto*//*Label 4900*/ GIMT_Encode4(213991),
     /* 213837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 213840 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 213843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213847 */   GIM_Try, /*On fail goto*//*Label 4901*/ GIMT_Encode4(213905), // Rule ID 24319 //
     /* 213852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 213855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 213859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213863 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213866 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213870 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213878 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213880 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213887 */     // (strict_fadd:{ *:[v8f16] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8f16] }:$src1)  =>  (VADDPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZ128rm),
     /* 213890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213892 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 213894 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213898 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213903 */     GIR_RootConstrainSelectedInstOperands,
     /* 213904 */     // GIR_Coverage, 24319,
     /* 213904 */     GIR_EraseRootFromParent_Done,
     /* 213905 */   // Label 4901: @213905
     /* 213905 */   GIM_Try, /*On fail goto*//*Label 4902*/ GIMT_Encode4(213963), // Rule ID 6344 //
     /* 213910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 213913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213925 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213928 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213932 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213936 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213938 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213945 */     // (strict_fadd:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZ128rm),
     /* 213948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213950 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 213952 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213956 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213961 */     GIR_RootConstrainSelectedInstOperands,
     /* 213962 */     // GIR_Coverage, 6344,
     /* 213962 */     GIR_EraseRootFromParent_Done,
     /* 213963 */   // Label 4902: @213963
     /* 213963 */   GIM_Try, /*On fail goto*//*Label 4903*/ GIMT_Encode4(213990), // Rule ID 6340 //
     /* 213968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 213971 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213979 */     // (strict_fadd:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VADDPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 213979 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPHZ128rr),
     /* 213984 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 213988 */     GIR_RootConstrainSelectedInstOperands,
     /* 213989 */     // GIR_Coverage, 6340,
     /* 213989 */     GIR_Done,
     /* 213990 */   // Label 4903: @213990
     /* 213990 */   GIM_Reject,
     /* 213991 */ // Label 4900: @213991
     /* 213991 */ GIM_Reject,
     /* 213992 */ // Label 4821: @213992
     /* 213992 */ GIM_Try, /*On fail goto*//*Label 4904*/ GIMT_Encode4(214314),
     /* 213997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 214000 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 214003 */   GIM_Try, /*On fail goto*//*Label 4905*/ GIMT_Encode4(214065), // Rule ID 23373 //
     /* 214008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 214011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 214015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 214019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214023 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214026 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214030 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 214038 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214040 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214047 */     // (strict_fadd:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1)  =>  (VADDPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSYrm),
     /* 214050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214052 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 214054 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214058 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214063 */     GIR_RootConstrainSelectedInstOperands,
     /* 214064 */     // GIR_Coverage, 23373,
     /* 214064 */     GIR_EraseRootFromParent_Done,
     /* 214065 */   // Label 4905: @214065
     /* 214065 */   GIM_Try, /*On fail goto*//*Label 4906*/ GIMT_Encode4(214127), // Rule ID 24287 //
     /* 214070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 214073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 214077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 214081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214085 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214088 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214092 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 214100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214102 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214109 */     // (strict_fadd:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8f32] }:$src1)  =>  (VADDPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZ256rm),
     /* 214112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214114 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 214116 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214120 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214125 */     GIR_RootConstrainSelectedInstOperands,
     /* 214126 */     // GIR_Coverage, 24287,
     /* 214126 */     GIR_EraseRootFromParent_Done,
     /* 214127 */   // Label 4906: @214127
     /* 214127 */   GIM_Try, /*On fail goto*//*Label 4907*/ GIMT_Encode4(214189), // Rule ID 2144 //
     /* 214132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 214135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 214139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 214143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214151 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214154 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214158 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214164 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214171 */     // (strict_fadd:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSYrm),
     /* 214174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214176 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 214178 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214182 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214187 */     GIR_RootConstrainSelectedInstOperands,
     /* 214188 */     // GIR_Coverage, 2144,
     /* 214188 */     GIR_EraseRootFromParent_Done,
     /* 214189 */   // Label 4907: @214189
     /* 214189 */   GIM_Try, /*On fail goto*//*Label 4908*/ GIMT_Encode4(214251), // Rule ID 6296 //
     /* 214194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 214197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 214201 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 214205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214213 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214216 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214220 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214226 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214233 */     // (strict_fadd:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZ256rm),
     /* 214236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214238 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 214240 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214244 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214249 */     GIR_RootConstrainSelectedInstOperands,
     /* 214250 */     // GIR_Coverage, 6296,
     /* 214250 */     GIR_EraseRootFromParent_Done,
     /* 214251 */   // Label 4908: @214251
     /* 214251 */   GIM_Try, /*On fail goto*//*Label 4909*/ GIMT_Encode4(214282), // Rule ID 2142 //
     /* 214256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 214259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 214263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 214267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 214271 */     // (strict_fadd:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VADDPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 214271 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSYrr),
     /* 214276 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 214280 */     GIR_RootConstrainSelectedInstOperands,
     /* 214281 */     // GIR_Coverage, 2142,
     /* 214281 */     GIR_Done,
     /* 214282 */   // Label 4909: @214282
     /* 214282 */   GIM_Try, /*On fail goto*//*Label 4910*/ GIMT_Encode4(214313), // Rule ID 6292 //
     /* 214287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 214290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 214294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 214298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 214302 */     // (strict_fadd:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VADDPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 214302 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSZ256rr),
     /* 214307 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 214311 */     GIR_RootConstrainSelectedInstOperands,
     /* 214312 */     // GIR_Coverage, 6292,
     /* 214312 */     GIR_Done,
     /* 214313 */   // Label 4910: @214313
     /* 214313 */   GIM_Reject,
     /* 214314 */ // Label 4904: @214314
     /* 214314 */ GIM_Reject,
     /* 214315 */ // Label 4822: @214315
     /* 214315 */ GIM_Try, /*On fail goto*//*Label 4911*/ GIMT_Encode4(214474),
     /* 214320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 214323 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 214326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 214330 */   GIM_Try, /*On fail goto*//*Label 4912*/ GIMT_Encode4(214388), // Rule ID 24271 //
     /* 214335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 214338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 214342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214346 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214349 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214353 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 214361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214363 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214370 */     // (strict_fadd:{ *:[v8f64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8f64] }:$src1)  =>  (VADDPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZrm),
     /* 214373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214375 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 214377 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214381 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214386 */     GIR_RootConstrainSelectedInstOperands,
     /* 214387 */     // GIR_Coverage, 24271,
     /* 214387 */     GIR_EraseRootFromParent_Done,
     /* 214388 */   // Label 4912: @214388
     /* 214388 */   GIM_Try, /*On fail goto*//*Label 4913*/ GIMT_Encode4(214446), // Rule ID 6272 //
     /* 214393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 214396 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 214400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214408 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214411 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214415 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214421 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214428 */     // (strict_fadd:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZrm),
     /* 214431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214433 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 214435 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214439 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214444 */     GIR_RootConstrainSelectedInstOperands,
     /* 214445 */     // GIR_Coverage, 6272,
     /* 214445 */     GIR_EraseRootFromParent_Done,
     /* 214446 */   // Label 4913: @214446
     /* 214446 */   GIM_Try, /*On fail goto*//*Label 4914*/ GIMT_Encode4(214473), // Rule ID 6268 //
     /* 214451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 214454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 214458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 214462 */     // (strict_fadd:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VADDPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 214462 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDZrr),
     /* 214467 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 214471 */     GIR_RootConstrainSelectedInstOperands,
     /* 214472 */     // GIR_Coverage, 6268,
     /* 214472 */     GIR_Done,
     /* 214473 */   // Label 4914: @214473
     /* 214473 */   GIM_Reject,
     /* 214474 */ // Label 4911: @214474
     /* 214474 */ GIM_Reject,
     /* 214475 */ // Label 4823: @214475
     /* 214475 */ GIM_Try, /*On fail goto*//*Label 4915*/ GIMT_Encode4(214634),
     /* 214480 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 214483 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 214486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 214490 */   GIM_Try, /*On fail goto*//*Label 4916*/ GIMT_Encode4(214548), // Rule ID 24327 //
     /* 214495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 214498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 214502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214506 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214509 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214513 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 214521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214523 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214530 */     // (strict_fadd:{ *:[v16f16] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16f16] }:$src1)  =>  (VADDPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZ256rm),
     /* 214533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214535 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 214537 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214541 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214546 */     GIR_RootConstrainSelectedInstOperands,
     /* 214547 */     // GIR_Coverage, 24327,
     /* 214547 */     GIR_EraseRootFromParent_Done,
     /* 214548 */   // Label 4916: @214548
     /* 214548 */   GIM_Try, /*On fail goto*//*Label 4917*/ GIMT_Encode4(214606), // Rule ID 6356 //
     /* 214553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 214556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 214560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214568 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214571 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214575 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214581 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214588 */     // (strict_fadd:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZ256rm),
     /* 214591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214593 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 214595 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214599 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214604 */     GIR_RootConstrainSelectedInstOperands,
     /* 214605 */     // GIR_Coverage, 6356,
     /* 214605 */     GIR_EraseRootFromParent_Done,
     /* 214606 */   // Label 4917: @214606
     /* 214606 */   GIM_Try, /*On fail goto*//*Label 4918*/ GIMT_Encode4(214633), // Rule ID 6352 //
     /* 214611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 214614 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 214618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 214622 */     // (strict_fadd:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VADDPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 214622 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPHZ256rr),
     /* 214627 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 214631 */     GIR_RootConstrainSelectedInstOperands,
     /* 214632 */     // GIR_Coverage, 6352,
     /* 214632 */     GIR_Done,
     /* 214633 */   // Label 4918: @214633
     /* 214633 */   GIM_Reject,
     /* 214634 */ // Label 4915: @214634
     /* 214634 */ GIM_Reject,
     /* 214635 */ // Label 4824: @214635
     /* 214635 */ GIM_Try, /*On fail goto*//*Label 4919*/ GIMT_Encode4(214794),
     /* 214640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 214643 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 214646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 214650 */   GIM_Try, /*On fail goto*//*Label 4920*/ GIMT_Encode4(214708), // Rule ID 24263 //
     /* 214655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 214658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 214662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214666 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214669 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214673 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 214681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214683 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214690 */     // (strict_fadd:{ *:[v16f32] } (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16f32] }:$src1)  =>  (VADDPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZrm),
     /* 214693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214695 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 214697 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214701 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214706 */     GIR_RootConstrainSelectedInstOperands,
     /* 214707 */     // GIR_Coverage, 24263,
     /* 214707 */     GIR_EraseRootFromParent_Done,
     /* 214708 */   // Label 4920: @214708
     /* 214708 */   GIM_Try, /*On fail goto*//*Label 4921*/ GIMT_Encode4(214766), // Rule ID 6260 //
     /* 214713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 214716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 214720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214728 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214731 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214735 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214741 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214748 */     // (strict_fadd:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZrm),
     /* 214751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214753 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 214755 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214759 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214764 */     GIR_RootConstrainSelectedInstOperands,
     /* 214765 */     // GIR_Coverage, 6260,
     /* 214765 */     GIR_EraseRootFromParent_Done,
     /* 214766 */   // Label 4921: @214766
     /* 214766 */   GIM_Try, /*On fail goto*//*Label 4922*/ GIMT_Encode4(214793), // Rule ID 6256 //
     /* 214771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 214774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 214778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 214782 */     // (strict_fadd:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VADDPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 214782 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSZrr),
     /* 214787 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 214791 */     GIR_RootConstrainSelectedInstOperands,
     /* 214792 */     // GIR_Coverage, 6256,
     /* 214792 */     GIR_Done,
     /* 214793 */   // Label 4922: @214793
     /* 214793 */   GIM_Reject,
     /* 214794 */ // Label 4919: @214794
     /* 214794 */ GIM_Reject,
     /* 214795 */ // Label 4825: @214795
     /* 214795 */ GIM_Try, /*On fail goto*//*Label 4923*/ GIMT_Encode4(214954),
     /* 214800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 214803 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 214806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 214810 */   GIM_Try, /*On fail goto*//*Label 4924*/ GIMT_Encode4(214868), // Rule ID 24311 //
     /* 214815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 214818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 214822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214826 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214829 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214833 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 214841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214843 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214850 */     // (strict_fadd:{ *:[v32f16] } (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32f16] }:$src1)  =>  (VADDPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZrm),
     /* 214853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214855 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 214857 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214861 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214866 */     GIR_RootConstrainSelectedInstOperands,
     /* 214867 */     // GIR_Coverage, 24311,
     /* 214867 */     GIR_EraseRootFromParent_Done,
     /* 214868 */   // Label 4924: @214868
     /* 214868 */   GIM_Try, /*On fail goto*//*Label 4925*/ GIMT_Encode4(214926), // Rule ID 6332 //
     /* 214873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 214876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 214880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214888 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214891 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214895 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214901 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214908 */     // (strict_fadd:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZrm),
     /* 214911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214913 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 214915 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214919 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214924 */     GIR_RootConstrainSelectedInstOperands,
     /* 214925 */     // GIR_Coverage, 6332,
     /* 214925 */     GIR_EraseRootFromParent_Done,
     /* 214926 */   // Label 4925: @214926
     /* 214926 */   GIM_Try, /*On fail goto*//*Label 4926*/ GIMT_Encode4(214953), // Rule ID 6328 //
     /* 214931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 214934 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 214938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 214942 */     // (strict_fadd:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VADDPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 214942 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPHZrr),
     /* 214947 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 214951 */     GIR_RootConstrainSelectedInstOperands,
     /* 214952 */     // GIR_Coverage, 6328,
     /* 214952 */     GIR_Done,
     /* 214953 */   // Label 4926: @214953
     /* 214953 */   GIM_Reject,
     /* 214954 */ // Label 4923: @214954
     /* 214954 */ GIM_Reject,
     /* 214955 */ // Label 4826: @214955
     /* 214955 */ GIM_Reject,
     /* 214956 */ // Label 69: @214956
     /* 214956 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 4940*/ GIMT_Encode4(218645),
     /* 214967 */ /*GILLT_s16*//*Label 4927*/ GIMT_Encode4(215051),
     /* 214971 */ /*GILLT_s32*//*Label 4928*/ GIMT_Encode4(215149),
     /* 214975 */ /*GILLT_s64*//*Label 4929*/ GIMT_Encode4(215868),
     /* 214979 */ /*GILLT_s80*//*Label 4930*/ GIMT_Encode4(216731), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 214991 */ /*GILLT_v2s64*//*Label 4931*/ GIMT_Encode4(217297), GIMT_Encode4(0),
     /* 214999 */ /*GILLT_v4s32*//*Label 4932*/ GIMT_Encode4(217527),
     /* 215003 */ /*GILLT_v4s64*//*Label 4933*/ GIMT_Encode4(217757), GIMT_Encode4(0),
     /* 215011 */ /*GILLT_v8s16*//*Label 4934*/ GIMT_Encode4(217956),
     /* 215015 */ /*GILLT_v8s32*//*Label 4935*/ GIMT_Encode4(218054),
     /* 215019 */ /*GILLT_v8s64*//*Label 4936*/ GIMT_Encode4(218253), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 215031 */ /*GILLT_v16s16*//*Label 4937*/ GIMT_Encode4(218351),
     /* 215035 */ /*GILLT_v16s32*//*Label 4938*/ GIMT_Encode4(218449), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 215047 */ /*GILLT_v32s16*//*Label 4939*/ GIMT_Encode4(218547),
     /* 215051 */ // Label 4927: @215051
     /* 215051 */ GIM_Try, /*On fail goto*//*Label 4941*/ GIMT_Encode4(215148),
     /* 215056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 215059 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 215062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 215066 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 215070 */   GIM_Try, /*On fail goto*//*Label 4942*/ GIMT_Encode4(215124), // Rule ID 6068 //
     /* 215075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 215078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 215086 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 215089 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 215093 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215099 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215106 */     // (strict_fsub:{ *:[f16] } FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSHZrm),
     /* 215109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215111 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 215113 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215117 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215122 */     GIR_RootConstrainSelectedInstOperands,
     /* 215123 */     // GIR_Coverage, 6068,
     /* 215123 */     GIR_EraseRootFromParent_Done,
     /* 215124 */   // Label 4942: @215124
     /* 215124 */   GIM_Try, /*On fail goto*//*Label 4943*/ GIMT_Encode4(215147), // Rule ID 6066 //
     /* 215129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 215132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 215136 */     // (strict_fsub:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VSUBSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 215136 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSHZrr),
     /* 215141 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 215145 */     GIR_RootConstrainSelectedInstOperands,
     /* 215146 */     // GIR_Coverage, 6066,
     /* 215146 */     GIR_Done,
     /* 215147 */   // Label 4943: @215147
     /* 215147 */   GIM_Reject,
     /* 215148 */ // Label 4941: @215148
     /* 215148 */ GIM_Reject,
     /* 215149 */ // Label 4928: @215149
     /* 215149 */ GIM_Try, /*On fail goto*//*Label 4944*/ GIMT_Encode4(215867),
     /* 215154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 215157 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 215160 */   GIM_Try, /*On fail goto*//*Label 4945*/ GIMT_Encode4(215225), // Rule ID 964 //
     /* 215165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 215168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 215172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 215176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 215180 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 215187 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 215195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215197 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215204 */     // (strict_fsub:{ *:[f32] } (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP32:{ *:[f32] }:$src1)  =>  (SUBR_FpI16m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_FpI16m32),
     /* 215207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215209 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 215211 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215215 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 215218 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215223 */     GIR_RootConstrainSelectedInstOperands,
     /* 215224 */     // GIR_Coverage, 964,
     /* 215224 */     GIR_EraseRootFromParent_Done,
     /* 215225 */   // Label 4945: @215225
     /* 215225 */   GIM_Try, /*On fail goto*//*Label 4946*/ GIMT_Encode4(215290), // Rule ID 966 //
     /* 215230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 215233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 215237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 215241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 215245 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 215252 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 215260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215262 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215269 */     // (strict_fsub:{ *:[f32] } (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP32:{ *:[f32] }:$src1)  =>  (SUBR_FpI32m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_FpI32m32),
     /* 215272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215274 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 215276 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215280 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 215283 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215288 */     GIR_RootConstrainSelectedInstOperands,
     /* 215289 */     // GIR_Coverage, 966,
     /* 215289 */     GIR_EraseRootFromParent_Done,
     /* 215290 */   // Label 4946: @215290
     /* 215290 */   GIM_Try, /*On fail goto*//*Label 4947*/ GIMT_Encode4(215355), // Rule ID 954 //
     /* 215295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 215298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 215302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 215306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 215310 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 215313 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 215317 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 215325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215327 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215334 */     // (strict_fsub:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP32:{ *:[f32] }:$src1)  =>  (SUBR_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp32m),
     /* 215337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215339 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 215341 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215345 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 215348 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215353 */     GIR_RootConstrainSelectedInstOperands,
     /* 215354 */     // GIR_Coverage, 954,
     /* 215354 */     GIR_EraseRootFromParent_Done,
     /* 215355 */   // Label 4947: @215355
     /* 215355 */   GIM_Try, /*On fail goto*//*Label 4948*/ GIMT_Encode4(215420), // Rule ID 942 //
     /* 215360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 215363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 215367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 215371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 215379 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 215386 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215392 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215399 */     // (strict_fsub:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (SUB_FpI16m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_FpI16m32),
     /* 215402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215404 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 215406 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215410 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 215413 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215418 */     GIR_RootConstrainSelectedInstOperands,
     /* 215419 */     // GIR_Coverage, 942,
     /* 215419 */     GIR_EraseRootFromParent_Done,
     /* 215420 */   // Label 4948: @215420
     /* 215420 */   GIM_Try, /*On fail goto*//*Label 4949*/ GIMT_Encode4(215485), // Rule ID 944 //
     /* 215425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 215428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 215432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 215436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 215444 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 215451 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215457 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215464 */     // (strict_fsub:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (SUB_FpI32m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_FpI32m32),
     /* 215467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215469 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 215471 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215475 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 215478 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215483 */     GIR_RootConstrainSelectedInstOperands,
     /* 215484 */     // GIR_Coverage, 944,
     /* 215484 */     GIR_EraseRootFromParent_Done,
     /* 215485 */   // Label 4949: @215485
     /* 215485 */   GIM_Try, /*On fail goto*//*Label 4950*/ GIMT_Encode4(215550), // Rule ID 932 //
     /* 215490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 215493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 215497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 215501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 215509 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 215512 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 215516 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215522 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215529 */     // (strict_fsub:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUB_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp32m),
     /* 215532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215534 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 215536 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215540 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 215543 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215548 */     GIR_RootConstrainSelectedInstOperands,
     /* 215549 */     // GIR_Coverage, 932,
     /* 215549 */     GIR_EraseRootFromParent_Done,
     /* 215550 */   // Label 4950: @215550
     /* 215550 */   GIM_Try, /*On fail goto*//*Label 4951*/ GIMT_Encode4(215612), // Rule ID 2240 //
     /* 215555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 215558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 215562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 215566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 215574 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 215577 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 215581 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215587 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215594 */     // (strict_fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSSrm),
     /* 215597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215599 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 215601 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215610 */     GIR_RootConstrainSelectedInstOperands,
     /* 215611 */     // GIR_Coverage, 2240,
     /* 215611 */     GIR_EraseRootFromParent_Done,
     /* 215612 */   // Label 4951: @215612
     /* 215612 */   GIM_Try, /*On fail goto*//*Label 4952*/ GIMT_Encode4(215674), // Rule ID 2248 //
     /* 215617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 215620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 215624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 215628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 215636 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 215639 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 215643 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215649 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215656 */     // (strict_fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUBSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBSSrm),
     /* 215659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215661 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 215663 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215667 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215672 */     GIR_RootConstrainSelectedInstOperands,
     /* 215673 */     // GIR_Coverage, 2248,
     /* 215673 */     GIR_EraseRootFromParent_Done,
     /* 215674 */   // Label 4952: @215674
     /* 215674 */   GIM_Try, /*On fail goto*//*Label 4953*/ GIMT_Encode4(215736), // Rule ID 6030 //
     /* 215679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 215682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 215686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 215690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 215698 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 215701 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 215705 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215711 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215718 */     // (strict_fsub:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSSZrm),
     /* 215721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215723 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 215725 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215729 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215734 */     GIR_RootConstrainSelectedInstOperands,
     /* 215735 */     // GIR_Coverage, 6030,
     /* 215735 */     GIR_EraseRootFromParent_Done,
     /* 215736 */   // Label 4953: @215736
     /* 215736 */   GIM_Try, /*On fail goto*//*Label 4954*/ GIMT_Encode4(215773), // Rule ID 892 //
     /* 215741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 215744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 215748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 215752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 215756 */     // (strict_fsub:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (SUB_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 215756 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB_Fp32),
     /* 215761 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 215767 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 215771 */     GIR_RootConstrainSelectedInstOperands,
     /* 215772 */     // GIR_Coverage, 892,
     /* 215772 */     GIR_Done,
     /* 215773 */   // Label 4954: @215773
     /* 215773 */   GIM_Try, /*On fail goto*//*Label 4955*/ GIMT_Encode4(215804), // Rule ID 2238 //
     /* 215778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 215781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 215785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 215789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 215793 */     // (strict_fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VSUBSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 215793 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSSrr),
     /* 215798 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 215802 */     GIR_RootConstrainSelectedInstOperands,
     /* 215803 */     // GIR_Coverage, 2238,
     /* 215803 */     GIR_Done,
     /* 215804 */   // Label 4955: @215804
     /* 215804 */   GIM_Try, /*On fail goto*//*Label 4956*/ GIMT_Encode4(215835), // Rule ID 2246 //
     /* 215809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 215812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 215816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 215820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 215824 */     // (strict_fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (SUBSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 215824 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBSSrr),
     /* 215829 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 215833 */     GIR_RootConstrainSelectedInstOperands,
     /* 215834 */     // GIR_Coverage, 2246,
     /* 215834 */     GIR_Done,
     /* 215835 */   // Label 4956: @215835
     /* 215835 */   GIM_Try, /*On fail goto*//*Label 4957*/ GIMT_Encode4(215866), // Rule ID 6028 //
     /* 215840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 215843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 215847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 215851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 215855 */     // (strict_fsub:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VSUBSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 215855 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSSZrr),
     /* 215860 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 215864 */     GIR_RootConstrainSelectedInstOperands,
     /* 215865 */     // GIR_Coverage, 6028,
     /* 215865 */     GIR_Done,
     /* 215866 */   // Label 4957: @215866
     /* 215866 */   GIM_Reject,
     /* 215867 */ // Label 4944: @215867
     /* 215867 */ GIM_Reject,
     /* 215868 */ // Label 4929: @215868
     /* 215868 */ GIM_Try, /*On fail goto*//*Label 4958*/ GIMT_Encode4(216730),
     /* 215873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 215876 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 215879 */   GIM_Try, /*On fail goto*//*Label 4959*/ GIMT_Encode4(215944), // Rule ID 968 //
     /* 215884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 215887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 215891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 215895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 215899 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 215906 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 215914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215916 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215923 */     // (strict_fsub:{ *:[f64] } (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP64:{ *:[f64] }:$src1)  =>  (SUBR_FpI16m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_FpI16m64),
     /* 215926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215928 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 215930 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215934 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 215937 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215942 */     GIR_RootConstrainSelectedInstOperands,
     /* 215943 */     // GIR_Coverage, 968,
     /* 215943 */     GIR_EraseRootFromParent_Done,
     /* 215944 */   // Label 4959: @215944
     /* 215944 */   GIM_Try, /*On fail goto*//*Label 4960*/ GIMT_Encode4(216009), // Rule ID 970 //
     /* 215949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 215952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 215956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 215960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 215964 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 215971 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 215979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215981 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215988 */     // (strict_fsub:{ *:[f64] } (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP64:{ *:[f64] }:$src1)  =>  (SUBR_FpI32m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_FpI32m64),
     /* 215991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215993 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 215995 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215999 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 216002 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216007 */     GIR_RootConstrainSelectedInstOperands,
     /* 216008 */     // GIR_Coverage, 970,
     /* 216008 */     GIR_EraseRootFromParent_Done,
     /* 216009 */   // Label 4960: @216009
     /* 216009 */   GIM_Try, /*On fail goto*//*Label 4961*/ GIMT_Encode4(216074), // Rule ID 956 //
     /* 216014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 216017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 216021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 216025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216029 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216032 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216036 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 216044 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216046 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216053 */     // (strict_fsub:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP64:{ *:[f64] }:$src1)  =>  (SUBR_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp64m),
     /* 216056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216058 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 216060 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216064 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 216067 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216072 */     GIR_RootConstrainSelectedInstOperands,
     /* 216073 */     // GIR_Coverage, 956,
     /* 216073 */     GIR_EraseRootFromParent_Done,
     /* 216074 */   // Label 4961: @216074
     /* 216074 */   GIM_Try, /*On fail goto*//*Label 4962*/ GIMT_Encode4(216146), // Rule ID 958 //
     /* 216079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 216082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 216086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 216090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216094 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216097 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216101 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 216108 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 216116 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216118 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216125 */     // (strict_fsub:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP64:{ *:[f64] }:$src1)  =>  (SUBR_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp64m32),
     /* 216128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216130 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 216132 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216136 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 216139 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216144 */     GIR_RootConstrainSelectedInstOperands,
     /* 216145 */     // GIR_Coverage, 958,
     /* 216145 */     GIR_EraseRootFromParent_Done,
     /* 216146 */   // Label 4962: @216146
     /* 216146 */   GIM_Try, /*On fail goto*//*Label 4963*/ GIMT_Encode4(216211), // Rule ID 946 //
     /* 216151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 216154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 216158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 216162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 216166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 216170 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 216177 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216183 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216190 */     // (strict_fsub:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (SUB_FpI16m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_FpI16m64),
     /* 216193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216195 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 216197 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216201 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 216204 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216209 */     GIR_RootConstrainSelectedInstOperands,
     /* 216210 */     // GIR_Coverage, 946,
     /* 216210 */     GIR_EraseRootFromParent_Done,
     /* 216211 */   // Label 4963: @216211
     /* 216211 */   GIM_Try, /*On fail goto*//*Label 4964*/ GIMT_Encode4(216276), // Rule ID 948 //
     /* 216216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 216219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 216223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 216227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 216231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 216235 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 216242 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216248 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216255 */     // (strict_fsub:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (SUB_FpI32m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_FpI32m64),
     /* 216258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216260 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 216262 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216266 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 216269 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216274 */     GIR_RootConstrainSelectedInstOperands,
     /* 216275 */     // GIR_Coverage, 948,
     /* 216275 */     GIR_EraseRootFromParent_Done,
     /* 216276 */   // Label 4964: @216276
     /* 216276 */   GIM_Try, /*On fail goto*//*Label 4965*/ GIMT_Encode4(216341), // Rule ID 934 //
     /* 216281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 216284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 216288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 216292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 216296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216300 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216303 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216307 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216313 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216320 */     // (strict_fsub:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUB_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp64m),
     /* 216323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216325 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 216327 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216331 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 216334 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216339 */     GIR_RootConstrainSelectedInstOperands,
     /* 216340 */     // GIR_Coverage, 934,
     /* 216340 */     GIR_EraseRootFromParent_Done,
     /* 216341 */   // Label 4965: @216341
     /* 216341 */   GIM_Try, /*On fail goto*//*Label 4966*/ GIMT_Encode4(216413), // Rule ID 936 //
     /* 216346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 216349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 216353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 216357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 216361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216365 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216368 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216372 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 216379 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216385 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216392 */     // (strict_fsub:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (SUB_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp64m32),
     /* 216395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216397 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 216399 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216403 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 216406 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216411 */     GIR_RootConstrainSelectedInstOperands,
     /* 216412 */     // GIR_Coverage, 936,
     /* 216412 */     GIR_EraseRootFromParent_Done,
     /* 216413 */   // Label 4966: @216413
     /* 216413 */   GIM_Try, /*On fail goto*//*Label 4967*/ GIMT_Encode4(216475), // Rule ID 2244 //
     /* 216418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 216421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 216425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 216429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 216433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216437 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216440 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216444 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216448 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216450 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216457 */     // (strict_fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSDrm),
     /* 216460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216462 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 216464 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216468 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216473 */     GIR_RootConstrainSelectedInstOperands,
     /* 216474 */     // GIR_Coverage, 2244,
     /* 216474 */     GIR_EraseRootFromParent_Done,
     /* 216475 */   // Label 4967: @216475
     /* 216475 */   GIM_Try, /*On fail goto*//*Label 4968*/ GIMT_Encode4(216537), // Rule ID 2252 //
     /* 216480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 216483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 216487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 216491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 216495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216499 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216502 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216506 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216512 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216519 */     // (strict_fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUBSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBSDrm),
     /* 216522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216524 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 216526 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216530 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216535 */     GIR_RootConstrainSelectedInstOperands,
     /* 216536 */     // GIR_Coverage, 2252,
     /* 216536 */     GIR_EraseRootFromParent_Done,
     /* 216537 */   // Label 4968: @216537
     /* 216537 */   GIM_Try, /*On fail goto*//*Label 4969*/ GIMT_Encode4(216599), // Rule ID 6049 //
     /* 216542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 216545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 216549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 216553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 216557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216561 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216564 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216568 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216572 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216574 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216581 */     // (strict_fsub:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSDZrm),
     /* 216584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216586 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 216588 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216592 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216597 */     GIR_RootConstrainSelectedInstOperands,
     /* 216598 */     // GIR_Coverage, 6049,
     /* 216598 */     GIR_EraseRootFromParent_Done,
     /* 216599 */   // Label 4969: @216599
     /* 216599 */   GIM_Try, /*On fail goto*//*Label 4970*/ GIMT_Encode4(216636), // Rule ID 894 //
     /* 216604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 216607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 216611 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 216615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 216619 */     // (strict_fsub:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (SUB_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 216619 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB_Fp64),
     /* 216624 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 216630 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 216634 */     GIR_RootConstrainSelectedInstOperands,
     /* 216635 */     // GIR_Coverage, 894,
     /* 216635 */     GIR_Done,
     /* 216636 */   // Label 4970: @216636
     /* 216636 */   GIM_Try, /*On fail goto*//*Label 4971*/ GIMT_Encode4(216667), // Rule ID 2242 //
     /* 216641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 216644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 216648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 216652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 216656 */     // (strict_fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VSUBSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 216656 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSDrr),
     /* 216661 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 216665 */     GIR_RootConstrainSelectedInstOperands,
     /* 216666 */     // GIR_Coverage, 2242,
     /* 216666 */     GIR_Done,
     /* 216667 */   // Label 4971: @216667
     /* 216667 */   GIM_Try, /*On fail goto*//*Label 4972*/ GIMT_Encode4(216698), // Rule ID 2250 //
     /* 216672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 216675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 216679 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 216683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 216687 */     // (strict_fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (SUBSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 216687 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBSDrr),
     /* 216692 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 216696 */     GIR_RootConstrainSelectedInstOperands,
     /* 216697 */     // GIR_Coverage, 2250,
     /* 216697 */     GIR_Done,
     /* 216698 */   // Label 4972: @216698
     /* 216698 */   GIM_Try, /*On fail goto*//*Label 4973*/ GIMT_Encode4(216729), // Rule ID 6047 //
     /* 216703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 216706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 216710 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 216714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 216718 */     // (strict_fsub:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VSUBSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 216718 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSDZrr),
     /* 216723 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 216727 */     GIR_RootConstrainSelectedInstOperands,
     /* 216728 */     // GIR_Coverage, 6047,
     /* 216728 */     GIR_Done,
     /* 216729 */   // Label 4973: @216729
     /* 216729 */   GIM_Reject,
     /* 216730 */ // Label 4958: @216730
     /* 216730 */ GIM_Reject,
     /* 216731 */ // Label 4930: @216731
     /* 216731 */ GIM_Try, /*On fail goto*//*Label 4974*/ GIMT_Encode4(217296),
     /* 216736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 216739 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 216742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 216746 */   GIM_Try, /*On fail goto*//*Label 4975*/ GIMT_Encode4(216807), // Rule ID 972 //
     /* 216751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 216754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 216758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 216762 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 216769 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 216777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216779 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216786 */     // (strict_fsub:{ *:[f80] } (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP80:{ *:[f80] }:$src1)  =>  (SUBR_FpI16m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_FpI16m80),
     /* 216789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216791 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 216793 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216797 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 216800 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216805 */     GIR_RootConstrainSelectedInstOperands,
     /* 216806 */     // GIR_Coverage, 972,
     /* 216806 */     GIR_EraseRootFromParent_Done,
     /* 216807 */   // Label 4975: @216807
     /* 216807 */   GIM_Try, /*On fail goto*//*Label 4976*/ GIMT_Encode4(216868), // Rule ID 974 //
     /* 216812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 216815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 216819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 216823 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 216830 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 216838 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216840 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216847 */     // (strict_fsub:{ *:[f80] } (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP80:{ *:[f80] }:$src1)  =>  (SUBR_FpI32m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_FpI32m80),
     /* 216850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216852 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 216854 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216858 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 216861 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216866 */     GIR_RootConstrainSelectedInstOperands,
     /* 216867 */     // GIR_Coverage, 974,
     /* 216867 */     GIR_EraseRootFromParent_Done,
     /* 216868 */   // Label 4976: @216868
     /* 216868 */   GIM_Try, /*On fail goto*//*Label 4977*/ GIMT_Encode4(216936), // Rule ID 960 //
     /* 216873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 216876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 216880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216884 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216887 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216891 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 216898 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 216906 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216908 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216915 */     // (strict_fsub:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP80:{ *:[f80] }:$src1)  =>  (SUBR_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp80m32),
     /* 216918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216920 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 216922 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216926 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 216929 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216934 */     GIR_RootConstrainSelectedInstOperands,
     /* 216935 */     // GIR_Coverage, 960,
     /* 216935 */     GIR_EraseRootFromParent_Done,
     /* 216936 */   // Label 4977: @216936
     /* 216936 */   GIM_Try, /*On fail goto*//*Label 4978*/ GIMT_Encode4(217004), // Rule ID 962 //
     /* 216941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 216944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 216948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216952 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216955 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216959 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 216966 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 216974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216976 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216983 */     // (strict_fsub:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>, RFP80:{ *:[f80] }:$src1)  =>  (SUBR_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp80m64),
     /* 216986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216988 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 216990 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216994 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 216997 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217002 */     GIR_RootConstrainSelectedInstOperands,
     /* 217003 */     // GIR_Coverage, 962,
     /* 217003 */     GIR_EraseRootFromParent_Done,
     /* 217004 */   // Label 4978: @217004
     /* 217004 */   GIM_Try, /*On fail goto*//*Label 4979*/ GIMT_Encode4(217065), // Rule ID 950 //
     /* 217009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 217012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 217016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 217020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 217024 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 217031 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217037 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217044 */     // (strict_fsub:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (SUB_FpI16m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_FpI16m80),
     /* 217047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217049 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 217051 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217055 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 217058 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217063 */     GIR_RootConstrainSelectedInstOperands,
     /* 217064 */     // GIR_Coverage, 950,
     /* 217064 */     GIR_EraseRootFromParent_Done,
     /* 217065 */   // Label 4979: @217065
     /* 217065 */   GIM_Try, /*On fail goto*//*Label 4980*/ GIMT_Encode4(217126), // Rule ID 952 //
     /* 217070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 217073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 217077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 217081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 217085 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 217092 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217098 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217105 */     // (strict_fsub:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (SUB_FpI32m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_FpI32m80),
     /* 217108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217110 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 217112 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217116 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 217119 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217124 */     GIR_RootConstrainSelectedInstOperands,
     /* 217125 */     // GIR_Coverage, 952,
     /* 217125 */     GIR_EraseRootFromParent_Done,
     /* 217126 */   // Label 4980: @217126
     /* 217126 */   GIM_Try, /*On fail goto*//*Label 4981*/ GIMT_Encode4(217194), // Rule ID 938 //
     /* 217131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 217134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 217138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 217142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217146 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217149 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217153 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 217160 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217166 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217173 */     // (strict_fsub:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (SUB_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp80m32),
     /* 217176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217178 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 217180 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217184 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 217187 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217192 */     GIR_RootConstrainSelectedInstOperands,
     /* 217193 */     // GIR_Coverage, 938,
     /* 217193 */     GIR_EraseRootFromParent_Done,
     /* 217194 */   // Label 4981: @217194
     /* 217194 */   GIM_Try, /*On fail goto*//*Label 4982*/ GIMT_Encode4(217262), // Rule ID 940 //
     /* 217199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 217202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 217206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 217210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217214 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217217 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217221 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 217228 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217234 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217241 */     // (strict_fsub:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>)  =>  (SUB_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp80m64),
     /* 217244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217246 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 217248 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217252 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 217255 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217260 */     GIR_RootConstrainSelectedInstOperands,
     /* 217261 */     // GIR_Coverage, 940,
     /* 217261 */     GIR_EraseRootFromParent_Done,
     /* 217262 */   // Label 4982: @217262
     /* 217262 */   GIM_Try, /*On fail goto*//*Label 4983*/ GIMT_Encode4(217295), // Rule ID 896 //
     /* 217267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 217270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 217274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 217278 */     // (strict_fsub:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (SUB_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 217278 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB_Fp80),
     /* 217283 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 217289 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 217293 */     GIR_RootConstrainSelectedInstOperands,
     /* 217294 */     // GIR_Coverage, 896,
     /* 217294 */     GIR_Done,
     /* 217295 */   // Label 4983: @217295
     /* 217295 */   GIM_Reject,
     /* 217296 */ // Label 4974: @217296
     /* 217296 */ GIM_Reject,
     /* 217297 */ // Label 4931: @217297
     /* 217297 */ GIM_Try, /*On fail goto*//*Label 4984*/ GIMT_Encode4(217526),
     /* 217302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 217305 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 217308 */   GIM_Try, /*On fail goto*//*Label 4985*/ GIMT_Encode4(217370), // Rule ID 2220 //
     /* 217313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 217316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 217320 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 217324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 217328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217332 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217335 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217339 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217345 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217352 */     // (strict_fsub:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDrm),
     /* 217355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217357 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 217359 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217363 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217368 */     GIR_RootConstrainSelectedInstOperands,
     /* 217369 */     // GIR_Coverage, 2220,
     /* 217369 */     GIR_EraseRootFromParent_Done,
     /* 217370 */   // Label 4985: @217370
     /* 217370 */   GIM_Try, /*On fail goto*//*Label 4986*/ GIMT_Encode4(217432), // Rule ID 6542 //
     /* 217375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 217378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 217382 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 217386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 217390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217394 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217397 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217401 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217407 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217414 */     // (strict_fsub:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ128rm),
     /* 217417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217419 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 217421 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217425 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217430 */     GIR_RootConstrainSelectedInstOperands,
     /* 217431 */     // GIR_Coverage, 6542,
     /* 217431 */     GIR_EraseRootFromParent_Done,
     /* 217432 */   // Label 4986: @217432
     /* 217432 */   GIM_Try, /*On fail goto*//*Label 4987*/ GIMT_Encode4(217463), // Rule ID 2218 //
     /* 217437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 217440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 217444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 217448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 217452 */     // (strict_fsub:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VSUBPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 217452 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDrr),
     /* 217457 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 217461 */     GIR_RootConstrainSelectedInstOperands,
     /* 217462 */     // GIR_Coverage, 2218,
     /* 217462 */     GIR_Done,
     /* 217463 */   // Label 4987: @217463
     /* 217463 */   GIM_Try, /*On fail goto*//*Label 4988*/ GIMT_Encode4(217494), // Rule ID 2234 //
     /* 217468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 217471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 217475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 217479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 217483 */     // (strict_fsub:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (SUBPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 217483 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBPDrr),
     /* 217488 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 217492 */     GIR_RootConstrainSelectedInstOperands,
     /* 217493 */     // GIR_Coverage, 2234,
     /* 217493 */     GIR_Done,
     /* 217494 */   // Label 4988: @217494
     /* 217494 */   GIM_Try, /*On fail goto*//*Label 4989*/ GIMT_Encode4(217525), // Rule ID 6538 //
     /* 217499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 217502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 217506 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 217510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 217514 */     // (strict_fsub:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VSUBPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 217514 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ128rr),
     /* 217519 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 217523 */     GIR_RootConstrainSelectedInstOperands,
     /* 217524 */     // GIR_Coverage, 6538,
     /* 217524 */     GIR_Done,
     /* 217525 */   // Label 4989: @217525
     /* 217525 */   GIM_Reject,
     /* 217526 */ // Label 4984: @217526
     /* 217526 */ GIM_Reject,
     /* 217527 */ // Label 4932: @217527
     /* 217527 */ GIM_Try, /*On fail goto*//*Label 4990*/ GIMT_Encode4(217756),
     /* 217532 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 217535 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 217538 */   GIM_Try, /*On fail goto*//*Label 4991*/ GIMT_Encode4(217600), // Rule ID 2216 //
     /* 217543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 217546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 217550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 217554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 217558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217562 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217565 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217569 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217575 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217582 */     // (strict_fsub:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSrm),
     /* 217585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217587 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 217589 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217593 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217598 */     GIR_RootConstrainSelectedInstOperands,
     /* 217599 */     // GIR_Coverage, 2216,
     /* 217599 */     GIR_EraseRootFromParent_Done,
     /* 217600 */   // Label 4991: @217600
     /* 217600 */   GIM_Try, /*On fail goto*//*Label 4992*/ GIMT_Encode4(217662), // Rule ID 6518 //
     /* 217605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 217608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 217612 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 217616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 217620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217624 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217627 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217631 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217637 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217644 */     // (strict_fsub:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ128rm),
     /* 217647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217649 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 217651 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217655 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217660 */     GIR_RootConstrainSelectedInstOperands,
     /* 217661 */     // GIR_Coverage, 6518,
     /* 217661 */     GIR_EraseRootFromParent_Done,
     /* 217662 */   // Label 4992: @217662
     /* 217662 */   GIM_Try, /*On fail goto*//*Label 4993*/ GIMT_Encode4(217693), // Rule ID 2214 //
     /* 217667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 217670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 217674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 217678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 217682 */     // (strict_fsub:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VSUBPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 217682 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSrr),
     /* 217687 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 217691 */     GIR_RootConstrainSelectedInstOperands,
     /* 217692 */     // GIR_Coverage, 2214,
     /* 217692 */     GIR_Done,
     /* 217693 */   // Label 4993: @217693
     /* 217693 */   GIM_Try, /*On fail goto*//*Label 4994*/ GIMT_Encode4(217724), // Rule ID 2230 //
     /* 217698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 217701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 217705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 217709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 217713 */     // (strict_fsub:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (SUBPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 217713 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBPSrr),
     /* 217718 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 217722 */     GIR_RootConstrainSelectedInstOperands,
     /* 217723 */     // GIR_Coverage, 2230,
     /* 217723 */     GIR_Done,
     /* 217724 */   // Label 4994: @217724
     /* 217724 */   GIM_Try, /*On fail goto*//*Label 4995*/ GIMT_Encode4(217755), // Rule ID 6514 //
     /* 217729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 217732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 217736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 217740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 217744 */     // (strict_fsub:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VSUBPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 217744 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ128rr),
     /* 217749 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 217753 */     GIR_RootConstrainSelectedInstOperands,
     /* 217754 */     // GIR_Coverage, 6514,
     /* 217754 */     GIR_Done,
     /* 217755 */   // Label 4995: @217755
     /* 217755 */   GIM_Reject,
     /* 217756 */ // Label 4990: @217756
     /* 217756 */ GIM_Reject,
     /* 217757 */ // Label 4933: @217757
     /* 217757 */ GIM_Try, /*On fail goto*//*Label 4996*/ GIMT_Encode4(217955),
     /* 217762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 217765 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 217768 */   GIM_Try, /*On fail goto*//*Label 4997*/ GIMT_Encode4(217830), // Rule ID 2228 //
     /* 217773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 217776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 217780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 217784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 217788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217792 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217795 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217799 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217805 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217812 */     // (strict_fsub:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDYrm),
     /* 217815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217817 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 217819 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217823 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217828 */     GIR_RootConstrainSelectedInstOperands,
     /* 217829 */     // GIR_Coverage, 2228,
     /* 217829 */     GIR_EraseRootFromParent_Done,
     /* 217830 */   // Label 4997: @217830
     /* 217830 */   GIM_Try, /*On fail goto*//*Label 4998*/ GIMT_Encode4(217892), // Rule ID 6554 //
     /* 217835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 217838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 217842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 217846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 217850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217854 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217857 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217861 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217867 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217874 */     // (strict_fsub:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ256rm),
     /* 217877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217879 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 217881 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217885 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217890 */     GIR_RootConstrainSelectedInstOperands,
     /* 217891 */     // GIR_Coverage, 6554,
     /* 217891 */     GIR_EraseRootFromParent_Done,
     /* 217892 */   // Label 4998: @217892
     /* 217892 */   GIM_Try, /*On fail goto*//*Label 4999*/ GIMT_Encode4(217923), // Rule ID 2226 //
     /* 217897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 217900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 217904 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 217908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 217912 */     // (strict_fsub:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VSUBPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 217912 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDYrr),
     /* 217917 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 217921 */     GIR_RootConstrainSelectedInstOperands,
     /* 217922 */     // GIR_Coverage, 2226,
     /* 217922 */     GIR_Done,
     /* 217923 */   // Label 4999: @217923
     /* 217923 */   GIM_Try, /*On fail goto*//*Label 5000*/ GIMT_Encode4(217954), // Rule ID 6550 //
     /* 217928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 217931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 217935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 217939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 217943 */     // (strict_fsub:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VSUBPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 217943 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ256rr),
     /* 217948 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 217952 */     GIR_RootConstrainSelectedInstOperands,
     /* 217953 */     // GIR_Coverage, 6550,
     /* 217953 */     GIR_Done,
     /* 217954 */   // Label 5000: @217954
     /* 217954 */   GIM_Reject,
     /* 217955 */ // Label 4996: @217955
     /* 217955 */ GIM_Reject,
     /* 217956 */ // Label 4934: @217956
     /* 217956 */ GIM_Try, /*On fail goto*//*Label 5001*/ GIMT_Encode4(218053),
     /* 217961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 217964 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 217967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 217971 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 217975 */   GIM_Try, /*On fail goto*//*Label 5002*/ GIMT_Encode4(218029), // Rule ID 6578 //
     /* 217980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 217983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 217987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217991 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217994 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217998 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218002 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218004 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218011 */     // (strict_fsub:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ128rm),
     /* 218014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218016 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 218018 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218022 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218027 */     GIR_RootConstrainSelectedInstOperands,
     /* 218028 */     // GIR_Coverage, 6578,
     /* 218028 */     GIR_EraseRootFromParent_Done,
     /* 218029 */   // Label 5002: @218029
     /* 218029 */   GIM_Try, /*On fail goto*//*Label 5003*/ GIMT_Encode4(218052), // Rule ID 6574 //
     /* 218034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 218037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 218041 */     // (strict_fsub:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VSUBPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 218041 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ128rr),
     /* 218046 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 218050 */     GIR_RootConstrainSelectedInstOperands,
     /* 218051 */     // GIR_Coverage, 6574,
     /* 218051 */     GIR_Done,
     /* 218052 */   // Label 5003: @218052
     /* 218052 */   GIM_Reject,
     /* 218053 */ // Label 5001: @218053
     /* 218053 */ GIM_Reject,
     /* 218054 */ // Label 4935: @218054
     /* 218054 */ GIM_Try, /*On fail goto*//*Label 5004*/ GIMT_Encode4(218252),
     /* 218059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 218062 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 218065 */   GIM_Try, /*On fail goto*//*Label 5005*/ GIMT_Encode4(218127), // Rule ID 2224 //
     /* 218070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 218073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 218077 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 218081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 218085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218089 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218092 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218096 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218102 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218109 */     // (strict_fsub:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSYrm),
     /* 218112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218114 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 218116 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218120 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218125 */     GIR_RootConstrainSelectedInstOperands,
     /* 218126 */     // GIR_Coverage, 2224,
     /* 218126 */     GIR_EraseRootFromParent_Done,
     /* 218127 */   // Label 5005: @218127
     /* 218127 */   GIM_Try, /*On fail goto*//*Label 5006*/ GIMT_Encode4(218189), // Rule ID 6530 //
     /* 218132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 218135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 218139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 218143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 218147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218151 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218154 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218158 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218164 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218171 */     // (strict_fsub:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ256rm),
     /* 218174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218176 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 218178 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218182 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218187 */     GIR_RootConstrainSelectedInstOperands,
     /* 218188 */     // GIR_Coverage, 6530,
     /* 218188 */     GIR_EraseRootFromParent_Done,
     /* 218189 */   // Label 5006: @218189
     /* 218189 */   GIM_Try, /*On fail goto*//*Label 5007*/ GIMT_Encode4(218220), // Rule ID 2222 //
     /* 218194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 218197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 218201 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 218205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 218209 */     // (strict_fsub:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VSUBPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 218209 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSYrr),
     /* 218214 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 218218 */     GIR_RootConstrainSelectedInstOperands,
     /* 218219 */     // GIR_Coverage, 2222,
     /* 218219 */     GIR_Done,
     /* 218220 */   // Label 5007: @218220
     /* 218220 */   GIM_Try, /*On fail goto*//*Label 5008*/ GIMT_Encode4(218251), // Rule ID 6526 //
     /* 218225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 218228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 218232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 218236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 218240 */     // (strict_fsub:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VSUBPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 218240 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ256rr),
     /* 218245 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 218249 */     GIR_RootConstrainSelectedInstOperands,
     /* 218250 */     // GIR_Coverage, 6526,
     /* 218250 */     GIR_Done,
     /* 218251 */   // Label 5008: @218251
     /* 218251 */   GIM_Reject,
     /* 218252 */ // Label 5004: @218252
     /* 218252 */ GIM_Reject,
     /* 218253 */ // Label 4936: @218253
     /* 218253 */ GIM_Try, /*On fail goto*//*Label 5009*/ GIMT_Encode4(218350),
     /* 218258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 218261 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 218264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 218268 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 218272 */   GIM_Try, /*On fail goto*//*Label 5010*/ GIMT_Encode4(218326), // Rule ID 6506 //
     /* 218277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 218280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 218284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218288 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218291 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218295 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218301 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218308 */     // (strict_fsub:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDZrm),
     /* 218311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218313 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 218315 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218319 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218324 */     GIR_RootConstrainSelectedInstOperands,
     /* 218325 */     // GIR_Coverage, 6506,
     /* 218325 */     GIR_EraseRootFromParent_Done,
     /* 218326 */   // Label 5010: @218326
     /* 218326 */   GIM_Try, /*On fail goto*//*Label 5011*/ GIMT_Encode4(218349), // Rule ID 6502 //
     /* 218331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 218334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 218338 */     // (strict_fsub:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VSUBPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 218338 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDZrr),
     /* 218343 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 218347 */     GIR_RootConstrainSelectedInstOperands,
     /* 218348 */     // GIR_Coverage, 6502,
     /* 218348 */     GIR_Done,
     /* 218349 */   // Label 5011: @218349
     /* 218349 */   GIM_Reject,
     /* 218350 */ // Label 5009: @218350
     /* 218350 */ GIM_Reject,
     /* 218351 */ // Label 4937: @218351
     /* 218351 */ GIM_Try, /*On fail goto*//*Label 5012*/ GIMT_Encode4(218448),
     /* 218356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 218359 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 218362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 218366 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 218370 */   GIM_Try, /*On fail goto*//*Label 5013*/ GIMT_Encode4(218424), // Rule ID 6590 //
     /* 218375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 218378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 218382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218386 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218389 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218393 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218399 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218406 */     // (strict_fsub:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ256rm),
     /* 218409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218411 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 218413 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218417 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218422 */     GIR_RootConstrainSelectedInstOperands,
     /* 218423 */     // GIR_Coverage, 6590,
     /* 218423 */     GIR_EraseRootFromParent_Done,
     /* 218424 */   // Label 5013: @218424
     /* 218424 */   GIM_Try, /*On fail goto*//*Label 5014*/ GIMT_Encode4(218447), // Rule ID 6586 //
     /* 218429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 218432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 218436 */     // (strict_fsub:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VSUBPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 218436 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ256rr),
     /* 218441 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 218445 */     GIR_RootConstrainSelectedInstOperands,
     /* 218446 */     // GIR_Coverage, 6586,
     /* 218446 */     GIR_Done,
     /* 218447 */   // Label 5014: @218447
     /* 218447 */   GIM_Reject,
     /* 218448 */ // Label 5012: @218448
     /* 218448 */ GIM_Reject,
     /* 218449 */ // Label 4938: @218449
     /* 218449 */ GIM_Try, /*On fail goto*//*Label 5015*/ GIMT_Encode4(218546),
     /* 218454 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 218457 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 218460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 218464 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 218468 */   GIM_Try, /*On fail goto*//*Label 5016*/ GIMT_Encode4(218522), // Rule ID 6494 //
     /* 218473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 218476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 218480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218484 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218487 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218491 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218497 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218504 */     // (strict_fsub:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSZrm),
     /* 218507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218509 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 218511 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218515 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218520 */     GIR_RootConstrainSelectedInstOperands,
     /* 218521 */     // GIR_Coverage, 6494,
     /* 218521 */     GIR_EraseRootFromParent_Done,
     /* 218522 */   // Label 5016: @218522
     /* 218522 */   GIM_Try, /*On fail goto*//*Label 5017*/ GIMT_Encode4(218545), // Rule ID 6490 //
     /* 218527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 218530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 218534 */     // (strict_fsub:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VSUBPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 218534 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSZrr),
     /* 218539 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 218543 */     GIR_RootConstrainSelectedInstOperands,
     /* 218544 */     // GIR_Coverage, 6490,
     /* 218544 */     GIR_Done,
     /* 218545 */   // Label 5017: @218545
     /* 218545 */   GIM_Reject,
     /* 218546 */ // Label 5015: @218546
     /* 218546 */ GIM_Reject,
     /* 218547 */ // Label 4939: @218547
     /* 218547 */ GIM_Try, /*On fail goto*//*Label 5018*/ GIMT_Encode4(218644),
     /* 218552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 218555 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 218558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 218562 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 218566 */   GIM_Try, /*On fail goto*//*Label 5019*/ GIMT_Encode4(218620), // Rule ID 6566 //
     /* 218571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 218574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 218578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218582 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218585 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218589 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218595 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218602 */     // (strict_fsub:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPHZrm),
     /* 218605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218607 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 218609 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218613 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218618 */     GIR_RootConstrainSelectedInstOperands,
     /* 218619 */     // GIR_Coverage, 6566,
     /* 218619 */     GIR_EraseRootFromParent_Done,
     /* 218620 */   // Label 5019: @218620
     /* 218620 */   GIM_Try, /*On fail goto*//*Label 5020*/ GIMT_Encode4(218643), // Rule ID 6562 //
     /* 218625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 218628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 218632 */     // (strict_fsub:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VSUBPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 218632 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPHZrr),
     /* 218637 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 218641 */     GIR_RootConstrainSelectedInstOperands,
     /* 218642 */     // GIR_Coverage, 6562,
     /* 218642 */     GIR_Done,
     /* 218643 */   // Label 5020: @218643
     /* 218643 */   GIM_Reject,
     /* 218644 */ // Label 5018: @218644
     /* 218644 */ GIM_Reject,
     /* 218645 */ // Label 4940: @218645
     /* 218645 */ GIM_Reject,
     /* 218646 */ // Label 70: @218646
     /* 218646 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 5034*/ GIMT_Encode4(223575),
     /* 218657 */ /*GILLT_s16*//*Label 5021*/ GIMT_Encode4(218741),
     /* 218661 */ /*GILLT_s32*//*Label 5022*/ GIMT_Encode4(218901),
     /* 218665 */ /*GILLT_s64*//*Label 5023*/ GIMT_Encode4(219806),
     /* 218669 */ /*GILLT_s80*//*Label 5024*/ GIMT_Encode4(220855), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 218681 */ /*GILLT_v2s64*//*Label 5025*/ GIMT_Encode4(221421), GIMT_Encode4(0),
     /* 218689 */ /*GILLT_v4s32*//*Label 5026*/ GIMT_Encode4(221775),
     /* 218693 */ /*GILLT_v4s64*//*Label 5027*/ GIMT_Encode4(222129), GIMT_Encode4(0),
     /* 218701 */ /*GILLT_v8s16*//*Label 5028*/ GIMT_Encode4(222452),
     /* 218705 */ /*GILLT_v8s32*//*Label 5029*/ GIMT_Encode4(222612),
     /* 218709 */ /*GILLT_v8s64*//*Label 5030*/ GIMT_Encode4(222935), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 218721 */ /*GILLT_v16s16*//*Label 5031*/ GIMT_Encode4(223095),
     /* 218725 */ /*GILLT_v16s32*//*Label 5032*/ GIMT_Encode4(223255), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 218737 */ /*GILLT_v32s16*//*Label 5033*/ GIMT_Encode4(223415),
     /* 218741 */ // Label 5021: @218741
     /* 218741 */ GIM_Try, /*On fail goto*//*Label 5035*/ GIMT_Encode4(218900),
     /* 218746 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 218749 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 218752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 218756 */   GIM_Try, /*On fail goto*//*Label 5036*/ GIMT_Encode4(218814), // Rule ID 24255 //
     /* 218761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 218764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 218768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218772 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218775 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218779 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 218787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218789 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218796 */     // (strict_fmul:{ *:[f16] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR16X:{ *:[f16] }:$src1)  =>  (VMULSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSHZrm),
     /* 218799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218801 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 218803 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218807 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218812 */     GIR_RootConstrainSelectedInstOperands,
     /* 218813 */     // GIR_Coverage, 24255,
     /* 218813 */     GIR_EraseRootFromParent_Done,
     /* 218814 */   // Label 5036: @218814
     /* 218814 */   GIM_Try, /*On fail goto*//*Label 5037*/ GIMT_Encode4(218872), // Rule ID 6011 //
     /* 218819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 218822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 218826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 218830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218834 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218837 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218841 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218847 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218854 */     // (strict_fmul:{ *:[f16] } FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSHZrm),
     /* 218857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218859 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 218861 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218865 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218870 */     GIR_RootConstrainSelectedInstOperands,
     /* 218871 */     // GIR_Coverage, 6011,
     /* 218871 */     GIR_EraseRootFromParent_Done,
     /* 218872 */   // Label 5037: @218872
     /* 218872 */   GIM_Try, /*On fail goto*//*Label 5038*/ GIMT_Encode4(218899), // Rule ID 6009 //
     /* 218877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 218880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 218884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 218888 */     // (strict_fmul:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VMULSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 218888 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSHZrr),
     /* 218893 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 218897 */     GIR_RootConstrainSelectedInstOperands,
     /* 218898 */     // GIR_Coverage, 6009,
     /* 218898 */     GIR_Done,
     /* 218899 */   // Label 5038: @218899
     /* 218899 */   GIM_Reject,
     /* 218900 */ // Label 5035: @218900
     /* 218900 */ GIM_Reject,
     /* 218901 */ // Label 5022: @218901
     /* 218901 */ GIM_Try, /*On fail goto*//*Label 5039*/ GIMT_Encode4(219805),
     /* 218906 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 218909 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 218912 */   GIM_Try, /*On fail goto*//*Label 5040*/ GIMT_Encode4(218977), // Rule ID 23268 //
     /* 218917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 218920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 218924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 218928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 218932 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 218939 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 218947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218949 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218956 */     // (strict_fmul:{ *:[f32] } (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP32:{ *:[f32] }:$src1)  =>  (MUL_FpI16m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI16m32),
     /* 218959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218961 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 218963 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218967 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 218970 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218975 */     GIR_RootConstrainSelectedInstOperands,
     /* 218976 */     // GIR_Coverage, 23268,
     /* 218976 */     GIR_EraseRootFromParent_Done,
     /* 218977 */   // Label 5040: @218977
     /* 218977 */   GIM_Try, /*On fail goto*//*Label 5041*/ GIMT_Encode4(219042), // Rule ID 23270 //
     /* 218982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 218985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 218989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 218993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 218997 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 219004 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 219012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219014 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219021 */     // (strict_fmul:{ *:[f32] } (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP32:{ *:[f32] }:$src1)  =>  (MUL_FpI32m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI32m32),
     /* 219024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219026 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 219028 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219032 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 219035 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219040 */     GIR_RootConstrainSelectedInstOperands,
     /* 219041 */     // GIR_Coverage, 23270,
     /* 219041 */     GIR_EraseRootFromParent_Done,
     /* 219042 */   // Label 5041: @219042
     /* 219042 */   GIM_Try, /*On fail goto*//*Label 5042*/ GIMT_Encode4(219107), // Rule ID 23258 //
     /* 219047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 219050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 219054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 219058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219062 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219065 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219069 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 219077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219079 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219086 */     // (strict_fmul:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP32:{ *:[f32] }:$src1)  =>  (MUL_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp32m),
     /* 219089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219091 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 219093 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219097 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 219100 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219105 */     GIR_RootConstrainSelectedInstOperands,
     /* 219106 */     // GIR_Coverage, 23258,
     /* 219106 */     GIR_EraseRootFromParent_Done,
     /* 219107 */   // Label 5042: @219107
     /* 219107 */   GIM_Try, /*On fail goto*//*Label 5043*/ GIMT_Encode4(219169), // Rule ID 23401 //
     /* 219112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 219115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 219119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 219123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219127 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219130 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219134 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 219142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219144 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219151 */     // (strict_fmul:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (VMULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSrm),
     /* 219154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219156 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 219158 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219162 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219167 */     GIR_RootConstrainSelectedInstOperands,
     /* 219168 */     // GIR_Coverage, 23401,
     /* 219168 */     GIR_EraseRootFromParent_Done,
     /* 219169 */   // Label 5043: @219169
     /* 219169 */   GIM_Try, /*On fail goto*//*Label 5044*/ GIMT_Encode4(219231), // Rule ID 23405 //
     /* 219174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 219177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 219181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 219185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219189 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219192 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219196 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 219204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219206 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219213 */     // (strict_fmul:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (MULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSSrm),
     /* 219216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219218 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 219220 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219224 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219229 */     GIR_RootConstrainSelectedInstOperands,
     /* 219230 */     // GIR_Coverage, 23405,
     /* 219230 */     GIR_EraseRootFromParent_Done,
     /* 219231 */   // Label 5044: @219231
     /* 219231 */   GIM_Try, /*On fail goto*//*Label 5045*/ GIMT_Encode4(219293), // Rule ID 24251 //
     /* 219236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 219239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 219243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 219247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219251 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219254 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219258 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 219266 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219268 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219275 */     // (strict_fmul:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32X:{ *:[f32] }:$src1)  =>  (VMULSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSZrm),
     /* 219278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219280 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 219282 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219286 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219291 */     GIR_RootConstrainSelectedInstOperands,
     /* 219292 */     // GIR_Coverage, 24251,
     /* 219292 */     GIR_EraseRootFromParent_Done,
     /* 219293 */   // Label 5045: @219293
     /* 219293 */   GIM_Try, /*On fail goto*//*Label 5046*/ GIMT_Encode4(219358), // Rule ID 986 //
     /* 219298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 219301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 219305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 219309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 219313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 219317 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 219324 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219328 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219330 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219337 */     // (strict_fmul:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (MUL_FpI16m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI16m32),
     /* 219340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219342 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 219344 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219348 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 219351 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219356 */     GIR_RootConstrainSelectedInstOperands,
     /* 219357 */     // GIR_Coverage, 986,
     /* 219357 */     GIR_EraseRootFromParent_Done,
     /* 219358 */   // Label 5046: @219358
     /* 219358 */   GIM_Try, /*On fail goto*//*Label 5047*/ GIMT_Encode4(219423), // Rule ID 988 //
     /* 219363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 219366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 219370 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 219374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 219378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 219382 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 219389 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219395 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219402 */     // (strict_fmul:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (MUL_FpI32m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI32m32),
     /* 219405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219407 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 219409 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219413 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 219416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219421 */     GIR_RootConstrainSelectedInstOperands,
     /* 219422 */     // GIR_Coverage, 988,
     /* 219422 */     GIR_EraseRootFromParent_Done,
     /* 219423 */   // Label 5047: @219423
     /* 219423 */   GIM_Try, /*On fail goto*//*Label 5048*/ GIMT_Encode4(219488), // Rule ID 976 //
     /* 219428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 219431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 219435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 219439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 219443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219447 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219450 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219454 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219458 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219460 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219467 */     // (strict_fmul:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MUL_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp32m),
     /* 219470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219472 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 219474 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219478 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 219481 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219486 */     GIR_RootConstrainSelectedInstOperands,
     /* 219487 */     // GIR_Coverage, 976,
     /* 219487 */     GIR_EraseRootFromParent_Done,
     /* 219488 */   // Label 5048: @219488
     /* 219488 */   GIM_Try, /*On fail goto*//*Label 5049*/ GIMT_Encode4(219550), // Rule ID 2200 //
     /* 219493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 219496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 219500 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 219504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 219508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219512 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219515 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219519 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219525 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219532 */     // (strict_fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSrm),
     /* 219535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219537 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 219539 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219543 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219548 */     GIR_RootConstrainSelectedInstOperands,
     /* 219549 */     // GIR_Coverage, 2200,
     /* 219549 */     GIR_EraseRootFromParent_Done,
     /* 219550 */   // Label 5049: @219550
     /* 219550 */   GIM_Try, /*On fail goto*//*Label 5050*/ GIMT_Encode4(219612), // Rule ID 2208 //
     /* 219555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 219558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 219562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 219566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 219570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219574 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219577 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219581 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219587 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219594 */     // (strict_fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSSrm),
     /* 219597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219599 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 219601 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219610 */     GIR_RootConstrainSelectedInstOperands,
     /* 219611 */     // GIR_Coverage, 2208,
     /* 219611 */     GIR_EraseRootFromParent_Done,
     /* 219612 */   // Label 5050: @219612
     /* 219612 */   GIM_Try, /*On fail goto*//*Label 5051*/ GIMT_Encode4(219674), // Rule ID 5973 //
     /* 219617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 219620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 219624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 219628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 219632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219636 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219639 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219643 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219649 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219656 */     // (strict_fmul:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSZrm),
     /* 219659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219661 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 219663 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219667 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219672 */     GIR_RootConstrainSelectedInstOperands,
     /* 219673 */     // GIR_Coverage, 5973,
     /* 219673 */     GIR_EraseRootFromParent_Done,
     /* 219674 */   // Label 5051: @219674
     /* 219674 */   GIM_Try, /*On fail goto*//*Label 5052*/ GIMT_Encode4(219711), // Rule ID 898 //
     /* 219679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 219682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 219686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 219690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 219694 */     // (strict_fmul:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (MUL_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 219694 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MUL_Fp32),
     /* 219699 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 219705 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 219709 */     GIR_RootConstrainSelectedInstOperands,
     /* 219710 */     // GIR_Coverage, 898,
     /* 219710 */     GIR_Done,
     /* 219711 */   // Label 5052: @219711
     /* 219711 */   GIM_Try, /*On fail goto*//*Label 5053*/ GIMT_Encode4(219742), // Rule ID 2198 //
     /* 219716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 219719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 219723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 219727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 219731 */     // (strict_fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VMULSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 219731 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSSrr),
     /* 219736 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 219740 */     GIR_RootConstrainSelectedInstOperands,
     /* 219741 */     // GIR_Coverage, 2198,
     /* 219741 */     GIR_Done,
     /* 219742 */   // Label 5053: @219742
     /* 219742 */   GIM_Try, /*On fail goto*//*Label 5054*/ GIMT_Encode4(219773), // Rule ID 2206 //
     /* 219747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 219750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 219754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 219758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 219762 */     // (strict_fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (MULSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 219762 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULSSrr),
     /* 219767 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 219771 */     GIR_RootConstrainSelectedInstOperands,
     /* 219772 */     // GIR_Coverage, 2206,
     /* 219772 */     GIR_Done,
     /* 219773 */   // Label 5054: @219773
     /* 219773 */   GIM_Try, /*On fail goto*//*Label 5055*/ GIMT_Encode4(219804), // Rule ID 5971 //
     /* 219778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 219781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 219785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 219789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 219793 */     // (strict_fmul:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VMULSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 219793 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSSZrr),
     /* 219798 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 219802 */     GIR_RootConstrainSelectedInstOperands,
     /* 219803 */     // GIR_Coverage, 5971,
     /* 219803 */     GIR_Done,
     /* 219804 */   // Label 5055: @219804
     /* 219804 */   GIM_Reject,
     /* 219805 */ // Label 5039: @219805
     /* 219805 */ GIM_Reject,
     /* 219806 */ // Label 5023: @219806
     /* 219806 */ GIM_Try, /*On fail goto*//*Label 5056*/ GIMT_Encode4(220854),
     /* 219811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 219814 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 219817 */   GIM_Try, /*On fail goto*//*Label 5057*/ GIMT_Encode4(219882), // Rule ID 23272 //
     /* 219822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 219825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 219829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 219833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 219837 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 219844 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 219852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219854 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219861 */     // (strict_fmul:{ *:[f64] } (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP64:{ *:[f64] }:$src1)  =>  (MUL_FpI16m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI16m64),
     /* 219864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219866 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 219868 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219872 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 219875 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219880 */     GIR_RootConstrainSelectedInstOperands,
     /* 219881 */     // GIR_Coverage, 23272,
     /* 219881 */     GIR_EraseRootFromParent_Done,
     /* 219882 */   // Label 5057: @219882
     /* 219882 */   GIM_Try, /*On fail goto*//*Label 5058*/ GIMT_Encode4(219947), // Rule ID 23274 //
     /* 219887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 219890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 219894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 219898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 219902 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 219909 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 219917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219919 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219926 */     // (strict_fmul:{ *:[f64] } (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP64:{ *:[f64] }:$src1)  =>  (MUL_FpI32m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI32m64),
     /* 219929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219931 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 219933 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219937 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 219940 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219945 */     GIR_RootConstrainSelectedInstOperands,
     /* 219946 */     // GIR_Coverage, 23274,
     /* 219946 */     GIR_EraseRootFromParent_Done,
     /* 219947 */   // Label 5058: @219947
     /* 219947 */   GIM_Try, /*On fail goto*//*Label 5059*/ GIMT_Encode4(220012), // Rule ID 23260 //
     /* 219952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 219955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 219959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 219963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219967 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219970 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219974 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 219982 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219984 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219991 */     // (strict_fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP64:{ *:[f64] }:$src1)  =>  (MUL_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64m),
     /* 219994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219996 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 219998 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220002 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 220005 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220010 */     GIR_RootConstrainSelectedInstOperands,
     /* 220011 */     // GIR_Coverage, 23260,
     /* 220011 */     GIR_EraseRootFromParent_Done,
     /* 220012 */   // Label 5059: @220012
     /* 220012 */   GIM_Try, /*On fail goto*//*Label 5060*/ GIMT_Encode4(220084), // Rule ID 23262 //
     /* 220017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 220020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 220024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 220028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220032 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220035 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220039 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 220046 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 220054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220056 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220063 */     // (strict_fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP64:{ *:[f64] }:$src1)  =>  (MUL_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64m32),
     /* 220066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220068 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 220070 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220074 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 220077 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220082 */     GIR_RootConstrainSelectedInstOperands,
     /* 220083 */     // GIR_Coverage, 23262,
     /* 220083 */     GIR_EraseRootFromParent_Done,
     /* 220084 */   // Label 5060: @220084
     /* 220084 */   GIM_Try, /*On fail goto*//*Label 5061*/ GIMT_Encode4(220146), // Rule ID 23403 //
     /* 220089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 220092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 220096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 220100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220104 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220107 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220111 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 220119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220121 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220128 */     // (strict_fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (VMULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDrm),
     /* 220131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220133 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 220135 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220139 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220144 */     GIR_RootConstrainSelectedInstOperands,
     /* 220145 */     // GIR_Coverage, 23403,
     /* 220145 */     GIR_EraseRootFromParent_Done,
     /* 220146 */   // Label 5061: @220146
     /* 220146 */   GIM_Try, /*On fail goto*//*Label 5062*/ GIMT_Encode4(220208), // Rule ID 23407 //
     /* 220151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 220154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 220158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 220162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220166 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220169 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220173 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 220181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220183 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220190 */     // (strict_fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (MULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSDrm),
     /* 220193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220195 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 220197 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220206 */     GIR_RootConstrainSelectedInstOperands,
     /* 220207 */     // GIR_Coverage, 23407,
     /* 220207 */     GIR_EraseRootFromParent_Done,
     /* 220208 */   // Label 5062: @220208
     /* 220208 */   GIM_Try, /*On fail goto*//*Label 5063*/ GIMT_Encode4(220270), // Rule ID 24253 //
     /* 220213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 220216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 220220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 220224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220228 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220231 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220235 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 220243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220245 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220252 */     // (strict_fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64X:{ *:[f64] }:$src1)  =>  (VMULSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDZrm),
     /* 220255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220257 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 220259 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220263 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220268 */     GIR_RootConstrainSelectedInstOperands,
     /* 220269 */     // GIR_Coverage, 24253,
     /* 220269 */     GIR_EraseRootFromParent_Done,
     /* 220270 */   // Label 5063: @220270
     /* 220270 */   GIM_Try, /*On fail goto*//*Label 5064*/ GIMT_Encode4(220335), // Rule ID 990 //
     /* 220275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 220278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 220282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 220286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 220290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 220294 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 220301 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220307 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220314 */     // (strict_fmul:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (MUL_FpI16m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI16m64),
     /* 220317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220319 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 220321 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220325 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 220328 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220333 */     GIR_RootConstrainSelectedInstOperands,
     /* 220334 */     // GIR_Coverage, 990,
     /* 220334 */     GIR_EraseRootFromParent_Done,
     /* 220335 */   // Label 5064: @220335
     /* 220335 */   GIM_Try, /*On fail goto*//*Label 5065*/ GIMT_Encode4(220400), // Rule ID 992 //
     /* 220340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 220343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 220347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 220351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 220355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 220359 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 220366 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220370 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220372 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220379 */     // (strict_fmul:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (MUL_FpI32m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI32m64),
     /* 220382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220384 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 220386 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220390 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 220393 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220398 */     GIR_RootConstrainSelectedInstOperands,
     /* 220399 */     // GIR_Coverage, 992,
     /* 220399 */     GIR_EraseRootFromParent_Done,
     /* 220400 */   // Label 5065: @220400
     /* 220400 */   GIM_Try, /*On fail goto*//*Label 5066*/ GIMT_Encode4(220465), // Rule ID 978 //
     /* 220405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 220408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 220412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 220416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 220420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220424 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220427 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220431 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220437 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220444 */     // (strict_fmul:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MUL_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64m),
     /* 220447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220449 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 220451 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220455 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 220458 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220463 */     GIR_RootConstrainSelectedInstOperands,
     /* 220464 */     // GIR_Coverage, 978,
     /* 220464 */     GIR_EraseRootFromParent_Done,
     /* 220465 */   // Label 5066: @220465
     /* 220465 */   GIM_Try, /*On fail goto*//*Label 5067*/ GIMT_Encode4(220537), // Rule ID 980 //
     /* 220470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 220473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 220477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 220481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 220485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220489 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220492 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220496 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 220503 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220509 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220516 */     // (strict_fmul:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (MUL_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64m32),
     /* 220519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220521 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 220523 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220527 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 220530 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220535 */     GIR_RootConstrainSelectedInstOperands,
     /* 220536 */     // GIR_Coverage, 980,
     /* 220536 */     GIR_EraseRootFromParent_Done,
     /* 220537 */   // Label 5067: @220537
     /* 220537 */   GIM_Try, /*On fail goto*//*Label 5068*/ GIMT_Encode4(220599), // Rule ID 2204 //
     /* 220542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 220545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 220549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 220553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 220557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220561 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220564 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220568 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220572 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220574 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220581 */     // (strict_fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDrm),
     /* 220584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220586 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 220588 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220592 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220597 */     GIR_RootConstrainSelectedInstOperands,
     /* 220598 */     // GIR_Coverage, 2204,
     /* 220598 */     GIR_EraseRootFromParent_Done,
     /* 220599 */   // Label 5068: @220599
     /* 220599 */   GIM_Try, /*On fail goto*//*Label 5069*/ GIMT_Encode4(220661), // Rule ID 2212 //
     /* 220604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 220607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 220611 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 220615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 220619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220623 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220626 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220630 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220634 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220636 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220643 */     // (strict_fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSDrm),
     /* 220646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220648 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 220650 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220654 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220659 */     GIR_RootConstrainSelectedInstOperands,
     /* 220660 */     // GIR_Coverage, 2212,
     /* 220660 */     GIR_EraseRootFromParent_Done,
     /* 220661 */   // Label 5069: @220661
     /* 220661 */   GIM_Try, /*On fail goto*//*Label 5070*/ GIMT_Encode4(220723), // Rule ID 5992 //
     /* 220666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 220669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 220673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 220677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 220681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220685 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220688 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220692 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220698 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220705 */     // (strict_fmul:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDZrm),
     /* 220708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220710 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 220712 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220716 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220721 */     GIR_RootConstrainSelectedInstOperands,
     /* 220722 */     // GIR_Coverage, 5992,
     /* 220722 */     GIR_EraseRootFromParent_Done,
     /* 220723 */   // Label 5070: @220723
     /* 220723 */   GIM_Try, /*On fail goto*//*Label 5071*/ GIMT_Encode4(220760), // Rule ID 900 //
     /* 220728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 220731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 220735 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 220739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 220743 */     // (strict_fmul:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (MUL_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 220743 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64),
     /* 220748 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 220754 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 220758 */     GIR_RootConstrainSelectedInstOperands,
     /* 220759 */     // GIR_Coverage, 900,
     /* 220759 */     GIR_Done,
     /* 220760 */   // Label 5071: @220760
     /* 220760 */   GIM_Try, /*On fail goto*//*Label 5072*/ GIMT_Encode4(220791), // Rule ID 2202 //
     /* 220765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 220768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 220772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 220776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 220780 */     // (strict_fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VMULSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 220780 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSDrr),
     /* 220785 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 220789 */     GIR_RootConstrainSelectedInstOperands,
     /* 220790 */     // GIR_Coverage, 2202,
     /* 220790 */     GIR_Done,
     /* 220791 */   // Label 5072: @220791
     /* 220791 */   GIM_Try, /*On fail goto*//*Label 5073*/ GIMT_Encode4(220822), // Rule ID 2210 //
     /* 220796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 220799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 220803 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 220807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 220811 */     // (strict_fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (MULSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 220811 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULSDrr),
     /* 220816 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 220820 */     GIR_RootConstrainSelectedInstOperands,
     /* 220821 */     // GIR_Coverage, 2210,
     /* 220821 */     GIR_Done,
     /* 220822 */   // Label 5073: @220822
     /* 220822 */   GIM_Try, /*On fail goto*//*Label 5074*/ GIMT_Encode4(220853), // Rule ID 5990 //
     /* 220827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 220830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 220834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 220838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 220842 */     // (strict_fmul:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VMULSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 220842 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSDZrr),
     /* 220847 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 220851 */     GIR_RootConstrainSelectedInstOperands,
     /* 220852 */     // GIR_Coverage, 5990,
     /* 220852 */     GIR_Done,
     /* 220853 */   // Label 5074: @220853
     /* 220853 */   GIM_Reject,
     /* 220854 */ // Label 5056: @220854
     /* 220854 */ GIM_Reject,
     /* 220855 */ // Label 5024: @220855
     /* 220855 */ GIM_Try, /*On fail goto*//*Label 5075*/ GIMT_Encode4(221420),
     /* 220860 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 220863 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 220866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 220870 */   GIM_Try, /*On fail goto*//*Label 5076*/ GIMT_Encode4(220931), // Rule ID 23276 //
     /* 220875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 220878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 220882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 220886 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 220893 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 220901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220903 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220910 */     // (strict_fmul:{ *:[f80] } (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP80:{ *:[f80] }:$src1)  =>  (MUL_FpI16m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI16m80),
     /* 220913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220915 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 220917 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220921 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 220924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220929 */     GIR_RootConstrainSelectedInstOperands,
     /* 220930 */     // GIR_Coverage, 23276,
     /* 220930 */     GIR_EraseRootFromParent_Done,
     /* 220931 */   // Label 5076: @220931
     /* 220931 */   GIM_Try, /*On fail goto*//*Label 5077*/ GIMT_Encode4(220992), // Rule ID 23278 //
     /* 220936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 220939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 220943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 220947 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 220954 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 220962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220964 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220971 */     // (strict_fmul:{ *:[f80] } (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP80:{ *:[f80] }:$src1)  =>  (MUL_FpI32m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI32m80),
     /* 220974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220976 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 220978 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220982 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 220985 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220990 */     GIR_RootConstrainSelectedInstOperands,
     /* 220991 */     // GIR_Coverage, 23278,
     /* 220991 */     GIR_EraseRootFromParent_Done,
     /* 220992 */   // Label 5077: @220992
     /* 220992 */   GIM_Try, /*On fail goto*//*Label 5078*/ GIMT_Encode4(221060), // Rule ID 23264 //
     /* 220997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 221000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 221004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221008 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221011 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221015 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 221022 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 221030 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221032 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221039 */     // (strict_fmul:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP80:{ *:[f80] }:$src1)  =>  (MUL_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 221039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80m32),
     /* 221042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221044 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 221046 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 221050 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 221053 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221058 */     GIR_RootConstrainSelectedInstOperands,
     /* 221059 */     // GIR_Coverage, 23264,
     /* 221059 */     GIR_EraseRootFromParent_Done,
     /* 221060 */   // Label 5078: @221060
     /* 221060 */   GIM_Try, /*On fail goto*//*Label 5079*/ GIMT_Encode4(221128), // Rule ID 23266 //
     /* 221065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 221068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 221072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221076 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221079 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221083 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 221090 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 221098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221100 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221107 */     // (strict_fmul:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>, RFP80:{ *:[f80] }:$src1)  =>  (MUL_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 221107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80m64),
     /* 221110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221112 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 221114 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 221118 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 221121 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221126 */     GIR_RootConstrainSelectedInstOperands,
     /* 221127 */     // GIR_Coverage, 23266,
     /* 221127 */     GIR_EraseRootFromParent_Done,
     /* 221128 */   // Label 5079: @221128
     /* 221128 */   GIM_Try, /*On fail goto*//*Label 5080*/ GIMT_Encode4(221189), // Rule ID 994 //
     /* 221133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 221136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 221140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 221144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 221148 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 221155 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221161 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221168 */     // (strict_fmul:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (MUL_FpI16m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 221168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI16m80),
     /* 221171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221173 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 221175 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 221179 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 221182 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221187 */     GIR_RootConstrainSelectedInstOperands,
     /* 221188 */     // GIR_Coverage, 994,
     /* 221188 */     GIR_EraseRootFromParent_Done,
     /* 221189 */   // Label 5080: @221189
     /* 221189 */   GIM_Try, /*On fail goto*//*Label 5081*/ GIMT_Encode4(221250), // Rule ID 996 //
     /* 221194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 221197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 221201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 221205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 221209 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 221216 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221220 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221222 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221229 */     // (strict_fmul:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (MUL_FpI32m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 221229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI32m80),
     /* 221232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221234 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 221236 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 221240 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 221243 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221248 */     GIR_RootConstrainSelectedInstOperands,
     /* 221249 */     // GIR_Coverage, 996,
     /* 221249 */     GIR_EraseRootFromParent_Done,
     /* 221250 */   // Label 5081: @221250
     /* 221250 */   GIM_Try, /*On fail goto*//*Label 5082*/ GIMT_Encode4(221318), // Rule ID 982 //
     /* 221255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 221258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 221262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 221266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221270 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221273 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221277 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 221284 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221288 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221290 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221297 */     // (strict_fmul:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (MUL_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 221297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80m32),
     /* 221300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221302 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 221304 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 221308 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 221311 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221316 */     GIR_RootConstrainSelectedInstOperands,
     /* 221317 */     // GIR_Coverage, 982,
     /* 221317 */     GIR_EraseRootFromParent_Done,
     /* 221318 */   // Label 5082: @221318
     /* 221318 */   GIM_Try, /*On fail goto*//*Label 5083*/ GIMT_Encode4(221386), // Rule ID 984 //
     /* 221323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 221326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 221330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 221334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221338 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221341 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221345 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 221352 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221356 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221358 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221365 */     // (strict_fmul:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>)  =>  (MUL_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 221365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80m64),
     /* 221368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221370 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 221372 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 221376 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 221379 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221384 */     GIR_RootConstrainSelectedInstOperands,
     /* 221385 */     // GIR_Coverage, 984,
     /* 221385 */     GIR_EraseRootFromParent_Done,
     /* 221386 */   // Label 5083: @221386
     /* 221386 */   GIM_Try, /*On fail goto*//*Label 5084*/ GIMT_Encode4(221419), // Rule ID 902 //
     /* 221391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 221394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 221398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 221402 */     // (strict_fmul:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (MUL_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 221402 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80),
     /* 221407 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 221413 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 221417 */     GIR_RootConstrainSelectedInstOperands,
     /* 221418 */     // GIR_Coverage, 902,
     /* 221418 */     GIR_Done,
     /* 221419 */   // Label 5084: @221419
     /* 221419 */   GIM_Reject,
     /* 221420 */ // Label 5075: @221420
     /* 221420 */ GIM_Reject,
     /* 221421 */ // Label 5025: @221421
     /* 221421 */ GIM_Try, /*On fail goto*//*Label 5085*/ GIMT_Encode4(221774),
     /* 221426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 221429 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 221432 */   GIM_Try, /*On fail goto*//*Label 5086*/ GIMT_Encode4(221494), // Rule ID 23391 //
     /* 221437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 221440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 221444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 221448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221452 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221455 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221459 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 221467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221469 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221476 */     // (strict_fmul:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1)  =>  (VMULPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 221476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDrm),
     /* 221479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221481 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 221483 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 221487 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221492 */     GIR_RootConstrainSelectedInstOperands,
     /* 221493 */     // GIR_Coverage, 23391,
     /* 221493 */     GIR_EraseRootFromParent_Done,
     /* 221494 */   // Label 5086: @221494
     /* 221494 */   GIM_Try, /*On fail goto*//*Label 5087*/ GIMT_Encode4(221556), // Rule ID 24367 //
     /* 221499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 221502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 221506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 221510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221514 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221517 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221521 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 221529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221531 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221538 */     // (strict_fmul:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2f64] }:$src1)  =>  (VMULPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 221538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZ128rm),
     /* 221541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221543 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 221545 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 221549 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221554 */     GIR_RootConstrainSelectedInstOperands,
     /* 221555 */     // GIR_Coverage, 24367,
     /* 221555 */     GIR_EraseRootFromParent_Done,
     /* 221556 */   // Label 5087: @221556
     /* 221556 */   GIM_Try, /*On fail goto*//*Label 5088*/ GIMT_Encode4(221618), // Rule ID 2180 //
     /* 221561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 221564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 221568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 221572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 221576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221580 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221583 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221587 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221593 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221600 */     // (strict_fmul:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 221600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDrm),
     /* 221603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221605 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 221607 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 221611 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221616 */     GIR_RootConstrainSelectedInstOperands,
     /* 221617 */     // GIR_Coverage, 2180,
     /* 221617 */     GIR_EraseRootFromParent_Done,
     /* 221618 */   // Label 5088: @221618
     /* 221618 */   GIM_Try, /*On fail goto*//*Label 5089*/ GIMT_Encode4(221680), // Rule ID 6425 //
     /* 221623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 221626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 221630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 221634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 221638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221642 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221645 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221649 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221655 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221662 */     // (strict_fmul:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 221662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZ128rm),
     /* 221665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221667 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 221669 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 221673 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221678 */     GIR_RootConstrainSelectedInstOperands,
     /* 221679 */     // GIR_Coverage, 6425,
     /* 221679 */     GIR_EraseRootFromParent_Done,
     /* 221680 */   // Label 5089: @221680
     /* 221680 */   GIM_Try, /*On fail goto*//*Label 5090*/ GIMT_Encode4(221711), // Rule ID 2178 //
     /* 221685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 221688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 221692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 221696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 221700 */     // (strict_fmul:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VMULPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 221700 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDrr),
     /* 221705 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 221709 */     GIR_RootConstrainSelectedInstOperands,
     /* 221710 */     // GIR_Coverage, 2178,
     /* 221710 */     GIR_Done,
     /* 221711 */   // Label 5090: @221711
     /* 221711 */   GIM_Try, /*On fail goto*//*Label 5091*/ GIMT_Encode4(221742), // Rule ID 2194 //
     /* 221716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 221719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 221723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 221727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 221731 */     // (strict_fmul:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (MULPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 221731 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULPDrr),
     /* 221736 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 221740 */     GIR_RootConstrainSelectedInstOperands,
     /* 221741 */     // GIR_Coverage, 2194,
     /* 221741 */     GIR_Done,
     /* 221742 */   // Label 5091: @221742
     /* 221742 */   GIM_Try, /*On fail goto*//*Label 5092*/ GIMT_Encode4(221773), // Rule ID 6421 //
     /* 221747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 221750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 221754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 221758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 221762 */     // (strict_fmul:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VMULPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 221762 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDZ128rr),
     /* 221767 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 221771 */     GIR_RootConstrainSelectedInstOperands,
     /* 221772 */     // GIR_Coverage, 6421,
     /* 221772 */     GIR_Done,
     /* 221773 */   // Label 5092: @221773
     /* 221773 */   GIM_Reject,
     /* 221774 */ // Label 5085: @221774
     /* 221774 */ GIM_Reject,
     /* 221775 */ // Label 5026: @221775
     /* 221775 */ GIM_Try, /*On fail goto*//*Label 5093*/ GIMT_Encode4(222128),
     /* 221780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 221783 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 221786 */   GIM_Try, /*On fail goto*//*Label 5094*/ GIMT_Encode4(221848), // Rule ID 23389 //
     /* 221791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 221794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 221798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 221802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221806 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221809 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221813 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 221821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221823 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221830 */     // (strict_fmul:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1)  =>  (VMULPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 221830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSrm),
     /* 221833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221835 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 221837 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 221841 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221846 */     GIR_RootConstrainSelectedInstOperands,
     /* 221847 */     // GIR_Coverage, 23389,
     /* 221847 */     GIR_EraseRootFromParent_Done,
     /* 221848 */   // Label 5094: @221848
     /* 221848 */   GIM_Try, /*On fail goto*//*Label 5095*/ GIMT_Encode4(221910), // Rule ID 24351 //
     /* 221853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 221856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 221860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 221864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221868 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221871 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221875 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 221883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221885 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221892 */     // (strict_fmul:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4f32] }:$src1)  =>  (VMULPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 221892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZ128rm),
     /* 221895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221897 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 221899 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 221903 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221908 */     GIR_RootConstrainSelectedInstOperands,
     /* 221909 */     // GIR_Coverage, 24351,
     /* 221909 */     GIR_EraseRootFromParent_Done,
     /* 221910 */   // Label 5095: @221910
     /* 221910 */   GIM_Try, /*On fail goto*//*Label 5096*/ GIMT_Encode4(221972), // Rule ID 2176 //
     /* 221915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 221918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 221922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 221926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 221930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221934 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221937 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221941 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221947 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221954 */     // (strict_fmul:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 221954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSrm),
     /* 221957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221959 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 221961 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 221965 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221970 */     GIR_RootConstrainSelectedInstOperands,
     /* 221971 */     // GIR_Coverage, 2176,
     /* 221971 */     GIR_EraseRootFromParent_Done,
     /* 221972 */   // Label 5096: @221972
     /* 221972 */   GIM_Try, /*On fail goto*//*Label 5097*/ GIMT_Encode4(222034), // Rule ID 6401 //
     /* 221977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 221980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 221984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 221988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 221992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221996 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221999 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222003 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222009 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222016 */     // (strict_fmul:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 222016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZ128rm),
     /* 222019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222021 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 222023 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 222027 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222032 */     GIR_RootConstrainSelectedInstOperands,
     /* 222033 */     // GIR_Coverage, 6401,
     /* 222033 */     GIR_EraseRootFromParent_Done,
     /* 222034 */   // Label 5097: @222034
     /* 222034 */   GIM_Try, /*On fail goto*//*Label 5098*/ GIMT_Encode4(222065), // Rule ID 2174 //
     /* 222039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 222042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222046 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222054 */     // (strict_fmul:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VMULPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 222054 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSrr),
     /* 222059 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 222063 */     GIR_RootConstrainSelectedInstOperands,
     /* 222064 */     // GIR_Coverage, 2174,
     /* 222064 */     GIR_Done,
     /* 222065 */   // Label 5098: @222065
     /* 222065 */   GIM_Try, /*On fail goto*//*Label 5099*/ GIMT_Encode4(222096), // Rule ID 2190 //
     /* 222070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 222073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222077 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222085 */     // (strict_fmul:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (MULPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 222085 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULPSrr),
     /* 222090 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 222094 */     GIR_RootConstrainSelectedInstOperands,
     /* 222095 */     // GIR_Coverage, 2190,
     /* 222095 */     GIR_Done,
     /* 222096 */   // Label 5099: @222096
     /* 222096 */   GIM_Try, /*On fail goto*//*Label 5100*/ GIMT_Encode4(222127), // Rule ID 6397 //
     /* 222101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 222104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 222108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 222112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 222116 */     // (strict_fmul:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VMULPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 222116 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSZ128rr),
     /* 222121 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 222125 */     GIR_RootConstrainSelectedInstOperands,
     /* 222126 */     // GIR_Coverage, 6397,
     /* 222126 */     GIR_Done,
     /* 222127 */   // Label 5100: @222127
     /* 222127 */   GIM_Reject,
     /* 222128 */ // Label 5093: @222128
     /* 222128 */ GIM_Reject,
     /* 222129 */ // Label 5027: @222129
     /* 222129 */ GIM_Try, /*On fail goto*//*Label 5101*/ GIMT_Encode4(222451),
     /* 222134 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 222137 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 222140 */   GIM_Try, /*On fail goto*//*Label 5102*/ GIMT_Encode4(222202), // Rule ID 23395 //
     /* 222145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 222148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 222152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 222156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222160 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222163 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222167 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 222175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222177 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222184 */     // (strict_fmul:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1)  =>  (VMULPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 222184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDYrm),
     /* 222187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222189 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 222191 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 222195 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222200 */     GIR_RootConstrainSelectedInstOperands,
     /* 222201 */     // GIR_Coverage, 23395,
     /* 222201 */     GIR_EraseRootFromParent_Done,
     /* 222202 */   // Label 5102: @222202
     /* 222202 */   GIM_Try, /*On fail goto*//*Label 5103*/ GIMT_Encode4(222264), // Rule ID 24375 //
     /* 222207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 222210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 222214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 222218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222222 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222225 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222229 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 222237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222239 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222246 */     // (strict_fmul:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4f64] }:$src1)  =>  (VMULPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 222246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZ256rm),
     /* 222249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222251 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 222253 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 222257 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222262 */     GIR_RootConstrainSelectedInstOperands,
     /* 222263 */     // GIR_Coverage, 24375,
     /* 222263 */     GIR_EraseRootFromParent_Done,
     /* 222264 */   // Label 5103: @222264
     /* 222264 */   GIM_Try, /*On fail goto*//*Label 5104*/ GIMT_Encode4(222326), // Rule ID 2188 //
     /* 222269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 222272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 222276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 222280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 222284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222288 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222291 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222295 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222301 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222308 */     // (strict_fmul:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 222308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDYrm),
     /* 222311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222313 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 222315 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 222319 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222324 */     GIR_RootConstrainSelectedInstOperands,
     /* 222325 */     // GIR_Coverage, 2188,
     /* 222325 */     GIR_EraseRootFromParent_Done,
     /* 222326 */   // Label 5104: @222326
     /* 222326 */   GIM_Try, /*On fail goto*//*Label 5105*/ GIMT_Encode4(222388), // Rule ID 6437 //
     /* 222331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 222334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 222338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 222342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 222346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222350 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222353 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222357 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222363 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222370 */     // (strict_fmul:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 222370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZ256rm),
     /* 222373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222375 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 222377 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 222381 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222386 */     GIR_RootConstrainSelectedInstOperands,
     /* 222387 */     // GIR_Coverage, 6437,
     /* 222387 */     GIR_EraseRootFromParent_Done,
     /* 222388 */   // Label 5105: @222388
     /* 222388 */   GIM_Try, /*On fail goto*//*Label 5106*/ GIMT_Encode4(222419), // Rule ID 2186 //
     /* 222393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 222396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 222400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 222404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 222408 */     // (strict_fmul:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VMULPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 222408 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDYrr),
     /* 222413 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 222417 */     GIR_RootConstrainSelectedInstOperands,
     /* 222418 */     // GIR_Coverage, 2186,
     /* 222418 */     GIR_Done,
     /* 222419 */   // Label 5106: @222419
     /* 222419 */   GIM_Try, /*On fail goto*//*Label 5107*/ GIMT_Encode4(222450), // Rule ID 6433 //
     /* 222424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 222427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 222431 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 222435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 222439 */     // (strict_fmul:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VMULPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 222439 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDZ256rr),
     /* 222444 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 222448 */     GIR_RootConstrainSelectedInstOperands,
     /* 222449 */     // GIR_Coverage, 6433,
     /* 222449 */     GIR_Done,
     /* 222450 */   // Label 5107: @222450
     /* 222450 */   GIM_Reject,
     /* 222451 */ // Label 5101: @222451
     /* 222451 */ GIM_Reject,
     /* 222452 */ // Label 5028: @222452
     /* 222452 */ GIM_Try, /*On fail goto*//*Label 5108*/ GIMT_Encode4(222611),
     /* 222457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 222460 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 222463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 222467 */   GIM_Try, /*On fail goto*//*Label 5109*/ GIMT_Encode4(222525), // Rule ID 24391 //
     /* 222472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 222475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 222479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222483 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222486 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222490 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 222498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222500 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222507 */     // (strict_fmul:{ *:[v8f16] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8f16] }:$src1)  =>  (VMULPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 222507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZ128rm),
     /* 222510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222512 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 222514 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 222518 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222523 */     GIR_RootConstrainSelectedInstOperands,
     /* 222524 */     // GIR_Coverage, 24391,
     /* 222524 */     GIR_EraseRootFromParent_Done,
     /* 222525 */   // Label 5109: @222525
     /* 222525 */   GIM_Try, /*On fail goto*//*Label 5110*/ GIMT_Encode4(222583), // Rule ID 6461 //
     /* 222530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 222533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 222537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 222541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222545 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222548 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222552 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222558 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222565 */     // (strict_fmul:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 222565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZ128rm),
     /* 222568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222570 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 222572 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 222576 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222581 */     GIR_RootConstrainSelectedInstOperands,
     /* 222582 */     // GIR_Coverage, 6461,
     /* 222582 */     GIR_EraseRootFromParent_Done,
     /* 222583 */   // Label 5110: @222583
     /* 222583 */   GIM_Try, /*On fail goto*//*Label 5111*/ GIMT_Encode4(222610), // Rule ID 6457 //
     /* 222588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 222591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 222595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 222599 */     // (strict_fmul:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VMULPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 222599 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPHZ128rr),
     /* 222604 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 222608 */     GIR_RootConstrainSelectedInstOperands,
     /* 222609 */     // GIR_Coverage, 6457,
     /* 222609 */     GIR_Done,
     /* 222610 */   // Label 5111: @222610
     /* 222610 */   GIM_Reject,
     /* 222611 */ // Label 5108: @222611
     /* 222611 */ GIM_Reject,
     /* 222612 */ // Label 5029: @222612
     /* 222612 */ GIM_Try, /*On fail goto*//*Label 5112*/ GIMT_Encode4(222934),
     /* 222617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 222620 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 222623 */   GIM_Try, /*On fail goto*//*Label 5113*/ GIMT_Encode4(222685), // Rule ID 23393 //
     /* 222628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 222631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 222635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 222639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222643 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222646 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222650 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 222658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222660 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222667 */     // (strict_fmul:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1)  =>  (VMULPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 222667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSYrm),
     /* 222670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222672 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 222674 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 222678 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222683 */     GIR_RootConstrainSelectedInstOperands,
     /* 222684 */     // GIR_Coverage, 23393,
     /* 222684 */     GIR_EraseRootFromParent_Done,
     /* 222685 */   // Label 5113: @222685
     /* 222685 */   GIM_Try, /*On fail goto*//*Label 5114*/ GIMT_Encode4(222747), // Rule ID 24359 //
     /* 222690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 222693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 222697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 222701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222705 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222708 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222712 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 222720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222722 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222729 */     // (strict_fmul:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8f32] }:$src1)  =>  (VMULPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 222729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZ256rm),
     /* 222732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222734 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 222736 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 222740 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222745 */     GIR_RootConstrainSelectedInstOperands,
     /* 222746 */     // GIR_Coverage, 24359,
     /* 222746 */     GIR_EraseRootFromParent_Done,
     /* 222747 */   // Label 5114: @222747
     /* 222747 */   GIM_Try, /*On fail goto*//*Label 5115*/ GIMT_Encode4(222809), // Rule ID 2184 //
     /* 222752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 222755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 222759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 222763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 222767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222771 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222774 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222778 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222784 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222791 */     // (strict_fmul:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 222791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSYrm),
     /* 222794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222796 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 222798 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 222802 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222807 */     GIR_RootConstrainSelectedInstOperands,
     /* 222808 */     // GIR_Coverage, 2184,
     /* 222808 */     GIR_EraseRootFromParent_Done,
     /* 222809 */   // Label 5115: @222809
     /* 222809 */   GIM_Try, /*On fail goto*//*Label 5116*/ GIMT_Encode4(222871), // Rule ID 6413 //
     /* 222814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 222817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 222821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 222825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 222829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222833 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222836 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222840 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222846 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222853 */     // (strict_fmul:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 222853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZ256rm),
     /* 222856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222858 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 222860 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 222864 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222869 */     GIR_RootConstrainSelectedInstOperands,
     /* 222870 */     // GIR_Coverage, 6413,
     /* 222870 */     GIR_EraseRootFromParent_Done,
     /* 222871 */   // Label 5116: @222871
     /* 222871 */   GIM_Try, /*On fail goto*//*Label 5117*/ GIMT_Encode4(222902), // Rule ID 2182 //
     /* 222876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 222879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 222883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 222887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 222891 */     // (strict_fmul:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VMULPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 222891 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSYrr),
     /* 222896 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 222900 */     GIR_RootConstrainSelectedInstOperands,
     /* 222901 */     // GIR_Coverage, 2182,
     /* 222901 */     GIR_Done,
     /* 222902 */   // Label 5117: @222902
     /* 222902 */   GIM_Try, /*On fail goto*//*Label 5118*/ GIMT_Encode4(222933), // Rule ID 6409 //
     /* 222907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 222910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 222914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 222918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 222922 */     // (strict_fmul:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VMULPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 222922 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSZ256rr),
     /* 222927 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 222931 */     GIR_RootConstrainSelectedInstOperands,
     /* 222932 */     // GIR_Coverage, 6409,
     /* 222932 */     GIR_Done,
     /* 222933 */   // Label 5118: @222933
     /* 222933 */   GIM_Reject,
     /* 222934 */ // Label 5112: @222934
     /* 222934 */ GIM_Reject,
     /* 222935 */ // Label 5030: @222935
     /* 222935 */ GIM_Try, /*On fail goto*//*Label 5119*/ GIMT_Encode4(223094),
     /* 222940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 222943 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 222946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 222950 */   GIM_Try, /*On fail goto*//*Label 5120*/ GIMT_Encode4(223008), // Rule ID 24343 //
     /* 222955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 222958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 222962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222966 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222969 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222973 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 222981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222983 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222990 */     // (strict_fmul:{ *:[v8f64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8f64] }:$src1)  =>  (VMULPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 222990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZrm),
     /* 222993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222995 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 222997 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 223001 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223006 */     GIR_RootConstrainSelectedInstOperands,
     /* 223007 */     // GIR_Coverage, 24343,
     /* 223007 */     GIR_EraseRootFromParent_Done,
     /* 223008 */   // Label 5120: @223008
     /* 223008 */   GIM_Try, /*On fail goto*//*Label 5121*/ GIMT_Encode4(223066), // Rule ID 6389 //
     /* 223013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 223016 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 223020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 223024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223028 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223031 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223035 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223041 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223048 */     // (strict_fmul:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 223048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZrm),
     /* 223051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223053 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 223055 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 223059 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223064 */     GIR_RootConstrainSelectedInstOperands,
     /* 223065 */     // GIR_Coverage, 6389,
     /* 223065 */     GIR_EraseRootFromParent_Done,
     /* 223066 */   // Label 5121: @223066
     /* 223066 */   GIM_Try, /*On fail goto*//*Label 5122*/ GIMT_Encode4(223093), // Rule ID 6385 //
     /* 223071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 223074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 223078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 223082 */     // (strict_fmul:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VMULPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 223082 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDZrr),
     /* 223087 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 223091 */     GIR_RootConstrainSelectedInstOperands,
     /* 223092 */     // GIR_Coverage, 6385,
     /* 223092 */     GIR_Done,
     /* 223093 */   // Label 5122: @223093
     /* 223093 */   GIM_Reject,
     /* 223094 */ // Label 5119: @223094
     /* 223094 */ GIM_Reject,
     /* 223095 */ // Label 5031: @223095
     /* 223095 */ GIM_Try, /*On fail goto*//*Label 5123*/ GIMT_Encode4(223254),
     /* 223100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 223103 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 223106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 223110 */   GIM_Try, /*On fail goto*//*Label 5124*/ GIMT_Encode4(223168), // Rule ID 24399 //
     /* 223115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 223118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 223122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223126 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223129 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223133 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 223141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223143 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223150 */     // (strict_fmul:{ *:[v16f16] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16f16] }:$src1)  =>  (VMULPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 223150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZ256rm),
     /* 223153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223155 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 223157 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 223161 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223166 */     GIR_RootConstrainSelectedInstOperands,
     /* 223167 */     // GIR_Coverage, 24399,
     /* 223167 */     GIR_EraseRootFromParent_Done,
     /* 223168 */   // Label 5124: @223168
     /* 223168 */   GIM_Try, /*On fail goto*//*Label 5125*/ GIMT_Encode4(223226), // Rule ID 6473 //
     /* 223173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 223176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 223180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 223184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223188 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223191 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223195 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223201 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223208 */     // (strict_fmul:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 223208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZ256rm),
     /* 223211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223213 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 223215 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 223219 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223224 */     GIR_RootConstrainSelectedInstOperands,
     /* 223225 */     // GIR_Coverage, 6473,
     /* 223225 */     GIR_EraseRootFromParent_Done,
     /* 223226 */   // Label 5125: @223226
     /* 223226 */   GIM_Try, /*On fail goto*//*Label 5126*/ GIMT_Encode4(223253), // Rule ID 6469 //
     /* 223231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 223234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 223238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 223242 */     // (strict_fmul:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VMULPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 223242 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPHZ256rr),
     /* 223247 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 223251 */     GIR_RootConstrainSelectedInstOperands,
     /* 223252 */     // GIR_Coverage, 6469,
     /* 223252 */     GIR_Done,
     /* 223253 */   // Label 5126: @223253
     /* 223253 */   GIM_Reject,
     /* 223254 */ // Label 5123: @223254
     /* 223254 */ GIM_Reject,
     /* 223255 */ // Label 5032: @223255
     /* 223255 */ GIM_Try, /*On fail goto*//*Label 5127*/ GIMT_Encode4(223414),
     /* 223260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 223263 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 223266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 223270 */   GIM_Try, /*On fail goto*//*Label 5128*/ GIMT_Encode4(223328), // Rule ID 24335 //
     /* 223275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 223278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 223282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223286 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223289 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223293 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 223301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223303 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223310 */     // (strict_fmul:{ *:[v16f32] } (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16f32] }:$src1)  =>  (VMULPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 223310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZrm),
     /* 223313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223315 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 223317 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 223321 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223326 */     GIR_RootConstrainSelectedInstOperands,
     /* 223327 */     // GIR_Coverage, 24335,
     /* 223327 */     GIR_EraseRootFromParent_Done,
     /* 223328 */   // Label 5128: @223328
     /* 223328 */   GIM_Try, /*On fail goto*//*Label 5129*/ GIMT_Encode4(223386), // Rule ID 6377 //
     /* 223333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 223336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 223340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 223344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223348 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223351 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223355 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223361 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223368 */     // (strict_fmul:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 223368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZrm),
     /* 223371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223373 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 223375 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 223379 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223384 */     GIR_RootConstrainSelectedInstOperands,
     /* 223385 */     // GIR_Coverage, 6377,
     /* 223385 */     GIR_EraseRootFromParent_Done,
     /* 223386 */   // Label 5129: @223386
     /* 223386 */   GIM_Try, /*On fail goto*//*Label 5130*/ GIMT_Encode4(223413), // Rule ID 6373 //
     /* 223391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 223394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 223398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 223402 */     // (strict_fmul:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VMULPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 223402 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSZrr),
     /* 223407 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 223411 */     GIR_RootConstrainSelectedInstOperands,
     /* 223412 */     // GIR_Coverage, 6373,
     /* 223412 */     GIR_Done,
     /* 223413 */   // Label 5130: @223413
     /* 223413 */   GIM_Reject,
     /* 223414 */ // Label 5127: @223414
     /* 223414 */ GIM_Reject,
     /* 223415 */ // Label 5033: @223415
     /* 223415 */ GIM_Try, /*On fail goto*//*Label 5131*/ GIMT_Encode4(223574),
     /* 223420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 223423 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 223426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 223430 */   GIM_Try, /*On fail goto*//*Label 5132*/ GIMT_Encode4(223488), // Rule ID 24383 //
     /* 223435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 223438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 223442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223446 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223449 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223453 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 223461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223463 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223470 */     // (strict_fmul:{ *:[v32f16] } (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32f16] }:$src1)  =>  (VMULPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 223470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZrm),
     /* 223473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223475 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 223477 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 223481 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223486 */     GIR_RootConstrainSelectedInstOperands,
     /* 223487 */     // GIR_Coverage, 24383,
     /* 223487 */     GIR_EraseRootFromParent_Done,
     /* 223488 */   // Label 5132: @223488
     /* 223488 */   GIM_Try, /*On fail goto*//*Label 5133*/ GIMT_Encode4(223546), // Rule ID 6449 //
     /* 223493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 223496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 223500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 223504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223508 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223511 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223515 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223521 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223528 */     // (strict_fmul:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 223528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZrm),
     /* 223531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223533 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 223535 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 223539 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223544 */     GIR_RootConstrainSelectedInstOperands,
     /* 223545 */     // GIR_Coverage, 6449,
     /* 223545 */     GIR_EraseRootFromParent_Done,
     /* 223546 */   // Label 5133: @223546
     /* 223546 */   GIM_Try, /*On fail goto*//*Label 5134*/ GIMT_Encode4(223573), // Rule ID 6445 //
     /* 223551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 223554 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 223558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 223562 */     // (strict_fmul:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VMULPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 223562 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPHZrr),
     /* 223567 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 223571 */     GIR_RootConstrainSelectedInstOperands,
     /* 223572 */     // GIR_Coverage, 6445,
     /* 223572 */     GIR_Done,
     /* 223573 */   // Label 5134: @223573
     /* 223573 */   GIM_Reject,
     /* 223574 */ // Label 5131: @223574
     /* 223574 */ GIM_Reject,
     /* 223575 */ // Label 5034: @223575
     /* 223575 */ GIM_Reject,
     /* 223576 */ // Label 71: @223576
     /* 223576 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 5148*/ GIMT_Encode4(227265),
     /* 223587 */ /*GILLT_s16*//*Label 5135*/ GIMT_Encode4(223671),
     /* 223591 */ /*GILLT_s32*//*Label 5136*/ GIMT_Encode4(223769),
     /* 223595 */ /*GILLT_s64*//*Label 5137*/ GIMT_Encode4(224488),
     /* 223599 */ /*GILLT_s80*//*Label 5138*/ GIMT_Encode4(225351), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 223611 */ /*GILLT_v2s64*//*Label 5139*/ GIMT_Encode4(225917), GIMT_Encode4(0),
     /* 223619 */ /*GILLT_v4s32*//*Label 5140*/ GIMT_Encode4(226147),
     /* 223623 */ /*GILLT_v4s64*//*Label 5141*/ GIMT_Encode4(226377), GIMT_Encode4(0),
     /* 223631 */ /*GILLT_v8s16*//*Label 5142*/ GIMT_Encode4(226576),
     /* 223635 */ /*GILLT_v8s32*//*Label 5143*/ GIMT_Encode4(226674),
     /* 223639 */ /*GILLT_v8s64*//*Label 5144*/ GIMT_Encode4(226873), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 223651 */ /*GILLT_v16s16*//*Label 5145*/ GIMT_Encode4(226971),
     /* 223655 */ /*GILLT_v16s32*//*Label 5146*/ GIMT_Encode4(227069), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 223667 */ /*GILLT_v32s16*//*Label 5147*/ GIMT_Encode4(227167),
     /* 223671 */ // Label 5135: @223671
     /* 223671 */ GIM_Try, /*On fail goto*//*Label 5149*/ GIMT_Encode4(223768),
     /* 223676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 223679 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 223682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 223686 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 223690 */   GIM_Try, /*On fail goto*//*Label 5150*/ GIMT_Encode4(223744), // Rule ID 6125 //
     /* 223695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 223698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 223702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223706 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223709 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223713 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223719 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223726 */     // (strict_fdiv:{ *:[f16] } FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 223726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSHZrm),
     /* 223729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223731 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 223733 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 223737 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223742 */     GIR_RootConstrainSelectedInstOperands,
     /* 223743 */     // GIR_Coverage, 6125,
     /* 223743 */     GIR_EraseRootFromParent_Done,
     /* 223744 */   // Label 5150: @223744
     /* 223744 */   GIM_Try, /*On fail goto*//*Label 5151*/ GIMT_Encode4(223767), // Rule ID 6123 //
     /* 223749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 223752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 223756 */     // (strict_fdiv:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VDIVSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 223756 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSHZrr),
     /* 223761 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 223765 */     GIR_RootConstrainSelectedInstOperands,
     /* 223766 */     // GIR_Coverage, 6123,
     /* 223766 */     GIR_Done,
     /* 223767 */   // Label 5151: @223767
     /* 223767 */   GIM_Reject,
     /* 223768 */ // Label 5149: @223768
     /* 223768 */ GIM_Reject,
     /* 223769 */ // Label 5136: @223769
     /* 223769 */ GIM_Try, /*On fail goto*//*Label 5152*/ GIMT_Encode4(224487),
     /* 223774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 223777 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 223780 */   GIM_Try, /*On fail goto*//*Label 5153*/ GIMT_Encode4(223845), // Rule ID 1030 //
     /* 223785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 223788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 223792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 223796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 223800 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 223807 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 223815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223817 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223824 */     // (strict_fdiv:{ *:[f32] } (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP32:{ *:[f32] }:$src1)  =>  (DIVR_FpI16m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 223824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_FpI16m32),
     /* 223827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223829 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 223831 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 223835 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 223838 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223843 */     GIR_RootConstrainSelectedInstOperands,
     /* 223844 */     // GIR_Coverage, 1030,
     /* 223844 */     GIR_EraseRootFromParent_Done,
     /* 223845 */   // Label 5153: @223845
     /* 223845 */   GIM_Try, /*On fail goto*//*Label 5154*/ GIMT_Encode4(223910), // Rule ID 1032 //
     /* 223850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 223853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 223857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 223861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 223865 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 223872 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 223880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223882 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223889 */     // (strict_fdiv:{ *:[f32] } (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP32:{ *:[f32] }:$src1)  =>  (DIVR_FpI32m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 223889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_FpI32m32),
     /* 223892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223894 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 223896 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 223900 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 223903 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223908 */     GIR_RootConstrainSelectedInstOperands,
     /* 223909 */     // GIR_Coverage, 1032,
     /* 223909 */     GIR_EraseRootFromParent_Done,
     /* 223910 */   // Label 5154: @223910
     /* 223910 */   GIM_Try, /*On fail goto*//*Label 5155*/ GIMT_Encode4(223975), // Rule ID 1020 //
     /* 223915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 223918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 223922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 223926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223930 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223933 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223937 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 223945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223947 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223954 */     // (strict_fdiv:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP32:{ *:[f32] }:$src1)  =>  (DIVR_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 223954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp32m),
     /* 223957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223959 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 223961 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 223965 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 223968 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223973 */     GIR_RootConstrainSelectedInstOperands,
     /* 223974 */     // GIR_Coverage, 1020,
     /* 223974 */     GIR_EraseRootFromParent_Done,
     /* 223975 */   // Label 5155: @223975
     /* 223975 */   GIM_Try, /*On fail goto*//*Label 5156*/ GIMT_Encode4(224040), // Rule ID 1008 //
     /* 223980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 223983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 223987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 223991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 223995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 223999 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 224006 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224010 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224012 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224019 */     // (strict_fdiv:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (DIV_FpI16m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 224019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_FpI16m32),
     /* 224022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224024 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 224026 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 224030 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 224033 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224038 */     GIR_RootConstrainSelectedInstOperands,
     /* 224039 */     // GIR_Coverage, 1008,
     /* 224039 */     GIR_EraseRootFromParent_Done,
     /* 224040 */   // Label 5156: @224040
     /* 224040 */   GIM_Try, /*On fail goto*//*Label 5157*/ GIMT_Encode4(224105), // Rule ID 1010 //
     /* 224045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 224048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 224052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 224056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 224060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 224064 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 224071 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224077 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224084 */     // (strict_fdiv:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (DIV_FpI32m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 224084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_FpI32m32),
     /* 224087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224089 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 224091 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 224095 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 224098 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224103 */     GIR_RootConstrainSelectedInstOperands,
     /* 224104 */     // GIR_Coverage, 1010,
     /* 224104 */     GIR_EraseRootFromParent_Done,
     /* 224105 */   // Label 5157: @224105
     /* 224105 */   GIM_Try, /*On fail goto*//*Label 5158*/ GIMT_Encode4(224170), // Rule ID 998 //
     /* 224110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 224113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 224117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 224121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 224125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224129 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224132 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224136 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224140 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224142 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224149 */     // (strict_fdiv:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (DIV_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 224149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp32m),
     /* 224152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224154 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 224156 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 224160 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 224163 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224168 */     GIR_RootConstrainSelectedInstOperands,
     /* 224169 */     // GIR_Coverage, 998,
     /* 224169 */     GIR_EraseRootFromParent_Done,
     /* 224170 */   // Label 5158: @224170
     /* 224170 */   GIM_Try, /*On fail goto*//*Label 5159*/ GIMT_Encode4(224232), // Rule ID 2280 //
     /* 224175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 224178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 224182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 224186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 224190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224194 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224197 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224201 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224207 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224214 */     // (strict_fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 224214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSSrm),
     /* 224217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224219 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 224221 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 224225 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224230 */     GIR_RootConstrainSelectedInstOperands,
     /* 224231 */     // GIR_Coverage, 2280,
     /* 224231 */     GIR_EraseRootFromParent_Done,
     /* 224232 */   // Label 5159: @224232
     /* 224232 */   GIM_Try, /*On fail goto*//*Label 5160*/ GIMT_Encode4(224294), // Rule ID 2288 //
     /* 224237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 224240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 224244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 224248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 224252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224256 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224259 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224263 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224269 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224276 */     // (strict_fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (DIVSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 224276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVSSrm),
     /* 224279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224281 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 224283 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 224287 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224292 */     GIR_RootConstrainSelectedInstOperands,
     /* 224293 */     // GIR_Coverage, 2288,
     /* 224293 */     GIR_EraseRootFromParent_Done,
     /* 224294 */   // Label 5160: @224294
     /* 224294 */   GIM_Try, /*On fail goto*//*Label 5161*/ GIMT_Encode4(224356), // Rule ID 6087 //
     /* 224299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 224302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 224306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 224310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 224314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224318 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224321 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224325 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224331 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224338 */     // (strict_fdiv:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 224338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSSZrm),
     /* 224341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224343 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 224345 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 224349 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224354 */     GIR_RootConstrainSelectedInstOperands,
     /* 224355 */     // GIR_Coverage, 6087,
     /* 224355 */     GIR_EraseRootFromParent_Done,
     /* 224356 */   // Label 5161: @224356
     /* 224356 */   GIM_Try, /*On fail goto*//*Label 5162*/ GIMT_Encode4(224393), // Rule ID 904 //
     /* 224361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 224364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 224368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 224372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 224376 */     // (strict_fdiv:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (DIV_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 224376 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIV_Fp32),
     /* 224381 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 224387 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 224391 */     GIR_RootConstrainSelectedInstOperands,
     /* 224392 */     // GIR_Coverage, 904,
     /* 224392 */     GIR_Done,
     /* 224393 */   // Label 5162: @224393
     /* 224393 */   GIM_Try, /*On fail goto*//*Label 5163*/ GIMT_Encode4(224424), // Rule ID 2278 //
     /* 224398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 224401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 224405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 224409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 224413 */     // (strict_fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VDIVSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 224413 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSSrr),
     /* 224418 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 224422 */     GIR_RootConstrainSelectedInstOperands,
     /* 224423 */     // GIR_Coverage, 2278,
     /* 224423 */     GIR_Done,
     /* 224424 */   // Label 5163: @224424
     /* 224424 */   GIM_Try, /*On fail goto*//*Label 5164*/ GIMT_Encode4(224455), // Rule ID 2286 //
     /* 224429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 224432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 224436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 224440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 224444 */     // (strict_fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (DIVSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 224444 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVSSrr),
     /* 224449 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 224453 */     GIR_RootConstrainSelectedInstOperands,
     /* 224454 */     // GIR_Coverage, 2286,
     /* 224454 */     GIR_Done,
     /* 224455 */   // Label 5164: @224455
     /* 224455 */   GIM_Try, /*On fail goto*//*Label 5165*/ GIMT_Encode4(224486), // Rule ID 6085 //
     /* 224460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 224463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 224467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 224471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 224475 */     // (strict_fdiv:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VDIVSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 224475 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSSZrr),
     /* 224480 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 224484 */     GIR_RootConstrainSelectedInstOperands,
     /* 224485 */     // GIR_Coverage, 6085,
     /* 224485 */     GIR_Done,
     /* 224486 */   // Label 5165: @224486
     /* 224486 */   GIM_Reject,
     /* 224487 */ // Label 5152: @224487
     /* 224487 */ GIM_Reject,
     /* 224488 */ // Label 5137: @224488
     /* 224488 */ GIM_Try, /*On fail goto*//*Label 5166*/ GIMT_Encode4(225350),
     /* 224493 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 224496 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 224499 */   GIM_Try, /*On fail goto*//*Label 5167*/ GIMT_Encode4(224564), // Rule ID 1034 //
     /* 224504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 224507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 224511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 224515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 224519 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 224526 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 224534 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224536 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224543 */     // (strict_fdiv:{ *:[f64] } (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP64:{ *:[f64] }:$src1)  =>  (DIVR_FpI16m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 224543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_FpI16m64),
     /* 224546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224548 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 224550 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 224554 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 224557 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224562 */     GIR_RootConstrainSelectedInstOperands,
     /* 224563 */     // GIR_Coverage, 1034,
     /* 224563 */     GIR_EraseRootFromParent_Done,
     /* 224564 */   // Label 5167: @224564
     /* 224564 */   GIM_Try, /*On fail goto*//*Label 5168*/ GIMT_Encode4(224629), // Rule ID 1036 //
     /* 224569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 224572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 224576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 224580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 224584 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 224591 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 224599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224601 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224608 */     // (strict_fdiv:{ *:[f64] } (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP64:{ *:[f64] }:$src1)  =>  (DIVR_FpI32m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 224608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_FpI32m64),
     /* 224611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224613 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 224615 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 224619 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 224622 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224627 */     GIR_RootConstrainSelectedInstOperands,
     /* 224628 */     // GIR_Coverage, 1036,
     /* 224628 */     GIR_EraseRootFromParent_Done,
     /* 224629 */   // Label 5168: @224629
     /* 224629 */   GIM_Try, /*On fail goto*//*Label 5169*/ GIMT_Encode4(224694), // Rule ID 1022 //
     /* 224634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 224637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 224641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 224645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224649 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224652 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224656 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 224664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224666 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224673 */     // (strict_fdiv:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP64:{ *:[f64] }:$src1)  =>  (DIVR_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 224673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp64m),
     /* 224676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224678 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 224680 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 224684 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 224687 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224692 */     GIR_RootConstrainSelectedInstOperands,
     /* 224693 */     // GIR_Coverage, 1022,
     /* 224693 */     GIR_EraseRootFromParent_Done,
     /* 224694 */   // Label 5169: @224694
     /* 224694 */   GIM_Try, /*On fail goto*//*Label 5170*/ GIMT_Encode4(224766), // Rule ID 1024 //
     /* 224699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 224702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 224706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 224710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224714 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224717 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224721 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 224728 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 224736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224738 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224745 */     // (strict_fdiv:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP64:{ *:[f64] }:$src1)  =>  (DIVR_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 224745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp64m32),
     /* 224748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224750 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 224752 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 224756 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 224759 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224764 */     GIR_RootConstrainSelectedInstOperands,
     /* 224765 */     // GIR_Coverage, 1024,
     /* 224765 */     GIR_EraseRootFromParent_Done,
     /* 224766 */   // Label 5170: @224766
     /* 224766 */   GIM_Try, /*On fail goto*//*Label 5171*/ GIMT_Encode4(224831), // Rule ID 1012 //
     /* 224771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 224774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 224778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 224782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 224786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 224790 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 224797 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224803 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224810 */     // (strict_fdiv:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (DIV_FpI16m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 224810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_FpI16m64),
     /* 224813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224815 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 224817 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 224821 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 224824 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224829 */     GIR_RootConstrainSelectedInstOperands,
     /* 224830 */     // GIR_Coverage, 1012,
     /* 224830 */     GIR_EraseRootFromParent_Done,
     /* 224831 */   // Label 5171: @224831
     /* 224831 */   GIM_Try, /*On fail goto*//*Label 5172*/ GIMT_Encode4(224896), // Rule ID 1014 //
     /* 224836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 224839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 224843 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 224847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 224851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 224855 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 224862 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224868 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224875 */     // (strict_fdiv:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (DIV_FpI32m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 224875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_FpI32m64),
     /* 224878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224880 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 224882 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 224886 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 224889 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224894 */     GIR_RootConstrainSelectedInstOperands,
     /* 224895 */     // GIR_Coverage, 1014,
     /* 224895 */     GIR_EraseRootFromParent_Done,
     /* 224896 */   // Label 5172: @224896
     /* 224896 */   GIM_Try, /*On fail goto*//*Label 5173*/ GIMT_Encode4(224961), // Rule ID 1000 //
     /* 224901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 224904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 224908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 224912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 224916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224920 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224923 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224927 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224933 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224940 */     // (strict_fdiv:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (DIV_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 224940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp64m),
     /* 224943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224945 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 224947 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 224951 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 224954 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224959 */     GIR_RootConstrainSelectedInstOperands,
     /* 224960 */     // GIR_Coverage, 1000,
     /* 224960 */     GIR_EraseRootFromParent_Done,
     /* 224961 */   // Label 5173: @224961
     /* 224961 */   GIM_Try, /*On fail goto*//*Label 5174*/ GIMT_Encode4(225033), // Rule ID 1002 //
     /* 224966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 224969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 224973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 224977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 224981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224985 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224988 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224992 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 224999 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225005 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225012 */     // (strict_fdiv:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (DIV_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 225012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp64m32),
     /* 225015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225017 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 225019 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 225023 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 225026 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225031 */     GIR_RootConstrainSelectedInstOperands,
     /* 225032 */     // GIR_Coverage, 1002,
     /* 225032 */     GIR_EraseRootFromParent_Done,
     /* 225033 */   // Label 5174: @225033
     /* 225033 */   GIM_Try, /*On fail goto*//*Label 5175*/ GIMT_Encode4(225095), // Rule ID 2284 //
     /* 225038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 225041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 225045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 225049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 225053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225057 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225060 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225064 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225070 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225077 */     // (strict_fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 225077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSDrm),
     /* 225080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225082 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 225084 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 225088 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225093 */     GIR_RootConstrainSelectedInstOperands,
     /* 225094 */     // GIR_Coverage, 2284,
     /* 225094 */     GIR_EraseRootFromParent_Done,
     /* 225095 */   // Label 5175: @225095
     /* 225095 */   GIM_Try, /*On fail goto*//*Label 5176*/ GIMT_Encode4(225157), // Rule ID 2292 //
     /* 225100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 225103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 225107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 225111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 225115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225119 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225122 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225126 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225132 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225139 */     // (strict_fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (DIVSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 225139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVSDrm),
     /* 225142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225144 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 225146 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 225150 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225155 */     GIR_RootConstrainSelectedInstOperands,
     /* 225156 */     // GIR_Coverage, 2292,
     /* 225156 */     GIR_EraseRootFromParent_Done,
     /* 225157 */   // Label 5176: @225157
     /* 225157 */   GIM_Try, /*On fail goto*//*Label 5177*/ GIMT_Encode4(225219), // Rule ID 6106 //
     /* 225162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 225165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 225169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 225173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 225177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225181 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225184 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225188 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225194 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225201 */     // (strict_fdiv:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 225201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSDZrm),
     /* 225204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225206 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 225208 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 225212 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225217 */     GIR_RootConstrainSelectedInstOperands,
     /* 225218 */     // GIR_Coverage, 6106,
     /* 225218 */     GIR_EraseRootFromParent_Done,
     /* 225219 */   // Label 5177: @225219
     /* 225219 */   GIM_Try, /*On fail goto*//*Label 5178*/ GIMT_Encode4(225256), // Rule ID 906 //
     /* 225224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 225227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 225231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 225235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 225239 */     // (strict_fdiv:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (DIV_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 225239 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIV_Fp64),
     /* 225244 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 225250 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 225254 */     GIR_RootConstrainSelectedInstOperands,
     /* 225255 */     // GIR_Coverage, 906,
     /* 225255 */     GIR_Done,
     /* 225256 */   // Label 5178: @225256
     /* 225256 */   GIM_Try, /*On fail goto*//*Label 5179*/ GIMT_Encode4(225287), // Rule ID 2282 //
     /* 225261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 225264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 225268 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 225272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 225276 */     // (strict_fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VDIVSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 225276 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSDrr),
     /* 225281 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 225285 */     GIR_RootConstrainSelectedInstOperands,
     /* 225286 */     // GIR_Coverage, 2282,
     /* 225286 */     GIR_Done,
     /* 225287 */   // Label 5179: @225287
     /* 225287 */   GIM_Try, /*On fail goto*//*Label 5180*/ GIMT_Encode4(225318), // Rule ID 2290 //
     /* 225292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 225295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 225299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 225303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 225307 */     // (strict_fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (DIVSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 225307 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVSDrr),
     /* 225312 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 225316 */     GIR_RootConstrainSelectedInstOperands,
     /* 225317 */     // GIR_Coverage, 2290,
     /* 225317 */     GIR_Done,
     /* 225318 */   // Label 5180: @225318
     /* 225318 */   GIM_Try, /*On fail goto*//*Label 5181*/ GIMT_Encode4(225349), // Rule ID 6104 //
     /* 225323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 225326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 225330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 225334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 225338 */     // (strict_fdiv:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VDIVSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 225338 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSDZrr),
     /* 225343 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 225347 */     GIR_RootConstrainSelectedInstOperands,
     /* 225348 */     // GIR_Coverage, 6104,
     /* 225348 */     GIR_Done,
     /* 225349 */   // Label 5181: @225349
     /* 225349 */   GIM_Reject,
     /* 225350 */ // Label 5166: @225350
     /* 225350 */ GIM_Reject,
     /* 225351 */ // Label 5138: @225351
     /* 225351 */ GIM_Try, /*On fail goto*//*Label 5182*/ GIMT_Encode4(225916),
     /* 225356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 225359 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 225362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 225366 */   GIM_Try, /*On fail goto*//*Label 5183*/ GIMT_Encode4(225427), // Rule ID 1038 //
     /* 225371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 225374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 225378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 225382 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 225389 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 225397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225399 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225406 */     // (strict_fdiv:{ *:[f80] } (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP80:{ *:[f80] }:$src1)  =>  (DIVR_FpI16m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 225406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_FpI16m80),
     /* 225409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225411 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 225413 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 225417 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 225420 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225425 */     GIR_RootConstrainSelectedInstOperands,
     /* 225426 */     // GIR_Coverage, 1038,
     /* 225426 */     GIR_EraseRootFromParent_Done,
     /* 225427 */   // Label 5183: @225427
     /* 225427 */   GIM_Try, /*On fail goto*//*Label 5184*/ GIMT_Encode4(225488), // Rule ID 1040 //
     /* 225432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 225435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 225439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 225443 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 225450 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 225458 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225460 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225467 */     // (strict_fdiv:{ *:[f80] } (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP80:{ *:[f80] }:$src1)  =>  (DIVR_FpI32m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 225467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_FpI32m80),
     /* 225470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225472 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 225474 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 225478 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 225481 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225486 */     GIR_RootConstrainSelectedInstOperands,
     /* 225487 */     // GIR_Coverage, 1040,
     /* 225487 */     GIR_EraseRootFromParent_Done,
     /* 225488 */   // Label 5184: @225488
     /* 225488 */   GIM_Try, /*On fail goto*//*Label 5185*/ GIMT_Encode4(225556), // Rule ID 1026 //
     /* 225493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 225496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 225500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225504 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225507 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225511 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 225518 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 225526 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225528 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225535 */     // (strict_fdiv:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP80:{ *:[f80] }:$src1)  =>  (DIVR_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 225535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp80m32),
     /* 225538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225540 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 225542 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 225546 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 225549 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225554 */     GIR_RootConstrainSelectedInstOperands,
     /* 225555 */     // GIR_Coverage, 1026,
     /* 225555 */     GIR_EraseRootFromParent_Done,
     /* 225556 */   // Label 5185: @225556
     /* 225556 */   GIM_Try, /*On fail goto*//*Label 5186*/ GIMT_Encode4(225624), // Rule ID 1028 //
     /* 225561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 225564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 225568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225572 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225575 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225579 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 225586 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 225594 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225596 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225603 */     // (strict_fdiv:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>, RFP80:{ *:[f80] }:$src1)  =>  (DIVR_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 225603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp80m64),
     /* 225606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225608 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 225610 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 225614 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 225617 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225622 */     GIR_RootConstrainSelectedInstOperands,
     /* 225623 */     // GIR_Coverage, 1028,
     /* 225623 */     GIR_EraseRootFromParent_Done,
     /* 225624 */   // Label 5186: @225624
     /* 225624 */   GIM_Try, /*On fail goto*//*Label 5187*/ GIMT_Encode4(225685), // Rule ID 1016 //
     /* 225629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 225632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 225636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 225640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 225644 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 225651 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225657 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225664 */     // (strict_fdiv:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (DIV_FpI16m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 225664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_FpI16m80),
     /* 225667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225669 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 225671 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 225675 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 225678 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225683 */     GIR_RootConstrainSelectedInstOperands,
     /* 225684 */     // GIR_Coverage, 1016,
     /* 225684 */     GIR_EraseRootFromParent_Done,
     /* 225685 */   // Label 5187: @225685
     /* 225685 */   GIM_Try, /*On fail goto*//*Label 5188*/ GIMT_Encode4(225746), // Rule ID 1018 //
     /* 225690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 225693 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 225697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 225701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 225705 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 225712 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225716 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225718 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225725 */     // (strict_fdiv:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (DIV_FpI32m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 225725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_FpI32m80),
     /* 225728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225730 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 225732 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 225736 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 225739 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225744 */     GIR_RootConstrainSelectedInstOperands,
     /* 225745 */     // GIR_Coverage, 1018,
     /* 225745 */     GIR_EraseRootFromParent_Done,
     /* 225746 */   // Label 5188: @225746
     /* 225746 */   GIM_Try, /*On fail goto*//*Label 5189*/ GIMT_Encode4(225814), // Rule ID 1004 //
     /* 225751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 225754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 225758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 225762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225766 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225769 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225773 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 225780 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225786 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225793 */     // (strict_fdiv:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (DIV_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 225793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp80m32),
     /* 225796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225798 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 225800 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 225804 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 225807 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225812 */     GIR_RootConstrainSelectedInstOperands,
     /* 225813 */     // GIR_Coverage, 1004,
     /* 225813 */     GIR_EraseRootFromParent_Done,
     /* 225814 */   // Label 5189: @225814
     /* 225814 */   GIM_Try, /*On fail goto*//*Label 5190*/ GIMT_Encode4(225882), // Rule ID 1006 //
     /* 225819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 225822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 225826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 225830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225834 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225837 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225841 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 225848 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225854 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225861 */     // (strict_fdiv:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>)  =>  (DIV_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 225861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp80m64),
     /* 225864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225866 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 225868 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 225872 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 225875 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225880 */     GIR_RootConstrainSelectedInstOperands,
     /* 225881 */     // GIR_Coverage, 1006,
     /* 225881 */     GIR_EraseRootFromParent_Done,
     /* 225882 */   // Label 5190: @225882
     /* 225882 */   GIM_Try, /*On fail goto*//*Label 5191*/ GIMT_Encode4(225915), // Rule ID 908 //
     /* 225887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 225890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 225894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 225898 */     // (strict_fdiv:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (DIV_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 225898 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIV_Fp80),
     /* 225903 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 225909 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 225913 */     GIR_RootConstrainSelectedInstOperands,
     /* 225914 */     // GIR_Coverage, 908,
     /* 225914 */     GIR_Done,
     /* 225915 */   // Label 5191: @225915
     /* 225915 */   GIM_Reject,
     /* 225916 */ // Label 5182: @225916
     /* 225916 */ GIM_Reject,
     /* 225917 */ // Label 5139: @225917
     /* 225917 */ GIM_Try, /*On fail goto*//*Label 5192*/ GIMT_Encode4(226146),
     /* 225922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 225925 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 225928 */   GIM_Try, /*On fail goto*//*Label 5193*/ GIMT_Encode4(225990), // Rule ID 2260 //
     /* 225933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 225936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 225940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 225944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 225948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225952 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225955 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225959 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225965 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225972 */     // (strict_fdiv:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 225972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDrm),
     /* 225975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225977 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 225979 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 225983 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225988 */     GIR_RootConstrainSelectedInstOperands,
     /* 225989 */     // GIR_Coverage, 2260,
     /* 225989 */     GIR_EraseRootFromParent_Done,
     /* 225990 */   // Label 5193: @225990
     /* 225990 */   GIM_Try, /*On fail goto*//*Label 5194*/ GIMT_Encode4(226052), // Rule ID 6659 //
     /* 225995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 225998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 226002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 226006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 226010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226014 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226017 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226021 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226027 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226034 */     // (strict_fdiv:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 226034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ128rm),
     /* 226037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226039 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 226041 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 226045 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226050 */     GIR_RootConstrainSelectedInstOperands,
     /* 226051 */     // GIR_Coverage, 6659,
     /* 226051 */     GIR_EraseRootFromParent_Done,
     /* 226052 */   // Label 5194: @226052
     /* 226052 */   GIM_Try, /*On fail goto*//*Label 5195*/ GIMT_Encode4(226083), // Rule ID 2258 //
     /* 226057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 226060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 226064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 226068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 226072 */     // (strict_fdiv:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VDIVPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 226072 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDrr),
     /* 226077 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 226081 */     GIR_RootConstrainSelectedInstOperands,
     /* 226082 */     // GIR_Coverage, 2258,
     /* 226082 */     GIR_Done,
     /* 226083 */   // Label 5195: @226083
     /* 226083 */   GIM_Try, /*On fail goto*//*Label 5196*/ GIMT_Encode4(226114), // Rule ID 2274 //
     /* 226088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 226091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 226095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 226099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 226103 */     // (strict_fdiv:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (DIVPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 226103 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVPDrr),
     /* 226108 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 226112 */     GIR_RootConstrainSelectedInstOperands,
     /* 226113 */     // GIR_Coverage, 2274,
     /* 226113 */     GIR_Done,
     /* 226114 */   // Label 5196: @226114
     /* 226114 */   GIM_Try, /*On fail goto*//*Label 5197*/ GIMT_Encode4(226145), // Rule ID 6655 //
     /* 226119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 226122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 226126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 226130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 226134 */     // (strict_fdiv:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VDIVPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 226134 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ128rr),
     /* 226139 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 226143 */     GIR_RootConstrainSelectedInstOperands,
     /* 226144 */     // GIR_Coverage, 6655,
     /* 226144 */     GIR_Done,
     /* 226145 */   // Label 5197: @226145
     /* 226145 */   GIM_Reject,
     /* 226146 */ // Label 5192: @226146
     /* 226146 */ GIM_Reject,
     /* 226147 */ // Label 5140: @226147
     /* 226147 */ GIM_Try, /*On fail goto*//*Label 5198*/ GIMT_Encode4(226376),
     /* 226152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 226155 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 226158 */   GIM_Try, /*On fail goto*//*Label 5199*/ GIMT_Encode4(226220), // Rule ID 2256 //
     /* 226163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 226166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 226170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 226174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 226178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226182 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226185 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226189 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226195 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226202 */     // (strict_fdiv:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 226202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSrm),
     /* 226205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226207 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 226209 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 226213 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226218 */     GIR_RootConstrainSelectedInstOperands,
     /* 226219 */     // GIR_Coverage, 2256,
     /* 226219 */     GIR_EraseRootFromParent_Done,
     /* 226220 */   // Label 5199: @226220
     /* 226220 */   GIM_Try, /*On fail goto*//*Label 5200*/ GIMT_Encode4(226282), // Rule ID 6635 //
     /* 226225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 226228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 226232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 226236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 226240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226244 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226247 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226251 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226257 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226264 */     // (strict_fdiv:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 226264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ128rm),
     /* 226267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226269 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 226271 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 226275 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226280 */     GIR_RootConstrainSelectedInstOperands,
     /* 226281 */     // GIR_Coverage, 6635,
     /* 226281 */     GIR_EraseRootFromParent_Done,
     /* 226282 */   // Label 5200: @226282
     /* 226282 */   GIM_Try, /*On fail goto*//*Label 5201*/ GIMT_Encode4(226313), // Rule ID 2254 //
     /* 226287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 226290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 226294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 226298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 226302 */     // (strict_fdiv:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VDIVPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 226302 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSrr),
     /* 226307 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 226311 */     GIR_RootConstrainSelectedInstOperands,
     /* 226312 */     // GIR_Coverage, 2254,
     /* 226312 */     GIR_Done,
     /* 226313 */   // Label 5201: @226313
     /* 226313 */   GIM_Try, /*On fail goto*//*Label 5202*/ GIMT_Encode4(226344), // Rule ID 2270 //
     /* 226318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 226321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 226325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 226329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 226333 */     // (strict_fdiv:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (DIVPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 226333 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVPSrr),
     /* 226338 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 226342 */     GIR_RootConstrainSelectedInstOperands,
     /* 226343 */     // GIR_Coverage, 2270,
     /* 226343 */     GIR_Done,
     /* 226344 */   // Label 5202: @226344
     /* 226344 */   GIM_Try, /*On fail goto*//*Label 5203*/ GIMT_Encode4(226375), // Rule ID 6631 //
     /* 226349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 226352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 226356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 226360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 226364 */     // (strict_fdiv:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VDIVPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 226364 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ128rr),
     /* 226369 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 226373 */     GIR_RootConstrainSelectedInstOperands,
     /* 226374 */     // GIR_Coverage, 6631,
     /* 226374 */     GIR_Done,
     /* 226375 */   // Label 5203: @226375
     /* 226375 */   GIM_Reject,
     /* 226376 */ // Label 5198: @226376
     /* 226376 */ GIM_Reject,
     /* 226377 */ // Label 5141: @226377
     /* 226377 */ GIM_Try, /*On fail goto*//*Label 5204*/ GIMT_Encode4(226575),
     /* 226382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 226385 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 226388 */   GIM_Try, /*On fail goto*//*Label 5205*/ GIMT_Encode4(226450), // Rule ID 2268 //
     /* 226393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 226396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 226400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 226404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 226408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226412 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226415 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226419 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226425 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226432 */     // (strict_fdiv:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 226432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDYrm),
     /* 226435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226437 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 226439 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 226443 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226448 */     GIR_RootConstrainSelectedInstOperands,
     /* 226449 */     // GIR_Coverage, 2268,
     /* 226449 */     GIR_EraseRootFromParent_Done,
     /* 226450 */   // Label 5205: @226450
     /* 226450 */   GIM_Try, /*On fail goto*//*Label 5206*/ GIMT_Encode4(226512), // Rule ID 6671 //
     /* 226455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 226458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 226470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226474 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226477 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226481 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226487 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226494 */     // (strict_fdiv:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 226494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ256rm),
     /* 226497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226499 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 226501 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 226505 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226510 */     GIR_RootConstrainSelectedInstOperands,
     /* 226511 */     // GIR_Coverage, 6671,
     /* 226511 */     GIR_EraseRootFromParent_Done,
     /* 226512 */   // Label 5206: @226512
     /* 226512 */   GIM_Try, /*On fail goto*//*Label 5207*/ GIMT_Encode4(226543), // Rule ID 2266 //
     /* 226517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 226520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 226524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 226528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 226532 */     // (strict_fdiv:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VDIVPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 226532 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDYrr),
     /* 226537 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 226541 */     GIR_RootConstrainSelectedInstOperands,
     /* 226542 */     // GIR_Coverage, 2266,
     /* 226542 */     GIR_Done,
     /* 226543 */   // Label 5207: @226543
     /* 226543 */   GIM_Try, /*On fail goto*//*Label 5208*/ GIMT_Encode4(226574), // Rule ID 6667 //
     /* 226548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 226551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226555 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226563 */     // (strict_fdiv:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VDIVPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 226563 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ256rr),
     /* 226568 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 226572 */     GIR_RootConstrainSelectedInstOperands,
     /* 226573 */     // GIR_Coverage, 6667,
     /* 226573 */     GIR_Done,
     /* 226574 */   // Label 5208: @226574
     /* 226574 */   GIM_Reject,
     /* 226575 */ // Label 5204: @226575
     /* 226575 */ GIM_Reject,
     /* 226576 */ // Label 5142: @226576
     /* 226576 */ GIM_Try, /*On fail goto*//*Label 5209*/ GIMT_Encode4(226673),
     /* 226581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 226584 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 226587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 226591 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 226595 */   GIM_Try, /*On fail goto*//*Label 5210*/ GIMT_Encode4(226649), // Rule ID 6695 //
     /* 226600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 226603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 226607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226611 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226614 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226618 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226622 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226624 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226631 */     // (strict_fdiv:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 226631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ128rm),
     /* 226634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226636 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 226638 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 226642 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226647 */     GIR_RootConstrainSelectedInstOperands,
     /* 226648 */     // GIR_Coverage, 6695,
     /* 226648 */     GIR_EraseRootFromParent_Done,
     /* 226649 */   // Label 5210: @226649
     /* 226649 */   GIM_Try, /*On fail goto*//*Label 5211*/ GIMT_Encode4(226672), // Rule ID 6691 //
     /* 226654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 226657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 226661 */     // (strict_fdiv:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VDIVPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 226661 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ128rr),
     /* 226666 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 226670 */     GIR_RootConstrainSelectedInstOperands,
     /* 226671 */     // GIR_Coverage, 6691,
     /* 226671 */     GIR_Done,
     /* 226672 */   // Label 5211: @226672
     /* 226672 */   GIM_Reject,
     /* 226673 */ // Label 5209: @226673
     /* 226673 */ GIM_Reject,
     /* 226674 */ // Label 5143: @226674
     /* 226674 */ GIM_Try, /*On fail goto*//*Label 5212*/ GIMT_Encode4(226872),
     /* 226679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 226682 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 226685 */   GIM_Try, /*On fail goto*//*Label 5213*/ GIMT_Encode4(226747), // Rule ID 2264 //
     /* 226690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 226693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 226697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 226701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 226705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226709 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226712 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226716 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226722 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226729 */     // (strict_fdiv:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 226729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSYrm),
     /* 226732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226734 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 226736 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 226740 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226745 */     GIR_RootConstrainSelectedInstOperands,
     /* 226746 */     // GIR_Coverage, 2264,
     /* 226746 */     GIR_EraseRootFromParent_Done,
     /* 226747 */   // Label 5213: @226747
     /* 226747 */   GIM_Try, /*On fail goto*//*Label 5214*/ GIMT_Encode4(226809), // Rule ID 6647 //
     /* 226752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 226755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 226767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226771 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226774 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226778 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226784 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226791 */     // (strict_fdiv:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 226791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ256rm),
     /* 226794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226796 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 226798 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 226802 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226807 */     GIR_RootConstrainSelectedInstOperands,
     /* 226808 */     // GIR_Coverage, 6647,
     /* 226808 */     GIR_EraseRootFromParent_Done,
     /* 226809 */   // Label 5214: @226809
     /* 226809 */   GIM_Try, /*On fail goto*//*Label 5215*/ GIMT_Encode4(226840), // Rule ID 2262 //
     /* 226814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 226817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 226821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 226825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 226829 */     // (strict_fdiv:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VDIVPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 226829 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSYrr),
     /* 226834 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 226838 */     GIR_RootConstrainSelectedInstOperands,
     /* 226839 */     // GIR_Coverage, 2262,
     /* 226839 */     GIR_Done,
     /* 226840 */   // Label 5215: @226840
     /* 226840 */   GIM_Try, /*On fail goto*//*Label 5216*/ GIMT_Encode4(226871), // Rule ID 6643 //
     /* 226845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 226848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226860 */     // (strict_fdiv:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VDIVPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 226860 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ256rr),
     /* 226865 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 226869 */     GIR_RootConstrainSelectedInstOperands,
     /* 226870 */     // GIR_Coverage, 6643,
     /* 226870 */     GIR_Done,
     /* 226871 */   // Label 5216: @226871
     /* 226871 */   GIM_Reject,
     /* 226872 */ // Label 5212: @226872
     /* 226872 */ GIM_Reject,
     /* 226873 */ // Label 5144: @226873
     /* 226873 */ GIM_Try, /*On fail goto*//*Label 5217*/ GIMT_Encode4(226970),
     /* 226878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 226881 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 226884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226888 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226892 */   GIM_Try, /*On fail goto*//*Label 5218*/ GIMT_Encode4(226946), // Rule ID 6623 //
     /* 226897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 226900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 226904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226908 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226911 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226915 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226921 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226928 */     // (strict_fdiv:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 226928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDZrm),
     /* 226931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226933 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 226935 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 226939 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226944 */     GIR_RootConstrainSelectedInstOperands,
     /* 226945 */     // GIR_Coverage, 6623,
     /* 226945 */     GIR_EraseRootFromParent_Done,
     /* 226946 */   // Label 5218: @226946
     /* 226946 */   GIM_Try, /*On fail goto*//*Label 5219*/ GIMT_Encode4(226969), // Rule ID 6619 //
     /* 226951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 226954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226958 */     // (strict_fdiv:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VDIVPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 226958 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDZrr),
     /* 226963 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 226967 */     GIR_RootConstrainSelectedInstOperands,
     /* 226968 */     // GIR_Coverage, 6619,
     /* 226968 */     GIR_Done,
     /* 226969 */   // Label 5219: @226969
     /* 226969 */   GIM_Reject,
     /* 226970 */ // Label 5217: @226970
     /* 226970 */ GIM_Reject,
     /* 226971 */ // Label 5145: @226971
     /* 226971 */ GIM_Try, /*On fail goto*//*Label 5220*/ GIMT_Encode4(227068),
     /* 226976 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 226979 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 226982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226986 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226990 */   GIM_Try, /*On fail goto*//*Label 5221*/ GIMT_Encode4(227044), // Rule ID 6707 //
     /* 226995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 226998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 227002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227006 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227009 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227013 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227019 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227026 */     // (strict_fdiv:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 227026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ256rm),
     /* 227029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227031 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 227033 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 227037 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227042 */     GIR_RootConstrainSelectedInstOperands,
     /* 227043 */     // GIR_Coverage, 6707,
     /* 227043 */     GIR_EraseRootFromParent_Done,
     /* 227044 */   // Label 5221: @227044
     /* 227044 */   GIM_Try, /*On fail goto*//*Label 5222*/ GIMT_Encode4(227067), // Rule ID 6703 //
     /* 227049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 227052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 227056 */     // (strict_fdiv:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VDIVPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 227056 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ256rr),
     /* 227061 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 227065 */     GIR_RootConstrainSelectedInstOperands,
     /* 227066 */     // GIR_Coverage, 6703,
     /* 227066 */     GIR_Done,
     /* 227067 */   // Label 5222: @227067
     /* 227067 */   GIM_Reject,
     /* 227068 */ // Label 5220: @227068
     /* 227068 */ GIM_Reject,
     /* 227069 */ // Label 5146: @227069
     /* 227069 */ GIM_Try, /*On fail goto*//*Label 5223*/ GIMT_Encode4(227166),
     /* 227074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 227077 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 227080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 227084 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 227088 */   GIM_Try, /*On fail goto*//*Label 5224*/ GIMT_Encode4(227142), // Rule ID 6611 //
     /* 227093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 227096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 227100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227104 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227107 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227111 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227117 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227124 */     // (strict_fdiv:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 227124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSZrm),
     /* 227127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227129 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 227131 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 227135 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227140 */     GIR_RootConstrainSelectedInstOperands,
     /* 227141 */     // GIR_Coverage, 6611,
     /* 227141 */     GIR_EraseRootFromParent_Done,
     /* 227142 */   // Label 5224: @227142
     /* 227142 */   GIM_Try, /*On fail goto*//*Label 5225*/ GIMT_Encode4(227165), // Rule ID 6607 //
     /* 227147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 227150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 227154 */     // (strict_fdiv:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VDIVPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 227154 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSZrr),
     /* 227159 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 227163 */     GIR_RootConstrainSelectedInstOperands,
     /* 227164 */     // GIR_Coverage, 6607,
     /* 227164 */     GIR_Done,
     /* 227165 */   // Label 5225: @227165
     /* 227165 */   GIM_Reject,
     /* 227166 */ // Label 5223: @227166
     /* 227166 */ GIM_Reject,
     /* 227167 */ // Label 5147: @227167
     /* 227167 */ GIM_Try, /*On fail goto*//*Label 5226*/ GIMT_Encode4(227264),
     /* 227172 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 227175 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 227178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 227182 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 227186 */   GIM_Try, /*On fail goto*//*Label 5227*/ GIMT_Encode4(227240), // Rule ID 6683 //
     /* 227191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 227194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 227198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227202 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227205 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227209 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227215 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227222 */     // (strict_fdiv:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 227222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPHZrm),
     /* 227225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227227 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 227229 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 227233 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227238 */     GIR_RootConstrainSelectedInstOperands,
     /* 227239 */     // GIR_Coverage, 6683,
     /* 227239 */     GIR_EraseRootFromParent_Done,
     /* 227240 */   // Label 5227: @227240
     /* 227240 */   GIM_Try, /*On fail goto*//*Label 5228*/ GIMT_Encode4(227263), // Rule ID 6679 //
     /* 227245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 227248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 227252 */     // (strict_fdiv:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VDIVPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 227252 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPHZrr),
     /* 227257 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 227261 */     GIR_RootConstrainSelectedInstOperands,
     /* 227262 */     // GIR_Coverage, 6679,
     /* 227262 */     GIR_Done,
     /* 227263 */   // Label 5228: @227263
     /* 227263 */   GIM_Reject,
     /* 227264 */ // Label 5226: @227264
     /* 227264 */ GIM_Reject,
     /* 227265 */ // Label 5148: @227265
     /* 227265 */ GIM_Reject,
     /* 227266 */ // Label 72: @227266
     /* 227266 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 5241*/ GIMT_Encode4(233253),
     /* 227277 */ /*GILLT_s16*//*Label 5229*/ GIMT_Encode4(227361),
     /* 227281 */ /*GILLT_s32*//*Label 5230*/ GIMT_Encode4(227606),
     /* 227285 */ /*GILLT_s64*//*Label 5231*/ GIMT_Encode4(228343), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 227301 */ /*GILLT_v2s64*//*Label 5232*/ GIMT_Encode4(229080), GIMT_Encode4(0),
     /* 227309 */ /*GILLT_v4s32*//*Label 5233*/ GIMT_Encode4(229817),
     /* 227313 */ /*GILLT_v4s64*//*Label 5234*/ GIMT_Encode4(230554), GIMT_Encode4(0),
     /* 227321 */ /*GILLT_v8s16*//*Label 5235*/ GIMT_Encode4(231291),
     /* 227325 */ /*GILLT_v8s32*//*Label 5236*/ GIMT_Encode4(231536),
     /* 227329 */ /*GILLT_v8s64*//*Label 5237*/ GIMT_Encode4(232273), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 227341 */ /*GILLT_v16s16*//*Label 5238*/ GIMT_Encode4(232518),
     /* 227345 */ /*GILLT_v16s32*//*Label 5239*/ GIMT_Encode4(232763), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 227357 */ /*GILLT_v32s16*//*Label 5240*/ GIMT_Encode4(233008),
     /* 227361 */ // Label 5229: @227361
     /* 227361 */ GIM_Try, /*On fail goto*//*Label 5242*/ GIMT_Encode4(227605),
     /* 227366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 227369 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 227372 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 227375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 227379 */   GIM_Try, /*On fail goto*//*Label 5243*/ GIMT_Encode4(227443), // Rule ID 10157 //
     /* 227384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 227387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 227391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227395 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227398 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227402 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 227410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 227414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227416 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227423 */     // (strict_fma:{ *:[f16] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VFMADD132SHZm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 227423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SHZm),
     /* 227426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227428 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 227430 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 227432 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 227436 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227441 */     GIR_RootConstrainSelectedInstOperands,
     /* 227442 */     // GIR_Coverage, 10157,
     /* 227442 */     GIR_EraseRootFromParent_Done,
     /* 227443 */   // Label 5243: @227443
     /* 227443 */   GIM_Try, /*On fail goto*//*Label 5244*/ GIMT_Encode4(227507), // Rule ID 10155 //
     /* 227448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 227451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 227455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 227459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227463 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227466 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227470 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 227478 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227480 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227487 */     // (strict_fma:{ *:[f16] } FR16X:{ *:[f16] }:$src2, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR16X:{ *:[f16] }:$src1)  =>  (VFMADD231SHZm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 227487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SHZm),
     /* 227490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227492 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 227494 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 227496 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 227500 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227505 */     GIR_RootConstrainSelectedInstOperands,
     /* 227506 */     // GIR_Coverage, 10155,
     /* 227506 */     GIR_EraseRootFromParent_Done,
     /* 227507 */   // Label 5244: @227507
     /* 227507 */   GIM_Try, /*On fail goto*//*Label 5245*/ GIMT_Encode4(227571), // Rule ID 10152 //
     /* 227512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 227515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 227519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 227523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 227527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227531 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227534 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227538 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227542 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227544 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227551 */     // (strict_fma:{ *:[f16] } FR16X:{ *:[f16] }:$src2, FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SHZm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 227551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SHZm),
     /* 227554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227556 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 227558 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 227560 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 227564 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227569 */     GIR_RootConstrainSelectedInstOperands,
     /* 227570 */     // GIR_Coverage, 10152,
     /* 227570 */     GIR_EraseRootFromParent_Done,
     /* 227571 */   // Label 5245: @227571
     /* 227571 */   GIM_Try, /*On fail goto*//*Label 5246*/ GIMT_Encode4(227604), // Rule ID 10150 //
     /* 227576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 227579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 227583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 227587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 227591 */     // (strict_fma:{ *:[f16] } FR16X:{ *:[f16] }:$src2, FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src3)  =>  (VFMADD213SHZr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2, FR16X:{ *:[f16] }:$src3)
     /* 227591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SHZr),
     /* 227594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227596 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 227598 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 227600 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 227602 */     GIR_RootConstrainSelectedInstOperands,
     /* 227603 */     // GIR_Coverage, 10150,
     /* 227603 */     GIR_EraseRootFromParent_Done,
     /* 227604 */   // Label 5246: @227604
     /* 227604 */   GIM_Reject,
     /* 227605 */ // Label 5242: @227605
     /* 227605 */ GIM_Reject,
     /* 227606 */ // Label 5230: @227606
     /* 227606 */ GIM_Try, /*On fail goto*//*Label 5247*/ GIMT_Encode4(228342),
     /* 227611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 227614 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 227617 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 227620 */   GIM_Try, /*On fail goto*//*Label 5248*/ GIMT_Encode4(227688), // Rule ID 1303 //
     /* 227625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 227628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 227632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 227636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227640 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227643 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227647 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 227655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 227659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227661 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227668 */     // (strict_fma:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VFMADD132SSm:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 227668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SSm),
     /* 227671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227673 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 227675 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 227677 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 227681 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227686 */     GIR_RootConstrainSelectedInstOperands,
     /* 227687 */     // GIR_Coverage, 1303,
     /* 227687 */     GIR_EraseRootFromParent_Done,
     /* 227688 */   // Label 5248: @227688
     /* 227688 */   GIM_Try, /*On fail goto*//*Label 5249*/ GIMT_Encode4(227756), // Rule ID 10139 //
     /* 227693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 227696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 227700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 227704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227708 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227711 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227715 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 227723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 227727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227729 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227736 */     // (strict_fma:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VFMADD132SSZm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 227736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SSZm),
     /* 227739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227741 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 227743 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 227745 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 227749 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227754 */     GIR_RootConstrainSelectedInstOperands,
     /* 227755 */     // GIR_Coverage, 10139,
     /* 227755 */     GIR_EraseRootFromParent_Done,
     /* 227756 */   // Label 5249: @227756
     /* 227756 */   GIM_Try, /*On fail goto*//*Label 5250*/ GIMT_Encode4(227824), // Rule ID 23280 //
     /* 227761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 227764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 227768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 227772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227776 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227779 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227783 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 227791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 227795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227797 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227804 */     // (strict_fma:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src3)  =>  (VFMADDSS4mr:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 227804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSS4mr),
     /* 227807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227809 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 227811 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 227815 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 227817 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227822 */     GIR_RootConstrainSelectedInstOperands,
     /* 227823 */     // GIR_Coverage, 23280,
     /* 227823 */     GIR_EraseRootFromParent_Done,
     /* 227824 */   // Label 5250: @227824
     /* 227824 */   GIM_Try, /*On fail goto*//*Label 5251*/ GIMT_Encode4(227892), // Rule ID 1301 //
     /* 227829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 227832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 227836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 227840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 227844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227848 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227851 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227855 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 227863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227865 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227872 */     // (strict_fma:{ *:[f32] } FR32:{ *:[f32] }:$src2, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (VFMADD231SSm:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 227872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SSm),
     /* 227875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227877 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 227879 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 227881 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 227885 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227890 */     GIR_RootConstrainSelectedInstOperands,
     /* 227891 */     // GIR_Coverage, 1301,
     /* 227891 */     GIR_EraseRootFromParent_Done,
     /* 227892 */   // Label 5251: @227892
     /* 227892 */   GIM_Try, /*On fail goto*//*Label 5252*/ GIMT_Encode4(227960), // Rule ID 1365 //
     /* 227897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 227900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 227904 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 227908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 227912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227916 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227919 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227923 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 227931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227933 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227940 */     // (strict_fma:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src3)  =>  (VFMADDSS4mr:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 227940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSS4mr),
     /* 227943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227945 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 227947 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 227951 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 227953 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227958 */     GIR_RootConstrainSelectedInstOperands,
     /* 227959 */     // GIR_Coverage, 1365,
     /* 227959 */     GIR_EraseRootFromParent_Done,
     /* 227960 */   // Label 5252: @227960
     /* 227960 */   GIM_Try, /*On fail goto*//*Label 5253*/ GIMT_Encode4(228028), // Rule ID 10137 //
     /* 227965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 227968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 227972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 227976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 227980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227984 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227987 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227991 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 227999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228001 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228008 */     // (strict_fma:{ *:[f32] } FR32X:{ *:[f32] }:$src2, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32X:{ *:[f32] }:$src1)  =>  (VFMADD231SSZm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 228008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SSZm),
     /* 228011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228013 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 228015 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 228017 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 228021 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228026 */     GIR_RootConstrainSelectedInstOperands,
     /* 228027 */     // GIR_Coverage, 10137,
     /* 228027 */     GIR_EraseRootFromParent_Done,
     /* 228028 */   // Label 5253: @228028
     /* 228028 */   GIM_Try, /*On fail goto*//*Label 5254*/ GIMT_Encode4(228096), // Rule ID 1299 //
     /* 228033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 228036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 228040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 228044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 228048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 228052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228056 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228059 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228063 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228069 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228076 */     // (strict_fma:{ *:[f32] } FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SSm:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 228076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSm),
     /* 228079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228081 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 228083 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 228085 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 228089 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228094 */     GIR_RootConstrainSelectedInstOperands,
     /* 228095 */     // GIR_Coverage, 1299,
     /* 228095 */     GIR_EraseRootFromParent_Done,
     /* 228096 */   // Label 5254: @228096
     /* 228096 */   GIM_Try, /*On fail goto*//*Label 5255*/ GIMT_Encode4(228164), // Rule ID 1363 //
     /* 228101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 228104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 228108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 228112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 228116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 228120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228124 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228127 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228131 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228137 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228144 */     // (strict_fma:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDSS4rm:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 228144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSS4rm),
     /* 228147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228149 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 228151 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 228153 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 228157 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228162 */     GIR_RootConstrainSelectedInstOperands,
     /* 228163 */     // GIR_Coverage, 1363,
     /* 228163 */     GIR_EraseRootFromParent_Done,
     /* 228164 */   // Label 5255: @228164
     /* 228164 */   GIM_Try, /*On fail goto*//*Label 5256*/ GIMT_Encode4(228232), // Rule ID 10134 //
     /* 228169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 228172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 228176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 228180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 228184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 228188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228192 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228195 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228199 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228205 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228212 */     // (strict_fma:{ *:[f32] } FR32X:{ *:[f32] }:$src2, FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SSZm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 228212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSZm),
     /* 228215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228217 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 228219 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 228221 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 228225 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228230 */     GIR_RootConstrainSelectedInstOperands,
     /* 228231 */     // GIR_Coverage, 10134,
     /* 228231 */     GIR_EraseRootFromParent_Done,
     /* 228232 */   // Label 5256: @228232
     /* 228232 */   GIM_Try, /*On fail goto*//*Label 5257*/ GIMT_Encode4(228269), // Rule ID 1297 //
     /* 228237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 228240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 228244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 228248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 228252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 228256 */     // (strict_fma:{ *:[f32] } FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src3)  =>  (VFMADD213SSr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 228256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSr),
     /* 228259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228261 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 228263 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 228265 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 228267 */     GIR_RootConstrainSelectedInstOperands,
     /* 228268 */     // GIR_Coverage, 1297,
     /* 228268 */     GIR_EraseRootFromParent_Done,
     /* 228269 */   // Label 5257: @228269
     /* 228269 */   GIM_Try, /*On fail goto*//*Label 5258*/ GIMT_Encode4(228304), // Rule ID 1361 //
     /* 228274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 228277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 228281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 228285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 228289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 228293 */     // (strict_fma:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src3)  =>  (VFMADDSS4rr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 228293 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDSS4rr),
     /* 228298 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 228302 */     GIR_RootConstrainSelectedInstOperands,
     /* 228303 */     // GIR_Coverage, 1361,
     /* 228303 */     GIR_Done,
     /* 228304 */   // Label 5258: @228304
     /* 228304 */   GIM_Try, /*On fail goto*//*Label 5259*/ GIMT_Encode4(228341), // Rule ID 10132 //
     /* 228309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 228312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 228316 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 228320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 228324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 228328 */     // (strict_fma:{ *:[f32] } FR32X:{ *:[f32] }:$src2, FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src3)  =>  (VFMADD213SSZr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2, FR32X:{ *:[f32] }:$src3)
     /* 228328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSZr),
     /* 228331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228333 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 228335 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 228337 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 228339 */     GIR_RootConstrainSelectedInstOperands,
     /* 228340 */     // GIR_Coverage, 10132,
     /* 228340 */     GIR_EraseRootFromParent_Done,
     /* 228341 */   // Label 5259: @228341
     /* 228341 */   GIM_Reject,
     /* 228342 */ // Label 5247: @228342
     /* 228342 */ GIM_Reject,
     /* 228343 */ // Label 5231: @228343
     /* 228343 */ GIM_Try, /*On fail goto*//*Label 5260*/ GIMT_Encode4(229079),
     /* 228348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 228351 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 228354 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 228357 */   GIM_Try, /*On fail goto*//*Label 5261*/ GIMT_Encode4(228425), // Rule ID 1311 //
     /* 228362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 228365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 228373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228377 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228380 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228384 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228398 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228405 */     // (strict_fma:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VFMADD132SDm:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 228405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SDm),
     /* 228408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228410 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 228412 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 228414 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 228418 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228423 */     GIR_RootConstrainSelectedInstOperands,
     /* 228424 */     // GIR_Coverage, 1311,
     /* 228424 */     GIR_EraseRootFromParent_Done,
     /* 228425 */   // Label 5261: @228425
     /* 228425 */   GIM_Try, /*On fail goto*//*Label 5262*/ GIMT_Encode4(228493), // Rule ID 10148 //
     /* 228430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 228433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 228437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 228441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228445 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228448 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228452 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 228460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 228464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228466 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228473 */     // (strict_fma:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VFMADD132SDZm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 228473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SDZm),
     /* 228476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228478 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 228480 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 228482 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 228486 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228491 */     GIR_RootConstrainSelectedInstOperands,
     /* 228492 */     // GIR_Coverage, 10148,
     /* 228492 */     GIR_EraseRootFromParent_Done,
     /* 228493 */   // Label 5262: @228493
     /* 228493 */   GIM_Try, /*On fail goto*//*Label 5263*/ GIMT_Encode4(228561), // Rule ID 23308 //
     /* 228498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 228501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 228509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228513 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228516 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228520 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228534 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228541 */     // (strict_fma:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src3)  =>  (VFMADDSD4mr:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 228541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSD4mr),
     /* 228544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228546 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 228548 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 228552 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 228554 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228559 */     GIR_RootConstrainSelectedInstOperands,
     /* 228560 */     // GIR_Coverage, 23308,
     /* 228560 */     GIR_EraseRootFromParent_Done,
     /* 228561 */   // Label 5263: @228561
     /* 228561 */   GIM_Try, /*On fail goto*//*Label 5264*/ GIMT_Encode4(228629), // Rule ID 1309 //
     /* 228566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 228569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 228581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228585 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228588 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228592 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228602 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228609 */     // (strict_fma:{ *:[f64] } FR64:{ *:[f64] }:$src2, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (VFMADD231SDm:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 228609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SDm),
     /* 228612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228614 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 228616 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 228618 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 228622 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228627 */     GIR_RootConstrainSelectedInstOperands,
     /* 228628 */     // GIR_Coverage, 1309,
     /* 228628 */     GIR_EraseRootFromParent_Done,
     /* 228629 */   // Label 5264: @228629
     /* 228629 */   GIM_Try, /*On fail goto*//*Label 5265*/ GIMT_Encode4(228697), // Rule ID 1449 //
     /* 228634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 228637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 228649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228653 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228656 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228660 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228670 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228677 */     // (strict_fma:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src3)  =>  (VFMADDSD4mr:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 228677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSD4mr),
     /* 228680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228682 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 228684 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 228688 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 228690 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228695 */     GIR_RootConstrainSelectedInstOperands,
     /* 228696 */     // GIR_Coverage, 1449,
     /* 228696 */     GIR_EraseRootFromParent_Done,
     /* 228697 */   // Label 5265: @228697
     /* 228697 */   GIM_Try, /*On fail goto*//*Label 5266*/ GIMT_Encode4(228765), // Rule ID 10146 //
     /* 228702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 228705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 228709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 228713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 228717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228721 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228724 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228728 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 228736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228738 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228745 */     // (strict_fma:{ *:[f64] } FR64X:{ *:[f64] }:$src2, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64X:{ *:[f64] }:$src1)  =>  (VFMADD231SDZm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 228745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SDZm),
     /* 228748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228750 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 228752 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 228754 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 228758 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228763 */     GIR_RootConstrainSelectedInstOperands,
     /* 228764 */     // GIR_Coverage, 10146,
     /* 228764 */     GIR_EraseRootFromParent_Done,
     /* 228765 */   // Label 5266: @228765
     /* 228765 */   GIM_Try, /*On fail goto*//*Label 5267*/ GIMT_Encode4(228833), // Rule ID 1307 //
     /* 228770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 228773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 228789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228793 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228796 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228800 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228806 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228813 */     // (strict_fma:{ *:[f64] } FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SDm:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 228813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDm),
     /* 228816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228818 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 228820 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 228822 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 228826 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228831 */     GIR_RootConstrainSelectedInstOperands,
     /* 228832 */     // GIR_Coverage, 1307,
     /* 228832 */     GIR_EraseRootFromParent_Done,
     /* 228833 */   // Label 5267: @228833
     /* 228833 */   GIM_Try, /*On fail goto*//*Label 5268*/ GIMT_Encode4(228901), // Rule ID 1447 //
     /* 228838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 228841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 228857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228861 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228864 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228868 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228874 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228881 */     // (strict_fma:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDSD4rm:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 228881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSD4rm),
     /* 228884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228886 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 228888 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 228890 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 228894 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228899 */     GIR_RootConstrainSelectedInstOperands,
     /* 228900 */     // GIR_Coverage, 1447,
     /* 228900 */     GIR_EraseRootFromParent_Done,
     /* 228901 */   // Label 5268: @228901
     /* 228901 */   GIM_Try, /*On fail goto*//*Label 5269*/ GIMT_Encode4(228969), // Rule ID 10143 //
     /* 228906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 228909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 228913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 228917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 228921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 228925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228929 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228932 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228936 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228940 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228942 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228949 */     // (strict_fma:{ *:[f64] } FR64X:{ *:[f64] }:$src2, FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SDZm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 228949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDZm),
     /* 228952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228954 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 228956 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 228958 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 228962 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228967 */     GIR_RootConstrainSelectedInstOperands,
     /* 228968 */     // GIR_Coverage, 10143,
     /* 228968 */     GIR_EraseRootFromParent_Done,
     /* 228969 */   // Label 5269: @228969
     /* 228969 */   GIM_Try, /*On fail goto*//*Label 5270*/ GIMT_Encode4(229006), // Rule ID 1305 //
     /* 228974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 228977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228993 */     // (strict_fma:{ *:[f64] } FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src3)  =>  (VFMADD213SDr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 228993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDr),
     /* 228996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228998 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 229000 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 229002 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 229004 */     GIR_RootConstrainSelectedInstOperands,
     /* 229005 */     // GIR_Coverage, 1305,
     /* 229005 */     GIR_EraseRootFromParent_Done,
     /* 229006 */   // Label 5270: @229006
     /* 229006 */   GIM_Try, /*On fail goto*//*Label 5271*/ GIMT_Encode4(229041), // Rule ID 1445 //
     /* 229011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 229014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 229018 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 229022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 229026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 229030 */     // (strict_fma:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src3)  =>  (VFMADDSD4rr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 229030 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDSD4rr),
     /* 229035 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 229039 */     GIR_RootConstrainSelectedInstOperands,
     /* 229040 */     // GIR_Coverage, 1445,
     /* 229040 */     GIR_Done,
     /* 229041 */   // Label 5271: @229041
     /* 229041 */   GIM_Try, /*On fail goto*//*Label 5272*/ GIMT_Encode4(229078), // Rule ID 10141 //
     /* 229046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 229049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 229053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 229057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 229061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 229065 */     // (strict_fma:{ *:[f64] } FR64X:{ *:[f64] }:$src2, FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src3)  =>  (VFMADD213SDZr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2, FR64X:{ *:[f64] }:$src3)
     /* 229065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDZr),
     /* 229068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229070 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 229072 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 229074 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 229076 */     GIR_RootConstrainSelectedInstOperands,
     /* 229077 */     // GIR_Coverage, 10141,
     /* 229077 */     GIR_EraseRootFromParent_Done,
     /* 229078 */   // Label 5272: @229078
     /* 229078 */   GIM_Reject,
     /* 229079 */ // Label 5260: @229079
     /* 229079 */ GIM_Reject,
     /* 229080 */ // Label 5232: @229080
     /* 229080 */ GIM_Try, /*On fail goto*//*Label 5273*/ GIMT_Encode4(229816),
     /* 229085 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 229088 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 229091 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 229094 */   GIM_Try, /*On fail goto*//*Label 5274*/ GIMT_Encode4(229162), // Rule ID 1191 //
     /* 229099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 229102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 229110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 229114 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 229117 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 229121 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 229125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229135 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 229142 */     // (strict_fma:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VFMADD132PDm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 229142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDm),
     /* 229145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229147 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 229149 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 229151 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 229155 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 229160 */     GIR_RootConstrainSelectedInstOperands,
     /* 229161 */     // GIR_Coverage, 1191,
     /* 229161 */     GIR_EraseRootFromParent_Done,
     /* 229162 */   // Label 5274: @229162
     /* 229162 */   GIM_Try, /*On fail goto*//*Label 5275*/ GIMT_Encode4(229230), // Rule ID 9680 //
     /* 229167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 229170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 229174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 229178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 229182 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 229185 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 229189 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 229193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 229197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 229201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229203 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 229210 */     // (strict_fma:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VFMADD132PDZ128m:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 229210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDZ128m),
     /* 229213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229215 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 229217 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 229219 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 229223 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 229228 */     GIR_RootConstrainSelectedInstOperands,
     /* 229229 */     // GIR_Coverage, 9680,
     /* 229229 */     GIR_EraseRootFromParent_Done,
     /* 229230 */   // Label 5275: @229230
     /* 229230 */   GIM_Try, /*On fail goto*//*Label 5276*/ GIMT_Encode4(229298), // Rule ID 23316 //
     /* 229235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 229238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 229246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 229250 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 229253 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 229257 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 229261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229271 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 229278 */     // (strict_fma:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADDPD4mr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 229278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4mr),
     /* 229281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229283 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 229285 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 229289 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 229291 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 229296 */     GIR_RootConstrainSelectedInstOperands,
     /* 229297 */     // GIR_Coverage, 23316,
     /* 229297 */     GIR_EraseRootFromParent_Done,
     /* 229298 */   // Label 5276: @229298
     /* 229298 */   GIM_Try, /*On fail goto*//*Label 5277*/ GIMT_Encode4(229366), // Rule ID 1189 //
     /* 229303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 229306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 229318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 229322 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 229325 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 229329 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 229333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229339 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 229346 */     // (strict_fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src2, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1)  =>  (VFMADD231PDm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 229346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDm),
     /* 229349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229351 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 229353 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 229355 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 229359 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 229364 */     GIR_RootConstrainSelectedInstOperands,
     /* 229365 */     // GIR_Coverage, 1189,
     /* 229365 */     GIR_EraseRootFromParent_Done,
     /* 229366 */   // Label 5277: @229366
     /* 229366 */   GIM_Try, /*On fail goto*//*Label 5278*/ GIMT_Encode4(229434), // Rule ID 1473 //
     /* 229371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 229374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229378 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 229386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 229390 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 229393 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 229397 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 229401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229407 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 229414 */     // (strict_fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADDPD4mr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 229414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4mr),
     /* 229417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229419 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 229421 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 229425 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 229427 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 229432 */     GIR_RootConstrainSelectedInstOperands,
     /* 229433 */     // GIR_Coverage, 1473,
     /* 229433 */     GIR_EraseRootFromParent_Done,
     /* 229434 */   // Label 5278: @229434
     /* 229434 */   GIM_Try, /*On fail goto*//*Label 5279*/ GIMT_Encode4(229502), // Rule ID 9140 //
     /* 229439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 229442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 229446 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 229450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 229454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 229458 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 229461 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 229465 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 229469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 229473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229475 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 229482 */     // (strict_fma:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src2, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2f64] }:$src1)  =>  (VFMADD231PDZ128m:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 229482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDZ128m),
     /* 229485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229487 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 229489 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 229491 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 229495 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 229500 */     GIR_RootConstrainSelectedInstOperands,
     /* 229501 */     // GIR_Coverage, 9140,
     /* 229501 */     GIR_EraseRootFromParent_Done,
     /* 229502 */   // Label 5279: @229502
     /* 229502 */   GIM_Try, /*On fail goto*//*Label 5280*/ GIMT_Encode4(229570), // Rule ID 1187 //
     /* 229507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 229510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 229526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 229530 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 229533 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 229537 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 229541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229543 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 229550 */     // (strict_fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 229550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDm),
     /* 229553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229555 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 229557 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 229559 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 229563 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 229568 */     GIR_RootConstrainSelectedInstOperands,
     /* 229569 */     // GIR_Coverage, 1187,
     /* 229569 */     GIR_EraseRootFromParent_Done,
     /* 229570 */   // Label 5280: @229570
     /* 229570 */   GIM_Try, /*On fail goto*//*Label 5281*/ GIMT_Encode4(229638), // Rule ID 1471 //
     /* 229575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 229578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 229594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 229598 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 229601 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 229605 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 229609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229611 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 229618 */     // (strict_fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDPD4rm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 229618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4rm),
     /* 229621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229623 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 229625 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 229627 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 229631 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 229636 */     GIR_RootConstrainSelectedInstOperands,
     /* 229637 */     // GIR_Coverage, 1471,
     /* 229637 */     GIR_EraseRootFromParent_Done,
     /* 229638 */   // Label 5281: @229638
     /* 229638 */   GIM_Try, /*On fail goto*//*Label 5282*/ GIMT_Encode4(229706), // Rule ID 8513 //
     /* 229643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 229646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 229650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 229654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 229658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 229662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 229666 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 229669 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 229673 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 229677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229679 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 229686 */     // (strict_fma:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src2, VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDZ128m:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 229686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ128m),
     /* 229689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229691 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 229693 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 229695 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 229699 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 229704 */     GIR_RootConstrainSelectedInstOperands,
     /* 229705 */     // GIR_Coverage, 8513,
     /* 229705 */     GIR_EraseRootFromParent_Done,
     /* 229706 */   // Label 5282: @229706
     /* 229706 */   GIM_Try, /*On fail goto*//*Label 5283*/ GIMT_Encode4(229743), // Rule ID 1185 //
     /* 229711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 229714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229730 */     // (strict_fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADD213PDr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 229730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDr),
     /* 229733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229735 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 229737 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 229739 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 229741 */     GIR_RootConstrainSelectedInstOperands,
     /* 229742 */     // GIR_Coverage, 1185,
     /* 229742 */     GIR_EraseRootFromParent_Done,
     /* 229743 */   // Label 5283: @229743
     /* 229743 */   GIM_Try, /*On fail goto*//*Label 5284*/ GIMT_Encode4(229778), // Rule ID 1469 //
     /* 229748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 229751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229755 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229767 */     // (strict_fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADDPD4rr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 229767 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4rr),
     /* 229772 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 229776 */     GIR_RootConstrainSelectedInstOperands,
     /* 229777 */     // GIR_Coverage, 1469,
     /* 229777 */     GIR_Done,
     /* 229778 */   // Label 5284: @229778
     /* 229778 */   GIM_Try, /*On fail goto*//*Label 5285*/ GIMT_Encode4(229815), // Rule ID 8509 //
     /* 229783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 229786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 229790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 229794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 229798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 229802 */     // (strict_fma:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src2, VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src3)  =>  (VFMADD213PDZ128r:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2, VR128X:{ *:[v2f64] }:$src3)
     /* 229802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ128r),
     /* 229805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229807 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 229809 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 229811 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 229813 */     GIR_RootConstrainSelectedInstOperands,
     /* 229814 */     // GIR_Coverage, 8509,
     /* 229814 */     GIR_EraseRootFromParent_Done,
     /* 229815 */   // Label 5285: @229815
     /* 229815 */   GIM_Reject,
     /* 229816 */ // Label 5273: @229816
     /* 229816 */ GIM_Reject,
     /* 229817 */ // Label 5233: @229817
     /* 229817 */ GIM_Try, /*On fail goto*//*Label 5286*/ GIMT_Encode4(230553),
     /* 229822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 229825 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 229828 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 229831 */   GIM_Try, /*On fail goto*//*Label 5287*/ GIMT_Encode4(229899), // Rule ID 1143 //
     /* 229836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 229839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 229847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 229851 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 229854 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 229858 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 229862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229872 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 229879 */     // (strict_fma:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VFMADD132PSm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 229879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSm),
     /* 229882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229884 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 229886 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 229888 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 229892 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 229897 */     GIR_RootConstrainSelectedInstOperands,
     /* 229898 */     // GIR_Coverage, 1143,
     /* 229898 */     GIR_EraseRootFromParent_Done,
     /* 229899 */   // Label 5287: @229899
     /* 229899 */   GIM_Try, /*On fail goto*//*Label 5288*/ GIMT_Encode4(229967), // Rule ID 9648 //
     /* 229904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 229907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 229911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 229915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 229919 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 229922 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 229926 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 229930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 229934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 229938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229940 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 229947 */     // (strict_fma:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VFMADD132PSZ128m:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 229947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSZ128m),
     /* 229950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229952 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 229954 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 229956 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 229960 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 229965 */     GIR_RootConstrainSelectedInstOperands,
     /* 229966 */     // GIR_Coverage, 9648,
     /* 229966 */     GIR_EraseRootFromParent_Done,
     /* 229967 */   // Label 5288: @229967
     /* 229967 */   GIM_Try, /*On fail goto*//*Label 5289*/ GIMT_Encode4(230035), // Rule ID 23288 //
     /* 229972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 229975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 229983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 229987 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 229990 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 229994 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 229998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230006 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230008 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 230015 */     // (strict_fma:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADDPS4mr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 230015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4mr),
     /* 230018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230020 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 230022 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 230026 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 230028 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 230033 */     GIR_RootConstrainSelectedInstOperands,
     /* 230034 */     // GIR_Coverage, 23288,
     /* 230034 */     GIR_EraseRootFromParent_Done,
     /* 230035 */   // Label 5289: @230035
     /* 230035 */   GIM_Try, /*On fail goto*//*Label 5290*/ GIMT_Encode4(230103), // Rule ID 1141 //
     /* 230040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 230043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230047 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 230059 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 230062 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 230066 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 230070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230074 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230076 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 230083 */     // (strict_fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src2, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1)  =>  (VFMADD231PSm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 230083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSm),
     /* 230086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230088 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 230090 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 230092 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 230096 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 230101 */     GIR_RootConstrainSelectedInstOperands,
     /* 230102 */     // GIR_Coverage, 1141,
     /* 230102 */     GIR_EraseRootFromParent_Done,
     /* 230103 */   // Label 5290: @230103
     /* 230103 */   GIM_Try, /*On fail goto*//*Label 5291*/ GIMT_Encode4(230171), // Rule ID 1389 //
     /* 230108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 230111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 230127 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 230130 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 230134 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 230138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230144 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 230151 */     // (strict_fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADDPS4mr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 230151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4mr),
     /* 230154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230156 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 230158 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 230162 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 230164 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 230169 */     GIR_RootConstrainSelectedInstOperands,
     /* 230170 */     // GIR_Coverage, 1389,
     /* 230170 */     GIR_EraseRootFromParent_Done,
     /* 230171 */   // Label 5291: @230171
     /* 230171 */   GIM_Try, /*On fail goto*//*Label 5292*/ GIMT_Encode4(230239), // Rule ID 9108 //
     /* 230176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 230179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 230183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 230187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 230195 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 230198 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 230202 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 230206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 230210 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230212 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 230219 */     // (strict_fma:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src2, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4f32] }:$src1)  =>  (VFMADD231PSZ128m:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 230219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSZ128m),
     /* 230222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230224 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 230226 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 230228 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 230232 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 230237 */     GIR_RootConstrainSelectedInstOperands,
     /* 230238 */     // GIR_Coverage, 9108,
     /* 230238 */     GIR_EraseRootFromParent_Done,
     /* 230239 */   // Label 5292: @230239
     /* 230239 */   GIM_Try, /*On fail goto*//*Label 5293*/ GIMT_Encode4(230307), // Rule ID 1139 //
     /* 230244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 230247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230251 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 230263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 230267 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 230270 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 230274 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 230278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230280 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 230287 */     // (strict_fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 230287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSm),
     /* 230290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230292 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 230294 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 230296 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 230300 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 230305 */     GIR_RootConstrainSelectedInstOperands,
     /* 230306 */     // GIR_Coverage, 1139,
     /* 230306 */     GIR_EraseRootFromParent_Done,
     /* 230307 */   // Label 5293: @230307
     /* 230307 */   GIM_Try, /*On fail goto*//*Label 5294*/ GIMT_Encode4(230375), // Rule ID 1387 //
     /* 230312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 230315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 230331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 230335 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 230338 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 230342 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 230346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230348 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 230355 */     // (strict_fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDPS4rm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 230355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4rm),
     /* 230358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230360 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 230362 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 230364 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 230368 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 230373 */     GIR_RootConstrainSelectedInstOperands,
     /* 230374 */     // GIR_Coverage, 1387,
     /* 230374 */     GIR_EraseRootFromParent_Done,
     /* 230375 */   // Label 5294: @230375
     /* 230375 */   GIM_Try, /*On fail goto*//*Label 5295*/ GIMT_Encode4(230443), // Rule ID 8474 //
     /* 230380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 230383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 230387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 230391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 230395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 230399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 230403 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 230406 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 230410 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 230414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230416 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 230423 */     // (strict_fma:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src2, VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSZ128m:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 230423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ128m),
     /* 230426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230428 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 230430 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 230432 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 230436 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 230441 */     GIR_RootConstrainSelectedInstOperands,
     /* 230442 */     // GIR_Coverage, 8474,
     /* 230442 */     GIR_EraseRootFromParent_Done,
     /* 230443 */   // Label 5295: @230443
     /* 230443 */   GIM_Try, /*On fail goto*//*Label 5296*/ GIMT_Encode4(230480), // Rule ID 1137 //
     /* 230448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 230451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230467 */     // (strict_fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADD213PSr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 230467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSr),
     /* 230470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230472 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 230474 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 230476 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 230478 */     GIR_RootConstrainSelectedInstOperands,
     /* 230479 */     // GIR_Coverage, 1137,
     /* 230479 */     GIR_EraseRootFromParent_Done,
     /* 230480 */   // Label 5296: @230480
     /* 230480 */   GIM_Try, /*On fail goto*//*Label 5297*/ GIMT_Encode4(230515), // Rule ID 1385 //
     /* 230485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 230488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230504 */     // (strict_fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADDPS4rr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 230504 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4rr),
     /* 230509 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 230513 */     GIR_RootConstrainSelectedInstOperands,
     /* 230514 */     // GIR_Coverage, 1385,
     /* 230514 */     GIR_Done,
     /* 230515 */   // Label 5297: @230515
     /* 230515 */   GIM_Try, /*On fail goto*//*Label 5298*/ GIMT_Encode4(230552), // Rule ID 8470 //
     /* 230520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 230523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 230527 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 230531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 230535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 230539 */     // (strict_fma:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src2, VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src3)  =>  (VFMADD213PSZ128r:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2, VR128X:{ *:[v4f32] }:$src3)
     /* 230539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ128r),
     /* 230542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230544 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 230546 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 230548 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 230550 */     GIR_RootConstrainSelectedInstOperands,
     /* 230551 */     // GIR_Coverage, 8470,
     /* 230551 */     GIR_EraseRootFromParent_Done,
     /* 230552 */   // Label 5298: @230552
     /* 230552 */   GIM_Reject,
     /* 230553 */ // Label 5286: @230553
     /* 230553 */ GIM_Reject,
     /* 230554 */ // Label 5234: @230554
     /* 230554 */ GIM_Try, /*On fail goto*//*Label 5299*/ GIMT_Encode4(231290),
     /* 230559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 230562 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 230565 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 230568 */   GIM_Try, /*On fail goto*//*Label 5300*/ GIMT_Encode4(230636), // Rule ID 1199 //
     /* 230573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 230576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 230580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 230584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 230588 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 230591 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 230595 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 230599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 230603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 230607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230609 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 230616 */     // (strict_fma:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VFMADD132PDYm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 230616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDYm),
     /* 230619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230621 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 230623 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 230625 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 230629 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 230634 */     GIR_RootConstrainSelectedInstOperands,
     /* 230635 */     // GIR_Coverage, 1199,
     /* 230635 */     GIR_EraseRootFromParent_Done,
     /* 230636 */   // Label 5300: @230636
     /* 230636 */   GIM_Try, /*On fail goto*//*Label 5301*/ GIMT_Encode4(230704), // Rule ID 9670 //
     /* 230641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 230644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 230648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 230652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 230656 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 230659 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 230663 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 230667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 230671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 230675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230677 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 230684 */     // (strict_fma:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VFMADD132PDZ256m:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 230684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDZ256m),
     /* 230687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230689 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 230691 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 230693 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 230697 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 230702 */     GIR_RootConstrainSelectedInstOperands,
     /* 230703 */     // GIR_Coverage, 9670,
     /* 230703 */     GIR_EraseRootFromParent_Done,
     /* 230704 */   // Label 5301: @230704
     /* 230704 */   GIM_Try, /*On fail goto*//*Label 5302*/ GIMT_Encode4(230772), // Rule ID 23318 //
     /* 230709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 230712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 230716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 230720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 230724 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 230727 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 230731 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 230735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 230739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 230743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230745 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 230752 */     // (strict_fma:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADDPD4Ymr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 230752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4Ymr),
     /* 230755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230757 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 230759 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 230763 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 230765 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 230770 */     GIR_RootConstrainSelectedInstOperands,
     /* 230771 */     // GIR_Coverage, 23318,
     /* 230771 */     GIR_EraseRootFromParent_Done,
     /* 230772 */   // Label 5302: @230772
     /* 230772 */   GIM_Try, /*On fail goto*//*Label 5303*/ GIMT_Encode4(230840), // Rule ID 1197 //
     /* 230777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 230780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 230784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 230788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 230796 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 230799 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 230803 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 230807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 230811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230813 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 230820 */     // (strict_fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src2, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1)  =>  (VFMADD231PDYm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 230820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDYm),
     /* 230823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230825 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 230827 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 230829 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 230833 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 230838 */     GIR_RootConstrainSelectedInstOperands,
     /* 230839 */     // GIR_Coverage, 1197,
     /* 230839 */     GIR_EraseRootFromParent_Done,
     /* 230840 */   // Label 5303: @230840
     /* 230840 */   GIM_Try, /*On fail goto*//*Label 5304*/ GIMT_Encode4(230908), // Rule ID 1479 //
     /* 230845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 230848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 230852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 230856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 230864 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 230867 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 230871 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 230875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 230879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230881 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 230888 */     // (strict_fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADDPD4Ymr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 230888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4Ymr),
     /* 230891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230893 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 230895 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 230899 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 230901 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 230906 */     GIR_RootConstrainSelectedInstOperands,
     /* 230907 */     // GIR_Coverage, 1479,
     /* 230907 */     GIR_EraseRootFromParent_Done,
     /* 230908 */   // Label 5304: @230908
     /* 230908 */   GIM_Try, /*On fail goto*//*Label 5305*/ GIMT_Encode4(230976), // Rule ID 9130 //
     /* 230913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 230916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 230920 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 230924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 230932 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 230935 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 230939 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 230943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 230947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230949 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 230956 */     // (strict_fma:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src2, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4f64] }:$src1)  =>  (VFMADD231PDZ256m:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 230956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDZ256m),
     /* 230959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230961 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 230963 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 230965 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 230969 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 230974 */     GIR_RootConstrainSelectedInstOperands,
     /* 230975 */     // GIR_Coverage, 9130,
     /* 230975 */     GIR_EraseRootFromParent_Done,
     /* 230976 */   // Label 5305: @230976
     /* 230976 */   GIM_Try, /*On fail goto*//*Label 5306*/ GIMT_Encode4(231044), // Rule ID 1195 //
     /* 230981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 230984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 230988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 230992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 230996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 231000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 231004 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 231007 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 231011 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 231015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 231017 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 231024 */     // (strict_fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDYm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 231024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDYm),
     /* 231027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231029 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 231031 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 231033 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 231037 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 231042 */     GIR_RootConstrainSelectedInstOperands,
     /* 231043 */     // GIR_Coverage, 1195,
     /* 231043 */     GIR_EraseRootFromParent_Done,
     /* 231044 */   // Label 5306: @231044
     /* 231044 */   GIM_Try, /*On fail goto*//*Label 5307*/ GIMT_Encode4(231112), // Rule ID 1477 //
     /* 231049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 231052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 231068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 231072 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 231075 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 231079 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 231083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 231085 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 231092 */     // (strict_fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDPD4Yrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 231092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4Yrm),
     /* 231095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231097 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 231099 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 231101 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 231105 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 231110 */     GIR_RootConstrainSelectedInstOperands,
     /* 231111 */     // GIR_Coverage, 1477,
     /* 231111 */     GIR_EraseRootFromParent_Done,
     /* 231112 */   // Label 5307: @231112
     /* 231112 */   GIM_Try, /*On fail goto*//*Label 5308*/ GIMT_Encode4(231180), // Rule ID 8501 //
     /* 231117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 231120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 231124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 231128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 231132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 231136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 231140 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 231143 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 231147 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 231151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 231153 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 231160 */     // (strict_fma:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src2, VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDZ256m:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 231160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ256m),
     /* 231163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231165 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 231167 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 231169 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 231173 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 231178 */     GIR_RootConstrainSelectedInstOperands,
     /* 231179 */     // GIR_Coverage, 8501,
     /* 231179 */     GIR_EraseRootFromParent_Done,
     /* 231180 */   // Label 5308: @231180
     /* 231180 */   GIM_Try, /*On fail goto*//*Label 5309*/ GIMT_Encode4(231217), // Rule ID 1193 //
     /* 231185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 231188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231204 */     // (strict_fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADD213PDYr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 231204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDYr),
     /* 231207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231209 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 231211 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 231213 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 231215 */     GIR_RootConstrainSelectedInstOperands,
     /* 231216 */     // GIR_Coverage, 1193,
     /* 231216 */     GIR_EraseRootFromParent_Done,
     /* 231217 */   // Label 5309: @231217
     /* 231217 */   GIM_Try, /*On fail goto*//*Label 5310*/ GIMT_Encode4(231252), // Rule ID 1475 //
     /* 231222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 231225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231229 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231241 */     // (strict_fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADDPD4Yrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 231241 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4Yrr),
     /* 231246 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 231250 */     GIR_RootConstrainSelectedInstOperands,
     /* 231251 */     // GIR_Coverage, 1475,
     /* 231251 */     GIR_Done,
     /* 231252 */   // Label 5310: @231252
     /* 231252 */   GIM_Try, /*On fail goto*//*Label 5311*/ GIMT_Encode4(231289), // Rule ID 8497 //
     /* 231257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 231260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 231264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 231268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 231272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 231276 */     // (strict_fma:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src2, VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src3)  =>  (VFMADD213PDZ256r:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2, VR256X:{ *:[v4f64] }:$src3)
     /* 231276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ256r),
     /* 231279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231281 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 231283 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 231285 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 231287 */     GIR_RootConstrainSelectedInstOperands,
     /* 231288 */     // GIR_Coverage, 8497,
     /* 231288 */     GIR_EraseRootFromParent_Done,
     /* 231289 */   // Label 5311: @231289
     /* 231289 */   GIM_Reject,
     /* 231290 */ // Label 5299: @231290
     /* 231290 */ GIM_Reject,
     /* 231291 */ // Label 5235: @231291
     /* 231291 */ GIM_Try, /*On fail goto*//*Label 5312*/ GIMT_Encode4(231535),
     /* 231296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 231299 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 231302 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 231305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 231309 */   GIM_Try, /*On fail goto*//*Label 5313*/ GIMT_Encode4(231373), // Rule ID 9616 //
     /* 231314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 231317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 231321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 231325 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 231328 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 231332 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 231336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 231340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 231344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 231346 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 231353 */     // (strict_fma:{ *:[v8f16] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VFMADD132PHZ128m:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 231353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PHZ128m),
     /* 231356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231358 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 231360 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 231362 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 231366 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 231371 */     GIR_RootConstrainSelectedInstOperands,
     /* 231372 */     // GIR_Coverage, 9616,
     /* 231372 */     GIR_EraseRootFromParent_Done,
     /* 231373 */   // Label 5313: @231373
     /* 231373 */   GIM_Try, /*On fail goto*//*Label 5314*/ GIMT_Encode4(231437), // Rule ID 9076 //
     /* 231378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 231381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 231385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 231389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 231393 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 231396 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 231400 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 231404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 231408 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 231410 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 231417 */     // (strict_fma:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src2, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8f16] }:$src1)  =>  (VFMADD231PHZ128m:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 231417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PHZ128m),
     /* 231420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231422 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 231424 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 231426 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 231430 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 231435 */     GIR_RootConstrainSelectedInstOperands,
     /* 231436 */     // GIR_Coverage, 9076,
     /* 231436 */     GIR_EraseRootFromParent_Done,
     /* 231437 */   // Label 5314: @231437
     /* 231437 */   GIM_Try, /*On fail goto*//*Label 5315*/ GIMT_Encode4(231501), // Rule ID 8435 //
     /* 231442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 231445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 231449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 231453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 231457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 231461 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 231464 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 231468 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 231472 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 231474 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 231481 */     // (strict_fma:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src2, VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PHZ128m:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 231481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ128m),
     /* 231484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231486 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 231488 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 231490 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 231494 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 231499 */     GIR_RootConstrainSelectedInstOperands,
     /* 231500 */     // GIR_Coverage, 8435,
     /* 231500 */     GIR_EraseRootFromParent_Done,
     /* 231501 */   // Label 5315: @231501
     /* 231501 */   GIM_Try, /*On fail goto*//*Label 5316*/ GIMT_Encode4(231534), // Rule ID 8431 //
     /* 231506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 231509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 231513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 231517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 231521 */     // (strict_fma:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src2, VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src3)  =>  (VFMADD213PHZ128r:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2, VR128X:{ *:[v8f16] }:$src3)
     /* 231521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ128r),
     /* 231524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231526 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 231528 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 231530 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 231532 */     GIR_RootConstrainSelectedInstOperands,
     /* 231533 */     // GIR_Coverage, 8431,
     /* 231533 */     GIR_EraseRootFromParent_Done,
     /* 231534 */   // Label 5316: @231534
     /* 231534 */   GIM_Reject,
     /* 231535 */ // Label 5312: @231535
     /* 231535 */ GIM_Reject,
     /* 231536 */ // Label 5236: @231536
     /* 231536 */ GIM_Try, /*On fail goto*//*Label 5317*/ GIMT_Encode4(232272),
     /* 231541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 231544 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 231547 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 231550 */   GIM_Try, /*On fail goto*//*Label 5318*/ GIMT_Encode4(231618), // Rule ID 1151 //
     /* 231555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 231558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 231566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 231570 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 231573 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 231577 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 231581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 231591 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 231598 */     // (strict_fma:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VFMADD132PSYm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 231598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSYm),
     /* 231601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231603 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 231605 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 231607 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 231611 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 231616 */     GIR_RootConstrainSelectedInstOperands,
     /* 231617 */     // GIR_Coverage, 1151,
     /* 231617 */     GIR_EraseRootFromParent_Done,
     /* 231618 */   // Label 5318: @231618
     /* 231618 */   GIM_Try, /*On fail goto*//*Label 5319*/ GIMT_Encode4(231686), // Rule ID 9638 //
     /* 231623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 231626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 231630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 231634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 231638 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 231641 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 231645 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 231649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 231653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 231657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 231659 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 231666 */     // (strict_fma:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VFMADD132PSZ256m:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 231666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSZ256m),
     /* 231669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231671 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 231673 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 231675 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 231679 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 231684 */     GIR_RootConstrainSelectedInstOperands,
     /* 231685 */     // GIR_Coverage, 9638,
     /* 231685 */     GIR_EraseRootFromParent_Done,
     /* 231686 */   // Label 5319: @231686
     /* 231686 */   GIM_Try, /*On fail goto*//*Label 5320*/ GIMT_Encode4(231754), // Rule ID 23290 //
     /* 231691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 231694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 231702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 231706 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 231709 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 231713 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 231717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 231727 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 231734 */     // (strict_fma:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADDPS4Ymr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 231734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4Ymr),
     /* 231737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231739 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 231741 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 231745 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 231747 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 231752 */     GIR_RootConstrainSelectedInstOperands,
     /* 231753 */     // GIR_Coverage, 23290,
     /* 231753 */     GIR_EraseRootFromParent_Done,
     /* 231754 */   // Label 5320: @231754
     /* 231754 */   GIM_Try, /*On fail goto*//*Label 5321*/ GIMT_Encode4(231822), // Rule ID 1149 //
     /* 231759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 231762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 231774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 231778 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 231781 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 231785 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 231789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 231795 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 231802 */     // (strict_fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src2, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1)  =>  (VFMADD231PSYm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 231802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSYm),
     /* 231805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231807 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 231809 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 231811 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 231815 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 231820 */     GIR_RootConstrainSelectedInstOperands,
     /* 231821 */     // GIR_Coverage, 1149,
     /* 231821 */     GIR_EraseRootFromParent_Done,
     /* 231822 */   // Label 5321: @231822
     /* 231822 */   GIM_Try, /*On fail goto*//*Label 5322*/ GIMT_Encode4(231890), // Rule ID 1395 //
     /* 231827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 231830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 231842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 231846 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 231849 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 231853 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 231857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 231863 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 231870 */     // (strict_fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADDPS4Ymr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 231870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4Ymr),
     /* 231873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231875 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 231877 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 231881 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 231883 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 231888 */     GIR_RootConstrainSelectedInstOperands,
     /* 231889 */     // GIR_Coverage, 1395,
     /* 231889 */     GIR_EraseRootFromParent_Done,
     /* 231890 */   // Label 5322: @231890
     /* 231890 */   GIM_Try, /*On fail goto*//*Label 5323*/ GIMT_Encode4(231958), // Rule ID 9098 //
     /* 231895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 231898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 231902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 231906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 231910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 231914 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 231917 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 231921 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 231925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 231929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 231931 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 231938 */     // (strict_fma:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src2, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8f32] }:$src1)  =>  (VFMADD231PSZ256m:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 231938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSZ256m),
     /* 231941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231943 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 231945 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 231947 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 231951 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 231956 */     GIR_RootConstrainSelectedInstOperands,
     /* 231957 */     // GIR_Coverage, 9098,
     /* 231957 */     GIR_EraseRootFromParent_Done,
     /* 231958 */   // Label 5323: @231958
     /* 231958 */   GIM_Try, /*On fail goto*//*Label 5324*/ GIMT_Encode4(232026), // Rule ID 1147 //
     /* 231963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 231966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 231982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 231986 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 231989 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 231993 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 231997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 231999 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 232006 */     // (strict_fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSYm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 232006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSYm),
     /* 232009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232011 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 232013 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 232015 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 232019 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 232024 */     GIR_RootConstrainSelectedInstOperands,
     /* 232025 */     // GIR_Coverage, 1147,
     /* 232025 */     GIR_EraseRootFromParent_Done,
     /* 232026 */   // Label 5324: @232026
     /* 232026 */   GIM_Try, /*On fail goto*//*Label 5325*/ GIMT_Encode4(232094), // Rule ID 1393 //
     /* 232031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 232034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 232038 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 232042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 232046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 232050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 232054 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 232057 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 232061 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 232065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232067 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 232074 */     // (strict_fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDPS4Yrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 232074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4Yrm),
     /* 232077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232079 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 232081 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 232083 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 232087 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 232092 */     GIR_RootConstrainSelectedInstOperands,
     /* 232093 */     // GIR_Coverage, 1393,
     /* 232093 */     GIR_EraseRootFromParent_Done,
     /* 232094 */   // Label 5325: @232094
     /* 232094 */   GIM_Try, /*On fail goto*//*Label 5326*/ GIMT_Encode4(232162), // Rule ID 8462 //
     /* 232099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 232102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 232106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 232110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 232114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 232118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 232122 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 232125 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 232129 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 232133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232135 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 232142 */     // (strict_fma:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src2, VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSZ256m:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 232142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ256m),
     /* 232145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232147 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 232149 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 232151 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 232155 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 232160 */     GIR_RootConstrainSelectedInstOperands,
     /* 232161 */     // GIR_Coverage, 8462,
     /* 232161 */     GIR_EraseRootFromParent_Done,
     /* 232162 */   // Label 5326: @232162
     /* 232162 */   GIM_Try, /*On fail goto*//*Label 5327*/ GIMT_Encode4(232199), // Rule ID 1145 //
     /* 232167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 232170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 232174 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 232178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 232182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 232186 */     // (strict_fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADD213PSYr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 232186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSYr),
     /* 232189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232191 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 232193 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 232195 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 232197 */     GIR_RootConstrainSelectedInstOperands,
     /* 232198 */     // GIR_Coverage, 1145,
     /* 232198 */     GIR_EraseRootFromParent_Done,
     /* 232199 */   // Label 5327: @232199
     /* 232199 */   GIM_Try, /*On fail goto*//*Label 5328*/ GIMT_Encode4(232234), // Rule ID 1391 //
     /* 232204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 232207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 232211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 232215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 232219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 232223 */     // (strict_fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADDPS4Yrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 232223 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4Yrr),
     /* 232228 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 232232 */     GIR_RootConstrainSelectedInstOperands,
     /* 232233 */     // GIR_Coverage, 1391,
     /* 232233 */     GIR_Done,
     /* 232234 */   // Label 5328: @232234
     /* 232234 */   GIM_Try, /*On fail goto*//*Label 5329*/ GIMT_Encode4(232271), // Rule ID 8458 //
     /* 232239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 232242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 232246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 232250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 232254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 232258 */     // (strict_fma:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src2, VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src3)  =>  (VFMADD213PSZ256r:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2, VR256X:{ *:[v8f32] }:$src3)
     /* 232258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ256r),
     /* 232261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232263 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 232265 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 232267 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 232269 */     GIR_RootConstrainSelectedInstOperands,
     /* 232270 */     // GIR_Coverage, 8458,
     /* 232270 */     GIR_EraseRootFromParent_Done,
     /* 232271 */   // Label 5329: @232271
     /* 232271 */   GIM_Reject,
     /* 232272 */ // Label 5317: @232272
     /* 232272 */ GIM_Reject,
     /* 232273 */ // Label 5237: @232273
     /* 232273 */ GIM_Try, /*On fail goto*//*Label 5330*/ GIMT_Encode4(232517),
     /* 232278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 232281 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 232284 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /* 232287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232291 */   GIM_Try, /*On fail goto*//*Label 5331*/ GIMT_Encode4(232355), // Rule ID 9658 //
     /* 232296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 232299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 232303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 232307 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 232310 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 232314 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 232318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232328 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 232335 */     // (strict_fma:{ *:[v8f64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VFMADD132PDZm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 232335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDZm),
     /* 232338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232340 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 232342 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 232344 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 232348 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 232353 */     GIR_RootConstrainSelectedInstOperands,
     /* 232354 */     // GIR_Coverage, 9658,
     /* 232354 */     GIR_EraseRootFromParent_Done,
     /* 232355 */   // Label 5331: @232355
     /* 232355 */   GIM_Try, /*On fail goto*//*Label 5332*/ GIMT_Encode4(232419), // Rule ID 9118 //
     /* 232360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 232363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 232371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 232375 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 232378 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 232382 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 232386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232392 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 232399 */     // (strict_fma:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src2, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8f64] }:$src1)  =>  (VFMADD231PDZm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 232399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDZm),
     /* 232402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232404 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 232406 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 232408 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 232412 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 232417 */     GIR_RootConstrainSelectedInstOperands,
     /* 232418 */     // GIR_Coverage, 9118,
     /* 232418 */     GIR_EraseRootFromParent_Done,
     /* 232419 */   // Label 5332: @232419
     /* 232419 */   GIM_Try, /*On fail goto*//*Label 5333*/ GIMT_Encode4(232483), // Rule ID 8486 //
     /* 232424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 232427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 232439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 232443 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 232446 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 232450 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 232454 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232456 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 232463 */     // (strict_fma:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src2, VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDZm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 232463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZm),
     /* 232466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232468 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 232470 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 232472 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 232476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 232481 */     GIR_RootConstrainSelectedInstOperands,
     /* 232482 */     // GIR_Coverage, 8486,
     /* 232482 */     GIR_EraseRootFromParent_Done,
     /* 232483 */   // Label 5333: @232483
     /* 232483 */   GIM_Try, /*On fail goto*//*Label 5334*/ GIMT_Encode4(232516), // Rule ID 8482 //
     /* 232488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 232491 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232503 */     // (strict_fma:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src2, VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src3)  =>  (VFMADD213PDZr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2, VR512:{ *:[v8f64] }:$src3)
     /* 232503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZr),
     /* 232506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232508 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 232510 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 232512 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 232514 */     GIR_RootConstrainSelectedInstOperands,
     /* 232515 */     // GIR_Coverage, 8482,
     /* 232515 */     GIR_EraseRootFromParent_Done,
     /* 232516 */   // Label 5334: @232516
     /* 232516 */   GIM_Reject,
     /* 232517 */ // Label 5330: @232517
     /* 232517 */ GIM_Reject,
     /* 232518 */ // Label 5238: @232518
     /* 232518 */ GIM_Try, /*On fail goto*//*Label 5335*/ GIMT_Encode4(232762),
     /* 232523 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 232526 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 232529 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 232532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 232536 */   GIM_Try, /*On fail goto*//*Label 5336*/ GIMT_Encode4(232600), // Rule ID 9606 //
     /* 232541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 232544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 232548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 232552 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 232555 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 232559 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 232563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 232567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 232571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232573 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 232580 */     // (strict_fma:{ *:[v16f16] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VFMADD132PHZ256m:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 232580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PHZ256m),
     /* 232583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232585 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 232587 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 232589 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 232593 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 232598 */     GIR_RootConstrainSelectedInstOperands,
     /* 232599 */     // GIR_Coverage, 9606,
     /* 232599 */     GIR_EraseRootFromParent_Done,
     /* 232600 */   // Label 5336: @232600
     /* 232600 */   GIM_Try, /*On fail goto*//*Label 5337*/ GIMT_Encode4(232664), // Rule ID 9066 //
     /* 232605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 232608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 232612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 232616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 232620 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 232623 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 232627 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 232631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 232635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232637 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 232644 */     // (strict_fma:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src2, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16f16] }:$src1)  =>  (VFMADD231PHZ256m:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 232644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PHZ256m),
     /* 232647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232649 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 232651 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 232653 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 232657 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 232662 */     GIR_RootConstrainSelectedInstOperands,
     /* 232663 */     // GIR_Coverage, 9066,
     /* 232663 */     GIR_EraseRootFromParent_Done,
     /* 232664 */   // Label 5337: @232664
     /* 232664 */   GIM_Try, /*On fail goto*//*Label 5338*/ GIMT_Encode4(232728), // Rule ID 8423 //
     /* 232669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 232672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 232676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 232680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 232684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 232688 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 232691 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 232695 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 232699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232701 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 232708 */     // (strict_fma:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src2, VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PHZ256m:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 232708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ256m),
     /* 232711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232713 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 232715 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 232717 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 232721 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 232726 */     GIR_RootConstrainSelectedInstOperands,
     /* 232727 */     // GIR_Coverage, 8423,
     /* 232727 */     GIR_EraseRootFromParent_Done,
     /* 232728 */   // Label 5338: @232728
     /* 232728 */   GIM_Try, /*On fail goto*//*Label 5339*/ GIMT_Encode4(232761), // Rule ID 8419 //
     /* 232733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 232736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 232740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 232744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 232748 */     // (strict_fma:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src2, VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src3)  =>  (VFMADD213PHZ256r:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2, VR256X:{ *:[v16f16] }:$src3)
     /* 232748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ256r),
     /* 232751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232753 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 232755 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 232757 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 232759 */     GIR_RootConstrainSelectedInstOperands,
     /* 232760 */     // GIR_Coverage, 8419,
     /* 232760 */     GIR_EraseRootFromParent_Done,
     /* 232761 */   // Label 5339: @232761
     /* 232761 */   GIM_Reject,
     /* 232762 */ // Label 5335: @232762
     /* 232762 */ GIM_Reject,
     /* 232763 */ // Label 5239: @232763
     /* 232763 */ GIM_Try, /*On fail goto*//*Label 5340*/ GIMT_Encode4(233007),
     /* 232768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 232771 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 232774 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /* 232777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232781 */   GIM_Try, /*On fail goto*//*Label 5341*/ GIMT_Encode4(232845), // Rule ID 9626 //
     /* 232786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 232789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 232793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 232797 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 232800 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 232804 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 232808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232816 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232818 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 232825 */     // (strict_fma:{ *:[v16f32] } (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VFMADD132PSZm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 232825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSZm),
     /* 232828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232830 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 232832 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 232834 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 232838 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 232843 */     GIR_RootConstrainSelectedInstOperands,
     /* 232844 */     // GIR_Coverage, 9626,
     /* 232844 */     GIR_EraseRootFromParent_Done,
     /* 232845 */   // Label 5341: @232845
     /* 232845 */   GIM_Try, /*On fail goto*//*Label 5342*/ GIMT_Encode4(232909), // Rule ID 9086 //
     /* 232850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 232853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 232861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 232865 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 232868 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 232872 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 232876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232882 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 232889 */     // (strict_fma:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src2, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16f32] }:$src1)  =>  (VFMADD231PSZm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 232889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSZm),
     /* 232892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232894 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 232896 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 232898 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 232902 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 232907 */     GIR_RootConstrainSelectedInstOperands,
     /* 232908 */     // GIR_Coverage, 9086,
     /* 232908 */     GIR_EraseRootFromParent_Done,
     /* 232909 */   // Label 5342: @232909
     /* 232909 */   GIM_Try, /*On fail goto*//*Label 5343*/ GIMT_Encode4(232973), // Rule ID 8447 //
     /* 232914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 232917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 232929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 232933 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 232936 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 232940 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 232944 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232946 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 232953 */     // (strict_fma:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src2, VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSZm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 232953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZm),
     /* 232956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232958 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 232960 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 232962 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 232966 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 232971 */     GIR_RootConstrainSelectedInstOperands,
     /* 232972 */     // GIR_Coverage, 8447,
     /* 232972 */     GIR_EraseRootFromParent_Done,
     /* 232973 */   // Label 5343: @232973
     /* 232973 */   GIM_Try, /*On fail goto*//*Label 5344*/ GIMT_Encode4(233006), // Rule ID 8443 //
     /* 232978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 232981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232993 */     // (strict_fma:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src2, VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src3)  =>  (VFMADD213PSZr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2, VR512:{ *:[v16f32] }:$src3)
     /* 232993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZr),
     /* 232996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232998 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 233000 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 233002 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 233004 */     GIR_RootConstrainSelectedInstOperands,
     /* 233005 */     // GIR_Coverage, 8443,
     /* 233005 */     GIR_EraseRootFromParent_Done,
     /* 233006 */   // Label 5344: @233006
     /* 233006 */   GIM_Reject,
     /* 233007 */ // Label 5340: @233007
     /* 233007 */ GIM_Reject,
     /* 233008 */ // Label 5240: @233008
     /* 233008 */ GIM_Try, /*On fail goto*//*Label 5345*/ GIMT_Encode4(233252),
     /* 233013 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 233016 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 233019 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s16,
     /* 233022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 233026 */   GIM_Try, /*On fail goto*//*Label 5346*/ GIMT_Encode4(233090), // Rule ID 9594 //
     /* 233031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 233034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 233038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 233042 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 233045 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 233049 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 233053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 233057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 233061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 233063 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 233070 */     // (strict_fma:{ *:[v32f16] } (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VFMADD132PHZm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 233070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PHZm),
     /* 233073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233075 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 233077 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 233079 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 233083 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 233088 */     GIR_RootConstrainSelectedInstOperands,
     /* 233089 */     // GIR_Coverage, 9594,
     /* 233089 */     GIR_EraseRootFromParent_Done,
     /* 233090 */   // Label 5346: @233090
     /* 233090 */   GIM_Try, /*On fail goto*//*Label 5347*/ GIMT_Encode4(233154), // Rule ID 9054 //
     /* 233095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 233098 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 233102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 233106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 233110 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 233113 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 233117 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 233121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 233125 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 233127 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 233134 */     // (strict_fma:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src2, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32f16] }:$src1)  =>  (VFMADD231PHZm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 233134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PHZm),
     /* 233137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233139 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 233141 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 233143 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 233147 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 233152 */     GIR_RootConstrainSelectedInstOperands,
     /* 233153 */     // GIR_Coverage, 9054,
     /* 233153 */     GIR_EraseRootFromParent_Done,
     /* 233154 */   // Label 5347: @233154
     /* 233154 */   GIM_Try, /*On fail goto*//*Label 5348*/ GIMT_Encode4(233218), // Rule ID 8408 //
     /* 233159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 233162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 233166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 233170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 233174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 233178 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 233181 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 233185 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 233189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 233191 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 233198 */     // (strict_fma:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src2, VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PHZm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 233198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZm),
     /* 233201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233203 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 233205 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 233207 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 233211 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 233216 */     GIR_RootConstrainSelectedInstOperands,
     /* 233217 */     // GIR_Coverage, 8408,
     /* 233217 */     GIR_EraseRootFromParent_Done,
     /* 233218 */   // Label 5348: @233218
     /* 233218 */   GIM_Try, /*On fail goto*//*Label 5349*/ GIMT_Encode4(233251), // Rule ID 8404 //
     /* 233223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 233226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 233230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 233234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 233238 */     // (strict_fma:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src2, VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src3)  =>  (VFMADD213PHZr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2, VR512:{ *:[v32f16] }:$src3)
     /* 233238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZr),
     /* 233241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233243 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 233245 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 233247 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 233249 */     GIR_RootConstrainSelectedInstOperands,
     /* 233250 */     // GIR_Coverage, 8404,
     /* 233250 */     GIR_EraseRootFromParent_Done,
     /* 233251 */   // Label 5349: @233251
     /* 233251 */   GIM_Reject,
     /* 233252 */ // Label 5345: @233252
     /* 233252 */ GIM_Reject,
     /* 233253 */ // Label 5241: @233253
     /* 233253 */ GIM_Reject,
     /* 233254 */ // Label 73: @233254
     /* 233254 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 5363*/ GIMT_Encode4(235422),
     /* 233265 */ /*GILLT_s16*//*Label 5350*/ GIMT_Encode4(233349),
     /* 233269 */ /*GILLT_s32*//*Label 5351*/ GIMT_Encode4(233470),
     /* 233273 */ /*GILLT_s64*//*Label 5352*/ GIMT_Encode4(233826),
     /* 233277 */ /*GILLT_s80*//*Label 5353*/ GIMT_Encode4(234182), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 233289 */ /*GILLT_v2s64*//*Label 5354*/ GIMT_Encode4(234219), GIMT_Encode4(0),
     /* 233297 */ /*GILLT_v4s32*//*Label 5355*/ GIMT_Encode4(234422),
     /* 233301 */ /*GILLT_v4s64*//*Label 5356*/ GIMT_Encode4(234625), GIMT_Encode4(0),
     /* 233309 */ /*GILLT_v8s16*//*Label 5357*/ GIMT_Encode4(234801),
     /* 233313 */ /*GILLT_v8s32*//*Label 5358*/ GIMT_Encode4(234890),
     /* 233317 */ /*GILLT_v8s64*//*Label 5359*/ GIMT_Encode4(235066), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 233329 */ /*GILLT_v16s16*//*Label 5360*/ GIMT_Encode4(235155),
     /* 233333 */ /*GILLT_v16s32*//*Label 5361*/ GIMT_Encode4(235244), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 233345 */ /*GILLT_v32s16*//*Label 5362*/ GIMT_Encode4(235333),
     /* 233349 */ // Label 5350: @233349
     /* 233349 */ GIM_Try, /*On fail goto*//*Label 5364*/ GIMT_Encode4(233469),
     /* 233354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 233357 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 233361 */   GIM_Try, /*On fail goto*//*Label 5365*/ GIMT_Encode4(233430), // Rule ID 21420 //
     /* 233366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_OptForSize),
     /* 233369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 233373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 233377 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 233380 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 233384 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 233388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 233390 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 233397 */     // (strict_fsqrt:{ *:[f16] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSHZm:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), addr:{ *:[iPTR] }:$src)
     /* 233397 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 233400 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 233404 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 233409 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 233411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSHZm),
     /* 233414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233416 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 233419 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 233423 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 233428 */     GIR_RootConstrainSelectedInstOperands,
     /* 233429 */     // GIR_Coverage, 21420,
     /* 233429 */     GIR_EraseRootFromParent_Done,
     /* 233430 */   // Label 5365: @233430
     /* 233430 */   GIM_Try, /*On fail goto*//*Label 5366*/ GIMT_Encode4(233468), // Rule ID 21418 //
     /* 233435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 233438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 233442 */     // (strict_fsqrt:{ *:[f16] } FR16X:{ *:[f16] }:$src)  =>  (VSQRTSHZr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), FR16X:{ *:[f16] }:$src)
     /* 233442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 233445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 233449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 233454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 233456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSHZr),
     /* 233459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 233464 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 233466 */     GIR_RootConstrainSelectedInstOperands,
     /* 233467 */     // GIR_Coverage, 21418,
     /* 233467 */     GIR_EraseRootFromParent_Done,
     /* 233468 */   // Label 5366: @233468
     /* 233468 */   GIM_Reject,
     /* 233469 */ // Label 5364: @233469
     /* 233469 */ GIM_Reject,
     /* 233470 */ // Label 5351: @233470
     /* 233470 */ GIM_Try, /*On fail goto*//*Label 5367*/ GIMT_Encode4(233825),
     /* 233475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 233478 */   GIM_Try, /*On fail goto*//*Label 5368*/ GIMT_Encode4(233534), // Rule ID 2448 //
     /* 233483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseSSE1),
     /* 233486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 233490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 233494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 233498 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 233501 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 233505 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 233509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 233511 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 233518 */     // (strict_fsqrt:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SQRTSSm:{ *:[f32] } addr:{ *:[iPTR] }:$src1)
     /* 233518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SQRTSSm),
     /* 233521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233523 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 233527 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 233532 */     GIR_RootConstrainSelectedInstOperands,
     /* 233533 */     // GIR_Coverage, 2448,
     /* 233533 */     GIR_EraseRootFromParent_Done,
     /* 233534 */   // Label 5368: @233534
     /* 233534 */   GIM_Try, /*On fail goto*//*Label 5369*/ GIMT_Encode4(233607), // Rule ID 18276 //
     /* 233539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseAVX),
     /* 233542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 233546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 233550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 233554 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 233557 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 233561 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 233565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 233567 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 233574 */     // (strict_fsqrt:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSSm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 233574 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 233577 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 233581 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 233586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 233588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSm),
     /* 233591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 233596 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 233600 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 233605 */     GIR_RootConstrainSelectedInstOperands,
     /* 233606 */     // GIR_Coverage, 18276,
     /* 233606 */     GIR_EraseRootFromParent_Done,
     /* 233607 */   // Label 5369: @233607
     /* 233607 */   GIM_Try, /*On fail goto*//*Label 5370*/ GIMT_Encode4(233680), // Rule ID 21424 //
     /* 233612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_OptForSize),
     /* 233615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 233619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 233623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 233627 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 233630 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 233634 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 233638 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 233640 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 233647 */     // (strict_fsqrt:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSSZm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 233647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 233650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 233654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 233659 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 233661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSZm),
     /* 233664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233666 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 233669 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 233673 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 233678 */     GIR_RootConstrainSelectedInstOperands,
     /* 233679 */     // GIR_Coverage, 21424,
     /* 233679 */     GIR_EraseRootFromParent_Done,
     /* 233680 */   // Label 5370: @233680
     /* 233680 */   GIM_Try, /*On fail goto*//*Label 5371*/ GIMT_Encode4(233713), // Rule ID 1048 //
     /* 233685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 233688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 233692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 233696 */     // (strict_fsqrt:{ *:[f32] } RFP32:{ *:[f32] }:$src)  =>  (SQRT_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src)
     /* 233696 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRT_Fp32),
     /* 233701 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 233707 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 233711 */     GIR_RootConstrainSelectedInstOperands,
     /* 233712 */     // GIR_Coverage, 1048,
     /* 233712 */     GIR_Done,
     /* 233713 */   // Label 5371: @233713
     /* 233713 */   GIM_Try, /*On fail goto*//*Label 5372*/ GIMT_Encode4(233740), // Rule ID 2446 //
     /* 233718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 233721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 233725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 233729 */     // (strict_fsqrt:{ *:[f32] } FR32:{ *:[f32] }:$src1)  =>  (SQRTSSr:{ *:[f32] } FR32:{ *:[f32] }:$src1)
     /* 233729 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTSSr),
     /* 233734 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 233738 */     GIR_RootConstrainSelectedInstOperands,
     /* 233739 */     // GIR_Coverage, 2446,
     /* 233739 */     GIR_Done,
     /* 233740 */   // Label 5372: @233740
     /* 233740 */   GIM_Try, /*On fail goto*//*Label 5373*/ GIMT_Encode4(233782), // Rule ID 18274 //
     /* 233745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 233748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 233752 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 233756 */     // (strict_fsqrt:{ *:[f32] } FR32:{ *:[f32] }:$src)  =>  (VSQRTSSr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR32:{ *:[f32] }:$src)
     /* 233756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 233759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 233763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 233768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 233770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSr),
     /* 233773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 233778 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 233780 */     GIR_RootConstrainSelectedInstOperands,
     /* 233781 */     // GIR_Coverage, 18274,
     /* 233781 */     GIR_EraseRootFromParent_Done,
     /* 233782 */   // Label 5373: @233782
     /* 233782 */   GIM_Try, /*On fail goto*//*Label 5374*/ GIMT_Encode4(233824), // Rule ID 21422 //
     /* 233787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 233790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 233794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 233798 */     // (strict_fsqrt:{ *:[f32] } FR32X:{ *:[f32] }:$src)  =>  (VSQRTSSZr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR32X:{ *:[f32] }:$src)
     /* 233798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 233801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 233805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 233810 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 233812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSZr),
     /* 233815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233817 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 233820 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 233822 */     GIR_RootConstrainSelectedInstOperands,
     /* 233823 */     // GIR_Coverage, 21422,
     /* 233823 */     GIR_EraseRootFromParent_Done,
     /* 233824 */   // Label 5374: @233824
     /* 233824 */   GIM_Reject,
     /* 233825 */ // Label 5367: @233825
     /* 233825 */ GIM_Reject,
     /* 233826 */ // Label 5352: @233826
     /* 233826 */ GIM_Try, /*On fail goto*//*Label 5375*/ GIMT_Encode4(234181),
     /* 233831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 233834 */   GIM_Try, /*On fail goto*//*Label 5376*/ GIMT_Encode4(233890), // Rule ID 2464 //
     /* 233839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseSSE2),
     /* 233842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 233846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 233850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 233854 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 233857 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 233861 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 233865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 233867 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 233874 */     // (strict_fsqrt:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SQRTSDm:{ *:[f64] } addr:{ *:[iPTR] }:$src1)
     /* 233874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SQRTSDm),
     /* 233877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233879 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 233883 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 233888 */     GIR_RootConstrainSelectedInstOperands,
     /* 233889 */     // GIR_Coverage, 2464,
     /* 233889 */     GIR_EraseRootFromParent_Done,
     /* 233890 */   // Label 5376: @233890
     /* 233890 */   GIM_Try, /*On fail goto*//*Label 5377*/ GIMT_Encode4(233963), // Rule ID 18280 //
     /* 233895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseAVX),
     /* 233898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 233902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 233906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 233910 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 233913 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 233917 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 233921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 233923 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 233930 */     // (strict_fsqrt:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSDm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 233930 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 233933 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 233937 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 233942 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 233944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDm),
     /* 233947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233949 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 233952 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 233956 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 233961 */     GIR_RootConstrainSelectedInstOperands,
     /* 233962 */     // GIR_Coverage, 18280,
     /* 233962 */     GIR_EraseRootFromParent_Done,
     /* 233963 */   // Label 5377: @233963
     /* 233963 */   GIM_Try, /*On fail goto*//*Label 5378*/ GIMT_Encode4(234036), // Rule ID 21428 //
     /* 233968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_OptForSize),
     /* 233971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 233975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 233979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 233983 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 233986 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 233990 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 233994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 233996 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 234003 */     // (strict_fsqrt:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSDZm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 234003 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 234006 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 234010 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 234015 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 234017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDZm),
     /* 234020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234022 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 234025 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 234029 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 234034 */     GIR_RootConstrainSelectedInstOperands,
     /* 234035 */     // GIR_Coverage, 21428,
     /* 234035 */     GIR_EraseRootFromParent_Done,
     /* 234036 */   // Label 5378: @234036
     /* 234036 */   GIM_Try, /*On fail goto*//*Label 5379*/ GIMT_Encode4(234069), // Rule ID 1050 //
     /* 234041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 234044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 234048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 234052 */     // (strict_fsqrt:{ *:[f64] } RFP64:{ *:[f64] }:$src)  =>  (SQRT_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src)
     /* 234052 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRT_Fp64),
     /* 234057 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 234063 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 234067 */     GIR_RootConstrainSelectedInstOperands,
     /* 234068 */     // GIR_Coverage, 1050,
     /* 234068 */     GIR_Done,
     /* 234069 */   // Label 5379: @234069
     /* 234069 */   GIM_Try, /*On fail goto*//*Label 5380*/ GIMT_Encode4(234096), // Rule ID 2462 //
     /* 234074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 234077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 234081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 234085 */     // (strict_fsqrt:{ *:[f64] } FR64:{ *:[f64] }:$src1)  =>  (SQRTSDr:{ *:[f64] } FR64:{ *:[f64] }:$src1)
     /* 234085 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTSDr),
     /* 234090 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 234094 */     GIR_RootConstrainSelectedInstOperands,
     /* 234095 */     // GIR_Coverage, 2462,
     /* 234095 */     GIR_Done,
     /* 234096 */   // Label 5380: @234096
     /* 234096 */   GIM_Try, /*On fail goto*//*Label 5381*/ GIMT_Encode4(234138), // Rule ID 18278 //
     /* 234101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 234104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 234108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 234112 */     // (strict_fsqrt:{ *:[f64] } FR64:{ *:[f64] }:$src)  =>  (VSQRTSDr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR64:{ *:[f64] }:$src)
     /* 234112 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 234115 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 234119 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 234124 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 234126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDr),
     /* 234129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234131 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 234134 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 234136 */     GIR_RootConstrainSelectedInstOperands,
     /* 234137 */     // GIR_Coverage, 18278,
     /* 234137 */     GIR_EraseRootFromParent_Done,
     /* 234138 */   // Label 5381: @234138
     /* 234138 */   GIM_Try, /*On fail goto*//*Label 5382*/ GIMT_Encode4(234180), // Rule ID 21426 //
     /* 234143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 234146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 234150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 234154 */     // (strict_fsqrt:{ *:[f64] } FR64X:{ *:[f64] }:$src)  =>  (VSQRTSDZr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR64X:{ *:[f64] }:$src)
     /* 234154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 234157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 234161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 234166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 234168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDZr),
     /* 234171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 234176 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 234178 */     GIR_RootConstrainSelectedInstOperands,
     /* 234179 */     // GIR_Coverage, 21426,
     /* 234179 */     GIR_EraseRootFromParent_Done,
     /* 234180 */   // Label 5382: @234180
     /* 234180 */   GIM_Reject,
     /* 234181 */ // Label 5375: @234181
     /* 234181 */ GIM_Reject,
     /* 234182 */ // Label 5353: @234182
     /* 234182 */ GIM_Try, /*On fail goto*//*Label 5383*/ GIMT_Encode4(234218), // Rule ID 1052 //
     /* 234187 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 234190 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 234193 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 234197 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 234201 */   // (strict_fsqrt:{ *:[f80] } RFP80:{ *:[f80] }:$src)  =>  (SQRT_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src)
     /* 234201 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRT_Fp80),
     /* 234206 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 234212 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 234216 */   GIR_RootConstrainSelectedInstOperands,
     /* 234217 */   // GIR_Coverage, 1052,
     /* 234217 */   GIR_Done,
     /* 234218 */ // Label 5383: @234218
     /* 234218 */ GIM_Reject,
     /* 234219 */ // Label 5354: @234219
     /* 234219 */ GIM_Try, /*On fail goto*//*Label 5384*/ GIMT_Encode4(234421),
     /* 234224 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 234227 */   GIM_Try, /*On fail goto*//*Label 5385*/ GIMT_Encode4(234283), // Rule ID 2468 //
     /* 234232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 234235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 234239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 234243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 234247 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 234250 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 234254 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 234258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 234260 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 234267 */     // (strict_fsqrt:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /* 234267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDm),
     /* 234270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234272 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 234276 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 234281 */     GIR_RootConstrainSelectedInstOperands,
     /* 234282 */     // GIR_Coverage, 2468,
     /* 234282 */     GIR_EraseRootFromParent_Done,
     /* 234283 */   // Label 5385: @234283
     /* 234283 */   GIM_Try, /*On fail goto*//*Label 5386*/ GIMT_Encode4(234339), // Rule ID 12086 //
     /* 234288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 234291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 234295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 234299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 234303 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 234306 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 234310 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 234314 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 234316 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 234323 */     // (strict_fsqrt:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDZ128m:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /* 234323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ128m),
     /* 234326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234328 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 234332 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 234337 */     GIR_RootConstrainSelectedInstOperands,
     /* 234338 */     // GIR_Coverage, 12086,
     /* 234338 */     GIR_EraseRootFromParent_Done,
     /* 234339 */   // Label 5386: @234339
     /* 234339 */   GIM_Try, /*On fail goto*//*Label 5387*/ GIMT_Encode4(234366), // Rule ID 2466 //
     /* 234344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 234347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 234351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 234355 */     // (strict_fsqrt:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)  =>  (VSQRTPDr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)
     /* 234355 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDr),
     /* 234360 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 234364 */     GIR_RootConstrainSelectedInstOperands,
     /* 234365 */     // GIR_Coverage, 2466,
     /* 234365 */     GIR_Done,
     /* 234366 */   // Label 5387: @234366
     /* 234366 */   GIM_Try, /*On fail goto*//*Label 5388*/ GIMT_Encode4(234393), // Rule ID 2474 //
     /* 234371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 234374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 234378 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 234382 */     // (strict_fsqrt:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)  =>  (SQRTPDr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)
     /* 234382 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTPDr),
     /* 234387 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 234391 */     GIR_RootConstrainSelectedInstOperands,
     /* 234392 */     // GIR_Coverage, 2474,
     /* 234392 */     GIR_Done,
     /* 234393 */   // Label 5388: @234393
     /* 234393 */   GIM_Try, /*On fail goto*//*Label 5389*/ GIMT_Encode4(234420), // Rule ID 12082 //
     /* 234398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 234401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 234405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 234409 */     // (strict_fsqrt:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src)  =>  (VSQRTPDZ128r:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src)
     /* 234409 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ128r),
     /* 234414 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 234418 */     GIR_RootConstrainSelectedInstOperands,
     /* 234419 */     // GIR_Coverage, 12082,
     /* 234419 */     GIR_Done,
     /* 234420 */   // Label 5389: @234420
     /* 234420 */   GIM_Reject,
     /* 234421 */ // Label 5384: @234421
     /* 234421 */ GIM_Reject,
     /* 234422 */ // Label 5355: @234422
     /* 234422 */ GIM_Try, /*On fail goto*//*Label 5390*/ GIMT_Encode4(234624),
     /* 234427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 234430 */   GIM_Try, /*On fail goto*//*Label 5391*/ GIMT_Encode4(234486), // Rule ID 2452 //
     /* 234435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 234438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 234442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 234446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 234450 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 234453 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 234457 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 234461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 234463 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 234470 */     // (strict_fsqrt:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 234470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSm),
     /* 234473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234475 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 234479 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 234484 */     GIR_RootConstrainSelectedInstOperands,
     /* 234485 */     // GIR_Coverage, 2452,
     /* 234485 */     GIR_EraseRootFromParent_Done,
     /* 234486 */   // Label 5391: @234486
     /* 234486 */   GIM_Try, /*On fail goto*//*Label 5392*/ GIMT_Encode4(234542), // Rule ID 12062 //
     /* 234491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 234494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 234498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 234502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 234506 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 234509 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 234513 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 234517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 234519 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 234526 */     // (strict_fsqrt:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSZ128m:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 234526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ128m),
     /* 234529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234531 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 234535 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 234540 */     GIR_RootConstrainSelectedInstOperands,
     /* 234541 */     // GIR_Coverage, 12062,
     /* 234541 */     GIR_EraseRootFromParent_Done,
     /* 234542 */   // Label 5392: @234542
     /* 234542 */   GIM_Try, /*On fail goto*//*Label 5393*/ GIMT_Encode4(234569), // Rule ID 2450 //
     /* 234547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 234550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 234554 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 234558 */     // (strict_fsqrt:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)  =>  (VSQRTPSr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)
     /* 234558 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSr),
     /* 234563 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 234567 */     GIR_RootConstrainSelectedInstOperands,
     /* 234568 */     // GIR_Coverage, 2450,
     /* 234568 */     GIR_Done,
     /* 234569 */   // Label 5393: @234569
     /* 234569 */   GIM_Try, /*On fail goto*//*Label 5394*/ GIMT_Encode4(234596), // Rule ID 2458 //
     /* 234574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 234577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 234581 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 234585 */     // (strict_fsqrt:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)  =>  (SQRTPSr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)
     /* 234585 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTPSr),
     /* 234590 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 234594 */     GIR_RootConstrainSelectedInstOperands,
     /* 234595 */     // GIR_Coverage, 2458,
     /* 234595 */     GIR_Done,
     /* 234596 */   // Label 5394: @234596
     /* 234596 */   GIM_Try, /*On fail goto*//*Label 5395*/ GIMT_Encode4(234623), // Rule ID 12058 //
     /* 234601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 234604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 234608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 234612 */     // (strict_fsqrt:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src)  =>  (VSQRTPSZ128r:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src)
     /* 234612 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ128r),
     /* 234617 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 234621 */     GIR_RootConstrainSelectedInstOperands,
     /* 234622 */     // GIR_Coverage, 12058,
     /* 234622 */     GIR_Done,
     /* 234623 */   // Label 5395: @234623
     /* 234623 */   GIM_Reject,
     /* 234624 */ // Label 5390: @234624
     /* 234624 */ GIM_Reject,
     /* 234625 */ // Label 5356: @234625
     /* 234625 */ GIM_Try, /*On fail goto*//*Label 5396*/ GIMT_Encode4(234800),
     /* 234630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 234633 */   GIM_Try, /*On fail goto*//*Label 5397*/ GIMT_Encode4(234689), // Rule ID 2472 //
     /* 234638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 234641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 234645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 234649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 234653 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 234656 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 234660 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 234664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 234666 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 234673 */     // (strict_fsqrt:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDYm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /* 234673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDYm),
     /* 234676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234678 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 234682 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 234687 */     GIR_RootConstrainSelectedInstOperands,
     /* 234688 */     // GIR_Coverage, 2472,
     /* 234688 */     GIR_EraseRootFromParent_Done,
     /* 234689 */   // Label 5397: @234689
     /* 234689 */   GIM_Try, /*On fail goto*//*Label 5398*/ GIMT_Encode4(234745), // Rule ID 12098 //
     /* 234694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 234697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 234701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 234705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 234709 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 234712 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 234716 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 234720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 234722 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 234729 */     // (strict_fsqrt:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDZ256m:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /* 234729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ256m),
     /* 234732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234734 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 234738 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 234743 */     GIR_RootConstrainSelectedInstOperands,
     /* 234744 */     // GIR_Coverage, 12098,
     /* 234744 */     GIR_EraseRootFromParent_Done,
     /* 234745 */   // Label 5398: @234745
     /* 234745 */   GIM_Try, /*On fail goto*//*Label 5399*/ GIMT_Encode4(234772), // Rule ID 2470 //
     /* 234750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 234753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 234757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 234761 */     // (strict_fsqrt:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src)  =>  (VSQRTPDYr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src)
     /* 234761 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDYr),
     /* 234766 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 234770 */     GIR_RootConstrainSelectedInstOperands,
     /* 234771 */     // GIR_Coverage, 2470,
     /* 234771 */     GIR_Done,
     /* 234772 */   // Label 5399: @234772
     /* 234772 */   GIM_Try, /*On fail goto*//*Label 5400*/ GIMT_Encode4(234799), // Rule ID 12094 //
     /* 234777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 234780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 234784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 234788 */     // (strict_fsqrt:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src)  =>  (VSQRTPDZ256r:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src)
     /* 234788 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ256r),
     /* 234793 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 234797 */     GIR_RootConstrainSelectedInstOperands,
     /* 234798 */     // GIR_Coverage, 12094,
     /* 234798 */     GIR_Done,
     /* 234799 */   // Label 5400: @234799
     /* 234799 */   GIM_Reject,
     /* 234800 */ // Label 5396: @234800
     /* 234800 */ GIM_Reject,
     /* 234801 */ // Label 5357: @234801
     /* 234801 */ GIM_Try, /*On fail goto*//*Label 5401*/ GIMT_Encode4(234889),
     /* 234806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 234809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 234813 */   GIM_Try, /*On fail goto*//*Label 5402*/ GIMT_Encode4(234865), // Rule ID 12014 //
     /* 234818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 234821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 234825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 234829 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 234832 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 234836 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 234840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 234842 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 234849 */     // (strict_fsqrt:{ *:[v8f16] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPHZ128m:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /* 234849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ128m),
     /* 234852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234854 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 234858 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 234863 */     GIR_RootConstrainSelectedInstOperands,
     /* 234864 */     // GIR_Coverage, 12014,
     /* 234864 */     GIR_EraseRootFromParent_Done,
     /* 234865 */   // Label 5402: @234865
     /* 234865 */   GIM_Try, /*On fail goto*//*Label 5403*/ GIMT_Encode4(234888), // Rule ID 12010 //
     /* 234870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 234873 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 234877 */     // (strict_fsqrt:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src)  =>  (VSQRTPHZ128r:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src)
     /* 234877 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ128r),
     /* 234882 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 234886 */     GIR_RootConstrainSelectedInstOperands,
     /* 234887 */     // GIR_Coverage, 12010,
     /* 234887 */     GIR_Done,
     /* 234888 */   // Label 5403: @234888
     /* 234888 */   GIM_Reject,
     /* 234889 */ // Label 5401: @234889
     /* 234889 */ GIM_Reject,
     /* 234890 */ // Label 5358: @234890
     /* 234890 */ GIM_Try, /*On fail goto*//*Label 5404*/ GIMT_Encode4(235065),
     /* 234895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 234898 */   GIM_Try, /*On fail goto*//*Label 5405*/ GIMT_Encode4(234954), // Rule ID 2456 //
     /* 234903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 234906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 234910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 234914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 234918 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 234921 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 234925 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 234929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 234931 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 234938 */     // (strict_fsqrt:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSYm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 234938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSYm),
     /* 234941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234943 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 234947 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 234952 */     GIR_RootConstrainSelectedInstOperands,
     /* 234953 */     // GIR_Coverage, 2456,
     /* 234953 */     GIR_EraseRootFromParent_Done,
     /* 234954 */   // Label 5405: @234954
     /* 234954 */   GIM_Try, /*On fail goto*//*Label 5406*/ GIMT_Encode4(235010), // Rule ID 12074 //
     /* 234959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 234962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 234966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 234970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 234974 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 234977 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 234981 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 234985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 234987 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 234994 */     // (strict_fsqrt:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSZ256m:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 234994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ256m),
     /* 234997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234999 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 235003 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 235008 */     GIR_RootConstrainSelectedInstOperands,
     /* 235009 */     // GIR_Coverage, 12074,
     /* 235009 */     GIR_EraseRootFromParent_Done,
     /* 235010 */   // Label 5406: @235010
     /* 235010 */   GIM_Try, /*On fail goto*//*Label 5407*/ GIMT_Encode4(235037), // Rule ID 2454 //
     /* 235015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 235018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 235022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 235026 */     // (strict_fsqrt:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src)  =>  (VSQRTPSYr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src)
     /* 235026 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSYr),
     /* 235031 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 235035 */     GIR_RootConstrainSelectedInstOperands,
     /* 235036 */     // GIR_Coverage, 2454,
     /* 235036 */     GIR_Done,
     /* 235037 */   // Label 5407: @235037
     /* 235037 */   GIM_Try, /*On fail goto*//*Label 5408*/ GIMT_Encode4(235064), // Rule ID 12070 //
     /* 235042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 235045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 235049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 235053 */     // (strict_fsqrt:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src)  =>  (VSQRTPSZ256r:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src)
     /* 235053 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ256r),
     /* 235058 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 235062 */     GIR_RootConstrainSelectedInstOperands,
     /* 235063 */     // GIR_Coverage, 12070,
     /* 235063 */     GIR_Done,
     /* 235064 */   // Label 5408: @235064
     /* 235064 */   GIM_Reject,
     /* 235065 */ // Label 5404: @235065
     /* 235065 */ GIM_Reject,
     /* 235066 */ // Label 5359: @235066
     /* 235066 */ GIM_Try, /*On fail goto*//*Label 5409*/ GIMT_Encode4(235154),
     /* 235071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 235074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 235078 */   GIM_Try, /*On fail goto*//*Label 5410*/ GIMT_Encode4(235130), // Rule ID 12050 //
     /* 235083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 235086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 235090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 235094 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 235097 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 235101 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 235105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 235107 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 235114 */     // (strict_fsqrt:{ *:[v8f64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDZm:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)
     /* 235114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZm),
     /* 235117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235119 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 235123 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 235128 */     GIR_RootConstrainSelectedInstOperands,
     /* 235129 */     // GIR_Coverage, 12050,
     /* 235129 */     GIR_EraseRootFromParent_Done,
     /* 235130 */   // Label 5410: @235130
     /* 235130 */   GIM_Try, /*On fail goto*//*Label 5411*/ GIMT_Encode4(235153), // Rule ID 12046 //
     /* 235135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 235138 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 235142 */     // (strict_fsqrt:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src)  =>  (VSQRTPDZr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src)
     /* 235142 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZr),
     /* 235147 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 235151 */     GIR_RootConstrainSelectedInstOperands,
     /* 235152 */     // GIR_Coverage, 12046,
     /* 235152 */     GIR_Done,
     /* 235153 */   // Label 5411: @235153
     /* 235153 */   GIM_Reject,
     /* 235154 */ // Label 5409: @235154
     /* 235154 */ GIM_Reject,
     /* 235155 */ // Label 5360: @235155
     /* 235155 */ GIM_Try, /*On fail goto*//*Label 5412*/ GIMT_Encode4(235243),
     /* 235160 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 235163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 235167 */   GIM_Try, /*On fail goto*//*Label 5413*/ GIMT_Encode4(235219), // Rule ID 12026 //
     /* 235172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 235175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 235179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 235183 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 235186 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 235190 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 235194 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 235196 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 235203 */     // (strict_fsqrt:{ *:[v16f16] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPHZ256m:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /* 235203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ256m),
     /* 235206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235208 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 235212 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 235217 */     GIR_RootConstrainSelectedInstOperands,
     /* 235218 */     // GIR_Coverage, 12026,
     /* 235218 */     GIR_EraseRootFromParent_Done,
     /* 235219 */   // Label 5413: @235219
     /* 235219 */   GIM_Try, /*On fail goto*//*Label 5414*/ GIMT_Encode4(235242), // Rule ID 12022 //
     /* 235224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 235227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 235231 */     // (strict_fsqrt:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src)  =>  (VSQRTPHZ256r:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src)
     /* 235231 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ256r),
     /* 235236 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 235240 */     GIR_RootConstrainSelectedInstOperands,
     /* 235241 */     // GIR_Coverage, 12022,
     /* 235241 */     GIR_Done,
     /* 235242 */   // Label 5414: @235242
     /* 235242 */   GIM_Reject,
     /* 235243 */ // Label 5412: @235243
     /* 235243 */ GIM_Reject,
     /* 235244 */ // Label 5361: @235244
     /* 235244 */ GIM_Try, /*On fail goto*//*Label 5415*/ GIMT_Encode4(235332),
     /* 235249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 235252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 235256 */   GIM_Try, /*On fail goto*//*Label 5416*/ GIMT_Encode4(235308), // Rule ID 12038 //
     /* 235261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 235264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 235268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 235272 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 235275 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 235279 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 235283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 235285 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 235292 */     // (strict_fsqrt:{ *:[v16f32] } (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSZm:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)
     /* 235292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZm),
     /* 235295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235297 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 235301 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 235306 */     GIR_RootConstrainSelectedInstOperands,
     /* 235307 */     // GIR_Coverage, 12038,
     /* 235307 */     GIR_EraseRootFromParent_Done,
     /* 235308 */   // Label 5416: @235308
     /* 235308 */   GIM_Try, /*On fail goto*//*Label 5417*/ GIMT_Encode4(235331), // Rule ID 12034 //
     /* 235313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 235316 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 235320 */     // (strict_fsqrt:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src)  =>  (VSQRTPSZr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src)
     /* 235320 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZr),
     /* 235325 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 235329 */     GIR_RootConstrainSelectedInstOperands,
     /* 235330 */     // GIR_Coverage, 12034,
     /* 235330 */     GIR_Done,
     /* 235331 */   // Label 5417: @235331
     /* 235331 */   GIM_Reject,
     /* 235332 */ // Label 5415: @235332
     /* 235332 */ GIM_Reject,
     /* 235333 */ // Label 5362: @235333
     /* 235333 */ GIM_Try, /*On fail goto*//*Label 5418*/ GIMT_Encode4(235421),
     /* 235338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 235341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 235345 */   GIM_Try, /*On fail goto*//*Label 5419*/ GIMT_Encode4(235397), // Rule ID 12002 //
     /* 235350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 235353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 235357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 235361 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 235364 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 235368 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 235372 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 235374 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 235381 */     // (strict_fsqrt:{ *:[v32f16] } (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPHZm:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)
     /* 235381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZm),
     /* 235384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235386 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 235390 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 235395 */     GIR_RootConstrainSelectedInstOperands,
     /* 235396 */     // GIR_Coverage, 12002,
     /* 235396 */     GIR_EraseRootFromParent_Done,
     /* 235397 */   // Label 5419: @235397
     /* 235397 */   GIM_Try, /*On fail goto*//*Label 5420*/ GIMT_Encode4(235420), // Rule ID 11998 //
     /* 235402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 235405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 235409 */     // (strict_fsqrt:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src)  =>  (VSQRTPHZr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src)
     /* 235409 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZr),
     /* 235414 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 235418 */     GIR_RootConstrainSelectedInstOperands,
     /* 235419 */     // GIR_Coverage, 11998,
     /* 235419 */     GIR_Done,
     /* 235420 */   // Label 5420: @235420
     /* 235420 */   GIM_Reject,
     /* 235421 */ // Label 5418: @235421
     /* 235421 */ GIM_Reject,
     /* 235422 */ // Label 5363: @235422
     /* 235422 */ GIM_Reject,
     /* 235423 */ // Label 74: @235423
     /* 235423 */ GIM_Try, /*On fail goto*//*Label 5421*/ GIMT_Encode4(235435), // Rule ID 17074 //
     /* 235428 */   // (trap)  =>  (TRAP)
     /* 235428 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::TRAP),
     /* 235433 */   GIR_RootConstrainSelectedInstOperands,
     /* 235434 */   // GIR_Coverage, 17074,
     /* 235434 */   GIR_Done,
     /* 235435 */ // Label 5421: @235435
     /* 235435 */ GIM_Reject,
     /* 235436 */ // Label 75: @235436
     /* 235436 */ GIM_Try, /*On fail goto*//*Label 5422*/ GIMT_Encode4(235451), // Rule ID 22377 //
     /* 235441 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotPS),
     /* 235444 */   // (debugtrap)  =>  (INT3)
     /* 235444 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::INT3),
     /* 235449 */   GIR_RootConstrainSelectedInstOperands,
     /* 235450 */   // GIR_Coverage, 22377,
     /* 235450 */   GIR_Done,
     /* 235451 */ // Label 5422: @235451
     /* 235451 */ GIM_Try, /*On fail goto*//*Label 5423*/ GIMT_Encode4(235471), // Rule ID 22378 //
     /* 235456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsPS),
     /* 235459 */   // (debugtrap)  =>  (INT 65:{ *:[i8] })
     /* 235459 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INT),
     /* 235462 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/65,
     /* 235465 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 235469 */   GIR_RootConstrainSelectedInstOperands,
     /* 235470 */   // GIR_Coverage, 22378,
     /* 235470 */   GIR_EraseRootFromParent_Done,
     /* 235471 */ // Label 5423: @235471
     /* 235471 */ GIM_Reject,
     /* 235472 */ // Label 76: @235472
     /* 235472 */ GIM_Try, /*On fail goto*//*Label 5424*/ GIMT_Encode4(235487), // Rule ID 17076 //
     /* 235477 */   // MIs[0] kind
     /* 235477 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 235480 */   // (ubsantrap (timm:{ *:[i32] }):$kind)  =>  (UBSAN_UD1 (timm:{ *:[i32] }):$kind)
     /* 235480 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::UBSAN_UD1),
     /* 235485 */   GIR_RootConstrainSelectedInstOperands,
     /* 235486 */   // GIR_Coverage, 17076,
     /* 235486 */   GIR_Done,
     /* 235487 */ // Label 5424: @235487
     /* 235487 */ GIM_Reject,
     /* 235488 */ // Label 77: @235488
     /* 235488 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(6), /*)*//*default:*//*Label 5428*/ GIMT_Encode4(235946),
     /* 235499 */ /*GILLT_s32*//*Label 5425*/ GIMT_Encode4(235511),
     /* 235503 */ /*GILLT_s64*//*Label 5426*/ GIMT_Encode4(235656),
     /* 235507 */ /*GILLT_s80*//*Label 5427*/ GIMT_Encode4(235801),
     /* 235511 */ // Label 5425: @235511
     /* 235511 */ GIM_Try, /*On fail goto*//*Label 5429*/ GIMT_Encode4(235559), // Rule ID 1086 //
     /* 235516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 235519 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 235526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 235530 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 235534 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 235541 */   // (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_X86fild16>>  =>  (ILD_Fp16m32:{ *:[f32] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /* 235541 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ILD_Fp16m32),
     /* 235544 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235546 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 235550 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 235553 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 235557 */   GIR_RootConstrainSelectedInstOperands,
     /* 235558 */   // GIR_Coverage, 1086,
     /* 235558 */   GIR_EraseRootFromParent_Done,
     /* 235559 */ // Label 5429: @235559
     /* 235559 */ GIM_Try, /*On fail goto*//*Label 5430*/ GIMT_Encode4(235607), // Rule ID 1087 //
     /* 235564 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 235567 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 235574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 235578 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 235582 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 235589 */   // (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_X86fild32>>  =>  (ILD_Fp32m32:{ *:[f32] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /* 235589 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ILD_Fp32m32),
     /* 235592 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235594 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 235598 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 235601 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 235605 */   GIR_RootConstrainSelectedInstOperands,
     /* 235606 */   // GIR_Coverage, 1087,
     /* 235606 */   GIR_EraseRootFromParent_Done,
     /* 235607 */ // Label 5430: @235607
     /* 235607 */ GIM_Try, /*On fail goto*//*Label 5431*/ GIMT_Encode4(235655), // Rule ID 1088 //
     /* 235612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 235615 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 235622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 235626 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 235630 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 235637 */   // (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_X86fild64>>  =>  (ILD_Fp64m32:{ *:[f32] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /* 235637 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ILD_Fp64m32),
     /* 235640 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235642 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 235646 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 235649 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 235653 */   GIR_RootConstrainSelectedInstOperands,
     /* 235654 */   // GIR_Coverage, 1088,
     /* 235654 */   GIR_EraseRootFromParent_Done,
     /* 235655 */ // Label 5431: @235655
     /* 235655 */ GIM_Reject,
     /* 235656 */ // Label 5426: @235656
     /* 235656 */ GIM_Try, /*On fail goto*//*Label 5432*/ GIMT_Encode4(235704), // Rule ID 1089 //
     /* 235661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 235664 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 235671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 235675 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 235679 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 235686 */   // (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_X86fild16>>  =>  (ILD_Fp16m64:{ *:[f64] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /* 235686 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ILD_Fp16m64),
     /* 235689 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235691 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 235695 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 235698 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 235702 */   GIR_RootConstrainSelectedInstOperands,
     /* 235703 */   // GIR_Coverage, 1089,
     /* 235703 */   GIR_EraseRootFromParent_Done,
     /* 235704 */ // Label 5432: @235704
     /* 235704 */ GIM_Try, /*On fail goto*//*Label 5433*/ GIMT_Encode4(235752), // Rule ID 1090 //
     /* 235709 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 235712 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 235719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 235723 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 235727 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 235734 */   // (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_X86fild32>>  =>  (ILD_Fp32m64:{ *:[f64] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /* 235734 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ILD_Fp32m64),
     /* 235737 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235739 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 235743 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 235746 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 235750 */   GIR_RootConstrainSelectedInstOperands,
     /* 235751 */   // GIR_Coverage, 1090,
     /* 235751 */   GIR_EraseRootFromParent_Done,
     /* 235752 */ // Label 5433: @235752
     /* 235752 */ GIM_Try, /*On fail goto*//*Label 5434*/ GIMT_Encode4(235800), // Rule ID 1091 //
     /* 235757 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 235760 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 235767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 235771 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 235775 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 235782 */   // (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_X86fild64>>  =>  (ILD_Fp64m64:{ *:[f64] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /* 235782 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ILD_Fp64m64),
     /* 235785 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235787 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 235791 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 235794 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 235798 */   GIR_RootConstrainSelectedInstOperands,
     /* 235799 */   // GIR_Coverage, 1091,
     /* 235799 */   GIR_EraseRootFromParent_Done,
     /* 235800 */ // Label 5434: @235800
     /* 235800 */ GIM_Reject,
     /* 235801 */ // Label 5427: @235801
     /* 235801 */ GIM_Try, /*On fail goto*//*Label 5435*/ GIMT_Encode4(235849), // Rule ID 1092 //
     /* 235806 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 235809 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 235816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 235820 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 235824 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 235831 */   // (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src)<<P:Predicate_X86fild16>>  =>  (ILD_Fp16m80:{ *:[f80] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /* 235831 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ILD_Fp16m80),
     /* 235834 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235836 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 235840 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 235843 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 235847 */   GIR_RootConstrainSelectedInstOperands,
     /* 235848 */   // GIR_Coverage, 1092,
     /* 235848 */   GIR_EraseRootFromParent_Done,
     /* 235849 */ // Label 5435: @235849
     /* 235849 */ GIM_Try, /*On fail goto*//*Label 5436*/ GIMT_Encode4(235897), // Rule ID 1093 //
     /* 235854 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 235857 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 235864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 235868 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 235872 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 235879 */   // (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src)<<P:Predicate_X86fild32>>  =>  (ILD_Fp32m80:{ *:[f80] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /* 235879 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ILD_Fp32m80),
     /* 235882 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235884 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 235888 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 235891 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 235895 */   GIR_RootConstrainSelectedInstOperands,
     /* 235896 */   // GIR_Coverage, 1093,
     /* 235896 */   GIR_EraseRootFromParent_Done,
     /* 235897 */ // Label 5436: @235897
     /* 235897 */ GIM_Try, /*On fail goto*//*Label 5437*/ GIMT_Encode4(235945), // Rule ID 1094 //
     /* 235902 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 235905 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 235912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 235916 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 235920 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 235927 */   // (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src)<<P:Predicate_X86fild64>>  =>  (ILD_Fp64m80:{ *:[f80] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /* 235927 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ILD_Fp64m80),
     /* 235930 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235932 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 235936 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 235939 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 235943 */   GIR_RootConstrainSelectedInstOperands,
     /* 235944 */   // GIR_Coverage, 1094,
     /* 235944 */   GIR_EraseRootFromParent_Done,
     /* 235945 */ // Label 5437: @235945
     /* 235945 */ GIM_Reject,
     /* 235946 */ // Label 5428: @235946
     /* 235946 */ GIM_Reject,
     /* 235947 */ // Label 78: @235947
     /* 235947 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(6), /*)*//*default:*//*Label 5441*/ GIMT_Encode4(236810),
     /* 235958 */ /*GILLT_s32*//*Label 5438*/ GIMT_Encode4(235970),
     /* 235962 */ /*GILLT_s64*//*Label 5439*/ GIMT_Encode4(236250),
     /* 235966 */ /*GILLT_s80*//*Label 5440*/ GIMT_Encode4(236530),
     /* 235970 */ // Label 5438: @235970
     /* 235970 */ GIM_Try, /*On fail goto*//*Label 5442*/ GIMT_Encode4(236015), // Rule ID 873 //
     /* 235975 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 235982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 235986 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 235990 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 235997 */   // (X86fp_to_mem RFP32:{ *:[f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_X86fp_to_i16mem>>  =>  (FP32_TO_INT16_IN_MEM:{ *:[i32] } addr:{ *:[iPTR] }:$dst, RFP32:{ *:[f32] }:$src)
     /* 235997 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::FP32_TO_INT16_IN_MEM),
     /* 236000 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 236004 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /* 236006 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 236009 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 236013 */   GIR_RootConstrainSelectedInstOperands,
     /* 236014 */   // GIR_Coverage, 873,
     /* 236014 */   GIR_EraseRootFromParent_Done,
     /* 236015 */ // Label 5442: @236015
     /* 236015 */ GIM_Try, /*On fail goto*//*Label 5443*/ GIMT_Encode4(236060), // Rule ID 874 //
     /* 236020 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 236027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 236031 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 236035 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 236042 */   // (X86fp_to_mem RFP32:{ *:[f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_X86fp_to_i32mem>>  =>  (FP32_TO_INT32_IN_MEM:{ *:[i32] } addr:{ *:[iPTR] }:$dst, RFP32:{ *:[f32] }:$src)
     /* 236042 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::FP32_TO_INT32_IN_MEM),
     /* 236045 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 236049 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /* 236051 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 236054 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 236058 */   GIR_RootConstrainSelectedInstOperands,
     /* 236059 */   // GIR_Coverage, 874,
     /* 236059 */   GIR_EraseRootFromParent_Done,
     /* 236060 */ // Label 5443: @236060
     /* 236060 */ GIM_Try, /*On fail goto*//*Label 5444*/ GIMT_Encode4(236105), // Rule ID 875 //
     /* 236065 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 236072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 236076 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 236080 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 236087 */   // (X86fp_to_mem RFP32:{ *:[f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_X86fp_to_i64mem>>  =>  (FP32_TO_INT64_IN_MEM:{ *:[i32] } addr:{ *:[iPTR] }:$dst, RFP32:{ *:[f32] }:$src)
     /* 236087 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::FP32_TO_INT64_IN_MEM),
     /* 236090 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 236094 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /* 236096 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 236099 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 236103 */   GIR_RootConstrainSelectedInstOperands,
     /* 236104 */   // GIR_Coverage, 875,
     /* 236104 */   GIR_EraseRootFromParent_Done,
     /* 236105 */ // Label 5444: @236105
     /* 236105 */ GIM_Try, /*On fail goto*//*Label 5445*/ GIMT_Encode4(236153), // Rule ID 1107 //
     /* 236110 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE3),
     /* 236113 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 236120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 236124 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 236128 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 236135 */   // (X86fp_to_mem RFP32:{ *:[f32] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_X86fp_to_i16mem>>  =>  (ISTT_Fp16m32:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP32:{ *:[f32] }:$src)
     /* 236135 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ISTT_Fp16m32),
     /* 236138 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /* 236142 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /* 236144 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 236147 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 236151 */   GIR_RootConstrainSelectedInstOperands,
     /* 236152 */   // GIR_Coverage, 1107,
     /* 236152 */   GIR_EraseRootFromParent_Done,
     /* 236153 */ // Label 5445: @236153
     /* 236153 */ GIM_Try, /*On fail goto*//*Label 5446*/ GIMT_Encode4(236201), // Rule ID 1108 //
     /* 236158 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE3),
     /* 236161 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 236168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 236172 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 236176 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 236183 */   // (X86fp_to_mem RFP32:{ *:[f32] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_X86fp_to_i32mem>>  =>  (ISTT_Fp32m32:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP32:{ *:[f32] }:$src)
     /* 236183 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ISTT_Fp32m32),
     /* 236186 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /* 236190 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /* 236192 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 236195 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 236199 */   GIR_RootConstrainSelectedInstOperands,
     /* 236200 */   // GIR_Coverage, 1108,
     /* 236200 */   GIR_EraseRootFromParent_Done,
     /* 236201 */ // Label 5446: @236201
     /* 236201 */ GIM_Try, /*On fail goto*//*Label 5447*/ GIMT_Encode4(236249), // Rule ID 1109 //
     /* 236206 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE3),
     /* 236209 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 236216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 236220 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 236224 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 236231 */   // (X86fp_to_mem RFP32:{ *:[f32] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_X86fp_to_i64mem>>  =>  (ISTT_Fp64m32:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP32:{ *:[f32] }:$src)
     /* 236231 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ISTT_Fp64m32),
     /* 236234 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /* 236238 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /* 236240 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 236243 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 236247 */   GIR_RootConstrainSelectedInstOperands,
     /* 236248 */   // GIR_Coverage, 1109,
     /* 236248 */   GIR_EraseRootFromParent_Done,
     /* 236249 */ // Label 5447: @236249
     /* 236249 */ GIM_Reject,
     /* 236250 */ // Label 5439: @236250
     /* 236250 */ GIM_Try, /*On fail goto*//*Label 5448*/ GIMT_Encode4(236295), // Rule ID 876 //
     /* 236255 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 236262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 236266 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 236270 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 236277 */   // (X86fp_to_mem RFP64:{ *:[f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_X86fp_to_i16mem>>  =>  (FP64_TO_INT16_IN_MEM:{ *:[i32] } addr:{ *:[iPTR] }:$dst, RFP64:{ *:[f64] }:$src)
     /* 236277 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::FP64_TO_INT16_IN_MEM),
     /* 236280 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 236284 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /* 236286 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 236289 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 236293 */   GIR_RootConstrainSelectedInstOperands,
     /* 236294 */   // GIR_Coverage, 876,
     /* 236294 */   GIR_EraseRootFromParent_Done,
     /* 236295 */ // Label 5448: @236295
     /* 236295 */ GIM_Try, /*On fail goto*//*Label 5449*/ GIMT_Encode4(236340), // Rule ID 877 //
     /* 236300 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 236307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 236311 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 236315 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 236322 */   // (X86fp_to_mem RFP64:{ *:[f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_X86fp_to_i32mem>>  =>  (FP64_TO_INT32_IN_MEM:{ *:[i32] } addr:{ *:[iPTR] }:$dst, RFP64:{ *:[f64] }:$src)
     /* 236322 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::FP64_TO_INT32_IN_MEM),
     /* 236325 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 236329 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /* 236331 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 236334 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 236338 */   GIR_RootConstrainSelectedInstOperands,
     /* 236339 */   // GIR_Coverage, 877,
     /* 236339 */   GIR_EraseRootFromParent_Done,
     /* 236340 */ // Label 5449: @236340
     /* 236340 */ GIM_Try, /*On fail goto*//*Label 5450*/ GIMT_Encode4(236385), // Rule ID 878 //
     /* 236345 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 236352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 236356 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 236360 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 236367 */   // (X86fp_to_mem RFP64:{ *:[f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_X86fp_to_i64mem>>  =>  (FP64_TO_INT64_IN_MEM:{ *:[i32] } addr:{ *:[iPTR] }:$dst, RFP64:{ *:[f64] }:$src)
     /* 236367 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::FP64_TO_INT64_IN_MEM),
     /* 236370 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 236374 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /* 236376 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 236379 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 236383 */   GIR_RootConstrainSelectedInstOperands,
     /* 236384 */   // GIR_Coverage, 878,
     /* 236384 */   GIR_EraseRootFromParent_Done,
     /* 236385 */ // Label 5450: @236385
     /* 236385 */ GIM_Try, /*On fail goto*//*Label 5451*/ GIMT_Encode4(236433), // Rule ID 1110 //
     /* 236390 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE3),
     /* 236393 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 236400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 236404 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 236408 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 236415 */   // (X86fp_to_mem RFP64:{ *:[f64] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_X86fp_to_i16mem>>  =>  (ISTT_Fp16m64:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP64:{ *:[f64] }:$src)
     /* 236415 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ISTT_Fp16m64),
     /* 236418 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /* 236422 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /* 236424 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 236427 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 236431 */   GIR_RootConstrainSelectedInstOperands,
     /* 236432 */   // GIR_Coverage, 1110,
     /* 236432 */   GIR_EraseRootFromParent_Done,
     /* 236433 */ // Label 5451: @236433
     /* 236433 */ GIM_Try, /*On fail goto*//*Label 5452*/ GIMT_Encode4(236481), // Rule ID 1111 //
     /* 236438 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE3),
     /* 236441 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 236448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 236452 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 236456 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 236463 */   // (X86fp_to_mem RFP64:{ *:[f64] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_X86fp_to_i32mem>>  =>  (ISTT_Fp32m64:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP64:{ *:[f64] }:$src)
     /* 236463 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ISTT_Fp32m64),
     /* 236466 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /* 236470 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /* 236472 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 236475 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 236479 */   GIR_RootConstrainSelectedInstOperands,
     /* 236480 */   // GIR_Coverage, 1111,
     /* 236480 */   GIR_EraseRootFromParent_Done,
     /* 236481 */ // Label 5452: @236481
     /* 236481 */ GIM_Try, /*On fail goto*//*Label 5453*/ GIMT_Encode4(236529), // Rule ID 1112 //
     /* 236486 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE3),
     /* 236489 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 236496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 236500 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 236504 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 236511 */   // (X86fp_to_mem RFP64:{ *:[f64] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_X86fp_to_i64mem>>  =>  (ISTT_Fp64m64:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP64:{ *:[f64] }:$src)
     /* 236511 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ISTT_Fp64m64),
     /* 236514 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /* 236518 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /* 236520 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 236523 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 236527 */   GIR_RootConstrainSelectedInstOperands,
     /* 236528 */   // GIR_Coverage, 1112,
     /* 236528 */   GIR_EraseRootFromParent_Done,
     /* 236529 */ // Label 5453: @236529
     /* 236529 */ GIM_Reject,
     /* 236530 */ // Label 5440: @236530
     /* 236530 */ GIM_Try, /*On fail goto*//*Label 5454*/ GIMT_Encode4(236575), // Rule ID 879 //
     /* 236535 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 236542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 236546 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 236550 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 236557 */   // (X86fp_to_mem RFP80:{ *:[f80] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_X86fp_to_i16mem>>  =>  (FP80_TO_INT16_IN_MEM:{ *:[i32] } addr:{ *:[iPTR] }:$dst, RFP80:{ *:[f80] }:$src)
     /* 236557 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::FP80_TO_INT16_IN_MEM),
     /* 236560 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 236564 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /* 236566 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 236569 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 236573 */   GIR_RootConstrainSelectedInstOperands,
     /* 236574 */   // GIR_Coverage, 879,
     /* 236574 */   GIR_EraseRootFromParent_Done,
     /* 236575 */ // Label 5454: @236575
     /* 236575 */ GIM_Try, /*On fail goto*//*Label 5455*/ GIMT_Encode4(236620), // Rule ID 880 //
     /* 236580 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 236587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 236591 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 236595 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 236602 */   // (X86fp_to_mem RFP80:{ *:[f80] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_X86fp_to_i32mem>>  =>  (FP80_TO_INT32_IN_MEM:{ *:[i32] } addr:{ *:[iPTR] }:$dst, RFP80:{ *:[f80] }:$src)
     /* 236602 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::FP80_TO_INT32_IN_MEM),
     /* 236605 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 236609 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /* 236611 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 236614 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 236618 */   GIR_RootConstrainSelectedInstOperands,
     /* 236619 */   // GIR_Coverage, 880,
     /* 236619 */   GIR_EraseRootFromParent_Done,
     /* 236620 */ // Label 5455: @236620
     /* 236620 */ GIM_Try, /*On fail goto*//*Label 5456*/ GIMT_Encode4(236665), // Rule ID 881 //
     /* 236625 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 236632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 236636 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 236640 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 236647 */   // (X86fp_to_mem RFP80:{ *:[f80] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_X86fp_to_i64mem>>  =>  (FP80_TO_INT64_IN_MEM:{ *:[i32] } addr:{ *:[iPTR] }:$dst, RFP80:{ *:[f80] }:$src)
     /* 236647 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::FP80_TO_INT64_IN_MEM),
     /* 236650 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 236654 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /* 236656 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 236659 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 236663 */   GIR_RootConstrainSelectedInstOperands,
     /* 236664 */   // GIR_Coverage, 881,
     /* 236664 */   GIR_EraseRootFromParent_Done,
     /* 236665 */ // Label 5456: @236665
     /* 236665 */ GIM_Try, /*On fail goto*//*Label 5457*/ GIMT_Encode4(236713), // Rule ID 1113 //
     /* 236670 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE3),
     /* 236673 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 236680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 236684 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 236688 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 236695 */   // (X86fp_to_mem RFP80:{ *:[f80] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_X86fp_to_i16mem>>  =>  (ISTT_Fp16m80:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP80:{ *:[f80] }:$src)
     /* 236695 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ISTT_Fp16m80),
     /* 236698 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /* 236702 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /* 236704 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 236707 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 236711 */   GIR_RootConstrainSelectedInstOperands,
     /* 236712 */   // GIR_Coverage, 1113,
     /* 236712 */   GIR_EraseRootFromParent_Done,
     /* 236713 */ // Label 5457: @236713
     /* 236713 */ GIM_Try, /*On fail goto*//*Label 5458*/ GIMT_Encode4(236761), // Rule ID 1114 //
     /* 236718 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE3),
     /* 236721 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 236728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 236732 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 236736 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 236743 */   // (X86fp_to_mem RFP80:{ *:[f80] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_X86fp_to_i32mem>>  =>  (ISTT_Fp32m80:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP80:{ *:[f80] }:$src)
     /* 236743 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ISTT_Fp32m80),
     /* 236746 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /* 236750 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /* 236752 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 236755 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 236759 */   GIR_RootConstrainSelectedInstOperands,
     /* 236760 */   // GIR_Coverage, 1114,
     /* 236760 */   GIR_EraseRootFromParent_Done,
     /* 236761 */ // Label 5458: @236761
     /* 236761 */ GIM_Try, /*On fail goto*//*Label 5459*/ GIMT_Encode4(236809), // Rule ID 1115 //
     /* 236766 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE3),
     /* 236769 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 236776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 236780 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 236784 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 236791 */   // (X86fp_to_mem RFP80:{ *:[f80] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_X86fp_to_i64mem>>  =>  (ISTT_Fp64m80:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP80:{ *:[f80] }:$src)
     /* 236791 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ISTT_Fp64m80),
     /* 236794 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /* 236798 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /* 236800 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 236803 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 236807 */   GIR_RootConstrainSelectedInstOperands,
     /* 236808 */   // GIR_Coverage, 1115,
     /* 236808 */   GIR_EraseRootFromParent_Done,
     /* 236809 */ // Label 5459: @236809
     /* 236809 */ GIM_Reject,
     /* 236810 */ // Label 5441: @236810
     /* 236810 */ GIM_Reject,
     /* 236811 */ // Label 79: @236811
     /* 236811 */ GIM_Reject,
     /* 236812 */ }; // Size: 236812 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const X86Subtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const X86Subtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
